// the url of the main doc tree, for compact url
// representation (see also the UncompactUrl function)
plt_main_url = "../";

// classes to be used for compact representation of html strings in
// plt_search_data below (see also the UncompactHtml function)
plt_span_classes = [
  "schemesymbol",
  "schemevaluelink",
  "schemeinputbg",
  "hspace",
  "schemeinput",
  "stt",
  "schemesyntaxlink",
  "schemevalue",
  "schemeparen",
  "nobreak",
  "schemevariable",
  "schememeta",
  "smaller",
  "noborder",
  "schememodlink",
  "schememod"];

// this array has an entry of four items for each index link:
// - text is a string holding the indexed text
// - url holds the link (">" prefix means relative to plt_main_url)
// - html holds either a string, or [idx, html] where idx is an
//   index into plt_span_classes (note: this is recursive)
// - from_lib is an array of module names for bound identifiers,
//   or the string "module" for a module entry
plt_search_data = [
["!",">lazy/index.html#(def._((lib._lazy/force..ss)._!))",[0,[1,"!"]],["lazy/force"]],
["!!",">lazy/index.html#(def._((lib._lazy/force..ss)._!!))",[0,[1,"!!"]],["lazy/force"]],
["!!list",">lazy/index.html#(def._((lib._lazy/force..ss)._!!list))",[0,[1,"!!list"]],["lazy/force"]],
["!list",">lazy/index.html#(def._((lib._lazy/force..ss)._!list))",[0,[1,"!list"]],["lazy/force"]],
["\"",">reference/reader.html#(idx._(gentag._151._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"\""],[3,""]]],false],
["\".plt\"",">mzc/plt.html#(idx._(gentag._25._(lib._scribblings/mzc/mzc..scrbl)))",[5,"\".plt\""],false],
["\".plt\" archives",">setup-plt/_plt-archives.html",[[5,"\".plt\""]," Archives"],false],
["\"escheme.h\"",">inside/overview.html#(idx._(gentag._4._(lib._scribblings/inside/inside..scrbl)))",[5,"\"escheme.h\""],false],
["\"hello world\" server",">more/index.html#(part.__.Hello_.World__.Server)","&ldquo;Hello World&rdquo; Server",false],
["\"info.ss\" file format",">setup-plt/info_ss.html",[[5,"\"info.ss\""]," File Format"],false],
["\"libmzgc.a\"",">inside/overview.html#(idx._(gentag._18._(lib._scribblings/inside/inside..scrbl)))",[5,"\"libmzgc.a\""],false],
["\"libmzgc.la\"",">inside/overview.html#(idx._(gentag._22._(lib._scribblings/inside/inside..scrbl)))",[5,"\"libmzgc.la\""],false],
["\"libmzgc.so\"",">inside/overview.html#(idx._(gentag._20._(lib._scribblings/inside/inside..scrbl)))",[5,"\"libmzgc.so\""],false],
["\"libmzscheme.a\"",">inside/overview.html#(idx._(gentag._17._(lib._scribblings/inside/inside..scrbl)))",[5,"\"libmzscheme.a\""],false],
["\"libmzscheme.la\"",">inside/overview.html#(idx._(gentag._21._(lib._scribblings/inside/inside..scrbl)))",[5,"\"libmzscheme.la\""],false],
["\"libmzscheme.so\"",">inside/overview.html#(idx._(gentag._19._(lib._scribblings/inside/inside..scrbl)))",[5,"\"libmzscheme.so\""],false],
["\"libmzscheme3m.a\"",">inside/overview.html#(idx._(gentag._25._(lib._scribblings/inside/inside..scrbl)))",[5,"\"libmzscheme3m.a\""],false],
["\"libmzscheme3m.la\"",">inside/overview.html#(idx._(gentag._27._(lib._scribblings/inside/inside..scrbl)))",[5,"\"libmzscheme3m.la\""],false],
["\"libmzscheme3m.so\"",">inside/overview.html#(idx._(gentag._26._(lib._scribblings/inside/inside..scrbl)))",[5,"\"libmzscheme3m.so\""],false],
["\"mzdyn.o\"",">inside/overview.html#(idx._(gentag._8._(lib._scribblings/inside/inside..scrbl)))",[5,"\"mzdyn.o\""],false],
["\"mzdyn.obj\"",">inside/overview.html#(idx._(gentag._9._(lib._scribblings/inside/inside..scrbl)))",[5,"\"mzdyn.obj\""],false],
["\"mzdyn3m.o\"",">inside/overview.html#(idx._(gentag._14._(lib._scribblings/inside/inside..scrbl)))",[5,"\"mzdyn3m.o\""],false],
["\"mzdyn3m.obj\"",">inside/overview.html#(idx._(gentag._15._(lib._scribblings/inside/inside..scrbl)))",[5,"\"mzdyn3m.obj\""],false],
["\"scheme.h\"",">inside/overview.html#(idx._(gentag._23._(lib._scribblings/inside/inside..scrbl)))",[5,"\"scheme.h\""],false],
["#!",">guide/scripts.html#(idx._(gentag._1._(lib._scribblings/guide/guide..scrbl)))",[5,"#!"],false],
["#!",">reference/reader.html#(idx._(gentag._182._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#!"],[3,"&nbsp;"]]],false],
["#!",">reference/reader.html#(idx._(gentag._196._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#!"],[3,""]]],false],
["#!/",">reference/reader.html#(idx._(gentag._183._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#!/"],[3,""]]],false],
["#\"",">reference/reader.html#(idx._(gentag._168._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#\""],[3,""]]],false],
["#%",">reference/reader.html#(idx._(gentag._124._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#%"],[3,""]]],false],
["#%app",">reference/application.html#(form._((lib._scheme/base..ss)._~23~25app))",[0,[6,"#%app"]],["scheme/base","scheme"]],
["#%app",">htdp-langs/beginner-call.html#(form._((lib._lang/htdp-beginner..ss)._~23~25app))",[0,[6,"#%app"]],["lang/htdp-beginner"]],
["#%app",">htdp-langs/intermediate-call.html#(form._((lib._lang/htdp-intermediate..ss)._~23~25app))",[0,[6,"#%app"]],["lang/htdp-intermediate"]],
["#%app",">htdp-langs/intermediate-lambda-call.html#(form._((lib._lang/htdp-intermediate-lambda..ss)._~23~25app))",[0,[6,"#%app"]],["lang/htdp-intermediate-lambda"]],
["#%app",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..ss)._~23~25app))",[0,[6,"#%app"]],["mzscheme"]],
["#%datum",">reference/quote.html#(form._((quote._~23~25kernel)._~23~25datum))",[0,[6,"#%datum"]],["scheme/base","scheme"]],
["#%datum",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..ss)._~23~25datum))",[0,[6,"#%datum"]],["mzscheme"]],
["#%expression",">reference/__expression.html#(form._((quote._~23~25kernel)._~23~25expression))",[0,[6,"#%expression"]],["scheme/base","scheme"]],
["#%kernel",">reference/running-sa.html#(idx._(gentag._317._(lib._scribblings/reference/reference..scrbl)))",[7,"'#%kernel"],false],
["#%module-begin",">reference/module.html#(form._((lib._scheme/base..ss)._~23~25module-begin))",[0,[6,"#%module-begin"]],["scheme/base","scheme"]],
["#%module-begin",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..ss)._~23~25module-begin))",[0,[6,"#%module-begin"]],["mzscheme"]],
["#%module-begin",">syntax/reader-helpers.html#(form._((lib._syntax/module-reader..ss)._~23~25module-begin))",[0,[6,"#%module-begin"]],["syntax/module-reader"]],
["#%plain-app",">reference/application.html#(form._((lib._scheme/base..ss)._~23~25plain-app))",[0,[6,"#%plain-app"]],["scheme/base","scheme"]],
["#%plain-app",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..ss)._~23~25plain-app))",[0,[6,"#%plain-app"]],["mzscheme"]],
["#%plain-lambda",">reference/lambda.html#(form._((lib._scheme/base..ss)._~23~25plain-lambda))",[0,[6,"#%plain-lambda"]],["scheme/base","scheme"]],
["#%plain-lambda",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..ss)._~23~25plain-lambda))",[0,[6,"#%plain-lambda"]],["mzscheme"]],
["#%plain-module-begin",">reference/module.html#(form._((lib._scheme/base..ss)._~23~25plain-module-begin))",[0,[6,"#%plain-module-begin"]],["scheme/base","scheme"]],
["#%plain-module-begin",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..ss)._~23~25plain-module-begin))",[0,[6,"#%plain-module-begin"]],["mzscheme"]],
["#%provide",">reference/require.html#(form._((quote._~23~25kernel)._~23~25provide))",[0,[6,"#%provide"]],["scheme/base","scheme"]],
["#%require",">reference/require.html#(form._((quote._~23~25kernel)._~23~25require))",[0,[6,"#%require"]],["scheme/base","scheme"]],
["#%top",">reference/__top.html#(form._((quote._~23~25kernel)._~23~25top))",[0,[6,"#%top"]],["scheme/base","scheme"]],
["#%top-interaction",">reference/__top-interaction.html#(form._((lib._scheme/base..ss)._~23~25top-interaction))",[0,[6,"#%top-interaction"]],["scheme/base","scheme"]],
["#%top-interaction",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..ss)._~23~25top-interaction))",[0,[6,"#%top-interaction"]],["mzscheme"]],
["#%variable-reference",">reference/Locations____variable-reference.html#(form._((quote._~23~25kernel)._~23~25variable-reference))",[0,[6,"#%variable-reference"]],["scheme/base","scheme"]],
["#%variable-reference",">inside/im_env.html#(idx._(gentag._240._(lib._scribblings/inside/inside..scrbl)))",[0,[6,"#%variable-reference"]],false],
["#&",">reference/reader.html#(idx._(gentag._187._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#&amp;"],[3,""]]],false],
["#'",">reference/reader.html#(idx._(gentag._175._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#'"],[3,""]]],false],
["#,",">reference/reader.html#(idx._(gentag._177._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#,"],[3,""]]],false],
["#,@",">reference/reader.html#(idx._(gentag._178._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#,@"],[3,""]]],false],
["#0#",">reference/reader.html#(idx._(gentag._192._(lib._scribblings/reference/reference..scrbl)))","#0#",false],
["#0=",">reference/reader.html#(idx._(gentag._193._(lib._scribblings/reference/reference..scrbl)))","#0=",false],
["#:",">reference/reader.html#(idx._(gentag._189._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#:"],[3,""]]],false],
["#:all-keys",">mzlib/mzlib_kw.html#(idx._(gentag._4._(lib._mzlib/scribblings/mzlib..scrbl)))",[8,"#:all-keys"],false],
["#:allow-anything",">mzlib/mzlib_kw.html#(idx._(gentag._11._(lib._mzlib/scribblings/mzlib..scrbl)))",[8,"#:allow-anything"],false],
["#:allow-body",">mzlib/mzlib_kw.html#(idx._(gentag._9._(lib._mzlib/scribblings/mzlib..scrbl)))",[8,"#:allow-body"],false],
["#:allow-duplicate-keys",">mzlib/mzlib_kw.html#(idx._(gentag._7._(lib._mzlib/scribblings/mzlib..scrbl)))",[8,"#:allow-duplicate-keys"],false],
["#:allow-other-keys",">mzlib/mzlib_kw.html#(idx._(gentag._5._(lib._mzlib/scribblings/mzlib..scrbl)))",[8,"#:allow-other-keys"],false],
["#:body",">mzlib/mzlib_kw.html#(idx._(gentag._3._(lib._mzlib/scribblings/mzlib..scrbl)))",[8,"#:body"],false],
["#:forbid-anything",">mzlib/mzlib_kw.html#(idx._(gentag._12._(lib._mzlib/scribblings/mzlib..scrbl)))",[8,"#:forbid-anything"],false],
["#:forbid-body",">mzlib/mzlib_kw.html#(idx._(gentag._10._(lib._mzlib/scribblings/mzlib..scrbl)))",[8,"#:forbid-body"],false],
["#:forbid-duplicate-keys",">mzlib/mzlib_kw.html#(idx._(gentag._8._(lib._mzlib/scribblings/mzlib..scrbl)))",[8,"#:forbid-duplicate-keys"],false],
["#:forbid-other-keys",">mzlib/mzlib_kw.html#(idx._(gentag._6._(lib._mzlib/scribblings/mzlib..scrbl)))",[8,"#:forbid-other-keys"],false],
["#:key",">mzlib/mzlib_kw.html#(idx._(gentag._1._(lib._mzlib/scribblings/mzlib..scrbl)))",[8,"#:key"],false],
["#:optional",">mzlib/mzlib_kw.html#(idx._(gentag._0._(lib._mzlib/scribblings/mzlib..scrbl)))",[8,"#:optional"],false],
["#:rest",">mzlib/mzlib_kw.html#(idx._(gentag._2._(lib._mzlib/scribblings/mzlib..scrbl)))",[8,"#:rest"],false],
["#;",">reference/reader.html#(idx._(gentag._181._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#;"],[3,""]]],false],
["#<<",">reference/reader.html#(idx._(gentag._169._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#&lt;&lt;"],[3,""]]],false],
["#\\",">reference/reader.html#(idx._(gentag._188._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#\\"],[3,""]]],false],
["#`",">reference/reader.html#(idx._(gentag._176._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#`"],[3,""]]],false],
["#b",">reference/reader.html#(idx._(gentag._132._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#b"],[3,""]]],false],
["#ci",">reference/reader.html#(idx._(gentag._127._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#ci"],[3,""]]],false],
["#cs",">reference/reader.html#(idx._(gentag._128._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#cs"],[3,""]]],false],
["#d",">reference/reader.html#(idx._(gentag._134._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#d"],[3,""]]],false],
["#e",">reference/reader.html#(idx._(gentag._130._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#e"],[3,""]]],false],
["#f",">reference/reader.html#(idx._(gentag._139._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#F"],[3,""]]],false],
["#f",">reference/reader.html#(idx._(gentag._138._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#f"],[3,""]]],false],
["#hash",">reference/reader.html#(idx._(gentag._184._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#hash"],[3,""]]],false],
["#hasheq",">reference/reader.html#(idx._(gentag._185._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#hasheq"],[3,""]]],false],
["#hasheqv",">reference/reader.html#(idx._(gentag._186._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#hasheqv"],[3,""]]],false],
["#i",">reference/reader.html#(idx._(gentag._131._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#i"],[3,""]]],false],
["#lang",">reference/reader.html#(idx._(gentag._195._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#lang"],[3,""]]],false],
["#o",">reference/reader.html#(idx._(gentag._133._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#o"],[3,""]]],false],
["#px",">reference/reader.html#(idx._(gentag._191._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#px"],[3,""]]],false],
["#reader",">reference/reader.html#(idx._(gentag._194._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#reader"],[3,""]]],false],
["#rx",">reference/reader.html#(idx._(gentag._190._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#rx"],[3,""]]],false],
["#t",">reference/reader.html#(idx._(gentag._137._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#T"],[3,""]]],false],
["#t",">reference/reader.html#(idx._(gentag._136._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#t"],[3,""]]],false],
["#x",">reference/reader.html#(idx._(gentag._135._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#x"],[3,""]]],false],
["#|",">reference/reader.html#(idx._(gentag._180._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"#|"],[3,""]]],false],
["%",">reference/cont.html#(form._((lib._scheme/control..ss)._~25))",[0,[6,"%"]],["scheme/control"]],
["&",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-sre..ss)._~26))",[0,[6,"&amp;"]],["parser-tools/lex-sre"]],
["&assertion",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_438",[0,[1,"&amp;assertion"]],["rnrs/conditions-6"]],
["&condition",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_392",[0,[1,"&amp;condition"]],["rnrs/conditions-6"]],
["&error",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_426",[0,[1,"&amp;error"]],["rnrs/conditions-6"]],
["&i/o",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_494",[0,[1,"&amp;i/o"]],["rnrs/io/ports-6"]],
["&i/o-decoding",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_600",[0,[1,"&amp;i/o-decoding"]],["rnrs/io/ports-6"]],
["&i/o-encoding",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_606",[0,[1,"&amp;i/o-encoding"]],["rnrs/io/ports-6"]],
["&i/o-file-already-exists",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_540",[0,[1,"&amp;i/o-file-already-exists"]],["rnrs/io/ports-6"]],
["&i/o-file-does-not-exist",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_546",[0,[1,"&amp;i/o-file-does-not-exist"]],["rnrs/io/ports-6"]],
["&i/o-file-is-read-only",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_534",[0,[1,"&amp;i/o-file-is-read-only"]],["rnrs/io/ports-6"]],
["&i/o-file-protection",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_528",[0,[1,"&amp;i/o-file-protection"]],["rnrs/io/ports-6"]],
["&i/o-filename",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_520",[0,[1,"&amp;i/o-filename"]],["rnrs/io/ports-6"]],
["&i/o-invalid-position",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_512",[0,[1,"&amp;i/o-invalid-position"]],["rnrs/io/ports-6"]],
["&i/o-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_552",[0,[1,"&amp;i/o-port"]],["rnrs/io/ports-6"]],
["&i/o-read",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_500",[0,[1,"&amp;i/o-read"]],["rnrs/io/ports-6"]],
["&i/o-write",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_506",[0,[1,"&amp;i/o-write"]],["rnrs/io/ports-6"]],
["&implementation-restriction",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_466",[0,[1,"&amp;implementation-restriction"]],["rnrs/conditions-6"]],
["&irritants",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_444",[0,[1,"&amp;irritants"]],["rnrs/conditions-6"]],
["&lexical",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_472",[0,[1,"&amp;lexical"]],["rnrs/conditions-6"]],
["&message",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_406",[0,[1,"&amp;message"]],["rnrs/conditions-6"]],
["&no-infinities",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1048",[0,[1,"&amp;no-infinities"]],["rnrs/arithmetic/flonums-6"]],
["&no-nans",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1054",[0,[1,"&amp;no-nans"]],["rnrs/arithmetic/flonums-6"]],
["&non-continuable",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_460",[0,[1,"&amp;non-continuable"]],["rnrs/conditions-6"]],
["&serious",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_420",[0,[1,"&amp;serious"]],["rnrs/conditions-6"]],
["&syntax",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_478",[0,[1,"&amp;syntax"]],["rnrs/conditions-6"]],
["&undefined",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_488",[0,[1,"&amp;undefined"]],["rnrs/conditions-6"]],
["&violation",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_432",[0,[1,"&amp;violation"]],["rnrs/conditions-6"]],
["&warning",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_414",[0,[1,"&amp;warning"]],["rnrs/conditions-6"]],
["&who",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_452",[0,[1,"&amp;who"]],["rnrs/conditions-6"]],
["'",">reference/reader.html#(idx._(gentag._171._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"'"],[3,""]]],false],
["'framework:backup-files?",">framework/Editor.html#(idx._(gentag._2._(lib._scribblings/framework/framework..scrbl)))","'framework:backup-files?",false],
["'framework:basic-canvas-background",">framework/Canvas.html#(idx._(gentag._1._(lib._scribblings/framework/framework..scrbl)))","'framework:basic-canvas-background",false],
["(",">reference/reader.html#(idx._(gentag._140._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"("],[3,""]]],false],
["(define ...) button",">drscheme/buttons.html#(idx._(gentag._2._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">(define ...)</font></b>\nbutton",false],
["(rnrs arithmetic bitwise (6)): arithmetic: bitwise",">r6rs/R6RS_Libraries.html#(part._rnrs/arithmetic/bitwise-6)",[[8,"("],[0,"rnrs"],[5," "],[0,"arithmetic"],[5," "],[0,"bitwise"],[5," "],[8,"("],[7,"6"],[8,"))"],": Arithmetic: Bitwise"],false],
["(rnrs arithmetic fixnums (6)): arithmetic: fixnums",">r6rs/R6RS_Libraries.html#(part._rnrs/arithmetic/fixnums-6)",[[8,"("],[0,"rnrs"],[5," "],[0,"arithmetic"],[5," "],[0,"fixnums"],[5," "],[8,"("],[7,"6"],[8,"))"],": Arithmetic: Fixnums"],false],
["(rnrs arithmetic flonums (6)): arithmetic: flonums",">r6rs/R6RS_Libraries.html#(part._rnrs/arithmetic/flonums-6)",[[8,"("],[0,"rnrs"],[5," "],[0,"arithmetic"],[5," "],[0,"flonums"],[5," "],[8,"("],[7,"6"],[8,"))"],": Arithmetic: Flonums"],false],
["(rnrs base (6)): base",">r6rs/R6RS_Libraries.html#(part._rnrs/base-6)",[[8,"("],[0,"rnrs"],[5," "],[0,"base"],[5," "],[8,"("],[7,"6"],[8,"))"],": Base"],false],
["(rnrs bytevectors (6)): bytevectors",">r6rs/R6RS_Libraries.html#(part._rnrs/bytevectors-6)",[[8,"("],[0,"rnrs"],[5," "],[0,"bytevectors"],[5," "],[8,"("],[7,"6"],[8,"))"],": Bytevectors"],false],
["(rnrs conditions (6)): conditions",">r6rs/R6RS_Libraries.html#(part._rnrs/conditions-6)",[[8,"("],[0,"rnrs"],[5," "],[0,"conditions"],[5," "],[8,"("],[7,"6"],[8,"))"],": Conditions"],false],
["(rnrs control (6)): control structures",">r6rs/R6RS_Libraries.html#(part._rnrs/control-6)",[[8,"("],[0,"rnrs"],[5," "],[0,"control"],[5," "],[8,"("],[7,"6"],[8,"))"],": Control Structures"],false],
["(rnrs enums (6)): enumerations",">r6rs/R6RS_Libraries.html#(part._rnrs/enums-6)",[[8,"("],[0,"rnrs"],[5," "],[0,"enums"],[5," "],[8,"("],[7,"6"],[8,"))"],": Enumerations"],false],
["(rnrs eval (6)): eval",">r6rs/R6RS_Libraries.html#(part._rnrs/eval-6)",[[8,"("],[0,"rnrs"],[5," "],[0,"eval"],[5," "],[8,"("],[7,"6"],[8,"))"],": Eval"],false],
["(rnrs exceptions (6)): exceptions",">r6rs/R6RS_Libraries.html#(part._rnrs/exceptions-6)",[[8,"("],[0,"rnrs"],[5," "],[0,"exceptions"],[5," "],[8,"("],[7,"6"],[8,"))"],": Exceptions"],false],
["(rnrs files (6)): file system",">r6rs/R6RS_Libraries.html#(part._rnrs/files-6)",[[8,"("],[0,"rnrs"],[5," "],[0,"files"],[5," "],[8,"("],[7,"6"],[8,"))"],": File System"],false],
["(rnrs hashtables (6)): hashtables",">r6rs/R6RS_Libraries.html#(part._rnrs/hashtables-6)",[[8,"("],[0,"rnrs"],[5," "],[0,"hashtables"],[5," "],[8,"("],[7,"6"],[8,"))"],": Hashtables"],false],
["(rnrs io ports (6)): i/o: ports",">r6rs/R6RS_Libraries.html#(part._rnrs/io/ports-6)",[[8,"("],[0,"rnrs"],[5," "],[0,"io"],[5," "],[0,"ports"],[5," "],[8,"("],[7,"6"],[8,"))"],": I/O: Ports"],false],
["(rnrs io simple (6)): i/o: simple",">r6rs/R6RS_Libraries.html#(part._rnrs/io/simple-6)",[[8,"("],[0,"rnrs"],[5," "],[0,"io"],[5," "],[0,"simple"],[5," "],[8,"("],[7,"6"],[8,"))"],": I/O: Simple"],false],
["(rnrs lists (6)): list utilities",">r6rs/R6RS_Libraries.html#(part._rnrs/lists-6)",[[8,"("],[0,"rnrs"],[5," "],[0,"lists"],[5," "],[8,"("],[7,"6"],[8,"))"],": List utilities"],false],
["(rnrs mutable-pairs (6)): mutable pairs",">r6rs/R6RS_Libraries.html#(part._rnrs/mutable-pairs-6)",[[8,"("],[0,"rnrs"],[5," "],[0,"mutable-pairs"],[5," "],[8,"("],[7,"6"],[8,"))"],": Mutable Pairs"],false],
["(rnrs mutable-strings (6)): mutable strings",">r6rs/R6RS_Libraries.html#(part._rnrs/mutable-strings-6)",[[8,"("],[0,"rnrs"],[5," "],[0,"mutable-strings"],[5," "],[8,"("],[7,"6"],[8,"))"],": Mutable Strings"],false],
["(rnrs programs (6)): command-line access and exit values",">r6rs/R6RS_Libraries.html#(part._rnrs/programs-6)",[[8,"("],[0,"rnrs"],[5," "],[0,"programs"],[5," "],[8,"("],[7,"6"],[8,"))"],": Command-line Access and Exit Values"],false],
["(rnrs r5rs (6)): r5rs compatibility",">r6rs/R6RS_Libraries.html#(part._rnrs/r5rs-6)",[[8,"("],[0,"rnrs"],[5," "],[0,"r5rs"],[5," "],[8,"("],[7,"6"],[8,"))"],": R5RS Compatibility"],false],
["(rnrs records inspection (6)): records: inspection",">r6rs/R6RS_Libraries.html#(part._rnrs/records/inspection-6)",[[8,"("],[0,"rnrs"],[5," "],[0,"records"],[5," "],[0,"inspection"],[5," "],[8,"("],[7,"6"],[8,"))"],": Records: Inspection"],false],
["(rnrs records procedural (6)): records: procedural",">r6rs/R6RS_Libraries.html#(part._rnrs/records/procedural-6)",[[8,"("],[0,"rnrs"],[5," "],[0,"records"],[5," "],[0,"procedural"],[5," "],[8,"("],[7,"6"],[8,"))"],": Records: Procedural"],false],
["(rnrs records syntactic (6)): records: syntactic",">r6rs/R6RS_Libraries.html#(part._rnrs/records/syntactic-6)",[[8,"("],[0,"rnrs"],[5," "],[0,"records"],[5," "],[0,"syntactic"],[5," "],[8,"("],[7,"6"],[8,"))"],": Records: Syntactic"],false],
["(rnrs sorting (6)): sorting",">r6rs/R6RS_Libraries.html#(part._rnrs/sorting-6)",[[8,"("],[0,"rnrs"],[5," "],[0,"sorting"],[5," "],[8,"("],[7,"6"],[8,"))"],": Sorting"],false],
["(rnrs syntax-case (6)): syntax-case",">r6rs/R6RS_Libraries.html#(part._rnrs/syntax-case-6)",[[8,"("],[0,"rnrs"],[5," "],[0,"syntax-case"],[5," "],[8,"("],[7,"6"],[8,"))"],": Syntax-Case"],false],
["(rnrs unicode (6)): unicode",">r6rs/R6RS_Libraries.html#(part._rnrs/unicode-6)",[[8,"("],[0,"rnrs"],[5," "],[0,"unicode"],[5," "],[8,"("],[7,"6"],[8,"))"],": Unicode"],false],
[")",">reference/reader.html#(idx._(gentag._143._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,")"],[3,""]]],false],
["*",">reference/numbers.html#(def._((quote._~23~25kernel)._*))",[0,[1,"*"]],["scheme/base","scheme"]],
["*",">r5rs-std/r5rs-Z-H-9.html#%_idx_284",[0,[1,"*"]],["r5rs"]],
["*",">r6rs-std/r6rs-Z-H-14.html#node_idx_496",[0,[1,"*"]],["rnrs/base-6"]],
["*",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._*))",[0,[1,"*"]],["lang/htdp-advanced"]],
["*",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._*))",[0,[1,"*"]],["lang/htdp-beginner"]],
["*",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._*))",[0,[1,"*"]],["lang/htdp-beginner-abbr"]],
["*",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._*))",[0,[1,"*"]],["lang/htdp-intermediate"]],
["*",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._*))",[0,[1,"*"]],["lang/htdp-intermediate-lambda"]],
["*",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-sre..ss)._*))",[0,[6,"*"]],["parser-tools/lex-sre"]],
["**",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-sre..ss)._**))",[0,[6,"**"]],["parser-tools/lex-sre"]],
["+",">reference/numbers.html#(def._((quote._~23~25kernel)._+))",[0,[1,"+"]],["scheme/base","scheme"]],
["+",">r5rs-std/r5rs-Z-H-9.html#%_idx_282",[0,[1,"+"]],["r5rs"]],
["+",">r6rs-std/r6rs-Z-H-14.html#node_idx_494",[0,[1,"+"]],["rnrs/base-6"]],
["+",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._+))",[0,[1,"+"]],["lang/htdp-advanced"]],
["+",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._+))",[0,[1,"+"]],["lang/htdp-beginner"]],
["+",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._+))",[0,[1,"+"]],["lang/htdp-beginner-abbr"]],
["+",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._+))",[0,[1,"+"]],["lang/htdp-intermediate"]],
["+",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._+))",[0,[1,"+"]],["lang/htdp-intermediate-lambda"]],
["+",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-sre..ss)._+))",[0,[6,"+"]],["parser-tools/lex-sre"]],
["++copy-collects",">mzc/exe-dist.html#(idx._(gentag._23._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"++copy-collects"]],false],
["++cppf",">mzc/cc.html#(idx._(gentag._45._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"++cppf"]],false],
["++cppf",">mzc/cc.html#(idx._(gentag._46._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"++cppf"]],false],
["++cppf-clear",">mzc/cc.html#(idx._(gentag._47._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"++cppf-clear"]],false],
["++ldf",">mzc/cc.html#(idx._(gentag._39._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"++ldf"]],false],
["++ldl",">mzc/cc.html#(idx._(gentag._43._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"++ldl"]],false],
["++path",">r6rs/Installing_Libraries.html#(idx._(gentag._0._(lib._r6rs/scribblings/r6rs..scrbl)))",[9,[5,"++path"]],false],
["++setup",">mzc/plt.html#(idx._(gentag._30._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"++setup"]],false],
["+inf.0",">reference/numbers.html#(idx._(gentag._8._(lib._scribblings/reference/reference..scrbl)))",[7,"+inf.0"],false],
["+nan.0",">reference/numbers.html#(idx._(gentag._11._(lib._scribblings/reference/reference..scrbl)))",[7,"+nan.0"],false],
["+rv",">reference/running-sa.html#(idx._(gentag._384._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"+rv"]],false],
[",",">reference/reader.html#(idx._(gentag._173._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,","],[3,""]]],false],
[",@",">reference/reader.html#(idx._(gentag._174._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,",@"],[3,""]]],false],
["-",">reference/numbers.html#(def._((quote._~23~25kernel)._-))",[0,[1,"-"]],["scheme/base","scheme"]],
["-",">r5rs-std/r5rs-Z-H-9.html#%_idx_290",[0,[1,"-"]],["r5rs"]],
["-",">r6rs-std/r6rs-Z-H-14.html#node_idx_498",[0,[1,"-"]],["rnrs/base-6"]],
["-",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._-))",[0,[1,"-"]],["lang/htdp-advanced"]],
["-",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._-))",[0,[1,"-"]],["lang/htdp-beginner"]],
["-",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._-))",[0,[1,"-"]],["lang/htdp-beginner-abbr"]],
["-",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._-))",[0,[1,"-"]],["lang/htdp-intermediate"]],
["-",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._-))",[0,[1,"-"]],["lang/htdp-intermediate-lambda"]],
["-",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-sre..ss)._-))",[0,[6,"-"]],["parser-tools/lex-sre"]],
["--",">reference/running-sa.html#(idx._(gentag._369._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"--"]],false],
["--3m",">inside/overview.html#(idx._(gentag._13._(lib._scribblings/inside/inside..scrbl)))",[9,[5,"--3m"]],false],
["--3m",">mzc/cc.html#(idx._(gentag._49._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--3m"]],false],
["-->",">redex/Reduction_Relations.html#(form._((lib._redex/main..ss)._--~3e))",[0,[6,"--&gt;"]],["redex"]],
["--all-users",">mzc/plt.html#(idx._(gentag._28._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--all-users"]],false],
["--at-plt",">mzc/plt.html#(idx._(gentag._26._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--at-plt"]],false],
["--auto-dir",">mzc/zo.html#(idx._(gentag._51._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--auto-dir"]],false],
["--auto-dir",">mzc/ext.html#(idx._(gentag._52._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--auto-dir"]],false],
["--back",">reference/running-sa.html#(idx._(gentag._341._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"--back"]],false],
["--binary",">reference/running-sa.html#(idx._(gentag._364._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"--binary"]],false],
["--c-mods",">mzc/Running_mzc.html#(idx._(gentag._12._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--c-mods"]],false],
["--c-source",">mzc/Running_mzc.html#(idx._(gentag._20._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--c-source"]],false],
["--cc",">inside/overview.html#(idx._(gentag._6._(lib._scribblings/inside/inside..scrbl)))",[9,[5,"--cc"]],false],
["--cc",">mzc/Running_mzc.html#(idx._(gentag._8._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--cc"]],false],
["--ccf",">mzc/cc.html#(idx._(gentag._34._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--ccf"]],false],
["--ccf",">mzc/cc.html#(idx._(gentag._35._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--ccf"]],false],
["--ccf-clear",">mzc/cc.html#(idx._(gentag._36._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--ccf-clear"]],false],
["--ccf-show",">mzc/cc.html#(idx._(gentag._37._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--ccf-show"]],false],
["--cgc",">mzc/cc.html#(idx._(gentag._50._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--cgc"]],false],
["--cgc",">inside/overview.html#(idx._(gentag._7._(lib._scribblings/inside/inside..scrbl)))",[9,[5,"--cgc"]],false],
["--collection-plt",">mzc/plt.html#(idx._(gentag._27._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--collection-plt"]],false],
["--collection-plt",">mzc/Running_mzc.html#(idx._(gentag._6._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--collection-plt"]],false],
["--collection-zo",">mzc/Running_mzc.html#(idx._(gentag._17._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--collection-zo"]],false],
["--collects",">reference/running-sa.html#(idx._(gentag._352._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"--collects"]],false],
["--collects-dest",">mzc/exe-dist.html#(idx._(gentag._24._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--collects-dest"]],false],
["--compiler",">mzc/cc.html#(idx._(gentag._33._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--compiler"]],false],
["--cppf-show",">mzc/cc.html#(idx._(gentag._48._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--cppf-show"]],false],
["--decompile",">mzc/Running_mzc.html#(idx._(gentag._14._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--decompile"]],false],
["--eval",">reference/running-sa.html#(idx._(gentag._319._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"--eval"]],false],
["--exe",">mzc/Running_mzc.html#(idx._(gentag._3._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--exe"]],false],
["--exe-dir",">mzc/Running_mzc.html#(idx._(gentag._5._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--exe-dir"]],false],
["--expand",">mzc/Running_mzc.html#(idx._(gentag._13._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--expand"]],false],
["--extension",">mzc/Running_mzc.html#(idx._(gentag._18._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--extension"]],false],
["--gui-exe",">mzc/Running_mzc.html#(idx._(gentag._4._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--gui-exe"]],false],
["--help",">reference/running-sa.html#(idx._(gentag._371._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"--help"]],false],
["--inline",">mzc/ext.html#(idx._(gentag._54._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--inline"]],false],
["--ld",">inside/overview.html#(idx._(gentag._10._(lib._scribblings/inside/inside..scrbl)))",[9,[5,"--ld"]],false],
["--ld",">mzc/Running_mzc.html#(idx._(gentag._9._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--ld"]],false],
["--ldf",">mzc/cc.html#(idx._(gentag._40._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--ldf"]],false],
["--ldf-clear",">mzc/cc.html#(idx._(gentag._41._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--ldf-clear"]],false],
["--ldf-show",">mzc/cc.html#(idx._(gentag._42._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--ldf-show"]],false],
["--ldl-show",">mzc/cc.html#(idx._(gentag._44._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--ldl-show"]],false],
["--lib",">reference/running-sa.html#(idx._(gentag._325._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"--lib"]],false],
["--linker",">mzc/cc.html#(idx._(gentag._38._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--linker"]],false],
["--load",">reference/running-sa.html#(idx._(gentag._321._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"--load"]],false],
["--main",">reference/running-sa.html#(idx._(gentag._333._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"--main"]],false],
["--make",">mzc/Running_mzc.html#(idx._(gentag._0._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--make"]],false],
["--make-collection",">mzc/Running_mzc.html#(idx._(gentag._2._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--make-collection"]],false],
["--name",">reference/running-sa.html#(idx._(gentag._358._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"--name"]],false],
["--no-compiled",">reference/running-sa.html#(idx._(gentag._345._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"--no-compiled"]],false],
["--no-delay",">reference/running-sa.html#(idx._(gentag._362._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"--no-delay"]],false],
["--no-init-file",">reference/running-sa.html#(idx._(gentag._347._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"--no-init-file"]],false],
["--no-jit",">reference/running-sa.html#(idx._(gentag._360._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"--no-jit"]],false],
["--no-lib",">reference/running-sa.html#(idx._(gentag._337._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"--no-lib"]],false],
["--no-prim",">r5rs/plt-r5rs.html#(idx._(gentag._0._(lib._r5rs/r5rs..scrbl)))",[9,[5,"--no-prim"]],false],
["--no-prim",">mzc/ext.html#(idx._(gentag._55._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--no-prim"]],false],
["--no-prop",">mzc/ext.html#(idx._(gentag._53._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--no-prop"]],false],
["--no-user-path",">reference/running-sa.html#(idx._(gentag._356._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"--no-user-path"]],false],
["--no-yield",">reference/running-sa.html#(idx._(gentag._343._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"--no-yield"]],false],
["--plt",">mzc/Running_mzc.html#(idx._(gentag._7._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--plt"]],false],
["--plt-name",">mzc/plt.html#(idx._(gentag._31._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--plt-name"]],false],
["--repl",">reference/running-sa.html#(idx._(gentag._335._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"--repl"]],false],
["--replace",">mzc/plt.html#(idx._(gentag._29._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--replace"]],false],
["--require",">reference/running-sa.html#(idx._(gentag._323._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"--require"]],false],
["--require-script",">reference/running-sa.html#(idx._(gentag._330._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"--require-script"]],false],
["--script",">reference/running-sa.html#(idx._(gentag._328._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"--script"]],false],
["--search",">reference/running-sa.html#(idx._(gentag._354._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"--search"]],false],
["--stupid",">mzc/ext.html#(idx._(gentag._56._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--stupid"]],false],
["--syslog",">reference/running-sa.html#(idx._(gentag._368._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"--syslog"]],false],
["--text-repl",">reference/running-sa.html#(idx._(gentag._349._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"--text-repl"]],false],
["--tool",">mzc/cc.html#(idx._(gentag._32._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--tool"]],false],
["--unsafe-disable-interrupts",">mzc/ext.html#(idx._(gentag._57._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--unsafe-disable-interrupts"]],false],
["--unsafe-fixnum-arithmetic",">mzc/ext.html#(idx._(gentag._59._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--unsafe-fixnum-arithmetic"]],false],
["--unsafe-skip-tests",">mzc/ext.html#(idx._(gentag._58._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--unsafe-skip-tests"]],false],
["--version",">reference/running-sa.html#(idx._(gentag._339._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"--version"]],false],
["--warn",">reference/running-sa.html#(idx._(gentag._366._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"--warn"]],false],
["--xform",">mzc/Running_mzc.html#(idx._(gentag._10._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--xform"]],false],
["--xform",">inside/overview.html#(idx._(gentag._12._(lib._scribblings/inside/inside..scrbl)))",[9,[5,"--xform"]],false],
["--zo",">mzc/Running_mzc.html#(idx._(gentag._15._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"--zo"]],false],
["->",">reference/Function_Contracts.html#(form._((lib._scheme/contract..ss)._-~3e))",[0,[6,"-&gt;"]],["scheme/contract","scheme"]],
["->",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._-~3e))",[10,"-&gt;"],["typed-scheme"]],
["->*",">reference/Function_Contracts.html#(form._((lib._scheme/contract..ss)._-~3e*))",[0,[6,"-&gt;*"]],["scheme/contract","scheme"]],
["->char-set",">srfi-std/srfi-14.html#->char-set",[0,[1,"-&gt;char-set"]],["srfi/14"]],
["->d",">reference/Function_Contracts.html#(form._((lib._scheme/contract..ss)._-~3ed))",[0,[6,"-&gt;d"]],["scheme/contract","scheme"]],
["-b",">reference/running-sa.html#(idx._(gentag._363._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-b"]],false],
["-background",">reference/running-sa.html#(idx._(gentag._375._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-background"]],false],
["-bg",">reference/running-sa.html#(idx._(gentag._374._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-bg"]],false],
["-c",">mzc/Running_mzc.html#(idx._(gentag._21._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"-c"]],false],
["-c",">reference/running-sa.html#(idx._(gentag._344._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-c"]],false],
["-d",">reference/running-sa.html#(idx._(gentag._361._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-d"]],false],
["-display",">reference/running-sa.html#(idx._(gentag._372._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-display"]],false],
["-e",">mzc/Running_mzc.html#(idx._(gentag._19._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"-e"]],false],
["-e",">reference/running-sa.html#(idx._(gentag._318._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-e"]],false],
["-f",">reference/running-sa.html#(idx._(gentag._320._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-f"]],false],
["-fg",">reference/running-sa.html#(idx._(gentag._376._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-fg"]],false],
["-fn",">reference/running-sa.html#(idx._(gentag._378._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-fn"]],false],
["-font",">reference/running-sa.html#(idx._(gentag._379._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-font"]],false],
["-foreground",">reference/running-sa.html#(idx._(gentag._377._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-foreground"]],false],
["-geometry",">reference/running-sa.html#(idx._(gentag._373._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-geometry"]],false],
["-h",">reference/running-sa.html#(idx._(gentag._370._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-h"]],false],
["-i",">reference/running-sa.html#(idx._(gentag._350._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-I"]],false],
["-i",">reference/running-sa.html#(idx._(gentag._334._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-i"]],false],
["-iconic",">reference/running-sa.html#(idx._(gentag._380._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-iconic"]],false],
["-inf.0",">reference/numbers.html#(idx._(gentag._10._(lib._scribblings/reference/reference..scrbl)))",[7,"-inf.0"],false],
["-j",">reference/running-sa.html#(idx._(gentag._359._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-j"]],false],
["-k",">reference/running-sa.html#(idx._(gentag._340._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-K"]],false],
["-k",">mzc/Running_mzc.html#(idx._(gentag._1._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"-k"]],false],
["-k",">reference/running-sa.html#(idx._(gentag._331._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-k"]],false],
["-l",">reference/running-sa.html#(idx._(gentag._367._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-L"]],false],
["-l",">reference/running-sa.html#(idx._(gentag._324._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-l"]],false],
["-m",">reference/running-sa.html#(idx._(gentag._332._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-m"]],false],
["-n",">reference/running-sa.html#(idx._(gentag._357._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-N"]],false],
["-n",">reference/running-sa.html#(idx._(gentag._336._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-n"]],false],
["-name",">reference/running-sa.html#(idx._(gentag._381._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-name"]],false],
["-p",">reference/running-sa.html#(idx._(gentag._326._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-p"]],false],
["-printable signature",">net/qp.html#(part._-.Printable_.Signature)","-Printable Signature",false],
["-psn_",">reference/running-sa.html#(idx._(gentag._391._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-psn_"]],false],
["-q",">reference/running-sa.html#(idx._(gentag._346._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-q"]],false],
["-r",">reference/running-sa.html#(idx._(gentag._327._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-r"]],false],
["-reverse",">reference/running-sa.html#(idx._(gentag._383._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-reverse"]],false],
["-rv",">reference/running-sa.html#(idx._(gentag._382._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-rv"]],false],
["-s",">reference/running-sa.html#(idx._(gentag._353._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-S"]],false],
["-selectiontimeout",">reference/running-sa.html#(idx._(gentag._385._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-selectionTimeout"]],false],
["-singleinstance",">reference/running-sa.html#(idx._(gentag._390._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-singleInstance"]],false],
["-synchronous",">reference/running-sa.html#(idx._(gentag._386._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-synchronous"]],false],
["-t",">reference/running-sa.html#(idx._(gentag._322._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-t"]],false],
["-title",">reference/running-sa.html#(idx._(gentag._387._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-title"]],false],
["-u",">reference/running-sa.html#(idx._(gentag._355._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-U"]],false],
["-u",">reference/running-sa.html#(idx._(gentag._329._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-u"]],false],
["-v",">reference/running-sa.html#(idx._(gentag._342._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-V"]],false],
["-v",">reference/running-sa.html#(idx._(gentag._338._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-v"]],false],
["-w",">reference/running-sa.html#(idx._(gentag._365._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-W"]],false],
["-x",">reference/running-sa.html#(idx._(gentag._351._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-X"]],false],
["-x",">mzc/Running_mzc.html#(idx._(gentag._11._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"-x"]],false],
["-xnllanguage",">reference/running-sa.html#(idx._(gentag._388._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-xnllanguage"]],false],
["-xrm",">reference/running-sa.html#(idx._(gentag._389._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-xrm"]],false],
["-z",">mzc/Running_mzc.html#(idx._(gentag._16._(lib._scribblings/mzc/mzc..scrbl)))",[9,[5,"-z"]],false],
["-z",">reference/running-sa.html#(idx._(gentag._348._(lib._scribblings/reference/reference..scrbl)))",[9,[5,"-z"]],false],
[".",">reference/reader.html#(idx._(gentag._146._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"."],[3,""]]],false],
["...",">reference/stx-patterns.html#(form._((lib._scheme/private/stxcase-scheme..ss)._......))",[11,[6,"..."]],["scheme/base","scheme"]],
["...",">r6rs-std/r6rs-Z-H-14.html#node_idx_784",[0,[6,"..."]],["r6rs/private/base-for-syntax"]],
["...",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1128",[0,[6,"..."]],["rnrs/syntax-case-6"]],
[".afm",">gui/fontresources.html#(idx._(gentag._309._(lib._scribblings/gui/gui..scrbl)))",[5,"\".afm\""],false],
[".bak",">drscheme/prefs-explanation.html#(idx._(gentag._150._(lib._scribblings/drscheme/drscheme..scrbl)))",[5,"\".bak\""],false],
[".lock.org.plt-scheme.prefs.ss",">drscheme/drscheme-files.html#(idx._(gentag._226._(lib._scribblings/drscheme/drscheme..scrbl)))",[5,"\".LOCK.org.plt-scheme.prefs.ss\""],false],
[".lock.plt-prefs.ss",">drscheme/drscheme-files.html#(idx._(gentag._225._(lib._scribblings/drscheme/drscheme..scrbl)))",[5,"\".LOCK.plt-prefs.ss\""],false],
[".mredrc",">gui/Windowing_Functions.html#(idx._(gentag._150._(lib._scribblings/gui/gui..scrbl)))",[5,"\".mredrc\""],false],
[".mzschemerc",">reference/Filesystem.html#(idx._(gentag._252._(lib._scribblings/reference/reference..scrbl)))",[5,"\".mzschemerc\""],false],
[".plt-scheme",">drscheme/drscheme-files.html#(idx._(gentag._218._(lib._scribblings/drscheme/drscheme..scrbl)))",[5,"\".plt-scheme\""],false],
[".sch",">drscheme/drscheme-files.html#(idx._(gentag._217._(lib._scribblings/drscheme/drscheme..scrbl)))",[5,"\".sch\""],false],
[".scm",">drscheme/drscheme-files.html#(idx._(gentag._216._(lib._scribblings/drscheme/drscheme..scrbl)))",[5,"\".scm\""],false],
[".ss",">drscheme/drscheme-files.html#(idx._(gentag._215._(lib._scribblings/drscheme/drscheme..scrbl)))",[5,"\".ss\""],false],
["/",">reference/numbers.html#(def._((quote._~23~25kernel)._/))",[0,[1,"/"]],["scheme/base","scheme"]],
["/",">r5rs-std/r5rs-Z-H-9.html#%_idx_296",[0,[1,"/"]],["r5rs"]],
["/",">r6rs-std/r6rs-Z-H-14.html#node_idx_502",[0,[1,"/"]],["rnrs/base-6"]],
["/",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._/))",[0,[1,"/"]],["lang/htdp-advanced"]],
["/",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._/))",[0,[1,"/"]],["lang/htdp-beginner"]],
["/",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._/))",[0,[1,"/"]],["lang/htdp-beginner-abbr"]],
["/",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._/))",[0,[1,"/"]],["lang/htdp-intermediate"]],
["/",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._/))",[0,[1,"/"]],["lang/htdp-intermediate-lambda"]],
["/",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-sre..ss)._/))",[0,[6,"/"]],["parser-tools/lex-sre"]],
["1+",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..ss)._1+))",[0,[1,"1+"]],["mzlib/compat"]],
["1-",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..ss)._1-))",[0,[1,"1-"]],["mzlib/compat"]],
["2d-view%",">plot/extend.html#(def._((lib._plot/extend..ss)._2d-view~25))",[0,[1,"2d-view%"]],["plot/extend"]],
["3d-view%",">plot/extend.html#(def._((lib._plot/extend..ss)._3d-view~25))",[0,[1,"3d-view%"]],["plot/extend"]],
["3m",">inside/overview.html#(idx._(gentag._0._(lib._scribblings/inside/inside..scrbl)))","3m",false],
["3m",">reference/runtime.html#(idx._(gentag._301._(lib._scribblings/reference/reference..scrbl)))",[7,"'3m"],false],
["3m",">guide/performance.html#(tech._3m)","<i>3m</i>",false],
["3m embedding",">inside/overview.html#(part._3m_.Embedding)","3m Embedding",false],
["3m extensions",">inside/overview.html#(part._3m_.Extensions)","3m Extensions",false],
["3m-suffix",">config/index.html#(def._((lib._config/main..ss)._3m-suffix))",[0,[1,"3m-suffix"]],["config"]],
[":",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-sre..ss)._~3a))",[0,[6,":"]],["parser-tools/lex-sre"]],
[":",">srfi-std/srfi-42.html#:",[0,[6,":"]],["srfi/42"]],
[":",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._~3a))",[0,[6,":"]],["typed-scheme"]],
[":char-range",">srfi-std/srfi-42.html#:char-range",[0,[6,":char-range"]],["srfi/42"]],
[":dispatched",">srfi-std/srfi-42.html#",[0,[6,":dispatched"]],["srfi/42"]],
[":do",">srfi-std/srfi-42.html#:do",[0,[6,":do"]],["srfi/42"]],
[":do-in",">reference/for.html#(form._((lib._scheme/base..ss)._~3ado-in))",[0,[6,":do-in"]],["scheme/base","scheme"]],
[":generator-proc",">srfi-std/srfi-42.html#:generator-proc",[0,[6,":generator-proc"]],["srfi/42"]],
[":integers",">srfi-std/srfi-42.html#:integers",[0,[6,":integers"]],["srfi/42"]],
[":let",">srfi-std/srfi-42.html#:let",[0,[6,":let"]],["srfi/42"]],
[":list",">srfi-std/srfi-42.html#:list",[0,[6,":list"]],["srfi/42"]],
[":parallel",">srfi-std/srfi-42.html#:parallel",[0,[6,":parallel"]],["srfi/42"]],
[":port",">srfi-std/srfi-42.html#:port",[0,[6,":port"]],["srfi/42"]],
[":range",">srfi-std/srfi-42.html#:range",[0,[6,":range"]],["srfi/42"]],
[":real-range",">srfi-std/srfi-42.html#:real-range",[0,[6,":real-range"]],["srfi/42"]],
[":string",">srfi-std/srfi-42.html#:string",[0,[6,":string"]],["srfi/42"]],
[":until",">srfi-std/srfi-42.html#:until",[0,[6,":until"]],["srfi/42"]],
[":vector",">srfi-std/srfi-42.html#:vector",[0,[6,":vector"]],["srfi/42"]],
[":while",">srfi-std/srfi-42.html#:while",[0,[6,":while"]],["srfi/42"]],
[";",">reference/reader.html#(idx._(gentag._179._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,";"],[3,""]]],false],
["<",">reference/numbers.html#(def._((quote._~23~25kernel)._~3c))",[0,[1,"&lt;"]],["scheme/base","scheme"]],
["<",">r5rs-std/r5rs-Z-H-9.html#%_idx_260",[0,[1,"&lt;"]],["r5rs"]],
["<",">r6rs-std/r6rs-Z-H-14.html#node_idx_466",[0,[1,"&lt;"]],["rnrs/base-6"]],
["<",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._~3c))",[0,[1,"&lt;"]],["lang/htdp-advanced"]],
["<",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._~3c))",[0,[1,"&lt;"]],["lang/htdp-beginner"]],
["<",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._~3c))",[0,[1,"&lt;"]],["lang/htdp-beginner-abbr"]],
["<",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._~3c))",[0,[1,"&lt;"]],["lang/htdp-intermediate"]],
["<",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._~3c))",[0,[1,"&lt;"]],["lang/htdp-intermediate-lambda"]],
["</c",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._~3c/c))",[0,[1,"&lt;/c"]],["scheme/contract","scheme"]],
["<=",">reference/numbers.html#(def._((quote._~23~25kernel)._~3c~3d))",[0,[1,"&lt;="]],["scheme/base","scheme"]],
["<=",">r5rs-std/r5rs-Z-H-9.html#%_idx_264",[0,[1,"&lt;="]],["r5rs"]],
["<=",">r6rs-std/r6rs-Z-H-14.html#node_idx_470",[0,[1,"&lt;="]],["rnrs/base-6"]],
["<=",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._~3c~3d))",[0,[1,"&lt;="]],["lang/htdp-advanced"]],
["<=",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._~3c~3d))",[0,[1,"&lt;="]],["lang/htdp-beginner"]],
["<=",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._~3c~3d))",[0,[1,"&lt;="]],["lang/htdp-beginner-abbr"]],
["<=",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._~3c~3d))",[0,[1,"&lt;="]],["lang/htdp-intermediate"]],
["<=",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._~3c~3d))",[0,[1,"&lt;="]],["lang/htdp-intermediate-lambda"]],
["<=/c",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._~3c~3d/c))",[0,[1,"&lt;=/c"]],["scheme/contract","scheme"]],
["<=?",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..ss)._~3c~3d~3f))",[0,[1,"&lt;=?"]],["mzlib/compat"]],
["<?",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..ss)._~3c~3f))",[0,[1,"&lt;?"]],["mzlib/compat"]],
["=",">reference/numbers.html#(def._((quote._~23~25kernel)._~3d))",[0,[1,"="]],["scheme/base","scheme"]],
["=",">r5rs-std/r5rs-Z-H-9.html#%_idx_258",[0,[1,"="]],["r5rs"]],
["=",">r6rs-std/r6rs-Z-H-14.html#node_idx_464",[0,[1,"="]],["rnrs/base-6"]],
["=",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._~3d))",[0,[1,"="]],["lang/htdp-advanced"]],
["=",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._~3d))",[0,[1,"="]],["lang/htdp-beginner"]],
["=",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._~3d))",[0,[1,"="]],["lang/htdp-beginner-abbr"]],
["=",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._~3d))",[0,[1,"="]],["lang/htdp-intermediate"]],
["=",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._~3d))",[0,[1,"="]],["lang/htdp-intermediate-lambda"]],
["=",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-sre..ss)._~3d))",[0,[6,"="]],["parser-tools/lex-sre"]],
["=#>",">frtime/index.html#(def._((lib._frtime/main..ss)._~3d~23~3e))",[0,[1,"=#&gt;"]],["frtime"]],
["=/c",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._~3d/c))",[0,[1,"=/c"]],["scheme/contract","scheme"]],
["==>",">frtime/index.html#(def._((lib._frtime/main..ss)._~3d~3d~3e))",[0,[1,"==&gt;"]],["frtime"]],
["=>",">reference/if.html#(form._((lib._scheme/private/letstx-scheme..ss)._~3d~3e))",[0,[6,"=&gt;"]],["scheme/base","scheme"]],
["=>",">r6rs-std/r6rs-Z-H-14.html#node_idx_378",[0,[6,"=&gt;"]],["rnrs/base-6"]],
["=>",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_372",[0,[6,"=&gt;"]],["rnrs/exceptions-6"]],
["=?",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..ss)._~3d~3f))",[0,[1,"=?"]],["mzlib/compat"]],
["=~",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._~3d~7e))",[0,[1,"=~"]],["lang/htdp-advanced"]],
["=~",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._~3d~7e))",[0,[1,"=~"]],["lang/htdp-beginner"]],
["=~",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._~3d~7e))",[0,[1,"=~"]],["lang/htdp-beginner-abbr"]],
["=~",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._~3d~7e))",[0,[1,"=~"]],["lang/htdp-intermediate"]],
["=~",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._~3d~7e))",[0,[1,"=~"]],["lang/htdp-intermediate-lambda"]],
[">",">reference/numbers.html#(def._((quote._~23~25kernel)._~3e))",[0,[1,"&gt;"]],["scheme/base","scheme"]],
[">",">r5rs-std/r5rs-Z-H-9.html#%_idx_262",[0,[1,"&gt;"]],["r5rs"]],
[">",">r6rs-std/r6rs-Z-H-14.html#node_idx_468",[0,[1,"&gt;"]],["rnrs/base-6"]],
[">",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._~3e))",[0,[1,"&gt;"]],["lang/htdp-advanced"]],
[">",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._~3e))",[0,[1,"&gt;"]],["lang/htdp-beginner"]],
[">",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._~3e))",[0,[1,"&gt;"]],["lang/htdp-beginner-abbr"]],
[">",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._~3e))",[0,[1,"&gt;"]],["lang/htdp-intermediate"]],
[">",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._~3e))",[0,[1,"&gt;"]],["lang/htdp-intermediate-lambda"]],
["> prompt",">drscheme/interactions-window.html#(idx._(gentag._23._(lib._scribblings/drscheme/drscheme..scrbl)))","&gt; prompt",false],
[">/c",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._~3e/c))",[0,[1,"&gt;/c"]],["scheme/contract","scheme"]],
[">=",">reference/numbers.html#(def._((quote._~23~25kernel)._~3e~3d))",[0,[1,"&gt;="]],["scheme/base","scheme"]],
[">=",">r5rs-std/r5rs-Z-H-9.html#%_idx_266",[0,[1,"&gt;="]],["r5rs"]],
[">=",">r6rs-std/r6rs-Z-H-14.html#node_idx_472",[0,[1,"&gt;="]],["rnrs/base-6"]],
[">=",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._~3e~3d))",[0,[1,"&gt;="]],["lang/htdp-advanced"]],
[">=",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._~3e~3d))",[0,[1,"&gt;="]],["lang/htdp-beginner"]],
[">=",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._~3e~3d))",[0,[1,"&gt;="]],["lang/htdp-beginner-abbr"]],
[">=",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._~3e~3d))",[0,[1,"&gt;="]],["lang/htdp-intermediate"]],
[">=",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._~3e~3d))",[0,[1,"&gt;="]],["lang/htdp-intermediate-lambda"]],
[">=",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-sre..ss)._~3e~3d))",[0,[6,"&gt;="]],["parser-tools/lex-sre"]],
[">=/c",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._~3e~3d/c))",[0,[1,"&gt;=/c"]],["scheme/contract","scheme"]],
[">=?",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..ss)._~3e~3d~3f))",[0,[1,"&gt;=?"]],["mzlib/compat"]],
[">?",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..ss)._~3e~3f))",[0,[1,"&gt;?"]],["mzlib/compat"]],
["?",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-sre..ss)._~3f))",[0,[6,"?"]],["parser-tools/lex-sre"]],
["@-reader",">scribble/reader.html","@-Reader",false],
["[",">reference/reader.html#(idx._(gentag._141._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"["],[3,""]]],false],
["\\",">reference/reader.html#(idx._(gentag._123._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"\\"],[3,""]]],false],
["\\\"",">reference/reader.html#(idx._(gentag._160._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"\\\""],[3,""]]],false],
["\\'",">reference/reader.html#(idx._(gentag._161._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"\\'"],[3,""]]],false],
["\\<digit8>{1,3}",">reference/reader.html#(idx._(gentag._163._(lib._scribblings/reference/reference..scrbl)))",[[2,[[3,""],[4,"\\"],[3,""]]],"&#8249;","<i>digit<sub>8</sub></i>","&#8250;","<sup>{1,3}</sup>"],false],
["\\<newline>",">reference/reader.html#(idx._(gentag._167._(lib._scribblings/reference/reference..scrbl)))",[[2,[[3,""],[4,"\\"],[3,""]]],"&#8249;","<i>newline</i>","&#8250;"],false],
["\\\\",">reference/reader.html#(idx._(gentag._162._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"\\\\"],[3,""]]],false],
["\\a",">reference/reader.html#(idx._(gentag._152._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"\\a"],[3,""]]],false],
["\\b",">reference/reader.html#(idx._(gentag._153._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"\\b"],[3,""]]],false],
["\\e",">reference/reader.html#(idx._(gentag._159._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"\\e"],[3,""]]],false],
["\\f",">reference/reader.html#(idx._(gentag._157._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"\\f"],[3,""]]],false],
["\\n",">reference/reader.html#(idx._(gentag._155._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"\\n"],[3,""]]],false],
["\\r",">reference/reader.html#(idx._(gentag._158._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"\\r"],[3,""]]],false],
["\\t",">reference/reader.html#(idx._(gentag._154._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"\\t"],[3,""]]],false],
["\\u<digit16>{1,4}",">reference/reader.html#(idx._(gentag._165._(lib._scribblings/reference/reference..scrbl)))",[[2,[[3,""],[4,"\\u"],[3,""]]],"&#8249;","<i>digit<sub>16</sub></i>","&#8250;","<sup>{1,4}</sup>"],false],
["\\u<digit16>{1,8}",">reference/reader.html#(idx._(gentag._166._(lib._scribblings/reference/reference..scrbl)))",[[2,[[3,""],[4,"\\U"],[3,""]]],"&#8249;","<i>digit<sub>16</sub></i>","&#8250;","<sup>{1,8}</sup>"],false],
["\\v",">reference/reader.html#(idx._(gentag._156._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"\\v"],[3,""]]],false],
["\\x<digit16>{1,2}",">reference/reader.html#(idx._(gentag._164._(lib._scribblings/reference/reference..scrbl)))",[[2,[[3,""],[4,"\\x"],[3,""]]],"&#8249;","<i>digit<sub>16</sub></i>","&#8250;","<sup>{1,2}</sup>"],false],
["]",">reference/reader.html#(idx._(gentag._144._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"]"],[3,""]]],false],
["_",">reference/stx-patterns.html#(form._((lib._scheme/private/stxcase-scheme..ss).__))",[0,[6,"_"]],["scheme/base","scheme"]],
["_",">r6rs-std/r6rs-Z-H-14.html#node_idx_788",[0,[6,"_"]],["r6rs/private/base-for-syntax"]],
["_",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1126",[0,[6,"_"]],["rnrs/syntax-case-6"]],
["_?",">foreign/foreign_procedures.html#(form._((lib._scheme/foreign..ss).__~3f))",[0,[6,"_?"]],["scheme/foreign"]],
["_bitmask",">foreign/Enumerations_and_Masks.html#(def._((lib._scheme/foreign..ss).__bitmask))",[0,[1,"_bitmask"]],["scheme/foreign"]],
["_bool",">foreign/Other_Atomic_Types.html#(def._((lib._scheme/foreign..ss).__bool))",[0,[1,"_bool"]],["scheme/foreign"]],
["_box",">foreign/foreign_procedures.html#(form._((lib._scheme/foreign..ss).__box))",[0,[6,"_box"]],["scheme/foreign"]],
["_byte",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__byte))",[0,[1,"_byte"]],["scheme/foreign"]],
["_bytes",">foreign/foreign_procedures.html#(form._((lib._scheme/foreign..ss).__bytes))",[0,[6,"_bytes"]],["scheme/foreign"]],
["_bytes/eof",">foreign/String_Types.html#(def._((lib._scheme/foreign..ss).__bytes/eof))",[0,[1,"_bytes/eof"]],["scheme/foreign"]],
["_cpointer",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss).__cpointer))",[0,[1,"_cpointer"]],["scheme/foreign"]],
["_cpointer/null",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss).__cpointer/null))",[0,[1,"_cpointer/null"]],["scheme/foreign"]],
["_cprocedure",">foreign/foreign_procedures.html#(def._((lib._scheme/foreign..ss).__cprocedure))",[0,[1,"_cprocedure"]],["scheme/foreign"]],
["_cvector",">foreign/foreign_procedures.html#(form._((lib._scheme/foreign..ss).__cvector))",[0,[6,"_cvector"]],["scheme/foreign"]],
["_double",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__double))",[0,[1,"_double"]],["scheme/foreign"]],
["_double*",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__double*))",[0,[1,"_double*"]],["scheme/foreign"]],
["_enum",">foreign/Enumerations_and_Masks.html#(def._((lib._scheme/foreign..ss).__enum))",[0,[1,"_enum"]],["scheme/foreign"]],
["_f32vector",">foreign/Derived_Utilities.html#(form._((lib._scheme/foreign..ss).__f32vector))",[0,[6,"_f32vector"]],["scheme/foreign"]],
["_f64vector",">foreign/Derived_Utilities.html#(form._((lib._scheme/foreign..ss).__f64vector))",[0,[6,"_f64vector"]],["scheme/foreign"]],
["_file",">foreign/String_Types.html#(def._((lib._scheme/foreign..ss).__file))",[0,[1,"_file"]],["scheme/foreign"]],
["_fixint",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__fixint))",[0,[1,"_fixint"]],["scheme/foreign"]],
["_fixnum",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__fixnum))",[0,[1,"_fixnum"]],["scheme/foreign"]],
["_float",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__float))",[0,[1,"_float"]],["scheme/foreign"]],
["_fpointer",">foreign/Pointer_Types.html#(def._((lib._scheme/foreign..ss).__fpointer))",[0,[1,"_fpointer"]],["scheme/foreign"]],
["_fun",">foreign/foreign_procedures.html#(form._((lib._scheme/foreign..ss).__fun))",[0,[6,"_fun"]],["scheme/foreign"]],
["_int",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__int))",[0,[1,"_int"]],["scheme/foreign"]],
["_int16",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__int16))",[0,[1,"_int16"]],["scheme/foreign"]],
["_int32",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__int32))",[0,[1,"_int32"]],["scheme/foreign"]],
["_int64",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__int64))",[0,[1,"_int64"]],["scheme/foreign"]],
["_int8",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__int8))",[0,[1,"_int8"]],["scheme/foreign"]],
["_list",">foreign/foreign_procedures.html#(form._((lib._scheme/foreign..ss).__list))",[0,[6,"_list"]],["scheme/foreign"]],
["_list-struct",">foreign/C_Struct_Types.html#(def._((lib._scheme/foreign..ss).__list-struct))",[0,[1,"_list-struct"]],["scheme/foreign"]],
["_lockplt-prefs.ss",">drscheme/drscheme-files.html#(idx._(gentag._224._(lib._scribblings/drscheme/drscheme..scrbl)))",[5,"\"_LOCKplt-prefs.ss\""],false],
["_long",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__long))",[0,[1,"_long"]],["scheme/foreign"]],
["_path",">foreign/String_Types.html#(def._((lib._scheme/foreign..ss).__path))",[0,[1,"_path"]],["scheme/foreign"]],
["_pointer",">foreign/Pointer_Types.html#(def._((lib._scheme/foreign..ss).__pointer))",[0,[1,"_pointer"]],["scheme/foreign"]],
["_ptr",">foreign/foreign_procedures.html#(form._((lib._scheme/foreign..ss).__ptr))",[0,[6,"_ptr"]],["scheme/foreign"]],
["_s16vector",">foreign/Derived_Utilities.html#(form._((lib._scheme/foreign..ss).__s16vector))",[0,[6,"_s16vector"]],["scheme/foreign"]],
["_s32vector",">foreign/Derived_Utilities.html#(form._((lib._scheme/foreign..ss).__s32vector))",[0,[6,"_s32vector"]],["scheme/foreign"]],
["_s64vector",">foreign/Derived_Utilities.html#(form._((lib._scheme/foreign..ss).__s64vector))",[0,[6,"_s64vector"]],["scheme/foreign"]],
["_s8vector",">foreign/Derived_Utilities.html#(form._((lib._scheme/foreign..ss).__s8vector))",[0,[6,"_s8vector"]],["scheme/foreign"]],
["_sbyte",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__sbyte))",[0,[1,"_sbyte"]],["scheme/foreign"]],
["_scheme",">foreign/Pointer_Types.html#(def._((lib._scheme/foreign..ss).__scheme))",[0,[1,"_scheme"]],["scheme/foreign"]],
["_scheme_apply",">inside/Evaluation.html#(idx._(gentag._268._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"_scheme_apply"]],false],
["_scheme_apply_multi",">inside/Evaluation.html#(idx._(gentag._269._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"_scheme_apply_multi"]],false],
["_scheme_eval_compiled",">inside/Evaluation.html#(idx._(gentag._262._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"_scheme_eval_compiled"]],false],
["_scheme_eval_compiled_multi",">inside/Evaluation.html#(idx._(gentag._263._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"_scheme_eval_compiled_multi"]],false],
["_short",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__short))",[0,[1,"_short"]],["scheme/foreign"]],
["_sint",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__sint))",[0,[1,"_sint"]],["scheme/foreign"]],
["_sint16",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__sint16))",[0,[1,"_sint16"]],["scheme/foreign"]],
["_sint32",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__sint32))",[0,[1,"_sint32"]],["scheme/foreign"]],
["_sint64",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__sint64))",[0,[1,"_sint64"]],["scheme/foreign"]],
["_sint8",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__sint8))",[0,[1,"_sint8"]],["scheme/foreign"]],
["_slong",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__slong))",[0,[1,"_slong"]],["scheme/foreign"]],
["_sshort",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__sshort))",[0,[1,"_sshort"]],["scheme/foreign"]],
["_string",">foreign/String_Types.html#(def._((lib._scheme/foreign..ss).__string))",[0,[1,"_string"]],["scheme/foreign"]],
["_string*/latin-1",">foreign/String_Types.html#(def._((lib._scheme/foreign..ss).__string*/latin-1))",[0,[1,"_string*/latin-1"]],["scheme/foreign"]],
["_string*/locale",">foreign/String_Types.html#(def._((lib._scheme/foreign..ss).__string*/locale))",[0,[1,"_string*/locale"]],["scheme/foreign"]],
["_string*/utf-8",">foreign/String_Types.html#(def._((lib._scheme/foreign..ss).__string*/utf-8))",[0,[1,"_string*/utf-8"]],["scheme/foreign"]],
["_string/eof",">foreign/String_Types.html#(def._((lib._scheme/foreign..ss).__string/eof))",[0,[1,"_string/eof"]],["scheme/foreign"]],
["_string/latin-1",">foreign/String_Types.html#(def._((lib._scheme/foreign..ss).__string/latin-1))",[0,[1,"_string/latin-1"]],["scheme/foreign"]],
["_string/locale",">foreign/String_Types.html#(def._((lib._scheme/foreign..ss).__string/locale))",[0,[1,"_string/locale"]],["scheme/foreign"]],
["_string/ucs-4",">foreign/String_Types.html#(def._((lib._scheme/foreign..ss).__string/ucs-4))",[0,[1,"_string/ucs-4"]],["scheme/foreign"]],
["_string/utf-16",">foreign/String_Types.html#(def._((lib._scheme/foreign..ss).__string/utf-16))",[0,[1,"_string/utf-16"]],["scheme/foreign"]],
["_string/utf-8",">foreign/String_Types.html#(def._((lib._scheme/foreign..ss).__string/utf-8))",[0,[1,"_string/utf-8"]],["scheme/foreign"]],
["_sword",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__sword))",[0,[1,"_sword"]],["scheme/foreign"]],
["_symbol",">foreign/String_Types.html#(def._((lib._scheme/foreign..ss).__symbol))",[0,[1,"_symbol"]],["scheme/foreign"]],
["_u16vector",">foreign/Derived_Utilities.html#(form._((lib._scheme/foreign..ss).__u16vector))",[0,[6,"_u16vector"]],["scheme/foreign"]],
["_u32vector",">foreign/Derived_Utilities.html#(form._((lib._scheme/foreign..ss).__u32vector))",[0,[6,"_u32vector"]],["scheme/foreign"]],
["_u64vector",">foreign/Derived_Utilities.html#(form._((lib._scheme/foreign..ss).__u64vector))",[0,[6,"_u64vector"]],["scheme/foreign"]],
["_u8vector",">foreign/Derived_Utilities.html#(form._((lib._scheme/foreign..ss).__u8vector))",[0,[6,"_u8vector"]],["scheme/foreign"]],
["_ubyte",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__ubyte))",[0,[1,"_ubyte"]],["scheme/foreign"]],
["_ufixint",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__ufixint))",[0,[1,"_ufixint"]],["scheme/foreign"]],
["_ufixnum",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__ufixnum))",[0,[1,"_ufixnum"]],["scheme/foreign"]],
["_uint",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__uint))",[0,[1,"_uint"]],["scheme/foreign"]],
["_uint16",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__uint16))",[0,[1,"_uint16"]],["scheme/foreign"]],
["_uint32",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__uint32))",[0,[1,"_uint32"]],["scheme/foreign"]],
["_uint64",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__uint64))",[0,[1,"_uint64"]],["scheme/foreign"]],
["_uint8",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__uint8))",[0,[1,"_uint8"]],["scheme/foreign"]],
["_ulong",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__ulong))",[0,[1,"_ulong"]],["scheme/foreign"]],
["_ushort",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__ushort))",[0,[1,"_ushort"]],["scheme/foreign"]],
["_uword",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__uword))",[0,[1,"_uword"]],["scheme/foreign"]],
["_vector",">foreign/foreign_procedures.html#(form._((lib._scheme/foreign..ss).__vector))",[0,[6,"_vector"]],["scheme/foreign"]],
["_void",">foreign/Other_Atomic_Types.html#(def._((lib._scheme/foreign..ss).__void))",[0,[1,"_void"]],["scheme/foreign"]],
["_word",">foreign/Numeric_Types.html#(def._((lib._scheme/foreign..ss).__word))",[0,[1,"_word"]],["scheme/foreign"]],
["`",">reference/reader.html#(idx._(gentag._172._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"`"],[3,""]]],false],
["a",">html/index.html#(def._((lib._html/main..ss)._a))",[0,[1,"a"]],["html"]],
["a customer manager component for managing customer relationships",">guide/contracts-examples.html#(part._.A_.Customer_.Manager_.Component_for_.Managing_.Customer_.Relationships)","A Customer Manager Component for Managing Customer Relationships",false],
["a dictionary",">guide/contracts-examples.html#(part._.A_.Dictionary)","A Dictionary",false],
["a first contract violation",">guide/contract-boundaries.html#(part._contracts-amount0)","A First Contract Violation",false],
["a first example",">teachpack/world.html#(part._example)","A First Example",false],
["a first function",">typed-scheme/index.html#(part._.A_.First_.Function)","A First Function",false],
["a model of persistent",">continue/index.html#(part._.A_.Model_of_.Persistent)","A Model of Persistent",false],
["a more complicated example",">graphics/A_More_Complicated_Example.html","A More Complicated Example",false],
["a note to readers with scheme/lisp experience",">guide/intro.html#(part._use-module)","A Note to Readers with Scheme/Lisp Experience",false],
["a parameteric (simple) stack",">guide/contracts-examples.html#(part._.A_.Parameteric__.Simple__.Stack)","A Parameteric (Simple) Stack",false],
["a queue",">guide/contracts-examples.html#(part._.A_.Queue)","A Queue",false],
["a subtle contract violation",">guide/contract-boundaries.html#(part._contracts-qamount)","A Subtle Contract Violation",false],
["a-c-down keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._179._(lib._scribblings/drscheme/drscheme..scrbl)))","A-C-down keybinding",false],
["a-c-left keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._173._(lib._scribblings/drscheme/drscheme..scrbl)))","A-C-left keybinding",false],
["a-c-right keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._175._(lib._scribblings/drscheme/drscheme..scrbl)))","A-C-right keybinding",false],
["a-c-up keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._177._(lib._scribblings/drscheme/drscheme..scrbl)))","A-C-up keybinding",false],
["a?",">html/index.html#(def._((lib._html/main..ss)._a~3f))",[0,[1,"a?"]],["html"]],
["abbr",">html/index.html#(def._((lib._html/main..ss)._abbr))",[0,[1,"abbr"]],["html"]],
["abbr?",">html/index.html#(def._((lib._html/main..ss)._abbr~3f))",[0,[1,"abbr?"]],["html"]],
["abbreviate-cons-as-list",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..ss)._abbreviate-cons-as-list))",[0,[1,"abbreviate-cons-as-list"]],["mzlib/pconvert"]],
["abbreviating quote with '",">guide/Pairs__Lists__and_Scheme_Syntax.html#(part._.Abbreviating_quote_with__)",["Abbreviating ",[0,[6,"quote"]]," with ",[7,"&rsquo;"]],false],
["abort",">reference/cont.html#(def._((lib._scheme/control..ss)._abort))",[0,[1,"abort"]],["scheme/control"]],
["abort-current-continuation",">reference/cont.html#(def._((quote._~23~25kernel)._abort-current-continuation))",[0,[1,"abort-current-continuation"]],["scheme/base","scheme"]],
["aborts",">reference/bytestrings.html#(idx._(gentag._32._(lib._scribblings/reference/reference..scrbl)))",[7,"'aborts"],false],
["aborts",">guide/prompt.html#(tech._abort)","<i>aborts</i>",false],
["about com method",">mzcom/index.html#(idx._(gentag._0._(lib._mzcom/mzcom..scrbl)))",[[5,"About"]," COM method"],false],
["about drscheme... menu item",">drscheme/Menus.html#(idx._(gentag._146._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">About DrScheme...</font></b> menu item",false],
["abs",">reference/numbers.html#(def._((quote._~23~25kernel)._abs))",[0,[1,"abs"]],["scheme/base","scheme"]],
["abs",">r5rs-std/r5rs-Z-H-9.html#%_idx_298",[0,[1,"abs"]],["r5rs"]],
["abs",">r6rs-std/r6rs-Z-H-14.html#node_idx_506",[0,[1,"abs"]],["rnrs/base-6"]],
["abs",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._abs))",[0,[1,"abs"]],["lang/htdp-advanced"]],
["abs",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._abs))",[0,[1,"abs"]],["lang/htdp-beginner"]],
["abs",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._abs))",[0,[1,"abs"]],["lang/htdp-beginner-abbr"]],
["abs",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._abs))",[0,[1,"abs"]],["lang/htdp-intermediate"]],
["abs",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._abs))",[0,[1,"abs"]],["lang/htdp-intermediate-lambda"]],
["absolute-installation?",">config/index.html#(def._((lib._config/main..ss)._absolute-installation~3f))",[0,[1,"absolute-installation?"]],["config"]],
["absolute-installation?",">setup-plt/dirs.html#(def._((lib._setup/dirs..ss)._absolute-installation~3f))",[0,[1,"absolute-installation?"]],["setup/dirs"]],
["absolute-path?",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._absolute-path~3f))",[0,[1,"absolute-path?"]],["scheme/base","scheme"]],
["abstracting the model",">continue/index.html#(part._.Abstracting_the_.Model)","Abstracting the Model",false],
["accept-drop-files",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._accept-drop-files))",[[0,[1,"accept-drop-files"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["accept-tab-focus",">gui/canvas_.html#(meth._(((lib._mred/main..ss)._canvas~25)._accept-tab-focus))",[[0,[1,"accept-tab-focus"]],[12,[" (method of ",[0,[1,"canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["acceptable local package",">planet/search-order.html#(part._.Acceptable_.Local_.Package)","Acceptable Local Package",false],
["acceptable remote package",">planet/search-order.html#(part._.Acceptable_.Remote_.Package)","Acceptable Remote Package",false],
["accessor",">guide/define-struct.html#(tech._accessor)","<i>accessor</i>",false],
["accessor",">reference/define-struct.html#(tech._accessor)","<i>accessor</i>",false],
["accum-b",">frtime/index.html#(def._((lib._frtime/main..ss)._accum-b))",[0,[1,"accum-b"]],["frtime"]],
["accum-e",">frtime/index.html#(def._((lib._frtime/main..ss)._accum-e))",[0,[1,"accum-e"]],["frtime"]],
["aces --- solitaire card game",">games/aces.html",[[13,"<img src=\"aces.png\" />"]," ","<b><font size=\"-1\" face=\"Helvetica\">Aces</font></b>","  ","&ndash;","  Solitaire Card Game"],false],
["acknowledgements",">acks/index.html","Acknowledgements",false],
["acknowledgements",">web-server/ack.html","Acknowledgements",false],
["acknowledgments",">mrlib/Acknowledgments.html","Acknowledgments",false],
["acknowledgments",">mzcom/index.html#(part._.Acknowledgments)","Acknowledgments",false],
["acos",">reference/numbers.html#(def._((quote._~23~25kernel)._acos))",[0,[1,"acos"]],["scheme/base","scheme"]],
["acos",">r5rs-std/r5rs-Z-H-9.html#%_idx_338",[0,[1,"acos"]],["r5rs"]],
["acos",">r6rs-std/r6rs-Z-H-14.html#node_idx_554",[0,[1,"acos"]],["rnrs/base-6"]],
["acos",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._acos))",[0,[1,"acos"]],["lang/htdp-advanced"]],
["acos",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._acos))",[0,[1,"acos"]],["lang/htdp-beginner"]],
["acos",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._acos))",[0,[1,"acos"]],["lang/htdp-beginner-abbr"]],
["acos",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._acos))",[0,[1,"acos"]],["lang/htdp-intermediate"]],
["acos",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._acos))",[0,[1,"acos"]],["lang/htdp-intermediate-lambda"]],
["acronym",">html/index.html#(def._((lib._html/main..ss)._acronym))",[0,[1,"acronym"]],["html"]],
["acronym?",">html/index.html#(def._((lib._html/main..ss)._acronym~3f))",[0,[1,"acronym?"]],["html"]],
["actions and completeness",">framework/Test.html#(part._test~3aactions-completeness)","Actions and completeness",false],
["active certificate",">reference/stxcerts.html#(tech._active._certificate)","<i>active certificate</i>",false],
["active frame",">framework/Test.html#(part._.Active_.Frame)","Active Frame",false],
["active-child",">framework/Panel.html#(meth._(((lib._framework/main..ss)._panel~3asingle~3c~25~3e)._active-child))",[[0,[1,"active-child"]],[12,[" (method of ",[0,[1,"panel:single&lt;%&gt;"]],")"]]],["framework"]],
["activex",">mysterx/index.html#(idx._(gentag._0._(lib._mysterx/scribblings/mysterx..scrbl)))","ActiveX",false],
["activex and dhtml",">mysterx/activex.html","ActiveX and DHTML",false],
["add",">gui/editor-data-class-list___.html#(meth._(((lib._mred/main..ss)._editor-data-class-list~3c~25~3e)._add))",[[0,[1,"add"]],[12,[" (method of ",[0,[1,"editor-data-class-list&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["add",">gui/snip-class-list___.html#(meth._(((lib._mred/main..ss)._snip-class-list~3c~25~3e)._add))",[[0,[1,"add"]],[12,[" (method of ",[0,[1,"snip-class-list&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["add",">gui/key-event_.html#(idx._(gentag._81._(lib._scribblings/gui/gui..scrbl)))",[7,"'add"],false],
["add teachpack... menu item",">drscheme/Menus.html#(idx._(gentag._116._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Add Teachpack...</font></b> menu item",false],
["add user-defined keybindings... menu item",">drscheme/Menus.html#(idx._(gentag._94._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Add User-defined Keybindings...</font></b> menu item",false],
["add-area",">browser/index.html#(meth._(((lib._browser/main..ss)._image-map-snip~25)._add-area))",[[0,[1,"add-area"]],[12,[" (method of ",[0,[1,"image-map-snip%"]],")"]]],["browser"]],
["add-between",">reference/pairs.html#(def._((lib._scheme/list..ss)._add-between))",[0,[1,"add-between"]],["scheme/list","scheme"]],
["add-canvas",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._add-canvas))",[[0,[1,"add-canvas"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["add-card",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._add-card))",[[0,[1,"add-card"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["add-cards",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._add-cards))",[[0,[1,"add-cards"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["add-cards-to-region",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._add-cards-to-region))",[[0,[1,"add-cards-to-region"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["add-child",">gui/area-container___.html#(meth._(((lib._mred/main..ss)._area-container~3c~25~3e)._add-child))",[[0,[1,"add-child"]],[12,[" (method of ",[0,[1,"area-container&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["add-child",">embedded-gui/alignment-parent___.html#(meth._(((lib._embedded-gui/main..ss)._alignment-parent~3c~25~3e)._add-child))",[[0,[1,"add-child"]],[12,[" (method of ",[0,[1,"alignment-parent&lt;%&gt;"]],")"]]],["embedded-gui"]],
["add-child",">mrlib/graph-snip___.html#(meth._(((lib._mrlib/graph..ss)._graph-snip~3c~25~3e)._add-child))",[[0,[1,"add-child"]],[12,[" (method of ",[0,[1,"graph-snip&lt;%&gt;"]],")"]]],["mrlib/graph"]],
["add-color<%>",">gui/add-color___.html",[0,[1,"add-color&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["add-duration",">srfi-std/srfi-19.html#add-duration",[0,[1,"add-duration"]],["srfi/19"]],
["add-duration!",">srfi-std/srfi-19.html#add-duration!",[0,[1,"add-duration!"]],["srfi/19"]],
["add-editor-keymap-functions",">gui/Editor_Functions.html#(def._((lib._mred/main..ss)._add-editor-keymap-functions))",[0,[1,"add-editor-keymap-functions"]],["scheme/gui/base","scheme/gui"]],
["add-function",">gui/keymap_.html#(meth._(((lib._mred/main..ss)._keymap~25)._add-function))",[[0,[1,"add-function"]],[12,[" (method of ",[0,[1,"keymap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["add-hard-link",">planet/Utility_Libraries.html#(def._((lib._planet/util..ss)._add-hard-link))",[0,[1,"add-hard-link"]],["planet/util"]],
["add-heads-up",">gl-board-game/index.html#(meth._(((lib._games/gl-board-game..ss)._gl-board~25)._add-heads-up))",[[0,[1,"add-heads-up"]],[12,[" (method of ",[0,[1,"gl-board%"]],")"]]],["games/gl-board-game"]],
["add-help-button",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._add-help-button))",[[0,[1,"add-help-button"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["add-history",">readline/index.html#(def._((lib._readline/readline..ss)._add-history))",[0,[1,"add-history"]],["readline/readline"]],
["add-history-bytes",">readline/index.html#(def._((lib._readline/readline..ss)._add-history-bytes))",[0,[1,"add-history-bytes"]],["readline/readline"]],
["add-line",">teachpack/image.html#(def._((lib._htdp/image..ss)._add-line))",[0,[1,"add-line"]],["teachpack/htdp/image"]],
["add-link",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-text-mixin)._add-link))",[[0,[1,"add-link"]],[12,[" (method of ",[0,[1,"hyper-text-mixin"]],")"]]],["browser"]],
["add-link",">browser/index.html#(meth._(((lib._browser/htmltext..ss)._html-text~3c~25~3e)._add-link))",[[0,[1,"add-link"]],[12,[" (method of ",[0,[1,"html-text&lt;%&gt;"]],")"]]],["browser/htmltext"]],
["add-links",">mrlib/Graph_Functions.html#(def._((lib._mrlib/graph..ss)._add-links))",[0,[1,"add-links"]],["mrlib/graph"]],
["add-links/text-colors",">mrlib/Graph_Functions.html#(def._((lib._mrlib/graph..ss)._add-links/text-colors))",[0,[1,"add-links/text-colors"]],["mrlib/graph"]],
["add-parent",">mrlib/graph-snip___.html#(meth._(((lib._mrlib/graph..ss)._graph-snip~3c~25~3e)._add-parent))",[[0,[1,"add-parent"]],[12,[" (method of ",[0,[1,"graph-snip&lt;%&gt;"]],")"]]],["mrlib/graph"]],
["add-pasteboard-keymap-functions",">gui/Editor_Functions.html#(def._((lib._mred/main..ss)._add-pasteboard-keymap-functions))",[0,[1,"add-pasteboard-keymap-functions"]],["scheme/gui/base","scheme/gui"]],
["add-piece",">gl-board-game/index.html#(meth._(((lib._games/gl-board-game..ss)._gl-board~25)._add-piece))",[[0,[1,"add-piece"]],[12,[" (method of ",[0,[1,"gl-board%"]],")"]]],["games/gl-board-game"]],
["add-region",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._add-region))",[[0,[1,"add-region"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["add-scheme-callback",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-text-mixin)._add-scheme-callback))",[[0,[1,"add-scheme-callback"]],[12,[" (method of ",[0,[1,"hyper-text-mixin"]],")"]]],["browser"]],
["add-scheme-callback",">browser/index.html#(meth._(((lib._browser/htmltext..ss)._html-text~3c~25~3e)._add-scheme-callback))",[[0,[1,"add-scheme-callback"]],[12,[" (method of ",[0,[1,"html-text&lt;%&gt;"]],")"]]],["browser/htmltext"]],
["add-scribble-button",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._add-scribble-button))",[[0,[1,"add-scribble-button"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["add-selected",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._add-selected))",[[0,[1,"add-selected"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["add-show-menu-items",">tools/drscheme_frame.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aframe~3a~3c~25~3e)._add-show-menu-items))",[[0,[1,"add-show-menu-items"]],[12,[" (method of ",[0,[1,"drscheme:frame:&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["add-show-menu-items",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._add-show-menu-items))",[[0,[1,"add-show-menu-items"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["add-space",">gl-board-game/index.html#(meth._(((lib._games/gl-board-game..ss)._gl-board~25)._add-space))",[[0,[1,"add-space"]],[12,[" (method of ",[0,[1,"gl-board%"]],")"]]],["games/gl-board-game"]],
["add-tag",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-text-mixin)._add-tag))",[[0,[1,"add-tag"]],[12,[" (method of ",[0,[1,"hyper-text-mixin"]],")"]]],["browser"]],
["add-tag",">browser/index.html#(meth._(((lib._browser/htmltext..ss)._html-text~3c~25~3e)._add-tag))",[[0,[1,"add-tag"]],[12,[" (method of ",[0,[1,"html-text&lt;%&gt;"]],")"]]],["browser/htmltext"]],
["add-tall-snip",">framework/Canvas.html#(meth._(((lib._framework/main..ss)._canvas~3awide-snip~3c~25~3e)._add-tall-snip))",[[0,[1,"add-tall-snip"]],[12,[" (method of ",[0,[1,"canvas:wide-snip&lt;%&gt;"]],")"]]],["framework"]],
["add-tall-snip",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3awide-snip~3c~25~3e)._add-tall-snip))",[[0,[1,"add-tall-snip"]],[12,[" (method of ",[0,[1,"text:wide-snip&lt;%&gt;"]],")"]]],["framework"]],
["add-text-keymap-functions",">gui/Editor_Functions.html#(def._((lib._mred/main..ss)._add-text-keymap-functions))",[0,[1,"add-text-keymap-functions"]],["scheme/gui/base","scheme/gui"]],
["add-thunk-callback",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-text-mixin)._add-thunk-callback))",[[0,[1,"add-thunk-callback"]],[12,[" (method of ",[0,[1,"hyper-text-mixin"]],")"]]],["browser"]],
["add-thunk-callback",">browser/index.html#(meth._(((lib._browser/htmltext..ss)._html-text~3c~25~3e)._add-thunk-callback))",[[0,[1,"add-thunk-callback"]],[12,[" (method of ",[0,[1,"html-text&lt;%&gt;"]],")"]]],["browser/htmltext"]],
["add-to-browser-prefs-panel",">browser/index.html#(def._((lib._browser/external..ss)._add-to-browser-prefs-panel))",[0,[1,"add-to-browser-prefs-panel"]],["browser/external"]],
["add-to-input",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..ss)._add-to-input))",[0,[1,"add-to-input"]],["preprocessor/mztext"]],
["add-type",">gui/clipboard-client_.html#(meth._(((lib._mred/main..ss)._clipboard-client~25)._add-type))",[[0,[1,"add-type"]],[12,[" (method of ",[0,[1,"clipboard-client%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["add-undo",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._add-undo))",[[0,[1,"add-undo"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["add-wide-snip",">framework/Canvas.html#(meth._(((lib._framework/main..ss)._canvas~3awide-snip~3c~25~3e)._add-wide-snip))",[[0,[1,"add-wide-snip"]],[12,[" (method of ",[0,[1,"canvas:wide-snip&lt;%&gt;"]],")"]]],["framework"]],
["add-wide-snip",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3awide-snip~3c~25~3e)._add-wide-snip))",[[0,[1,"add-wide-snip"]],[12,[" (method of ",[0,[1,"text:wide-snip&lt;%&gt;"]],")"]]],["framework"]],
["add1",">reference/numbers.html#(def._((quote._~23~25kernel)._add1))",[0,[1,"add1"]],["scheme/base","scheme"]],
["add1",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._add1))",[0,[1,"add1"]],["lang/htdp-advanced"]],
["add1",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._add1))",[0,[1,"add1"]],["lang/htdp-beginner"]],
["add1",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._add1))",[0,[1,"add1"]],["lang/htdp-beginner-abbr"]],
["add1",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._add1))",[0,[1,"add1"]],["lang/htdp-intermediate"]],
["add1",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._add1))",[0,[1,"add1"]],["lang/htdp-intermediate-lambda"]],
["adding a back button",">continue/index.html#(part._.Adding_a_.Back_.Button)","Adding a Back Button",false],
["adding arbitrary languages to drscheme",">tools/adding-languages.html#(part._.Adding_.Arbitrary_.Languages_to_.Dr.Scheme)","Adding Arbitrary Languages to DrScheme",false],
["adding languages to drscheme",">tools/adding-languages.html","Adding Languages to DrScheme",false],
["adding languages to drscheme",">tools/adding-languages.html#(idx._(gentag._2._(lib._scribblings/tools/tools..scrbl)))","adding languages to DrScheme",false],
["adding module-based languages to drscheme",">tools/adding-languages.html#(part._.Adding_.Module-based_.Languages_to_.Dr.Scheme)","Adding Module-based Languages to DrScheme",false],
["adding more complexity",">typed-scheme/index.html#(part._complex)","Adding more complexity",false],
["adding string constants",">string-constants/index.html#(part._.Adding_.String_.Constants)","Adding String Constants",false],
["additional custom-output support",">reference/pretty-print.html#(part._.Additional_.Custom-.Output_.Support)","Additional Custom-Output Support",false],
["additional list functions and synonyms",">reference/pairs.html#(part._.Additional_.List_.Functions_and_.Synonyms)","Additional List Functions and Synonyms",false],
["additional procedure functions",">reference/procedures.html#(part._.Additional_.Procedure_.Functions)","Additional Procedure Functions",false],
["additional provide forms",">reference/require.html#(part._.Additional_provide_.Forms)",["Additional ",[0,[6,"provide"]]," Forms"],false],
["additional require forms",">reference/require.html#(part._.Additional_require_.Forms)",["Additional ",[0,[6,"require"]]," Forms"],false],
["additional string functions",">reference/strings.html#(part._.Additional_.String_.Functions)","Additional String Functions",false],
["additional syntactic constraints",">reference/regexp.html#(part._.Additional_.Syntactic_.Constraints)","Additional Syntactic Constraints",false],
["addon-dir",">reference/Filesystem.html#(idx._(gentag._254._(lib._scribblings/reference/reference..scrbl)))",[7,"'addon-dir"],false],
["address",">html/index.html#(def._((lib._html/main..ss)._address))",[0,[1,"address"]],["html"]],
["address?",">html/index.html#(def._((lib._html/main..ss)._address~3f))",[0,[1,"address?"]],["html"]],
["adjust-connection-timeout!",">web-server/connection-manager_ss.html#(def._((lib._web-server/private/connection-manager..ss)._adjust-connection-timeout!))",[0,[1,"adjust-connection-timeout!"]],["web-server/private/connection-manager"]],
["adjust-cursor",">gui/editor-snip_.html#(meth._(((lib._mred/main..ss)._editor-snip~25)._adjust-cursor))",[[0,[1,"adjust-cursor"]],[12,[" (method of ",[0,[1,"editor-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["adjust-cursor",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._adjust-cursor))",[[0,[1,"adjust-cursor"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["adjust-cursor",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._adjust-cursor))",[[0,[1,"adjust-cursor"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["adjust-timeout!",">web-server/web_ss.html#(def._((lib._web-server/servlet/web..ss)._adjust-timeout!))",[0,[1,"adjust-timeout!"]],["web-server/servlet/web"]],
["administrators",">gui/editor-overview.html#(part._editoradministrators)","Administrators",false],
["advanced control flow",">continue/index.html#(part._.Advanced_.Control_.Flow)","Advanced Control Flow",false],
["advanced student",">htdp-langs/advanced.html","Advanced Student",false],
["advanced student language",">drscheme/htdp-langs.html#(idx._(gentag._47._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Advanced Student</font></b> language",false],
["afm",">gui/fontresources.html#(idx._(gentag._306._(lib._scribblings/gui/gui..scrbl)))","AFM",false],
["after-change-style",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._after-change-style))",[[0,[1,"after-change-style"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["after-change-style",">framework/Color.html#(meth._(((lib._framework/main..ss)._color~3atext-mixin)._after-change-style))",[[0,[1,"after-change-style"]],[12,[" (method of ",[0,[1,"color:text-mixin"]],")"]]],["framework"]],
["after-change-style",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._after-change-style))",[[0,[1,"after-change-style"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["after-change-style",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._after-change-style))",[[0,[1,"after-change-style"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["after-change-style",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3adelegate-mixin)._after-change-style))",[[0,[1,"after-change-style"]],[12,[" (method of ",[0,[1,"text:delegate-mixin"]],")"]]],["framework"]],
["after-delete",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._after-delete))",[[0,[1,"after-delete"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["after-delete",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._after-delete))",[[0,[1,"after-delete"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["after-delete",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3atext~25)._after-delete))",[[0,[1,"after-delete"]],[12,[" (method of ",[0,[1,"drscheme:rep:text%"]],")"]]],["drscheme/tool-lib"]],
["after-delete",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aprogram-editor-mixin)._after-delete))",[[0,[1,"after-delete"]],[12,[" (method of ",[0,[1,"drscheme:unit:program-editor-mixin"]],")"]]],["drscheme/tool-lib"]],
["after-delete",">framework/Color.html#(meth._(((lib._framework/main..ss)._color~3atext-mixin)._after-delete))",[[0,[1,"after-delete"]],[12,[" (method of ",[0,[1,"color:text-mixin"]],")"]]],["framework"]],
["after-delete",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._after-delete))",[[0,[1,"after-delete"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["after-delete",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._after-delete))",[[0,[1,"after-delete"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["after-delete",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3adelegate-mixin)._after-delete))",[[0,[1,"after-delete"]],[12,[" (method of ",[0,[1,"text:delegate-mixin"]],")"]]],["framework"]],
["after-delete",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3ainfo-mixin)._after-delete))",[[0,[1,"after-delete"]],[12,[" (method of ",[0,[1,"text:info-mixin"]],")"]]],["framework"]],
["after-delete",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3asearching-mixin)._after-delete))",[[0,[1,"after-delete"]],[12,[" (method of ",[0,[1,"text:searching-mixin"]],")"]]],["framework"]],
["after-delete",">mrlib/horizontal-pasteboard_.html#(meth._(((lib._mrlib/aligned-pasteboard..ss)._horizontal-pasteboard~25)._after-delete))",[[0,[1,"after-delete"]],[12,[" (method of ",[0,[1,"horizontal-pasteboard%"]],")"]]],["mrlib/aligned-pasteboard"]],
["after-delete",">mrlib/vertical-pasteboard_.html#(meth._(((lib._mrlib/aligned-pasteboard..ss)._vertical-pasteboard~25)._after-delete))",[[0,[1,"after-delete"]],[12,[" (method of ",[0,[1,"vertical-pasteboard%"]],")"]]],["mrlib/aligned-pasteboard"]],
["after-edit-sequence",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._after-edit-sequence))",[[0,[1,"after-edit-sequence"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["after-edit-sequence",">framework/Color.html#(meth._(((lib._framework/main..ss)._color~3atext-mixin)._after-edit-sequence))",[[0,[1,"after-edit-sequence"]],[12,[" (method of ",[0,[1,"color:text-mixin"]],")"]]],["framework"]],
["after-edit-sequence",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abasic-mixin)._after-edit-sequence))",[[0,[1,"after-edit-sequence"]],[12,[" (method of ",[0,[1,"editor:basic-mixin"]],")"]]],["framework"]],
["after-edit-sequence",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._after-edit-sequence))",[[0,[1,"after-edit-sequence"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["after-edit-sequence",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._after-edit-sequence))",[[0,[1,"after-edit-sequence"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["after-edit-sequence",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3adelegate-mixin)._after-edit-sequence))",[[0,[1,"after-edit-sequence"]],[12,[" (method of ",[0,[1,"text:delegate-mixin"]],")"]]],["framework"]],
["after-insert",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._after-insert))",[[0,[1,"after-insert"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["after-insert",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._after-insert))",[[0,[1,"after-insert"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["after-insert",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3atext~25)._after-insert))",[[0,[1,"after-insert"]],[12,[" (method of ",[0,[1,"drscheme:rep:text%"]],")"]]],["drscheme/tool-lib"]],
["after-insert",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aprogram-editor-mixin)._after-insert))",[[0,[1,"after-insert"]],[12,[" (method of ",[0,[1,"drscheme:unit:program-editor-mixin"]],")"]]],["drscheme/tool-lib"]],
["after-insert",">framework/Color.html#(meth._(((lib._framework/main..ss)._color~3atext-mixin)._after-insert))",[[0,[1,"after-insert"]],[12,[" (method of ",[0,[1,"color:text-mixin"]],")"]]],["framework"]],
["after-insert",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._after-insert))",[[0,[1,"after-insert"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["after-insert",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._after-insert))",[[0,[1,"after-insert"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["after-insert",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3abasic-mixin)._after-insert))",[[0,[1,"after-insert"]],[12,[" (method of ",[0,[1,"text:basic-mixin"]],")"]]],["framework"]],
["after-insert",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3adelegate-mixin)._after-insert))",[[0,[1,"after-insert"]],[12,[" (method of ",[0,[1,"text:delegate-mixin"]],")"]]],["framework"]],
["after-insert",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3ainfo-mixin)._after-insert))",[[0,[1,"after-insert"]],[12,[" (method of ",[0,[1,"text:info-mixin"]],")"]]],["framework"]],
["after-insert",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3anbsp-~3espace-mixin)._after-insert))",[[0,[1,"after-insert"]],[12,[" (method of ",[0,[1,"text:nbsp-&gt;space-mixin"]],")"]]],["framework"]],
["after-insert",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3asearching-mixin)._after-insert))",[[0,[1,"after-insert"]],[12,[" (method of ",[0,[1,"text:searching-mixin"]],")"]]],["framework"]],
["after-insert",">mrlib/horizontal-pasteboard_.html#(meth._(((lib._mrlib/aligned-pasteboard..ss)._horizontal-pasteboard~25)._after-insert))",[[0,[1,"after-insert"]],[12,[" (method of ",[0,[1,"horizontal-pasteboard%"]],")"]]],["mrlib/aligned-pasteboard"]],
["after-insert",">mrlib/vertical-pasteboard_.html#(meth._(((lib._mrlib/aligned-pasteboard..ss)._vertical-pasteboard~25)._after-insert))",[[0,[1,"after-insert"]],[12,[" (method of ",[0,[1,"vertical-pasteboard%"]],")"]]],["mrlib/aligned-pasteboard"]],
["after-interactive-move",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._after-interactive-move))",[[0,[1,"after-interactive-move"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["after-interactive-resize",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._after-interactive-resize))",[[0,[1,"after-interactive-resize"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["after-io-insertion",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._after-io-insertion))",[[0,[1,"after-io-insertion"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["after-load-file",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._after-load-file))",[[0,[1,"after-load-file"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["after-load-file",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abasic-mixin)._after-load-file))",[[0,[1,"after-load-file"]],[12,[" (method of ",[0,[1,"editor:basic-mixin"]],")"]]],["framework"]],
["after-load-file",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._after-load-file))",[[0,[1,"after-load-file"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["after-load-file",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._after-load-file))",[[0,[1,"after-load-file"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["after-load-file",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3adelegate-mixin)._after-load-file))",[[0,[1,"after-load-file"]],[12,[" (method of ",[0,[1,"text:delegate-mixin"]],")"]]],["framework"]],
["after-load-file",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3afile-mixin)._after-load-file))",[[0,[1,"after-load-file"]],[12,[" (method of ",[0,[1,"text:file-mixin"]],")"]]],["framework"]],
["after-merge-snips",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._after-merge-snips))",[[0,[1,"after-merge-snips"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["after-move-to",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._after-move-to))",[[0,[1,"after-move-to"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["after-new-child",">gui/area-container___.html#(meth._(((lib._mred/main..ss)._area-container~3c~25~3e)._after-new-child))",[[0,[1,"after-new-child"]],[12,[" (method of ",[0,[1,"area-container&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["after-new-child",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3abasic-mixin)._after-new-child))",[[0,[1,"after-new-child"]],[12,[" (method of ",[0,[1,"frame:basic-mixin"]],")"]]],["framework"]],
["after-new-child",">framework/Panel.html#(meth._(((lib._framework/main..ss)._panel~3adragable-mixin)._after-new-child))",[[0,[1,"after-new-child"]],[12,[" (method of ",[0,[1,"panel:dragable-mixin"]],")"]]],["framework"]],
["after-new-child",">framework/Panel.html#(meth._(((lib._framework/main..ss)._panel~3asingle-mixin)._after-new-child))",[[0,[1,"after-new-child"]],[12,[" (method of ",[0,[1,"panel:single-mixin"]],")"]]],["framework"]],
["after-percentage-change",">framework/Panel.html#(meth._(((lib._framework/main..ss)._panel~3adragable~3c~25~3e)._after-percentage-change))",[[0,[1,"after-percentage-change"]],[12,[" (method of ",[0,[1,"panel:dragable&lt;%&gt;"]],")"]]],["framework"]],
["after-reorder",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._after-reorder))",[[0,[1,"after-reorder"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["after-reorder",">mrlib/horizontal-pasteboard_.html#(meth._(((lib._mrlib/aligned-pasteboard..ss)._horizontal-pasteboard~25)._after-reorder))",[[0,[1,"after-reorder"]],[12,[" (method of ",[0,[1,"horizontal-pasteboard%"]],")"]]],["mrlib/aligned-pasteboard"]],
["after-reorder",">mrlib/vertical-pasteboard_.html#(meth._(((lib._mrlib/aligned-pasteboard..ss)._vertical-pasteboard~25)._after-reorder))",[[0,[1,"after-reorder"]],[12,[" (method of ",[0,[1,"vertical-pasteboard%"]],")"]]],["mrlib/aligned-pasteboard"]],
["after-resize",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._after-resize))",[[0,[1,"after-resize"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["after-save-file",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._after-save-file))",[[0,[1,"after-save-file"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["after-save-file",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abasic-mixin)._after-save-file))",[[0,[1,"after-save-file"]],[12,[" (method of ",[0,[1,"editor:basic-mixin"]],")"]]],["framework"]],
["after-save-file",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._after-save-file))",[[0,[1,"after-save-file"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["after-save-file",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._after-save-file))",[[0,[1,"after-save-file"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["after-save-file",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3afile-mixin)._after-save-file))",[[0,[1,"after-save-file"]],[12,[" (method of ",[0,[1,"text:file-mixin"]],")"]]],["framework"]],
["after-select",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._after-select))",[[0,[1,"after-select"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["after-set-next-settings",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3adefinitions-text~3c~25~3e)._after-set-next-settings))",[[0,[1,"after-set-next-settings"]],[12,[" (method of ",[0,[1,"drscheme:unit:definitions-text&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["after-set-page",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-canvas-mixin)._after-set-page))",[[0,[1,"after-set-page"]],[12,[" (method of ",[0,[1,"hyper-canvas-mixin"]],")"]]],["browser"]],
["after-set-position",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._after-set-position))",[[0,[1,"after-set-position"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["after-set-position",">framework/Color.html#(meth._(((lib._framework/main..ss)._color~3atext-mixin)._after-set-position))",[[0,[1,"after-set-position"]],[12,[" (method of ",[0,[1,"color:text-mixin"]],")"]]],["framework"]],
["after-set-position",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._after-set-position))",[[0,[1,"after-set-position"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["after-set-position",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._after-set-position))",[[0,[1,"after-set-position"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["after-set-position",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3ahide-caret/selection-mixin)._after-set-position))",[[0,[1,"after-set-position"]],[12,[" (method of ",[0,[1,"text:hide-caret/selection-mixin"]],")"]]],["framework"]],
["after-set-position",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3ainfo-mixin)._after-set-position))",[[0,[1,"after-set-position"]],[12,[" (method of ",[0,[1,"text:info-mixin"]],")"]]],["framework"]],
["after-set-size-constraint",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._after-set-size-constraint))",[[0,[1,"after-set-size-constraint"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["after-set-size-constraint",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._after-set-size-constraint))",[[0,[1,"after-set-size-constraint"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["after-set-size-constraint",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._after-set-size-constraint))",[[0,[1,"after-set-size-constraint"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["after-split-snip",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._after-split-snip))",[[0,[1,"after-split-snip"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["alarm-evt",">reference/sync.html#(def._((quote._~23~25kernel)._alarm-evt))",[0,[1,"alarm-evt"]],["scheme/base","scheme"]],
["algol 60",">algol60/index.html","<b>Algol 60</b>",false],
["algol60/algol60",">algol60/index.html#(mod-path._algol60/algol60)",[14,[0,"algol60/algol60"]],"module"],
["align",">embedded-gui/alignment___.html#(meth._(((lib._embedded-gui/main..ss)._alignment~3c~25~3e)._align))",[[0,[1,"align"]],[12,[" (method of ",[0,[1,"alignment&lt;%&gt;"]],")"]]],["embedded-gui"]],
["aligned pasteboard",">mrlib/Aligned_Pasteboard.html","Aligned Pasteboard",false],
["aligned-editor-canvas%",">mrlib/aligned-editor-canvas_.html",[0,[1,"aligned-editor-canvas%"]],["mrlib/aligned-pasteboard"]],
["aligned-editor-snip%",">mrlib/aligned-editor-snip_.html",[0,[1,"aligned-editor-snip%"]],["mrlib/aligned-pasteboard"]],
["aligned-pasteboard%",">embedded-gui/aligned-pasteboard_.html",[0,[1,"aligned-pasteboard%"]],["embedded-gui"]],
["aligned-pasteboard-parent<%>",">mrlib/aligned-pasteboard-parent___.html",[0,[1,"aligned-pasteboard-parent&lt;%&gt;"]],["mrlib/aligned-pasteboard"]],
["aligned-pasteboard<%>",">mrlib/aligned-pasteboard___.html",[0,[1,"aligned-pasteboard&lt;%&gt;"]],["mrlib/aligned-pasteboard"]],
["alignment",">gui/area-container___.html#(idx._(gentag._27._(lib._scribblings/gui/gui..scrbl)))",[0,"alignment"],false],
["alignment-parent<%>",">embedded-gui/alignment-parent___.html",[0,[1,"alignment-parent&lt;%&gt;"]],["embedded-gui"]],
["alignment<%>",">embedded-gui/alignment___.html",[0,[1,"alignment&lt;%&gt;"]],["embedded-gui"]],
["alink",">html/index.html#(def._((lib._html/main..ss)._alink))",[0,[1,"alink"]],["html"]],
["alink?",">html/index.html#(def._((lib._html/main..ss)._alink~3f))",[0,[1,"alink?"]],["html"]],
["alist->form-urlencoded",">net/uri-codec.html#(def._((lib._net/uri-codec..ss)._alist-~3eform-urlencoded))",[0,[1,"alist-&gt;form-urlencoded"]],["net/uri-codec"]],
["alist-cons",">srfi-std/srfi-1.html#alist-cons",[0,[1,"alist-cons"]],["srfi/1"]],
["alist-copy",">srfi-std/srfi-1.html#alist-copy",[0,[1,"alist-copy"]],["srfi/1"]],
["alist-delete",">srfi-std/srfi-1.html#alist-delete",[0,[1,"alist-delete"]],["srfi/1"]],
["alist-delete!",">srfi-std/srfi-1.html#alist-delete!",[0,[1,"alist-delete!"]],["srfi/1"]],
["all",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._.All))",[0,[6,"All"]],["typed-scheme"]],
["all-cards",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._all-cards))",[[0,[1,"all-cards"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["all-defined-out",">reference/require.html#(form._((lib._scheme/base..ss)._all-defined-out))",[0,[6,"all-defined-out"]],["scheme/base","scheme"]],
["all-from-out",">reference/require.html#(form._((lib._scheme/base..ss)._all-from-out))",[0,[6,"all-from-out"]],["scheme/base","scheme"]],
["all-languages",">string-constants/index.html#(form._((lib._string-constants/main..ss)._all-languages))",[0,[6,"all-languages"]],["string-constants"]],
["allocation",">inside/overview.html#(idx._(gentag._11._(lib._scribblings/inside/inside..scrbl)))","allocation",false],
["allocation",">inside/overview.html#(idx._(gentag._24._(lib._scribblings/inside/inside..scrbl)))","allocation",false],
["allow-close-with-no-filename?",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3afile~3c~25~3e)._allow-close-with-no-filename~3f))",[[0,[1,"allow-close-with-no-filename?"]],[12,[" (method of ",[0,[1,"editor:file&lt;%&gt;"]],")"]]],["framework"]],
["allow-deselect",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._allow-deselect))",[[0,[1,"allow-deselect"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["allow-scroll-to-last",">gui/editor-canvas_.html#(meth._(((lib._mred/main..ss)._editor-canvas~25)._allow-scroll-to-last))",[[0,[1,"allow-scroll-to-last"]],[12,[" (method of ",[0,[1,"editor-canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["allow-tab-exit",">gui/editor-canvas_.html#(meth._(((lib._mred/main..ss)._editor-canvas~25)._allow-tab-exit))",[[0,[1,"allow-tab-exit"]],[12,[" (method of ",[0,[1,"editor-canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["allowing thread switches",">inside/threads.html#(part._usefuel)","Allowing Thread Switches",false],
["alpha renaming",">drscheme/buttons.html#(idx._(gentag._11._(lib._scribblings/drscheme/drscheme..scrbl)))","alpha renaming",false],
["alpha-color",">teachpack/image.html#(def._((lib._htdp/image..ss)._alpha-color))",[0,[1,"alpha-color"]],["teachpack/htdp/image"]],
["alpha-color-alpha",">teachpack/image.html#(def._((lib._htdp/image..ss)._alpha-color-alpha))",[0,[1,"alpha-color-alpha"]],["teachpack/htdp/image"]],
["alpha-color-blue",">teachpack/image.html#(def._((lib._htdp/image..ss)._alpha-color-blue))",[0,[1,"alpha-color-blue"]],["teachpack/htdp/image"]],
["alpha-color-green",">teachpack/image.html#(def._((lib._htdp/image..ss)._alpha-color-green))",[0,[1,"alpha-color-green"]],["teachpack/htdp/image"]],
["alpha-color-list->image",">teachpack/image.html#(def._((lib._htdp/image..ss)._alpha-color-list-~3eimage))",[0,[1,"alpha-color-list-&gt;image"]],["teachpack/htdp/image"]],
["alpha-color-red",">teachpack/image.html#(def._((lib._htdp/image..ss)._alpha-color-red))",[0,[1,"alpha-color-red"]],["teachpack/htdp/image"]],
["alpha-color?",">teachpack/image.html#(def._((lib._htdp/image..ss)._alpha-color~3f))",[0,[1,"alpha-color?"]],["teachpack/htdp/image"]],
["alpha-version?",">version/index.html#(def._((lib._version/utils..ss)._alpha-version~3f))",[0,[1,"alpha-version?"]],["version/utils"]],
["alphabetic",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..ss)._alphabetic))",[0,[6,"alphabetic"]],["parser-tools/lex"]],
["alt-key",">mysterx/html-events.html#(meth._(((lib._mysterx/main..ss)._mx-event~3c~25~3e)._alt-key))",[[0,[1,"alt-key"]],[12,[" (method of ",[0,[1,"mx-event&lt;%&gt;"]],")"]]],["mysterx"]],
["alternation",">guide/regexp-alternation.html","Alternation",false],
["always-evt",">reference/sync.html#(def._((quote._~23~25kernel)._always-evt))",[0,[1,"always-evt"]],["scheme/base","scheme"]],
["always?",">eopl/index.html#(def._((lib._eopl/eopl..ss)._always~3f))",[0,[1,"always?"]],["eopl/eopl"]],
["an arrow gui: \"arrow-gui.ss\"",">teachpack/arrow-gui.html",["An Arrow GUI: ",[5,"\"arrow-gui.ss\""],"<a name=\"(idx._(gentag._12._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["an aside on indenting code",">guide/syntax-overview.html#(part._indentation)","An Aside on Indenting Code",false],
["an example",">graphics/An_Example.html","An Example",false],
["an extended example",">guide/An_Extended_Example.html","An Extended Example",false],
["anchor-status-changed",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3atext-info~3c~25~3e)._anchor-status-changed))",[[0,[1,"anchor-status-changed"]],[12,[" (method of ",[0,[1,"frame:text-info&lt;%&gt;"]],")"]]],["framework"]],
["and",">htdp-langs/and.html",[0,[6,"and"]],false],
["and",">reference/if.html#(form._((lib._scheme/private/letstx-scheme..ss)._and))",[0,[6,"and"]],["scheme/base","scheme"]],
["and",">r5rs-std/r5rs-Z-H-7.html#%_idx_120",[0,[6,"and"]],["r5rs"]],
["and",">r6rs-std/r6rs-Z-H-14.html#node_idx_388",[0,[6,"and"]],["rnrs/base-6"]],
["and",">htdp-langs/advanced-unchanged.html#(form._((lib._lang/htdp-advanced..ss)._and))",[0,[6,"and"]],["lang/htdp-advanced"]],
["and",">htdp-langs/and.html#(form._((lib._lang/htdp-beginner..ss)._and))",[0,[6,"and"]],["lang/htdp-beginner"]],
["and",">htdp-langs/Unchanged_Forms.html#(form._((lib._lang/htdp-beginner-abbr..ss)._and))",[0,[6,"and"]],["lang/htdp-beginner-abbr"]],
["and",">htdp-langs/intermediate-unchanged.html#(form._((lib._lang/htdp-intermediate..ss)._and))",[0,[6,"and"]],["lang/htdp-intermediate"]],
["and",">htdp-langs/intermediate-lambda-unchanged.html#(form._((lib._lang/htdp-intermediate-lambda..ss)._and))",[0,[6,"and"]],["lang/htdp-intermediate-lambda"]],
["and",">lazy/index.html#(def._((lib._lazy/main..ss)._and))",[0,[1,"and"]],["lazy"]],
["and",">srfi-std/srfi-42.html#and",[0,[6,"and"]],["srfi/42"]],
["and-let*",">srfi-std/srfi-2.html#and-let",[0,[6,"and-let*"]],["srfi/2"]],
["and/c",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract-guts..ss)._and/c))",[0,[1,"and/c"]],["scheme/contract","scheme"]],
["andmap",">reference/pairs.html#(def._((quote._~23~25kernel)._andmap))",[0,[1,"andmap"]],["scheme/base","scheme"]],
["andmap",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._andmap))",[0,[1,"andmap"]],["lang/htdp-advanced"]],
["andmap",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._andmap))",[0,[1,"andmap"]],["lang/htdp-intermediate"]],
["andmap",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._andmap))",[0,[1,"andmap"]],["lang/htdp-intermediate-lambda"]],
["andmap",">lazy/index.html#(def._((lib._lazy/main..ss)._andmap))",[0,[1,"andmap"]],["lazy"]],
["angel-wing",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._angel-wing))",[0,[1,"angel-wing"]],["slideshow/pict","slideshow"]],
["angle",">reference/numbers.html#(def._((quote._~23~25kernel)._angle))",[0,[1,"angle"]],["scheme/base","scheme"]],
["angle",">r5rs-std/r5rs-Z-H-9.html#%_idx_358",[0,[1,"angle"]],["r5rs"]],
["angle",">r6rs-std/r6rs-Z-H-14.html#node_idx_576",[0,[1,"angle"]],["rnrs/base-6"]],
["angle",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._angle))",[0,[1,"angle"]],["lang/htdp-advanced"]],
["angle",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._angle))",[0,[1,"angle"]],["lang/htdp-beginner"]],
["angle",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._angle))",[0,[1,"angle"]],["lang/htdp-beginner-abbr"]],
["angle",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._angle))",[0,[1,"angle"]],["lang/htdp-intermediate"]],
["angle",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._angle))",[0,[1,"angle"]],["lang/htdp-intermediate-lambda"]],
["animated",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._animated))",[[0,[1,"animated"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["ann",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._ann))",[0,[6,"ann"]],["typed-scheme"]],
["annotate",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..ss)._stacktrace~5e._annotate))",[0,[1,"annotate"]],["errortrace/stacktrace"]],
["annotate",">trace/index.html#(def._((lib._trace/calltrace-lib..ss)._annotate))",[0,"annotate"],["trace/calltrace-lib"]],
["annotate-covered-file",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..ss)._annotate-covered-file))",[0,[1,"annotate-covered-file"]],["errortrace"]],
["annotate-executed-file",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..ss)._annotate-executed-file))",[0,[1,"annotate-executed-file"]],["errortrace"]],
["annotate-top",">errortrace/errortrace-library.html#(def._((lib._errortrace/errortrace-lib..ss)._annotate-top))",[0,[1,"annotate-top"]],["errortrace/errortrace-lib"]],
["annotate-top",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..ss)._stacktrace~5e._annotate-top))",[0,[1,"annotate-top"]],["errortrace/stacktrace"]],
["annotation",">teachpack/docs.html#(tech._annotation)","<i>Annotation</i>",false],
["annotation?",">teachpack/docs.html#(def._((lib._teachpack/htdp/docs..ss)._annotation~3f))",[0,[1,"annotation?"]],["teachpack/htdp/docs"]],
["anonymous functions with lambda",">guide/syntax-overview.html#(part._.Anonymous_.Functions_with_lambda)",["Anonymous Functions with ",[0,[6,"lambda"]]],false],
["any",">reference/Data-structure_Contracts.html#(form._((lib._scheme/private/contract-guts..ss)._any))",[0,[6,"any"]],["scheme/contract","scheme"]],
["any",">srfi-std/srfi-1.html#any",[0,[1,"any"]],["srfi/1"]],
["any",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._.Any))",[0,[6,"Any"]],["typed-scheme"]],
["any",">reference/Byte_and_String_Input.html#(idx._(gentag._119._(lib._scribblings/reference/reference..scrbl)))",[7,"'any"],false],
["any",">redex/Patterns.html#(tech._any)","<i>any</i>",false],
["any-char",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..ss)._any-char))",[0,[6,"any-char"]],["parser-tools/lex"]],
["any-one",">reference/Byte_and_String_Input.html#(idx._(gentag._120._(lib._scribblings/reference/reference..scrbl)))",[7,"'any-one"],false],
["any-string",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..ss)._any-string))",[0,[6,"any-string"]],["parser-tools/lex"]],
["any/c",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract-guts..ss)._any/c))",[0,[1,"any/c"]],["scheme/contract","scheme"]],
["any?-ec",">srfi-std/srfi-42.html#any?-ec",[0,[6,"any?-ec"]],["srfi/42"]],
["apache-default-format",">web-server/dispatch-log_ss.html#(def._((lib._web-server/dispatchers/dispatch-log..ss)._apache-default-format))",[0,[1,"apache-default-format"]],["web-server/dispatchers/dispatch-log"]],
["app",">gui/message_.html#(idx._(gentag._121._(lib._scribblings/gui/gui..scrbl)))",[7,"'app"],false],
["append",">reference/pairs.html#(def._((quote._~23~25kernel)._append))",[0,[1,"append"]],["scheme/base","scheme"]],
["append",">gui/combo-field_.html#(meth._(((lib._mred/main..ss)._combo-field~25)._append))",[[0,[1,"append"]],[12,[" (method of ",[0,[1,"combo-field%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["append",">gui/dc-path_.html#(meth._(((lib._mred/main..ss)._dc-path~25)._append))",[[0,[1,"append"]],[12,[" (method of ",[0,[1,"dc-path%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["append",">gui/list-box_.html#(meth._(((lib._mred/main..ss)._list-box~25)._append))",[[0,[1,"append"]],[12,[" (method of ",[0,[1,"list-box%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["append",">gui/list-control___.html#(meth._(((lib._mred/main..ss)._list-control~3c~25~3e)._append))",[[0,[1,"append"]],[12,[" (method of ",[0,[1,"list-control&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["append",">gui/tab-panel_.html#(meth._(((lib._mred/main..ss)._tab-panel~25)._append))",[[0,[1,"append"]],[12,[" (method of ",[0,[1,"tab-panel%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["append",">r5rs-std/r5rs-Z-H-9.html#%_idx_438",[0,[1,"append"]],["r5rs"]],
["append",">r6rs-std/r6rs-Z-H-14.html#node_idx_634",[0,[1,"append"]],["rnrs/base-6"]],
["append",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._append))",[0,[1,"append"]],["lang/htdp-advanced"]],
["append",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._append))",[0,[1,"append"]],["lang/htdp-beginner"]],
["append",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._append))",[0,[1,"append"]],["lang/htdp-beginner-abbr"]],
["append",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._append))",[0,[1,"append"]],["lang/htdp-intermediate"]],
["append",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._append))",[0,[1,"append"]],["lang/htdp-intermediate-lambda"]],
["append",">lazy/index.html#(def._((lib._lazy/main..ss)._append))",[0,[1,"append"]],["lazy"]],
["append",">srfi-std/srfi-1.html#append",[0,[1,"append"]],["srfi/1"]],
["append",">reference/file-ports.html#(idx._(gentag._114._(lib._scribblings/reference/reference..scrbl)))",[7,"'append"],false],
["append!",">srfi-std/srfi-1.html#append!",[0,[1,"append!"]],["srfi/1"]],
["append*",">reference/pairs.html#(def._((lib._scheme/list..ss)._append*))",[0,[1,"append*"]],["scheme/list","scheme"]],
["append-c-suffix",">dynext/Filenames.html#(def._((lib._dynext/file..ss)._append-c-suffix))",[0,[1,"append-c-suffix"]],["dynext/file"]],
["append-constant-pool-suffix",">dynext/Filenames.html#(def._((lib._dynext/file..ss)._append-constant-pool-suffix))",[0,[1,"append-constant-pool-suffix"]],["dynext/file"]],
["append-ec",">srfi-std/srfi-42.html#append-ec",[0,[6,"append-ec"]],["srfi/42"]],
["append-editor-font-menu-items",">gui/Editor_Functions.html#(def._((lib._mred/main..ss)._append-editor-font-menu-items))",[0,[1,"append-editor-font-menu-items"]],["scheme/gui/base","scheme/gui"]],
["append-editor-operation-menu-items",">gui/Editor_Functions.html#(def._((lib._mred/main..ss)._append-editor-operation-menu-items))",[0,[1,"append-editor-operation-menu-items"]],["scheme/gui/base","scheme/gui"]],
["append-extension-suffix",">dynext/Filenames.html#(def._((lib._dynext/file..ss)._append-extension-suffix))",[0,[1,"append-extension-suffix"]],["dynext/file"]],
["append-headers",">net/head.html#(def._((lib._net/head..ss)._append-headers))",[0,[1,"append-headers"]],["net/head"]],
["append-html",">mysterx/documents.html#(meth._(((lib._mysterx/main..ss)._mx-document~3c~25~3e)._append-html))",[[0,[1,"append-html"]],[12,[" (method of ",[0,[1,"mx-document&lt;%&gt;"]],")"]]],["mysterx"]],
["append-html",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._append-html))",[[0,[1,"append-html"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["append-map",">reference/pairs.html#(def._((lib._scheme/list..ss)._append-map))",[0,[1,"append-map"]],["scheme/list","scheme"]],
["append-map",">srfi-std/srfi-1.html#append-map",[0,[1,"append-map"]],["srfi/1"]],
["append-map!",">srfi-std/srfi-1.html#append-map!",[0,[1,"append-map!"]],["srfi/1"]],
["append-object-from-coclass",">mysterx/documents.html#(meth._(((lib._mysterx/main..ss)._mx-document~3c~25~3e)._append-object-from-coclass))",[[0,[1,"append-object-from-coclass"]],[12,[" (method of ",[0,[1,"mx-document&lt;%&gt;"]],")"]]],["mysterx"]],
["append-object-from-coclass",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._append-object-from-coclass))",[[0,[1,"append-object-from-coclass"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["append-object-from-progid",">mysterx/documents.html#(meth._(((lib._mysterx/main..ss)._mx-document~3c~25~3e)._append-object-from-progid))",[[0,[1,"append-object-from-progid"]],[12,[" (method of ",[0,[1,"mx-document&lt;%&gt;"]],")"]]],["mysterx"]],
["append-object-from-progid",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._append-object-from-progid))",[[0,[1,"append-object-from-progid"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["append-object-suffix",">dynext/Filenames.html#(def._((lib._dynext/file..ss)._append-object-suffix))",[0,[1,"append-object-suffix"]],["dynext/file"]],
["append-reverse",">srfi-std/srfi-1.html#append-reverse",[0,[1,"append-reverse"]],["srfi/1"]],
["append-reverse!",">srfi-std/srfi-1.html#append-reverse!",[0,[1,"append-reverse!"]],["srfi/1"]],
["append-text",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._append-text))",[[0,[1,"append-text"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["append-zo-suffix",">dynext/Filenames.html#(def._((lib._dynext/file..ss)._append-zo-suffix))",[0,[1,"append-zo-suffix"]],["dynext/file"]],
["applet",">html/index.html#(def._((lib._html/main..ss)._applet))",[0,[1,"applet"]],["html"]],
["applet?",">html/index.html#(def._((lib._html/main..ss)._applet~3f))",[0,[1,"applet?"]],["html"]],
["applicable structure",">reference/define-struct.html#(idx._(gentag._74._(lib._scribblings/reference/reference..scrbl)))","applicable structure",false],
["application",">framework/Application.html","Application",false],
["application data",">drscheme/drscheme-files.html#(idx._(gentag._222._(lib._scribblings/drscheme/drscheme..scrbl)))",[5,"\"Application Data\""],false],
["application-about-handler",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._application-about-handler))",[0,[1,"application-about-handler"]],["scheme/gui/base","scheme/gui"]],
["application-file-handler",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._application-file-handler))",[0,[1,"application-file-handler"]],["scheme/gui/base","scheme/gui"]],
["application-preferences-handler",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._application-preferences-handler))",[0,[1,"application-preferences-handler"]],["scheme/gui/base","scheme/gui"]],
["application-quit-handler",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._application-quit-handler))",[0,[1,"application-quit-handler"]],["scheme/gui/base","scheme/gui"]],
["application:current-app-name",">framework/Application.html#(def._((lib._framework/main..ss)._application~3acurrent-app-name))",[0,[1,"application:current-app-name"]],["framework"]],
["apply",">reference/procedures.html#(def._((lib._scheme/base..ss)._apply))",[0,[1,"apply"]],["scheme/base","scheme"]],
["apply",">r5rs-std/r5rs-Z-H-9.html#%_idx_578",[0,[1,"apply"]],["r5rs"]],
["apply",">r6rs-std/r6rs-Z-H-14.html#node_idx_752",[0,[1,"apply"]],["rnrs/base-6"]],
["apply",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._apply))",[0,[1,"apply"]],["lang/htdp-advanced"]],
["apply",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._apply))",[0,[1,"apply"]],["lang/htdp-intermediate"]],
["apply",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._apply))",[0,[1,"apply"]],["lang/htdp-intermediate-lambda"]],
["apply",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..ss)._apply))",[0,[1,"apply"]],["mzscheme"]],
["apply-reduction-relation",">redex/Reduction_Relations.html#(def._((lib._redex/main..ss)._apply-reduction-relation))",[0,[1,"apply-reduction-relation"]],["redex"]],
["apply-reduction-relation*",">redex/Reduction_Relations.html#(def._((lib._redex/main..ss)._apply-reduction-relation*))",[0,[1,"apply-reduction-relation*"]],["redex"]],
["apply-reduction-relation/tag-with-names",">redex/Reduction_Relations.html#(def._((lib._redex/main..ss)._apply-reduction-relation/tag-with-names))",[0,[1,"apply-reduction-relation/tag-with-names"]],["redex"]],
["arc",">gui/dc-path_.html#(meth._(((lib._mred/main..ss)._dc-path~25)._arc))",[[0,[1,"arc"]],[12,[" (method of ",[0,[1,"dc-path%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["archives",">setup-plt/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..ss)._setup-option~5e._archives))",[0,[1,"archives"]],["setup/option-sig"]],
["area",">html/index.html#(def._((lib._html/main..ss)._area))",[0,[1,"area"]],["html"]],
["area",">gui/windowing-overview.html#(tech._area)","<i>area</i>",false],
["area-container-window<%>",">gui/area-container-window___.html",[0,[1,"area-container-window&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["area-container<%>",">gui/area-container___.html",[0,[1,"area-container&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["area<%>",">gui/area___.html",[0,[1,"area&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["area?",">html/index.html#(def._((lib._html/main..ss)._area~3f))",[0,[1,"area?"]],["html"]],
["argb->bitmap",">mrlib/Cache-image_Snip.html#(def._((lib._mrlib/cache-image-snip..ss)._argb-~3ebitmap))",[0,[1,"argb-&gt;bitmap"]],["mrlib/cache-image-snip"]],
["argb->cache-image-snip",">mrlib/Cache-image_Snip.html#(def._((lib._mrlib/cache-image-snip..ss)._argb-~3ecache-image-snip))",[0,[1,"argb-&gt;cache-image-snip"]],["mrlib/cache-image-snip"]],
["argb-height",">mrlib/Cache-image_Snip.html#(def._((lib._mrlib/cache-image-snip..ss)._argb-height))",[0,[1,"argb-height"]],["mrlib/cache-image-snip"]],
["argb-vector",">mrlib/Cache-image_Snip.html#(def._((lib._mrlib/cache-image-snip..ss)._argb-vector))",[0,[1,"argb-vector"]],["mrlib/cache-image-snip"]],
["argb-width",">mrlib/Cache-image_Snip.html#(def._((lib._mrlib/cache-image-snip..ss)._argb-width))",[0,[1,"argb-width"]],["mrlib/cache-image-snip"]],
["argb?",">mrlib/Cache-image_Snip.html#(def._((lib._mrlib/cache-image-snip..ss)._argb~3f))",[0,[1,"argb?"]],["mrlib/cache-image-snip"]],
["arithmetic",">reference/numbers.html#(part._.Arithmetic)","Arithmetic",false],
["arithmetic-shift",">reference/numbers.html#(def._((quote._~23~25kernel)._arithmetic-shift))",[0,[1,"arithmetic-shift"]],["scheme/base","scheme"]],
["arity",">inside/Procedures.html#(idx._(gentag._252._(lib._scribblings/inside/inside..scrbl)))",[0,"arity"],false],
["arity-at-least",">reference/procedures.html#(def._((quote._~23~25kernel)._arity-at-least))",[0,[1,"arity-at-least"]],["scheme/base","scheme"]],
["arity-at-least-value",">reference/procedures.html#(def._((quote._~23~25kernel)._arity-at-least-value))",[0,[1,"arity-at-least-value"]],["scheme/base","scheme"]],
["arity-at-least?",">reference/procedures.html#(def._((quote._~23~25kernel)._arity-at-least~3f))",[0,[1,"arity-at-least?"]],["scheme/base","scheme"]],
["arity-sensitive functions: case-lambda",">guide/lambda.html#(part._.Arity-.Sensitive_.Functions__case-lambda)",["Arity-Sensitive Functions: ",[0,[6,"case-lambda"]]],false],
["arrange files into a directory",">planet/Developing_Packages_for_PLaneT.html#(part._.Arrange_.Files_.Into_a_.Directory)","Arrange Files Into a Directory",false],
["array",">srfi-std/srfi-25.html#array",[0,[1,"array"]],["srfi/25"]],
["array-end",">srfi-std/srfi-25.html#array-end",[0,[1,"array-end"]],["srfi/25"]],
["array-rank",">srfi-std/srfi-25.html#array-rank",[0,[1,"array-rank"]],["srfi/25"]],
["array-ref",">srfi-std/srfi-25.html#array-ref",[0,[1,"array-ref"]],["srfi/25"]],
["array-set!",">srfi-std/srfi-25.html#array-set!",[0,[1,"array-set!"]],["srfi/25"]],
["array-start",">srfi-std/srfi-25.html#array-start",[0,[1,"array-start"]],["srfi/25"]],
["array?",">srfi-std/srfi-25.html#array-p",[0,[1,"array?"]],["srfi/25"]],
["arrayinit",">htdc/advanced_arrayInt.html",[0,"ArrayInit"],false],
["arrow",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._arrow))",[0,[1,"arrow"]],["slideshow/pict","slideshow"]],
["arrow teachpack",">teachpack/arrow.html#(idx._(gentag._7._(lib._teachpack/teachpack..scrbl)))","arrow teachpack",false],
["arrow-gui teachpack",">teachpack/arrow-gui.html#(idx._(gentag._12._(lib._teachpack/teachpack..scrbl)))","arrow-gui teachpack",false],
["arrow-space",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._arrow-space))",[0,[1,"arrow-space"]],["redex/pict"]],
["arrowhead",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._arrowhead))",[0,[1,"arrowhead"]],["slideshow/pict","slideshow"]],
["arrows",">guide/contract-func.html#(part._contracts-arrow)","Arrows",false],
["article-not-found",">net/nntp.html#(def._((lib._net/nntp..ss)._article-not-found))",[0,[1,"article-not-found"]],["net/nntp"]],
["article-not-found-article",">net/nntp.html#(def._((lib._net/nntp..ss)._article-not-found-article))",[0,[1,"article-not-found-article"]],["net/nntp"]],
["article-not-found?",">net/nntp.html#(def._((lib._net/nntp..ss)._article-not-found~3f))",[0,[1,"article-not-found?"]],["net/nntp"]],
["article-not-in-group",">net/nntp.html#(def._((lib._net/nntp..ss)._article-not-in-group))",[0,[1,"article-not-in-group"]],["net/nntp"]],
["article-not-in-group-article",">net/nntp.html#(def._((lib._net/nntp..ss)._article-not-in-group-article))",[0,[1,"article-not-in-group-article"]],["net/nntp"]],
["article-not-in-group?",">net/nntp.html#(def._((lib._net/nntp..ss)._article-not-in-group~3f))",[0,[1,"article-not-in-group?"]],["net/nntp"]],
["as-index",">scribble/basic.html#(def._((lib._scribble/basic..ss)._as-index))",[0,[1,"as-index"]],["scribble/basic"]],
["asin",">reference/numbers.html#(def._((quote._~23~25kernel)._asin))",[0,[1,"asin"]],["scheme/base","scheme"]],
["asin",">r5rs-std/r5rs-Z-H-9.html#%_idx_336",[0,[1,"asin"]],["r5rs"]],
["asin",">r6rs-std/r6rs-Z-H-14.html#node_idx_552",[0,[1,"asin"]],["rnrs/base-6"]],
["asin",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._asin))",[0,[1,"asin"]],["lang/htdp-advanced"]],
["asin",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._asin))",[0,[1,"asin"]],["lang/htdp-beginner"]],
["asin",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._asin))",[0,[1,"asin"]],["lang/htdp-beginner-abbr"]],
["asin",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._asin))",[0,[1,"asin"]],["lang/htdp-intermediate"]],
["asin",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._asin))",[0,[1,"asin"]],["lang/htdp-intermediate-lambda"]],
["assemble-address-field",">net/head.html#(def._((lib._net/head..ss)._assemble-address-field))",[0,[1,"assemble-address-field"]],["net/head"]],
["assemble-distribution",">mzc/exe-dist.html#(def._((lib._compiler/distribute..ss)._assemble-distribution))",[0,[1,"assemble-distribution"]],["compiler/distribute"]],
["assert",">r6rs-std/r6rs-Z-H-14.html#node_idx_750",[0,[6,"assert"]],["rnrs/base-6"]],
["assertion-violation",">r6rs-std/r6rs-Z-H-14.html#node_idx_748",[0,[1,"assertion-violation"]],["rnrs/base-6"]],
["assertion-violation?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_442",[0,[1,"assertion-violation?"]],["rnrs/conditions-6"]],
["assertions",">guide/regexp-assert.html#(tech._assertion)","<i>assertions</i>",false],
["assf",">reference/pairs.html#(def._((lib._scheme/base..ss)._assf))",[0,[1,"assf"]],["scheme/base","scheme"]],
["assf",">lazy/index.html#(def._((lib._lazy/main..ss)._assf))",[0,[1,"assf"]],["lazy"]],
["assignment and redefinition",">guide/module-set.html","Assignment and Redefinition",false],
["assignment transformers",">reference/syntax-model.html#(tech._assignment._transformer)","<i>assignment transformers</i>",false],
["assignment: set!",">guide/set_.html",["Assignment: ",[0,[6,"set!"]]],false],
["assignment: set! and set!-values",">reference/set_.html",["Assignment: ",[0,[6,"set!"]]," and ",[0,[6,"set!-values"]]],false],
["assoc",">reference/pairs.html#(def._((quote._~23~25kernel)._assoc))",[0,[1,"assoc"]],["scheme/base","scheme"]],
["assoc",">r5rs-std/r5rs-Z-H-9.html#%_idx_456",[0,[1,"assoc"]],["r5rs"]],
["assoc",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_234",[0,[1,"assoc"]],["rnrs/lists-6"]],
["assoc",">lazy/index.html#(def._((lib._lazy/main..ss)._assoc))",[0,[1,"assoc"]],["lazy"]],
["assoc",">srfi-std/srfi-1.html#assoc",[0,[1,"assoc"]],["srfi/1"]],
["association list",">reference/dicts.html#(tech._association._list)","<i>association\nlist</i>",false],
["assp",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_232",[0,[1,"assp"]],["rnrs/lists-6"]],
["assq",">reference/pairs.html#(def._((quote._~23~25kernel)._assq))",[0,[1,"assq"]],["scheme/base","scheme"]],
["assq",">r5rs-std/r5rs-Z-H-9.html#%_idx_452",[0,[1,"assq"]],["r5rs"]],
["assq",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_238",[0,[1,"assq"]],["rnrs/lists-6"]],
["assq",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._assq))",[0,[1,"assq"]],["lang/htdp-advanced"]],
["assq",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._assq))",[0,[1,"assq"]],["lang/htdp-beginner"]],
["assq",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._assq))",[0,[1,"assq"]],["lang/htdp-beginner-abbr"]],
["assq",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._assq))",[0,[1,"assq"]],["lang/htdp-intermediate"]],
["assq",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._assq))",[0,[1,"assq"]],["lang/htdp-intermediate-lambda"]],
["assq",">lazy/index.html#(def._((lib._lazy/main..ss)._assq))",[0,[1,"assq"]],["lazy"]],
["assq",">srfi-std/srfi-1.html#assq",[0,[1,"assq"]],["srfi/1"]],
["assume-primitives",">mzc/Scheme_API_for_Compilation.html#(def._((lib._compiler/option..ss)._assume-primitives))",[0,[1,"assume-primitives"]],["compiler/option"]],
["assv",">reference/pairs.html#(def._((quote._~23~25kernel)._assv))",[0,[1,"assv"]],["scheme/base","scheme"]],
["assv",">r5rs-std/r5rs-Z-H-9.html#%_idx_454",[0,[1,"assv"]],["r5rs"]],
["assv",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_236",[0,[1,"assv"]],["rnrs/lists-6"]],
["assv",">lazy/index.html#(def._((lib._lazy/main..ss)._assv))",[0,[1,"assv"]],["lazy"]],
["assv",">srfi-std/srfi-1.html#assv",[0,[1,"assv"]],["srfi/1"]],
["async-channel-get",">reference/async-channel.html#(def._((lib._scheme/async-channel..ss)._async-channel-get))",[0,[1,"async-channel-get"]],["scheme/async-channel"]],
["async-channel-put",">reference/async-channel.html#(def._((lib._scheme/async-channel..ss)._async-channel-put))",[0,[1,"async-channel-put"]],["scheme/async-channel"]],
["async-channel-put-evt",">reference/async-channel.html#(def._((lib._scheme/async-channel..ss)._async-channel-put-evt))",[0,[1,"async-channel-put-evt"]],["scheme/async-channel"]],
["async-channel-try-get",">reference/async-channel.html#(def._((lib._scheme/async-channel..ss)._async-channel-try-get))",[0,[1,"async-channel-try-get"]],["scheme/async-channel"]],
["async-channel?",">reference/async-channel.html#(def._((lib._scheme/async-channel..ss)._async-channel~3f))",[0,[1,"async-channel?"]],["scheme/async-channel"]],
["at-bottom?",">macro-debugger/index.html#(meth._(((lib._macro-debugger/stepper..ss)._macro-stepper~3c~25~3e)._at-bottom~3f))",["at-bottom?",[12,[" (method of ",[0,[1,"macro-stepper&lt;%&gt;"]],")"]]],["macro-debugger/stepper"]],
["at-end?",">macro-debugger/index.html#(meth._(((lib._macro-debugger/stepper..ss)._macro-stepper~3c~25~3e)._at-end~3f))",["at-end?",[12,[" (method of ",[0,[1,"macro-stepper&lt;%&gt;"]],")"]]],["macro-debugger/stepper"]],
["at-start?",">macro-debugger/index.html#(meth._(((lib._macro-debugger/stepper..ss)._macro-stepper~3c~25~3e)._at-start~3f))",["at-start?",[12,[" (method of ",[0,[1,"macro-stepper&lt;%&gt;"]],")"]]],["macro-debugger/stepper"]],
["at-top?",">macro-debugger/index.html#(meth._(((lib._macro-debugger/stepper..ss)._macro-stepper~3c~25~3e)._at-top~3f))",["at-top?",[12,[" (method of ",[0,[1,"macro-stepper&lt;%&gt;"]],")"]]],["macro-debugger/stepper"]],
["atan",">reference/numbers.html#(def._((quote._~23~25kernel)._atan))",[0,[1,"atan"]],["scheme/base","scheme"]],
["atan",">r5rs-std/r5rs-Z-H-9.html#%_idx_342",[0,[1,"atan"]],["r5rs"]],
["atan",">r6rs-std/r6rs-Z-H-14.html#node_idx_556",[0,[1,"atan"]],["rnrs/base-6"]],
["atan",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._atan))",[0,[1,"atan"]],["lang/htdp-advanced"]],
["atan",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._atan))",[0,[1,"atan"]],["lang/htdp-beginner"]],
["atan",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._atan))",[0,[1,"atan"]],["lang/htdp-beginner-abbr"]],
["atan",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._atan))",[0,[1,"atan"]],["lang/htdp-intermediate"]],
["atan",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._atan))",[0,[1,"atan"]],["lang/htdp-intermediate-lambda"]],
["atom?",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..ss)._atom~3f))",[0,[1,"atom?"]],["mzlib/compat"]],
["atom?",">teachpack/docs.html#(def._((lib._teachpack/htdp/docs..ss)._atom~3f))",[0,[1,"atom?"]],["teachpack/htdp/docs"]],
["atomic",">foreign/foreign_pointer-funcs.html#(idx._(gentag._5._(lib._scribblings/foreign/foreign..scrbl)))",[7,"'atomic"],false],
["atomic-interior",">foreign/foreign_pointer-funcs.html#(idx._(gentag._10._(lib._scribblings/foreign/foreign..scrbl)))",[7,"'atomic-interior"],false],
["attached",">guide/mk-namespace.html#(tech._attached)","<i>attached</i>",false],
["attaching contracts to values",">reference/Attaching_Contracts_to_Values.html","Attaching Contracts to Values",false],
["attaching documentation to exports",">syntax/docprovide.html","Attaching Documentation to Exports",false],
["attribute",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._attribute))",[[0,[1,"attribute"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["attribute",">xml/index.html#(def._((lib._xml/main..ss)._attribute))",[0,[1,"attribute"]],["xml"]],
["attribute-name",">xml/index.html#(def._((lib._xml/main..ss)._attribute-name))",[0,[1,"attribute-name"]],["xml"]],
["attribute-value",">xml/index.html#(def._((lib._xml/main..ss)._attribute-value))",[0,[1,"attribute-value"]],["xml"]],
["attribute?",">xml/index.html#(def._((lib._xml/main..ss)._attribute~3f))",[0,[1,"attribute?"]],["xml"]],
["augment",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._augment))",[0,[6,"augment"]],["scheme/class","scheme"]],
["augment*",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._augment*))",[0,[6,"augment*"]],["scheme/class","scheme"]],
["augment-final",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._augment-final))",[0,[6,"augment-final"]],["scheme/class","scheme"]],
["augment-final*",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._augment-final*))",[0,[6,"augment-final*"]],["scheme/class","scheme"]],
["augmenting",">reference/mzlib_class.html#(tech._augmenting)","<i>augmenting</i>",false],
["augride",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._augride))",[0,[6,"augride"]],["scheme/class","scheme"]],
["augride*",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._augride*))",[0,[6,"augride*"]],["scheme/class","scheme"]],
["authenticate-user",">net/nntp.html#(def._((lib._net/nntp..ss)._authenticate-user))",[0,[1,"authenticate-user"]],["net/nntp"]],
["authenticate/plain-text",">net/pop3.html#(def._((lib._net/pop3..ss)._authenticate/plain-text))",[0,[1,"authenticate/plain-text"]],["net/pop3"]],
["authentication-rejected",">net/nntp.html#(def._((lib._net/nntp..ss)._authentication-rejected))",[0,[1,"authentication-rejected"]],["net/nntp"]],
["authentication-rejected?",">net/nntp.html#(def._((lib._net/nntp..ss)._authentication-rejected~3f))",[0,[1,"authentication-rejected?"]],["net/nntp"]],
["author",">scribble/basic.html#(def._((lib._scribble/basic..ss)._author))",[0,[1,"author"]],["scribble/basic"]],
["author+email",">scribble/basic.html#(def._((lib._scribble/basic..ss)._author+email))",[0,[1,"author+email"]],["scribble/basic"]],
["auto-complete",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aautocomplete~3c~25~3e)._auto-complete))",[[0,[1,"auto-complete"]],[12,[" (method of ",[0,[1,"text:autocomplete&lt;%&gt;"]],")"]]],["framework"]],
["auto-play",">games/gobblet.html#(part._.Auto-.Play)","Auto-Play",false],
["auto-resize",">gui/message_.html#(meth._(((lib._mred/main..ss)._message~25)._auto-resize))",[[0,[1,"auto-resize"]],[12,[" (method of ",[0,[1,"message%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["auto-wrap",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._auto-wrap))",[[0,[1,"auto-wrap"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["automatic fields",">reference/structures.html#(tech._automatic._field)","<i>automatic fields</i>",false],
["automatic parenthesis",">drscheme/editor.html#(idx._(gentag._22._(lib._scribblings/drscheme/drscheme..scrbl)))","automatic\nparenthesis",false],
["autosave",">framework/Autosave.html","Autosave",false],
["autosave:autosavable<%>",">framework/Autosave.html#(def._((lib._framework/main..ss)._autosave~3aautosavable~3c~25~3e))",[0,[1,"autosave:autosavable&lt;%&gt;"]],["framework"]],
["autosave:register",">framework/Autosave.html#(def._((lib._framework/main..ss)._autosave~3aregister))",[0,[1,"autosave:register"]],["framework"]],
["autosave:restore-autosave-files/gui",">framework/Autosave.html#(def._((lib._framework/main..ss)._autosave~3arestore-autosave-files/gui))",[0,[1,"autosave:restore-autosave-files/gui"]],["framework"]],
["autosave?",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abackup-autosave~3c~25~3e)._autosave~3f))",[[0,[1,"autosave?"]],[12,[" (method of ",[0,[1,"editor:backup-autosave&lt;%&gt;"]],")"]]],["framework"]],
["aux",">reference/windowspaths.html#(idx._(gentag._218._(lib._scribblings/reference/reference..scrbl)))",[5,"\"AUX\""],false],
["aux-elem",">scribble/basic.html#(def._((lib._scribble/basic..ss)._aux-elem))",[0,[1,"aux-elem"]],["scribble/basic"]],
["aux-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._aux-element))",[0,[1,"aux-element"]],["scribble/struct"]],
["aux-element?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._aux-element~3f))",[0,[1,"aux-element?"]],["scribble/struct"]],
["available-mred-variants",">mzc/launcher.html#(def._((lib._launcher/launcher..ss)._available-mred-variants))",[0,[1,"available-mred-variants"]],["launcher/launcher"]],
["available-mzscheme-variants",">mzc/launcher.html#(def._((lib._launcher/launcher..ss)._available-mzscheme-variants))",[0,[1,"available-mzscheme-variants"]],["launcher/launcher"]],
["awk",">mzlib/mzlib_awk.html#(form._((lib._mzlib/awk..ss)._awk))",[0,[6,"awk"]],["mzlib/awk"]],
["b",">html/index.html#(def._((lib._html/main..ss)._b))",[0,[1,"b"]],["html"]],
["b?",">html/index.html#(def._((lib._html/main..ss)._b~3f))",[0,[1,"b?"]],["html"]],
["background color",">framework/Canvas.html#(idx._(gentag._0._(lib._scribblings/framework/framework..scrbl)))","background color",false],
["background-color",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._background-color))",[[0,[1,"background-color"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["background-color-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._background-color-native))",[[0,[1,"background-color-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["background-image",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._background-image))",[[0,[1,"background-image"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["background-image-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._background-image-native))",[[0,[1,"background-image-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["background-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._background-native))",[[0,[1,"background-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["background-position",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._background-position))",[[0,[1,"background-position"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["background-position-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._background-position-native))",[[0,[1,"background-position-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["background-position-x",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._background-position-x))",[[0,[1,"background-position-x"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["background-position-x-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._background-position-x-native))",[[0,[1,"background-position-x-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["background-position-y",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._background-position-y))",[[0,[1,"background-position-y"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["background-position-y-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._background-position-y-native))",[[0,[1,"background-position-y-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["background-repeat",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._background-repeat))",[[0,[1,"background-repeat"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["background-repeat-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._background-repeat-native))",[[0,[1,"background-repeat-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["backreference",">guide/regexp-clusters.html#(tech._backreference)","<i>backreference</i>",false],
["backreferences",">guide/regexp-clusters.html#(part._.Backreferences)","Backreferences",false],
["backtracking",">guide/Backtracking.html","Backtracking",false],
["backtracking",">guide/Backtracking.html#(tech._backtracking)","<i>backtracking</i>",false],
["backup and autosave files",">drscheme/drscheme-files.html#(part._drscheme-autosave-files)","Backup and Autosave Files",false],
["backup?",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abackup-autosave~3c~25~3e)._backup~3f))",[[0,[1,"backup?"]],[12,[" (method of ",[0,[1,"editor:backup-autosave&lt;%&gt;"]],")"]]],["framework"]],
["backward-containing-sexp",">framework/Color.html#(meth._(((lib._framework/main..ss)._color~3atext~3c~25~3e)._backward-containing-sexp))",[[0,[1,"backward-containing-sexp"]],[12,[" (method of ",[0,[1,"color:text&lt;%&gt;"]],")"]]],["framework"]],
["backward-kill-word",">framework/Keymap.html#(idx._(gentag._27._(lib._scribblings/framework/framework..scrbl)))","backward-kill-word",false],
["backward-match",">framework/Color.html#(meth._(((lib._framework/main..ss)._color~3atext~3c~25~3e)._backward-match))",[[0,[1,"backward-match"]],[12,[" (method of ",[0,[1,"color:text&lt;%&gt;"]],")"]]],["framework"]],
["backward-sexp",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._backward-sexp))",[[0,[1,"backward-sexp"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["bad-newsgroup-line",">net/nntp.html#(def._((lib._net/nntp..ss)._bad-newsgroup-line))",[0,[1,"bad-newsgroup-line"]],["net/nntp"]],
["bad-newsgroup-line-line",">net/nntp.html#(def._((lib._net/nntp..ss)._bad-newsgroup-line-line))",[0,[1,"bad-newsgroup-line-line"]],["net/nntp"]],
["bad-newsgroup-line?",">net/nntp.html#(def._((lib._net/nntp..ss)._bad-newsgroup-line~3f))",[0,[1,"bad-newsgroup-line?"]],["net/nntp"]],
["bad-status-line",">net/nntp.html#(def._((lib._net/nntp..ss)._bad-status-line))",[0,[1,"bad-status-line"]],["net/nntp"]],
["bad-status-line-line",">net/nntp.html#(def._((lib._net/nntp..ss)._bad-status-line-line))",[0,[1,"bad-status-line-line"]],["net/nntp"]],
["bad-status-line?",">net/nntp.html#(def._((lib._net/nntp..ss)._bad-status-line~3f))",[0,[1,"bad-status-line?"]],["net/nntp"]],
["bad?",">gui/editor-stream-in-base_.html#(meth._(((lib._mred/main..ss)._editor-stream-in-base~25)._bad~3f))",[[0,[1,"bad?"]],[12,[" (method of ",[0,[1,"editor-stream-in-base%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["bad?",">gui/editor-stream-out-base_.html#(meth._(((lib._mred/main..ss)._editor-stream-out-base~25)._bad~3f))",[[0,[1,"bad?"]],[12,[" (method of ",[0,[1,"editor-stream-out-base%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["balance-parens",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._balance-parens))",[[0,[1,"balance-parens"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["balloon",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/balloon..ss)._balloon))",[0,[1,"balloon"]],["slideshow/balloon"]],
["balloon annotations",">slideshow/More_Pict_Constructors.html#(part._.Balloon_.Annotations)","Balloon Annotations",false],
["balloon-color",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/balloon..ss)._balloon-color))",[0,[1,"balloon-color"]],["slideshow/balloon"]],
["balloon-pict",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/balloon..ss)._balloon-pict))",[0,[1,"balloon-pict"]],["slideshow/balloon"]],
["balloon-point-x",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/balloon..ss)._balloon-point-x))",[0,[1,"balloon-point-x"]],["slideshow/balloon"]],
["balloon-point-y",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/balloon..ss)._balloon-point-y))",[0,[1,"balloon-point-y"]],["slideshow/balloon"]],
["balloon?",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/balloon..ss)._balloon~3f))",[0,[1,"balloon?"]],["slideshow/balloon"]],
["banner",">reference/runtime.html#(def._((quote._~23~25kernel)._banner))",[0,[1,"banner"]],["scheme/base","scheme"]],
["base",">html/index.html#(def._((lib._html/main..ss)._base))",[0,[1,"base"]],["html"]],
["base",">gui/style-delta_.html#(idx._(gentag._259._(lib._scribblings/gui/gui..scrbl)))",[7,"'base"],false],
["base",">gui/style-delta_.html#(idx._(gentag._263._(lib._scribblings/gui/gui..scrbl)))",[7,"'base"],false],
["base",">gui/style-delta_.html#(idx._(gentag._267._(lib._scribblings/gui/gui..scrbl)))",[7,"'base"],false],
["base",">gui/style-delta_.html#(idx._(gentag._272._(lib._scribblings/gui/gui..scrbl)))",[7,"'base"],false],
["base",">gui/style-delta_.html#(idx._(gentag._276._(lib._scribblings/gui/gui..scrbl)))",[7,"'base"],false],
["base",">gui/style-delta_.html#(idx._(gentag._277._(lib._scribblings/gui/gui..scrbl)))",[7,"'base"],false],
["base",">gui/style-delta_.html#(idx._(gentag._278._(lib._scribblings/gui/gui..scrbl)))",[7,"'base"],false],
["base 64: encoding and decoding",">net/base64.html","Base 64: Encoding and Decoding",false],
["base environment",">reference/syntax-model.html#(tech._base._environment)","<i>base environment</i>",false],
["base phase",">reference/syntax-model.html#(tech._base._phase)","<i>base phase</i>",false],
["base renderer",">scribble/renderer.html#(part._.Base_.Renderer)","Base Renderer",false],
["base64 signature",">net/base64.html#(part._.Base64_.Signature)","Base64 Signature",false],
["base64 unit",">net/base64.html#(part._.Base64_.Unit)","Base64 Unit",false],
["base64-decode",">net/base64.html#(def._((lib._net/base64..ss)._base64-decode))",[0,[1,"base64-decode"]],["net/base64"]],
["base64-decode-stream",">net/base64.html#(def._((lib._net/base64..ss)._base64-decode-stream))",[0,[1,"base64-decode-stream"]],["net/base64"]],
["base64-encode",">net/base64.html#(def._((lib._net/base64..ss)._base64-encode))",[0,[1,"base64-encode"]],["net/base64"]],
["base64-encode-stream",">net/base64.html#(def._((lib._net/base64..ss)._base64-encode-stream))",[0,[1,"base64-encode-stream"]],["net/base64"]],
["base64@",">net/base64.html#(def._((lib._net/base64-unit..ss)._base64~40))",[0,[1,"base64@"]],["net/base64-unit"]],
["base64^",">net/base64.html#(form._((lib._net/base64-sig..ss)._base64~5e))",[0,[6,"base64^"]],["net/base64-sig"]],
["base?",">html/index.html#(def._((lib._html/main..ss)._base~3f))",[0,[1,"base?"]],["html"]],
["basefont",">html/index.html#(def._((lib._html/main..ss)._basefont))",[0,[1,"basefont"]],["html"]],
["basefont?",">html/index.html#(def._((lib._html/main..ss)._basefont~3f))",[0,[1,"basefont?"]],["html"]],
["baseless",">slideshow/Bounding-Box_Adjusters.html#(def._((lib._slideshow/pict..ss)._baseless))",[0,[1,"baseless"]],["slideshow/pict","slideshow"]],
["basic assertions",">guide/regexp-assert.html","Basic Assertions",false],
["basic authentication",">web-server/basic-auth_ss.html","Basic Authentication",false],
["basic blog",">continue/index.html#(part._.Basic_.Blog)","Basic Blog",false],
["basic commands",">graphics/Basic_Commands.html","Basic Commands",false],
["basic document forms",">scribble/basic.html","Basic Document Forms",false],
["basic formlet usage",">web-server/Basic_Formlet_Usage.html","Basic Formlet Usage",false],
["basic image properties",">teachpack/image.html#(part._properties)","Basic Image Properties",false],
["basic pict constructors",">slideshow/Basic_Pict_Constructors.html","Basic Pict Constructors",false],
["basic plotting",">plot/Quick_Start.html#(part._.Basic_.Plotting)","Basic Plotting",false],
["basic pretty-print options",">reference/pretty-print.html#(part._.Basic_.Pretty-.Print_.Options)","Basic Pretty-Print Options",false],
["basic style",">gui/editor-overview.html#(idx._(gentag._13._(lib._scribblings/gui/gui..scrbl)))",[[7,"\"Basic\""],"\nstyle"],false],
["basic-style",">gui/style-list_.html#(meth._(((lib._mred/main..ss)._style-list~25)._basic-style))",[[0,[1,"basic-style"]],[12,[" (method of ",[0,[1,"style-list%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["basics",">teachpack/world.html#(part._basics)","Basics",false],
["bdiagonal-hatch",">gui/brush_.html#(idx._(gentag._183._(lib._scribblings/gui/gui..scrbl)))",[7,"'bdiagonal-hatch"],false],
["bdo",">html/index.html#(def._((lib._html/main..ss)._bdo))",[0,[1,"bdo"]],["html"]],
["bdo?",">html/index.html#(def._((lib._html/main..ss)._bdo~3f))",[0,[1,"bdo?"]],["html"]],
["beg-mark",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..ss)._beg-mark))",[0,[1,"beg-mark"]],["preprocessor/mzpp"]],
["begin",">htdp-langs/begin.html",[0,[6,"begin"]],false],
["begin",">reference/begin.html#(form._((quote._~23~25kernel)._begin))",[0,[6,"begin"]],["scheme/base","scheme"]],
["begin",">r5rs-std/r5rs-Z-H-7.html#%_idx_138",[0,[6,"begin"]],["r5rs"]],
["begin",">r6rs-std/r6rs-Z-H-14.html#node_idx_418",[0,[6,"begin"]],["rnrs/base-6"]],
["begin",">htdp-langs/begin.html#(form._((lib._lang/htdp-advanced..ss)._begin))",[0,[6,"begin"]],["lang/htdp-advanced"]],
["begin",">lazy/index.html#(form._((lib._lazy/main..ss)._begin))",[0,[6,"begin"]],["lazy"]],
["begin",">srfi-std/srfi-42.html#begin",[0,[6,"begin"]],["srfi/42"]],
["begin-busy-cursor",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._begin-busy-cursor))",[0,[1,"begin-busy-cursor"]],["scheme/gui/base","scheme/gui"]],
["begin-card-sequence",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._begin-card-sequence))",[[0,[1,"begin-card-sequence"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["begin-container-sequence",">gui/area-container___.html#(meth._(((lib._mred/main..ss)._area-container~3c~25~3e)._begin-container-sequence))",[[0,[1,"begin-container-sequence"]],[12,[" (method of ",[0,[1,"area-container&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["begin-edit-sequence",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._begin-edit-sequence))",[[0,[1,"begin-edit-sequence"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["begin-for-syntax",">reference/begin.html#(form._((lib._scheme/private/define..ss)._begin-for-syntax))",[0,[6,"begin-for-syntax"]],["scheme/base","scheme"]],
["begin-lifted",">mzlib/mzlib_etc.html#(form._((lib._mzlib/etc..ss)._begin-lifted))",[0,[6,"begin-lifted"]],["mzlib/etc"]],
["begin-metadata-changes",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3adefinitions-text~3c~25~3e)._begin-metadata-changes))",[[0,[1,"begin-metadata-changes"]],[12,[" (method of ",[0,[1,"drscheme:unit:definitions-text&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["begin-with-definitions",">mzlib/mzlib_etc.html#(form._((lib._mzlib/etc..ss)._begin-with-definitions))",[0,[6,"begin-with-definitions"]],["mzlib/etc"]],
["begin-write-header-footer-to-file",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._begin-write-header-footer-to-file))",[[0,[1,"begin-write-header-footer-to-file"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["begin0",">htdp-langs/begin0.html",[0,[6,"begin0"]],false],
["begin0",">reference/begin.html#(form._((quote._~23~25kernel)._begin0))",[0,[6,"begin0"]],["scheme/base","scheme"]],
["begin0",">htdp-langs/begin0.html#(form._((lib._lang/htdp-advanced..ss)._begin0))",[0,[6,"begin0"]],["lang/htdp-advanced"]],
["begin0",">lazy/index.html#(form._((lib._lazy/main..ss)._begin0))",[0,[6,"begin0"]],["lazy"]],
["beginning student",">htdp-langs/beginner.html","Beginning Student",false],
["beginning student language",">drscheme/htdp-langs.html#(idx._(gentag._43._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Beginning Student</font></b> language",false],
["beginning student with list abbreviations",">htdp-langs/beginner-abbr.html","Beginning Student with List Abbreviations",false],
["beginning student with list abbreviations languages",">drscheme/htdp-langs.html#(idx._(gentag._44._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Beginning Student with List\nAbbreviations</font></b> languages",false],
["behavior?",">frtime/index.html#(def._((lib._frtime/main..ss)._behavior~3f))",[0,[1,"behavior?"]],["frtime"]],
["bell",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._bell))",[0,[1,"bell"]],["scheme/gui/base","scheme/gui"]],
["between/c",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._between/c))",[0,[1,"between/c"]],["scheme/contract","scheme"]],
["bib-entry",">scribble/Bibliography.html#(def._((lib._scribble/manual..ss)._bib-entry))",[0,[1,"bib-entry"]],["scribble/manual"]],
["bib-entry?",">scribble/Bibliography.html#(def._((lib._scribble/manual..ss)._bib-entry~3f))",[0,[1,"bib-entry?"]],["scribble/manual"]],
["bibliography",">scribble/Bibliography.html","Bibliography",false],
["bibliography",">scribble/Bibliography.html#(def._((lib._scribble/manual..ss)._bibliography))",[0,[1,"bibliography"]],["scribble/manual"]],
["big",">html/index.html#(def._((lib._html/main..ss)._big))",[0,[1,"big"]],["html"]],
["big-bang",">teachpack/draw.html#(def._((lib._teachpack/htdp/draw..ss)._big-bang))",[0,[1,"big-bang"]],["teachpack/htdp/draw"]],
["big-bang",">teachpack/world.html#(def._((lib._teachpack/htdp/world..ss)._big-bang))",[0,[1,"big-bang"]],["teachpack/htdp/world"]],
["big?",">html/index.html#(def._((lib._html/main..ss)._big~3f))",[0,[1,"big?"]],["html"]],
["bigbang",">teachpack/Jdraw.html#(def._((lib._teachpack/htdc/draw..ss)._big.Bang))",[0,[1,"bigBang"]],["teachpack/htdc/draw"]],
["bignums, rationals, and complex numbers",">inside/Bignums__Rationals__and_Complex_Numbers.html","Bignums, Rationals, and Complex Numbers",false],
["bin-dir",">config/index.html#(def._((lib._config/main..ss)._bin-dir))",[0,[1,"bin-dir"]],["config"]],
["binary",">reference/file-ports.html#(idx._(gentag._105._(lib._scribblings/reference/reference..scrbl)))",[7,"'binary"],false],
["binary-port?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_648",[0,[1,"binary-port?"]],["rnrs/io/ports-6"]],
["bind",">redex/Patterns.html#(def._((lib._redex/reduction-semantics..ss)._bind))",[0,[1,"bind"]],["redex/reduction-semantics"]],
["bind-exp",">redex/Patterns.html#(def._((lib._redex/reduction-semantics..ss)._bind-exp))",[0,[1,"bind-exp"]],["redex/reduction-semantics"]],
["bind-name",">redex/Patterns.html#(def._((lib._redex/reduction-semantics..ss)._bind-name))",[0,[1,"bind-name"]],["redex/reduction-semantics"]],
["bind?",">redex/Patterns.html#(def._((lib._redex/reduction-semantics..ss)._bind~3f))",[0,[1,"bind?"]],["redex/reduction-semantics"]],
["binding",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._binding))",[0,[1,"binding"]],["web-server/private/request-structs"]],
["binding",">net/cgi.html#(tech._binding)","<i>binding</i>",false],
["binding",">reference/syntax-model.html#(tech._binding)","<i>binding</i>",false],
["binding forms",">typed-scheme/index.html#(part._.Binding_.Forms)","Binding Forms",false],
["binding-id",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._binding-id))",[0,[1,"binding-id"]],["web-server/private/request-structs"]],
["binding:file",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._binding~3afile))",[0,[1,"binding:file"]],["web-server/private/request-structs"]],
["binding:file-content",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._binding~3afile-content))",[0,[1,"binding:file-content"]],["web-server/private/request-structs"]],
["binding:file-filename",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._binding~3afile-filename))",[0,[1,"binding:file-filename"]],["web-server/private/request-structs"]],
["binding:file?",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._binding~3afile~3f))",[0,[1,"binding:file?"]],["web-server/private/request-structs"]],
["binding:form",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._binding~3aform))",[0,[1,"binding:form"]],["web-server/private/request-structs"]],
["binding:form-value",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._binding~3aform-value))",[0,[1,"binding:form-value"]],["web-server/private/request-structs"]],
["binding:form?",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._binding~3aform~3f))",[0,[1,"binding:form?"]],["web-server/private/request-structs"]],
["binding?",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._binding~3f))",[0,[1,"binding?"]],["web-server/private/request-structs"]],
["bindings-as-html",">net/cgi.html#(def._((lib._net/cgi..ss)._bindings-as-html))",[0,[1,"bindings-as-html"]],["net/cgi"]],
["bindings-assq",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._bindings-assq))",[0,[1,"bindings-assq"]],["web-server/private/request-structs"]],
["binds",">reference/syntax-model.html#(tech._bind)","<i>binds</i>",false],
["bit",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..ss)._bit))",[0,[1,"bit"]],["slideshow/base","slideshow"]],
["bitmap",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._bitmap))",[0,[1,"bitmap"]],["slideshow/pict","slideshow"]],
["bitmap dc",">gui/drawing-overview.html#(tech._bitmap._dc)","<i>bitmap DC</i>",false],
["bitmap label",">mrlib/Bitmap_Label.html","Bitmap Label",false],
["bitmap%",">gui/bitmap_.html",[0,[1,"bitmap%"]],["scheme/gui/base","scheme/gui"]],
["bitmap->gl-list",">sgl/bitmaps.html#(def._((lib._sgl/bitmap..ss)._bitmap-~3egl-list))",[0,"bitmap-&gt;gl-list"],["sgl/bitmap"]],
["bitmap-dc%",">gui/bitmap-dc_.html",[0,[1,"bitmap-dc%"]],["scheme/gui/base","scheme/gui"]],
["bitmap-draft-mode",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._bitmap-draft-mode))",[0,[1,"bitmap-draft-mode"]],["slideshow/pict","slideshow"]],
["bitmap-label-maker",">mrlib/Bitmap_Label.html#(def._((lib._mrlib/bitmap-label..ss)._bitmap-label-maker))",[0,[1,"bitmap-label-maker"]],["mrlib/bitmap-label"]],
["bitmaps",">sgl/bitmaps.html","Bitmaps",false],
["bitwise operations",">reference/numbers.html#(part._.Bitwise_.Operations)","Bitwise Operations",false],
["bitwise-and",">reference/numbers.html#(def._((quote._~23~25kernel)._bitwise-and))",[0,[1,"bitwise-and"]],["scheme/base","scheme"]],
["bitwise-and",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1066",[0,[1,"bitwise-and"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-arithmetic-shift",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1088",[0,[1,"bitwise-arithmetic-shift"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-arithmetic-shift-left",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1090",[0,[1,"bitwise-arithmetic-shift-left"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-arithmetic-shift-right",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1092",[0,[1,"bitwise-arithmetic-shift-right"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-bit-count",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1074",[0,[1,"bitwise-bit-count"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-bit-field",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1084",[0,[1,"bitwise-bit-field"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-bit-set?",">reference/numbers.html#(def._((quote._~23~25kernel)._bitwise-bit-set~3f))",[0,[1,"bitwise-bit-set?"]],["scheme/base","scheme"]],
["bitwise-bit-set?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1080",[0,[1,"bitwise-bit-set?"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-copy-bit",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1082",[0,[1,"bitwise-copy-bit"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-copy-bit-field",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1086",[0,[1,"bitwise-copy-bit-field"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-first-bit-set",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1078",[0,[1,"bitwise-first-bit-set"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-if",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1072",[0,[1,"bitwise-if"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-ior",">reference/numbers.html#(def._((quote._~23~25kernel)._bitwise-ior))",[0,[1,"bitwise-ior"]],["scheme/base","scheme"]],
["bitwise-ior",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1068",[0,[1,"bitwise-ior"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-length",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1076",[0,[1,"bitwise-length"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-not",">reference/numbers.html#(def._((quote._~23~25kernel)._bitwise-not))",[0,[1,"bitwise-not"]],["scheme/base","scheme"]],
["bitwise-not",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1064",[0,[1,"bitwise-not"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-reverse-bit-field",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1096",[0,[1,"bitwise-reverse-bit-field"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-rotate-bit-field",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1094",[0,[1,"bitwise-rotate-bit-field"]],["rnrs/arithmetic/bitwise-6"]],
["bitwise-xor",">reference/numbers.html#(def._((quote._~23~25kernel)._bitwise-xor))",[0,[1,"bitwise-xor"]],["scheme/base","scheme"]],
["bitwise-xor",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1070",[0,[1,"bitwise-xor"]],["rnrs/arithmetic/bitwise-6"]],
["black-and-white",">slideshow/Pict_Drawing_Adjusters.html#(def._((lib._slideshow/pict..ss)._black-and-white))",[0,[1,"black-and-white"]],["slideshow/pict","slideshow"]],
["blackjack --- 21 card game",">games/blackjack.html",[[13,"<img src=\"blackjack.png\" />"]," ","<b><font size=\"-1\" face=\"Helvetica\">Blackjack</font></b>","  ","&ndash;","  21 Card Game"],false],
["blank",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..ss)._blank))",[0,[6,"blank"]],["parser-tools/lex"]],
["blank",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._blank))",[0,[1,"blank"]],["slideshow/pict","slideshow"]],
["blink-caret",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._blink-caret))",[[0,[1,"blink-caret"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["blink-caret",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._blink-caret))",[[0,[1,"blink-caret"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["block",">reference/port-buffers.html#(idx._(gentag._101._(lib._scribblings/reference/reference..scrbl)))",[7,"'block"],false],
["block",">scribble/struct.html#(tech._block)","<i>block</i>",false],
["block-while-browsers",">mysterx/browsers.html#(def._((lib._mysterx/main..ss)._block-while-browsers))",[0,[1,"block-while-browsers"]],["mysterx"]],
["block-width",">scribble/struct.html#(def._((lib._scribble/struct..ss)._block-width))",[0,[1,"block-width"]],["scribble/struct"]],
["block?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._block~3f))",[0,[1,"block?"]],["scribble/struct"]],
["blocking the current thread",">inside/threads.html#(part._threadblock)","Blocking the Current Thread",false],
["blockquote",">html/index.html#(def._((lib._html/main..ss)._blockquote))",[0,[1,"blockquote"]],["html"]],
["blockquote",">scribble/struct.html#(def._((lib._scribble/struct..ss)._blockquote))",[0,[1,"blockquote"]],["scribble/struct"]],
["blockquote",">scribble/struct.html#(tech._blockquote)","<i>blockquote</i>",false],
["blockquote-paragraphs",">scribble/struct.html#(def._((lib._scribble/struct..ss)._blockquote-paragraphs))",[0,[1,"blockquote-paragraphs"]],["scribble/struct"]],
["blockquote-style",">scribble/struct.html#(def._((lib._scribble/struct..ss)._blockquote-style))",[0,[1,"blockquote-style"]],["scribble/struct"]],
["blockquote?",">html/index.html#(def._((lib._html/main..ss)._blockquote~3f))",[0,[1,"blockquote?"]],["html"]],
["blockquote?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._blockquote~3f))",[0,[1,"blockquote?"]],["scribble/struct"]],
["blog",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/dummy-10..ss)._blog))",[0,[1,"blog"]],[]],
["blog",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-1..ss)._blog))",[0,"blog"],[]],
["blog",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-4..ss)._blog))",[0,[1,"blog"]],[]],
["blog",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-9..ss)._blog))",[0,[1,"blog"]],[]],
["blog-db",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/dummy-10..ss)._blog-db))",[0,[1,"blog-db"]],[]],
["blog-home",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-9..ss)._blog-home))",[0,[1,"blog-home"]],[]],
["blog-insert-post!",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-4..ss)._blog-insert-post!))",[0,"blog-insert-post!"],[]],
["blog-insert-post!",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-9..ss)._blog-insert-post!))",[0,"blog-insert-post!"],[]],
["blog-posts",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-4..ss)._blog-posts))",[0,[1,"blog-posts"]],[]],
["blog-posts",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-9..ss)._blog-posts))",[0,[1,"blog-posts"]],[]],
["blog?",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/dummy-10..ss)._blog~3f))",[0,[1,"blog?"]],[]],
["blog?",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-4..ss)._blog~3f))",[0,[1,"blog?"]],[]],
["blog?",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-9..ss)._blog~3f))",[0,[1,"blog?"]],[]],
["blue",">gui/color_.html#(meth._(((lib._mred/main..ss)._color~25)._blue))",[[0,[1,"blue"]],[12,[" (method of ",[0,[1,"color%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["bnf",">scribble/bnf.html#(def._((lib._scribble/bnf..ss)._.B.N.F))",[0,[1,"BNF"]],["scribble/bnf"]],
["bnf grammars",">scribble/bnf.html","BNF Grammars",false],
["bnf-alt",">scribble/bnf.html#(def._((lib._scribble/bnf..ss)._.B.N.F-alt))",[0,[1,"BNF-alt"]],["scribble/bnf"]],
["bnf-etc",">scribble/bnf.html#(def._((lib._scribble/bnf..ss)._.B.N.F-etc))",[0,[1,"BNF-etc"]],["scribble/bnf"]],
["bnf-group",">scribble/bnf.html#(def._((lib._scribble/bnf..ss)._.B.N.F-group))",[0,[1,"BNF-group"]],["scribble/bnf"]],
["bnf-seq",">scribble/bnf.html#(def._((lib._scribble/bnf..ss)._.B.N.F-seq))",[0,[1,"BNF-seq"]],["scribble/bnf"]],
["body",">html/index.html#(def._((lib._html/main..ss)._body))",[0,[1,"body"]],["html"]],
["body argument",">mzlib/mzlib_kw.html#(part._kw-body)","Body Argument",false],
["body-of-message",">net/nntp.html#(def._((lib._net/nntp..ss)._body-of-message))",[0,[1,"body-of-message"]],["net/nntp"]],
["body?",">html/index.html#(def._((lib._html/main..ss)._body~3f))",[0,[1,"body?"]],["html"]],
["bold",">scribble/basic.html#(def._((lib._scribble/basic..ss)._bold))",[0,[1,"bold"]],["scribble/basic"]],
["bold",">gui/font_.html#(idx._(gentag._207._(lib._scribblings/gui/gui..scrbl)))",[7,"'bold"],false],
["bold",">gui/style-delta_.html#(idx._(gentag._274._(lib._scribblings/gui/gui..scrbl)))",[7,"'bold"],false],
["boolean",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._.Boolean))",[0,[6,"Boolean"]],["typed-scheme"]],
["boolean synonyms",">reference/booleans.html#(part._.Boolean_.Synonyms)","Boolean Synonyms",false],
["boolean=?",">reference/booleans.html#(def._((lib._scheme/bool..ss)._boolean~3d~3f))",[0,[1,"boolean=?"]],["scheme/bool","scheme"]],
["boolean=?",">r6rs-std/r6rs-Z-H-14.html#node_idx_598",[0,[1,"boolean=?"]],["rnrs/base-6"]],
["boolean=?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._boolean~3d~3f))",[0,[1,"boolean=?"]],["lang/htdp-advanced"]],
["boolean=?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._boolean~3d~3f))",[0,[1,"boolean=?"]],["lang/htdp-beginner"]],
["boolean=?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._boolean~3d~3f))",[0,[1,"boolean=?"]],["lang/htdp-beginner-abbr"]],
["boolean=?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._boolean~3d~3f))",[0,[1,"boolean=?"]],["lang/htdp-intermediate"]],
["boolean=?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._boolean~3d~3f))",[0,[1,"boolean=?"]],["lang/htdp-intermediate-lambda"]],
["boolean=?",">lazy/index.html#(def._((lib._lazy/main..ss)._boolean~3d~3f))",[0,[1,"boolean=?"]],["lazy"]],
["boolean?",">reference/booleans.html#(def._((quote._~23~25kernel)._boolean~3f))",[0,[1,"boolean?"]],["scheme/base","scheme"]],
["boolean?",">r5rs-std/r5rs-Z-H-9.html#%_idx_388",[0,[1,"boolean?"]],["r5rs"]],
["boolean?",">r6rs-std/r6rs-Z-H-14.html#node_idx_596",[0,[1,"boolean?"]],["rnrs/base-6"]],
["boolean?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._boolean~3f))",[0,[1,"boolean?"]],["lang/htdp-advanced"]],
["boolean?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._boolean~3f))",[0,[1,"boolean?"]],["lang/htdp-beginner"]],
["boolean?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._boolean~3f))",[0,[1,"boolean?"]],["lang/htdp-beginner-abbr"]],
["boolean?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._boolean~3f))",[0,[1,"boolean?"]],["lang/htdp-intermediate"]],
["boolean?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._boolean~3f))",[0,[1,"boolean?"]],["lang/htdp-intermediate-lambda"]],
["booleans",">guide/booleans.html","Booleans",false],
["booleans",">reference/booleans.html#(tech._boolean)","<i>booleans</i>",false],
["booleans and equality",">reference/booleans.html","Booleans and Equality",false],
["booleans-as-true/false",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..ss)._booleans-as-true/false))",[0,[1,"booleans-as-true/false"]],["mzlib/pconvert"]],
["border",">gui/area-container___.html#(meth._(((lib._mred/main..ss)._area-container~3c~25~3e)._border))",[[0,[1,"border"]],[12,[" (method of ",[0,[1,"area-container&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["border",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border))",[[0,[1,"border"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border",">gui/area-container___.html#(idx._(gentag._25._(lib._scribblings/gui/gui..scrbl)))",[0,"border"],false],
["border-bottom",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-bottom))",[[0,[1,"border-bottom"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-bottom-color",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-bottom-color))",[[0,[1,"border-bottom-color"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-bottom-color-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-bottom-color-native))",[[0,[1,"border-bottom-color-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-bottom-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-bottom-native))",[[0,[1,"border-bottom-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-bottom-style",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-bottom-style))",[[0,[1,"border-bottom-style"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-bottom-style-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-bottom-style-native))",[[0,[1,"border-bottom-style-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-bottom-width",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-bottom-width))",[[0,[1,"border-bottom-width"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-bottom-width-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-bottom-width-native))",[[0,[1,"border-bottom-width-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-color",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-color))",[[0,[1,"border-color"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-color-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-color-native))",[[0,[1,"border-color-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-left",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-left))",[[0,[1,"border-left"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-left-color",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-left-color))",[[0,[1,"border-left-color"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-left-color-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-left-color-native))",[[0,[1,"border-left-color-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-left-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-left-native))",[[0,[1,"border-left-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-left-style",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-left-style))",[[0,[1,"border-left-style"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-left-style-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-left-style-native))",[[0,[1,"border-left-style-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-left-width",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-left-width))",[[0,[1,"border-left-width"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-left-width-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-left-width-native))",[[0,[1,"border-left-width-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-native))",[[0,[1,"border-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-right",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-right))",[[0,[1,"border-right"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-right-color",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-right-color))",[[0,[1,"border-right-color"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-right-color-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-right-color-native))",[[0,[1,"border-right-color-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-right-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-right-native))",[[0,[1,"border-right-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-right-style",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-right-style))",[[0,[1,"border-right-style"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-right-style-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-right-style-native))",[[0,[1,"border-right-style-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-right-width",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-right-width))",[[0,[1,"border-right-width"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-right-width-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-right-width-native))",[[0,[1,"border-right-width-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-style",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-style))",[[0,[1,"border-style"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-style-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-style-native))",[[0,[1,"border-style-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-top",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-top))",[[0,[1,"border-top"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-top-color",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-top-color))",[[0,[1,"border-top-color"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-top-color-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-top-color-native))",[[0,[1,"border-top-color-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-top-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-top-native))",[[0,[1,"border-top-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-top-style",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-top-style))",[[0,[1,"border-top-style"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-top-style-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-top-style-native))",[[0,[1,"border-top-style-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-top-width",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-top-width))",[[0,[1,"border-top-width"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-top-width-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-top-width-native))",[[0,[1,"border-top-width-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-visible?",">gui/editor-snip_.html#(meth._(((lib._mred/main..ss)._editor-snip~25)._border-visible~3f))",[[0,[1,"border-visible?"]],[12,[" (method of ",[0,[1,"editor-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["border-width",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-width))",[[0,[1,"border-width"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["border-width-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._border-width-native))",[[0,[1,"border-width-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["bottom",">gui/style-delta_.html#(idx._(gentag._262._(lib._scribblings/gui/gui..scrbl)))",[7,"'bottom"],false],
["bound",">reference/syntax-model.html#(tech._bound)","<i>bound</i>",false],
["bound-identifier-mapping-for-each",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..ss)._bound-identifier-mapping-for-each))",[0,[1,"bound-identifier-mapping-for-each"]],["syntax/boundmap"]],
["bound-identifier-mapping-get",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..ss)._bound-identifier-mapping-get))",[0,[1,"bound-identifier-mapping-get"]],["syntax/boundmap"]],
["bound-identifier-mapping-map",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..ss)._bound-identifier-mapping-map))",[0,[1,"bound-identifier-mapping-map"]],["syntax/boundmap"]],
["bound-identifier-mapping-put!",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..ss)._bound-identifier-mapping-put!))",[0,[1,"bound-identifier-mapping-put!"]],["syntax/boundmap"]],
["bound-identifier-mapping?",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..ss)._bound-identifier-mapping~3f))",[0,[1,"bound-identifier-mapping?"]],["syntax/boundmap"]],
["bound-identifier=?",">reference/stxcmp.html#(def._((quote._~23~25kernel)._bound-identifier~3d~3f))",[0,[1,"bound-identifier=?"]],["scheme/base","scheme"]],
["bound-identifier=?",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1140",[0,[1,"bound-identifier=?"]],["rnrs/syntax-case-6"]],
["bounding box",">slideshow/Pict_Datatype.html#(tech._bounding._box)","<i>bounding box</i>",false],
["bounding-box adjusters",">slideshow/Bounding-Box_Adjusters.html","Bounding-Box Adjusters",false],
["box",">reference/boxes.html#(def._((quote._~23~25kernel)._box))",[0,[1,"box"]],["scheme/base","scheme"]],
["box",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._box))",[0,[1,"box"]],["lang/htdp-advanced"]],
["box",">lazy/index.html#(def._((lib._lazy/main..ss)._box))",[0,[1,"box"]],["lazy"]],
["box",">guide/boxes.html#(tech._box)","<i>box</i>",false],
["box",">reference/boxes.html#(tech._box)","<i>box</i>",false],
["box-comment-out-selection",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._box-comment-out-selection))",[[0,[1,"box-comment-out-selection"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["box-immutable",">reference/boxes.html#(def._((quote._~23~25kernel)._box-immutable))",[0,[1,"box-immutable"]],["scheme/base","scheme"]],
["box-immutable/c",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._box-immutable/c))",[0,[1,"box-immutable/c"]],["scheme/contract","scheme"]],
["box/c",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._box/c))",[0,[1,"box/c"]],["scheme/contract","scheme"]],
["box?",">reference/boxes.html#(def._((quote._~23~25kernel)._box~3f))",[0,[1,"box?"]],["scheme/base","scheme"]],
["box?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._box~3f))",[0,[1,"box?"]],["lang/htdp-advanced"]],
["boxes",">guide/boxes.html","Boxes",false],
["boxes",">reference/boxes.html","Boxes",false],
["boxof",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._.Boxof))",[0,[6,"Boxof"]],["typed-scheme"]],
["br",">html/index.html#(def._((lib._html/main..ss)._br))",[0,[1,"br"]],["html"]],
["br?",">html/index.html#(def._((lib._html/main..ss)._br~3f))",[0,[1,"br?"]],["html"]],
["bracketed character class",">guide/regexp-chars.html#(tech._bracketed._character._clas)","<i>bracketed\ncharacter class</i>",false],
["break",">srfi-std/srfi-1.html#break",[0,[1,"break"]],["srfi/1"]],
["break",">reference/breakhandler.html#(tech._break)","<i>break</i>",false],
["break button",">drscheme/buttons.html#(idx._(gentag._15._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Break</font></b> button",false],
["break button",">tools/Expanding_and_Breaking.html#(idx._(gentag._11._(lib._scribblings/tools/tools..scrbl)))","break button",false],
["break menu item",">drscheme/Menus.html#(idx._(gentag._119._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Break</font></b> menu item",false],
["break!",">srfi-std/srfi-1.html#break!",[0,[1,"break!"]],["srfi/1"]],
["break-callback",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._break-callback))",[[0,[1,"break-callback"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["break-callback",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3atab~3c~25~3e)._break-callback))",[[0,[1,"break-callback"]],[12,[" (method of ",[0,[1,"drscheme:unit:tab&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["break-enabled",">reference/breakhandler.html#(def._((quote._~23~25kernel)._break-enabled))",[0,[1,"break-enabled"]],["scheme/base","scheme"]],
["break-evaluator",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._break-evaluator))",[0,[1,"break-evaluator"]],["scheme/sandbox"]],
["break-sequence",">gui/keymap_.html#(meth._(((lib._mred/main..ss)._keymap~25)._break-sequence))",[[0,[1,"break-sequence"]],[12,[" (method of ",[0,[1,"keymap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["break-thread",">reference/threads.html#(def._((quote._~23~25kernel)._break-thread))",[0,[1,"break-thread"]],["scheme/base","scheme"]],
["breaking",">tools/Expanding_and_Breaking.html#(idx._(gentag._10._(lib._scribblings/tools/tools..scrbl)))","breaking",false],
["breaking up the display",">continue/index.html#(part._.Breaking_.Up_the_.Display)","Breaking Up the Display",false],
["breaks",">reference/breakhandler.html","Breaks",false],
["bring frame to front... menu item",">drscheme/Menus.html#(idx._(gentag._143._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Bring Frame to Front...</font></b> menu item",false],
["broken-wxme-big-endian?",">gui/WXME_Decoding.html#(def._((lib._wxme/main..ss)._broken-wxme-big-endian~3f))",[0,[1,"broken-wxme-big-endian?"]],["wxme"]],
["browse-syntax",">macro-debugger/index.html#(def._((lib._macro-debugger/syntax-browser..ss)._browse-syntax))",[0,[1,"browse-syntax"]],["macro-debugger/syntax-browser"]],
["browse-syntaxes",">macro-debugger/index.html#(def._((lib._macro-debugger/syntax-browser..ss)._browse-syntaxes))",[0,[1,"browse-syntaxes"]],["macro-debugger/syntax-browser"]],
["browser",">browser/index.html#(part._browser)","Browser",false],
["browser",">drscheme/prefs-explanation.html#(part._.Browser)","<b><font size=\"-1\" face=\"Helvetica\">Browser</font></b>",false],
["browser",">browser/index.html#(mod-path._browser)",[14,[0,"browser"]],"module"],
["browser signature",">browser/index.html#(part._browser-sig)","Browser Signature",false],
["browser unit",">browser/index.html#(part._browser-unit)","Browser Unit",false],
["browser-preference?",">browser/index.html#(def._((lib._browser/external..ss)._browser-preference~3f))",[0,[1,"browser-preference?"]],["browser/external"]],
["browser-preference?",">net/sendurl.html#(def._((lib._net/sendurl..ss)._browser-preference~3f))",[0,[1,"browser-preference?"]],["net/sendurl"]],
["browser/browser-sig",">browser/index.html#(mod-path._browser/browser-sig)",[14,[0,"browser/browser-sig"]],"module"],
["browser/browser-unit",">browser/index.html#(mod-path._browser/browser-unit)",[14,[0,"browser/browser-unit"]],"module"],
["browser/external",">browser/index.html#(mod-path._browser/external)",[14,[0,"browser/external"]],"module"],
["browser/htmltext",">browser/index.html#(mod-path._browser/htmltext)",[14,[0,"browser/htmltext"]],"module"],
["browser/tool",">browser/index.html#(mod-path._browser/tool)",[14,[0,"browser/tool"]],"module"],
["browser: simple html rendering",">browser/index.html","<b>Browser</b>: Simple HTML Rendering",false],
["browser@",">browser/index.html#(def._((lib._browser/browser-unit..ss)._browser~40))",[0,[1,"browser@"]],["browser/browser-unit"]],
["browser^",">browser/index.html#(form._((lib._browser/browser-sig..ss)._browser~5e))",[0,[6,"browser^"]],["browser/browser-sig"]],
["browsers",">mysterx/browsers.html","Browsers",false],
["brush%",">gui/brush_.html",[0,[1,"brush%"]],["scheme/gui/base","scheme/gui"]],
["brush-list%",">gui/brush-list_.html",[0,[1,"brush-list%"]],["scheme/gui/base","scheme/gui"]],
["bt",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..ss)._bt))",[0,[1,"bt"]],["slideshow/base","slideshow"]],
["buffer-mode",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_576",[0,[6,"buffer-mode"]],["rnrs/io/ports-6"]],
["buffer-mode?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_578",[0,[1,"buffer-mode?"]],["rnrs/io/ports-6"]],
["buffered asynchronous channels",">reference/async-channel.html","Buffered Asynchronous Channels",false],
["build a distribution archive",">planet/Developing_Packages_for_PLaneT.html#(part._.Build_a_.Distribution_.Archive)","Build a Distribution Archive",false],
["build-absolute-path",">mzlib/mzlib_file.html#(def._((lib._mzlib/file..ss)._build-absolute-path))",[0,[1,"build-absolute-path"]],["mzlib/file"]],
["build-aux-from-path",">mzc/launcher.html#(def._((lib._launcher/launcher..ss)._build-aux-from-path))",[0,[1,"build-aux-from-path"]],["launcher/launcher"]],
["build-bitmap",">mrlib/Cache-image_Snip.html#(def._((lib._mrlib/cache-image-snip..ss)._build-bitmap))",[0,[1,"build-bitmap"]],["mrlib/cache-image-snip"]],
["build-compound-type-name",">reference/Building_New_Contract_Combinators.html#(def._((lib._scheme/private/contract-guts..ss)._build-compound-type-name))",[0,[1,"build-compound-type-name"]],["scheme/contract","scheme"]],
["build-expand-context",">syntax/transformer-helpers.html#(def._((lib._syntax/context..ss)._build-expand-context))",[0,[1,"build-expand-context"]],["syntax/context"]],
["build-list",">reference/pairs.html#(def._((lib._scheme/base..ss)._build-list))",[0,[1,"build-list"]],["scheme/base","scheme"]],
["build-list",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._build-list))",[0,[1,"build-list"]],["lang/htdp-advanced"]],
["build-list",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._build-list))",[0,[1,"build-list"]],["lang/htdp-intermediate"]],
["build-list",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._build-list))",[0,[1,"build-list"]],["lang/htdp-intermediate-lambda"]],
["build-list",">lazy/index.html#(def._((lib._lazy/main..ss)._build-list))",[0,[1,"build-list"]],["lazy"]],
["build-lw",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._build-lw))",[0,[1,"build-lw"]],["redex/pict"]],
["build-matrix",">teachpack/matrix.html#(def._((lib._teachpack/htdp/matrix..ss)._build-matrix))",[0,[1,"build-matrix"]],["teachpack/htdp/matrix"]],
["build-path",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._build-path))",[0,[1,"build-path"]],["scheme/base","scheme"]],
["build-path-unless-absolute",">web-server/util_ss.html#(def._((lib._web-server/private/util..ss)._build-path-unless-absolute))",[0,[1,"build-path-unless-absolute"]],["web-server/private/util"]],
["build-path/convention-type",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._build-path/convention-type))",[0,[1,"build-path/convention-type"]],["scheme/base","scheme"]],
["build-relative-path",">mzlib/mzlib_file.html#(def._((lib._mzlib/file..ss)._build-relative-path))",[0,[1,"build-relative-path"]],["mzlib/file"]],
["build-share",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..ss)._build-share))",[0,[1,"build-share"]],["mzlib/pconvert"]],
["build-string",">reference/strings.html#(def._((lib._scheme/base..ss)._build-string))",[0,[1,"build-string"]],["scheme/base","scheme"]],
["build-string",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._build-string))",[0,[1,"build-string"]],["lang/htdp-advanced"]],
["build-string",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._build-string))",[0,[1,"build-string"]],["lang/htdp-intermediate"]],
["build-string",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._build-string))",[0,[1,"build-string"]],["lang/htdp-intermediate-lambda"]],
["build-struct-expand-info",">syntax/transformer-helpers.html#(def._((lib._syntax/struct..ss)._build-struct-expand-info))",[0,[1,"build-struct-expand-info"]],["syntax/struct"]],
["build-struct-generation",">syntax/transformer-helpers.html#(def._((lib._syntax/struct..ss)._build-struct-generation))",[0,[1,"build-struct-generation"]],["syntax/struct"]],
["build-struct-generation*",">syntax/transformer-helpers.html#(def._((lib._syntax/struct..ss)._build-struct-generation*))",[0,[1,"build-struct-generation*"]],["syntax/struct"]],
["build-struct-names",">syntax/transformer-helpers.html#(def._((lib._syntax/struct..ss)._build-struct-names))",[0,[1,"build-struct-names"]],["syntax/struct"]],
["build-vector",">reference/vectors.html#(def._((lib._scheme/base..ss)._build-vector))",[0,[1,"build-vector"]],["scheme/base","scheme"]],
["build-vector",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._build-vector))",[0,[1,"build-vector"]],["lang/htdp-advanced"]],
["building native-code extensions",">make/setup-extension.html","Building Native-Code Extensions",false],
["building new contract combinators",">reference/Building_New_Contract_Combinators.html","Building New Contract Combinators",false],
["built-in datatypes",">guide/datatypes.html","Built-In Datatypes",false],
["built-in exception types",">reference/exns.html#(part._.Built-in_.Exception_.Types)","Built-in Exception Types",false],
["bullet",">slideshow/Constants_and_Layout_Variables.html#(def._((lib._slideshow/base..ss)._bullet))",[0,[1,"bullet"]],["slideshow/base","slideshow"]],
["bullet-size",">browser/index.html#(def._((lib._browser/main..ss)._bullet-size))",[0,[1,"bullet-size"]],["browser"]],
["bundle-directory",">mzc/exe-dist.html#(def._((lib._compiler/bundle-dist..ss)._bundle-directory))",[0,[1,"bundle-directory"]],["compiler/bundle-dist"]],
["bundle-put-file-extension+style+filters",">mzc/exe-dist.html#(def._((lib._compiler/bundle-dist..ss)._bundle-put-file-extension+style+filters))",[0,[1,"bundle-put-file-extension+style+filters"]],["compiler/bundle-dist"]],
["bundled games",">games/bundled.html","Bundled Games",false],
["butterfly attractor",">turtles/Traditional_Turtles.html#(idx._(gentag._3._(lib._graphics/scribblings/turtles..scrbl)))","butterfly attractor",false],
["button",">html/index.html#(def._((lib._html/main..ss)._button))",[0,[1,"button"]],["html"]],
["button",">gui/button_.html#(idx._(gentag._28._(lib._scribblings/gui/gui..scrbl)))",[7,"'button"],false],
["button",">gui/windowing-overview.html#(tech._button)","<i>button</i>",false],
["button%",">gui/button_.html",[0,[1,"button%"]],["scheme/gui/base","scheme/gui"]],
["button-changed?",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._button-changed~3f))",[[0,[1,"button-changed?"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["button-down?",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._button-down~3f))",[[0,[1,"button-down?"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["button-snip%",">embedded-gui/button-snip_.html",[0,[1,"button-snip%"]],["embedded-gui"]],
["button-up?",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._button-up~3f))",[[0,[1,"button-up?"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["button?",">html/index.html#(def._((lib._html/main..ss)._button~3f))",[0,[1,"button?"]],["html"]],
["buttons",">drscheme/buttons.html","Buttons",false],
["byte",">guide/bytestrings.html#(tech._byte)","<i>byte</i>",false],
["byte and string input",">reference/Byte_and_String_Input.html","Byte and String Input",false],
["byte and string output",">reference/Byte_and_String_Output.html","Byte and String Output",false],
["byte string",">guide/bytestrings.html#(tech._byte._string)","<i>byte string</i>",false],
["byte string",">reference/bytestrings.html#(tech._byte._string)","<i>byte string</i>",false],
["byte string comparisons",">reference/bytestrings.html#(part._.Byte_.String_.Comparisons)","Byte String Comparisons",false],
["byte string constructors, selectors, and mutators",">reference/bytestrings.html#(part._.Byte_.String_.Constructors__.Selectors__and_.Mutators)","Byte String Constructors, Selectors, and Mutators",false],
["byte strings parsing",">reference/reader.html#(idx._(gentag._149._(lib._scribblings/reference/reference..scrbl)))","byte strings, parsing",false],
["byte strings immutable",">reference/bytestrings.html#(idx._(gentag._27._(lib._scribblings/reference/reference..scrbl)))","byte strings, immutable",false],
["byte strings concatenate",">reference/bytestrings.html#(idx._(gentag._28._(lib._scribblings/reference/reference..scrbl)))","byte strings, concatenate",false],
["byte strings",">reference/bytestrings.html","Byte Strings",false],
["byte-pregexp",">reference/regexp.html#(def._((quote._~23~25kernel)._byte-pregexp))",[0,[1,"byte-pregexp"]],["scheme/base","scheme"]],
["byte-pregexp?",">reference/regexp.html#(def._((quote._~23~25kernel)._byte-pregexp~3f))",[0,[1,"byte-pregexp?"]],["scheme/base","scheme"]],
["byte-ready?",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._byte-ready~3f))",[0,[1,"byte-ready?"]],["scheme/base","scheme"]],
["byte-regexp",">reference/regexp.html#(def._((quote._~23~25kernel)._byte-regexp))",[0,[1,"byte-regexp"]],["scheme/base","scheme"]],
["byte-regexp?",">reference/regexp.html#(def._((quote._~23~25kernel)._byte-regexp~3f))",[0,[1,"byte-regexp?"]],["scheme/base","scheme"]],
["byte?",">reference/bytestrings.html#(def._((quote._~23~25kernel)._byte~3f))",[0,[1,"byte?"]],["scheme/base","scheme"]],
["bytecode compilation",">mzc/Scheme_API_for_Compilation.html#(part._api~3azo)","Bytecode Compilation",false],
["bytecode files",">mzc/make.html#(part._.Bytecode_.Files)","Bytecode Files",false],
["bytes",">web-server/util_ss.html#(part._.Bytes)","Bytes",false],
["bytes",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes))",[0,[1,"bytes"]],["scheme/base","scheme"]],
["bytes",">reference/bytestrings.html#(idx._(gentag._26._(lib._scribblings/reference/reference..scrbl)))","bytes",false],
["bytes and byte strings",">guide/bytestrings.html","Bytes and Byte Strings",false],
["bytes to bytes encoding conversion",">reference/bytestrings.html#(part._.Bytes_to_.Bytes_.Encoding_.Conversion)","Bytes to Bytes Encoding Conversion",false],
["bytes to/from characters, decoding and encoding",">reference/bytestrings.html#(part._.Bytes_to_from_.Characters__.Decoding_and_.Encoding)","Bytes to/from Characters, Decoding and Encoding",false],
["bytes, characters, and encodings",">guide/Bytes__Characters__and_Encodings.html","Bytes, Characters, and Encodings",false],
["bytes->immutable-bytes",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-~3eimmutable-bytes))",[0,[1,"bytes-&gt;immutable-bytes"]],["scheme/base","scheme"]],
["bytes->list",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-~3elist))",[0,[1,"bytes-&gt;list"]],["scheme/base","scheme"]],
["bytes->path",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._bytes-~3epath))",[0,[1,"bytes-&gt;path"]],["scheme/base","scheme"]],
["bytes->path-element",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._bytes-~3epath-element))",[0,[1,"bytes-&gt;path-element"]],["scheme/base","scheme"]],
["bytes->string/latin-1",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-~3estring/latin-1))",[0,[1,"bytes-&gt;string/latin-1"]],["scheme/base","scheme"]],
["bytes->string/locale",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-~3estring/locale))",[0,[1,"bytes-&gt;string/locale"]],["scheme/base","scheme"]],
["bytes->string/utf-8",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-~3estring/utf-8))",[0,[1,"bytes-&gt;string/utf-8"]],["scheme/base","scheme"]],
["bytes-append",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-append))",[0,[1,"bytes-append"]],["scheme/base","scheme"]],
["bytes-close-converter",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-close-converter))",[0,[1,"bytes-close-converter"]],["scheme/base","scheme"]],
["bytes-convert",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-convert))",[0,[1,"bytes-convert"]],["scheme/base","scheme"]],
["bytes-convert-end",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-convert-end))",[0,[1,"bytes-convert-end"]],["scheme/base","scheme"]],
["bytes-converter?",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-converter~3f))",[0,[1,"bytes-converter?"]],["scheme/base","scheme"]],
["bytes-copy",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-copy))",[0,[1,"bytes-copy"]],["scheme/base","scheme"]],
["bytes-copy!",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-copy!))",[0,[1,"bytes-copy!"]],["scheme/base","scheme"]],
["bytes-fill!",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-fill!))",[0,[1,"bytes-fill!"]],["scheme/base","scheme"]],
["bytes-length",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-length))",[0,[1,"bytes-length"]],["scheme/base","scheme"]],
["bytes-open-converter",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-open-converter))",[0,[1,"bytes-open-converter"]],["scheme/base","scheme"]],
["bytes-ref",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-ref))",[0,[1,"bytes-ref"]],["scheme/base","scheme"]],
["bytes-set!",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-set!))",[0,[1,"bytes-set!"]],["scheme/base","scheme"]],
["bytes-utf-8-index",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-utf-8-index))",[0,[1,"bytes-utf-8-index"]],["scheme/base","scheme"]],
["bytes-utf-8-length",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-utf-8-length))",[0,[1,"bytes-utf-8-length"]],["scheme/base","scheme"]],
["bytes-utf-8-ref",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes-utf-8-ref))",[0,[1,"bytes-utf-8-ref"]],["scheme/base","scheme"]],
["bytes<?",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes~3c~3f))",[0,[1,"bytes&lt;?"]],["scheme/base","scheme"]],
["bytes=?",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes~3d~3f))",[0,[1,"bytes=?"]],["scheme/base","scheme"]],
["bytes>?",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes~3e~3f))",[0,[1,"bytes&gt;?"]],["scheme/base","scheme"]],
["bytes?",">reference/bytestrings.html#(def._((quote._~23~25kernel)._bytes~3f))",[0,[1,"bytes?"]],["scheme/base","scheme"]],
["bytevector->sint-list",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_118",[0,[1,"bytevector-&gt;sint-list"]],["rnrs/bytevectors-6"]],
["bytevector->string",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_630",[0,[1,"bytevector-&gt;string"]],["rnrs/io/ports-6"]],
["bytevector->u8-list",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_104",[0,[1,"bytevector-&gt;u8-list"]],["rnrs/bytevectors-6"]],
["bytevector->uint-list",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_116",[0,[1,"bytevector-&gt;uint-list"]],["rnrs/bytevectors-6"]],
["bytevector-copy",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_94",[0,[1,"bytevector-copy"]],["rnrs/bytevectors-6"]],
["bytevector-copy!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_92",[0,[1,"bytevector-copy!"]],["rnrs/bytevectors-6"]],
["bytevector-fill!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_90",[0,[1,"bytevector-fill!"]],["rnrs/bytevectors-6"]],
["bytevector-ieee-double-native-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_176",[0,[1,"bytevector-ieee-double-native-ref"]],["rnrs/bytevectors-6"]],
["bytevector-ieee-double-native-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_182",[0,[1,"bytevector-ieee-double-native-set!"]],["rnrs/bytevectors-6"]],
["bytevector-ieee-double-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_178",[0,[1,"bytevector-ieee-double-ref"]],["rnrs/bytevectors-6"]],
["bytevector-ieee-single-native-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_172",[0,[1,"bytevector-ieee-single-native-ref"]],["rnrs/bytevectors-6"]],
["bytevector-ieee-single-native-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_180",[0,[1,"bytevector-ieee-single-native-set!"]],["rnrs/bytevectors-6"]],
["bytevector-ieee-single-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_174",[0,[1,"bytevector-ieee-single-ref"]],["rnrs/bytevectors-6"]],
["bytevector-length",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_86",[0,[1,"bytevector-length"]],["rnrs/bytevectors-6"]],
["bytevector-s16-native-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_130",[0,[1,"bytevector-s16-native-ref"]],["rnrs/bytevectors-6"]],
["bytevector-s16-native-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_138",[0,[1,"bytevector-s16-native-set!"]],["rnrs/bytevectors-6"]],
["bytevector-s16-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_126",[0,[1,"bytevector-s16-ref"]],["rnrs/bytevectors-6"]],
["bytevector-s16-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_134",[0,[1,"bytevector-s16-set!"]],["rnrs/bytevectors-6"]],
["bytevector-s32-native-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_146",[0,[1,"bytevector-s32-native-ref"]],["rnrs/bytevectors-6"]],
["bytevector-s32-native-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_154",[0,[1,"bytevector-s32-native-set!"]],["rnrs/bytevectors-6"]],
["bytevector-s32-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_142",[0,[1,"bytevector-s32-ref"]],["rnrs/bytevectors-6"]],
["bytevector-s32-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_150",[0,[1,"bytevector-s32-set!"]],["rnrs/bytevectors-6"]],
["bytevector-s64-native-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_162",[0,[1,"bytevector-s64-native-ref"]],["rnrs/bytevectors-6"]],
["bytevector-s64-native-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_170",[0,[1,"bytevector-s64-native-set!"]],["rnrs/bytevectors-6"]],
["bytevector-s64-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_158",[0,[1,"bytevector-s64-ref"]],["rnrs/bytevectors-6"]],
["bytevector-s64-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_166",[0,[1,"bytevector-s64-set!"]],["rnrs/bytevectors-6"]],
["bytevector-s8-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_98",[0,[1,"bytevector-s8-ref"]],["rnrs/bytevectors-6"]],
["bytevector-s8-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_102",[0,[1,"bytevector-s8-set!"]],["rnrs/bytevectors-6"]],
["bytevector-sint-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_110",[0,[1,"bytevector-sint-ref"]],["rnrs/bytevectors-6"]],
["bytevector-sint-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_114",[0,[1,"bytevector-sint-set!"]],["rnrs/bytevectors-6"]],
["bytevector-u16-native-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_128",[0,[1,"bytevector-u16-native-ref"]],["rnrs/bytevectors-6"]],
["bytevector-u16-native-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_136",[0,[1,"bytevector-u16-native-set!"]],["rnrs/bytevectors-6"]],
["bytevector-u16-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_124",[0,[1,"bytevector-u16-ref"]],["rnrs/bytevectors-6"]],
["bytevector-u16-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_132",[0,[1,"bytevector-u16-set!"]],["rnrs/bytevectors-6"]],
["bytevector-u32-native-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_144",[0,[1,"bytevector-u32-native-ref"]],["rnrs/bytevectors-6"]],
["bytevector-u32-native-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_152",[0,[1,"bytevector-u32-native-set!"]],["rnrs/bytevectors-6"]],
["bytevector-u32-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_140",[0,[1,"bytevector-u32-ref"]],["rnrs/bytevectors-6"]],
["bytevector-u32-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_148",[0,[1,"bytevector-u32-set!"]],["rnrs/bytevectors-6"]],
["bytevector-u64-native-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_160",[0,[1,"bytevector-u64-native-ref"]],["rnrs/bytevectors-6"]],
["bytevector-u64-native-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_168",[0,[1,"bytevector-u64-native-set!"]],["rnrs/bytevectors-6"]],
["bytevector-u64-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_156",[0,[1,"bytevector-u64-ref"]],["rnrs/bytevectors-6"]],
["bytevector-u64-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_164",[0,[1,"bytevector-u64-set!"]],["rnrs/bytevectors-6"]],
["bytevector-u8-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_96",[0,[1,"bytevector-u8-ref"]],["rnrs/bytevectors-6"]],
["bytevector-u8-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_100",[0,[1,"bytevector-u8-set!"]],["rnrs/bytevectors-6"]],
["bytevector-uint-ref",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_108",[0,[1,"bytevector-uint-ref"]],["rnrs/bytevectors-6"]],
["bytevector-uint-set!",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_112",[0,[1,"bytevector-uint-set!"]],["rnrs/bytevectors-6"]],
["bytevector=?",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_88",[0,[1,"bytevector=?"]],["rnrs/bytevectors-6"]],
["bytevector?",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_80",[0,[1,"bytevector?"]],["rnrs/bytevectors-6"]],
["c struct types",">foreign/C_Struct_Types.html","C Struct Types",false],
["c types",">foreign/types.html","C Types",false],
["c types",">foreign/types.html#(tech._c._type)","<i>C types</i>",false],
["c-+ keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._182._(lib._scribblings/drscheme/drscheme..scrbl)))","C-+ keybinding",false],
["c-_ keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._181._(lib._scribblings/drscheme/drscheme..scrbl)))","C-_ keybinding",false],
["c-a keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._162._(lib._scribblings/drscheme/drscheme..scrbl)))","C-a keybinding",false],
["c-b keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._155._(lib._scribblings/drscheme/drscheme..scrbl)))","C-b keybinding",false],
["c-c c-e keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._203._(lib._scribblings/drscheme/drscheme..scrbl)))","C-c C-e keybinding",false],
["c-c c-l keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._204._(lib._scribblings/drscheme/drscheme..scrbl)))","C-c C-l keybinding",false],
["c-c c-o keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._202._(lib._scribblings/drscheme/drscheme..scrbl)))","C-c C-o keybinding",false],
["c-d keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._184._(lib._scribblings/drscheme/drscheme..scrbl)))","C-d keybinding",false],
["c-declare",">cffi/index.html#(form._((lib._compiler/cffi..ss)._c-declare))",[0,[6,"c-declare"]],["compiler/cffi"]],
["c-e keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._163._(lib._scribblings/drscheme/drscheme..scrbl)))","C-e keybinding",false],
["c-f keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._154._(lib._scribblings/drscheme/drscheme..scrbl)))","C-f keybinding",false],
["c-f6 keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._180._(lib._scribblings/drscheme/drscheme..scrbl)))","C-F6 keybinding",false],
["c-h keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._185._(lib._scribblings/drscheme/drscheme..scrbl)))","C-h keybinding",false],
["c-include",">cffi/index.html#(form._((lib._compiler/cffi..ss)._c-include))",[0,[6,"c-include"]],["compiler/cffi"]],
["c-k keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._188._(lib._scribblings/drscheme/drscheme..scrbl)))","C-k keybinding",false],
["c-lambda",">cffi/index.html#(form._((lib._compiler/cffi..ss)._c-lambda))",[0,[6,"c-lambda"]],["compiler/cffi"]],
["c-lambda: c ffi via mzc",">cffi/index.html",[[0,[6,"c-lambda"]],": C FFI via ",[5,"mzc"]],false],
["c-n keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._164._(lib._scribblings/drscheme/drscheme..scrbl)))","C-n keybinding",false],
["c-p keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._165._(lib._scribblings/drscheme/drscheme..scrbl)))","C-p keybinding",false],
["c-r keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._210._(lib._scribblings/drscheme/drscheme..scrbl)))","C-r keybinding",false],
["c-s keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._209._(lib._scribblings/drscheme/drscheme..scrbl)))","C-s keybinding",false],
["c-style opengl",">sgl/gl.html","C-Style OpenGL",false],
["c-t keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._193._(lib._scribblings/drscheme/drscheme..scrbl)))","C-t keybinding",false],
["c-v keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._158._(lib._scribblings/drscheme/drscheme..scrbl)))","C-v keybinding",false],
["c-w keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._191._(lib._scribblings/drscheme/drscheme..scrbl)))","C-w keybinding",false],
["c-x c-s keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._207._(lib._scribblings/drscheme/drscheme..scrbl)))","C-x C-s keybinding",false],
["c-x c-w keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._208._(lib._scribblings/drscheme/drscheme..scrbl)))","C-x C-w keybinding",false],
["c-x u keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._183._(lib._scribblings/drscheme/drscheme..scrbl)))","C-x u keybinding",false],
["c-y keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._192._(lib._scribblings/drscheme/drscheme..scrbl)))","C-y keybinding",false],
["caaaar",">reference/pairs.html#(def._((quote._~23~25kernel)._caaaar))",[0,[1,"caaaar"]],["scheme/base","scheme"]],
["caaaar",">lazy/index.html#(def._((lib._lazy/main..ss)._caaaar))",[0,[1,"caaaar"]],["lazy"]],
["caaadr",">reference/pairs.html#(def._((quote._~23~25kernel)._caaadr))",[0,[1,"caaadr"]],["scheme/base","scheme"]],
["caaadr",">lazy/index.html#(def._((lib._lazy/main..ss)._caaadr))",[0,[1,"caaadr"]],["lazy"]],
["caaar",">reference/pairs.html#(def._((quote._~23~25kernel)._caaar))",[0,[1,"caaar"]],["scheme/base","scheme"]],
["caaar",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._caaar))",[0,[1,"caaar"]],["lang/htdp-advanced"]],
["caaar",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._caaar))",[0,[1,"caaar"]],["lang/htdp-beginner"]],
["caaar",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._caaar))",[0,[1,"caaar"]],["lang/htdp-beginner-abbr"]],
["caaar",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._caaar))",[0,[1,"caaar"]],["lang/htdp-intermediate"]],
["caaar",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._caaar))",[0,[1,"caaar"]],["lang/htdp-intermediate-lambda"]],
["caaar",">lazy/index.html#(def._((lib._lazy/main..ss)._caaar))",[0,[1,"caaar"]],["lazy"]],
["caadar",">reference/pairs.html#(def._((quote._~23~25kernel)._caadar))",[0,[1,"caadar"]],["scheme/base","scheme"]],
["caadar",">lazy/index.html#(def._((lib._lazy/main..ss)._caadar))",[0,[1,"caadar"]],["lazy"]],
["caaddr",">reference/pairs.html#(def._((quote._~23~25kernel)._caaddr))",[0,[1,"caaddr"]],["scheme/base","scheme"]],
["caaddr",">lazy/index.html#(def._((lib._lazy/main..ss)._caaddr))",[0,[1,"caaddr"]],["lazy"]],
["caadr",">reference/pairs.html#(def._((quote._~23~25kernel)._caadr))",[0,[1,"caadr"]],["scheme/base","scheme"]],
["caadr",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._caadr))",[0,[1,"caadr"]],["lang/htdp-advanced"]],
["caadr",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._caadr))",[0,[1,"caadr"]],["lang/htdp-beginner"]],
["caadr",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._caadr))",[0,[1,"caadr"]],["lang/htdp-beginner-abbr"]],
["caadr",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._caadr))",[0,[1,"caadr"]],["lang/htdp-intermediate"]],
["caadr",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._caadr))",[0,[1,"caadr"]],["lang/htdp-intermediate-lambda"]],
["caadr",">lazy/index.html#(def._((lib._lazy/main..ss)._caadr))",[0,[1,"caadr"]],["lazy"]],
["caar",">reference/pairs.html#(def._((quote._~23~25kernel)._caar))",[0,[1,"caar"]],["scheme/base","scheme"]],
["caar",">r5rs-std/r5rs-Z-H-9.html#%_idx_420",[0,[1,"caar"]],["r5rs"]],
["caar",">r6rs-std/r6rs-Z-H-14.html#node_idx_616",[0,[1,"caar"]],["rnrs/base-6"]],
["caar",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._caar))",[0,[1,"caar"]],["lang/htdp-advanced"]],
["caar",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._caar))",[0,[1,"caar"]],["lang/htdp-beginner"]],
["caar",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._caar))",[0,[1,"caar"]],["lang/htdp-beginner-abbr"]],
["caar",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._caar))",[0,[1,"caar"]],["lang/htdp-intermediate"]],
["caar",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._caar))",[0,[1,"caar"]],["lang/htdp-intermediate-lambda"]],
["caar",">lazy/index.html#(def._((lib._lazy/main..ss)._caar))",[0,[1,"caar"]],["lazy"]],
["cache table",">web-server/cache-table_ss.html","Cache Table",false],
["cache-dir",">planet/Utility_Libraries.html#(def._((lib._planet/config..ss)._.C.A.C.H.E-.D.I.R))",[0,[1,"CACHE-DIR"]],["planet/config"]],
["cache-image snip",">mrlib/Cache-image_Snip.html","Cache-image Snip",false],
["cache-image%",">gui/WXME_Decoding.html#(def._((lib._wxme/cache-image..ss)._cache-image~25))",[0,[1,"cache-image%"]],["wxme/cache-image"]],
["cache-image-snip%",">mrlib/Cache-image_Snip.html#(def._((lib._mrlib/cache-image-snip..ss)._cache-image-snip~25))",[0,[1,"cache-image-snip%"]],["mrlib/cache-image-snip"]],
["cache-table-clear!",">web-server/cache-table_ss.html#(def._((lib._web-server/private/cache-table..ss)._cache-table-clear!))",[0,[1,"cache-table-clear!"]],["web-server/private/cache-table"]],
["cache-table-lookup!",">web-server/cache-table_ss.html#(def._((lib._web-server/private/cache-table..ss)._cache-table-lookup!))",[0,[1,"cache-table-lookup!"]],["web-server/private/cache-table"]],
["cache-table?",">web-server/cache-table_ss.html#(def._((lib._web-server/private/cache-table..ss)._cache-table~3f))",[0,[1,"cache-table?"]],["web-server/private/cache-table"]],
["cached installation archive",">planet/search-order.html#(part._.Cached_.Installation_.Archive)","Cached Installation Archive",false],
["cadaar",">reference/pairs.html#(def._((quote._~23~25kernel)._cadaar))",[0,[1,"cadaar"]],["scheme/base","scheme"]],
["cadaar",">lazy/index.html#(def._((lib._lazy/main..ss)._cadaar))",[0,[1,"cadaar"]],["lazy"]],
["cadadr",">reference/pairs.html#(def._((quote._~23~25kernel)._cadadr))",[0,[1,"cadadr"]],["scheme/base","scheme"]],
["cadadr",">lazy/index.html#(def._((lib._lazy/main..ss)._cadadr))",[0,[1,"cadadr"]],["lazy"]],
["cadar",">reference/pairs.html#(def._((quote._~23~25kernel)._cadar))",[0,[1,"cadar"]],["scheme/base","scheme"]],
["cadar",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._cadar))",[0,[1,"cadar"]],["lang/htdp-advanced"]],
["cadar",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._cadar))",[0,[1,"cadar"]],["lang/htdp-beginner"]],
["cadar",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._cadar))",[0,[1,"cadar"]],["lang/htdp-beginner-abbr"]],
["cadar",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._cadar))",[0,[1,"cadar"]],["lang/htdp-intermediate"]],
["cadar",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._cadar))",[0,[1,"cadar"]],["lang/htdp-intermediate-lambda"]],
["cadar",">lazy/index.html#(def._((lib._lazy/main..ss)._cadar))",[0,[1,"cadar"]],["lazy"]],
["caddar",">reference/pairs.html#(def._((quote._~23~25kernel)._caddar))",[0,[1,"caddar"]],["scheme/base","scheme"]],
["caddar",">lazy/index.html#(def._((lib._lazy/main..ss)._caddar))",[0,[1,"caddar"]],["lazy"]],
["cadddr",">reference/pairs.html#(def._((quote._~23~25kernel)._cadddr))",[0,[1,"cadddr"]],["scheme/base","scheme"]],
["cadddr",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._cadddr))",[0,[1,"cadddr"]],["lang/htdp-advanced"]],
["cadddr",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._cadddr))",[0,[1,"cadddr"]],["lang/htdp-beginner"]],
["cadddr",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._cadddr))",[0,[1,"cadddr"]],["lang/htdp-beginner-abbr"]],
["cadddr",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._cadddr))",[0,[1,"cadddr"]],["lang/htdp-intermediate"]],
["cadddr",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._cadddr))",[0,[1,"cadddr"]],["lang/htdp-intermediate-lambda"]],
["cadddr",">lazy/index.html#(def._((lib._lazy/main..ss)._cadddr))",[0,[1,"cadddr"]],["lazy"]],
["caddr",">reference/pairs.html#(def._((quote._~23~25kernel)._caddr))",[0,[1,"caddr"]],["scheme/base","scheme"]],
["caddr",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._caddr))",[0,[1,"caddr"]],["lang/htdp-advanced"]],
["caddr",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._caddr))",[0,[1,"caddr"]],["lang/htdp-beginner"]],
["caddr",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._caddr))",[0,[1,"caddr"]],["lang/htdp-beginner-abbr"]],
["caddr",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._caddr))",[0,[1,"caddr"]],["lang/htdp-intermediate"]],
["caddr",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._caddr))",[0,[1,"caddr"]],["lang/htdp-intermediate-lambda"]],
["caddr",">lazy/index.html#(def._((lib._lazy/main..ss)._caddr))",[0,[1,"caddr"]],["lazy"]],
["cadr",">reference/pairs.html#(def._((quote._~23~25kernel)._cadr))",[0,[1,"cadr"]],["scheme/base","scheme"]],
["cadr",">r5rs-std/r5rs-Z-H-9.html#%_idx_422",[0,[1,"cadr"]],["r5rs"]],
["cadr",">r6rs-std/r6rs-Z-H-14.html#node_idx_618",[0,[1,"cadr"]],["rnrs/base-6"]],
["cadr",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._cadr))",[0,[1,"cadr"]],["lang/htdp-advanced"]],
["cadr",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._cadr))",[0,[1,"cadr"]],["lang/htdp-beginner"]],
["cadr",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._cadr))",[0,[1,"cadr"]],["lang/htdp-beginner-abbr"]],
["cadr",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._cadr))",[0,[1,"cadr"]],["lang/htdp-intermediate"]],
["cadr",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._cadr))",[0,[1,"cadr"]],["lang/htdp-intermediate-lambda"]],
["cadr",">lazy/index.html#(def._((lib._lazy/main..ss)._cadr))",[0,[1,"cadr"]],["lazy"]],
["calc-button-min-sizes",">mrlib/Name_Message.html#(def._((lib._mrlib/name-message..ss)._calc-button-min-sizes))",[0,[1,"calc-button-min-sizes"]],["mrlib/name-message"]],
["call-as-current",">gui/gl-context___.html#(meth._(((lib._mred/main..ss)._gl-context~3c~25~3e)._call-as-current))",[[0,[1,"call-as-current"]],[12,[" (method of ",[0,[1,"gl-context&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["call-as-primary-owner",">gui/editor-canvas_.html#(meth._(((lib._mred/main..ss)._editor-canvas~25)._call-as-primary-owner))",[[0,[1,"call-as-primary-owner"]],[12,[" (method of ",[0,[1,"editor-canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["call-by-reference",">guide/pattern-macros.html#(tech._call._by._reference)","<i>call-by-reference</i>",false],
["call-by-value",">reference/eval-model.html#(tech._call._by._value)","<i>call-by-value</i>",false],
["call-clickback",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._call-clickback))",[[0,[1,"call-clickback"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["call-function",">gui/keymap_.html#(meth._(((lib._mred/main..ss)._keymap~25)._call-function))",[[0,[1,"call-function"]],[12,[" (method of ",[0,[1,"keymap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["call-in-nested-thread",">reference/threads.html#(def._((quote._~23~25kernel)._call-in-nested-thread))",[0,[1,"call-in-nested-thread"]],["scheme/base","scheme"]],
["call-install",">setup-plt/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..ss)._setup-option~5e._call-install))",[0,[1,"call-install"]],["setup/option-sig"]],
["call-with-break-parameterization",">reference/breakhandler.html#(def._((lib._scheme/private/more-scheme..ss)._call-with-break-parameterization))",[0,[1,"call-with-break-parameterization"]],["scheme/base","scheme"]],
["call-with-bytevector-output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_724",[0,[1,"call-with-bytevector-output-port"]],["rnrs/io/ports-6"]],
["call-with-composable-continuation",">reference/cont.html#(def._((quote._~23~25kernel)._call-with-composable-continuation))",[0,[1,"call-with-composable-continuation"]],["scheme/base","scheme"]],
["call-with-continuation-barrier",">reference/cont.html#(def._((quote._~23~25kernel)._call-with-continuation-barrier))",[0,[1,"call-with-continuation-barrier"]],["scheme/base","scheme"]],
["call-with-continuation-prompt",">reference/cont.html#(def._((quote._~23~25kernel)._call-with-continuation-prompt))",[0,[1,"call-with-continuation-prompt"]],["scheme/base","scheme"]],
["call-with-current-continuation",">reference/cont.html#(def._((quote._~23~25kernel)._call-with-current-continuation))",[0,[1,"call-with-current-continuation"]],["scheme/base","scheme"]],
["call-with-current-continuation",">r5rs-std/r5rs-Z-H-9.html#%_idx_588",[0,[1,"call-with-current-continuation"]],["r5rs"]],
["call-with-current-continuation",">r6rs-std/r6rs-Z-H-14.html#node_idx_754",[0,[1,"call-with-current-continuation"]],["rnrs/base-6"]],
["call-with-escape-continuation",">reference/cont.html#(def._((quote._~23~25kernel)._call-with-escape-continuation))",[0,[1,"call-with-escape-continuation"]],["scheme/base","scheme"]],
["call-with-exception-handler",">reference/exns.html#(def._((lib._scheme/private/more-scheme..ss)._call-with-exception-handler))",[0,[1,"call-with-exception-handler"]],["scheme/base","scheme"]],
["call-with-input-file",">reference/file-ports.html#(def._((lib._scheme/base..ss)._call-with-input-file))",[0,[1,"call-with-input-file"]],["scheme/base","scheme"]],
["call-with-input-file",">r5rs-std/r5rs-Z-H-9.html#%_idx_610",[0,[1,"call-with-input-file"]],["r5rs"]],
["call-with-input-file",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_776",[0,[1,"call-with-input-file"]],["rnrs/io/simple-6"]],
["call-with-input-file",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..ss)._call-with-input-file))",[0,[1,"call-with-input-file"]],["mzscheme"]],
["call-with-input-file*",">reference/file-ports.html#(def._((lib._scheme/base..ss)._call-with-input-file*))",[0,[1,"call-with-input-file*"]],["scheme/base","scheme"]],
["call-with-input-file*",">mzlib/mzlib_file.html#(def._((lib._mzlib/file..ss)._call-with-input-file*))",[0,[1,"call-with-input-file*"]],["mzlib/file"]],
["call-with-limits",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._call-with-limits))",[0,[1,"call-with-limits"]],["scheme/sandbox"]],
["call-with-output-file",">reference/file-ports.html#(def._((lib._scheme/base..ss)._call-with-output-file))",[0,[1,"call-with-output-file"]],["scheme/base","scheme"]],
["call-with-output-file",">r5rs-std/r5rs-Z-H-9.html#%_idx_612",[0,[1,"call-with-output-file"]],["r5rs"]],
["call-with-output-file",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_778",[0,[1,"call-with-output-file"]],["rnrs/io/simple-6"]],
["call-with-output-file",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..ss)._call-with-output-file))",[0,[1,"call-with-output-file"]],["mzscheme"]],
["call-with-output-file*",">reference/file-ports.html#(def._((lib._scheme/base..ss)._call-with-output-file*))",[0,[1,"call-with-output-file*"]],["scheme/base","scheme"]],
["call-with-output-file*",">mzlib/mzlib_file.html#(def._((lib._mzlib/file..ss)._call-with-output-file*))",[0,[1,"call-with-output-file*"]],["mzlib/file"]],
["call-with-parameterization",">reference/parameters.html#(def._((lib._scheme/private/more-scheme..ss)._call-with-parameterization))",[0,[1,"call-with-parameterization"]],["scheme/base","scheme"]],
["call-with-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_662",[0,[1,"call-with-port"]],["rnrs/io/ports-6"]],
["call-with-semaphore",">reference/semaphore.html#(def._((quote._~23~25kernel)._call-with-semaphore))",[0,[1,"call-with-semaphore"]],["scheme/base","scheme"]],
["call-with-semaphore/enable-break",">reference/semaphore.html#(def._((quote._~23~25kernel)._call-with-semaphore/enable-break))",[0,[1,"call-with-semaphore/enable-break"]],["scheme/base","scheme"]],
["call-with-string-output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_728",[0,[1,"call-with-string-output-port"]],["rnrs/io/ports-6"]],
["call-with-values",">reference/values.html#(def._((quote._~23~25kernel)._call-with-values))",[0,[1,"call-with-values"]],["scheme/base","scheme"]],
["call-with-values",">r5rs-std/r5rs-Z-H-9.html#%_idx_596",[0,[1,"call-with-values"]],["r5rs"]],
["call-with-values",">r6rs-std/r6rs-Z-H-14.html#node_idx_762",[0,[1,"call-with-values"]],["rnrs/base-6"]],
["call/cc",">reference/cont.html#(def._((quote._~23~25kernel)._call/cc))",[0,[1,"call/cc"]],["scheme/base","scheme"]],
["call/cc",">r6rs-std/r6rs-Z-H-14.html#node_idx_756",[0,[1,"call/cc"]],["rnrs/base-6"]],
["call/ec",">reference/cont.html#(def._((quote._~23~25kernel)._call/ec))",[0,[1,"call/ec"]],["scheme/base","scheme"]],
["call/input-url",">net/url.html#(def._((lib._net/url..ss)._call/input-url))",[0,[1,"call/input-url"]],["net/url"]],
["callbacks for blocked threads",">inside/threads.html#(part._blockednonmainel)","Callbacks for Blocked Threads",false],
["calltrace library",">trace/index.html#(part._.Calltrace_.Library)","Calltrace Library",false],
["calltrace-eval-handler",">trace/index.html#(def._((lib._trace/calltrace-lib..ss)._calltrace-eval-handler))",[0,"calltrace-eval-handler"],["trace/calltrace-lib"]],
["can the server create a pid file?",">web-server/Troubleshooting.html#(part._.Can_the_server_create_a_.P.I.D_file_)","Can the server create a PID file?",false],
["can-append",">gui/snip_.html#(idx._(gentag._246._(lib._scribblings/gui/gui..scrbl)))",[7,"'can-append"],false],
["can-append",">gui/snip_.html#(idx._(gentag._256._(lib._scribblings/gui/gui..scrbl)))",[7,"'can-append"],false],
["can-change-style?",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._can-change-style~3f))",[[0,[1,"can-change-style?"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["can-change-style?",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._can-change-style~3f))",[[0,[1,"can-change-style?"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["can-change-style?",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._can-change-style~3f))",[[0,[1,"can-change-style?"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["can-close-all?",">framework/Group.html#(meth._(((lib._framework/main..ss)._group~3a~25)._can-close-all~3f))",[[0,[1,"can-close-all?"]],[12,[" (method of ",[0,[1,"group:%"]],")"]]],["framework"]],
["can-close?",">gui/top-level-window___.html#(meth._(((lib._mred/main..ss)._top-level-window~3c~25~3e)._can-close~3f))",[[0,[1,"can-close?"]],[12,[" (method of ",[0,[1,"top-level-window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["can-close?",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3atab~3c~25~3e)._can-close~3f))",[[0,[1,"can-close?"]],[12,[" (method of ",[0,[1,"drscheme:unit:tab&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["can-close?",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abasic~3c~25~3e)._can-close~3f))",[[0,[1,"can-close?"]],[12,[" (method of ",[0,[1,"editor:basic&lt;%&gt;"]],")"]]],["framework"]],
["can-close?",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3afile-mixin)._can-close~3f))",[[0,[1,"can-close?"]],[12,[" (method of ",[0,[1,"editor:file-mixin"]],")"]]],["framework"]],
["can-close?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor-mixin)._can-close~3f))",[[0,[1,"can-close?"]],[12,[" (method of ",[0,[1,"frame:editor-mixin"]],")"]]],["framework"]],
["can-close?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aregister-group-mixin)._can-close~3f))",[[0,[1,"can-close?"]],[12,[" (method of ",[0,[1,"frame:register-group-mixin"]],")"]]],["framework"]],
["can-delete?",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._can-delete~3f))",[[0,[1,"can-delete?"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["can-delete?",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._can-delete~3f))",[[0,[1,"can-delete?"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["can-delete?",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._can-delete~3f))",[[0,[1,"can-delete?"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["can-delete?",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._can-delete~3f))",[[0,[1,"can-delete?"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["can-delete?",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3afile-mixin)._can-delete~3f))",[[0,[1,"can-delete?"]],[12,[" (method of ",[0,[1,"text:file-mixin"]],")"]]],["framework"]],
["can-delete?",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports-mixin)._can-delete~3f))",[[0,[1,"can-delete?"]],[12,[" (method of ",[0,[1,"text:ports-mixin"]],")"]]],["framework"]],
["can-do-edit-operation?",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._can-do-edit-operation~3f))",[[0,[1,"can-do-edit-operation?"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["can-do-edit-operation?",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._can-do-edit-operation~3f))",[[0,[1,"can-do-edit-operation?"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["can-do-edit-operation?",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._can-do-edit-operation~3f))",[[0,[1,"can-do-edit-operation?"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["can-do-edit-operation?",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._can-do-edit-operation~3f))",[[0,[1,"can-do-edit-operation?"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["can-do-edit-operation?",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._can-do-edit-operation~3f))",[[0,[1,"can-do-edit-operation?"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["can-exit?",">gui/top-level-window___.html#(meth._(((lib._mred/main..ss)._top-level-window~3c~25~3e)._can-exit~3f))",[[0,[1,"can-exit?"]],[12,[" (method of ",[0,[1,"top-level-window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["can-exit?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3abasic-mixin)._can-exit~3f))",[[0,[1,"can-exit?"]],[12,[" (method of ",[0,[1,"frame:basic-mixin"]],")"]]],["framework"]],
["can-get-page-setup-from-user?",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._can-get-page-setup-from-user~3f))",[0,[1,"can-get-page-setup-from-user?"]],["scheme/gui/base","scheme/gui"]],
["can-insert?",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._can-insert~3f))",[[0,[1,"can-insert?"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["can-insert?",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._can-insert~3f))",[[0,[1,"can-insert?"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["can-insert?",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._can-insert~3f))",[[0,[1,"can-insert?"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["can-insert?",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._can-insert~3f))",[[0,[1,"can-insert?"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["can-insert?",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3afile-mixin)._can-insert~3f))",[[0,[1,"can-insert?"]],[12,[" (method of ",[0,[1,"text:file-mixin"]],")"]]],["framework"]],
["can-insert?",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports-mixin)._can-insert~3f))",[[0,[1,"can-insert?"]],[12,[" (method of ",[0,[1,"text:ports-mixin"]],")"]]],["framework"]],
["can-interactive-move?",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._can-interactive-move~3f))",[[0,[1,"can-interactive-move?"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["can-interactive-resize?",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._can-interactive-resize~3f))",[[0,[1,"can-interactive-resize?"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["can-load-file?",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._can-load-file~3f))",[[0,[1,"can-load-file?"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["can-load-file?",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._can-load-file~3f))",[[0,[1,"can-load-file?"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["can-load-file?",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._can-load-file~3f))",[[0,[1,"can-load-file?"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["can-move-to?",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._can-move-to~3f))",[[0,[1,"can-move-to?"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["can-parse-post?",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-2..ss)._can-parse-post~3f))",[0,"can-parse-post?"],[]],
["can-reorder?",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._can-reorder~3f))",[[0,[1,"can-reorder?"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["can-resize?",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._can-resize~3f))",[[0,[1,"can-resize?"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["can-save-file?",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._can-save-file~3f))",[[0,[1,"can-save-file?"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["can-save-file?",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abasic-mixin)._can-save-file~3f))",[[0,[1,"can-save-file?"]],[12,[" (method of ",[0,[1,"editor:basic-mixin"]],")"]]],["framework"]],
["can-save-file?",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._can-save-file~3f))",[[0,[1,"can-save-file?"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["can-save-file?",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._can-save-file~3f))",[[0,[1,"can-save-file?"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["can-select?",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._can-select~3f))",[[0,[1,"can-select?"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["can-set-size-constraint?",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._can-set-size-constraint~3f))",[[0,[1,"can-set-size-constraint?"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["can-set-size-constraint?",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._can-set-size-constraint~3f))",[[0,[1,"can-set-size-constraint?"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["can-set-size-constraint?",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._can-set-size-constraint~3f))",[[0,[1,"can-set-size-constraint?"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["can-update",">reference/file-ports.html#(idx._(gentag._113._(lib._scribblings/reference/reference..scrbl)))",[7,"'can-update"],false],
["cancel",">gui/key-event_.html#(idx._(gentag._47._(lib._scribblings/gui/gui..scrbl)))",[7,"'cancel"],false],
["cancel-timer!",">web-server/timer_ss.html#(def._((lib._web-server/private/timer..ss)._cancel-timer!))",[0,[1,"cancel-timer!"]],["web-server/private/timer"]],
["cannot-connect",">net/pop3.html#(def._((lib._net/pop3..ss)._cannot-connect))",[0,[1,"cannot-connect"]],["net/pop3"]],
["cannot-connect?",">net/pop3.html#(def._((lib._net/pop3..ss)._cannot-connect~3f))",[0,[1,"cannot-connect?"]],["net/pop3"]],
["cannot-delete-message",">net/pop3.html#(def._((lib._net/pop3..ss)._cannot-delete-message))",[0,[1,"cannot-delete-message"]],["net/pop3"]],
["cannot-delete-message-communicator",">net/pop3.html#(def._((lib._net/pop3..ss)._cannot-delete-message-communicator))",[0,[1,"cannot-delete-message-communicator"]],["net/pop3"]],
["cannot-delete-message-message",">net/pop3.html#(def._((lib._net/pop3..ss)._cannot-delete-message-message))",[0,[1,"cannot-delete-message-message"]],["net/pop3"]],
["cannot-delete-message?",">net/pop3.html#(def._((lib._net/pop3..ss)._cannot-delete-message~3f))",[0,[1,"cannot-delete-message?"]],["net/pop3"]],
["canvas",">framework/Canvas.html","Canvas",false],
["canvas",">teachpack/Jdraw.html#(part._canvas)","Canvas",false],
["canvas",">gui/windowing-overview.html#(tech._canva)","<i>canvas</i>",false],
["canvas%",">gui/canvas_.html",[0,[1,"canvas%"]],["scheme/gui/base","scheme/gui"]],
["canvas:basic%",">framework/Canvas.html#(def._((lib._framework/main..ss)._canvas~3abasic~25))",[0,[1,"canvas:basic%"]],["framework"]],
["canvas:basic-mixin",">framework/Canvas.html#(def._((lib._framework/main..ss)._canvas~3abasic-mixin))",[0,[1,"canvas:basic-mixin"]],["framework"]],
["canvas:basic<%>",">framework/Canvas.html#(def._((lib._framework/main..ss)._canvas~3abasic~3c~25~3e))",[0,[1,"canvas:basic&lt;%&gt;"]],["framework"]],
["canvas:color%",">framework/Canvas.html#(def._((lib._framework/main..ss)._canvas~3acolor~25))",[0,[1,"canvas:color%"]],["framework"]],
["canvas:color-mixin",">framework/Canvas.html#(def._((lib._framework/main..ss)._canvas~3acolor-mixin))",[0,[1,"canvas:color-mixin"]],["framework"]],
["canvas:color<%>",">framework/Canvas.html#(def._((lib._framework/main..ss)._canvas~3acolor~3c~25~3e))",[0,[1,"canvas:color&lt;%&gt;"]],["framework"]],
["canvas:delegate%",">framework/Canvas.html#(def._((lib._framework/main..ss)._canvas~3adelegate~25))",[0,[1,"canvas:delegate%"]],["framework"]],
["canvas:delegate-mixin",">framework/Canvas.html#(def._((lib._framework/main..ss)._canvas~3adelegate-mixin))",[0,[1,"canvas:delegate-mixin"]],["framework"]],
["canvas:delegate<%>",">framework/Canvas.html#(def._((lib._framework/main..ss)._canvas~3adelegate~3c~25~3e))",[0,[1,"canvas:delegate&lt;%&gt;"]],["framework"]],
["canvas:info%",">framework/Canvas.html#(def._((lib._framework/main..ss)._canvas~3ainfo~25))",[0,[1,"canvas:info%"]],["framework"]],
["canvas:info-mixin",">framework/Canvas.html#(def._((lib._framework/main..ss)._canvas~3ainfo-mixin))",[0,[1,"canvas:info-mixin"]],["framework"]],
["canvas:info<%>",">framework/Canvas.html#(def._((lib._framework/main..ss)._canvas~3ainfo~3c~25~3e))",[0,[1,"canvas:info&lt;%&gt;"]],["framework"]],
["canvas:wide-snip%",">framework/Canvas.html#(def._((lib._framework/main..ss)._canvas~3awide-snip~25))",[0,[1,"canvas:wide-snip%"]],["framework"]],
["canvas:wide-snip-mixin",">framework/Canvas.html#(def._((lib._framework/main..ss)._canvas~3awide-snip-mixin))",[0,[1,"canvas:wide-snip-mixin"]],["framework"]],
["canvas:wide-snip<%>",">framework/Canvas.html#(def._((lib._framework/main..ss)._canvas~3awide-snip~3c~25~3e))",[0,[1,"canvas:wide-snip&lt;%&gt;"]],["framework"]],
["canvas<%>",">gui/canvas___.html",[0,[1,"canvas&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["capability-value",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e)._capability-value))",[[0,[1,"capability-value"]],[12,[" (method of ",[0,[1,"drscheme:language:language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["capital",">gui/key-event_.html#(idx._(gentag._53._(lib._scribblings/gui/gui..scrbl)))",[7,"'capital"],false],
["capitalize-word",">framework/Keymap.html#(idx._(gentag._23._(lib._scribblings/framework/framework..scrbl)))","capitalize-word",false],
["caption",">html/index.html#(def._((lib._html/main..ss)._caption))",[0,[1,"caption"]],["html"]],
["caption?",">html/index.html#(def._((lib._html/main..ss)._caption~3f))",[0,[1,"caption?"]],["html"]],
["car",">reference/pairs.html#(def._((quote._~23~25kernel)._car))",[0,[1,"car"]],["scheme/base","scheme"]],
["car",">r5rs-std/r5rs-Z-H-9.html#%_idx_410",[0,[1,"car"]],["r5rs"]],
["car",">r6rs-std/r6rs-Z-H-14.html#node_idx_612",[0,[1,"car"]],["rnrs/base-6"]],
["car",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._car))",[0,[1,"car"]],["lang/htdp-advanced"]],
["car",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._car))",[0,[1,"car"]],["lang/htdp-beginner"]],
["car",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._car))",[0,[1,"car"]],["lang/htdp-beginner-abbr"]],
["car",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._car))",[0,[1,"car"]],["lang/htdp-intermediate"]],
["car",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._car))",[0,[1,"car"]],["lang/htdp-intermediate-lambda"]],
["car",">srfi-std/srfi-1.html#car",[0,[1,"car"]],["srfi/1"]],
["car+cdr",">srfi-std/srfi-1.html#car+cdr",[0,[1,"car+cdr"]],["srfi/1"]],
["card",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..ss)._card))",[0,[1,"card"]],["mzlib/integer-set"]],
["card methods",">cards/index.html#(part._.Card_.Methods)","Card Methods",false],
["card-face-down",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._card-face-down))",[[0,[1,"card-face-down"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["card-face-up",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._card-face-up))",[[0,[1,"card-face-up"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["card-height",">cards/index.html#(meth._(((lib._games/cards..ss)._card~3c~25~3e)._card-height))",[[0,[1,"card-height"]],[12,[" (method of ",[0,[1,"card&lt;%&gt;"]],")"]]],["games/cards"]],
["card-location",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._card-location))",[[0,[1,"card-location"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["card-to-back",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._card-to-back))",[[0,[1,"card-to-back"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["card-to-front",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._card-to-front))",[[0,[1,"card-to-front"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["card-width",">cards/index.html#(meth._(((lib._games/cards..ss)._card~3c~25~3e)._card-width))",[[0,[1,"card-width"]],[12,[" (method of ",[0,[1,"card&lt;%&gt;"]],")"]]],["games/cards"]],
["card<%>",">cards/index.html#(def._((lib._games/cards..ss)._card~3c~25~3e))",[0,[1,"card&lt;%&gt;"]],["games/cards"]],
["cards-face-down",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._cards-face-down))",[[0,[1,"cards-face-down"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["cards-face-up",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._cards-face-up))",[[0,[1,"cards-face-up"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["cards: virtual playing cards library",">cards/index.html","<b>Cards</b>: Virtual Playing Cards Library",false],
["caret",">gui/editor-wordbreak-map_.html#(idx._(gentag._239._(lib._scribblings/gui/gui..scrbl)))",[7,"'caret"],false],
["caret",">gui/editor-overview.html#(tech._caret)","<i>caret</i>",false],
["caret ownership",">gui/editor-overview.html#(part._drawcaretinfo)","Caret Ownership",false],
["caret-hidden?",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._caret-hidden~3f))",[[0,[1,"caret-hidden?"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["case",">htdp-langs/case.html",[0,[6,"case"]],false],
["case",">reference/case.html#(form._((lib._scheme/private/more-scheme..ss)._case))",[0,[6,"case"]],["scheme/base","scheme"]],
["case",">r5rs-std/r5rs-Z-H-7.html#%_idx_116",[0,[6,"case"]],["r5rs"]],
["case",">r6rs-std/r6rs-Z-H-14.html#node_idx_384",[0,[1,"case"]],["rnrs/base-6"]],
["case",">htdp-langs/case.html#(form._((lib._lang/htdp-advanced..ss)._case))",[0,[6,"case"]],["lang/htdp-advanced"]],
["case",">lazy/index.html#(form._((lib._lazy/main..ss)._case))",[0,[6,"case"]],["lazy"]],
["case",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..ss)._case))",[0,[6,"case"]],["mzscheme"]],
["case->",">reference/Function_Contracts.html#(form._((lib._scheme/contract..ss)._case-~3e))",[0,[6,"case-&gt;"]],["scheme/contract","scheme"]],
["case-insensitive",">reference/reader.html#(idx._(gentag._126._(lib._scribblings/reference/reference..scrbl)))","case-insensitive",false],
["case-lambda",">reference/lambda.html#(form._((quote._~23~25kernel)._case-lambda))",[0,[6,"case-lambda"]],["scheme/base","scheme"]],
["case-lambda",">r6rs-lib-std/r6rs-lib-Z-H-6.html#node_idx_262",[0,[6,"case-lambda"]],["rnrs/control-6"]],
["case-lambda",">srfi-std/srfi-16.html#case-lambda",[0,[6,"case-lambda"]],["srfi/16"]],
["case-lambda",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._case-lambda))",[0,[6,"case-lambda"]],["typed-scheme"]],
["case-lambda:",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._case-lambda~3a))",[0,[6,"case-lambda:"]],["typed-scheme"]],
["case-sensitivity",">reference/reader.html#(idx._(gentag._125._(lib._scribblings/reference/reference..scrbl)))","case-sensitivity",false],
["cases",">eopl/index.html#(form._((lib._eopl/eopl..ss)._cases))",[0,[6,"cases"]],["eopl/eopl"]],
["caution",">gui/message_.html#(idx._(gentag._122._(lib._scribblings/gui/gui..scrbl)))",[7,"'caution"],false],
["cb-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..ss)._cb-find))",[0,[1,"cb-find"]],["slideshow/pict","slideshow"]],
["cb-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..ss)._cb-superimpose))",[0,[1,"cb-superimpose"]],["slideshow/pict","slideshow"]],
["cbl-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..ss)._cbl-find))",[0,[1,"cbl-find"]],["slideshow/pict","slideshow"]],
["cbl-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..ss)._cbl-superimpose))",[0,[1,"cbl-superimpose"]],["slideshow/pict","slideshow"]],
["cblock->list",">foreign/Miscellaneous_Support.html#(def._((lib._scribblings/foreign/unsafe-foreign..ss)._cblock-~3elist))",[0,[1,"cblock-&gt;list"]],["scribblings/foreign/unsafe-foreign"]],
["cblock->vector",">foreign/Miscellaneous_Support.html#(def._((lib._scribblings/foreign/unsafe-foreign..ss)._cblock-~3evector))",[0,[1,"cblock-&gt;vector"]],["scribblings/foreign/unsafe-foreign"]],
["cc",">reference/characters.html#(idx._(gentag._61._(lib._scribblings/reference/reference..scrbl)))",[7,"'cc"],false],
["cc-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..ss)._cc-find))",[0,[1,"cc-find"]],["slideshow/pict","slideshow"]],
["cc-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..ss)._cc-superimpose))",[0,[1,"cc-superimpose"]],["slideshow/pict","slideshow"]],
["cci/coclass",">mysterx/methprop.html#(def._((lib._mysterx/main..ss)._cci/coclass))",[0,[1,"cci/coclass"]],["mysterx"]],
["cci/progid",">mysterx/methprop.html#(def._((lib._mysterx/main..ss)._cci/progid))",[0,[1,"cci/progid"]],["mysterx"]],
["cd",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..ss)._cd))",[0,[1,"cd"]],["preprocessor/mzpp"]],
["cd",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..ss)._cd))",[0,[1,"cd"]],["preprocessor/mztext"]],
["cdaaar",">reference/pairs.html#(def._((quote._~23~25kernel)._cdaaar))",[0,[1,"cdaaar"]],["scheme/base","scheme"]],
["cdaaar",">lazy/index.html#(def._((lib._lazy/main..ss)._cdaaar))",[0,[1,"cdaaar"]],["lazy"]],
["cdaadr",">reference/pairs.html#(def._((quote._~23~25kernel)._cdaadr))",[0,[1,"cdaadr"]],["scheme/base","scheme"]],
["cdaadr",">lazy/index.html#(def._((lib._lazy/main..ss)._cdaadr))",[0,[1,"cdaadr"]],["lazy"]],
["cdaar",">reference/pairs.html#(def._((quote._~23~25kernel)._cdaar))",[0,[1,"cdaar"]],["scheme/base","scheme"]],
["cdaar",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._cdaar))",[0,[1,"cdaar"]],["lang/htdp-advanced"]],
["cdaar",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._cdaar))",[0,[1,"cdaar"]],["lang/htdp-beginner"]],
["cdaar",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._cdaar))",[0,[1,"cdaar"]],["lang/htdp-beginner-abbr"]],
["cdaar",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._cdaar))",[0,[1,"cdaar"]],["lang/htdp-intermediate"]],
["cdaar",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._cdaar))",[0,[1,"cdaar"]],["lang/htdp-intermediate-lambda"]],
["cdaar",">lazy/index.html#(def._((lib._lazy/main..ss)._cdaar))",[0,[1,"cdaar"]],["lazy"]],
["cdadar",">reference/pairs.html#(def._((quote._~23~25kernel)._cdadar))",[0,[1,"cdadar"]],["scheme/base","scheme"]],
["cdadar",">lazy/index.html#(def._((lib._lazy/main..ss)._cdadar))",[0,[1,"cdadar"]],["lazy"]],
["cdaddr",">reference/pairs.html#(def._((quote._~23~25kernel)._cdaddr))",[0,[1,"cdaddr"]],["scheme/base","scheme"]],
["cdaddr",">lazy/index.html#(def._((lib._lazy/main..ss)._cdaddr))",[0,[1,"cdaddr"]],["lazy"]],
["cdadr",">reference/pairs.html#(def._((quote._~23~25kernel)._cdadr))",[0,[1,"cdadr"]],["scheme/base","scheme"]],
["cdadr",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._cdadr))",[0,[1,"cdadr"]],["lang/htdp-advanced"]],
["cdadr",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._cdadr))",[0,[1,"cdadr"]],["lang/htdp-beginner"]],
["cdadr",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._cdadr))",[0,[1,"cdadr"]],["lang/htdp-beginner-abbr"]],
["cdadr",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._cdadr))",[0,[1,"cdadr"]],["lang/htdp-intermediate"]],
["cdadr",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._cdadr))",[0,[1,"cdadr"]],["lang/htdp-intermediate-lambda"]],
["cdadr",">lazy/index.html#(def._((lib._lazy/main..ss)._cdadr))",[0,[1,"cdadr"]],["lazy"]],
["cdar",">reference/pairs.html#(def._((quote._~23~25kernel)._cdar))",[0,[1,"cdar"]],["scheme/base","scheme"]],
["cdar",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._cdar))",[0,[1,"cdar"]],["lang/htdp-advanced"]],
["cdar",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._cdar))",[0,[1,"cdar"]],["lang/htdp-beginner"]],
["cdar",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._cdar))",[0,[1,"cdar"]],["lang/htdp-beginner-abbr"]],
["cdar",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._cdar))",[0,[1,"cdar"]],["lang/htdp-intermediate"]],
["cdar",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._cdar))",[0,[1,"cdar"]],["lang/htdp-intermediate-lambda"]],
["cdar",">lazy/index.html#(def._((lib._lazy/main..ss)._cdar))",[0,[1,"cdar"]],["lazy"]],
["cdata",">xml/index.html#(def._((lib._xml/main..ss)._cdata))",[0,[1,"cdata"]],["xml"]],
["cdata-string",">xml/index.html#(def._((lib._xml/main..ss)._cdata-string))",[0,[1,"cdata-string"]],["xml"]],
["cdata?",">xml/index.html#(def._((lib._xml/main..ss)._cdata~3f))",[0,[1,"cdata?"]],["xml"]],
["cddaar",">reference/pairs.html#(def._((quote._~23~25kernel)._cddaar))",[0,[1,"cddaar"]],["scheme/base","scheme"]],
["cddaar",">lazy/index.html#(def._((lib._lazy/main..ss)._cddaar))",[0,[1,"cddaar"]],["lazy"]],
["cddadr",">reference/pairs.html#(def._((quote._~23~25kernel)._cddadr))",[0,[1,"cddadr"]],["scheme/base","scheme"]],
["cddadr",">lazy/index.html#(def._((lib._lazy/main..ss)._cddadr))",[0,[1,"cddadr"]],["lazy"]],
["cddadr",">srfi-std/srfi-1.html#cddadr",[0,[1,"cddadr"]],["srfi/1"]],
["cddar",">reference/pairs.html#(def._((quote._~23~25kernel)._cddar))",[0,[1,"cddar"]],["scheme/base","scheme"]],
["cddar",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._cddar))",[0,[1,"cddar"]],["lang/htdp-advanced"]],
["cddar",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._cddar))",[0,[1,"cddar"]],["lang/htdp-beginner"]],
["cddar",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._cddar))",[0,[1,"cddar"]],["lang/htdp-beginner-abbr"]],
["cddar",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._cddar))",[0,[1,"cddar"]],["lang/htdp-intermediate"]],
["cddar",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._cddar))",[0,[1,"cddar"]],["lang/htdp-intermediate-lambda"]],
["cddar",">lazy/index.html#(def._((lib._lazy/main..ss)._cddar))",[0,[1,"cddar"]],["lazy"]],
["cdddar",">reference/pairs.html#(def._((quote._~23~25kernel)._cdddar))",[0,[1,"cdddar"]],["scheme/base","scheme"]],
["cdddar",">r5rs-std/r5rs-Z-H-9.html#%_idx_424",[0,[1,"cdddar"]],["r5rs"]],
["cdddar",">r6rs-std/r6rs-Z-H-14.html#node_idx_620",[0,[1,"cdddar"]],["rnrs/base-6"]],
["cdddar",">lazy/index.html#(def._((lib._lazy/main..ss)._cdddar))",[0,[1,"cdddar"]],["lazy"]],
["cddddr",">reference/pairs.html#(def._((quote._~23~25kernel)._cddddr))",[0,[1,"cddddr"]],["scheme/base","scheme"]],
["cddddr",">r5rs-std/r5rs-Z-H-9.html#%_idx_426",[0,[1,"cddddr"]],["r5rs"]],
["cddddr",">r6rs-std/r6rs-Z-H-14.html#node_idx_622",[0,[1,"cddddr"]],["rnrs/base-6"]],
["cddddr",">lazy/index.html#(def._((lib._lazy/main..ss)._cddddr))",[0,[1,"cddddr"]],["lazy"]],
["cddddr",">srfi-std/srfi-1.html#cddddr",[0,[1,"cddddr"]],["srfi/1"]],
["cdddr",">reference/pairs.html#(def._((quote._~23~25kernel)._cdddr))",[0,[1,"cdddr"]],["scheme/base","scheme"]],
["cdddr",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._cdddr))",[0,[1,"cdddr"]],["lang/htdp-advanced"]],
["cdddr",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._cdddr))",[0,[1,"cdddr"]],["lang/htdp-beginner"]],
["cdddr",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._cdddr))",[0,[1,"cdddr"]],["lang/htdp-beginner-abbr"]],
["cdddr",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._cdddr))",[0,[1,"cdddr"]],["lang/htdp-intermediate"]],
["cdddr",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._cdddr))",[0,[1,"cdddr"]],["lang/htdp-intermediate-lambda"]],
["cdddr",">lazy/index.html#(def._((lib._lazy/main..ss)._cdddr))",[0,[1,"cdddr"]],["lazy"]],
["cddr",">reference/pairs.html#(def._((quote._~23~25kernel)._cddr))",[0,[1,"cddr"]],["scheme/base","scheme"]],
["cddr",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._cddr))",[0,[1,"cddr"]],["lang/htdp-advanced"]],
["cddr",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._cddr))",[0,[1,"cddr"]],["lang/htdp-beginner"]],
["cddr",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._cddr))",[0,[1,"cddr"]],["lang/htdp-beginner-abbr"]],
["cddr",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._cddr))",[0,[1,"cddr"]],["lang/htdp-intermediate"]],
["cddr",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._cddr))",[0,[1,"cddr"]],["lang/htdp-intermediate-lambda"]],
["cddr",">lazy/index.html#(def._((lib._lazy/main..ss)._cddr))",[0,[1,"cddr"]],["lazy"]],
["cdr",">reference/pairs.html#(def._((quote._~23~25kernel)._cdr))",[0,[1,"cdr"]],["scheme/base","scheme"]],
["cdr",">r5rs-std/r5rs-Z-H-9.html#%_idx_414",[0,[1,"cdr"]],["r5rs"]],
["cdr",">r6rs-std/r6rs-Z-H-14.html#node_idx_614",[0,[1,"cdr"]],["rnrs/base-6"]],
["cdr",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._cdr))",[0,[1,"cdr"]],["lang/htdp-advanced"]],
["cdr",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._cdr))",[0,[1,"cdr"]],["lang/htdp-beginner"]],
["cdr",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._cdr))",[0,[1,"cdr"]],["lang/htdp-beginner-abbr"]],
["cdr",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._cdr))",[0,[1,"cdr"]],["lang/htdp-intermediate"]],
["cdr",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._cdr))",[0,[1,"cdr"]],["lang/htdp-intermediate-lambda"]],
["cdr",">srfi-std/srfi-1.html#cdr",[0,[1,"cdr"]],["srfi/1"]],
["ceiling",">reference/numbers.html#(def._((quote._~23~25kernel)._ceiling))",[0,[1,"ceiling"]],["scheme/base","scheme"]],
["ceiling",">r5rs-std/r5rs-Z-H-9.html#%_idx_316",[0,[1,"ceiling"]],["r5rs"]],
["ceiling",">r6rs-std/r6rs-Z-H-14.html#node_idx_530",[0,[1,"ceiling"]],["rnrs/base-6"]],
["ceiling",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._ceiling))",[0,[1,"ceiling"]],["lang/htdp-advanced"]],
["ceiling",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._ceiling))",[0,[1,"ceiling"]],["lang/htdp-beginner"]],
["ceiling",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._ceiling))",[0,[1,"ceiling"]],["lang/htdp-beginner-abbr"]],
["ceiling",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._ceiling))",[0,[1,"ceiling"]],["lang/htdp-intermediate"]],
["ceiling",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._ceiling))",[0,[1,"ceiling"]],["lang/htdp-intermediate-lambda"]],
["cellophane",">slideshow/Pict_Drawing_Adjusters.html#(def._((lib._slideshow/pict..ss)._cellophane))",[0,[1,"cellophane"]],["slideshow/pict","slideshow"]],
["center",">gui/top-level-window___.html#(meth._(((lib._mred/main..ss)._top-level-window~3c~25~3e)._center))",[[0,[1,"center"]],[12,[" (method of ",[0,[1,"top-level-window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["center",">html/index.html#(def._((lib._html/main..ss)._center))",[0,[1,"center"]],["html"]],
["center",">gui/windowing-overview.html#(idx._(gentag._1._(lib._scribblings/gui/gui..scrbl)))",[7,"'center"],false],
["center",">gui/style-delta_.html#(idx._(gentag._261._(lib._scribblings/gui/gui..scrbl)))",[7,"'center"],false],
["center-view-on-line",">framework/Keymap.html#(idx._(gentag._16._(lib._scribblings/framework/framework..scrbl)))","center-view-on-line",false],
["center?",">html/index.html#(def._((lib._html/main..ss)._center~3f))",[0,[1,"center?"]],["html"]],
["centerline",">scribble/Miscellaneous.html#(def._((lib._scribble/manual..ss)._centerline))",[0,[1,"centerline"]],["scribble/manual"]],
["certificate propagation",">guide/stx-certs.html#(part._stxinactivecerts)","Certificate Propagation",false],
["certify-mode",">reference/stxcerts.html#(idx._(gentag._88._(lib._scribblings/reference/reference..scrbl)))",[7,"'certify-mode"],false],
["cf",">reference/characters.html#(idx._(gentag._62._(lib._scribblings/reference/reference..scrbl)))",[7,"'cf"],false],
["cgc",">inside/overview.html#(idx._(gentag._1._(lib._scribblings/inside/inside..scrbl)))","CGC",false],
["cgc",">guide/performance.html#(tech._cgc)","<i>CGC</i>",false],
["cgc",">reference/runtime.html#(idx._(gentag._300._(lib._scribblings/reference/reference..scrbl)))",[7,"'cgc"],false],
["cgc embedding",">inside/overview.html#(part._.C.G.C_.Embedding)","CGC Embedding",false],
["cgc extensions",">inside/overview.html#(part._.C.G.C_.Extensions)","CGC Extensions",false],
["cgc versus 3m",">inside/overview.html#(part._.C.G.C_versus_3m)","CGC versus 3m",false],
["cgc-suffix",">config/index.html#(def._((lib._config/main..ss)._cgc-suffix))",[0,[1,"cgc-suffix"]],["config"]],
["cgi functions",">net/cgi.html#(part._.C.G.I_.Functions)","CGI Functions",false],
["cgi scripts",">net/cgi.html","CGI Scripts",false],
["cgi signature",">net/cgi.html#(part._.C.G.I_.Signature)","CGI Signature",false],
["cgi unit",">net/cgi.html#(part._.C.G.I_.Unit)","CGI Unit",false],
["cgi-error",">net/cgi.html#(def._((lib._net/cgi..ss)._cgi-error))",[0,[1,"cgi-error"]],["net/cgi"]],
["cgi-error?",">net/cgi.html#(def._((lib._net/cgi..ss)._cgi-error~3f))",[0,[1,"cgi-error?"]],["net/cgi"]],
["cgi@",">net/cgi.html#(def._((lib._net/cgi-unit..ss)._cgi~40))",[0,[1,"cgi@"]],["net/cgi-unit"]],
["cgi^",">net/cgi.html#(form._((lib._net/cgi-sig..ss)._cgi~5e))",[0,[6,"cgi^"]],["net/cgi-sig"]],
["chain-to-keymap",">gui/keymap_.html#(meth._(((lib._mred/main..ss)._keymap~25)._chain-to-keymap))",[[0,[1,"chain-to-keymap"]],[12,[" (method of ",[0,[1,"keymap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["chain-to-keymap",">framework/Keymap.html#(meth._(((lib._framework/main..ss)._keymap~3aaug-keymap-mixin)._chain-to-keymap))",[[0,[1,"chain-to-keymap"]],[12,[" (method of ",[0,[1,"keymap:aug-keymap-mixin"]],")"]]],["framework"]],
["chaining tests: cond",">guide/conditionals.html#(part._cond)",["Chaining Tests: ",[0,[6,"cond"]]],false],
["change-children",">gui/area-container___.html#(meth._(((lib._mred/main..ss)._area-container~3c~25~3e)._change-children))",[[0,[1,"change-children"]],[12,[" (method of ",[0,[1,"area-container&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["change-color",">graphics/Color_Operations.html#(def._((lib._graphics/graphics..ss)._change-color))",[0,[1,"change-color"]],["graphics/graphics"]],
["change-style",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._change-style))",[[0,[1,"change-style"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["change-style",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._change-style))",[[0,[1,"change-style"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["change-style",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._change-style))",[[0,[1,"change-style"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["change-to-file",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._change-to-file))",[[0,[1,"change-to-file"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["changes",">frtime/index.html#(def._((lib._frtime/main..ss)._changes))",[0,[1,"changes"]],["frtime"]],
["changing a parenthesis as you type",">drscheme/editor.html#(idx._(gentag._21._(lib._scribblings/drscheme/drscheme..scrbl)))","changing a parenthesis as you type",false],
["channel",">mzlib/mzlib_cml.html#(def._((lib._mzlib/cml..ss)._channel))",[0,[1,"channel"]],["mzlib/cml"]],
["channel",">reference/channel.html#(tech._channel)","<i>channel</i>",false],
["channel-get",">reference/channel.html#(def._((lib._scheme/private/misc..ss)._channel-get))",[0,[1,"channel-get"]],["scheme/base","scheme"]],
["channel-put",">reference/channel.html#(def._((lib._scheme/private/misc..ss)._channel-put))",[0,[1,"channel-put"]],["scheme/base","scheme"]],
["channel-put-evt",">reference/channel.html#(def._((quote._~23~25kernel)._channel-put-evt))",[0,[1,"channel-put-evt"]],["scheme/base","scheme"]],
["channel-recv-evt",">mzlib/mzlib_cml.html#(def._((lib._mzlib/cml..ss)._channel-recv-evt))",[0,[1,"channel-recv-evt"]],["mzlib/cml"]],
["channel-send-evt",">mzlib/mzlib_cml.html#(def._((lib._mzlib/cml..ss)._channel-send-evt))",[0,[1,"channel-send-evt"]],["mzlib/cml"]],
["channel-try-get",">reference/channel.html#(def._((lib._scheme/private/misc..ss)._channel-try-get))",[0,[1,"channel-try-get"]],["scheme/base","scheme"]],
["channel?",">reference/channel.html#(def._((quote._~23~25kernel)._channel~3f))",[0,[1,"channel?"]],["scheme/base","scheme"]],
["channels",">reference/channel.html","Channels",false],
["char",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._.Char))",[0,[6,"Char"]],["typed-scheme"]],
["char->integer",">reference/characters.html#(def._((quote._~23~25kernel)._char-~3einteger))",[0,[1,"char-&gt;integer"]],["scheme/base","scheme"]],
["char->integer",">r5rs-std/r5rs-Z-H-9.html#%_idx_498",[0,[1,"char-&gt;integer"]],["r5rs"]],
["char->integer",">r6rs-std/r6rs-Z-H-14.html#node_idx_670",[0,[1,"char-&gt;integer"]],["rnrs/base-6"]],
["char->integer",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._char-~3einteger))",[0,[1,"char-&gt;integer"]],["lang/htdp-advanced"]],
["char->integer",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._char-~3einteger))",[0,[1,"char-&gt;integer"]],["lang/htdp-beginner"]],
["char->integer",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._char-~3einteger))",[0,[1,"char-&gt;integer"]],["lang/htdp-beginner-abbr"]],
["char->integer",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._char-~3einteger))",[0,[1,"char-&gt;integer"]],["lang/htdp-intermediate"]],
["char->integer",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._char-~3einteger))",[0,[1,"char-&gt;integer"]],["lang/htdp-intermediate-lambda"]],
["char-alphabetic?",">reference/characters.html#(def._((quote._~23~25kernel)._char-alphabetic~3f))",[0,[1,"char-alphabetic?"]],["scheme/base","scheme"]],
["char-alphabetic?",">r5rs-std/r5rs-Z-H-9.html#%_idx_488",[0,[1,"char-alphabetic?"]],["r5rs"]],
["char-alphabetic?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_22",[0,[1,"char-alphabetic?"]],["rnrs/unicode-6"]],
["char-alphabetic?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._char-alphabetic~3f))",[0,[1,"char-alphabetic?"]],["lang/htdp-advanced"]],
["char-alphabetic?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._char-alphabetic~3f))",[0,[1,"char-alphabetic?"]],["lang/htdp-beginner"]],
["char-alphabetic?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._char-alphabetic~3f))",[0,[1,"char-alphabetic?"]],["lang/htdp-beginner-abbr"]],
["char-alphabetic?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._char-alphabetic~3f))",[0,[1,"char-alphabetic?"]],["lang/htdp-intermediate"]],
["char-alphabetic?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._char-alphabetic~3f))",[0,[1,"char-alphabetic?"]],["lang/htdp-intermediate-lambda"]],
["char-blank?",">reference/characters.html#(def._((quote._~23~25kernel)._char-blank~3f))",[0,[1,"char-blank?"]],["scheme/base","scheme"]],
["char-ci<=?",">reference/characters.html#(def._((quote._~23~25kernel)._char-ci~3c~3d~3f))",[0,[1,"char-ci&lt;=?"]],["scheme/base","scheme"]],
["char-ci<=?",">r5rs-std/r5rs-Z-H-9.html#%_idx_484",[0,[1,"char-ci&lt;=?"]],["r5rs"]],
["char-ci<=?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_18",[0,[1,"char-ci&lt;=?"]],["rnrs/unicode-6"]],
["char-ci<=?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._char-ci~3c~3d~3f))",[0,[1,"char-ci&lt;=?"]],["lang/htdp-advanced"]],
["char-ci<=?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._char-ci~3c~3d~3f))",[0,[1,"char-ci&lt;=?"]],["lang/htdp-beginner"]],
["char-ci<=?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._char-ci~3c~3d~3f))",[0,[1,"char-ci&lt;=?"]],["lang/htdp-beginner-abbr"]],
["char-ci<=?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._char-ci~3c~3d~3f))",[0,[1,"char-ci&lt;=?"]],["lang/htdp-intermediate"]],
["char-ci<=?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._char-ci~3c~3d~3f))",[0,[1,"char-ci&lt;=?"]],["lang/htdp-intermediate-lambda"]],
["char-ci<?",">reference/characters.html#(def._((quote._~23~25kernel)._char-ci~3c~3f))",[0,[1,"char-ci&lt;?"]],["scheme/base","scheme"]],
["char-ci<?",">r5rs-std/r5rs-Z-H-9.html#%_idx_480",[0,[1,"char-ci&lt;?"]],["r5rs"]],
["char-ci<?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_14",[0,[1,"char-ci&lt;?"]],["rnrs/unicode-6"]],
["char-ci<?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._char-ci~3c~3f))",[0,[1,"char-ci&lt;?"]],["lang/htdp-advanced"]],
["char-ci<?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._char-ci~3c~3f))",[0,[1,"char-ci&lt;?"]],["lang/htdp-beginner"]],
["char-ci<?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._char-ci~3c~3f))",[0,[1,"char-ci&lt;?"]],["lang/htdp-beginner-abbr"]],
["char-ci<?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._char-ci~3c~3f))",[0,[1,"char-ci&lt;?"]],["lang/htdp-intermediate"]],
["char-ci<?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._char-ci~3c~3f))",[0,[1,"char-ci&lt;?"]],["lang/htdp-intermediate-lambda"]],
["char-ci=?",">reference/characters.html#(def._((quote._~23~25kernel)._char-ci~3d~3f))",[0,[1,"char-ci=?"]],["scheme/base","scheme"]],
["char-ci=?",">r5rs-std/r5rs-Z-H-9.html#%_idx_478",[0,[1,"char-ci=?"]],["r5rs"]],
["char-ci=?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_12",[0,[1,"char-ci=?"]],["rnrs/unicode-6"]],
["char-ci=?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._char-ci~3d~3f))",[0,[1,"char-ci=?"]],["lang/htdp-advanced"]],
["char-ci=?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._char-ci~3d~3f))",[0,[1,"char-ci=?"]],["lang/htdp-beginner"]],
["char-ci=?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._char-ci~3d~3f))",[0,[1,"char-ci=?"]],["lang/htdp-beginner-abbr"]],
["char-ci=?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._char-ci~3d~3f))",[0,[1,"char-ci=?"]],["lang/htdp-intermediate"]],
["char-ci=?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._char-ci~3d~3f))",[0,[1,"char-ci=?"]],["lang/htdp-intermediate-lambda"]],
["char-ci>=?",">reference/characters.html#(def._((quote._~23~25kernel)._char-ci~3e~3d~3f))",[0,[1,"char-ci&gt;=?"]],["scheme/base","scheme"]],
["char-ci>=?",">r5rs-std/r5rs-Z-H-9.html#%_idx_486",[0,[1,"char-ci&gt;=?"]],["r5rs"]],
["char-ci>=?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_20",[0,[1,"char-ci&gt;=?"]],["rnrs/unicode-6"]],
["char-ci>=?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._char-ci~3e~3d~3f))",[0,[1,"char-ci&gt;=?"]],["lang/htdp-advanced"]],
["char-ci>=?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._char-ci~3e~3d~3f))",[0,[1,"char-ci&gt;=?"]],["lang/htdp-beginner"]],
["char-ci>=?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._char-ci~3e~3d~3f))",[0,[1,"char-ci&gt;=?"]],["lang/htdp-beginner-abbr"]],
["char-ci>=?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._char-ci~3e~3d~3f))",[0,[1,"char-ci&gt;=?"]],["lang/htdp-intermediate"]],
["char-ci>=?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._char-ci~3e~3d~3f))",[0,[1,"char-ci&gt;=?"]],["lang/htdp-intermediate-lambda"]],
["char-ci>?",">reference/characters.html#(def._((quote._~23~25kernel)._char-ci~3e~3f))",[0,[1,"char-ci&gt;?"]],["scheme/base","scheme"]],
["char-ci>?",">r5rs-std/r5rs-Z-H-9.html#%_idx_482",[0,[1,"char-ci&gt;?"]],["r5rs"]],
["char-ci>?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_16",[0,[1,"char-ci&gt;?"]],["rnrs/unicode-6"]],
["char-ci>?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._char-ci~3e~3f))",[0,[1,"char-ci&gt;?"]],["lang/htdp-advanced"]],
["char-ci>?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._char-ci~3e~3f))",[0,[1,"char-ci&gt;?"]],["lang/htdp-beginner"]],
["char-ci>?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._char-ci~3e~3f))",[0,[1,"char-ci&gt;?"]],["lang/htdp-beginner-abbr"]],
["char-ci>?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._char-ci~3e~3f))",[0,[1,"char-ci&gt;?"]],["lang/htdp-intermediate"]],
["char-ci>?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._char-ci~3e~3f))",[0,[1,"char-ci&gt;?"]],["lang/htdp-intermediate-lambda"]],
["char-downcase",">reference/characters.html#(def._((quote._~23~25kernel)._char-downcase))",[0,[1,"char-downcase"]],["scheme/base","scheme"]],
["char-downcase",">r5rs-std/r5rs-Z-H-9.html#%_idx_504",[0,[1,"char-downcase"]],["r5rs"]],
["char-downcase",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_6",[0,[1,"char-downcase"]],["rnrs/unicode-6"]],
["char-downcase",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._char-downcase))",[0,[1,"char-downcase"]],["lang/htdp-advanced"]],
["char-downcase",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._char-downcase))",[0,[1,"char-downcase"]],["lang/htdp-beginner"]],
["char-downcase",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._char-downcase))",[0,[1,"char-downcase"]],["lang/htdp-beginner-abbr"]],
["char-downcase",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._char-downcase))",[0,[1,"char-downcase"]],["lang/htdp-intermediate"]],
["char-downcase",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._char-downcase))",[0,[1,"char-downcase"]],["lang/htdp-intermediate-lambda"]],
["char-foldcase",">reference/characters.html#(def._((quote._~23~25kernel)._char-foldcase))",[0,[1,"char-foldcase"]],["scheme/base","scheme"]],
["char-foldcase",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_10",[0,[1,"char-foldcase"]],["rnrs/unicode-6"]],
["char-general-category",">reference/characters.html#(def._((quote._~23~25kernel)._char-general-category))",[0,[1,"char-general-category"]],["scheme/base","scheme"]],
["char-general-category",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_34",[0,[1,"char-general-category"]],["rnrs/unicode-6"]],
["char-graphic?",">reference/characters.html#(def._((quote._~23~25kernel)._char-graphic~3f))",[0,[1,"char-graphic?"]],["scheme/base","scheme"]],
["char-iso-control?",">reference/characters.html#(def._((quote._~23~25kernel)._char-iso-control~3f))",[0,[1,"char-iso-control?"]],["scheme/base","scheme"]],
["char-lower-case?",">reference/characters.html#(def._((quote._~23~25kernel)._char-lower-case~3f))",[0,[1,"char-lower-case?"]],["scheme/base","scheme"]],
["char-lower-case?",">r5rs-std/r5rs-Z-H-9.html#%_idx_496",[0,[1,"char-lower-case?"]],["r5rs"]],
["char-lower-case?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_30",[0,[1,"char-lower-case?"]],["rnrs/unicode-6"]],
["char-lower-case?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._char-lower-case~3f))",[0,[1,"char-lower-case?"]],["lang/htdp-advanced"]],
["char-lower-case?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._char-lower-case~3f))",[0,[1,"char-lower-case?"]],["lang/htdp-beginner"]],
["char-lower-case?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._char-lower-case~3f))",[0,[1,"char-lower-case?"]],["lang/htdp-beginner-abbr"]],
["char-lower-case?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._char-lower-case~3f))",[0,[1,"char-lower-case?"]],["lang/htdp-intermediate"]],
["char-lower-case?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._char-lower-case~3f))",[0,[1,"char-lower-case?"]],["lang/htdp-intermediate-lambda"]],
["char-numeric?",">reference/characters.html#(def._((quote._~23~25kernel)._char-numeric~3f))",[0,[1,"char-numeric?"]],["scheme/base","scheme"]],
["char-numeric?",">r5rs-std/r5rs-Z-H-9.html#%_idx_490",[0,[1,"char-numeric?"]],["r5rs"]],
["char-numeric?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_24",[0,[1,"char-numeric?"]],["rnrs/unicode-6"]],
["char-numeric?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._char-numeric~3f))",[0,[1,"char-numeric?"]],["lang/htdp-advanced"]],
["char-numeric?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._char-numeric~3f))",[0,[1,"char-numeric?"]],["lang/htdp-beginner"]],
["char-numeric?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._char-numeric~3f))",[0,[1,"char-numeric?"]],["lang/htdp-beginner-abbr"]],
["char-numeric?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._char-numeric~3f))",[0,[1,"char-numeric?"]],["lang/htdp-intermediate"]],
["char-numeric?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._char-numeric~3f))",[0,[1,"char-numeric?"]],["lang/htdp-intermediate-lambda"]],
["char-punctuation?",">reference/characters.html#(def._((quote._~23~25kernel)._char-punctuation~3f))",[0,[1,"char-punctuation?"]],["scheme/base","scheme"]],
["char-ready?",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._char-ready~3f))",[0,[1,"char-ready?"]],["scheme/base","scheme"]],
["char-ready?",">r5rs-std/r5rs-Z-H-9.html#%_idx_650",[0,[1,"char-ready?"]],["r5rs"]],
["char-set",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..ss)._char-set))",[0,[6,"char-set"]],["parser-tools/lex"]],
["char-set",">srfi-std/srfi-14.html#char-set",[0,[1,"char-set"]],["srfi/14"]],
["char-set->list",">srfi-std/srfi-14.html#char-set->list",[0,[1,"char-set-&gt;list"]],["srfi/14"]],
["char-set->string",">srfi-std/srfi-14.html#char-set->string",[0,[1,"char-set-&gt;string"]],["srfi/14"]],
["char-set-adjoin",">srfi-std/srfi-14.html#char-set-adjoin",[0,[1,"char-set-adjoin"]],["srfi/14"]],
["char-set-adjoin!",">srfi-std/srfi-14.html#char-set-adjoin!",[0,[1,"char-set-adjoin!"]],["srfi/14"]],
["char-set-any",">srfi-std/srfi-14.html#char-set-any",[0,[1,"char-set-any"]],["srfi/14"]],
["char-set-complement",">srfi-std/srfi-14.html#char-set-complement",[0,[1,"char-set-complement"]],["srfi/14"]],
["char-set-complement!",">srfi-std/srfi-14.html#char-set-complement!",[0,[1,"char-set-complement!"]],["srfi/14"]],
["char-set-contains?",">srfi-std/srfi-14.html#char-set-contains-p",[0,[1,"char-set-contains?"]],["srfi/14"]],
["char-set-copy",">srfi-std/srfi-14.html#char-set-copy",[0,[1,"char-set-copy"]],["srfi/14"]],
["char-set-count",">srfi-std/srfi-14.html#char-set-count",[0,[1,"char-set-count"]],["srfi/14"]],
["char-set-cursor",">srfi-std/srfi-14.html#char-set-cursor",[0,[1,"char-set-cursor"]],["srfi/14"]],
["char-set-cursor-next",">srfi-std/srfi-14.html#char-set-cursor-next",[0,[1,"char-set-cursor-next"]],["srfi/14"]],
["char-set-delete",">srfi-std/srfi-14.html#char-set-delete",[0,[1,"char-set-delete"]],["srfi/14"]],
["char-set-delete!",">srfi-std/srfi-14.html#char-set-delete!",[0,[1,"char-set-delete!"]],["srfi/14"]],
["char-set-diff+intersection",">srfi-std/srfi-14.html#char-set-diff+intersection",[0,[1,"char-set-diff+intersection"]],["srfi/14"]],
["char-set-diff+intersection!",">srfi-std/srfi-14.html#char-set-diff+intersection!",[0,[1,"char-set-diff+intersection!"]],["srfi/14"]],
["char-set-difference",">srfi-std/srfi-14.html#char-set-difference",[0,[1,"char-set-difference"]],["srfi/14"]],
["char-set-difference!",">srfi-std/srfi-14.html#char-set-difference!",[0,[1,"char-set-difference!"]],["srfi/14"]],
["char-set-every",">srfi-std/srfi-14.html#char-set-every",[0,[1,"char-set-every"]],["srfi/14"]],
["char-set-filter",">srfi-std/srfi-14.html#char-set-filter",[0,[1,"char-set-filter"]],["srfi/14"]],
["char-set-filter!",">srfi-std/srfi-14.html#char-set-filter!",[0,[1,"char-set-filter!"]],["srfi/14"]],
["char-set-fold",">srfi-std/srfi-14.html#char-set-fold",[0,[1,"char-set-fold"]],["srfi/14"]],
["char-set-for-each",">srfi-std/srfi-14.html#char-set-for-each",[0,[1,"char-set-for-each"]],["srfi/14"]],
["char-set-hash",">srfi-std/srfi-14.html#char-set-hash",[0,[1,"char-set-hash"]],["srfi/14"]],
["char-set-intersection",">srfi-std/srfi-14.html#char-set-intersection",[0,[1,"char-set-intersection"]],["srfi/14"]],
["char-set-intersection!",">srfi-std/srfi-14.html#char-set-intersection!",[0,[1,"char-set-intersection!"]],["srfi/14"]],
["char-set-map",">srfi-std/srfi-14.html#char-set-map",[0,[1,"char-set-map"]],["srfi/14"]],
["char-set-ref",">srfi-std/srfi-14.html#char-set-ref",[0,[1,"char-set-ref"]],["srfi/14"]],
["char-set-size",">srfi-std/srfi-14.html#char-set-size",[0,[1,"char-set-size"]],["srfi/14"]],
["char-set-unfold",">srfi-std/srfi-14.html#char-set-unfold",[0,[1,"char-set-unfold"]],["srfi/14"]],
["char-set-unfold!",">srfi-std/srfi-14.html#char-set-unfold!",[0,[1,"char-set-unfold!"]],["srfi/14"]],
["char-set-union",">srfi-std/srfi-14.html#char-set-union",[0,[1,"char-set-union"]],["srfi/14"]],
["char-set-union!",">srfi-std/srfi-14.html#char-set-union!",[0,[1,"char-set-union!"]],["srfi/14"]],
["char-set-xor",">srfi-std/srfi-14.html#char-set-xor",[0,[1,"char-set-xor"]],["srfi/14"]],
["char-set-xor!",">srfi-std/srfi-14.html#char-set-xor!",[0,[1,"char-set-xor!"]],["srfi/14"]],
["char-set:ascii",">srfi-std/srfi-14.html#char-set:ascii",[0,[1,"char-set:ascii"]],["srfi/14"]],
["char-set:blank",">srfi-std/srfi-14.html#char-set:blank",[0,[1,"char-set:blank"]],["srfi/14"]],
["char-set:digit",">srfi-std/srfi-14.html#char-set:digit",[0,[1,"char-set:digit"]],["srfi/14"]],
["char-set:empty",">srfi-std/srfi-14.html#char-set:empty",[0,[1,"char-set:empty"]],["srfi/14"]],
["char-set:full",">srfi-std/srfi-14.html#char-set:full",[0,[1,"char-set:full"]],["srfi/14"]],
["char-set:graphic",">srfi-std/srfi-14.html#char-set:graphic",[0,[1,"char-set:graphic"]],["srfi/14"]],
["char-set:hex-digit",">srfi-std/srfi-14.html#char-set:hex-digit",[0,[1,"char-set:hex-digit"]],["srfi/14"]],
["char-set:iso-control",">srfi-std/srfi-14.html#char-set:iso-control",[0,[1,"char-set:iso-control"]],["srfi/14"]],
["char-set:letter",">srfi-std/srfi-14.html#char-set:letter",[0,[1,"char-set:letter"]],["srfi/14"]],
["char-set:letter+digit",">srfi-std/srfi-14.html#char-set:letter+digit",[0,[1,"char-set:letter+digit"]],["srfi/14"]],
["char-set:lower-case",">srfi-std/srfi-14.html#char-set:lower-case",[0,[1,"char-set:lower-case"]],["srfi/14"]],
["char-set:printing",">srfi-std/srfi-14.html#char-set:printing",[0,[1,"char-set:printing"]],["srfi/14"]],
["char-set:punctuation",">srfi-std/srfi-14.html#char-set:punctuation",[0,[1,"char-set:punctuation"]],["srfi/14"]],
["char-set:symbol",">srfi-std/srfi-14.html#char-set:symbol",[0,[1,"char-set:symbol"]],["srfi/14"]],
["char-set:title-case",">srfi-std/srfi-14.html#char-set:title-case",[0,[1,"char-set:title-case"]],["srfi/14"]],
["char-set:upper-case",">srfi-std/srfi-14.html#char-set:upper-case",[0,[1,"char-set:upper-case"]],["srfi/14"]],
["char-set:whitespace",">srfi-std/srfi-14.html#char-set:whitespace",[0,[1,"char-set:whitespace"]],["srfi/14"]],
["char-set<=",">srfi-std/srfi-14.html#char-set<=",[0,[1,"char-set&lt;="]],["srfi/14"]],
["char-set=",">srfi-std/srfi-14.html#char-set=",[0,[1,"char-set="]],["srfi/14"]],
["char-set?",">srfi-std/srfi-14.html#char-set-p",[0,[1,"char-set?"]],["srfi/14"]],
["char-symbolic?",">reference/characters.html#(def._((quote._~23~25kernel)._char-symbolic~3f))",[0,[1,"char-symbolic?"]],["scheme/base","scheme"]],
["char-title-case?",">reference/characters.html#(def._((quote._~23~25kernel)._char-title-case~3f))",[0,[1,"char-title-case?"]],["scheme/base","scheme"]],
["char-title-case?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_32",[0,[1,"char-title-case?"]],["rnrs/unicode-6"]],
["char-titlecase",">reference/characters.html#(def._((quote._~23~25kernel)._char-titlecase))",[0,[1,"char-titlecase"]],["scheme/base","scheme"]],
["char-titlecase",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_8",[0,[1,"char-titlecase"]],["rnrs/unicode-6"]],
["char-upcase",">reference/characters.html#(def._((quote._~23~25kernel)._char-upcase))",[0,[1,"char-upcase"]],["scheme/base","scheme"]],
["char-upcase",">r5rs-std/r5rs-Z-H-9.html#%_idx_502",[0,[1,"char-upcase"]],["r5rs"]],
["char-upcase",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_4",[0,[1,"char-upcase"]],["rnrs/unicode-6"]],
["char-upcase",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._char-upcase))",[0,[1,"char-upcase"]],["lang/htdp-advanced"]],
["char-upcase",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._char-upcase))",[0,[1,"char-upcase"]],["lang/htdp-beginner"]],
["char-upcase",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._char-upcase))",[0,[1,"char-upcase"]],["lang/htdp-beginner-abbr"]],
["char-upcase",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._char-upcase))",[0,[1,"char-upcase"]],["lang/htdp-intermediate"]],
["char-upcase",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._char-upcase))",[0,[1,"char-upcase"]],["lang/htdp-intermediate-lambda"]],
["char-upper-case?",">reference/characters.html#(def._((quote._~23~25kernel)._char-upper-case~3f))",[0,[1,"char-upper-case?"]],["scheme/base","scheme"]],
["char-upper-case?",">r5rs-std/r5rs-Z-H-9.html#%_idx_494",[0,[1,"char-upper-case?"]],["r5rs"]],
["char-upper-case?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_28",[0,[1,"char-upper-case?"]],["rnrs/unicode-6"]],
["char-upper-case?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._char-upper-case~3f))",[0,[1,"char-upper-case?"]],["lang/htdp-advanced"]],
["char-upper-case?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._char-upper-case~3f))",[0,[1,"char-upper-case?"]],["lang/htdp-beginner"]],
["char-upper-case?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._char-upper-case~3f))",[0,[1,"char-upper-case?"]],["lang/htdp-beginner-abbr"]],
["char-upper-case?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._char-upper-case~3f))",[0,[1,"char-upper-case?"]],["lang/htdp-intermediate"]],
["char-upper-case?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._char-upper-case~3f))",[0,[1,"char-upper-case?"]],["lang/htdp-intermediate-lambda"]],
["char-utf-8-length",">reference/characters.html#(def._((quote._~23~25kernel)._char-utf-8-length))",[0,[1,"char-utf-8-length"]],["scheme/base","scheme"]],
["char-whitespace?",">reference/characters.html#(def._((quote._~23~25kernel)._char-whitespace~3f))",[0,[1,"char-whitespace?"]],["scheme/base","scheme"]],
["char-whitespace?",">r5rs-std/r5rs-Z-H-9.html#%_idx_492",[0,[1,"char-whitespace?"]],["r5rs"]],
["char-whitespace?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_26",[0,[1,"char-whitespace?"]],["rnrs/unicode-6"]],
["char-whitespace?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._char-whitespace~3f))",[0,[1,"char-whitespace?"]],["lang/htdp-advanced"]],
["char-whitespace?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._char-whitespace~3f))",[0,[1,"char-whitespace?"]],["lang/htdp-beginner"]],
["char-whitespace?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._char-whitespace~3f))",[0,[1,"char-whitespace?"]],["lang/htdp-beginner-abbr"]],
["char-whitespace?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._char-whitespace~3f))",[0,[1,"char-whitespace?"]],["lang/htdp-intermediate"]],
["char-whitespace?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._char-whitespace~3f))",[0,[1,"char-whitespace?"]],["lang/htdp-intermediate-lambda"]],
["char<=?",">reference/characters.html#(def._((quote._~23~25kernel)._char~3c~3d~3f))",[0,[1,"char&lt;=?"]],["scheme/base","scheme"]],
["char<=?",">r5rs-std/r5rs-Z-H-9.html#%_idx_474",[0,[1,"char&lt;=?"]],["r5rs"]],
["char<=?",">r6rs-std/r6rs-Z-H-14.html#node_idx_680",[0,[1,"char&lt;=?"]],["rnrs/base-6"]],
["char<=?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._char~3c~3d~3f))",[0,[1,"char&lt;=?"]],["lang/htdp-advanced"]],
["char<=?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._char~3c~3d~3f))",[0,[1,"char&lt;=?"]],["lang/htdp-beginner"]],
["char<=?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._char~3c~3d~3f))",[0,[1,"char&lt;=?"]],["lang/htdp-beginner-abbr"]],
["char<=?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._char~3c~3d~3f))",[0,[1,"char&lt;=?"]],["lang/htdp-intermediate"]],
["char<=?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._char~3c~3d~3f))",[0,[1,"char&lt;=?"]],["lang/htdp-intermediate-lambda"]],
["char<?",">reference/characters.html#(def._((quote._~23~25kernel)._char~3c~3f))",[0,[1,"char&lt;?"]],["scheme/base","scheme"]],
["char<?",">r5rs-std/r5rs-Z-H-9.html#%_idx_470",[0,[1,"char&lt;?"]],["r5rs"]],
["char<?",">r6rs-std/r6rs-Z-H-14.html#node_idx_676",[0,[1,"char&lt;?"]],["rnrs/base-6"]],
["char<?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._char~3c~3f))",[0,[1,"char&lt;?"]],["lang/htdp-advanced"]],
["char<?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._char~3c~3f))",[0,[1,"char&lt;?"]],["lang/htdp-beginner"]],
["char<?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._char~3c~3f))",[0,[1,"char&lt;?"]],["lang/htdp-beginner-abbr"]],
["char<?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._char~3c~3f))",[0,[1,"char&lt;?"]],["lang/htdp-intermediate"]],
["char<?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._char~3c~3f))",[0,[1,"char&lt;?"]],["lang/htdp-intermediate-lambda"]],
["char=?",">reference/characters.html#(def._((quote._~23~25kernel)._char~3d~3f))",[0,[1,"char=?"]],["scheme/base","scheme"]],
["char=?",">r5rs-std/r5rs-Z-H-9.html#%_idx_468",[0,[1,"char=?"]],["r5rs"]],
["char=?",">r6rs-std/r6rs-Z-H-14.html#node_idx_674",[0,[1,"char=?"]],["rnrs/base-6"]],
["char=?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._char~3d~3f))",[0,[1,"char=?"]],["lang/htdp-advanced"]],
["char=?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._char~3d~3f))",[0,[1,"char=?"]],["lang/htdp-beginner"]],
["char=?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._char~3d~3f))",[0,[1,"char=?"]],["lang/htdp-beginner-abbr"]],
["char=?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._char~3d~3f))",[0,[1,"char=?"]],["lang/htdp-intermediate"]],
["char=?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._char~3d~3f))",[0,[1,"char=?"]],["lang/htdp-intermediate-lambda"]],
["char>=?",">reference/characters.html#(def._((quote._~23~25kernel)._char~3e~3d~3f))",[0,[1,"char&gt;=?"]],["scheme/base","scheme"]],
["char>=?",">r5rs-std/r5rs-Z-H-9.html#%_idx_476",[0,[1,"char&gt;=?"]],["r5rs"]],
["char>=?",">r6rs-std/r6rs-Z-H-14.html#node_idx_682",[0,[1,"char&gt;=?"]],["rnrs/base-6"]],
["char>=?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._char~3e~3d~3f))",[0,[1,"char&gt;=?"]],["lang/htdp-advanced"]],
["char>=?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._char~3e~3d~3f))",[0,[1,"char&gt;=?"]],["lang/htdp-beginner"]],
["char>=?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._char~3e~3d~3f))",[0,[1,"char&gt;=?"]],["lang/htdp-beginner-abbr"]],
["char>=?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._char~3e~3d~3f))",[0,[1,"char&gt;=?"]],["lang/htdp-intermediate"]],
["char>=?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._char~3e~3d~3f))",[0,[1,"char&gt;=?"]],["lang/htdp-intermediate-lambda"]],
["char>?",">reference/characters.html#(def._((quote._~23~25kernel)._char~3e~3f))",[0,[1,"char&gt;?"]],["scheme/base","scheme"]],
["char>?",">r5rs-std/r5rs-Z-H-9.html#%_idx_472",[0,[1,"char&gt;?"]],["r5rs"]],
["char>?",">r6rs-std/r6rs-Z-H-14.html#node_idx_678",[0,[1,"char&gt;?"]],["rnrs/base-6"]],
["char>?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._char~3e~3f))",[0,[1,"char&gt;?"]],["lang/htdp-advanced"]],
["char>?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._char~3e~3f))",[0,[1,"char&gt;?"]],["lang/htdp-beginner"]],
["char>?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._char~3e~3f))",[0,[1,"char&gt;?"]],["lang/htdp-beginner-abbr"]],
["char>?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._char~3e~3f))",[0,[1,"char&gt;?"]],["lang/htdp-intermediate"]],
["char>?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._char~3e~3f))",[0,[1,"char&gt;?"]],["lang/htdp-intermediate-lambda"]],
["char?",">reference/characters.html#(def._((quote._~23~25kernel)._char~3f))",[0,[1,"char?"]],["scheme/base","scheme"]],
["char?",">r5rs-std/r5rs-Z-H-9.html#%_idx_466",[0,[1,"char?"]],["r5rs"]],
["char?",">r6rs-std/r6rs-Z-H-14.html#node_idx_668",[0,[1,"char?"]],["rnrs/base-6"]],
["char?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._char~3f))",[0,[1,"char?"]],["lang/htdp-advanced"]],
["char?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._char~3f))",[0,[1,"char?"]],["lang/htdp-beginner"]],
["char?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._char~3f))",[0,[1,"char?"]],["lang/htdp-beginner-abbr"]],
["char?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._char~3f))",[0,[1,"char?"]],["lang/htdp-intermediate"]],
["char?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._char~3f))",[0,[1,"char?"]],["lang/htdp-intermediate-lambda"]],
["character",">guide/characters.html#(tech._character)","<i>character</i>",false],
["character class",">guide/regexp-chars.html#(tech._character._clas)","<i>character class</i>",false],
["character comparisons",">reference/characters.html#(part._.Character_.Comparisons)","Character Comparisons",false],
["character conversions",">reference/characters.html#(part._.Character_.Conversions)","Character Conversions",false],
["characters",">guide/characters.html","Characters",false],
["characters",">honu/H-expressions.html#(part._honu~3achars)","Characters",false],
["characters",">reference/characters.html","Characters",false],
["characters",">reference/characters.html#(tech._character)","<i>Characters</i>",false],
["characters and character classes",">guide/regexp-chars.html","Characters and Character Classes",false],
["characters and scalar values",">reference/characters.html#(part._.Characters_and_.Scalar_.Values)","Characters and Scalar Values",false],
["chat noir --- puzzle game",">games/chat-noir.html",[[13,"<img src=\"chat-noir.png\" />"]," ","<b><font size=\"-1\" face=\"Helvetica\">Chat Noir</font></b>","  ","&ndash;","  Puzzle Game"],false],
["check",">gui/checkable-menu-item_.html#(meth._(((lib._mred/main..ss)._checkable-menu-item~25)._check))",[[0,[1,"check"]],[12,[" (method of ",[0,[1,"checkable-menu-item%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["check box",">gui/windowing-overview.html#(tech._check._box)","<i>check box</i>",false],
["check syntax question-mark arrows",">drscheme/buttons.html#(idx._(gentag._10._(lib._scribblings/drscheme/drscheme..scrbl)))","Check\n       syntax, question-mark arrows",false],
["check syntax purple arrows",">drscheme/buttons.html#(idx._(gentag._9._(lib._scribblings/drscheme/drscheme..scrbl)))","Check syntax, purple arrows",false],
["check syntax button",">drscheme/buttons.html#(idx._(gentag._8._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Check Syntax</font></b> button",false],
["check-box",">gui/check-box_.html#(idx._(gentag._36._(lib._scribblings/gui/gui..scrbl)))",[7,"'check-box"],false],
["check-box%",">gui/check-box_.html",[0,[1,"check-box%"]],["scheme/gui/base","scheme/gui"]],
["check-duplicate-identifier",">reference/stxcmp.html#(def._((lib._scheme/private/stxcase-scheme..ss)._check-duplicate-identifier))",[0,[1,"check-duplicate-identifier"]],["scheme/base","scheme"]],
["check-error",">htdp-langs/advanced-unchanged.html#(form._((lib._lang/htdp-advanced..ss)._check-error))",[0,[6,"check-error"]],["lang/htdp-advanced"]],
["check-error",">htdp-langs/Test_Cases.html#(form._((lib._lang/htdp-beginner..ss)._check-error))",[0,[6,"check-error"]],["lang/htdp-beginner"]],
["check-error",">htdp-langs/Unchanged_Forms.html#(form._((lib._lang/htdp-beginner-abbr..ss)._check-error))",[0,[6,"check-error"]],["lang/htdp-beginner-abbr"]],
["check-error",">htdp-langs/intermediate-unchanged.html#(form._((lib._lang/htdp-intermediate..ss)._check-error))",[0,[6,"check-error"]],["lang/htdp-intermediate"]],
["check-error",">htdp-langs/intermediate-lambda-unchanged.html#(form._((lib._lang/htdp-intermediate-lambda..ss)._check-error))",[0,[6,"check-error"]],["lang/htdp-intermediate-lambda"]],
["check-expect",">htdp-langs/advanced-unchanged.html#(form._((lib._lang/htdp-advanced..ss)._check-expect))",[0,[6,"check-expect"]],["lang/htdp-advanced"]],
["check-expect",">htdp-langs/Test_Cases.html#(form._((lib._lang/htdp-beginner..ss)._check-expect))",[0,[6,"check-expect"]],["lang/htdp-beginner"]],
["check-expect",">htdp-langs/Unchanged_Forms.html#(form._((lib._lang/htdp-beginner-abbr..ss)._check-expect))",[0,[6,"check-expect"]],["lang/htdp-beginner-abbr"]],
["check-expect",">htdp-langs/intermediate-unchanged.html#(form._((lib._lang/htdp-intermediate..ss)._check-expect))",[0,[6,"check-expect"]],["lang/htdp-intermediate"]],
["check-expect",">htdp-langs/intermediate-lambda-unchanged.html#(form._((lib._lang/htdp-intermediate-lambda..ss)._check-expect))",[0,[6,"check-expect"]],["lang/htdp-intermediate-lambda"]],
["check-for-break",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._check-for-break))",[0,[1,"check-for-break"]],["scheme/gui/base","scheme/gui"]],
["check-module-form",">syntax/module-helpers.html#(def._((lib._syntax/modread..ss)._check-module-form))",[0,[1,"check-module-form"]],["syntax/modread"]],
["check-substring-spec",">srfi-std/srfi-13.html#check-substring-spec",[0,[1,"check-substring-spec"]],["srfi/13"]],
["check-version",">version/index.html#(def._((lib._version/check..ss)._check-version))",[0,[1,"check-version"]],["version/check"]],
["check-within",">htdp-langs/advanced-unchanged.html#(form._((lib._lang/htdp-advanced..ss)._check-within))",[0,[6,"check-within"]],["lang/htdp-advanced"]],
["check-within",">htdp-langs/Test_Cases.html#(form._((lib._lang/htdp-beginner..ss)._check-within))",[0,[6,"check-within"]],["lang/htdp-beginner"]],
["check-within",">htdp-langs/Unchanged_Forms.html#(form._((lib._lang/htdp-beginner-abbr..ss)._check-within))",[0,[6,"check-within"]],["lang/htdp-beginner-abbr"]],
["check-within",">htdp-langs/intermediate-unchanged.html#(form._((lib._lang/htdp-intermediate..ss)._check-within))",[0,[6,"check-within"]],["lang/htdp-intermediate"]],
["check-within",">htdp-langs/intermediate-lambda-unchanged.html#(form._((lib._lang/htdp-intermediate-lambda..ss)._check-within))",[0,[6,"check-within"]],["lang/htdp-intermediate-lambda"]],
["checkable menu item",">gui/windowing-overview.html#(tech._checkable._menu._item)","<i>checkable menu\nitem</i>",false],
["checkable-menu-item%",">gui/checkable-menu-item_.html",[0,[1,"checkable-menu-item%"]],["scheme/gui/base","scheme/gui"]],
["checked-struct-info?",">reference/structinfo.html#(def._((lib._scheme/struct-info..ss)._checked-struct-info~3f))",[0,[1,"checked-struct-info?"]],["scheme/struct-info"]],
["checkers --- board game",">games/checkers.html",[[13,"<img src=\"checkers.png\" />"]," ","<b><font size=\"-1\" face=\"Helvetica\">Checkers</font></b>","  ","&ndash;","  Board Game"],false],
["checking available versions",">version/index.html#(part._.Checking_.Available_.Versions)","Checking Available Versions",false],
["checking properties of data structures",">guide/contracts-struct.html#(part._contracts-lazy-contracts)","Checking Properties of Data Structures",false],
["child",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..ss)._child))",[0,[1,"child"]],["slideshow/pict","slideshow"]],
["child-dx",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..ss)._child-dx))",[0,[1,"child-dx"]],["slideshow/pict","slideshow"]],
["child-dy",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..ss)._child-dy))",[0,[1,"child-dy"]],["slideshow/pict","slideshow"]],
["child-pict",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..ss)._child-pict))",[0,[1,"child-pict"]],["slideshow/pict","slideshow"]],
["child-sx",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..ss)._child-sx))",[0,[1,"child-sx"]],["slideshow/pict","slideshow"]],
["child-sy",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..ss)._child-sy))",[0,[1,"child-sy"]],["slideshow/pict","slideshow"]],
["child?",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..ss)._child~3f))",[0,[1,"child?"]],["slideshow/pict","slideshow"]],
["choice",">gui/choice_.html#(idx._(gentag._38._(lib._scribblings/gui/gui..scrbl)))",[7,"'choice"],false],
["choice item",">gui/windowing-overview.html#(tech._choice._item)","<i>choice item</i>",false],
["choice%",">gui/choice_.html",[0,[1,"choice%"]],["scheme/gui/base","scheme/gui"]],
["choice-evt",">reference/sync.html#(def._((quote._~23~25kernel)._choice-evt))",[0,[1,"choice-evt"]],["scheme/base","scheme"]],
["choice-index",">teachpack/gui.html#(def._((lib._teachpack/htdp/gui..ss)._choice-index))",[0,[1,"choice-index"]],["teachpack/htdp/gui"]],
["choose language... menu item",">drscheme/Menus.html#(idx._(gentag._115._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Choose Language...</font></b> menu item",false],
["choosing a language",">drscheme/choose-language.html","Choosing a Language",false],
["cid",">gui/fontresources.html#(idx._(gentag._305._(lib._scribblings/gui/gui..scrbl)))","CID",false],
["circle",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._circle))",[0,[1,"circle"]],["slideshow/pict","slideshow"]],
["circle",">teachpack/image.html#(def._((lib._htdp/image..ss)._circle))",[0,[1,"circle"]],["teachpack/htdp/image"]],
["circular-list",">srfi-std/srfi-1.html#circular-list",[0,[1,"circular-list"]],["srfi/1"]],
["circular-list?",">srfi-std/srfi-1.html#circular-list-p",[0,[1,"circular-list?"]],["srfi/1"]],
["cite",">html/index.html#(def._((lib._html/main..ss)._cite))",[0,[1,"cite"]],["html"]],
["cite",">scribble/Bibliography.html#(def._((lib._scribble/manual..ss)._cite))",[0,[1,"cite"]],["scribble/manual"]],
["cite?",">html/index.html#(def._((lib._html/main..ss)._cite~3f))",[0,[1,"cite?"]],["html"]],
["class",">htdc/advanced_class.html",[0,"class"],false],
["class",">htdc/class.html",[0,"class"],false],
["class",">htdc/intermed_class.html",[0,"class"],false],
["class",">htdc/intermedAcc_class.html",[0,"class"],false],
["class",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._class))",[0,[6,"class"]],["scheme/class","scheme"]],
["class",">reference/mzlib_class.html#(tech._clas)","<i>class</i>",false],
["class*",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._class*))",[0,[6,"class*"]],["scheme/class","scheme"]],
["class->interface",">reference/objectutils.html#(def._((lib._scheme/private/class-internal..ss)._class-~3einterface))",[0,[1,"class-&gt;interface"]],["scheme/class","scheme"]],
["class-field-accessor",">reference/ivaraccess.html#(form._((lib._scheme/private/class-internal..ss)._class-field-accessor))",[0,[6,"class-field-accessor"]],["scheme/class","scheme"]],
["class-field-mutator",">reference/ivaraccess.html#(form._((lib._scheme/private/class-internal..ss)._class-field-mutator))",[0,[6,"class-field-mutator"]],["scheme/class","scheme"]],
["class-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._class-index-desc))",[0,[1,"class-index-desc"]],["scribble/manual-struct"]],
["class-index-desc?",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._class-index-desc~3f))",[0,[1,"class-index-desc?"]],["scribble/manual-struct"]],
["class-info",">reference/objectutils.html#(def._((lib._scheme/private/class-internal..ss)._class-info))",[0,[1,"class-info"]],["scheme/class","scheme"]],
["class/derived",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._class/derived))",[0,[6,"class/derived"]],["scheme/class","scheme"]],
["class100",">mzlib/mzlib_class100.html#(form._((lib._mzlib/class100..ss)._class100))",[0,[6,"class100"]],["mzlib/class100"]],
["class100*",">mzlib/mzlib_class100.html#(form._((lib._mzlib/class100..ss)._class100*))",[0,[6,"class100*"]],["mzlib/class100"]],
["class100*-asi",">mzlib/mzlib_class100.html#(form._((lib._mzlib/class100..ss)._class100*-asi))",[0,[6,"class100*-asi"]],["mzlib/class100"]],
["class100-asi",">mzlib/mzlib_class100.html#(form._((lib._mzlib/class100..ss)._class100-asi))",[0,[6,"class100-asi"]],["mzlib/class100"]],
["class?",">reference/objectutils.html#(def._((lib._scheme/private/class-internal..ss)._class~3f))",[0,[1,"class?"]],["scheme/class","scheme"]],
["classes and objects",">guide/classes.html","Classes and Objects",false],
["classes and objects",">reference/mzlib_class.html","Classes and Objects",false],
["classical control operators",">reference/cont.html#(part._.Classical_.Control_.Operators)","Classical Control Operators",false],
["classifications",">reference/characters.html#(part._.Classifications)","Classifications",false],
["classify-position",">framework/Color.html#(meth._(((lib._framework/main..ss)._color~3atext~3c~25~3e)._classify-position))",[[0,[1,"classify-position"]],[12,[" (method of ",[0,[1,"color:text&lt;%&gt;"]],")"]]],["framework"]],
["clean",">setup-plt/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..ss)._setup-option~5e._clean))",[0,[1,"clean"]],["setup/option-sig"]],
["clean-intermediate-files",">mzc/Scheme_API_for_Compilation.html#(def._((lib._compiler/option..ss)._clean-intermediate-files))",[0,[1,"clean-intermediate-files"]],["compiler/option"]],
["clean-up-index-string",">scribble/decode.html#(def._((lib._scribble/decode..ss)._clean-up-index-string))",[0,[1,"clean-up-index-string"]],["scribble/decode"]],
["cleanse",">reference/pathutils.html#(tech._cleanse)","<i>cleanse</i>",false],
["cleanse-path",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._cleanse-path))",[0,[1,"cleanse-path"]],["scheme/base","scheme"]],
["clear",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._clear))",[[0,[1,"clear"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["clear",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._clear))",[[0,[1,"clear"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["clear",">gui/list-control___.html#(meth._(((lib._mred/main..ss)._list-control~3c~25~3e)._clear))",[[0,[1,"clear"]],[12,[" (method of ",[0,[1,"list-control&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["clear",">framework/Group.html#(meth._(((lib._framework/main..ss)._group~3a~25)._clear))",[[0,[1,"clear"]],[12,[" (method of ",[0,[1,"group:%"]],")"]]],["framework"]],
["clear",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtles..ss)._clear))",[0,[1,"clear"]],["graphics/turtles"]],
["clear",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._clear))",[[0,[1,"clear"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["clear",">gui/key-event_.html#(idx._(gentag._48._(lib._scribblings/gui/gui..scrbl)))",[7,"'clear"],false],
["clear all teachpacks menu item",">drscheme/Menus.html#(idx._(gentag._117._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Clear All Teachpacks</font></b> menu item",false],
["clear error highlight menu item",">drscheme/Menus.html#(idx._(gentag._122._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Clear Error Highlight</font></b> menu item",false],
["clear menu item",">drscheme/Menus.html#(idx._(gentag._82._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Clear</font></b> menu item",false],
["clear-annotations",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3acontext~3c~25~3e)._clear-annotations))",[[0,[1,"clear-annotations"]],[12,[" (method of ",[0,[1,"drscheme:rep:context&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["clear-annotations",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3atab~25)._clear-annotations))",[[0,[1,"clear-annotations"]],[12,[" (method of ",[0,[1,"drscheme:unit:tab%"]],")"]]],["drscheme/tool-lib"]],
["clear-box-input-port",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._clear-box-input-port))",[[0,[1,"clear-box-input-port"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["clear-continuation-table!",">web-server/web_ss.html#(def._((lib._web-server/servlet/web..ss)._clear-continuation-table!))",[0,[1,"clear-continuation-table!"]],["web-server/servlet/web"]],
["clear-cue-text",">embedded-gui/Helpers.html#(meth._(((lib._embedded-gui/main..ss)._cue-text~25)._clear-cue-text))",[[0,[1,"clear-cue-text"]],[12,[" (method of ",[0,[1,"cue-text%"]],")"]]],["embedded-gui"]],
["clear-ellipse",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._clear-ellipse))",[0,[1,"clear-ellipse"]],["graphics/graphics"]],
["clear-input-port",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._clear-input-port))",[[0,[1,"clear-input-port"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["clear-line",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._clear-line))",[0,[1,"clear-line"]],["graphics/graphics"]],
["clear-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._clear-native))",[[0,[1,"clear-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["clear-output-ports",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._clear-output-ports))",[[0,[1,"clear-output-ports"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["clear-pixel",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._clear-pixel))",[0,[1,"clear-pixel"]],["graphics/graphics"]],
["clear-polygon",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._clear-polygon))",[0,[1,"clear-polygon"]],["graphics/graphics"]],
["clear-profile-results",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..ss)._clear-profile-results))",[0,[1,"clear-profile-results"]],["errortrace"]],
["clear-rectangle",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._clear-rectangle))",[0,[1,"clear-rectangle"]],["graphics/graphics"]],
["clear-solid-ellipse",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._clear-solid-ellipse))",[0,[1,"clear-solid-ellipse"]],["graphics/graphics"]],
["clear-solid-polygon",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._clear-solid-polygon))",[0,[1,"clear-solid-polygon"]],["graphics/graphics"]],
["clear-solid-rectangle",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._clear-solid-rectangle))",[0,[1,"clear-solid-rectangle"]],["graphics/graphics"]],
["clear-string",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._clear-string))",[0,[1,"clear-string"]],["graphics/graphics"]],
["clear-undos",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._clear-undos))",[[0,[1,"clear-undos"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["clear-viewport",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._clear-viewport))",[0,[1,"clear-viewport"]],["graphics/graphics"]],
["clearlinks",">planet/cmdline.html#(part._clearlinks)",[5,"clearlinks"],false],
["click",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._click))",[[0,[1,"click"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["click-select",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._click-select))",[[0,[1,"click-select"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["click-select",">mrlib/hierarchical-list-item___.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list-item~3c~25~3e)._click-select))",[[0,[1,"click-select"]],[12,[" (method of ",[0,[1,"hierarchical-list-item&lt;%&gt;"]],")"]]],["mrlib/hierlist"]],
["click?",">mysterx/html-events.html#(meth._(((lib._mysterx/main..ss)._mx-event~3c~25~3e)._click~3f))",[[0,[1,"click?"]],[12,[" (method of ",[0,[1,"mx-event&lt;%&gt;"]],")"]]],["mysterx"]],
["clickback",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..ss)._clickback))",[0,[1,"clickback"]],["slideshow/base","slideshow"]],
["clickbacks",">gui/editor-overview.html#(part._editorclickback)","Clickbacks",false],
["clickbacks",">gui/editor-overview.html#(tech._clickback)","<i>Clickbacks</i>",false],
["client",">reference/securityguards.html#(idx._(gentag._208._(lib._scribblings/reference/reference..scrbl)))",[7,"'client"],false],
["client->screen",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._client-~3escreen))",[[0,[1,"client-&gt;screen"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["client-h",">slideshow/Constants_and_Layout_Variables.html#(form._((lib._slideshow/base..ss)._client-h))",[0,[6,"client-h"]],["slideshow/base","slideshow"]],
["client-w",">slideshow/Constants_and_Layout_Variables.html#(form._((lib._slideshow/base..ss)._client-w))",[0,[6,"client-w"]],["slideshow/base","slideshow"]],
["clip",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._clip))",[[0,[1,"clip"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["clip",">slideshow/Pict_Drawing_Adjusters.html#(def._((lib._slideshow/pict..ss)._clip))",[0,[1,"clip"]],["slideshow/pict","slideshow"]],
["clip-descent",">slideshow/Bounding-Box_Adjusters.html#(def._((lib._slideshow/pict..ss)._clip-descent))",[0,[1,"clip-descent"]],["slideshow/pict","slideshow"]],
["clip-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._clip-native))",[[0,[1,"clip-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["clipboard-client%",">gui/clipboard-client_.html",[0,[1,"clipboard-client%"]],["scheme/gui/base","scheme/gui"]],
["clipboard<%>",">gui/clipboard___.html",[0,[1,"clipboard&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["cloister",">guide/regexp-clusters.html#(tech._cloister)","<i>cloister</i>",false],
["cloisters",">guide/regexp-clusters.html#(part._regexp-cloister)","Cloisters",false],
["close",">gui/dc-path_.html#(meth._(((lib._mred/main..ss)._dc-path~25)._close))",[[0,[1,"close"]],[12,[" (method of ",[0,[1,"dc-path%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["close",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abasic~3c~25~3e)._close))",[[0,[1,"close"]],[12,[" (method of ",[0,[1,"editor:basic&lt;%&gt;"]],")"]]],["framework"]],
["close",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3abasic~3c~25~3e)._close))",[[0,[1,"close"]],[12,[" (method of ",[0,[1,"frame:basic&lt;%&gt;"]],")"]]],["framework"]],
["close",">mrlib/hierarchical-list-compound-item___.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list-compound-item~3c~25~3e)._close))",[[0,[1,"close"]],[12,[" (method of ",[0,[1,"hierarchical-list-compound-item&lt;%&gt;"]],")"]]],["mrlib/hierlist"]],
["close",">teachpack/Jdraw.html#(def._((lib._teachpack/htdc/draw..ss)._close))",[0,[1,"close"]],["teachpack/htdc/draw"]],
["close icon",">mrlib/Close_Icon.html","Close Icon",false],
["close menu item",">drscheme/Menus.html#(idx._(gentag._75._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Close</font></b> menu item",false],
["close-eval",">scribble/eval.html#(def._((lib._scribble/eval..ss)._close-eval))",[0,[1,"close-eval"]],["scribble/eval"]],
["close-graphics",">graphics/Basic_Commands.html#(def._((lib._graphics/graphics..ss)._close-graphics))",[0,[1,"close-graphics"]],["graphics/graphics"]],
["close-icon%",">mrlib/Close_Icon.html#(def._((lib._mrlib/close-icon..ss)._close-icon~25))",[0,[1,"close-icon%"]],["mrlib/close-icon"]],
["close-input-port",">reference/port-ops.html#(def._((quote._~23~25kernel)._close-input-port))",[0,[1,"close-input-port"]],["scheme/base","scheme"]],
["close-input-port",">r5rs-std/r5rs-Z-H-9.html#%_idx_630",[0,[1,"close-input-port"]],["r5rs"]],
["close-input-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_804",[0,[1,"close-input-port"]],["rnrs/io/simple-6"]],
["close-output-port",">reference/port-ops.html#(def._((quote._~23~25kernel)._close-output-port))",[0,[1,"close-output-port"]],["scheme/base","scheme"]],
["close-output-port",">r5rs-std/r5rs-Z-H-9.html#%_idx_632",[0,[1,"close-output-port"]],["r5rs"]],
["close-output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_806",[0,[1,"close-output-port"]],["rnrs/io/simple-6"]],
["close-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_660",[0,[1,"close-port"]],["rnrs/io/ports-6"]],
["close-status-line",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astatus-line~3c~25~3e)._close-status-line))",[[0,[1,"close-status-line"]],[12,[" (method of ",[0,[1,"frame:status-line&lt;%&gt;"]],")"]]],["framework"]],
["close-viewport",">graphics/Basic_Commands.html#(def._((lib._graphics/graphics..ss)._close-viewport))",[0,[1,"close-viewport"]],["graphics/graphics"]],
["closed sub-paths",">gui/dc-path_.html#(tech._closed._sub._path)","<i>closed sub-paths</i>",false],
["closure->deserialize-name",">web-server/closure_ss.html#(def._((lib._web-server/private/closure..ss)._closure-~3edeserialize-name))",[0,[1,"closure-&gt;deserialize-name"]],["web-server/private/closure"]],
["closures",">guide/performance.html#(tech._closure)","<i>closures</i>",false],
["cloud",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._cloud))",[0,[1,"cloud"]],["slideshow/pict","slideshow"]],
["clustering",">guide/regexp-clusters.html#(tech._clustering)","<i>Clustering</i>",false],
["clusters",">guide/regexp-clusters.html","Clusters",false],
["cmap",">gui/fontresources.html#(idx._(gentag._304._(lib._scribblings/gui/gui..scrbl)))","CMap",false],
["cn",">reference/characters.html#(idx._(gentag._65._(lib._scribblings/reference/reference..scrbl)))",[7,"'cn"],false],
["co",">reference/characters.html#(idx._(gentag._64._(lib._scribblings/reference/reference..scrbl)))",[7,"'co"],false],
["coclass",">mysterx/methprop.html#(def._((lib._mysterx/main..ss)._coclass))",[0,[1,"coclass"]],["mysterx"]],
["coclass->html",">mysterx/Generating_ActiveX_HTML.html#(def._((lib._mysterx/main..ss)._coclass-~3ehtml))",[0,[1,"coclass-&gt;html"]],["mysterx"]],
["cocreate-instance-from-coclass",">mysterx/methprop.html#(def._((lib._mysterx/main..ss)._cocreate-instance-from-coclass))",[0,[1,"cocreate-instance-from-coclass"]],["mysterx"]],
["cocreate-instance-from-progid",">mysterx/methprop.html#(def._((lib._mysterx/main..ss)._cocreate-instance-from-progid))",[0,[1,"cocreate-instance-from-progid"]],["mysterx"]],
["code",">html/index.html#(def._((lib._html/main..ss)._code))",[0,[1,"code"]],["html"]],
["code",">slideshow/Typesetting_Scheme_Code.html#(form._((lib._slideshow/code..ss)._code))",[0,[6,"code"]],["slideshow/code"]],
["code inspectors",">reference/modprotect.html","Code Inspectors",false],
["code-align",">slideshow/Typesetting_Scheme_Code.html#(def._((lib._slideshow/code..ss)._code-align))",[0,[1,"code-align"]],["slideshow/code"]],
["code-colorize-enabled",">slideshow/Typesetting_Scheme_Code.html#(def._((lib._slideshow/code..ss)._code-colorize-enabled))",[0,[1,"code-colorize-enabled"]],["slideshow/code"]],
["code-colorize-quote-enabled",">slideshow/Typesetting_Scheme_Code.html#(def._((lib._slideshow/code..ss)._code-colorize-quote-enabled))",[0,[1,"code-colorize-quote-enabled"]],["slideshow/code"]],
["code-italic-underscore-enabled",">slideshow/Typesetting_Scheme_Code.html#(def._((lib._slideshow/code..ss)._code-italic-underscore-enabled))",[0,[1,"code-italic-underscore-enabled"]],["slideshow/code"]],
["code-pict-bottom-line-pict",">slideshow/Typesetting_Scheme_Code.html#(def._((lib._slideshow/code..ss)._code-pict-bottom-line-pict))",[0,[1,"code-pict-bottom-line-pict"]],["slideshow/code"]],
["code-scripts-enabled",">slideshow/Typesetting_Scheme_Code.html#(def._((lib._slideshow/code..ss)._code-scripts-enabled))",[0,[1,"code-scripts-enabled"]],["slideshow/code"]],
["code:blank",">slideshow/Typesetting_Scheme_Code.html#(idx._(gentag._1._(lib._scribblings/slideshow/slideshow..scrbl)))",[0,"code:blank"],false],
["code:comment",">slideshow/Typesetting_Scheme_Code.html#(idx._(gentag._2._(lib._scribblings/slideshow/slideshow..scrbl)))",[0,"code:comment"],false],
["code:contract",">slideshow/Typesetting_Scheme_Code.html#(idx._(gentag._4._(lib._scribblings/slideshow/slideshow..scrbl)))",[0,"code:contract"],false],
["code:line",">slideshow/Typesetting_Scheme_Code.html#(idx._(gentag._3._(lib._scribblings/slideshow/slideshow..scrbl)))",[0,"code:line"],false],
["code:template",">slideshow/Typesetting_Scheme_Code.html#(idx._(gentag._5._(lib._scribblings/slideshow/slideshow..scrbl)))",[0,"code:template"],false],
["code?",">html/index.html#(def._((lib._html/main..ss)._code~3f))",[0,[1,"code?"]],["html"]],
["coerce-contract",">reference/Building_New_Contract_Combinators.html#(def._((lib._scheme/private/contract-guts..ss)._coerce-contract))",[0,[1,"coerce-contract"]],["scheme/contract","scheme"]],
["coerce-contract/f",">reference/Building_New_Contract_Combinators.html#(def._((lib._scheme/private/contract-guts..ss)._coerce-contract/f))",[0,[1,"coerce-contract/f"]],["scheme/contract","scheme"]],
["coerce-contracts",">reference/Building_New_Contract_Combinators.html#(def._((lib._scheme/private/contract-guts..ss)._coerce-contracts))",[0,[1,"coerce-contracts"]],["scheme/contract","scheme"]],
["coerce-flat-contract",">reference/Building_New_Contract_Combinators.html#(def._((lib._scheme/private/contract-guts..ss)._coerce-flat-contract))",[0,[1,"coerce-flat-contract"]],["scheme/contract","scheme"]],
["coerce-flat-contracts",">reference/Building_New_Contract_Combinators.html#(def._((lib._scheme/private/contract-guts..ss)._coerce-flat-contracts))",[0,[1,"coerce-flat-contracts"]],["scheme/contract","scheme"]],
["col",">html/index.html#(def._((lib._html/main..ss)._col))",[0,[1,"col"]],["html"]],
["col?",">html/index.html#(def._((lib._html/main..ss)._col~3f))",[0,[1,"col?"]],["html"]],
["colgroup",">html/index.html#(def._((lib._html/main..ss)._colgroup))",[0,[1,"colgroup"]],["html"]],
["colgroup?",">html/index.html#(def._((lib._html/main..ss)._colgroup~3f))",[0,[1,"colgroup?"]],["html"]],
["collapse",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._collapse))",[[0,[1,"collapse"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["collapse menu item",">drscheme/Menus.html#(idx._(gentag._114._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Collapse</font></b> menu item",false],
["collapse-module-path",">syntax/module-helpers.html#(def._((lib._syntax/modcollapse..ss)._collapse-module-path))",[0,[1,"collapse-module-path"]],["syntax/modcollapse"]],
["collapse-module-path-index",">syntax/module-helpers.html#(def._((lib._syntax/modcollapse..ss)._collapse-module-path-index))",[0,[1,"collapse-module-path-index"]],["syntax/modcollapse"]],
["collapse-newline",">framework/Keymap.html#(idx._(gentag._19._(lib._scribblings/framework/framework..scrbl)))","collapse-newline",false],
["collapse-space",">framework/Keymap.html#(idx._(gentag._17._(lib._scribblings/framework/framework..scrbl)))","collapse-space",false],
["collapse-whitespace",">xml/index.html#(def._((lib._xml/main..ss)._collapse-whitespace))",[0,[1,"collapse-whitespace"]],["xml"]],
["collect",">scribble/renderer.html#(meth._(((lib._scribble/base-render..ss)._render~25)._collect))",[[0,[1,"collect"]],[12,[" (method of ",[0,[1,"render%"]],")"]]],["scribble/base-render"]],
["collect pass",">scribble/struct.html#(tech._collect._pas)","<i>collect pass</i>",false],
["collect-b",">frtime/index.html#(def._((lib._frtime/main..ss)._collect-b))",[0,[1,"collect-b"]],["frtime"]],
["collect-e",">frtime/index.html#(def._((lib._frtime/main..ss)._collect-e))",[0,[1,"collect-e"]],["frtime"]],
["collect-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._collect-element))",[0,[1,"collect-element"]],["scribble/struct"]],
["collect-element-collect",">scribble/struct.html#(def._((lib._scribble/struct..ss)._collect-element-collect))",[0,[1,"collect-element-collect"]],["scribble/struct"]],
["collect-element?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._collect-element~3f))",[0,[1,"collect-element?"]],["scribble/struct"]],
["collect-garbage",">reference/garbagecollection.html#(def._((quote._~23~25kernel)._collect-garbage))",[0,[1,"collect-garbage"]],["scheme/base","scheme"]],
["collect-garbage",">eopl/index.html#(def._((lib._eopl/eopl..ss)._collect-garbage))",[0,[1,"collect-garbage"]],["eopl/eopl"]],
["collect-info",">scribble/struct.html#(def._((lib._scribble/struct..ss)._collect-info))",[0,[1,"collect-info"]],["scribble/struct"]],
["collect-info-ext-ht",">scribble/struct.html#(def._((lib._scribble/struct..ss)._collect-info-ext-ht))",[0,[1,"collect-info-ext-ht"]],["scribble/struct"]],
["collect-info-gen-prefix",">scribble/struct.html#(def._((lib._scribble/struct..ss)._collect-info-gen-prefix))",[0,[1,"collect-info-gen-prefix"]],["scribble/struct"]],
["collect-info-ht",">scribble/struct.html#(def._((lib._scribble/struct..ss)._collect-info-ht))",[0,[1,"collect-info-ht"]],["scribble/struct"]],
["collect-info-parents",">scribble/struct.html#(def._((lib._scribble/struct..ss)._collect-info-parents))",[0,[1,"collect-info-parents"]],["scribble/struct"]],
["collect-info-parts",">scribble/struct.html#(def._((lib._scribble/struct..ss)._collect-info-parts))",[0,[1,"collect-info-parts"]],["scribble/struct"]],
["collect-info-relatives",">scribble/struct.html#(def._((lib._scribble/struct..ss)._collect-info-relatives))",[0,[1,"collect-info-relatives"]],["scribble/struct"]],
["collect-info-tags",">scribble/struct.html#(def._((lib._scribble/struct..ss)._collect-info-tags))",[0,[1,"collect-info-tags"]],["scribble/struct"]],
["collect-info?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._collect-info~3f))",[0,[1,"collect-info?"]],["scribble/struct"]],
["collect-put!",">scribble/struct.html#(def._((lib._scribble/struct..ss)._collect-put!))",[0,[1,"collect-put!"]],["scribble/struct"]],
["collected and resolved information",">scribble/struct.html#(part._passes)","Collected and Resolved Information",false],
["collected-info",">scribble/struct.html#(def._((lib._scribble/struct..ss)._collected-info))",[0,[1,"collected-info"]],["scribble/struct"]],
["collected-info-info",">scribble/struct.html#(def._((lib._scribble/struct..ss)._collected-info-info))",[0,[1,"collected-info-info"]],["scribble/struct"]],
["collected-info-number",">scribble/struct.html#(def._((lib._scribble/struct..ss)._collected-info-number))",[0,[1,"collected-info-number"]],["scribble/struct"]],
["collected-info-parent",">scribble/struct.html#(def._((lib._scribble/struct..ss)._collected-info-parent))",[0,[1,"collected-info-parent"]],["scribble/struct"]],
["collected-info?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._collected-info~3f))",[0,[1,"collected-info?"]],["scribble/struct"]],
["collection-path",">reference/collects.html#(def._((lib._scheme/private/misc..ss)._collection-path))",[0,[1,"collection-path"]],["scheme/base","scheme"]],
["collections",">guide/module-basics.html#(tech._collection)","<i>collections</i>",false],
["collections",">reference/collects.html#(tech._collection)","<i>collections</i>",false],
["collects-dir",">reference/Filesystem.html#(idx._(gentag._260._(lib._scribblings/reference/reference..scrbl)))",[7,"'collects-dir"],false],
["color",">framework/Color.html","Color",false],
["color",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._color))",[[0,[1,"color"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["color",">teachpack/image.html#(def._((lib._htdp/image..ss)._color))",[0,[1,"color"]],["teachpack/htdp/image"]],
["color",">teachpack/image.html#(tech._color)","<i>Color</i>",false],
["color model",">framework/Color_Model.html","Color Model",false],
["color operations",">graphics/Color_Operations.html","Color Operations",false],
["color prefs",">framework/Color_Prefs.html","Color Prefs",false],
["color%",">gui/color_.html",[0,[1,"color%"]],["scheme/gui/base","scheme/gui"]],
["color-blue",">teachpack/image.html#(def._((lib._htdp/image..ss)._color-blue))",[0,[1,"color-blue"]],["teachpack/htdp/image"]],
["color-database<%>",">gui/color-database___.html",[0,[1,"color-database&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["color-green",">teachpack/image.html#(def._((lib._htdp/image..ss)._color-green))",[0,[1,"color-green"]],["teachpack/htdp/image"]],
["color-list->image",">teachpack/image.html#(def._((lib._htdp/image..ss)._color-list-~3eimage))",[0,[1,"color-list-&gt;image"]],["teachpack/htdp/image"]],
["color-model:rgb->xyz",">framework/Color_Model.html#(def._((lib._framework/main..ss)._color-model~3argb-~3exyz))",[0,[1,"color-model:rgb-&gt;xyz"]],["framework"]],
["color-model:rgb-color-distance",">framework/Color_Model.html#(def._((lib._framework/main..ss)._color-model~3argb-color-distance))",[0,[1,"color-model:rgb-color-distance"]],["framework"]],
["color-model:xyz->rgb",">framework/Color_Model.html#(def._((lib._framework/main..ss)._color-model~3axyz-~3ergb))",[0,[1,"color-model:xyz-&gt;rgb"]],["framework"]],
["color-model:xyz-x",">framework/Color_Model.html#(def._((lib._framework/main..ss)._color-model~3axyz-x))",[0,[1,"color-model:xyz-x"]],["framework"]],
["color-model:xyz-y",">framework/Color_Model.html#(def._((lib._framework/main..ss)._color-model~3axyz-y))",[0,[1,"color-model:xyz-y"]],["framework"]],
["color-model:xyz-z",">framework/Color_Model.html#(def._((lib._framework/main..ss)._color-model~3axyz-z))",[0,[1,"color-model:xyz-z"]],["framework"]],
["color-model:xyz?",">framework/Color_Model.html#(def._((lib._framework/main..ss)._color-model~3axyz~3f))",[0,[1,"color-model:xyz?"]],["framework"]],
["color-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._color-native))",[[0,[1,"color-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["color-prefs:add-background-preferences-panel",">framework/Color_Prefs.html#(def._((lib._framework/main..ss)._color-prefs~3aadd-background-preferences-panel))",[0,[1,"color-prefs:add-background-preferences-panel"]],["framework"]],
["color-prefs:add-to-preferences-panel",">framework/Color_Prefs.html#(def._((lib._framework/main..ss)._color-prefs~3aadd-to-preferences-panel))",[0,[1,"color-prefs:add-to-preferences-panel"]],["framework"]],
["color-prefs:black-on-white",">framework/Color_Prefs.html#(def._((lib._framework/main..ss)._color-prefs~3ablack-on-white))",[0,[1,"color-prefs:black-on-white"]],["framework"]],
["color-prefs:build-color-selection-panel",">framework/Color_Prefs.html#(def._((lib._framework/main..ss)._color-prefs~3abuild-color-selection-panel))",[0,[1,"color-prefs:build-color-selection-panel"]],["framework"]],
["color-prefs:marshall-style-delta",">framework/Color_Prefs.html#(def._((lib._framework/main..ss)._color-prefs~3amarshall-style-delta))",[0,[1,"color-prefs:marshall-style-delta"]],["framework"]],
["color-prefs:register-color-preference",">framework/Color_Prefs.html#(def._((lib._framework/main..ss)._color-prefs~3aregister-color-preference))",[0,[1,"color-prefs:register-color-preference"]],["framework"]],
["color-prefs:set-default/color-scheme",">framework/Color_Prefs.html#(def._((lib._framework/main..ss)._color-prefs~3aset-default/color-scheme))",[0,[1,"color-prefs:set-default/color-scheme"]],["framework"]],
["color-prefs:unmarshall-style-delta",">framework/Color_Prefs.html#(def._((lib._framework/main..ss)._color-prefs~3aunmarshall-style-delta))",[0,[1,"color-prefs:unmarshall-style-delta"]],["framework"]],
["color-prefs:white-on-black",">framework/Color_Prefs.html#(def._((lib._framework/main..ss)._color-prefs~3awhite-on-black))",[0,[1,"color-prefs:white-on-black"]],["framework"]],
["color-red",">teachpack/image.html#(def._((lib._htdp/image..ss)._color-red))",[0,[1,"color-red"]],["teachpack/htdp/image"]],
["color-series",">slideshow/Miscellaneous.html#(def._((lib._slideshow/pict..ss)._color-series))",[0,[1,"color-series"]],["slideshow/pict","slideshow"]],
["color:text%",">framework/Color.html#(def._((lib._framework/main..ss)._color~3atext~25))",[0,[1,"color:text%"]],["framework"]],
["color:text-mixin",">framework/Color.html#(def._((lib._framework/main..ss)._color~3atext-mixin))",[0,[1,"color:text-mixin"]],["framework"]],
["color:text-mode%",">framework/Color.html#(def._((lib._framework/main..ss)._color~3atext-mode~25))",[0,[1,"color:text-mode%"]],["framework"]],
["color:text-mode-mixin",">framework/Color.html#(def._((lib._framework/main..ss)._color~3atext-mode-mixin))",[0,[1,"color:text-mode-mixin"]],["framework"]],
["color:text-mode<%>",">framework/Color.html#(def._((lib._framework/main..ss)._color~3atext-mode~3c~25~3e))",[0,[1,"color:text-mode&lt;%&gt;"]],["framework"]],
["color:text<%>",">framework/Color.html#(def._((lib._framework/main..ss)._color~3atext~3c~25~3e))",[0,[1,"color:text&lt;%&gt;"]],["framework"]],
["color?",">file/gif.html#(def._((lib._file/gif..ss)._color~3f))",[0,[1,"color?"]],["file/gif"]],
["color?",">teachpack/image.html#(def._((lib._htdp/image..ss)._color~3f))",[0,[1,"color?"]],["teachpack/htdp/image"]],
["colorize",">slideshow/Pict_Drawing_Adjusters.html#(def._((lib._slideshow/pict..ss)._colorize))",[0,[1,"colorize"]],["slideshow/pict","slideshow"]],
["colors",">mysterx/Colors.html","Colors",false],
["colors",">drscheme/prefs-explanation.html#(part._.Colors)","<b><font size=\"-1\" face=\"Helvetica\">Colors</font></b>",false],
["colors: colors.*",">teachpack/colors.html","Colors: colors.*",false],
["column locations",">reference/linecol.html#(tech._column._location)","<i>column\nlocations</i>",false],
["column numbers",">reference/linecol.html","column numbers",false],
["com",">mysterx/com.html","COM",false],
["com events",">mysterx/com-events.html","COM Events",false],
["com methods and properties",">mysterx/methprop.html","COM Methods and Properties",false],
["com types",">mysterx/com-types.html","COM Types",false],
["com-add-ref",">mysterx/methprop.html#(def._((lib._mysterx/main..ss)._com-add-ref))",[0,[1,"com-add-ref"]],["mysterx"]],
["com-all-coclasses",">mysterx/methprop.html#(def._((lib._mysterx/main..ss)._com-all-coclasses))",[0,[1,"com-all-coclasses"]],["mysterx"]],
["com-all-controls",">mysterx/methprop.html#(def._((lib._mysterx/main..ss)._com-all-controls))",[0,[1,"com-all-controls"]],["mysterx"]],
["com-currency->number",">mysterx/com-types.html#(def._((lib._mysterx/main..ss)._com-currency-~3enumber))",[0,[1,"com-currency-&gt;number"]],["mysterx"]],
["com-currency?",">mysterx/com-types.html#(def._((lib._mysterx/main..ss)._com-currency~3f))",[0,[1,"com-currency?"]],["mysterx"]],
["com-date->date",">mysterx/com-types.html#(def._((lib._mysterx/main..ss)._com-date-~3edate))",[0,[1,"com-date-&gt;date"]],["mysterx"]],
["com-date?",">mysterx/com-types.html#(def._((lib._mysterx/main..ss)._com-date~3f))",[0,[1,"com-date?"]],["mysterx"]],
["com-event-type",">mysterx/com-events.html#(def._((lib._mysterx/main..ss)._com-event-type))",[0,[1,"com-event-type"]],["mysterx"]],
["com-events",">mysterx/com-events.html#(def._((lib._mysterx/main..ss)._com-events))",[0,[1,"com-events"]],["mysterx"]],
["com-get-properties",">mysterx/methprop.html#(def._((lib._mysterx/main..ss)._com-get-properties))",[0,[1,"com-get-properties"]],["mysterx"]],
["com-get-property",">mysterx/methprop.html#(def._((lib._mysterx/main..ss)._com-get-property))",[0,[1,"com-get-property"]],["mysterx"]],
["com-get-property-type",">mysterx/methprop.html#(def._((lib._mysterx/main..ss)._com-get-property-type))",[0,[1,"com-get-property-type"]],["mysterx"]],
["com-help",">mysterx/methprop.html#(def._((lib._mysterx/main..ss)._com-help))",[0,[1,"com-help"]],["mysterx"]],
["com-invoke",">mysterx/methprop.html#(def._((lib._mysterx/main..ss)._com-invoke))",[0,[1,"com-invoke"]],["mysterx"]],
["com-is-a?",">mysterx/com-types.html#(def._((lib._mysterx/main..ss)._com-is-a~3f))",[0,[1,"com-is-a?"]],["mysterx"]],
["com-iunknown?",">mysterx/com-types.html#(def._((lib._mysterx/main..ss)._com-iunknown~3f))",[0,[1,"com-iunknown?"]],["mysterx"]],
["com-method-type",">mysterx/methprop.html#(def._((lib._mysterx/main..ss)._com-method-type))",[0,[1,"com-method-type"]],["mysterx"]],
["com-methods",">mysterx/methprop.html#(def._((lib._mysterx/main..ss)._com-methods))",[0,[1,"com-methods"]],["mysterx"]],
["com-object-eq?",">mysterx/methprop.html#(def._((lib._mysterx/main..ss)._com-object-eq~3f))",[0,[1,"com-object-eq?"]],["mysterx"]],
["com-object-type",">mysterx/com-types.html#(def._((lib._mysterx/main..ss)._com-object-type))",[0,[1,"com-object-type"]],["mysterx"]],
["com-object?",">mysterx/methprop.html#(def._((lib._mysterx/main..ss)._com-object~3f))",[0,[1,"com-object?"]],["mysterx"]],
["com-omit",">mysterx/com-types.html#(def._((lib._mysterx/main..ss)._com-omit))",[0,[1,"com-omit"]],["mysterx"]],
["com-ref-count",">mysterx/methprop.html#(def._((lib._mysterx/main..ss)._com-ref-count))",[0,[1,"com-ref-count"]],["mysterx"]],
["com-register-event-handler",">mysterx/com-events.html#(def._((lib._mysterx/main..ss)._com-register-event-handler))",[0,[1,"com-register-event-handler"]],["mysterx"]],
["com-scode->number",">mysterx/com-types.html#(def._((lib._mysterx/main..ss)._com-scode-~3enumber))",[0,[1,"com-scode-&gt;number"]],["mysterx"]],
["com-scode?",">mysterx/com-types.html#(def._((lib._mysterx/main..ss)._com-scode~3f))",[0,[1,"com-scode?"]],["mysterx"]],
["com-set-properties",">mysterx/methprop.html#(def._((lib._mysterx/main..ss)._com-set-properties))",[0,[1,"com-set-properties"]],["mysterx"]],
["com-set-property!",">mysterx/methprop.html#(def._((lib._mysterx/main..ss)._com-set-property!))",[0,[1,"com-set-property!"]],["mysterx"]],
["com-set-property-type",">mysterx/methprop.html#(def._((lib._mysterx/main..ss)._com-set-property-type))",[0,[1,"com-set-property-type"]],["mysterx"]],
["com-unregister-event-handler",">mysterx/com-events.html#(def._((lib._mysterx/main..ss)._com-unregister-event-handler))",[0,[1,"com-unregister-event-handler"]],["mysterx"]],
["com1",">reference/windowspaths.html#(idx._(gentag._219._(lib._scribblings/reference/reference..scrbl)))",[5,"\"COM1\""],false],
["com2",">reference/windowspaths.html#(idx._(gentag._220._(lib._scribblings/reference/reference..scrbl)))",[5,"\"COM2\""],false],
["com3",">reference/windowspaths.html#(idx._(gentag._221._(lib._scribblings/reference/reference..scrbl)))",[5,"\"COM3\""],false],
["com4",">reference/windowspaths.html#(idx._(gentag._222._(lib._scribblings/reference/reference..scrbl)))",[5,"\"COM4\""],false],
["com5",">reference/windowspaths.html#(idx._(gentag._223._(lib._scribblings/reference/reference..scrbl)))",[5,"\"COM5\""],false],
["com6",">reference/windowspaths.html#(idx._(gentag._224._(lib._scribblings/reference/reference..scrbl)))",[5,"\"COM6\""],false],
["com7",">reference/windowspaths.html#(idx._(gentag._225._(lib._scribblings/reference/reference..scrbl)))",[5,"\"COM7\""],false],
["com8",">reference/windowspaths.html#(idx._(gentag._226._(lib._scribblings/reference/reference..scrbl)))",[5,"\"COM8\""],false],
["com9",">reference/windowspaths.html#(idx._(gentag._227._(lib._scribblings/reference/reference..scrbl)))",[5,"\"COM9\""],false],
["combine-in",">reference/require.html#(form._((lib._scheme/base..ss)._combine-in))",[0,[6,"combine-in"]],["scheme/base","scheme"]],
["combine-out",">reference/require.html#(form._((lib._scheme/base..ss)._combine-out))",[0,[6,"combine-out"]],["scheme/base","scheme"]],
["combine-url/relative",">net/url.html#(def._((lib._net/url..ss)._combine-url/relative))",[0,[1,"combine-url/relative"]],["net/url"]],
["combined matching forms",">reference/match.html#(part._.Combined_.Matching_.Forms)","Combined Matching Forms",false],
["combining tests: and and or",">guide/conditionals.html#(part._and+or)",["Combining Tests: ",[0,[6,"and"]]," and ",[0,[6,"or"]]],false],
["combo field",">gui/windowing-overview.html#(tech._combo._field)","<i>combo field</i>",false],
["combo-field%",">gui/combo-field_.html",[0,[1,"combo-field%"]],["scheme/gui/base","scheme/gui"]],
["command",">gui/control___.html#(meth._(((lib._mred/main..ss)._control~3c~25~3e)._command))",[[0,[1,"command"]],[12,[" (method of ",[0,[1,"control&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["command",">gui/selectable-menu-item___.html#(meth._(((lib._mred/main..ss)._selectable-menu-item~3c~25~3e)._command))",[[0,[1,"command"]],[12,[" (method of ",[0,[1,"selectable-menu-item&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["command",">mrlib/Switchable_Button.html#(meth._(((lib._mrlib/switchable-button..ss)._switchable-button~25)._command))",[[0,[1,"command"]],[12,[" (method of ",[0,[1,"switchable-button%"]],")"]]],["mrlib/switchable-button"]],
["command line",">reference/running-sa.html#(part._mz-cmdline)","Command Line",false],
["command-line",">reference/Command-Line_Parsing.html#(form._((lib._scheme/cmdline..ss)._command-line))",[0,[6,"command-line"]],["scheme/cmdline","scheme"]],
["command-line",">r6rs-lib-std/r6rs-lib-Z-H-11.html#node_idx_844",[0,[1,"command-line"]],["rnrs/programs-6"]],
["command-line",">mzlib/mzlib_cmdline.html#(form._((lib._mzlib/cmdline..ss)._command-line))",[0,[6,"command-line"]],["mzlib/cmdline"]],
["command-line options",">slideshow/Creating_Slide_Presentations.html#(part._.Command-line_.Options)","Command-line Options",false],
["command-line parsing",">reference/Command-Line_Parsing.html","Command-Line Parsing",false],
["command-line tools",">web-server/command-line-tools.html","Command-line Tools",false],
["command-marker",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..ss)._command-marker))",[0,[1,"command-marker"]],["preprocessor/mztext"]],
["commandline",">scribble/Miscellaneous.html#(def._((lib._scribble/manual..ss)._commandline))",[0,[1,"commandline"]],["scribble/manual"]],
["comment",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..ss)._comment))",[0,[1,"comment"]],["slideshow/base","slideshow"]],
["comment",">xml/index.html#(def._((lib._xml/main..ss)._comment))",[0,[1,"comment"]],["xml"]],
["comment box",">framework/Comment_Box.html","Comment Box",false],
["comment out with a box menu item",">drscheme/Menus.html#(idx._(gentag._128._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Comment Out with a Box</font></b> menu item",false],
["comment out with semicolons menu item",">drscheme/Menus.html#(idx._(gentag._127._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Comment Out with Semicolons</font></b> menu item",false],
["comment-box:snip%",">framework/Comment_Box.html#(def._((lib._framework/main..ss)._comment-box~3asnip~25))",[0,[1,"comment-box:snip%"]],["framework"]],
["comment-color",">slideshow/Typesetting_Scheme_Code.html#(def._((lib._slideshow/code..ss)._comment-color))",[0,[1,"comment-color"]],["slideshow/code"]],
["comment-editor%",">gui/WXME_Decoding.html#(def._((lib._wxme/comment..ss)._comment-editor~25))",[0,[1,"comment-editor%"]],["wxme/comment"]],
["comment-out-selection",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._comment-out-selection))",[[0,[1,"comment-out-selection"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["comment-text",">xml/index.html#(def._((lib._xml/main..ss)._comment-text))",[0,[1,"comment-text"]],["xml"]],
["comment?",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..ss)._comment~3f))",[0,[1,"comment?"]],["slideshow/base","slideshow"]],
["comment?",">xml/index.html#(def._((lib._xml/main..ss)._comment~3f))",[0,[1,"comment?"]],["xml"]],
["comments",">honu/H-expressions.html#(part._honu~3acomments)","Comments",false],
["communicator",">net/nntp.html#(def._((lib._net/nntp..ss)._communicator))",[0,[1,"communicator"]],["net/nntp"]],
["communicator",">net/pop3.html#(def._((lib._net/pop3..ss)._communicator))",[0,[1,"communicator"]],["net/pop3"]],
["communicator-port",">net/nntp.html#(def._((lib._net/nntp..ss)._communicator-port))",[0,[1,"communicator-port"]],["net/nntp"]],
["communicator-port",">net/pop3.html#(def._((lib._net/pop3..ss)._communicator-port))",[0,[1,"communicator-port"]],["net/pop3"]],
["communicator-receiver",">net/nntp.html#(def._((lib._net/nntp..ss)._communicator-receiver))",[0,[1,"communicator-receiver"]],["net/nntp"]],
["communicator-receiver",">net/pop3.html#(def._((lib._net/pop3..ss)._communicator-receiver))",[0,[1,"communicator-receiver"]],["net/pop3"]],
["communicator-sender",">net/nntp.html#(def._((lib._net/nntp..ss)._communicator-sender))",[0,[1,"communicator-sender"]],["net/nntp"]],
["communicator-sender",">net/pop3.html#(def._((lib._net/pop3..ss)._communicator-sender))",[0,[1,"communicator-sender"]],["net/pop3"]],
["communicator-server",">net/nntp.html#(def._((lib._net/nntp..ss)._communicator-server))",[0,[1,"communicator-server"]],["net/nntp"]],
["communicator-server",">net/pop3.html#(def._((lib._net/pop3..ss)._communicator-server))",[0,[1,"communicator-server"]],["net/pop3"]],
["communicator-state",">net/pop3.html#(def._((lib._net/pop3..ss)._communicator-state))",[0,[1,"communicator-state"]],["net/pop3"]],
["communicator?",">net/nntp.html#(def._((lib._net/nntp..ss)._communicator~3f))",[0,[1,"communicator?"]],["net/nntp"]],
["communicator?",">net/pop3.html#(def._((lib._net/pop3..ss)._communicator~3f))",[0,[1,"communicator?"]],["net/pop3"]],
["comp@",">mzc/Scheme_API_for_Compilation.html#(def._((lib._compiler/comp-unit..ss)._comp~40))",[0,[1,"comp@"]],["compiler/comp-unit"]],
["compatible-closure",">redex/Reduction_Relations.html#(form._((lib._redex/main..ss)._compatible-closure))",[0,[6,"compatible-closure"]],["redex"]],
["compilation",">dynext/Compilation.html","Compilation",false],
["compilation",">reference/syntax-model.html#(part._compilation-model)","Compilation",false],
["compilation and configuration",">guide/compile.html","Compilation and Configuration",false],
["compilation handler",">reference/Evaluation_and_Compilation.html#(tech._compilation._handler)","<i>compilation handler</i>",false],
["compilation manager hook for syntax transformers",">mzc/make.html#(part._.Compilation_.Manager_.Hook_for_.Syntax_.Transformers)","Compilation Manager Hook for Syntax Transformers",false],
["compilation parameters",">dynext/Compilation.html#(part._compile-params)","Compilation Parameters",false],
["compilation via c",">mzc/Scheme_API_for_Compilation.html#(part._api~3aext)","Compilation via C",false],
["compile",">reference/Evaluation_and_Compilation.html#(def._((quote._~23~25kernel)._compile))",[0,[1,"compile"]],["scheme/base","scheme"]],
["compile and run-time phases",">guide/stx-phases.html","Compile and Run-Time Phases",false],
["compile-allow-set!-undefined",">reference/Evaluation_and_Compilation.html#(def._((quote._~23~25kernel)._compile-allow-set!-undefined))",[0,[1,"compile-allow-set!-undefined"]],["scheme/base","scheme"]],
["compile-c-extension",">mzc/Scheme_API_for_Compilation.html#(sig-val._((lib._compiler/sig..ss)._compiler~3ainner~5e._compile-c-extension))",[0,[1,"compile-c-extension"]],["compiler/sig"]],
["compile-c-extensions",">mzc/Scheme_API_for_Compilation.html#(def._((lib._compiler/compiler..ss)._compile-c-extensions))",[0,[1,"compile-c-extensions"]],["compiler/compiler"]],
["compile-collection-zos",">mzc/Scheme_API_for_Compilation.html#(def._((lib._compiler/compiler..ss)._compile-collection-zos))",[0,[1,"compile-collection-zos"]],["compiler/compiler"]],
["compile-directory-zos",">mzc/Scheme_API_for_Compilation.html#(def._((lib._compiler/compiler..ss)._compile-directory-zos))",[0,[1,"compile-directory-zos"]],["compiler/compiler"]],
["compile-enforce-module-constants",">reference/Evaluation_and_Compilation.html#(def._((quote._~23~25kernel)._compile-enforce-module-constants))",[0,[1,"compile-enforce-module-constants"]],["scheme/base","scheme"]],
["compile-extension",">mzc/Scheme_API_for_Compilation.html#(sig-val._((lib._compiler/sig..ss)._compiler~3ainner~5e._compile-extension))",[0,[1,"compile-extension"]],["compiler/sig"]],
["compile-extension",">dynext/Compilation.html#(def._((lib._dynext/compile..ss)._compile-extension))",[0,[1,"compile-extension"]],["dynext/compile"]],
["compile-extension-to-c",">mzc/Scheme_API_for_Compilation.html#(sig-val._((lib._compiler/sig..ss)._compiler~3ainner~5e._compile-extension-to-c))",[0,[1,"compile-extension-to-c"]],["compiler/sig"]],
["compile-extensions",">mzc/Scheme_API_for_Compilation.html#(def._((lib._compiler/compiler..ss)._compile-extensions))",[0,[1,"compile-extensions"]],["compiler/compiler"]],
["compile-extensions-to-c",">mzc/Scheme_API_for_Compilation.html#(def._((lib._compiler/compiler..ss)._compile-extensions-to-c))",[0,[1,"compile-extensions-to-c"]],["compiler/compiler"]],
["compile-file",">mzlib/mzlib_compile.html#(def._((lib._mzlib/compile..ss)._compile-file))",[0,[1,"compile-file"]],["mzlib/compile"]],
["compile-for-embedded",">mzc/Scheme_API_for_Compilation.html#(def._((lib._compiler/option..ss)._compile-for-embedded))",[0,[1,"compile-for-embedded"]],["compiler/option"]],
["compile-mode",">setup-plt/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..ss)._setup-option~5e._compile-mode))",[0,[1,"compile-mode"]],["setup/option-sig"]],
["compile-omit-files",">mzc/Scheme_API_for_Compilation.html#(idx._(gentag._62._(lib._scribblings/mzc/mzc..scrbl)))",[0,"compile-omit-files"],false],
["compile-omit-paths",">mzc/Scheme_API_for_Compilation.html#(idx._(gentag._61._(lib._scribblings/mzc/mzc..scrbl)))",[0,"compile-omit-paths"],false],
["compile-subcollections",">mzc/Scheme_API_for_Compilation.html#(def._((lib._compiler/option..ss)._compile-subcollections))",[0,[1,"compile-subcollections"]],["compiler/option"]],
["compile-syntax",">reference/Evaluation_and_Compilation.html#(def._((quote._~23~25kernel)._compile-syntax))",[0,[1,"compile-syntax"]],["scheme/base","scheme"]],
["compile-variant",">dynext/Compilation.html#(def._((lib._dynext/compile..ss)._compile-variant))",[0,[1,"compile-variant"]],["dynext/compile"]],
["compile-zos",">mzc/Scheme_API_for_Compilation.html#(def._((lib._compiler/compiler..ss)._compile-zos))",[0,[1,"compile-zos"]],["compiler/compiler"]],
["compiled",">reference/syntax-model.html#(tech._compiled)","<i>compiled</i>",false],
["compiled modules and references",">reference/Module_Names_and_Loading.html#(part._modpathidx)","Compiled Modules and References",false],
["compiled-expression?",">reference/Evaluation_and_Compilation.html#(def._((quote._~23~25kernel)._compiled-expression~3f))",[0,[1,"compiled-expression?"]],["scheme/base","scheme"]],
["compiled-lang?",">redex/Languages.html#(def._((lib._redex/main..ss)._compiled-lang~3f))",[0,[1,"compiled-lang?"]],["redex"]],
["compiled-load handler",">reference/Evaluation_and_Compilation.html#(tech._compiled._load._handler)","<i>compiled-load\nhandler</i>",false],
["compiled-module-expression?",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._compiled-module-expression~3f))",[0,[1,"compiled-module-expression?"]],["scheme/base","scheme"]],
["compiler inner unit",">mzc/Scheme_API_for_Compilation.html#(part._.Compiler_.Inner_.Unit)","Compiler Inner Unit",false],
["compiler-sizeof",">foreign/Type_Constructors.html#(def._((lib._scheme/foreign..ss)._compiler-sizeof))",[0,[1,"compiler-sizeof"]],["scheme/foreign"]],
["compiler-verbose",">setup-plt/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..ss)._setup-option~5e._compiler-verbose))",[0,[1,"compiler-verbose"]],["setup/option-sig"]],
["compiler/bundle-dist",">mzc/exe-dist.html#(mod-path._compiler/bundle-dist)",[14,[0,"compiler/bundle-dist"]],"module"],
["compiler/cffi",">cffi/index.html",[14,[0,"compiler/cffi"]],"module"],
["compiler/cm",">mzc/make.html#(mod-path._compiler/cm)",[14,[0,"compiler/cm"]],"module"],
["compiler/cm-accomplice",">mzc/make.html#(mod-path._compiler/cm-accomplice)",[14,[0,"compiler/cm-accomplice"]],"module"],
["compiler/comp-unit",">mzc/Scheme_API_for_Compilation.html#(mod-path._compiler/comp-unit)",[14,[0,"compiler/comp-unit"]],"module"],
["compiler/compiler",">mzc/Scheme_API_for_Compilation.html",[14,[0,"compiler/compiler"]],"module"],
["compiler/compiler-unit",">mzc/Scheme_API_for_Compilation.html#(mod-path._compiler/compiler-unit)",[14,[0,"compiler/compiler-unit"]],"module"],
["compiler/distribute",">mzc/exe-dist.html#(mod-path._compiler/distribute)",[14,[0,"compiler/distribute"]],"module"],
["compiler/embed",">mzc/exe.html#(mod-path._compiler/embed)",[14,[0,"compiler/embed"]],"module"],
["compiler/embed-sig",">mzc/exe.html#(mod-path._compiler/embed-sig)",[14,[0,"compiler/embed-sig"]],"module"],
["compiler/embed-unit",">mzc/exe.html#(mod-path._compiler/embed-unit)",[14,[0,"compiler/embed-unit"]],"module"],
["compiler/option",">mzc/Scheme_API_for_Compilation.html#(mod-path._compiler/option)",[14,[0,"compiler/option"]],"module"],
["compiler/option-unit",">mzc/Scheme_API_for_Compilation.html#(mod-path._compiler/option-unit)",[14,[0,"compiler/option-unit"]],"module"],
["compiler/sig",">mzc/Scheme_API_for_Compilation.html#(mod-path._compiler/sig)",[14,[0,"compiler/sig"]],"module"],
["compiler:embed@",">mzc/exe.html#(def._((lib._compiler/embed-unit..ss)._compiler~3aembed~40))",[0,[1,"compiler:embed@"]],["compiler/embed-unit"]],
["compiler:embed^",">mzc/exe.html#(form._((lib._compiler/embed-sig..ss)._compiler~3aembed~5e))",[0,[6,"compiler:embed^"]],["compiler/embed-sig"]],
["compiler:inner^",">mzc/Scheme_API_for_Compilation.html#(form._((lib._compiler/sig..ss)._compiler~3ainner~5e))",[0,[6,"compiler:inner^"]],["compiler/sig"]],
["compiler:option@",">mzc/Scheme_API_for_Compilation.html#(def._((lib._compiler/option-unit..ss)._compiler~3aoption~40))",[0,[1,"compiler:option@"]],["compiler/option-unit"]],
["compiler:option^",">mzc/Scheme_API_for_Compilation.html#(form._((lib._compiler/sig..ss)._compiler~3aoption~5e))",[0,[6,"compiler:option^"]],["compiler/sig"]],
["compiler@",">mzc/Scheme_API_for_Compilation.html#(def._((lib._compiler/compiler-unit..ss)._compiler~40))",[0,[1,"compiler@"]],["compiler/compiler-unit"]],
["compiler^",">mzc/Scheme_API_for_Compilation.html#(form._((lib._compiler/sig..ss)._compiler~5e))",[0,[6,"compiler^"]],["compiler/sig"]],
["compiling and linking c extensions",">mzc/cc.html","Compiling and Linking C Extensions",false],
["compiling modified modules to bytecode",">mzc/make.html","Compiling Modified Modules to Bytecode",false],
["compiling to native code via c",">mzc/ext.html","Compiling to Native Code via C",false],
["compiling to raw bytecode",">mzc/zo.html","Compiling to Raw Bytecode",false],
["complement",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..ss)._complement))",[0,[1,"complement"]],["mzlib/integer-set"]],
["complete",">reference/bytestrings.html#(idx._(gentag._30._(lib._scribblings/reference/reference..scrbl)))",[7,"'complete"],false],
["complete",">reference/bytestrings.html#(idx._(gentag._34._(lib._scribblings/reference/reference..scrbl)))",[7,"'complete"],false],
["complete word menu item",">drscheme/Menus.html#(idx._(gentag._95._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Complete Word</font></b> menu item",false],
["complete-path?",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._complete-path~3f))",[0,[1,"complete-path?"]],["scheme/base","scheme"]],
["completion-mode-key-event?",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aautocomplete~3c~25~3e)._completion-mode-key-event~3f))",[[0,[1,"completion-mode-key-event?"]],[12,[" (method of ",[0,[1,"text:autocomplete&lt;%&gt;"]],")"]]],["framework"]],
["complex",">guide/numbers.html#(tech._complex)","<i>complex</i>",false],
["complex numbers",">reference/numbers.html#(part._.Complex_.Numbers)","Complex Numbers",false],
["complex numbers",">reference/numbers.html#(tech._complex._number)","<i>complex numbers</i>",false],
["complex?",">reference/numbers.html#(def._((quote._~23~25kernel)._complex~3f))",[0,[1,"complex?"]],["scheme/base","scheme"]],
["complex?",">r5rs-std/r5rs-Z-H-9.html#%_idx_246",[0,[1,"complex?"]],["r5rs"]],
["complex?",">r6rs-std/r6rs-Z-H-14.html#node_idx_442",[0,[1,"complex?"]],["rnrs/base-6"]],
["complex?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._complex~3f))",[0,[1,"complex?"]],["lang/htdp-advanced"]],
["complex?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._complex~3f))",[0,[1,"complex?"]],["lang/htdp-beginner"]],
["complex?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._complex~3f))",[0,[1,"complex?"]],["lang/htdp-beginner-abbr"]],
["complex?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._complex~3f))",[0,[1,"complex?"]],["lang/htdp-intermediate"]],
["complex?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._complex~3f))",[0,[1,"complex?"]],["lang/htdp-intermediate-lambda"]],
["components",">guide/units.html#(tech._component)","<i>components</i>",false],
["composable continuation",">reference/eval-model.html#(tech._composable._continuation)","<i>composable continuation</i>",false],
["composable continuations",">guide/Continuations.html#(tech._composable._continuation)","<i>composable continuations</i>",false],
["compose",">reference/procedures.html#(def._((lib._scheme/base..ss)._compose))",[0,[1,"compose"]],["scheme/base","scheme"]],
["compose",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._compose))",[0,[1,"compose"]],["lang/htdp-advanced"]],
["compose",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._compose))",[0,[1,"compose"]],["lang/htdp-intermediate"]],
["compose",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._compose))",[0,[1,"compose"]],["lang/htdp-intermediate-lambda"]],
["compose",">lazy/index.html#(def._((lib._lazy/main..ss)._compose))",[0,[1,"compose"]],["lazy"]],
["composing images",">teachpack/image.html#(part._composition)","Composing Images",false],
["composite input port",">preprocessor/mztext.html#(tech._composite._input._port)","<i>composite input port</i>",false],
["compound-unit",">reference/compoundunits.html#(form._((lib._mzlib/unit..ss)._compound-unit))",[0,[6,"compound-unit"]],["scheme/unit","scheme"]],
["compound-unit/infer",">reference/linkinference.html#(form._((lib._mzlib/unit..ss)._compound-unit/infer))",[0,[6,"compound-unit/infer"]],["scheme/unit","scheme"]],
["compress-serial",">web-server/mod-map_ss.html#(def._((lib._web-server/private/mod-map..ss)._compress-serial))",[0,[1,"compress-serial"]],["web-server/private/mod-map"]],
["computing the free variables of an expression",">syntax/syntax-helpers.html#(part._free-vars)","Computing the Free Variables of an Expression",false],
["con",">reference/windowspaths.html#(idx._(gentag._216._(lib._scribblings/reference/reference..scrbl)))",[5,"\"CON\""],false],
["concatenate",">srfi-std/srfi-1.html#concatenate",[0,[1,"concatenate"]],["srfi/1"]],
["concatenate!",">srfi-std/srfi-1.html#concatenate!",[0,[1,"concatenate!"]],["srfi/1"]],
["concrete syntax",">scribble/reader.html#(part._.Concrete_.Syntax)","Concrete Syntax",false],
["concurrency",">reference/concurrency.html","Concurrency",false],
["cond",">htdp-langs/cond.html",[0,[6,"cond"]],false],
["cond",">reference/if.html#(form._((lib._scheme/private/letstx-scheme..ss)._cond))",[0,[6,"cond"]],["scheme/base","scheme"]],
["cond",">r5rs-std/r5rs-Z-H-7.html#%_idx_108",[0,[6,"cond"]],["r5rs"]],
["cond",">r6rs-std/r6rs-Z-H-14.html#node_idx_376",[0,[1,"cond"]],["rnrs/base-6"]],
["cond",">htdp-langs/advanced-unchanged.html#(form._((lib._lang/htdp-advanced..ss)._cond))",[0,[6,"cond"]],["lang/htdp-advanced"]],
["cond",">htdp-langs/cond.html#(form._((lib._lang/htdp-beginner..ss)._cond))",[0,[6,"cond"]],["lang/htdp-beginner"]],
["cond",">htdp-langs/Unchanged_Forms.html#(form._((lib._lang/htdp-beginner-abbr..ss)._cond))",[0,[6,"cond"]],["lang/htdp-beginner-abbr"]],
["cond",">htdp-langs/intermediate-unchanged.html#(form._((lib._lang/htdp-intermediate..ss)._cond))",[0,[6,"cond"]],["lang/htdp-intermediate"]],
["cond",">htdp-langs/intermediate-lambda-unchanged.html#(form._((lib._lang/htdp-intermediate-lambda..ss)._cond))",[0,[6,"cond"]],["lang/htdp-intermediate-lambda"]],
["cond",">lazy/index.html#(form._((lib._lazy/main..ss)._cond))",[0,[6,"cond"]],["lazy"]],
["cond",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..ss)._cond))",[0,[6,"cond"]],["mzscheme"]],
["condense?",">slideshow/Constants_and_Layout_Variables.html#(def._((lib._slideshow/base..ss)._condense~3f))",[0,[1,"condense?"]],["slideshow/base","slideshow"]],
["condition",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_394",[0,[1,"condition"]],["rnrs/conditions-6"]],
["condition-accessor",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_402",[0,[1,"condition-accessor"]],["rnrs/conditions-6"]],
["condition-irritants",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_450",[0,[1,"condition-irritants"]],["rnrs/conditions-6"]],
["condition-message",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_412",[0,[1,"condition-message"]],["rnrs/conditions-6"]],
["condition-predicate",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_400",[0,[1,"condition-predicate"]],["rnrs/conditions-6"]],
["condition-who",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_458",[0,[1,"condition-who"]],["rnrs/conditions-6"]],
["condition?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_398",[0,[1,"condition?"]],["rnrs/conditions-6"]],
["conditionals",">guide/conditionals.html","Conditionals",false],
["conditionals with if, and, or, and cond",">guide/syntax-overview.html#(part._.Conditionals_with_if__and__or__and_cond)",["Conditionals with ",[0,[6,"if"]],", ",[0,[6,"and"]],", ",[0,[6,"or"]],", and ",[0,[6,"cond"]]],false],
["conditionals: if, cond, and, and or",">reference/if.html",["Conditionals: ",[0,[6,"if"]],", ",[0,[6,"cond"]],", ",[0,[6,"and"]],", and ",[0,[6,"or"]]],false],
["config",">config/index.html#(mod-path._config)",[14,[0,"config"]],"module"],
["config-panel",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e)._config-panel))",[[0,[1,"config-panel"]],[12,[" (method of ",[0,[1,"drscheme:language:language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["config-panel",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3amodule-based-language~3c~25~3e)._config-panel))",[[0,[1,"config-panel"]],[12,[" (method of ",[0,[1,"drscheme:language:module-based-language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["config-panel",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-module-based-language-~3emodule-based-language-mixin)._config-panel))",[[0,[1,"config-panel"]],[12,[" (method of ",[0,[1,"drscheme:language:simple-module-based-language-&gt;module-based-language-mixin"]],")"]]],["drscheme/tool-lib"]],
["config.ss: client configuration",">planet/Utility_Libraries.html#(part._config_ss__.Client_.Configuration)","config.ss: Client Configuration",false],
["config: installation and search paths",">config/index.html","<b>Config</b>: Installation and Search Paths",false],
["configuration",">gui/Configuration.html","Configuration",false],
["configuration",">slideshow/Configuration.html","Configuration",false],
["configuration",">web-server/configuration.html","Configuration",false],
["configuration language",">config/index.html#(part._.Configuration_.Language)","Configuration Language",false],
["configuration options",">reference/running-sa.html#(tech._configuration._option)","<i>Configuration options</i>",false],
["configuration signature",">web-server/web-config-unit_ss.html#(part._.Configuration_.Signature)","Configuration Signature",false],
["configuration table",">web-server/configuration-table_ss.html","Configuration Table",false],
["configuration table structure",">web-server/configuration-table-structs_ss.html","Configuration Table Structure",false],
["configuration units",">web-server/web-config-unit_ss.html#(part._.Configuration_.Units)","Configuration Units",false],
["configuration-table",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._configuration-table))",[0,[1,"configuration-table"]],["web-server/configuration/configuration-table-structs"]],
["configuration-table->sexpr",">web-server/configuration-table_ss.html#(def._((lib._web-server/configuration/configuration-table..ss)._configuration-table-~3esexpr))",[0,[1,"configuration-table-&gt;sexpr"]],["web-server/configuration/configuration-table"]],
["configuration-table->web-config@",">web-server/web-config-unit_ss.html#(def._((lib._web-server/web-config-unit..ss)._configuration-table-~3eweb-config~40))",[0,[1,"configuration-table-&gt;web-config@"]],["web-server/web-config-unit"]],
["configuration-table-default-host",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._configuration-table-default-host))",[0,[1,"configuration-table-default-host"]],["web-server/configuration/configuration-table-structs"]],
["configuration-table-initial-connection-timeout",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._configuration-table-initial-connection-timeout))",[0,[1,"configuration-table-initial-connection-timeout"]],["web-server/configuration/configuration-table-structs"]],
["configuration-table-max-waiting",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._configuration-table-max-waiting))",[0,[1,"configuration-table-max-waiting"]],["web-server/configuration/configuration-table-structs"]],
["configuration-table-port",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._configuration-table-port))",[0,[1,"configuration-table-port"]],["web-server/configuration/configuration-table-structs"]],
["configuration-table-sexpr->web-config@",">web-server/web-config-unit_ss.html#(def._((lib._web-server/web-config-unit..ss)._configuration-table-sexpr-~3eweb-config~40))",[0,[1,"configuration-table-sexpr-&gt;web-config@"]],["web-server/web-config-unit"]],
["configuration-table-virtual-hosts",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._configuration-table-virtual-hosts))",[0,[1,"configuration-table-virtual-hosts"]],["web-server/configuration/configuration-table-structs"]],
["configuration-table?",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._configuration-table~3f))",[0,[1,"configuration-table?"]],["web-server/configuration/configuration-table-structs"]],
["configuring default handling",">reference/exns.html#(part._.Configuring_.Default_.Handling)","Configuring Default Handling",false],
["configuring directories and search paths",">config/index.html#(part._.Configuring_.Directories_and_.Search_.Paths)","Configuring Directories and Search Paths",false],
["conjugate",">reference/numbers.html#(def._((lib._scheme/math..ss)._conjugate))",[0,[1,"conjugate"]],["scheme/math","scheme"]],
["conjugate",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._conjugate))",[0,[1,"conjugate"]],["lang/htdp-advanced"]],
["conjugate",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._conjugate))",[0,[1,"conjugate"]],["lang/htdp-beginner"]],
["conjugate",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._conjugate))",[0,[1,"conjugate"]],["lang/htdp-beginner-abbr"]],
["conjugate",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._conjugate))",[0,[1,"conjugate"]],["lang/htdp-intermediate"]],
["conjugate",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._conjugate))",[0,[1,"conjugate"]],["lang/htdp-intermediate-lambda"]],
["connect",">teachpack/arrow-gui.html#(def._((lib._teachpack/htdp/arrow-gui..ss)._connect))",[0,[1,"connect"]],["teachpack/htdp/arrow-gui"]],
["connect-to-server",">net/nntp.html#(def._((lib._net/nntp..ss)._connect-to-server))",[0,[1,"connect-to-server"]],["net/nntp"]],
["connect-to-server",">net/pop3.html#(def._((lib._net/pop3..ss)._connect-to-server))",[0,[1,"connect-to-server"]],["net/pop3"]],
["connecting and selecting mailboxes",">net/imap.html#(part._.Connecting_and_.Selecting_.Mailboxes)","Connecting and Selecting Mailboxes",false],
["connection",">web-server/connection-manager_ss.html#(def._((lib._web-server/private/connection-manager..ss)._connection))",[0,[1,"connection"]],["web-server/private/connection-manager"]],
["connection and operations",">net/nntp.html#(part._.Connection_and_.Operations)","Connection and Operations",false],
["connection manager",">web-server/connection-manager_ss.html","Connection Manager",false],
["connection threads",">more/index.html#(part._.Connection_.Threads)","Connection Threads",false],
["connection-close?",">web-server/connection-manager_ss.html#(def._((lib._web-server/private/connection-manager..ss)._connection-close~3f))",[0,[1,"connection-close?"]],["web-server/private/connection-manager"]],
["connection-custodian",">web-server/connection-manager_ss.html#(def._((lib._web-server/private/connection-manager..ss)._connection-custodian))",[0,[1,"connection-custodian"]],["web-server/private/connection-manager"]],
["connection-i-port",">web-server/connection-manager_ss.html#(def._((lib._web-server/private/connection-manager..ss)._connection-i-port))",[0,[1,"connection-i-port"]],["web-server/private/connection-manager"]],
["connection-o-port",">web-server/connection-manager_ss.html#(def._((lib._web-server/private/connection-manager..ss)._connection-o-port))",[0,[1,"connection-o-port"]],["web-server/private/connection-manager"]],
["connection-timer",">web-server/connection-manager_ss.html#(def._((lib._web-server/private/connection-manager..ss)._connection-timer))",[0,[1,"connection-timer"]],["web-server/private/connection-manager"]],
["connection?",">web-server/connection-manager_ss.html#(def._((lib._web-server/private/connection-manager..ss)._connection~3f))",[0,[1,"connection?"]],["web-server/private/connection-manager"]],
["cons",">reference/pairs.html#(def._((quote._~23~25kernel)._cons))",[0,[1,"cons"]],["scheme/base","scheme"]],
["cons",">r5rs-std/r5rs-Z-H-9.html#%_idx_408",[0,[1,"cons"]],["r5rs"]],
["cons",">r6rs-std/r6rs-Z-H-14.html#node_idx_610",[0,[1,"cons"]],["rnrs/base-6"]],
["cons",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._cons))",[0,[1,"cons"]],["lang/htdp-advanced"]],
["cons",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._cons))",[0,[1,"cons"]],["lang/htdp-beginner"]],
["cons",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._cons))",[0,[1,"cons"]],["lang/htdp-beginner-abbr"]],
["cons",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._cons))",[0,[1,"cons"]],["lang/htdp-intermediate"]],
["cons",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._cons))",[0,[1,"cons"]],["lang/htdp-intermediate-lambda"]],
["cons",">lazy/index.html#(def._((lib._lazy/main..ss)._cons))",[0,[1,"cons"]],["lazy"]],
["cons",">srfi-std/srfi-1.html#cons",[0,[1,"cons"]],["srfi/1"]],
["cons*",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_240",[0,[1,"cons*"]],["rnrs/lists-6"]],
["cons*",">srfi-std/srfi-1.html#cons*",[0,[1,"cons*"]],["srfi/1"]],
["cons/c",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._cons/c))",[0,[1,"cons/c"]],["scheme/contract","scheme"]],
["cons?",">reference/pairs.html#(def._((lib._scheme/list..ss)._cons~3f))",[0,[1,"cons?"]],["scheme/list","scheme"]],
["cons?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._cons~3f))",[0,[1,"cons?"]],["lang/htdp-advanced"]],
["cons?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._cons~3f))",[0,[1,"cons?"]],["lang/htdp-beginner"]],
["cons?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._cons~3f))",[0,[1,"cons?"]],["lang/htdp-beginner-abbr"]],
["cons?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._cons~3f))",[0,[1,"cons?"]],["lang/htdp-intermediate"]],
["cons?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._cons~3f))",[0,[1,"cons?"]],["lang/htdp-intermediate-lambda"]],
["cons?",">lazy/index.html#(def._((lib._lazy/main..ss)._cons~3f))",[0,[1,"cons?"]],["lazy"]],
["conservative garbage collector",">guide/performance.html#(tech._conservative._garbage._collector)","<i>conservative garbage collector</i>",false],
["constants and layout variables",">slideshow/Constants_and_Layout_Variables.html","Constants and Layout Variables",false],
["constructing graphs: shared",">reference/shared.html",["Constructing Graphs: ",[0,[6,"shared"]]],false],
["constructor",">htdc/Constructor.html",[0,"Constructor"],false],
["constructor",">htdc/advanced_ctor.html",[0,"Constructor"],false],
["constructor",">htdc/intermed_ctor.html",[0,"Constructor"],false],
["constructor",">htdc/intermedAcc_ctor.html",[0,"Constructor"],false],
["constructor",">guide/define-struct.html#(tech._constructor)","<i>constructor</i>",false],
["constructor",">reference/define-struct.html#(tech._constructor)","<i>constructor</i>",false],
["constructor guard",">guide/define-struct.html#(tech._constructor._guard)","<i>constructor guard</i>",false],
["constructor output",">drscheme/output-syntax.html#(idx._(gentag._55._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Constructor</font></b> output",false],
["constructor-style-printing",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..ss)._constructor-style-printing))",[0,[1,"constructor-style-printing"]],["mzlib/pconvert"]],
["consumer-thread",">mzlib/mzlib_thread.html#(def._((lib._mzlib/thread..ss)._consumer-thread))",[0,[1,"consumer-thread"]],["mzlib/thread"]],
["containees",">gui/windowing-overview.html#(part._containees)","Containees",false],
["containees",">gui/windowing-overview.html#(tech._containee)","<i>Containees</i>",false],
["container-flow-modified",">gui/area-container___.html#(meth._(((lib._mred/main..ss)._area-container~3c~25~3e)._container-flow-modified))",[[0,[1,"container-flow-modified"]],[12,[" (method of ",[0,[1,"area-container&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["container-size",">gui/area-container___.html#(meth._(((lib._mred/main..ss)._area-container~3c~25~3e)._container-size))",[[0,[1,"container-size"]],[12,[" (method of ",[0,[1,"area-container&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["container-size",">framework/Panel.html#(meth._(((lib._framework/main..ss)._panel~3adragable-mixin)._container-size))",[[0,[1,"container-size"]],[12,[" (method of ",[0,[1,"panel:dragable-mixin"]],")"]]],["framework"]],
["container-size",">framework/Panel.html#(meth._(((lib._framework/main..ss)._panel~3asingle-mixin)._container-size))",[[0,[1,"container-size"]],[12,[" (method of ",[0,[1,"panel:single-mixin"]],")"]]],["framework"]],
["container-size",">framework/Panel.html#(meth._(((lib._framework/main..ss)._panel~3asingle-window-mixin)._container-size))",[[0,[1,"container-size"]],[12,[" (method of ",[0,[1,"panel:single-window-mixin"]],")"]]],["framework"]],
["containers",">embedded-gui/containers.html","Containers",false],
["containers",">gui/windowing-overview.html#(part._containers)","Containers",false],
["containers",">gui/windowing-overview.html#(tech._container)","<i>Containers</i>",false],
["content",">scribble/struct.html#(tech._content)","<i>content</i>",false],
["content->string",">scribble/struct.html#(def._((lib._scribble/struct..ss)._content-~3estring))",[0,[1,"content-&gt;string"]],["scribble/struct"]],
["content?",">xml/index.html#(def._((lib._xml/main..ss)._content~3f))",[0,[1,"content?"]],["xml"]],
["context",">reference/syntax-model.html#(tech._context)","<i>context</i>",false],
["context procedures",">openssl/index.html#(part._cert-procs)","Context Procedures",false],
["context-closure",">redex/Reduction_Relations.html#(form._((lib._redex/main..ss)._context-closure))",[0,[6,"context-closure"]],["redex"]],
["continuation",">guide/Continuations.html#(tech._continuation)","<i>continuation</i>",false],
["continuation",">reference/eval-model.html#(tech._continuation)","<i>continuation</i>",false],
["continuation barrier",">reference/eval-model.html#(tech._continuation._barrier)","<i>continuation barrier</i>",false],
["continuation frames",">reference/eval-model.html#(tech._continuation._frame)","<i>continuation frames</i>",false],
["continuation frames and marks",">reference/eval-model.html#(part._mark-model)","Continuation Frames and Marks",false],
["continuation managers",">web-server/managers.html","Continuation Managers",false],
["continuation marks",">inside/contmarks.html","Continuation Marks",false],
["continuation marks",">reference/contmarks.html","Continuation Marks",false],
["continuation marks",">reference/eval-model.html#(tech._continuation._mark)","<i>continuation marks</i>",false],
["continuation marks: with-continuation-mark",">reference/wcm.html",["Continuation Marks: ",[0,[6,"with-continuation-mark"]]],false],
["continuation-mark-set->context",">reference/contmarks.html#(def._((quote._~23~25kernel)._continuation-mark-set-~3econtext))",[0,[1,"continuation-mark-set-&gt;context"]],["scheme/base","scheme"]],
["continuation-mark-set->list",">reference/contmarks.html#(def._((quote._~23~25kernel)._continuation-mark-set-~3elist))",[0,[1,"continuation-mark-set-&gt;list"]],["scheme/base","scheme"]],
["continuation-mark-set->list*",">reference/contmarks.html#(def._((quote._~23~25kernel)._continuation-mark-set-~3elist*))",[0,[1,"continuation-mark-set-&gt;list*"]],["scheme/base","scheme"]],
["continuation-mark-set-first",">reference/contmarks.html#(def._((quote._~23~25kernel)._continuation-mark-set-first))",[0,[1,"continuation-mark-set-first"]],["scheme/base","scheme"]],
["continuation-mark-set?",">reference/contmarks.html#(def._((quote._~23~25kernel)._continuation-mark-set~3f))",[0,[1,"continuation-mark-set?"]],["scheme/base","scheme"]],
["continuation-marks",">reference/contmarks.html#(def._((quote._~23~25kernel)._continuation-marks))",[0,[1,"continuation-marks"]],["scheme/base","scheme"]],
["continuation-prompt-available?",">reference/cont.html#(def._((quote._~23~25kernel)._continuation-prompt-available~3f))",[0,[1,"continuation-prompt-available?"]],["scheme/base","scheme"]],
["continuation-prompt-tag?",">reference/cont.html#(def._((quote._~23~25kernel)._continuation-prompt-tag~3f))",[0,[1,"continuation-prompt-tag?"]],["scheme/base","scheme"]],
["continuation-url?",">web-server/web_ss.html#(def._((lib._web-server/servlet/web..ss)._continuation-url~3f))",[0,[1,"continuation-url?"]],["web-server/servlet/web"]],
["continuation?",">reference/cont.html#(def._((quote._~23~25kernel)._continuation~3f))",[0,[1,"continuation?"]],["scheme/base","scheme"]],
["continuations",">guide/Continuations.html","Continuations",false],
["continuations",">more/index.html#(part._.Continuations)","Continuations",false],
["continuations",">reference/cont.html","Continuations",false],
["continuations",">inside/exceptions.html#(idx._(gentag._281._(lib._scribblings/inside/inside..scrbl)))","continuations",false],
["continue: web applications in plt scheme",">continue/index.html","<b>Continue</b>: Web Applications in PLT Scheme",false],
["continues",">reference/bytestrings.html#(idx._(gentag._31._(lib._scribblings/reference/reference..scrbl)))",[7,"'continues"],false],
["continues",">reference/bytestrings.html#(idx._(gentag._35._(lib._scribblings/reference/reference..scrbl)))",[7,"'continues"],false],
["contour",">plot/plot.html#(def._((lib._plot/main..ss)._contour))",[0,[1,"contour"]],["plot"]],
["contract",">reference/Attaching_Contracts_to_Values.html#(form._((lib._scheme/private/contract..ss)._contract))",[0,[6,"contract"]],["scheme/contract","scheme"]],
["contract error messages that contain \"???\"",">guide/contracts-general-functions.html#(part._contracts-flat-named-contracts)","Contract Error Messages that Contain &ldquo;???&rdquo;",false],
["contract utilities",">reference/Contract_Utilities.html","Contract Utilities",false],
["contract-first-order-passes?",">reference/Contract_Utilities.html#(def._((lib._scheme/private/contract-guts..ss)._contract-first-order-passes~3f))",[0,[1,"contract-first-order-passes?"]],["scheme/contract","scheme"]],
["contract-violation->string",">reference/Contract_Utilities.html#(def._((lib._scheme/private/contract-guts..ss)._contract-violation-~3estring))",[0,[1,"contract-violation-&gt;string"]],["scheme/contract","scheme"]],
["contract?",">reference/Contract_Utilities.html#(def._((lib._scheme/private/contract-guts..ss)._contract~3f))",[0,[1,"contract?"]],["scheme/contract","scheme"]],
["contracts",">guide/contracts.html","Contracts",false],
["contracts",">reference/contracts.html","Contracts",false],
["contracts",">web-server/util_ss.html#(part._.Contracts)","Contracts",false],
["contracts",">web-server/servlet-structs_ss.html","Contracts",false],
["contracts",">reference/contracts.html#(tech._contract)","<i>Contracts</i>",false],
["contracts and boundaries",">guide/contract-boundaries.html","Contracts and Boundaries",false],
["contracts and eq?",">guide/contracts-gotchas.html#(part._.Contracts_and_eq_)",["Contracts and ",[0,[1,"eq?"]]],false],
["contracts coerced from other values",">guide/contract-func.html#(part._contracts-coercion)","Contracts Coerced from Other Values",false],
["contracts for case-lambda",">guide/contracts-general-functions.html#(part._contracts-case-lambda)",["Contracts for ",[0,[6,"case-lambda"]]],false],
["contracts on functions in general",">guide/contracts-general-functions.html","Contracts on Functions in General",false],
["contracts on higher-order functions",">guide/contract-func.html#(part._.Contracts_on_.Higher-order_.Functions)","Contracts on Higher-order Functions",false],
["contracts on structures",">guide/contracts-struct.html","Contracts on Structures",false],
["control",">reference/cont.html#(form._((lib._scheme/control..ss)._control))",[0,[6,"control"]],["scheme/control"]],
["control",">teachpack/arrow.html#(def._((lib._teachpack/htdp/arrow..ss)._control))",[0,[1,"control"]],["teachpack/htdp/arrow"]],
["control",">teachpack/arrow-gui.html#(def._((lib._teachpack/htdp/arrow-gui..ss)._control))",[0,[1,"control"]],["teachpack/htdp/arrow-gui"]],
["control",">gui/key-event_.html#(idx._(gentag._50._(lib._scribblings/gui/gui..scrbl)))",[7,"'control"],false],
["control flow",">reference/control.html","Control Flow",false],
["control snips",">embedded-gui/control-snips.html","Control Snips",false],
["control-at",">reference/cont.html#(form._((lib._scheme/control..ss)._control-at))",[0,[6,"control-at"]],["scheme/control"]],
["control-event%",">gui/control-event_.html",[0,[1,"control-event%"]],["scheme/gui/base","scheme/gui"]],
["control-left-right",">teachpack/arrow.html#(def._((lib._teachpack/htdp/arrow..ss)._control-left-right))",[0,[1,"control-left-right"]],["teachpack/htdp/arrow"]],
["control-up-down",">teachpack/arrow.html#(def._((lib._teachpack/htdp/arrow..ss)._control-up-down))",[0,[1,"control-up-down"]],["teachpack/htdp/arrow"]],
["control0",">reference/cont.html#(form._((lib._scheme/control..ss)._control0))",[0,[6,"control0"]],["scheme/control"]],
["control0-at",">reference/cont.html#(form._((lib._scheme/control..ss)._control0-at))",[0,[6,"control0-at"]],["scheme/control"]],
["control<%>",">gui/control___.html",[0,[1,"control&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["controlling an elevator: \"elevator.ss\"",">teachpack/elevator.html",["Controlling an Elevator: ",[5,"\"elevator.ss\""],"<a name=\"(idx._(gentag._13._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["controlling setup-plt with \"info.ss\" files",">setup-plt/running.html#(part._setup-info)",["Controlling ",[5,"setup-plt"]," with ",[5,"\"info.ss\""]," Files"],false],
["controlling the scope of external names",">guide/classes.html#(part._extnames)","Controlling the Scope of External Names",false],
["controls",">embedded-gui/controls.html","Controls",false],
["controls",">games/gobblet.html#(part._.Controls)","Controls",false],
["controls",">gui/windowing-overview.html#(tech._control)","<i>Controls</i>",false],
["convert",">gui/style-list_.html#(meth._(((lib._mred/main..ss)._style-list~25)._convert))",[[0,[1,"convert"]],[12,[" (method of ",[0,[1,"style-list%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["convert teachpack",">teachpack/convert.html#(idx._(gentag._2._(lib._teachpack/teachpack..scrbl)))","convert teachpack",false],
["convert-file",">teachpack/convert.html#(def._((lib._teachpack/htdp/convert..ss)._convert-file))",[0,[1,"convert-file"]],["teachpack/htdp/convert"]],
["convert-gui",">teachpack/convert.html#(def._((lib._teachpack/htdp/convert..ss)._convert-gui))",[0,[1,"convert-gui"]],["teachpack/htdp/convert"]],
["convert-repl",">teachpack/convert.html#(def._((lib._teachpack/htdp/convert..ss)._convert-repl))",[0,[1,"convert-repl"]],["teachpack/htdp/convert"]],
["convert-stream",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._convert-stream))",[0,[1,"convert-stream"]],["scheme/port"]],
["converting temperatures: \"convert.ss\"",">teachpack/convert.html",["Converting Temperatures: ",[5,"\"convert.ss\""],"<a name=\"(idx._(gentag._2._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["converting yacc or bison grammars",">parser-tools/Converting_yacc_or_bison_Grammars.html",["Converting ",[5,"yacc"]," or ",[5,"bison"]," Grammars"],false],
["cookie signature",">net/cookie.html#(part._.Cookie_.Signature)","Cookie Signature",false],
["cookie unit",">net/cookie.html#(part._.Cookie_.Unit)","Cookie Unit",false],
["cookie-error",">net/cookie.html#(def._((lib._net/cookie..ss)._cookie-error))",[0,[1,"cookie-error"]],["net/cookie"]],
["cookie-error?",">net/cookie.html#(def._((lib._net/cookie..ss)._cookie-error~3f))",[0,[1,"cookie-error?"]],["net/cookie"]],
["cookie: http client storage",">net/cookie.html","Cookie: HTTP Client Storage",false],
["cookie:add-comment",">net/cookie.html#(def._((lib._net/cookie..ss)._cookie~3aadd-comment))",[0,[1,"cookie:add-comment"]],["net/cookie"]],
["cookie:add-domain",">net/cookie.html#(def._((lib._net/cookie..ss)._cookie~3aadd-domain))",[0,[1,"cookie:add-domain"]],["net/cookie"]],
["cookie:add-max-age",">net/cookie.html#(def._((lib._net/cookie..ss)._cookie~3aadd-max-age))",[0,[1,"cookie:add-max-age"]],["net/cookie"]],
["cookie:add-path",">net/cookie.html#(def._((lib._net/cookie..ss)._cookie~3aadd-path))",[0,[1,"cookie:add-path"]],["net/cookie"]],
["cookie:secure",">net/cookie.html#(def._((lib._net/cookie..ss)._cookie~3asecure))",[0,[1,"cookie:secure"]],["net/cookie"]],
["cookie:version",">net/cookie.html#(def._((lib._net/cookie..ss)._cookie~3aversion))",[0,[1,"cookie:version"]],["net/cookie"]],
["cookie?",">net/cookie.html#(def._((lib._net/cookie..ss)._cookie~3f))",[0,[1,"cookie?"]],["net/cookie"]],
["cookie@",">net/cookie.html#(def._((lib._net/cookie-unit..ss)._cookie~40))",[0,[1,"cookie@"]],["net/cookie-unit"]],
["cookie^",">net/cookie.html#(form._((lib._net/cookie-sig..ss)._cookie~5e))",[0,[6,"cookie^"]],["net/cookie-sig"]],
["cooperating with 3m",">inside/im_memoryalloc.html#(part._im~3a3m)","Cooperating with 3m",false],
["copy",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._copy))",[[0,[1,"copy"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["copy",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._copy))",[[0,[1,"copy"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["copy",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._copy))",[[0,[1,"copy"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["copy",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._copy))",[[0,[1,"copy"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["copy",">framework/editor-snip.html#(meth._(((lib._framework/main..ss)._editor-snip~3adecorated~25)._copy))",[[0,[1,"copy"]],[12,[" (method of ",[0,[1,"editor-snip:decorated%"]],")"]]],["framework"]],
["copy",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3asexp-snip~25)._copy))",[[0,[1,"copy"]],[12,[" (method of ",[0,[1,"scheme:sexp-snip%"]],")"]]],["framework"]],
["copy",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3a1-pixel-string-snip~25)._copy))",[[0,[1,"copy"]],[12,[" (method of ",[0,[1,"text:1-pixel-string-snip%"]],")"]]],["framework"]],
["copy",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3a1-pixel-tab-snip~25)._copy))",[[0,[1,"copy"]],[12,[" (method of ",[0,[1,"text:1-pixel-tab-snip%"]],")"]]],["framework"]],
["copy",">cards/index.html#(meth._(((lib._games/cards..ss)._card~3c~25~3e)._copy))",[[0,[1,"copy"]],[12,[" (method of ",[0,[1,"card&lt;%&gt;"]],")"]]],["games/cards"]],
["copy menu item",">drscheme/Menus.html#(idx._(gentag._79._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Copy</font></b> menu item",false],
["copy-click-region",">framework/Keymap.html#(idx._(gentag._33._(lib._scribblings/framework/framework..scrbl)))","copy-click-region",false],
["copy-clipboard",">framework/Keymap.html#(idx._(gentag._30._(lib._scribblings/framework/framework..scrbl)))","copy-clipboard",false],
["copy-directory/files",">reference/Filesystem.html#(def._((lib._scheme/file..ss)._copy-directory/files))",[0,[1,"copy-directory/files"]],["scheme/file","scheme"]],
["copy-file",">reference/Filesystem.html#(def._((quote._~23~25kernel)._copy-file))",[0,[1,"copy-file"]],["scheme/base","scheme"]],
["copy-from",">gui/color_.html#(meth._(((lib._mred/main..ss)._color~25)._copy-from))",[[0,[1,"copy-from"]],[12,[" (method of ",[0,[1,"color%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["copy-from",">gui/ps-setup_.html#(meth._(((lib._mred/main..ss)._ps-setup~25)._copy-from))",[[0,[1,"copy-from"]],[12,[" (method of ",[0,[1,"ps-setup%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["copy-port",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._copy-port))",[0,[1,"copy-port"]],["scheme/port"]],
["copy-self",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._copy-self))",[[0,[1,"copy-self"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["copy-self-to",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._copy-self-to))",[[0,[1,"copy-self-to"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["copy-self-to",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._copy-self-to))",[[0,[1,"copy-self-to"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["copy-self-to",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._copy-self-to))",[[0,[1,"copy-self-to"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["copy-struct",">mzlib/mzlib_struct.html#(form._((lib._mzlib/struct..ss)._copy-struct))",[0,[6,"copy-struct"]],["mzlib/struct"]],
["copy-time",">srfi-std/srfi-19.html#copy-time",[0,[1,"copy-time"]],["srfi/19"]],
["copy-viewport",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._copy-viewport))",[0,[1,"copy-viewport"]],["graphics/graphics"]],
["copying and update",">guide/define-struct.html#(part._struct-copy)","Copying and Update",false],
["copying and updating structures",">reference/struct-copy.html","Copying and Updating Structures",false],
["copying streams",">reference/More_Port_Constructors_and_Events.html#(part._.Copying_.Streams)","Copying Streams",false],
["core windowing classes",">gui/windowing-overview.html#(part._.Core_.Windowing_.Classes)","Core Windowing Classes",false],
["coroutine",">mzlib/mzlib_thread.html#(def._((lib._mzlib/thread..ss)._coroutine))",[0,[1,"coroutine"]],["mzlib/thread"]],
["coroutine-kill",">mzlib/mzlib_thread.html#(def._((lib._mzlib/thread..ss)._coroutine-kill))",[0,[1,"coroutine-kill"]],["mzlib/thread"]],
["coroutine-result",">mzlib/mzlib_thread.html#(def._((lib._mzlib/thread..ss)._coroutine-result))",[0,[1,"coroutine-result"]],["mzlib/thread"]],
["coroutine-run",">mzlib/mzlib_thread.html#(def._((lib._mzlib/thread..ss)._coroutine-run))",[0,[1,"coroutine-run"]],["mzlib/thread"]],
["coroutine?",">mzlib/mzlib_thread.html#(def._((lib._mzlib/thread..ss)._coroutine~3f))",[0,[1,"coroutine?"]],["mzlib/thread"]],
["correct-xexpr?",">xml/index.html#(def._((lib._xml/main..ss)._correct-xexpr~3f))",[0,[1,"correct-xexpr?"]],["xml"]],
["cos",">reference/numbers.html#(def._((quote._~23~25kernel)._cos))",[0,[1,"cos"]],["scheme/base","scheme"]],
["cos",">r5rs-std/r5rs-Z-H-9.html#%_idx_332",[0,[1,"cos"]],["r5rs"]],
["cos",">r6rs-std/r6rs-Z-H-14.html#node_idx_548",[0,[1,"cos"]],["rnrs/base-6"]],
["cos",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._cos))",[0,[1,"cos"]],["lang/htdp-advanced"]],
["cos",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._cos))",[0,[1,"cos"]],["lang/htdp-beginner"]],
["cos",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._cos))",[0,[1,"cos"]],["lang/htdp-beginner-abbr"]],
["cos",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._cos))",[0,[1,"cos"]],["lang/htdp-intermediate"]],
["cos",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._cos))",[0,[1,"cos"]],["lang/htdp-intermediate-lambda"]],
["cosh",">reference/numbers.html#(def._((lib._scheme/math..ss)._cosh))",[0,[1,"cosh"]],["scheme/math","scheme"]],
["cosh",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._cosh))",[0,[1,"cosh"]],["lang/htdp-advanced"]],
["cosh",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._cosh))",[0,[1,"cosh"]],["lang/htdp-beginner"]],
["cosh",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._cosh))",[0,[1,"cosh"]],["lang/htdp-beginner-abbr"]],
["cosh",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._cosh))",[0,[1,"cosh"]],["lang/htdp-intermediate"]],
["cosh",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._cosh))",[0,[1,"cosh"]],["lang/htdp-intermediate-lambda"]],
["count",">srfi-std/srfi-1.html#count",[0,[1,"count"]],["srfi/1"]],
["count",">gui/editor-overview.html#(tech._count)","<i>count</i>",false],
["counting positions, lines, and columns",">reference/linecol.html","Counting Positions, Lines, and Columns",false],
["coverage",">errortrace/using-errortrace.html#(part._coverage)","Coverage",false],
["coverage-counts-enabled",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..ss)._coverage-counts-enabled))",[0,[1,"coverage-counts-enabled"]],["errortrace"]],
["cpointer-has-tag?",">foreign/Derived_Utilities.html#(def._((lib._scribblings/foreign/unsafe-foreign..ss)._cpointer-has-tag~3f))",[0,[1,"cpointer-has-tag?"]],["scribblings/foreign/unsafe-foreign"]],
["cpointer-push-tag!",">foreign/Derived_Utilities.html#(def._((lib._scribblings/foreign/unsafe-foreign..ss)._cpointer-push-tag!))",[0,[1,"cpointer-push-tag!"]],["scribblings/foreign/unsafe-foreign"]],
["cpointer-tag",">foreign/foreign_pointer-funcs.html#(def._((lib._scribblings/foreign/unsafe-foreign..ss)._cpointer-tag))",[0,[1,"cpointer-tag"]],["scribblings/foreign/unsafe-foreign"]],
["cpointer?",">foreign/foreign_pointer-funcs.html#(def._((lib._scheme/foreign..ss)._cpointer~3f))",[0,[1,"cpointer?"]],["scheme/foreign"]],
["crazy 8s --- card game",">games/crazy8s.html",[[13,"<img src=\"crazy8s.png\" />"]," ","<b><font size=\"-1\" face=\"Helvetica\">Crazy 8s</font></b>","  ","&ndash;","  Card Game"],false],
["create",">planet/cmdline.html#(part._create)",[5,"create"],false],
["create an \"info.ss\" file [optional]",">planet/Developing_Packages_for_PLaneT.html#(part._.Create_an__info_ss__.File__.Optional_)",["Create an ",[5,"\"info.ss\""]," File [Optional]"],false],
["create documentation [optional]",">planet/Developing_Packages_for_PLaneT.html#(part._.Create_.Documentation__.Optional_)","Create Documentation [Optional]",false],
["create executable... menu item",">drscheme/Menus.html#(idx._(gentag._123._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Create Executable...</font></b> menu item",false],
["create-dir",">teachpack/dir.html#(def._((lib._teachpack/htdp/dir..ss)._create-dir))",[0,[1,"create-dir"]],["teachpack/htdp/dir"]],
["create-embedding-executable",">mzc/exe.html#(def._((lib._compiler/embed..ss)._create-embedding-executable))",[0,[1,"create-embedding-executable"]],["compiler/embed"]],
["create-executable",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e)._create-executable))",[[0,[1,"create-executable"]],[12,[" (method of ",[0,[1,"drscheme:language:language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["create-lru-manager",">web-server/lru_ss.html#(def._((lib._web-server/managers/lru..ss)._create-.L.R.U-manager))",[0,[1,"create-LRU-manager"]],["web-server/managers/lru"]],
["create-none-manager",">web-server/none_ss.html#(def._((lib._web-server/managers/none..ss)._create-none-manager))",[0,[1,"create-none-manager"]],["web-server/managers/none"]],
["create-status-line",">gui/frame_.html#(meth._(((lib._mred/main..ss)._frame~25)._create-status-line))",[[0,[1,"create-status-line"]],[12,[" (method of ",[0,[1,"frame%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["create-status-pane",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._create-status-pane))",[[0,[1,"create-status-pane"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["create-timeout-manager",">web-server/timeouts_ss.html#(def._((lib._web-server/managers/timeouts..ss)._create-timeout-manager))",[0,[1,"create-timeout-manager"]],["web-server/managers/timeouts"]],
["create-window",">teachpack/gui.html#(def._((lib._teachpack/htdp/gui..ss)._create-window))",[0,[1,"create-window"]],["teachpack/htdp/gui"]],
["creating a cookie",">net/cookie.html#(part._.Creating_a_cookie)","Creating a cookie",false],
["creating a lexer",">parser-tools/Lexers.html#(part._.Creating_a_.Lexer)","Creating a Lexer",false],
["creating and distributing stand-alone executables",">mzc/sa.html","Creating and Distributing Stand-Alone Executables",false],
["creating and installing namespaces",">guide/mk-namespace.html#(part._.Creating_and_.Installing_.Namespaces)","Creating and Installing Namespaces",false],
["creating and setting the eventspace",">gui/windowing-overview.html#(part._currenteventspace)","Creating and Setting the Eventspace",false],
["creating basic shapes",">teachpack/image.html#(part._creational)","Creating Basic Shapes",false],
["creating classes",">reference/createclass.html","Creating Classes",false],
["creating custom plots",">plot/Quick_Start.html#(part._.Creating_.Custom_.Plots)","Creating Custom Plots",false],
["creating executables",">drscheme/create-exe.html","Creating Executables",false],
["creating executables",">guide/intro.html#(part._.Creating_.Executables)","Creating Executables",false],
["creating interfaces",">reference/createinterface.html","Creating Interfaces",false],
["creating launchers",">mzc/launcher.html#(part._.Creating_.Launchers)","Creating Launchers",false],
["creating loggers",">reference/logging.html#(part._.Creating_.Loggers)","Creating Loggers",false],
["creating new kinds of drscheme frames",">tools/Creating_New_Kinds_of_DrScheme_Frames.html","Creating New Kinds of DrScheme Frames",false],
["creating objects",">reference/objcreation.html","Creating Objects",false],
["creating ports",">reference/More_Port_Constructors_and_Events.html#(part._.Creating_.Ports)","Creating Ports",false],
["creating slide presentations",">slideshow/Creating_Slide_Presentations.html","Creating Slide Presentations",false],
["creating stand-alone executables",">guide/exe.html","Creating Stand-Alone Executables",false],
["creating structure types",">reference/creatingmorestructs.html","Creating Structure Types",false],
["creating tables and cards",">cards/index.html#(part._.Creating_.Tables_and_.Cards)","Creating Tables and Cards",false],
["creating threads",">reference/threads.html#(part._.Creating_.Threads)","Creating Threads",false],
["creating units",">reference/creatingunits.html","Creating Units",false],
["cross",">web-server/Functional_Usage.html#(def._((lib._web-server/formlets/lib..ss)._cross))",[0,[1,"cross"]],["web-server/formlets/lib"]],
["cross",">redex/Patterns.html#(tech._cros)","<i>cross</i>",false],
["cross*",">web-server/Functional_Usage.html#(def._((lib._web-server/formlets/lib..ss)._cross*))",[0,[1,"cross*"]],["web-server/formlets/lib"]],
["cross-hatch",">gui/brush_.html#(idx._(gentag._186._(lib._scribblings/gui/gui..scrbl)))",[7,"'cross-hatch"],false],
["cross-reference utilities",">scribble/xref.html","Cross-Reference Utilities",false],
["cross-references for installed manuals",">setup-plt/xref.html","Cross-References for Installed Manuals",false],
["crossdiag-hatch",">gui/brush_.html#(idx._(gentag._184._(lib._scribblings/gui/gui..scrbl)))",[7,"'crossdiag-hatch"],false],
["cs",">reference/characters.html#(idx._(gentag._63._(lib._scribblings/reference/reference..scrbl)))",[7,"'cs"],false],
["css",">mysterx/CSS.html","CSS",false],
["css-length",">mysterx/CSS.html#(def._((lib._mysterx/main..ss)._css-length))",[0,[1,"css-length"]],["mysterx"]],
["css-length-num",">mysterx/CSS.html#(def._((lib._mysterx/main..ss)._css-length-num))",[0,[1,"css-length-num"]],["mysterx"]],
["css-length-units",">mysterx/CSS.html#(def._((lib._mysterx/main..ss)._css-length-units))",[0,[1,"css-length-units"]],["mysterx"]],
["css-length?",">mysterx/CSS.html#(def._((lib._mysterx/main..ss)._css-length~3f))",[0,[1,"css-length?"]],["mysterx"]],
["css-percentage",">mysterx/CSS.html#(def._((lib._mysterx/main..ss)._css-percentage))",[0,[1,"css-percentage"]],["mysterx"]],
["css-percentage-num",">mysterx/CSS.html#(def._((lib._mysterx/main..ss)._css-percentage-num))",[0,[1,"css-percentage-num"]],["mysterx"]],
["css-percentage?",">mysterx/CSS.html#(def._((lib._mysterx/main..ss)._css-percentage~3f))",[0,[1,"css-percentage?"]],["mysterx"]],
["css-text-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._css-text-native))",[[0,[1,"css-text-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["ct-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..ss)._ct-find))",[0,[1,"ct-find"]],["slideshow/pict","slideshow"]],
["ct-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..ss)._ct-superimpose))",[0,[1,"ct-superimpose"]],["slideshow/pict","slideshow"]],
["ctl-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..ss)._ctl-find))",[0,[1,"ctl-find"]],["slideshow/pict","slideshow"]],
["ctl-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..ss)._ctl-superimpose))",[0,[1,"ctl-superimpose"]],["slideshow/pict","slideshow"]],
["ctrl-key",">mysterx/html-events.html#(meth._(((lib._mysterx/main..ss)._mx-event~3c~25~3e)._ctrl-key))",[[0,[1,"ctrl-key"]],[12,[" (method of ",[0,[1,"mx-event&lt;%&gt;"]],")"]]],["mysterx"]],
["ctype-alignof",">foreign/Type_Constructors.html#(def._((lib._scheme/foreign..ss)._ctype-alignof))",[0,[1,"ctype-alignof"]],["scheme/foreign"]],
["ctype-basetype",">foreign/foreign_c-only.html#(def._((quote._~23~25foreign)._ctype-basetype))",[0,[1,"ctype-basetype"]],["'#%foreign"]],
["ctype-c->scheme",">foreign/foreign_c-only.html#(def._((quote._~23~25foreign)._ctype-c-~3escheme))",[0,[1,"ctype-c-&gt;scheme"]],["'#%foreign"]],
["ctype-scheme->c",">foreign/foreign_c-only.html#(def._((quote._~23~25foreign)._ctype-scheme-~3ec))",[0,[1,"ctype-scheme-&gt;c"]],["'#%foreign"]],
["ctype-sizeof",">foreign/Type_Constructors.html#(def._((lib._scheme/foreign..ss)._ctype-sizeof))",[0,[1,"ctype-sizeof"]],["scheme/foreign"]],
["ctype?",">foreign/Type_Constructors.html#(def._((lib._scheme/foreign..ss)._ctype~3f))",[0,[1,"ctype?"]],["scheme/foreign"]],
["cube operations",">games/gcalc.html#(part._.Cube_operations)","Cube operations",false],
["cue-text%",">embedded-gui/Helpers.html#(def._((lib._embedded-gui/main..ss)._cue-text~25))",[0,[1,"cue-text%"]],["embedded-gui"]],
["cue-text-mixin",">embedded-gui/Helpers.html#(def._((lib._embedded-gui/main..ss)._cue-text-mixin))",[0,[1,"cue-text-mixin"]],["embedded-gui"]],
["cupto",">reference/cont.html#(form._((lib._scheme/control..ss)._cupto))",[0,[6,"cupto"]],["scheme/control"]],
["curly-quotes-for-strings",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._curly-quotes-for-strings))",[0,[1,"curly-quotes-for-strings"]],["redex/pict"]],
["current continuation",">guide/Continuations.html#(tech._current._continuation)","<i>current continuation</i>",false],
["current custodian",">reference/eval-model.html#(tech._current._custodian)","<i>current custodian</i>",false],
["current eventspace",">gui/windowing-overview.html#(tech._current._eventspace)","<i>current eventspace</i>",false],
["current logger",">reference/logging.html#(tech._current._logger)","<i>current logger</i>",false],
["current namespace",">guide/eval.html#(tech._current._namespace)","<i>current namespace</i>",false],
["current namespace",">reference/syntax-model.html#(tech._current._namespace)","<i>current namespace</i>",false],
["current working directory",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._473._(lib._scribblings/inside/inside..scrbl)))","current working directory",false],
["current-alist-separator-mode",">net/uri-codec.html#(def._((lib._net/uri-codec..ss)._current-alist-separator-mode))",[0,[1,"current-alist-separator-mode"]],["net/uri-codec"]],
["current-base-color",">slideshow/Typesetting_Scheme_Code.html#(def._((lib._slideshow/code..ss)._current-base-color))",[0,[1,"current-base-color"]],["slideshow/code"]],
["current-break-parameterization",">reference/breakhandler.html#(def._((lib._scheme/private/more-scheme..ss)._current-break-parameterization))",[0,[1,"current-break-parameterization"]],["scheme/base","scheme"]],
["current-build-share-hook",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..ss)._current-build-share-hook))",[0,[1,"current-build-share-hook"]],["mzlib/pconvert"]],
["current-build-share-name-hook",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..ss)._current-build-share-name-hook))",[0,[1,"current-build-share-name-hook"]],["mzlib/pconvert"]],
["current-cache-contents",">planet/Utility_Libraries.html#(def._((lib._planet/util..ss)._current-cache-contents))",[0,[1,"current-cache-contents"]],["planet/util"]],
["current-code-font",">slideshow/Typesetting_Scheme_Code.html#(def._((lib._slideshow/code..ss)._current-code-font))",[0,[1,"current-code-font"]],["slideshow/code"]],
["current-code-inspector",">reference/modprotect.html#(def._((quote._~23~25kernel)._current-code-inspector))",[0,[1,"current-code-inspector"]],["scheme/base","scheme"]],
["current-code-line-sep",">slideshow/Typesetting_Scheme_Code.html#(def._((lib._slideshow/code..ss)._current-code-line-sep))",[0,[1,"current-code-line-sep"]],["slideshow/code"]],
["current-code-tt",">slideshow/Typesetting_Scheme_Code.html#(def._((lib._slideshow/code..ss)._current-code-tt))",[0,[1,"current-code-tt"]],["slideshow/code"]],
["current-command-line-arguments",">reference/runtime.html#(def._((quote._~23~25kernel)._current-command-line-arguments))",[0,[1,"current-command-line-arguments"]],["scheme/base","scheme"]],
["current-command-line-arguments",">reference/running-sa.html#(idx._(gentag._392._(lib._scribblings/reference/reference..scrbl)))",[0,[1,"current-command-line-arguments"]],false],
["current-comment-color",">slideshow/Typesetting_Scheme_Code.html#(def._((lib._slideshow/code..ss)._current-comment-color))",[0,[1,"current-comment-color"]],["slideshow/code"]],
["current-compile",">reference/Evaluation_and_Compilation.html#(def._((quote._~23~25kernel)._current-compile))",[0,[1,"current-compile"]],["scheme/base","scheme"]],
["current-compiler-dynamic-require-wrapper",">mzc/Scheme_API_for_Compilation.html#(def._((lib._compiler/compiler..ss)._current-compiler-dynamic-require-wrapper))",[0,[1,"current-compiler-dynamic-require-wrapper"]],["compiler/compiler"]],
["current-const-color",">slideshow/Typesetting_Scheme_Code.html#(def._((lib._slideshow/code..ss)._current-const-color))",[0,[1,"current-const-color"]],["slideshow/code"]],
["current-const-list",">slideshow/Typesetting_Scheme_Code.html#(def._((lib._slideshow/code..ss)._current-const-list))",[0,[1,"current-const-list"]],["slideshow/code"]],
["current-continuation-marks",">reference/contmarks.html#(def._((quote._~23~25kernel)._current-continuation-marks))",[0,[1,"current-continuation-marks"]],["scheme/base","scheme"]],
["current-country",">srfi-std/srfi-29.html#current-country",[0,[1,"current-country"]],["srfi/29"]],
["current-custodian",">reference/custodians.html#(def._((quote._~23~25kernel)._current-custodian))",[0,[1,"current-custodian"]],["scheme/base","scheme"]],
["current-date",">srfi-std/srfi-19.html#",[0,[1,"current-date"]],["srfi/19"]],
["current-directory",">reference/Filesystem.html#(def._((quote._~23~25kernel)._current-directory))",[0,[1,"current-directory"]],["scheme/base","scheme"]],
["current-document",">mysterx/browsers.html#(meth._(((lib._mysterx/main..ss)._mx-browser~25)._current-document))",[[0,[1,"current-document"]],[12,[" (method of ",[0,[1,"mx-browser%"]],")"]]],["mysterx"]],
["current-drive",">reference/Filesystem.html#(def._((quote._~23~25kernel)._current-drive))",[0,[1,"current-drive"]],["scheme/base","scheme"]],
["current-error-port",">reference/port-ops.html#(def._((quote._~23~25kernel)._current-error-port))",[0,[1,"current-error-port"]],["scheme/base","scheme"]],
["current-error-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_736",[0,[1,"current-error-port"]],["rnrs/io/ports-6"]],
["current-eval",">reference/Evaluation_and_Compilation.html#(def._((quote._~23~25kernel)._current-eval))",[0,[1,"current-eval"]],["scheme/base","scheme"]],
["current-eventspace",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._current-eventspace))",[0,[1,"current-eventspace"]],["scheme/gui/base","scheme/gui"]],
["current-eventspace-has-menu-root?",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._current-eventspace-has-menu-root~3f))",[0,[1,"current-eventspace-has-menu-root?"]],["scheme/gui/base","scheme/gui"]],
["current-eventspace-has-standard-menus?",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._current-eventspace-has-standard-menus~3f))",[0,[1,"current-eventspace-has-standard-menus?"]],["scheme/gui/base","scheme/gui"]],
["current-evt-pseudo-random-generator",">reference/sync.html#(def._((quote._~23~25kernel)._current-evt-pseudo-random-generator))",[0,[1,"current-evt-pseudo-random-generator"]],["scheme/base","scheme"]],
["current-expected-text-scale",">slideshow/Rendering.html#(def._((lib._slideshow/pict..ss)._current-expected-text-scale))",[0,[1,"current-expected-text-scale"]],["slideshow/pict","slideshow"]],
["current-extension-compiler",">dynext/Compilation.html#(def._((lib._dynext/compile..ss)._current-extension-compiler))",[0,[1,"current-extension-compiler"]],["dynext/compile"]],
["current-extension-compiler-flags",">dynext/Compilation.html#(def._((lib._dynext/compile..ss)._current-extension-compiler-flags))",[0,[1,"current-extension-compiler-flags"]],["dynext/compile"]],
["current-extension-linker",">dynext/Linking.html#(def._((lib._dynext/link..ss)._current-extension-linker))",[0,[1,"current-extension-linker"]],["dynext/link"]],
["current-extension-linker-flags",">dynext/Linking.html#(def._((lib._dynext/link..ss)._current-extension-linker-flags))",[0,[1,"current-extension-linker-flags"]],["dynext/link"]],
["current-extension-preprocess-flags",">dynext/Compilation.html#(def._((lib._dynext/compile..ss)._current-extension-preprocess-flags))",[0,[1,"current-extension-preprocess-flags"]],["dynext/compile"]],
["current-file",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..ss)._current-file))",[0,[1,"current-file"]],["preprocessor/mzpp"]],
["current-file",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..ss)._current-file))",[0,[1,"current-file"]],["preprocessor/mztext"]],
["current-font-size",">slideshow/Configuration.html#(def._((lib._slideshow/base..ss)._current-font-size))",[0,[1,"current-font-size"]],["slideshow/base","slideshow"]],
["current-gc-milliseconds",">reference/time.html#(def._((quote._~23~25kernel)._current-gc-milliseconds))",[0,[1,"current-gc-milliseconds"]],["scheme/base","scheme"]],
["current-id-color",">slideshow/Typesetting_Scheme_Code.html#(def._((lib._slideshow/code..ss)._current-id-color))",[0,[1,"current-id-color"]],["slideshow/code"]],
["current-inexact-milliseconds",">reference/time.html#(def._((quote._~23~25kernel)._current-inexact-milliseconds))",[0,[1,"current-inexact-milliseconds"]],["scheme/base","scheme"]],
["current-input-port",">reference/port-ops.html#(def._((quote._~23~25kernel)._current-input-port))",[0,[1,"current-input-port"]],["scheme/base","scheme"]],
["current-input-port",">r5rs-std/r5rs-Z-H-9.html#%_idx_618",[0,[1,"current-input-port"]],["r5rs"]],
["current-input-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_678",[0,[1,"current-input-port"]],["rnrs/io/ports-6"]],
["current-inspector",">reference/inspectors.html#(def._((quote._~23~25kernel)._current-inspector))",[0,[1,"current-inspector"]],["scheme/base","scheme"]],
["current-julian-day",">srfi-std/srfi-19.html#current-julian-day",[0,[1,"current-julian-day"]],["srfi/19"]],
["current-keyword-color",">slideshow/Typesetting_Scheme_Code.html#(def._((lib._slideshow/code..ss)._current-keyword-color))",[0,[1,"current-keyword-color"]],["slideshow/code"]],
["current-keyword-list",">slideshow/Typesetting_Scheme_Code.html#(def._((lib._slideshow/code..ss)._current-keyword-list))",[0,[1,"current-keyword-list"]],["slideshow/code"]],
["current-language",">srfi-std/srfi-29.html#current-language",[0,[1,"current-language"]],["srfi/29"]],
["current-launcher-variant",">mzc/launcher.html#(def._((lib._launcher/launcher..ss)._current-launcher-variant))",[0,[1,"current-launcher-variant"]],["launcher/launcher"]],
["current-library-collection-paths",">reference/collects.html#(def._((quote._~23~25kernel)._current-library-collection-paths))",[0,[1,"current-library-collection-paths"]],["scheme/base","scheme"]],
["current-line-sep",">slideshow/Configuration.html#(def._((lib._slideshow/base..ss)._current-line-sep))",[0,[1,"current-line-sep"]],["slideshow/base","slideshow"]],
["current-linkage",">planet/Utility_Libraries.html#(def._((lib._planet/util..ss)._current-linkage))",[0,[1,"current-linkage"]],["planet/util"]],
["current-literal-color",">slideshow/Typesetting_Scheme_Code.html#(def._((lib._slideshow/code..ss)._current-literal-color))",[0,[1,"current-literal-color"]],["slideshow/code"]],
["current-literal-list",">slideshow/Typesetting_Scheme_Code.html#(def._((lib._slideshow/code..ss)._current-literal-list))",[0,[1,"current-literal-list"]],["slideshow/code"]],
["current-load",">reference/Evaluation_and_Compilation.html#(def._((quote._~23~25kernel)._current-load))",[0,[1,"current-load"]],["scheme/base","scheme"]],
["current-load-extension",">reference/Evaluation_and_Compilation.html#(def._((quote._~23~25kernel)._current-load-extension))",[0,[1,"current-load-extension"]],["scheme/base","scheme"]],
["current-load-relative-directory",">reference/Evaluation_and_Compilation.html#(def._((quote._~23~25kernel)._current-load-relative-directory))",[0,[1,"current-load-relative-directory"]],["scheme/base","scheme"]],
["current-load/use-compiled",">reference/Evaluation_and_Compilation.html#(def._((quote._~23~25kernel)._current-load/use-compiled))",[0,[1,"current-load/use-compiled"]],["scheme/base","scheme"]],
["current-locale",">reference/encodings.html#(def._((quote._~23~25kernel)._current-locale))",[0,[1,"current-locale"]],["scheme/base","scheme"]],
["current-locale-details",">srfi-std/srfi-29.html#current-locale-details",[0,[1,"current-locale-details"]],["srfi/29"]],
["current-logger",">reference/logging.html#(def._((quote._~23~25kernel)._current-logger))",[0,[1,"current-logger"]],["scheme/base","scheme"]],
["current-main-font",">slideshow/Configuration.html#(def._((lib._slideshow/base..ss)._current-main-font))",[0,[1,"current-main-font"]],["slideshow/base","slideshow"]],
["current-make-compile-include-strings",">dynext/Compilation.html#(def._((lib._dynext/compile..ss)._current-make-compile-include-strings))",[0,[1,"current-make-compile-include-strings"]],["dynext/compile"]],
["current-make-compile-input-strings",">dynext/Compilation.html#(def._((lib._dynext/compile..ss)._current-make-compile-input-strings))",[0,[1,"current-make-compile-input-strings"]],["dynext/compile"]],
["current-make-compile-output-strings",">dynext/Compilation.html#(def._((lib._dynext/compile..ss)._current-make-compile-output-strings))",[0,[1,"current-make-compile-output-strings"]],["dynext/compile"]],
["current-make-link-input-strings",">dynext/Linking.html#(def._((lib._dynext/link..ss)._current-make-link-input-strings))",[0,[1,"current-make-link-input-strings"]],["dynext/link"]],
["current-make-link-output-strings",">dynext/Linking.html#(def._((lib._dynext/link..ss)._current-make-link-output-strings))",[0,[1,"current-make-link-output-strings"]],["dynext/link"]],
["current-memory-use",">reference/garbagecollection.html#(def._((quote._~23~25kernel)._current-memory-use))",[0,[1,"current-memory-use"]],["scheme/base","scheme"]],
["current-milliseconds",">reference/time.html#(def._((quote._~23~25kernel)._current-milliseconds))",[0,[1,"current-milliseconds"]],["scheme/base","scheme"]],
["current-modified-julian-day",">srfi-std/srfi-19.html#current-modified-julian-day",[0,[1,"current-modified-julian-day"]],["srfi/19"]],
["current-module-declare-name",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._current-module-declare-name))",[0,[1,"current-module-declare-name"]],["scheme/base","scheme"]],
["current-module-name-resolver",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._current-module-name-resolver))",[0,[1,"current-module-name-resolver"]],["scheme/base","scheme"]],
["current-namespace",">reference/Namespaces.html#(def._((quote._~23~25kernel)._current-namespace))",[0,[1,"current-namespace"]],["scheme/base","scheme"]],
["current-output-port",">reference/port-ops.html#(def._((quote._~23~25kernel)._current-output-port))",[0,[1,"current-output-port"]],["scheme/base","scheme"]],
["current-output-port",">r5rs-std/r5rs-Z-H-9.html#%_idx_620",[0,[1,"current-output-port"]],["r5rs"]],
["current-output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_734",[0,[1,"current-output-port"]],["rnrs/io/ports-6"]],
["current-page",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-canvas-mixin)._current-page))",[[0,[1,"current-page"]],[12,[" (method of ",[0,[1,"hyper-canvas-mixin"]],")"]]],["browser"]],
["current-page-number-adjust",">slideshow/Viewer_Control.html#(def._((lib._slideshow/base..ss)._current-page-number-adjust))",[0,[1,"current-page-number-adjust"]],["slideshow/base","slideshow"]],
["current-page-number-color",">slideshow/Viewer_Control.html#(def._((lib._slideshow/base..ss)._current-page-number-color))",[0,[1,"current-page-number-color"]],["slideshow/base","slideshow"]],
["current-page-number-font",">slideshow/Viewer_Control.html#(def._((lib._slideshow/base..ss)._current-page-number-font))",[0,[1,"current-page-number-font"]],["slideshow/base","slideshow"]],
["current-para-width",">slideshow/Configuration.html#(def._((lib._slideshow/base..ss)._current-para-width))",[0,[1,"current-para-width"]],["slideshow/base","slideshow"]],
["current-parameterization",">reference/parameters.html#(def._((lib._scheme/private/more-scheme..ss)._current-parameterization))",[0,[1,"current-parameterization"]],["scheme/base","scheme"]],
["current-preserved-thread-cell-values",">reference/threadcells.html#(def._((quote._~23~25kernel)._current-preserved-thread-cell-values))",[0,[1,"current-preserved-thread-cell-values"]],["scheme/base","scheme"]],
["current-print",">reference/Evaluation_and_Compilation.html#(def._((quote._~23~25kernel)._current-print))",[0,[1,"current-print"]],["scheme/base","scheme"]],
["current-print output",">drscheme/output-syntax.html#(idx._(gentag._58._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">current-print</font></b> output",false],
["current-print-convert-hook",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..ss)._current-print-convert-hook))",[0,[1,"current-print-convert-hook"]],["mzlib/pconvert"]],
["current-process-milliseconds",">reference/time.html#(def._((quote._~23~25kernel)._current-process-milliseconds))",[0,[1,"current-process-milliseconds"]],["scheme/base","scheme"]],
["current-prompt",">readline/index.html#(def._((lib._readline/pread..ss)._current-prompt))",[0,[1,"current-prompt"]],["readline/pread"]],
["current-prompt-read",">reference/Evaluation_and_Compilation.html#(def._((quote._~23~25kernel)._current-prompt-read))",[0,[1,"current-prompt-read"]],["scheme/base","scheme"]],
["current-proxy-servers",">net/url.html#(def._((lib._net/url..ss)._current-proxy-servers))",[0,[1,"current-proxy-servers"]],["net/url"]],
["current-ps-afm-file-paths",">gui/Drawing_Functions.html#(def._((lib._mred/main..ss)._current-ps-afm-file-paths))",[0,[1,"current-ps-afm-file-paths"]],["scheme/gui/base","scheme/gui"]],
["current-ps-cmap-file-paths",">gui/Drawing_Functions.html#(def._((lib._mred/main..ss)._current-ps-cmap-file-paths))",[0,[1,"current-ps-cmap-file-paths"]],["scheme/gui/base","scheme/gui"]],
["current-ps-setup",">gui/Drawing_Functions.html#(def._((lib._mred/main..ss)._current-ps-setup))",[0,[1,"current-ps-setup"]],["scheme/gui/base","scheme/gui"]],
["current-pseudo-random-generator",">reference/numbers.html#(def._((quote._~23~25kernel)._current-pseudo-random-generator))",[0,[1,"current-pseudo-random-generator"]],["scheme/base","scheme"]],
["current-read-eval-convert-print-prompt",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..ss)._current-read-eval-convert-print-prompt))",[0,[1,"current-read-eval-convert-print-prompt"]],["mzlib/pconvert"]],
["current-reader-forms",">slideshow/Typesetting_Scheme_Code.html#(def._((lib._slideshow/code..ss)._current-reader-forms))",[0,[1,"current-reader-forms"]],["slideshow/code"]],
["current-reader-guard",">reference/Reading.html#(def._((quote._~23~25kernel)._current-reader-guard))",[0,[1,"current-reader-guard"]],["scheme/base","scheme"]],
["current-readtable",">reference/Reading.html#(def._((quote._~23~25kernel)._current-readtable))",[0,[1,"current-readtable"]],["scheme/base","scheme"]],
["current-seconds",">reference/time.html#(def._((quote._~23~25kernel)._current-seconds))",[0,[1,"current-seconds"]],["scheme/base","scheme"]],
["current-seconds",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._current-seconds))",[0,[1,"current-seconds"]],["lang/htdp-advanced"]],
["current-seconds",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._current-seconds))",[0,[1,"current-seconds"]],["lang/htdp-beginner"]],
["current-seconds",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._current-seconds))",[0,[1,"current-seconds"]],["lang/htdp-beginner-abbr"]],
["current-seconds",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._current-seconds))",[0,[1,"current-seconds"]],["lang/htdp-intermediate"]],
["current-seconds",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._current-seconds))",[0,[1,"current-seconds"]],["lang/htdp-intermediate-lambda"]],
["current-security-guard",">reference/securityguards.html#(def._((quote._~23~25kernel)._current-security-guard))",[0,[1,"current-security-guard"]],["scheme/base","scheme"]],
["current-servlet-continuation-expiration-handler",">web-server/web_ss.html#(def._((lib._web-server/servlet/web..ss)._current-servlet-continuation-expiration-handler))",[0,[1,"current-servlet-continuation-expiration-handler"]],["web-server/servlet/web"]],
["current-slide-assembler",">slideshow/Configuration.html#(def._((lib._slideshow/base..ss)._current-slide-assembler))",[0,[1,"current-slide-assembler"]],["slideshow/base","slideshow"]],
["current-standard-link-libraries",">dynext/Linking.html#(def._((lib._dynext/link..ss)._current-standard-link-libraries))",[0,[1,"current-standard-link-libraries"]],["dynext/link"]],
["current-target-directory-getter",">setup-plt/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..ss)._setup-option~5e._current-target-directory-getter))",[0,[1,"current-target-directory-getter"]],["setup/option-sig"]],
["current-target-plt-directory-getter",">setup-plt/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..ss)._setup-option~5e._current-target-plt-directory-getter))",[0,[1,"current-target-plt-directory-getter"]],["setup/option-sig"]],
["current-text",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._current-text))",[0,[1,"current-text"]],["redex/pict"]],
["current-text-keymap-initializer",">gui/Editor_Functions.html#(def._((lib._mred/main..ss)._current-text-keymap-initializer))",[0,[1,"current-text-keymap-initializer"]],["scheme/gui/base","scheme/gui"]],
["current-thread",">reference/threads.html#(def._((quote._~23~25kernel)._current-thread))",[0,[1,"current-thread"]],["scheme/base","scheme"]],
["current-thread-group",">reference/threadgroups.html#(def._((quote._~23~25kernel)._current-thread-group))",[0,[1,"current-thread-group"]],["scheme/base","scheme"]],
["current-thread-initial-stack-size",">reference/runtime.html#(def._((quote._~23~25kernel)._current-thread-initial-stack-size))",[0,[1,"current-thread-initial-stack-size"]],["scheme/base","scheme"]],
["current-time",">mzlib/mzlib_cml.html#(def._((lib._mzlib/cml..ss)._current-time))",[0,[1,"current-time"]],["mzlib/cml"]],
["current-time",">srfi-std/srfi-19.html#current-time",[0,[1,"current-time"]],["srfi/19"]],
["current-title-color",">slideshow/Configuration.html#(def._((lib._slideshow/base..ss)._current-title-color))",[0,[1,"current-title-color"]],["slideshow/base","slideshow"]],
["current-titlet",">slideshow/Configuration.html#(def._((lib._slideshow/base..ss)._current-titlet))",[0,[1,"current-titlet"]],["slideshow/base","slideshow"]],
["current-trace-notify",">mzlib/mzlib_trace.html#(def._((lib._mzlib/trace..ss)._current-trace-notify))",[0,[1,"current-trace-notify"]],["mzlib/trace"]],
["current-url",">mysterx/browsers.html#(meth._(((lib._mysterx/main..ss)._mx-browser~25)._current-url))",[[0,[1,"current-url"]],[12,[" (method of ",[0,[1,"mx-browser%"]],")"]]],["mysterx"]],
["current-url-transform",">web-server/web_ss.html#(def._((lib._web-server/servlet/web..ss)._current-url-transform))",[0,[1,"current-url-transform"]],["web-server/servlet/web"]],
["current-use-mzdyn",">dynext/Linking.html#(def._((lib._dynext/link..ss)._current-use-mzdyn))",[0,[1,"current-use-mzdyn"]],["dynext/link"]],
["current-write-relative-directory",">reference/Writing.html#(def._((quote._~23~25kernel)._current-write-relative-directory))",[0,[1,"current-write-relative-directory"]],["scheme/base","scheme"]],
["curried function shorthand",">guide/define.html#(part._.Curried_.Function_.Shorthand)","Curried Function Shorthand",false],
["curry",">reference/procedures.html#(def._((lib._scheme/function..ss)._curry))",[0,[1,"curry"]],["scheme/function","scheme"]],
["curryr",">reference/procedures.html#(def._((lib._scheme/function..ss)._curryr))",[0,[1,"curryr"]],["scheme/function","scheme"]],
["cursor",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._cursor))",[[0,[1,"cursor"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["cursor%",">gui/cursor_.html",[0,[1,"cursor%"]],["scheme/gui/base","scheme/gui"]],
["cursor-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._cursor-native))",[[0,[1,"cursor-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["curve fitting",">plot/plot.html#(part._curve-fit)","Curve Fitting",false],
["curve fitting",">plot/Quick_Start.html#(part._ex-curve-fit)","Curve Fitting",false],
["curve-to",">gui/dc-path_.html#(meth._(((lib._mred/main..ss)._dc-path~25)._curve-to))",[[0,[1,"curve-to"]],[12,[" (method of ",[0,[1,"dc-path%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["custodian",">reference/eval-model.html#(tech._custodian)","<i>custodian</i>",false],
["custodian box",">reference/custodians.html#(tech._custodian._box)","<i>custodian box</i>",false],
["custodian-box-value",">reference/custodians.html#(def._((quote._~23~25kernel)._custodian-box-value))",[0,[1,"custodian-box-value"]],["scheme/base","scheme"]],
["custodian-box?",">reference/custodians.html#(def._((quote._~23~25kernel)._custodian-box~3f))",[0,[1,"custodian-box?"]],["scheme/base","scheme"]],
["custodian-limit-memory",">reference/custodians.html#(def._((quote._~23~25kernel)._custodian-limit-memory))",[0,[1,"custodian-limit-memory"]],["scheme/base","scheme"]],
["custodian-managed-list",">reference/custodians.html#(def._((quote._~23~25kernel)._custodian-managed-list))",[0,[1,"custodian-managed-list"]],["scheme/base","scheme"]],
["custodian-memory-accounting-available?",">reference/custodians.html#(def._((quote._~23~25kernel)._custodian-memory-accounting-available~3f))",[0,[1,"custodian-memory-accounting-available?"]],["scheme/base","scheme"]],
["custodian-require-memory",">reference/custodians.html#(def._((quote._~23~25kernel)._custodian-require-memory))",[0,[1,"custodian-require-memory"]],["scheme/base","scheme"]],
["custodian-shutdown-all",">reference/custodians.html#(def._((quote._~23~25kernel)._custodian-shutdown-all))",[0,[1,"custodian-shutdown-all"]],["scheme/base","scheme"]],
["custodian?",">reference/custodians.html#(def._((quote._~23~25kernel)._custodian~3f))",[0,[1,"custodian?"]],["scheme/base","scheme"]],
["custodians",">inside/Custodians.html","Custodians",false],
["custodians",">reference/eval-model.html#(part._custodian-model)","Custodians",false],
["custodians",">reference/custodians.html","Custodians",false],
["custom function types",">foreign/foreign_procedures.html#(part._foreign~3acustom-types)","Custom Function Types",false],
["custom function types",">foreign/foreign_procedures.html#(tech._custom._function._type)","<i>custom function types</i>",false],
["custom ports",">reference/customport.html","Custom Ports",false],
["custom-write-accessor",">reference/Printer_Extension.html#(def._((quote._~23~25kernel)._custom-write-accessor))",[0,[1,"custom-write-accessor"]],["scheme/base","scheme"]],
["custom-write?",">reference/Printer_Extension.html#(def._((quote._~23~25kernel)._custom-write~3f))",[0,[1,"custom-write?"]],["scheme/base","scheme"]],
["customization",">redex/Typesetting.html#(part._.Customization)","Customization",false],
["customization api",">web-server/insta.html#(part._.Customization_.A.P.I)","Customization API",false],
["customizing evaluators",">reference/Sandboxed_Evaluation.html#(part._.Customizing_.Evaluators)","Customizing Evaluators",false],
["customizing plots",">plot/extend.html","Customizing Plots",false],
["cut",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._cut))",[[0,[1,"cut"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["cut",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._cut))",[[0,[1,"cut"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["cut",">srfi-std/srfi-26.html#cut",[0,[6,"cut"]],["srfi/26"]],
["cut and paste time stamps",">gui/editor-overview.html#(part._editorcutandpastetime)","Cut and Paste Time Stamps",false],
["cut menu item",">drscheme/Menus.html#(idx._(gentag._78._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Cut</font></b> menu item",false],
["cut-click-region",">framework/Keymap.html#(idx._(gentag._34._(lib._scribblings/framework/framework..scrbl)))","cut-click-region",false],
["cut-clipboard",">framework/Keymap.html#(idx._(gentag._31._(lib._scribblings/framework/framework..scrbl)))","cut-clipboard",false],
["cute",">srfi-std/srfi-26.html#cute",[0,[6,"cute"]],["srfi/26"]],
["cvector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._cvector))",[0,[1,"cvector"]],["scheme/foreign"]],
["cvector->list",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._cvector-~3elist))",[0,[1,"cvector-&gt;list"]],["scheme/foreign"]],
["cvector-length",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._cvector-length))",[0,[1,"cvector-length"]],["scheme/foreign"]],
["cvector-ptr",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._cvector-ptr))",[0,[1,"cvector-ptr"]],["scheme/foreign"]],
["cvector-ref",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._cvector-ref))",[0,[1,"cvector-ref"]],["scheme/foreign"]],
["cvector-set!",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._cvector-set!))",[0,[1,"cvector-set!"]],["scheme/foreign"]],
["cvector-type",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._cvector-type))",[0,[1,"cvector-type"]],["scheme/foreign"]],
["cvector?",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._cvector~3f))",[0,[1,"cvector?"]],["scheme/foreign"]],
["cycle",">lazy/index.html#(def._((lib._lazy/main..ss)._cycle))",[0,[1,"cycle"]],["lazy"]],
["cycle back through old expressions",">drscheme/interactions-window.html#(idx._(gentag._26._(lib._scribblings/drscheme/drscheme..scrbl)))","cycle back through old expressions",false],
["d",">teachpack/world.html#(tech._d)","<i>D</i>",false],
["dark-brush-color",">redex/GUI.html#(def._((lib._redex/gui..ss)._dark-brush-color))",[0,[1,"dark-brush-color"]],["redex/gui"]],
["dark-pen-color",">redex/GUI.html#(def._((lib._redex/gui..ss)._dark-pen-color))",[0,[1,"dark-pen-color"]],["redex/gui"]],
["data-lines->data",">net/head.html#(def._((lib._net/head..ss)._data-lines-~3edata))",[0,[1,"data-lines-&gt;data"]],["net/head"]],
["data-set",">mrlib/Plot.html#(def._((lib._mrlib/plot..ss)._data-set))",[0,[1,"data-set"]],["mrlib/plot"]],
["data-set-connected?",">mrlib/Plot.html#(def._((lib._mrlib/plot..ss)._data-set-connected~3f))",[0,[1,"data-set-connected?"]],["mrlib/plot"]],
["data-set-max-x",">mrlib/Plot.html#(def._((lib._mrlib/plot..ss)._data-set-max-x))",[0,[1,"data-set-max-x"]],["mrlib/plot"]],
["data-set-max-y",">mrlib/Plot.html#(def._((lib._mrlib/plot..ss)._data-set-max-y))",[0,[1,"data-set-max-y"]],["mrlib/plot"]],
["data-set-min-x",">mrlib/Plot.html#(def._((lib._mrlib/plot..ss)._data-set-min-x))",[0,[1,"data-set-min-x"]],["mrlib/plot"]],
["data-set-min-y",">mrlib/Plot.html#(def._((lib._mrlib/plot..ss)._data-set-min-y))",[0,[1,"data-set-min-y"]],["mrlib/plot"]],
["data-set-pen",">mrlib/Plot.html#(def._((lib._mrlib/plot..ss)._data-set-pen))",[0,[1,"data-set-pen"]],["mrlib/plot"]],
["data-set-points",">mrlib/Plot.html#(def._((lib._mrlib/plot..ss)._data-set-points))",[0,[1,"data-set-points"]],["mrlib/plot"]],
["data-set?",">mrlib/Plot.html#(def._((lib._mrlib/plot..ss)._data-set~3f))",[0,[1,"data-set?"]],["mrlib/plot"]],
["data-structure contracts",">reference/Data-structure_Contracts.html","Data-structure Contracts",false],
["datatypes",">reference/data.html","Datatypes",false],
["datatypes",">xml/index.html#(part._.Datatypes)","Datatypes",false],
["datatypes and serialization",">guide/serialization.html","Datatypes and Serialization",false],
["date",">reference/time.html#(def._((quote._~23~25kernel)._date))",[0,[1,"date"]],["scheme/base","scheme"]],
["date utilities",">reference/time.html#(part._date-string)","Date Utilities",false],
["date->com-date",">mysterx/com-types.html#(def._((lib._mysterx/main..ss)._date-~3ecom-date))",[0,[1,"date-&gt;com-date"]],["mysterx"]],
["date->julian-day",">srfi-std/srfi-19.html#date->julian-day",[0,[1,"date-&gt;julian-day"]],["srfi/19"]],
["date->julian/scalinger",">reference/time.html#(def._((lib._scheme/date..ss)._date-~3ejulian/scalinger))",[0,[1,"date-&gt;julian/scalinger"]],["scheme/date"]],
["date->modified-julian-day",">srfi-std/srfi-19.html#date->modified-julian-day",[0,[1,"date-&gt;modified-julian-day"]],["srfi/19"]],
["date->string",">reference/time.html#(def._((lib._scheme/date..ss)._date-~3estring))",[0,[1,"date-&gt;string"]],["scheme/date"]],
["date->string",">srfi-std/srfi-19.html#date->string",[0,[1,"date-&gt;string"]],["srfi/19"]],
["date->time-monotonic",">srfi-std/srfi-19.html#date->time-monotonic",[0,[1,"date-&gt;time-monotonic"]],["srfi/19"]],
["date->time-tai",">srfi-std/srfi-19.html#date->time-tai",[0,[1,"date-&gt;time-tai"]],["srfi/19"]],
["date->time-utc",">srfi-std/srfi-19.html#date->time-utc",[0,[1,"date-&gt;time-utc"]],["srfi/19"]],
["date-day",">reference/time.html#(def._((quote._~23~25kernel)._date-day))",[0,[1,"date-day"]],["scheme/base","scheme"]],
["date-day",">srfi-std/srfi-19.html#date-day",[0,[1,"date-day"]],["srfi/19"]],
["date-display-format",">reference/time.html#(def._((lib._scheme/date..ss)._date-display-format))",[0,[1,"date-display-format"]],["scheme/date"]],
["date-dst?",">reference/time.html#(def._((quote._~23~25kernel)._date-dst~3f))",[0,[1,"date-dst?"]],["scheme/base","scheme"]],
["date-hour",">reference/time.html#(def._((quote._~23~25kernel)._date-hour))",[0,[1,"date-hour"]],["scheme/base","scheme"]],
["date-hour",">srfi-std/srfi-19.html#date-hour",[0,[1,"date-hour"]],["srfi/19"]],
["date-minute",">reference/time.html#(def._((quote._~23~25kernel)._date-minute))",[0,[1,"date-minute"]],["scheme/base","scheme"]],
["date-minute",">srfi-std/srfi-19.html#date-minute",[0,[1,"date-minute"]],["srfi/19"]],
["date-month",">reference/time.html#(def._((quote._~23~25kernel)._date-month))",[0,[1,"date-month"]],["scheme/base","scheme"]],
["date-month",">srfi-std/srfi-19.html#date-month",[0,[1,"date-month"]],["srfi/19"]],
["date-nanosecond",">srfi-std/srfi-19.html#date-nanosecond",[0,[1,"date-nanosecond"]],["srfi/19"]],
["date-second",">reference/time.html#(def._((quote._~23~25kernel)._date-second))",[0,[1,"date-second"]],["scheme/base","scheme"]],
["date-second",">srfi-std/srfi-19.html#date-second",[0,[1,"date-second"]],["srfi/19"]],
["date-time-zone-offset",">reference/time.html#(def._((quote._~23~25kernel)._date-time-zone-offset))",[0,[1,"date-time-zone-offset"]],["scheme/base","scheme"]],
["date-week-day",">reference/time.html#(def._((quote._~23~25kernel)._date-week-day))",[0,[1,"date-week-day"]],["scheme/base","scheme"]],
["date-week-day",">srfi-std/srfi-19.html#date-week-day",[0,[1,"date-week-day"]],["srfi/19"]],
["date-week-number",">srfi-std/srfi-19.html#date-week-number",[0,[1,"date-week-number"]],["srfi/19"]],
["date-year",">reference/time.html#(def._((quote._~23~25kernel)._date-year))",[0,[1,"date-year"]],["scheme/base","scheme"]],
["date-year",">srfi-std/srfi-19.html#date-year",[0,[1,"date-year"]],["srfi/19"]],
["date-year-day",">reference/time.html#(def._((quote._~23~25kernel)._date-year-day))",[0,[1,"date-year-day"]],["scheme/base","scheme"]],
["date-year-day",">srfi-std/srfi-19.html#date-year-day",[0,[1,"date-year-day"]],["srfi/19"]],
["date-zone-offset",">srfi-std/srfi-19.html#date-zone-offset",[0,[1,"date-zone-offset"]],["srfi/19"]],
["date?",">reference/time.html#(def._((quote._~23~25kernel)._date~3f))",[0,[1,"date?"]],["scheme/base","scheme"]],
["date?",">srfi-std/srfi-19.html#date-p",[0,[1,"date?"]],["srfi/19"]],
["datum",">reference/reader.html#(tech._datum)","<i>datum</i>",false],
["datum->syntax",">reference/stxops.html#(def._((quote._~23~25kernel)._datum-~3esyntax))",[0,[1,"datum-&gt;syntax"]],["scheme/base","scheme"]],
["datum->syntax",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1146",[0,[1,"datum-&gt;syntax"]],["rnrs/syntax-case-6"]],
["datum->syntax-object",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..ss)._datum-~3esyntax-object))",[0,[1,"datum-&gt;syntax-object"]],["mzscheme"]],
["dblclick?",">mysterx/html-events.html#(meth._(((lib._mysterx/main..ss)._mx-event~3c~25~3e)._dblclick~3f))",[[0,[1,"dblclick?"]],[12,[" (method of ",[0,[1,"mx-event&lt;%&gt;"]],")"]]],["mysterx"]],
["dc",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._dc))",[0,[1,"dc"]],["slideshow/pict","slideshow"]],
["dc",">gui/drawing-overview.html#(tech._dc)","<i>DC</i>",false],
["dc-for-text-size",">slideshow/Rendering.html#(def._((lib._slideshow/pict..ss)._dc-for-text-size))",[0,[1,"dc-for-text-size"]],["slideshow/pict","slideshow"]],
["dc-location-to-editor-location",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._dc-location-to-editor-location))",[[0,[1,"dc-location-to-editor-location"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["dc-path%",">gui/dc-path_.html",[0,[1,"dc-path%"]],["scheme/gui/base","scheme/gui"]],
["dc<%>",">gui/dc___.html",[0,[1,"dc&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["dd",">html/index.html#(def._((lib._html/main..ss)._dd))",[0,[1,"dd"]],["html"]],
["dd?",">html/index.html#(def._((lib._html/main..ss)._dd~3f))",[0,[1,"dd?"]],["html"]],
["debug",">mzc/Scheme_API_for_Compilation.html#(def._((lib._compiler/option..ss)._debug))",[0,[1,"debug"]],["compiler/option"]],
["debug button",">drscheme/debugger.html#(idx._(gentag._33._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Debug</font></b> button",false],
["debug button",">drscheme/buttons.html#(idx._(gentag._6._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Debug</font></b> button",false],
["debug?",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..ss)._debug~3f))",[0,[1,"debug?"]],["preprocessor/mzpp"]],
["debugger",">drscheme/buttons.html#(idx._(gentag._7._(lib._scribblings/drscheme/drscheme..scrbl)))","debugger",false],
["debugger buttons",">drscheme/debugger.html#(part._.Debugger_.Buttons)","Debugger Buttons",false],
["debugging multiple files",">drscheme/debugger.html#(part._.Debugging_.Multiple_.Files)","Debugging Multiple Files",false],
["debugging plt redex programs",">redex/Testing.html#(tech._debugging._plt._redex._program)","<i>Debugging PLT Redex Programs</i>",false],
["decimal",">gui/key-event_.html#(idx._(gentag._84._(lib._scribblings/gui/gui..scrbl)))",[7,"'decimal"],false],
["declare-bundle!",">srfi-std/srfi-29.html#declare-bundle!",[0,[1,"declare-bundle!"]],["srfi/29"]],
["declare-exporting",">scribble/doc-modules.html#(form._((lib._scribble/manual..ss)._declare-exporting))",[0,[6,"declare-exporting"]],["scribble/manual"]],
["declaring a rest argument",">guide/lambda.html#(part._.Declaring_a_.Rest_.Argument)","Declaring a Rest Argument",false],
["declaring keyword arguments",">guide/lambda.html#(part._lambda-keywords)","Declaring Keyword Arguments",false],
["declaring optional arguments",">guide/lambda.html#(part._.Declaring_.Optional_.Arguments)","Declaring Optional Arguments",false],
["declaring paths needed at run time",">reference/Filesystem.html#(part._runtime-path)","Declaring Paths Needed at Run Time",false],
["decode",">scribble/decode.html#(def._((lib._scribble/decode..ss)._decode))",[0,[1,"decode"]],["scribble/decode"]],
["decode",">scribble/decode.html#(tech._decode)","<i>decode</i>",false],
["decode-content",">scribble/decode.html#(def._((lib._scribble/decode..ss)._decode-content))",[0,[1,"decode-content"]],["scribble/decode"]],
["decode-elements",">scribble/decode.html#(def._((lib._scribble/decode..ss)._decode-elements))",[0,[1,"decode-elements"]],["scribble/decode"]],
["decode-flow",">scribble/decode.html#(def._((lib._scribble/decode..ss)._decode-flow))",[0,[1,"decode-flow"]],["scribble/decode"]],
["decode-paragraph",">scribble/decode.html#(def._((lib._scribble/decode..ss)._decode-paragraph))",[0,[1,"decode-paragraph"]],["scribble/decode"]],
["decode-part",">scribble/decode.html#(def._((lib._scribble/decode..ss)._decode-part))",[0,[1,"decode-part"]],["scribble/decode"]],
["decode-string",">scribble/decode.html#(def._((lib._scribble/decode..ss)._decode-string))",[0,[1,"decode-string"]],["scribble/decode"]],
["decoding text",">scribble/decode.html","Decoding Text",false],
["decompiling bytecode",">mzc/decompile.html","Decompiling Bytecode",false],
["decompress-serial",">web-server/mod-map_ss.html#(def._((lib._web-server/private/mod-map..ss)._decompress-serial))",[0,[1,"decompress-serial"]],["web-server/private/mod-map"]],
["deconstructing syntax objects",">syntax/syntax-helpers.html#(part._stx)","Deconstructing Syntax Objects",false],
["decorating with style!",">continue/index.html#(part._.Decorating_.With_.Style_)","Decorating With Style!",false],
["decorative",">gui/font_.html#(idx._(gentag._195._(lib._scribblings/gui/gui..scrbl)))",[7,"'decorative"],false],
["decorative",">gui/style-delta_.html#(idx._(gentag._280._(lib._scribblings/gui/gui..scrbl)))",[7,"'decorative"],false],
["def+int",">scribble/eval.html#(form._((lib._scribble/eval..ss)._def+int))",[0,[6,"def+int"]],["scribble/eval"]],
["default",">gui/font_.html#(idx._(gentag._194._(lib._scribblings/gui/gui..scrbl)))",[7,"'default"],false],
["default",">gui/font_.html#(idx._(gentag._208._(lib._scribblings/gui/gui..scrbl)))",[7,"'default"],false],
["default",">gui/style-delta_.html#(idx._(gentag._268._(lib._scribblings/gui/gui..scrbl)))",[7,"'default"],false],
["default",">gui/style-delta_.html#(idx._(gentag._279._(lib._scribblings/gui/gui..scrbl)))",[7,"'default"],false],
["default lexer",">syntax-color/index.html#(part._.Default_lexer)","Default lexer",false],
["default ports",">guide/Default_Ports.html","Default Ports",false],
["default prompt tag",">guide/prompt.html#(tech._default._prompt._tag)","<i>default\nprompt tag</i>",false],
["default-_string-type",">foreign/String_Types.html#(def._((lib._scheme/foreign..ss)._default-_string-type))",[0,[1,"default-_string-type"]],["scheme/foreign"]],
["default-configuration-table-path",">web-server/configuration-table_ss.html#(def._((lib._web-server/configuration/configuration-table..ss)._default-configuration-table-path))",[0,[1,"default-configuration-table-path"]],["web-server/configuration/configuration-table"]],
["default-continuation-prompt-tag",">reference/cont.html#(def._((quote._~23~25kernel)._default-continuation-prompt-tag))",[0,[1,"default-continuation-prompt-tag"]],["scheme/base","scheme"]],
["default-display-is-color?",">graphics/Color_Operations.html#(def._((lib._graphics/graphics..ss)._default-display-is-color~3f))",[0,[1,"default-display-is-color?"]],["graphics/graphics"]],
["default-face-color",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/face..ss)._default-face-color))",[0,[1,"default-face-color"]],["slideshow/face"]],
["default-font-size",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._default-font-size))",[0,[1,"default-font-size"]],["redex/pict"]],
["default-lexer",">syntax-color/index.html#(def._((lib._syntax-color/default-lexer..ss)._default-lexer))",[0,[1,"default-lexer"]],["syntax-color/default-lexer"]],
["default-pretty-printer",">redex/GUI.html#(def._((lib._redex/gui..ss)._default-pretty-printer))",[0,[1,"default-pretty-printer"]],["redex/gui"]],
["default-random-source",">srfi-std/srfi-27.html#default-random-source",[0,[1,"default-random-source"]],["srfi/27"]],
["default-settings",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e)._default-settings))",[[0,[1,"default-settings"]],[12,[" (method of ",[0,[1,"drscheme:language:language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["default-settings",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3amodule-based-language~3c~25~3e)._default-settings))",[[0,[1,"default-settings"]],[12,[" (method of ",[0,[1,"drscheme:language:module-based-language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["default-settings",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-module-based-language-~3emodule-based-language-mixin)._default-settings))",[[0,[1,"default-settings"]],[12,[" (method of ",[0,[1,"drscheme:language:simple-module-based-language-&gt;module-based-language-mixin"]],")"]]],["drscheme/tool-lib"]],
["default-settings?",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e)._default-settings~3f))",[[0,[1,"default-settings?"]],[12,[" (method of ",[0,[1,"drscheme:language:language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["default-settings?",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3amodule-based-language~3c~25~3e)._default-settings~3f))",[[0,[1,"default-settings?"]],[12,[" (method of ",[0,[1,"drscheme:language:module-based-language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["default-settings?",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-module-based-language-~3emodule-based-language-mixin)._default-settings~3f))",[[0,[1,"default-settings?"]],[12,[" (method of ",[0,[1,"drscheme:language:simple-module-based-language-&gt;module-based-language-mixin"]],")"]]],["drscheme/tool-lib"]],
["default-style",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._default-style))",[0,[1,"default-style"]],["redex/pict"]],
["default-style-name",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._default-style-name))",[[0,[1,"default-style-name"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["default-style-name",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aforeground-color-mixin)._default-style-name))",[[0,[1,"default-style-name"]],[12,[" (method of ",[0,[1,"text:foreground-color-mixin"]],")"]]],["framework"]],
["defboolparam",">scribble/doc-forms.html#(form._((lib._scribble/manual..ss)._defboolparam))",[0,[6,"defboolparam"]],["scribble/manual"]],
["defclass",">scribble/doc-classes.html#(form._((lib._scribble/manual..ss)._defclass))",[0,[6,"defclass"]],["scribble/manual"]],
["defclass/title",">scribble/doc-classes.html#(form._((lib._scribble/manual..ss)._defclass/title))",[0,[6,"defclass/title"]],["scribble/manual"]],
["defcommand",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..ss)._defcommand))",[0,[1,"defcommand"]],["preprocessor/mztext"]],
["defconstructor",">scribble/doc-classes.html#(form._((lib._scribble/manual..ss)._defconstructor))",[0,[6,"defconstructor"]],["scribble/manual"]],
["defconstructor*/make",">scribble/doc-classes.html#(form._((lib._scribble/manual..ss)._defconstructor*/make))",[0,[6,"defconstructor*/make"]],["scribble/manual"]],
["defconstructor/auto-super",">scribble/doc-classes.html#(form._((lib._scribble/manual..ss)._defconstructor/auto-super))",[0,[6,"defconstructor/auto-super"]],["scribble/manual"]],
["defconstructor/make",">scribble/doc-classes.html#(form._((lib._scribble/manual..ss)._defconstructor/make))",[0,[6,"defconstructor/make"]],["scribble/manual"]],
["defexamples",">scribble/eval.html#(form._((lib._scribble/eval..ss)._defexamples))",[0,[6,"defexamples"]],["scribble/eval"]],
["defform",">scribble/doc-forms.html#(form._((lib._scribble/manual..ss)._defform))",[0,[6,"defform"]],["scribble/manual"]],
["defform*",">scribble/doc-forms.html#(form._((lib._scribble/manual..ss)._defform*))",[0,[6,"defform*"]],["scribble/manual"]],
["defform*/subs",">scribble/doc-forms.html#(form._((lib._scribble/manual..ss)._defform*/subs))",[0,[6,"defform*/subs"]],["scribble/manual"]],
["defform/none",">scribble/doc-forms.html#(form._((lib._scribble/manual..ss)._defform/none))",[0,[6,"defform/none"]],["scribble/manual"]],
["defform/subs",">scribble/doc-forms.html#(form._((lib._scribble/manual..ss)._defform/subs))",[0,[6,"defform/subs"]],["scribble/manual"]],
["defidform",">scribble/doc-forms.html#(form._((lib._scribble/manual..ss)._defidform))",[0,[6,"defidform"]],["scribble/manual"]],
["define",">htdp-langs/advanced-define.html",[0,[6,"define"]],false],
["define",">htdp-langs/define.html",[0,[6,"define"]],false],
["define",">htdp-langs/intermediate-define.html",[0,[6,"define"]],false],
["define",">htdp-langs/intermediate-lambda-define.html",[0,[6,"define"]],false],
["define",">reference/define.html#(form._((lib._scheme/base..ss)._define))",[0,[6,"define"]],["scheme/base","scheme"]],
["define",">r5rs-std/r5rs-Z-H-8.html#%_idx_194",[0,[6,"define"]],["r5rs"]],
["define",">r6rs-std/r6rs-Z-H-14.html#node_idx_352",[0,[6,"define"]],["rnrs/base-6"]],
["define",">htdp-langs/advanced-define.html#(form._((lib._lang/htdp-advanced..ss)._define))",[0,[6,"define"]],["lang/htdp-advanced"]],
["define",">htdp-langs/define.html#(form._((lib._lang/htdp-beginner..ss)._define))",[0,[6,"define"]],["lang/htdp-beginner"]],
["define",">htdp-langs/Unchanged_Forms.html#(form._((lib._lang/htdp-beginner-abbr..ss)._define))",[0,[6,"define"]],["lang/htdp-beginner-abbr"]],
["define",">htdp-langs/intermediate-define.html#(form._((lib._lang/htdp-intermediate..ss)._define))",[0,[6,"define"]],["lang/htdp-intermediate"]],
["define",">htdp-langs/intermediate-lambda-define.html#(form._((lib._lang/htdp-intermediate-lambda..ss)._define))",[0,[6,"define"]],["lang/htdp-intermediate-lambda"]],
["define",">lazy/index.html#(form._((lib._lazy/main..ss)._define))",[0,[6,"define"]],["lazy"]],
["define",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..ss)._define))",[0,[6,"define"]],["mzscheme"]],
["define-c",">foreign/Loading_Foreign_Libraries.html#(form._((lib._scribblings/foreign/unsafe-foreign..ss)._define-c))",[0,[6,"define-c"]],["scribblings/foreign/unsafe-foreign"]],
["define-closure",">web-server/closure_ss.html#(form._((lib._web-server/private/define-closure..ss)._define-closure))",[0,[6,"define-closure"]],["web-server/private/define-closure"]],
["define-code",">slideshow/Typesetting_Scheme_Code.html#(form._((lib._slideshow/code..ss)._define-code))",[0,[6,"define-code"]],["slideshow/code"]],
["define-compound-unit",">reference/linkinference.html#(form._((lib._mzlib/unit..ss)._define-compound-unit))",[0,[6,"define-compound-unit"]],["scheme/unit","scheme"]],
["define-compound-unit/infer",">reference/linkinference.html#(form._((lib._mzlib/unit..ss)._define-compound-unit/infer))",[0,[6,"define-compound-unit/infer"]],["scheme/unit","scheme"]],
["define-condition-type",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_404",[0,[6,"define-condition-type"]],["rnrs/conditions-6"]],
["define-contract-struct",">reference/Lazy_Data-structure_Contracts.html#(form._((lib._scheme/private/contract-ds..ss)._define-contract-struct))",[0,[6,"define-contract-struct"]],["scheme/contract","scheme"]],
["define-cpointer-type",">foreign/Derived_Utilities.html#(form._((lib._scheme/foreign..ss)._define-cpointer-type))",[0,[6,"define-cpointer-type"]],["scheme/foreign"]],
["define-cstruct",">foreign/C_Struct_Types.html#(form._((lib._scheme/foreign..ss)._define-cstruct))",[0,[6,"define-cstruct"]],["scheme/foreign"]],
["define-datatype",">eopl/index.html#(form._((lib._eopl/eopl..ss)._define-datatype))",[0,[6,"define-datatype"]],["eopl/eopl"]],
["define-empty-tokens",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..ss)._define-empty-tokens))",[0,[6,"define-empty-tokens"]],["parser-tools/lex"]],
["define-enumeration",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1262",[0,[6,"define-enumeration"]],["rnrs/enums-6"]],
["define-exec-code",">slideshow/Typesetting_Scheme_Code.html#(form._((lib._slideshow/code..ss)._define-exec-code))",[0,[6,"define-exec-code"]],["slideshow/code"]],
["define-exec-code/scale",">slideshow/Typesetting_Scheme_Code.html#(form._((lib._slideshow/code..ss)._define-exec-code/scale))",[0,[6,"define-exec-code/scale"]],["slideshow/code"]],
["define-extended-language",">redex/Languages.html#(form._((lib._redex/main..ss)._define-extended-language))",[0,[6,"define-extended-language"]],["redex"]],
["define-for-syntax",">reference/define.html#(form._((lib._scheme/private/define..ss)._define-for-syntax))",[0,[6,"define-for-syntax"]],["scheme/base","scheme"]],
["define-fun-syntax",">foreign/foreign_procedures.html#(form._((lib._scheme/foreign..ss)._define-fun-syntax))",[0,[6,"define-fun-syntax"]],["scheme/foreign"]],
["define-higher-order-primitive",">htdp-lib/index.html#(form._((lib._lang/prim..ss)._define-higher-order-primitive))",[0,[6,"define-higher-order-primitive"]],["lang/prim"]],
["define-language",">redex/Languages.html#(form._((lib._redex/main..ss)._define-language))",[0,[6,"define-language"]],["redex"]],
["define-lex-abbrev",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..ss)._define-lex-abbrev))",[0,[6,"define-lex-abbrev"]],["parser-tools/lex"]],
["define-lex-abbrevs",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..ss)._define-lex-abbrevs))",[0,[6,"define-lex-abbrevs"]],["parser-tools/lex"]],
["define-lex-trans",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..ss)._define-lex-trans))",[0,[6,"define-lex-trans"]],["parser-tools/lex"]],
["define-local-member-name",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._define-local-member-name))",[0,[6,"define-local-member-name"]],["scheme/class","scheme"]],
["define-macro",">mzlib/mzlib_defmacro.html#(form._((lib._mzlib/defmacro..ss)._define-macro))",[0,[6,"define-macro"]],["mzlib/defmacro"]],
["define-match-expander",">reference/match.html#(form._((lib._scheme/match..ss)._define-match-expander))",[0,[6,"define-match-expander"]],["scheme/match","scheme"]],
["define-match-expander",">mzlib/mzlib_match.html#(form._((lib._mzlib/match..ss)._define-match-expander))",[0,[6,"define-match-expander"]],["mzlib/match"]],
["define-match-expander",">mzlib/mzlib_plt-match.html#(form._((lib._mzlib/plt-match..ss)._define-match-expander))",[0,[6,"define-match-expander"]],["mzlib/plt-match"]],
["define-member-name",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._define-member-name))",[0,[6,"define-member-name"]],["scheme/class","scheme"]],
["define-metafunction",">redex/Metafunctions.html#(form._((lib._redex/main..ss)._define-metafunction))",[0,[6,"define-metafunction"]],["redex"]],
["define-metafunction/extension",">redex/Metafunctions.html#(form._((lib._redex/main..ss)._define-metafunction/extension))",[0,[6,"define-metafunction/extension"]],["redex"]],
["define-namespace-anchor",">reference/Namespaces.html#(form._((lib._scheme/base..ss)._define-namespace-anchor))",[0,[6,"define-namespace-anchor"]],["scheme/base","scheme"]],
["define-opt/c",">reference/Contract_Utilities.html#(form._((lib._scheme/contract..ss)._define-opt/c))",[0,[6,"define-opt/c"]],["scheme/contract","scheme"]],
["define-primitive",">htdp-lib/index.html#(form._((lib._lang/prim..ss)._define-primitive))",[0,[6,"define-primitive"]],["lang/prim"]],
["define-provide-syntax",">reference/define.html#(form._((lib._scheme/provide-syntax..ss)._define-provide-syntax))",[0,[6,"define-provide-syntax"]],["scheme/provide-syntax"]],
["define-record-type",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_288",[0,[6,"define-record-type"]],["rnrs/records/syntactic-6"]],
["define-record-type",">srfi-std/srfi-9.html#define-record-type",[0,[6,"define-record-type"]],["srfi/9"]],
["define-require-syntax",">reference/define.html#(form._((lib._scheme/require-syntax..ss)._define-require-syntax))",[0,[6,"define-require-syntax"]],["scheme/require-syntax"]],
["define-runtime-path",">reference/Filesystem.html#(form._((lib._scheme/runtime-path..ss)._define-runtime-path))",[0,[6,"define-runtime-path"]],["scheme/runtime-path"]],
["define-runtime-path-list",">reference/Filesystem.html#(form._((lib._scheme/runtime-path..ss)._define-runtime-path-list))",[0,[6,"define-runtime-path-list"]],["scheme/runtime-path"]],
["define-runtime-paths",">reference/Filesystem.html#(form._((lib._scheme/runtime-path..ss)._define-runtime-paths))",[0,[6,"define-runtime-paths"]],["scheme/runtime-path"]],
["define-sequence-syntax",">reference/for.html#(form._((lib._scheme/base..ss)._define-sequence-syntax))",[0,[6,"define-sequence-syntax"]],["scheme/base","scheme"]],
["define-serializable-class",">reference/objectserialize.html#(form._((lib._scheme/private/class-internal..ss)._define-serializable-class))",[0,[6,"define-serializable-class"]],["scheme/class","scheme"]],
["define-serializable-class*",">reference/objectserialize.html#(form._((lib._scheme/private/class-internal..ss)._define-serializable-class*))",[0,[6,"define-serializable-class*"]],["scheme/class","scheme"]],
["define-serializable-struct",">reference/serialization.html#(form._((lib._scheme/serialize..ss)._define-serializable-struct))",[0,[6,"define-serializable-struct"]],["scheme/serialize"]],
["define-serializable-struct",">mzlib/mzlib_serialize.html#(form._((lib._mzlib/serialize..ss)._define-serializable-struct))",[0,[6,"define-serializable-struct"]],["mzlib/serialize"]],
["define-serializable-struct/versions",">reference/serialization.html#(form._((lib._scheme/serialize..ss)._define-serializable-struct/versions))",[0,[6,"define-serializable-struct/versions"]],["scheme/serialize"]],
["define-serializable-struct/versions",">mzlib/mzlib_serialize.html#(form._((lib._mzlib/serialize..ss)._define-serializable-struct/versions))",[0,[6,"define-serializable-struct/versions"]],["mzlib/serialize"]],
["define-signature",">reference/creatingunits.html#(form._((lib._mzlib/unit..ss)._define-signature))",[0,[6,"define-signature"]],["scheme/unit","scheme"]],
["define-signature-form",">reference/define-sig-form.html#(form._((lib._mzlib/unit..ss)._define-signature-form))",[0,[6,"define-signature-form"]],["scheme/unit","scheme"]],
["define-stream",">srfi-std/srfi-41/srfi-41.html#define-stream",[0,[6,"define-stream"]],["srfi/41"]],
["define-struct",">htdp-langs/advanced-define-struct.html",[0,[6,"define-struct"]],false],
["define-struct",">htdp-langs/define-struct.html",[0,[6,"define-struct"]],false],
["define-struct",">htdp-langs/intermediate-define-struct.html",[0,[6,"define-struct"]],false],
["define-struct",">reference/define-struct.html#(form._((lib._scheme/base..ss)._define-struct))",[0,[6,"define-struct"]],["scheme/base","scheme"]],
["define-struct",">htdp-langs/advanced-define-struct.html#(form._((lib._lang/htdp-advanced..ss)._define-struct))",[0,[6,"define-struct"]],["lang/htdp-advanced"]],
["define-struct",">htdp-langs/define-struct.html#(form._((lib._lang/htdp-beginner..ss)._define-struct))",[0,[6,"define-struct"]],["lang/htdp-beginner"]],
["define-struct",">htdp-langs/Unchanged_Forms.html#(form._((lib._lang/htdp-beginner-abbr..ss)._define-struct))",[0,[6,"define-struct"]],["lang/htdp-beginner-abbr"]],
["define-struct",">htdp-langs/intermediate-define-struct.html#(form._((lib._lang/htdp-intermediate..ss)._define-struct))",[0,[6,"define-struct"]],["lang/htdp-intermediate"]],
["define-struct",">htdp-langs/intermediate-lambda-unchanged.html#(form._((lib._lang/htdp-intermediate-lambda..ss)._define-struct))",[0,[6,"define-struct"]],["lang/htdp-intermediate-lambda"]],
["define-struct",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..ss)._define-struct))",[0,[6,"define-struct"]],["mzscheme"]],
["define-struct/derived",">reference/define-struct.html#(form._((lib._scheme/base..ss)._define-struct/derived))",[0,[6,"define-struct/derived"]],["scheme/base","scheme"]],
["define-struct/properties",">mzlib/mzlib_struct.html#(form._((lib._mzlib/struct..ss)._define-struct/properties))",[0,[6,"define-struct/properties"]],["mzlib/struct"]],
["define-struct:",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._define-struct~3a))",[0,[6,"define-struct:"]],["typed-scheme"]],
["define-structure",">mzlib/mzlib_compat.html#(form._((lib._mzlib/compat..ss)._define-structure))",[0,[6,"define-structure"]],["mzlib/compat"]],
["define-syntax",">reference/define.html#(form._((lib._scheme/private/define..ss)._define-syntax))",[0,[6,"define-syntax"]],["scheme/base","scheme"]],
["define-syntax",">r5rs-std/r5rs-Z-H-8.html#%_idx_202",[0,[6,"define-syntax"]],["r5rs"]],
["define-syntax",">r6rs-std/r6rs-Z-H-14.html#node_idx_358",[0,[6,"define-syntax"]],["rnrs/base-6"]],
["define-syntax and syntax-rules",">guide/pattern-macros.html#(part._define-syntax_and_syntax-rules)",[[0,[6,"define-syntax"]]," and ",[0,[6,"syntax-rules"]]],false],
["define-syntax-parameter",">reference/stxparam.html#(form._((lib._scheme/stxparam..ss)._define-syntax-parameter))",[0,[6,"define-syntax-parameter"]],["scheme/stxparam"]],
["define-syntax-rule",">guide/pattern-macros.html#(part._define-syntax-rule)",[0,[6,"define-syntax-rule"]],false],
["define-syntax-rule",">reference/stx-patterns.html#(form._((lib._scheme/private/misc..ss)._define-syntax-rule))",[0,[6,"define-syntax-rule"]],["scheme/base","scheme"]],
["define-syntax-set",">mzlib/mzlib_etc.html#(form._((lib._mzlib/etc..ss)._define-syntax-set))",[0,[6,"define-syntax-set"]],["mzlib/etc"]],
["define-syntaxes",">reference/define.html#(form._((quote._~23~25kernel)._define-syntaxes))",[0,[6,"define-syntaxes"]],["scheme/base","scheme"]],
["define-tokens",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..ss)._define-tokens))",[0,[6,"define-tokens"]],["parser-tools/lex"]],
["define-type-alias",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._define-type-alias))",[0,[6,"define-type-alias"]],["typed-scheme"]],
["define-unit",">reference/linkinference.html#(form._((lib._mzlib/unit..ss)._define-unit))",[0,[6,"define-unit"]],["scheme/unit","scheme"]],
["define-unit-binding",">reference/linkinference.html#(form._((lib._mzlib/unit..ss)._define-unit-binding))",[0,[6,"define-unit-binding"]],["scheme/unit","scheme"]],
["define-unit-from-context",">reference/Generating_A_Unit_from_Context.html#(form._((lib._mzlib/unit..ss)._define-unit-from-context))",[0,[6,"define-unit-from-context"]],["scheme/unit","scheme"]],
["define-unit/new-import-export",">reference/Structural_Matching.html#(form._((lib._mzlib/unit..ss)._define-unit/new-import-export))",[0,[6,"define-unit/new-import-export"]],["scheme/unit","scheme"]],
["define-unsafer",">foreign/Macros_for_Unsafety.html#(form._((lib._scheme/foreign..ss)._define-unsafer))",[0,[6,"define-unsafer"]],["scheme/foreign"]],
["define-values",">reference/define.html#(form._((quote._~23~25kernel)._define-values))",[0,[6,"define-values"]],["scheme/base","scheme"]],
["define-values",">lazy/index.html#(form._((lib._lazy/main..ss)._define-values))",[0,[6,"define-values"]],["lazy"]],
["define-values-for-syntax",">reference/define.html#(form._((quote._~23~25kernel)._define-values-for-syntax))",[0,[6,"define-values-for-syntax"]],["scheme/base","scheme"]],
["define-values/invoke-unit",">reference/invokingunits.html#(form._((lib._mzlib/unit..ss)._define-values/invoke-unit))",[0,[6,"define-values/invoke-unit"]],["scheme/unit","scheme"]],
["define-values/invoke-unit/infer",">reference/linkinference.html#(form._((lib._mzlib/unit..ss)._define-values/invoke-unit/infer))",[0,[6,"define-values/invoke-unit/infer"]],["scheme/unit","scheme"]],
["define/augment",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._define/augment))",[0,[6,"define/augment"]],["scheme/class","scheme"]],
["define/augment-final",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._define/augment-final))",[0,[6,"define/augment-final"]],["scheme/class","scheme"]],
["define/augride",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._define/augride))",[0,[6,"define/augride"]],["scheme/class","scheme"]],
["define/contract",">reference/Attaching_Contracts_to_Values.html#(form._((lib._scheme/private/contract..ss)._define/contract))",[0,[6,"define/contract"]],["scheme/contract","scheme"]],
["define/kw",">mzlib/mzlib_kw.html#(form._((lib._mzlib/kw..ss)._define/kw))",[0,[6,"define/kw"]],["mzlib/kw"]],
["define/overment",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._define/overment))",[0,[6,"define/overment"]],["scheme/class","scheme"]],
["define/override",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._define/override))",[0,[6,"define/override"]],["scheme/class","scheme"]],
["define/override-final",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._define/override-final))",[0,[6,"define/override-final"]],["scheme/class","scheme"]],
["define/private",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._define/private))",[0,[6,"define/private"]],["scheme/class","scheme"]],
["define/public",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._define/public))",[0,[6,"define/public"]],["scheme/class","scheme"]],
["define/public-final",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._define/public-final))",[0,[6,"define/public-final"]],["scheme/class","scheme"]],
["define/pubment",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._define/pubment))",[0,[6,"define/pubment"]],["scheme/class","scheme"]],
["define:",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._define~3a))",[0,[6,"define:"]],["typed-scheme"]],
["defining custom input signals",">frtime/index.html#(part._.Defining_.Custom_.Input_.Signals)","Defining Custom Input Signals",false],
["defining custom shortcuts",">drscheme/Keyboard_Shortcuts.html#(part._defining-shortcuts)","Defining Custom Shortcuts",false],
["defining new datatypes",">typed-scheme/index.html#(part._.Defining_.New_.Datatypes)","Defining New Datatypes",false],
["defining new types of containers",">gui/windowing-overview.html#(part._new-containers)","Defining New Types of Containers",false],
["defining recursive contracts",">guide/contracts-gotchas.html#(part._.Defining_recursive_contracts)","Defining recursive contracts",false],
["defining scheme bindings",">scribble/How_to_Scribble_Documentation.html#(part._.Defining_.Scheme_.Bindings)","Defining Scheme Bindings",false],
["defining structure types: define-struct",">reference/define-struct.html",["Defining Structure Types: ",[0,[6,"define-struct"]]],false],
["definition",">web-server/lang-servlets.html","Definition",false],
["definition",">web-server/module-servlets.html","Definition",false],
["definitions",">guide/syntax-overview.html#(part._.Definitions)","Definitions",false],
["definitions",">quick/index.html#(part._.Definitions)","Definitions",false],
["definitions and interactions",">guide/intro.html#(part._.Definitions_and_.Interactions)","Definitions and Interactions",false],
["definitions area",">guide/intro.html#(tech._definitions._area)","<i>definitions area</i>",false],
["definitions window",">drscheme/interface-essentials.html#(tech._definitions._window)","<i>definitions window</i>",false],
["definitions window actions",">drscheme/debugger.html#(part._.Definitions_.Window_.Actions)","Definitions Window Actions",false],
["definitions: define",">guide/define.html",["Definitions: ",[0,[6,"define"]]],false],
["definitions: define, define-syntax, ...",">reference/define.html",["Definitions: ",[0,[6,"define"]],", ",[0,[6,"define-syntax"]],", ..."],false],
["definterface",">scribble/doc-classes.html#(form._((lib._scribble/manual..ss)._definterface))",[0,[6,"definterface"]],["scribble/manual"]],
["definterface/title",">scribble/doc-classes.html#(form._((lib._scribble/manual..ss)._definterface/title))",[0,[6,"definterface/title"]],["scribble/manual"]],
["deflate",">file/gzip.html#(def._((lib._file/gzip..ss)._deflate))",[0,[1,"deflate"]],["file/gzip"]],
["defmacro",">mzlib/mzlib_defmacro.html#(form._((lib._mzlib/defmacro..ss)._defmacro))",[0,[6,"defmacro"]],["mzlib/defmacro"]],
["defmethod",">scribble/doc-classes.html#(form._((lib._scribble/manual..ss)._defmethod))",[0,[6,"defmethod"]],["scribble/manual"]],
["defmethod*",">scribble/doc-classes.html#(form._((lib._scribble/manual..ss)._defmethod*))",[0,[6,"defmethod*"]],["scribble/manual"]],
["defmixin",">scribble/doc-classes.html#(form._((lib._scribble/manual..ss)._defmixin))",[0,[6,"defmixin"]],["scribble/manual"]],
["defmixin/title",">scribble/doc-classes.html#(form._((lib._scribble/manual..ss)._defmixin/title))",[0,[6,"defmixin/title"]],["scribble/manual"]],
["defmodule",">scribble/doc-modules.html#(form._((lib._scribble/manual..ss)._defmodule))",[0,[6,"defmodule"]],["scribble/manual"]],
["defmodule*",">scribble/doc-modules.html#(form._((lib._scribble/manual..ss)._defmodule*))",[0,[6,"defmodule*"]],["scribble/manual"]],
["defmodule*/no-declare",">scribble/doc-modules.html#(form._((lib._scribble/manual..ss)._defmodule*/no-declare))",[0,[6,"defmodule*/no-declare"]],["scribble/manual"]],
["defmodulelang",">scribble/doc-modules.html#(form._((lib._scribble/manual..ss)._defmodulelang))",[0,[6,"defmodulelang"]],["scribble/manual"]],
["defmodulelang*",">scribble/doc-modules.html#(form._((lib._scribble/manual..ss)._defmodulelang*))",[0,[6,"defmodulelang*"]],["scribble/manual"]],
["defmodulelang*/no-declare",">scribble/doc-modules.html#(form._((lib._scribble/manual..ss)._defmodulelang*/no-declare))",[0,[6,"defmodulelang*/no-declare"]],["scribble/manual"]],
["defparam",">scribble/doc-forms.html#(form._((lib._scribble/manual..ss)._defparam))",[0,[6,"defparam"]],["scribble/manual"]],
["defproc",">scribble/doc-forms.html#(form._((lib._scribble/manual..ss)._defproc))",[0,[6,"defproc"]],["scribble/manual"]],
["defproc*",">scribble/doc-forms.html#(form._((lib._scribble/manual..ss)._defproc*))",[0,[6,"defproc*"]],["scribble/manual"]],
["defs+int",">scribble/eval.html#(form._((lib._scribble/eval..ss)._defs+int))",[0,[6,"defs+int"]],["scribble/eval"]],
["defsignature",">scribble/doc-signatures.html#(form._((lib._scribble/manual..ss)._defsignature))",[0,[6,"defsignature"]],["scribble/manual"]],
["defsignature/splice",">scribble/doc-signatures.html#(form._((lib._scribble/manual..ss)._defsignature/splice))",[0,[6,"defsignature/splice"]],["scribble/manual"]],
["defstruct",">scribble/doc-forms.html#(form._((lib._scribble/manual..ss)._defstruct))",[0,[6,"defstruct"]],["scribble/manual"]],
["deftech",">scribble/section-links.html#(def._((lib._scribble/manual..ss)._deftech))",[0,[1,"deftech"]],["scribble/manual"]],
["defterm",">scribble/doc-strings.html#(def._((lib._scribble/manual..ss)._defterm))",[0,[1,"defterm"]],["scribble/manual"]],
["defthing",">scribble/doc-forms.html#(form._((lib._scribble/manual..ss)._defthing))",[0,[6,"defthing"]],["scribble/manual"]],
["deftogether",">scribble/doc-forms.html#(form._((lib._scribble/manual..ss)._deftogether))",[0,[6,"deftogether"]],["scribble/manual"]],
["del",">html/index.html#(def._((lib._html/main..ss)._del))",[0,[1,"del"]],["html"]],
["del?",">html/index.html#(def._((lib._html/main..ss)._del~3f))",[0,[1,"del?"]],["html"]],
["delay",">htdp-langs/delay.html",[0,[6,"delay"]],false],
["delay",">reference/Delayed_Evaluation.html#(form._((lib._scheme/promise..ss)._delay))",[0,[6,"delay"]],["scheme/promise","scheme"]],
["delay",">r5rs-std/r5rs-Z-H-7.html#%_idx_146",[0,[6,"delay"]],["r5rs"]],
["delay",">r6rs-lib-std/r6rs-lib-Z-H-20.html#node_idx_1296",[0,[6,"delay"]],["rnrs/r5rs-6"]],
["delay",">htdp-langs/delay.html#(form._((lib._lang/htdp-advanced..ss)._delay))",[0,[6,"delay"]],["lang/htdp-advanced"]],
["delay",">srfi-std/srfi-45.html#delay",[0,[6,"delay"]],["srfi/45"]],
["delay-by",">frtime/index.html#(def._((lib._frtime/main..ss)._delay-by))",[0,[1,"delay-by"]],["frtime"]],
["delayed block",">scribble/struct.html#(tech._delayed._block)","<i>delayed block</i>",false],
["delayed element",">scribble/struct.html#(tech._delayed._element)","<i>delayed element</i>",false],
["delayed evaluation",">reference/Delayed_Evaluation.html","Delayed Evaluation",false],
["delayed-block",">scribble/struct.html#(def._((lib._scribble/struct..ss)._delayed-block))",[0,[1,"delayed-block"]],["scribble/struct"]],
["delayed-block-resolve",">scribble/struct.html#(def._((lib._scribble/struct..ss)._delayed-block-resolve))",[0,[1,"delayed-block-resolve"]],["scribble/struct"]],
["delayed-block?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._delayed-block~3f))",[0,[1,"delayed-block?"]],["scribble/struct"]],
["delayed-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._delayed-element))",[0,[1,"delayed-element"]],["scribble/struct"]],
["delayed-element-plain",">scribble/struct.html#(def._((lib._scribble/struct..ss)._delayed-element-plain))",[0,[1,"delayed-element-plain"]],["scribble/struct"]],
["delayed-element-resolve",">scribble/struct.html#(def._((lib._scribble/struct..ss)._delayed-element-resolve))",[0,[1,"delayed-element-resolve"]],["scribble/struct"]],
["delayed-element-sizer",">scribble/struct.html#(def._((lib._scribble/struct..ss)._delayed-element-sizer))",[0,[1,"delayed-element-sizer"]],["scribble/struct"]],
["delayed-element?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._delayed-element~3f))",[0,[1,"delayed-element?"]],["scribble/struct"]],
["delegate-moved",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3adelegate~3c~25~3e)._delegate-moved))",[[0,[1,"delegate-moved"]],[12,[" (method of ",[0,[1,"frame:delegate&lt;%&gt;"]],")"]]],["framework"]],
["delegated-text-shown?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3adelegate~3c~25~3e)._delegated-text-shown~3f))",[[0,[1,"delegated-text-shown?"]],[12,[" (method of ",[0,[1,"frame:delegate&lt;%&gt;"]],")"]]],["framework"]],
["delete",">gui/list-box_.html#(meth._(((lib._mred/main..ss)._list-box~25)._delete))",[[0,[1,"delete"]],[12,[" (method of ",[0,[1,"list-box%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["delete",">gui/menu-item___.html#(meth._(((lib._mred/main..ss)._menu-item~3c~25~3e)._delete))",[[0,[1,"delete"]],[12,[" (method of ",[0,[1,"menu-item&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["delete",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._delete))",[[0,[1,"delete"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["delete",">gui/tab-panel_.html#(meth._(((lib._mred/main..ss)._tab-panel~25)._delete))",[[0,[1,"delete"]],[12,[" (method of ",[0,[1,"tab-panel%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["delete",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._delete))",[[0,[1,"delete"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["delete",">srfi-std/srfi-1.html#delete",[0,[1,"delete"]],["srfi/1"]],
["delete",">reference/securityguards.html#(idx._(gentag._206._(lib._scribblings/reference/reference..scrbl)))",[7,"'delete"],false],
["delete menu item",">drscheme/Menus.html#(idx._(gentag._81._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Delete</font></b> menu item",false],
["delete!",">srfi-std/srfi-1.html#delete!",[0,[1,"delete!"]],["srfi/1"]],
["delete-child",">gui/area-container___.html#(meth._(((lib._mred/main..ss)._area-container~3c~25~3e)._delete-child))",[[0,[1,"delete-child"]],[12,[" (method of ",[0,[1,"area-container&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["delete-child",">embedded-gui/alignment-parent___.html#(meth._(((lib._embedded-gui/main..ss)._alignment-parent~3c~25~3e)._delete-child))",[[0,[1,"delete-child"]],[12,[" (method of ",[0,[1,"alignment-parent&lt;%&gt;"]],")"]]],["embedded-gui"]],
["delete-directory",">reference/Filesystem.html#(def._((quote._~23~25kernel)._delete-directory))",[0,[1,"delete-directory"]],["scheme/base","scheme"]],
["delete-directory/files",">reference/Filesystem.html#(def._((lib._scheme/file..ss)._delete-directory/files))",[0,[1,"delete-directory/files"]],["scheme/file","scheme"]],
["delete-duplicates",">srfi-std/srfi-1.html#delete-duplicates",[0,[1,"delete-duplicates"]],["srfi/1"]],
["delete-duplicates!",">srfi-std/srfi-1.html#delete-duplicates!",[0,[1,"delete-duplicates!"]],["srfi/1"]],
["delete-file",">reference/Filesystem.html#(def._((quote._~23~25kernel)._delete-file))",[0,[1,"delete-file"]],["scheme/base","scheme"]],
["delete-file",">r6rs-lib-std/r6rs-lib-Z-H-10.html#node_idx_840",[0,[1,"delete-file"]],["rnrs/files-6"]],
["delete-impure-port",">net/url.html#(def._((lib._net/url..ss)._delete-impure-port))",[0,[1,"delete-impure-port"]],["net/url"]],
["delete-item",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._delete-item))",[[0,[1,"delete-item"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["delete-item",">mrlib/hierarchical-list-compound-item___.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list-compound-item~3c~25~3e)._delete-item))",[[0,[1,"delete-item"]],[12,[" (method of ",[0,[1,"hierarchical-list-compound-item&lt;%&gt;"]],")"]]],["mrlib/hierlist"]],
["delete-message",">net/pop3.html#(def._((lib._net/pop3..ss)._delete-message))",[0,[1,"delete-message"]],["net/pop3"]],
["delete-pure-port",">net/url.html#(def._((lib._net/url..ss)._delete-pure-port))",[0,[1,"delete-pure-port"]],["net/url"]],
["delete/io",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._delete/io))",[[0,[1,"delete/io"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["deleted",">gui/windowing-overview.html#(tech._deleted)","<i>deleted</i>",false],
["delimited continuation",">reference/eval-model.html#(tech._delimited._continuation)","<i>delimited continuation</i>",false],
["delimited continuations",">guide/Continuations.html#(tech._delimited._continuation)","<i>delimited continuations</i>",false],
["delimiters and dispatch",">reference/reader.html#(part._default-readtable-dispatch)","Delimiters and Dispatch",false],
["delta",">gui/editor-overview.html#(tech._delta)","<i>delta</i>",false],
["denominator",">reference/numbers.html#(def._((quote._~23~25kernel)._denominator))",[0,[1,"denominator"]],["scheme/base","scheme"]],
["denominator",">r5rs-std/r5rs-Z-H-9.html#%_idx_312",[0,[1,"denominator"]],["r5rs"]],
["denominator",">r6rs-std/r6rs-Z-H-14.html#node_idx_526",[0,[1,"denominator"]],["rnrs/base-6"]],
["denominator",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._denominator))",[0,[1,"denominator"]],["lang/htdp-advanced"]],
["denominator",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._denominator))",[0,[1,"denominator"]],["lang/htdp-beginner"]],
["denominator",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._denominator))",[0,[1,"denominator"]],["lang/htdp-beginner-abbr"]],
["denominator",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._denominator))",[0,[1,"denominator"]],["lang/htdp-intermediate"]],
["denominator",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._denominator))",[0,[1,"denominator"]],["lang/htdp-intermediate-lambda"]],
["dependency files",">mzc/make.html#(part._.Dependency_.Files)","Dependency Files",false],
["depth marker",">reference/stx-patterns.html#(tech._depth._marker)","<i>depth marker</i>",false],
["derivative",">frtime/index.html#(def._((lib._frtime/main..ss)._derivative))",[0,[1,"derivative"]],["frtime"]],
["derivative",">plot/plot.html#(def._((lib._plot/main..ss)._derivative))",[0,[1,"derivative"]],["plot"]],
["derived class",">reference/mzlib_class.html#(tech._derived._clas)","<i>derived class</i>",false],
["derived style",">gui/editor-overview.html#(tech._derived._style)","<i>derived style</i>",false],
["derived utilities",">foreign/Derived_Utilities.html","Derived Utilities",false],
["deriving new iteration forms",">reference/for.html#(part._.Deriving_.New_.Iteration_.Forms)","Deriving New Iteration Forms",false],
["deserialize",">reference/serialization.html#(def._((lib._scheme/private/serialize..ss)._deserialize))",[0,[1,"deserialize"]],["scheme/serialize"]],
["deserialize-info",">scribble/renderer.html#(meth._(((lib._scribble/base-render..ss)._render~25)._deserialize-info))",[[0,[1,"deserialize-info"]],[12,[" (method of ",[0,[1,"render%"]],")"]]],["scribble/base-render"]],
["deserialize-module-guard",">reference/serialization.html#(def._((lib._scheme/private/serialize..ss)._deserialize-module-guard))",[0,[1,"deserialize-module-guard"]],["scheme/serialize"]],
["desk-dir",">reference/Filesystem.html#(idx._(gentag._256._(lib._scribblings/reference/reference..scrbl)))",[7,"'desk-dir"],false],
["destructing bind",">guide/match.html#(idx._(gentag._0._(lib._scribblings/guide/guide..scrbl)))","destructing\nbind",false],
["determine your package's backwards-compatibility",">planet/Developing_Packages_for_PLaneT.html#(part._backwards-compatibility)","Determine Your Package&rsquo;s Backwards-Compatibility",false],
["determine-width",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3ainfo~3c~25~3e)._determine-width))",[[0,[1,"determine-width"]],[12,[" (method of ",[0,[1,"frame:info&lt;%&gt;"]],")"]]],["framework"]],
["developing packages for planet",">planet/Developing_Packages_for_PLaneT.html","Developing Packages for PLaneT",false],
["development links",">planet/Developing_Packages_for_PLaneT.html#(part._devlinks)","Development Links",false],
["device context",">gui/drawing-overview.html#(tech._device._context)","<i>device context</i>",false],
["dflag",">scribble/doc-strings.html#(def._((lib._scribble/manual..ss)._.D.Flag))",[0,[1,"DFlag"]],["scribble/manual"]],
["dfn",">html/index.html#(def._((lib._html/main..ss)._dfn))",[0,[1,"dfn"]],["html"]],
["dfn?",">html/index.html#(def._((lib._html/main..ss)._dfn~3f))",[0,[1,"dfn?"]],["html"]],
["dialog",">gui/windowing-overview.html#(tech._dialog)","<i>dialog</i>",false],
["dialog%",">gui/dialog_.html",[0,[1,"dialog%"]],["scheme/gui/base","scheme/gui"]],
["dialogs modal",">gui/windowing-overview.html#(idx._(gentag._10._(lib._scribblings/gui/gui..scrbl)))","dialogs, modal",false],
["dialogs",">gui/Windowing_Functions.html#(part._.Dialogs)","Dialogs",false],
["dict-can-functional-set?",">reference/dicts.html#(def._((lib._scheme/dict..ss)._dict-can-functional-set~3f))",[0,[1,"dict-can-functional-set?"]],["scheme/dict","scheme"]],
["dict-can-remove-keys?",">reference/dicts.html#(def._((lib._scheme/dict..ss)._dict-can-remove-keys~3f))",[0,[1,"dict-can-remove-keys?"]],["scheme/dict","scheme"]],
["dict-count",">reference/dicts.html#(def._((lib._scheme/dict..ss)._dict-count))",[0,[1,"dict-count"]],["scheme/dict","scheme"]],
["dict-for-each",">reference/dicts.html#(def._((lib._scheme/dict..ss)._dict-for-each))",[0,[1,"dict-for-each"]],["scheme/dict","scheme"]],
["dict-iterate-first",">reference/dicts.html#(def._((lib._scheme/dict..ss)._dict-iterate-first))",[0,[1,"dict-iterate-first"]],["scheme/dict","scheme"]],
["dict-iterate-key",">reference/dicts.html#(def._((lib._scheme/dict..ss)._dict-iterate-key))",[0,[1,"dict-iterate-key"]],["scheme/dict","scheme"]],
["dict-iterate-next",">reference/dicts.html#(def._((lib._scheme/dict..ss)._dict-iterate-next))",[0,[1,"dict-iterate-next"]],["scheme/dict","scheme"]],
["dict-iterate-value",">reference/dicts.html#(def._((lib._scheme/dict..ss)._dict-iterate-value))",[0,[1,"dict-iterate-value"]],["scheme/dict","scheme"]],
["dict-map",">reference/dicts.html#(def._((lib._scheme/dict..ss)._dict-map))",[0,[1,"dict-map"]],["scheme/dict","scheme"]],
["dict-mutable?",">reference/dicts.html#(def._((lib._scheme/dict..ss)._dict-mutable~3f))",[0,[1,"dict-mutable?"]],["scheme/dict","scheme"]],
["dict-ref",">reference/dicts.html#(def._((lib._scheme/dict..ss)._dict-ref))",[0,[1,"dict-ref"]],["scheme/dict","scheme"]],
["dict-remove",">reference/dicts.html#(def._((lib._scheme/dict..ss)._dict-remove))",[0,[1,"dict-remove"]],["scheme/dict","scheme"]],
["dict-remove!",">reference/dicts.html#(def._((lib._scheme/dict..ss)._dict-remove!))",[0,[1,"dict-remove!"]],["scheme/dict","scheme"]],
["dict-set",">reference/dicts.html#(def._((lib._scheme/dict..ss)._dict-set))",[0,[1,"dict-set"]],["scheme/dict","scheme"]],
["dict-set!",">reference/dicts.html#(def._((lib._scheme/dict..ss)._dict-set!))",[0,[1,"dict-set!"]],["scheme/dict","scheme"]],
["dict-update",">reference/dicts.html#(def._((lib._scheme/dict..ss)._dict-update))",[0,[1,"dict-update"]],["scheme/dict","scheme"]],
["dict-update!",">reference/dicts.html#(def._((lib._scheme/dict..ss)._dict-update!))",[0,[1,"dict-update!"]],["scheme/dict","scheme"]],
["dict?",">reference/dicts.html#(def._((lib._scheme/dict..ss)._dict~3f))",[0,[1,"dict?"]],["scheme/dict","scheme"]],
["dictionaries",">reference/dicts.html","Dictionaries",false],
["dictionary",">reference/dicts.html#(tech._dictionary)","<i>dictionary</i>",false],
["dictionary x-expression",">xml/index.html#(tech._dictionary._x._expression)","<i>dictionary X-expression</i>",false],
["difference",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..ss)._difference))",[0,[1,"difference"]],["mzlib/integer-set"]],
["dim",">cards/index.html#(meth._(((lib._games/cards..ss)._card~3c~25~3e)._dim))",[[0,[1,"dim"]],[12,[" (method of ",[0,[1,"card&lt;%&gt;"]],")"]]],["games/cards"]],
["dimension?",">file/gif.html#(def._((lib._file/gif..ss)._dimension~3f))",[0,[1,"dimension?"]],["file/gif"]],
["dingbats",">slideshow/More_Pict_Constructors.html#(part._.Dingbats)","Dingbats",false],
["dir",">html/index.html#(def._((lib._html/main..ss)._dir))",[0,[1,"dir"]],["html"]],
["dir",">teachpack/dir.html#(def._((lib._teachpack/htdp/dir..ss)._dir))",[0,[1,"dir"]],["teachpack/htdp/dir"]],
["dir teachpack",">teachpack/dir.html#(idx._(gentag._9._(lib._teachpack/teachpack..scrbl)))","dir teachpack",false],
["dir-dirs",">teachpack/dir.html#(def._((lib._teachpack/htdp/dir..ss)._dir-dirs))",[0,[1,"dir-dirs"]],["teachpack/htdp/dir"]],
["dir-files",">teachpack/dir.html#(def._((lib._teachpack/htdp/dir..ss)._dir-files))",[0,[1,"dir-files"]],["teachpack/htdp/dir"]],
["dir-name",">teachpack/dir.html#(def._((lib._teachpack/htdp/dir..ss)._dir-name))",[0,[1,"dir-name"]],["teachpack/htdp/dir"]],
["dir?",">html/index.html#(def._((lib._html/main..ss)._dir~3f))",[0,[1,"dir?"]],["html"]],
["dir?",">teachpack/dir.html#(def._((lib._teachpack/htdp/dir..ss)._dir~3f))",[0,[1,"dir?"]],["teachpack/htdp/dir"]],
["direct bindings for readline hackers",">readline/index.html#(part._.Direct_.Bindings_for_.Readline_.Hackers)","Direct Bindings for Readline Hackers",false],
["directories",">reference/Filesystem.html#(part._directories)","Directories",false],
["directory-exists?",">reference/Filesystem.html#(def._((quote._~23~25kernel)._directory-exists~3f))",[0,[1,"directory-exists?"]],["scheme/base","scheme"]],
["directory-list",">reference/Filesystem.html#(def._((quote._~23~25kernel)._directory-list))",[0,[1,"directory-list"]],["scheme/base","scheme"]],
["directory-part",">web-server/util_ss.html#(def._((lib._web-server/private/util..ss)._directory-part))",[0,[1,"directory-part"]],["web-server/private/util"]],
["disable tests menu item",">drscheme/Menus.html#(idx._(gentag._130._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Disable Tests</font></b> menu item",false],
["disable-evaluation",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3acontext~3c~25~3e)._disable-evaluation))",[[0,[1,"disable-evaluation"]],[12,[" (method of ",[0,[1,"drscheme:rep:context&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["disable-evaluation",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3atab~3c~25~3e)._disable-evaluation))",[[0,[1,"disable-evaluation"]],[12,[" (method of ",[0,[1,"drscheme:unit:tab&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["disappeared-binding",">reference/stxprops.html#(idx._(gentag._85._(lib._scribblings/reference/reference..scrbl)))",[7,"'disappeared-binding"],false],
["disappeared-use",">reference/stxprops.html#(idx._(gentag._86._(lib._scribblings/reference/reference..scrbl)))",[7,"'disappeared-use"],false],
["disconnect-from-server",">net/nntp.html#(def._((lib._net/nntp..ss)._disconnect-from-server))",[0,[1,"disconnect-from-server"]],["net/nntp"]],
["disconnect-from-server",">net/pop3.html#(def._((lib._net/pop3..ss)._disconnect-from-server))",[0,[1,"disconnect-from-server"]],["net/pop3"]],
["disconnect-not-quiet",">net/pop3.html#(def._((lib._net/pop3..ss)._disconnect-not-quiet))",[0,[1,"disconnect-not-quiet"]],["net/pop3"]],
["disconnect-not-quiet-communicator",">net/pop3.html#(def._((lib._net/pop3..ss)._disconnect-not-quiet-communicator))",[0,[1,"disconnect-not-quiet-communicator"]],["net/pop3"]],
["disconnect-not-quiet?",">net/pop3.html#(def._((lib._net/pop3..ss)._disconnect-not-quiet~3f))",[0,[1,"disconnect-not-quiet?"]],["net/pop3"]],
["disk",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._disk))",[0,[1,"disk"]],["slideshow/pict","slideshow"]],
["dispatch",">web-server/dispatch-server-unit_ss.html#(sig-val._((lib._web-server/private/dispatch-server-sig..ss)._dispatch-server-config~5e._dispatch))",[0,[1,"dispatch"]],["web-server/private/dispatch-server-sig"]],
["dispatch-macro",">reference/readtables.html#(idx._(gentag._199._(lib._scribblings/reference/reference..scrbl)))",[7,"'dispatch-macro"],false],
["dispatch-server-config^",">web-server/dispatch-server-unit_ss.html#(form._((lib._web-server/private/dispatch-server-sig..ss)._dispatch-server-config~5e))",[0,[6,"dispatch-server-config^"]],["web-server/private/dispatch-server-sig"]],
["dispatch-server@",">web-server/dispatch-server-unit_ss.html#(def._((lib._web-server/private/dispatch-server-unit..ss)._dispatch-server~40))",[0,[1,"dispatch-server@"]],["web-server/private/dispatch-server-unit"]],
["dispatch-server^",">web-server/dispatch-server-unit_ss.html#(form._((lib._web-server/private/dispatch-server-sig..ss)._dispatch-server~5e))",[0,[6,"dispatch-server^"]],["web-server/private/dispatch-server-sig"]],
["dispatch: case",">reference/case.html",["Dispatch: ",[0,[6,"case"]]],false],
["dispatcher-interface-version/c",">web-server/dispatch_ss.html#(def._((lib._web-server/dispatchers/dispatch..ss)._dispatcher-interface-version/c))",[0,[1,"dispatcher-interface-version/c"]],["web-server/dispatchers/dispatch"]],
["dispatcher/c",">web-server/dispatch_ss.html#(def._((lib._web-server/dispatchers/dispatch..ss)._dispatcher/c))",[0,[1,"dispatcher/c"]],["web-server/dispatchers/dispatch"]],
["dispatchers",">web-server/dispatchers.html","Dispatchers",false],
["dispatchers",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..ss)._dispatchers))",[0,[1,"dispatchers"]],["preprocessor/mztext"]],
["dispatching",">more/index.html#(part._.Dispatching)","Dispatching",false],
["dispatching server",">web-server/dispatch-server-unit_ss.html","Dispatching Server",false],
["dispatching server signatures",">web-server/dispatch-server-unit_ss.html#(part._.Dispatching_.Server_.Signatures)","Dispatching Server Signatures",false],
["dispatching server unit",">web-server/dispatch-server-unit_ss.html#(part._.Dispatching_.Server_.Unit)","Dispatching Server Unit",false],
["display",">reference/Writing.html#(def._((quote._~23~25kernel)._display))",[0,[1,"display"]],["scheme/base","scheme"]],
["display",">r5rs-std/r5rs-Z-H-9.html#%_idx_658",[0,[1,"display"]],["r5rs"]],
["display",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_828",[0,[1,"display"]],["rnrs/io/simple-6"]],
["display",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._display))",[0,[1,"display"]],["lang/htdp-advanced"]],
["display",">lazy/index.html#(def._((lib._lazy/main..ss)._display))",[0,[1,"display"]],["lazy"]],
["display",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._display))",[[0,[1,"display"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["display",">drscheme/interactions-window.html#(idx._(gentag._30._(lib._scribblings/drscheme/drscheme..scrbl)))",[0,[1,"display"]],false],
["display",">gui/editor-overview.html#(tech._display)","<i>display</i>",false],
["display size and fonts",">slideshow/Creating_Slide_Presentations.html#(part._display-size)","Display Size and Fonts",false],
["display-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._display-native))",[[0,[1,"display-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["display-plt-archived-file",">planet/Utility_Libraries.html#(def._((lib._planet/util..ss)._display-plt-archived-file))",[0,[1,"display-plt-archived-file"]],["planet/util"]],
["display-plt-file-structure",">planet/Utility_Libraries.html#(def._((lib._planet/util..ss)._display-plt-file-structure))",[0,[1,"display-plt-file-structure"]],["planet/util"]],
["display-pure-port",">net/url.html#(def._((lib._net/url..ss)._display-pure-port))",[0,[1,"display-pure-port"]],["net/url"]],
["display-results",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3atext~25)._display-results))",[[0,[1,"display-results"]],[12,[" (method of ",[0,[1,"drscheme:rep:text%"]],")"]]],["drscheme/tool-lib"]],
["display-xml",">xml/index.html#(def._((lib._xml/main..ss)._display-xml))",[0,[1,"display-xml"]],["xml"]],
["display-xml/content",">xml/index.html#(def._((lib._xml/main..ss)._display-xml/content))",[0,[1,"display-xml/content"]],["xml"]],
["disposition",">net/mime.html#(def._((lib._net/mime..ss)._disposition))",[0,[1,"disposition"]],["net/mime"]],
["disposition-creation",">net/mime.html#(def._((lib._net/mime..ss)._disposition-creation))",[0,[1,"disposition-creation"]],["net/mime"]],
["disposition-filename",">net/mime.html#(def._((lib._net/mime..ss)._disposition-filename))",[0,[1,"disposition-filename"]],["net/mime"]],
["disposition-modification",">net/mime.html#(def._((lib._net/mime..ss)._disposition-modification))",[0,[1,"disposition-modification"]],["net/mime"]],
["disposition-params",">net/mime.html#(def._((lib._net/mime..ss)._disposition-params))",[0,[1,"disposition-params"]],["net/mime"]],
["disposition-read",">net/mime.html#(def._((lib._net/mime..ss)._disposition-read))",[0,[1,"disposition-read"]],["net/mime"]],
["disposition-size",">net/mime.html#(def._((lib._net/mime..ss)._disposition-size))",[0,[1,"disposition-size"]],["net/mime"]],
["disposition-type",">net/mime.html#(def._((lib._net/mime..ss)._disposition-type))",[0,[1,"disposition-type"]],["net/mime"]],
["disposition?",">net/mime.html#(def._((lib._net/mime..ss)._disposition~3f))",[0,[1,"disposition?"]],["net/mime"]],
["distributing stand-alone executables",">mzc/exe-dist.html","Distributing Stand-Alone Executables",false],
["distribution archive",">drscheme/create-exe.html#(tech._distribution._archive)","<i>distribution archive</i>",false],
["div",">r6rs-std/r6rs-Z-H-14.html#node_idx_510",[0,[1,"div"]],["rnrs/base-6"]],
["div",">html/index.html#(def._((lib._html/main..ss)._div))",[0,[1,"div"]],["html"]],
["div-and-mod",">r6rs-std/r6rs-Z-H-14.html#node_idx_508",[0,[1,"div-and-mod"]],["rnrs/base-6"]],
["div0",">r6rs-std/r6rs-Z-H-14.html#node_idx_516",[0,[1,"div0"]],["rnrs/base-6"]],
["div0-and-mod0",">r6rs-std/r6rs-Z-H-14.html#node_idx_514",[0,[1,"div0-and-mod0"]],["rnrs/base-6"]],
["div?",">html/index.html#(def._((lib._html/main..ss)._div~3f))",[0,[1,"div?"]],["html"]],
["divide",">gui/key-event_.html#(idx._(gentag._85._(lib._scribblings/gui/gui..scrbl)))",[7,"'divide"],false],
["division by inexact zero",">reference/numbers.html#(idx._(gentag._14._(lib._scribblings/reference/reference..scrbl)))","division by inexact zero",false],
["dl",">html/index.html#(def._((lib._html/main..ss)._dl))",[0,[1,"dl"]],["html"]],
["dl?",">html/index.html#(def._((lib._html/main..ss)._dl~3f))",[0,[1,"dl?"]],["html"]],
["dll",">reference/runtime.html#(idx._(gentag._305._(lib._scribblings/reference/reference..scrbl)))",[7,"'dll"],false],
["dll-dir",">config/index.html#(def._((lib._config/main..ss)._dll-dir))",[0,[1,"dll-dir"]],["config"]],
["dllist<%>",">embedded-gui/dllist___.html",[0,[1,"dllist&lt;%&gt;"]],["embedded-gui"]],
["dns signature",">net/dns.html#(part._.D.N.S_.Signature)","DNS Signature",false],
["dns unit",">net/dns.html#(part._.D.N.S_.Unit)","DNS Unit",false],
["dns-find-nameserver",">net/dns.html#(def._((lib._net/dns..ss)._dns-find-nameserver))",[0,[1,"dns-find-nameserver"]],["net/dns"]],
["dns-get-address",">net/dns.html#(def._((lib._net/dns..ss)._dns-get-address))",[0,[1,"dns-get-address"]],["net/dns"]],
["dns-get-mail-exchanger",">net/dns.html#(def._((lib._net/dns..ss)._dns-get-mail-exchanger))",[0,[1,"dns-get-mail-exchanger"]],["net/dns"]],
["dns-get-name",">net/dns.html#(def._((lib._net/dns..ss)._dns-get-name))",[0,[1,"dns-get-name"]],["net/dns"]],
["dns: domain name service queries",">net/dns.html","DNS: Domain Name Service Queries",false],
["dns@",">net/dns.html#(def._((lib._net/dns-unit..ss)._dns~40))",[0,[1,"dns@"]],["net/dns-unit"]],
["dns^",">net/dns.html#(form._((lib._net/dns-sig..ss)._dns~5e))",[0,[6,"dns^"]],["net/dns-sig"]],
["do",">reference/for.html#(form._((lib._scheme/private/more-scheme..ss)._do))",[0,[6,"do"]],["scheme/base","scheme"]],
["do",">r5rs-std/r5rs-Z-H-7.html#%_idx_140",[0,[6,"do"]],["r5rs"]],
["do",">r6rs-lib-std/r6rs-lib-Z-H-6.html#node_idx_258",[0,[6,"do"]],["rnrs/control-6"]],
["do loops",">reference/for.html#(part._.Do_.Loops)","Do Loops",false],
["do-autosave",">framework/Autosave.html#(meth._(((lib._framework/main..ss)._autosave~3aautosavable~3c~25~3e)._do-autosave))",[[0,[1,"do-autosave"]],[12,[" (method of ",[0,[1,"autosave:autosavable&lt;%&gt;"]],")"]]],["framework"]],
["do-autosave",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abackup-autosave~3c~25~3e)._do-autosave))",[[0,[1,"do-autosave"]],[12,[" (method of ",[0,[1,"editor:backup-autosave&lt;%&gt;"]],")"]]],["framework"]],
["do-copy",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._do-copy))",[[0,[1,"do-copy"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["do-copy",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._do-copy))",[[0,[1,"do-copy"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["do-ec",">srfi-std/srfi-42.html#do-ec",[0,[6,"do-ec"]],["srfi/42"]],
["do-edit-operation",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._do-edit-operation))",[[0,[1,"do-edit-operation"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["do-edit-operation",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._do-edit-operation))",[[0,[1,"do-edit-operation"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["do-edit-operation",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._do-edit-operation))",[[0,[1,"do-edit-operation"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["do-macro",">framework/Keymap.html#(idx._(gentag._40._(lib._scribblings/framework/framework..scrbl)))","do-macro",false],
["do-many-evals",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3atext~25)._do-many-evals))",[[0,[1,"do-many-evals"]],[12,[" (method of ",[0,[1,"drscheme:rep:text%"]],")"]]],["drscheme/tool-lib"]],
["do-many-text-evals",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3atext~25)._do-many-text-evals))",[[0,[1,"do-many-text-evals"]],[12,[" (method of ",[0,[1,"drscheme:rep:text%"]],")"]]],["drscheme/tool-lib"]],
["do-not-return",">web-server/web-server_ss.html#(def._((lib._web-server/web-server..ss)._do-not-return))",[0,[1,"do-not-return"]],["web-server/web-server"]],
["do-paste",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._do-paste))",[[0,[1,"do-paste"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["do-paste",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._do-paste))",[[0,[1,"do-paste"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["do-paste-x-selection",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._do-paste-x-selection))",[[0,[1,"do-paste-x-selection"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["do-paste-x-selection",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._do-paste-x-selection))",[[0,[1,"do-paste-x-selection"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["doc-dir",">config/index.html#(def._((lib._config/main..ss)._doc-dir))",[0,[1,"doc-dir"]],["config"]],
["doc-dir",">reference/Filesystem.html#(idx._(gentag._255._(lib._scribblings/reference/reference..scrbl)))",[7,"'doc-dir"],false],
["doc-search-dirs",">config/index.html#(def._((lib._config/main..ss)._doc-search-dirs))",[0,[1,"doc-search-dirs"]],["config"]],
["dock test report menu item",">drscheme/Menus.html#(idx._(gentag._109._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Dock Test Report</font></b> menu item",false],
["docs teachpack",">teachpack/docs.html#(idx._(gentag._8._(lib._teachpack/teachpack..scrbl)))","docs teachpack",false],
["document",">xml/index.html#(def._((lib._xml/main..ss)._document))",[0,[1,"document"]],["xml"]],
["document language",">scribble/doclang.html","Document Language",false],
["document reader",">scribble/docreader.html","Document Reader",false],
["document structure",">scribble/basic.html#(part._.Document_.Structure)","Document Structure",false],
["document syntax",">scribble/How_to_Scribble_Documentation.html#(part._how-to~3areader)","Document Syntax",false],
["document-element",">xml/index.html#(def._((lib._xml/main..ss)._document-element))",[0,[1,"document-element"]],["xml"]],
["document-misc",">xml/index.html#(def._((lib._xml/main..ss)._document-misc))",[0,[1,"document-misc"]],["xml"]],
["document-prolog",">xml/index.html#(def._((lib._xml/main..ss)._document-prolog))",[0,[1,"document-prolog"]],["xml"]],
["document-type",">xml/index.html#(def._((lib._xml/main..ss)._document-type))",[0,[1,"document-type"]],["xml"]],
["document-type-external",">xml/index.html#(def._((lib._xml/main..ss)._document-type-external))",[0,[1,"document-type-external"]],["xml"]],
["document-type-inlined",">xml/index.html#(def._((lib._xml/main..ss)._document-type-inlined))",[0,[1,"document-type-inlined"]],["xml"]],
["document-type-name",">xml/index.html#(def._((lib._xml/main..ss)._document-type-name))",[0,[1,"document-type-name"]],["xml"]],
["document-type?",">xml/index.html#(def._((lib._xml/main..ss)._document-type~3f))",[0,[1,"document-type?"]],["xml"]],
["document?",">xml/index.html#(def._((lib._xml/main..ss)._document~3f))",[0,[1,"document?"]],["xml"]],
["documenting classes and interfaces",">scribble/doc-classes.html","Documenting Classes and Interfaces",false],
["documenting forms, functions, structure types, and values",">scribble/doc-forms.html","Documenting Forms, Functions, Structure Types, and Values",false],
["documenting modules",">scribble/doc-modules.html","Documenting Modules",false],
["documenting signatures",">scribble/doc-signatures.html","Documenting Signatures",false],
["documents",">mysterx/documents.html","Documents",false],
["dot",">gui/pen_.html#(idx._(gentag._220._(lib._scribblings/gui/gui..scrbl)))",[7,"'dot"],false],
["dot-dash",">gui/pen_.html#(idx._(gentag._223._(lib._scribblings/gui/gui..scrbl)))",[7,"'dot-dash"],false],
["dotted-list?",">srfi-std/srfi-1.html#dotted-list-p",[0,[1,"dotted-list?"]],["srfi/1"]],
["down",">gui/key-event_.html#(idx._(gentag._61._(lib._scribblings/gui/gui..scrbl)))",[7,"'down"],false],
["down-sexp",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._down-sexp))",[[0,[1,"down-sexp"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["downcase-word",">framework/Keymap.html#(idx._(gentag._25._(lib._scribblings/framework/framework..scrbl)))","downcase-word",false],
["download/install-pkg",">planet/Utility_Libraries.html#(def._((lib._planet/util..ss)._download/install-pkg))",[0,[1,"download/install-pkg"]],["planet/util"]],
["dpflag",">scribble/doc-strings.html#(def._((lib._scribble/manual..ss)._.D.P.Flag))",[0,[1,"DPFlag"]],["scribble/manual"]],
["drag-and-drop",">gui/top-level-window___.html#(idx._(gentag._137._(lib._scribblings/gui/gui..scrbl)))","drag-and-drop",false],
["drag-and-drop",">gui/window___.html#(idx._(gentag._140._(lib._scribblings/gui/gui..scrbl)))","drag-and-drop",false],
["drag-and-drop",">gui/window___.html#(idx._(gentag._143._(lib._scribblings/gui/gui..scrbl)))","drag-and-drop",false],
["drag-and-drop",">gui/Windowing_Functions.html#(idx._(gentag._161._(lib._scribblings/gui/gui..scrbl)))","drag-and-drop",false],
["dragging?",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._dragging~3f))",[[0,[1,"dragging?"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["draw",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._draw))",[[0,[1,"draw"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["draw",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3asexp-snip~25)._draw))",[[0,[1,"draw"]],[12,[" (method of ",[0,[1,"scheme:sexp-snip%"]],")"]]],["framework"]],
["draw",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3a1-pixel-string-snip~25)._draw))",[[0,[1,"draw"]],[12,[" (method of ",[0,[1,"text:1-pixel-string-snip%"]],")"]]],["framework"]],
["draw",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3a1-pixel-tab-snip~25)._draw))",[[0,[1,"draw"]],[12,[" (method of ",[0,[1,"text:1-pixel-tab-snip%"]],")"]]],["framework"]],
["draw",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtles..ss)._draw))",[0,[1,"draw"]],["graphics/turtles"]],
["draw",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles..ss)._draw))",[0,[1,"draw"]],["graphics/value-turtles"]],
["draw",">teachpack/Jdraw.html#(def._((lib._teachpack/htdc/draw..ss)._draw))",[0,[1,"draw"]],["teachpack/htdc/draw"]],
["draw teachpack",">teachpack/draw.html#(idx._(gentag._5._(lib._teachpack/teachpack..scrbl)))","draw teachpack",false],
["draw, clear, and flip operations",">graphics/Draw__Clear__and_Flip_Operations.html","Draw, Clear, and Flip Operations",false],
["draw-arc",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._draw-arc))",[[0,[1,"draw-arc"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["draw-bitmap",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._draw-bitmap))",[[0,[1,"draw-bitmap"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["draw-bitmap-section",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._draw-bitmap-section))",[[0,[1,"draw-bitmap-section"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["draw-bitmap-section-smooth",">gui/bitmap-dc_.html#(meth._(((lib._mred/main..ss)._bitmap-dc~25)._draw-bitmap-section-smooth))",[[0,[1,"draw-bitmap-section-smooth"]],[12,[" (method of ",[0,[1,"bitmap-dc%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["draw-button-label",">mrlib/Name_Message.html#(def._((lib._mrlib/name-message..ss)._draw-button-label))",[0,[1,"draw-button-label"]],["mrlib/name-message"]],
["draw-circle",">teachpack/draw.html#(def._((lib._teachpack/htdp/draw..ss)._draw-circle))",[0,[1,"draw-circle"]],["teachpack/htdp/draw"]],
["draw-edges",">mrlib/graph-pasteboard___.html#(meth._(((lib._mrlib/graph..ss)._graph-pasteboard~3c~25~3e)._draw-edges))",[[0,[1,"draw-edges"]],[12,[" (method of ",[0,[1,"graph-pasteboard&lt;%&gt;"]],")"]]],["mrlib/graph"]],
["draw-ellipse",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._draw-ellipse))",[[0,[1,"draw-ellipse"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["draw-ellipse",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._draw-ellipse))",[0,[1,"draw-ellipse"]],["graphics/graphics"]],
["draw-line",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._draw-line))",[[0,[1,"draw-line"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["draw-line",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._draw-line))",[0,[1,"draw-line"]],["graphics/graphics"]],
["draw-lines",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._draw-lines))",[[0,[1,"draw-lines"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["draw-message",">teachpack/gui.html#(def._((lib._teachpack/htdp/gui..ss)._draw-message))",[0,[1,"draw-message"]],["teachpack/htdp/gui"]],
["draw-offset",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtles..ss)._draw-offset))",[0,[1,"draw-offset"]],["graphics/turtles"]],
["draw-offset",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles..ss)._draw-offset))",[0,"draw-offset"],["graphics/value-turtles"]],
["draw-path",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._draw-path))",[[0,[1,"draw-path"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["draw-pict",">slideshow/Rendering.html#(def._((lib._slideshow/pict..ss)._draw-pict))",[0,[1,"draw-pict"]],["slideshow/pict","slideshow"]],
["draw-pixel",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._draw-pixel))",[0,[1,"draw-pixel"]],["graphics/graphics"]],
["draw-pixmap",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._draw-pixmap))",[0,[1,"draw-pixmap"]],["graphics/graphics"]],
["draw-pixmap-posn",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._draw-pixmap-posn))",[0,[1,"draw-pixmap-posn"]],["graphics/graphics"]],
["draw-point",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._draw-point))",[[0,[1,"draw-point"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["draw-polygon",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._draw-polygon))",[[0,[1,"draw-polygon"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["draw-polygon",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._draw-polygon))",[0,[1,"draw-polygon"]],["graphics/graphics"]],
["draw-rectangle",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._draw-rectangle))",[[0,[1,"draw-rectangle"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["draw-rectangle",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._draw-rectangle))",[0,[1,"draw-rectangle"]],["graphics/graphics"]],
["draw-rounded-rectangle",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._draw-rounded-rectangle))",[[0,[1,"draw-rounded-rectangle"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["draw-solid-disk",">teachpack/draw.html#(def._((lib._teachpack/htdp/draw..ss)._draw-solid-disk))",[0,[1,"draw-solid-disk"]],["teachpack/htdp/draw"]],
["draw-solid-ellipse",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._draw-solid-ellipse))",[0,[1,"draw-solid-ellipse"]],["graphics/graphics"]],
["draw-solid-line",">teachpack/draw.html#(def._((lib._teachpack/htdp/draw..ss)._draw-solid-line))",[0,[1,"draw-solid-line"]],["teachpack/htdp/draw"]],
["draw-solid-polygon",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._draw-solid-polygon))",[0,[1,"draw-solid-polygon"]],["graphics/graphics"]],
["draw-solid-rect",">teachpack/draw.html#(def._((lib._teachpack/htdp/draw..ss)._draw-solid-rect))",[0,[1,"draw-solid-rect"]],["teachpack/htdp/draw"]],
["draw-solid-rectangle",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._draw-solid-rectangle))",[0,[1,"draw-solid-rectangle"]],["graphics/graphics"]],
["draw-solid-string",">teachpack/draw.html#(def._((lib._teachpack/htdp/draw..ss)._draw-solid-string))",[0,[1,"draw-solid-string"]],["teachpack/htdp/draw"]],
["draw-spline",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._draw-spline))",[[0,[1,"draw-spline"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["draw-string",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._draw-string))",[0,[1,"draw-string"]],["graphics/graphics"]],
["draw-text",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._draw-text))",[[0,[1,"draw-text"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["draw-viewport",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._draw-viewport))",[0,[1,"draw-viewport"]],["graphics/graphics"]],
["draw: draw.*",">teachpack/Jdraw.html","Draw: draw.*",false],
["draw: idraw.*",">teachpack/iJdraw.html","Draw: idraw.*",false],
["drawcircle",">teachpack/Jdraw.html#(def._((lib._teachpack/htdc/draw..ss)._draw.Circle))",[0,[1,"drawCircle"]],["teachpack/htdc/draw"]],
["drawcolor",">teachpack/draw.html#(tech._drawcolor)","<i>DrawColor</i>",false],
["drawdisk",">teachpack/Jdraw.html#(def._((lib._teachpack/htdc/draw..ss)._draw.Disk))",[0,[1,"drawDisk"]],["teachpack/htdc/draw"]],
["drawing outlines",">gui/brush_.html#(idx._(gentag._189._(lib._scribblings/gui/gui..scrbl)))","drawing, outlines",false],
["drawing",">gui/drawing-overview.html","Drawing",false],
["drawing classes",">gui/Drawing_Classes.html","Drawing Classes",false],
["drawing curves",">gui/dc___.html#(idx._(gentag._192._(lib._scribblings/gui/gui..scrbl)))","drawing curves",false],
["drawing functions",">gui/Drawing_Functions.html","Drawing Functions",false],
["drawing object lists",">gui/Drawing_Functions.html#(part._.Drawing_.Object_.Lists)","Drawing Object Lists",false],
["drawing on a canvas",">teachpack/draw.html#(part._drawing)","Drawing on a Canvas",false],
["drawing toolbox",">gui/Overview.html#(tech._drawing._toolbox)","<i>drawing toolbox</i>",false],
["drawkeyevent",">teachpack/draw.html#(tech._drawkeyevent)","<i>DrawKeyEvent</i>",false],
["drawline",">teachpack/Jdraw.html#(def._((lib._teachpack/htdc/draw..ss)._draw.Line))",[0,[1,"drawLine"]],["teachpack/htdc/draw"]],
["drawrect",">teachpack/Jdraw.html#(def._((lib._teachpack/htdc/draw..ss)._draw.Rect))",[0,[1,"drawRect"]],["teachpack/htdc/draw"]],
["drawstring",">teachpack/Jdraw.html#(def._((lib._teachpack/htdc/draw..ss)._draw.String))",[0,[1,"drawString"]],["teachpack/htdc/draw"]],
["drawworld",">teachpack/draw.html#(tech._drawworld)","<i>DrawWorld</i>",false],
["drop",">reference/pairs.html#(def._((lib._scheme/list..ss)._drop))",[0,[1,"drop"]],["scheme/list","scheme"]],
["drop",">srfi-std/srfi-1.html#drop",[0,[1,"drop"]],["srfi/1"]],
["drop-below-ascent",">slideshow/Bounding-Box_Adjusters.html#(def._((lib._slideshow/pict..ss)._drop-below-ascent))",[0,[1,"drop-below-ascent"]],["slideshow/pict","slideshow"]],
["drop-right",">reference/pairs.html#(def._((lib._scheme/list..ss)._drop-right))",[0,[1,"drop-right"]],["scheme/list","scheme"]],
["drop-right",">srfi-std/srfi-1.html#drop-right",[0,[1,"drop-right"]],["srfi/1"]],
["drop-right!",">srfi-std/srfi-1.html#drop-right!",[0,[1,"drop-right!"]],["srfi/1"]],
["drop-while",">srfi-std/srfi-1.html#drop-while",[0,[1,"drop-while"]],["srfi/1"]],
["drscheme browser preference panel",">browser/index.html#(part._tool)","DrScheme Browser Preference Panel",false],
["drscheme comment boxes",">gui/WXME_Decoding.html#(part._.Dr.Scheme_.Comment_.Boxes)","DrScheme Comment Boxes",false],
["drscheme files",">drscheme/drscheme-files.html","DrScheme Files",false],
["drscheme fractions",">gui/WXME_Decoding.html#(part._.Dr.Scheme_.Fractions)","DrScheme Fractions",false],
["drscheme scheme boxes",">gui/WXME_Decoding.html#(part._.Dr.Scheme_.Scheme_.Boxes)","DrScheme Scheme Boxes",false],
["drscheme teachpack images",">gui/WXME_Decoding.html#(part._.Dr.Scheme_.Teachpack_.Images)","DrScheme Teachpack Images",false],
["drscheme teachpacks",">drscheme/extending-drscheme.html#(idx._(gentag._229._(lib._scribblings/drscheme/drscheme..scrbl)))","DrScheme\n  Teachpacks",false],
["drscheme test-case boxes",">gui/WXME_Decoding.html#(part._.Dr.Scheme_.Test-.Case_.Boxes)","DrScheme Test-Case Boxes",false],
["drscheme text boxes",">gui/WXME_Decoding.html#(part._.Dr.Scheme_.Text_.Boxes)","DrScheme Text Boxes",false],
["drscheme version tool",">version/index.html#(part._.Dr.Scheme_.Version_.Tool)","DrScheme Version Tool",false],
["drscheme xml boxes",">gui/WXME_Decoding.html#(part._.Dr.Scheme_.X.M.L_.Boxes)","DrScheme XML Boxes",false],
["drscheme-language-modules",">tools/adding-languages.html#(idx._(gentag._3._(lib._scribblings/tools/tools..scrbl)))","drscheme-language-modules",false],
["drscheme-language-numbers",">tools/adding-languages.html#(idx._(gentag._5._(lib._scribblings/tools/tools..scrbl)))","drscheme-language-numbers",false],
["drscheme-language-one-line-summaries",">tools/adding-languages.html#(idx._(gentag._6._(lib._scribblings/tools/tools..scrbl)))","drscheme-language-one-line-summaries",false],
["drscheme-language-positions",">tools/adding-languages.html#(idx._(gentag._4._(lib._scribblings/tools/tools..scrbl)))","drscheme-language-positions",false],
["drscheme-language-readers",">tools/adding-languages.html#(idx._(gentag._8._(lib._scribblings/tools/tools..scrbl)))","drscheme-language-readers",false],
["drscheme-language-urls",">tools/adding-languages.html#(idx._(gentag._7._(lib._scribblings/tools/tools..scrbl)))","drscheme-language-urls",false],
["drscheme/tool-lib",">tools/index.html",[14,[0,"drscheme/tool-lib"]],"module"],
["drscheme: plt programming environment",">drscheme/index.html","<b>DrScheme</b>: PLT Programming Environment",false],
["drscheme:debug",">tools/drscheme_debug.html",[5,"drscheme:debug"],false],
["drscheme:debug:add-prefs-panel",">tools/drscheme_debug.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3adebug~3aadd-prefs-panel))",[0,[1,"drscheme:debug:add-prefs-panel"]],["drscheme/tool-lib"]],
["drscheme:debug:error-display-handler/stacktrace",">tools/drscheme_debug.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3adebug~3aerror-display-handler/stacktrace))",[0,[1,"drscheme:debug:error-display-handler/stacktrace"]],["drscheme/tool-lib"]],
["drscheme:debug:get-cm-key",">tools/drscheme_debug.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3adebug~3aget-cm-key))",[0,[1,"drscheme:debug:get-cm-key"]],["drscheme/tool-lib"]],
["drscheme:debug:hide-backtrace-window",">tools/drscheme_debug.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3adebug~3ahide-backtrace-window))",[0,[1,"drscheme:debug:hide-backtrace-window"]],["drscheme/tool-lib"]],
["drscheme:debug:make-debug-error-display-handler",">tools/drscheme_debug.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3adebug~3amake-debug-error-display-handler))",[0,[1,"drscheme:debug:make-debug-error-display-handler"]],["drscheme/tool-lib"]],
["drscheme:debug:make-debug-eval-handler",">tools/drscheme_debug.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3adebug~3amake-debug-eval-handler))",[0,[1,"drscheme:debug:make-debug-eval-handler"]],["drscheme/tool-lib"]],
["drscheme:debug:open-and-highlight-in-file",">tools/drscheme_debug.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3adebug~3aopen-and-highlight-in-file))",[0,[1,"drscheme:debug:open-and-highlight-in-file"]],["drscheme/tool-lib"]],
["drscheme:debug:profile-definitions-text-mixin",">tools/drscheme_debug.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3adebug~3aprofile-definitions-text-mixin))",[0,[1,"drscheme:debug:profile-definitions-text-mixin"]],["drscheme/tool-lib"]],
["drscheme:debug:profile-interactions-text-mixin",">tools/drscheme_debug.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3adebug~3aprofile-interactions-text-mixin))",[0,"drscheme:debug:profile-interactions-text-mixin"],["drscheme/tool-lib"]],
["drscheme:debug:profile-unit-frame-mixin",">tools/drscheme_debug.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3adebug~3aprofile-unit-frame-mixin))",[0,[1,"drscheme:debug:profile-unit-frame-mixin"]],["drscheme/tool-lib"]],
["drscheme:debug:profiling-enabled",">tools/drscheme_debug.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3adebug~3aprofiling-enabled))",[0,[1,"drscheme:debug:profiling-enabled"]],["drscheme/tool-lib"]],
["drscheme:debug:show-backtrace-window",">tools/drscheme_debug.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3adebug~3ashow-backtrace-window))",[0,[1,"drscheme:debug:show-backtrace-window"]],["drscheme/tool-lib"]],
["drscheme:eval",">tools/drscheme_eval.html",[5,"drscheme:eval"],false],
["drscheme:eval:build-user-eventspace/custodian",">tools/drscheme_eval.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aeval~3abuild-user-eventspace/custodian))",[0,[1,"drscheme:eval:build-user-eventspace/custodian"]],["drscheme/tool-lib"]],
["drscheme:eval:expand-program",">tools/drscheme_eval.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aeval~3aexpand-program))",[0,[1,"drscheme:eval:expand-program"]],["drscheme/tool-lib"]],
["drscheme:eval:expand-program/multiple",">tools/drscheme_eval.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aeval~3aexpand-program/multiple))",[0,[1,"drscheme:eval:expand-program/multiple"]],["drscheme/tool-lib"]],
["drscheme:eval:get-snip-classes",">tools/drscheme_eval.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aeval~3aget-snip-classes))",[0,[1,"drscheme:eval:get-snip-classes"]],["drscheme/tool-lib"]],
["drscheme:eval:set-basic-parameters",">tools/drscheme_eval.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aeval~3aset-basic-parameters))",[0,[1,"drscheme:eval:set-basic-parameters"]],["drscheme/tool-lib"]],
["drscheme:eval:traverse-program/multiple",">tools/drscheme_eval.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aeval~3atraverse-program/multiple))",[0,[1,"drscheme:eval:traverse-program/multiple"]],["drscheme/tool-lib"]],
["drscheme:frame",">tools/drscheme_frame.html",[5,"drscheme:frame"],false],
["drscheme:frame:<%>",">tools/drscheme_frame.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aframe~3a~3c~25~3e))",[0,[1,"drscheme:frame:&lt;%&gt;"]],["drscheme/tool-lib"]],
["drscheme:frame:basics-mixin",">tools/drscheme_frame.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aframe~3abasics-mixin))",[0,[1,"drscheme:frame:basics-mixin"]],["drscheme/tool-lib"]],
["drscheme:frame:basics<%>",">tools/drscheme_frame.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aframe~3abasics~3c~25~3e))",[0,[1,"drscheme:frame:basics&lt;%&gt;"]],["drscheme/tool-lib"]],
["drscheme:frame:mixin",">tools/drscheme_frame.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aframe~3amixin))",[0,[1,"drscheme:frame:mixin"]],["drscheme/tool-lib"]],
["drscheme:frame:name-message%",">tools/drscheme_frame.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aframe~3aname-message~25))",[0,"drscheme:frame:name-message%"],["drscheme/tool-lib"]],
["drscheme:get/extend",">tools/drscheme_get_extend.html",[5,"drscheme:get/extend"],false],
["drscheme:get/extend:extend-definitions-canvas",">tools/drscheme_get_extend.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aget/extend~3aextend-definitions-canvas))",[0,[1,"drscheme:get/extend:extend-definitions-canvas"]],["drscheme/tool-lib"]],
["drscheme:get/extend:extend-definitions-text",">tools/drscheme_get_extend.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aget/extend~3aextend-definitions-text))",[0,[1,"drscheme:get/extend:extend-definitions-text"]],["drscheme/tool-lib"]],
["drscheme:get/extend:extend-interactions-canvas",">tools/drscheme_get_extend.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aget/extend~3aextend-interactions-canvas))",[0,[1,"drscheme:get/extend:extend-interactions-canvas"]],["drscheme/tool-lib"]],
["drscheme:get/extend:extend-interactions-text",">tools/drscheme_get_extend.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aget/extend~3aextend-interactions-text))",[0,[1,"drscheme:get/extend:extend-interactions-text"]],["drscheme/tool-lib"]],
["drscheme:get/extend:extend-tab",">tools/drscheme_get_extend.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aget/extend~3aextend-tab))",[0,[1,"drscheme:get/extend:extend-tab"]],["drscheme/tool-lib"]],
["drscheme:get/extend:extend-unit-frame",">tools/drscheme_get_extend.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aget/extend~3aextend-unit-frame))",[0,[1,"drscheme:get/extend:extend-unit-frame"]],["drscheme/tool-lib"]],
["drscheme:get/extend:get-definitions-canvas",">tools/drscheme_get_extend.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aget/extend~3aget-definitions-canvas))",[0,[1,"drscheme:get/extend:get-definitions-canvas"]],["drscheme/tool-lib"]],
["drscheme:get/extend:get-definitions-text",">tools/drscheme_get_extend.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aget/extend~3aget-definitions-text))",[0,[1,"drscheme:get/extend:get-definitions-text"]],["drscheme/tool-lib"]],
["drscheme:get/extend:get-interactions-canvas",">tools/drscheme_get_extend.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aget/extend~3aget-interactions-canvas))",[0,[1,"drscheme:get/extend:get-interactions-canvas"]],["drscheme/tool-lib"]],
["drscheme:get/extend:get-interactions-text",">tools/drscheme_get_extend.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aget/extend~3aget-interactions-text))",[0,[1,"drscheme:get/extend:get-interactions-text"]],["drscheme/tool-lib"]],
["drscheme:get/extend:get-unit-frame",">tools/drscheme_get_extend.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aget/extend~3aget-unit-frame))",[0,[1,"drscheme:get/extend:get-unit-frame"]],["drscheme/tool-lib"]],
["drscheme:help-desk",">tools/drscheme_help-desk.html",[5,"drscheme:help-desk"],false],
["drscheme:language",">tools/drscheme_language.html",[5,"drscheme:language"],false],
["drscheme:language-configuration",">tools/drscheme_language-configuration.html",[5,"drscheme:language-configuration"],false],
["drscheme:language-configuration:add-language",">tools/drscheme_language-configuration.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage-configuration~3aadd-language))",[0,[1,"drscheme:language-configuration:add-language"]],["drscheme/tool-lib"]],
["drscheme:language-configuration:fill-language-dialog",">tools/drscheme_language-configuration.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage-configuration~3afill-language-dialog))",[0,[1,"drscheme:language-configuration:fill-language-dialog"]],["drscheme/tool-lib"]],
["drscheme:language-configuration:get-languages",">tools/drscheme_language-configuration.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage-configuration~3aget-languages))",[0,[1,"drscheme:language-configuration:get-languages"]],["drscheme/tool-lib"]],
["drscheme:language-configuration:get-settings-preferences-symbol",">tools/drscheme_language-configuration.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage-configuration~3aget-settings-preferences-symbol))",[0,[1,"drscheme:language-configuration:get-settings-preferences-symbol"]],["drscheme/tool-lib"]],
["drscheme:language-configuration:language-dialog",">tools/drscheme_language-configuration.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage-configuration~3alanguage-dialog))",[0,[1,"drscheme:language-configuration:language-dialog"]],["drscheme/tool-lib"]],
["drscheme:language-configuration:language-settings-language",">tools/drscheme_language-configuration.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage-configuration~3alanguage-settings-language))",[0,[1,"drscheme:language-configuration:language-settings-language"]],["drscheme/tool-lib"]],
["drscheme:language-configuration:language-settings-settings",">tools/drscheme_language-configuration.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage-configuration~3alanguage-settings-settings))",[0,[1,"drscheme:language-configuration:language-settings-settings"]],["drscheme/tool-lib"]],
["drscheme:language-configuration:language-settings?",">tools/drscheme_language-configuration.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage-configuration~3alanguage-settings~3f))",[0,[1,"drscheme:language-configuration:language-settings?"]],["drscheme/tool-lib"]],
["drscheme:language-configuration:make-language-settings",">tools/drscheme_language-configuration.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage-configuration~3amake-language-settings))",[0,[1,"drscheme:language-configuration:make-language-settings"]],["drscheme/tool-lib"]],
["drscheme:language:add-snip-value",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3aadd-snip-value))",[0,[1,"drscheme:language:add-snip-value"]],["drscheme/tool-lib"]],
["drscheme:language:capability-registered?",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3acapability-registered~3f))",[0,[1,"drscheme:language:capability-registered?"]],["drscheme/tool-lib"]],
["drscheme:language:create-distribution-for-executable",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3acreate-distribution-for-executable))",[0,[1,"drscheme:language:create-distribution-for-executable"]],["drscheme/tool-lib"]],
["drscheme:language:create-executable-gui",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3acreate-executable-gui))",[0,[1,"drscheme:language:create-executable-gui"]],["drscheme/tool-lib"]],
["drscheme:language:create-module-based-distribution",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3acreate-module-based-distribution))",[0,[1,"drscheme:language:create-module-based-distribution"]],["drscheme/tool-lib"]],
["drscheme:language:create-module-based-launcher",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3acreate-module-based-launcher))",[0,[1,"drscheme:language:create-module-based-launcher"]],["drscheme/tool-lib"]],
["drscheme:language:create-module-based-stand-alone-executable",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3acreate-module-based-stand-alone-executable))",[0,[1,"drscheme:language:create-module-based-stand-alone-executable"]],["drscheme/tool-lib"]],
["drscheme:language:extend-language-interface",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3aextend-language-interface))",[0,[1,"drscheme:language:extend-language-interface"]],["drscheme/tool-lib"]],
["drscheme:language:get-capability-contract",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3aget-capability-contract))",[0,[1,"drscheme:language:get-capability-contract"]],["drscheme/tool-lib"]],
["drscheme:language:get-capability-default",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3aget-capability-default))",[0,[1,"drscheme:language:get-capability-default"]],["drscheme/tool-lib"]],
["drscheme:language:get-default-mixin",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3aget-default-mixin))",[0,[1,"drscheme:language:get-default-mixin"]],["drscheme/tool-lib"]],
["drscheme:language:get-language-extensions",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3aget-language-extensions))",[0,[1,"drscheme:language:get-language-extensions"]],["drscheme/tool-lib"]],
["drscheme:language:language<%>",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e))",[0,[1,"drscheme:language:language&lt;%&gt;"]],["drscheme/tool-lib"]],
["drscheme:language:make-simple-settings",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3amake-simple-settings))",[0,[1,"drscheme:language:make-simple-settings"]],["drscheme/tool-lib"]],
["drscheme:language:make-text/pos",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3amake-text/pos))",[0,[1,"drscheme:language:make-text/pos"]],["drscheme/tool-lib"]],
["drscheme:language:module-based-language->language-mixin",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3amodule-based-language-~3elanguage-mixin))",[0,[1,"drscheme:language:module-based-language-&gt;language-mixin"]],["drscheme/tool-lib"]],
["drscheme:language:module-based-language<%>",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3amodule-based-language~3c~25~3e))",[0,[1,"drscheme:language:module-based-language&lt;%&gt;"]],["drscheme/tool-lib"]],
["drscheme:language:object/c",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3aobject/c))",[0,[1,"drscheme:language:object/c"]],["drscheme/tool-lib"]],
["drscheme:language:put-executable",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3aput-executable))",[0,[1,"drscheme:language:put-executable"]],["drscheme/tool-lib"]],
["drscheme:language:register-capability",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3aregister-capability))",[0,[1,"drscheme:language:register-capability"]],["drscheme/tool-lib"]],
["drscheme:language:simple-module-based-language%",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-module-based-language~25))",[0,[1,"drscheme:language:simple-module-based-language%"]],["drscheme/tool-lib"]],
["drscheme:language:simple-module-based-language->module-based-language-mixin",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-module-based-language-~3emodule-based-language-mixin))",[0,[1,"drscheme:language:simple-module-based-language-&gt;module-based-language-mixin"]],["drscheme/tool-lib"]],
["drscheme:language:simple-module-based-language<%>",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-module-based-language~3c~25~3e))",[0,[1,"drscheme:language:simple-module-based-language&lt;%&gt;"]],["drscheme/tool-lib"]],
["drscheme:language:simple-settings",">tools/drscheme_language.html#(idx._(gentag._14._(lib._scribblings/tools/tools..scrbl)))","drscheme:language:simple-settings",false],
["drscheme:language:simple-settings->vector",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-settings-~3evector))",[0,[1,"drscheme:language:simple-settings-&gt;vector"]],["drscheme/tool-lib"]],
["drscheme:language:simple-settings-annotations",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-settings-annotations))",[0,[1,"drscheme:language:simple-settings-annotations"]],["drscheme/tool-lib"]],
["drscheme:language:simple-settings-case-sensitive",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-settings-case-sensitive))",[0,[1,"drscheme:language:simple-settings-case-sensitive"]],["drscheme/tool-lib"]],
["drscheme:language:simple-settings-fraction-style",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-settings-fraction-style))",[0,[1,"drscheme:language:simple-settings-fraction-style"]],["drscheme/tool-lib"]],
["drscheme:language:simple-settings-insert-newlines",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-settings-insert-newlines))",[0,[1,"drscheme:language:simple-settings-insert-newlines"]],["drscheme/tool-lib"]],
["drscheme:language:simple-settings-printing-style",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-settings-printing-style))",[0,[1,"drscheme:language:simple-settings-printing-style"]],["drscheme/tool-lib"]],
["drscheme:language:simple-settings-show-sharing",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-settings-show-sharing))",[0,[1,"drscheme:language:simple-settings-show-sharing"]],["drscheme/tool-lib"]],
["drscheme:language:simple-settings?",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-settings~3f))",[0,[1,"drscheme:language:simple-settings?"]],["drscheme/tool-lib"]],
["drscheme:language:text/pos-end",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3atext/pos-end))",[0,[1,"drscheme:language:text/pos-end"]],["drscheme/tool-lib"]],
["drscheme:language:text/pos-start",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3atext/pos-start))",[0,[1,"drscheme:language:text/pos-start"]],["drscheme/tool-lib"]],
["drscheme:language:text/pos-text",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3atext/pos-text))",[0,[1,"drscheme:language:text/pos-text"]],["drscheme/tool-lib"]],
["drscheme:language:text/pos?",">tools/drscheme_language.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3atext/pos~3f))",[0,[1,"drscheme:language:text/pos?"]],["drscheme/tool-lib"]],
["drscheme:modes",">tools/drscheme_modes.html",[5,"drscheme:modes"],false],
["drscheme:modes:add-mode",">tools/drscheme_modes.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3amodes~3aadd-mode))",[0,[1,"drscheme:modes:add-mode"]],["drscheme/tool-lib"]],
["drscheme:modes:get-modes",">tools/drscheme_modes.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3amodes~3aget-modes))",[0,[1,"drscheme:modes:get-modes"]],["drscheme/tool-lib"]],
["drscheme:modes:mode-matches-language",">tools/drscheme_modes.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3amodes~3amode-matches-language))",[0,[1,"drscheme:modes:mode-matches-language"]],["drscheme/tool-lib"]],
["drscheme:modes:mode-name",">tools/drscheme_modes.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3amodes~3amode-name))",[0,[1,"drscheme:modes:mode-name"]],["drscheme/tool-lib"]],
["drscheme:modes:mode-repl-submit",">tools/drscheme_modes.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3amodes~3amode-repl-submit))",[0,[1,"drscheme:modes:mode-repl-submit"]],["drscheme/tool-lib"]],
["drscheme:modes:mode-surrogate",">tools/drscheme_modes.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3amodes~3amode-surrogate))",[0,[1,"drscheme:modes:mode-surrogate"]],["drscheme/tool-lib"]],
["drscheme:modes:mode?",">tools/drscheme_modes.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3amodes~3amode~3f))",[0,[1,"drscheme:modes:mode?"]],["drscheme/tool-lib"]],
["drscheme:rep",">tools/drscheme_rep.html",[5,"drscheme:rep"],false],
["drscheme:rep:context<%>",">tools/drscheme_rep.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3arep~3acontext~3c~25~3e))",[0,[1,"drscheme:rep:context&lt;%&gt;"]],["drscheme/tool-lib"]],
["drscheme:rep:current-rep",">tools/drscheme_rep.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3arep~3acurrent-rep))",[0,[1,"drscheme:rep:current-rep"]],["drscheme/tool-lib"]],
["drscheme:rep:current-value-port",">tools/drscheme_rep.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3arep~3acurrent-value-port))",[0,[1,"drscheme:rep:current-value-port"]],["drscheme/tool-lib"]],
["drscheme:rep:drs-bindings-keymap-mixin",">tools/drscheme_rep.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3arep~3adrs-bindings-keymap-mixin))",[0,[1,"drscheme:rep:drs-bindings-keymap-mixin"]],["drscheme/tool-lib"]],
["drscheme:rep:get-dark-green-delta",">tools/drscheme_rep.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3arep~3aget-dark-green-delta))",[0,[1,"drscheme:rep:get-dark-green-delta"]],["drscheme/tool-lib"]],
["drscheme:rep:get-drs-bindings-keymap",">tools/drscheme_rep.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3arep~3aget-drs-bindings-keymap))",[0,[1,"drscheme:rep:get-drs-bindings-keymap"]],["drscheme/tool-lib"]],
["drscheme:rep:get-welcome-delta",">tools/drscheme_rep.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3arep~3aget-welcome-delta))",[0,[1,"drscheme:rep:get-welcome-delta"]],["drscheme/tool-lib"]],
["drscheme:rep:text%",">tools/drscheme_rep.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3arep~3atext~25))",[0,[1,"drscheme:rep:text%"]],["drscheme/tool-lib"]],
["drscheme:rep:text<%>",">tools/drscheme_rep.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3arep~3atext~3c~25~3e))",[0,[1,"drscheme:rep:text&lt;%&gt;"]],["drscheme/tool-lib"]],
["drscheme:unit",">tools/drscheme_unit.html",[5,"drscheme:unit"],false],
["drscheme:unit:add-to-program-editor-mixin",">tools/drscheme_unit.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aadd-to-program-editor-mixin))",[0,[1,"drscheme:unit:add-to-program-editor-mixin"]],["drscheme/tool-lib"]],
["drscheme:unit:definitions-canvas%",">tools/drscheme_unit.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3adefinitions-canvas~25))",[0,[1,"drscheme:unit:definitions-canvas%"]],["drscheme/tool-lib"]],
["drscheme:unit:definitions-text%",">tools/drscheme_unit.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3adefinitions-text~25))",[0,"drscheme:unit:definitions-text%"],["drscheme/tool-lib"]],
["drscheme:unit:definitions-text<%>",">tools/drscheme_unit.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3adefinitions-text~3c~25~3e))",[0,[1,"drscheme:unit:definitions-text&lt;%&gt;"]],["drscheme/tool-lib"]],
["drscheme:unit:frame%",">tools/drscheme_unit.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25))",[0,[1,"drscheme:unit:frame%"]],["drscheme/tool-lib"]],
["drscheme:unit:frame<%>",">tools/drscheme_unit.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~3c~25~3e))",[0,[1,"drscheme:unit:frame&lt;%&gt;"]],["drscheme/tool-lib"]],
["drscheme:unit:get-program-editor-mixin",">tools/drscheme_unit.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aget-program-editor-mixin))",[0,[1,"drscheme:unit:get-program-editor-mixin"]],["drscheme/tool-lib"]],
["drscheme:unit:interactions-canvas%",">tools/drscheme_unit.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3ainteractions-canvas~25))",[0,[1,"drscheme:unit:interactions-canvas%"]],["drscheme/tool-lib"]],
["drscheme:unit:open-drscheme-window",">tools/drscheme_unit.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aopen-drscheme-window))",[0,[1,"drscheme:unit:open-drscheme-window"]],["drscheme/tool-lib"]],
["drscheme:unit:program-editor-mixin",">tools/drscheme_unit.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aprogram-editor-mixin))",[0,[1,"drscheme:unit:program-editor-mixin"]],["drscheme/tool-lib"]],
["drscheme:unit:tab%",">tools/drscheme_unit.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3atab~25))",[0,[1,"drscheme:unit:tab%"]],["drscheme/tool-lib"]],
["drscheme:unit:tab<%>",">tools/drscheme_unit.html#(def._((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3atab~3c~25~3e))",[0,[1,"drscheme:unit:tab&lt;%&gt;"]],["drscheme/tool-lib"]],
["dt",">html/index.html#(def._((lib._html/main..ss)._dt))",[0,[1,"dt"]],["html"]],
["dt?",">html/index.html#(def._((lib._html/main..ss)._dt~3f))",[0,[1,"dt?"]],["html"]],
["dump-memory-stats",">reference/garbagecollection.html#(def._((quote._~23~25kernel)._dump-memory-stats))",[0,[1,"dump-memory-stats"]],["scheme/base","scheme"]],
["dup-input-port",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._dup-input-port))",[0,[1,"dup-input-port"]],["scheme/port"]],
["dup-output-port",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._dup-output-port))",[0,[1,"dup-output-port"]],["scheme/port"]],
["dynamic extension",">mzc/cc.html#(tech._dynamic._extension)","<i>dynamic extension</i>",false],
["dynamic extension",">reference/Evaluation_and_Compilation.html#(tech._dynamic._extension)","<i>dynamic extension</i>",false],
["dynamic extent",">reference/eval-model.html#(tech._dynamic._extent)","<i>dynamic extent</i>",false],
["dynamic loading",">gui/Dynamic_Loading.html","Dynamic Loading",false],
["dynamic module access",">reference/Module_Names_and_Loading.html#(part._dynreq)","Dynamic Module Access",false],
["dynamic-require",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._dynamic-require))",[0,[1,"dynamic-require"]],["scheme/base","scheme"]],
["dynamic-require-for-syntax",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._dynamic-require-for-syntax))",[0,[1,"dynamic-require-for-syntax"]],["scheme/base","scheme"]],
["dynamic-wind",">reference/cont.html#(def._((quote._~23~25kernel)._dynamic-wind))",[0,[1,"dynamic-wind"]],["scheme/base","scheme"]],
["dynamic-wind",">r5rs-std/r5rs-Z-H-9.html#%_idx_598",[0,[1,"dynamic-wind"]],["r5rs"]],
["dynamic-wind",">r6rs-std/r6rs-Z-H-14.html#node_idx_764",[0,[1,"dynamic-wind"]],["rnrs/base-6"]],
["dynamically loaded libraries",">foreign/Loading_Foreign_Libraries.html#(idx._(gentag._3._(lib._scribblings/foreign/foreign..scrbl)))","dynamically loaded libraries",false],
["dynext/compile",">dynext/Compilation.html",[14,[0,"dynext/compile"]],"module"],
["dynext/compile-sig",">dynext/Compilation.html#(mod-path._dynext/compile-sig)",[14,[0,"dynext/compile-sig"]],"module"],
["dynext/compile-unit",">dynext/Compilation.html#(mod-path._dynext/compile-unit)",[14,[0,"dynext/compile-unit"]],"module"],
["dynext/file",">dynext/Filenames.html",[14,[0,"dynext/file"]],"module"],
["dynext/file-sig",">dynext/Filenames.html#(mod-path._dynext/file-sig)",[14,[0,"dynext/file-sig"]],"module"],
["dynext/file-unit",">dynext/Filenames.html#(mod-path._dynext/file-unit)",[14,[0,"dynext/file-unit"]],"module"],
["dynext/link",">dynext/Linking.html",[14,[0,"dynext/link"]],"module"],
["dynext/link-sig",">dynext/Linking.html#(mod-path._dynext/link-sig)",[14,[0,"dynext/link-sig"]],"module"],
["dynext/link-unit",">dynext/Linking.html#(mod-path._dynext/link-unit)",[14,[0,"dynext/link-unit"]],"module"],
["dynext: running a c compiler/linker",">dynext/index.html","<b>Dynext</b>: Running a C Compiler/Linker",false],
["dynext:compile^",">dynext/Compilation.html#(form._((lib._dynext/compile-sig..ss)._dynext~3acompile~5e))",[0,[6,"dynext:compile^"]],["dynext/compile-sig"]],
["dynext:file^",">dynext/Filenames.html#(form._((lib._dynext/file-sig..ss)._dynext~3afile~5e))",[0,[6,"dynext:file^"]],["dynext/file-sig"]],
["dynext:link^",">dynext/Linking.html#(form._((lib._dynext/link-sig..ss)._dynext~3alink~5e))",[0,[6,"dynext:link^"]],["dynext/link-sig"]],
["dyntex:compile@",">dynext/Compilation.html#(def._((lib._dynext/compile-unit..ss)._dyntex~3acompile~40))",[0,"dyntex:compile@"],["dynext/compile-unit"]],
["dyntex:file@",">dynext/Filenames.html#(def._((lib._dynext/file-unit..ss)._dyntex~3afile~40))",[0,"dyntex:file@"],["dynext/file-unit"]],
["dyntex:link@",">dynext/Linking.html#(def._((lib._dynext/link-unit..ss)._dyntex~3alink~40))",[0,"dyntex:link@"],["dynext/link-unit"]],
["e",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._e))",[0,[1,"e"]],["lang/htdp-advanced"]],
["e",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._e))",[0,[1,"e"]],["lang/htdp-beginner"]],
["e",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._e))",[0,[1,"e"]],["lang/htdp-beginner-abbr"]],
["e",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._e))",[0,[1,"e"]],["lang/htdp-intermediate"]],
["e",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._e))",[0,[1,"e"]],["lang/htdp-intermediate-lambda"]],
["e",">mzlib/mzlib_math.html#(def._((lib._mzlib/math..ss)._e))",[0,[1,"e"]],["mzlib/math"]],
["eager",">srfi-std/srfi-45.html#eager",[0,[1,"eager"]],["srfi/45"]],
["edit",">drscheme/Menus.html#(part._.Edit)","<b><font size=\"-1\" face=\"Helvetica\">Edit</font></b>",false],
["edit-menu:after-preferences",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aafter-preferences))",[[0,[1,"edit-menu:after-preferences"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:between-clear-and-select-all",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3abetween-clear-and-select-all))",[[0,[1,"edit-menu:between-clear-and-select-all"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:between-copy-and-paste",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3abetween-copy-and-paste))",[[0,[1,"edit-menu:between-copy-and-paste"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:between-cut-and-copy",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3abetween-cut-and-copy))",[[0,[1,"edit-menu:between-cut-and-copy"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:between-find-and-preferences",">tools/drscheme_frame.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aframe~3abasics-mixin)._edit-menu~3abetween-find-and-preferences))",[[0,[1,"edit-menu:between-find-and-preferences"]],[12,[" (method of ",[0,[1,"drscheme:frame:basics-mixin"]],")"]]],["drscheme/tool-lib"]],
["edit-menu:between-find-and-preferences",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3abetween-find-and-preferences))",[[0,[1,"edit-menu:between-find-and-preferences"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:between-paste-and-clear",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3abetween-paste-and-clear))",[[0,[1,"edit-menu:between-paste-and-clear"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:between-redo-and-cut",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3abetween-redo-and-cut))",[[0,[1,"edit-menu:between-redo-and-cut"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:between-select-all-and-find",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._edit-menu~3abetween-select-all-and-find))",[[0,[1,"edit-menu:between-select-all-and-find"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["edit-menu:between-select-all-and-find",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor-mixin)._edit-menu~3abetween-select-all-and-find))",[[0,[1,"edit-menu:between-select-all-and-find"]],[12,[" (method of ",[0,[1,"frame:editor-mixin"]],")"]]],["framework"]],
["edit-menu:between-select-all-and-find",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3abetween-select-all-and-find))",[[0,[1,"edit-menu:between-select-all-and-find"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:clear-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aclear-callback))",[[0,[1,"edit-menu:clear-callback"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:clear-help-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aclear-help-string))",[[0,[1,"edit-menu:clear-help-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:clear-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aclear-on-demand))",[[0,[1,"edit-menu:clear-on-demand"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:clear-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aclear-string))",[[0,[1,"edit-menu:clear-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:copy-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acopy-callback))",[[0,[1,"edit-menu:copy-callback"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:copy-help-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acopy-help-string))",[[0,[1,"edit-menu:copy-help-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:copy-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acopy-on-demand))",[[0,[1,"edit-menu:copy-on-demand"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:copy-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acopy-string))",[[0,[1,"edit-menu:copy-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:create-clear?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-clear~3f))",[[0,[1,"edit-menu:create-clear?"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:create-copy?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-copy~3f))",[[0,[1,"edit-menu:create-copy?"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:create-cut?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-cut~3f))",[[0,[1,"edit-menu:create-cut?"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:create-find-again-backwards?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable-mixin)._edit-menu~3acreate-find-again-backwards~3f))",[[0,[1,"edit-menu:create-find-again-backwards?"]],[12,[" (method of ",[0,[1,"frame:searchable-mixin"]],")"]]],["framework"]],
["edit-menu:create-find-again?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable-mixin)._edit-menu~3acreate-find-again~3f))",[[0,[1,"edit-menu:create-find-again?"]],[12,[" (method of ",[0,[1,"frame:searchable-mixin"]],")"]]],["framework"]],
["edit-menu:create-find-case-sensitive?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable-mixin)._edit-menu~3acreate-find-case-sensitive~3f))",[[0,[1,"edit-menu:create-find-case-sensitive?"]],[12,[" (method of ",[0,[1,"frame:searchable-mixin"]],")"]]],["framework"]],
["edit-menu:create-find-case-sensitive?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-find-case-sensitive~3f))",[[0,[1,"edit-menu:create-find-case-sensitive?"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:create-find-next?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-find-next~3f))",[[0,[1,"edit-menu:create-find-next?"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:create-find-previous?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-find-previous~3f))",[[0,[1,"edit-menu:create-find-previous?"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:create-find?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable-mixin)._edit-menu~3acreate-find~3f))",[[0,[1,"edit-menu:create-find?"]],[12,[" (method of ",[0,[1,"frame:searchable-mixin"]],")"]]],["framework"]],
["edit-menu:create-find?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-find~3f))",[[0,[1,"edit-menu:create-find?"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:create-paste?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-paste~3f))",[[0,[1,"edit-menu:create-paste?"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:create-preferences?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-preferences~3f))",[[0,[1,"edit-menu:create-preferences?"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:create-redo?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-redo~3f))",[[0,[1,"edit-menu:create-redo?"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:create-replace-all?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable-mixin)._edit-menu~3acreate-replace-all~3f))",[[0,[1,"edit-menu:create-replace-all?"]],[12,[" (method of ",[0,[1,"frame:searchable-mixin"]],")"]]],["framework"]],
["edit-menu:create-replace-all?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-replace-all~3f))",[[0,[1,"edit-menu:create-replace-all?"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:create-replace?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-replace~3f))",[[0,[1,"edit-menu:create-replace?"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:create-select-all?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-select-all~3f))",[[0,[1,"edit-menu:create-select-all?"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:create-show/hide-replace?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-show/hide-replace~3f))",[[0,[1,"edit-menu:create-show/hide-replace?"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:create-undo?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acreate-undo~3f))",[[0,[1,"edit-menu:create-undo?"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:cut-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acut-callback))",[[0,[1,"edit-menu:cut-callback"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:cut-help-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acut-help-string))",[[0,[1,"edit-menu:cut-help-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:cut-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acut-on-demand))",[[0,[1,"edit-menu:cut-on-demand"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:cut-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3acut-string))",[[0,[1,"edit-menu:cut-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:find-again-backwards-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable-mixin)._edit-menu~3afind-again-backwards-callback))",[[0,[1,"edit-menu:find-again-backwards-callback"]],[12,[" (method of ",[0,[1,"frame:searchable-mixin"]],")"]]],["framework"]],
["edit-menu:find-again-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable-mixin)._edit-menu~3afind-again-callback))",[[0,[1,"edit-menu:find-again-callback"]],[12,[" (method of ",[0,[1,"frame:searchable-mixin"]],")"]]],["framework"]],
["edit-menu:find-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable-mixin)._edit-menu~3afind-callback))",[[0,[1,"edit-menu:find-callback"]],[12,[" (method of ",[0,[1,"frame:searchable-mixin"]],")"]]],["framework"]],
["edit-menu:find-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-callback))",[[0,[1,"edit-menu:find-callback"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:find-case-sensitive-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable-mixin)._edit-menu~3afind-case-sensitive-callback))",[[0,[1,"edit-menu:find-case-sensitive-callback"]],[12,[" (method of ",[0,[1,"frame:searchable-mixin"]],")"]]],["framework"]],
["edit-menu:find-case-sensitive-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-case-sensitive-callback))",[[0,[1,"edit-menu:find-case-sensitive-callback"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:find-case-sensitive-help-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-case-sensitive-help-string))",[[0,[1,"edit-menu:find-case-sensitive-help-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:find-case-sensitive-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable-mixin)._edit-menu~3afind-case-sensitive-on-demand))",[[0,[1,"edit-menu:find-case-sensitive-on-demand"]],[12,[" (method of ",[0,[1,"frame:searchable-mixin"]],")"]]],["framework"]],
["edit-menu:find-case-sensitive-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-case-sensitive-on-demand))",[[0,[1,"edit-menu:find-case-sensitive-on-demand"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:find-case-sensitive-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-case-sensitive-string))",[[0,[1,"edit-menu:find-case-sensitive-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:find-help-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-help-string))",[[0,[1,"edit-menu:find-help-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:find-next-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-next-callback))",[[0,[1,"edit-menu:find-next-callback"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:find-next-help-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-next-help-string))",[[0,[1,"edit-menu:find-next-help-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:find-next-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-next-on-demand))",[[0,[1,"edit-menu:find-next-on-demand"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:find-next-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-next-string))",[[0,[1,"edit-menu:find-next-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:find-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-on-demand))",[[0,[1,"edit-menu:find-on-demand"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:find-previous-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-previous-callback))",[[0,[1,"edit-menu:find-previous-callback"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:find-previous-help-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-previous-help-string))",[[0,[1,"edit-menu:find-previous-help-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:find-previous-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-previous-on-demand))",[[0,[1,"edit-menu:find-previous-on-demand"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:find-previous-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-previous-string))",[[0,[1,"edit-menu:find-previous-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:find-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3afind-string))",[[0,[1,"edit-menu:find-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:get-clear-item",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-clear-item))",[[0,[1,"edit-menu:get-clear-item"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:get-copy-item",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-copy-item))",[[0,[1,"edit-menu:get-copy-item"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:get-cut-item",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-cut-item))",[[0,[1,"edit-menu:get-cut-item"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:get-find-case-sensitive-item",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-find-case-sensitive-item))",[[0,[1,"edit-menu:get-find-case-sensitive-item"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:get-find-item",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-find-item))",[[0,[1,"edit-menu:get-find-item"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:get-find-next-item",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-find-next-item))",[[0,[1,"edit-menu:get-find-next-item"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:get-find-previous-item",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-find-previous-item))",[[0,[1,"edit-menu:get-find-previous-item"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:get-paste-item",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-paste-item))",[[0,[1,"edit-menu:get-paste-item"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:get-preferences-item",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-preferences-item))",[[0,[1,"edit-menu:get-preferences-item"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:get-redo-item",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-redo-item))",[[0,[1,"edit-menu:get-redo-item"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:get-replace-all-item",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-replace-all-item))",[[0,[1,"edit-menu:get-replace-all-item"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:get-replace-item",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-replace-item))",[[0,[1,"edit-menu:get-replace-item"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:get-select-all-item",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-select-all-item))",[[0,[1,"edit-menu:get-select-all-item"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:get-show/hide-replace-item",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-show/hide-replace-item))",[[0,[1,"edit-menu:get-show/hide-replace-item"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:get-undo-item",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aget-undo-item))",[[0,[1,"edit-menu:get-undo-item"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:paste-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3apaste-callback))",[[0,[1,"edit-menu:paste-callback"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:paste-help-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3apaste-help-string))",[[0,[1,"edit-menu:paste-help-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:paste-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3apaste-on-demand))",[[0,[1,"edit-menu:paste-on-demand"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:paste-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3apaste-string))",[[0,[1,"edit-menu:paste-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:preferences-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3apreferences-callback))",[[0,[1,"edit-menu:preferences-callback"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:preferences-help-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3apreferences-help-string))",[[0,[1,"edit-menu:preferences-help-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:preferences-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3apreferences-on-demand))",[[0,[1,"edit-menu:preferences-on-demand"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:preferences-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3apreferences-string))",[[0,[1,"edit-menu:preferences-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:redo-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aredo-callback))",[[0,[1,"edit-menu:redo-callback"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:redo-help-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aredo-help-string))",[[0,[1,"edit-menu:redo-help-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:redo-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aredo-on-demand))",[[0,[1,"edit-menu:redo-on-demand"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:redo-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aredo-string))",[[0,[1,"edit-menu:redo-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:replace-all-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable-mixin)._edit-menu~3areplace-all-callback))",[[0,[1,"edit-menu:replace-all-callback"]],[12,[" (method of ",[0,[1,"frame:searchable-mixin"]],")"]]],["framework"]],
["edit-menu:replace-all-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3areplace-all-callback))",[[0,[1,"edit-menu:replace-all-callback"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:replace-all-help-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3areplace-all-help-string))",[[0,[1,"edit-menu:replace-all-help-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:replace-all-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable-mixin)._edit-menu~3areplace-all-on-demand))",[[0,[1,"edit-menu:replace-all-on-demand"]],[12,[" (method of ",[0,[1,"frame:searchable-mixin"]],")"]]],["framework"]],
["edit-menu:replace-all-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3areplace-all-on-demand))",[[0,[1,"edit-menu:replace-all-on-demand"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:replace-all-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3areplace-all-string))",[[0,[1,"edit-menu:replace-all-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:replace-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3areplace-callback))",[[0,[1,"edit-menu:replace-callback"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:replace-help-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3areplace-help-string))",[[0,[1,"edit-menu:replace-help-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:replace-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3areplace-on-demand))",[[0,[1,"edit-menu:replace-on-demand"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:replace-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3areplace-string))",[[0,[1,"edit-menu:replace-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:select-all-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aselect-all-callback))",[[0,[1,"edit-menu:select-all-callback"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:select-all-help-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aselect-all-help-string))",[[0,[1,"edit-menu:select-all-help-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:select-all-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aselect-all-on-demand))",[[0,[1,"edit-menu:select-all-on-demand"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:select-all-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aselect-all-string))",[[0,[1,"edit-menu:select-all-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:show/hide-replace-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3ashow/hide-replace-callback))",[[0,[1,"edit-menu:show/hide-replace-callback"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:show/hide-replace-help-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3ashow/hide-replace-help-string))",[[0,[1,"edit-menu:show/hide-replace-help-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:show/hide-replace-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3ashow/hide-replace-on-demand))",[[0,[1,"edit-menu:show/hide-replace-on-demand"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:show/hide-replace-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3ashow/hide-replace-string))",[[0,[1,"edit-menu:show/hide-replace-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:undo-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aundo-callback))",[[0,[1,"edit-menu:undo-callback"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:undo-help-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aundo-help-string))",[[0,[1,"edit-menu:undo-help-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:undo-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aundo-on-demand))",[[0,[1,"edit-menu:undo-on-demand"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["edit-menu:undo-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._edit-menu~3aundo-string))",[[0,[1,"edit-menu:undo-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["editing",">drscheme/prefs-explanation.html#(part._.Editing)","<b><font size=\"-1\" face=\"Helvetica\">Editing</font></b>",false],
["editing operations",">drscheme/Keyboard_Shortcuts.html#(part._.Editing_.Operations)","Editing Operations",false],
["editing with parentheses",">drscheme/editor.html","Editing with Parentheses",false],
["editing-this-file?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3abasic~3c~25~3e)._editing-this-file~3f))",[[0,[1,"editing-this-file?"]],[12,[" (method of ",[0,[1,"frame:basic&lt;%&gt;"]],")"]]],["framework"]],
["editing-this-file?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor-mixin)._editing-this-file~3f))",[[0,[1,"editing-this-file?"]],[12,[" (method of ",[0,[1,"frame:editor-mixin"]],")"]]],["framework"]],
["editor",">framework/Editor.html","Editor",false],
["editor",">gui/editor-overview.html","Editor",false],
["editor",">gui/editor-overview.html#(tech._editor)","<i>editor</i>",false],
["editor administrator",">gui/editor-overview.html#(tech._editor._administrator)","<i>editor\nadministrator</i>",false],
["editor canvas",">gui/windowing-overview.html#(tech._editor._canva)","<i>editor canvas</i>",false],
["editor classes",">gui/Editor_Classes.html","Editor Classes",false],
["editor data",">gui/editor-overview.html#(part._editordata)","Editor Data",false],
["editor data",">gui/editor-overview.html#(tech._editor._data)","<i>editor data</i>",false],
["editor data class",">gui/editor-overview.html#(tech._editor._data._clas)","<i>editor data class</i>",false],
["editor data class list",">gui/editor-overview.html#(tech._editor._data._class._list)","<i>editor data class list</i>",false],
["editor functions",">gui/Editor_Functions.html","Editor Functions",false],
["editor modes",">tools/Editor_Modes.html","Editor Modes",false],
["editor snip",">framework/editor-snip.html","Editor Snip",false],
["editor structure and terminology",">gui/editor-overview.html#(part._tb~3amiaoverview)","Editor Structure and Terminology",false],
["editor toolbox",">gui/Overview.html#(tech._editor._toolbox)","<i>editor toolbox</i>",false],
["editor%",">gui/WXME_Decoding.html#(def._((lib._wxme/editor..ss)._editor~25))",[0,[1,"editor%"]],["wxme/editor"]],
["editor->page",">browser/index.html#(def._((lib._browser/main..ss)._editor-~3epage))",[0,[1,"editor-&gt;page"]],["browser"]],
["editor-admin%",">gui/editor-admin_.html",[0,[1,"editor-admin%"]],["scheme/gui/base","scheme/gui"]],
["editor-canvas%",">gui/editor-canvas_.html",[0,[1,"editor-canvas%"]],["scheme/gui/base","scheme/gui"]],
["editor-data%",">gui/editor-data_.html",[0,[1,"editor-data%"]],["scheme/gui/base","scheme/gui"]],
["editor-data-class%",">gui/editor-data-class_.html",[0,[1,"editor-data-class%"]],["scheme/gui/base","scheme/gui"]],
["editor-data-class-list<%>",">gui/editor-data-class-list___.html",[0,[1,"editor-data-class-list&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["editor-location-to-dc-location",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._editor-location-to-dc-location))",[[0,[1,"editor-location-to-dc-location"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["editor-position-changed",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3atext-info~3c~25~3e)._editor-position-changed))",[[0,[1,"editor-position-changed"]],[12,[" (method of ",[0,[1,"frame:text-info&lt;%&gt;"]],")"]]],["framework"]],
["editor-set-x-selection-mode",">gui/Editor_Functions.html#(def._((lib._mred/main..ss)._editor-set-x-selection-mode))",[0,[1,"editor-set-x-selection-mode"]],["scheme/gui/base","scheme/gui"]],
["editor-snip%",">gui/editor-snip_.html",[0,[1,"editor-snip%"]],["scheme/gui/base","scheme/gui"]],
["editor-snip-editor-admin<%>",">gui/editor-snip-editor-admin___.html",[0,[1,"editor-snip-editor-admin&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["editor-snip:decorated%",">framework/editor-snip.html#(def._((lib._framework/main..ss)._editor-snip~3adecorated~25))",[0,[1,"editor-snip:decorated%"]],["framework"]],
["editor-snip:decorated-mixin",">framework/editor-snip.html#(def._((lib._framework/main..ss)._editor-snip~3adecorated-mixin))",[0,[1,"editor-snip:decorated-mixin"]],["framework"]],
["editor-snip:decorated-snipclass%",">framework/editor-snip.html#(def._((lib._framework/main..ss)._editor-snip~3adecorated-snipclass~25))",[0,"editor-snip:decorated-snipclass%"],["framework"]],
["editor-snip:decorated<%>",">framework/editor-snip.html#(def._((lib._framework/main..ss)._editor-snip~3adecorated~3c~25~3e))",[0,[1,"editor-snip:decorated&lt;%&gt;"]],["framework"]],
["editor-stream-in%",">gui/editor-stream-in_.html",[0,[1,"editor-stream-in%"]],["scheme/gui/base","scheme/gui"]],
["editor-stream-in-base%",">gui/editor-stream-in-base_.html",[0,[1,"editor-stream-in-base%"]],["scheme/gui/base","scheme/gui"]],
["editor-stream-in-bytes-base%",">gui/editor-stream-in-bytes-base_.html",[0,[1,"editor-stream-in-bytes-base%"]],["scheme/gui/base","scheme/gui"]],
["editor-stream-out%",">gui/editor-stream-out_.html",[0,[1,"editor-stream-out%"]],["scheme/gui/base","scheme/gui"]],
["editor-stream-out-base%",">gui/editor-stream-out-base_.html",[0,[1,"editor-stream-out-base%"]],["scheme/gui/base","scheme/gui"]],
["editor-stream-out-bytes-base%",">gui/editor-stream-out-bytes-base_.html",[0,[1,"editor-stream-out-bytes-base%"]],["scheme/gui/base","scheme/gui"]],
["editor-wordbreak-map%",">gui/editor-wordbreak-map_.html",[0,[1,"editor-wordbreak-map%"]],["scheme/gui/base","scheme/gui"]],
["editor:autowrap-mixin",">framework/Editor.html#(def._((lib._framework/main..ss)._editor~3aautowrap-mixin))",[0,[1,"editor:autowrap-mixin"]],["framework"]],
["editor:autowrap<%>",">framework/Editor.html#(def._((lib._framework/main..ss)._editor~3aautowrap~3c~25~3e))",[0,[1,"editor:autowrap&lt;%&gt;"]],["framework"]],
["editor:backup-autosave-mixin",">framework/Editor.html#(def._((lib._framework/main..ss)._editor~3abackup-autosave-mixin))",[0,[1,"editor:backup-autosave-mixin"]],["framework"]],
["editor:backup-autosave<%>",">framework/Editor.html#(def._((lib._framework/main..ss)._editor~3abackup-autosave~3c~25~3e))",[0,[1,"editor:backup-autosave&lt;%&gt;"]],["framework"]],
["editor:basic-mixin",">framework/Editor.html#(def._((lib._framework/main..ss)._editor~3abasic-mixin))",[0,[1,"editor:basic-mixin"]],["framework"]],
["editor:basic<%>",">framework/Editor.html#(def._((lib._framework/main..ss)._editor~3abasic~3c~25~3e))",[0,[1,"editor:basic&lt;%&gt;"]],["framework"]],
["editor:file-mixin",">framework/Editor.html#(def._((lib._framework/main..ss)._editor~3afile-mixin))",[0,[1,"editor:file-mixin"]],["framework"]],
["editor:file<%>",">framework/Editor.html#(def._((lib._framework/main..ss)._editor~3afile~3c~25~3e))",[0,[1,"editor:file&lt;%&gt;"]],["framework"]],
["editor:get-default-color-style-name",">framework/Editor.html#(def._((lib._framework/main..ss)._editor~3aget-default-color-style-name))",[0,[1,"editor:get-default-color-style-name"]],["framework"]],
["editor:get-standard-style-list",">framework/Editor.html#(def._((lib._framework/main..ss)._editor~3aget-standard-style-list))",[0,[1,"editor:get-standard-style-list"]],["framework"]],
["editor:info-mixin",">framework/Editor.html#(def._((lib._framework/main..ss)._editor~3ainfo-mixin))",[0,[1,"editor:info-mixin"]],["framework"]],
["editor:info<%>",">framework/Editor.html#(def._((lib._framework/main..ss)._editor~3ainfo~3c~25~3e))",[0,[1,"editor:info&lt;%&gt;"]],["framework"]],
["editor:keymap-mixin",">framework/Editor.html#(def._((lib._framework/main..ss)._editor~3akeymap-mixin))",[0,[1,"editor:keymap-mixin"]],["framework"]],
["editor:keymap<%>",">framework/Editor.html#(def._((lib._framework/main..ss)._editor~3akeymap~3c~25~3e))",[0,[1,"editor:keymap&lt;%&gt;"]],["framework"]],
["editor:set-default-font-color",">framework/Editor.html#(def._((lib._framework/main..ss)._editor~3aset-default-font-color))",[0,[1,"editor:set-default-font-color"]],["framework"]],
["editor:set-standard-style-list-delta",">framework/Editor.html#(def._((lib._framework/main..ss)._editor~3aset-standard-style-list-delta))",[0,[1,"editor:set-standard-style-list-delta"]],["framework"]],
["editor:set-standard-style-list-pref-callbacks",">framework/Editor.html#(def._((lib._framework/main..ss)._editor~3aset-standard-style-list-pref-callbacks))",[0,[1,"editor:set-standard-style-list-pref-callbacks"]],["framework"]],
["editor:standard-style-list-mixin",">framework/Editor.html#(def._((lib._framework/main..ss)._editor~3astandard-style-list-mixin))",[0,[1,"editor:standard-style-list-mixin"]],["framework"]],
["editor:standard-style-list<%>",">framework/Editor.html#(def._((lib._framework/main..ss)._editor~3astandard-style-list~3c~25~3e))",[0,[1,"editor:standard-style-list&lt;%&gt;"]],["framework"]],
["editor<%>",">gui/editor___.html",[0,[1,"editor&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["editors and threads",">gui/editor-overview.html#(part._editorthreads)","Editors and Threads",false],
["effects after: begin0",">guide/begin.html#(part._.Effects_.After__begin0)",["Effects After: ",[0,[6,"begin0"]]],false],
["effects before: begin",">guide/begin.html#(part._.Effects_.Before__begin)",["Effects Before: ",[0,[6,"begin"]]],false],
["effects if...: when and unless",">guide/begin.html#(part._when+unless)",["Effects If...: ",[0,[6,"when"]]," and ",[0,[6,"unless"]]],false],
["eighth",">reference/pairs.html#(def._((lib._scheme/list..ss)._eighth))",[0,[1,"eighth"]],["scheme/list","scheme"]],
["eighth",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._eighth))",[0,[1,"eighth"]],["lang/htdp-advanced"]],
["eighth",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._eighth))",[0,[1,"eighth"]],["lang/htdp-beginner"]],
["eighth",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._eighth))",[0,[1,"eighth"]],["lang/htdp-beginner-abbr"]],
["eighth",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._eighth))",[0,[1,"eighth"]],["lang/htdp-intermediate"]],
["eighth",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._eighth))",[0,[1,"eighth"]],["lang/htdp-intermediate-lambda"]],
["eighth",">lazy/index.html#(def._((lib._lazy/main..ss)._eighth))",[0,[1,"eighth"]],["lazy"]],
["eighth",">mzlib/mzlib_list.html#(def._((lib._mzlib/list..ss)._eighth))",[0,[1,"eighth"]],["mzlib/list"]],
["eighth",">srfi-std/srfi-1.html#eighth",[0,[1,"eighth"]],["srfi/1"]],
["elem",">scribble/basic.html#(def._((lib._scribble/basic..ss)._elem))",[0,[1,"elem"]],["scribble/basic"]],
["element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._element))",[0,[1,"element"]],["scribble/struct"]],
["element",">xml/index.html#(def._((lib._xml/main..ss)._element))",[0,[1,"element"]],["xml"]],
["element",">scribble/struct.html#(tech._element)","<i>element</i>",false],
["element->string",">scribble/struct.html#(def._((lib._scribble/struct..ss)._element-~3estring))",[0,[1,"element-&gt;string"]],["scribble/struct"]],
["element-attributes",">xml/index.html#(def._((lib._xml/main..ss)._element-attributes))",[0,[1,"element-attributes"]],["xml"]],
["element-content",">scribble/struct.html#(def._((lib._scribble/struct..ss)._element-content))",[0,[1,"element-content"]],["scribble/struct"]],
["element-content",">xml/index.html#(def._((lib._xml/main..ss)._element-content))",[0,[1,"element-content"]],["xml"]],
["element-name",">xml/index.html#(def._((lib._xml/main..ss)._element-name))",[0,[1,"element-name"]],["xml"]],
["element-style",">scribble/struct.html#(def._((lib._scribble/struct..ss)._element-style))",[0,[1,"element-style"]],["scribble/struct"]],
["element-width",">scribble/struct.html#(def._((lib._scribble/struct..ss)._element-width))",[0,[1,"element-width"]],["scribble/struct"]],
["element?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._element~3f))",[0,[1,"element?"]],["scribble/struct"]],
["element?",">xml/index.html#(def._((lib._xml/main..ss)._element~3f))",[0,[1,"element?"]],["xml"]],
["elements-with-tag",">mysterx/documents.html#(meth._(((lib._mysterx/main..ss)._mx-document~3c~25~3e)._elements-with-tag))",[[0,[1,"elements-with-tag"]],[12,[" (method of ",[0,[1,"mx-document&lt;%&gt;"]],")"]]],["mysterx"]],
["elemref",">scribble/section-links.html#(def._((lib._scribble/manual..ss)._elemref))",[0,[1,"elemref"]],["scribble/manual"]],
["elemtag",">scribble/section-links.html#(def._((lib._scribble/manual..ss)._elemtag))",[0,[1,"elemtag"]],["scribble/manual"]],
["elevator teachpack",">teachpack/elevator.html#(idx._(gentag._13._(lib._teachpack/teachpack..scrbl)))","elevator teachpack",false],
["eliminate-whitespace",">xml/index.html#(def._((lib._xml/main..ss)._eliminate-whitespace))",[0,[1,"eliminate-whitespace"]],["xml"]],
["ellipse",">gui/dc-path_.html#(meth._(((lib._mred/main..ss)._dc-path~25)._ellipse))",[[0,[1,"ellipse"]],[12,[" (method of ",[0,[1,"dc-path%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["ellipse",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._ellipse))",[0,[1,"ellipse"]],["slideshow/pict","slideshow"]],
["ellipse",">teachpack/image.html#(def._((lib._htdp/image..ss)._ellipse))",[0,[1,"ellipse"]],["teachpack/htdp/image"]],
["ellipses",">graphics/Draw__Clear__and_Flip_Operations.html#(part._.Ellipses)","Ellipses",false],
["else",">reference/if.html#(form._((lib._scheme/private/letstx-scheme..ss)._else))",[0,[6,"else"]],["scheme/base","scheme"]],
["else",">r6rs-std/r6rs-Z-H-14.html#node_idx_380",[0,[6,"else"]],["rnrs/base-6"]],
["else",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_374",[0,[6,"else"]],["rnrs/exceptions-6"]],
["else",">htdp-langs/advanced-unchanged.html#(form._((lib._lang/htdp-advanced..ss)._else))",[0,[6,"else"]],["lang/htdp-advanced"]],
["else",">htdp-langs/cond.html#(form._((lib._lang/htdp-beginner..ss)._else))",[0,[6,"else"]],["lang/htdp-beginner"]],
["else",">htdp-langs/Unchanged_Forms.html#(form._((lib._lang/htdp-beginner-abbr..ss)._else))",[0,[6,"else"]],["lang/htdp-beginner-abbr"]],
["else",">htdp-langs/intermediate-unchanged.html#(form._((lib._lang/htdp-intermediate..ss)._else))",[0,[6,"else"]],["lang/htdp-intermediate"]],
["else",">htdp-langs/intermediate-lambda-unchanged.html#(form._((lib._lang/htdp-intermediate-lambda..ss)._else))",[0,[6,"else"]],["lang/htdp-intermediate-lambda"]],
["em",">html/index.html#(def._((lib._html/main..ss)._em))",[0,[1,"em"]],["html"]],
["em?",">html/index.html#(def._((lib._html/main..ss)._em~3f))",[0,[1,"em?"]],["html"]],
["emacs keybindings",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._153._(lib._scribblings/drscheme/drscheme..scrbl)))","Emacs keybindings",false],
["embed-formlet",">web-server/Utilities.html#(def._((lib._web-server/formlets/servlet..ss)._embed-formlet))",[0,[1,"embed-formlet"]],["web-server/formlets/servlet"]],
["embed-ids",">web-server/web_ss.html#(def._((lib._web-server/servlet/web..ss)._embed-ids))",[0,[1,"embed-ids"]],["web-server/servlet/web"]],
["embed/url/c",">web-server/servlet-structs_ss.html#(def._((lib._web-server/servlet/servlet-structs..ss)._embed/url/c))",[0,[1,"embed/url/c"]],["web-server/servlet/servlet-structs"]],
["embedded gui: widgets within editor<%>",">embedded-gui/index.html",["<b>Embedded GUI</b>",": Widgets within ",[0,[1,"editor&lt;%&gt;"]]],false],
["embedded-button%",">embedded-gui/embedded-button_.html",[0,[1,"embedded-button%"]],["embedded-gui"]],
["embedded-gui",">embedded-gui/index.html",[14,[0,"embedded-gui"]],"module"],
["embedded-message%",">embedded-gui/embedded-message_.html",[0,[1,"embedded-message%"]],["embedded-gui"]],
["embedded-text-button%",">embedded-gui/embedded-text-button_.html",[0,[1,"embedded-text-button%"]],["embedded-gui"]],
["embedded-toggle-button%",">embedded-gui/embedded-toggle-button_.html",[0,[1,"embedded-toggle-button%"]],["embedded-gui"]],
["embedding mzscheme",">inside/overview.html#(idx._(gentag._16._(lib._scribblings/inside/inside..scrbl)))","embedding MzScheme",false],
["embedding mzscheme into a program",">inside/overview.html#(part._embedding)","Embedding MzScheme into a Program",false],
["embedding scheme modules via c",">mzc/c-mods.html","Embedding Scheme Modules via C",false],
["embedding-executable-add-suffix",">mzc/exe.html#(def._((lib._compiler/embed..ss)._embedding-executable-add-suffix))",[0,[1,"embedding-executable-add-suffix"]],["compiler/embed"]],
["embedding-executable-is-actually-directory?",">mzc/exe.html#(def._((lib._compiler/embed..ss)._embedding-executable-is-actually-directory~3f))",[0,[1,"embedding-executable-is-actually-directory?"]],["compiler/embed"]],
["embedding-executable-is-directory?",">mzc/exe.html#(def._((lib._compiler/embed..ss)._embedding-executable-is-directory~3f))",[0,[1,"embedding-executable-is-directory?"]],["compiler/embed"]],
["embedding-executable-put-file-extension+style+filters",">mzc/exe.html#(def._((lib._compiler/embed..ss)._embedding-executable-put-file-extension+style+filters))",[0,[1,"embedding-executable-put-file-extension+style+filters"]],["compiler/embed"]],
["emph",">scribble/doc-strings.html#(def._((lib._scribble/manual..ss)._emph))",[0,[1,"emph"]],["scribble/manual"]],
["empty",">htdp-langs/empty.html",[0,[1,"empty"]],false],
["empty",">reference/pairs.html#(def._((lib._scheme/list..ss)._empty))",[0,[1,"empty"]],["scheme/list","scheme"]],
["empty",">htdp-langs/advanced-unchanged.html#(def._((lib._lang/htdp-advanced..ss)._empty))",[0,[1,"empty"]],["lang/htdp-advanced"]],
["empty",">htdp-langs/empty.html#(def._((lib._lang/htdp-beginner..ss)._empty))",[0,[1,"empty"]],["lang/htdp-beginner"]],
["empty",">htdp-langs/Unchanged_Forms.html#(def._((lib._lang/htdp-beginner-abbr..ss)._empty))",[0,[1,"empty"]],["lang/htdp-beginner-abbr"]],
["empty",">htdp-langs/intermediate-unchanged.html#(def._((lib._lang/htdp-intermediate..ss)._empty))",[0,[1,"empty"]],["lang/htdp-intermediate"]],
["empty",">htdp-langs/intermediate-lambda-unchanged.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._empty))",[0,[1,"empty"]],["lang/htdp-intermediate-lambda"]],
["empty",">eopl/index.html#(def._((lib._eopl/eopl..ss)._empty))",[0,[1,"empty"]],["eopl/eopl"]],
["empty",">lazy/index.html#(def._((lib._lazy/main..ss)._empty))",[0,[1,"empty"]],["lazy"]],
["empty-disposition-type",">net/mime.html#(def._((lib._net/mime..ss)._empty-disposition-type))",[0,[1,"empty-disposition-type"]],["net/mime"]],
["empty-disposition-type?",">net/mime.html#(def._((lib._net/mime..ss)._empty-disposition-type~3f))",[0,[1,"empty-disposition-type?"]],["net/mime"]],
["empty-gif-stream?",">file/gif.html#(def._((lib._file/gif..ss)._empty-gif-stream~3f))",[0,[1,"empty-gif-stream?"]],["file/gif"]],
["empty-header",">net/head.html#(def._((lib._net/head..ss)._empty-header))",[0,[1,"empty-header"]],["net/head"]],
["empty-mechanism",">net/mime.html#(def._((lib._net/mime..ss)._empty-mechanism))",[0,[1,"empty-mechanism"]],["net/mime"]],
["empty-mechanism?",">net/mime.html#(def._((lib._net/mime..ss)._empty-mechanism~3f))",[0,[1,"empty-mechanism?"]],["net/mime"]],
["empty-scene",">teachpack/world.html#(def._((lib._teachpack/htdp/world..ss)._empty-scene))",[0,[1,"empty-scene"]],["teachpack/htdp/world"]],
["empty-subtype",">net/mime.html#(def._((lib._net/mime..ss)._empty-subtype))",[0,[1,"empty-subtype"]],["net/mime"]],
["empty-subtype?",">net/mime.html#(def._((lib._net/mime..ss)._empty-subtype~3f))",[0,[1,"empty-subtype?"]],["net/mime"]],
["empty-tag-shorthand",">xml/index.html#(def._((lib._xml/main..ss)._empty-tag-shorthand))",[0,[1,"empty-tag-shorthand"]],["xml"]],
["empty-type",">net/mime.html#(def._((lib._net/mime..ss)._empty-type))",[0,[1,"empty-type"]],["net/mime"]],
["empty-type?",">net/mime.html#(def._((lib._net/mime..ss)._empty-type~3f))",[0,[1,"empty-type?"]],["net/mime"]],
["empty?",">reference/pairs.html#(def._((lib._scheme/list..ss)._empty~3f))",[0,[1,"empty?"]],["scheme/list","scheme"]],
["empty?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._empty~3f))",[0,[1,"empty?"]],["lang/htdp-advanced"]],
["empty?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._empty~3f))",[0,[1,"empty?"]],["lang/htdp-beginner"]],
["empty?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._empty~3f))",[0,[1,"empty?"]],["lang/htdp-beginner-abbr"]],
["empty?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._empty~3f))",[0,[1,"empty?"]],["lang/htdp-intermediate"]],
["empty?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._empty~3f))",[0,[1,"empty?"]],["lang/htdp-intermediate-lambda"]],
["empty?",">lazy/index.html#(def._((lib._lazy/main..ss)._empty~3f))",[0,[1,"empty?"]],["lazy"]],
["enable",">gui/labelled-menu-item___.html#(meth._(((lib._mred/main..ss)._labelled-menu-item~3c~25~3e)._enable))",[[0,[1,"enable"]],[12,[" (method of ",[0,[1,"labelled-menu-item&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["enable",">gui/menu-bar_.html#(meth._(((lib._mred/main..ss)._menu-bar~25)._enable))",[[0,[1,"enable"]],[12,[" (method of ",[0,[1,"menu-bar%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["enable",">gui/radio-box_.html#(meth._(((lib._mred/main..ss)._radio-box~25)._enable))",[[0,[1,"enable"]],[12,[" (method of ",[0,[1,"radio-box%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["enable",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._enable))",[[0,[1,"enable"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["enable tests menu item",">drscheme/Menus.html#(idx._(gentag._131._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Enable Tests</font></b> menu item",false],
["enable-click-advance!",">slideshow/Viewer_Control.html#(def._((lib._slideshow/base..ss)._enable-click-advance!))",[0,[1,"enable-click-advance!"]],["slideshow/base","slideshow"]],
["enable-evaluation",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3acontext~3c~25~3e)._enable-evaluation))",[[0,[1,"enable-evaluation"]],[12,[" (method of ",[0,[1,"drscheme:rep:context&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["enable-evaluation",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3atab~3c~25~3e)._enable-evaluation))",[[0,[1,"enable-evaluation"]],[12,[" (method of ",[0,[1,"drscheme:unit:tab&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["enable-piece",">gl-board-game/index.html#(meth._(((lib._games/gl-board-game..ss)._gl-board~25)._enable-piece))",[[0,[1,"enable-piece"]],[12,[" (method of ",[0,[1,"gl-board%"]],")"]]],["games/gl-board-game"]],
["enabled",">gui/window___.html#(idx._(gentag._139._(lib._scribblings/gui/gui..scrbl)))",[0,"enabled"],false],
["enabled?",">gl-board-game/index.html#(meth._(((lib._games/gl-board-game..ss)._gl-board~25)._enabled~3f))",[[0,[1,"enabled?"]],[12,[" (method of ",[0,[1,"gl-board%"]],")"]]],["games/gl-board-game"]],
["enabling and disabling breaks",">inside/exceptions.html#(part._.Enabling_and_.Disabling_.Breaks)","Enabling and Disabling Breaks",false],
["encapsulated postscript (eps)",">gui/post-script-dc_.html#(idx._(gentag._230._(lib._scribblings/gui/gui..scrbl)))","Encapsulated PostScript (EPS)",false],
["enclosing-module-name",">reference/module.html#(idx._(gentag._2._(lib._scribblings/reference/reference..scrbl)))",[7,"'enclosing-module-name"],false],
["encoding snips",">gui/editor-overview.html#(part._.Encoding_.Snips)","Encoding Snips",false],
["encodings and locales",">reference/encodings.html","Encodings and Locales",false],
["end",">gui/key-event_.html#(idx._(gentag._56._(lib._scribblings/gui/gui..scrbl)))",[7,"'end"],false],
["end of line ambiguity",">gui/editor-overview.html#(part._editoreol)","End of Line Ambiguity",false],
["end-annotation",">teachpack/docs.html#(def._((lib._teachpack/htdp/docs..ss)._end-annotation))",[0,[1,"end-annotation"]],["teachpack/htdp/docs"]],
["end-busy-cursor",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._end-busy-cursor))",[0,[1,"end-busy-cursor"]],["scheme/gui/base","scheme/gui"]],
["end-card-sequence",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._end-card-sequence))",[[0,[1,"end-card-sequence"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["end-container-sequence",">gui/area-container___.html#(meth._(((lib._mred/main..ss)._area-container~3c~25~3e)._end-container-sequence))",[[0,[1,"end-container-sequence"]],[12,[" (method of ",[0,[1,"area-container&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["end-doc",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._end-doc))",[[0,[1,"end-doc"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["end-edit-sequence",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._end-edit-sequence))",[[0,[1,"end-edit-sequence"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["end-macro",">framework/Keymap.html#(idx._(gentag._39._(lib._scribblings/framework/framework..scrbl)))","end-macro",false],
["end-mark",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..ss)._end-mark))",[0,[1,"end-mark"]],["preprocessor/mzpp"]],
["end-metadata-changes",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3adefinitions-text~3c~25~3e)._end-metadata-changes))",[[0,[1,"end-metadata-changes"]],[12,[" (method of ",[0,[1,"drscheme:unit:definitions-text&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["end-of-char-set?",">srfi-std/srfi-14.html#end-of-char-set-p",[0,[1,"end-of-char-set?"]],["srfi/14"]],
["end-of-time",">teachpack/draw.html#(def._((lib._teachpack/htdp/draw..ss)._end-of-time))",[0,[1,"end-of-time"]],["teachpack/htdp/draw"]],
["end-page",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._end-page))",[[0,[1,"end-page"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["end-pos",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..ss)._end-pos))",[0,[6,"end-pos"]],["parser-tools/lex"]],
["end-stubborn-change",">foreign/foreign_pointer-funcs.html#(def._((lib._scribblings/foreign/unsafe-foreign..ss)._end-stubborn-change))",[0,[1,"end-stubborn-change"]],["scribblings/foreign/unsafe-foreign"]],
["end-write-header-footer-to-file",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._end-write-header-footer-to-file))",[[0,[1,"end-write-header-footer-to-file"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["endianness",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_76",[0,[6,"endianness"]],["rnrs/bytevectors-6"]],
["endoftime",">teachpack/Jdraw.html#(def._((lib._teachpack/htdc/draw..ss)._end.Of.Time))",[0,[1,"endOfTime"]],["teachpack/htdc/draw"]],
["endofworld",">teachpack/Jdraw.html#(def._((lib._teachpack/htdc/draw..ss)._end.Of.World))",[0,[1,"endOfWorld"]],["teachpack/htdc/draw"]],
["ensure-defs-shown",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~3c~25~3e)._ensure-defs-shown))",[[0,[1,"ensure-defs-shown"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["ensure-rep-hidden",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~3c~25~3e)._ensure-rep-hidden))",[[0,[1,"ensure-rep-hidden"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["ensure-rep-shown",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3acontext~3c~25~3e)._ensure-rep-shown))",[[0,[1,"ensure-rep-shown"]],[12,[" (method of ",[0,[1,"drscheme:rep:context&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["ensure-rep-shown",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~3c~25~3e)._ensure-rep-shown))",[[0,[1,"ensure-rep-shown"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["ensuring that a function properly modifies state",">guide/contracts-general-functions.html#(part._contracts-arrow-d-eval-order)","Ensuring that a Function Properly Modifies State",false],
["ensuring that all structs are well-formed",">guide/contracts-struct.html#(part._contracts-define-struct)","Ensuring that All Structs are Well-Formed",false],
["enter!",">reference/enter.html#(form._((lib._scheme/enter..ss)._enter!))",[0,[6,"enter!"]],["scheme/enter","scheme/init"]],
["entering?",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._entering~3f))",[[0,[1,"entering?"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["entity",">net/mime.html#(def._((lib._net/mime..ss)._entity))",[0,[1,"entity"]],["net/mime"]],
["entity",">xml/index.html#(def._((lib._xml/main..ss)._entity))",[0,[1,"entity"]],["xml"]],
["entity-body",">net/mime.html#(def._((lib._net/mime..ss)._entity-body))",[0,[1,"entity-body"]],["net/mime"]],
["entity-charset",">net/mime.html#(def._((lib._net/mime..ss)._entity-charset))",[0,[1,"entity-charset"]],["net/mime"]],
["entity-description",">net/mime.html#(def._((lib._net/mime..ss)._entity-description))",[0,[1,"entity-description"]],["net/mime"]],
["entity-disposition",">net/mime.html#(def._((lib._net/mime..ss)._entity-disposition))",[0,[1,"entity-disposition"]],["net/mime"]],
["entity-encoding",">net/mime.html#(def._((lib._net/mime..ss)._entity-encoding))",[0,[1,"entity-encoding"]],["net/mime"]],
["entity-fields",">net/mime.html#(def._((lib._net/mime..ss)._entity-fields))",[0,[1,"entity-fields"]],["net/mime"]],
["entity-id",">net/mime.html#(def._((lib._net/mime..ss)._entity-id))",[0,[1,"entity-id"]],["net/mime"]],
["entity-other",">net/mime.html#(def._((lib._net/mime..ss)._entity-other))",[0,[1,"entity-other"]],["net/mime"]],
["entity-params",">net/mime.html#(def._((lib._net/mime..ss)._entity-params))",[0,[1,"entity-params"]],["net/mime"]],
["entity-parts",">net/mime.html#(def._((lib._net/mime..ss)._entity-parts))",[0,[1,"entity-parts"]],["net/mime"]],
["entity-subtype",">net/mime.html#(def._((lib._net/mime..ss)._entity-subtype))",[0,[1,"entity-subtype"]],["net/mime"]],
["entity-text",">xml/index.html#(def._((lib._xml/main..ss)._entity-text))",[0,[1,"entity-text"]],["xml"]],
["entity-type",">net/mime.html#(def._((lib._net/mime..ss)._entity-type))",[0,[1,"entity-type"]],["net/mime"]],
["entity?",">net/mime.html#(def._((lib._net/mime..ss)._entity~3f))",[0,[1,"entity?"]],["net/mime"]],
["entity?",">xml/index.html#(def._((lib._xml/main..ss)._entity~3f))",[0,[1,"entity?"]],["xml"]],
["entry",">scribble/xref.html#(def._((lib._scribble/xref..ss)._entry))",[0,[1,"entry"]],["scribble/xref"]],
["entry-content",">scribble/xref.html#(def._((lib._scribble/xref..ss)._entry-content))",[0,[1,"entry-content"]],["scribble/xref"]],
["entry-desc",">scribble/xref.html#(def._((lib._scribble/xref..ss)._entry-desc))",[0,[1,"entry-desc"]],["scribble/xref"]],
["entry-tag",">scribble/xref.html#(def._((lib._scribble/xref..ss)._entry-tag))",[0,[1,"entry-tag"]],["scribble/xref"]],
["entry-words",">scribble/xref.html#(def._((lib._scribble/xref..ss)._entry-words))",[0,[1,"entry-words"]],["scribble/xref"]],
["entry?",">scribble/xref.html#(def._((lib._scribble/xref..ss)._entry~3f))",[0,[1,"entry?"]],["scribble/xref"]],
["enum-set->list",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1244",[0,[1,"enum-set-&gt;list"]],["rnrs/enums-6"]],
["enum-set-complement",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1258",[0,[1,"enum-set-complement"]],["rnrs/enums-6"]],
["enum-set-constructor",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1242",[0,[1,"enum-set-constructor"]],["rnrs/enums-6"]],
["enum-set-difference",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1256",[0,[1,"enum-set-difference"]],["rnrs/enums-6"]],
["enum-set-indexer",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1240",[0,[1,"enum-set-indexer"]],["rnrs/enums-6"]],
["enum-set-intersection",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1254",[0,[1,"enum-set-intersection"]],["rnrs/enums-6"]],
["enum-set-member?",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1246",[0,[1,"enum-set-member?"]],["rnrs/enums-6"]],
["enum-set-projection",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1260",[0,[1,"enum-set-projection"]],["rnrs/enums-6"]],
["enum-set-subset?",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1248",[0,[1,"enum-set-subset?"]],["rnrs/enums-6"]],
["enum-set-union",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1252",[0,[1,"enum-set-union"]],["rnrs/enums-6"]],
["enum-set-universe",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1238",[0,[1,"enum-set-universe"]],["rnrs/enums-6"]],
["enum-set=?",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1250",[0,[1,"enum-set=?"]],["rnrs/enums-6"]],
["enumerations and masks",">foreign/Enumerations_and_Masks.html","Enumerations and Masks",false],
["environment",">r6rs-lib-std/r6rs-lib-Z-H-17.html#node_idx_1270",[0,[1,"environment"]],["rnrs/eval-6"]],
["environment",">reference/syntax-model.html#(tech._environment)","<i>environment</i>",false],
["environment and runtime information",">reference/runtime.html","Environment and Runtime Information",false],
["environment variables",">drscheme/extending-drscheme.html#(part._environment-variables)","Environment Variables",false],
["envvar",">scribble/doc-strings.html#(def._((lib._scribble/manual..ss)._envvar))",[0,[1,"envvar"]],["scribble/manual"]],
["eof",">reference/port-ops.html#(def._((quote._~23~25kernel)._eof))",[0,[1,"eof"]],["scheme/base","scheme"]],
["eof",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._eof))",[0,[1,"eof"]],["lang/htdp-advanced"]],
["eof",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._eof))",[0,[1,"eof"]],["lang/htdp-beginner"]],
["eof",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._eof))",[0,[1,"eof"]],["lang/htdp-beginner-abbr"]],
["eof",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._eof))",[0,[1,"eof"]],["lang/htdp-intermediate"]],
["eof",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._eof))",[0,[1,"eof"]],["lang/htdp-intermediate-lambda"]],
["eof-evt",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._eof-evt))",[0,[1,"eof-evt"]],["scheme/port"]],
["eof-object",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_636",[0,[1,"eof-object"]],["rnrs/io/ports-6"]],
["eof-object?",">reference/port-ops.html#(def._((quote._~23~25kernel)._eof-object~3f))",[0,[1,"eof-object?"]],["scheme/base","scheme"]],
["eof-object?",">r5rs-std/r5rs-Z-H-9.html#%_idx_646",[0,[1,"eof-object?"]],["r5rs"]],
["eof-object?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_638",[0,[1,"eof-object?"]],["rnrs/io/ports-6"]],
["eof-object?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._eof-object~3f))",[0,[1,"eof-object?"]],["lang/htdp-advanced"]],
["eof-object?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._eof-object~3f))",[0,[1,"eof-object?"]],["lang/htdp-beginner"]],
["eof-object?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._eof-object~3f))",[0,[1,"eof-object?"]],["lang/htdp-beginner-abbr"]],
["eof-object?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._eof-object~3f))",[0,[1,"eof-object?"]],["lang/htdp-intermediate"]],
["eof-object?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._eof-object~3f))",[0,[1,"eof-object?"]],["lang/htdp-intermediate-lambda"]],
["eol-style",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_596",[0,[6,"eol-style"]],["rnrs/io/ports-6"]],
["eopl/eopl",">eopl/index.html",[14,[0,"eopl/eopl"]],"module"],
["eopl:error",">eopl/index.html#(def._((lib._eopl/eopl..ss)._eopl~3aerror))",[0,[1,"eopl:error"]],["eopl/eopl"]],
["eopl:error-stop",">eopl/index.html#(def._((lib._eopl/eopl..ss)._eopl~3aerror-stop))",[0,"eopl:error-stop"],["eopl/eopl"]],
["eopl:pretty-print",">eopl/index.html#(def._((lib._eopl/eopl..ss)._eopl~3apretty-print))",[0,[1,"eopl:pretty-print"]],["eopl/eopl"]],
["eopl:printf",">eopl/index.html#(def._((lib._eopl/eopl..ss)._eopl~3aprintf))",[0,[1,"eopl:printf"]],["eopl/eopl"]],
["ephemeron",">reference/ephemerons.html#(tech._ephemeron)","<i>ephemeron</i>",false],
["ephemeron-value",">reference/ephemerons.html#(def._((quote._~23~25kernel)._ephemeron-value))",[0,[1,"ephemeron-value"]],["scheme/base","scheme"]],
["ephemeron?",">reference/ephemerons.html#(def._((quote._~23~25kernel)._ephemeron~3f))",[0,[1,"ephemeron?"]],["scheme/base","scheme"]],
["ephemerons",">reference/ephemerons.html","Ephemerons",false],
["epsilon",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-plt-v200..ss)._epsilon))",[0,[6,"epsilon"]],["parser-tools/lex-plt-v200"]],
["eq-hash-code",">reference/hashtables.html#(def._((quote._~23~25kernel)._eq-hash-code))",[0,[1,"eq-hash-code"]],["scheme/base","scheme"]],
["eq?",">reference/booleans.html#(def._((quote._~23~25kernel)._eq~3f))",[0,[1,"eq?"]],["scheme/base","scheme"]],
["eq?",">r5rs-std/r5rs-Z-H-9.html#%_idx_220",[0,[1,"eq?"]],["r5rs"]],
["eq?",">r6rs-std/r6rs-Z-H-14.html#node_idx_434",[0,[1,"eq?"]],["rnrs/base-6"]],
["eq?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._eq~3f))",[0,[1,"eq?"]],["lang/htdp-advanced"]],
["eq?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._eq~3f))",[0,[1,"eq?"]],["lang/htdp-beginner"]],
["eq?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._eq~3f))",[0,[1,"eq?"]],["lang/htdp-beginner-abbr"]],
["eq?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._eq~3f))",[0,[1,"eq?"]],["lang/htdp-intermediate"]],
["eq?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._eq~3f))",[0,[1,"eq?"]],["lang/htdp-intermediate-lambda"]],
["eq?",">lazy/index.html#(def._((lib._lazy/main..ss)._eq~3f))",[0,[1,"eq?"]],["lazy"]],
["equal",">mzscheme/Old_Functions.html#(idx._(gentag._1._(lib._mzscheme/mzscheme..scrbl)))",[7,"'equal"],false],
["equal-hash",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1218",[0,[1,"equal-hash"]],["rnrs/hashtables-6"]],
["equal-hash-code",">reference/hashtables.html#(def._((quote._~23~25kernel)._equal-hash-code))",[0,[1,"equal-hash-code"]],["scheme/base","scheme"]],
["equal-secondary-hash-code",">reference/hashtables.html#(def._((quote._~23~25kernel)._equal-secondary-hash-code))",[0,[1,"equal-secondary-hash-code"]],["scheme/base","scheme"]],
["equal?",">reference/booleans.html#(def._((quote._~23~25kernel)._equal~3f))",[0,[1,"equal?"]],["scheme/base","scheme"]],
["equal?",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._equal~3f))",[[0,[1,"equal?"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["equal?",">r5rs-std/r5rs-Z-H-9.html#%_idx_222",[0,[1,"equal?"]],["r5rs"]],
["equal?",">r6rs-std/r6rs-Z-H-14.html#node_idx_436",[0,[1,"equal?"]],["rnrs/base-6"]],
["equal?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._equal~3f))",[0,[1,"equal?"]],["lang/htdp-advanced"]],
["equal?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._equal~3f))",[0,[1,"equal?"]],["lang/htdp-beginner"]],
["equal?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._equal~3f))",[0,[1,"equal?"]],["lang/htdp-beginner-abbr"]],
["equal?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._equal~3f))",[0,[1,"equal?"]],["lang/htdp-intermediate"]],
["equal?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._equal~3f))",[0,[1,"equal?"]],["lang/htdp-intermediate-lambda"]],
["equal?",">lazy/index.html#(def._((lib._lazy/main..ss)._equal~3f))",[0,[1,"equal?"]],["lazy"]],
["equal~?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._equal~7e~3f))",[0,[1,"equal~?"]],["lang/htdp-advanced"]],
["equal~?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._equal~7e~3f))",[0,[1,"equal~?"]],["lang/htdp-beginner"]],
["equal~?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._equal~7e~3f))",[0,[1,"equal~?"]],["lang/htdp-beginner-abbr"]],
["equal~?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._equal~7e~3f))",[0,[1,"equal~?"]],["lang/htdp-intermediate"]],
["equal~?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._equal~7e~3f))",[0,[1,"equal~?"]],["lang/htdp-intermediate-lambda"]],
["eqv",">mzscheme/Old_Functions.html#(idx._(gentag._2._(lib._mzscheme/mzscheme..scrbl)))",[7,"'eqv"],false],
["eqv-hash-code",">reference/hashtables.html#(def._((quote._~23~25kernel)._eqv-hash-code))",[0,[1,"eqv-hash-code"]],["scheme/base","scheme"]],
["eqv?",">reference/booleans.html#(def._((quote._~23~25kernel)._eqv~3f))",[0,[1,"eqv?"]],["scheme/base","scheme"]],
["eqv?",">r5rs-std/r5rs-Z-H-9.html#%_idx_214",[0,[1,"eqv?"]],["r5rs"]],
["eqv?",">r6rs-std/r6rs-Z-H-14.html#node_idx_428",[0,[1,"eqv?"]],["rnrs/base-6"]],
["eqv?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._eqv~3f))",[0,[1,"eqv?"]],["lang/htdp-advanced"]],
["eqv?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._eqv~3f))",[0,[1,"eqv?"]],["lang/htdp-beginner"]],
["eqv?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._eqv~3f))",[0,[1,"eqv?"]],["lang/htdp-beginner-abbr"]],
["eqv?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._eqv~3f))",[0,[1,"eqv?"]],["lang/htdp-intermediate"]],
["eqv?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._eqv~3f))",[0,[1,"eqv?"]],["lang/htdp-intermediate-lambda"]],
["eqv?",">lazy/index.html#(def._((lib._lazy/main..ss)._eqv~3f))",[0,[1,"eqv?"]],["lazy"]],
["erase",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._erase))",[[0,[1,"erase"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["erase",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._erase))",[[0,[1,"erase"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["erase",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtles..ss)._erase))",[0,[1,"erase"]],["graphics/turtles"]],
["erase",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles..ss)._erase))",[0,"erase"],["graphics/value-turtles"]],
["erase-offset",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtles..ss)._erase-offset))",[0,[1,"erase-offset"]],["graphics/turtles"]],
["erase-offset",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles..ss)._erase-offset))",[0,"erase-offset"],["graphics/value-turtles"]],
["erase-underscores",">framework/Menu.html#(meth._(((lib._framework/main..ss)._menu~3acan-restore-underscore~3c~25~3e)._erase-underscores))",[[0,[1,"erase-underscores"]],[12,[" (method of ",[0,[1,"menu:can-restore-underscore&lt;%&gt;"]],")"]]],["framework"]],
["error",">reference/exns.html#(def._((quote._~23~25kernel)._error))",[0,[1,"error"]],["scheme/base","scheme"]],
["error",">r6rs-std/r6rs-Z-H-14.html#node_idx_746",[0,[1,"error"]],["rnrs/base-6"]],
["error",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._error))",[0,[1,"error"]],["lang/htdp-advanced"]],
["error",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._error))",[0,[1,"error"]],["lang/htdp-beginner"]],
["error",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._error))",[0,[1,"error"]],["lang/htdp-beginner-abbr"]],
["error",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._error))",[0,[1,"error"]],["lang/htdp-intermediate"]],
["error",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._error))",[0,[1,"error"]],["lang/htdp-intermediate-lambda"]],
["error",">lazy/index.html#(def._((lib._lazy/main..ss)._error))",[0,[1,"error"]],["lazy"]],
["error",">srfi-std/srfi-23.html#error",[0,[1,"error"]],["srfi/23"]],
["error",">reference/file-ports.html#(idx._(gentag._107._(lib._scribblings/reference/reference..scrbl)))",[7,"'error"],false],
["error",">reference/bytestrings.html#(idx._(gentag._33._(lib._scribblings/reference/reference..scrbl)))",[7,"'error"],false],
["error display handler",">reference/exns.html#(tech._error._display._handler)","<i>error display handler</i>",false],
["error escape handler",">reference/exns.html#(tech._error._escape._handler)","<i>error escape handler</i>",false],
["error highlighting",">drscheme/interactions-window.html#(idx._(gentag._27._(lib._scribblings/drscheme/drscheme..scrbl)))","error highlighting",false],
["error value conversion handler",">reference/exns.html#(tech._error._value._conversion._handler)","<i>error value conversion\nhandler</i>",false],
["error-bars",">plot/plot.html#(def._((lib._plot/main..ss)._error-bars))",[0,[1,"error-bars"]],["plot"]],
["error-context-display-depth",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..ss)._error-context-display-depth))",[0,[1,"error-context-display-depth"]],["errortrace"]],
["error-display-handler",">reference/exns.html#(def._((quote._~23~25kernel)._error-display-handler))",[0,[1,"error-display-handler"]],["scheme/base","scheme"]],
["error-escape-handler",">reference/exns.html#(def._((quote._~23~25kernel)._error-escape-handler))",[0,[1,"error-escape-handler"]],["scheme/base","scheme"]],
["error-handling-mode",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_614",[0,[6,"error-handling-mode"]],["rnrs/io/ports-6"]],
["error-print-context-length",">reference/exns.html#(def._((quote._~23~25kernel)._error-print-context-length))",[0,[1,"error-print-context-length"]],["scheme/base","scheme"]],
["error-print-source-location",">reference/exns.html#(def._((quote._~23~25kernel)._error-print-source-location))",[0,[1,"error-print-source-location"]],["scheme/base","scheme"]],
["error-print-width",">reference/exns.html#(def._((quote._~23~25kernel)._error-print-width))",[0,[1,"error-print-width"]],["scheme/base","scheme"]],
["error-value->string-handler",">reference/exns.html#(def._((quote._~23~25kernel)._error-value-~3estring-handler))",[0,[1,"error-value-&gt;string-handler"]],["scheme/base","scheme"]],
["error?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_430",[0,[1,"error?"]],["rnrs/conditions-6"]],
["error?",">mysterx/html-events.html#(meth._(((lib._mysterx/main..ss)._mx-event~3c~25~3e)._error~3f))",[[0,[1,"error?"]],[12,[" (method of ",[0,[1,"mx-event&lt;%&gt;"]],")"]]],["mysterx"]],
["errors",">mzcom/index.html#(part._.Errors)","Errors",false],
["errors",">drscheme/interactions-window.html#(part._.Errors)","Errors",false],
["errors",">framework/Test.html#(part._test~3aerrors)","Errors",false],
["errortrace",">errortrace/using-errortrace.html",[14,[0,"errortrace"]],"module"],
["errortrace library",">errortrace/errortrace-library.html","Errortrace Library",false],
["errortrace-annotate",">errortrace/errortrace-library.html#(def._((lib._errortrace/errortrace-lib..ss)._errortrace-annotate))",[0,[1,"errortrace-annotate"]],["errortrace/errortrace-lib"]],
["errortrace-compile-handler",">errortrace/errortrace-library.html#(def._((lib._errortrace/errortrace-lib..ss)._errortrace-compile-handler))",[0,[1,"errortrace-compile-handler"]],["errortrace/errortrace-lib"]],
["errortrace-error-display-handler",">errortrace/errortrace-library.html#(def._((lib._errortrace/errortrace-lib..ss)._errortrace-error-display-handler))",[0,[1,"errortrace-error-display-handler"]],["errortrace/errortrace-lib"]],
["errortrace/errortrace-lib",">errortrace/errortrace-library.html",[14,[0,"errortrace/errortrace-lib"]],"module"],
["errortrace/stacktrace",">errortrace/stacktrace.html",[14,[0,"errortrace/stacktrace"]],"module"],
["errortrace: debugging and profiling",">errortrace/index.html","<b>Errortrace</b>: Debugging and Profiling",false],
["escape",">gui/key-event_.html#(idx._(gentag._62._(lib._scribblings/gui/gui..scrbl)))",[7,"'escape"],false],
["escape continuation",">reference/eval-model.html#(tech._escape._continuation)","<i>escape continuation</i>",false],
["essentials of programming languages language",">eopl/index.html","<i>Essentials of Programming Languages</i> Language",false],
["eternal",">foreign/foreign_pointer-funcs.html#(idx._(gentag._8._(lib._scribblings/foreign/foreign..scrbl)))",[7,"'eternal"],false],
["eval",">guide/eval.html",[0,[1,"eval"]],false],
["eval",">reference/Evaluation_and_Compilation.html#(def._((quote._~23~25kernel)._eval))",[0,[1,"eval"]],["scheme/base","scheme"]],
["eval",">r5rs-std/r5rs-Z-H-9.html#%_idx_600",[0,[1,"eval"]],["r5rs"]],
["eval",">r6rs-lib-std/r6rs-lib-Z-H-17.html#node_idx_1266",[0,[1,"eval"]],["rnrs/eval-6"]],
["eval com method",">mzcom/index.html#(idx._(gentag._1._(lib._mzcom/mzcom..scrbl)))",[[5,"Eval"]," COM method"],false],
["eval-compile-prefix",">mzc/Scheme_API_for_Compilation.html#(sig-val._((lib._compiler/sig..ss)._compiler~3ainner~5e._eval-compile-prefix))",[0,[1,"eval-compile-prefix"]],["compiler/sig"]],
["eval-compile-time-part-of-top-level",">syntax/toplevel.html#(def._((lib._syntax/toplevel..ss)._eval-compile-time-part-of-top-level))",[0,[1,"eval-compile-time-part-of-top-level"]],["syntax/toplevel"]],
["eval-compile-time-part-of-top-level/compile",">syntax/toplevel.html#(def._((lib._syntax/toplevel..ss)._eval-compile-time-part-of-top-level/compile))",[0,[1,"eval-compile-time-part-of-top-level/compile"]],["syntax/toplevel"]],
["eval-jit-enabled",">reference/Evaluation_and_Compilation.html#(def._((quote._~23~25kernel)._eval-jit-enabled))",[0,[1,"eval-jit-enabled"]],["scheme/base","scheme"]],
["eval-scheme-string",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-text-mixin)._eval-scheme-string))",[[0,[1,"eval-scheme-string"]],[12,[" (method of ",[0,[1,"hyper-text-mixin"]],")"]]],["browser"]],
["eval-string",">mzlib/mzlib_string.html#(def._((lib._mzlib/string..ss)._eval-string))",[0,[1,"eval-string"]],["mzlib/string"]],
["eval-syntax",">reference/Evaluation_and_Compilation.html#(def._((quote._~23~25kernel)._eval-syntax))",[0,[1,"eval-syntax"]],["scheme/base","scheme"]],
["evaluating expressions",">drscheme/interactions-window.html#(idx._(gentag._24._(lib._scribblings/drscheme/drscheme..scrbl)))","evaluating expressions",false],
["evaluation",">inside/Evaluation.html","Evaluation",false],
["evaluation and compilation",">reference/Evaluation_and_Compilation.html","Evaluation and Compilation",false],
["evaluation and examples",">scribble/eval.html","Evaluation and Examples",false],
["evaluation functions",">inside/Evaluation.html#(part._.Evaluation_.Functions)","Evaluation Functions",false],
["evaluation handler",">reference/Evaluation_and_Compilation.html#(tech._evaluation._handler)","<i>evaluation handler</i>",false],
["evaluation model",">reference/eval-model.html","Evaluation Model",false],
["evaluation order",">reference/application.html","evaluation order",false],
["evaluation order and arity",">guide/application.html#(part._.Evaluation_.Order_and_.Arity)","Evaluation Order and Arity",false],
["evaluation thread",">mzcom/index.html#(part._.Evaluation_thread)","Evaluation thread",false],
["evcase",">mzlib/mzlib_etc.html#(form._((lib._mzlib/etc..ss)._evcase))",[0,[6,"evcase"]],["mzlib/etc"]],
["even?",">reference/numbers.html#(def._((quote._~23~25kernel)._even~3f))",[0,[1,"even?"]],["scheme/base","scheme"]],
["even?",">r5rs-std/r5rs-Z-H-9.html#%_idx_276",[0,[1,"even?"]],["r5rs"]],
["even?",">r6rs-std/r6rs-Z-H-14.html#node_idx_482",[0,[1,"even?"]],["rnrs/base-6"]],
["even?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._even~3f))",[0,[1,"even?"]],["lang/htdp-advanced"]],
["even?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._even~3f))",[0,[1,"even?"]],["lang/htdp-beginner"]],
["even?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._even~3f))",[0,[1,"even?"]],["lang/htdp-beginner-abbr"]],
["even?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._even~3f))",[0,[1,"even?"]],["lang/htdp-intermediate"]],
["even?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._even~3f))",[0,[1,"even?"]],["lang/htdp-intermediate-lambda"]],
["event dispatching and eventspaces",">gui/windowing-overview.html#(part._eventspaceinfo)","Event Dispatching and Eventspaces",false],
["event queue",">gui/windowing-overview.html#(tech._event._queue)","<i>event queue</i>",false],
["event types and priorities",">gui/windowing-overview.html#(part._.Event_.Types_and_.Priorities)","Event Types and Priorities",false],
["event%",">gui/event_.html",[0,[1,"event%"]],["scheme/gui/base","scheme/gui"]],
["event-dispatch-handler",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._event-dispatch-handler))",[0,[1,"event-dispatch-handler"]],["scheme/gui/base","scheme/gui"]],
["event-receiver",">frtime/index.html#(def._((lib._frtime/main..ss)._event-receiver))",[0,[1,"event-receiver"]],["frtime"]],
["event?",">frtime/index.html#(def._((lib._frtime/main..ss)._event~3f))",[0,[1,"event?"]],["frtime"]],
["events timer",">gui/windowing-overview.html#(idx._(gentag._12._(lib._scribblings/gui/gui..scrbl)))","events, timer",false],
["events explicitly queued",">gui/windowing-overview.html#(idx._(gentag._11._(lib._scribblings/gui/gui..scrbl)))","events, explicitly queued",false],
["events dispatching",">gui/windowing-overview.html#(idx._(gentag._9._(lib._scribblings/gui/gui..scrbl)))","events, dispatching",false],
["events delivery",">gui/windowing-overview.html#(idx._(gentag._7._(lib._scribblings/gui/gui..scrbl)))","events, delivery",false],
["events",">mzcom/index.html#(part._.Events)","Events",false],
["events",">reference/sync.html","Events",false],
["eventspace",">gui/windowing-overview.html#(tech._eventspace)","<i>eventspace</i>",false],
["eventspace-handler-thread",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._eventspace-handler-thread))",[0,[1,"eventspace-handler-thread"]],["scheme/gui/base","scheme/gui"]],
["eventspace-shutdown?",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._eventspace-shutdown~3f))",[0,[1,"eventspace-shutdown?"]],["scheme/gui/base","scheme/gui"]],
["eventspace?",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._eventspace~3f))",[0,[1,"eventspace?"]],["scheme/gui/base","scheme/gui"]],
["eventspaces",">gui/Windowing_Functions.html#(part._eventspace-funcs)","Eventspaces",false],
["eventspaces and threads",">gui/windowing-overview.html#(part._espacethreads)","Eventspaces and Threads",false],
["every",">srfi-std/srfi-1.html#every",[0,[1,"every"]],["srfi/1"]],
["every?-ec",">srfi-std/srfi-42.html#every?-ec",[0,[6,"every?-ec"]],["srfi/42"]],
["evt?",">reference/sync.html#(def._((quote._~23~25kernel)._evt~3f))",[0,[1,"evt?"]],["scheme/base","scheme"]],
["exact",">r6rs-std/r6rs-Z-H-14.html#node_idx_462",[0,[1,"exact"]],["rnrs/base-6"]],
["exact",">reference/subprocess.html#(idx._(gentag._266._(lib._scribblings/reference/reference..scrbl)))",[7,"'exact"],false],
["exact number",">reference/numbers.html#(tech._exact._number)","<i>exact number</i>",false],
["exact->inexact",">reference/numbers.html#(def._((quote._~23~25kernel)._exact-~3einexact))",[0,[1,"exact-&gt;inexact"]],["scheme/base","scheme"]],
["exact->inexact",">r5rs-std/r5rs-Z-H-9.html#%_idx_360",[0,[1,"exact-&gt;inexact"]],["r5rs"]],
["exact->inexact",">r6rs-lib-std/r6rs-lib-Z-H-20.html#node_idx_1286",[0,[1,"exact-&gt;inexact"]],["rnrs/r5rs-6"]],
["exact->inexact",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._exact-~3einexact))",[0,[1,"exact-&gt;inexact"]],["lang/htdp-advanced"]],
["exact->inexact",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._exact-~3einexact))",[0,[1,"exact-&gt;inexact"]],["lang/htdp-beginner"]],
["exact->inexact",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._exact-~3einexact))",[0,[1,"exact-&gt;inexact"]],["lang/htdp-beginner-abbr"]],
["exact->inexact",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._exact-~3einexact))",[0,[1,"exact-&gt;inexact"]],["lang/htdp-intermediate"]],
["exact->inexact",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._exact-~3einexact))",[0,[1,"exact-&gt;inexact"]],["lang/htdp-intermediate-lambda"]],
["exact-integer-sqrt",">r6rs-std/r6rs-Z-H-14.html#node_idx_562",[0,[1,"exact-integer-sqrt"]],["rnrs/base-6"]],
["exact-integer?",">reference/numbers.html#(def._((quote._~23~25kernel)._exact-integer~3f))",[0,[1,"exact-integer?"]],["scheme/base","scheme"]],
["exact-nonnegative-integer?",">reference/numbers.html#(def._((quote._~23~25kernel)._exact-nonnegative-integer~3f))",[0,[1,"exact-nonnegative-integer?"]],["scheme/base","scheme"]],
["exact-positive-integer?",">reference/numbers.html#(def._((quote._~23~25kernel)._exact-positive-integer~3f))",[0,[1,"exact-positive-integer?"]],["scheme/base","scheme"]],
["exact?",">reference/numbers.html#(def._((quote._~23~25kernel)._exact~3f))",[0,[1,"exact?"]],["scheme/base","scheme"]],
["exact?",">r5rs-std/r5rs-Z-H-9.html#%_idx_254",[0,[1,"exact?"]],["r5rs"]],
["exact?",">r6rs-std/r6rs-Z-H-14.html#node_idx_456",[0,[1,"exact?"]],["rnrs/base-6"]],
["exact?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._exact~3f))",[0,[1,"exact?"]],["lang/htdp-advanced"]],
["exact?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._exact~3f))",[0,[1,"exact?"]],["lang/htdp-beginner"]],
["exact?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._exact~3f))",[0,[1,"exact?"]],["lang/htdp-beginner-abbr"]],
["exact?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._exact~3f))",[0,[1,"exact?"]],["lang/htdp-intermediate"]],
["exact?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._exact~3f))",[0,[1,"exact?"]],["lang/htdp-intermediate-lambda"]],
["example",">html/index.html#(part._.Example)","Example",false],
["example session",">net/pop3.html#(part._.Example_.Session)","Example Session",false],
["examples",">turtles/Traditional_Turtles.html#(part._.Examples)","Examples",false],
["examples",">turtles/Value_Turtles.html#(part._value-examples)","Examples",false],
["examples",">net/cookie.html#(part._cookie-examples)","Examples",false],
["examples",">guide/contracts-examples.html","Examples",false],
["examples",">scribble/eval.html#(form._((lib._scribble/eval..ss)._examples))",[0,[6,"examples"]],["scribble/eval"]],
["except",">reference/creatingunits.html#(form._((lib._mzlib/unit..ss)._except))",[0,[6,"except"]],["scheme/unit","scheme"]],
["except-in",">reference/require.html#(form._((lib._scheme/base..ss)._except-in))",[0,[6,"except-in"]],["scheme/base","scheme"]],
["except-out",">reference/require.html#(form._((lib._scheme/base..ss)._except-out))",[0,[6,"except-out"]],["scheme/base","scheme"]],
["exception",">guide/exns.html#(tech._exception)","<i>exception</i>",false],
["exception functions",">inside/exceptions.html#(part._.Exception_.Functions)","Exception Functions",false],
["exception handler",">reference/eval-model.html#(tech._exception._handler)","<i>exception handler</i>",false],
["exceptions",">net/nntp.html#(part._.Exceptions)","Exceptions",false],
["exceptions",">net/mime.html#(part._mime-exns)","Exceptions",false],
["exceptions",">net/pop3.html#(part._pop3-exns)","Exceptions",false],
["exceptions",">net/qp.html#(part._qp-exn)","Exceptions",false],
["exceptions",">guide/exns.html","Exceptions",false],
["exceptions",">reference/eval-model.html#(part._exn-model)","Exceptions",false],
["exceptions",">reference/exns.html","Exceptions",false],
["exceptions",">web-server/util_ss.html#(part._.Exceptions)","Exceptions",false],
["exceptions",">reference/eval-model.html#(tech._exception)","<i>Exceptions</i>",false],
["exceptions and continuation jumps",">gui/windowing-overview.html#(part._evtcontjump)","Exceptions and Continuation Jumps",false],
["exceptions and control",">guide/control.html","Exceptions and Control",false],
["exceptions and escape continuations",">inside/exceptions.html","Exceptions and Escape Continuations",false],
["exec",">scribble/doc-strings.html#(def._((lib._scribble/manual..ss)._exec))",[0,[1,"exec"]],["scribble/manual"]],
["exec-file",">reference/Filesystem.html#(idx._(gentag._258._(lib._scribblings/reference/reference..scrbl)))",[7,"'exec-file"],false],
["executable creation signature",">mzc/exe.html#(part._.Executable_.Creation_.Signature)","Executable Creation Signature",false],
["executable creation unit",">mzc/exe.html#(part._.Executable_.Creation_.Unit)","Executable Creation Unit",false],
["execute",">reference/securityguards.html#(idx._(gentag._205._(lib._scribblings/reference/reference..scrbl)))",[7,"'execute"],false],
["execute",">reference/Filesystem.html#(idx._(gentag._265._(lib._scribblings/reference/reference..scrbl)))",[7,"'execute"],false],
["execute",">gui/key-event_.html#(idx._(gentag._65._(lib._scribblings/gui/gui..scrbl)))",[7,"'execute"],false],
["execute-callback",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._execute-callback))",[[0,[1,"execute-callback"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["execute-counts-enabled",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..ss)._execute-counts-enabled))",[0,[1,"execute-counts-enabled"]],["errortrace"]],
["exists",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_206",[0,[1,"exists"]],["rnrs/lists-6"]],
["exists",">reference/securityguards.html#(idx._(gentag._207._(lib._scribblings/reference/reference..scrbl)))",[7,"'exists"],false],
["exists-binding?",">continue/index.html#(def._((lib._web-server/servlet..ss)._exists-binding~3f))",[0,[1,"exists-binding?"]],[]],
["exists-binding?",">web-server/bindings_ss.html#(def._((lib._web-server/servlet/bindings..ss)._exists-binding~3f))",[0,[1,"exists-binding?"]],["web-server/servlet/bindings"]],
["exit",">framework/Exit.html","Exit",false],
["exit",">reference/Exiting.html#(def._((quote._~23~25kernel)._exit))",[0,[1,"exit"]],["scheme/base","scheme"]],
["exit",">r6rs-lib-std/r6rs-lib-Z-H-11.html#node_idx_846",[0,[1,"exit"]],["rnrs/programs-6"]],
["exit",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._exit))",[0,[1,"exit"]],["lang/htdp-advanced"]],
["exit",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._exit))",[0,[1,"exit"]],["lang/htdp-beginner"]],
["exit",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._exit))",[0,[1,"exit"]],["lang/htdp-beginner-abbr"]],
["exit",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._exit))",[0,[1,"exit"]],["lang/htdp-intermediate"]],
["exit",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._exit))",[0,[1,"exit"]],["lang/htdp-intermediate-lambda"]],
["exit handler",">reference/Exiting.html#(tech._exit._handler)","<i>exit handler</i>",false],
["exit status",">reference/running-sa.html#(part._exit-status)","Exit Status",false],
["exit-handler",">reference/Exiting.html#(def._((quote._~23~25kernel)._exit-handler))",[0,[1,"exit-handler"]],["scheme/base","scheme"]],
["exit:can-exit?",">framework/Exit.html#(def._((lib._framework/main..ss)._exit~3acan-exit~3f))",[0,[1,"exit:can-exit?"]],["framework"]],
["exit:exit",">framework/Exit.html#(def._((lib._framework/main..ss)._exit~3aexit))",[0,[1,"exit:exit"]],["framework"]],
["exit:exiting?",">framework/Exit.html#(def._((lib._framework/main..ss)._exit~3aexiting~3f))",[0,[1,"exit:exiting?"]],["framework"]],
["exit:insert-can?-callback",">framework/Exit.html#(def._((lib._framework/main..ss)._exit~3ainsert-can~3f-callback))",[0,[1,"exit:insert-can?-callback"]],["framework"]],
["exit:insert-on-callback",">framework/Exit.html#(def._((lib._framework/main..ss)._exit~3ainsert-on-callback))",[0,[1,"exit:insert-on-callback"]],["framework"]],
["exit:on-exit",">framework/Exit.html#(def._((lib._framework/main..ss)._exit~3aon-exit))",[0,[1,"exit:on-exit"]],["framework"]],
["exit:set-exiting",">framework/Exit.html#(def._((lib._framework/main..ss)._exit~3aset-exiting))",[0,[1,"exit:set-exiting"]],["framework"]],
["exit:user-oks-exit",">framework/Exit.html#(def._((lib._framework/main..ss)._exit~3auser-oks-exit))",[0,[1,"exit:user-oks-exit"]],["framework"]],
["exiting",">reference/Exiting.html","Exiting",false],
["exn",">reference/exns.html#(def._((quote._~23~25kernel)._exn))",[0,[1,"exn"]],["scheme/base","scheme"]],
["exn->string",">web-server/util_ss.html#(def._((lib._web-server/private/util..ss)._exn-~3estring))",[0,[1,"exn-&gt;string"]],["web-server/private/util"]],
["exn-continuation-marks",">reference/exns.html#(def._((quote._~23~25kernel)._exn-continuation-marks))",[0,[1,"exn-continuation-marks"]],["scheme/base","scheme"]],
["exn-message",">reference/exns.html#(def._((quote._~23~25kernel)._exn-message))",[0,[1,"exn-message"]],["scheme/base","scheme"]],
["exn:break",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3abreak))",[0,[1,"exn:break"]],["scheme/base","scheme"]],
["exn:break-continuation",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3abreak-continuation))",[0,[1,"exn:break-continuation"]],["scheme/base","scheme"]],
["exn:break?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3abreak~3f))",[0,[1,"exn:break?"]],["scheme/base","scheme"]],
["exn:dispatcher",">web-server/dispatch_ss.html#(def._((lib._web-server/dispatchers/dispatch..ss)._exn~3adispatcher))",[0,[1,"exn:dispatcher"]],["web-server/dispatchers/dispatch"]],
["exn:dispatcher?",">web-server/dispatch_ss.html#(def._((lib._web-server/dispatchers/dispatch..ss)._exn~3adispatcher~3f))",[0,[1,"exn:dispatcher?"]],["web-server/dispatchers/dispatch"]],
["exn:fail",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail))",[0,[1,"exn:fail"]],["scheme/base","scheme"]],
["exn:fail:contract",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3acontract))",[0,[1,"exn:fail:contract"]],["scheme/base","scheme"]],
["exn:fail:contract:arity",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3acontract~3aarity))",[0,[1,"exn:fail:contract:arity"]],["scheme/base","scheme"]],
["exn:fail:contract:arity?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3acontract~3aarity~3f))",[0,[1,"exn:fail:contract:arity?"]],["scheme/base","scheme"]],
["exn:fail:contract:continuation",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3acontract~3acontinuation))",[0,[1,"exn:fail:contract:continuation"]],["scheme/base","scheme"]],
["exn:fail:contract:continuation?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3acontract~3acontinuation~3f))",[0,[1,"exn:fail:contract:continuation?"]],["scheme/base","scheme"]],
["exn:fail:contract:divide-by-zero",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3acontract~3adivide-by-zero))",[0,[1,"exn:fail:contract:divide-by-zero"]],["scheme/base","scheme"]],
["exn:fail:contract:divide-by-zero?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3acontract~3adivide-by-zero~3f))",[0,[1,"exn:fail:contract:divide-by-zero?"]],["scheme/base","scheme"]],
["exn:fail:contract:variable",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3acontract~3avariable))",[0,[1,"exn:fail:contract:variable"]],["scheme/base","scheme"]],
["exn:fail:contract:variable-id",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3acontract~3avariable-id))",[0,[1,"exn:fail:contract:variable-id"]],["scheme/base","scheme"]],
["exn:fail:contract:variable?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3acontract~3avariable~3f))",[0,[1,"exn:fail:contract:variable?"]],["scheme/base","scheme"]],
["exn:fail:contract?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3acontract~3f))",[0,[1,"exn:fail:contract?"]],["scheme/base","scheme"]],
["exn:fail:filesystem",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3afilesystem))",[0,[1,"exn:fail:filesystem"]],["scheme/base","scheme"]],
["exn:fail:filesystem:exists",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3afilesystem~3aexists))",[0,[1,"exn:fail:filesystem:exists"]],["scheme/base","scheme"]],
["exn:fail:filesystem:exists?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3afilesystem~3aexists~3f))",[0,[1,"exn:fail:filesystem:exists?"]],["scheme/base","scheme"]],
["exn:fail:filesystem:version",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3afilesystem~3aversion))",[0,[1,"exn:fail:filesystem:version"]],["scheme/base","scheme"]],
["exn:fail:filesystem:version?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3afilesystem~3aversion~3f))",[0,[1,"exn:fail:filesystem:version?"]],["scheme/base","scheme"]],
["exn:fail:filesystem?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3afilesystem~3f))",[0,[1,"exn:fail:filesystem?"]],["scheme/base","scheme"]],
["exn:fail:make",">make/make.html#(def._((lib._make/main..ss)._exn~3afail~3amake))",[0,[1,"exn:fail:make"]],["make"]],
["exn:fail:make-orig-exn",">make/make.html#(def._((lib._make/main..ss)._exn~3afail~3amake-orig-exn))",[0,[1,"exn:fail:make-orig-exn"]],["make"]],
["exn:fail:make-targets",">make/make.html#(def._((lib._make/main..ss)._exn~3afail~3amake-targets))",[0,[1,"exn:fail:make-targets"]],["make"]],
["exn:fail:make?",">make/make.html#(def._((lib._make/main..ss)._exn~3afail~3amake~3f))",[0,[1,"exn:fail:make?"]],["make"]],
["exn:fail:network",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3anetwork))",[0,[1,"exn:fail:network"]],["scheme/base","scheme"]],
["exn:fail:network?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3anetwork~3f))",[0,[1,"exn:fail:network?"]],["scheme/base","scheme"]],
["exn:fail:object",">reference/objectutils.html#(def._((lib._scheme/private/class-internal..ss)._exn~3afail~3aobject))",[0,[1,"exn:fail:object"]],["scheme/class","scheme"]],
["exn:fail:object?",">reference/objectutils.html#(def._((lib._scheme/private/class-internal..ss)._exn~3afail~3aobject~3f))",[0,[1,"exn:fail:object?"]],["scheme/class","scheme"]],
["exn:fail:out-of-memory",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3aout-of-memory))",[0,[1,"exn:fail:out-of-memory"]],["scheme/base","scheme"]],
["exn:fail:out-of-memory?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3aout-of-memory~3f))",[0,[1,"exn:fail:out-of-memory?"]],["scheme/base","scheme"]],
["exn:fail:read",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3aread))",[0,[1,"exn:fail:read"]],["scheme/base","scheme"]],
["exn:fail:read-srclocs",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3aread-srclocs))",[0,[1,"exn:fail:read-srclocs"]],["scheme/base","scheme"]],
["exn:fail:read:eof",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3aread~3aeof))",[0,[1,"exn:fail:read:eof"]],["scheme/base","scheme"]],
["exn:fail:read:eof?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3aread~3aeof~3f))",[0,[1,"exn:fail:read:eof?"]],["scheme/base","scheme"]],
["exn:fail:read:non-char",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3aread~3anon-char))",[0,[1,"exn:fail:read:non-char"]],["scheme/base","scheme"]],
["exn:fail:read:non-char?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3aread~3anon-char~3f))",[0,[1,"exn:fail:read:non-char?"]],["scheme/base","scheme"]],
["exn:fail:read?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3aread~3f))",[0,[1,"exn:fail:read?"]],["scheme/base","scheme"]],
["exn:fail:redex?",">redex/Terms.html#(def._((lib._redex/main..ss)._exn~3afail~3aredex~3f))",[0,[1,"exn:fail:redex?"]],["redex"]],
["exn:fail:resource-resource",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._exn~3afail~3aresource-resource))",[0,[1,"exn:fail:resource-resource"]],["scheme/sandbox"]],
["exn:fail:resource?",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._exn~3afail~3aresource~3f))",[0,[1,"exn:fail:resource?"]],["scheme/sandbox"]],
["exn:fail:servlet-manager:no-continuation",">web-server/manager_ss.html#(def._((lib._web-server/managers/manager..ss)._exn~3afail~3aservlet-manager~3ano-continuation))",[0,[1,"exn:fail:servlet-manager:no-continuation"]],["web-server/managers/manager"]],
["exn:fail:servlet-manager:no-continuation-expiration-handler",">web-server/manager_ss.html#(def._((lib._web-server/managers/manager..ss)._exn~3afail~3aservlet-manager~3ano-continuation-expiration-handler))",[0,[1,"exn:fail:servlet-manager:no-continuation-expiration-handler"]],["web-server/managers/manager"]],
["exn:fail:servlet-manager:no-continuation?",">web-server/manager_ss.html#(def._((lib._web-server/managers/manager..ss)._exn~3afail~3aservlet-manager~3ano-continuation~3f))",[0,[1,"exn:fail:servlet-manager:no-continuation?"]],["web-server/managers/manager"]],
["exn:fail:servlet-manager:no-instance",">web-server/manager_ss.html#(def._((lib._web-server/managers/manager..ss)._exn~3afail~3aservlet-manager~3ano-instance))",[0,[1,"exn:fail:servlet-manager:no-instance"]],["web-server/managers/manager"]],
["exn:fail:servlet-manager:no-instance-expiration-handler",">web-server/manager_ss.html#(def._((lib._web-server/managers/manager..ss)._exn~3afail~3aservlet-manager~3ano-instance-expiration-handler))",[0,[1,"exn:fail:servlet-manager:no-instance-expiration-handler"]],["web-server/managers/manager"]],
["exn:fail:servlet-manager:no-instance?",">web-server/manager_ss.html#(def._((lib._web-server/managers/manager..ss)._exn~3afail~3aservlet-manager~3ano-instance~3f))",[0,[1,"exn:fail:servlet-manager:no-instance?"]],["web-server/managers/manager"]],
["exn:fail:syntax",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3asyntax))",[0,[1,"exn:fail:syntax"]],["scheme/base","scheme"]],
["exn:fail:syntax-exprs",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3asyntax-exprs))",[0,[1,"exn:fail:syntax-exprs"]],["scheme/base","scheme"]],
["exn:fail:syntax?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3asyntax~3f))",[0,[1,"exn:fail:syntax?"]],["scheme/base","scheme"]],
["exn:fail:unsupported",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3aunsupported))",[0,[1,"exn:fail:unsupported"]],["scheme/base","scheme"]],
["exn:fail:unsupported?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3aunsupported~3f))",[0,[1,"exn:fail:unsupported?"]],["scheme/base","scheme"]],
["exn:fail:user",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3auser))",[0,[1,"exn:fail:user"]],["scheme/base","scheme"]],
["exn:fail:user?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3auser~3f))",[0,[1,"exn:fail:user?"]],["scheme/base","scheme"]],
["exn:fail?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3afail~3f))",[0,[1,"exn:fail?"]],["scheme/base","scheme"]],
["exn:get-module-code",">syntax/module-helpers.html#(def._((lib._syntax/modcode..ss)._exn~3aget-module-code))",[0,[1,"exn:get-module-code"]],["syntax/modcode"]],
["exn:get-module-code-path",">syntax/module-helpers.html#(def._((lib._syntax/modcode..ss)._exn~3aget-module-code-path))",[0,[1,"exn:get-module-code-path"]],["syntax/modcode"]],
["exn:get-module-code?",">syntax/module-helpers.html#(def._((lib._syntax/modcode..ss)._exn~3aget-module-code~3f))",[0,[1,"exn:get-module-code?"]],["syntax/modcode"]],
["exn:invalid-xexpr",">xml/index.html#(def._((lib._xml/main..ss)._exn~3ainvalid-xexpr))",[0,[1,"exn:invalid-xexpr"]],["xml"]],
["exn:invalid-xexpr-code",">xml/index.html#(def._((lib._xml/main..ss)._exn~3ainvalid-xexpr-code))",[0,[1,"exn:invalid-xexpr-code"]],["xml"]],
["exn:invalid-xexpr?",">xml/index.html#(def._((lib._xml/main..ss)._exn~3ainvalid-xexpr~3f))",[0,[1,"exn:invalid-xexpr?"]],["xml"]],
["exn:make-unknown-preference",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..ss)._exn~3amake-unknown-preference))",[0,[1,"exn:make-unknown-preference"]],["framework/preferences"]],
["exn:srclocs-accessor",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3asrclocs-accessor))",[0,[1,"exn:srclocs-accessor"]],["scheme/base","scheme"]],
["exn:srclocs?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3asrclocs~3f))",[0,[1,"exn:srclocs?"]],["scheme/base","scheme"]],
["exn:unknown-preference",">framework/Preferences__Textual.html#(idx._(gentag._42._(lib._scribblings/framework/framework..scrbl)))","exn:unknown-preference",false],
["exn:unknown-preference",">framework/Preferences__Textual.html#(idx._(gentag._43._(lib._scribblings/framework/framework..scrbl)))","exn:unknown-preference",false],
["exn:unknown-preference",">framework/Preferences__Textual.html#(idx._(gentag._44._(lib._scribblings/framework/framework..scrbl)))","exn:unknown-preference",false],
["exn:unknown-preference?",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..ss)._exn~3aunknown-preference~3f))",[0,[1,"exn:unknown-preference?"]],["framework/preferences"]],
["exn?",">reference/exns.html#(def._((quote._~23~25kernel)._exn~3f))",[0,[1,"exn?"]],["scheme/base","scheme"]],
["exp",">reference/numbers.html#(def._((quote._~23~25kernel)._exp))",[0,[1,"exp"]],["scheme/base","scheme"]],
["exp",">r5rs-std/r5rs-Z-H-9.html#%_idx_326",[0,[1,"exp"]],["r5rs"]],
["exp",">r6rs-std/r6rs-Z-H-14.html#node_idx_540",[0,[1,"exp"]],["rnrs/base-6"]],
["exp",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._exp))",[0,[1,"exp"]],["lang/htdp-advanced"]],
["exp",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._exp))",[0,[1,"exp"]],["lang/htdp-beginner"]],
["exp",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._exp))",[0,[1,"exp"]],["lang/htdp-beginner-abbr"]],
["exp",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._exp))",[0,[1,"exp"]],["lang/htdp-intermediate"]],
["exp",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._exp))",[0,[1,"exp"]],["lang/htdp-intermediate-lambda"]],
["expand",">reference/Expanding_Top-Level_Forms.html#(def._((quote._~23~25kernel)._expand))",[0,[1,"expand"]],["scheme/base","scheme"]],
["expand",">reference/syntax-model.html#(tech._expand)","<i>expand</i>",false],
["expand-export",">reference/stxtrans.html#(def._((lib._scheme/provide-transform..ss)._expand-export))",[0,[1,"expand-export"]],["scheme/provide-transform"]],
["expand-for-compile-variant",">dynext/Compilation.html#(def._((lib._dynext/compile..ss)._expand-for-compile-variant))",[0,[1,"expand-for-compile-variant"]],["dynext/compile"]],
["expand-for-link-variant",">dynext/Linking.html#(def._((lib._dynext/link..ss)._expand-for-link-variant))",[0,[1,"expand-for-link-variant"]],["dynext/link"]],
["expand-import",">reference/stxtrans.html#(def._((lib._scheme/require-transform..ss)._expand-import))",[0,[1,"expand-import"]],["scheme/require-transform"]],
["expand-once",">reference/Expanding_Top-Level_Forms.html#(def._((quote._~23~25kernel)._expand-once))",[0,[1,"expand-once"]],["scheme/base","scheme"]],
["expand-only",">macro-debugger/index.html#(def._((lib._macro-debugger/expand..ss)._expand-only))",[0,[1,"expand-only"]],["macro-debugger/expand"]],
["expand-syntax",">reference/Expanding_Top-Level_Forms.html#(def._((quote._~23~25kernel)._expand-syntax))",[0,[1,"expand-syntax"]],["scheme/base","scheme"]],
["expand-syntax-once",">reference/Expanding_Top-Level_Forms.html#(def._((quote._~23~25kernel)._expand-syntax-once))",[0,[1,"expand-syntax-once"]],["scheme/base","scheme"]],
["expand-syntax-to-top-form",">reference/Expanding_Top-Level_Forms.html#(def._((quote._~23~25kernel)._expand-syntax-to-top-form))",[0,[1,"expand-syntax-to-top-form"]],["scheme/base","scheme"]],
["expand-syntax-top-level-with-compile-time-evals",">syntax/toplevel.html#(def._((lib._syntax/toplevel..ss)._expand-syntax-top-level-with-compile-time-evals))",[0,[1,"expand-syntax-top-level-with-compile-time-evals"]],["syntax/toplevel"]],
["expand-syntax-top-level-with-compile-time-evals/flatten",">syntax/toplevel.html#(def._((lib._syntax/toplevel..ss)._expand-syntax-top-level-with-compile-time-evals/flatten))",[0,[1,"expand-syntax-top-level-with-compile-time-evals/flatten"]],["syntax/toplevel"]],
["expand-to-top-form",">reference/Expanding_Top-Level_Forms.html#(def._((quote._~23~25kernel)._expand-to-top-form))",[0,[1,"expand-to-top-form"]],["scheme/base","scheme"]],
["expand-top-level-with-compile-time-evals",">syntax/toplevel.html#(def._((lib._syntax/toplevel..ss)._expand-top-level-with-compile-time-evals))",[0,[1,"expand-top-level-with-compile-time-evals"]],["syntax/toplevel"]],
["expand-user-path",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._expand-user-path))",[0,[1,"expand-user-path"]],["scheme/base","scheme"]],
["expand/hide",">macro-debugger/index.html#(def._((lib._macro-debugger/expand..ss)._expand/hide))",[0,[1,"expand/hide"]],["macro-debugger/expand"]],
["expand/show-predicate",">macro-debugger/index.html#(def._((lib._macro-debugger/expand..ss)._expand/show-predicate))",[0,[1,"expand/show-predicate"]],["macro-debugger/expand"]],
["expand/step",">macro-debugger/index.html#(def._((lib._macro-debugger/stepper..ss)._expand/step))",[0,[1,"expand/step"]],["macro-debugger/stepper"]],
["expand/step-text",">macro-debugger/index.html#(def._((lib._macro-debugger/stepper-text..ss)._expand/step-text))",[0,[1,"expand/step-text"]],["macro-debugger/stepper-text"]],
["expanding define-struct-like forms",">syntax/transformer-helpers.html#(part._struct)",["Expanding ",[0,[6,"define-struct"]],"-like Forms"],false],
["expanding the user's program text and breaking",">tools/Expanding_and_Breaking.html","Expanding the User&rsquo;s Program Text and Breaking",false],
["expanding top-level forms",">reference/Expanding_Top-Level_Forms.html","Expanding Top-Level Forms",false],
["expanding user programs",">tools/Expanding_and_Breaking.html#(idx._(gentag._9._(lib._scribblings/tools/tools..scrbl)))","expanding user programs",false],
["expands",">guide/macros.html#(tech._expand)","<i>expands</i>",false],
["expansion",">reference/syntax-model.html#(tech._expansion)","<i>Expansion</i>",false],
["expansion (parsing)",">reference/syntax-model.html#(part._expansion)","Expansion (Parsing)",false],
["expansion context",">reference/syntax-model.html#(part._expand-context-model)","Expansion Context",false],
["expansion steps",">reference/syntax-model.html#(part._expand-steps)","Expansion Steps",false],
["experimenting with examples",">guide/contract-boundaries.html#(part._.Experimenting_with_examples)","Experimenting with examples",false],
["expiration-handler/c",">web-server/servlet-structs_ss.html#(def._((lib._web-server/servlet/servlet-structs..ss)._expiration-handler/c))",[0,[1,"expiration-handler/c"]],["web-server/servlet/servlet-structs"]],
["explicitly queued events",">gui/windowing-overview.html#(tech._explicitly._queued._event)","<i>Explicitly queued events</i>",false],
["explode-path",">reference/More_Path_Utilities.html#(def._((lib._scheme/path..ss)._explode-path))",[0,[1,"explode-path"]],["scheme/path","scheme"]],
["explode-path*",">web-server/util_ss.html#(def._((lib._web-server/private/util..ss)._explode-path*))",[0,[1,"explode-path*"]],["web-server/private/util"]],
["export",">reference/stxtrans.html#(def._((lib._scheme/provide-transform..ss)._export))",[0,[1,"export"]],["scheme/provide-transform"]],
["export",">reference/creatingunits.html#(form._((lib._mzlib/unit..ss)._export))",[0,[6,"export"]],["scheme/unit","scheme"]],
["export-local-id",">reference/stxtrans.html#(def._((lib._scheme/provide-transform..ss)._export-local-id))",[0,[1,"export-local-id"]],["scheme/provide-transform"]],
["export-mode",">reference/stxtrans.html#(def._((lib._scheme/provide-transform..ss)._export-mode))",[0,[1,"export-mode"]],["scheme/provide-transform"]],
["export-orig-stx",">reference/stxtrans.html#(def._((lib._scheme/provide-transform..ss)._export-orig-stx))",[0,[1,"export-orig-stx"]],["scheme/provide-transform"]],
["export-out-sym",">reference/stxtrans.html#(def._((lib._scheme/provide-transform..ss)._export-out-sym))",[0,[1,"export-out-sym"]],["scheme/provide-transform"]],
["export-protect?",">reference/stxtrans.html#(def._((lib._scheme/provide-transform..ss)._export-protect~3f))",[0,[1,"export-protect?"]],["scheme/provide-transform"]],
["export?",">reference/stxtrans.html#(def._((lib._scheme/provide-transform..ss)._export~3f))",[0,[1,"export?"]],["scheme/provide-transform"]],
["exported-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._exported-index-desc))",[0,[1,"exported-index-desc"]],["scribble/manual-struct"]],
["exported-index-desc-from-libs",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._exported-index-desc-from-libs))",[0,[1,"exported-index-desc-from-libs"]],["scribble/manual-struct"]],
["exported-index-desc-name",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._exported-index-desc-name))",[0,[1,"exported-index-desc-name"]],["scribble/manual-struct"]],
["exported-index-desc?",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._exported-index-desc~3f))",[0,[1,"exported-index-desc?"]],["scribble/manual-struct"]],
["exports: provide",">guide/module-provide.html",["Exports: ",[0,[6,"provide"]]],false],
["expr->string",">mzlib/mzlib_string.html#(def._((lib._mzlib/string..ss)._expr-~3estring))",[0,[1,"expr-&gt;string"]],["mzlib/string"]],
["expression",">htdc/Expression.html",[0,"Expression"],false],
["expression",">htdc/advanced_expr.html",[0,"Expression"],false],
["expression",">htdc/intermed_expr.html",[0,"Expression"],false],
["expression",">htdc/intermedAcc_expr.html",[0,"Expression"],false],
["expression context",">reference/syntax-model.html#(tech._expression._context)","<i>expression context</i>",false],
["expression wrapper: #%expression",">reference/__expression.html",["Expression Wrapper: ",[0,[6,"#%expression"]]],false],
["expressions and definitions",">guide/scheme-forms.html","Expressions and Definitions",false],
["expt",">reference/numbers.html#(def._((quote._~23~25kernel)._expt))",[0,[1,"expt"]],["scheme/base","scheme"]],
["expt",">r5rs-std/r5rs-Z-H-9.html#%_idx_346",[0,[1,"expt"]],["r5rs"]],
["expt",">r6rs-std/r6rs-Z-H-14.html#node_idx_564",[0,[1,"expt"]],["rnrs/base-6"]],
["expt",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._expt))",[0,[1,"expt"]],["lang/htdp-advanced"]],
["expt",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._expt))",[0,[1,"expt"]],["lang/htdp-beginner"]],
["expt",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._expt))",[0,[1,"expt"]],["lang/htdp-beginner-abbr"]],
["expt",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._expt))",[0,[1,"expt"]],["lang/htdp-intermediate"]],
["expt",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._expt))",[0,[1,"expt"]],["lang/htdp-intermediate-lambda"]],
["extend",">reference/mzlib_class.html#(tech._extend)","<i>extend</i>",false],
["extend-language-show-union",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._extend-language-show-union))",[0,[1,"extend-language-show-union"]],["redex/pict"]],
["extend-reduction-relation",">redex/Reduction_Relations.html#(form._((lib._redex/main..ss)._extend-reduction-relation))",[0,[6,"extend-reduction-relation"]],["redex"]],
["extended",">gui/Windowing_Functions.html#(idx._(gentag._148._(lib._scribblings/gui/gui..scrbl)))",[7,"'extended"],false],
["extended example: call-by-reference functions",">guide/pattern-macros.html#(part._pattern-macro-example)","Extended Example: Call-by-Reference Functions",false],
["extended-format",">web-server/dispatch-log_ss.html#(def._((lib._web-server/dispatchers/dispatch-log..ss)._extended-format))",[0,[1,"extended-format"]],["web-server/dispatchers/dispatch-log"]],
["extending drscheme",">drscheme/extending-drscheme.html","Extending DrScheme",false],
["extending match",">reference/match.html#(part._.Extending_match)",["Extending ",[0,[6,"match"]]],false],
["extending mzscheme",">inside/overview.html#(idx._(gentag._2._(lib._scribblings/inside/inside..scrbl)))","extending MzScheme",false],
["extending the existing drscheme classes",">tools/Extending_the_Existing_DrScheme_Classes.html","Extending the Existing DrScheme Classes",false],
["extending the model",">continue/index.html#(part._.Extending_the_.Model)","Extending the Model",false],
["extending the syntax of signatures",">reference/define-sig-form.html","Extending the Syntax of Signatures",false],
["extends",">reference/creatingunits.html#(form._((lib._mzlib/unit..ss)._extends))",[0,[6,"extends"]],["scheme/unit","scheme"]],
["extension-load handler",">reference/Evaluation_and_Compilation.html#(tech._extension._load._handler)","<i>extension-load handler</i>",false],
["external-browser",">net/sendurl.html#(def._((lib._net/sendurl..ss)._external-browser))",[0,[1,"external-browser"]],["net/sendurl"]],
["external-dtd",">xml/index.html#(def._((lib._xml/main..ss)._external-dtd))",[0,[1,"external-dtd"]],["xml"]],
["external-dtd-system",">xml/index.html#(def._((lib._xml/main..ss)._external-dtd-system))",[0,[1,"external-dtd-system"]],["xml"]],
["external-dtd/public",">xml/index.html#(def._((lib._xml/main..ss)._external-dtd/public))",[0,[1,"external-dtd/public"]],["xml"]],
["external-dtd/public-public",">xml/index.html#(def._((lib._xml/main..ss)._external-dtd/public-public))",[0,[1,"external-dtd/public-public"]],["xml"]],
["external-dtd/public?",">xml/index.html#(def._((lib._xml/main..ss)._external-dtd/public~3f))",[0,[1,"external-dtd/public?"]],["xml"]],
["external-dtd/system",">xml/index.html#(def._((lib._xml/main..ss)._external-dtd/system))",[0,[1,"external-dtd/system"]],["xml"]],
["external-dtd/system?",">xml/index.html#(def._((lib._xml/main..ss)._external-dtd/system~3f))",[0,[1,"external-dtd/system?"]],["xml"]],
["external-dtd?",">xml/index.html#(def._((lib._xml/main..ss)._external-dtd~3f))",[0,[1,"external-dtd?"]],["xml"]],
["externalizable<%>",">reference/objectserialize.html#(def._((lib._scheme/private/class-internal..ss)._externalizable~3c~25~3e))",[0,[1,"externalizable&lt;%&gt;"]],["scheme/class","scheme"]],
["extra constants and functions",">reference/numbers.html#(part._.Extra_.Constants_and_.Functions)","Extra Constants and Functions",false],
["extract-addresses",">net/head.html#(def._((lib._net/head..ss)._extract-addresses))",[0,[1,"extract-addresses"]],["net/head"]],
["extract-all-fields",">net/head.html#(def._((lib._net/head..ss)._extract-all-fields))",[0,[1,"extract-all-fields"]],["net/head"]],
["extract-base-filename/c",">dynext/Filenames.html#(def._((lib._dynext/file..ss)._extract-base-filename/c))",[0,[1,"extract-base-filename/c"]],["dynext/file"]],
["extract-base-filename/ext",">dynext/Filenames.html#(def._((lib._dynext/file..ss)._extract-base-filename/ext))",[0,[1,"extract-base-filename/ext"]],["dynext/file"]],
["extract-base-filename/kp",">dynext/Filenames.html#(def._((lib._dynext/file..ss)._extract-base-filename/kp))",[0,[1,"extract-base-filename/kp"]],["dynext/file"]],
["extract-base-filename/o",">dynext/Filenames.html#(def._((lib._dynext/file..ss)._extract-base-filename/o))",[0,[1,"extract-base-filename/o"]],["dynext/file"]],
["extract-base-filename/ss",">dynext/Filenames.html#(def._((lib._dynext/file..ss)._extract-base-filename/ss))",[0,[1,"extract-base-filename/ss"]],["dynext/file"]],
["extract-binding/single",">continue/index.html#(def._((lib._web-server/servlet..ss)._extract-binding/single))",[0,[1,"extract-binding/single"]],[]],
["extract-binding/single",">net/cgi.html#(def._((lib._net/cgi..ss)._extract-binding/single))",[0,[1,"extract-binding/single"]],["net/cgi"]],
["extract-binding/single",">web-server/bindings_ss.html#(def._((lib._web-server/servlet/bindings..ss)._extract-binding/single))",[0,[1,"extract-binding/single"]],["web-server/servlet/bindings"]],
["extract-bindings",">net/cgi.html#(def._((lib._net/cgi..ss)._extract-bindings))",[0,[1,"extract-bindings"]],["net/cgi"]],
["extract-bindings",">web-server/bindings_ss.html#(def._((lib._web-server/servlet/bindings..ss)._extract-bindings))",[0,[1,"extract-bindings"]],["web-server/servlet/bindings"]],
["extract-desired-headers",">net/nntp.html#(def._((lib._net/nntp..ss)._extract-desired-headers))",[0,[1,"extract-desired-headers"]],["net/nntp"]],
["extract-desired-headers",">net/pop3.html#(def._((lib._net/pop3..ss)._extract-desired-headers))",[0,[1,"extract-desired-headers"]],["net/pop3"]],
["extract-field",">net/head.html#(def._((lib._net/head..ss)._extract-field))",[0,[1,"extract-field"]],["net/head"]],
["extract-param",">web-server/url-param_ss.html#(def._((lib._web-server/private/url-param..ss)._extract-param))",[0,[1,"extract-param"]],["web-server/private/url-param"]],
["extract-struct-info",">reference/structinfo.html#(def._((lib._scheme/struct-info..ss)._extract-struct-info))",[0,[1,"extract-struct-info"]],["scheme/struct-info"]],
["extract-used-classes",">gui/WXME_Decoding.html#(def._((lib._wxme/main..ss)._extract-used-classes))",[0,[1,"extract-used-classes"]],["wxme"]],
["extract-user-pass",">web-server/basic-auth_ss.html#(def._((lib._web-server/servlet/basic-auth..ss)._extract-user-pass))",[0,[1,"extract-user-pass"]],["web-server/servlet/basic-auth"]],
["extracting inferred names",">syntax/transformer-helpers.html#(part._name)","Extracting Inferred Names",false],
["f1",">gui/key-event_.html#(idx._(gentag._86._(lib._scribblings/gui/gui..scrbl)))",[7,"'f1"],false],
["f10",">gui/key-event_.html#(idx._(gentag._95._(lib._scribblings/gui/gui..scrbl)))",[7,"'f10"],false],
["f11",">gui/key-event_.html#(idx._(gentag._96._(lib._scribblings/gui/gui..scrbl)))",[7,"'f11"],false],
["f12",">gui/key-event_.html#(idx._(gentag._97._(lib._scribblings/gui/gui..scrbl)))",[7,"'f12"],false],
["f13",">gui/key-event_.html#(idx._(gentag._98._(lib._scribblings/gui/gui..scrbl)))",[7,"'f13"],false],
["f14",">gui/key-event_.html#(idx._(gentag._99._(lib._scribblings/gui/gui..scrbl)))",[7,"'f14"],false],
["f15",">gui/key-event_.html#(idx._(gentag._100._(lib._scribblings/gui/gui..scrbl)))",[7,"'f15"],false],
["f16",">gui/key-event_.html#(idx._(gentag._101._(lib._scribblings/gui/gui..scrbl)))",[7,"'f16"],false],
["f17",">gui/key-event_.html#(idx._(gentag._102._(lib._scribblings/gui/gui..scrbl)))",[7,"'f17"],false],
["f18",">gui/key-event_.html#(idx._(gentag._103._(lib._scribblings/gui/gui..scrbl)))",[7,"'f18"],false],
["f19",">gui/key-event_.html#(idx._(gentag._104._(lib._scribblings/gui/gui..scrbl)))",[7,"'f19"],false],
["f2",">gui/key-event_.html#(idx._(gentag._87._(lib._scribblings/gui/gui..scrbl)))",[7,"'f2"],false],
["f20",">gui/key-event_.html#(idx._(gentag._105._(lib._scribblings/gui/gui..scrbl)))",[7,"'f20"],false],
["f21",">gui/key-event_.html#(idx._(gentag._106._(lib._scribblings/gui/gui..scrbl)))",[7,"'f21"],false],
["f22",">gui/key-event_.html#(idx._(gentag._107._(lib._scribblings/gui/gui..scrbl)))",[7,"'f22"],false],
["f23",">gui/key-event_.html#(idx._(gentag._108._(lib._scribblings/gui/gui..scrbl)))",[7,"'f23"],false],
["f24",">gui/key-event_.html#(idx._(gentag._109._(lib._scribblings/gui/gui..scrbl)))",[7,"'f24"],false],
["f3",">gui/key-event_.html#(idx._(gentag._88._(lib._scribblings/gui/gui..scrbl)))",[7,"'f3"],false],
["f32vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._f32vector))",[0,[1,"f32vector"]],["scheme/foreign"]],
["f32vector",">srfi-std/srfi-4.html#f32vector",[0,[1,"f32vector"]],["srfi/4"]],
["f32vector->list",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._f32vector-~3elist))",[0,[1,"f32vector-&gt;list"]],["scheme/foreign"]],
["f32vector-length",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._f32vector-length))",[0,[1,"f32vector-length"]],["scheme/foreign"]],
["f32vector-ref",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._f32vector-ref))",[0,[1,"f32vector-ref"]],["scheme/foreign"]],
["f32vector-set!",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._f32vector-set!))",[0,[1,"f32vector-set!"]],["scheme/foreign"]],
["f32vector?",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._f32vector~3f))",[0,[1,"f32vector?"]],["scheme/foreign"]],
["f4",">gui/key-event_.html#(idx._(gentag._89._(lib._scribblings/gui/gui..scrbl)))",[7,"'f4"],false],
["f5",">gui/key-event_.html#(idx._(gentag._90._(lib._scribblings/gui/gui..scrbl)))",[7,"'f5"],false],
["f5 keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._211._(lib._scribblings/drscheme/drscheme..scrbl)))","F5 keybinding",false],
["f6",">gui/key-event_.html#(idx._(gentag._91._(lib._scribblings/gui/gui..scrbl)))",[7,"'f6"],false],
["f64vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._f64vector))",[0,[1,"f64vector"]],["scheme/foreign"]],
["f64vector",">srfi-std/srfi-4.html#f64vector",[0,[1,"f64vector"]],["srfi/4"]],
["f64vector->list",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._f64vector-~3elist))",[0,[1,"f64vector-&gt;list"]],["scheme/foreign"]],
["f64vector-length",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._f64vector-length))",[0,[1,"f64vector-length"]],["scheme/foreign"]],
["f64vector-ref",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._f64vector-ref))",[0,[1,"f64vector-ref"]],["scheme/foreign"]],
["f64vector-set!",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._f64vector-set!))",[0,[1,"f64vector-set!"]],["scheme/foreign"]],
["f64vector?",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._f64vector~3f))",[0,[1,"f64vector?"]],["scheme/foreign"]],
["f7",">gui/key-event_.html#(idx._(gentag._92._(lib._scribblings/gui/gui..scrbl)))",[7,"'f7"],false],
["f8",">gui/key-event_.html#(idx._(gentag._93._(lib._scribblings/gui/gui..scrbl)))",[7,"'f8"],false],
["f9",">gui/key-event_.html#(idx._(gentag._94._(lib._scribblings/gui/gui..scrbl)))",[7,"'f9"],false],
["face",">slideshow/More_Pict_Constructors.html#(part._.Face)","Face",false],
["face",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/face..ss)._face))",[0,[1,"face"]],["slideshow/face"]],
["face*",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/face..ss)._face*))",[0,[1,"face*"]],["slideshow/face"]],
["face-down",">cards/index.html#(meth._(((lib._games/cards..ss)._card~3c~25~3e)._face-down))",[[0,[1,"face-down"]],[12,[" (method of ",[0,[1,"card&lt;%&gt;"]],")"]]],["games/cards"]],
["face-down?",">cards/index.html#(meth._(((lib._games/cards..ss)._card~3c~25~3e)._face-down~3f))",[[0,[1,"face-down?"]],[12,[" (method of ",[0,[1,"card&lt;%&gt;"]],")"]]],["games/cards"]],
["face-up",">cards/index.html#(meth._(((lib._games/cards..ss)._card~3c~25~3e)._face-up))",[[0,[1,"face-up"]],[12,[" (method of ",[0,[1,"card&lt;%&gt;"]],")"]]],["games/cards"]],
["failok",">foreign/foreign_pointer-funcs.html#(idx._(gentag._12._(lib._scribblings/foreign/foreign..scrbl)))",[7,"'failok"],false],
["false",">reference/booleans.html#(def._((lib._scheme/bool..ss)._false))",[0,[1,"false"]],["scheme/bool","scheme"]],
["false",">htdp-langs/advanced-unchanged.html#(def._((lib._lang/htdp-advanced..ss)._false))",[0,[1,"false"]],["lang/htdp-advanced"]],
["false",">htdp-langs/true_and_false.html#(def._((lib._lang/htdp-beginner..ss)._false))",[0,[1,"false"]],["lang/htdp-beginner"]],
["false",">htdp-langs/Unchanged_Forms.html#(def._((lib._lang/htdp-beginner-abbr..ss)._false))",[0,[1,"false"]],["lang/htdp-beginner-abbr"]],
["false",">htdp-langs/intermediate-unchanged.html#(def._((lib._lang/htdp-intermediate..ss)._false))",[0,[1,"false"]],["lang/htdp-intermediate"]],
["false",">htdp-langs/intermediate-lambda-unchanged.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._false))",[0,[1,"false"]],["lang/htdp-intermediate-lambda"]],
["false",">lazy/index.html#(def._((lib._lazy/main..ss)._false))",[0,[1,"false"]],["lazy"]],
["false/c",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._false/c))",[0,[1,"false/c"]],["scheme/contract","scheme"]],
["false?",">reference/booleans.html#(def._((lib._scheme/bool..ss)._false~3f))",[0,[1,"false?"]],["scheme/bool","scheme"]],
["false?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._false~3f))",[0,[1,"false?"]],["lang/htdp-advanced"]],
["false?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._false~3f))",[0,[1,"false?"]],["lang/htdp-beginner"]],
["false?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._false~3f))",[0,[1,"false?"]],["lang/htdp-beginner-abbr"]],
["false?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._false~3f))",[0,[1,"false?"]],["lang/htdp-intermediate"]],
["false?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._false~3f))",[0,[1,"false?"]],["lang/htdp-intermediate-lambda"]],
["fcontrol",">reference/cont.html#(def._((lib._scheme/control..ss)._fcontrol))",[0,[1,"fcontrol"]],["scheme/control"]],
["fdiagonal-hatch",">gui/brush_.html#(idx._(gentag._185._(lib._scribblings/gui/gui..scrbl)))",[7,"'fdiagonal-hatch"],false],
["features",">swindle/index.html#(part._.Features)","Features",false],
["feedback-buffer->gl-float-vector",">sgl/gl.html#(def._((lib._sgl/gl..ss)._feedback-buffer-~3egl-float-vector))",[0,[1,"feedback-buffer-&gt;gl-float-vector"]],["sgl/gl"]],
["fern fractal",">turtles/Traditional_Turtles.html#(idx._(gentag._5._(lib._graphics/scribblings/turtles..scrbl)))","fern fractal",false],
["fern-size",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..ss)._fern-size))",[0,[1,"fern-size"]],["graphics/turtle-examples"]],
["fern1",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..ss)._fern1))",[0,[1,"fern1"]],["graphics/turtle-examples"]],
["fern2",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..ss)._fern2))",[0,[1,"fern2"]],["graphics/turtle-examples"]],
["fetch",">planet/cmdline.html#(part._fetch)",[5,"fetch"],false],
["ffi",">foreign/index.html#(tech._ffi)","<i>FFI</i>",false],
["ffi-call",">foreign/foreign_c-only.html#(def._((quote._~23~25foreign)._ffi-call))",[0,[1,"ffi-call"]],["'#%foreign"]],
["ffi-callback",">foreign/foreign_c-only.html#(def._((quote._~23~25foreign)._ffi-callback))",[0,[1,"ffi-callback"]],["'#%foreign"]],
["ffi-callback?",">foreign/foreign_c-only.html#(def._((quote._~23~25foreign)._ffi-callback~3f))",[0,[1,"ffi-callback?"]],["'#%foreign"]],
["ffi-lib",">foreign/Loading_Foreign_Libraries.html#(def._((lib._scribblings/foreign/unsafe-foreign..ss)._ffi-lib))",[0,[1,"ffi-lib"]],["scribblings/foreign/unsafe-foreign"]],
["ffi-lib?",">foreign/Loading_Foreign_Libraries.html#(def._((lib._scheme/foreign..ss)._ffi-lib~3f))",[0,[1,"ffi-lib?"]],["scheme/foreign"]],
["ffi-obj",">foreign/foreign_c-only.html#(def._((quote._~23~25foreign)._ffi-obj))",[0,[1,"ffi-obj"]],["'#%foreign"]],
["ffi-obj-lib",">foreign/foreign_c-only.html#(def._((quote._~23~25foreign)._ffi-obj-lib))",[0,[1,"ffi-obj-lib"]],["'#%foreign"]],
["ffi-obj-name",">foreign/foreign_c-only.html#(def._((quote._~23~25foreign)._ffi-obj-name))",[0,[1,"ffi-obj-name"]],["'#%foreign"]],
["ffi-obj-ref",">foreign/Loading_Foreign_Libraries.html#(def._((lib._scribblings/foreign/unsafe-foreign..ss)._ffi-obj-ref))",[0,[1,"ffi-obj-ref"]],["scribblings/foreign/unsafe-foreign"]],
["ffi-obj?",">foreign/foreign_c-only.html#(def._((quote._~23~25foreign)._ffi-obj~3f))",[0,[1,"ffi-obj?"]],["'#%foreign"]],
["ffi: plt scheme foreign interface",">foreign/index.html","<b>FFI</b>: PLT Scheme Foreign Interface",false],
["field",">htdc/Field.html",[0,"Field"],false],
["field",">htdc/advanced_field.html",[0,"Field"],false],
["field",">htdc/intermed_field.html",[0,"Field"],false],
["field",">htdc/intermedAcc_field.html",[0,"Field"],false],
["field",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._field))",[0,[6,"field"]],["scheme/class","scheme"]],
["field and method access",">reference/ivaraccess.html","Field and Method Access",false],
["field-bound?",">reference/ivaraccess.html#(form._((lib._scheme/private/class-internal..ss)._field-bound~3f))",[0,[6,"field-bound?"]],["scheme/class","scheme"]],
["field-names",">reference/objectutils.html#(def._((lib._scheme/private/class-internal..ss)._field-names))",[0,[1,"field-names"]],["scheme/class","scheme"]],
["fields",">reference/ivaraccess.html#(part._.Fields)","Fields",false],
["fields",">reference/createclass.html#(part._clfields)","Fields",false],
["fields",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_290",[0,[6,"fields"]],["rnrs/records/syntactic-6"]],
["fieldset",">html/index.html#(def._((lib._html/main..ss)._fieldset))",[0,[1,"fieldset"]],["html"]],
["fieldset?",">html/index.html#(def._((lib._html/main..ss)._fieldset~3f))",[0,[1,"fieldset?"]],["html"]],
["fifth",">reference/pairs.html#(def._((lib._scheme/list..ss)._fifth))",[0,[1,"fifth"]],["scheme/list","scheme"]],
["fifth",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._fifth))",[0,[1,"fifth"]],["lang/htdp-advanced"]],
["fifth",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._fifth))",[0,[1,"fifth"]],["lang/htdp-beginner"]],
["fifth",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._fifth))",[0,[1,"fifth"]],["lang/htdp-beginner-abbr"]],
["fifth",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._fifth))",[0,[1,"fifth"]],["lang/htdp-intermediate"]],
["fifth",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._fifth))",[0,[1,"fifth"]],["lang/htdp-intermediate-lambda"]],
["fifth",">lazy/index.html#(def._((lib._lazy/main..ss)._fifth))",[0,[1,"fifth"]],["lazy"]],
["fifth",">mzlib/mzlib_list.html#(def._((lib._mzlib/list..ss)._fifth))",[0,[1,"fifth"]],["mzlib/list"]],
["fifth",">srfi-std/srfi-1.html#fifth",[0,[1,"fifth"]],["srfi/1"]],
["file",">drscheme/Menus.html#(part._.File)","<b><font size=\"-1\" face=\"Helvetica\">File</font></b>",false],
["file",">reference/require.html#(form._((lib._scheme/base..ss)._file))",[0,[6,"file"]],["scheme/base","scheme"]],
["file",">teachpack/dir.html#(def._((lib._teachpack/htdp/dir..ss)._file))",[0,[1,"file"]],["teachpack/htdp/dir"]],
["file boxes",">web-server/lang_file-box_ss.html","File Boxes",false],
["file extension",">drscheme/drscheme-files.html#(idx._(gentag._214._(lib._scribblings/drscheme/drscheme..scrbl)))","file extension",false],
["file format",">gui/editor-overview.html#(part._editorfileformat)","File Format",false],
["file inclusion",">reference/include.html","File Inclusion",false],
["file operations",">drscheme/Keyboard_Shortcuts.html#(part._.File_.Operations)","File Operations",false],
["file ports",">reference/file-ports.html","File Ports",false],
["file-box",">web-server/lang_file-box_ss.html#(def._((lib._web-server/lang/file-box..ss)._file-box))",[0,[1,"file-box"]],["web-server/lang/file-box"]],
["file-box-set!",">web-server/lang_file-box_ss.html#(def._((lib._web-server/lang/file-box..ss)._file-box-set!))",[0,[1,"file-box-set!"]],["web-server/lang/file-box"]],
["file-box-set?",">web-server/lang_file-box_ss.html#(def._((lib._web-server/lang/file-box..ss)._file-box-set~3f))",[0,[1,"file-box-set?"]],["web-server/lang/file-box"]],
["file-box?",">web-server/lang_file-box_ss.html#(def._((lib._web-server/lang/file-box..ss)._file-box~3f))",[0,[1,"file-box?"]],["web-server/lang/file-box"]],
["file-content",">teachpack/dir.html#(def._((lib._teachpack/htdp/dir..ss)._file-content))",[0,[1,"file-content"]],["teachpack/htdp/dir"]],
["file-creator-and-type",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._file-creator-and-type))",[0,[1,"file-creator-and-type"]],["scheme/gui/base","scheme/gui"]],
["file-exists?",">reference/Filesystem.html#(def._((quote._~23~25kernel)._file-exists~3f))",[0,[1,"file-exists?"]],["scheme/base","scheme"]],
["file-exists?",">r6rs-lib-std/r6rs-lib-Z-H-10.html#node_idx_838",[0,[1,"file-exists?"]],["rnrs/files-6"]],
["file-icon",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._file-icon))",[0,[1,"file-icon"]],["slideshow/pict","slideshow"]],
["file-menu:after-quit",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aafter-quit))",[[0,[1,"file-menu:after-quit"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:between-close-and-quit",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3abetween-close-and-quit))",[[0,[1,"file-menu:between-close-and-quit"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:between-new-and-open",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3abetween-new-and-open))",[[0,[1,"file-menu:between-new-and-open"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:between-open-and-revert",">tools/drscheme_frame.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aframe~3abasics-mixin)._file-menu~3abetween-open-and-revert))",[[0,[1,"file-menu:between-open-and-revert"]],[12,[" (method of ",[0,[1,"drscheme:frame:basics-mixin"]],")"]]],["drscheme/tool-lib"]],
["file-menu:between-open-and-revert",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._file-menu~3abetween-open-and-revert))",[[0,[1,"file-menu:between-open-and-revert"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["file-menu:between-open-and-revert",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3abetween-open-and-revert))",[[0,[1,"file-menu:between-open-and-revert"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:between-print-and-close",">tools/drscheme_frame.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aframe~3abasics-mixin)._file-menu~3abetween-print-and-close))",[[0,[1,"file-menu:between-print-and-close"]],[12,[" (method of ",[0,[1,"drscheme:frame:basics-mixin"]],")"]]],["drscheme/tool-lib"]],
["file-menu:between-print-and-close",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._file-menu~3abetween-print-and-close))",[[0,[1,"file-menu:between-print-and-close"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["file-menu:between-print-and-close",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3abetween-print-and-close))",[[0,[1,"file-menu:between-print-and-close"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:between-revert-and-save",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3abetween-revert-and-save))",[[0,[1,"file-menu:between-revert-and-save"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:between-save-as-and-print",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._file-menu~3abetween-save-as-and-print))",[[0,[1,"file-menu:between-save-as-and-print"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["file-menu:between-save-as-and-print",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor-mixin)._file-menu~3abetween-save-as-and-print))",[[0,[1,"file-menu:between-save-as-and-print"]],[12,[" (method of ",[0,[1,"frame:editor-mixin"]],")"]]],["framework"]],
["file-menu:between-save-as-and-print",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3abetween-save-as-and-print))",[[0,[1,"file-menu:between-save-as-and-print"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:close-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aclose-callback))",[[0,[1,"file-menu:close-callback"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:close-help-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aclose-help-string))",[[0,[1,"file-menu:close-help-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:close-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aclose-on-demand))",[[0,[1,"file-menu:close-on-demand"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:close-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aclose-string))",[[0,[1,"file-menu:close-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:create-close?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3acreate-close~3f))",[[0,[1,"file-menu:create-close?"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:create-new?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3acreate-new~3f))",[[0,[1,"file-menu:create-new?"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:create-open-recent?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3acreate-open-recent~3f))",[[0,[1,"file-menu:create-open-recent?"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:create-open?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3acreate-open~3f))",[[0,[1,"file-menu:create-open?"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:create-print?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor-mixin)._file-menu~3acreate-print~3f))",[[0,[1,"file-menu:create-print?"]],[12,[" (method of ",[0,[1,"frame:editor-mixin"]],")"]]],["framework"]],
["file-menu:create-print?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3acreate-print~3f))",[[0,[1,"file-menu:create-print?"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:create-quit?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3acreate-quit~3f))",[[0,[1,"file-menu:create-quit?"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:create-revert?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor-mixin)._file-menu~3acreate-revert~3f))",[[0,[1,"file-menu:create-revert?"]],[12,[" (method of ",[0,[1,"frame:editor-mixin"]],")"]]],["framework"]],
["file-menu:create-revert?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3acreate-revert~3f))",[[0,[1,"file-menu:create-revert?"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:create-save-as?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor-mixin)._file-menu~3acreate-save-as~3f))",[[0,[1,"file-menu:create-save-as?"]],[12,[" (method of ",[0,[1,"frame:editor-mixin"]],")"]]],["framework"]],
["file-menu:create-save-as?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3acreate-save-as~3f))",[[0,[1,"file-menu:create-save-as?"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:create-save?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor-mixin)._file-menu~3acreate-save~3f))",[[0,[1,"file-menu:create-save?"]],[12,[" (method of ",[0,[1,"frame:editor-mixin"]],")"]]],["framework"]],
["file-menu:create-save?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3acreate-save~3f))",[[0,[1,"file-menu:create-save?"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:get-close-item",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aget-close-item))",[[0,[1,"file-menu:get-close-item"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:get-new-item",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aget-new-item))",[[0,[1,"file-menu:get-new-item"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:get-open-item",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aget-open-item))",[[0,[1,"file-menu:get-open-item"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:get-open-recent-item",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aget-open-recent-item))",[[0,[1,"file-menu:get-open-recent-item"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:get-print-item",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aget-print-item))",[[0,[1,"file-menu:get-print-item"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:get-quit-item",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aget-quit-item))",[[0,[1,"file-menu:get-quit-item"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:get-revert-item",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aget-revert-item))",[[0,[1,"file-menu:get-revert-item"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:get-save-as-item",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aget-save-as-item))",[[0,[1,"file-menu:get-save-as-item"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:get-save-item",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aget-save-item))",[[0,[1,"file-menu:get-save-item"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:new-callback",">tools/drscheme_frame.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aframe~3abasics-mixin)._file-menu~3anew-callback))",[[0,[1,"file-menu:new-callback"]],[12,[" (method of ",[0,[1,"drscheme:frame:basics-mixin"]],")"]]],["drscheme/tool-lib"]],
["file-menu:new-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aopen-here-mixin)._file-menu~3anew-callback))",[[0,[1,"file-menu:new-callback"]],[12,[" (method of ",[0,[1,"frame:open-here-mixin"]],")"]]],["framework"]],
["file-menu:new-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3anew-callback))",[[0,[1,"file-menu:new-callback"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:new-help-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3anew-help-string))",[[0,[1,"file-menu:new-help-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:new-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aopen-here-mixin)._file-menu~3anew-on-demand))",[[0,[1,"file-menu:new-on-demand"]],[12,[" (method of ",[0,[1,"frame:open-here-mixin"]],")"]]],["framework"]],
["file-menu:new-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3anew-on-demand))",[[0,[1,"file-menu:new-on-demand"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:new-string",">tools/drscheme_frame.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aframe~3abasics-mixin)._file-menu~3anew-string))",[[0,[1,"file-menu:new-string"]],[12,[" (method of ",[0,[1,"drscheme:frame:basics-mixin"]],")"]]],["drscheme/tool-lib"]],
["file-menu:new-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3anew-string))",[[0,[1,"file-menu:new-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:open-callback",">tools/drscheme_frame.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aframe~3abasics-mixin)._file-menu~3aopen-callback))",[[0,[1,"file-menu:open-callback"]],[12,[" (method of ",[0,[1,"drscheme:frame:basics-mixin"]],")"]]],["drscheme/tool-lib"]],
["file-menu:open-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor-mixin)._file-menu~3aopen-callback))",[[0,[1,"file-menu:open-callback"]],[12,[" (method of ",[0,[1,"frame:editor-mixin"]],")"]]],["framework"]],
["file-menu:open-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aopen-callback))",[[0,[1,"file-menu:open-callback"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:open-help-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aopen-help-string))",[[0,[1,"file-menu:open-help-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:open-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aopen-here-mixin)._file-menu~3aopen-on-demand))",[[0,[1,"file-menu:open-on-demand"]],[12,[" (method of ",[0,[1,"frame:open-here-mixin"]],")"]]],["framework"]],
["file-menu:open-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aopen-on-demand))",[[0,[1,"file-menu:open-on-demand"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:open-recent-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aopen-recent-callback))",[[0,[1,"file-menu:open-recent-callback"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:open-recent-help-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aopen-recent-help-string))",[[0,[1,"file-menu:open-recent-help-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:open-recent-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aopen-recent-on-demand))",[[0,[1,"file-menu:open-recent-on-demand"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:open-recent-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aopen-recent-string))",[[0,[1,"file-menu:open-recent-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:open-string",">tools/drscheme_frame.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aframe~3abasics-mixin)._file-menu~3aopen-string))",[[0,[1,"file-menu:open-string"]],[12,[" (method of ",[0,[1,"drscheme:frame:basics-mixin"]],")"]]],["drscheme/tool-lib"]],
["file-menu:open-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aopen-string))",[[0,[1,"file-menu:open-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:print-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor-mixin)._file-menu~3aprint-callback))",[[0,[1,"file-menu:print-callback"]],[12,[" (method of ",[0,[1,"frame:editor-mixin"]],")"]]],["framework"]],
["file-menu:print-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aprint-callback))",[[0,[1,"file-menu:print-callback"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:print-help-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aprint-help-string))",[[0,[1,"file-menu:print-help-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:print-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aprint-on-demand))",[[0,[1,"file-menu:print-on-demand"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:print-string",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._file-menu~3aprint-string))",[[0,[1,"file-menu:print-string"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["file-menu:print-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aprint-string))",[[0,[1,"file-menu:print-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:quit-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aquit-callback))",[[0,[1,"file-menu:quit-callback"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:quit-help-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aquit-help-string))",[[0,[1,"file-menu:quit-help-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:quit-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aquit-on-demand))",[[0,[1,"file-menu:quit-on-demand"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:quit-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3aquit-string))",[[0,[1,"file-menu:quit-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:revert-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor-mixin)._file-menu~3arevert-callback))",[[0,[1,"file-menu:revert-callback"]],[12,[" (method of ",[0,[1,"frame:editor-mixin"]],")"]]],["framework"]],
["file-menu:revert-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3arevert-callback))",[[0,[1,"file-menu:revert-callback"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:revert-help-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3arevert-help-string))",[[0,[1,"file-menu:revert-help-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:revert-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor-mixin)._file-menu~3arevert-on-demand))",[[0,[1,"file-menu:revert-on-demand"]],[12,[" (method of ",[0,[1,"frame:editor-mixin"]],")"]]],["framework"]],
["file-menu:revert-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3arevert-on-demand))",[[0,[1,"file-menu:revert-on-demand"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:revert-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3arevert-string))",[[0,[1,"file-menu:revert-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:save-as-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor-mixin)._file-menu~3asave-as-callback))",[[0,[1,"file-menu:save-as-callback"]],[12,[" (method of ",[0,[1,"frame:editor-mixin"]],")"]]],["framework"]],
["file-menu:save-as-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3asave-as-callback))",[[0,[1,"file-menu:save-as-callback"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:save-as-help-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3asave-as-help-string))",[[0,[1,"file-menu:save-as-help-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:save-as-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3asave-as-on-demand))",[[0,[1,"file-menu:save-as-on-demand"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:save-as-string",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._file-menu~3asave-as-string))",[[0,[1,"file-menu:save-as-string"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["file-menu:save-as-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3asave-as-string))",[[0,[1,"file-menu:save-as-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:save-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor-mixin)._file-menu~3asave-callback))",[[0,[1,"file-menu:save-callback"]],[12,[" (method of ",[0,[1,"frame:editor-mixin"]],")"]]],["framework"]],
["file-menu:save-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3asave-callback))",[[0,[1,"file-menu:save-callback"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:save-help-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3asave-help-string))",[[0,[1,"file-menu:save-help-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:save-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3asave-on-demand))",[[0,[1,"file-menu:save-on-demand"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-menu:save-string",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._file-menu~3asave-string))",[[0,[1,"file-menu:save-string"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["file-menu:save-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._file-menu~3asave-string))",[[0,[1,"file-menu:save-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["file-name",">teachpack/dir.html#(def._((lib._teachpack/htdp/dir..ss)._file-name))",[0,[1,"file-name"]],["teachpack/htdp/dir"]],
["file-name-from-path",">reference/More_Path_Utilities.html#(def._((lib._scheme/path..ss)._file-name-from-path))",[0,[1,"file-name-from-path"]],["scheme/path","scheme"]],
["file-options",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_574",[0,[6,"file-options"]],["rnrs/io/ports-6"]],
["file-or-directory-modify-seconds",">reference/Filesystem.html#(def._((quote._~23~25kernel)._file-or-directory-modify-seconds))",[0,[1,"file-or-directory-modify-seconds"]],["scheme/base","scheme"]],
["file-or-directory-permissions",">reference/Filesystem.html#(def._((quote._~23~25kernel)._file-or-directory-permissions))",[0,[1,"file-or-directory-permissions"]],["scheme/base","scheme"]],
["file-path",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..ss)._file-path))",[0,[1,"file-path"]],["parser-tools/lex"]],
["file-position",">reference/port-buffers.html#(def._((quote._~23~25kernel)._file-position))",[0,[1,"file-position"]],["scheme/base","scheme"]],
["file-response",">web-server/responders_ss.html#(def._((lib._web-server/configuration/responders..ss)._file-response))",[0,[1,"file-response"]],["web-server/configuration/responders"]],
["file-size",">reference/Filesystem.html#(def._((quote._~23~25kernel)._file-size))",[0,[1,"file-size"]],["scheme/base","scheme"]],
["file-stream port",">reference/file-ports.html#(tech._file._stream._port)","<i>file-stream\nport</i>",false],
["file-stream-buffer-mode",">reference/port-buffers.html#(def._((quote._~23~25kernel)._file-stream-buffer-mode))",[0,[1,"file-stream-buffer-mode"]],["scheme/base","scheme"]],
["file-stream-port?",">reference/port-ops.html#(def._((quote._~23~25kernel)._file-stream-port~3f))",[0,[1,"file-stream-port?"]],["scheme/base","scheme"]],
["file-unbox",">web-server/lang_file-box_ss.html#(def._((lib._web-server/lang/file-box..ss)._file-unbox))",[0,[1,"file-unbox"]],["web-server/lang/file-box"]],
["file-url-path-convention-type",">net/url.html#(def._((lib._net/url..ss)._file-url-path-convention-type))",[0,[1,"file-url-path-convention-type"]],["net/url"]],
["file/gif",">file/gif.html",[14,[0,"file/gif"]],"module"],
["file/gunzip",">file/gunzip.html",[14,[0,"file/gunzip"]],"module"],
["file/gzip",">file/gzip.html",[14,[0,"file/gzip"]],"module"],
["file/md5",">file/md5.html",[14,[0,"file/md5"]],"module"],
["file/tar",">file/tar.html",[14,[0,"file/tar"]],"module"],
["file/zip",">file/zip.html",[14,[0,"file/zip"]],"module"],
["file: plt file format libraries",">file/index.html","<b>File</b>: PLT File Format Libraries",false],
["file?",">teachpack/dir.html#(def._((lib._teachpack/htdp/dir..ss)._file~3f))",[0,[1,"file?"]],["teachpack/htdp/dir"]],
["fileinject",">planet/cmdline.html#(part._fileinject)",[5,"fileinject"],false],
["filename button",">drscheme/buttons.html#(idx._(gentag._1._(lib._scribblings/drscheme/drscheme..scrbl)))","filename button",false],
["filename->latex-filename",">slatex-wrap/index.html#(def._((lib._slatex/slatex-wrapper..ss)._filename-~3elatex-filename))",[0,[1,"filename-&gt;latex-filename"]],["slatex/slatex-wrapper"]],
["filename-extension",">reference/More_Path_Utilities.html#(def._((lib._scheme/path..ss)._filename-extension))",[0,[1,"filename-extension"]],["scheme/path","scheme"]],
["filenames",">dynext/Filenames.html","Filenames",false],
["filepath",">scribble/doc-strings.html#(def._((lib._scribble/manual..ss)._filepath))",[0,[1,"filepath"]],["scribble/manual"]],
["files",">reference/Filesystem.html#(part._fileutils)","Files",false],
["filesystem",">reference/Filesystem.html","Filesystem",false],
["filesystem-root-list",">reference/Filesystem.html#(def._((quote._~23~25kernel)._filesystem-root-list))",[0,[1,"filesystem-root-list"]],["scheme/base","scheme"]],
["filled-ellipse",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._filled-ellipse))",[0,[1,"filled-ellipse"]],["slideshow/pict","slideshow"]],
["filled-flash",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/flash..ss)._filled-flash))",[0,[1,"filled-flash"]],["slideshow/flash"]],
["filled-rectangle",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._filled-rectangle))",[0,[1,"filled-rectangle"]],["slideshow/pict","slideshow"]],
["filled-rounded-rectangle",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._filled-rounded-rectangle))",[0,[1,"filled-rounded-rectangle"]],["slideshow/pict","slideshow"]],
["filter",">reference/pairs.html#(def._((lib._scheme/base..ss)._filter))",[0,[1,"filter"]],["scheme/base","scheme"]],
["filter",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_208",[0,[1,"filter"]],["rnrs/lists-6"]],
["filter",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._filter))",[0,[1,"filter"]],["lang/htdp-advanced"]],
["filter",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._filter))",[0,[1,"filter"]],["lang/htdp-intermediate"]],
["filter",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._filter))",[0,[1,"filter"]],["lang/htdp-intermediate-lambda"]],
["filter",">lazy/index.html#(def._((lib._lazy/main..ss)._filter))",[0,[1,"filter"]],["lazy"]],
["filter",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._filter))",[[0,[1,"filter"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["filter",">srfi-std/srfi-1.html#filter",[0,[1,"filter"]],["srfi/1"]],
["filter!",">srfi-std/srfi-1.html#filter!",[0,[1,"filter!"]],["srfi/1"]],
["filter-e",">frtime/index.html#(def._((lib._frtime/main..ss)._filter-e))",[0,[1,"filter-e"]],["frtime"]],
["filter-map",">reference/pairs.html#(def._((lib._scheme/list..ss)._filter-map))",[0,[1,"filter-map"]],["scheme/list","scheme"]],
["filter-map",">srfi-std/srfi-1.html#filter-map",[0,[1,"filter-map"]],["srfi/1"]],
["filter-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._filter-native))",[[0,[1,"filter-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["filter-not",">reference/pairs.html#(def._((lib._scheme/list..ss)._filter-not))",[0,[1,"filter-not"]],["scheme/list","scheme"]],
["filter-notes",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-panel-mixin)._filter-notes))",[[0,[1,"filter-notes"]],[12,[" (method of ",[0,[1,"hyper-panel-mixin"]],")"]]],["browser"]],
["filtered-in",">reference/require.html#(form._((lib._scheme/require..ss)._filtered-in))",[0,[6,"filtered-in"]],["scheme/require"]],
["filtered-out",">reference/require.html#(form._((lib._scheme/provide..ss)._filtered-out))",[0,[6,"filtered-out"]],["scheme/provide"]],
["filtering requests",">web-server/dispatch-filter_ss.html","Filtering Requests",false],
["final, augment, and inner",">guide/classes.html#(part._inner)","Final, Augment, and Inner",false],
["finalizers",">reference/willexecutor.html#(tech._finalizer)","<i>finalizers</i>",false],
["find",">gui/editor-data-class-list___.html#(meth._(((lib._mred/main..ss)._editor-data-class-list~3c~25~3e)._find))",[[0,[1,"find"]],[12,[" (method of ",[0,[1,"editor-data-class-list&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find",">gui/snip-class-list___.html#(meth._(((lib._mred/main..ss)._snip-class-list~3c~25~3e)._find))",[[0,[1,"find"]],[12,[" (method of ",[0,[1,"snip-class-list&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_202",[0,[1,"find"]],["rnrs/lists-6"]],
["find",">srfi-std/srfi-1.html#find",[0,[1,"find"]],["srfi/1"]],
["find again backwards menu item",">drscheme/Menus.html#(idx._(gentag._87._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Find Again Backwards</font></b> menu item",false],
["find again menu item",">drscheme/Menus.html#(idx._(gentag._86._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Find Again</font></b> menu item",false],
["find case sensitive menu item",">drscheme/Menus.html#(idx._(gentag._91._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Find Case Sensitive</font></b> menu item",false],
["find-collects-dir",">setup-plt/dirs.html#(def._((lib._setup/dirs..ss)._find-collects-dir))",[0,[1,"find-collects-dir"]],["setup/dirs"]],
["find-color",">gui/color-database___.html#(meth._(((lib._mred/main..ss)._color-database~3c~25~3e)._find-color))",[[0,[1,"find-color"]],[12,[" (method of ",[0,[1,"color-database&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find-console-bin-dir",">setup-plt/dirs.html#(def._((lib._setup/dirs..ss)._find-console-bin-dir))",[0,[1,"find-console-bin-dir"]],["setup/dirs"]],
["find-dll-dir",">setup-plt/dirs.html#(def._((lib._setup/dirs..ss)._find-dll-dir))",[0,[1,"find-dll-dir"]],["setup/dirs"]],
["find-doc-dir",">setup-plt/dirs.html#(def._((lib._setup/dirs..ss)._find-doc-dir))",[0,[1,"find-doc-dir"]],["setup/dirs"]],
["find-down-sexp",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._find-down-sexp))",[[0,[1,"find-down-sexp"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["find-element",">mysterx/documents.html#(meth._(((lib._mysterx/main..ss)._mx-document~3c~25~3e)._find-element))",[[0,[1,"find-element"]],[12,[" (method of ",[0,[1,"mx-document&lt;%&gt;"]],")"]]],["mysterx"]],
["find-element-by-id-or-name",">mysterx/documents.html#(meth._(((lib._mysterx/main..ss)._mx-document~3c~25~3e)._find-element-by-id-or-name))",[[0,[1,"find-element-by-id-or-name"]],[12,[" (method of ",[0,[1,"mx-document&lt;%&gt;"]],")"]]],["mysterx"]],
["find-executable-path",">reference/Filesystem.html#(def._((lib._scheme/private/misc..ss)._find-executable-path))",[0,[1,"find-executable-path"]],["scheme/base","scheme"]],
["find-family-default-font-id",">gui/font-name-directory___.html#(meth._(((lib._mred/main..ss)._font-name-directory~3c~25~3e)._find-family-default-font-id))",[[0,[1,"find-family-default-font-id"]],[12,[" (method of ",[0,[1,"font-name-directory&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find-files",">reference/Filesystem.html#(def._((lib._scheme/file..ss)._find-files))",[0,[1,"find-files"]],["scheme/file","scheme"]],
["find-first-snip",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._find-first-snip))",[[0,[1,"find-first-snip"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find-graphical-system-path",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._find-graphical-system-path))",[0,[1,"find-graphical-system-path"]],["scheme/gui/base","scheme/gui"]],
["find-gui-bin-dir",">setup-plt/dirs.html#(def._((lib._setup/dirs..ss)._find-gui-bin-dir))",[0,[1,"find-gui-bin-dir"]],["setup/dirs"]],
["find-image",">teachpack/image.html#(def._((lib._htdp/image..ss)._find-image))",[0,[1,"find-image"]],["teachpack/htdp/image"]],
["find-include-dir",">setup-plt/dirs.html#(def._((lib._setup/dirs..ss)._find-include-dir))",[0,[1,"find-include-dir"]],["setup/dirs"]],
["find-lib-dir",">setup-plt/dirs.html#(def._((lib._setup/dirs..ss)._find-lib-dir))",[0,[1,"find-lib-dir"]],["setup/dirs"]],
["find-library-collection-paths",">reference/collects.html#(def._((lib._scheme/private/misc..ss)._find-library-collection-paths))",[0,[1,"find-library-collection-paths"]],["scheme/base","scheme"]],
["find-line",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._find-line))",[[0,[1,"find-line"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find-named-style",">gui/style-list_.html#(meth._(((lib._mred/main..ss)._style-list~25)._find-named-style))",[[0,[1,"find-named-style"]],[12,[" (method of ",[0,[1,"style-list%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find-next-non-string-snip",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._find-next-non-string-snip))",[[0,[1,"find-next-non-string-snip"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find-next-selected-snip",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._find-next-selected-snip))",[[0,[1,"find-next-selected-snip"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find-or-create-brush",">gui/brush-list_.html#(meth._(((lib._mred/main..ss)._brush-list~25)._find-or-create-brush))",[[0,[1,"find-or-create-brush"]],[12,[" (method of ",[0,[1,"brush-list%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find-or-create-font",">gui/font-list_.html#(meth._(((lib._mred/main..ss)._font-list~25)._find-or-create-font))",[[0,[1,"find-or-create-font"]],[12,[" (method of ",[0,[1,"font-list%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find-or-create-font-id",">gui/font-name-directory___.html#(meth._(((lib._mred/main..ss)._font-name-directory~3c~25~3e)._find-or-create-font-id))",[[0,[1,"find-or-create-font-id"]],[12,[" (method of ",[0,[1,"font-name-directory&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find-or-create-join-style",">gui/style-list_.html#(meth._(((lib._mred/main..ss)._style-list~25)._find-or-create-join-style))",[[0,[1,"find-or-create-join-style"]],[12,[" (method of ",[0,[1,"style-list%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find-or-create-pen",">gui/pen-list_.html#(meth._(((lib._mred/main..ss)._pen-list~25)._find-or-create-pen))",[[0,[1,"find-or-create-pen"]],[12,[" (method of ",[0,[1,"pen-list%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find-or-create-style",">gui/style-list_.html#(meth._(((lib._mred/main..ss)._style-list~25)._find-or-create-style))",[[0,[1,"find-or-create-style"]],[12,[" (method of ",[0,[1,"style-list%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find-position",">gui/editor-data-class-list___.html#(meth._(((lib._mred/main..ss)._editor-data-class-list~3c~25~3e)._find-position))",[[0,[1,"find-position"]],[12,[" (method of ",[0,[1,"editor-data-class-list&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find-position",">gui/snip-class-list___.html#(meth._(((lib._mred/main..ss)._snip-class-list~3c~25~3e)._find-position))",[[0,[1,"find-position"]],[12,[" (method of ",[0,[1,"snip-class-list&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find-position",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._find-position))",[[0,[1,"find-position"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find-position-in-line",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._find-position-in-line))",[[0,[1,"find-position-in-line"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find-relative-path",">reference/More_Path_Utilities.html#(def._((lib._scheme/path..ss)._find-relative-path))",[0,[1,"find-relative-path"]],["scheme/path","scheme"]],
["find-relevant-directories",">setup-plt/getinfo.html#(def._((lib._setup/getinfo..ss)._find-relevant-directories))",[0,[1,"find-relevant-directories"]],["setup/getinfo"]],
["find-scroll-line",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._find-scroll-line))",[[0,[1,"find-scroll-line"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find-scroll-step",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._find-scroll-step))",[[0,[1,"find-scroll-step"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find-seconds",">reference/time.html#(def._((lib._scheme/date..ss)._find-seconds))",[0,[1,"find-seconds"]],["scheme/date"]],
["find-snip",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._find-snip))",[[0,[1,"find-snip"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find-snip",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._find-snip))",[[0,[1,"find-snip"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find-string",">gui/list-control___.html#(meth._(((lib._mred/main..ss)._list-control~3c~25~3e)._find-string))",[[0,[1,"find-string"]],[12,[" (method of ",[0,[1,"list-control&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find-string",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._find-string))",[[0,[1,"find-string"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find-string",">framework/Keymap.html#(idx._(gentag._12._(lib._scribblings/framework/framework..scrbl)))","find-string",false],
["find-string-all",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._find-string-all))",[[0,[1,"find-string-all"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find-string-replace",">framework/Keymap.html#(idx._(gentag._14._(lib._scribblings/framework/framework..scrbl)))","find-string-replace",false],
["find-string-reverse",">framework/Keymap.html#(idx._(gentag._13._(lib._scribblings/framework/framework..scrbl)))","find-string-reverse",false],
["find-system-path",">reference/Filesystem.html#(def._((quote._~23~25kernel)._find-system-path))",[0,[1,"find-system-path"]],["scheme/base","scheme"]],
["find-tag",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-text-mixin)._find-tag))",[[0,[1,"find-tag"]],[12,[" (method of ",[0,[1,"hyper-text-mixin"]],")"]]],["browser"]],
["find-tail",">srfi-std/srfi-1.html#find-tail",[0,[1,"find-tail"]],["srfi/1"]],
["find-up-sexp",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._find-up-sexp))",[[0,[1,"find-up-sexp"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["find-user-collects-dir",">setup-plt/dirs.html#(def._((lib._setup/dirs..ss)._find-user-collects-dir))",[0,[1,"find-user-collects-dir"]],["setup/dirs"]],
["find-user-doc-dir",">setup-plt/dirs.html#(def._((lib._setup/dirs..ss)._find-user-doc-dir))",[0,[1,"find-user-doc-dir"]],["setup/dirs"]],
["find-user-include-dir",">setup-plt/dirs.html#(def._((lib._setup/dirs..ss)._find-user-include-dir))",[0,[1,"find-user-include-dir"]],["setup/dirs"]],
["find-user-lib-dir",">setup-plt/dirs.html#(def._((lib._setup/dirs..ss)._find-user-lib-dir))",[0,[1,"find-user-lib-dir"]],["setup/dirs"]],
["find-wordbreak",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._find-wordbreak))",[[0,[1,"find-wordbreak"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["find... menu item",">drscheme/Menus.html#(idx._(gentag._85._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Find...</font></b> menu item",false],
["finder",">framework/Finder.html","Finder",false],
["finder:common-get-file",">framework/Finder.html#(def._((lib._framework/main..ss)._finder~3acommon-get-file))",[0,[1,"finder:common-get-file"]],["framework"]],
["finder:common-get-file-list",">framework/Finder.html#(def._((lib._framework/main..ss)._finder~3acommon-get-file-list))",[0,[1,"finder:common-get-file-list"]],["framework"]],
["finder:common-put-file",">framework/Finder.html#(def._((lib._framework/main..ss)._finder~3acommon-put-file))",[0,[1,"finder:common-put-file"]],["framework"]],
["finder:default-extension",">framework/Finder.html#(def._((lib._framework/main..ss)._finder~3adefault-extension))",[0,[1,"finder:default-extension"]],["framework"]],
["finder:default-filters",">framework/Finder.html#(def._((lib._framework/main..ss)._finder~3adefault-filters))",[0,[1,"finder:default-filters"]],["framework"]],
["finder:dialog-parent-parameter",">framework/Finder.html#(def._((lib._framework/main..ss)._finder~3adialog-parent-parameter))",[0,[1,"finder:dialog-parent-parameter"]],["framework"]],
["finder:get-file",">framework/Finder.html#(def._((lib._framework/main..ss)._finder~3aget-file))",[0,[1,"finder:get-file"]],["framework"]],
["finder:open-file",">framework/Keymap.html#(idx._(gentag._11._(lib._scribblings/framework/framework..scrbl)))","finder:open-file",false],
["finder:put-file",">framework/Finder.html#(def._((lib._framework/main..ss)._finder~3aput-file))",[0,[1,"finder:put-file"]],["framework"]],
["finder:put-file",">framework/Keymap.html#(idx._(gentag._7._(lib._scribblings/framework/framework..scrbl)))","finder:put-file",false],
["finder:put-file",">framework/Keymap.html#(idx._(gentag._9._(lib._scribblings/framework/framework..scrbl)))","finder:put-file",false],
["finder:std-get-file",">framework/Finder.html#(def._((lib._framework/main..ss)._finder~3astd-get-file))",[0,[1,"finder:std-get-file"]],["framework"]],
["finder:std-put-file",">framework/Finder.html#(def._((lib._framework/main..ss)._finder~3astd-put-file))",[0,[1,"finder:std-put-file"]],["framework"]],
["findf",">reference/pairs.html#(def._((lib._scheme/base..ss)._findf))",[0,[1,"findf"]],["scheme/base","scheme"]],
["finding a package",">planet/Using_PLaneT.html#(part._finding-a-package)","Finding a Package",false],
["finding installation directories",">setup-plt/dirs.html","Finding Installation Directories",false],
["fine-grained control over package imports",">planet/Using_PLaneT.html#(part._.Fine-.Grained_.Control_.Over_.Package_.Imports)","Fine-Grained Control Over Package Imports",false],
["finite?",">r6rs-std/r6rs-Z-H-14.html#node_idx_484",[0,[1,"finite?"]],["rnrs/base-6"]],
["first",">reference/pairs.html#(def._((lib._scheme/list..ss)._first))",[0,[1,"first"]],["scheme/list","scheme"]],
["first",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._first))",[0,[1,"first"]],["lang/htdp-advanced"]],
["first",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._first))",[0,[1,"first"]],["lang/htdp-beginner"]],
["first",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._first))",[0,[1,"first"]],["lang/htdp-beginner-abbr"]],
["first",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._first))",[0,[1,"first"]],["lang/htdp-intermediate"]],
["first",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._first))",[0,[1,"first"]],["lang/htdp-intermediate-lambda"]],
["first",">lazy/index.html#(def._((lib._lazy/main..ss)._first))",[0,[1,"first"]],["lazy"]],
["first",">mzlib/mzlib_list.html#(def._((lib._mzlib/list..ss)._first))",[0,[1,"first"]],["mzlib/list"]],
["first",">srfi-std/srfi-1.html#first",[0,[1,"first"]],["srfi/1"]],
["first-class units",">guide/First-Class_Units.html","First-Class Units",false],
["first-ec",">srfi-std/srfi-42.html#first-ec",[0,[6,"first-ec"]],["srfi/42"]],
["first-line-currently-drawn-specially?",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3afirst-line~3c~25~3e)._first-line-currently-drawn-specially~3f))",[[0,[1,"first-line-currently-drawn-specially?"]],[12,[" (method of ",[0,[1,"text:first-line&lt;%&gt;"]],")"]]],["framework"]],
["first-opened",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e)._first-opened))",[[0,[1,"first-opened"]],[12,[" (method of ",[0,[1,"drscheme:language:language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["fit",">plot/plot.html#(def._((lib._plot/main..ss)._fit))",[0,[1,"fit"]],["plot"]],
["fit-result",">plot/plot.html#(def._((lib._plot/main..ss)._fit-result))",[0,[1,"fit-result"]],["plot"]],
["fit-result-final-params",">plot/plot.html#(def._((lib._plot/main..ss)._fit-result-final-params))",[0,[1,"fit-result-final-params"]],["plot"]],
["fit-result-function",">plot/plot.html#(def._((lib._plot/main..ss)._fit-result-function))",[0,[1,"fit-result-function"]],["plot"]],
["fit-result-names",">plot/plot.html#(def._((lib._plot/main..ss)._fit-result-names))",[0,[1,"fit-result-names"]],["plot"]],
["fit-result-rms",">plot/plot.html#(def._((lib._plot/main..ss)._fit-result-rms))",[0,[1,"fit-result-rms"]],["plot"]],
["fit-result-std-error",">plot/plot.html#(def._((lib._plot/main..ss)._fit-result-std-error))",[0,[1,"fit-result-std-error"]],["plot"]],
["fit-result-std-error-percent",">plot/plot.html#(def._((lib._plot/main..ss)._fit-result-std-error-percent))",[0,[1,"fit-result-std-error-percent"]],["plot"]],
["fit-result-variance",">plot/plot.html#(def._((lib._plot/main..ss)._fit-result-variance))",[0,[1,"fit-result-variance"]],["plot"]],
["fit-result?",">plot/plot.html#(def._((lib._plot/main..ss)._fit-result~3f))",[0,[1,"fit-result?"]],["plot"]],
["fixed auto-converting string types",">foreign/String_Types.html#(part._.Fixed_.Auto-.Converting_.String_.Types)","Fixed Auto-Converting String Types",false],
["fixed-width-label-snip",">embedded-gui/Helpers.html#(def._((lib._embedded-gui/main..ss)._fixed-width-label-snip))",[0,[1,"fixed-width-label-snip"]],["embedded-gui"]],
["fixnum",">guide/performance.html#(tech._fixnum)","<i>fixnum</i>",false],
["fixnum",">reference/numbers.html#(tech._fixnum)","<i>fixnum</i>",false],
["fixnum and flonum optimizations",">guide/performance.html#(part._fixnums+flonums)","Fixnum and Flonum Optimizations",false],
["fixnum->flonum",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1060",[0,[1,"fixnum-&gt;flonum"]],["rnrs/arithmetic/flonums-6"]],
["fixnum-width",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_858",[0,[1,"fixnum-width"]],["rnrs/arithmetic/fixnums-6"]],
["fixnum?",">reference/numbers.html#(def._((quote._~23~25kernel)._fixnum~3f))",[0,[1,"fixnum?"]],["scheme/base","scheme"]],
["fixnum?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_856",[0,[1,"fixnum?"]],["rnrs/arithmetic/fixnums-6"]],
["fl*",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_988",[0,[1,"fl*"]],["rnrs/arithmetic/flonums-6"]],
["fl+",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_986",[0,[1,"fl+"]],["rnrs/arithmetic/flonums-6"]],
["fl-",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_990",[0,[1,"fl-"]],["rnrs/arithmetic/flonums-6"]],
["fl/",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_994",[0,[1,"fl/"]],["rnrs/arithmetic/flonums-6"]],
["fl<=?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_958",[0,[1,"fl&lt;=?"]],["rnrs/arithmetic/flonums-6"]],
["fl<?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_956",[0,[1,"fl&lt;?"]],["rnrs/arithmetic/flonums-6"]],
["fl=?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_954",[0,[1,"fl=?"]],["rnrs/arithmetic/flonums-6"]],
["fl>=?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_962",[0,[1,"fl&gt;=?"]],["rnrs/arithmetic/flonums-6"]],
["fl>?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_960",[0,[1,"fl&gt;?"]],["rnrs/arithmetic/flonums-6"]],
["flabs",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_998",[0,[1,"flabs"]],["rnrs/arithmetic/flonums-6"]],
["flacos",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1038",[0,[1,"flacos"]],["rnrs/arithmetic/flonums-6"]],
["flag",">scribble/doc-strings.html#(def._((lib._scribble/manual..ss)._.Flag))",[0,[1,"Flag"]],["scribble/manual"]],
["flags and hooks",">inside/Flags_and_Hooks.html","Flags and Hooks",false],
["flash",">slideshow/More_Pict_Constructors.html#(part._.Flash)","Flash",false],
["flash-backward-sexp",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._flash-backward-sexp))",[[0,[1,"flash-backward-sexp"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["flash-forward-sexp",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._flash-forward-sexp))",[[0,[1,"flash-forward-sexp"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["flash-off",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._flash-off))",[[0,[1,"flash-off"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["flash-on",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._flash-on))",[[0,[1,"flash-on"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["flashing parenthesis matches",">drscheme/editor.html#(idx._(gentag._17._(lib._scribblings/drscheme/drscheme..scrbl)))","flashing parenthesis matches",false],
["flasin",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1036",[0,[1,"flasin"]],["rnrs/arithmetic/flonums-6"]],
["flat contract",">reference/Data-structure_Contracts.html#(tech._flat._contract)","<i>flat contract</i>",false],
["flat named contracts",">guide/contracts-general-functions.html#(tech._flat._named._contract)","<i>flat named\ncontracts</i>",false],
["flat-contract",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract-guts..ss)._flat-contract))",[0,[1,"flat-contract"]],["scheme/contract","scheme"]],
["flat-contract-predicate",">reference/Contract_Utilities.html#(def._((lib._scheme/private/contract-guts..ss)._flat-contract-predicate))",[0,[1,"flat-contract-predicate"]],["scheme/contract","scheme"]],
["flat-contract?",">reference/Contract_Utilities.html#(def._((lib._scheme/private/contract-guts..ss)._flat-contract~3f))",[0,[1,"flat-contract?"]],["scheme/contract","scheme"]],
["flat-murec-contract",">reference/Data-structure_Contracts.html#(form._((lib._scheme/private/contract..ss)._flat-murec-contract))",[0,[6,"flat-murec-contract"]],["scheme/contract","scheme"]],
["flat-named-contract",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract-guts..ss)._flat-named-contract))",[0,[1,"flat-named-contract"]],["scheme/contract","scheme"]],
["flat-rec-contract",">reference/Data-structure_Contracts.html#(form._((lib._scheme/private/contract..ss)._flat-rec-contract))",[0,[6,"flat-rec-contract"]],["scheme/contract","scheme"]],
["flatan",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1040",[0,[1,"flatan"]],["rnrs/arithmetic/flonums-6"]],
["flatten",">reference/pairs.html#(def._((lib._scheme/list..ss)._flatten))",[0,[1,"flatten"]],["scheme/list","scheme"]],
["flatten-bitmap",">mrlib/Cache-image_Snip.html#(def._((lib._mrlib/cache-image-snip..ss)._flatten-bitmap))",[0,[1,"flatten-bitmap"]],["mrlib/cache-image-snip"]],
["flattened text",">gui/editor-overview.html#(part._editorflattened)","Flattened Text",false],
["flattened text",">gui/editor-overview.html#(tech._flattened._text)","<i>Flattened text</i>",false],
["flattening syntactic sequences: nest",">reference/nest.html",["Flattening Syntactic Sequences: ",[0,[6,"nest"]]],false],
["flceiling",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1018",[0,[1,"flceiling"]],["rnrs/arithmetic/flonums-6"]],
["flcos",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1032",[0,[1,"flcos"]],["rnrs/arithmetic/flonums-6"]],
["fldenominator",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1014",[0,[1,"fldenominator"]],["rnrs/arithmetic/flonums-6"]],
["fldiv",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1002",[0,[1,"fldiv"]],["rnrs/arithmetic/flonums-6"]],
["fldiv-and-mod",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1000",[0,[1,"fldiv-and-mod"]],["rnrs/arithmetic/flonums-6"]],
["fldiv0",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1008",[0,[1,"fldiv0"]],["rnrs/arithmetic/flonums-6"]],
["fldiv0-and-mod0",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1006",[0,[1,"fldiv0-and-mod0"]],["rnrs/arithmetic/flonums-6"]],
["fleven?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_974",[0,[1,"fleven?"]],["rnrs/arithmetic/flonums-6"]],
["flexp",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1024",[0,[1,"flexp"]],["rnrs/arithmetic/flonums-6"]],
["flexpt",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1046",[0,[1,"flexpt"]],["rnrs/arithmetic/flonums-6"]],
["flfinite?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_976",[0,[1,"flfinite?"]],["rnrs/arithmetic/flonums-6"]],
["flfloor",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1016",[0,[1,"flfloor"]],["rnrs/arithmetic/flonums-6"]],
["flinfinite?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_978",[0,[1,"flinfinite?"]],["rnrs/arithmetic/flonums-6"]],
["flinteger?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_964",[0,[1,"flinteger?"]],["rnrs/arithmetic/flonums-6"]],
["flip",">cards/index.html#(meth._(((lib._games/cards..ss)._card~3c~25~3e)._flip))",[[0,[1,"flip"]],[12,[" (method of ",[0,[1,"card&lt;%&gt;"]],")"]]],["games/cards"]],
["flip-card",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._flip-card))",[[0,[1,"flip-card"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["flip-cards",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._flip-cards))",[[0,[1,"flip-cards"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["flip-ellipse",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._flip-ellipse))",[0,[1,"flip-ellipse"]],["graphics/graphics"]],
["flip-line",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._flip-line))",[0,[1,"flip-line"]],["graphics/graphics"]],
["flip-pixel",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._flip-pixel))",[0,[1,"flip-pixel"]],["graphics/graphics"]],
["flip-polygon",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._flip-polygon))",[0,[1,"flip-polygon"]],["graphics/graphics"]],
["flip-rectangle",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._flip-rectangle))",[0,[1,"flip-rectangle"]],["graphics/graphics"]],
["flip-solid-ellipse",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._flip-solid-ellipse))",[0,[1,"flip-solid-ellipse"]],["graphics/graphics"]],
["flip-solid-polygon",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._flip-solid-polygon))",[0,[1,"flip-solid-polygon"]],["graphics/graphics"]],
["flip-solid-rectangle",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._flip-solid-rectangle))",[0,[1,"flip-solid-rectangle"]],["graphics/graphics"]],
["flip-string",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._flip-string))",[0,[1,"flip-string"]],["graphics/graphics"]],
["flip-viewport",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._flip-viewport))",[0,[1,"flip-viewport"]],["graphics/graphics"]],
["fllog",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1026",[0,[1,"fllog"]],["rnrs/arithmetic/flonums-6"]],
["flmax",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_982",[0,[1,"flmax"]],["rnrs/arithmetic/flonums-6"]],
["flmin",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_984",[0,[1,"flmin"]],["rnrs/arithmetic/flonums-6"]],
["flmod",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1004",[0,[1,"flmod"]],["rnrs/arithmetic/flonums-6"]],
["flmod0",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1010",[0,[1,"flmod0"]],["rnrs/arithmetic/flonums-6"]],
["flnan?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_980",[0,[1,"flnan?"]],["rnrs/arithmetic/flonums-6"]],
["flnegative?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_970",[0,[1,"flnegative?"]],["rnrs/arithmetic/flonums-6"]],
["flnumerator",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1012",[0,[1,"flnumerator"]],["rnrs/arithmetic/flonums-6"]],
["floating-point-bytes->real",">reference/numbers.html#(def._((quote._~23~25kernel)._floating-point-bytes-~3ereal))",[0,[1,"floating-point-bytes-&gt;real"]],["scheme/base","scheme"]],
["flodd?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_972",[0,[1,"flodd?"]],["rnrs/arithmetic/flonums-6"]],
["flonum",">guide/performance.html#(tech._flonum)","<i>flonum</i>",false],
["flonum?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_950",[0,[1,"flonum?"]],["rnrs/arithmetic/flonums-6"]],
["floor",">reference/numbers.html#(def._((quote._~23~25kernel)._floor))",[0,[1,"floor"]],["scheme/base","scheme"]],
["floor",">r5rs-std/r5rs-Z-H-9.html#%_idx_314",[0,[1,"floor"]],["r5rs"]],
["floor",">r6rs-std/r6rs-Z-H-14.html#node_idx_528",[0,[1,"floor"]],["rnrs/base-6"]],
["floor",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._floor))",[0,[1,"floor"]],["lang/htdp-advanced"]],
["floor",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._floor))",[0,[1,"floor"]],["lang/htdp-beginner"]],
["floor",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._floor))",[0,[1,"floor"]],["lang/htdp-beginner-abbr"]],
["floor",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._floor))",[0,[1,"floor"]],["lang/htdp-intermediate"]],
["floor",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._floor))",[0,[1,"floor"]],["lang/htdp-intermediate-lambda"]],
["flow",">scribble/struct.html#(def._((lib._scribble/struct..ss)._flow))",[0,[1,"flow"]],["scribble/struct"]],
["flow",">scribble/struct.html#(tech._flow)","<i>flow</i>",false],
["flow-paragraphs",">scribble/struct.html#(def._((lib._scribble/struct..ss)._flow-paragraphs))",[0,[1,"flow-paragraphs"]],["scribble/struct"]],
["flow?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._flow~3f))",[0,[1,"flow?"]],["scribble/struct"]],
["flpositive?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_968",[0,[1,"flpositive?"]],["rnrs/arithmetic/flonums-6"]],
["flround",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1022",[0,[1,"flround"]],["rnrs/arithmetic/flonums-6"]],
["flsin",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1030",[0,[1,"flsin"]],["rnrs/arithmetic/flonums-6"]],
["flsqrt",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1044",[0,[1,"flsqrt"]],["rnrs/arithmetic/flonums-6"]],
["fltan",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1034",[0,[1,"fltan"]],["rnrs/arithmetic/flonums-6"]],
["fltruncate",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1020",[0,[1,"fltruncate"]],["rnrs/arithmetic/flonums-6"]],
["fluid-let",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..ss)._fluid-let))",[0,[6,"fluid-let"]],["mzscheme"]],
["flush-display",">gui/Drawing_Functions.html#(def._((lib._mred/main..ss)._flush-display))",[0,[1,"flush-display"]],["scheme/gui/base","scheme/gui"]],
["flush-output",">reference/port-buffers.html#(def._((quote._~23~25kernel)._flush-output))",[0,[1,"flush-output"]],["scheme/base","scheme"]],
["flush-output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_712",[0,[1,"flush-output-port"]],["rnrs/io/ports-6"]],
["flush-output-port",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..ss)._flush-output-port))",[0,[1,"flush-output-port"]],["mzlib/compat"]],
["flushing",">graphics/Flushing.html","Flushing",false],
["flzero?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_966",[0,[1,"flzero?"]],["rnrs/arithmetic/flonums-6"]],
["focus",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._focus))",[[0,[1,"focus"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["focus",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._focus))",[[0,[1,"focus"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["fold",">srfi-std/srfi-1.html#fold",[0,[1,"fold"]],["srfi/1"]],
["fold-ec",">srfi-std/srfi-42.html#fold-ec",[0,[6,"fold-ec"]],["srfi/42"]],
["fold-files",">reference/Filesystem.html#(def._((lib._scheme/file..ss)._fold-files))",[0,[1,"fold-files"]],["scheme/file","scheme"]],
["fold-left",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_212",[0,[1,"fold-left"]],["rnrs/lists-6"]],
["fold-plt-archive",">setup-plt/_plt-archives.html#(def._((lib._setup/unpack..ss)._fold-plt-archive))",[0,[1,"fold-plt-archive"]],["setup/unpack"]],
["fold-right",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_214",[0,[1,"fold-right"]],["rnrs/lists-6"]],
["fold-right",">srfi-std/srfi-1.html#fold-right",[0,[1,"fold-right"]],["srfi/1"]],
["fold-snip",">embedded-gui/snip-related-functions.html#(def._((lib._embedded-gui/main..ss)._fold-snip))",[0,[1,"fold-snip"]],["embedded-gui"]],
["fold3-ec",">srfi-std/srfi-42.html#fold3-ec",[0,[6,"fold3-ec"]],["srfi/42"]],
["foldl",">reference/pairs.html#(def._((lib._scheme/base..ss)._foldl))",[0,[1,"foldl"]],["scheme/base","scheme"]],
["foldl",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._foldl))",[0,[1,"foldl"]],["lang/htdp-advanced"]],
["foldl",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._foldl))",[0,[1,"foldl"]],["lang/htdp-intermediate"]],
["foldl",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._foldl))",[0,[1,"foldl"]],["lang/htdp-intermediate-lambda"]],
["foldl",">lazy/index.html#(def._((lib._lazy/main..ss)._foldl))",[0,[1,"foldl"]],["lazy"]],
["foldr",">reference/pairs.html#(def._((lib._scheme/base..ss)._foldr))",[0,[1,"foldr"]],["scheme/base","scheme"]],
["foldr",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._foldr))",[0,[1,"foldr"]],["lang/htdp-advanced"]],
["foldr",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._foldr))",[0,[1,"foldr"]],["lang/htdp-intermediate"]],
["foldr",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._foldr))",[0,[1,"foldr"]],["lang/htdp-intermediate-lambda"]],
["foldr",">lazy/index.html#(def._((lib._lazy/main..ss)._foldr))",[0,[1,"foldr"]],["lazy"]],
["foldr",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..ss)._foldr))",[0,[1,"foldr"]],["mzlib/integer-set"]],
["font",">drscheme/prefs-explanation.html#(part._.Font)","<b><font size=\"-1\" face=\"Helvetica\">Font</font></b>",false],
["font",">html/index.html#(def._((lib._html/main..ss)._font))",[0,[1,"font"]],["html"]],
["font configuration",">gui/fontresources.html","Font Configuration",false],
["font%",">gui/font_.html",[0,[1,"font%"]],["scheme/gui/base","scheme/gui"]],
["font-family",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._font-family))",[[0,[1,"font-family"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["font-family-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._font-family-native))",[[0,[1,"font-family-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["font-list%",">gui/font-list_.html",[0,[1,"font-list%"]],["scheme/gui/base","scheme/gui"]],
["font-name-directory<%>",">gui/font-name-directory___.html",[0,[1,"font-name-directory&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["font-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._font-native))",[[0,[1,"font-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["font-size",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._font-size))",[[0,[1,"font-size"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["font-size-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._font-size-native))",[[0,[1,"font-size-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["font-style",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._font-style))",[[0,[1,"font-style"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["font-style-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._font-style-native))",[[0,[1,"font-style-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["font-variant",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._font-variant))",[[0,[1,"font-variant"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["font-variant-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._font-variant-native))",[[0,[1,"font-variant-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["font-weight",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._font-weight))",[[0,[1,"font-weight"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["font-weight-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._font-weight-native))",[[0,[1,"font-weight-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["font?",">html/index.html#(def._((lib._html/main..ss)._font~3f))",[0,[1,"font?"]],["html"]],
["fonts postscript",">gui/fontresources.html#(idx._(gentag._308._(lib._scribblings/gui/gui..scrbl)))","fonts, PostScript",false],
["fonts",">gui/Drawing_Functions.html#(part._.Fonts)","Fonts",false],
["for",">reference/for.html#(form._((lib._scheme/base..ss)._for))",[0,[6,"for"]],["scheme/base","scheme"]],
["for and for*",">guide/for.html#(part._for_and_for_)",[[0,[6,"for"]]," and ",[0,[6,"for*"]]],false],
["for*",">reference/for.html#(form._((lib._scheme/base..ss)._for*))",[0,[6,"for*"]],["scheme/base","scheme"]],
["for*/and",">reference/for.html#(form._((lib._scheme/base..ss)._for*/and))",[0,[6,"for*/and"]],["scheme/base","scheme"]],
["for*/first",">reference/for.html#(form._((lib._scheme/base..ss)._for*/first))",[0,[6,"for*/first"]],["scheme/base","scheme"]],
["for*/fold",">reference/for.html#(form._((lib._scheme/base..ss)._for*/fold))",[0,[6,"for*/fold"]],["scheme/base","scheme"]],
["for*/fold/derived",">reference/for.html#(form._((lib._scheme/base..ss)._for*/fold/derived))",[0,[6,"for*/fold/derived"]],["scheme/base","scheme"]],
["for*/hash",">reference/for.html#(form._((lib._scheme/base..ss)._for*/hash))",[0,[6,"for*/hash"]],["scheme/base","scheme"]],
["for*/hasheq",">reference/for.html#(form._((lib._scheme/base..ss)._for*/hasheq))",[0,[6,"for*/hasheq"]],["scheme/base","scheme"]],
["for*/last",">reference/for.html#(form._((lib._scheme/base..ss)._for*/last))",[0,[6,"for*/last"]],["scheme/base","scheme"]],
["for*/list",">reference/for.html#(form._((lib._scheme/base..ss)._for*/list))",[0,[6,"for*/list"]],["scheme/base","scheme"]],
["for*/lists",">reference/for.html#(form._((lib._scheme/base..ss)._for*/lists))",[0,[6,"for*/lists"]],["scheme/base","scheme"]],
["for*/or",">reference/for.html#(form._((lib._scheme/base..ss)._for*/or))",[0,[6,"for*/or"]],["scheme/base","scheme"]],
["for-all",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_204",[0,[1,"for-all"]],["rnrs/lists-6"]],
["for-each",">reference/pairs.html#(def._((quote._~23~25kernel)._for-each))",[0,[1,"for-each"]],["scheme/base","scheme"]],
["for-each",">r5rs-std/r5rs-Z-H-9.html#%_idx_582",[0,[1,"for-each"]],["r5rs"]],
["for-each",">r6rs-std/r6rs-Z-H-14.html#node_idx_644",[0,[1,"for-each"]],["rnrs/base-6"]],
["for-each",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._for-each))",[0,[1,"for-each"]],["lang/htdp-advanced"]],
["for-each",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._for-each))",[0,[1,"for-each"]],["lang/htdp-intermediate"]],
["for-each",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._for-each))",[0,[1,"for-each"]],["lang/htdp-intermediate-lambda"]],
["for-each",">embedded-gui/dllist___.html#(meth._(((lib._embedded-gui/main..ss)._dllist~3c~25~3e)._for-each))",[[0,[1,"for-each"]],[12,[" (method of ",[0,[1,"dllist&lt;%&gt;"]],")"]]],["embedded-gui"]],
["for-each",">lazy/index.html#(def._((lib._lazy/main..ss)._for-each))",[0,[1,"for-each"]],["lazy"]],
["for-each",">srfi-std/srfi-1.html#srfi-1.html",[0,[1,"for-each"]],["srfi/1"]],
["for-each-frame",">framework/Group.html#(meth._(((lib._framework/main..ss)._group~3a~25)._for-each-frame))",[[0,[1,"for-each-frame"]],[12,[" (method of ",[0,[1,"group:%"]],")"]]],["framework"]],
["for-each-snip",">embedded-gui/snip-related-functions.html#(def._((lib._embedded-gui/main..ss)._for-each-snip))",[0,[1,"for-each-snip"]],["embedded-gui"]],
["for-label",">reference/require.html#(form._((lib._scheme/base..ss)._for-label))",[0,[6,"for-label"]],["scheme/base","scheme"]],
["for-meta",">reference/require.html#(form._((lib._scheme/base..ss)._for-meta))",[0,[6,"for-meta"]],["scheme/base","scheme"]],
["for-syntax",">reference/require.html#(form._((lib._scheme/base..ss)._for-syntax))",[0,[6,"for-syntax"]],["scheme/base","scheme"]],
["for-template",">reference/require.html#(form._((lib._scheme/base..ss)._for-template))",[0,[6,"for-template"]],["scheme/base","scheme"]],
["for/and",">reference/for.html#(form._((lib._scheme/base..ss)._for/and))",[0,[6,"for/and"]],["scheme/base","scheme"]],
["for/and and for/or",">guide/for.html#(part._for_and_and_for_or)",[[0,[6,"for/and"]]," and ",[0,[6,"for/or"]]],false],
["for/first",">reference/for.html#(form._((lib._scheme/base..ss)._for/first))",[0,[6,"for/first"]],["scheme/base","scheme"]],
["for/first and for/last",">guide/for.html#(part._for_first_and_for_last)",[[0,[6,"for/first"]]," and ",[0,[6,"for/last"]]],false],
["for/fold",">reference/for.html#(form._((lib._scheme/base..ss)._for/fold))",[0,[6,"for/fold"]],["scheme/base","scheme"]],
["for/fold and for*/fold",">guide/for.html#(part._for/fold)",[[0,[6,"for/fold"]]," and ",[0,[6,"for*/fold"]]],false],
["for/fold/derived",">reference/for.html#(form._((lib._scheme/base..ss)._for/fold/derived))",[0,[6,"for/fold/derived"]],["scheme/base","scheme"]],
["for/hash",">reference/for.html#(form._((lib._scheme/base..ss)._for/hash))",[0,[6,"for/hash"]],["scheme/base","scheme"]],
["for/hasheq",">reference/for.html#(form._((lib._scheme/base..ss)._for/hasheq))",[0,[6,"for/hasheq"]],["scheme/base","scheme"]],
["for/last",">reference/for.html#(form._((lib._scheme/base..ss)._for/last))",[0,[6,"for/last"]],["scheme/base","scheme"]],
["for/list",">reference/for.html#(form._((lib._scheme/base..ss)._for/list))",[0,[6,"for/list"]],["scheme/base","scheme"]],
["for/list and for*/list",">guide/for.html#(part._for_list_and_for__list)",[[0,[6,"for/list"]]," and ",[0,[6,"for*/list"]]],false],
["for/lists",">reference/for.html#(form._((lib._scheme/base..ss)._for/lists))",[0,[6,"for/lists"]],["scheme/base","scheme"]],
["for/or",">reference/for.html#(form._((lib._scheme/base..ss)._for/or))",[0,[6,"for/or"]],["scheme/base","scheme"]],
["force",">reference/Delayed_Evaluation.html#(def._((lib._scheme/promise..ss)._force))",[0,[1,"force"]],["scheme/promise","scheme"]],
["force",">r5rs-std/r5rs-Z-H-9.html#%_idx_584",[0,[1,"force"]],["r5rs"]],
["force",">r6rs-lib-std/r6rs-lib-Z-H-20.html#node_idx_1304",[0,[1,"force"]],["rnrs/r5rs-6"]],
["force",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._force))",[0,[1,"force"]],["lang/htdp-advanced"]],
["force",">srfi-std/srfi-45.html#force",[0,[1,"force"]],["srfi/45"]],
["force-display-focus",">gui/editor-canvas_.html#(meth._(((lib._mred/main..ss)._editor-canvas~25)._force-display-focus))",[[0,[1,"force-display-focus"]],[12,[" (method of ",[0,[1,"editor-canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["force-stop-colorer",">framework/Color.html#(meth._(((lib._framework/main..ss)._color~3atext~3c~25~3e)._force-stop-colorer))",[[0,[1,"force-stop-colorer"]],[12,[" (method of ",[0,[1,"color:text&lt;%&gt;"]],")"]]],["framework"]],
["force-unpack",">setup-plt/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..ss)._setup-option~5e._force-unpack))",[0,[1,"force-unpack"]],["setup/option-sig"]],
["forcing values",">lazy/index.html#(part._forcing)","Forcing Values",false],
["forever",">gui/editor___.html#(idx._(gentag._235._(lib._scribblings/gui/gui..scrbl)))",[7,"'forever"],false],
["forget-notification",">gui/style-list_.html#(meth._(((lib._mred/main..ss)._style-list~25)._forget-notification))",[[0,[1,"forget-notification"]],[12,[" (method of ",[0,[1,"style-list%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["form",">html/index.html#(def._((lib._html/main..ss)._form))",[0,[1,"form"]],["html"]],
["form-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._form-index-desc))",[0,[1,"form-index-desc"]],["scribble/manual-struct"]],
["form-index-desc?",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._form-index-desc~3f))",[0,[1,"form-index-desc?"]],["scribble/manual-struct"]],
["form-urlencoded->alist",">net/uri-codec.html#(def._((lib._net/uri-codec..ss)._form-urlencoded-~3ealist))",[0,[1,"form-urlencoded-&gt;alist"]],["net/uri-codec"]],
["form-urlencoded-deecode",">net/uri-codec.html#(def._((lib._net/uri-codec..ss)._form-urlencoded-deecode))",[0,"form-urlencoded-deecode"],["net/uri-codec"]],
["form-urlencoded-encode",">net/uri-codec.html#(def._((lib._net/uri-codec..ss)._form-urlencoded-encode))",[0,[1,"form-urlencoded-encode"]],["net/uri-codec"]],
["form?",">html/index.html#(def._((lib._html/main..ss)._form~3f))",[0,[1,"form?"]],["html"]],
["format",">reference/Writing.html#(def._((quote._~23~25kernel)._format))",[0,[1,"format"]],["scheme/base","scheme"]],
["format",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._format))",[0,[1,"format"]],["lang/htdp-advanced"]],
["format",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._format))",[0,[1,"format"]],["lang/htdp-beginner"]],
["format",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._format))",[0,[1,"format"]],["lang/htdp-beginner-abbr"]],
["format",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._format))",[0,[1,"format"]],["lang/htdp-intermediate"]],
["format",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._format))",[0,[1,"format"]],["lang/htdp-intermediate-lambda"]],
["format",">srfi-std/srfi-28.html#format",[0,[1,"format"]],["srfi/28"]],
["format",">srfi-std/srfi-48.html#format",[0,[1,"format"]],["srfi/48"]],
["format of \".plt\" archives",">setup-plt/_plt-archives.html#(part._format-of-..plt-archives)",["Format of ",[5,"\".plt\""]," Archives"],false],
["format-req/c",">web-server/dispatch-log_ss.html#(def._((lib._web-server/dispatchers/dispatch-log..ss)._format-req/c))",[0,[1,"format-req/c"]],["web-server/dispatchers/dispatch-log"]],
["formatting scheme code",">drscheme/editor.html#(idx._(gentag._19._(lib._scribblings/drscheme/drscheme..scrbl)))","formatting Scheme code",false],
["formlet",">web-server/Syntactic_Shorthand.html#(form._((lib._web-server/formlets/syntax..ss)._formlet))",[0,[6,"formlet"]],["web-server/formlets/syntax"]],
["formlet",">web-server/Functional_Usage.html#(tech._formlet)","<i>formlet</i>",false],
["formlet-display",">web-server/Functional_Usage.html#(def._((lib._web-server/formlets/lib..ss)._formlet-display))",[0,[1,"formlet-display"]],["web-server/formlets/lib"]],
["formlet-process",">web-server/Functional_Usage.html#(def._((lib._web-server/formlets/lib..ss)._formlet-process))",[0,[1,"formlet-process"]],["web-server/formlets/lib"]],
["formlet/c",">web-server/Functional_Usage.html#(def._((lib._web-server/formlets/lib..ss)._formlet/c))",[0,[1,"formlet/c"]],["web-server/formlets/lib"]],
["formlets",">web-server/formlets.html","Formlets",false],
["forward",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-panel-mixin)._forward))",[[0,[1,"forward"]],[12,[" (method of ",[0,[1,"hyper-panel-mixin"]],")"]]],["browser"]],
["forward-match",">framework/Color.html#(meth._(((lib._framework/main..ss)._color~3atext~3c~25~3e)._forward-match))",[[0,[1,"forward-match"]],[12,[" (method of ",[0,[1,"color:text&lt;%&gt;"]],")"]]],["framework"]],
["forward-sexp",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._forward-sexp))",[[0,[1,"forward-sexp"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["fourth",">reference/pairs.html#(def._((lib._scheme/list..ss)._fourth))",[0,[1,"fourth"]],["scheme/list","scheme"]],
["fourth",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._fourth))",[0,[1,"fourth"]],["lang/htdp-advanced"]],
["fourth",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._fourth))",[0,[1,"fourth"]],["lang/htdp-beginner"]],
["fourth",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._fourth))",[0,[1,"fourth"]],["lang/htdp-beginner-abbr"]],
["fourth",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._fourth))",[0,[1,"fourth"]],["lang/htdp-intermediate"]],
["fourth",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._fourth))",[0,[1,"fourth"]],["lang/htdp-intermediate-lambda"]],
["fourth",">lazy/index.html#(def._((lib._lazy/main..ss)._fourth))",[0,[1,"fourth"]],["lazy"]],
["fourth",">mzlib/mzlib_list.html#(def._((lib._mzlib/list..ss)._fourth))",[0,[1,"fourth"]],["mzlib/list"]],
["fourth",">srfi-std/srfi-1.html#fourth",[0,[1,"fourth"]],["srfi/1"]],
["fprintf",">reference/Writing.html#(def._((quote._~23~25kernel)._fprintf))",[0,[1,"fprintf"]],["scheme/base","scheme"]],
["fprintf",">lazy/index.html#(def._((lib._lazy/main..ss)._fprintf))",[0,[1,"fprintf"]],["lazy"]],
["frame",">framework/Frame.html","Frame",false],
["frame",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._frame))",[0,[1,"frame"]],["slideshow/pict","slideshow"]],
["frame",">gui/windowing-overview.html#(tech._frame)","<i>frame</i>",false],
["frame%",">gui/frame_.html",[0,[1,"frame%"]],["scheme/gui/base","scheme/gui"]],
["frame-label-changed",">framework/Group.html#(meth._(((lib._framework/main..ss)._group~3a~25)._frame-label-changed))",[[0,[1,"frame-label-changed"]],[12,[" (method of ",[0,[1,"group:%"]],")"]]],["framework"]],
["frame-shown/hidden",">framework/Group.html#(meth._(((lib._framework/main..ss)._group~3a~25)._frame-shown/hidden))",[[0,[1,"frame-shown/hidden"]],[12,[" (method of ",[0,[1,"group:%"]],")"]]],["framework"]],
["frame:add-snip-menu-items",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3aadd-snip-menu-items))",[0,[1,"frame:add-snip-menu-items"]],["framework"]],
["frame:basic%",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3abasic~25))",[0,[1,"frame:basic%"]],["framework"]],
["frame:basic-mixin",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3abasic-mixin))",[0,[1,"frame:basic-mixin"]],["framework"]],
["frame:basic<%>",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3abasic~3c~25~3e))",[0,[1,"frame:basic&lt;%&gt;"]],["framework"]],
["frame:delegate%",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3adelegate~25))",[0,[1,"frame:delegate%"]],["framework"]],
["frame:delegate-mixin",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3adelegate-mixin))",[0,[1,"frame:delegate-mixin"]],["framework"]],
["frame:delegate<%>",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3adelegate~3c~25~3e))",[0,[1,"frame:delegate&lt;%&gt;"]],["framework"]],
["frame:editor%",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3aeditor~25))",[0,[1,"frame:editor%"]],["framework"]],
["frame:editor-mixin",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3aeditor-mixin))",[0,[1,"frame:editor-mixin"]],["framework"]],
["frame:editor<%>",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3aeditor~3c~25~3e))",[0,[1,"frame:editor&lt;%&gt;"]],["framework"]],
["frame:info%",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3ainfo~25))",[0,[1,"frame:info%"]],["framework"]],
["frame:info-mixin",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3ainfo-mixin))",[0,[1,"frame:info-mixin"]],["framework"]],
["frame:info<%>",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3ainfo~3c~25~3e))",[0,[1,"frame:info&lt;%&gt;"]],["framework"]],
["frame:open-here%",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3aopen-here~25))",[0,[1,"frame:open-here%"]],["framework"]],
["frame:open-here-mixin",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3aopen-here-mixin))",[0,[1,"frame:open-here-mixin"]],["framework"]],
["frame:open-here<%>",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3aopen-here~3c~25~3e))",[0,[1,"frame:open-here&lt;%&gt;"]],["framework"]],
["frame:pasteboard%",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3apasteboard~25))",[0,[1,"frame:pasteboard%"]],["framework"]],
["frame:pasteboard-info%",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3apasteboard-info~25))",[0,[1,"frame:pasteboard-info%"]],["framework"]],
["frame:pasteboard-info-mixin",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3apasteboard-info-mixin))",[0,[1,"frame:pasteboard-info-mixin"]],["framework"]],
["frame:pasteboard-info<%>",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3apasteboard-info~3c~25~3e))",[0,[1,"frame:pasteboard-info&lt;%&gt;"]],["framework"]],
["frame:pasteboard-mixin",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3apasteboard-mixin))",[0,[1,"frame:pasteboard-mixin"]],["framework"]],
["frame:pasteboard<%>",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3apasteboard~3c~25~3e))",[0,[1,"frame:pasteboard&lt;%&gt;"]],["framework"]],
["frame:register-group-mixin",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3aregister-group-mixin))",[0,[1,"frame:register-group-mixin"]],["framework"]],
["frame:register-group<%>",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3aregister-group~3c~25~3e))",[0,[1,"frame:register-group&lt;%&gt;"]],["framework"]],
["frame:remove-empty-menus",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3aremove-empty-menus))",[0,[1,"frame:remove-empty-menus"]],["framework"]],
["frame:reorder-menus",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3areorder-menus))",[0,[1,"frame:reorder-menus"]],["framework"]],
["frame:searchable%",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3asearchable~25))",[0,[1,"frame:searchable%"]],["framework"]],
["frame:searchable-mixin",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3asearchable-mixin))",[0,[1,"frame:searchable-mixin"]],["framework"]],
["frame:searchable-text-mixin",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3asearchable-text-mixin))",[0,[1,"frame:searchable-text-mixin"]],["framework"]],
["frame:searchable-text<%>",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3asearchable-text~3c~25~3e))",[0,[1,"frame:searchable-text&lt;%&gt;"]],["framework"]],
["frame:searchable<%>",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3asearchable~3c~25~3e))",[0,[1,"frame:searchable&lt;%&gt;"]],["framework"]],
["frame:setup-size-pref",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3asetup-size-pref))",[0,[1,"frame:setup-size-pref"]],["framework"]],
["frame:size-pref%",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3asize-pref~25))",[0,[1,"frame:size-pref%"]],["framework"]],
["frame:size-pref-mixin",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3asize-pref-mixin))",[0,[1,"frame:size-pref-mixin"]],["framework"]],
["frame:size-pref<%>",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3asize-pref~3c~25~3e))",[0,[1,"frame:size-pref&lt;%&gt;"]],["framework"]],
["frame:standard-menus%",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3astandard-menus~25))",[0,[1,"frame:standard-menus%"]],["framework"]],
["frame:standard-menus-mixin",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3astandard-menus-mixin))",[0,[1,"frame:standard-menus-mixin"]],["framework"]],
["frame:standard-menus<%>",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e))",[0,[1,"frame:standard-menus&lt;%&gt;"]],["framework"]],
["frame:status-line%",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3astatus-line~25))",[0,[1,"frame:status-line%"]],["framework"]],
["frame:status-line-mixin",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3astatus-line-mixin))",[0,[1,"frame:status-line-mixin"]],["framework"]],
["frame:status-line<%>",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3astatus-line~3c~25~3e))",[0,[1,"frame:status-line&lt;%&gt;"]],["framework"]],
["frame:text%",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3atext~25))",[0,[1,"frame:text%"]],["framework"]],
["frame:text-info%",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3atext-info~25))",[0,[1,"frame:text-info%"]],["framework"]],
["frame:text-info-mixin",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3atext-info-mixin))",[0,[1,"frame:text-info-mixin"]],["framework"]],
["frame:text-info<%>",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3atext-info~3c~25~3e))",[0,[1,"frame:text-info&lt;%&gt;"]],["framework"]],
["frame:text-mixin",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3atext-mixin))",[0,[1,"frame:text-mixin"]],["framework"]],
["frame:text<%>",">framework/Frame.html#(def._((lib._framework/main..ss)._frame~3atext~3c~25~3e))",[0,[1,"frame:text&lt;%&gt;"]],["framework"]],
["framework",">framework/index.html",[14,[0,"framework"]],"module"],
["framework",">reference/runtime.html#(idx._(gentag._306._(lib._scribblings/reference/reference..scrbl)))",[7,"'framework"],false],
["framework/gui-utils",">framework/GUI_Utilities.html",[14,[0,"framework/gui-utils"]],"module"],
["framework/preferences",">framework/Preferences__Textual.html",[14,[0,"framework/preferences"]],"module"],
["framework/test",">framework/Test.html",[14,[0,"framework/test"]],"module"],
["framework: plt gui application framework",">framework/index.html","<b>Framework</b>: PLT GUI Application Framework",false],
["fred: functional reactive wrapper around mred",">frtime/index.html#(part._fred)","Fred: Functional Reactive Wrapper around MrEd",false],
["free",">foreign/foreign_pointer-funcs.html#(def._((lib._scribblings/foreign/unsafe-foreign..ss)._free))",[0,[1,"free"]],["scribblings/foreign/unsafe-foreign"]],
["free-identifier-mapping-for-each",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..ss)._free-identifier-mapping-for-each))",[0,[1,"free-identifier-mapping-for-each"]],["syntax/boundmap"]],
["free-identifier-mapping-get",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..ss)._free-identifier-mapping-get))",[0,[1,"free-identifier-mapping-get"]],["syntax/boundmap"]],
["free-identifier-mapping-map",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..ss)._free-identifier-mapping-map))",[0,[1,"free-identifier-mapping-map"]],["syntax/boundmap"]],
["free-identifier-mapping-put!",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..ss)._free-identifier-mapping-put!))",[0,[1,"free-identifier-mapping-put!"]],["syntax/boundmap"]],
["free-identifier-mapping?",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..ss)._free-identifier-mapping~3f))",[0,[1,"free-identifier-mapping?"]],["syntax/boundmap"]],
["free-identifier=?",">reference/stxcmp.html#(def._((quote._~23~25kernel)._free-identifier~3d~3f))",[0,[1,"free-identifier=?"]],["scheme/base","scheme"]],
["free-identifier=?",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1142",[0,[1,"free-identifier=?"]],["rnrs/syntax-case-6"]],
["free-identifier=?",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..ss)._free-identifier~3d~3f))",[0,[1,"free-identifier=?"]],["mzscheme"]],
["free-immobile-cell",">foreign/foreign_pointer-funcs.html#(def._((lib._scribblings/foreign/unsafe-foreign..ss)._free-immobile-cell))",[0,[1,"free-immobile-cell"]],["scribblings/foreign/unsafe-foreign"]],
["free-label-identifier=?",">reference/stxcmp.html#(def._((quote._~23~25kernel)._free-label-identifier~3d~3f))",[0,[1,"free-label-identifier=?"]],["scheme/base","scheme"]],
["free-template-identifier=?",">reference/stxcmp.html#(def._((quote._~23~25kernel)._free-template-identifier~3d~3f))",[0,[1,"free-template-identifier=?"]],["scheme/base","scheme"]],
["free-transformer-identifier=?",">reference/stxcmp.html#(def._((quote._~23~25kernel)._free-transformer-identifier~3d~3f))",[0,[1,"free-transformer-identifier=?"]],["scheme/base","scheme"]],
["free-vars",">syntax/syntax-helpers.html#(def._((lib._syntax/free-vars..ss)._free-vars))",[0,[1,"free-vars"]],["syntax/free-vars"]],
["freeze-colorer",">framework/Color.html#(meth._(((lib._framework/main..ss)._color~3atext~3c~25~3e)._freeze-colorer))",[[0,[1,"freeze-colorer"]],[12,[" (method of ",[0,[1,"color:text&lt;%&gt;"]],")"]]],["framework"]],
["fresh",">redex/Reduction_Relations.html#(form._((lib._redex/main..ss)._fresh))",[0,[6,"fresh"]],["redex"]],
["from-id",">mysterx/html-events.html#(meth._(((lib._mysterx/main..ss)._mx-event~3c~25~3e)._from-id))",[[0,[1,"from-id"]],[12,[" (method of ",[0,[1,"mx-event&lt;%&gt;"]],")"]]],["mysterx"]],
["from-tag",">mysterx/html-events.html#(meth._(((lib._mysterx/main..ss)._mx-event~3c~25~3e)._from-tag))",[[0,[1,"from-tag"]],[12,[" (method of ",[0,[1,"mx-event&lt;%&gt;"]],")"]]],["mysterx"]],
["front-end/complete-program",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e)._front-end/complete-program))",[[0,[1,"front-end/complete-program"]],[12,[" (method of ",[0,[1,"drscheme:language:language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["front-end/complete-program",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3amodule-based-language-~3elanguage-mixin)._front-end/complete-program))",[[0,[1,"front-end/complete-program"]],[12,[" (method of ",[0,[1,"drscheme:language:module-based-language-&gt;language-mixin"]],")"]]],["drscheme/tool-lib"]],
["front-end/finished-complete-program",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e)._front-end/finished-complete-program))",[[0,[1,"front-end/finished-complete-program"]],[12,[" (method of ",[0,[1,"drscheme:language:language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["front-end/interaction",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e)._front-end/interaction))",[[0,[1,"front-end/interaction"]],[12,[" (method of ",[0,[1,"drscheme:language:language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["front-end/interaction",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3amodule-based-language-~3elanguage-mixin)._front-end/interaction))",[[0,[1,"front-end/interaction"]],[12,[" (method of ",[0,[1,"drscheme:language:module-based-language-&gt;language-mixin"]],")"]]],["drscheme/tool-lib"]],
["frtime",">frtime/index.html",[14,[0,"frtime"]],"module"],
["frtime/gui/fred",">frtime/index.html#(mod-path._frtime/gui/fred)",[14,[0,"frtime/gui/fred"]],"module"],
["frtime: a language for reactive programs",">frtime/index.html","<b>FrTime</b>: A Language for Reactive Programs",false],
["ft-button%",">frtime/index.html#(def._((lib._frtime/gui/fred..ss)._ft-button~25))",[0,[1,"ft-button%"]],["frtime/gui/fred"]],
["ft-check-box%",">frtime/index.html#(def._((lib._frtime/gui/fred..ss)._ft-check-box~25))",[0,[1,"ft-check-box%"]],["frtime/gui/fred"]],
["ft-choice%",">frtime/index.html#(def._((lib._frtime/gui/fred..ss)._ft-choice~25))",[0,[1,"ft-choice%"]],["frtime/gui/fred"]],
["ft-frame%",">frtime/index.html#(def._((lib._frtime/gui/fred..ss)._ft-frame~25))",[0,[1,"ft-frame%"]],["frtime/gui/fred"]],
["ft-list-box%",">frtime/index.html#(def._((lib._frtime/gui/fred..ss)._ft-list-box~25))",[0,[1,"ft-list-box%"]],["frtime/gui/fred"]],
["ft-message%",">frtime/index.html#(def._((lib._frtime/gui/fred..ss)._ft-message~25))",[0,[1,"ft-message%"]],["frtime/gui/fred"]],
["ft-radio-box%",">frtime/index.html#(def._((lib._frtime/gui/fred..ss)._ft-radio-box~25))",[0,[1,"ft-radio-box%"]],["frtime/gui/fred"]],
["ft-slider%",">frtime/index.html#(def._((lib._frtime/gui/fred..ss)._ft-slider~25))",[0,[1,"ft-slider%"]],["frtime/gui/fred"]],
["ft-text-field%",">frtime/index.html#(def._((lib._frtime/gui/fred..ss)._ft-text-field~25))",[0,[1,"ft-text-field%"]],["frtime/gui/fred"]],
["ftp signature",">net/ftp.html#(part._.F.T.P_.Signature)","FTP Signature",false],
["ftp unit",">net/ftp.html#(part._.F.T.P_.Unit)","FTP Unit",false],
["ftp-cd",">net/ftp.html#(def._((lib._net/ftp..ss)._ftp-cd))",[0,[1,"ftp-cd"]],["net/ftp"]],
["ftp-close-connection",">net/ftp.html#(def._((lib._net/ftp..ss)._ftp-close-connection))",[0,[1,"ftp-close-connection"]],["net/ftp"]],
["ftp-connection?",">net/ftp.html#(def._((lib._net/ftp..ss)._ftp-connection~3f))",[0,[1,"ftp-connection?"]],["net/ftp"]],
["ftp-directory-list",">net/ftp.html#(def._((lib._net/ftp..ss)._ftp-directory-list))",[0,[1,"ftp-directory-list"]],["net/ftp"]],
["ftp-download-file",">net/ftp.html#(def._((lib._net/ftp..ss)._ftp-download-file))",[0,[1,"ftp-download-file"]],["net/ftp"]],
["ftp-establish-connection",">net/ftp.html#(def._((lib._net/ftp..ss)._ftp-establish-connection))",[0,[1,"ftp-establish-connection"]],["net/ftp"]],
["ftp-make-file-seconds",">net/ftp.html#(def._((lib._net/ftp..ss)._ftp-make-file-seconds))",[0,[1,"ftp-make-file-seconds"]],["net/ftp"]],
["ftp: client downloading",">net/ftp.html","FTP: Client Downloading",false],
["ftp@",">net/ftp.html#(def._((lib._net/ftp-unit..ss)._ftp~40))",[0,[1,"ftp@"]],["net/ftp-unit"]],
["ftp^",">net/ftp.html#(form._((lib._net/ftp-sig..ss)._ftp~5e))",[0,[6,"ftp^"]],["net/ftp-sig"]],
["full-page",">slideshow/Constants_and_Layout_Variables.html#(form._((lib._slideshow/base..ss)._full-page))",[0,[6,"full-page"]],["slideshow/base","slideshow"]],
["fully expanded programs",">reference/syntax-model.html#(part._fully-expanded)","Fully Expanded Programs",false],
["function calls",">htdp-langs/beginner-call.html","Function Calls",false],
["function calls",">htdp-langs/intermediate-call.html","Function Calls",false],
["function calls",">htdp-langs/intermediate-lambda-call.html","Function Calls",false],
["function calls (procedure applications)",">guide/syntax-overview.html#(part._.Function_.Calls__.Procedure_.Applications_)","Function Calls (Procedure Applications)",false],
["function calls (procedure applications)",">guide/application.html","Function Calls (Procedure Applications)",false],
["function calls, again",">guide/syntax-overview.html#(part._.Function_.Calls__.Again)","Function Calls, Again",false],
["function contract",">reference/Function_Contracts.html#(tech._function._contract)","<i>function contract</i>",false],
["function contracts",">reference/Function_Contracts.html","Function Contracts",false],
["function shorthand",">guide/define.html#(part._.Function_.Shorthand)","Function Shorthand",false],
["function types",">foreign/foreign_procedures.html","Function Types",false],
["function-call optimizations",">guide/performance.html#(part._func-call-performance)","Function-Call Optimizations",false],
["functional",">web-server/web-server_ss.html","Functional",false],
["functional update",">guide/define-struct.html#(tech._functional._update)","<i>functional update</i>",false],
["functional usage",">web-server/Functional_Usage.html","Functional Usage",false],
["functions",">net/head.html#(part._.Functions)","Functions",false],
["functions",">net/base64.html#(part._base64-procs)","Functions",false],
["functions",">net/cookie.html#(part._cookie-procs)","Functions",false],
["functions",">net/dns.html#(part._dns-proc)","Functions",false],
["functions",">net/ftp.html#(part._ftp-procs)","Functions",false],
["functions",">net/qp.html#(part._qp-procs)","Functions",false],
["functions",">net/uri-codec.html#(part._uri-codec-proc)","Functions",false],
["functions (procedures): lambda",">guide/lambda.html",["Functions (Procedures): ",[0,[6,"lambda"]]],false],
["functions are values",">quick/index.html#(part._.Functions_are_.Values)","Functions are Values",false],
["fx*",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_890",[0,[1,"fx*"]],["rnrs/arithmetic/fixnums-6"]],
["fx*/carry",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_912",[0,[1,"fx*/carry"]],["rnrs/arithmetic/fixnums-6"]],
["fx+",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_888",[0,[1,"fx+"]],["rnrs/arithmetic/fixnums-6"]],
["fx+/carry",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_908",[0,[1,"fx+/carry"]],["rnrs/arithmetic/fixnums-6"]],
["fx-",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_892",[0,[1,"fx-"]],["rnrs/arithmetic/fixnums-6"]],
["fx-/carry",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_910",[0,[1,"fx-/carry"]],["rnrs/arithmetic/fixnums-6"]],
["fx<=?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_872",[0,[1,"fx&lt;=?"]],["rnrs/arithmetic/fixnums-6"]],
["fx<?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_868",[0,[1,"fx&lt;?"]],["rnrs/arithmetic/fixnums-6"]],
["fx=?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_864",[0,[1,"fx=?"]],["rnrs/arithmetic/fixnums-6"]],
["fx>=?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_870",[0,[1,"fx&gt;=?"]],["rnrs/arithmetic/fixnums-6"]],
["fx>?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_866",[0,[1,"fx&gt;?"]],["rnrs/arithmetic/fixnums-6"]],
["fxand",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_916",[0,[1,"fxand"]],["rnrs/arithmetic/fixnums-6"]],
["fxarithmetic-shift",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_938",[0,[1,"fxarithmetic-shift"]],["rnrs/arithmetic/fixnums-6"]],
["fxarithmetic-shift-left",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_940",[0,[1,"fxarithmetic-shift-left"]],["rnrs/arithmetic/fixnums-6"]],
["fxarithmetic-shift-right",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_942",[0,[1,"fxarithmetic-shift-right"]],["rnrs/arithmetic/fixnums-6"]],
["fxbit-count",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_924",[0,[1,"fxbit-count"]],["rnrs/arithmetic/fixnums-6"]],
["fxbit-field",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_934",[0,[1,"fxbit-field"]],["rnrs/arithmetic/fixnums-6"]],
["fxbit-set?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_930",[0,[1,"fxbit-set?"]],["rnrs/arithmetic/fixnums-6"]],
["fxcopy-bit",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_932",[0,[1,"fxcopy-bit"]],["rnrs/arithmetic/fixnums-6"]],
["fxcopy-bit-field",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_936",[0,[1,"fxcopy-bit-field"]],["rnrs/arithmetic/fixnums-6"]],
["fxdiv",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_898",[0,[1,"fxdiv"]],["rnrs/arithmetic/fixnums-6"]],
["fxdiv-and-mod",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_896",[0,[1,"fxdiv-and-mod"]],["rnrs/arithmetic/fixnums-6"]],
["fxdiv0",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_904",[0,[1,"fxdiv0"]],["rnrs/arithmetic/fixnums-6"]],
["fxdiv0-and-mod0",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_902",[0,[1,"fxdiv0-and-mod0"]],["rnrs/arithmetic/fixnums-6"]],
["fxeven?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_882",[0,[1,"fxeven?"]],["rnrs/arithmetic/fixnums-6"]],
["fxfirst-bit-set",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_928",[0,[1,"fxfirst-bit-set"]],["rnrs/arithmetic/fixnums-6"]],
["fxif",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_922",[0,[1,"fxif"]],["rnrs/arithmetic/fixnums-6"]],
["fxior",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_918",[0,[1,"fxior"]],["rnrs/arithmetic/fixnums-6"]],
["fxlength",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_926",[0,[1,"fxlength"]],["rnrs/arithmetic/fixnums-6"]],
["fxmax",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_884",[0,[1,"fxmax"]],["rnrs/arithmetic/fixnums-6"]],
["fxmin",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_886",[0,[1,"fxmin"]],["rnrs/arithmetic/fixnums-6"]],
["fxmod",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_900",[0,[1,"fxmod"]],["rnrs/arithmetic/fixnums-6"]],
["fxmod0",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_906",[0,[1,"fxmod0"]],["rnrs/arithmetic/fixnums-6"]],
["fxnegative?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_878",[0,[1,"fxnegative?"]],["rnrs/arithmetic/fixnums-6"]],
["fxnot",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_914",[0,[1,"fxnot"]],["rnrs/arithmetic/fixnums-6"]],
["fxodd?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_880",[0,[1,"fxodd?"]],["rnrs/arithmetic/fixnums-6"]],
["fxpositive?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_876",[0,[1,"fxpositive?"]],["rnrs/arithmetic/fixnums-6"]],
["fxreverse-bit-field",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_946",[0,[1,"fxreverse-bit-field"]],["rnrs/arithmetic/fixnums-6"]],
["fxrotate-bit-field",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_944",[0,[1,"fxrotate-bit-field"]],["rnrs/arithmetic/fixnums-6"]],
["fxxor",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_920",[0,[1,"fxxor"]],["rnrs/arithmetic/fixnums-6"]],
["fxzero?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_874",[0,[1,"fxzero?"]],["rnrs/arithmetic/fixnums-6"]],
["gambit-c",">cffi/index.html#(idx._(gentag._0._(lib._compiler/cffi..scrbl)))","Gambit-C",false],
["game rules",">games/gobblet.html#(part._.Game_.Rules)","Game Rules",false],
["games/cards",">cards/index.html",[14,[0,"games/cards"]],"module"],
["games/gl-board-game",">gl-board-game/index.html",[14,[0,"games/gl-board-game"]],"module"],
["games/show-help",">games/Showing_Text_Help.html",[14,[0,"games/show-help"]],"module"],
["games/show-scribbling",">games/Showing_Scribbled_Help.html",[14,[0,"games/show-scribbling"]],"module"],
["games: fun examples",">games/index.html","<b>Games</b>: Fun Examples",false],
["gamma correction",">gui/bitmap_.html#(idx._(gentag._169._(lib._scribblings/gui/gui..scrbl)))","gamma correction",false],
["gap-size",">slideshow/Constants_and_Layout_Variables.html#(def._((lib._slideshow/base..ss)._gap-size))",[0,[1,"gap-size"]],["slideshow/base","slideshow"]],
["garbage collection",">reference/garbagecollection.html","Garbage Collection",false],
["garbage collection",">reference/eval-model.html#(part._gc-model)","Garbage Collection",false],
["garbage collection",">inside/im_memoryalloc.html","garbage collection",false],
["garbage collection",">reference/eval-model.html#(tech._garbage._collection)","<i>garbage\ncollection</i>",false],
["gauge",">gui/windowing-overview.html#(tech._gauge)","<i>gauge</i>",false],
["gauge%",">gui/gauge_.html",[0,[1,"gauge%"]],["scheme/gui/base","scheme/gui"]],
["gc",">reference/runtime.html#(idx._(gentag._299._(lib._scribblings/reference/reference..scrbl)))",[7,"'gc"],false],
["gc_fixup_self",">inside/im_memoryalloc.html#(idx._(gentag._237._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"GC_fixup_self"]],false],
["gc_register_traversers",">inside/im_memoryalloc.html#(idx._(gentag._235._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"GC_register_traversers"]],false],
["gc_resolve",">inside/im_memoryalloc.html#(idx._(gentag._236._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"GC_resolve"]],false],
["gcalc --- visual \u03bb-calculus",">games/gcalc.html",[[13,"<img src=\"gcalc.png\" />"]," ","<b><font size=\"-1\" face=\"Helvetica\">GCalc</font></b>","  ","&ndash;","  Visual ","&#955;","-Calculus"],false],
["gcd",">reference/numbers.html#(def._((quote._~23~25kernel)._gcd))",[0,[1,"gcd"]],["scheme/base","scheme"]],
["gcd",">r5rs-std/r5rs-Z-H-9.html#%_idx_306",[0,[1,"gcd"]],["r5rs"]],
["gcd",">r6rs-std/r6rs-Z-H-14.html#node_idx_520",[0,[1,"gcd"]],["rnrs/base-6"]],
["gcd",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._gcd))",[0,[1,"gcd"]],["lang/htdp-advanced"]],
["gcd",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._gcd))",[0,[1,"gcd"]],["lang/htdp-beginner"]],
["gcd",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._gcd))",[0,[1,"gcd"]],["lang/htdp-beginner-abbr"]],
["gcd",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._gcd))",[0,[1,"gcd"]],["lang/htdp-intermediate"]],
["gcd",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._gcd))",[0,[1,"gcd"]],["lang/htdp-intermediate-lambda"]],
["gen-authentication-responder",">web-server/responders_ss.html#(def._((lib._web-server/configuration/responders..ss)._gen-authentication-responder))",[0,[1,"gen-authentication-responder"]],["web-server/configuration/responders"]],
["gen-collect-garbage-responder",">web-server/responders_ss.html#(def._((lib._web-server/configuration/responders..ss)._gen-collect-garbage-responder))",[0,[1,"gen-collect-garbage-responder"]],["web-server/configuration/responders"]],
["gen-file-not-found-responder",">web-server/responders_ss.html#(def._((lib._web-server/configuration/responders..ss)._gen-file-not-found-responder))",[0,[1,"gen-file-not-found-responder"]],["web-server/configuration/responders"]],
["gen-passwords-refreshed",">web-server/responders_ss.html#(def._((lib._web-server/configuration/responders..ss)._gen-passwords-refreshed))",[0,[1,"gen-passwords-refreshed"]],["web-server/configuration/responders"]],
["gen-protocol-responder",">web-server/responders_ss.html#(def._((lib._web-server/configuration/responders..ss)._gen-protocol-responder))",[0,[1,"gen-protocol-responder"]],["web-server/configuration/responders"]],
["gen-servlet-not-found",">web-server/responders_ss.html#(def._((lib._web-server/configuration/responders..ss)._gen-servlet-not-found))",[0,[1,"gen-servlet-not-found"]],["web-server/configuration/responders"]],
["gen-servlet-responder",">web-server/responders_ss.html#(def._((lib._web-server/configuration/responders..ss)._gen-servlet-responder))",[0,[1,"gen-servlet-responder"]],["web-server/configuration/responders"]],
["gen-servlets-refreshed",">web-server/responders_ss.html#(def._((lib._web-server/configuration/responders..ss)._gen-servlets-refreshed))",[0,[1,"gen-servlets-refreshed"]],["web-server/configuration/responders"]],
["general",">web-server/dispatch_ss.html","General",false],
["general",">web-server/manager_ss.html","General",false],
["general macro transformers",">guide/proc-macros.html","General Macro Transformers",false],
["generate-error-output",">net/cgi.html#(def._((lib._net/cgi..ss)._generate-error-output))",[0,[1,"generate-error-output"]],["net/cgi"]],
["generate-expand-context",">syntax/transformer-helpers.html#(def._((lib._syntax/context..ss)._generate-expand-context))",[0,[1,"generate-expand-context"]],["syntax/context"]],
["generate-html-output",">net/cgi.html#(def._((lib._net/cgi..ss)._generate-html-output))",[0,[1,"generate-html-output"]],["net/cgi"]],
["generate-link-text",">net/cgi.html#(def._((lib._net/cgi..ss)._generate-link-text))",[0,[1,"generate-link-text"]],["net/cgi"]],
["generate-member-key",">reference/createclass.html#(def._((lib._scheme/private/class-internal..ss)._generate-member-key))",[0,[1,"generate-member-key"]],["scheme/class","scheme"]],
["generate-struct-declaration",">syntax/transformer-helpers.html#(def._((lib._syntax/struct..ss)._generate-struct-declaration))",[0,[1,"generate-struct-declaration"]],["syntax/struct"]],
["generate-temporaries",">reference/stxops.html#(def._((lib._scheme/private/stxcase-scheme..ss)._generate-temporaries))",[0,[1,"generate-temporaries"]],["scheme/base","scheme"]],
["generate-temporaries",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1150",[0,[1,"generate-temporaries"]],["rnrs/syntax-case-6"]],
["generated-tag",">scribble/struct.html#(def._((lib._scribble/struct..ss)._generated-tag))",[0,[1,"generated-tag"]],["scribble/struct"]],
["generated-tag?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._generated-tag~3f))",[0,[1,"generated-tag?"]],["scribble/struct"]],
["generating a unit from context",">reference/Generating_A_Unit_from_Context.html","Generating A Unit from Context",false],
["generating activex html",">mysterx/Generating_ActiveX_HTML.html","Generating ActiveX HTML",false],
["generational garbage collector",">guide/performance.html#(tech._generational._garbage._collector)","<i>generational garbage collector</i>",false],
["generator",">srfi-std/srfi-42.html#generator",[0,[6,"generator"]],["srfi/42"]],
["generic",">reference/ivaraccess.html#(form._((lib._scheme/private/class-internal..ss)._generic))",[0,[6,"generic"]],["scheme/class","scheme"]],
["generic",">reference/ivaraccess.html#(tech._generic)","<i>generic</i>",false],
["generic-message-command",">net/nntp.html#(def._((lib._net/nntp..ss)._generic-message-command))",[0,[1,"generic-message-command"]],["net/nntp"]],
["generic?",">reference/objectutils.html#(def._((lib._scheme/private/class-internal..ss)._generic~3f))",[0,[1,"generic?"]],["scheme/class","scheme"]],
["generics",">reference/ivaraccess.html#(part._.Generics)","Generics",false],
["gensym",">reference/symbols.html#(def._((quote._~23~25kernel)._gensym))",[0,[1,"gensym"]],["scheme/base","scheme"]],
["gentmp",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..ss)._gentmp))",[0,"gentmp"],["mzlib/compat"]],
["geometry management",">gui/windowing-overview.html#(part._containeroverview)","Geometry Management",false],
["geometry: geometry.*",">teachpack/geometry.html","Geometry: geometry.*",false],
["get",">gui/add-color___.html#(meth._(((lib._mred/main..ss)._add-color~3c~25~3e)._get))",[[0,[1,"get"]],[12,[" (method of ",[0,[1,"add-color&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get",">gui/editor-stream-in_.html#(meth._(((lib._mred/main..ss)._editor-stream-in~25)._get))",[[0,[1,"get"]],[12,[" (method of ",[0,[1,"editor-stream-in%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get",">gui/mult-color___.html#(meth._(((lib._mred/main..ss)._mult-color~3c~25~3e)._get))",[[0,[1,"get"]],[12,[" (method of ",[0,[1,"mult-color&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-accum-size",">gui/gl-config_.html#(meth._(((lib._mred/main..ss)._gl-config~25)._get-accum-size))",[[0,[1,"get-accum-size"]],[12,[" (method of ",[0,[1,"gl-config%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-active-canvas",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._get-active-canvas))",[[0,[1,"get-active-canvas"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-active-frame",">framework/Group.html#(meth._(((lib._framework/main..ss)._group~3a~25)._get-active-frame))",[[0,[1,"get-active-frame"]],[12,[" (method of ",[0,[1,"group:%"]],")"]]],["framework"]],
["get-additional-important-urls",">tools/drscheme_frame.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aframe~3abasics-mixin)._get-additional-important-urls))",[[0,[1,"get-additional-important-urls"]],[12,[" (method of ",[0,[1,"drscheme:frame:basics-mixin"]],")"]]],["drscheme/tool-lib"]],
["get-admin",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._get-admin))",[[0,[1,"get-admin"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-admin",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._get-admin))",[[0,[1,"get-admin"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-align-top-line",">gui/editor-snip_.html#(meth._(((lib._mred/main..ss)._editor-snip~25)._get-align-top-line))",[[0,[1,"get-align-top-line"]],[12,[" (method of ",[0,[1,"editor-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-aligned-min-height",">embedded-gui/stretchable-snip___.html#(meth._(((lib._embedded-gui/main..ss)._stretchable-snip~3c~25~3e)._get-aligned-min-height))",[[0,[1,"get-aligned-min-height"]],[12,[" (method of ",[0,[1,"stretchable-snip&lt;%&gt;"]],")"]]],["embedded-gui"]],
["get-aligned-min-height",">mrlib/aligned-pasteboard___.html#(meth._(((lib._mrlib/aligned-pasteboard..ss)._aligned-pasteboard~3c~25~3e)._get-aligned-min-height))",[[0,[1,"get-aligned-min-height"]],[12,[" (method of ",[0,[1,"aligned-pasteboard&lt;%&gt;"]],")"]]],["mrlib/aligned-pasteboard"]],
["get-aligned-min-height",">mrlib/stretchable-snip___.html#(meth._(((lib._mrlib/aligned-pasteboard..ss)._stretchable-snip~3c~25~3e)._get-aligned-min-height))",[[0,[1,"get-aligned-min-height"]],[12,[" (method of ",[0,[1,"stretchable-snip&lt;%&gt;"]],")"]]],["mrlib/aligned-pasteboard"]],
["get-aligned-min-width",">embedded-gui/stretchable-snip___.html#(meth._(((lib._embedded-gui/main..ss)._stretchable-snip~3c~25~3e)._get-aligned-min-width))",[[0,[1,"get-aligned-min-width"]],[12,[" (method of ",[0,[1,"stretchable-snip&lt;%&gt;"]],")"]]],["embedded-gui"]],
["get-aligned-min-width",">mrlib/aligned-pasteboard___.html#(meth._(((lib._mrlib/aligned-pasteboard..ss)._aligned-pasteboard~3c~25~3e)._get-aligned-min-width))",[[0,[1,"get-aligned-min-width"]],[12,[" (method of ",[0,[1,"aligned-pasteboard&lt;%&gt;"]],")"]]],["mrlib/aligned-pasteboard"]],
["get-aligned-min-width",">mrlib/stretchable-snip___.html#(meth._(((lib._mrlib/aligned-pasteboard..ss)._stretchable-snip~3c~25~3e)._get-aligned-min-width))",[[0,[1,"get-aligned-min-width"]],[12,[" (method of ",[0,[1,"stretchable-snip&lt;%&gt;"]],")"]]],["mrlib/aligned-pasteboard"]],
["get-alignment",">gui/area-container___.html#(meth._(((lib._mred/main..ss)._area-container~3c~25~3e)._get-alignment))",[[0,[1,"get-alignment"]],[12,[" (method of ",[0,[1,"area-container&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-alignment",">gui/style___.html#(meth._(((lib._mred/main..ss)._style~3c~25~3e)._get-alignment))",[[0,[1,"get-alignment"]],[12,[" (method of ",[0,[1,"style&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-alignment-off",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._get-alignment-off))",[[0,[1,"get-alignment-off"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-alignment-on",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._get-alignment-on))",[[0,[1,"get-alignment-on"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-all-words",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aautocomplete~3c~25~3e)._get-all-words))",[[0,[1,"get-all-words"]],[12,[" (method of ",[0,[1,"text:autocomplete&lt;%&gt;"]],")"]]],["framework"]],
["get-allow-edits",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._get-allow-edits))",[[0,[1,"get-allow-edits"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["get-allow-selection?",">mrlib/hierarchical-list-item___.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list-item~3c~25~3e)._get-allow-selection~3f))",[[0,[1,"get-allow-selection?"]],[12,[" (method of ",[0,[1,"hierarchical-list-item&lt;%&gt;"]],")"]]],["mrlib/hierlist"]],
["get-alpha",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._get-alpha))",[[0,[1,"get-alpha"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-alt",">plot/extend.html#(meth._(((lib._plot/extend..ss)._3d-view~25)._get-alt))",[[0,[1,"get-alt"]],[12,[" (method of ",[0,[1,"3d-view%"]],")"]]],["plot/extend"]],
["get-alt-down",">gui/key-event_.html#(meth._(((lib._mred/main..ss)._key-event~25)._get-alt-down))",[[0,[1,"get-alt-down"]],[12,[" (method of ",[0,[1,"key-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-alt-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._get-alt-down))",[[0,[1,"get-alt-down"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-anchor",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._get-anchor))",[[0,[1,"get-anchor"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-area-container",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3abasic~3c~25~3e)._get-area-container))",[[0,[1,"get-area-container"]],[12,[" (method of ",[0,[1,"frame:basic&lt;%&gt;"]],")"]]],["framework"]],
["get-area-container%",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3abasic~3c~25~3e)._get-area-container~25))",[[0,[1,"get-area-container%"]],[12,[" (method of ",[0,[1,"frame:basic&lt;%&gt;"]],")"]]],["framework"]],
["get-arg",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..ss)._get-arg))",[0,[1,"get-arg"]],["preprocessor/mztext"]],
["get-arg*",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..ss)._get-arg*))",[0,[1,"get-arg*"]],["preprocessor/mztext"]],
["get-arg-reads-word?",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..ss)._get-arg-reads-word~3f))",[0,[1,"get-arg-reads-word?"]],["preprocessor/mztext"]],
["get-argb",">mrlib/Cache-image_Snip.html#(meth._(((lib._mrlib/cache-image-snip..ss)._cache-image-snip~25)._get-argb))",[[0,[1,"get-argb"]],[12,[" (method of ",[0,[1,"cache-image-snip%"]],")"]]],["mrlib/cache-image-snip"]],
["get-argb",">gui/WXME_Decoding.html#(meth._(((lib._wxme/cache-image..ss)._cache-image~25)._get-argb))",[[0,[1,"get-argb"]],[12,[" (method of ",[0,[1,"cache-image%"]],")"]]],["wxme/cache-image"]],
["get-argb-pixels",">gui/bitmap_.html#(meth._(((lib._mred/main..ss)._bitmap~25)._get-argb-pixels))",[[0,[1,"get-argb-pixels"]],[12,[" (method of ",[0,[1,"bitmap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-argb-pixels",">gui/bitmap-dc_.html#(meth._(((lib._mred/main..ss)._bitmap-dc~25)._get-argb-pixels))",[[0,[1,"get-argb-pixels"]],[12,[" (method of ",[0,[1,"bitmap-dc%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-argb-proc",">mrlib/Cache-image_Snip.html#(meth._(((lib._mrlib/cache-image-snip..ss)._cache-image-snip~25)._get-argb-proc))",[[0,[1,"get-argb-proc"]],[12,[" (method of ",[0,[1,"cache-image-snip%"]],")"]]],["mrlib/cache-image-snip"]],
["get-argb/no-compute",">mrlib/Cache-image_Snip.html#(meth._(((lib._mrlib/cache-image-snip..ss)._cache-image-snip~25)._get-argb/no-compute))",[[0,[1,"get-argb/no-compute"]],[12,[" (method of ",[0,[1,"cache-image-snip%"]],")"]]],["mrlib/cache-image-snip"]],
["get-arrow-snip",">mrlib/hierarchical-list-compound-item___.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list-compound-item~3c~25~3e)._get-arrow-snip))",[[0,[1,"get-arrow-snip"]],[12,[" (method of ",[0,[1,"hierarchical-list-compound-item&lt;%&gt;"]],")"]]],["mrlib/hierlist"]],
["get-arrowhead-params",">mrlib/graph-pasteboard___.html#(meth._(((lib._mrlib/graph..ss)._graph-pasteboard~3c~25~3e)._get-arrowhead-params))",[[0,[1,"get-arrowhead-params"]],[12,[" (method of ",[0,[1,"graph-pasteboard&lt;%&gt;"]],")"]]],["mrlib/graph"]],
["get-autocomplete-background-color",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aautocomplete~3c~25~3e)._get-autocomplete-background-color))",[[0,[1,"get-autocomplete-background-color"]],[12,[" (method of ",[0,[1,"text:autocomplete&lt;%&gt;"]],")"]]],["framework"]],
["get-autocomplete-border-color",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aautocomplete~3c~25~3e)._get-autocomplete-border-color))",[[0,[1,"get-autocomplete-border-color"]],[12,[" (method of ",[0,[1,"text:autocomplete&lt;%&gt;"]],")"]]],["framework"]],
["get-autocomplete-selected-color",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aautocomplete~3c~25~3e)._get-autocomplete-selected-color))",[[0,[1,"get-autocomplete-selected-color"]],[12,[" (method of ",[0,[1,"text:autocomplete&lt;%&gt;"]],")"]]],["framework"]],
["get-az",">plot/extend.html#(meth._(((lib._plot/extend..ss)._3d-view~25)._get-az))",[[0,[1,"get-az"]],[12,[" (method of ",[0,[1,"3d-view%"]],")"]]],["plot/extend"]],
["get-b",">gui/add-color___.html#(meth._(((lib._mred/main..ss)._add-color~3c~25~3e)._get-b))",[[0,[1,"get-b"]],[12,[" (method of ",[0,[1,"add-color&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-b",">gui/mult-color___.html#(meth._(((lib._mred/main..ss)._mult-color~3c~25~3e)._get-b))",[[0,[1,"get-b"]],[12,[" (method of ",[0,[1,"mult-color&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-background",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._get-background))",[[0,[1,"get-background"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-background",">gui/style___.html#(meth._(((lib._mred/main..ss)._style~3c~25~3e)._get-background))",[[0,[1,"get-background"]],[12,[" (method of ",[0,[1,"style&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-background-add",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._get-background-add))",[[0,[1,"get-background-add"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-background-color",">mrlib/Name_Message.html#(meth._(((lib._mrlib/name-message..ss)._name-message~25)._get-background-color))",[[0,[1,"get-background-color"]],[12,[" (method of ",[0,[1,"name-message%"]],")"]]],["mrlib/name-message"]],
["get-background-mult",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._get-background-mult))",[[0,[1,"get-background-mult"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-backward-sexp",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._get-backward-sexp))",[[0,[1,"get-backward-sexp"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["get-base-style",">gui/style___.html#(meth._(((lib._mred/main..ss)._style~3c~25~3e)._get-base-style))",[[0,[1,"get-base-style"]],[12,[" (method of ",[0,[1,"style&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-between-threshold",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._get-between-threshold))",[[0,[1,"get-between-threshold"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-bindings",">net/cgi.html#(def._((lib._net/cgi..ss)._get-bindings))",[0,[1,"get-bindings"]],["net/cgi"]],
["get-bindings/get",">net/cgi.html#(def._((lib._net/cgi..ss)._get-bindings/get))",[0,[1,"get-bindings/get"]],["net/cgi"]],
["get-bindings/post",">net/cgi.html#(def._((lib._net/cgi..ss)._get-bindings/post))",[0,[1,"get-bindings/post"]],["net/cgi"]],
["get-bitmap",">gui/bitmap-dc_.html#(meth._(((lib._mred/main..ss)._bitmap-dc~25)._get-bitmap))",[[0,[1,"get-bitmap"]],[12,[" (method of ",[0,[1,"bitmap-dc%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-bitmap",">gui/image-snip_.html#(meth._(((lib._mred/main..ss)._image-snip~25)._get-bitmap))",[[0,[1,"get-bitmap"]],[12,[" (method of ",[0,[1,"image-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-bitmap",">mrlib/Cache-image_Snip.html#(meth._(((lib._mrlib/cache-image-snip..ss)._cache-image-snip~25)._get-bitmap))",[[0,[1,"get-bitmap"]],[12,[" (method of ",[0,[1,"cache-image-snip%"]],")"]]],["mrlib/cache-image-snip"]],
["get-bitmap-mask",">gui/image-snip_.html#(meth._(((lib._mred/main..ss)._image-snip~25)._get-bitmap-mask))",[[0,[1,"get-bitmap-mask"]],[12,[" (method of ",[0,[1,"image-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-bounding-box",">gui/dc-path_.html#(meth._(((lib._mred/main..ss)._dc-path~25)._get-bounding-box))",[[0,[1,"get-bounding-box"]],[12,[" (method of ",[0,[1,"dc-path%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-bounding-box",">gui/region_.html#(meth._(((lib._mred/main..ss)._region~25)._get-bounding-box))",[[0,[1,"get-bounding-box"]],[12,[" (method of ",[0,[1,"region%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-box-input-editor-snip%",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._get-box-input-editor-snip~25))",[[0,[1,"get-box-input-editor-snip%"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["get-box-input-text%",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._get-box-input-text~25))",[[0,[1,"get-box-input-text%"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["get-break-button",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._get-break-button))",[[0,[1,"get-break-button"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["get-breakables",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3acontext~3c~25~3e)._get-breakables))",[[0,[1,"get-breakables"]],[12,[" (method of ",[0,[1,"drscheme:rep:context&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-breakables",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3atab~3c~25~3e)._get-breakables))",[[0,[1,"get-breakables"]],[12,[" (method of ",[0,[1,"drscheme:unit:tab&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-brush",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._get-brush))",[[0,[1,"get-brush"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-button-panel",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._get-button-panel))",[[0,[1,"get-button-panel"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["get-bytes",">gui/editor-stream-in_.html#(meth._(((lib._mred/main..ss)._editor-stream-in~25)._get-bytes))",[[0,[1,"get-bytes"]],[12,[" (method of ",[0,[1,"editor-stream-in%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-bytes",">gui/editor-stream-out-bytes-base_.html#(meth._(((lib._mred/main..ss)._editor-stream-out-bytes-base~25)._get-bytes))",[[0,[1,"get-bytes"]],[12,[" (method of ",[0,[1,"editor-stream-out-bytes-base%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-bytevector-all",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_694",[0,[1,"get-bytevector-all"]],["rnrs/io/ports-6"]],
["get-bytevector-n",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_688",[0,[1,"get-bytevector-n"]],["rnrs/io/ports-6"]],
["get-bytevector-n!",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_690",[0,[1,"get-bytevector-n!"]],["rnrs/io/ports-6"]],
["get-bytevector-some",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_692",[0,[1,"get-bytevector-some"]],["rnrs/io/ports-6"]],
["get-can-close-parent",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3afile~3c~25~3e)._get-can-close-parent))",[[0,[1,"get-can-close-parent"]],[12,[" (method of ",[0,[1,"editor:file&lt;%&gt;"]],")"]]],["framework"]],
["get-canvas",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._get-canvas))",[[0,[1,"get-canvas"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-canvas",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-panel-mixin)._get-canvas))",[[0,[1,"get-canvas"]],[12,[" (method of ",[0,[1,"hyper-panel-mixin"]],")"]]],["browser"]],
["get-canvas",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._get-canvas))",[[0,[1,"get-canvas"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["get-canvas",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor~3c~25~3e)._get-canvas))",[[0,[1,"get-canvas"]],[12,[" (method of ",[0,[1,"frame:editor&lt;%&gt;"]],")"]]],["framework"]],
["get-canvas%",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-panel-mixin)._get-canvas~25))",[[0,[1,"get-canvas%"]],[12,[" (method of ",[0,[1,"hyper-panel-mixin"]],")"]]],["browser"]],
["get-canvas%",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._get-canvas~25))",[[0,[1,"get-canvas%"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["get-canvas%",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor~3c~25~3e)._get-canvas~25))",[[0,[1,"get-canvas%"]],[12,[" (method of ",[0,[1,"frame:editor&lt;%&gt;"]],")"]]],["framework"]],
["get-canvas-background",">gui/canvas___.html#(meth._(((lib._mred/main..ss)._canvas~3c~25~3e)._get-canvas-background))",[[0,[1,"get-canvas-background"]],[12,[" (method of ",[0,[1,"canvas&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-canvas<%>",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor~3c~25~3e)._get-canvas~3c~25~3e))",[[0,[1,"get-canvas&lt;%&gt;"]],[12,[" (method of ",[0,[1,"frame:editor&lt;%&gt;"]],")"]]],["framework"]],
["get-canvases",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._get-canvases))",[[0,[1,"get-canvases"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-cap",">gui/pen_.html#(meth._(((lib._mred/main..ss)._pen~25)._get-cap))",[[0,[1,"get-cap"]],[12,[" (method of ",[0,[1,"pen%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-caps-down",">gui/key-event_.html#(meth._(((lib._mred/main..ss)._key-event~25)._get-caps-down))",[[0,[1,"get-caps-down"]],[12,[" (method of ",[0,[1,"key-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-caps-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._get-caps-down))",[[0,[1,"get-caps-down"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-case-sensitive-search?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable~3c~25~3e)._get-case-sensitive-search~3f))",[[0,[1,"get-case-sensitive-search?"]],[12,[" (method of ",[0,[1,"frame:searchable&lt;%&gt;"]],")"]]],["framework"]],
["get-center",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._get-center))",[[0,[1,"get-center"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-cgi-method",">net/cgi.html#(def._((lib._net/cgi..ss)._get-cgi-method))",[0,[1,"get-cgi-method"]],["net/cgi"]],
["get-chained-keymaps",">framework/Keymap.html#(meth._(((lib._framework/main..ss)._keymap~3aaug-keymap~3c~25~3e)._get-chained-keymaps))",[[0,[1,"get-chained-keymaps"]],[12,[" (method of ",[0,[1,"keymap:aug-keymap&lt;%&gt;"]],")"]]],["framework"]],
["get-char",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_696",[0,[1,"get-char"]],["rnrs/io/ports-6"]],
["get-char-height",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._get-char-height))",[[0,[1,"get-char-height"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-char-width",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._get-char-width))",[[0,[1,"get-char-width"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-character",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._get-character))",[[0,[1,"get-character"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-checkable-menu-item%",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._get-checkable-menu-item~25))",[[0,[1,"get-checkable-menu-item%"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["get-children",">gui/area-container___.html#(meth._(((lib._mred/main..ss)._area-container~3c~25~3e)._get-children))",[[0,[1,"get-children"]],[12,[" (method of ",[0,[1,"area-container&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-children",">mrlib/graph-snip___.html#(meth._(((lib._mrlib/graph..ss)._graph-snip~3c~25~3e)._get-children))",[[0,[1,"get-children"]],[12,[" (method of ",[0,[1,"graph-snip&lt;%&gt;"]],")"]]],["mrlib/graph"]],
["get-choices-from-user",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._get-choices-from-user))",[0,[1,"get-choices-from-user"]],["scheme/gui/base","scheme/gui"]],
["get-classname",">gui/editor-data-class_.html#(meth._(((lib._mred/main..ss)._editor-data-class~25)._get-classname))",[[0,[1,"get-classname"]],[12,[" (method of ",[0,[1,"editor-data-class%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-classname",">gui/snip-class_.html#(meth._(((lib._mred/main..ss)._snip-class~25)._get-classname))",[[0,[1,"get-classname"]],[12,[" (method of ",[0,[1,"snip-class%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-clickable-snip",">mrlib/hierarchical-list-item___.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list-item~3c~25~3e)._get-clickable-snip))",[[0,[1,"get-clickable-snip"]],[12,[" (method of ",[0,[1,"hierarchical-list-item&lt;%&gt;"]],")"]]],["mrlib/hierlist"]],
["get-client-size",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._get-client-size))",[[0,[1,"get-client-size"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-clipboard-bitmap",">gui/clipboard___.html#(meth._(((lib._mred/main..ss)._clipboard~3c~25~3e)._get-clipboard-bitmap))",[[0,[1,"get-clipboard-bitmap"]],[12,[" (method of ",[0,[1,"clipboard&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-clipboard-data",">gui/clipboard___.html#(meth._(((lib._mred/main..ss)._clipboard~3c~25~3e)._get-clipboard-data))",[[0,[1,"get-clipboard-data"]],[12,[" (method of ",[0,[1,"clipboard&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-clipboard-string",">gui/clipboard___.html#(meth._(((lib._mred/main..ss)._clipboard~3c~25~3e)._get-clipboard-string))",[[0,[1,"get-clipboard-string"]],[12,[" (method of ",[0,[1,"clipboard&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-clipping-region",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._get-clipping-region))",[[0,[1,"get-clipping-region"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-collapsed?",">gui/WXME_Decoding.html#(meth._(((lib._wxme/test-case..ss)._test-case~25)._get-collapsed~3f))",[[0,[1,"get-collapsed?"]],[12,[" (method of ",[0,[1,"test-case%"]],")"]]],["wxme/test-case"]],
["get-collects-search-dirs",">setup-plt/dirs.html#(def._((lib._setup/dirs..ss)._get-collects-search-dirs))",[0,[1,"get-collects-search-dirs"]],["setup/dirs"]],
["get-color",">gui/brush_.html#(meth._(((lib._mred/main..ss)._brush~25)._get-color))",[[0,[1,"get-color"]],[12,[" (method of ",[0,[1,"brush%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-color",">gui/pen_.html#(meth._(((lib._mred/main..ss)._pen~25)._get-color))",[[0,[1,"get-color"]],[12,[" (method of ",[0,[1,"pen%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-color",">framework/editor-snip.html#(meth._(((lib._framework/main..ss)._editor-snip~3adecorated-mixin)._get-color))",[[0,[1,"get-color"]],[12,[" (method of ",[0,[1,"editor-snip:decorated-mixin"]],")"]]],["framework"]],
["get-color",">framework/editor-snip.html#(meth._(((lib._framework/main..ss)._editor-snip~3adecorated~3c~25~3e)._get-color))",[[0,[1,"get-color"]],[12,[" (method of ",[0,[1,"editor-snip:decorated&lt;%&gt;"]],")"]]],["framework"]],
["get-color-from-user",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._get-color-from-user))",[0,[1,"get-color-from-user"]],["scheme/gui/base","scheme/gui"]],
["get-color-pixel",">graphics/posn.html#(def._((lib._graphics/graphics..ss)._get-color-pixel))",[0,[1,"get-color-pixel"]],["graphics/graphics"]],
["get-command",">gui/ps-setup_.html#(meth._(((lib._mred/main..ss)._ps-setup~25)._get-command))",[[0,[1,"get-command"]],[12,[" (method of ",[0,[1,"ps-setup%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-comment",">gui/WXME_Decoding.html#(meth._(((lib._wxme/test-case..ss)._test-case~25)._get-comment))",[[0,[1,"get-comment"]],[12,[" (method of ",[0,[1,"test-case%"]],")"]]],["wxme/test-case"]],
["get-comment-character",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e)._get-comment-character))",[[0,[1,"get-comment-character"]],[12,[" (method of ",[0,[1,"drscheme:language:language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-content-buffer",">mrlib/Snips_in_a_hierarchical-list__Instance.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list-snip~25)._get-content-buffer))",[[0,[1,"get-content-buffer"]],[12,[" (method of ",[0,[1,"hierarchical-list-snip%"]],")"]]],["mrlib/hierlist"]],
["get-content-port",">gui/WXME_Decoding.html#(meth._(((lib._wxme/editor..ss)._editor~25)._get-content-port))",[[0,[1,"get-content-port"]],[12,[" (method of ",[0,[1,"editor%"]],")"]]],["wxme/editor"]],
["get-control-down",">gui/key-event_.html#(meth._(((lib._mred/main..ss)._key-event~25)._get-control-down))",[[0,[1,"get-control-down"]],[12,[" (method of ",[0,[1,"key-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-control-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._get-control-down))",[[0,[1,"get-control-down"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-cookie",">net/cookie.html#(def._((lib._net/cookie..ss)._get-cookie))",[0,[1,"get-cookie"]],["net/cookie"]],
["get-cookie/single",">net/cookie.html#(def._((lib._net/cookie..ss)._get-cookie/single))",[0,[1,"get-cookie/single"]],["net/cookie"]],
["get-corner-bitmap",">framework/Comment_Box.html#(meth._(((lib._framework/main..ss)._comment-box~3asnip~25)._get-corner-bitmap))",[[0,[1,"get-corner-bitmap"]],[12,[" (method of ",[0,[1,"comment-box:snip%"]],")"]]],["framework"]],
["get-corner-bitmap",">framework/editor-snip.html#(meth._(((lib._framework/main..ss)._editor-snip~3adecorated-mixin)._get-corner-bitmap))",[[0,[1,"get-corner-bitmap"]],[12,[" (method of ",[0,[1,"editor-snip:decorated-mixin"]],")"]]],["framework"]],
["get-corner-bitmap",">framework/editor-snip.html#(meth._(((lib._framework/main..ss)._editor-snip~3adecorated~3c~25~3e)._get-corner-bitmap))",[[0,[1,"get-corner-bitmap"]],[12,[" (method of ",[0,[1,"editor-snip:decorated&lt;%&gt;"]],")"]]],["framework"]],
["get-count",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._get-count))",[[0,[1,"get-count"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-coverage-counts",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..ss)._get-coverage-counts))",[0,[1,"get-coverage-counts"]],["errortrace"]],
["get-current-tab",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~3c~25~3e)._get-current-tab))",[[0,[1,"get-current-tab"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-cursor",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._get-cursor))",[[0,[1,"get-cursor"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-data",">gui/clipboard-client_.html#(meth._(((lib._mred/main..ss)._clipboard-client~25)._get-data))",[[0,[1,"get-data"]],[12,[" (method of ",[0,[1,"clipboard-client%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-data",">gui/list-box_.html#(meth._(((lib._mred/main..ss)._list-box~25)._get-data))",[[0,[1,"get-data"]],[12,[" (method of ",[0,[1,"list-box%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-data",">gui/WXME_Decoding.html#(meth._(((lib._wxme/comment..ss)._comment-editor~25)._get-data))",[[0,[1,"get-data"]],[12,[" (method of ",[0,[1,"comment-editor%"]],")"]]],["wxme/comment"]],
["get-data",">gui/WXME_Decoding.html#(meth._(((lib._wxme/image..ss)._image~25)._get-data))",[[0,[1,"get-data"]],[12,[" (method of ",[0,[1,"image%"]],")"]]],["wxme/image"]],
["get-data",">gui/WXME_Decoding.html#(meth._(((lib._wxme/scheme..ss)._scheme-editor~25)._get-data))",[[0,[1,"get-data"]],[12,[" (method of ",[0,[1,"scheme-editor%"]],")"]]],["wxme/scheme"]],
["get-data",">gui/WXME_Decoding.html#(meth._(((lib._wxme/text..ss)._text-editor~25)._get-data))",[[0,[1,"get-data"]],[12,[" (method of ",[0,[1,"text-editor%"]],")"]]],["wxme/text"]],
["get-data",">gui/WXME_Decoding.html#(meth._(((lib._wxme/xml..ss)._xml-editor~25)._get-data))",[[0,[1,"get-data"]],[12,[" (method of ",[0,[1,"xml-editor%"]],")"]]],["wxme/xml"]],
["get-dataclass",">gui/editor-data_.html#(meth._(((lib._mred/main..ss)._editor-data~25)._get-dataclass))",[[0,[1,"get-dataclass"]],[12,[" (method of ",[0,[1,"editor-data%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-datum",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_708",[0,[1,"get-datum"]],["rnrs/io/ports-6"]],
["get-dc",">gui/canvas___.html#(meth._(((lib._mred/main..ss)._canvas~3c~25~3e)._get-dc))",[[0,[1,"get-dc"]],[12,[" (method of ",[0,[1,"canvas&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-dc",">gui/editor-admin_.html#(meth._(((lib._mred/main..ss)._editor-admin~25)._get-dc))",[[0,[1,"get-dc"]],[12,[" (method of ",[0,[1,"editor-admin%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-dc",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._get-dc))",[[0,[1,"get-dc"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-dc",">gui/region_.html#(meth._(((lib._mred/main..ss)._region~25)._get-dc))",[[0,[1,"get-dc"]],[12,[" (method of ",[0,[1,"region%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-dc",">gui/snip-admin_.html#(meth._(((lib._mred/main..ss)._snip-admin~25)._get-dc))",[[0,[1,"get-dc"]],[12,[" (method of ",[0,[1,"snip-admin%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-dc-proc",">mrlib/Cache-image_Snip.html#(meth._(((lib._mrlib/cache-image-snip..ss)._cache-image-snip~25)._get-dc-proc))",[[0,[1,"get-dc-proc"]],[12,[" (method of ",[0,[1,"cache-image-snip%"]],")"]]],["mrlib/cache-image-snip"]],
["get-default-shortcut-prefix",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._get-default-shortcut-prefix))",[0,[1,"get-default-shortcut-prefix"]],["scheme/gui/base","scheme/gui"]],
["get-definitions-canvas",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~3c~25~3e)._get-definitions-canvas))",[[0,[1,"get-definitions-canvas"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-definitions-text",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~3c~25~3e)._get-definitions-text))",[[0,[1,"get-definitions-text"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-definitions/interactions-panel-parent",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._get-definitions/interactions-panel-parent))",[[0,[1,"get-definitions/interactions-panel-parent"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["get-defs",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3atab~3c~25~3e)._get-defs))",[[0,[1,"get-defs"]],[12,[" (method of ",[0,[1,"drscheme:unit:tab&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-delegate",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3adelegate~3c~25~3e)._get-delegate))",[[0,[1,"get-delegate"]],[12,[" (method of ",[0,[1,"text:delegate&lt;%&gt;"]],")"]]],["framework"]],
["get-delegated-text",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3adelegate~3c~25~3e)._get-delegated-text))",[[0,[1,"get-delegated-text"]],[12,[" (method of ",[0,[1,"frame:delegate&lt;%&gt;"]],")"]]],["framework"]],
["get-delta",">gui/style___.html#(meth._(((lib._mred/main..ss)._style~3c~25~3e)._get-delta))",[[0,[1,"get-delta"]],[12,[" (method of ",[0,[1,"style&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-depth",">gui/bitmap_.html#(meth._(((lib._mred/main..ss)._bitmap~25)._get-depth))",[[0,[1,"get-depth"]],[12,[" (method of ",[0,[1,"bitmap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-depth-size",">gui/gl-config_.html#(meth._(((lib._mred/main..ss)._gl-config~25)._get-depth-size))",[[0,[1,"get-depth-size"]],[12,[" (method of ",[0,[1,"gl-config%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-descent",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._get-descent))",[[0,[1,"get-descent"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-direction",">gui/scroll-event_.html#(meth._(((lib._mred/main..ss)._scroll-event~25)._get-direction))",[[0,[1,"get-direction"]],[12,[" (method of ",[0,[1,"scroll-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-directory",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._get-directory))",[0,[1,"get-directory"]],["scheme/gui/base","scheme/gui"]],
["get-directory",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3acontext~3c~25~3e)._get-directory))",[[0,[1,"get-directory"]],[12,[" (method of ",[0,[1,"drscheme:rep:context&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-directory",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3atab~3c~25~3e)._get-directory))",[[0,[1,"get-directory"]],[12,[" (method of ",[0,[1,"drscheme:unit:tab&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-display-depth",">gui/Drawing_Functions.html#(def._((lib._mred/main..ss)._get-display-depth))",[0,[1,"get-display-depth"]],["scheme/gui/base","scheme/gui"]],
["get-display-left-top-inset",">gui/Drawing_Functions.html#(def._((lib._mred/main..ss)._get-display-left-top-inset))",[0,[1,"get-display-left-top-inset"]],["scheme/gui/base","scheme/gui"]],
["get-display-size",">gui/Drawing_Functions.html#(def._((lib._mred/main..ss)._get-display-size))",[0,[1,"get-display-size"]],["scheme/gui/base","scheme/gui"]],
["get-doc-search-dirs",">setup-plt/dirs.html#(def._((lib._setup/dirs..ss)._get-doc-search-dirs))",[0,[1,"get-doc-search-dirs"]],["setup/dirs"]],
["get-double-buffered",">gui/gl-config_.html#(meth._(((lib._mred/main..ss)._gl-config~25)._get-double-buffered))",[[0,[1,"get-double-buffered"]],[12,[" (method of ",[0,[1,"gl-config%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-double-click-interval",">gui/keymap_.html#(meth._(((lib._mred/main..ss)._keymap~25)._get-double-click-interval))",[[0,[1,"get-double-click-interval"]],[12,[" (method of ",[0,[1,"keymap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-dragable",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._get-dragable))",[[0,[1,"get-dragable"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-dx",">gui/WXME_Decoding.html#(meth._(((lib._wxme/image..ss)._image~25)._get-dx))",[[0,[1,"get-dx"]],[12,[" (method of ",[0,[1,"image%"]],")"]]],["wxme/image"]],
["get-dy",">gui/WXME_Decoding.html#(meth._(((lib._wxme/image..ss)._image~25)._get-dy))",[[0,[1,"get-dy"]],[12,[" (method of ",[0,[1,"image%"]],")"]]],["wxme/image"]],
["get-edit-menu",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._get-edit-menu))",[[0,[1,"get-edit-menu"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["get-edit-target-object",">gui/top-level-window___.html#(meth._(((lib._mred/main..ss)._top-level-window~3c~25~3e)._get-edit-target-object))",[[0,[1,"get-edit-target-object"]],[12,[" (method of ",[0,[1,"top-level-window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-edit-target-window",">gui/top-level-window___.html#(meth._(((lib._mred/main..ss)._top-level-window~3c~25~3e)._get-edit-target-window))",[[0,[1,"get-edit-target-window"]],[12,[" (method of ",[0,[1,"top-level-window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-editor",">gui/editor-canvas_.html#(meth._(((lib._mred/main..ss)._editor-canvas~25)._get-editor))",[[0,[1,"get-editor"]],[12,[" (method of ",[0,[1,"editor-canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-editor",">gui/editor-snip_.html#(meth._(((lib._mred/main..ss)._editor-snip~25)._get-editor))",[[0,[1,"get-editor"]],[12,[" (method of ",[0,[1,"editor-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-editor",">gui/snip-admin_.html#(meth._(((lib._mred/main..ss)._snip-admin~25)._get-editor))",[[0,[1,"get-editor"]],[12,[" (method of ",[0,[1,"snip-admin%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-editor",">gui/text-field_.html#(meth._(((lib._mred/main..ss)._text-field~25)._get-editor))",[[0,[1,"get-editor"]],[12,[" (method of ",[0,[1,"text-field%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-editor",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._get-editor))",[[0,[1,"get-editor"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["get-editor",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor~3c~25~3e)._get-editor))",[[0,[1,"get-editor"]],[12,[" (method of ",[0,[1,"frame:editor&lt;%&gt;"]],")"]]],["framework"]],
["get-editor",">mrlib/hierarchical-list-item___.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list-item~3c~25~3e)._get-editor))",[[0,[1,"get-editor"]],[12,[" (method of ",[0,[1,"hierarchical-list-item&lt;%&gt;"]],")"]]],["mrlib/hierlist"]],
["get-editor%",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-canvas-mixin)._get-editor~25))",[[0,[1,"get-editor%"]],[12,[" (method of ",[0,[1,"hyper-canvas-mixin"]],")"]]],["browser"]],
["get-editor%",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._get-editor~25))",[[0,[1,"get-editor%"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["get-editor%",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3adelegate-mixin)._get-editor~25))",[[0,[1,"get-editor%"]],[12,[" (method of ",[0,[1,"frame:delegate-mixin"]],")"]]],["framework"]],
["get-editor%",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor~3c~25~3e)._get-editor~25))",[[0,[1,"get-editor%"]],[12,[" (method of ",[0,[1,"frame:editor&lt;%&gt;"]],")"]]],["framework"]],
["get-editor%",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable-text-mixin)._get-editor~25))",[[0,[1,"get-editor%"]],[12,[" (method of ",[0,[1,"frame:searchable-text-mixin"]],")"]]],["framework"]],
["get-editor-margin",">gui/ps-setup_.html#(meth._(((lib._mred/main..ss)._ps-setup~25)._get-editor-margin))",[[0,[1,"get-editor-margin"]],[12,[" (method of ",[0,[1,"ps-setup%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-editor<%>",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3adelegate-mixin)._get-editor~3c~25~3e))",[[0,[1,"get-editor&lt;%&gt;"]],[12,[" (method of ",[0,[1,"frame:delegate-mixin"]],")"]]],["framework"]],
["get-editor<%>",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor~3c~25~3e)._get-editor~3c~25~3e))",[[0,[1,"get-editor&lt;%&gt;"]],[12,[" (method of ",[0,[1,"frame:editor&lt;%&gt;"]],")"]]],["framework"]],
["get-editor<%>",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3apasteboard-mixin)._get-editor~3c~25~3e))",[[0,[1,"get-editor&lt;%&gt;"]],[12,[" (method of ",[0,[1,"frame:pasteboard-mixin"]],")"]]],["framework"]],
["get-editor<%>",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable-text-mixin)._get-editor~3c~25~3e))",[[0,[1,"get-editor&lt;%&gt;"]],[12,[" (method of ",[0,[1,"frame:searchable-text-mixin"]],")"]]],["framework"]],
["get-editor<%>",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3atext-mixin)._get-editor~3c~25~3e))",[[0,[1,"get-editor&lt;%&gt;"]],[12,[" (method of ",[0,[1,"frame:text-mixin"]],")"]]],["framework"]],
["get-enabled",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3atab~3c~25~3e)._get-enabled))",[[0,[1,"get-enabled"]],[12,[" (method of ",[0,[1,"drscheme:unit:tab&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-enabled?",">gui/WXME_Decoding.html#(meth._(((lib._wxme/test-case..ss)._test-case~25)._get-enabled~3f))",[[0,[1,"get-enabled?"]],[12,[" (method of ",[0,[1,"test-case%"]],")"]]],["wxme/test-case"]],
["get-end-position",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._get-end-position))",[[0,[1,"get-end-position"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-entire-label",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor~3c~25~3e)._get-entire-label))",[[0,[1,"get-entire-label"]],[12,[" (method of ",[0,[1,"frame:editor&lt;%&gt;"]],")"]]],["framework"]],
["get-err-port",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._get-err-port))",[[0,[1,"get-err-port"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["get-err-style-delta",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._get-err-style-delta))",[[0,[1,"get-err-style-delta"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["get-error-box?",">gui/WXME_Decoding.html#(meth._(((lib._wxme/test-case..ss)._test-case~25)._get-error-box~3f))",[[0,[1,"get-error-box?"]],[12,[" (method of ",[0,[1,"test-case%"]],")"]]],["wxme/test-case"]],
["get-error-message",">gui/WXME_Decoding.html#(meth._(((lib._wxme/test-case..ss)._test-case~25)._get-error-message))",[[0,[1,"get-error-message"]],[12,[" (method of ",[0,[1,"test-case%"]],")"]]],["wxme/test-case"]],
["get-error-output",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._get-error-output))",[0,[1,"get-error-output"]],["scheme/sandbox"]],
["get-error-range",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3atext~25)._get-error-range))",[[0,[1,"get-error-range"]],[12,[" (method of ",[0,[1,"drscheme:rep:text%"]],")"]]],["drscheme/tool-lib"]],
["get-event-type",">gui/control-event_.html#(meth._(((lib._mred/main..ss)._control-event~25)._get-event-type))",[[0,[1,"get-event-type"]],[12,[" (method of ",[0,[1,"control-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-event-type",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._get-event-type))",[[0,[1,"get-event-type"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-event-type",">gui/scroll-event_.html#(meth._(((lib._mred/main..ss)._scroll-event~25)._get-event-type))",[[0,[1,"get-event-type"]],[12,[" (method of ",[0,[1,"scroll-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-eventspace",">gui/top-level-window___.html#(meth._(((lib._mred/main..ss)._top-level-window~3c~25~3e)._get-eventspace))",[[0,[1,"get-eventspace"]],[12,[" (method of ",[0,[1,"top-level-window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-exact",">gui/editor-stream-in_.html#(meth._(((lib._mred/main..ss)._editor-stream-in~25)._get-exact))",[[0,[1,"get-exact"]],[12,[" (method of ",[0,[1,"editor-stream-in%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-execute-button",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._get-execute-button))",[[0,[1,"get-execute-button"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["get-execute-counts",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..ss)._get-execute-counts))",[0,[1,"get-execute-counts"]],["errortrace"]],
["get-expected",">gui/WXME_Decoding.html#(meth._(((lib._wxme/test-case..ss)._test-case~25)._get-expected))",[[0,[1,"get-expected"]],[12,[" (method of ",[0,[1,"test-case%"]],")"]]],["wxme/test-case"]],
["get-extent",">gui/editor-snip_.html#(meth._(((lib._mred/main..ss)._editor-snip~25)._get-extent))",[[0,[1,"get-extent"]],[12,[" (method of ",[0,[1,"editor-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-extent",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._get-extent))",[[0,[1,"get-extent"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-extent",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._get-extent))",[[0,[1,"get-extent"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-extent",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3asexp-snip~25)._get-extent))",[[0,[1,"get-extent"]],[12,[" (method of ",[0,[1,"scheme:sexp-snip%"]],")"]]],["framework"]],
["get-extent",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3a1-pixel-string-snip~25)._get-extent))",[[0,[1,"get-extent"]],[12,[" (method of ",[0,[1,"text:1-pixel-string-snip%"]],")"]]],["framework"]],
["get-extent",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3a1-pixel-tab-snip~25)._get-extent))",[[0,[1,"get-extent"]],[12,[" (method of ",[0,[1,"text:1-pixel-tab-snip%"]],")"]]],["framework"]],
["get-face",">gui/font_.html#(meth._(((lib._mred/main..ss)._font~25)._get-face))",[[0,[1,"get-face"]],[12,[" (method of ",[0,[1,"font%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-face",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._get-face))",[[0,[1,"get-face"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-face",">gui/style___.html#(meth._(((lib._mred/main..ss)._style~3c~25~3e)._get-face))",[[0,[1,"get-face"]],[12,[" (method of ",[0,[1,"style&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-face-list",">gui/Drawing_Functions.html#(def._((lib._mred/main..ss)._get-face-list))",[0,[1,"get-face-list"]],["scheme/gui/base","scheme/gui"]],
["get-face-name",">gui/font-name-directory___.html#(meth._(((lib._mred/main..ss)._font-name-directory~3c~25~3e)._get-face-name))",[[0,[1,"get-face-name"]],[12,[" (method of ",[0,[1,"font-name-directory&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-family",">gui/font_.html#(meth._(((lib._mred/main..ss)._font~25)._get-family))",[[0,[1,"get-family"]],[12,[" (method of ",[0,[1,"font%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-family",">gui/font-name-directory___.html#(meth._(((lib._mred/main..ss)._font-name-directory~3c~25~3e)._get-family))",[[0,[1,"get-family"]],[12,[" (method of ",[0,[1,"font-name-directory&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-family",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._get-family))",[[0,[1,"get-family"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-family",">gui/style___.html#(meth._(((lib._mred/main..ss)._style~3c~25~3e)._get-family))",[[0,[1,"get-family"]],[12,[" (method of ",[0,[1,"style&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-family-builtin-face",">gui/Drawing_Functions.html#(def._((lib._mred/main..ss)._get-family-builtin-face))",[0,[1,"get-family-builtin-face"]],["scheme/gui/base","scheme/gui"]],
["get-ffi-obj",">foreign/Loading_Foreign_Libraries.html#(def._((lib._scribblings/foreign/unsafe-foreign..ss)._get-ffi-obj))",[0,[1,"get-ffi-obj"]],["scribblings/foreign/unsafe-foreign"]],
["get-field",">reference/ivaraccess.html#(form._((lib._scheme/private/class-internal..ss)._get-field))",[0,[6,"get-field"]],["scheme/class","scheme"]],
["get-file",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._get-file))",[0,[1,"get-file"]],["scheme/gui/base","scheme/gui"]],
["get-file",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._get-file))",[[0,[1,"get-file"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-file",">gui/ps-setup_.html#(meth._(((lib._mred/main..ss)._ps-setup~25)._get-file))",[[0,[1,"get-file"]],[12,[" (method of ",[0,[1,"ps-setup%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-file",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abasic-mixin)._get-file))",[[0,[1,"get-file"]],[12,[" (method of ",[0,[1,"editor:basic-mixin"]],")"]]],["framework"]],
["get-file-format",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._get-file-format))",[[0,[1,"get-file-format"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-file-list",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._get-file-list))",[0,[1,"get-file-list"]],["scheme/gui/base","scheme/gui"]],
["get-file-menu",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._get-file-menu))",[[0,[1,"get-file-menu"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["get-filename",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._get-filename))",[[0,[1,"get-filename"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-filename",">gui/image-snip_.html#(meth._(((lib._mred/main..ss)._image-snip~25)._get-filename))",[[0,[1,"get-filename"]],[12,[" (method of ",[0,[1,"image-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-filename",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3abasic~3c~25~3e)._get-filename))",[[0,[1,"get-filename"]],[12,[" (method of ",[0,[1,"frame:basic&lt;%&gt;"]],")"]]],["framework"]],
["get-filename",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor-mixin)._get-filename))",[[0,[1,"get-filename"]],[12,[" (method of ",[0,[1,"frame:editor-mixin"]],")"]]],["framework"]],
["get-filename",">gui/WXME_Decoding.html#(meth._(((lib._wxme/image..ss)._image~25)._get-filename))",[[0,[1,"get-filename"]],[12,[" (method of ",[0,[1,"image%"]],")"]]],["wxme/image"]],
["get-filename/untitled-name",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abasic~3c~25~3e)._get-filename/untitled-name))",[[0,[1,"get-filename/untitled-name"]],[12,[" (method of ",[0,[1,"editor:basic&lt;%&gt;"]],")"]]],["framework"]],
["get-filetype",">gui/image-snip_.html#(meth._(((lib._mred/main..ss)._image-snip~25)._get-filetype))",[[0,[1,"get-filetype"]],[12,[" (method of ",[0,[1,"image-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-first-line-height",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3afirst-line~3c~25~3e)._get-first-line-height))",[[0,[1,"get-first-line-height"]],[12,[" (method of ",[0,[1,"text:first-line&lt;%&gt;"]],")"]]],["framework"]],
["get-first-visible-item",">gui/list-box_.html#(meth._(((lib._mred/main..ss)._list-box~25)._get-first-visible-item))",[[0,[1,"get-first-visible-item"]],[12,[" (method of ",[0,[1,"list-box%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-fixed",">gui/editor-stream-in_.html#(meth._(((lib._mred/main..ss)._editor-stream-in~25)._get-fixed))",[[0,[1,"get-fixed"]],[12,[" (method of ",[0,[1,"editor-stream-in%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-fixed-style",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3abasic~3c~25~3e)._get-fixed-style))",[[0,[1,"get-fixed-style"]],[12,[" (method of ",[0,[1,"text:basic&lt;%&gt;"]],")"]]],["framework"]],
["get-fixed-style",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aforeground-color-mixin)._get-fixed-style))",[[0,[1,"get-fixed-style"]],[12,[" (method of ",[0,[1,"text:foreground-color-mixin"]],")"]]],["framework"]],
["get-flags",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._get-flags))",[[0,[1,"get-flags"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-flattened-text",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._get-flattened-text))",[[0,[1,"get-flattened-text"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-focus-object",">gui/top-level-window___.html#(meth._(((lib._mred/main..ss)._top-level-window~3c~25~3e)._get-focus-object))",[[0,[1,"get-focus-object"]],[12,[" (method of ",[0,[1,"top-level-window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-focus-snip",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._get-focus-snip))",[[0,[1,"get-focus-snip"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-focus-window",">gui/top-level-window___.html#(meth._(((lib._mred/main..ss)._top-level-window~3c~25~3e)._get-focus-window))",[[0,[1,"get-focus-window"]],[12,[" (method of ",[0,[1,"top-level-window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-font",">gui/control___.html#(meth._(((lib._mred/main..ss)._control~3c~25~3e)._get-font))",[[0,[1,"get-font"]],[12,[" (method of ",[0,[1,"control&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-font",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._get-font))",[[0,[1,"get-font"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-font",">gui/popup-menu_.html#(meth._(((lib._mred/main..ss)._popup-menu~25)._get-font))",[[0,[1,"get-font"]],[12,[" (method of ",[0,[1,"popup-menu%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-font",">gui/style___.html#(meth._(((lib._mred/main..ss)._style~3c~25~3e)._get-font))",[[0,[1,"get-font"]],[12,[" (method of ",[0,[1,"style&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-font-from-user",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._get-font-from-user))",[0,[1,"get-font-from-user"]],["scheme/gui/base","scheme/gui"]],
["get-font-id",">gui/font_.html#(meth._(((lib._mred/main..ss)._font~25)._get-font-id))",[[0,[1,"get-font-id"]],[12,[" (method of ",[0,[1,"font%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-font-id",">gui/font-name-directory___.html#(meth._(((lib._mred/main..ss)._font-name-directory~3c~25~3e)._get-font-id))",[[0,[1,"get-font-id"]],[12,[" (method of ",[0,[1,"font-name-directory&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-foreground",">gui/style___.html#(meth._(((lib._mred/main..ss)._style~3c~25~3e)._get-foreground))",[[0,[1,"get-foreground"]],[12,[" (method of ",[0,[1,"style&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-foreground-add",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._get-foreground-add))",[[0,[1,"get-foreground-add"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-foreground-mult",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._get-foreground-mult))",[[0,[1,"get-foreground-mult"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-forward-sexp",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._get-forward-sexp))",[[0,[1,"get-forward-sexp"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["get-frame",">gui/menu-bar_.html#(meth._(((lib._mred/main..ss)._menu-bar~25)._get-frame))",[[0,[1,"get-frame"]],[12,[" (method of ",[0,[1,"menu-bar%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-frame",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3atab~3c~25~3e)._get-frame))",[[0,[1,"get-frame"]],[12,[" (method of ",[0,[1,"drscheme:unit:tab&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-frames",">framework/Group.html#(meth._(((lib._framework/main..ss)._group~3a~25)._get-frames))",[[0,[1,"get-frames"]],[12,[" (method of ",[0,[1,"group:%"]],")"]]],["framework"]],
["get-g",">gui/add-color___.html#(meth._(((lib._mred/main..ss)._add-color~3c~25~3e)._get-g))",[[0,[1,"get-g"]],[12,[" (method of ",[0,[1,"add-color&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-g",">gui/mult-color___.html#(meth._(((lib._mred/main..ss)._mult-color~3c~25~3e)._get-g))",[[0,[1,"get-g"]],[12,[" (method of ",[0,[1,"mult-color&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-gl-config",">gui/bitmap_.html#(meth._(((lib._mred/main..ss)._bitmap~25)._get-gl-config))",[[0,[1,"get-gl-config"]],[12,[" (method of ",[0,[1,"bitmap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-gl-context",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._get-gl-context))",[[0,[1,"get-gl-context"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-graphical-min-size",">gui/area___.html#(meth._(((lib._mred/main..ss)._area~3c~25~3e)._get-graphical-min-size))",[[0,[1,"get-graphical-min-size"]],[12,[" (method of ",[0,[1,"area&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-h",">gui/WXME_Decoding.html#(meth._(((lib._wxme/image..ss)._image~25)._get-h))",[[0,[1,"get-h"]],[12,[" (method of ",[0,[1,"image%"]],")"]]],["wxme/image"]],
["get-handle",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._get-handle))",[[0,[1,"get-handle"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-heads-up",">gl-board-game/index.html#(meth._(((lib._games/gl-board-game..ss)._gl-board~25)._get-heads-up))",[[0,[1,"get-heads-up"]],[12,[" (method of ",[0,[1,"gl-board%"]],")"]]],["games/gl-board-game"]],
["get-height",">gui/bitmap_.html#(meth._(((lib._mred/main..ss)._bitmap~25)._get-height))",[[0,[1,"get-height"]],[12,[" (method of ",[0,[1,"bitmap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-height",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._get-height))",[[0,[1,"get-height"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-height",">gui/WXME_Decoding.html#(meth._(((lib._wxme/cache-image..ss)._cache-image~25)._get-height))",[[0,[1,"get-height"]],[12,[" (method of ",[0,[1,"cache-image%"]],")"]]],["wxme/cache-image"]],
["get-help-menu",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._get-help-menu))",[[0,[1,"get-help-menu"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["get-help-string",">gui/labelled-menu-item___.html#(meth._(((lib._mred/main..ss)._labelled-menu-item~3c~25~3e)._get-help-string))",[[0,[1,"get-help-string"]],[12,[" (method of ",[0,[1,"labelled-menu-item&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-highlighted-ranges",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3abasic~3c~25~3e)._get-highlighted-ranges))",[[0,[1,"get-highlighted-ranges"]],[12,[" (method of ",[0,[1,"text:basic&lt;%&gt;"]],")"]]],["framework"]],
["get-html",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._get-html))",[[0,[1,"get-html"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["get-hyper-keymap",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-text-mixin)._get-hyper-keymap))",[[0,[1,"get-hyper-keymap"]],[12,[" (method of ",[0,[1,"hyper-text-mixin"]],")"]]],["browser"]],
["get-hyper-panel",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-frame-mixin)._get-hyper-panel))",[[0,[1,"get-hyper-panel"]],[12,[" (method of ",[0,[1,"hyper-frame-mixin"]],")"]]],["browser"]],
["get-hyper-panel%",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-frame-mixin)._get-hyper-panel~25))",[[0,[1,"get-hyper-panel%"]],[12,[" (method of ",[0,[1,"hyper-frame-mixin"]],")"]]],["browser"]],
["get-impure-port",">net/url.html#(def._((lib._net/url..ss)._get-impure-port))",[0,[1,"get-impure-port"]],["net/url"]],
["get-in-box-port",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._get-in-box-port))",[[0,[1,"get-in-box-port"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["get-in-port",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._get-in-port))",[[0,[1,"get-in-port"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["get-inactive-caret-threshold",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._get-inactive-caret-threshold))",[[0,[1,"get-inactive-caret-threshold"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-include-search-dirs",">setup-plt/dirs.html#(def._((lib._setup/dirs..ss)._get-include-search-dirs))",[0,[1,"get-include-search-dirs"]],["setup/dirs"]],
["get-inexact",">gui/editor-stream-in_.html#(meth._(((lib._mred/main..ss)._editor-stream-in~25)._get-inexact))",[[0,[1,"get-inexact"]],[12,[" (method of ",[0,[1,"editor-stream-in%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-info",">setup-plt/getinfo.html#(def._((lib._setup/getinfo..ss)._get-info))",[0,[1,"get-info"]],["setup/getinfo"]],
["get-info-canvas",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3ainfo~3c~25~3e)._get-info-canvas))",[[0,[1,"get-info-canvas"]],[12,[" (method of ",[0,[1,"frame:info&lt;%&gt;"]],")"]]],["framework"]],
["get-info-editor",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3ainfo~3c~25~3e)._get-info-editor))",[[0,[1,"get-info-editor"]],[12,[" (method of ",[0,[1,"frame:info&lt;%&gt;"]],")"]]],["framework"]],
["get-info-panel",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3ainfo~3c~25~3e)._get-info-panel))",[[0,[1,"get-info-panel"]],[12,[" (method of ",[0,[1,"frame:info&lt;%&gt;"]],")"]]],["framework"]],
["get-info/full",">setup-plt/getinfo.html#(def._((lib._setup/getinfo..ss)._get-info/full))",[0,[1,"get-info/full"]],["setup/getinfo"]],
["get-init-code",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3amodule-based-language~3c~25~3e)._get-init-code))",[[0,[1,"get-init-code"]],[12,[" (method of ",[0,[1,"drscheme:language:module-based-language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-init-code",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-module-based-language-~3emodule-based-language-mixin)._get-init-code))",[[0,[1,"get-init-code"]],[12,[" (method of ",[0,[1,"drscheme:language:simple-module-based-language-&gt;module-based-language-mixin"]],")"]]],["drscheme/tool-lib"]],
["get-insert-menu",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~3c~25~3e)._get-insert-menu))",[[0,[1,"get-insert-menu"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-insertion-point",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._get-insertion-point))",[[0,[1,"get-insertion-point"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["get-inset",">gui/editor-snip_.html#(meth._(((lib._mred/main..ss)._editor-snip~25)._get-inset))",[[0,[1,"get-inset"]],[12,[" (method of ",[0,[1,"editor-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-integer",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..ss)._get-integer))",[0,[1,"get-integer"]],["mzlib/integer-set"]],
["get-interactions-canvas",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~3c~25~3e)._get-interactions-canvas))",[[0,[1,"get-interactions-canvas"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-interactions-text",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~3c~25~3e)._get-interactions-text))",[[0,[1,"get-interactions-text"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-ints",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3atab~3c~25~3e)._get-ints))",[[0,[1,"get-ints"]],[12,[" (method of ",[0,[1,"drscheme:unit:tab&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-item",">mrlib/Snips_in_a_hierarchical-list__Instance.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-item-snip~25)._get-item))",[[0,[1,"get-item"]],[12,[" (method of ",[0,[1,"hierarchical-item-snip%"]],")"]]],["mrlib/hierlist"]],
["get-item",">mrlib/Snips_in_a_hierarchical-list__Instance.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list-snip~25)._get-item))",[[0,[1,"get-item"]],[12,[" (method of ",[0,[1,"hierarchical-list-snip%"]],")"]]],["mrlib/hierlist"]],
["get-item-label",">gui/radio-box_.html#(meth._(((lib._mred/main..ss)._radio-box~25)._get-item-label))",[[0,[1,"get-item-label"]],[12,[" (method of ",[0,[1,"radio-box%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-item-label",">gui/tab-panel_.html#(meth._(((lib._mred/main..ss)._tab-panel~25)._get-item-label))",[[0,[1,"get-item-label"]],[12,[" (method of ",[0,[1,"tab-panel%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-item-plain-label",">gui/radio-box_.html#(meth._(((lib._mred/main..ss)._radio-box~25)._get-item-plain-label))",[[0,[1,"get-item-plain-label"]],[12,[" (method of ",[0,[1,"radio-box%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-items",">gui/menu-item-container___.html#(meth._(((lib._mred/main..ss)._menu-item-container~3c~25~3e)._get-items))",[[0,[1,"get-items"]],[12,[" (method of ",[0,[1,"menu-item-container&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-items",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._get-items))",[[0,[1,"get-items"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["get-items",">mrlib/hierarchical-list-compound-item___.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list-compound-item~3c~25~3e)._get-items))",[[0,[1,"get-items"]],[12,[" (method of ",[0,[1,"hierarchical-list-compound-item&lt;%&gt;"]],")"]]],["mrlib/hierlist"]],
["get-join",">gui/pen_.html#(meth._(((lib._mred/main..ss)._pen~25)._get-join))",[[0,[1,"get-join"]],[12,[" (method of ",[0,[1,"pen%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-key",">browser/index.html#(meth._(((lib._browser/main..ss)._image-map-snip~25)._get-key))",[[0,[1,"get-key"]],[12,[" (method of ",[0,[1,"image-map-snip%"]],")"]]],["browser"]],
["get-key-code",">gui/key-event_.html#(meth._(((lib._mred/main..ss)._key-event~25)._get-key-code))",[[0,[1,"get-key-code"]],[12,[" (method of ",[0,[1,"key-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-key-event",">teachpack/draw.html#(def._((lib._teachpack/htdp/draw..ss)._get-key-event))",[0,[1,"get-key-event"]],["teachpack/htdp/draw"]],
["get-key-press",">graphics/Keyboard_Operations.html#(def._((lib._graphics/graphics..ss)._get-key-press))",[0,[1,"get-key-press"]],["graphics/graphics"]],
["get-key-release-code",">gui/key-event_.html#(meth._(((lib._mred/main..ss)._key-event~25)._get-key-release-code))",[[0,[1,"get-key-release-code"]],[12,[" (method of ",[0,[1,"key-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-keymap",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._get-keymap))",[[0,[1,"get-keymap"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-keymaps",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3adrs-bindings-keymap-mixin)._get-keymaps))",[[0,[1,"get-keymaps"]],[12,[" (method of ",[0,[1,"drscheme:rep:drs-bindings-keymap-mixin"]],")"]]],["drscheme/tool-lib"]],
["get-keymaps",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3afile-mixin)._get-keymaps))",[[0,[1,"get-keymaps"]],[12,[" (method of ",[0,[1,"editor:file-mixin"]],")"]]],["framework"]],
["get-keymaps",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3akeymap~3c~25~3e)._get-keymaps))",[[0,[1,"get-keymaps"]],[12,[" (method of ",[0,[1,"editor:keymap&lt;%&gt;"]],")"]]],["framework"]],
["get-keymaps",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3asearching-mixin)._get-keymaps))",[[0,[1,"get-keymaps"]],[12,[" (method of ",[0,[1,"text:searching-mixin"]],")"]]],["framework"]],
["get-label",">gui/labelled-menu-item___.html#(meth._(((lib._mred/main..ss)._labelled-menu-item~3c~25~3e)._get-label))",[[0,[1,"get-label"]],[12,[" (method of ",[0,[1,"labelled-menu-item&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-label",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._get-label))",[[0,[1,"get-label"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-label",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor-mixin)._get-label))",[[0,[1,"get-label"]],[12,[" (method of ",[0,[1,"frame:editor-mixin"]],")"]]],["framework"]],
["get-label-font",">gui/list-box_.html#(meth._(((lib._mred/main..ss)._list-box~25)._get-label-font))",[[0,[1,"get-label-font"]],[12,[" (method of ",[0,[1,"list-box%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-label-prefix",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor~3c~25~3e)._get-label-prefix))",[[0,[1,"get-label-prefix"]],[12,[" (method of ",[0,[1,"frame:editor&lt;%&gt;"]],")"]]],["framework"]],
["get-language-menu",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~3c~25~3e)._get-language-menu))",[[0,[1,"get-language-menu"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-language-name",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e)._get-language-name))",[[0,[1,"get-language-name"]],[12,[" (method of ",[0,[1,"drscheme:language:language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-language-name",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3amodule-based-language-~3elanguage-mixin)._get-language-name))",[[0,[1,"get-language-name"]],[12,[" (method of ",[0,[1,"drscheme:language:module-based-language-&gt;language-mixin"]],")"]]],["drscheme/tool-lib"]],
["get-language-numbers",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e)._get-language-numbers))",[[0,[1,"get-language-numbers"]],[12,[" (method of ",[0,[1,"drscheme:language:language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-language-numbers",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3amodule-based-language~3c~25~3e)._get-language-numbers))",[[0,[1,"get-language-numbers"]],[12,[" (method of ",[0,[1,"drscheme:language:module-based-language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-language-numbers",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-module-based-language~25)._get-language-numbers))",[[0,[1,"get-language-numbers"]],[12,[" (method of ",[0,[1,"drscheme:language:simple-module-based-language%"]],")"]]],["drscheme/tool-lib"]],
["get-language-numbers",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-module-based-language~3c~25~3e)._get-language-numbers))",[[0,[1,"get-language-numbers"]],[12,[" (method of ",[0,[1,"drscheme:language:simple-module-based-language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-language-position",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e)._get-language-position))",[[0,[1,"get-language-position"]],[12,[" (method of ",[0,[1,"drscheme:language:language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-language-position",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3amodule-based-language~3c~25~3e)._get-language-position))",[[0,[1,"get-language-position"]],[12,[" (method of ",[0,[1,"drscheme:language:module-based-language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-language-position",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-module-based-language~25)._get-language-position))",[[0,[1,"get-language-position"]],[12,[" (method of ",[0,[1,"drscheme:language:simple-module-based-language%"]],")"]]],["drscheme/tool-lib"]],
["get-language-position",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-module-based-language~3c~25~3e)._get-language-position))",[[0,[1,"get-language-position"]],[12,[" (method of ",[0,[1,"drscheme:language:simple-module-based-language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-language-url",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e)._get-language-url))",[[0,[1,"get-language-url"]],[12,[" (method of ",[0,[1,"drscheme:language:language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-left-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._get-left-down))",[[0,[1,"get-left-down"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-level-2",">gui/ps-setup_.html#(meth._(((lib._mred/main..ss)._ps-setup~25)._get-level-2))",[[0,[1,"get-level-2"]],[12,[" (method of ",[0,[1,"ps-setup%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-lib-search-dirs",">setup-plt/dirs.html#(def._((lib._setup/dirs..ss)._get-lib-search-dirs))",[0,[1,"get-lib-search-dirs"]],["setup/dirs"]],
["get-limit",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._get-limit))",[[0,[1,"get-limit"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["get-line",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_706",[0,[1,"get-line"]],["rnrs/io/ports-6"]],
["get-line-count",">gui/editor-canvas_.html#(meth._(((lib._mred/main..ss)._editor-canvas~25)._get-line-count))",[[0,[1,"get-line-count"]],[12,[" (method of ",[0,[1,"editor-canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-line-spacing",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._get-line-spacing))",[[0,[1,"get-line-spacing"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-load-overwrites-styles",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._get-load-overwrites-styles))",[[0,[1,"get-load-overwrites-styles"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-loaded-mask",">gui/bitmap_.html#(meth._(((lib._mred/main..ss)._bitmap~25)._get-loaded-mask))",[[0,[1,"get-loaded-mask"]],[12,[" (method of ",[0,[1,"bitmap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-mailbox-status",">net/pop3.html#(def._((lib._net/pop3..ss)._get-mailbox-status))",[0,[1,"get-mailbox-status"]],["net/pop3"]],
["get-map",">gui/editor-wordbreak-map_.html#(meth._(((lib._mred/main..ss)._editor-wordbreak-map~25)._get-map))",[[0,[1,"get-map"]],[12,[" (method of ",[0,[1,"editor-wordbreak-map%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-map-function-table",">framework/Keymap.html#(meth._(((lib._framework/main..ss)._keymap~3aaug-keymap~3c~25~3e)._get-map-function-table))",[[0,[1,"get-map-function-table"]],[12,[" (method of ",[0,[1,"keymap:aug-keymap&lt;%&gt;"]],")"]]],["framework"]],
["get-map-function-table/ht",">framework/Keymap.html#(meth._(((lib._framework/main..ss)._keymap~3aaug-keymap~3c~25~3e)._get-map-function-table/ht))",[[0,[1,"get-map-function-table/ht"]],[12,[" (method of ",[0,[1,"keymap:aug-keymap&lt;%&gt;"]],")"]]],["framework"]],
["get-margin",">gui/editor-snip_.html#(meth._(((lib._mred/main..ss)._editor-snip~25)._get-margin))",[[0,[1,"get-margin"]],[12,[" (method of ",[0,[1,"editor-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-margin",">gui/ps-setup_.html#(meth._(((lib._mred/main..ss)._ps-setup~25)._get-margin))",[[0,[1,"get-margin"]],[12,[" (method of ",[0,[1,"ps-setup%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-max-height",">gui/editor-snip_.html#(meth._(((lib._mred/main..ss)._editor-snip~25)._get-max-height))",[[0,[1,"get-max-height"]],[12,[" (method of ",[0,[1,"editor-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-max-height",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._get-max-height))",[[0,[1,"get-max-height"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-max-undo-history",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._get-max-undo-history))",[[0,[1,"get-max-undo-history"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-max-view",">gui/editor-admin_.html#(meth._(((lib._mred/main..ss)._editor-admin~25)._get-max-view))",[[0,[1,"get-max-view"]],[12,[" (method of ",[0,[1,"editor-admin%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-max-view-size",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._get-max-view-size))",[[0,[1,"get-max-view-size"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-max-width",">gui/editor-snip_.html#(meth._(((lib._mred/main..ss)._editor-snip~25)._get-max-width))",[[0,[1,"get-max-width"]],[12,[" (method of ",[0,[1,"editor-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-max-width",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._get-max-width))",[[0,[1,"get-max-width"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-mdi-parent",">framework/Group.html#(meth._(((lib._framework/main..ss)._group~3a~25)._get-mdi-parent))",[[0,[1,"get-mdi-parent"]],[12,[" (method of ",[0,[1,"group:%"]],")"]]],["framework"]],
["get-menu",">gui/combo-field_.html#(meth._(((lib._mred/main..ss)._combo-field~25)._get-menu))",[[0,[1,"get-menu"]],[12,[" (method of ",[0,[1,"combo-field%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-menu",">framework/Comment_Box.html#(meth._(((lib._framework/main..ss)._comment-box~3asnip~25)._get-menu))",[[0,[1,"get-menu"]],[12,[" (method of ",[0,[1,"comment-box:snip%"]],")"]]],["framework"]],
["get-menu",">framework/editor-snip.html#(meth._(((lib._framework/main..ss)._editor-snip~3adecorated-mixin)._get-menu))",[[0,[1,"get-menu"]],[12,[" (method of ",[0,[1,"editor-snip:decorated-mixin"]],")"]]],["framework"]],
["get-menu",">framework/editor-snip.html#(meth._(((lib._framework/main..ss)._editor-snip~3adecorated~3c~25~3e)._get-menu))",[[0,[1,"get-menu"]],[12,[" (method of ",[0,[1,"editor-snip:decorated&lt;%&gt;"]],")"]]],["framework"]],
["get-menu%",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._get-menu~25))",[[0,[1,"get-menu%"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["get-menu-bar",">gui/frame_.html#(meth._(((lib._mred/main..ss)._frame~25)._get-menu-bar))",[[0,[1,"get-menu-bar"]],[12,[" (method of ",[0,[1,"frame%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-menu-bar%",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3abasic~3c~25~3e)._get-menu-bar~25))",[[0,[1,"get-menu-bar%"]],[12,[" (method of ",[0,[1,"frame:basic&lt;%&gt;"]],")"]]],["framework"]],
["get-menu-item%",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._get-menu-item~25))",[[0,[1,"get-menu-item%"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["get-message/body",">net/pop3.html#(def._((lib._net/pop3..ss)._get-message/body))",[0,[1,"get-message/body"]],["net/pop3"]],
["get-message/complete",">net/pop3.html#(def._((lib._net/pop3..ss)._get-message/complete))",[0,[1,"get-message/complete"]],["net/pop3"]],
["get-message/headers",">net/pop3.html#(def._((lib._net/pop3..ss)._get-message/headers))",[0,[1,"get-message/headers"]],["net/pop3"]],
["get-meta-down",">gui/key-event_.html#(meth._(((lib._mred/main..ss)._key-event~25)._get-meta-down))",[[0,[1,"get-meta-down"]],[12,[" (method of ",[0,[1,"key-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-meta-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._get-meta-down))",[[0,[1,"get-meta-down"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-metadata",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e)._get-metadata))",[[0,[1,"get-metadata"]],[12,[" (method of ",[0,[1,"drscheme:language:language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-metadata-lines",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e)._get-metadata-lines))",[[0,[1,"get-metadata-lines"]],[12,[" (method of ",[0,[1,"drscheme:language:language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-middle-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._get-middle-down))",[[0,[1,"get-middle-down"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-min-height",">gui/editor-snip_.html#(meth._(((lib._mred/main..ss)._editor-snip~25)._get-min-height))",[[0,[1,"get-min-height"]],[12,[" (method of ",[0,[1,"editor-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-min-height",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._get-min-height))",[[0,[1,"get-min-height"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-min-height",">embedded-gui/alignment___.html#(meth._(((lib._embedded-gui/main..ss)._alignment~3c~25~3e)._get-min-height))",[[0,[1,"get-min-height"]],[12,[" (method of ",[0,[1,"alignment&lt;%&gt;"]],")"]]],["embedded-gui"]],
["get-min-width",">gui/editor-snip_.html#(meth._(((lib._mred/main..ss)._editor-snip~25)._get-min-width))",[[0,[1,"get-min-width"]],[12,[" (method of ",[0,[1,"editor-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-min-width",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._get-min-width))",[[0,[1,"get-min-width"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-min-width",">embedded-gui/alignment___.html#(meth._(((lib._embedded-gui/main..ss)._alignment~3c~25~3e)._get-min-width))",[[0,[1,"get-min-width"]],[12,[" (method of ",[0,[1,"alignment&lt;%&gt;"]],")"]]],["embedded-gui"]],
["get-mode",">gui/ps-setup_.html#(meth._(((lib._mred/main..ss)._ps-setup~25)._get-mode))",[[0,[1,"get-mode"]],[12,[" (method of ",[0,[1,"ps-setup%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-module",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3amodule-based-language~3c~25~3e)._get-module))",[[0,[1,"get-module"]],[12,[" (method of ",[0,[1,"drscheme:language:module-based-language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-module",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-module-based-language~25)._get-module))",[[0,[1,"get-module"]],[12,[" (method of ",[0,[1,"drscheme:language:simple-module-based-language%"]],")"]]],["drscheme/tool-lib"]],
["get-module",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-module-based-language~3c~25~3e)._get-module))",[[0,[1,"get-module"]],[12,[" (method of ",[0,[1,"drscheme:language:simple-module-based-language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-module-code",">syntax/module-helpers.html#(def._((lib._syntax/modcode..ss)._get-module-code))",[0,[1,"get-module-code"]],["syntax/modcode"]],
["get-mouse-click",">graphics/Mouse_Operations.html#(def._((lib._graphics/graphics..ss)._get-mouse-click))",[0,[1,"get-mouse-click"]],["graphics/graphics"]],
["get-multisample-size",">gui/gl-config_.html#(meth._(((lib._mred/main..ss)._gl-config~25)._get-multisample-size))",[[0,[1,"get-multisample-size"]],[12,[" (method of ",[0,[1,"gl-config%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-name",">gui/style___.html#(meth._(((lib._mred/main..ss)._style~3c~25~3e)._get-name))",[[0,[1,"get-name"]],[12,[" (method of ",[0,[1,"style&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-next",">gui/editor-data_.html#(meth._(((lib._mred/main..ss)._editor-data~25)._get-next))",[[0,[1,"get-next"]],[12,[" (method of ",[0,[1,"editor-data%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-next-settings",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3adefinitions-text~3c~25~3e)._get-next-settings))",[[0,[1,"get-next-settings"]],[12,[" (method of ",[0,[1,"drscheme:unit:definitions-text&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-num-scroll-steps",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._get-num-scroll-steps))",[[0,[1,"get-num-scroll-steps"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-number",">gui/list-control___.html#(meth._(((lib._mred/main..ss)._list-control~3c~25~3e)._get-number))",[[0,[1,"get-number"]],[12,[" (method of ",[0,[1,"list-control&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-number",">gui/radio-box_.html#(meth._(((lib._mred/main..ss)._radio-box~25)._get-number))",[[0,[1,"get-number"]],[12,[" (method of ",[0,[1,"radio-box%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-number",">gui/tab-panel_.html#(meth._(((lib._mred/main..ss)._tab-panel~25)._get-number))",[[0,[1,"get-number"]],[12,[" (method of ",[0,[1,"tab-panel%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-one-line-summary",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e)._get-one-line-summary))",[[0,[1,"get-one-line-summary"]],[12,[" (method of ",[0,[1,"drscheme:language:language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-one-line-summary",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3amodule-based-language~3c~25~3e)._get-one-line-summary))",[[0,[1,"get-one-line-summary"]],[12,[" (method of ",[0,[1,"drscheme:language:module-based-language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-one-line-summary",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-module-based-language~25)._get-one-line-summary))",[[0,[1,"get-one-line-summary"]],[12,[" (method of ",[0,[1,"drscheme:language:simple-module-based-language%"]],")"]]],["drscheme/tool-lib"]],
["get-one-line-summary",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-module-based-language~3c~25~3e)._get-one-line-summary))",[[0,[1,"get-one-line-summary"]],[12,[" (method of ",[0,[1,"drscheme:language:simple-module-based-language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-open-here-editor",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aopen-here~3c~25~3e)._get-open-here-editor))",[[0,[1,"get-open-here-editor"]],[12,[" (method of ",[0,[1,"frame:open-here&lt;%&gt;"]],")"]]],["framework"]],
["get-open-here-frame",">framework/Group.html#(meth._(((lib._framework/main..ss)._group~3a~25)._get-open-here-frame))",[[0,[1,"get-open-here-frame"]],[12,[" (method of ",[0,[1,"group:%"]],")"]]],["framework"]],
["get-orientation",">gui/horizontal-panel_.html#(meth._(((lib._mred/main..ss)._horizontal-panel~25)._get-orientation))",[[0,[1,"get-orientation"]],[12,[" (method of ",[0,[1,"horizontal-panel%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-orientation",">gui/ps-setup_.html#(meth._(((lib._mred/main..ss)._ps-setup~25)._get-orientation))",[[0,[1,"get-orientation"]],[12,[" (method of ",[0,[1,"ps-setup%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-orientation",">gui/vertical-panel_.html#(meth._(((lib._mred/main..ss)._vertical-panel~25)._get-orientation))",[[0,[1,"get-orientation"]],[12,[" (method of ",[0,[1,"vertical-panel%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-origin",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._get-origin))",[[0,[1,"get-origin"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-other-altgr-key-code",">gui/key-event_.html#(meth._(((lib._mred/main..ss)._key-event~25)._get-other-altgr-key-code))",[[0,[1,"get-other-altgr-key-code"]],[12,[" (method of ",[0,[1,"key-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-other-caps-key-code",">gui/key-event_.html#(meth._(((lib._mred/main..ss)._key-event~25)._get-other-caps-key-code))",[[0,[1,"get-other-caps-key-code"]],[12,[" (method of ",[0,[1,"key-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-other-shift-altgr-key-code",">gui/key-event_.html#(meth._(((lib._mred/main..ss)._key-event~25)._get-other-shift-altgr-key-code))",[[0,[1,"get-other-shift-altgr-key-code"]],[12,[" (method of ",[0,[1,"key-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-other-shift-key-code",">gui/key-event_.html#(meth._(((lib._mred/main..ss)._key-event~25)._get-other-shift-key-code))",[[0,[1,"get-other-shift-key-code"]],[12,[" (method of ",[0,[1,"key-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-out-port",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._get-out-port))",[[0,[1,"get-out-port"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["get-out-style-delta",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._get-out-style-delta))",[[0,[1,"get-out-style-delta"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["get-output",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._get-output))",[0,[1,"get-output"]],["scheme/sandbox"]],
["get-output-bytes",">reference/stringport.html#(def._((quote._~23~25kernel)._get-output-bytes))",[0,[1,"get-output-bytes"]],["scheme/base","scheme"]],
["get-output-string",">reference/stringport.html#(def._((quote._~23~25kernel)._get-output-string))",[0,[1,"get-output-string"]],["scheme/base","scheme"]],
["get-output-string",">srfi-std/srfi-6.html#get-output-string",[0,[1,"get-output-string"]],["srfi/6"]],
["get-overwrite-mode",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._get-overwrite-mode))",[[0,[1,"get-overwrite-mode"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-page-setup-from-user",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._get-page-setup-from-user))",[0,[1,"get-page-setup-from-user"]],["scheme/gui/base","scheme/gui"]],
["get-panel-background",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._get-panel-background))",[0,[1,"get-panel-background"]],["scheme/gui/base","scheme/gui"]],
["get-paper-name",">gui/ps-setup_.html#(meth._(((lib._mred/main..ss)._ps-setup~25)._get-paper-name))",[[0,[1,"get-paper-name"]],[12,[" (method of ",[0,[1,"ps-setup%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-parent",">gui/area___.html#(meth._(((lib._mred/main..ss)._area~3c~25~3e)._get-parent))",[[0,[1,"get-parent"]],[12,[" (method of ",[0,[1,"area&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-parent",">gui/menu-item___.html#(meth._(((lib._mred/main..ss)._menu-item~3c~25~3e)._get-parent))",[[0,[1,"get-parent"]],[12,[" (method of ",[0,[1,"menu-item&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-parent",">embedded-gui/alignment___.html#(meth._(((lib._embedded-gui/main..ss)._alignment~3c~25~3e)._get-parent))",[[0,[1,"get-parent"]],[12,[" (method of ",[0,[1,"alignment&lt;%&gt;"]],")"]]],["embedded-gui"]],
["get-parents",">mrlib/graph-snip___.html#(meth._(((lib._mrlib/graph..ss)._graph-snip~3c~25~3e)._get-parents))",[[0,[1,"get-parents"]],[12,[" (method of ",[0,[1,"graph-snip&lt;%&gt;"]],")"]]],["mrlib/graph"]],
["get-paste-text-only",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._get-paste-text-only))",[[0,[1,"get-paste-text-only"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-pasteboard",">embedded-gui/alignment-parent___.html#(meth._(((lib._embedded-gui/main..ss)._alignment-parent~3c~25~3e)._get-pasteboard))",[[0,[1,"get-pasteboard"]],[12,[" (method of ",[0,[1,"alignment-parent&lt;%&gt;"]],")"]]],["embedded-gui"]],
["get-pen",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._get-pen))",[[0,[1,"get-pen"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-percentages",">framework/Panel.html#(meth._(((lib._framework/main..ss)._panel~3adragable~3c~25~3e)._get-percentages))",[[0,[1,"get-percentages"]],[12,[" (method of ",[0,[1,"panel:dragable&lt;%&gt;"]],")"]]],["framework"]],
["get-pieces",">gl-board-game/index.html#(meth._(((lib._games/gl-board-game..ss)._gl-board~25)._get-pieces))",[[0,[1,"get-pieces"]],[12,[" (method of ",[0,[1,"gl-board%"]],")"]]],["games/gl-board-game"]],
["get-pin-x",">gui/WXME_Decoding.html#(meth._(((lib._wxme/cache-image..ss)._cache-image~25)._get-pin-x))",[[0,[1,"get-pin-x"]],[12,[" (method of ",[0,[1,"cache-image%"]],")"]]],["wxme/cache-image"]],
["get-pin-y",">gui/WXME_Decoding.html#(meth._(((lib._wxme/cache-image..ss)._cache-image~25)._get-pin-y))",[[0,[1,"get-pin-y"]],[12,[" (method of ",[0,[1,"cache-image%"]],")"]]],["wxme/cache-image"]],
["get-pinhole",">mrlib/Cache-image_Snip.html#(meth._(((lib._mrlib/cache-image-snip..ss)._cache-image-snip~25)._get-pinhole))",[[0,[1,"get-pinhole"]],[12,[" (method of ",[0,[1,"cache-image-snip%"]],")"]]],["mrlib/cache-image-snip"]],
["get-pixel",">gui/bitmap-dc_.html#(meth._(((lib._mred/main..ss)._bitmap-dc~25)._get-pixel))",[[0,[1,"get-pixel"]],[12,[" (method of ",[0,[1,"bitmap-dc%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-pixel",">graphics/posn.html#(def._((lib._graphics/graphics..ss)._get-pixel))",[0,[1,"get-pixel"]],["graphics/graphics"]],
["get-plain-label",">gui/labelled-menu-item___.html#(meth._(((lib._mred/main..ss)._labelled-menu-item~3c~25~3e)._get-plain-label))",[[0,[1,"get-plain-label"]],[12,[" (method of ",[0,[1,"labelled-menu-item&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-plain-label",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._get-plain-label))",[[0,[1,"get-plain-label"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-point-size",">gui/font_.html#(meth._(((lib._mred/main..ss)._font~25)._get-point-size))",[[0,[1,"get-point-size"]],[12,[" (method of ",[0,[1,"font%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-popup-target",">gui/popup-menu_.html#(meth._(((lib._mred/main..ss)._popup-menu~25)._get-popup-target))",[[0,[1,"get-popup-target"]],[12,[" (method of ",[0,[1,"popup-menu%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-port-name",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3abasic~3c~25~3e)._get-port-name))",[[0,[1,"get-port-name"]],[12,[" (method of ",[0,[1,"text:basic&lt;%&gt;"]],")"]]],["framework"]],
["get-port-name-identifier",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3adefinitions-text~3c~25~3e)._get-port-name-identifier))",[[0,[1,"get-port-name-identifier"]],[12,[" (method of ",[0,[1,"drscheme:unit:definitions-text&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-pos/text",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abasic~3c~25~3e)._get-pos/text))",[[0,[1,"get-pos/text"]],[12,[" (method of ",[0,[1,"editor:basic&lt;%&gt;"]],")"]]],["framework"]],
["get-position",">gui/scroll-event_.html#(meth._(((lib._mred/main..ss)._scroll-event~25)._get-position))",[[0,[1,"get-position"]],[12,[" (method of ",[0,[1,"scroll-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-position",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._get-position))",[[0,[1,"get-position"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-position",">framework/Comment_Box.html#(meth._(((lib._framework/main..ss)._comment-box~3asnip~25)._get-position))",[[0,[1,"get-position"]],[12,[" (method of ",[0,[1,"comment-box:snip%"]],")"]]],["framework"]],
["get-position",">framework/editor-snip.html#(meth._(((lib._framework/main..ss)._editor-snip~3adecorated-mixin)._get-position))",[[0,[1,"get-position"]],[12,[" (method of ",[0,[1,"editor-snip:decorated-mixin"]],")"]]],["framework"]],
["get-position",">framework/editor-snip.html#(meth._(((lib._framework/main..ss)._editor-snip~3adecorated~3c~25~3e)._get-position))",[[0,[1,"get-position"]],[12,[" (method of ",[0,[1,"editor-snip:decorated&lt;%&gt;"]],")"]]],["framework"]],
["get-post-script-name",">gui/font-name-directory___.html#(meth._(((lib._mred/main..ss)._font-name-directory~3c~25~3e)._get-post-script-name))",[[0,[1,"get-post-script-name"]],[12,[" (method of ",[0,[1,"font-name-directory&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-preference",">reference/Filesystem.html#(def._((lib._scheme/file..ss)._get-preference))",[0,[1,"get-preference"]],["scheme/file","scheme"]],
["get-preview-command",">gui/ps-setup_.html#(meth._(((lib._mred/main..ss)._ps-setup~25)._get-preview-command))",[[0,[1,"get-preview-command"]],[12,[" (method of ",[0,[1,"ps-setup%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-profile-results",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..ss)._get-profile-results))",[0,[1,"get-profile-results"]],["errortrace"]],
["get-ps-setup-from-user",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._get-ps-setup-from-user))",[0,[1,"get-ps-setup-from-user"]],["scheme/gui/base","scheme/gui"]],
["get-pure-port",">net/url.html#(def._((lib._net/url..ss)._get-pure-port))",[0,[1,"get-pure-port"]],["net/url"]],
["get-r",">gui/add-color___.html#(meth._(((lib._mred/main..ss)._add-color~3c~25~3e)._get-r))",[[0,[1,"get-r"]],[12,[" (method of ",[0,[1,"add-color&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-r",">gui/mult-color___.html#(meth._(((lib._mred/main..ss)._mult-color~3c~25~3e)._get-r))",[[0,[1,"get-r"]],[12,[" (method of ",[0,[1,"mult-color&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-range",">gui/gauge_.html#(meth._(((lib._mred/main..ss)._gauge~25)._get-range))",[[0,[1,"get-range"]],[12,[" (method of ",[0,[1,"gauge%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-read-write?",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3afile~3c~25~3e)._get-read-write~3f))",[[0,[1,"get-read-write?"]],[12,[" (method of ",[0,[1,"text:file&lt;%&gt;"]],")"]]],["framework"]],
["get-reader",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3amodule-based-language~3c~25~3e)._get-reader))",[[0,[1,"get-reader"]],[12,[" (method of ",[0,[1,"drscheme:language:module-based-language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-reader",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-module-based-language~25)._get-reader))",[[0,[1,"get-reader"]],[12,[" (method of ",[0,[1,"drscheme:language:simple-module-based-language%"]],")"]]],["drscheme/tool-lib"]],
["get-reader",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-module-based-language~3c~25~3e)._get-reader))",[[0,[1,"get-reader"]],[12,[" (method of ",[0,[1,"drscheme:language:simple-module-based-language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-reader-module",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e)._get-reader-module))",[[0,[1,"get-reader-module"]],[12,[" (method of ",[0,[1,"drscheme:language:language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-region-data",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._get-region-data))",[[0,[1,"get-region-data"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-regions",">framework/Color.html#(meth._(((lib._framework/main..ss)._color~3atext~3c~25~3e)._get-regions))",[[0,[1,"get-regions"]],[12,[" (method of ",[0,[1,"color:text&lt;%&gt;"]],")"]]],["framework"]],
["get-resource",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._get-resource))",[0,[1,"get-resource"]],["scheme/gui/base","scheme/gui"]],
["get-revision-number",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._get-revision-number))",[[0,[1,"get-revision-number"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-right-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._get-right-down))",[[0,[1,"get-right-down"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-root",">syntax-color/index.html#(meth._(((lib._syntax-color/token-tree..ss)._token-tree~25)._get-root))",[[0,[1,"get-root"]],[12,[" (method of ",[0,[1,"token-tree%"]],")"]]],["syntax-color/token-tree"]],
["get-saved-snips",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3asexp-snip~3c~25~3e)._get-saved-snips))",[[0,[1,"get-saved-snips"]],[12,[" (method of ",[0,[1,"scheme:sexp-snip&lt;%&gt;"]],")"]]],["framework"]],
["get-scale",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._get-scale))",[[0,[1,"get-scale"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-scaling",">gui/ps-setup_.html#(meth._(((lib._mred/main..ss)._ps-setup~25)._get-scaling))",[[0,[1,"get-scaling"]],[12,[" (method of ",[0,[1,"ps-setup%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-screen-name",">gui/font-name-directory___.html#(meth._(((lib._mred/main..ss)._font-name-directory~3c~25~3e)._get-screen-name))",[[0,[1,"get-screen-name"]],[12,[" (method of ",[0,[1,"font-name-directory&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-scroll-page",">gui/canvas_.html#(meth._(((lib._mred/main..ss)._canvas~25)._get-scroll-page))",[[0,[1,"get-scroll-page"]],[12,[" (method of ",[0,[1,"canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-scroll-pos",">gui/canvas_.html#(meth._(((lib._mred/main..ss)._canvas~25)._get-scroll-pos))",[[0,[1,"get-scroll-pos"]],[12,[" (method of ",[0,[1,"canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-scroll-range",">gui/canvas_.html#(meth._(((lib._mred/main..ss)._canvas~25)._get-scroll-range))",[[0,[1,"get-scroll-range"]],[12,[" (method of ",[0,[1,"canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-scroll-step",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._get-scroll-step))",[[0,[1,"get-scroll-step"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-scroll-step-offset",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._get-scroll-step-offset))",[[0,[1,"get-scroll-step-offset"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-search-bubbles",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3asearching~3c~25~3e)._get-search-bubbles))",[[0,[1,"get-search-bubbles"]],[12,[" (method of ",[0,[1,"text:searching&lt;%&gt;"]],")"]]],["framework"]],
["get-search-hit-count",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3asearching~3c~25~3e)._get-search-hit-count))",[[0,[1,"get-search-hit-count"]],[12,[" (method of ",[0,[1,"text:searching&lt;%&gt;"]],")"]]],["framework"]],
["get-selected",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._get-selected))",[[0,[1,"get-selected"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["get-selection",">gui/list-control___.html#(meth._(((lib._mred/main..ss)._list-control~3c~25~3e)._get-selection))",[[0,[1,"get-selection"]],[12,[" (method of ",[0,[1,"list-control&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-selection",">gui/radio-box_.html#(meth._(((lib._mred/main..ss)._radio-box~25)._get-selection))",[[0,[1,"get-selection"]],[12,[" (method of ",[0,[1,"radio-box%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-selection",">gui/tab-panel_.html#(meth._(((lib._mred/main..ss)._tab-panel~25)._get-selection))",[[0,[1,"get-selection"]],[12,[" (method of ",[0,[1,"tab-panel%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-selection-b",">frtime/index.html#(meth._(((lib._frtime/gui/fred..ss)._ft-choice~25)._get-selection-b))",[[0,[1,"get-selection-b"]],[12,[" (method of ",[0,[1,"ft-choice%"]],")"]]],["frtime/gui/fred"]],
["get-selection-b",">frtime/index.html#(meth._(((lib._frtime/gui/fred..ss)._ft-list-box~25)._get-selection-b))",[[0,[1,"get-selection-b"]],[12,[" (method of ",[0,[1,"ft-list-box%"]],")"]]],["frtime/gui/fred"]],
["get-selection-b",">frtime/index.html#(meth._(((lib._frtime/gui/fred..ss)._ft-radio-box~25)._get-selection-b))",[[0,[1,"get-selection-b"]],[12,[" (method of ",[0,[1,"ft-radio-box%"]],")"]]],["frtime/gui/fred"]],
["get-selection-visible",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._get-selection-visible))",[[0,[1,"get-selection-visible"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-selections",">gui/list-box_.html#(meth._(((lib._mred/main..ss)._list-box~25)._get-selections))",[[0,[1,"get-selections"]],[12,[" (method of ",[0,[1,"list-box%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-selections-b",">frtime/index.html#(meth._(((lib._frtime/gui/fred..ss)._ft-list-box~25)._get-selections-b))",[[0,[1,"get-selections-b"]],[12,[" (method of ",[0,[1,"ft-list-box%"]],")"]]],["frtime/gui/fred"]],
["get-shared",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..ss)._get-shared))",[0,[1,"get-shared"]],["mzlib/pconvert"]],
["get-shift-down",">gui/key-event_.html#(meth._(((lib._mred/main..ss)._key-event~25)._get-shift-down))",[[0,[1,"get-shift-down"]],[12,[" (method of ",[0,[1,"key-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-shift-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._get-shift-down))",[[0,[1,"get-shift-down"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-shift-style",">gui/style___.html#(meth._(((lib._mred/main..ss)._style~3c~25~3e)._get-shift-style))",[[0,[1,"get-shift-style"]],[12,[" (method of ",[0,[1,"style&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-shortcut",">gui/selectable-menu-item___.html#(meth._(((lib._mred/main..ss)._selectable-menu-item~3c~25~3e)._get-shortcut))",[[0,[1,"get-shortcut"]],[12,[" (method of ",[0,[1,"selectable-menu-item&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-shortcut-prefix",">gui/selectable-menu-item___.html#(meth._(((lib._mred/main..ss)._selectable-menu-item~3c~25~3e)._get-shortcut-prefix))",[[0,[1,"get-shortcut-prefix"]],[12,[" (method of ",[0,[1,"selectable-menu-item&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-should-raise",">gui/WXME_Decoding.html#(meth._(((lib._wxme/test-case..ss)._test-case~25)._get-should-raise))",[[0,[1,"get-should-raise"]],[12,[" (method of ",[0,[1,"test-case%"]],")"]]],["wxme/test-case"]],
["get-show-menu",">tools/drscheme_frame.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aframe~3a~3c~25~3e)._get-show-menu))",[[0,[1,"get-show-menu"]],[12,[" (method of ",[0,[1,"drscheme:frame:&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-size",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._get-size))",[[0,[1,"get-size"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-size",">gui/style___.html#(meth._(((lib._mred/main..ss)._style~3c~25~3e)._get-size))",[[0,[1,"get-size"]],[12,[" (method of ",[0,[1,"style&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-size",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._get-size))",[[0,[1,"get-size"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-size",">mrlib/Cache-image_Snip.html#(meth._(((lib._mrlib/cache-image-snip..ss)._cache-image-snip~25)._get-size))",[[0,[1,"get-size"]],[12,[" (method of ",[0,[1,"cache-image-snip%"]],")"]]],["mrlib/cache-image-snip"]],
["get-size-add",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._get-size-add))",[[0,[1,"get-size-add"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-size-in-pixels",">gui/font_.html#(meth._(((lib._mred/main..ss)._font~25)._get-size-in-pixels))",[[0,[1,"get-size-in-pixels"]],[12,[" (method of ",[0,[1,"font%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-size-in-pixels",">gui/style___.html#(meth._(((lib._mred/main..ss)._style~3c~25~3e)._get-size-in-pixels))",[[0,[1,"get-size-in-pixels"]],[12,[" (method of ",[0,[1,"style&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-size-in-pixels-off",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._get-size-in-pixels-off))",[[0,[1,"get-size-in-pixels-off"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-size-in-pixels-on",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._get-size-in-pixels-on))",[[0,[1,"get-size-in-pixels-on"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-size-mult",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._get-size-mult))",[[0,[1,"get-size-mult"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-slides-as-picts",">slideshow/Slides_to_Picts.html#(def._((lib._slideshow/slides-to-picts..ss)._get-slides-as-picts))",[0,[1,"get-slides-as-picts"]],["slideshow/slides-to-picts"]],
["get-smoothing",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._get-smoothing))",[[0,[1,"get-smoothing"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-smoothing",">gui/font_.html#(meth._(((lib._mred/main..ss)._font~25)._get-smoothing))",[[0,[1,"get-smoothing"]],[12,[" (method of ",[0,[1,"font%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-smoothing",">gui/style___.html#(meth._(((lib._mred/main..ss)._style~3c~25~3e)._get-smoothing))",[[0,[1,"get-smoothing"]],[12,[" (method of ",[0,[1,"style&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-smoothing-off",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._get-smoothing-off))",[[0,[1,"get-smoothing-off"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-smoothing-on",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._get-smoothing-on))",[[0,[1,"get-smoothing-on"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-snip",">gui/editor-snip-editor-admin___.html#(meth._(((lib._mred/main..ss)._editor-snip-editor-admin~3c~25~3e)._get-snip))",[[0,[1,"get-snip"]],[12,[" (method of ",[0,[1,"editor-snip-editor-admin&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-snip-data",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._get-snip-data))",[[0,[1,"get-snip-data"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-snip-location",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._get-snip-location))",[[0,[1,"get-snip-location"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-snip-position",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._get-snip-position))",[[0,[1,"get-snip-position"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-snip-position-and-location",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._get-snip-position-and-location))",[[0,[1,"get-snip-position-and-location"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-snipclass",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._get-snipclass))",[[0,[1,"get-snipclass"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-space",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._get-space))",[[0,[1,"get-space"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-spaces",">gl-board-game/index.html#(meth._(((lib._games/gl-board-game..ss)._gl-board~25)._get-spaces))",[[0,[1,"get-spaces"]],[12,[" (method of ",[0,[1,"gl-board%"]],")"]]],["games/gl-board-game"]],
["get-standard-compilers",">dynext/Compilation.html#(def._((lib._dynext/compile..ss)._get-standard-compilers))",[0,[1,"get-standard-compilers"]],["dynext/compile"]],
["get-start-position",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._get-start-position))",[[0,[1,"get-start-position"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-stencil-size",">gui/gl-config_.html#(meth._(((lib._mred/main..ss)._gl-config~25)._get-stencil-size))",[[0,[1,"get-stencil-size"]],[12,[" (method of ",[0,[1,"gl-config%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-stereo",">gui/gl-config_.html#(meth._(((lib._mred/main..ss)._gl-config~25)._get-stereo))",[[0,[1,"get-stereo"]],[12,[" (method of ",[0,[1,"gl-config%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-stipple",">gui/brush_.html#(meth._(((lib._mred/main..ss)._brush~25)._get-stipple))",[[0,[1,"get-stipple"]],[12,[" (method of ",[0,[1,"brush%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-stipple",">gui/pen_.html#(meth._(((lib._mred/main..ss)._pen~25)._get-stipple))",[[0,[1,"get-stipple"]],[12,[" (method of ",[0,[1,"pen%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-string",">gui/list-control___.html#(meth._(((lib._mred/main..ss)._list-control~3c~25~3e)._get-string))",[[0,[1,"get-string"]],[12,[" (method of ",[0,[1,"list-control&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-string-all",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_704",[0,[1,"get-string-all"]],["rnrs/io/ports-6"]],
["get-string-n",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_700",[0,[1,"get-string-n"]],["rnrs/io/ports-6"]],
["get-string-n!",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_702",[0,[1,"get-string-n!"]],["rnrs/io/ports-6"]],
["get-string-selection",">gui/list-control___.html#(meth._(((lib._mred/main..ss)._list-control~3c~25~3e)._get-string-selection))",[[0,[1,"get-string-selection"]],[12,[" (method of ",[0,[1,"list-control&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-string-size",">graphics/Miscellaneous_Operations.html#(def._((lib._graphics/graphics..ss)._get-string-size))",[0,[1,"get-string-size"]],["graphics/graphics"]],
["get-style",">gui/brush_.html#(meth._(((lib._mred/main..ss)._brush~25)._get-style))",[[0,[1,"get-style"]],[12,[" (method of ",[0,[1,"brush%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-style",">gui/font_.html#(meth._(((lib._mred/main..ss)._font~25)._get-style))",[[0,[1,"get-style"]],[12,[" (method of ",[0,[1,"font%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-style",">gui/pen_.html#(meth._(((lib._mred/main..ss)._pen~25)._get-style))",[[0,[1,"get-style"]],[12,[" (method of ",[0,[1,"pen%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-style",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._get-style))",[[0,[1,"get-style"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-style",">gui/style___.html#(meth._(((lib._mred/main..ss)._style~3c~25~3e)._get-style))",[[0,[1,"get-style"]],[12,[" (method of ",[0,[1,"style&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-style-delta",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e)._get-style-delta))",[[0,[1,"get-style-delta"]],[12,[" (method of ",[0,[1,"drscheme:language:language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-style-list",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._get-style-list))",[[0,[1,"get-style-list"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-style-off",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._get-style-off))",[[0,[1,"get-style-off"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-style-on",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._get-style-on))",[[0,[1,"get-style-on"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-styles-fixed",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3abasic~3c~25~3e)._get-styles-fixed))",[[0,[1,"get-styles-fixed"]],[12,[" (method of ",[0,[1,"text:basic&lt;%&gt;"]],")"]]],["framework"]],
["get-styles-sticky",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._get-styles-sticky))",[[0,[1,"get-styles-sticky"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-suit",">cards/index.html#(meth._(((lib._games/cards..ss)._card~3c~25~3e)._get-suit))",[[0,[1,"get-suit"]],[12,[" (method of ",[0,[1,"card&lt;%&gt;"]],")"]]],["games/cards"]],
["get-suit-id",">cards/index.html#(meth._(((lib._games/cards..ss)._card~3c~25~3e)._get-suit-id))",[[0,[1,"get-suit-id"]],[12,[" (method of ",[0,[1,"card&lt;%&gt;"]],")"]]],["games/cards"]],
["get-surrogate",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text~3c~25~3e)._get-surrogate))",[[0,[1,"get-surrogate"]],[12,[" (method of ",[0,[1,"mode:host-text&lt;%&gt;"]],")"]]],["framework"]],
["get-tab",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3adefinitions-text~3c~25~3e)._get-tab))",[[0,[1,"get-tab"]],[12,[" (method of ",[0,[1,"drscheme:unit:definitions-text&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-tab-size",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._get-tab-size))",[[0,[1,"get-tab-size"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["get-tabs",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._get-tabs))",[[0,[1,"get-tabs"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-tabs",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~3c~25~3e)._get-tabs))",[[0,[1,"get-tabs"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-test",">gui/WXME_Decoding.html#(meth._(((lib._wxme/test-case..ss)._test-case~25)._get-test))",[[0,[1,"get-test"]],[12,[" (method of ",[0,[1,"test-case%"]],")"]]],["wxme/test-case"]],
["get-text",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._get-text))",[[0,[1,"get-text"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-text",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._get-text))",[[0,[1,"get-text"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-text",">framework/Comment_Box.html#(meth._(((lib._framework/main..ss)._comment-box~3asnip~25)._get-text))",[[0,[1,"get-text"]],[12,[" (method of ",[0,[1,"comment-box:snip%"]],")"]]],["framework"]],
["get-text",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3asexp-snip~25)._get-text))",[[0,[1,"get-text"]],[12,[" (method of ",[0,[1,"scheme:sexp-snip%"]],")"]]],["framework"]],
["get-text",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._get-text))",[[0,[1,"get-text"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["get-text!",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._get-text!))",[[0,[1,"get-text!"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-text-background",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._get-text-background))",[[0,[1,"get-text-background"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-text-descent",">gui/style___.html#(meth._(((lib._mred/main..ss)._style~3c~25~3e)._get-text-descent))",[[0,[1,"get-text-descent"]],[12,[" (method of ",[0,[1,"style&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-text-extent",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._get-text-extent))",[[0,[1,"get-text-extent"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-text-foreground",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._get-text-foreground))",[[0,[1,"get-text-foreground"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-text-from-user",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._get-text-from-user))",[0,[1,"get-text-from-user"]],["scheme/gui/base","scheme/gui"]],
["get-text-height",">gui/style___.html#(meth._(((lib._mred/main..ss)._style~3c~25~3e)._get-text-height))",[[0,[1,"get-text-height"]],[12,[" (method of ",[0,[1,"style&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-text-mode",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._get-text-mode))",[[0,[1,"get-text-mode"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-text-space",">gui/style___.html#(meth._(((lib._mred/main..ss)._style~3c~25~3e)._get-text-space))",[[0,[1,"get-text-space"]],[12,[" (method of ",[0,[1,"style&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-text-to-search",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._get-text-to-search))",[[0,[1,"get-text-to-search"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["get-text-to-search",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable-text-mixin)._get-text-to-search))",[[0,[1,"get-text-to-search"]],[12,[" (method of ",[0,[1,"frame:searchable-text-mixin"]],")"]]],["framework"]],
["get-text-to-search",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable~3c~25~3e)._get-text-to-search))",[[0,[1,"get-text-to-search"]],[12,[" (method of ",[0,[1,"frame:searchable&lt;%&gt;"]],")"]]],["framework"]],
["get-text-width",">gui/style___.html#(meth._(((lib._mred/main..ss)._style~3c~25~3e)._get-text-width))",[[0,[1,"get-text-width"]],[12,[" (method of ",[0,[1,"style&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-the-editor-data-class-list",">gui/Editor_Functions.html#(def._((lib._mred/main..ss)._get-the-editor-data-class-list))",[0,[1,"get-the-editor-data-class-list"]],["scheme/gui/base","scheme/gui"]],
["get-the-snip-class-list",">gui/Editor_Functions.html#(def._((lib._mred/main..ss)._get-the-snip-class-list))",[0,[1,"get-the-snip-class-list"]],["scheme/gui/base","scheme/gui"]],
["get-tight-text-fit",">gui/editor-snip_.html#(meth._(((lib._mred/main..ss)._editor-snip~25)._get-tight-text-fit))",[[0,[1,"get-tight-text-fit"]],[12,[" (method of ",[0,[1,"editor-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-time-stamp",">gui/event_.html#(meth._(((lib._mred/main..ss)._event~25)._get-time-stamp))",[[0,[1,"get-time-stamp"]],[12,[" (method of ",[0,[1,"event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-title",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-text-mixin)._get-title))",[[0,[1,"get-title"]],[12,[" (method of ",[0,[1,"hyper-text-mixin"]],")"]]],["browser"]],
["get-top-level-edit-target-window",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._get-top-level-edit-target-window))",[0,[1,"get-top-level-edit-target-window"]],["scheme/gui/base","scheme/gui"]],
["get-top-level-focus-window",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._get-top-level-focus-window))",[0,[1,"get-top-level-focus-window"]],["scheme/gui/base","scheme/gui"]],
["get-top-level-window",">gui/area___.html#(meth._(((lib._mred/main..ss)._area~3c~25~3e)._get-top-level-window))",[[0,[1,"get-top-level-window"]],[12,[" (method of ",[0,[1,"area&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-top-level-window",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abasic~3c~25~3e)._get-top-level-window))",[[0,[1,"get-top-level-window"]],[12,[" (method of ",[0,[1,"editor:basic&lt;%&gt;"]],")"]]],["framework"]],
["get-top-level-windows",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._get-top-level-windows))",[0,[1,"get-top-level-windows"]],["scheme/gui/base","scheme/gui"]],
["get-top-line-base",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._get-top-line-base))",[[0,[1,"get-top-line-base"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-transformer-module",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3amodule-based-language~3c~25~3e)._get-transformer-module))",[[0,[1,"get-transformer-module"]],[12,[" (method of ",[0,[1,"drscheme:language:module-based-language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["get-transformer-module",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-module-based-language-~3emodule-based-language-mixin)._get-transformer-module))",[[0,[1,"get-transformer-module"]],[12,[" (method of ",[0,[1,"drscheme:language:simple-module-based-language-&gt;module-based-language-mixin"]],")"]]],["drscheme/tool-lib"]],
["get-translation",">gui/ps-setup_.html#(meth._(((lib._mred/main..ss)._ps-setup~25)._get-translation))",[[0,[1,"get-translation"]],[12,[" (method of ",[0,[1,"ps-setup%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-transparent-text-backing",">gui/style___.html#(meth._(((lib._mred/main..ss)._style~3c~25~3e)._get-transparent-text-backing))",[[0,[1,"get-transparent-text-backing"]],[12,[" (method of ",[0,[1,"style&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-transparent-text-backing-off",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._get-transparent-text-backing-off))",[[0,[1,"get-transparent-text-backing-off"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-transparent-text-backing-on",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._get-transparent-text-backing-on))",[[0,[1,"get-transparent-text-backing-on"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-types",">gui/clipboard-client_.html#(meth._(((lib._mred/main..ss)._clipboard-client~25)._get-types))",[[0,[1,"get-types"]],[12,[" (method of ",[0,[1,"clipboard-client%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-u8",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_684",[0,[1,"get-u8"]],["rnrs/io/ports-6"]],
["get-uncovered-expressions",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._get-uncovered-expressions))",[0,[1,"get-uncovered-expressions"]],["scheme/sandbox"]],
["get-underlined",">gui/font_.html#(meth._(((lib._mred/main..ss)._font~25)._get-underlined))",[[0,[1,"get-underlined"]],[12,[" (method of ",[0,[1,"font%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-underlined",">gui/style___.html#(meth._(((lib._mred/main..ss)._style~3c~25~3e)._get-underlined))",[[0,[1,"get-underlined"]],[12,[" (method of ",[0,[1,"style&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-underlined-off",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._get-underlined-off))",[[0,[1,"get-underlined-off"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-underlined-on",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._get-underlined-on))",[[0,[1,"get-underlined-on"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-unique-id/all",">net/pop3.html#(def._((lib._net/pop3..ss)._get-unique-id/all))",[0,[1,"get-unique-id/all"]],["net/pop3"]],
["get-unique-id/single",">net/pop3.html#(def._((lib._net/pop3..ss)._get-unique-id/single))",[0,[1,"get-unique-id/single"]],["net/pop3"]],
["get-unread-start-point",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._get-unread-start-point))",[[0,[1,"get-unread-start-point"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["get-unterminated-bytes",">gui/editor-stream-in_.html#(meth._(((lib._mred/main..ss)._editor-stream-in~25)._get-unterminated-bytes))",[[0,[1,"get-unterminated-bytes"]],[12,[" (method of ",[0,[1,"editor-stream-in%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-url",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-text-mixin)._get-url))",[[0,[1,"get-url"]],[12,[" (method of ",[0,[1,"hyper-text-mixin"]],")"]]],["browser"]],
["get-url",">browser/index.html#(meth._(((lib._browser/htmltext..ss)._html-text~3c~25~3e)._get-url))",[[0,[1,"get-url"]],[12,[" (method of ",[0,[1,"html-text&lt;%&gt;"]],")"]]],["browser/htmltext"]],
["get-user-custodian",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3atext~25)._get-user-custodian))",[[0,[1,"get-user-custodian"]],[12,[" (method of ",[0,[1,"drscheme:rep:text%"]],")"]]],["drscheme/tool-lib"]],
["get-user-eventspace",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3atext~25)._get-user-eventspace))",[[0,[1,"get-user-eventspace"]],[12,[" (method of ",[0,[1,"drscheme:rep:text%"]],")"]]],["drscheme/tool-lib"]],
["get-user-language-settings",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3atext~25)._get-user-language-settings))",[[0,[1,"get-user-language-settings"]],[12,[" (method of ",[0,[1,"drscheme:rep:text%"]],")"]]],["drscheme/tool-lib"]],
["get-user-namespace",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3atext~25)._get-user-namespace))",[[0,[1,"get-user-namespace"]],[12,[" (method of ",[0,[1,"drscheme:rep:text%"]],")"]]],["drscheme/tool-lib"]],
["get-user-thread",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3atext~25)._get-user-thread))",[[0,[1,"get-user-thread"]],[12,[" (method of ",[0,[1,"drscheme:rep:text%"]],")"]]],["drscheme/tool-lib"]],
["get-value",">gui/check-box_.html#(meth._(((lib._mred/main..ss)._check-box~25)._get-value))",[[0,[1,"get-value"]],[12,[" (method of ",[0,[1,"check-box%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-value",">gui/gauge_.html#(meth._(((lib._mred/main..ss)._gauge~25)._get-value))",[[0,[1,"get-value"]],[12,[" (method of ",[0,[1,"gauge%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-value",">gui/slider_.html#(meth._(((lib._mred/main..ss)._slider~25)._get-value))",[[0,[1,"get-value"]],[12,[" (method of ",[0,[1,"slider%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-value",">gui/text-field_.html#(meth._(((lib._mred/main..ss)._text-field~25)._get-value))",[[0,[1,"get-value"]],[12,[" (method of ",[0,[1,"text-field%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-value",">cards/index.html#(meth._(((lib._games/cards..ss)._card~3c~25~3e)._get-value))",[[0,[1,"get-value"]],[12,[" (method of ",[0,[1,"card&lt;%&gt;"]],")"]]],["games/cards"]],
["get-value-b",">frtime/index.html#(meth._(((lib._frtime/gui/fred..ss)._ft-check-box~25)._get-value-b))",[[0,[1,"get-value-b"]],[12,[" (method of ",[0,[1,"ft-check-box%"]],")"]]],["frtime/gui/fred"]],
["get-value-b",">frtime/index.html#(meth._(((lib._frtime/gui/fred..ss)._ft-slider~25)._get-value-b))",[[0,[1,"get-value-b"]],[12,[" (method of ",[0,[1,"ft-slider%"]],")"]]],["frtime/gui/fred"]],
["get-value-b",">frtime/index.html#(meth._(((lib._frtime/gui/fred..ss)._ft-text-field~25)._get-value-b))",[[0,[1,"get-value-b"]],[12,[" (method of ",[0,[1,"ft-text-field%"]],")"]]],["frtime/gui/fred"]],
["get-value-e",">frtime/index.html#(meth._(((lib._frtime/gui/fred..ss)._ft-button~25)._get-value-e))",[[0,[1,"get-value-e"]],[12,[" (method of ",[0,[1,"ft-button%"]],")"]]],["frtime/gui/fred"]],
["get-value-port",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._get-value-port))",[[0,[1,"get-value-port"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["get-value-style-delta",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._get-value-style-delta))",[[0,[1,"get-value-style-delta"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["get-version",">gui/snip-class_.html#(meth._(((lib._mred/main..ss)._snip-class~25)._get-version))",[[0,[1,"get-version"]],[12,[" (method of ",[0,[1,"snip-class%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-vertical?",">framework/Panel.html#(meth._(((lib._framework/main..ss)._panel~3adragable~3c~25~3e)._get-vertical~3f))",[[0,[1,"get-vertical?"]],[12,[" (method of ",[0,[1,"panel:dragable&lt;%&gt;"]],")"]]],["framework"]],
["get-vertical?",">framework/Panel.html#(meth._(((lib._framework/main..ss)._panel~3ahorizontal-dragable-mixin)._get-vertical~3f))",[[0,[1,"get-vertical?"]],[12,[" (method of ",[0,[1,"panel:horizontal-dragable-mixin"]],")"]]],["framework"]],
["get-vertical?",">framework/Panel.html#(meth._(((lib._framework/main..ss)._panel~3avertical-dragable-mixin)._get-vertical~3f))",[[0,[1,"get-vertical?"]],[12,[" (method of ",[0,[1,"panel:vertical-dragable-mixin"]],")"]]],["framework"]],
["get-view",">gui/editor-admin_.html#(meth._(((lib._mred/main..ss)._editor-admin~25)._get-view))",[[0,[1,"get-view"]],[12,[" (method of ",[0,[1,"editor-admin%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-view",">gui/snip-admin_.html#(meth._(((lib._mred/main..ss)._snip-admin~25)._get-view))",[[0,[1,"get-view"]],[12,[" (method of ",[0,[1,"snip-admin%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-view-size",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._get-view-size))",[[0,[1,"get-view-size"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-view-size",">gui/snip-admin_.html#(meth._(((lib._mred/main..ss)._snip-admin~25)._get-view-size))",[[0,[1,"get-view-size"]],[12,[" (method of ",[0,[1,"snip-admin%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-view-start",">gui/canvas_.html#(meth._(((lib._mred/main..ss)._canvas~25)._get-view-start))",[[0,[1,"get-view-start"]],[12,[" (method of ",[0,[1,"canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-virtual-size",">gui/canvas_.html#(meth._(((lib._mred/main..ss)._canvas~25)._get-virtual-size))",[[0,[1,"get-virtual-size"]],[12,[" (method of ",[0,[1,"canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-visible-line-range",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._get-visible-line-range))",[[0,[1,"get-visible-line-range"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-visible-position-range",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._get-visible-position-range))",[[0,[1,"get-visible-position-range"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-w",">gui/WXME_Decoding.html#(meth._(((lib._wxme/image..ss)._image~25)._get-w))",[[0,[1,"get-w"]],[12,[" (method of ",[0,[1,"image%"]],")"]]],["wxme/image"]],
["get-weight",">gui/font_.html#(meth._(((lib._mred/main..ss)._font~25)._get-weight))",[[0,[1,"get-weight"]],[12,[" (method of ",[0,[1,"font%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-weight",">gui/style___.html#(meth._(((lib._mred/main..ss)._style~3c~25~3e)._get-weight))",[[0,[1,"get-weight"]],[12,[" (method of ",[0,[1,"style&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-weight-off",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._get-weight-off))",[[0,[1,"get-weight-off"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-weight-on",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._get-weight-on))",[[0,[1,"get-weight-on"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-width",">gui/bitmap_.html#(meth._(((lib._mred/main..ss)._bitmap~25)._get-width))",[[0,[1,"get-width"]],[12,[" (method of ",[0,[1,"bitmap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-width",">gui/pen_.html#(meth._(((lib._mred/main..ss)._pen~25)._get-width))",[[0,[1,"get-width"]],[12,[" (method of ",[0,[1,"pen%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-width",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._get-width))",[[0,[1,"get-width"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-width",">gui/WXME_Decoding.html#(meth._(((lib._wxme/cache-image..ss)._cache-image~25)._get-width))",[[0,[1,"get-width"]],[12,[" (method of ",[0,[1,"cache-image%"]],")"]]],["wxme/cache-image"]],
["get-window-text-extent",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._get-window-text-extent))",[0,[1,"get-window-text-extent"]],["scheme/gui/base","scheme/gui"]],
["get-word-at",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext-mixin)._get-word-at))",[[0,[1,"get-word-at"]],[12,[" (method of ",[0,[1,"scheme:text-mixin"]],")"]]],["framework"]],
["get-word-at",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aautocomplete~3c~25~3e)._get-word-at))",[[0,[1,"get-word-at"]],[12,[" (method of ",[0,[1,"text:autocomplete&lt;%&gt;"]],")"]]],["framework"]],
["get-wordbreak-map",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._get-wordbreak-map))",[[0,[1,"get-wordbreak-map"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-x",">gui/key-event_.html#(meth._(((lib._mred/main..ss)._key-event~25)._get-x))",[[0,[1,"get-x"]],[12,[" (method of ",[0,[1,"key-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-x",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._get-x))",[[0,[1,"get-x"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-x",">gui/point_.html#(meth._(((lib._mred/main..ss)._point~25)._get-x))",[[0,[1,"get-x"]],[12,[" (method of ",[0,[1,"point%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-x",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._get-x))",[[0,[1,"get-x"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-x-max",">plot/extend.html#(meth._(((lib._plot/extend..ss)._plot-view~25)._get-x-max))",[[0,[1,"get-x-max"]],[12,[" (method of ",[0,[1,"plot-view%"]],")"]]],["plot/extend"]],
["get-x-min",">plot/extend.html#(meth._(((lib._plot/extend..ss)._plot-view~25)._get-x-min))",[[0,[1,"get-x-min"]],[12,[" (method of ",[0,[1,"plot-view%"]],")"]]],["plot/extend"]],
["get-y",">gui/key-event_.html#(meth._(((lib._mred/main..ss)._key-event~25)._get-y))",[[0,[1,"get-y"]],[12,[" (method of ",[0,[1,"key-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-y",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._get-y))",[[0,[1,"get-y"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-y",">gui/point_.html#(meth._(((lib._mred/main..ss)._point~25)._get-y))",[[0,[1,"get-y"]],[12,[" (method of ",[0,[1,"point%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-y",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._get-y))",[[0,[1,"get-y"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["get-y-max",">plot/extend.html#(meth._(((lib._plot/extend..ss)._plot-view~25)._get-y-max))",[[0,[1,"get-y-max"]],[12,[" (method of ",[0,[1,"plot-view%"]],")"]]],["plot/extend"]],
["get-y-min",">plot/extend.html#(meth._(((lib._plot/extend..ss)._plot-view~25)._get-y-min))",[[0,[1,"get-y-min"]],[12,[" (method of ",[0,[1,"plot-view%"]],")"]]],["plot/extend"]],
["get-z-max",">plot/extend.html#(meth._(((lib._plot/extend..ss)._3d-view~25)._get-z-max))",[[0,[1,"get-z-max"]],[12,[" (method of ",[0,[1,"3d-view%"]],")"]]],["plot/extend"]],
["get-z-min",">plot/extend.html#(meth._(((lib._plot/extend..ss)._3d-view~25)._get-z-min))",[[0,[1,"get-z-min"]],[12,[" (method of ",[0,[1,"3d-view%"]],")"]]],["plot/extend"]],
["getenv",">reference/runtime.html#(def._((quote._~23~25kernel)._getenv))",[0,[1,"getenv"]],["scheme/base","scheme"]],
["gethostname",">mzlib/mzlib_os.html#(def._((lib._mzlib/os..ss)._gethostname))",[0,[1,"gethostname"]],["mzlib/os"]],
["getpid",">mzlib/mzlib_os.html#(def._((lib._mzlib/os..ss)._getpid))",[0,[1,"getpid"]],["mzlib/os"]],
["getprop",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..ss)._getprop))",[0,[1,"getprop"]],["mzlib/compat"]],
["getter-with-setter",">srfi-std/srfi-17.html#getter-with-setter",[0,[1,"getter-with-setter"]],["srfi/17"]],
["getting module compiled code",">syntax/module-helpers.html#(part._modcode)","Getting Module Compiled Code",false],
["getting started",">scribble/How_to_Scribble_Documentation.html#(part._getting-started)","Getting Started",false],
["getting started",">continue/index.html#(part._.Getting_.Started)","Getting Started",false],
["gfclampf",">sgl/gl.html#(idx._(gentag._13._(lib._sgl/scribblings/sgl..scrbl)))",[5,"GFclampf"],false],
["gffloat",">sgl/gl.html#(idx._(gentag._11._(lib._sgl/scribblings/sgl..scrbl)))",[5,"GFfloat"],false],
["ghost",">slideshow/Pict_Drawing_Adjusters.html#(def._((lib._slideshow/pict..ss)._ghost))",[0,[1,"ghost"]],["slideshow/pict","slideshow"]],
["gif",">gui/bitmap_.html#(idx._(gentag._163._(lib._scribblings/gui/gui..scrbl)))","GIF",false],
["gif and animated gif writing",">mrlib/GIF_and_Animated_GIF_Writing.html","GIF and Animated GIF Writing",false],
["gif file writing",">file/gif.html","GIF File Writing",false],
["gif-add-comment",">file/gif.html#(def._((lib._file/gif..ss)._gif-add-comment))",[0,[1,"gif-add-comment"]],["file/gif"]],
["gif-add-control",">file/gif.html#(def._((lib._file/gif..ss)._gif-add-control))",[0,[1,"gif-add-control"]],["file/gif"]],
["gif-add-image",">file/gif.html#(def._((lib._file/gif..ss)._gif-add-image))",[0,[1,"gif-add-image"]],["file/gif"]],
["gif-add-loop-control",">file/gif.html#(def._((lib._file/gif..ss)._gif-add-loop-control))",[0,[1,"gif-add-loop-control"]],["file/gif"]],
["gif-colormap?",">file/gif.html#(def._((lib._file/gif..ss)._gif-colormap~3f))",[0,[1,"gif-colormap?"]],["file/gif"]],
["gif-end",">file/gif.html#(def._((lib._file/gif..ss)._gif-end))",[0,[1,"gif-end"]],["file/gif"]],
["gif-start",">file/gif.html#(def._((lib._file/gif..ss)._gif-start))",[0,[1,"gif-start"]],["file/gif"]],
["gif-state",">file/gif.html#(def._((lib._file/gif..ss)._gif-state))",[0,[1,"gif-state"]],["file/gif"]],
["gif-stream?",">file/gif.html#(def._((lib._file/gif..ss)._gif-stream~3f))",[0,[1,"gif-stream?"]],["file/gif"]],
["gl board game: 3-d game support",">gl-board-game/index.html","<b>GL Board Game</b>: 3-D Game Support",false],
["gl-accum",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-accum))",[0,[1,"gl-accum"]],["sgl"]],
["gl-active-texture",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-active-texture))",[0,[1,"gl-active-texture"]],["sgl"]],
["gl-alpha-func",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-alpha-func))",[0,[1,"gl-alpha-func"]],["sgl"]],
["gl-begin",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-begin))",[0,[1,"gl-begin"]],["sgl"]],
["gl-begin-query",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-begin-query))",[0,[1,"gl-begin-query"]],["sgl"]],
["gl-blend-color",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-blend-color))",[0,[1,"gl-blend-color"]],["sgl"]],
["gl-blend-equation",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-blend-equation))",[0,[1,"gl-blend-equation"]],["sgl"]],
["gl-blend-func",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-blend-func))",[0,[1,"gl-blend-func"]],["sgl"]],
["gl-blend-func-separate",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-blend-func-separate))",[0,[1,"gl-blend-func-separate"]],["sgl"]],
["gl-board%",">gl-board-game/index.html#(def._((lib._games/gl-board-game..ss)._gl-board~25))",[0,[1,"gl-board%"]],["games/gl-board-game"]],
["gl-boolean-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-boolean-vector))",[0,[1,"gl-boolean-vector"]],["sgl/gl-vectors"]],
["gl-boolean-vector*",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-boolean-vector*))",[0,[1,"gl-boolean-vector*"]],["sgl/gl-vectors"]],
["gl-boolean-vector+",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-boolean-vector+))",[0,[1,"gl-boolean-vector+"]],["sgl/gl-vectors"]],
["gl-boolean-vector-",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-boolean-vector-))",[0,[1,"gl-boolean-vector-"]],["sgl/gl-vectors"]],
["gl-boolean-vector?",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-boolean-vector~3f))",[0,[1,"gl-boolean-vector?"]],["sgl/gl-vectors"]],
["gl-byte-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-byte-vector))",[0,[1,"gl-byte-vector"]],["sgl/gl-vectors"]],
["gl-byte-vector*",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-byte-vector*))",[0,[1,"gl-byte-vector*"]],["sgl/gl-vectors"]],
["gl-byte-vector+",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-byte-vector+))",[0,[1,"gl-byte-vector+"]],["sgl/gl-vectors"]],
["gl-byte-vector-",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-byte-vector-))",[0,[1,"gl-byte-vector-"]],["sgl/gl-vectors"]],
["gl-byte-vector?",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-byte-vector~3f))",[0,[1,"gl-byte-vector?"]],["sgl/gl-vectors"]],
["gl-call-list",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-call-list))",[0,[1,"gl-call-list"]],["sgl"]],
["gl-check-extension",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-check-extension))",[0,[1,"gl-check-extension"]],["sgl"]],
["gl-clear",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-clear))",[0,[1,"gl-clear"]],["sgl"]],
["gl-clear-accum",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-clear-accum))",[0,[1,"gl-clear-accum"]],["sgl"]],
["gl-clear-color",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-clear-color))",[0,[1,"gl-clear-color"]],["sgl"]],
["gl-clear-depth",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-clear-depth))",[0,[1,"gl-clear-depth"]],["sgl"]],
["gl-clear-index",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-clear-index))",[0,[1,"gl-clear-index"]],["sgl"]],
["gl-clear-stencil",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-clear-stencil))",[0,[1,"gl-clear-stencil"]],["sgl"]],
["gl-clip-plane",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-clip-plane))",[0,[1,"gl-clip-plane"]],["sgl"]],
["gl-color",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-color))",[0,[1,"gl-color"]],["sgl"]],
["gl-color-mask",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-color-mask))",[0,[1,"gl-color-mask"]],["sgl"]],
["gl-color-material",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-color-material))",[0,[1,"gl-color-material"]],["sgl"]],
["gl-color-v",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-color-v))",[0,[1,"gl-color-v"]],["sgl"]],
["gl-config%",">gui/gl-config_.html",[0,[1,"gl-config%"]],["scheme/gui/base","scheme/gui"]],
["gl-context<%>",">gui/gl-context___.html",[0,[1,"gl-context&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["gl-copy-pixels",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-copy-pixels))",[0,[1,"gl-copy-pixels"]],["sgl"]],
["gl-cull-face",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-cull-face))",[0,[1,"gl-cull-face"]],["sgl"]],
["gl-cylinder",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-cylinder))",[0,[1,"gl-cylinder"]],["sgl"]],
["gl-delete-lists",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-delete-lists))",[0,[1,"gl-delete-lists"]],["sgl"]],
["gl-delete-queries",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-delete-queries))",[0,[1,"gl-delete-queries"]],["sgl"]],
["gl-depth-func",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-depth-func))",[0,[1,"gl-depth-func"]],["sgl"]],
["gl-depth-mask",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-depth-mask))",[0,[1,"gl-depth-mask"]],["sgl"]],
["gl-depth-range",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-depth-range))",[0,[1,"gl-depth-range"]],["sgl"]],
["gl-disable",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-disable))",[0,[1,"gl-disable"]],["sgl"]],
["gl-disk",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-disk))",[0,[1,"gl-disk"]],["sgl"]],
["gl-double-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-double-vector))",[0,[1,"gl-double-vector"]],["sgl/gl-vectors"]],
["gl-double-vector*",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-double-vector*))",[0,[1,"gl-double-vector*"]],["sgl/gl-vectors"]],
["gl-double-vector+",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-double-vector+))",[0,[1,"gl-double-vector+"]],["sgl/gl-vectors"]],
["gl-double-vector-",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-double-vector-))",[0,[1,"gl-double-vector-"]],["sgl/gl-vectors"]],
["gl-double-vector?",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-double-vector~3f))",[0,[1,"gl-double-vector?"]],["sgl/gl-vectors"]],
["gl-edge-flag",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-edge-flag))",[0,[1,"gl-edge-flag"]],["sgl"]],
["gl-enable",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-enable))",[0,[1,"gl-enable"]],["sgl"]],
["gl-end",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-end))",[0,[1,"gl-end"]],["sgl"]],
["gl-end-list",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-end-list))",[0,[1,"gl-end-list"]],["sgl"]],
["gl-end-query",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-end-query))",[0,[1,"gl-end-query"]],["sgl"]],
["gl-eval-coord",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-eval-coord))",[0,[1,"gl-eval-coord"]],["sgl"]],
["gl-eval-coord-v",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-eval-coord-v))",[0,[1,"gl-eval-coord-v"]],["sgl"]],
["gl-eval-mesh",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-eval-mesh))",[0,[1,"gl-eval-mesh"]],["sgl"]],
["gl-eval-point",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-eval-point))",[0,[1,"gl-eval-point"]],["sgl"]],
["gl-feedback-buffer->gl-float-vector",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-feedback-buffer-~3egl-float-vector))",[0,[1,"gl-feedback-buffer-&gt;gl-float-vector"]],["sgl"]],
["gl-finish",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-finish))",[0,[1,"gl-finish"]],["sgl"]],
["gl-float-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-float-vector))",[0,[1,"gl-float-vector"]],["sgl/gl-vectors"]],
["gl-float-vector*",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-float-vector*))",[0,[1,"gl-float-vector*"]],["sgl/gl-vectors"]],
["gl-float-vector+",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-float-vector+))",[0,[1,"gl-float-vector+"]],["sgl/gl-vectors"]],
["gl-float-vector-",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-float-vector-))",[0,[1,"gl-float-vector-"]],["sgl/gl-vectors"]],
["gl-float-vector?",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-float-vector~3f))",[0,[1,"gl-float-vector?"]],["sgl/gl-vectors"]],
["gl-flush",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-flush))",[0,[1,"gl-flush"]],["sgl"]],
["gl-front-face",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-front-face))",[0,[1,"gl-front-face"]],["sgl"]],
["gl-frustum",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-frustum))",[0,[1,"gl-frustum"]],["sgl"]],
["gl-gen-lists",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-gen-lists))",[0,[1,"gl-gen-lists"]],["sgl"]],
["gl-gen-queries",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-gen-queries))",[0,[1,"gl-gen-queries"]],["sgl"]],
["gl-get-error",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-get-error))",[0,[1,"gl-get-error"]],["sgl"]],
["gl-get-gl-version-number",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-get-gl-version-number))",[0,[1,"gl-get-gl-version-number"]],["sgl"]],
["gl-get-glu-version-number",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-get-glu-version-number))",[0,[1,"gl-get-glu-version-number"]],["sgl"]],
["gl-get-string",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-get-string))",[0,[1,"gl-get-string"]],["sgl"]],
["gl-hint",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-hint))",[0,[1,"gl-hint"]],["sgl"]],
["gl-index",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-index))",[0,[1,"gl-index"]],["sgl"]],
["gl-index-mask",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-index-mask))",[0,[1,"gl-index-mask"]],["sgl"]],
["gl-index-v",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-index-v))",[0,[1,"gl-index-v"]],["sgl"]],
["gl-init-names",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-init-names))",[0,[1,"gl-init-names"]],["sgl"]],
["gl-int-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-int-vector))",[0,[1,"gl-int-vector"]],["sgl/gl-vectors"]],
["gl-int-vector*",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-int-vector*))",[0,[1,"gl-int-vector*"]],["sgl/gl-vectors"]],
["gl-int-vector+",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-int-vector+))",[0,[1,"gl-int-vector+"]],["sgl/gl-vectors"]],
["gl-int-vector-",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-int-vector-))",[0,[1,"gl-int-vector-"]],["sgl/gl-vectors"]],
["gl-int-vector?",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-int-vector~3f))",[0,[1,"gl-int-vector?"]],["sgl/gl-vectors"]],
["gl-is-buffer",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-is-buffer))",[0,[1,"gl-is-buffer"]],["sgl"]],
["gl-is-enabled",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-is-enabled))",[0,[1,"gl-is-enabled"]],["sgl"]],
["gl-is-list",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-is-list))",[0,[1,"gl-is-list"]],["sgl"]],
["gl-is-query",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-is-query))",[0,[1,"gl-is-query"]],["sgl"]],
["gl-light",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-light))",[0,[1,"gl-light"]],["sgl"]],
["gl-light-model",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-light-model))",[0,[1,"gl-light-model"]],["sgl"]],
["gl-light-model-v",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-light-model-v))",[0,[1,"gl-light-model-v"]],["sgl"]],
["gl-light-v",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-light-v))",[0,[1,"gl-light-v"]],["sgl"]],
["gl-line-stipple",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-line-stipple))",[0,[1,"gl-line-stipple"]],["sgl"]],
["gl-line-width",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-line-width))",[0,[1,"gl-line-width"]],["sgl"]],
["gl-list-base",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-list-base))",[0,[1,"gl-list-base"]],["sgl"]],
["gl-load-identity",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-load-identity))",[0,[1,"gl-load-identity"]],["sgl"]],
["gl-load-matrix",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-load-matrix))",[0,[1,"gl-load-matrix"]],["sgl"]],
["gl-load-name",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-load-name))",[0,[1,"gl-load-name"]],["sgl"]],
["gl-load-transpose-matrix",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-load-transpose-matrix))",[0,[1,"gl-load-transpose-matrix"]],["sgl"]],
["gl-look-at",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-look-at))",[0,[1,"gl-look-at"]],["sgl"]],
["gl-map-grid",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-map-grid))",[0,[1,"gl-map-grid"]],["sgl"]],
["gl-material",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-material))",[0,[1,"gl-material"]],["sgl"]],
["gl-material-v",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-material-v))",[0,[1,"gl-material-v"]],["sgl"]],
["gl-matrix-mode",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-matrix-mode))",[0,[1,"gl-matrix-mode"]],["sgl"]],
["gl-mult-matrix",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-mult-matrix))",[0,[1,"gl-mult-matrix"]],["sgl"]],
["gl-mult-transpose-matrix",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-mult-transpose-matrix))",[0,[1,"gl-mult-transpose-matrix"]],["sgl"]],
["gl-multi-tex-coord",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-multi-tex-coord))",[0,[1,"gl-multi-tex-coord"]],["sgl"]],
["gl-multi-tex-coord-v",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-multi-tex-coord-v))",[0,[1,"gl-multi-tex-coord-v"]],["sgl"]],
["gl-new-list",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-new-list))",[0,[1,"gl-new-list"]],["sgl"]],
["gl-new-quadric",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-new-quadric))",[0,[1,"gl-new-quadric"]],["sgl"]],
["gl-normal",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-normal))",[0,[1,"gl-normal"]],["sgl"]],
["gl-normal-v",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-normal-v))",[0,[1,"gl-normal-v"]],["sgl"]],
["gl-ortho",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-ortho))",[0,[1,"gl-ortho"]],["sgl"]],
["gl-ortho-2d",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-ortho-2d))",[0,[1,"gl-ortho-2d"]],["sgl"]],
["gl-partial-disk",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-partial-disk))",[0,[1,"gl-partial-disk"]],["sgl"]],
["gl-pass-through",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-pass-through))",[0,[1,"gl-pass-through"]],["sgl"]],
["gl-perspective",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-perspective))",[0,[1,"gl-perspective"]],["sgl"]],
["gl-pick-matrix",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-pick-matrix))",[0,[1,"gl-pick-matrix"]],["sgl"]],
["gl-pixel-store",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-pixel-store))",[0,[1,"gl-pixel-store"]],["sgl"]],
["gl-point-parameter",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-point-parameter))",[0,[1,"gl-point-parameter"]],["sgl"]],
["gl-point-parameter-v",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-point-parameter-v))",[0,[1,"gl-point-parameter-v"]],["sgl"]],
["gl-point-size",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-point-size))",[0,[1,"gl-point-size"]],["sgl"]],
["gl-polygon-mode",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-polygon-mode))",[0,[1,"gl-polygon-mode"]],["sgl"]],
["gl-polygon-offset",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-polygon-offset))",[0,[1,"gl-polygon-offset"]],["sgl"]],
["gl-pop-attrib",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-pop-attrib))",[0,[1,"gl-pop-attrib"]],["sgl"]],
["gl-pop-client-attrib",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-pop-client-attrib))",[0,[1,"gl-pop-client-attrib"]],["sgl"]],
["gl-pop-matrix",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-pop-matrix))",[0,[1,"gl-pop-matrix"]],["sgl"]],
["gl-pop-name",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-pop-name))",[0,[1,"gl-pop-name"]],["sgl"]],
["gl-process-selection",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-process-selection))",[0,[1,"gl-process-selection"]],["sgl"]],
["gl-project",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-project))",[0,[1,"gl-project"]],["sgl"]],
["gl-push-matrix",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-push-matrix))",[0,[1,"gl-push-matrix"]],["sgl"]],
["gl-push-name",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-push-name))",[0,[1,"gl-push-name"]],["sgl"]],
["gl-quadric-draw-style",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-quadric-draw-style))",[0,[1,"gl-quadric-draw-style"]],["sgl"]],
["gl-quadric-normals",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-quadric-normals))",[0,[1,"gl-quadric-normals"]],["sgl"]],
["gl-quadric-orientation",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-quadric-orientation))",[0,[1,"gl-quadric-orientation"]],["sgl"]],
["gl-quadric-texture",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-quadric-texture))",[0,[1,"gl-quadric-texture"]],["sgl"]],
["gl-raster-pos",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-raster-pos))",[0,[1,"gl-raster-pos"]],["sgl"]],
["gl-raster-pos-v",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-raster-pos-v))",[0,[1,"gl-raster-pos-v"]],["sgl"]],
["gl-rect",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-rect))",[0,[1,"gl-rect"]],["sgl"]],
["gl-rect-v",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-rect-v))",[0,[1,"gl-rect-v"]],["sgl"]],
["gl-render-mode",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-render-mode))",[0,[1,"gl-render-mode"]],["sgl"]],
["gl-rotate",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-rotate))",[0,[1,"gl-rotate"]],["sgl"]],
["gl-sample-coverage",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-sample-coverage))",[0,[1,"gl-sample-coverage"]],["sgl"]],
["gl-scale",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-scale))",[0,[1,"gl-scale"]],["sgl"]],
["gl-scissor",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-scissor))",[0,[1,"gl-scissor"]],["sgl"]],
["gl-secondary-color",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-secondary-color))",[0,[1,"gl-secondary-color"]],["sgl"]],
["gl-secondary-color-v",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-secondary-color-v))",[0,[1,"gl-secondary-color-v"]],["sgl"]],
["gl-select-buffer->gl-uint-vector",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-select-buffer-~3egl-uint-vector))",[0,[1,"gl-select-buffer-&gt;gl-uint-vector"]],["sgl"]],
["gl-selection-record",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-selection-record))",[0,[1,"gl-selection-record"]],["sgl"]],
["gl-selection-record-max-z",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-selection-record-max-z))",[0,[1,"gl-selection-record-max-z"]],["sgl"]],
["gl-selection-record-min-z",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-selection-record-min-z))",[0,[1,"gl-selection-record-min-z"]],["sgl"]],
["gl-selection-record-stack",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-selection-record-stack))",[0,[1,"gl-selection-record-stack"]],["sgl"]],
["gl-selection-record?",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-selection-record~3f))",[0,[1,"gl-selection-record?"]],["sgl"]],
["gl-shade-model",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-shade-model))",[0,[1,"gl-shade-model"]],["sgl"]],
["gl-short-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-short-vector))",[0,[1,"gl-short-vector"]],["sgl/gl-vectors"]],
["gl-short-vector*",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-short-vector*))",[0,[1,"gl-short-vector*"]],["sgl/gl-vectors"]],
["gl-short-vector+",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-short-vector+))",[0,[1,"gl-short-vector+"]],["sgl/gl-vectors"]],
["gl-short-vector-",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-short-vector-))",[0,[1,"gl-short-vector-"]],["sgl/gl-vectors"]],
["gl-short-vector?",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-short-vector~3f))",[0,[1,"gl-short-vector?"]],["sgl/gl-vectors"]],
["gl-sphere",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-sphere))",[0,[1,"gl-sphere"]],["sgl"]],
["gl-stencil-func",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-stencil-func))",[0,[1,"gl-stencil-func"]],["sgl"]],
["gl-stencil-mask",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-stencil-mask))",[0,[1,"gl-stencil-mask"]],["sgl"]],
["gl-stencil-op",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-stencil-op))",[0,[1,"gl-stencil-op"]],["sgl"]],
["gl-tex-coord",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-tex-coord))",[0,[1,"gl-tex-coord"]],["sgl"]],
["gl-tex-coord-v",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-tex-coord-v))",[0,[1,"gl-tex-coord-v"]],["sgl"]],
["gl-tex-gen",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-tex-gen))",[0,[1,"gl-tex-gen"]],["sgl"]],
["gl-tex-gen-v",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-tex-gen-v))",[0,[1,"gl-tex-gen-v"]],["sgl"]],
["gl-translate",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-translate))",[0,[1,"gl-translate"]],["sgl"]],
["gl-u-get-string",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-u-get-string))",[0,[1,"gl-u-get-string"]],["sgl"]],
["gl-ubyte-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-ubyte-vector))",[0,[1,"gl-ubyte-vector"]],["sgl/gl-vectors"]],
["gl-ubyte-vector*",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-ubyte-vector*))",[0,[1,"gl-ubyte-vector*"]],["sgl/gl-vectors"]],
["gl-ubyte-vector+",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-ubyte-vector+))",[0,[1,"gl-ubyte-vector+"]],["sgl/gl-vectors"]],
["gl-ubyte-vector-",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-ubyte-vector-))",[0,[1,"gl-ubyte-vector-"]],["sgl/gl-vectors"]],
["gl-ubyte-vector?",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-ubyte-vector~3f))",[0,[1,"gl-ubyte-vector?"]],["sgl/gl-vectors"]],
["gl-uint-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-uint-vector))",[0,[1,"gl-uint-vector"]],["sgl/gl-vectors"]],
["gl-uint-vector*",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-uint-vector*))",[0,[1,"gl-uint-vector*"]],["sgl/gl-vectors"]],
["gl-uint-vector+",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-uint-vector+))",[0,[1,"gl-uint-vector+"]],["sgl/gl-vectors"]],
["gl-uint-vector-",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-uint-vector-))",[0,[1,"gl-uint-vector-"]],["sgl/gl-vectors"]],
["gl-uint-vector?",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-uint-vector~3f))",[0,[1,"gl-uint-vector?"]],["sgl/gl-vectors"]],
["gl-un-project",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-un-project))",[0,[1,"gl-un-project"]],["sgl"]],
["gl-un-project4",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-un-project4))",[0,[1,"gl-un-project4"]],["sgl"]],
["gl-ushort-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-ushort-vector))",[0,[1,"gl-ushort-vector"]],["sgl/gl-vectors"]],
["gl-ushort-vector*",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-ushort-vector*))",[0,[1,"gl-ushort-vector*"]],["sgl/gl-vectors"]],
["gl-ushort-vector+",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-ushort-vector+))",[0,[1,"gl-ushort-vector+"]],["sgl/gl-vectors"]],
["gl-ushort-vector-",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-ushort-vector-))",[0,[1,"gl-ushort-vector-"]],["sgl/gl-vectors"]],
["gl-ushort-vector?",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-ushort-vector~3f))",[0,[1,"gl-ushort-vector?"]],["sgl/gl-vectors"]],
["gl-vector->list",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-vector-~3elist))",[0,[1,"gl-vector-&gt;list"]],["sgl/gl-vectors"]],
["gl-vector->vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-vector-~3evector))",[0,[1,"gl-vector-&gt;vector"]],["sgl/gl-vectors"]],
["gl-vector-length",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-vector-length))",[0,[1,"gl-vector-length"]],["sgl/gl-vectors"]],
["gl-vector-norm",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-vector-norm))",[0,[1,"gl-vector-norm"]],["sgl/gl-vectors"]],
["gl-vector-ref",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-vector-ref))",[0,[1,"gl-vector-ref"]],["sgl/gl-vectors"]],
["gl-vector-set!",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-vector-set!))",[0,[1,"gl-vector-set!"]],["sgl/gl-vectors"]],
["gl-vector?",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._gl-vector~3f))",[0,[1,"gl-vector?"]],["sgl/gl-vectors"]],
["gl-vertex",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-vertex))",[0,[1,"gl-vertex"]],["sgl"]],
["gl-vertex-v",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-vertex-v))",[0,[1,"gl-vertex-v"]],["sgl"]],
["gl-viewport",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-viewport))",[0,[1,"gl-viewport"]],["sgl"]],
["gl-window-pos",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-window-pos))",[0,[1,"gl-window-pos"]],["sgl"]],
["gl-window-pos-v",">sgl/main.html#(def._((lib._sgl/main..ss)._gl-window-pos-v))",[0,[1,"gl-window-pos-v"]],["sgl"]],
["gl: 3-d graphics",">sgl/index.html","<b>GL</b>: 3-D Graphics",false],
["gl_2_bytes",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_2_.B.Y.T.E.S))",[0,[1,"GL_2_BYTES"]],["sgl/gl"]],
["gl_2d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_2.D))",[0,[1,"GL_2D"]],["sgl/gl"]],
["gl_3_bytes",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_3_.B.Y.T.E.S))",[0,[1,"GL_3_BYTES"]],["sgl/gl"]],
["gl_3d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_3.D))",[0,[1,"GL_3D"]],["sgl/gl"]],
["gl_3d_color",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_3.D_.C.O.L.O.R))",[0,[1,"GL_3D_COLOR"]],["sgl/gl"]],
["gl_3d_color_texture",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_3.D_.C.O.L.O.R_.T.E.X.T.U.R.E))",[0,[1,"GL_3D_COLOR_TEXTURE"]],["sgl/gl"]],
["gl_4_bytes",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_4_.B.Y.T.E.S))",[0,[1,"GL_4_BYTES"]],["sgl/gl"]],
["gl_4d_color_texture",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_4.D_.C.O.L.O.R_.T.E.X.T.U.R.E))",[0,[1,"GL_4D_COLOR_TEXTURE"]],["sgl/gl"]],
["gl_accum",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.C.C.U.M))",[0,[1,"GL_ACCUM"]],["sgl/gl"]],
["gl_accum_alpha_bits",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.C.C.U.M_.A.L.P.H.A_.B.I.T.S))",[0,[1,"GL_ACCUM_ALPHA_BITS"]],["sgl/gl"]],
["gl_accum_blue_bits",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.C.C.U.M_.B.L.U.E_.B.I.T.S))",[0,[1,"GL_ACCUM_BLUE_BITS"]],["sgl/gl"]],
["gl_accum_buffer_bit",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.C.C.U.M_.B.U.F.F.E.R_.B.I.T))",[0,[1,"GL_ACCUM_BUFFER_BIT"]],["sgl/gl"]],
["gl_accum_clear_value",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.C.C.U.M_.C.L.E.A.R_.V.A.L.U.E))",[0,[1,"GL_ACCUM_CLEAR_VALUE"]],["sgl/gl"]],
["gl_accum_green_bits",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.C.C.U.M_.G.R.E.E.N_.B.I.T.S))",[0,[1,"GL_ACCUM_GREEN_BITS"]],["sgl/gl"]],
["gl_accum_red_bits",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.C.C.U.M_.R.E.D_.B.I.T.S))",[0,[1,"GL_ACCUM_RED_BITS"]],["sgl/gl"]],
["gl_active_texture",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.C.T.I.V.E_.T.E.X.T.U.R.E))",[0,[1,"GL_ACTIVE_TEXTURE"]],["sgl/gl"]],
["gl_add",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.D.D))",[0,[1,"GL_ADD"]],["sgl/gl"]],
["gl_add_signed",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.D.D_.S.I.G.N.E.D))",[0,[1,"GL_ADD_SIGNED"]],["sgl/gl"]],
["gl_aliased_line_width_range",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.L.I.A.S.E.D_.L.I.N.E_.W.I.D.T.H_.R.A.N.G.E))",[0,[1,"GL_ALIASED_LINE_WIDTH_RANGE"]],["sgl/gl"]],
["gl_aliased_point_size_range",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.L.I.A.S.E.D_.P.O.I.N.T_.S.I.Z.E_.R.A.N.G.E))",[0,[1,"GL_ALIASED_POINT_SIZE_RANGE"]],["sgl/gl"]],
["gl_all_attrib_bits",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.L.L_.A.T.T.R.I.B_.B.I.T.S))",[0,[1,"GL_ALL_ATTRIB_BITS"]],["sgl/gl"]],
["gl_all_client_attrib_bits",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.L.L_.C.L.I.E.N.T_.A.T.T.R.I.B_.B.I.T.S))",[0,[1,"GL_ALL_CLIENT_ATTRIB_BITS"]],["sgl/gl"]],
["gl_alpha",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.L.P.H.A))",[0,[1,"GL_ALPHA"]],["sgl/gl"]],
["gl_alpha12",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.L.P.H.A12))",[0,[1,"GL_ALPHA12"]],["sgl/gl"]],
["gl_alpha16",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.L.P.H.A16))",[0,[1,"GL_ALPHA16"]],["sgl/gl"]],
["gl_alpha4",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.L.P.H.A4))",[0,[1,"GL_ALPHA4"]],["sgl/gl"]],
["gl_alpha8",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.L.P.H.A8))",[0,[1,"GL_ALPHA8"]],["sgl/gl"]],
["gl_alpha_bias",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.L.P.H.A_.B.I.A.S))",[0,[1,"GL_ALPHA_BIAS"]],["sgl/gl"]],
["gl_alpha_bits",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.L.P.H.A_.B.I.T.S))",[0,[1,"GL_ALPHA_BITS"]],["sgl/gl"]],
["gl_alpha_scale",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.L.P.H.A_.S.C.A.L.E))",[0,[1,"GL_ALPHA_SCALE"]],["sgl/gl"]],
["gl_alpha_test",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.L.P.H.A_.T.E.S.T))",[0,[1,"GL_ALPHA_TEST"]],["sgl/gl"]],
["gl_alpha_test_func",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.L.P.H.A_.T.E.S.T_.F.U.N.C))",[0,[1,"GL_ALPHA_TEST_FUNC"]],["sgl/gl"]],
["gl_alpha_test_ref",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.L.P.H.A_.T.E.S.T_.R.E.F))",[0,[1,"GL_ALPHA_TEST_REF"]],["sgl/gl"]],
["gl_always",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.L.W.A.Y.S))",[0,[1,"GL_ALWAYS"]],["sgl/gl"]],
["gl_ambient",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.M.B.I.E.N.T))",[0,[1,"GL_AMBIENT"]],["sgl/gl"]],
["gl_ambient_and_diffuse",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.M.B.I.E.N.T_.A.N.D_.D.I.F.F.U.S.E))",[0,[1,"GL_AMBIENT_AND_DIFFUSE"]],["sgl/gl"]],
["gl_and",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.N.D))",[0,[1,"GL_AND"]],["sgl/gl"]],
["gl_and_inverted",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.N.D_.I.N.V.E.R.T.E.D))",[0,[1,"GL_AND_INVERTED"]],["sgl/gl"]],
["gl_and_reverse",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.N.D_.R.E.V.E.R.S.E))",[0,[1,"GL_AND_REVERSE"]],["sgl/gl"]],
["gl_array_buffer",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.R.R.A.Y_.B.U.F.F.E.R))",[0,[1,"GL_ARRAY_BUFFER"]],["sgl/gl"]],
["gl_array_buffer_binding",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.R.R.A.Y_.B.U.F.F.E.R_.B.I.N.D.I.N.G))",[0,[1,"GL_ARRAY_BUFFER_BINDING"]],["sgl/gl"]],
["gl_attrib_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.T.T.R.I.B_.S.T.A.C.K_.D.E.P.T.H))",[0,[1,"GL_ATTRIB_STACK_DEPTH"]],["sgl/gl"]],
["gl_auto_normal",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.U.T.O_.N.O.R.M.A.L))",[0,[1,"GL_AUTO_NORMAL"]],["sgl/gl"]],
["gl_aux0",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.U.X0))",[0,[1,"GL_AUX0"]],["sgl/gl"]],
["gl_aux1",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.U.X1))",[0,[1,"GL_AUX1"]],["sgl/gl"]],
["gl_aux2",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.U.X2))",[0,[1,"GL_AUX2"]],["sgl/gl"]],
["gl_aux3",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.U.X3))",[0,[1,"GL_AUX3"]],["sgl/gl"]],
["gl_aux_buffers",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.A.U.X_.B.U.F.F.E.R.S))",[0,[1,"GL_AUX_BUFFERS"]],["sgl/gl"]],
["gl_back",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.B.A.C.K))",[0,[1,"GL_BACK"]],["sgl/gl"]],
["gl_back_left",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.B.A.C.K_.L.E.F.T))",[0,[1,"GL_BACK_LEFT"]],["sgl/gl"]],
["gl_back_right",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.B.A.C.K_.R.I.G.H.T))",[0,[1,"GL_BACK_RIGHT"]],["sgl/gl"]],
["gl_bgr",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.B.G.R))",[0,[1,"GL_BGR"]],["sgl/gl"]],
["gl_bgra",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.B.G.R.A))",[0,[1,"GL_BGRA"]],["sgl/gl"]],
["gl_bitmap",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.B.I.T.M.A.P))",[0,[1,"GL_BITMAP"]],["sgl/gl"]],
["gl_bitmap_token",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.B.I.T.M.A.P_.T.O.K.E.N))",[0,[1,"GL_BITMAP_TOKEN"]],["sgl/gl"]],
["gl_blend",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.B.L.E.N.D))",[0,[1,"GL_BLEND"]],["sgl/gl"]],
["gl_blend_color",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.B.L.E.N.D_.C.O.L.O.R))",[0,[1,"GL_BLEND_COLOR"]],["sgl/gl"]],
["gl_blend_dst",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.B.L.E.N.D_.D.S.T))",[0,[1,"GL_BLEND_DST"]],["sgl/gl"]],
["gl_blend_dst_alpha",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.B.L.E.N.D_.D.S.T_.A.L.P.H.A))",[0,[1,"GL_BLEND_DST_ALPHA"]],["sgl/gl"]],
["gl_blend_dst_rgb",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.B.L.E.N.D_.D.S.T_.R.G.B))",[0,[1,"GL_BLEND_DST_RGB"]],["sgl/gl"]],
["gl_blend_equation",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.B.L.E.N.D_.E.Q.U.A.T.I.O.N))",[0,[1,"GL_BLEND_EQUATION"]],["sgl/gl"]],
["gl_blend_src",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.B.L.E.N.D_.S.R.C))",[0,[1,"GL_BLEND_SRC"]],["sgl/gl"]],
["gl_blend_src_alpha",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.B.L.E.N.D_.S.R.C_.A.L.P.H.A))",[0,[1,"GL_BLEND_SRC_ALPHA"]],["sgl/gl"]],
["gl_blend_src_rgb",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.B.L.E.N.D_.S.R.C_.R.G.B))",[0,[1,"GL_BLEND_SRC_RGB"]],["sgl/gl"]],
["gl_blue",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.B.L.U.E))",[0,[1,"GL_BLUE"]],["sgl/gl"]],
["gl_blue_bias",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.B.L.U.E_.B.I.A.S))",[0,[1,"GL_BLUE_BIAS"]],["sgl/gl"]],
["gl_blue_bits",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.B.L.U.E_.B.I.T.S))",[0,[1,"GL_BLUE_BITS"]],["sgl/gl"]],
["gl_blue_scale",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.B.L.U.E_.S.C.A.L.E))",[0,[1,"GL_BLUE_SCALE"]],["sgl/gl"]],
["gl_buffer_access",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.B.U.F.F.E.R_.A.C.C.E.S.S))",[0,[1,"GL_BUFFER_ACCESS"]],["sgl/gl"]],
["gl_buffer_map_pointer",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.B.U.F.F.E.R_.M.A.P_.P.O.I.N.T.E.R))",[0,[1,"GL_BUFFER_MAP_POINTER"]],["sgl/gl"]],
["gl_buffer_mapped",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.B.U.F.F.E.R_.M.A.P.P.E.D))",[0,[1,"GL_BUFFER_MAPPED"]],["sgl/gl"]],
["gl_buffer_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.B.U.F.F.E.R_.S.I.Z.E))",[0,[1,"GL_BUFFER_SIZE"]],["sgl/gl"]],
["gl_buffer_usage",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.B.U.F.F.E.R_.U.S.A.G.E))",[0,[1,"GL_BUFFER_USAGE"]],["sgl/gl"]],
["gl_byte",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.B.Y.T.E))",[0,[1,"GL_BYTE"]],["sgl/gl"]],
["gl_c3f_v3f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C3.F_.V3.F))",[0,[1,"GL_C3F_V3F"]],["sgl/gl"]],
["gl_c4f_n3f_v3f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C4.F_.N3.F_.V3.F))",[0,[1,"GL_C4F_N3F_V3F"]],["sgl/gl"]],
["gl_c4ub_v2f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C4.U.B_.V2.F))",[0,[1,"GL_C4UB_V2F"]],["sgl/gl"]],
["gl_c4ub_v3f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C4.U.B_.V3.F))",[0,[1,"GL_C4UB_V3F"]],["sgl/gl"]],
["gl_ccw",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.C.W))",[0,[1,"GL_CCW"]],["sgl/gl"]],
["gl_clamp",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.L.A.M.P))",[0,[1,"GL_CLAMP"]],["sgl/gl"]],
["gl_clamp_to_border",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.L.A.M.P_.T.O_.B.O.R.D.E.R))",[0,[1,"GL_CLAMP_TO_BORDER"]],["sgl/gl"]],
["gl_clamp_to_edge",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.L.A.M.P_.T.O_.E.D.G.E))",[0,[1,"GL_CLAMP_TO_EDGE"]],["sgl/gl"]],
["gl_clear",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.L.E.A.R))",[0,[1,"GL_CLEAR"]],["sgl/gl"]],
["gl_client_active_texture",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.L.I.E.N.T_.A.C.T.I.V.E_.T.E.X.T.U.R.E))",[0,[1,"GL_CLIENT_ACTIVE_TEXTURE"]],["sgl/gl"]],
["gl_client_all_attrib_bits",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.L.I.E.N.T_.A.L.L_.A.T.T.R.I.B_.B.I.T.S))",[0,[1,"GL_CLIENT_ALL_ATTRIB_BITS"]],["sgl/gl"]],
["gl_client_attrib_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.L.I.E.N.T_.A.T.T.R.I.B_.S.T.A.C.K_.D.E.P.T.H))",[0,[1,"GL_CLIENT_ATTRIB_STACK_DEPTH"]],["sgl/gl"]],
["gl_client_pixel_store_bit",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.L.I.E.N.T_.P.I.X.E.L_.S.T.O.R.E_.B.I.T))",[0,[1,"GL_CLIENT_PIXEL_STORE_BIT"]],["sgl/gl"]],
["gl_client_vertex_array_bit",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.L.I.E.N.T_.V.E.R.T.E.X_.A.R.R.A.Y_.B.I.T))",[0,[1,"GL_CLIENT_VERTEX_ARRAY_BIT"]],["sgl/gl"]],
["gl_clip_plane0",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.L.I.P_.P.L.A.N.E0))",[0,[1,"GL_CLIP_PLANE0"]],["sgl/gl"]],
["gl_clip_plane1",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.L.I.P_.P.L.A.N.E1))",[0,[1,"GL_CLIP_PLANE1"]],["sgl/gl"]],
["gl_clip_plane2",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.L.I.P_.P.L.A.N.E2))",[0,[1,"GL_CLIP_PLANE2"]],["sgl/gl"]],
["gl_clip_plane3",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.L.I.P_.P.L.A.N.E3))",[0,[1,"GL_CLIP_PLANE3"]],["sgl/gl"]],
["gl_clip_plane4",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.L.I.P_.P.L.A.N.E4))",[0,[1,"GL_CLIP_PLANE4"]],["sgl/gl"]],
["gl_clip_plane5",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.L.I.P_.P.L.A.N.E5))",[0,[1,"GL_CLIP_PLANE5"]],["sgl/gl"]],
["gl_coeff",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.E.F.F))",[0,[1,"GL_COEFF"]],["sgl/gl"]],
["gl_color",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R))",[0,[1,"GL_COLOR"]],["sgl/gl"]],
["gl_color_array",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.A.R.R.A.Y))",[0,[1,"GL_COLOR_ARRAY"]],["sgl/gl"]],
["gl_color_array_buffer_binding",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.A.R.R.A.Y_.B.U.F.F.E.R_.B.I.N.D.I.N.G))",[0,[1,"GL_COLOR_ARRAY_BUFFER_BINDING"]],["sgl/gl"]],
["gl_color_array_pointer",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.A.R.R.A.Y_.P.O.I.N.T.E.R))",[0,[1,"GL_COLOR_ARRAY_POINTER"]],["sgl/gl"]],
["gl_color_array_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.A.R.R.A.Y_.S.I.Z.E))",[0,[1,"GL_COLOR_ARRAY_SIZE"]],["sgl/gl"]],
["gl_color_array_stride",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.A.R.R.A.Y_.S.T.R.I.D.E))",[0,[1,"GL_COLOR_ARRAY_STRIDE"]],["sgl/gl"]],
["gl_color_array_type",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.A.R.R.A.Y_.T.Y.P.E))",[0,[1,"GL_COLOR_ARRAY_TYPE"]],["sgl/gl"]],
["gl_color_buffer_bit",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.B.U.F.F.E.R_.B.I.T))",[0,[1,"GL_COLOR_BUFFER_BIT"]],["sgl/gl"]],
["gl_color_clear_value",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.C.L.E.A.R_.V.A.L.U.E))",[0,[1,"GL_COLOR_CLEAR_VALUE"]],["sgl/gl"]],
["gl_color_index",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.I.N.D.E.X))",[0,[1,"GL_COLOR_INDEX"]],["sgl/gl"]],
["gl_color_indexes",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.I.N.D.E.X.E.S))",[0,[1,"GL_COLOR_INDEXES"]],["sgl/gl"]],
["gl_color_logic_op",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.L.O.G.I.C_.O.P))",[0,[1,"GL_COLOR_LOGIC_OP"]],["sgl/gl"]],
["gl_color_material",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.M.A.T.E.R.I.A.L))",[0,[1,"GL_COLOR_MATERIAL"]],["sgl/gl"]],
["gl_color_material_face",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.M.A.T.E.R.I.A.L_.F.A.C.E))",[0,[1,"GL_COLOR_MATERIAL_FACE"]],["sgl/gl"]],
["gl_color_material_parameter",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.M.A.T.E.R.I.A.L_.P.A.R.A.M.E.T.E.R))",[0,[1,"GL_COLOR_MATERIAL_PARAMETER"]],["sgl/gl"]],
["gl_color_matrix",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.M.A.T.R.I.X))",[0,[1,"GL_COLOR_MATRIX"]],["sgl/gl"]],
["gl_color_matrix_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.M.A.T.R.I.X_.S.T.A.C.K_.D.E.P.T.H))",[0,[1,"GL_COLOR_MATRIX_STACK_DEPTH"]],["sgl/gl"]],
["gl_color_sum",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.S.U.M))",[0,[1,"GL_COLOR_SUM"]],["sgl/gl"]],
["gl_color_table",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.T.A.B.L.E))",[0,[1,"GL_COLOR_TABLE"]],["sgl/gl"]],
["gl_color_table_alpha_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.T.A.B.L.E_.A.L.P.H.A_.S.I.Z.E))",[0,[1,"GL_COLOR_TABLE_ALPHA_SIZE"]],["sgl/gl"]],
["gl_color_table_bias",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.T.A.B.L.E_.B.I.A.S))",[0,[1,"GL_COLOR_TABLE_BIAS"]],["sgl/gl"]],
["gl_color_table_blue_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.T.A.B.L.E_.B.L.U.E_.S.I.Z.E))",[0,[1,"GL_COLOR_TABLE_BLUE_SIZE"]],["sgl/gl"]],
["gl_color_table_format",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.T.A.B.L.E_.F.O.R.M.A.T))",[0,[1,"GL_COLOR_TABLE_FORMAT"]],["sgl/gl"]],
["gl_color_table_green_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.T.A.B.L.E_.G.R.E.E.N_.S.I.Z.E))",[0,[1,"GL_COLOR_TABLE_GREEN_SIZE"]],["sgl/gl"]],
["gl_color_table_intensity_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.T.A.B.L.E_.I.N.T.E.N.S.I.T.Y_.S.I.Z.E))",[0,[1,"GL_COLOR_TABLE_INTENSITY_SIZE"]],["sgl/gl"]],
["gl_color_table_luminance_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.T.A.B.L.E_.L.U.M.I.N.A.N.C.E_.S.I.Z.E))",[0,[1,"GL_COLOR_TABLE_LUMINANCE_SIZE"]],["sgl/gl"]],
["gl_color_table_red_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.T.A.B.L.E_.R.E.D_.S.I.Z.E))",[0,[1,"GL_COLOR_TABLE_RED_SIZE"]],["sgl/gl"]],
["gl_color_table_scale",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.T.A.B.L.E_.S.C.A.L.E))",[0,[1,"GL_COLOR_TABLE_SCALE"]],["sgl/gl"]],
["gl_color_table_width",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.T.A.B.L.E_.W.I.D.T.H))",[0,[1,"GL_COLOR_TABLE_WIDTH"]],["sgl/gl"]],
["gl_color_writemask",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.L.O.R_.W.R.I.T.E.M.A.S.K))",[0,[1,"GL_COLOR_WRITEMASK"]],["sgl/gl"]],
["gl_combine",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.M.B.I.N.E))",[0,[1,"GL_COMBINE"]],["sgl/gl"]],
["gl_combine_alpha",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.M.B.I.N.E_.A.L.P.H.A))",[0,[1,"GL_COMBINE_ALPHA"]],["sgl/gl"]],
["gl_combine_rgb",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.M.B.I.N.E_.R.G.B))",[0,[1,"GL_COMBINE_RGB"]],["sgl/gl"]],
["gl_compare_r_to_texture",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.M.P.A.R.E_.R_.T.O_.T.E.X.T.U.R.E))",[0,[1,"GL_COMPARE_R_TO_TEXTURE"]],["sgl/gl"]],
["gl_compile",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.M.P.I.L.E))",[0,[1,"GL_COMPILE"]],["sgl/gl"]],
["gl_compile_and_execute",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.M.P.I.L.E_.A.N.D_.E.X.E.C.U.T.E))",[0,[1,"GL_COMPILE_AND_EXECUTE"]],["sgl/gl"]],
["gl_compressed_alpha",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.M.P.R.E.S.S.E.D_.A.L.P.H.A))",[0,[1,"GL_COMPRESSED_ALPHA"]],["sgl/gl"]],
["gl_compressed_intensity",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.M.P.R.E.S.S.E.D_.I.N.T.E.N.S.I.T.Y))",[0,[1,"GL_COMPRESSED_INTENSITY"]],["sgl/gl"]],
["gl_compressed_luminance",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.M.P.R.E.S.S.E.D_.L.U.M.I.N.A.N.C.E))",[0,[1,"GL_COMPRESSED_LUMINANCE"]],["sgl/gl"]],
["gl_compressed_luminance_alpha",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.M.P.R.E.S.S.E.D_.L.U.M.I.N.A.N.C.E_.A.L.P.H.A))",[0,[1,"GL_COMPRESSED_LUMINANCE_ALPHA"]],["sgl/gl"]],
["gl_compressed_rgb",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.M.P.R.E.S.S.E.D_.R.G.B))",[0,[1,"GL_COMPRESSED_RGB"]],["sgl/gl"]],
["gl_compressed_rgba",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.M.P.R.E.S.S.E.D_.R.G.B.A))",[0,[1,"GL_COMPRESSED_RGBA"]],["sgl/gl"]],
["gl_compressed_texture_formats",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.M.P.R.E.S.S.E.D_.T.E.X.T.U.R.E_.F.O.R.M.A.T.S))",[0,[1,"GL_COMPRESSED_TEXTURE_FORMATS"]],["sgl/gl"]],
["gl_constant",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.N.S.T.A.N.T))",[0,[1,"GL_CONSTANT"]],["sgl/gl"]],
["gl_constant_alpha",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.N.S.T.A.N.T_.A.L.P.H.A))",[0,[1,"GL_CONSTANT_ALPHA"]],["sgl/gl"]],
["gl_constant_attenuation",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.N.S.T.A.N.T_.A.T.T.E.N.U.A.T.I.O.N))",[0,[1,"GL_CONSTANT_ATTENUATION"]],["sgl/gl"]],
["gl_constant_border",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.N.S.T.A.N.T_.B.O.R.D.E.R))",[0,[1,"GL_CONSTANT_BORDER"]],["sgl/gl"]],
["gl_constant_color",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.N.S.T.A.N.T_.C.O.L.O.R))",[0,[1,"GL_CONSTANT_COLOR"]],["sgl/gl"]],
["gl_convolution_1d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.N.V.O.L.U.T.I.O.N_1.D))",[0,[1,"GL_CONVOLUTION_1D"]],["sgl/gl"]],
["gl_convolution_2d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.N.V.O.L.U.T.I.O.N_2.D))",[0,[1,"GL_CONVOLUTION_2D"]],["sgl/gl"]],
["gl_convolution_border_color",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.N.V.O.L.U.T.I.O.N_.B.O.R.D.E.R_.C.O.L.O.R))",[0,[1,"GL_CONVOLUTION_BORDER_COLOR"]],["sgl/gl"]],
["gl_convolution_border_mode",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.N.V.O.L.U.T.I.O.N_.B.O.R.D.E.R_.M.O.D.E))",[0,[1,"GL_CONVOLUTION_BORDER_MODE"]],["sgl/gl"]],
["gl_convolution_filter_bias",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.N.V.O.L.U.T.I.O.N_.F.I.L.T.E.R_.B.I.A.S))",[0,[1,"GL_CONVOLUTION_FILTER_BIAS"]],["sgl/gl"]],
["gl_convolution_filter_scale",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.N.V.O.L.U.T.I.O.N_.F.I.L.T.E.R_.S.C.A.L.E))",[0,[1,"GL_CONVOLUTION_FILTER_SCALE"]],["sgl/gl"]],
["gl_convolution_format",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.N.V.O.L.U.T.I.O.N_.F.O.R.M.A.T))",[0,[1,"GL_CONVOLUTION_FORMAT"]],["sgl/gl"]],
["gl_convolution_height",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.N.V.O.L.U.T.I.O.N_.H.E.I.G.H.T))",[0,[1,"GL_CONVOLUTION_HEIGHT"]],["sgl/gl"]],
["gl_convolution_width",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.N.V.O.L.U.T.I.O.N_.W.I.D.T.H))",[0,[1,"GL_CONVOLUTION_WIDTH"]],["sgl/gl"]],
["gl_copy",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.P.Y))",[0,[1,"GL_COPY"]],["sgl/gl"]],
["gl_copy_inverted",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.P.Y_.I.N.V.E.R.T.E.D))",[0,[1,"GL_COPY_INVERTED"]],["sgl/gl"]],
["gl_copy_pixel_token",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.O.P.Y_.P.I.X.E.L_.T.O.K.E.N))",[0,[1,"GL_COPY_PIXEL_TOKEN"]],["sgl/gl"]],
["gl_cull_face",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.U.L.L_.F.A.C.E))",[0,[1,"GL_CULL_FACE"]],["sgl/gl"]],
["gl_cull_face_mode",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.U.L.L_.F.A.C.E_.M.O.D.E))",[0,[1,"GL_CULL_FACE_MODE"]],["sgl/gl"]],
["gl_current_bit",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.U.R.R.E.N.T_.B.I.T))",[0,[1,"GL_CURRENT_BIT"]],["sgl/gl"]],
["gl_current_color",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.U.R.R.E.N.T_.C.O.L.O.R))",[0,[1,"GL_CURRENT_COLOR"]],["sgl/gl"]],
["gl_current_fog_coord",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.U.R.R.E.N.T_.F.O.G_.C.O.O.R.D))",[0,[1,"GL_CURRENT_FOG_COORD"]],["sgl/gl"]],
["gl_current_fog_coordinate",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.U.R.R.E.N.T_.F.O.G_.C.O.O.R.D.I.N.A.T.E))",[0,[1,"GL_CURRENT_FOG_COORDINATE"]],["sgl/gl"]],
["gl_current_index",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.U.R.R.E.N.T_.I.N.D.E.X))",[0,[1,"GL_CURRENT_INDEX"]],["sgl/gl"]],
["gl_current_normal",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.U.R.R.E.N.T_.N.O.R.M.A.L))",[0,[1,"GL_CURRENT_NORMAL"]],["sgl/gl"]],
["gl_current_query",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.U.R.R.E.N.T_.Q.U.E.R.Y))",[0,[1,"GL_CURRENT_QUERY"]],["sgl/gl"]],
["gl_current_raster_color",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.U.R.R.E.N.T_.R.A.S.T.E.R_.C.O.L.O.R))",[0,[1,"GL_CURRENT_RASTER_COLOR"]],["sgl/gl"]],
["gl_current_raster_distance",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.U.R.R.E.N.T_.R.A.S.T.E.R_.D.I.S.T.A.N.C.E))",[0,[1,"GL_CURRENT_RASTER_DISTANCE"]],["sgl/gl"]],
["gl_current_raster_index",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.U.R.R.E.N.T_.R.A.S.T.E.R_.I.N.D.E.X))",[0,[1,"GL_CURRENT_RASTER_INDEX"]],["sgl/gl"]],
["gl_current_raster_position",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.U.R.R.E.N.T_.R.A.S.T.E.R_.P.O.S.I.T.I.O.N))",[0,[1,"GL_CURRENT_RASTER_POSITION"]],["sgl/gl"]],
["gl_current_raster_position_valid",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.U.R.R.E.N.T_.R.A.S.T.E.R_.P.O.S.I.T.I.O.N_.V.A.L.I.D))",[0,[1,"GL_CURRENT_RASTER_POSITION_VALID"]],["sgl/gl"]],
["gl_current_raster_texture_coords",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.U.R.R.E.N.T_.R.A.S.T.E.R_.T.E.X.T.U.R.E_.C.O.O.R.D.S))",[0,[1,"GL_CURRENT_RASTER_TEXTURE_COORDS"]],["sgl/gl"]],
["gl_current_secondary_color",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.U.R.R.E.N.T_.S.E.C.O.N.D.A.R.Y_.C.O.L.O.R))",[0,[1,"GL_CURRENT_SECONDARY_COLOR"]],["sgl/gl"]],
["gl_current_texture_coords",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.U.R.R.E.N.T_.T.E.X.T.U.R.E_.C.O.O.R.D.S))",[0,[1,"GL_CURRENT_TEXTURE_COORDS"]],["sgl/gl"]],
["gl_cw",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.C.W))",[0,[1,"GL_CW"]],["sgl/gl"]],
["gl_decal",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.E.C.A.L))",[0,[1,"GL_DECAL"]],["sgl/gl"]],
["gl_decr",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.E.C.R))",[0,[1,"GL_DECR"]],["sgl/gl"]],
["gl_decr_wrap",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.E.C.R_.W.R.A.P))",[0,[1,"GL_DECR_WRAP"]],["sgl/gl"]],
["gl_depth",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.E.P.T.H))",[0,[1,"GL_DEPTH"]],["sgl/gl"]],
["gl_depth_bias",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.E.P.T.H_.B.I.A.S))",[0,[1,"GL_DEPTH_BIAS"]],["sgl/gl"]],
["gl_depth_bits",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.E.P.T.H_.B.I.T.S))",[0,[1,"GL_DEPTH_BITS"]],["sgl/gl"]],
["gl_depth_buffer_bit",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.E.P.T.H_.B.U.F.F.E.R_.B.I.T))",[0,[1,"GL_DEPTH_BUFFER_BIT"]],["sgl/gl"]],
["gl_depth_clear_value",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.E.P.T.H_.C.L.E.A.R_.V.A.L.U.E))",[0,[1,"GL_DEPTH_CLEAR_VALUE"]],["sgl/gl"]],
["gl_depth_component",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.E.P.T.H_.C.O.M.P.O.N.E.N.T))",[0,[1,"GL_DEPTH_COMPONENT"]],["sgl/gl"]],
["gl_depth_component16",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.E.P.T.H_.C.O.M.P.O.N.E.N.T16))",[0,[1,"GL_DEPTH_COMPONENT16"]],["sgl/gl"]],
["gl_depth_component24",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.E.P.T.H_.C.O.M.P.O.N.E.N.T24))",[0,[1,"GL_DEPTH_COMPONENT24"]],["sgl/gl"]],
["gl_depth_component32",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.E.P.T.H_.C.O.M.P.O.N.E.N.T32))",[0,[1,"GL_DEPTH_COMPONENT32"]],["sgl/gl"]],
["gl_depth_func",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.E.P.T.H_.F.U.N.C))",[0,[1,"GL_DEPTH_FUNC"]],["sgl/gl"]],
["gl_depth_range",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.E.P.T.H_.R.A.N.G.E))",[0,[1,"GL_DEPTH_RANGE"]],["sgl/gl"]],
["gl_depth_scale",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.E.P.T.H_.S.C.A.L.E))",[0,[1,"GL_DEPTH_SCALE"]],["sgl/gl"]],
["gl_depth_test",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.E.P.T.H_.T.E.S.T))",[0,[1,"GL_DEPTH_TEST"]],["sgl/gl"]],
["gl_depth_texture_mode",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.E.P.T.H_.T.E.X.T.U.R.E_.M.O.D.E))",[0,[1,"GL_DEPTH_TEXTURE_MODE"]],["sgl/gl"]],
["gl_depth_writemask",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.E.P.T.H_.W.R.I.T.E.M.A.S.K))",[0,[1,"GL_DEPTH_WRITEMASK"]],["sgl/gl"]],
["gl_diffuse",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.I.F.F.U.S.E))",[0,[1,"GL_DIFFUSE"]],["sgl/gl"]],
["gl_dither",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.I.T.H.E.R))",[0,[1,"GL_DITHER"]],["sgl/gl"]],
["gl_domain",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.O.M.A.I.N))",[0,[1,"GL_DOMAIN"]],["sgl/gl"]],
["gl_dont_care",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.O.N.T_.C.A.R.E))",[0,[1,"GL_DONT_CARE"]],["sgl/gl"]],
["gl_dot3_rgb",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.O.T3_.R.G.B))",[0,[1,"GL_DOT3_RGB"]],["sgl/gl"]],
["gl_dot3_rgba",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.O.T3_.R.G.B.A))",[0,[1,"GL_DOT3_RGBA"]],["sgl/gl"]],
["gl_double",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.O.U.B.L.E))",[0,[1,"GL_DOUBLE"]],["sgl/gl"]],
["gl_doublebuffer",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.O.U.B.L.E.B.U.F.F.E.R))",[0,[1,"GL_DOUBLEBUFFER"]],["sgl/gl"]],
["gl_draw_buffer",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.R.A.W_.B.U.F.F.E.R))",[0,[1,"GL_DRAW_BUFFER"]],["sgl/gl"]],
["gl_draw_pixel_token",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.R.A.W_.P.I.X.E.L_.T.O.K.E.N))",[0,[1,"GL_DRAW_PIXEL_TOKEN"]],["sgl/gl"]],
["gl_dst_alpha",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.S.T_.A.L.P.H.A))",[0,[1,"GL_DST_ALPHA"]],["sgl/gl"]],
["gl_dst_color",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.S.T_.C.O.L.O.R))",[0,[1,"GL_DST_COLOR"]],["sgl/gl"]],
["gl_dynamic_copy",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.Y.N.A.M.I.C_.C.O.P.Y))",[0,[1,"GL_DYNAMIC_COPY"]],["sgl/gl"]],
["gl_dynamic_draw",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.Y.N.A.M.I.C_.D.R.A.W))",[0,[1,"GL_DYNAMIC_DRAW"]],["sgl/gl"]],
["gl_dynamic_read",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.D.Y.N.A.M.I.C_.R.E.A.D))",[0,[1,"GL_DYNAMIC_READ"]],["sgl/gl"]],
["gl_edge_flag",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.E.D.G.E_.F.L.A.G))",[0,[1,"GL_EDGE_FLAG"]],["sgl/gl"]],
["gl_edge_flag_array",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.E.D.G.E_.F.L.A.G_.A.R.R.A.Y))",[0,[1,"GL_EDGE_FLAG_ARRAY"]],["sgl/gl"]],
["gl_edge_flag_array_buffer_binding",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.E.D.G.E_.F.L.A.G_.A.R.R.A.Y_.B.U.F.F.E.R_.B.I.N.D.I.N.G))",[0,[1,"GL_EDGE_FLAG_ARRAY_BUFFER_BINDING"]],["sgl/gl"]],
["gl_edge_flag_array_pointer",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.E.D.G.E_.F.L.A.G_.A.R.R.A.Y_.P.O.I.N.T.E.R))",[0,[1,"GL_EDGE_FLAG_ARRAY_POINTER"]],["sgl/gl"]],
["gl_edge_flag_array_stride",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.E.D.G.E_.F.L.A.G_.A.R.R.A.Y_.S.T.R.I.D.E))",[0,[1,"GL_EDGE_FLAG_ARRAY_STRIDE"]],["sgl/gl"]],
["gl_element_array_buffer",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.E.L.E.M.E.N.T_.A.R.R.A.Y_.B.U.F.F.E.R))",[0,[1,"GL_ELEMENT_ARRAY_BUFFER"]],["sgl/gl"]],
["gl_element_array_buffer_binding",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.E.L.E.M.E.N.T_.A.R.R.A.Y_.B.U.F.F.E.R_.B.I.N.D.I.N.G))",[0,[1,"GL_ELEMENT_ARRAY_BUFFER_BINDING"]],["sgl/gl"]],
["gl_emission",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.E.M.I.S.S.I.O.N))",[0,[1,"GL_EMISSION"]],["sgl/gl"]],
["gl_enable_bit",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.E.N.A.B.L.E_.B.I.T))",[0,[1,"GL_ENABLE_BIT"]],["sgl/gl"]],
["gl_equal",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.E.Q.U.A.L))",[0,[1,"GL_EQUAL"]],["sgl/gl"]],
["gl_equiv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.E.Q.U.I.V))",[0,[1,"GL_EQUIV"]],["sgl/gl"]],
["gl_eval_bit",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.E.V.A.L_.B.I.T))",[0,[1,"GL_EVAL_BIT"]],["sgl/gl"]],
["gl_exp",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.E.X.P))",[0,[1,"GL_EXP"]],["sgl/gl"]],
["gl_exp2",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.E.X.P2))",[0,[1,"GL_EXP2"]],["sgl/gl"]],
["gl_extensions",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.E.X.T.E.N.S.I.O.N.S))",[0,[1,"GL_EXTENSIONS"]],["sgl/gl"]],
["gl_eye_linear",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.E.Y.E_.L.I.N.E.A.R))",[0,[1,"GL_EYE_LINEAR"]],["sgl/gl"]],
["gl_eye_plane",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.E.Y.E_.P.L.A.N.E))",[0,[1,"GL_EYE_PLANE"]],["sgl/gl"]],
["gl_false",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.A.L.S.E))",[0,[1,"GL_FALSE"]],["sgl/gl"]],
["gl_false",">sgl/gl.html#(idx._(gentag._16._(lib._sgl/scribblings/sgl..scrbl)))",[5,"GL_FALSE"],false],
["gl_fastest",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.A.S.T.E.S.T))",[0,[1,"GL_FASTEST"]],["sgl/gl"]],
["gl_feedback",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.E.E.D.B.A.C.K))",[0,[1,"GL_FEEDBACK"]],["sgl/gl"]],
["gl_feedback_buffer_pointer",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.E.E.D.B.A.C.K_.B.U.F.F.E.R_.P.O.I.N.T.E.R))",[0,[1,"GL_FEEDBACK_BUFFER_POINTER"]],["sgl/gl"]],
["gl_feedback_buffer_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.E.E.D.B.A.C.K_.B.U.F.F.E.R_.S.I.Z.E))",[0,[1,"GL_FEEDBACK_BUFFER_SIZE"]],["sgl/gl"]],
["gl_feedback_buffer_type",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.E.E.D.B.A.C.K_.B.U.F.F.E.R_.T.Y.P.E))",[0,[1,"GL_FEEDBACK_BUFFER_TYPE"]],["sgl/gl"]],
["gl_fill",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.I.L.L))",[0,[1,"GL_FILL"]],["sgl/gl"]],
["gl_flat",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.L.A.T))",[0,[1,"GL_FLAT"]],["sgl/gl"]],
["gl_float",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.L.O.A.T))",[0,[1,"GL_FLOAT"]],["sgl/gl"]],
["gl_fog",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.O.G))",[0,[1,"GL_FOG"]],["sgl/gl"]],
["gl_fog_bit",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.O.G_.B.I.T))",[0,[1,"GL_FOG_BIT"]],["sgl/gl"]],
["gl_fog_color",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.O.G_.C.O.L.O.R))",[0,[1,"GL_FOG_COLOR"]],["sgl/gl"]],
["gl_fog_coord",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.O.G_.C.O.O.R.D))",[0,[1,"GL_FOG_COORD"]],["sgl/gl"]],
["gl_fog_coord_array",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.O.G_.C.O.O.R.D_.A.R.R.A.Y))",[0,[1,"GL_FOG_COORD_ARRAY"]],["sgl/gl"]],
["gl_fog_coord_array_buffer_binding",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.O.G_.C.O.O.R.D_.A.R.R.A.Y_.B.U.F.F.E.R_.B.I.N.D.I.N.G))",[0,[1,"GL_FOG_COORD_ARRAY_BUFFER_BINDING"]],["sgl/gl"]],
["gl_fog_coord_array_pointer",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.O.G_.C.O.O.R.D_.A.R.R.A.Y_.P.O.I.N.T.E.R))",[0,[1,"GL_FOG_COORD_ARRAY_POINTER"]],["sgl/gl"]],
["gl_fog_coord_array_stride",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.O.G_.C.O.O.R.D_.A.R.R.A.Y_.S.T.R.I.D.E))",[0,[1,"GL_FOG_COORD_ARRAY_STRIDE"]],["sgl/gl"]],
["gl_fog_coord_array_type",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.O.G_.C.O.O.R.D_.A.R.R.A.Y_.T.Y.P.E))",[0,[1,"GL_FOG_COORD_ARRAY_TYPE"]],["sgl/gl"]],
["gl_fog_coord_src",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.O.G_.C.O.O.R.D_.S.R.C))",[0,[1,"GL_FOG_COORD_SRC"]],["sgl/gl"]],
["gl_fog_coordinate",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.O.G_.C.O.O.R.D.I.N.A.T.E))",[0,[1,"GL_FOG_COORDINATE"]],["sgl/gl"]],
["gl_fog_coordinate_array",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.O.G_.C.O.O.R.D.I.N.A.T.E_.A.R.R.A.Y))",[0,[1,"GL_FOG_COORDINATE_ARRAY"]],["sgl/gl"]],
["gl_fog_coordinate_array_buffer_binding",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.O.G_.C.O.O.R.D.I.N.A.T.E_.A.R.R.A.Y_.B.U.F.F.E.R_.B.I.N.D.I.N.G))",[0,[1,"GL_FOG_COORDINATE_ARRAY_BUFFER_BINDING"]],["sgl/gl"]],
["gl_fog_coordinate_array_pointer",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.O.G_.C.O.O.R.D.I.N.A.T.E_.A.R.R.A.Y_.P.O.I.N.T.E.R))",[0,[1,"GL_FOG_COORDINATE_ARRAY_POINTER"]],["sgl/gl"]],
["gl_fog_coordinate_array_stride",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.O.G_.C.O.O.R.D.I.N.A.T.E_.A.R.R.A.Y_.S.T.R.I.D.E))",[0,[1,"GL_FOG_COORDINATE_ARRAY_STRIDE"]],["sgl/gl"]],
["gl_fog_coordinate_array_type",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.O.G_.C.O.O.R.D.I.N.A.T.E_.A.R.R.A.Y_.T.Y.P.E))",[0,[1,"GL_FOG_COORDINATE_ARRAY_TYPE"]],["sgl/gl"]],
["gl_fog_coordinate_source",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.O.G_.C.O.O.R.D.I.N.A.T.E_.S.O.U.R.C.E))",[0,[1,"GL_FOG_COORDINATE_SOURCE"]],["sgl/gl"]],
["gl_fog_density",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.O.G_.D.E.N.S.I.T.Y))",[0,[1,"GL_FOG_DENSITY"]],["sgl/gl"]],
["gl_fog_end",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.O.G_.E.N.D))",[0,[1,"GL_FOG_END"]],["sgl/gl"]],
["gl_fog_hint",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.O.G_.H.I.N.T))",[0,[1,"GL_FOG_HINT"]],["sgl/gl"]],
["gl_fog_index",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.O.G_.I.N.D.E.X))",[0,[1,"GL_FOG_INDEX"]],["sgl/gl"]],
["gl_fog_mode",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.O.G_.M.O.D.E))",[0,[1,"GL_FOG_MODE"]],["sgl/gl"]],
["gl_fog_start",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.O.G_.S.T.A.R.T))",[0,[1,"GL_FOG_START"]],["sgl/gl"]],
["gl_fragment_depth",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.R.A.G.M.E.N.T_.D.E.P.T.H))",[0,[1,"GL_FRAGMENT_DEPTH"]],["sgl/gl"]],
["gl_front",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.R.O.N.T))",[0,[1,"GL_FRONT"]],["sgl/gl"]],
["gl_front_and_back",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.R.O.N.T_.A.N.D_.B.A.C.K))",[0,[1,"GL_FRONT_AND_BACK"]],["sgl/gl"]],
["gl_front_face",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.R.O.N.T_.F.A.C.E))",[0,[1,"GL_FRONT_FACE"]],["sgl/gl"]],
["gl_front_left",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.R.O.N.T_.L.E.F.T))",[0,[1,"GL_FRONT_LEFT"]],["sgl/gl"]],
["gl_front_right",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.R.O.N.T_.R.I.G.H.T))",[0,[1,"GL_FRONT_RIGHT"]],["sgl/gl"]],
["gl_func_add",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.U.N.C_.A.D.D))",[0,[1,"GL_FUNC_ADD"]],["sgl/gl"]],
["gl_func_reverse_subtract",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.U.N.C_.R.E.V.E.R.S.E_.S.U.B.T.R.A.C.T))",[0,[1,"GL_FUNC_REVERSE_SUBTRACT"]],["sgl/gl"]],
["gl_func_subtract",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.F.U.N.C_.S.U.B.T.R.A.C.T))",[0,[1,"GL_FUNC_SUBTRACT"]],["sgl/gl"]],
["gl_generate_mipmap",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.G.E.N.E.R.A.T.E_.M.I.P.M.A.P))",[0,[1,"GL_GENERATE_MIPMAP"]],["sgl/gl"]],
["gl_generate_mipmap_hint",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.G.E.N.E.R.A.T.E_.M.I.P.M.A.P_.H.I.N.T))",[0,[1,"GL_GENERATE_MIPMAP_HINT"]],["sgl/gl"]],
["gl_gequal",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.G.E.Q.U.A.L))",[0,[1,"GL_GEQUAL"]],["sgl/gl"]],
["gl_greater",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.G.R.E.A.T.E.R))",[0,[1,"GL_GREATER"]],["sgl/gl"]],
["gl_green",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.G.R.E.E.N))",[0,[1,"GL_GREEN"]],["sgl/gl"]],
["gl_green_bias",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.G.R.E.E.N_.B.I.A.S))",[0,[1,"GL_GREEN_BIAS"]],["sgl/gl"]],
["gl_green_bits",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.G.R.E.E.N_.B.I.T.S))",[0,[1,"GL_GREEN_BITS"]],["sgl/gl"]],
["gl_green_scale",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.G.R.E.E.N_.S.C.A.L.E))",[0,[1,"GL_GREEN_SCALE"]],["sgl/gl"]],
["gl_hint_bit",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.H.I.N.T_.B.I.T))",[0,[1,"GL_HINT_BIT"]],["sgl/gl"]],
["gl_histogram",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.H.I.S.T.O.G.R.A.M))",[0,[1,"GL_HISTOGRAM"]],["sgl/gl"]],
["gl_histogram_alpha_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.H.I.S.T.O.G.R.A.M_.A.L.P.H.A_.S.I.Z.E))",[0,[1,"GL_HISTOGRAM_ALPHA_SIZE"]],["sgl/gl"]],
["gl_histogram_blue_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.H.I.S.T.O.G.R.A.M_.B.L.U.E_.S.I.Z.E))",[0,[1,"GL_HISTOGRAM_BLUE_SIZE"]],["sgl/gl"]],
["gl_histogram_format",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.H.I.S.T.O.G.R.A.M_.F.O.R.M.A.T))",[0,[1,"GL_HISTOGRAM_FORMAT"]],["sgl/gl"]],
["gl_histogram_green_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.H.I.S.T.O.G.R.A.M_.G.R.E.E.N_.S.I.Z.E))",[0,[1,"GL_HISTOGRAM_GREEN_SIZE"]],["sgl/gl"]],
["gl_histogram_luminance_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.H.I.S.T.O.G.R.A.M_.L.U.M.I.N.A.N.C.E_.S.I.Z.E))",[0,[1,"GL_HISTOGRAM_LUMINANCE_SIZE"]],["sgl/gl"]],
["gl_histogram_red_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.H.I.S.T.O.G.R.A.M_.R.E.D_.S.I.Z.E))",[0,[1,"GL_HISTOGRAM_RED_SIZE"]],["sgl/gl"]],
["gl_histogram_sink",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.H.I.S.T.O.G.R.A.M_.S.I.N.K))",[0,[1,"GL_HISTOGRAM_SINK"]],["sgl/gl"]],
["gl_histogram_width",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.H.I.S.T.O.G.R.A.M_.W.I.D.T.H))",[0,[1,"GL_HISTOGRAM_WIDTH"]],["sgl/gl"]],
["gl_incr",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.I.N.C.R))",[0,[1,"GL_INCR"]],["sgl/gl"]],
["gl_incr_wrap",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.I.N.C.R_.W.R.A.P))",[0,[1,"GL_INCR_WRAP"]],["sgl/gl"]],
["gl_index_array",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.I.N.D.E.X_.A.R.R.A.Y))",[0,[1,"GL_INDEX_ARRAY"]],["sgl/gl"]],
["gl_index_array_buffer_binding",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.I.N.D.E.X_.A.R.R.A.Y_.B.U.F.F.E.R_.B.I.N.D.I.N.G))",[0,[1,"GL_INDEX_ARRAY_BUFFER_BINDING"]],["sgl/gl"]],
["gl_index_array_pointer",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.I.N.D.E.X_.A.R.R.A.Y_.P.O.I.N.T.E.R))",[0,[1,"GL_INDEX_ARRAY_POINTER"]],["sgl/gl"]],
["gl_index_array_stride",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.I.N.D.E.X_.A.R.R.A.Y_.S.T.R.I.D.E))",[0,[1,"GL_INDEX_ARRAY_STRIDE"]],["sgl/gl"]],
["gl_index_array_type",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.I.N.D.E.X_.A.R.R.A.Y_.T.Y.P.E))",[0,[1,"GL_INDEX_ARRAY_TYPE"]],["sgl/gl"]],
["gl_index_bits",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.I.N.D.E.X_.B.I.T.S))",[0,[1,"GL_INDEX_BITS"]],["sgl/gl"]],
["gl_index_clear_value",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.I.N.D.E.X_.C.L.E.A.R_.V.A.L.U.E))",[0,[1,"GL_INDEX_CLEAR_VALUE"]],["sgl/gl"]],
["gl_index_logic_op",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.I.N.D.E.X_.L.O.G.I.C_.O.P))",[0,[1,"GL_INDEX_LOGIC_OP"]],["sgl/gl"]],
["gl_index_mode",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.I.N.D.E.X_.M.O.D.E))",[0,[1,"GL_INDEX_MODE"]],["sgl/gl"]],
["gl_index_offset",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.I.N.D.E.X_.O.F.F.S.E.T))",[0,[1,"GL_INDEX_OFFSET"]],["sgl/gl"]],
["gl_index_shift",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.I.N.D.E.X_.S.H.I.F.T))",[0,[1,"GL_INDEX_SHIFT"]],["sgl/gl"]],
["gl_index_writemask",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.I.N.D.E.X_.W.R.I.T.E.M.A.S.K))",[0,[1,"GL_INDEX_WRITEMASK"]],["sgl/gl"]],
["gl_int",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.I.N.T))",[0,[1,"GL_INT"]],["sgl/gl"]],
["gl_intensity",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.I.N.T.E.N.S.I.T.Y))",[0,[1,"GL_INTENSITY"]],["sgl/gl"]],
["gl_intensity12",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.I.N.T.E.N.S.I.T.Y12))",[0,[1,"GL_INTENSITY12"]],["sgl/gl"]],
["gl_intensity16",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.I.N.T.E.N.S.I.T.Y16))",[0,[1,"GL_INTENSITY16"]],["sgl/gl"]],
["gl_intensity4",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.I.N.T.E.N.S.I.T.Y4))",[0,[1,"GL_INTENSITY4"]],["sgl/gl"]],
["gl_intensity8",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.I.N.T.E.N.S.I.T.Y8))",[0,[1,"GL_INTENSITY8"]],["sgl/gl"]],
["gl_interpolate",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.I.N.T.E.R.P.O.L.A.T.E))",[0,[1,"GL_INTERPOLATE"]],["sgl/gl"]],
["gl_invalid_enum",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.I.N.V.A.L.I.D_.E.N.U.M))",[0,[1,"GL_INVALID_ENUM"]],["sgl/gl"]],
["gl_invalid_operation",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.I.N.V.A.L.I.D_.O.P.E.R.A.T.I.O.N))",[0,[1,"GL_INVALID_OPERATION"]],["sgl/gl"]],
["gl_invalid_value",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.I.N.V.A.L.I.D_.V.A.L.U.E))",[0,[1,"GL_INVALID_VALUE"]],["sgl/gl"]],
["gl_invert",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.I.N.V.E.R.T))",[0,[1,"GL_INVERT"]],["sgl/gl"]],
["gl_keep",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.K.E.E.P))",[0,[1,"GL_KEEP"]],["sgl/gl"]],
["gl_left",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.E.F.T))",[0,[1,"GL_LEFT"]],["sgl/gl"]],
["gl_lequal",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.E.Q.U.A.L))",[0,[1,"GL_LEQUAL"]],["sgl/gl"]],
["gl_less",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.E.S.S))",[0,[1,"GL_LESS"]],["sgl/gl"]],
["gl_light0",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.G.H.T0))",[0,[1,"GL_LIGHT0"]],["sgl/gl"]],
["gl_light1",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.G.H.T1))",[0,[1,"GL_LIGHT1"]],["sgl/gl"]],
["gl_light2",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.G.H.T2))",[0,[1,"GL_LIGHT2"]],["sgl/gl"]],
["gl_light3",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.G.H.T3))",[0,[1,"GL_LIGHT3"]],["sgl/gl"]],
["gl_light4",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.G.H.T4))",[0,[1,"GL_LIGHT4"]],["sgl/gl"]],
["gl_light5",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.G.H.T5))",[0,[1,"GL_LIGHT5"]],["sgl/gl"]],
["gl_light6",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.G.H.T6))",[0,[1,"GL_LIGHT6"]],["sgl/gl"]],
["gl_light7",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.G.H.T7))",[0,[1,"GL_LIGHT7"]],["sgl/gl"]],
["gl_light_model_ambient",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.G.H.T_.M.O.D.E.L_.A.M.B.I.E.N.T))",[0,[1,"GL_LIGHT_MODEL_AMBIENT"]],["sgl/gl"]],
["gl_light_model_color_control",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.G.H.T_.M.O.D.E.L_.C.O.L.O.R_.C.O.N.T.R.O.L))",[0,[1,"GL_LIGHT_MODEL_COLOR_CONTROL"]],["sgl/gl"]],
["gl_light_model_local_viewer",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.G.H.T_.M.O.D.E.L_.L.O.C.A.L_.V.I.E.W.E.R))",[0,[1,"GL_LIGHT_MODEL_LOCAL_VIEWER"]],["sgl/gl"]],
["gl_light_model_two_side",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.G.H.T_.M.O.D.E.L_.T.W.O_.S.I.D.E))",[0,[1,"GL_LIGHT_MODEL_TWO_SIDE"]],["sgl/gl"]],
["gl_lighting",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.G.H.T.I.N.G))",[0,[1,"GL_LIGHTING"]],["sgl/gl"]],
["gl_lighting_bit",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.G.H.T.I.N.G_.B.I.T))",[0,[1,"GL_LIGHTING_BIT"]],["sgl/gl"]],
["gl_line",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.N.E))",[0,[1,"GL_LINE"]],["sgl/gl"]],
["gl_line_bit",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.N.E_.B.I.T))",[0,[1,"GL_LINE_BIT"]],["sgl/gl"]],
["gl_line_loop",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.N.E_.L.O.O.P))",[0,[1,"GL_LINE_LOOP"]],["sgl/gl"]],
["gl_line_reset_token",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.N.E_.R.E.S.E.T_.T.O.K.E.N))",[0,[1,"GL_LINE_RESET_TOKEN"]],["sgl/gl"]],
["gl_line_smooth",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.N.E_.S.M.O.O.T.H))",[0,[1,"GL_LINE_SMOOTH"]],["sgl/gl"]],
["gl_line_smooth_hint",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.N.E_.S.M.O.O.T.H_.H.I.N.T))",[0,[1,"GL_LINE_SMOOTH_HINT"]],["sgl/gl"]],
["gl_line_stipple",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.N.E_.S.T.I.P.P.L.E))",[0,[1,"GL_LINE_STIPPLE"]],["sgl/gl"]],
["gl_line_stipple_pattern",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.N.E_.S.T.I.P.P.L.E_.P.A.T.T.E.R.N))",[0,[1,"GL_LINE_STIPPLE_PATTERN"]],["sgl/gl"]],
["gl_line_stipple_repeat",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.N.E_.S.T.I.P.P.L.E_.R.E.P.E.A.T))",[0,[1,"GL_LINE_STIPPLE_REPEAT"]],["sgl/gl"]],
["gl_line_strip",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.N.E_.S.T.R.I.P))",[0,[1,"GL_LINE_STRIP"]],["sgl/gl"]],
["gl_line_token",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.N.E_.T.O.K.E.N))",[0,[1,"GL_LINE_TOKEN"]],["sgl/gl"]],
["gl_line_width",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.N.E_.W.I.D.T.H))",[0,[1,"GL_LINE_WIDTH"]],["sgl/gl"]],
["gl_line_width_granularity",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.N.E_.W.I.D.T.H_.G.R.A.N.U.L.A.R.I.T.Y))",[0,[1,"GL_LINE_WIDTH_GRANULARITY"]],["sgl/gl"]],
["gl_line_width_range",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.N.E_.W.I.D.T.H_.R.A.N.G.E))",[0,[1,"GL_LINE_WIDTH_RANGE"]],["sgl/gl"]],
["gl_linear",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.N.E.A.R))",[0,[1,"GL_LINEAR"]],["sgl/gl"]],
["gl_linear_attenuation",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.N.E.A.R_.A.T.T.E.N.U.A.T.I.O.N))",[0,[1,"GL_LINEAR_ATTENUATION"]],["sgl/gl"]],
["gl_linear_mipmap_linear",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.N.E.A.R_.M.I.P.M.A.P_.L.I.N.E.A.R))",[0,[1,"GL_LINEAR_MIPMAP_LINEAR"]],["sgl/gl"]],
["gl_linear_mipmap_nearest",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.N.E.A.R_.M.I.P.M.A.P_.N.E.A.R.E.S.T))",[0,[1,"GL_LINEAR_MIPMAP_NEAREST"]],["sgl/gl"]],
["gl_lines",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.N.E.S))",[0,[1,"GL_LINES"]],["sgl/gl"]],
["gl_list_base",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.S.T_.B.A.S.E))",[0,[1,"GL_LIST_BASE"]],["sgl/gl"]],
["gl_list_bit",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.S.T_.B.I.T))",[0,[1,"GL_LIST_BIT"]],["sgl/gl"]],
["gl_list_index",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.S.T_.I.N.D.E.X))",[0,[1,"GL_LIST_INDEX"]],["sgl/gl"]],
["gl_list_mode",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.I.S.T_.M.O.D.E))",[0,[1,"GL_LIST_MODE"]],["sgl/gl"]],
["gl_load",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.O.A.D))",[0,[1,"GL_LOAD"]],["sgl/gl"]],
["gl_logic_op",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.O.G.I.C_.O.P))",[0,[1,"GL_LOGIC_OP"]],["sgl/gl"]],
["gl_logic_op_mode",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.O.G.I.C_.O.P_.M.O.D.E))",[0,[1,"GL_LOGIC_OP_MODE"]],["sgl/gl"]],
["gl_luminance",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.U.M.I.N.A.N.C.E))",[0,[1,"GL_LUMINANCE"]],["sgl/gl"]],
["gl_luminance12",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.U.M.I.N.A.N.C.E12))",[0,[1,"GL_LUMINANCE12"]],["sgl/gl"]],
["gl_luminance12_alpha12",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.U.M.I.N.A.N.C.E12_.A.L.P.H.A12))",[0,[1,"GL_LUMINANCE12_ALPHA12"]],["sgl/gl"]],
["gl_luminance12_alpha4",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.U.M.I.N.A.N.C.E12_.A.L.P.H.A4))",[0,[1,"GL_LUMINANCE12_ALPHA4"]],["sgl/gl"]],
["gl_luminance16",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.U.M.I.N.A.N.C.E16))",[0,[1,"GL_LUMINANCE16"]],["sgl/gl"]],
["gl_luminance16_alpha16",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.U.M.I.N.A.N.C.E16_.A.L.P.H.A16))",[0,[1,"GL_LUMINANCE16_ALPHA16"]],["sgl/gl"]],
["gl_luminance4",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.U.M.I.N.A.N.C.E4))",[0,[1,"GL_LUMINANCE4"]],["sgl/gl"]],
["gl_luminance4_alpha4",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.U.M.I.N.A.N.C.E4_.A.L.P.H.A4))",[0,[1,"GL_LUMINANCE4_ALPHA4"]],["sgl/gl"]],
["gl_luminance6_alpha2",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.U.M.I.N.A.N.C.E6_.A.L.P.H.A2))",[0,[1,"GL_LUMINANCE6_ALPHA2"]],["sgl/gl"]],
["gl_luminance8",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.U.M.I.N.A.N.C.E8))",[0,[1,"GL_LUMINANCE8"]],["sgl/gl"]],
["gl_luminance8_alpha8",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.U.M.I.N.A.N.C.E8_.A.L.P.H.A8))",[0,[1,"GL_LUMINANCE8_ALPHA8"]],["sgl/gl"]],
["gl_luminance_alpha",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.L.U.M.I.N.A.N.C.E_.A.L.P.H.A))",[0,[1,"GL_LUMINANCE_ALPHA"]],["sgl/gl"]],
["gl_map1_color_4",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.P1_.C.O.L.O.R_4))",[0,[1,"GL_MAP1_COLOR_4"]],["sgl/gl"]],
["gl_map1_grid_domain",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.P1_.G.R.I.D_.D.O.M.A.I.N))",[0,[1,"GL_MAP1_GRID_DOMAIN"]],["sgl/gl"]],
["gl_map1_grid_segments",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.P1_.G.R.I.D_.S.E.G.M.E.N.T.S))",[0,[1,"GL_MAP1_GRID_SEGMENTS"]],["sgl/gl"]],
["gl_map1_index",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.P1_.I.N.D.E.X))",[0,[1,"GL_MAP1_INDEX"]],["sgl/gl"]],
["gl_map1_normal",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.P1_.N.O.R.M.A.L))",[0,[1,"GL_MAP1_NORMAL"]],["sgl/gl"]],
["gl_map1_texture_coord_1",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.P1_.T.E.X.T.U.R.E_.C.O.O.R.D_1))",[0,[1,"GL_MAP1_TEXTURE_COORD_1"]],["sgl/gl"]],
["gl_map1_texture_coord_2",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.P1_.T.E.X.T.U.R.E_.C.O.O.R.D_2))",[0,[1,"GL_MAP1_TEXTURE_COORD_2"]],["sgl/gl"]],
["gl_map1_texture_coord_3",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.P1_.T.E.X.T.U.R.E_.C.O.O.R.D_3))",[0,[1,"GL_MAP1_TEXTURE_COORD_3"]],["sgl/gl"]],
["gl_map1_texture_coord_4",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.P1_.T.E.X.T.U.R.E_.C.O.O.R.D_4))",[0,[1,"GL_MAP1_TEXTURE_COORD_4"]],["sgl/gl"]],
["gl_map1_vertex_3",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.P1_.V.E.R.T.E.X_3))",[0,[1,"GL_MAP1_VERTEX_3"]],["sgl/gl"]],
["gl_map1_vertex_4",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.P1_.V.E.R.T.E.X_4))",[0,[1,"GL_MAP1_VERTEX_4"]],["sgl/gl"]],
["gl_map2_color_4",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.P2_.C.O.L.O.R_4))",[0,[1,"GL_MAP2_COLOR_4"]],["sgl/gl"]],
["gl_map2_grid_domain",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.P2_.G.R.I.D_.D.O.M.A.I.N))",[0,[1,"GL_MAP2_GRID_DOMAIN"]],["sgl/gl"]],
["gl_map2_grid_segments",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.P2_.G.R.I.D_.S.E.G.M.E.N.T.S))",[0,[1,"GL_MAP2_GRID_SEGMENTS"]],["sgl/gl"]],
["gl_map2_index",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.P2_.I.N.D.E.X))",[0,[1,"GL_MAP2_INDEX"]],["sgl/gl"]],
["gl_map2_normal",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.P2_.N.O.R.M.A.L))",[0,[1,"GL_MAP2_NORMAL"]],["sgl/gl"]],
["gl_map2_texture_coord_1",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.P2_.T.E.X.T.U.R.E_.C.O.O.R.D_1))",[0,[1,"GL_MAP2_TEXTURE_COORD_1"]],["sgl/gl"]],
["gl_map2_texture_coord_2",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.P2_.T.E.X.T.U.R.E_.C.O.O.R.D_2))",[0,[1,"GL_MAP2_TEXTURE_COORD_2"]],["sgl/gl"]],
["gl_map2_texture_coord_3",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.P2_.T.E.X.T.U.R.E_.C.O.O.R.D_3))",[0,[1,"GL_MAP2_TEXTURE_COORD_3"]],["sgl/gl"]],
["gl_map2_texture_coord_4",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.P2_.T.E.X.T.U.R.E_.C.O.O.R.D_4))",[0,[1,"GL_MAP2_TEXTURE_COORD_4"]],["sgl/gl"]],
["gl_map2_vertex_3",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.P2_.V.E.R.T.E.X_3))",[0,[1,"GL_MAP2_VERTEX_3"]],["sgl/gl"]],
["gl_map2_vertex_4",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.P2_.V.E.R.T.E.X_4))",[0,[1,"GL_MAP2_VERTEX_4"]],["sgl/gl"]],
["gl_map_color",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.P_.C.O.L.O.R))",[0,[1,"GL_MAP_COLOR"]],["sgl/gl"]],
["gl_map_stencil",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.P_.S.T.E.N.C.I.L))",[0,[1,"GL_MAP_STENCIL"]],["sgl/gl"]],
["gl_matrix_mode",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.T.R.I.X_.M.O.D.E))",[0,[1,"GL_MATRIX_MODE"]],["sgl/gl"]],
["gl_max",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.X))",[0,[1,"GL_MAX"]],["sgl/gl"]],
["gl_max_3d_texture_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.X_3.D_.T.E.X.T.U.R.E_.S.I.Z.E))",[0,[1,"GL_MAX_3D_TEXTURE_SIZE"]],["sgl/gl"]],
["gl_max_attrib_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.X_.A.T.T.R.I.B_.S.T.A.C.K_.D.E.P.T.H))",[0,[1,"GL_MAX_ATTRIB_STACK_DEPTH"]],["sgl/gl"]],
["gl_max_client_attrib_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.X_.C.L.I.E.N.T_.A.T.T.R.I.B_.S.T.A.C.K_.D.E.P.T.H))",[0,[1,"GL_MAX_CLIENT_ATTRIB_STACK_DEPTH"]],["sgl/gl"]],
["gl_max_clip_planes",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.X_.C.L.I.P_.P.L.A.N.E.S))",[0,[1,"GL_MAX_CLIP_PLANES"]],["sgl/gl"]],
["gl_max_color_matrix_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.X_.C.O.L.O.R_.M.A.T.R.I.X_.S.T.A.C.K_.D.E.P.T.H))",[0,[1,"GL_MAX_COLOR_MATRIX_STACK_DEPTH"]],["sgl/gl"]],
["gl_max_convolution_height",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.X_.C.O.N.V.O.L.U.T.I.O.N_.H.E.I.G.H.T))",[0,[1,"GL_MAX_CONVOLUTION_HEIGHT"]],["sgl/gl"]],
["gl_max_convolution_width",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.X_.C.O.N.V.O.L.U.T.I.O.N_.W.I.D.T.H))",[0,[1,"GL_MAX_CONVOLUTION_WIDTH"]],["sgl/gl"]],
["gl_max_cube_map_texture_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.X_.C.U.B.E_.M.A.P_.T.E.X.T.U.R.E_.S.I.Z.E))",[0,[1,"GL_MAX_CUBE_MAP_TEXTURE_SIZE"]],["sgl/gl"]],
["gl_max_elements_indices",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.X_.E.L.E.M.E.N.T.S_.I.N.D.I.C.E.S))",[0,[1,"GL_MAX_ELEMENTS_INDICES"]],["sgl/gl"]],
["gl_max_elements_vertices",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.X_.E.L.E.M.E.N.T.S_.V.E.R.T.I.C.E.S))",[0,[1,"GL_MAX_ELEMENTS_VERTICES"]],["sgl/gl"]],
["gl_max_eval_order",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.X_.E.V.A.L_.O.R.D.E.R))",[0,[1,"GL_MAX_EVAL_ORDER"]],["sgl/gl"]],
["gl_max_lights",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.X_.L.I.G.H.T.S))",[0,[1,"GL_MAX_LIGHTS"]],["sgl/gl"]],
["gl_max_list_nesting",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.X_.L.I.S.T_.N.E.S.T.I.N.G))",[0,[1,"GL_MAX_LIST_NESTING"]],["sgl/gl"]],
["gl_max_modelview_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.X_.M.O.D.E.L.V.I.E.W_.S.T.A.C.K_.D.E.P.T.H))",[0,[1,"GL_MAX_MODELVIEW_STACK_DEPTH"]],["sgl/gl"]],
["gl_max_name_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.X_.N.A.M.E_.S.T.A.C.K_.D.E.P.T.H))",[0,[1,"GL_MAX_NAME_STACK_DEPTH"]],["sgl/gl"]],
["gl_max_pixel_map_table",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.X_.P.I.X.E.L_.M.A.P_.T.A.B.L.E))",[0,[1,"GL_MAX_PIXEL_MAP_TABLE"]],["sgl/gl"]],
["gl_max_projection_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.X_.P.R.O.J.E.C.T.I.O.N_.S.T.A.C.K_.D.E.P.T.H))",[0,[1,"GL_MAX_PROJECTION_STACK_DEPTH"]],["sgl/gl"]],
["gl_max_texture_lod_bias",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.X_.T.E.X.T.U.R.E_.L.O.D_.B.I.A.S))",[0,[1,"GL_MAX_TEXTURE_LOD_BIAS"]],["sgl/gl"]],
["gl_max_texture_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.X_.T.E.X.T.U.R.E_.S.I.Z.E))",[0,[1,"GL_MAX_TEXTURE_SIZE"]],["sgl/gl"]],
["gl_max_texture_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.X_.T.E.X.T.U.R.E_.S.T.A.C.K_.D.E.P.T.H))",[0,[1,"GL_MAX_TEXTURE_STACK_DEPTH"]],["sgl/gl"]],
["gl_max_texture_units",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.X_.T.E.X.T.U.R.E_.U.N.I.T.S))",[0,[1,"GL_MAX_TEXTURE_UNITS"]],["sgl/gl"]],
["gl_max_viewport_dims",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.A.X_.V.I.E.W.P.O.R.T_.D.I.M.S))",[0,[1,"GL_MAX_VIEWPORT_DIMS"]],["sgl/gl"]],
["gl_min",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.I.N))",[0,[1,"GL_MIN"]],["sgl/gl"]],
["gl_minmax",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.I.N.M.A.X))",[0,[1,"GL_MINMAX"]],["sgl/gl"]],
["gl_minmax_format",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.I.N.M.A.X_.F.O.R.M.A.T))",[0,[1,"GL_MINMAX_FORMAT"]],["sgl/gl"]],
["gl_minmax_sink",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.I.N.M.A.X_.S.I.N.K))",[0,[1,"GL_MINMAX_SINK"]],["sgl/gl"]],
["gl_mirrored_repeat",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.I.R.R.O.R.E.D_.R.E.P.E.A.T))",[0,[1,"GL_MIRRORED_REPEAT"]],["sgl/gl"]],
["gl_modelview",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.O.D.E.L.V.I.E.W))",[0,[1,"GL_MODELVIEW"]],["sgl/gl"]],
["gl_modelview_matrix",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.O.D.E.L.V.I.E.W_.M.A.T.R.I.X))",[0,[1,"GL_MODELVIEW_MATRIX"]],["sgl/gl"]],
["gl_modelview_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.O.D.E.L.V.I.E.W_.S.T.A.C.K_.D.E.P.T.H))",[0,[1,"GL_MODELVIEW_STACK_DEPTH"]],["sgl/gl"]],
["gl_modulate",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.O.D.U.L.A.T.E))",[0,[1,"GL_MODULATE"]],["sgl/gl"]],
["gl_mult",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.U.L.T))",[0,[1,"GL_MULT"]],["sgl/gl"]],
["gl_multisample",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.U.L.T.I.S.A.M.P.L.E))",[0,[1,"GL_MULTISAMPLE"]],["sgl/gl"]],
["gl_multisample_bit",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.M.U.L.T.I.S.A.M.P.L.E_.B.I.T))",[0,[1,"GL_MULTISAMPLE_BIT"]],["sgl/gl"]],
["gl_n3f_v3f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.N3.F_.V3.F))",[0,[1,"GL_N3F_V3F"]],["sgl/gl"]],
["gl_name_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.N.A.M.E_.S.T.A.C.K_.D.E.P.T.H))",[0,[1,"GL_NAME_STACK_DEPTH"]],["sgl/gl"]],
["gl_nand",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.N.A.N.D))",[0,[1,"GL_NAND"]],["sgl/gl"]],
["gl_nearest",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.N.E.A.R.E.S.T))",[0,[1,"GL_NEAREST"]],["sgl/gl"]],
["gl_nearest_mipmap_linear",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.N.E.A.R.E.S.T_.M.I.P.M.A.P_.L.I.N.E.A.R))",[0,[1,"GL_NEAREST_MIPMAP_LINEAR"]],["sgl/gl"]],
["gl_nearest_mipmap_nearest",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.N.E.A.R.E.S.T_.M.I.P.M.A.P_.N.E.A.R.E.S.T))",[0,[1,"GL_NEAREST_MIPMAP_NEAREST"]],["sgl/gl"]],
["gl_never",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.N.E.V.E.R))",[0,[1,"GL_NEVER"]],["sgl/gl"]],
["gl_nicest",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.N.I.C.E.S.T))",[0,[1,"GL_NICEST"]],["sgl/gl"]],
["gl_no_error",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.N.O_.E.R.R.O.R))",[0,[1,"GL_NO_ERROR"]],["sgl/gl"]],
["gl_none",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.N.O.N.E))",[0,[1,"GL_NONE"]],["sgl/gl"]],
["gl_noop",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.N.O.O.P))",[0,[1,"GL_NOOP"]],["sgl/gl"]],
["gl_nor",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.N.O.R))",[0,[1,"GL_NOR"]],["sgl/gl"]],
["gl_normal_array",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.N.O.R.M.A.L_.A.R.R.A.Y))",[0,[1,"GL_NORMAL_ARRAY"]],["sgl/gl"]],
["gl_normal_array_buffer_binding",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.N.O.R.M.A.L_.A.R.R.A.Y_.B.U.F.F.E.R_.B.I.N.D.I.N.G))",[0,[1,"GL_NORMAL_ARRAY_BUFFER_BINDING"]],["sgl/gl"]],
["gl_normal_array_pointer",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.N.O.R.M.A.L_.A.R.R.A.Y_.P.O.I.N.T.E.R))",[0,[1,"GL_NORMAL_ARRAY_POINTER"]],["sgl/gl"]],
["gl_normal_array_stride",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.N.O.R.M.A.L_.A.R.R.A.Y_.S.T.R.I.D.E))",[0,[1,"GL_NORMAL_ARRAY_STRIDE"]],["sgl/gl"]],
["gl_normal_array_type",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.N.O.R.M.A.L_.A.R.R.A.Y_.T.Y.P.E))",[0,[1,"GL_NORMAL_ARRAY_TYPE"]],["sgl/gl"]],
["gl_normal_map",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.N.O.R.M.A.L_.M.A.P))",[0,[1,"GL_NORMAL_MAP"]],["sgl/gl"]],
["gl_normalize",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.N.O.R.M.A.L.I.Z.E))",[0,[1,"GL_NORMALIZE"]],["sgl/gl"]],
["gl_notequal",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.N.O.T.E.Q.U.A.L))",[0,[1,"GL_NOTEQUAL"]],["sgl/gl"]],
["gl_num_compressed_texture_formats",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.N.U.M_.C.O.M.P.R.E.S.S.E.D_.T.E.X.T.U.R.E_.F.O.R.M.A.T.S))",[0,[1,"GL_NUM_COMPRESSED_TEXTURE_FORMATS"]],["sgl/gl"]],
["gl_object_linear",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.O.B.J.E.C.T_.L.I.N.E.A.R))",[0,[1,"GL_OBJECT_LINEAR"]],["sgl/gl"]],
["gl_object_plane",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.O.B.J.E.C.T_.P.L.A.N.E))",[0,[1,"GL_OBJECT_PLANE"]],["sgl/gl"]],
["gl_one",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.O.N.E))",[0,[1,"GL_ONE"]],["sgl/gl"]],
["gl_one_minus_constant_alpha",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.O.N.E_.M.I.N.U.S_.C.O.N.S.T.A.N.T_.A.L.P.H.A))",[0,[1,"GL_ONE_MINUS_CONSTANT_ALPHA"]],["sgl/gl"]],
["gl_one_minus_constant_color",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.O.N.E_.M.I.N.U.S_.C.O.N.S.T.A.N.T_.C.O.L.O.R))",[0,[1,"GL_ONE_MINUS_CONSTANT_COLOR"]],["sgl/gl"]],
["gl_one_minus_dst_alpha",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.O.N.E_.M.I.N.U.S_.D.S.T_.A.L.P.H.A))",[0,[1,"GL_ONE_MINUS_DST_ALPHA"]],["sgl/gl"]],
["gl_one_minus_dst_color",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.O.N.E_.M.I.N.U.S_.D.S.T_.C.O.L.O.R))",[0,[1,"GL_ONE_MINUS_DST_COLOR"]],["sgl/gl"]],
["gl_one_minus_src_alpha",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.O.N.E_.M.I.N.U.S_.S.R.C_.A.L.P.H.A))",[0,[1,"GL_ONE_MINUS_SRC_ALPHA"]],["sgl/gl"]],
["gl_one_minus_src_color",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.O.N.E_.M.I.N.U.S_.S.R.C_.C.O.L.O.R))",[0,[1,"GL_ONE_MINUS_SRC_COLOR"]],["sgl/gl"]],
["gl_operand0_alpha",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.O.P.E.R.A.N.D0_.A.L.P.H.A))",[0,[1,"GL_OPERAND0_ALPHA"]],["sgl/gl"]],
["gl_operand0_rgb",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.O.P.E.R.A.N.D0_.R.G.B))",[0,[1,"GL_OPERAND0_RGB"]],["sgl/gl"]],
["gl_operand1_alpha",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.O.P.E.R.A.N.D1_.A.L.P.H.A))",[0,[1,"GL_OPERAND1_ALPHA"]],["sgl/gl"]],
["gl_operand1_rgb",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.O.P.E.R.A.N.D1_.R.G.B))",[0,[1,"GL_OPERAND1_RGB"]],["sgl/gl"]],
["gl_operand2_alpha",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.O.P.E.R.A.N.D2_.A.L.P.H.A))",[0,[1,"GL_OPERAND2_ALPHA"]],["sgl/gl"]],
["gl_operand2_rgb",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.O.P.E.R.A.N.D2_.R.G.B))",[0,[1,"GL_OPERAND2_RGB"]],["sgl/gl"]],
["gl_or",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.O.R))",[0,[1,"GL_OR"]],["sgl/gl"]],
["gl_or_inverted",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.O.R_.I.N.V.E.R.T.E.D))",[0,[1,"GL_OR_INVERTED"]],["sgl/gl"]],
["gl_or_reverse",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.O.R_.R.E.V.E.R.S.E))",[0,[1,"GL_OR_REVERSE"]],["sgl/gl"]],
["gl_order",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.O.R.D.E.R))",[0,[1,"GL_ORDER"]],["sgl/gl"]],
["gl_out_of_memory",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.O.U.T_.O.F_.M.E.M.O.R.Y))",[0,[1,"GL_OUT_OF_MEMORY"]],["sgl/gl"]],
["gl_pack_alignment",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.A.C.K_.A.L.I.G.N.M.E.N.T))",[0,[1,"GL_PACK_ALIGNMENT"]],["sgl/gl"]],
["gl_pack_image_height",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.A.C.K_.I.M.A.G.E_.H.E.I.G.H.T))",[0,[1,"GL_PACK_IMAGE_HEIGHT"]],["sgl/gl"]],
["gl_pack_lsb_first",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.A.C.K_.L.S.B_.F.I.R.S.T))",[0,[1,"GL_PACK_LSB_FIRST"]],["sgl/gl"]],
["gl_pack_row_length",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.A.C.K_.R.O.W_.L.E.N.G.T.H))",[0,[1,"GL_PACK_ROW_LENGTH"]],["sgl/gl"]],
["gl_pack_skip_images",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.A.C.K_.S.K.I.P_.I.M.A.G.E.S))",[0,[1,"GL_PACK_SKIP_IMAGES"]],["sgl/gl"]],
["gl_pack_skip_pixels",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.A.C.K_.S.K.I.P_.P.I.X.E.L.S))",[0,[1,"GL_PACK_SKIP_PIXELS"]],["sgl/gl"]],
["gl_pack_skip_rows",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.A.C.K_.S.K.I.P_.R.O.W.S))",[0,[1,"GL_PACK_SKIP_ROWS"]],["sgl/gl"]],
["gl_pack_swap_bytes",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.A.C.K_.S.W.A.P_.B.Y.T.E.S))",[0,[1,"GL_PACK_SWAP_BYTES"]],["sgl/gl"]],
["gl_pass_through_token",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.A.S.S_.T.H.R.O.U.G.H_.T.O.K.E.N))",[0,[1,"GL_PASS_THROUGH_TOKEN"]],["sgl/gl"]],
["gl_perspective_correction_hint",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.E.R.S.P.E.C.T.I.V.E_.C.O.R.R.E.C.T.I.O.N_.H.I.N.T))",[0,[1,"GL_PERSPECTIVE_CORRECTION_HINT"]],["sgl/gl"]],
["gl_pixel_map_a_to_a",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.I.X.E.L_.M.A.P_.A_.T.O_.A))",[0,[1,"GL_PIXEL_MAP_A_TO_A"]],["sgl/gl"]],
["gl_pixel_map_a_to_a_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.I.X.E.L_.M.A.P_.A_.T.O_.A_.S.I.Z.E))",[0,[1,"GL_PIXEL_MAP_A_TO_A_SIZE"]],["sgl/gl"]],
["gl_pixel_map_b_to_b",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.I.X.E.L_.M.A.P_.B_.T.O_.B))",[0,[1,"GL_PIXEL_MAP_B_TO_B"]],["sgl/gl"]],
["gl_pixel_map_b_to_b_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.I.X.E.L_.M.A.P_.B_.T.O_.B_.S.I.Z.E))",[0,[1,"GL_PIXEL_MAP_B_TO_B_SIZE"]],["sgl/gl"]],
["gl_pixel_map_g_to_g",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.I.X.E.L_.M.A.P_.G_.T.O_.G))",[0,[1,"GL_PIXEL_MAP_G_TO_G"]],["sgl/gl"]],
["gl_pixel_map_g_to_g_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.I.X.E.L_.M.A.P_.G_.T.O_.G_.S.I.Z.E))",[0,[1,"GL_PIXEL_MAP_G_TO_G_SIZE"]],["sgl/gl"]],
["gl_pixel_map_i_to_a",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.I.X.E.L_.M.A.P_.I_.T.O_.A))",[0,[1,"GL_PIXEL_MAP_I_TO_A"]],["sgl/gl"]],
["gl_pixel_map_i_to_a_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.I.X.E.L_.M.A.P_.I_.T.O_.A_.S.I.Z.E))",[0,[1,"GL_PIXEL_MAP_I_TO_A_SIZE"]],["sgl/gl"]],
["gl_pixel_map_i_to_b",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.I.X.E.L_.M.A.P_.I_.T.O_.B))",[0,[1,"GL_PIXEL_MAP_I_TO_B"]],["sgl/gl"]],
["gl_pixel_map_i_to_b_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.I.X.E.L_.M.A.P_.I_.T.O_.B_.S.I.Z.E))",[0,[1,"GL_PIXEL_MAP_I_TO_B_SIZE"]],["sgl/gl"]],
["gl_pixel_map_i_to_g",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.I.X.E.L_.M.A.P_.I_.T.O_.G))",[0,[1,"GL_PIXEL_MAP_I_TO_G"]],["sgl/gl"]],
["gl_pixel_map_i_to_g_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.I.X.E.L_.M.A.P_.I_.T.O_.G_.S.I.Z.E))",[0,[1,"GL_PIXEL_MAP_I_TO_G_SIZE"]],["sgl/gl"]],
["gl_pixel_map_i_to_i",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.I.X.E.L_.M.A.P_.I_.T.O_.I))",[0,[1,"GL_PIXEL_MAP_I_TO_I"]],["sgl/gl"]],
["gl_pixel_map_i_to_i_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.I.X.E.L_.M.A.P_.I_.T.O_.I_.S.I.Z.E))",[0,[1,"GL_PIXEL_MAP_I_TO_I_SIZE"]],["sgl/gl"]],
["gl_pixel_map_i_to_r",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.I.X.E.L_.M.A.P_.I_.T.O_.R))",[0,[1,"GL_PIXEL_MAP_I_TO_R"]],["sgl/gl"]],
["gl_pixel_map_i_to_r_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.I.X.E.L_.M.A.P_.I_.T.O_.R_.S.I.Z.E))",[0,[1,"GL_PIXEL_MAP_I_TO_R_SIZE"]],["sgl/gl"]],
["gl_pixel_map_r_to_r",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.I.X.E.L_.M.A.P_.R_.T.O_.R))",[0,[1,"GL_PIXEL_MAP_R_TO_R"]],["sgl/gl"]],
["gl_pixel_map_r_to_r_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.I.X.E.L_.M.A.P_.R_.T.O_.R_.S.I.Z.E))",[0,[1,"GL_PIXEL_MAP_R_TO_R_SIZE"]],["sgl/gl"]],
["gl_pixel_map_s_to_s",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.I.X.E.L_.M.A.P_.S_.T.O_.S))",[0,[1,"GL_PIXEL_MAP_S_TO_S"]],["sgl/gl"]],
["gl_pixel_map_s_to_s_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.I.X.E.L_.M.A.P_.S_.T.O_.S_.S.I.Z.E))",[0,[1,"GL_PIXEL_MAP_S_TO_S_SIZE"]],["sgl/gl"]],
["gl_pixel_mode_bit",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.I.X.E.L_.M.O.D.E_.B.I.T))",[0,[1,"GL_PIXEL_MODE_BIT"]],["sgl/gl"]],
["gl_point",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.I.N.T))",[0,[1,"GL_POINT"]],["sgl/gl"]],
["gl_point_bit",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.I.N.T_.B.I.T))",[0,[1,"GL_POINT_BIT"]],["sgl/gl"]],
["gl_point_distance_attenuation",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.I.N.T_.D.I.S.T.A.N.C.E_.A.T.T.E.N.U.A.T.I.O.N))",[0,[1,"GL_POINT_DISTANCE_ATTENUATION"]],["sgl/gl"]],
["gl_point_fade_threshold_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.I.N.T_.F.A.D.E_.T.H.R.E.S.H.O.L.D_.S.I.Z.E))",[0,[1,"GL_POINT_FADE_THRESHOLD_SIZE"]],["sgl/gl"]],
["gl_point_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.I.N.T_.S.I.Z.E))",[0,[1,"GL_POINT_SIZE"]],["sgl/gl"]],
["gl_point_size_granularity",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.I.N.T_.S.I.Z.E_.G.R.A.N.U.L.A.R.I.T.Y))",[0,[1,"GL_POINT_SIZE_GRANULARITY"]],["sgl/gl"]],
["gl_point_size_max",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.I.N.T_.S.I.Z.E_.M.A.X))",[0,[1,"GL_POINT_SIZE_MAX"]],["sgl/gl"]],
["gl_point_size_min",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.I.N.T_.S.I.Z.E_.M.I.N))",[0,[1,"GL_POINT_SIZE_MIN"]],["sgl/gl"]],
["gl_point_size_range",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.I.N.T_.S.I.Z.E_.R.A.N.G.E))",[0,[1,"GL_POINT_SIZE_RANGE"]],["sgl/gl"]],
["gl_point_smooth",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.I.N.T_.S.M.O.O.T.H))",[0,[1,"GL_POINT_SMOOTH"]],["sgl/gl"]],
["gl_point_smooth_hint",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.I.N.T_.S.M.O.O.T.H_.H.I.N.T))",[0,[1,"GL_POINT_SMOOTH_HINT"]],["sgl/gl"]],
["gl_point_token",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.I.N.T_.T.O.K.E.N))",[0,[1,"GL_POINT_TOKEN"]],["sgl/gl"]],
["gl_points",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.I.N.T.S))",[0,[1,"GL_POINTS"]],["sgl/gl"]],
["gl_polygon",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.L.Y.G.O.N))",[0,[1,"GL_POLYGON"]],["sgl/gl"]],
["gl_polygon_bit",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.L.Y.G.O.N_.B.I.T))",[0,[1,"GL_POLYGON_BIT"]],["sgl/gl"]],
["gl_polygon_mode",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.L.Y.G.O.N_.M.O.D.E))",[0,[1,"GL_POLYGON_MODE"]],["sgl/gl"]],
["gl_polygon_offset_factor",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.L.Y.G.O.N_.O.F.F.S.E.T_.F.A.C.T.O.R))",[0,[1,"GL_POLYGON_OFFSET_FACTOR"]],["sgl/gl"]],
["gl_polygon_offset_fill",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.L.Y.G.O.N_.O.F.F.S.E.T_.F.I.L.L))",[0,[1,"GL_POLYGON_OFFSET_FILL"]],["sgl/gl"]],
["gl_polygon_offset_line",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.L.Y.G.O.N_.O.F.F.S.E.T_.L.I.N.E))",[0,[1,"GL_POLYGON_OFFSET_LINE"]],["sgl/gl"]],
["gl_polygon_offset_point",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.L.Y.G.O.N_.O.F.F.S.E.T_.P.O.I.N.T))",[0,[1,"GL_POLYGON_OFFSET_POINT"]],["sgl/gl"]],
["gl_polygon_offset_units",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.L.Y.G.O.N_.O.F.F.S.E.T_.U.N.I.T.S))",[0,[1,"GL_POLYGON_OFFSET_UNITS"]],["sgl/gl"]],
["gl_polygon_smooth",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.L.Y.G.O.N_.S.M.O.O.T.H))",[0,[1,"GL_POLYGON_SMOOTH"]],["sgl/gl"]],
["gl_polygon_smooth_hint",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.L.Y.G.O.N_.S.M.O.O.T.H_.H.I.N.T))",[0,[1,"GL_POLYGON_SMOOTH_HINT"]],["sgl/gl"]],
["gl_polygon_stipple",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.L.Y.G.O.N_.S.T.I.P.P.L.E))",[0,[1,"GL_POLYGON_STIPPLE"]],["sgl/gl"]],
["gl_polygon_stipple_bit",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.L.Y.G.O.N_.S.T.I.P.P.L.E_.B.I.T))",[0,[1,"GL_POLYGON_STIPPLE_BIT"]],["sgl/gl"]],
["gl_polygon_token",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.L.Y.G.O.N_.T.O.K.E.N))",[0,[1,"GL_POLYGON_TOKEN"]],["sgl/gl"]],
["gl_position",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.S.I.T.I.O.N))",[0,[1,"GL_POSITION"]],["sgl/gl"]],
["gl_post_color_matrix_alpha_bias",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.S.T_.C.O.L.O.R_.M.A.T.R.I.X_.A.L.P.H.A_.B.I.A.S))",[0,[1,"GL_POST_COLOR_MATRIX_ALPHA_BIAS"]],["sgl/gl"]],
["gl_post_color_matrix_alpha_scale",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.S.T_.C.O.L.O.R_.M.A.T.R.I.X_.A.L.P.H.A_.S.C.A.L.E))",[0,[1,"GL_POST_COLOR_MATRIX_ALPHA_SCALE"]],["sgl/gl"]],
["gl_post_color_matrix_blue_bias",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.S.T_.C.O.L.O.R_.M.A.T.R.I.X_.B.L.U.E_.B.I.A.S))",[0,[1,"GL_POST_COLOR_MATRIX_BLUE_BIAS"]],["sgl/gl"]],
["gl_post_color_matrix_blue_scale",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.S.T_.C.O.L.O.R_.M.A.T.R.I.X_.B.L.U.E_.S.C.A.L.E))",[0,[1,"GL_POST_COLOR_MATRIX_BLUE_SCALE"]],["sgl/gl"]],
["gl_post_color_matrix_color_table",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.S.T_.C.O.L.O.R_.M.A.T.R.I.X_.C.O.L.O.R_.T.A.B.L.E))",[0,[1,"GL_POST_COLOR_MATRIX_COLOR_TABLE"]],["sgl/gl"]],
["gl_post_color_matrix_green_bias",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.S.T_.C.O.L.O.R_.M.A.T.R.I.X_.G.R.E.E.N_.B.I.A.S))",[0,[1,"GL_POST_COLOR_MATRIX_GREEN_BIAS"]],["sgl/gl"]],
["gl_post_color_matrix_green_scale",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.S.T_.C.O.L.O.R_.M.A.T.R.I.X_.G.R.E.E.N_.S.C.A.L.E))",[0,[1,"GL_POST_COLOR_MATRIX_GREEN_SCALE"]],["sgl/gl"]],
["gl_post_color_matrix_red_bias",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.S.T_.C.O.L.O.R_.M.A.T.R.I.X_.R.E.D_.B.I.A.S))",[0,[1,"GL_POST_COLOR_MATRIX_RED_BIAS"]],["sgl/gl"]],
["gl_post_color_matrix_red_scale",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.S.T_.C.O.L.O.R_.M.A.T.R.I.X_.R.E.D_.S.C.A.L.E))",[0,[1,"GL_POST_COLOR_MATRIX_RED_SCALE"]],["sgl/gl"]],
["gl_post_convolution_alpha_bias",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.S.T_.C.O.N.V.O.L.U.T.I.O.N_.A.L.P.H.A_.B.I.A.S))",[0,[1,"GL_POST_CONVOLUTION_ALPHA_BIAS"]],["sgl/gl"]],
["gl_post_convolution_alpha_scale",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.S.T_.C.O.N.V.O.L.U.T.I.O.N_.A.L.P.H.A_.S.C.A.L.E))",[0,[1,"GL_POST_CONVOLUTION_ALPHA_SCALE"]],["sgl/gl"]],
["gl_post_convolution_blue_bias",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.S.T_.C.O.N.V.O.L.U.T.I.O.N_.B.L.U.E_.B.I.A.S))",[0,[1,"GL_POST_CONVOLUTION_BLUE_BIAS"]],["sgl/gl"]],
["gl_post_convolution_blue_scale",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.S.T_.C.O.N.V.O.L.U.T.I.O.N_.B.L.U.E_.S.C.A.L.E))",[0,[1,"GL_POST_CONVOLUTION_BLUE_SCALE"]],["sgl/gl"]],
["gl_post_convolution_color_table",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.S.T_.C.O.N.V.O.L.U.T.I.O.N_.C.O.L.O.R_.T.A.B.L.E))",[0,[1,"GL_POST_CONVOLUTION_COLOR_TABLE"]],["sgl/gl"]],
["gl_post_convolution_green_bias",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.S.T_.C.O.N.V.O.L.U.T.I.O.N_.G.R.E.E.N_.B.I.A.S))",[0,[1,"GL_POST_CONVOLUTION_GREEN_BIAS"]],["sgl/gl"]],
["gl_post_convolution_green_scale",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.S.T_.C.O.N.V.O.L.U.T.I.O.N_.G.R.E.E.N_.S.C.A.L.E))",[0,[1,"GL_POST_CONVOLUTION_GREEN_SCALE"]],["sgl/gl"]],
["gl_post_convolution_red_bias",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.S.T_.C.O.N.V.O.L.U.T.I.O.N_.R.E.D_.B.I.A.S))",[0,[1,"GL_POST_CONVOLUTION_RED_BIAS"]],["sgl/gl"]],
["gl_post_convolution_red_scale",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.O.S.T_.C.O.N.V.O.L.U.T.I.O.N_.R.E.D_.S.C.A.L.E))",[0,[1,"GL_POST_CONVOLUTION_RED_SCALE"]],["sgl/gl"]],
["gl_previous",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.R.E.V.I.O.U.S))",[0,[1,"GL_PREVIOUS"]],["sgl/gl"]],
["gl_primary_color",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.R.I.M.A.R.Y_.C.O.L.O.R))",[0,[1,"GL_PRIMARY_COLOR"]],["sgl/gl"]],
["gl_projection",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.R.O.J.E.C.T.I.O.N))",[0,[1,"GL_PROJECTION"]],["sgl/gl"]],
["gl_projection_matrix",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.R.O.J.E.C.T.I.O.N_.M.A.T.R.I.X))",[0,[1,"GL_PROJECTION_MATRIX"]],["sgl/gl"]],
["gl_projection_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.R.O.J.E.C.T.I.O.N_.S.T.A.C.K_.D.E.P.T.H))",[0,[1,"GL_PROJECTION_STACK_DEPTH"]],["sgl/gl"]],
["gl_proxy_color_table",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.R.O.X.Y_.C.O.L.O.R_.T.A.B.L.E))",[0,[1,"GL_PROXY_COLOR_TABLE"]],["sgl/gl"]],
["gl_proxy_histogram",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.R.O.X.Y_.H.I.S.T.O.G.R.A.M))",[0,[1,"GL_PROXY_HISTOGRAM"]],["sgl/gl"]],
["gl_proxy_post_color_matrix_color_table",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.R.O.X.Y_.P.O.S.T_.C.O.L.O.R_.M.A.T.R.I.X_.C.O.L.O.R_.T.A.B.L.E))",[0,[1,"GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE"]],["sgl/gl"]],
["gl_proxy_post_convolution_color_table",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.R.O.X.Y_.P.O.S.T_.C.O.N.V.O.L.U.T.I.O.N_.C.O.L.O.R_.T.A.B.L.E))",[0,[1,"GL_PROXY_POST_CONVOLUTION_COLOR_TABLE"]],["sgl/gl"]],
["gl_proxy_texture_1d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.R.O.X.Y_.T.E.X.T.U.R.E_1.D))",[0,[1,"GL_PROXY_TEXTURE_1D"]],["sgl/gl"]],
["gl_proxy_texture_2d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.R.O.X.Y_.T.E.X.T.U.R.E_2.D))",[0,[1,"GL_PROXY_TEXTURE_2D"]],["sgl/gl"]],
["gl_proxy_texture_3d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.R.O.X.Y_.T.E.X.T.U.R.E_3.D))",[0,[1,"GL_PROXY_TEXTURE_3D"]],["sgl/gl"]],
["gl_proxy_texture_cube_map",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.P.R.O.X.Y_.T.E.X.T.U.R.E_.C.U.B.E_.M.A.P))",[0,[1,"GL_PROXY_TEXTURE_CUBE_MAP"]],["sgl/gl"]],
["gl_q",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.Q))",[0,[1,"GL_Q"]],["sgl/gl"]],
["gl_quad_strip",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.Q.U.A.D_.S.T.R.I.P))",[0,[1,"GL_QUAD_STRIP"]],["sgl/gl"]],
["gl_quadratic_attenuation",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.Q.U.A.D.R.A.T.I.C_.A.T.T.E.N.U.A.T.I.O.N))",[0,[1,"GL_QUADRATIC_ATTENUATION"]],["sgl/gl"]],
["gl_quads",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.Q.U.A.D.S))",[0,[1,"GL_QUADS"]],["sgl/gl"]],
["gl_query_counter_bits",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.Q.U.E.R.Y_.C.O.U.N.T.E.R_.B.I.T.S))",[0,[1,"GL_QUERY_COUNTER_BITS"]],["sgl/gl"]],
["gl_query_result",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.Q.U.E.R.Y_.R.E.S.U.L.T))",[0,[1,"GL_QUERY_RESULT"]],["sgl/gl"]],
["gl_query_result_available",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.Q.U.E.R.Y_.R.E.S.U.L.T_.A.V.A.I.L.A.B.L.E))",[0,[1,"GL_QUERY_RESULT_AVAILABLE"]],["sgl/gl"]],
["gl_r",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R))",[0,[1,"GL_R"]],["sgl/gl"]],
["gl_r3_g3_b2",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R3_.G3_.B2))",[0,[1,"GL_R3_G3_B2"]],["sgl/gl"]],
["gl_read_buffer",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.E.A.D_.B.U.F.F.E.R))",[0,[1,"GL_READ_BUFFER"]],["sgl/gl"]],
["gl_read_only",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.E.A.D_.O.N.L.Y))",[0,[1,"GL_READ_ONLY"]],["sgl/gl"]],
["gl_read_write",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.E.A.D_.W.R.I.T.E))",[0,[1,"GL_READ_WRITE"]],["sgl/gl"]],
["gl_red",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.E.D))",[0,[1,"GL_RED"]],["sgl/gl"]],
["gl_red_bias",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.E.D_.B.I.A.S))",[0,[1,"GL_RED_BIAS"]],["sgl/gl"]],
["gl_red_bits",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.E.D_.B.I.T.S))",[0,[1,"GL_RED_BITS"]],["sgl/gl"]],
["gl_red_scale",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.E.D_.S.C.A.L.E))",[0,[1,"GL_RED_SCALE"]],["sgl/gl"]],
["gl_reduce",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.E.D.U.C.E))",[0,[1,"GL_REDUCE"]],["sgl/gl"]],
["gl_reflection_map",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.E.F.L.E.C.T.I.O.N_.M.A.P))",[0,[1,"GL_REFLECTION_MAP"]],["sgl/gl"]],
["gl_render",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.E.N.D.E.R))",[0,[1,"GL_RENDER"]],["sgl/gl"]],
["gl_render_mode",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.E.N.D.E.R_.M.O.D.E))",[0,[1,"GL_RENDER_MODE"]],["sgl/gl"]],
["gl_renderer",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.E.N.D.E.R.E.R))",[0,[1,"GL_RENDERER"]],["sgl/gl"]],
["gl_repeat",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.E.P.E.A.T))",[0,[1,"GL_REPEAT"]],["sgl/gl"]],
["gl_replace",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.E.P.L.A.C.E))",[0,[1,"GL_REPLACE"]],["sgl/gl"]],
["gl_replicate_border",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.E.P.L.I.C.A.T.E_.B.O.R.D.E.R))",[0,[1,"GL_REPLICATE_BORDER"]],["sgl/gl"]],
["gl_rescale_normal",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.E.S.C.A.L.E_.N.O.R.M.A.L))",[0,[1,"GL_RESCALE_NORMAL"]],["sgl/gl"]],
["gl_return",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.E.T.U.R.N))",[0,[1,"GL_RETURN"]],["sgl/gl"]],
["gl_rgb",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.G.B))",[0,[1,"GL_RGB"]],["sgl/gl"]],
["gl_rgb10",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.G.B10))",[0,[1,"GL_RGB10"]],["sgl/gl"]],
["gl_rgb10_a2",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.G.B10_.A2))",[0,[1,"GL_RGB10_A2"]],["sgl/gl"]],
["gl_rgb12",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.G.B12))",[0,[1,"GL_RGB12"]],["sgl/gl"]],
["gl_rgb16",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.G.B16))",[0,[1,"GL_RGB16"]],["sgl/gl"]],
["gl_rgb4",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.G.B4))",[0,[1,"GL_RGB4"]],["sgl/gl"]],
["gl_rgb5",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.G.B5))",[0,[1,"GL_RGB5"]],["sgl/gl"]],
["gl_rgb5_a1",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.G.B5_.A1))",[0,[1,"GL_RGB5_A1"]],["sgl/gl"]],
["gl_rgb8",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.G.B8))",[0,[1,"GL_RGB8"]],["sgl/gl"]],
["gl_rgb_scale",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.G.B_.S.C.A.L.E))",[0,[1,"GL_RGB_SCALE"]],["sgl/gl"]],
["gl_rgba",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.G.B.A))",[0,[1,"GL_RGBA"]],["sgl/gl"]],
["gl_rgba12",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.G.B.A12))",[0,[1,"GL_RGBA12"]],["sgl/gl"]],
["gl_rgba16",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.G.B.A16))",[0,[1,"GL_RGBA16"]],["sgl/gl"]],
["gl_rgba2",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.G.B.A2))",[0,[1,"GL_RGBA2"]],["sgl/gl"]],
["gl_rgba4",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.G.B.A4))",[0,[1,"GL_RGBA4"]],["sgl/gl"]],
["gl_rgba8",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.G.B.A8))",[0,[1,"GL_RGBA8"]],["sgl/gl"]],
["gl_rgba_mode",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.G.B.A_.M.O.D.E))",[0,[1,"GL_RGBA_MODE"]],["sgl/gl"]],
["gl_right",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.R.I.G.H.T))",[0,[1,"GL_RIGHT"]],["sgl/gl"]],
["gl_s",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S))",[0,[1,"GL_S"]],["sgl/gl"]],
["gl_sample_alpha_to_coverage",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.A.M.P.L.E_.A.L.P.H.A_.T.O_.C.O.V.E.R.A.G.E))",[0,[1,"GL_SAMPLE_ALPHA_TO_COVERAGE"]],["sgl/gl"]],
["gl_sample_alpha_to_one",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.A.M.P.L.E_.A.L.P.H.A_.T.O_.O.N.E))",[0,[1,"GL_SAMPLE_ALPHA_TO_ONE"]],["sgl/gl"]],
["gl_sample_buffers",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.A.M.P.L.E_.B.U.F.F.E.R.S))",[0,[1,"GL_SAMPLE_BUFFERS"]],["sgl/gl"]],
["gl_sample_coverage",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.A.M.P.L.E_.C.O.V.E.R.A.G.E))",[0,[1,"GL_SAMPLE_COVERAGE"]],["sgl/gl"]],
["gl_sample_coverage_invert",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.A.M.P.L.E_.C.O.V.E.R.A.G.E_.I.N.V.E.R.T))",[0,[1,"GL_SAMPLE_COVERAGE_INVERT"]],["sgl/gl"]],
["gl_sample_coverage_value",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.A.M.P.L.E_.C.O.V.E.R.A.G.E_.V.A.L.U.E))",[0,[1,"GL_SAMPLE_COVERAGE_VALUE"]],["sgl/gl"]],
["gl_samples",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.A.M.P.L.E.S))",[0,[1,"GL_SAMPLES"]],["sgl/gl"]],
["gl_samples_passed",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.A.M.P.L.E.S_.P.A.S.S.E.D))",[0,[1,"GL_SAMPLES_PASSED"]],["sgl/gl"]],
["gl_scissor_bit",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.C.I.S.S.O.R_.B.I.T))",[0,[1,"GL_SCISSOR_BIT"]],["sgl/gl"]],
["gl_scissor_box",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.C.I.S.S.O.R_.B.O.X))",[0,[1,"GL_SCISSOR_BOX"]],["sgl/gl"]],
["gl_scissor_test",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.C.I.S.S.O.R_.T.E.S.T))",[0,[1,"GL_SCISSOR_TEST"]],["sgl/gl"]],
["gl_secondary_color_array",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.E.C.O.N.D.A.R.Y_.C.O.L.O.R_.A.R.R.A.Y))",[0,[1,"GL_SECONDARY_COLOR_ARRAY"]],["sgl/gl"]],
["gl_secondary_color_array_buffer_binding",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.E.C.O.N.D.A.R.Y_.C.O.L.O.R_.A.R.R.A.Y_.B.U.F.F.E.R_.B.I.N.D.I.N.G))",[0,[1,"GL_SECONDARY_COLOR_ARRAY_BUFFER_BINDING"]],["sgl/gl"]],
["gl_secondary_color_array_pointer",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.E.C.O.N.D.A.R.Y_.C.O.L.O.R_.A.R.R.A.Y_.P.O.I.N.T.E.R))",[0,[1,"GL_SECONDARY_COLOR_ARRAY_POINTER"]],["sgl/gl"]],
["gl_secondary_color_array_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.E.C.O.N.D.A.R.Y_.C.O.L.O.R_.A.R.R.A.Y_.S.I.Z.E))",[0,[1,"GL_SECONDARY_COLOR_ARRAY_SIZE"]],["sgl/gl"]],
["gl_secondary_color_array_stride",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.E.C.O.N.D.A.R.Y_.C.O.L.O.R_.A.R.R.A.Y_.S.T.R.I.D.E))",[0,[1,"GL_SECONDARY_COLOR_ARRAY_STRIDE"]],["sgl/gl"]],
["gl_secondary_color_array_type",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.E.C.O.N.D.A.R.Y_.C.O.L.O.R_.A.R.R.A.Y_.T.Y.P.E))",[0,[1,"GL_SECONDARY_COLOR_ARRAY_TYPE"]],["sgl/gl"]],
["gl_select",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.E.L.E.C.T))",[0,[1,"GL_SELECT"]],["sgl/gl"]],
["gl_selection_buffer_pointer",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.E.L.E.C.T.I.O.N_.B.U.F.F.E.R_.P.O.I.N.T.E.R))",[0,[1,"GL_SELECTION_BUFFER_POINTER"]],["sgl/gl"]],
["gl_selection_buffer_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.E.L.E.C.T.I.O.N_.B.U.F.F.E.R_.S.I.Z.E))",[0,[1,"GL_SELECTION_BUFFER_SIZE"]],["sgl/gl"]],
["gl_separable_2d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.E.P.A.R.A.B.L.E_2.D))",[0,[1,"GL_SEPARABLE_2D"]],["sgl/gl"]],
["gl_separate_specular_color",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.E.P.A.R.A.T.E_.S.P.E.C.U.L.A.R_.C.O.L.O.R))",[0,[1,"GL_SEPARATE_SPECULAR_COLOR"]],["sgl/gl"]],
["gl_set",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.E.T))",[0,[1,"GL_SET"]],["sgl/gl"]],
["gl_shade_model",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.H.A.D.E_.M.O.D.E.L))",[0,[1,"GL_SHADE_MODEL"]],["sgl/gl"]],
["gl_shininess",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.H.I.N.I.N.E.S.S))",[0,[1,"GL_SHININESS"]],["sgl/gl"]],
["gl_short",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.H.O.R.T))",[0,[1,"GL_SHORT"]],["sgl/gl"]],
["gl_single_color",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.I.N.G.L.E_.C.O.L.O.R))",[0,[1,"GL_SINGLE_COLOR"]],["sgl/gl"]],
["gl_smooth",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.M.O.O.T.H))",[0,[1,"GL_SMOOTH"]],["sgl/gl"]],
["gl_smooth_line_width_granularity",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.M.O.O.T.H_.L.I.N.E_.W.I.D.T.H_.G.R.A.N.U.L.A.R.I.T.Y))",[0,[1,"GL_SMOOTH_LINE_WIDTH_GRANULARITY"]],["sgl/gl"]],
["gl_smooth_line_width_range",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.M.O.O.T.H_.L.I.N.E_.W.I.D.T.H_.R.A.N.G.E))",[0,[1,"GL_SMOOTH_LINE_WIDTH_RANGE"]],["sgl/gl"]],
["gl_smooth_point_size_granularity",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.M.O.O.T.H_.P.O.I.N.T_.S.I.Z.E_.G.R.A.N.U.L.A.R.I.T.Y))",[0,[1,"GL_SMOOTH_POINT_SIZE_GRANULARITY"]],["sgl/gl"]],
["gl_smooth_point_size_range",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.M.O.O.T.H_.P.O.I.N.T_.S.I.Z.E_.R.A.N.G.E))",[0,[1,"GL_SMOOTH_POINT_SIZE_RANGE"]],["sgl/gl"]],
["gl_source0_alpha",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.O.U.R.C.E0_.A.L.P.H.A))",[0,[1,"GL_SOURCE0_ALPHA"]],["sgl/gl"]],
["gl_source0_rgb",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.O.U.R.C.E0_.R.G.B))",[0,[1,"GL_SOURCE0_RGB"]],["sgl/gl"]],
["gl_source1_alpha",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.O.U.R.C.E1_.A.L.P.H.A))",[0,[1,"GL_SOURCE1_ALPHA"]],["sgl/gl"]],
["gl_source1_rgb",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.O.U.R.C.E1_.R.G.B))",[0,[1,"GL_SOURCE1_RGB"]],["sgl/gl"]],
["gl_source2_alpha",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.O.U.R.C.E2_.A.L.P.H.A))",[0,[1,"GL_SOURCE2_ALPHA"]],["sgl/gl"]],
["gl_source2_rgb",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.O.U.R.C.E2_.R.G.B))",[0,[1,"GL_SOURCE2_RGB"]],["sgl/gl"]],
["gl_specular",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.P.E.C.U.L.A.R))",[0,[1,"GL_SPECULAR"]],["sgl/gl"]],
["gl_sphere_map",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.P.H.E.R.E_.M.A.P))",[0,[1,"GL_SPHERE_MAP"]],["sgl/gl"]],
["gl_spot_cutoff",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.P.O.T_.C.U.T.O.F.F))",[0,[1,"GL_SPOT_CUTOFF"]],["sgl/gl"]],
["gl_spot_direction",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.P.O.T_.D.I.R.E.C.T.I.O.N))",[0,[1,"GL_SPOT_DIRECTION"]],["sgl/gl"]],
["gl_spot_exponent",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.P.O.T_.E.X.P.O.N.E.N.T))",[0,[1,"GL_SPOT_EXPONENT"]],["sgl/gl"]],
["gl_src0_alpha",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.R.C0_.A.L.P.H.A))",[0,[1,"GL_SRC0_ALPHA"]],["sgl/gl"]],
["gl_src0_rgb",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.R.C0_.R.G.B))",[0,[1,"GL_SRC0_RGB"]],["sgl/gl"]],
["gl_src1_alpha",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.R.C1_.A.L.P.H.A))",[0,[1,"GL_SRC1_ALPHA"]],["sgl/gl"]],
["gl_src1_rgb",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.R.C1_.R.G.B))",[0,[1,"GL_SRC1_RGB"]],["sgl/gl"]],
["gl_src2_alpha",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.R.C2_.A.L.P.H.A))",[0,[1,"GL_SRC2_ALPHA"]],["sgl/gl"]],
["gl_src2_rgb",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.R.C2_.R.G.B))",[0,[1,"GL_SRC2_RGB"]],["sgl/gl"]],
["gl_src_alpha",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.R.C_.A.L.P.H.A))",[0,[1,"GL_SRC_ALPHA"]],["sgl/gl"]],
["gl_src_alpha_saturate",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.R.C_.A.L.P.H.A_.S.A.T.U.R.A.T.E))",[0,[1,"GL_SRC_ALPHA_SATURATE"]],["sgl/gl"]],
["gl_src_color",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.R.C_.C.O.L.O.R))",[0,[1,"GL_SRC_COLOR"]],["sgl/gl"]],
["gl_stack_overflow",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.T.A.C.K_.O.V.E.R.F.L.O.W))",[0,[1,"GL_STACK_OVERFLOW"]],["sgl/gl"]],
["gl_stack_underflow",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.T.A.C.K_.U.N.D.E.R.F.L.O.W))",[0,[1,"GL_STACK_UNDERFLOW"]],["sgl/gl"]],
["gl_static_copy",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.T.A.T.I.C_.C.O.P.Y))",[0,[1,"GL_STATIC_COPY"]],["sgl/gl"]],
["gl_static_draw",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.T.A.T.I.C_.D.R.A.W))",[0,[1,"GL_STATIC_DRAW"]],["sgl/gl"]],
["gl_static_read",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.T.A.T.I.C_.R.E.A.D))",[0,[1,"GL_STATIC_READ"]],["sgl/gl"]],
["gl_stencil",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.T.E.N.C.I.L))",[0,[1,"GL_STENCIL"]],["sgl/gl"]],
["gl_stencil_bits",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.T.E.N.C.I.L_.B.I.T.S))",[0,[1,"GL_STENCIL_BITS"]],["sgl/gl"]],
["gl_stencil_buffer_bit",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.T.E.N.C.I.L_.B.U.F.F.E.R_.B.I.T))",[0,[1,"GL_STENCIL_BUFFER_BIT"]],["sgl/gl"]],
["gl_stencil_clear_value",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.T.E.N.C.I.L_.C.L.E.A.R_.V.A.L.U.E))",[0,[1,"GL_STENCIL_CLEAR_VALUE"]],["sgl/gl"]],
["gl_stencil_fail",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.T.E.N.C.I.L_.F.A.I.L))",[0,[1,"GL_STENCIL_FAIL"]],["sgl/gl"]],
["gl_stencil_func",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.T.E.N.C.I.L_.F.U.N.C))",[0,[1,"GL_STENCIL_FUNC"]],["sgl/gl"]],
["gl_stencil_index",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.T.E.N.C.I.L_.I.N.D.E.X))",[0,[1,"GL_STENCIL_INDEX"]],["sgl/gl"]],
["gl_stencil_pass_depth_fail",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.T.E.N.C.I.L_.P.A.S.S_.D.E.P.T.H_.F.A.I.L))",[0,[1,"GL_STENCIL_PASS_DEPTH_FAIL"]],["sgl/gl"]],
["gl_stencil_pass_depth_pass",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.T.E.N.C.I.L_.P.A.S.S_.D.E.P.T.H_.P.A.S.S))",[0,[1,"GL_STENCIL_PASS_DEPTH_PASS"]],["sgl/gl"]],
["gl_stencil_ref",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.T.E.N.C.I.L_.R.E.F))",[0,[1,"GL_STENCIL_REF"]],["sgl/gl"]],
["gl_stencil_test",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.T.E.N.C.I.L_.T.E.S.T))",[0,[1,"GL_STENCIL_TEST"]],["sgl/gl"]],
["gl_stencil_value_mask",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.T.E.N.C.I.L_.V.A.L.U.E_.M.A.S.K))",[0,[1,"GL_STENCIL_VALUE_MASK"]],["sgl/gl"]],
["gl_stencil_writemask",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.T.E.N.C.I.L_.W.R.I.T.E.M.A.S.K))",[0,[1,"GL_STENCIL_WRITEMASK"]],["sgl/gl"]],
["gl_stereo",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.T.E.R.E.O))",[0,[1,"GL_STEREO"]],["sgl/gl"]],
["gl_stream_copy",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.T.R.E.A.M_.C.O.P.Y))",[0,[1,"GL_STREAM_COPY"]],["sgl/gl"]],
["gl_stream_draw",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.T.R.E.A.M_.D.R.A.W))",[0,[1,"GL_STREAM_DRAW"]],["sgl/gl"]],
["gl_stream_read",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.T.R.E.A.M_.R.E.A.D))",[0,[1,"GL_STREAM_READ"]],["sgl/gl"]],
["gl_subpixel_bits",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.U.B.P.I.X.E.L_.B.I.T.S))",[0,[1,"GL_SUBPIXEL_BITS"]],["sgl/gl"]],
["gl_subtract",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.S.U.B.T.R.A.C.T))",[0,[1,"GL_SUBTRACT"]],["sgl/gl"]],
["gl_t",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T))",[0,[1,"GL_T"]],["sgl/gl"]],
["gl_t2f_c3f_v3f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T2.F_.C3.F_.V3.F))",[0,[1,"GL_T2F_C3F_V3F"]],["sgl/gl"]],
["gl_t2f_c4f_n3f_v3f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T2.F_.C4.F_.N3.F_.V3.F))",[0,[1,"GL_T2F_C4F_N3F_V3F"]],["sgl/gl"]],
["gl_t2f_c4ub_v3f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T2.F_.C4.U.B_.V3.F))",[0,[1,"GL_T2F_C4UB_V3F"]],["sgl/gl"]],
["gl_t2f_n3f_v3f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T2.F_.N3.F_.V3.F))",[0,[1,"GL_T2F_N3F_V3F"]],["sgl/gl"]],
["gl_t2f_v3f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T2.F_.V3.F))",[0,[1,"GL_T2F_V3F"]],["sgl/gl"]],
["gl_t4f_c4f_n3f_v4f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T4.F_.C4.F_.N3.F_.V4.F))",[0,[1,"GL_T4F_C4F_N3F_V4F"]],["sgl/gl"]],
["gl_t4f_v4f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T4.F_.V4.F))",[0,[1,"GL_T4F_V4F"]],["sgl/gl"]],
["gl_table_too_large",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.A.B.L.E_.T.O.O_.L.A.R.G.E))",[0,[1,"GL_TABLE_TOO_LARGE"]],["sgl/gl"]],
["gl_texture",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E))",[0,[1,"GL_TEXTURE"]],["sgl/gl"]],
["gl_texture0",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E0))",[0,[1,"GL_TEXTURE0"]],["sgl/gl"]],
["gl_texture1",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E1))",[0,[1,"GL_TEXTURE1"]],["sgl/gl"]],
["gl_texture10",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E10))",[0,[1,"GL_TEXTURE10"]],["sgl/gl"]],
["gl_texture11",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E11))",[0,[1,"GL_TEXTURE11"]],["sgl/gl"]],
["gl_texture12",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E12))",[0,[1,"GL_TEXTURE12"]],["sgl/gl"]],
["gl_texture13",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E13))",[0,[1,"GL_TEXTURE13"]],["sgl/gl"]],
["gl_texture14",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E14))",[0,[1,"GL_TEXTURE14"]],["sgl/gl"]],
["gl_texture15",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E15))",[0,[1,"GL_TEXTURE15"]],["sgl/gl"]],
["gl_texture16",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E16))",[0,[1,"GL_TEXTURE16"]],["sgl/gl"]],
["gl_texture17",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E17))",[0,[1,"GL_TEXTURE17"]],["sgl/gl"]],
["gl_texture18",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E18))",[0,[1,"GL_TEXTURE18"]],["sgl/gl"]],
["gl_texture19",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E19))",[0,[1,"GL_TEXTURE19"]],["sgl/gl"]],
["gl_texture2",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E2))",[0,[1,"GL_TEXTURE2"]],["sgl/gl"]],
["gl_texture20",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E20))",[0,[1,"GL_TEXTURE20"]],["sgl/gl"]],
["gl_texture21",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E21))",[0,[1,"GL_TEXTURE21"]],["sgl/gl"]],
["gl_texture22",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E22))",[0,[1,"GL_TEXTURE22"]],["sgl/gl"]],
["gl_texture23",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E23))",[0,[1,"GL_TEXTURE23"]],["sgl/gl"]],
["gl_texture24",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E24))",[0,[1,"GL_TEXTURE24"]],["sgl/gl"]],
["gl_texture25",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E25))",[0,[1,"GL_TEXTURE25"]],["sgl/gl"]],
["gl_texture26",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E26))",[0,[1,"GL_TEXTURE26"]],["sgl/gl"]],
["gl_texture27",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E27))",[0,[1,"GL_TEXTURE27"]],["sgl/gl"]],
["gl_texture28",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E28))",[0,[1,"GL_TEXTURE28"]],["sgl/gl"]],
["gl_texture29",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E29))",[0,[1,"GL_TEXTURE29"]],["sgl/gl"]],
["gl_texture3",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E3))",[0,[1,"GL_TEXTURE3"]],["sgl/gl"]],
["gl_texture30",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E30))",[0,[1,"GL_TEXTURE30"]],["sgl/gl"]],
["gl_texture31",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E31))",[0,[1,"GL_TEXTURE31"]],["sgl/gl"]],
["gl_texture4",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E4))",[0,[1,"GL_TEXTURE4"]],["sgl/gl"]],
["gl_texture5",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E5))",[0,[1,"GL_TEXTURE5"]],["sgl/gl"]],
["gl_texture6",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E6))",[0,[1,"GL_TEXTURE6"]],["sgl/gl"]],
["gl_texture7",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E7))",[0,[1,"GL_TEXTURE7"]],["sgl/gl"]],
["gl_texture8",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E8))",[0,[1,"GL_TEXTURE8"]],["sgl/gl"]],
["gl_texture9",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E9))",[0,[1,"GL_TEXTURE9"]],["sgl/gl"]],
["gl_texture_1d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_1.D))",[0,[1,"GL_TEXTURE_1D"]],["sgl/gl"]],
["gl_texture_2d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_2.D))",[0,[1,"GL_TEXTURE_2D"]],["sgl/gl"]],
["gl_texture_3d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_3.D))",[0,[1,"GL_TEXTURE_3D"]],["sgl/gl"]],
["gl_texture_alpha_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.A.L.P.H.A_.S.I.Z.E))",[0,[1,"GL_TEXTURE_ALPHA_SIZE"]],["sgl/gl"]],
["gl_texture_base_level",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.B.A.S.E_.L.E.V.E.L))",[0,[1,"GL_TEXTURE_BASE_LEVEL"]],["sgl/gl"]],
["gl_texture_binding_1d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.B.I.N.D.I.N.G_1.D))",[0,[1,"GL_TEXTURE_BINDING_1D"]],["sgl/gl"]],
["gl_texture_binding_2d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.B.I.N.D.I.N.G_2.D))",[0,[1,"GL_TEXTURE_BINDING_2D"]],["sgl/gl"]],
["gl_texture_binding_3d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.B.I.N.D.I.N.G_3.D))",[0,[1,"GL_TEXTURE_BINDING_3D"]],["sgl/gl"]],
["gl_texture_binding_cube_map",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.B.I.N.D.I.N.G_.C.U.B.E_.M.A.P))",[0,[1,"GL_TEXTURE_BINDING_CUBE_MAP"]],["sgl/gl"]],
["gl_texture_bit",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.B.I.T))",[0,[1,"GL_TEXTURE_BIT"]],["sgl/gl"]],
["gl_texture_blue_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.B.L.U.E_.S.I.Z.E))",[0,[1,"GL_TEXTURE_BLUE_SIZE"]],["sgl/gl"]],
["gl_texture_border",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.B.O.R.D.E.R))",[0,[1,"GL_TEXTURE_BORDER"]],["sgl/gl"]],
["gl_texture_border_color",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.B.O.R.D.E.R_.C.O.L.O.R))",[0,[1,"GL_TEXTURE_BORDER_COLOR"]],["sgl/gl"]],
["gl_texture_compare_func",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.C.O.M.P.A.R.E_.F.U.N.C))",[0,[1,"GL_TEXTURE_COMPARE_FUNC"]],["sgl/gl"]],
["gl_texture_compare_mode",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.C.O.M.P.A.R.E_.M.O.D.E))",[0,[1,"GL_TEXTURE_COMPARE_MODE"]],["sgl/gl"]],
["gl_texture_components",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.C.O.M.P.O.N.E.N.T.S))",[0,[1,"GL_TEXTURE_COMPONENTS"]],["sgl/gl"]],
["gl_texture_compressed",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.C.O.M.P.R.E.S.S.E.D))",[0,[1,"GL_TEXTURE_COMPRESSED"]],["sgl/gl"]],
["gl_texture_compressed_image_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.C.O.M.P.R.E.S.S.E.D_.I.M.A.G.E_.S.I.Z.E))",[0,[1,"GL_TEXTURE_COMPRESSED_IMAGE_SIZE"]],["sgl/gl"]],
["gl_texture_compression_hint",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.C.O.M.P.R.E.S.S.I.O.N_.H.I.N.T))",[0,[1,"GL_TEXTURE_COMPRESSION_HINT"]],["sgl/gl"]],
["gl_texture_coord_array",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.C.O.O.R.D_.A.R.R.A.Y))",[0,[1,"GL_TEXTURE_COORD_ARRAY"]],["sgl/gl"]],
["gl_texture_coord_array_buffer_binding",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.C.O.O.R.D_.A.R.R.A.Y_.B.U.F.F.E.R_.B.I.N.D.I.N.G))",[0,[1,"GL_TEXTURE_COORD_ARRAY_BUFFER_BINDING"]],["sgl/gl"]],
["gl_texture_coord_array_pointer",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.C.O.O.R.D_.A.R.R.A.Y_.P.O.I.N.T.E.R))",[0,[1,"GL_TEXTURE_COORD_ARRAY_POINTER"]],["sgl/gl"]],
["gl_texture_coord_array_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.C.O.O.R.D_.A.R.R.A.Y_.S.I.Z.E))",[0,[1,"GL_TEXTURE_COORD_ARRAY_SIZE"]],["sgl/gl"]],
["gl_texture_coord_array_stride",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.C.O.O.R.D_.A.R.R.A.Y_.S.T.R.I.D.E))",[0,[1,"GL_TEXTURE_COORD_ARRAY_STRIDE"]],["sgl/gl"]],
["gl_texture_coord_array_type",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.C.O.O.R.D_.A.R.R.A.Y_.T.Y.P.E))",[0,[1,"GL_TEXTURE_COORD_ARRAY_TYPE"]],["sgl/gl"]],
["gl_texture_cube_map",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.C.U.B.E_.M.A.P))",[0,[1,"GL_TEXTURE_CUBE_MAP"]],["sgl/gl"]],
["gl_texture_cube_map_negative_x",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.C.U.B.E_.M.A.P_.N.E.G.A.T.I.V.E_.X))",[0,[1,"GL_TEXTURE_CUBE_MAP_NEGATIVE_X"]],["sgl/gl"]],
["gl_texture_cube_map_negative_y",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.C.U.B.E_.M.A.P_.N.E.G.A.T.I.V.E_.Y))",[0,[1,"GL_TEXTURE_CUBE_MAP_NEGATIVE_Y"]],["sgl/gl"]],
["gl_texture_cube_map_negative_z",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.C.U.B.E_.M.A.P_.N.E.G.A.T.I.V.E_.Z))",[0,[1,"GL_TEXTURE_CUBE_MAP_NEGATIVE_Z"]],["sgl/gl"]],
["gl_texture_cube_map_positive_x",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.C.U.B.E_.M.A.P_.P.O.S.I.T.I.V.E_.X))",[0,[1,"GL_TEXTURE_CUBE_MAP_POSITIVE_X"]],["sgl/gl"]],
["gl_texture_cube_map_positive_y",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.C.U.B.E_.M.A.P_.P.O.S.I.T.I.V.E_.Y))",[0,[1,"GL_TEXTURE_CUBE_MAP_POSITIVE_Y"]],["sgl/gl"]],
["gl_texture_cube_map_positive_z",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.C.U.B.E_.M.A.P_.P.O.S.I.T.I.V.E_.Z))",[0,[1,"GL_TEXTURE_CUBE_MAP_POSITIVE_Z"]],["sgl/gl"]],
["gl_texture_depth",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.D.E.P.T.H))",[0,[1,"GL_TEXTURE_DEPTH"]],["sgl/gl"]],
["gl_texture_depth_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.D.E.P.T.H_.S.I.Z.E))",[0,[1,"GL_TEXTURE_DEPTH_SIZE"]],["sgl/gl"]],
["gl_texture_env",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.E.N.V))",[0,[1,"GL_TEXTURE_ENV"]],["sgl/gl"]],
["gl_texture_env_color",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.E.N.V_.C.O.L.O.R))",[0,[1,"GL_TEXTURE_ENV_COLOR"]],["sgl/gl"]],
["gl_texture_env_mode",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.E.N.V_.M.O.D.E))",[0,[1,"GL_TEXTURE_ENV_MODE"]],["sgl/gl"]],
["gl_texture_filter_control",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.F.I.L.T.E.R_.C.O.N.T.R.O.L))",[0,[1,"GL_TEXTURE_FILTER_CONTROL"]],["sgl/gl"]],
["gl_texture_gen_mode",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.G.E.N_.M.O.D.E))",[0,[1,"GL_TEXTURE_GEN_MODE"]],["sgl/gl"]],
["gl_texture_gen_q",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.G.E.N_.Q))",[0,[1,"GL_TEXTURE_GEN_Q"]],["sgl/gl"]],
["gl_texture_gen_r",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.G.E.N_.R))",[0,[1,"GL_TEXTURE_GEN_R"]],["sgl/gl"]],
["gl_texture_gen_s",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.G.E.N_.S))",[0,[1,"GL_TEXTURE_GEN_S"]],["sgl/gl"]],
["gl_texture_gen_t",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.G.E.N_.T))",[0,[1,"GL_TEXTURE_GEN_T"]],["sgl/gl"]],
["gl_texture_green_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.G.R.E.E.N_.S.I.Z.E))",[0,[1,"GL_TEXTURE_GREEN_SIZE"]],["sgl/gl"]],
["gl_texture_height",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.H.E.I.G.H.T))",[0,[1,"GL_TEXTURE_HEIGHT"]],["sgl/gl"]],
["gl_texture_intensity_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.I.N.T.E.N.S.I.T.Y_.S.I.Z.E))",[0,[1,"GL_TEXTURE_INTENSITY_SIZE"]],["sgl/gl"]],
["gl_texture_internal_format",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.I.N.T.E.R.N.A.L_.F.O.R.M.A.T))",[0,[1,"GL_TEXTURE_INTERNAL_FORMAT"]],["sgl/gl"]],
["gl_texture_lod_bias",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.L.O.D_.B.I.A.S))",[0,[1,"GL_TEXTURE_LOD_BIAS"]],["sgl/gl"]],
["gl_texture_luminance_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.L.U.M.I.N.A.N.C.E_.S.I.Z.E))",[0,[1,"GL_TEXTURE_LUMINANCE_SIZE"]],["sgl/gl"]],
["gl_texture_mag_filter",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.M.A.G_.F.I.L.T.E.R))",[0,[1,"GL_TEXTURE_MAG_FILTER"]],["sgl/gl"]],
["gl_texture_matrix",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.M.A.T.R.I.X))",[0,[1,"GL_TEXTURE_MATRIX"]],["sgl/gl"]],
["gl_texture_max_level",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.M.A.X_.L.E.V.E.L))",[0,[1,"GL_TEXTURE_MAX_LEVEL"]],["sgl/gl"]],
["gl_texture_max_lod",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.M.A.X_.L.O.D))",[0,[1,"GL_TEXTURE_MAX_LOD"]],["sgl/gl"]],
["gl_texture_min_filter",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.M.I.N_.F.I.L.T.E.R))",[0,[1,"GL_TEXTURE_MIN_FILTER"]],["sgl/gl"]],
["gl_texture_min_lod",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.M.I.N_.L.O.D))",[0,[1,"GL_TEXTURE_MIN_LOD"]],["sgl/gl"]],
["gl_texture_priority",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.P.R.I.O.R.I.T.Y))",[0,[1,"GL_TEXTURE_PRIORITY"]],["sgl/gl"]],
["gl_texture_red_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.R.E.D_.S.I.Z.E))",[0,[1,"GL_TEXTURE_RED_SIZE"]],["sgl/gl"]],
["gl_texture_resident",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.R.E.S.I.D.E.N.T))",[0,[1,"GL_TEXTURE_RESIDENT"]],["sgl/gl"]],
["gl_texture_stack_depth",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.S.T.A.C.K_.D.E.P.T.H))",[0,[1,"GL_TEXTURE_STACK_DEPTH"]],["sgl/gl"]],
["gl_texture_width",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.W.I.D.T.H))",[0,[1,"GL_TEXTURE_WIDTH"]],["sgl/gl"]],
["gl_texture_wrap_r",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.W.R.A.P_.R))",[0,[1,"GL_TEXTURE_WRAP_R"]],["sgl/gl"]],
["gl_texture_wrap_s",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.W.R.A.P_.S))",[0,[1,"GL_TEXTURE_WRAP_S"]],["sgl/gl"]],
["gl_texture_wrap_t",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.E.X.T.U.R.E_.W.R.A.P_.T))",[0,[1,"GL_TEXTURE_WRAP_T"]],["sgl/gl"]],
["gl_transform_bit",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.R.A.N.S.F.O.R.M_.B.I.T))",[0,[1,"GL_TRANSFORM_BIT"]],["sgl/gl"]],
["gl_transpose_color_matrix",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.R.A.N.S.P.O.S.E_.C.O.L.O.R_.M.A.T.R.I.X))",[0,[1,"GL_TRANSPOSE_COLOR_MATRIX"]],["sgl/gl"]],
["gl_transpose_modelview_matrix",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.R.A.N.S.P.O.S.E_.M.O.D.E.L.V.I.E.W_.M.A.T.R.I.X))",[0,[1,"GL_TRANSPOSE_MODELVIEW_MATRIX"]],["sgl/gl"]],
["gl_transpose_projection_matrix",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.R.A.N.S.P.O.S.E_.P.R.O.J.E.C.T.I.O.N_.M.A.T.R.I.X))",[0,[1,"GL_TRANSPOSE_PROJECTION_MATRIX"]],["sgl/gl"]],
["gl_transpose_texture_matrix",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.R.A.N.S.P.O.S.E_.T.E.X.T.U.R.E_.M.A.T.R.I.X))",[0,[1,"GL_TRANSPOSE_TEXTURE_MATRIX"]],["sgl/gl"]],
["gl_triangle_fan",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.R.I.A.N.G.L.E_.F.A.N))",[0,[1,"GL_TRIANGLE_FAN"]],["sgl/gl"]],
["gl_triangle_strip",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.R.I.A.N.G.L.E_.S.T.R.I.P))",[0,[1,"GL_TRIANGLE_STRIP"]],["sgl/gl"]],
["gl_triangles",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.R.I.A.N.G.L.E.S))",[0,[1,"GL_TRIANGLES"]],["sgl/gl"]],
["gl_true",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.T.R.U.E))",[0,[1,"GL_TRUE"]],["sgl/gl"]],
["gl_true",">sgl/gl.html#(idx._(gentag._17._(lib._sgl/scribblings/sgl..scrbl)))",[5,"GL_TRUE"],false],
["gl_unpack_alignment",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.U.N.P.A.C.K_.A.L.I.G.N.M.E.N.T))",[0,[1,"GL_UNPACK_ALIGNMENT"]],["sgl/gl"]],
["gl_unpack_image_height",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.U.N.P.A.C.K_.I.M.A.G.E_.H.E.I.G.H.T))",[0,[1,"GL_UNPACK_IMAGE_HEIGHT"]],["sgl/gl"]],
["gl_unpack_lsb_first",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.U.N.P.A.C.K_.L.S.B_.F.I.R.S.T))",[0,[1,"GL_UNPACK_LSB_FIRST"]],["sgl/gl"]],
["gl_unpack_row_length",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.U.N.P.A.C.K_.R.O.W_.L.E.N.G.T.H))",[0,[1,"GL_UNPACK_ROW_LENGTH"]],["sgl/gl"]],
["gl_unpack_skip_images",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.U.N.P.A.C.K_.S.K.I.P_.I.M.A.G.E.S))",[0,[1,"GL_UNPACK_SKIP_IMAGES"]],["sgl/gl"]],
["gl_unpack_skip_pixels",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.U.N.P.A.C.K_.S.K.I.P_.P.I.X.E.L.S))",[0,[1,"GL_UNPACK_SKIP_PIXELS"]],["sgl/gl"]],
["gl_unpack_skip_rows",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.U.N.P.A.C.K_.S.K.I.P_.R.O.W.S))",[0,[1,"GL_UNPACK_SKIP_ROWS"]],["sgl/gl"]],
["gl_unpack_swap_bytes",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.U.N.P.A.C.K_.S.W.A.P_.B.Y.T.E.S))",[0,[1,"GL_UNPACK_SWAP_BYTES"]],["sgl/gl"]],
["gl_unsigned_byte",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.U.N.S.I.G.N.E.D_.B.Y.T.E))",[0,[1,"GL_UNSIGNED_BYTE"]],["sgl/gl"]],
["gl_unsigned_byte_2_3_3_rev",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.U.N.S.I.G.N.E.D_.B.Y.T.E_2_3_3_.R.E.V))",[0,[1,"GL_UNSIGNED_BYTE_2_3_3_REV"]],["sgl/gl"]],
["gl_unsigned_byte_3_3_2",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.U.N.S.I.G.N.E.D_.B.Y.T.E_3_3_2))",[0,[1,"GL_UNSIGNED_BYTE_3_3_2"]],["sgl/gl"]],
["gl_unsigned_int",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.U.N.S.I.G.N.E.D_.I.N.T))",[0,[1,"GL_UNSIGNED_INT"]],["sgl/gl"]],
["gl_unsigned_int_10_10_10_2",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.U.N.S.I.G.N.E.D_.I.N.T_10_10_10_2))",[0,[1,"GL_UNSIGNED_INT_10_10_10_2"]],["sgl/gl"]],
["gl_unsigned_int_2_10_10_10_rev",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.U.N.S.I.G.N.E.D_.I.N.T_2_10_10_10_.R.E.V))",[0,[1,"GL_UNSIGNED_INT_2_10_10_10_REV"]],["sgl/gl"]],
["gl_unsigned_int_8_8_8_8",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.U.N.S.I.G.N.E.D_.I.N.T_8_8_8_8))",[0,[1,"GL_UNSIGNED_INT_8_8_8_8"]],["sgl/gl"]],
["gl_unsigned_int_8_8_8_8_rev",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.U.N.S.I.G.N.E.D_.I.N.T_8_8_8_8_.R.E.V))",[0,[1,"GL_UNSIGNED_INT_8_8_8_8_REV"]],["sgl/gl"]],
["gl_unsigned_short",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.U.N.S.I.G.N.E.D_.S.H.O.R.T))",[0,[1,"GL_UNSIGNED_SHORT"]],["sgl/gl"]],
["gl_unsigned_short_1_5_5_5_rev",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.U.N.S.I.G.N.E.D_.S.H.O.R.T_1_5_5_5_.R.E.V))",[0,[1,"GL_UNSIGNED_SHORT_1_5_5_5_REV"]],["sgl/gl"]],
["gl_unsigned_short_4_4_4_4",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.U.N.S.I.G.N.E.D_.S.H.O.R.T_4_4_4_4))",[0,[1,"GL_UNSIGNED_SHORT_4_4_4_4"]],["sgl/gl"]],
["gl_unsigned_short_4_4_4_4_rev",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.U.N.S.I.G.N.E.D_.S.H.O.R.T_4_4_4_4_.R.E.V))",[0,[1,"GL_UNSIGNED_SHORT_4_4_4_4_REV"]],["sgl/gl"]],
["gl_unsigned_short_5_5_5_1",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.U.N.S.I.G.N.E.D_.S.H.O.R.T_5_5_5_1))",[0,[1,"GL_UNSIGNED_SHORT_5_5_5_1"]],["sgl/gl"]],
["gl_unsigned_short_5_6_5",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.U.N.S.I.G.N.E.D_.S.H.O.R.T_5_6_5))",[0,[1,"GL_UNSIGNED_SHORT_5_6_5"]],["sgl/gl"]],
["gl_unsigned_short_5_6_5_rev",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.U.N.S.I.G.N.E.D_.S.H.O.R.T_5_6_5_.R.E.V))",[0,[1,"GL_UNSIGNED_SHORT_5_6_5_REV"]],["sgl/gl"]],
["gl_v2f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.V2.F))",[0,[1,"GL_V2F"]],["sgl/gl"]],
["gl_v3f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.V3.F))",[0,[1,"GL_V3F"]],["sgl/gl"]],
["gl_vendor",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.V.E.N.D.O.R))",[0,[1,"GL_VENDOR"]],["sgl/gl"]],
["gl_version",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.V.E.R.S.I.O.N))",[0,[1,"GL_VERSION"]],["sgl/gl"]],
["gl_vertex_array",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.V.E.R.T.E.X_.A.R.R.A.Y))",[0,[1,"GL_VERTEX_ARRAY"]],["sgl/gl"]],
["gl_vertex_array_buffer_binding",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.V.E.R.T.E.X_.A.R.R.A.Y_.B.U.F.F.E.R_.B.I.N.D.I.N.G))",[0,[1,"GL_VERTEX_ARRAY_BUFFER_BINDING"]],["sgl/gl"]],
["gl_vertex_array_pointer",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.V.E.R.T.E.X_.A.R.R.A.Y_.P.O.I.N.T.E.R))",[0,[1,"GL_VERTEX_ARRAY_POINTER"]],["sgl/gl"]],
["gl_vertex_array_size",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.V.E.R.T.E.X_.A.R.R.A.Y_.S.I.Z.E))",[0,[1,"GL_VERTEX_ARRAY_SIZE"]],["sgl/gl"]],
["gl_vertex_array_stride",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.V.E.R.T.E.X_.A.R.R.A.Y_.S.T.R.I.D.E))",[0,[1,"GL_VERTEX_ARRAY_STRIDE"]],["sgl/gl"]],
["gl_vertex_array_type",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.V.E.R.T.E.X_.A.R.R.A.Y_.T.Y.P.E))",[0,[1,"GL_VERTEX_ARRAY_TYPE"]],["sgl/gl"]],
["gl_vertex_attrib_array_buffer_binding",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.V.E.R.T.E.X_.A.T.T.R.I.B_.A.R.R.A.Y_.B.U.F.F.E.R_.B.I.N.D.I.N.G))",[0,[1,"GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING"]],["sgl/gl"]],
["gl_viewport",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.V.I.E.W.P.O.R.T))",[0,[1,"GL_VIEWPORT"]],["sgl/gl"]],
["gl_viewport_bit",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.V.I.E.W.P.O.R.T_.B.I.T))",[0,[1,"GL_VIEWPORT_BIT"]],["sgl/gl"]],
["gl_weight_array_buffer_binding",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.W.E.I.G.H.T_.A.R.R.A.Y_.B.U.F.F.E.R_.B.I.N.D.I.N.G))",[0,[1,"GL_WEIGHT_ARRAY_BUFFER_BINDING"]],["sgl/gl"]],
["gl_write_only",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.W.R.I.T.E_.O.N.L.Y))",[0,[1,"GL_WRITE_ONLY"]],["sgl/gl"]],
["gl_xor",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.X.O.R))",[0,[1,"GL_XOR"]],["sgl/gl"]],
["gl_zero",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.Z.E.R.O))",[0,[1,"GL_ZERO"]],["sgl/gl"]],
["gl_zoom_x",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.Z.O.O.M_.X))",[0,[1,"GL_ZOOM_X"]],["sgl/gl"]],
["gl_zoom_y",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L_.Z.O.O.M_.Y))",[0,[1,"GL_ZOOM_Y"]],["sgl/gl"]],
["glaccum",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Accum))",[0,[1,"glAccum"]],["sgl/gl"]],
["glactivetexture",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Active.Texture))",[0,[1,"glActiveTexture"]],["sgl/gl"]],
["glalphafunc",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Alpha.Func))",[0,[1,"glAlphaFunc"]],["sgl/gl"]],
["glaretexturesresident",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Are.Textures.Resident))",[0,[1,"glAreTexturesResident"]],["sgl/gl"]],
["glbegin",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Begin))",[0,[1,"glBegin"]],["sgl/gl"]],
["glbeginquery",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Begin.Query))",[0,[1,"glBeginQuery"]],["sgl/gl"]],
["glbindtexture",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Bind.Texture))",[0,[1,"glBindTexture"]],["sgl/gl"]],
["glbitfield",">sgl/gl.html#(idx._(gentag._10._(lib._sgl/scribblings/sgl..scrbl)))",[5,"GLbitfield"],false],
["glbitmap",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Bitmap))",[0,[1,"glBitmap"]],["sgl/gl"]],
["glblendcolor",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Blend.Color))",[0,[1,"glBlendColor"]],["sgl/gl"]],
["glblendequation",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Blend.Equation))",[0,[1,"glBlendEquation"]],["sgl/gl"]],
["glblendfunc",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Blend.Func))",[0,[1,"glBlendFunc"]],["sgl/gl"]],
["glblendfuncseparate",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Blend.Func.Separate))",[0,[1,"glBlendFuncSeparate"]],["sgl/gl"]],
["glboolean",">sgl/gl.html#(idx._(gentag._15._(lib._sgl/scribblings/sgl..scrbl)))",[5,"GLboolean"],false],
["glbyte",">sgl/gl.html#(idx._(gentag._2._(lib._sgl/scribblings/sgl..scrbl)))",[5,"GLbyte"],false],
["glcalllist",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Call.List))",[0,[1,"glCallList"]],["sgl/gl"]],
["glcalllists",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Call.Lists))",[0,[1,"glCallLists"]],["sgl/gl"]],
["glclampd",">sgl/gl.html#(idx._(gentag._14._(lib._sgl/scribblings/sgl..scrbl)))",[5,"GLclampd"],false],
["glclear",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Clear))",[0,[1,"glClear"]],["sgl/gl"]],
["glclearaccum",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Clear.Accum))",[0,[1,"glClearAccum"]],["sgl/gl"]],
["glclearcolor",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Clear.Color))",[0,[1,"glClearColor"]],["sgl/gl"]],
["glcleardepth",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Clear.Depth))",[0,[1,"glClearDepth"]],["sgl/gl"]],
["glclearindex",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Clear.Index))",[0,[1,"glClearIndex"]],["sgl/gl"]],
["glclearstencil",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Clear.Stencil))",[0,[1,"glClearStencil"]],["sgl/gl"]],
["glclipplane",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Clip.Plane))",[0,[1,"glClipPlane"]],["sgl/gl"]],
["glcolor3b",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color3b))",[0,[1,"glColor3b"]],["sgl/gl"]],
["glcolor3bv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color3bv))",[0,[1,"glColor3bv"]],["sgl/gl"]],
["glcolor3d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color3d))",[0,[1,"glColor3d"]],["sgl/gl"]],
["glcolor3dv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color3dv))",[0,[1,"glColor3dv"]],["sgl/gl"]],
["glcolor3f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color3f))",[0,[1,"glColor3f"]],["sgl/gl"]],
["glcolor3fv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color3fv))",[0,[1,"glColor3fv"]],["sgl/gl"]],
["glcolor3i",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color3i))",[0,[1,"glColor3i"]],["sgl/gl"]],
["glcolor3iv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color3iv))",[0,[1,"glColor3iv"]],["sgl/gl"]],
["glcolor3s",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color3s))",[0,[1,"glColor3s"]],["sgl/gl"]],
["glcolor3sv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color3sv))",[0,[1,"glColor3sv"]],["sgl/gl"]],
["glcolor3ub",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color3ub))",[0,[1,"glColor3ub"]],["sgl/gl"]],
["glcolor3ubv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color3ubv))",[0,[1,"glColor3ubv"]],["sgl/gl"]],
["glcolor3ui",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color3ui))",[0,[1,"glColor3ui"]],["sgl/gl"]],
["glcolor3uiv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color3uiv))",[0,[1,"glColor3uiv"]],["sgl/gl"]],
["glcolor3us",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color3us))",[0,[1,"glColor3us"]],["sgl/gl"]],
["glcolor3usv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color3usv))",[0,[1,"glColor3usv"]],["sgl/gl"]],
["glcolor4b",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color4b))",[0,[1,"glColor4b"]],["sgl/gl"]],
["glcolor4bv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color4bv))",[0,[1,"glColor4bv"]],["sgl/gl"]],
["glcolor4d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color4d))",[0,[1,"glColor4d"]],["sgl/gl"]],
["glcolor4dv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color4dv))",[0,[1,"glColor4dv"]],["sgl/gl"]],
["glcolor4f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color4f))",[0,[1,"glColor4f"]],["sgl/gl"]],
["glcolor4fv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color4fv))",[0,[1,"glColor4fv"]],["sgl/gl"]],
["glcolor4i",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color4i))",[0,[1,"glColor4i"]],["sgl/gl"]],
["glcolor4iv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color4iv))",[0,[1,"glColor4iv"]],["sgl/gl"]],
["glcolor4s",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color4s))",[0,[1,"glColor4s"]],["sgl/gl"]],
["glcolor4sv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color4sv))",[0,[1,"glColor4sv"]],["sgl/gl"]],
["glcolor4ub",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color4ub))",[0,[1,"glColor4ub"]],["sgl/gl"]],
["glcolor4ubv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color4ubv))",[0,[1,"glColor4ubv"]],["sgl/gl"]],
["glcolor4ui",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color4ui))",[0,[1,"glColor4ui"]],["sgl/gl"]],
["glcolor4uiv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color4uiv))",[0,[1,"glColor4uiv"]],["sgl/gl"]],
["glcolor4us",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color4us))",[0,[1,"glColor4us"]],["sgl/gl"]],
["glcolor4usv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color4usv))",[0,[1,"glColor4usv"]],["sgl/gl"]],
["glcolormask",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color.Mask))",[0,[1,"glColorMask"]],["sgl/gl"]],
["glcolormaterial",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color.Material))",[0,[1,"glColorMaterial"]],["sgl/gl"]],
["glcolorsubtable",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color.Sub.Table))",[0,[1,"glColorSubTable"]],["sgl/gl"]],
["glcolortable",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color.Table))",[0,[1,"glColorTable"]],["sgl/gl"]],
["glcolortableparameterfv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color.Table.Parameterfv))",[0,[1,"glColorTableParameterfv"]],["sgl/gl"]],
["glcolortableparameteriv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Color.Table.Parameteriv))",[0,[1,"glColorTableParameteriv"]],["sgl/gl"]],
["glcompressedteximage1d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Compressed.Tex.Image1.D))",[0,[1,"glCompressedTexImage1D"]],["sgl/gl"]],
["glcompressedteximage2d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Compressed.Tex.Image2.D))",[0,[1,"glCompressedTexImage2D"]],["sgl/gl"]],
["glcompressedteximage3d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Compressed.Tex.Image3.D))",[0,[1,"glCompressedTexImage3D"]],["sgl/gl"]],
["glcompressedtexsubimage1d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Compressed.Tex.Sub.Image1.D))",[0,[1,"glCompressedTexSubImage1D"]],["sgl/gl"]],
["glcompressedtexsubimage2d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Compressed.Tex.Sub.Image2.D))",[0,[1,"glCompressedTexSubImage2D"]],["sgl/gl"]],
["glcompressedtexsubimage3d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Compressed.Tex.Sub.Image3.D))",[0,[1,"glCompressedTexSubImage3D"]],["sgl/gl"]],
["glconvolutionfilter1d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Convolution.Filter1.D))",[0,[1,"glConvolutionFilter1D"]],["sgl/gl"]],
["glconvolutionfilter2d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Convolution.Filter2.D))",[0,[1,"glConvolutionFilter2D"]],["sgl/gl"]],
["glconvolutionparameterf",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Convolution.Parameterf))",[0,[1,"glConvolutionParameterf"]],["sgl/gl"]],
["glconvolutionparameterfv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Convolution.Parameterfv))",[0,[1,"glConvolutionParameterfv"]],["sgl/gl"]],
["glconvolutionparameteri",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Convolution.Parameteri))",[0,[1,"glConvolutionParameteri"]],["sgl/gl"]],
["glconvolutionparameteriv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Convolution.Parameteriv))",[0,[1,"glConvolutionParameteriv"]],["sgl/gl"]],
["glcopycolorsubtable",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Copy.Color.Sub.Table))",[0,[1,"glCopyColorSubTable"]],["sgl/gl"]],
["glcopycolortable",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Copy.Color.Table))",[0,[1,"glCopyColorTable"]],["sgl/gl"]],
["glcopyconvolutionfilter1d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Copy.Convolution.Filter1.D))",[0,[1,"glCopyConvolutionFilter1D"]],["sgl/gl"]],
["glcopyconvolutionfilter2d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Copy.Convolution.Filter2.D))",[0,[1,"glCopyConvolutionFilter2D"]],["sgl/gl"]],
["glcopypixels",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Copy.Pixels))",[0,[1,"glCopyPixels"]],["sgl/gl"]],
["glcopyteximage1d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Copy.Tex.Image1.D))",[0,[1,"glCopyTexImage1D"]],["sgl/gl"]],
["glcopyteximage2d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Copy.Tex.Image2.D))",[0,[1,"glCopyTexImage2D"]],["sgl/gl"]],
["glcopytexsubimage1d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Copy.Tex.Sub.Image1.D))",[0,[1,"glCopyTexSubImage1D"]],["sgl/gl"]],
["glcopytexsubimage2d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Copy.Tex.Sub.Image2.D))",[0,[1,"glCopyTexSubImage2D"]],["sgl/gl"]],
["glcopytexsubimage3d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Copy.Tex.Sub.Image3.D))",[0,[1,"glCopyTexSubImage3D"]],["sgl/gl"]],
["glcullface",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Cull.Face))",[0,[1,"glCullFace"]],["sgl/gl"]],
["gldeletelists",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Delete.Lists))",[0,[1,"glDeleteLists"]],["sgl/gl"]],
["gldeletequeries",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Delete.Queries))",[0,[1,"glDeleteQueries"]],["sgl/gl"]],
["gldeletetextures",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Delete.Textures))",[0,[1,"glDeleteTextures"]],["sgl/gl"]],
["gldepthfunc",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Depth.Func))",[0,[1,"glDepthFunc"]],["sgl/gl"]],
["gldepthmask",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Depth.Mask))",[0,[1,"glDepthMask"]],["sgl/gl"]],
["gldepthrange",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Depth.Range))",[0,[1,"glDepthRange"]],["sgl/gl"]],
["gldisable",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Disable))",[0,[1,"glDisable"]],["sgl/gl"]],
["gldouble",">sgl/gl.html#(idx._(gentag._12._(lib._sgl/scribblings/sgl..scrbl)))",[5,"GLdouble"],false],
["gldrawbuffer",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Draw.Buffer))",[0,[1,"glDrawBuffer"]],["sgl/gl"]],
["gldrawpixels",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Draw.Pixels))",[0,[1,"glDrawPixels"]],["sgl/gl"]],
["gledgeflag",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Edge.Flag))",[0,[1,"glEdgeFlag"]],["sgl/gl"]],
["gledgeflagv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Edge.Flagv))",[0,[1,"glEdgeFlagv"]],["sgl/gl"]],
["glenable",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Enable))",[0,[1,"glEnable"]],["sgl/gl"]],
["glend",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.End))",[0,[1,"glEnd"]],["sgl/gl"]],
["glendlist",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.End.List))",[0,[1,"glEndList"]],["sgl/gl"]],
["glendquery",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.End.Query))",[0,[1,"glEndQuery"]],["sgl/gl"]],
["glenum",">sgl/gl.html#(idx._(gentag._9._(lib._sgl/scribblings/sgl..scrbl)))",[5,"GLenum"],false],
["glevalcoord1d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Eval.Coord1d))",[0,[1,"glEvalCoord1d"]],["sgl/gl"]],
["glevalcoord1dv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Eval.Coord1dv))",[0,[1,"glEvalCoord1dv"]],["sgl/gl"]],
["glevalcoord1f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Eval.Coord1f))",[0,[1,"glEvalCoord1f"]],["sgl/gl"]],
["glevalcoord1fv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Eval.Coord1fv))",[0,[1,"glEvalCoord1fv"]],["sgl/gl"]],
["glevalcoord2d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Eval.Coord2d))",[0,[1,"glEvalCoord2d"]],["sgl/gl"]],
["glevalcoord2dv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Eval.Coord2dv))",[0,[1,"glEvalCoord2dv"]],["sgl/gl"]],
["glevalcoord2f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Eval.Coord2f))",[0,[1,"glEvalCoord2f"]],["sgl/gl"]],
["glevalcoord2fv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Eval.Coord2fv))",[0,[1,"glEvalCoord2fv"]],["sgl/gl"]],
["glevalmesh1",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Eval.Mesh1))",[0,[1,"glEvalMesh1"]],["sgl/gl"]],
["glevalmesh2",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Eval.Mesh2))",[0,[1,"glEvalMesh2"]],["sgl/gl"]],
["glevalpoint1",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Eval.Point1))",[0,[1,"glEvalPoint1"]],["sgl/gl"]],
["glevalpoint2",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Eval.Point2))",[0,[1,"glEvalPoint2"]],["sgl/gl"]],
["glfeedbackbuffer",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Feedback.Buffer))",[0,[1,"glFeedbackBuffer"]],["sgl/gl"]],
["glfinish",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Finish))",[0,[1,"glFinish"]],["sgl/gl"]],
["glflush",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Flush))",[0,[1,"glFlush"]],["sgl/gl"]],
["glfogcoordd",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Fog.Coordd))",[0,[1,"glFogCoordd"]],["sgl/gl"]],
["glfogcoorddv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Fog.Coorddv))",[0,[1,"glFogCoorddv"]],["sgl/gl"]],
["glfogcoordf",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Fog.Coordf))",[0,[1,"glFogCoordf"]],["sgl/gl"]],
["glfogcoordfv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Fog.Coordfv))",[0,[1,"glFogCoordfv"]],["sgl/gl"]],
["glfogf",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Fogf))",[0,[1,"glFogf"]],["sgl/gl"]],
["glfogfv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Fogfv))",[0,[1,"glFogfv"]],["sgl/gl"]],
["glfogi",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Fogi))",[0,[1,"glFogi"]],["sgl/gl"]],
["glfogiv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Fogiv))",[0,[1,"glFogiv"]],["sgl/gl"]],
["glfrontface",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Front.Face))",[0,[1,"glFrontFace"]],["sgl/gl"]],
["glfrustum",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Frustum))",[0,[1,"glFrustum"]],["sgl/gl"]],
["glgenlists",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Gen.Lists))",[0,[1,"glGenLists"]],["sgl/gl"]],
["glgenqueries",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Gen.Queries))",[0,[1,"glGenQueries"]],["sgl/gl"]],
["glgentextures",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Gen.Textures))",[0,[1,"glGenTextures"]],["sgl/gl"]],
["glgetbooleanv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Booleanv))",[0,[1,"glGetBooleanv"]],["sgl/gl"]],
["glgetbufferparameteriv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Buffer.Parameteriv))",[0,[1,"glGetBufferParameteriv"]],["sgl/gl"]],
["glgetclipplane",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Clip.Plane))",[0,[1,"glGetClipPlane"]],["sgl/gl"]],
["glgetcolortable",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Color.Table))",[0,[1,"glGetColorTable"]],["sgl/gl"]],
["glgetcompressedteximage",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Compressed.Tex.Image))",[0,[1,"glGetCompressedTexImage"]],["sgl/gl"]],
["glgetconvolutionfilter",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Convolution.Filter))",[0,[1,"glGetConvolutionFilter"]],["sgl/gl"]],
["glgetconvolutionparameterfv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Convolution.Parameterfv))",[0,[1,"glGetConvolutionParameterfv"]],["sgl/gl"]],
["glgetconvolutionparameteriv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Convolution.Parameteriv))",[0,[1,"glGetConvolutionParameteriv"]],["sgl/gl"]],
["glgetdoublev",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Doublev))",[0,[1,"glGetDoublev"]],["sgl/gl"]],
["glgeterror",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Error))",[0,[1,"glGetError"]],["sgl/gl"]],
["glgetfloatv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Floatv))",[0,[1,"glGetFloatv"]],["sgl/gl"]],
["glgethistogram",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Histogram))",[0,[1,"glGetHistogram"]],["sgl/gl"]],
["glgethistogramparameterfv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Histogram.Parameterfv))",[0,[1,"glGetHistogramParameterfv"]],["sgl/gl"]],
["glgethistogramparameteriv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Histogram.Parameteriv))",[0,[1,"glGetHistogramParameteriv"]],["sgl/gl"]],
["glgetintegerv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Integerv))",[0,[1,"glGetIntegerv"]],["sgl/gl"]],
["glgetlightfv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Lightfv))",[0,[1,"glGetLightfv"]],["sgl/gl"]],
["glgetlightiv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Lightiv))",[0,[1,"glGetLightiv"]],["sgl/gl"]],
["glgetmapdv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Mapdv))",[0,[1,"glGetMapdv"]],["sgl/gl"]],
["glgetmapfv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Mapfv))",[0,[1,"glGetMapfv"]],["sgl/gl"]],
["glgetmapiv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Mapiv))",[0,[1,"glGetMapiv"]],["sgl/gl"]],
["glgetmaterialfv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Materialfv))",[0,[1,"glGetMaterialfv"]],["sgl/gl"]],
["glgetmaterialiv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Materialiv))",[0,[1,"glGetMaterialiv"]],["sgl/gl"]],
["glgetminmax",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Minmax))",[0,[1,"glGetMinmax"]],["sgl/gl"]],
["glgetminmaxparameterfv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Minmax.Parameterfv))",[0,[1,"glGetMinmaxParameterfv"]],["sgl/gl"]],
["glgetminmaxparameteriv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Minmax.Parameteriv))",[0,[1,"glGetMinmaxParameteriv"]],["sgl/gl"]],
["glgetpixelmapfv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Pixel.Mapfv))",[0,[1,"glGetPixelMapfv"]],["sgl/gl"]],
["glgetpixelmapuiv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Pixel.Mapuiv))",[0,[1,"glGetPixelMapuiv"]],["sgl/gl"]],
["glgetpixelmapusv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Pixel.Mapusv))",[0,[1,"glGetPixelMapusv"]],["sgl/gl"]],
["glgetpolygonstipple",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Polygon.Stipple))",[0,[1,"glGetPolygonStipple"]],["sgl/gl"]],
["glgetqueryiv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Queryiv))",[0,[1,"glGetQueryiv"]],["sgl/gl"]],
["glgetqueryobjectiv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Query.Objectiv))",[0,[1,"glGetQueryObjectiv"]],["sgl/gl"]],
["glgetqueryobjectuiv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Query.Objectuiv))",[0,[1,"glGetQueryObjectuiv"]],["sgl/gl"]],
["glgetseparablefilter",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Separable.Filter))",[0,[1,"glGetSeparableFilter"]],["sgl/gl"]],
["glgetstring",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.String))",[0,[1,"glGetString"]],["sgl/gl"]],
["glgettexenvfv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Tex.Envfv))",[0,[1,"glGetTexEnvfv"]],["sgl/gl"]],
["glgettexenviv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Tex.Enviv))",[0,[1,"glGetTexEnviv"]],["sgl/gl"]],
["glgettexgendv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Tex.Gendv))",[0,[1,"glGetTexGendv"]],["sgl/gl"]],
["glgettexgenfv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Tex.Genfv))",[0,[1,"glGetTexGenfv"]],["sgl/gl"]],
["glgettexgeniv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Tex.Geniv))",[0,[1,"glGetTexGeniv"]],["sgl/gl"]],
["glgetteximage",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Tex.Image))",[0,[1,"glGetTexImage"]],["sgl/gl"]],
["glgettexlevelparameterfv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Tex.Level.Parameterfv))",[0,[1,"glGetTexLevelParameterfv"]],["sgl/gl"]],
["glgettexlevelparameteriv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Tex.Level.Parameteriv))",[0,[1,"glGetTexLevelParameteriv"]],["sgl/gl"]],
["glgettexparameterfv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Tex.Parameterfv))",[0,[1,"glGetTexParameterfv"]],["sgl/gl"]],
["glgettexparameteriv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Get.Tex.Parameteriv))",[0,[1,"glGetTexParameteriv"]],["sgl/gl"]],
["glhint",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Hint))",[0,[1,"glHint"]],["sgl/gl"]],
["glhistogram",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Histogram))",[0,[1,"glHistogram"]],["sgl/gl"]],
["glindexd",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Indexd))",[0,[1,"glIndexd"]],["sgl/gl"]],
["glindexdv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Indexdv))",[0,[1,"glIndexdv"]],["sgl/gl"]],
["glindexf",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Indexf))",[0,[1,"glIndexf"]],["sgl/gl"]],
["glindexfv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Indexfv))",[0,[1,"glIndexfv"]],["sgl/gl"]],
["glindexi",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Indexi))",[0,[1,"glIndexi"]],["sgl/gl"]],
["glindexiv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Indexiv))",[0,[1,"glIndexiv"]],["sgl/gl"]],
["glindexmask",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Index.Mask))",[0,[1,"glIndexMask"]],["sgl/gl"]],
["glindexs",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Indexs))",[0,[1,"glIndexs"]],["sgl/gl"]],
["glindexsv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Indexsv))",[0,[1,"glIndexsv"]],["sgl/gl"]],
["glindexub",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Indexub))",[0,[1,"glIndexub"]],["sgl/gl"]],
["glindexubv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Indexubv))",[0,[1,"glIndexubv"]],["sgl/gl"]],
["glinitnames",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Init.Names))",[0,[1,"glInitNames"]],["sgl/gl"]],
["glint",">sgl/gl.html#(idx._(gentag._4._(lib._sgl/scribblings/sgl..scrbl)))",[5,"GLint"],false],
["glisbuffer",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Is.Buffer))",[0,[1,"glIsBuffer"]],["sgl/gl"]],
["glisenabled",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Is.Enabled))",[0,[1,"glIsEnabled"]],["sgl/gl"]],
["glislist",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Is.List))",[0,[1,"glIsList"]],["sgl/gl"]],
["glisquery",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Is.Query))",[0,[1,"glIsQuery"]],["sgl/gl"]],
["glistexture",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Is.Texture))",[0,[1,"glIsTexture"]],["sgl/gl"]],
["gllightf",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Lightf))",[0,[1,"glLightf"]],["sgl/gl"]],
["gllightfv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Lightfv))",[0,[1,"glLightfv"]],["sgl/gl"]],
["gllighti",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Lighti))",[0,[1,"glLighti"]],["sgl/gl"]],
["gllightiv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Lightiv))",[0,[1,"glLightiv"]],["sgl/gl"]],
["gllightmodelf",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Light.Modelf))",[0,[1,"glLightModelf"]],["sgl/gl"]],
["gllightmodelfv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Light.Modelfv))",[0,[1,"glLightModelfv"]],["sgl/gl"]],
["gllightmodeli",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Light.Modeli))",[0,[1,"glLightModeli"]],["sgl/gl"]],
["gllightmodeliv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Light.Modeliv))",[0,[1,"glLightModeliv"]],["sgl/gl"]],
["gllinestipple",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Line.Stipple))",[0,[1,"glLineStipple"]],["sgl/gl"]],
["gllinewidth",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Line.Width))",[0,[1,"glLineWidth"]],["sgl/gl"]],
["gllistbase",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.List.Base))",[0,[1,"glListBase"]],["sgl/gl"]],
["glloadidentity",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Load.Identity))",[0,[1,"glLoadIdentity"]],["sgl/gl"]],
["glloadmatrixd",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Load.Matrixd))",[0,[1,"glLoadMatrixd"]],["sgl/gl"]],
["glloadmatrixf",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Load.Matrixf))",[0,[1,"glLoadMatrixf"]],["sgl/gl"]],
["glloadname",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Load.Name))",[0,[1,"glLoadName"]],["sgl/gl"]],
["glloadtransposematrixd",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Load.Transpose.Matrixd))",[0,[1,"glLoadTransposeMatrixd"]],["sgl/gl"]],
["glloadtransposematrixf",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Load.Transpose.Matrixf))",[0,[1,"glLoadTransposeMatrixf"]],["sgl/gl"]],
["gllogicop",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Logic.Op))",[0,[1,"glLogicOp"]],["sgl/gl"]],
["glmap1d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Map1d))",[0,[1,"glMap1d"]],["sgl/gl"]],
["glmap1f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Map1f))",[0,[1,"glMap1f"]],["sgl/gl"]],
["glmap2d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Map2d))",[0,[1,"glMap2d"]],["sgl/gl"]],
["glmap2f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Map2f))",[0,[1,"glMap2f"]],["sgl/gl"]],
["glmapgrid1d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Map.Grid1d))",[0,[1,"glMapGrid1d"]],["sgl/gl"]],
["glmapgrid1f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Map.Grid1f))",[0,[1,"glMapGrid1f"]],["sgl/gl"]],
["glmapgrid2d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Map.Grid2d))",[0,[1,"glMapGrid2d"]],["sgl/gl"]],
["glmapgrid2f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Map.Grid2f))",[0,[1,"glMapGrid2f"]],["sgl/gl"]],
["glmaterialf",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Materialf))",[0,[1,"glMaterialf"]],["sgl/gl"]],
["glmaterialfv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Materialfv))",[0,[1,"glMaterialfv"]],["sgl/gl"]],
["glmateriali",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Materiali))",[0,[1,"glMateriali"]],["sgl/gl"]],
["glmaterialiv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Materialiv))",[0,[1,"glMaterialiv"]],["sgl/gl"]],
["glmatrixmode",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Matrix.Mode))",[0,[1,"glMatrixMode"]],["sgl/gl"]],
["glminmax",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Minmax))",[0,[1,"glMinmax"]],["sgl/gl"]],
["glmultitexcoord1d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord1d))",[0,[1,"glMultiTexCoord1d"]],["sgl/gl"]],
["glmultitexcoord1dv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord1dv))",[0,[1,"glMultiTexCoord1dv"]],["sgl/gl"]],
["glmultitexcoord1f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord1f))",[0,[1,"glMultiTexCoord1f"]],["sgl/gl"]],
["glmultitexcoord1fv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord1fv))",[0,[1,"glMultiTexCoord1fv"]],["sgl/gl"]],
["glmultitexcoord1i",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord1i))",[0,[1,"glMultiTexCoord1i"]],["sgl/gl"]],
["glmultitexcoord1iv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord1iv))",[0,[1,"glMultiTexCoord1iv"]],["sgl/gl"]],
["glmultitexcoord1s",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord1s))",[0,[1,"glMultiTexCoord1s"]],["sgl/gl"]],
["glmultitexcoord1sv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord1sv))",[0,[1,"glMultiTexCoord1sv"]],["sgl/gl"]],
["glmultitexcoord2d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord2d))",[0,[1,"glMultiTexCoord2d"]],["sgl/gl"]],
["glmultitexcoord2dv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord2dv))",[0,[1,"glMultiTexCoord2dv"]],["sgl/gl"]],
["glmultitexcoord2f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord2f))",[0,[1,"glMultiTexCoord2f"]],["sgl/gl"]],
["glmultitexcoord2fv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord2fv))",[0,[1,"glMultiTexCoord2fv"]],["sgl/gl"]],
["glmultitexcoord2i",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord2i))",[0,[1,"glMultiTexCoord2i"]],["sgl/gl"]],
["glmultitexcoord2iv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord2iv))",[0,[1,"glMultiTexCoord2iv"]],["sgl/gl"]],
["glmultitexcoord2s",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord2s))",[0,[1,"glMultiTexCoord2s"]],["sgl/gl"]],
["glmultitexcoord2sv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord2sv))",[0,[1,"glMultiTexCoord2sv"]],["sgl/gl"]],
["glmultitexcoord3d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord3d))",[0,[1,"glMultiTexCoord3d"]],["sgl/gl"]],
["glmultitexcoord3dv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord3dv))",[0,[1,"glMultiTexCoord3dv"]],["sgl/gl"]],
["glmultitexcoord3f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord3f))",[0,[1,"glMultiTexCoord3f"]],["sgl/gl"]],
["glmultitexcoord3fv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord3fv))",[0,[1,"glMultiTexCoord3fv"]],["sgl/gl"]],
["glmultitexcoord3i",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord3i))",[0,[1,"glMultiTexCoord3i"]],["sgl/gl"]],
["glmultitexcoord3iv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord3iv))",[0,[1,"glMultiTexCoord3iv"]],["sgl/gl"]],
["glmultitexcoord3s",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord3s))",[0,[1,"glMultiTexCoord3s"]],["sgl/gl"]],
["glmultitexcoord3sv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord3sv))",[0,[1,"glMultiTexCoord3sv"]],["sgl/gl"]],
["glmultitexcoord4d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord4d))",[0,[1,"glMultiTexCoord4d"]],["sgl/gl"]],
["glmultitexcoord4dv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord4dv))",[0,[1,"glMultiTexCoord4dv"]],["sgl/gl"]],
["glmultitexcoord4f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord4f))",[0,[1,"glMultiTexCoord4f"]],["sgl/gl"]],
["glmultitexcoord4fv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord4fv))",[0,[1,"glMultiTexCoord4fv"]],["sgl/gl"]],
["glmultitexcoord4i",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord4i))",[0,[1,"glMultiTexCoord4i"]],["sgl/gl"]],
["glmultitexcoord4iv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord4iv))",[0,[1,"glMultiTexCoord4iv"]],["sgl/gl"]],
["glmultitexcoord4s",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord4s))",[0,[1,"glMultiTexCoord4s"]],["sgl/gl"]],
["glmultitexcoord4sv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Multi.Tex.Coord4sv))",[0,[1,"glMultiTexCoord4sv"]],["sgl/gl"]],
["glmultmatrixd",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Mult.Matrixd))",[0,[1,"glMultMatrixd"]],["sgl/gl"]],
["glmultmatrixf",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Mult.Matrixf))",[0,[1,"glMultMatrixf"]],["sgl/gl"]],
["glmulttransposematrixd",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Mult.Transpose.Matrixd))",[0,[1,"glMultTransposeMatrixd"]],["sgl/gl"]],
["glmulttransposematrixf",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Mult.Transpose.Matrixf))",[0,[1,"glMultTransposeMatrixf"]],["sgl/gl"]],
["glnewlist",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.New.List))",[0,[1,"glNewList"]],["sgl/gl"]],
["glnormal3b",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Normal3b))",[0,[1,"glNormal3b"]],["sgl/gl"]],
["glnormal3bv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Normal3bv))",[0,[1,"glNormal3bv"]],["sgl/gl"]],
["glnormal3d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Normal3d))",[0,[1,"glNormal3d"]],["sgl/gl"]],
["glnormal3dv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Normal3dv))",[0,[1,"glNormal3dv"]],["sgl/gl"]],
["glnormal3f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Normal3f))",[0,[1,"glNormal3f"]],["sgl/gl"]],
["glnormal3fv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Normal3fv))",[0,[1,"glNormal3fv"]],["sgl/gl"]],
["glnormal3i",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Normal3i))",[0,[1,"glNormal3i"]],["sgl/gl"]],
["glnormal3iv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Normal3iv))",[0,[1,"glNormal3iv"]],["sgl/gl"]],
["glnormal3s",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Normal3s))",[0,[1,"glNormal3s"]],["sgl/gl"]],
["glnormal3sv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Normal3sv))",[0,[1,"glNormal3sv"]],["sgl/gl"]],
["glob->regexp",">mzlib/mzlib_string.html#(def._((lib._mzlib/string..ss)._glob-~3eregexp))",[0,[1,"glob-&gt;regexp"]],["mzlib/string"]],
["global constants",">inside/im_values_types.html#(part._.Global_.Constants)","Global Constants",false],
["global coordinates",">gui/window___.html#(idx._(gentag._141._(lib._scribblings/gui/gui..scrbl)))","global coordinates",false],
["global coordinates",">gui/window___.html#(idx._(gentag._145._(lib._scribblings/gui/gui..scrbl)))","global coordinates",false],
["global data: headers and footers",">gui/editor-overview.html#(part._globaleditordata)","Global Data: Headers and Footers",false],
["global graphics",">gui/Drawing_Functions.html#(part._.Global_.Graphics)","Global Graphics",false],
["global port print handler",">reference/Writing.html#(tech._global._port._print._handler)","<i>global port print handler</i>",false],
["global-port-print-handler",">reference/Writing.html#(def._((quote._~23~25kernel)._global-port-print-handler))",[0,[1,"global-port-print-handler"]],["scheme/base","scheme"]],
["global-to-local",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._global-to-local))",[[0,[1,"global-to-local"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["globals in extension code",">inside/im_memoryalloc.html#(idx._(gentag._202._(lib._scribblings/inside/inside..scrbl)))","globals, in extension code",false],
["globals",">inside/im_env.html#(idx._(gentag._238._(lib._scribblings/inside/inside..scrbl)))","globals",false],
["glortho",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Ortho))",[0,[1,"glOrtho"]],["sgl/gl"]],
["glpassthrough",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Pass.Through))",[0,[1,"glPassThrough"]],["sgl/gl"]],
["glpixelmapfv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Pixel.Mapfv))",[0,[1,"glPixelMapfv"]],["sgl/gl"]],
["glpixelmapuiv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Pixel.Mapuiv))",[0,[1,"glPixelMapuiv"]],["sgl/gl"]],
["glpixelmapusv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Pixel.Mapusv))",[0,[1,"glPixelMapusv"]],["sgl/gl"]],
["glpixelstoref",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Pixel.Storef))",[0,[1,"glPixelStoref"]],["sgl/gl"]],
["glpixelstorei",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Pixel.Storei))",[0,[1,"glPixelStorei"]],["sgl/gl"]],
["glpixeltransferf",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Pixel.Transferf))",[0,[1,"glPixelTransferf"]],["sgl/gl"]],
["glpixeltransferi",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Pixel.Transferi))",[0,[1,"glPixelTransferi"]],["sgl/gl"]],
["glpixelzoom",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Pixel.Zoom))",[0,[1,"glPixelZoom"]],["sgl/gl"]],
["glpointparameterf",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Point.Parameterf))",[0,[1,"glPointParameterf"]],["sgl/gl"]],
["glpointparameterfv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Point.Parameterfv))",[0,[1,"glPointParameterfv"]],["sgl/gl"]],
["glpointparameteri",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Point.Parameteri))",[0,[1,"glPointParameteri"]],["sgl/gl"]],
["glpointparameteriv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Point.Parameteriv))",[0,[1,"glPointParameteriv"]],["sgl/gl"]],
["glpointsize",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Point.Size))",[0,[1,"glPointSize"]],["sgl/gl"]],
["glpolygonmode",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Polygon.Mode))",[0,[1,"glPolygonMode"]],["sgl/gl"]],
["glpolygonoffset",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Polygon.Offset))",[0,[1,"glPolygonOffset"]],["sgl/gl"]],
["glpolygonstipple",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Polygon.Stipple))",[0,[1,"glPolygonStipple"]],["sgl/gl"]],
["glpopattrib",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Pop.Attrib))",[0,[1,"glPopAttrib"]],["sgl/gl"]],
["glpopclientattrib",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Pop.Client.Attrib))",[0,[1,"glPopClientAttrib"]],["sgl/gl"]],
["glpopmatrix",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Pop.Matrix))",[0,[1,"glPopMatrix"]],["sgl/gl"]],
["glpopname",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Pop.Name))",[0,[1,"glPopName"]],["sgl/gl"]],
["glpushattrib",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Push.Attrib))",[0,[1,"glPushAttrib"]],["sgl/gl"]],
["glpushclientattrib",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Push.Client.Attrib))",[0,[1,"glPushClientAttrib"]],["sgl/gl"]],
["glpushmatrix",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Push.Matrix))",[0,[1,"glPushMatrix"]],["sgl/gl"]],
["glpushname",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Push.Name))",[0,[1,"glPushName"]],["sgl/gl"]],
["glrasterpos2d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Raster.Pos2d))",[0,[1,"glRasterPos2d"]],["sgl/gl"]],
["glrasterpos2dv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Raster.Pos2dv))",[0,[1,"glRasterPos2dv"]],["sgl/gl"]],
["glrasterpos2f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Raster.Pos2f))",[0,[1,"glRasterPos2f"]],["sgl/gl"]],
["glrasterpos2fv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Raster.Pos2fv))",[0,[1,"glRasterPos2fv"]],["sgl/gl"]],
["glrasterpos2i",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Raster.Pos2i))",[0,[1,"glRasterPos2i"]],["sgl/gl"]],
["glrasterpos2iv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Raster.Pos2iv))",[0,[1,"glRasterPos2iv"]],["sgl/gl"]],
["glrasterpos2s",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Raster.Pos2s))",[0,[1,"glRasterPos2s"]],["sgl/gl"]],
["glrasterpos2sv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Raster.Pos2sv))",[0,[1,"glRasterPos2sv"]],["sgl/gl"]],
["glrasterpos3d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Raster.Pos3d))",[0,[1,"glRasterPos3d"]],["sgl/gl"]],
["glrasterpos3dv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Raster.Pos3dv))",[0,[1,"glRasterPos3dv"]],["sgl/gl"]],
["glrasterpos3f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Raster.Pos3f))",[0,[1,"glRasterPos3f"]],["sgl/gl"]],
["glrasterpos3fv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Raster.Pos3fv))",[0,[1,"glRasterPos3fv"]],["sgl/gl"]],
["glrasterpos3i",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Raster.Pos3i))",[0,[1,"glRasterPos3i"]],["sgl/gl"]],
["glrasterpos3iv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Raster.Pos3iv))",[0,[1,"glRasterPos3iv"]],["sgl/gl"]],
["glrasterpos3s",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Raster.Pos3s))",[0,[1,"glRasterPos3s"]],["sgl/gl"]],
["glrasterpos3sv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Raster.Pos3sv))",[0,[1,"glRasterPos3sv"]],["sgl/gl"]],
["glrasterpos4d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Raster.Pos4d))",[0,[1,"glRasterPos4d"]],["sgl/gl"]],
["glrasterpos4dv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Raster.Pos4dv))",[0,[1,"glRasterPos4dv"]],["sgl/gl"]],
["glrasterpos4f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Raster.Pos4f))",[0,[1,"glRasterPos4f"]],["sgl/gl"]],
["glrasterpos4fv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Raster.Pos4fv))",[0,[1,"glRasterPos4fv"]],["sgl/gl"]],
["glrasterpos4i",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Raster.Pos4i))",[0,[1,"glRasterPos4i"]],["sgl/gl"]],
["glrasterpos4iv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Raster.Pos4iv))",[0,[1,"glRasterPos4iv"]],["sgl/gl"]],
["glrasterpos4s",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Raster.Pos4s))",[0,[1,"glRasterPos4s"]],["sgl/gl"]],
["glrasterpos4sv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Raster.Pos4sv))",[0,[1,"glRasterPos4sv"]],["sgl/gl"]],
["glreadbuffer",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Read.Buffer))",[0,[1,"glReadBuffer"]],["sgl/gl"]],
["glreadpixels",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Read.Pixels))",[0,[1,"glReadPixels"]],["sgl/gl"]],
["glrectd",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Rectd))",[0,[1,"glRectd"]],["sgl/gl"]],
["glrectdv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Rectdv))",[0,[1,"glRectdv"]],["sgl/gl"]],
["glrectf",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Rectf))",[0,[1,"glRectf"]],["sgl/gl"]],
["glrectfv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Rectfv))",[0,[1,"glRectfv"]],["sgl/gl"]],
["glrecti",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Recti))",[0,[1,"glRecti"]],["sgl/gl"]],
["glrectiv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Rectiv))",[0,[1,"glRectiv"]],["sgl/gl"]],
["glrects",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Rects))",[0,[1,"glRects"]],["sgl/gl"]],
["glrectsv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Rectsv))",[0,[1,"glRectsv"]],["sgl/gl"]],
["glrendermode",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Render.Mode))",[0,[1,"glRenderMode"]],["sgl/gl"]],
["glresethistogram",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Reset.Histogram))",[0,[1,"glResetHistogram"]],["sgl/gl"]],
["glresetminmax",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Reset.Minmax))",[0,[1,"glResetMinmax"]],["sgl/gl"]],
["glrotated",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Rotated))",[0,[1,"glRotated"]],["sgl/gl"]],
["glrotatef",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Rotatef))",[0,[1,"glRotatef"]],["sgl/gl"]],
["glsamplecoverage",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Sample.Coverage))",[0,[1,"glSampleCoverage"]],["sgl/gl"]],
["glscaled",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Scaled))",[0,[1,"glScaled"]],["sgl/gl"]],
["glscalef",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Scalef))",[0,[1,"glScalef"]],["sgl/gl"]],
["glscissor",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Scissor))",[0,[1,"glScissor"]],["sgl/gl"]],
["glsecondarycolor3b",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Secondary.Color3b))",[0,[1,"glSecondaryColor3b"]],["sgl/gl"]],
["glsecondarycolor3bv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Secondary.Color3bv))",[0,[1,"glSecondaryColor3bv"]],["sgl/gl"]],
["glsecondarycolor3d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Secondary.Color3d))",[0,[1,"glSecondaryColor3d"]],["sgl/gl"]],
["glsecondarycolor3dv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Secondary.Color3dv))",[0,[1,"glSecondaryColor3dv"]],["sgl/gl"]],
["glsecondarycolor3f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Secondary.Color3f))",[0,[1,"glSecondaryColor3f"]],["sgl/gl"]],
["glsecondarycolor3fv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Secondary.Color3fv))",[0,[1,"glSecondaryColor3fv"]],["sgl/gl"]],
["glsecondarycolor3i",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Secondary.Color3i))",[0,[1,"glSecondaryColor3i"]],["sgl/gl"]],
["glsecondarycolor3iv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Secondary.Color3iv))",[0,[1,"glSecondaryColor3iv"]],["sgl/gl"]],
["glsecondarycolor3s",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Secondary.Color3s))",[0,[1,"glSecondaryColor3s"]],["sgl/gl"]],
["glsecondarycolor3sv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Secondary.Color3sv))",[0,[1,"glSecondaryColor3sv"]],["sgl/gl"]],
["glsecondarycolor3ub",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Secondary.Color3ub))",[0,[1,"glSecondaryColor3ub"]],["sgl/gl"]],
["glsecondarycolor3ubv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Secondary.Color3ubv))",[0,[1,"glSecondaryColor3ubv"]],["sgl/gl"]],
["glsecondarycolor3ui",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Secondary.Color3ui))",[0,[1,"glSecondaryColor3ui"]],["sgl/gl"]],
["glsecondarycolor3uiv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Secondary.Color3uiv))",[0,[1,"glSecondaryColor3uiv"]],["sgl/gl"]],
["glsecondarycolor3us",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Secondary.Color3us))",[0,[1,"glSecondaryColor3us"]],["sgl/gl"]],
["glsecondarycolor3usv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Secondary.Color3usv))",[0,[1,"glSecondaryColor3usv"]],["sgl/gl"]],
["glselectbuffer",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Select.Buffer))",[0,[1,"glSelectBuffer"]],["sgl/gl"]],
["glseparablefilter2d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Separable.Filter2.D))",[0,[1,"glSeparableFilter2D"]],["sgl/gl"]],
["glshademodel",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Shade.Model))",[0,[1,"glShadeModel"]],["sgl/gl"]],
["glshort",">sgl/gl.html#(idx._(gentag._3._(lib._sgl/scribblings/sgl..scrbl)))",[5,"GLshort"],false],
["glsizei",">sgl/gl.html#(idx._(gentag._8._(lib._sgl/scribblings/sgl..scrbl)))",[5,"GLsizei"],false],
["glstencilfunc",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Stencil.Func))",[0,[1,"glStencilFunc"]],["sgl/gl"]],
["glstencilmask",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Stencil.Mask))",[0,[1,"glStencilMask"]],["sgl/gl"]],
["glstencilop",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Stencil.Op))",[0,[1,"glStencilOp"]],["sgl/gl"]],
["gltexcoord1d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord1d))",[0,[1,"glTexCoord1d"]],["sgl/gl"]],
["gltexcoord1dv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord1dv))",[0,[1,"glTexCoord1dv"]],["sgl/gl"]],
["gltexcoord1f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord1f))",[0,[1,"glTexCoord1f"]],["sgl/gl"]],
["gltexcoord1fv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord1fv))",[0,[1,"glTexCoord1fv"]],["sgl/gl"]],
["gltexcoord1i",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord1i))",[0,[1,"glTexCoord1i"]],["sgl/gl"]],
["gltexcoord1iv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord1iv))",[0,[1,"glTexCoord1iv"]],["sgl/gl"]],
["gltexcoord1s",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord1s))",[0,[1,"glTexCoord1s"]],["sgl/gl"]],
["gltexcoord1sv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord1sv))",[0,[1,"glTexCoord1sv"]],["sgl/gl"]],
["gltexcoord2d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord2d))",[0,[1,"glTexCoord2d"]],["sgl/gl"]],
["gltexcoord2dv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord2dv))",[0,[1,"glTexCoord2dv"]],["sgl/gl"]],
["gltexcoord2f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord2f))",[0,[1,"glTexCoord2f"]],["sgl/gl"]],
["gltexcoord2fv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord2fv))",[0,[1,"glTexCoord2fv"]],["sgl/gl"]],
["gltexcoord2i",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord2i))",[0,[1,"glTexCoord2i"]],["sgl/gl"]],
["gltexcoord2iv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord2iv))",[0,[1,"glTexCoord2iv"]],["sgl/gl"]],
["gltexcoord2s",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord2s))",[0,[1,"glTexCoord2s"]],["sgl/gl"]],
["gltexcoord2sv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord2sv))",[0,[1,"glTexCoord2sv"]],["sgl/gl"]],
["gltexcoord3d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord3d))",[0,[1,"glTexCoord3d"]],["sgl/gl"]],
["gltexcoord3dv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord3dv))",[0,[1,"glTexCoord3dv"]],["sgl/gl"]],
["gltexcoord3f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord3f))",[0,[1,"glTexCoord3f"]],["sgl/gl"]],
["gltexcoord3fv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord3fv))",[0,[1,"glTexCoord3fv"]],["sgl/gl"]],
["gltexcoord3i",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord3i))",[0,[1,"glTexCoord3i"]],["sgl/gl"]],
["gltexcoord3iv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord3iv))",[0,[1,"glTexCoord3iv"]],["sgl/gl"]],
["gltexcoord3s",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord3s))",[0,[1,"glTexCoord3s"]],["sgl/gl"]],
["gltexcoord3sv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord3sv))",[0,[1,"glTexCoord3sv"]],["sgl/gl"]],
["gltexcoord4d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord4d))",[0,[1,"glTexCoord4d"]],["sgl/gl"]],
["gltexcoord4dv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord4dv))",[0,[1,"glTexCoord4dv"]],["sgl/gl"]],
["gltexcoord4f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord4f))",[0,[1,"glTexCoord4f"]],["sgl/gl"]],
["gltexcoord4fv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord4fv))",[0,[1,"glTexCoord4fv"]],["sgl/gl"]],
["gltexcoord4i",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord4i))",[0,[1,"glTexCoord4i"]],["sgl/gl"]],
["gltexcoord4iv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord4iv))",[0,[1,"glTexCoord4iv"]],["sgl/gl"]],
["gltexcoord4s",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord4s))",[0,[1,"glTexCoord4s"]],["sgl/gl"]],
["gltexcoord4sv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Coord4sv))",[0,[1,"glTexCoord4sv"]],["sgl/gl"]],
["gltexenvf",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Envf))",[0,[1,"glTexEnvf"]],["sgl/gl"]],
["gltexenvfv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Envfv))",[0,[1,"glTexEnvfv"]],["sgl/gl"]],
["gltexenvi",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Envi))",[0,[1,"glTexEnvi"]],["sgl/gl"]],
["gltexenviv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Enviv))",[0,[1,"glTexEnviv"]],["sgl/gl"]],
["gltexgend",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Gend))",[0,[1,"glTexGend"]],["sgl/gl"]],
["gltexgendv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Gendv))",[0,[1,"glTexGendv"]],["sgl/gl"]],
["gltexgenf",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Genf))",[0,[1,"glTexGenf"]],["sgl/gl"]],
["gltexgenfv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Genfv))",[0,[1,"glTexGenfv"]],["sgl/gl"]],
["gltexgeni",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Geni))",[0,[1,"glTexGeni"]],["sgl/gl"]],
["gltexgeniv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Geniv))",[0,[1,"glTexGeniv"]],["sgl/gl"]],
["glteximage1d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Image1.D))",[0,[1,"glTexImage1D"]],["sgl/gl"]],
["glteximage2d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Image2.D))",[0,[1,"glTexImage2D"]],["sgl/gl"]],
["glteximage3d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Image3.D))",[0,[1,"glTexImage3D"]],["sgl/gl"]],
["gltexparameterf",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Parameterf))",[0,[1,"glTexParameterf"]],["sgl/gl"]],
["gltexparameterfv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Parameterfv))",[0,[1,"glTexParameterfv"]],["sgl/gl"]],
["gltexparameteri",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Parameteri))",[0,[1,"glTexParameteri"]],["sgl/gl"]],
["gltexparameteriv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Parameteriv))",[0,[1,"glTexParameteriv"]],["sgl/gl"]],
["gltexsubimage1d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Sub.Image1.D))",[0,[1,"glTexSubImage1D"]],["sgl/gl"]],
["gltexsubimage2d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Sub.Image2.D))",[0,[1,"glTexSubImage2D"]],["sgl/gl"]],
["gltexsubimage3d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Tex.Sub.Image3.D))",[0,[1,"glTexSubImage3D"]],["sgl/gl"]],
["gltranslated",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Translated))",[0,[1,"glTranslated"]],["sgl/gl"]],
["gltranslatef",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Translatef))",[0,[1,"glTranslatef"]],["sgl/gl"]],
["glu",">sgl/index.html#(idx._(gentag._1._(lib._sgl/scribblings/sgl..scrbl)))","GLU",false],
["glu_auto_load_matrix",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.A.U.T.O_.L.O.A.D_.M.A.T.R.I.X))",[0,[1,"GLU_AUTO_LOAD_MATRIX"]],["sgl/gl"]],
["glu_begin",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.B.E.G.I.N))",[0,[1,"GLU_BEGIN"]],["sgl/gl"]],
["glu_ccw",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.C.C.W))",[0,[1,"GLU_CCW"]],["sgl/gl"]],
["glu_culling",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.C.U.L.L.I.N.G))",[0,[1,"GLU_CULLING"]],["sgl/gl"]],
["glu_cw",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.C.W))",[0,[1,"GLU_CW"]],["sgl/gl"]],
["glu_display_mode",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.D.I.S.P.L.A.Y_.M.O.D.E))",[0,[1,"GLU_DISPLAY_MODE"]],["sgl/gl"]],
["glu_domain_distance",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.D.O.M.A.I.N_.D.I.S.T.A.N.C.E))",[0,[1,"GLU_DOMAIN_DISTANCE"]],["sgl/gl"]],
["glu_edge_flag",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.E.D.G.E_.F.L.A.G))",[0,[1,"GLU_EDGE_FLAG"]],["sgl/gl"]],
["glu_end",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.E.N.D))",[0,[1,"GLU_END"]],["sgl/gl"]],
["glu_error",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.E.R.R.O.R))",[0,[1,"GLU_ERROR"]],["sgl/gl"]],
["glu_extensions",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.E.X.T.E.N.S.I.O.N.S))",[0,[1,"GLU_EXTENSIONS"]],["sgl/gl"]],
["glu_exterior",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.E.X.T.E.R.I.O.R))",[0,[1,"GLU_EXTERIOR"]],["sgl/gl"]],
["glu_false",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.F.A.L.S.E))",[0,[1,"GLU_FALSE"]],["sgl/gl"]],
["glu_fill",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.F.I.L.L))",[0,[1,"GLU_FILL"]],["sgl/gl"]],
["glu_flat",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.F.L.A.T))",[0,[1,"GLU_FLAT"]],["sgl/gl"]],
["glu_inside",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.I.N.S.I.D.E))",[0,[1,"GLU_INSIDE"]],["sgl/gl"]],
["glu_interior",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.I.N.T.E.R.I.O.R))",[0,[1,"GLU_INTERIOR"]],["sgl/gl"]],
["glu_invalid_enum",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.I.N.V.A.L.I.D_.E.N.U.M))",[0,[1,"GLU_INVALID_ENUM"]],["sgl/gl"]],
["glu_invalid_operation",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.I.N.V.A.L.I.D_.O.P.E.R.A.T.I.O.N))",[0,[1,"GLU_INVALID_OPERATION"]],["sgl/gl"]],
["glu_invalid_value",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.I.N.V.A.L.I.D_.V.A.L.U.E))",[0,[1,"GLU_INVALID_VALUE"]],["sgl/gl"]],
["glu_line",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.L.I.N.E))",[0,[1,"GLU_LINE"]],["sgl/gl"]],
["glu_map1_trim_2",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.M.A.P1_.T.R.I.M_2))",[0,[1,"GLU_MAP1_TRIM_2"]],["sgl/gl"]],
["glu_map1_trim_3",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.M.A.P1_.T.R.I.M_3))",[0,[1,"GLU_MAP1_TRIM_3"]],["sgl/gl"]],
["glu_none",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.O.N.E))",[0,[1,"GLU_NONE"]],["sgl/gl"]],
["glu_nurbs_begin",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.B.E.G.I.N))",[0,[1,"GLU_NURBS_BEGIN"]],["sgl/gl"]],
["glu_nurbs_begin_data",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.B.E.G.I.N_.D.A.T.A))",[0,[1,"GLU_NURBS_BEGIN_DATA"]],["sgl/gl"]],
["glu_nurbs_begin_data_ext",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.B.E.G.I.N_.D.A.T.A_.E.X.T))",[0,[1,"GLU_NURBS_BEGIN_DATA_EXT"]],["sgl/gl"]],
["glu_nurbs_begin_ext",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.B.E.G.I.N_.E.X.T))",[0,[1,"GLU_NURBS_BEGIN_EXT"]],["sgl/gl"]],
["glu_nurbs_color",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.C.O.L.O.R))",[0,[1,"GLU_NURBS_COLOR"]],["sgl/gl"]],
["glu_nurbs_color_data",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.C.O.L.O.R_.D.A.T.A))",[0,[1,"GLU_NURBS_COLOR_DATA"]],["sgl/gl"]],
["glu_nurbs_color_data_ext",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.C.O.L.O.R_.D.A.T.A_.E.X.T))",[0,[1,"GLU_NURBS_COLOR_DATA_EXT"]],["sgl/gl"]],
["glu_nurbs_color_ext",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.C.O.L.O.R_.E.X.T))",[0,[1,"GLU_NURBS_COLOR_EXT"]],["sgl/gl"]],
["glu_nurbs_end",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.N.D))",[0,[1,"GLU_NURBS_END"]],["sgl/gl"]],
["glu_nurbs_end_data",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.N.D_.D.A.T.A))",[0,[1,"GLU_NURBS_END_DATA"]],["sgl/gl"]],
["glu_nurbs_end_data_ext",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.N.D_.D.A.T.A_.E.X.T))",[0,[1,"GLU_NURBS_END_DATA_EXT"]],["sgl/gl"]],
["glu_nurbs_end_ext",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.N.D_.E.X.T))",[0,[1,"GLU_NURBS_END_EXT"]],["sgl/gl"]],
["glu_nurbs_error",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R))",[0,[1,"GLU_NURBS_ERROR"]],["sgl/gl"]],
["glu_nurbs_error1",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R1))",[0,[1,"GLU_NURBS_ERROR1"]],["sgl/gl"]],
["glu_nurbs_error10",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R10))",[0,[1,"GLU_NURBS_ERROR10"]],["sgl/gl"]],
["glu_nurbs_error11",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R11))",[0,[1,"GLU_NURBS_ERROR11"]],["sgl/gl"]],
["glu_nurbs_error12",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R12))",[0,[1,"GLU_NURBS_ERROR12"]],["sgl/gl"]],
["glu_nurbs_error13",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R13))",[0,[1,"GLU_NURBS_ERROR13"]],["sgl/gl"]],
["glu_nurbs_error14",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R14))",[0,[1,"GLU_NURBS_ERROR14"]],["sgl/gl"]],
["glu_nurbs_error15",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R15))",[0,[1,"GLU_NURBS_ERROR15"]],["sgl/gl"]],
["glu_nurbs_error16",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R16))",[0,[1,"GLU_NURBS_ERROR16"]],["sgl/gl"]],
["glu_nurbs_error17",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R17))",[0,[1,"GLU_NURBS_ERROR17"]],["sgl/gl"]],
["glu_nurbs_error18",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R18))",[0,[1,"GLU_NURBS_ERROR18"]],["sgl/gl"]],
["glu_nurbs_error19",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R19))",[0,[1,"GLU_NURBS_ERROR19"]],["sgl/gl"]],
["glu_nurbs_error2",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R2))",[0,[1,"GLU_NURBS_ERROR2"]],["sgl/gl"]],
["glu_nurbs_error20",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R20))",[0,[1,"GLU_NURBS_ERROR20"]],["sgl/gl"]],
["glu_nurbs_error21",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R21))",[0,[1,"GLU_NURBS_ERROR21"]],["sgl/gl"]],
["glu_nurbs_error22",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R22))",[0,[1,"GLU_NURBS_ERROR22"]],["sgl/gl"]],
["glu_nurbs_error23",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R23))",[0,[1,"GLU_NURBS_ERROR23"]],["sgl/gl"]],
["glu_nurbs_error24",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R24))",[0,[1,"GLU_NURBS_ERROR24"]],["sgl/gl"]],
["glu_nurbs_error25",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R25))",[0,[1,"GLU_NURBS_ERROR25"]],["sgl/gl"]],
["glu_nurbs_error26",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R26))",[0,[1,"GLU_NURBS_ERROR26"]],["sgl/gl"]],
["glu_nurbs_error27",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R27))",[0,[1,"GLU_NURBS_ERROR27"]],["sgl/gl"]],
["glu_nurbs_error28",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R28))",[0,[1,"GLU_NURBS_ERROR28"]],["sgl/gl"]],
["glu_nurbs_error29",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R29))",[0,[1,"GLU_NURBS_ERROR29"]],["sgl/gl"]],
["glu_nurbs_error3",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R3))",[0,[1,"GLU_NURBS_ERROR3"]],["sgl/gl"]],
["glu_nurbs_error30",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R30))",[0,[1,"GLU_NURBS_ERROR30"]],["sgl/gl"]],
["glu_nurbs_error31",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R31))",[0,[1,"GLU_NURBS_ERROR31"]],["sgl/gl"]],
["glu_nurbs_error32",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R32))",[0,[1,"GLU_NURBS_ERROR32"]],["sgl/gl"]],
["glu_nurbs_error33",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R33))",[0,[1,"GLU_NURBS_ERROR33"]],["sgl/gl"]],
["glu_nurbs_error34",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R34))",[0,[1,"GLU_NURBS_ERROR34"]],["sgl/gl"]],
["glu_nurbs_error35",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R35))",[0,[1,"GLU_NURBS_ERROR35"]],["sgl/gl"]],
["glu_nurbs_error36",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R36))",[0,[1,"GLU_NURBS_ERROR36"]],["sgl/gl"]],
["glu_nurbs_error37",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R37))",[0,[1,"GLU_NURBS_ERROR37"]],["sgl/gl"]],
["glu_nurbs_error4",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R4))",[0,[1,"GLU_NURBS_ERROR4"]],["sgl/gl"]],
["glu_nurbs_error5",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R5))",[0,[1,"GLU_NURBS_ERROR5"]],["sgl/gl"]],
["glu_nurbs_error6",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R6))",[0,[1,"GLU_NURBS_ERROR6"]],["sgl/gl"]],
["glu_nurbs_error7",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R7))",[0,[1,"GLU_NURBS_ERROR7"]],["sgl/gl"]],
["glu_nurbs_error8",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R8))",[0,[1,"GLU_NURBS_ERROR8"]],["sgl/gl"]],
["glu_nurbs_error9",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.E.R.R.O.R9))",[0,[1,"GLU_NURBS_ERROR9"]],["sgl/gl"]],
["glu_nurbs_mode",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.M.O.D.E))",[0,[1,"GLU_NURBS_MODE"]],["sgl/gl"]],
["glu_nurbs_mode_ext",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.M.O.D.E_.E.X.T))",[0,[1,"GLU_NURBS_MODE_EXT"]],["sgl/gl"]],
["glu_nurbs_normal",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.N.O.R.M.A.L))",[0,[1,"GLU_NURBS_NORMAL"]],["sgl/gl"]],
["glu_nurbs_normal_data",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.N.O.R.M.A.L_.D.A.T.A))",[0,[1,"GLU_NURBS_NORMAL_DATA"]],["sgl/gl"]],
["glu_nurbs_normal_data_ext",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.N.O.R.M.A.L_.D.A.T.A_.E.X.T))",[0,[1,"GLU_NURBS_NORMAL_DATA_EXT"]],["sgl/gl"]],
["glu_nurbs_normal_ext",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.N.O.R.M.A.L_.E.X.T))",[0,[1,"GLU_NURBS_NORMAL_EXT"]],["sgl/gl"]],
["glu_nurbs_renderer",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.R.E.N.D.E.R.E.R))",[0,[1,"GLU_NURBS_RENDERER"]],["sgl/gl"]],
["glu_nurbs_renderer_ext",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.R.E.N.D.E.R.E.R_.E.X.T))",[0,[1,"GLU_NURBS_RENDERER_EXT"]],["sgl/gl"]],
["glu_nurbs_tessellator",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.T.E.S.S.E.L.L.A.T.O.R))",[0,[1,"GLU_NURBS_TESSELLATOR"]],["sgl/gl"]],
["glu_nurbs_tessellator_ext",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.T.E.S.S.E.L.L.A.T.O.R_.E.X.T))",[0,[1,"GLU_NURBS_TESSELLATOR_EXT"]],["sgl/gl"]],
["glu_nurbs_tex_coord_data_ext",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.T.E.X_.C.O.O.R.D_.D.A.T.A_.E.X.T))",[0,[1,"GLU_NURBS_TEX_COORD_DATA_EXT"]],["sgl/gl"]],
["glu_nurbs_tex_coord_ext",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.T.E.X_.C.O.O.R.D_.E.X.T))",[0,[1,"GLU_NURBS_TEX_COORD_EXT"]],["sgl/gl"]],
["glu_nurbs_texture_coord",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.T.E.X.T.U.R.E_.C.O.O.R.D))",[0,[1,"GLU_NURBS_TEXTURE_COORD"]],["sgl/gl"]],
["glu_nurbs_texture_coord_data",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.T.E.X.T.U.R.E_.C.O.O.R.D_.D.A.T.A))",[0,[1,"GLU_NURBS_TEXTURE_COORD_DATA"]],["sgl/gl"]],
["glu_nurbs_vertex",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.V.E.R.T.E.X))",[0,[1,"GLU_NURBS_VERTEX"]],["sgl/gl"]],
["glu_nurbs_vertex_data",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.V.E.R.T.E.X_.D.A.T.A))",[0,[1,"GLU_NURBS_VERTEX_DATA"]],["sgl/gl"]],
["glu_nurbs_vertex_data_ext",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.V.E.R.T.E.X_.D.A.T.A_.E.X.T))",[0,[1,"GLU_NURBS_VERTEX_DATA_EXT"]],["sgl/gl"]],
["glu_nurbs_vertex_ext",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.N.U.R.B.S_.V.E.R.T.E.X_.E.X.T))",[0,[1,"GLU_NURBS_VERTEX_EXT"]],["sgl/gl"]],
["glu_object_parametric_error",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.O.B.J.E.C.T_.P.A.R.A.M.E.T.R.I.C_.E.R.R.O.R))",[0,[1,"GLU_OBJECT_PARAMETRIC_ERROR"]],["sgl/gl"]],
["glu_object_parametric_error_ext",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.O.B.J.E.C.T_.P.A.R.A.M.E.T.R.I.C_.E.R.R.O.R_.E.X.T))",[0,[1,"GLU_OBJECT_PARAMETRIC_ERROR_EXT"]],["sgl/gl"]],
["glu_object_path_length",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.O.B.J.E.C.T_.P.A.T.H_.L.E.N.G.T.H))",[0,[1,"GLU_OBJECT_PATH_LENGTH"]],["sgl/gl"]],
["glu_object_path_length_ext",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.O.B.J.E.C.T_.P.A.T.H_.L.E.N.G.T.H_.E.X.T))",[0,[1,"GLU_OBJECT_PATH_LENGTH_EXT"]],["sgl/gl"]],
["glu_out_of_memory",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.O.U.T_.O.F_.M.E.M.O.R.Y))",[0,[1,"GLU_OUT_OF_MEMORY"]],["sgl/gl"]],
["glu_outline_patch",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.O.U.T.L.I.N.E_.P.A.T.C.H))",[0,[1,"GLU_OUTLINE_PATCH"]],["sgl/gl"]],
["glu_outline_polygon",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.O.U.T.L.I.N.E_.P.O.L.Y.G.O.N))",[0,[1,"GLU_OUTLINE_POLYGON"]],["sgl/gl"]],
["glu_outside",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.O.U.T.S.I.D.E))",[0,[1,"GLU_OUTSIDE"]],["sgl/gl"]],
["glu_parametric_error",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.P.A.R.A.M.E.T.R.I.C_.E.R.R.O.R))",[0,[1,"GLU_PARAMETRIC_ERROR"]],["sgl/gl"]],
["glu_parametric_tolerance",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.P.A.R.A.M.E.T.R.I.C_.T.O.L.E.R.A.N.C.E))",[0,[1,"GLU_PARAMETRIC_TOLERANCE"]],["sgl/gl"]],
["glu_path_length",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.P.A.T.H_.L.E.N.G.T.H))",[0,[1,"GLU_PATH_LENGTH"]],["sgl/gl"]],
["glu_point",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.P.O.I.N.T))",[0,[1,"GLU_POINT"]],["sgl/gl"]],
["glu_sampling_method",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.S.A.M.P.L.I.N.G_.M.E.T.H.O.D))",[0,[1,"GLU_SAMPLING_METHOD"]],["sgl/gl"]],
["glu_sampling_tolerance",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.S.A.M.P.L.I.N.G_.T.O.L.E.R.A.N.C.E))",[0,[1,"GLU_SAMPLING_TOLERANCE"]],["sgl/gl"]],
["glu_silhouette",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.S.I.L.H.O.U.E.T.T.E))",[0,[1,"GLU_SILHOUETTE"]],["sgl/gl"]],
["glu_smooth",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.S.M.O.O.T.H))",[0,[1,"GLU_SMOOTH"]],["sgl/gl"]],
["glu_tess_begin",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.B.E.G.I.N))",[0,[1,"GLU_TESS_BEGIN"]],["sgl/gl"]],
["glu_tess_begin_data",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.B.E.G.I.N_.D.A.T.A))",[0,[1,"GLU_TESS_BEGIN_DATA"]],["sgl/gl"]],
["glu_tess_boundary_only",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.B.O.U.N.D.A.R.Y_.O.N.L.Y))",[0,[1,"GLU_TESS_BOUNDARY_ONLY"]],["sgl/gl"]],
["glu_tess_combine",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.C.O.M.B.I.N.E))",[0,[1,"GLU_TESS_COMBINE"]],["sgl/gl"]],
["glu_tess_combine_data",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.C.O.M.B.I.N.E_.D.A.T.A))",[0,[1,"GLU_TESS_COMBINE_DATA"]],["sgl/gl"]],
["glu_tess_coord_too_large",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.C.O.O.R.D_.T.O.O_.L.A.R.G.E))",[0,[1,"GLU_TESS_COORD_TOO_LARGE"]],["sgl/gl"]],
["glu_tess_edge_flag",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.E.D.G.E_.F.L.A.G))",[0,[1,"GLU_TESS_EDGE_FLAG"]],["sgl/gl"]],
["glu_tess_edge_flag_data",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.E.D.G.E_.F.L.A.G_.D.A.T.A))",[0,[1,"GLU_TESS_EDGE_FLAG_DATA"]],["sgl/gl"]],
["glu_tess_end",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.E.N.D))",[0,[1,"GLU_TESS_END"]],["sgl/gl"]],
["glu_tess_end_data",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.E.N.D_.D.A.T.A))",[0,[1,"GLU_TESS_END_DATA"]],["sgl/gl"]],
["glu_tess_error",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.E.R.R.O.R))",[0,[1,"GLU_TESS_ERROR"]],["sgl/gl"]],
["glu_tess_error1",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.E.R.R.O.R1))",[0,[1,"GLU_TESS_ERROR1"]],["sgl/gl"]],
["glu_tess_error2",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.E.R.R.O.R2))",[0,[1,"GLU_TESS_ERROR2"]],["sgl/gl"]],
["glu_tess_error3",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.E.R.R.O.R3))",[0,[1,"GLU_TESS_ERROR3"]],["sgl/gl"]],
["glu_tess_error4",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.E.R.R.O.R4))",[0,[1,"GLU_TESS_ERROR4"]],["sgl/gl"]],
["glu_tess_error5",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.E.R.R.O.R5))",[0,[1,"GLU_TESS_ERROR5"]],["sgl/gl"]],
["glu_tess_error6",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.E.R.R.O.R6))",[0,[1,"GLU_TESS_ERROR6"]],["sgl/gl"]],
["glu_tess_error7",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.E.R.R.O.R7))",[0,[1,"GLU_TESS_ERROR7"]],["sgl/gl"]],
["glu_tess_error8",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.E.R.R.O.R8))",[0,[1,"GLU_TESS_ERROR8"]],["sgl/gl"]],
["glu_tess_error_data",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.E.R.R.O.R_.D.A.T.A))",[0,[1,"GLU_TESS_ERROR_DATA"]],["sgl/gl"]],
["glu_tess_max_coord",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.M.A.X_.C.O.O.R.D))",[0,[1,"GLU_TESS_MAX_COORD"]],["sgl/gl"]],
["glu_tess_missing_begin_contour",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.M.I.S.S.I.N.G_.B.E.G.I.N_.C.O.N.T.O.U.R))",[0,[1,"GLU_TESS_MISSING_BEGIN_CONTOUR"]],["sgl/gl"]],
["glu_tess_missing_begin_polygon",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.M.I.S.S.I.N.G_.B.E.G.I.N_.P.O.L.Y.G.O.N))",[0,[1,"GLU_TESS_MISSING_BEGIN_POLYGON"]],["sgl/gl"]],
["glu_tess_missing_end_contour",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.M.I.S.S.I.N.G_.E.N.D_.C.O.N.T.O.U.R))",[0,[1,"GLU_TESS_MISSING_END_CONTOUR"]],["sgl/gl"]],
["glu_tess_missing_end_polygon",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.M.I.S.S.I.N.G_.E.N.D_.P.O.L.Y.G.O.N))",[0,[1,"GLU_TESS_MISSING_END_POLYGON"]],["sgl/gl"]],
["glu_tess_need_combine_callback",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.N.E.E.D_.C.O.M.B.I.N.E_.C.A.L.L.B.A.C.K))",[0,[1,"GLU_TESS_NEED_COMBINE_CALLBACK"]],["sgl/gl"]],
["glu_tess_tolerance",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.T.O.L.E.R.A.N.C.E))",[0,[1,"GLU_TESS_TOLERANCE"]],["sgl/gl"]],
["glu_tess_vertex",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.V.E.R.T.E.X))",[0,[1,"GLU_TESS_VERTEX"]],["sgl/gl"]],
["glu_tess_vertex_data",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.V.E.R.T.E.X_.D.A.T.A))",[0,[1,"GLU_TESS_VERTEX_DATA"]],["sgl/gl"]],
["glu_tess_winding_abs_geq_two",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.W.I.N.D.I.N.G_.A.B.S_.G.E.Q_.T.W.O))",[0,[1,"GLU_TESS_WINDING_ABS_GEQ_TWO"]],["sgl/gl"]],
["glu_tess_winding_negative",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.W.I.N.D.I.N.G_.N.E.G.A.T.I.V.E))",[0,[1,"GLU_TESS_WINDING_NEGATIVE"]],["sgl/gl"]],
["glu_tess_winding_nonzero",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.W.I.N.D.I.N.G_.N.O.N.Z.E.R.O))",[0,[1,"GLU_TESS_WINDING_NONZERO"]],["sgl/gl"]],
["glu_tess_winding_odd",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.W.I.N.D.I.N.G_.O.D.D))",[0,[1,"GLU_TESS_WINDING_ODD"]],["sgl/gl"]],
["glu_tess_winding_positive",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.W.I.N.D.I.N.G_.P.O.S.I.T.I.V.E))",[0,[1,"GLU_TESS_WINDING_POSITIVE"]],["sgl/gl"]],
["glu_tess_winding_rule",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.E.S.S_.W.I.N.D.I.N.G_.R.U.L.E))",[0,[1,"GLU_TESS_WINDING_RULE"]],["sgl/gl"]],
["glu_true",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.T.R.U.E))",[0,[1,"GLU_TRUE"]],["sgl/gl"]],
["glu_u_step",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.U_.S.T.E.P))",[0,[1,"GLU_U_STEP"]],["sgl/gl"]],
["glu_unknown",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.U.N.K.N.O.W.N))",[0,[1,"GLU_UNKNOWN"]],["sgl/gl"]],
["glu_v_step",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.V_.S.T.E.P))",[0,[1,"GLU_V_STEP"]],["sgl/gl"]],
["glu_version",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.V.E.R.S.I.O.N))",[0,[1,"GLU_VERSION"]],["sgl/gl"]],
["glu_vertex",">sgl/gl.html#(def._((lib._sgl/gl..ss)._.G.L.U_.V.E.R.T.E.X))",[0,[1,"GLU_VERTEX"]],["sgl/gl"]],
["glubuild1dmipmaplevels",">sgl/gl.html#(def._((lib._sgl/gl..ss)._glu.Build1.D.Mipmap.Levels))",[0,[1,"gluBuild1DMipmapLevels"]],["sgl/gl"]],
["glubuild1dmipmaps",">sgl/gl.html#(def._((lib._sgl/gl..ss)._glu.Build1.D.Mipmaps))",[0,[1,"gluBuild1DMipmaps"]],["sgl/gl"]],
["glubuild2dmipmaplevels",">sgl/gl.html#(def._((lib._sgl/gl..ss)._glu.Build2.D.Mipmap.Levels))",[0,[1,"gluBuild2DMipmapLevels"]],["sgl/gl"]],
["glubuild2dmipmaps",">sgl/gl.html#(def._((lib._sgl/gl..ss)._glu.Build2.D.Mipmaps))",[0,[1,"gluBuild2DMipmaps"]],["sgl/gl"]],
["glubuild3dmipmaplevels",">sgl/gl.html#(def._((lib._sgl/gl..ss)._glu.Build3.D.Mipmap.Levels))",[0,[1,"gluBuild3DMipmapLevels"]],["sgl/gl"]],
["glubuild3dmipmaps",">sgl/gl.html#(def._((lib._sgl/gl..ss)._glu.Build3.D.Mipmaps))",[0,[1,"gluBuild3DMipmaps"]],["sgl/gl"]],
["glubyte",">sgl/gl.html#(idx._(gentag._5._(lib._sgl/scribblings/sgl..scrbl)))",[5,"GLubyte"],false],
["glucheckextension",">sgl/gl.html#(def._((lib._sgl/gl..ss)._glu.Check.Extension))",[0,[1,"gluCheckExtension"]],["sgl/gl"]],
["glucylinder",">sgl/gl.html#(def._((lib._sgl/gl..ss)._glu.Cylinder))",[0,[1,"gluCylinder"]],["sgl/gl"]],
["gludisk",">sgl/gl.html#(def._((lib._sgl/gl..ss)._glu.Disk))",[0,[1,"gluDisk"]],["sgl/gl"]],
["gluerrorstring",">sgl/gl.html#(def._((lib._sgl/gl..ss)._glu.Error.String))",[0,[1,"gluErrorString"]],["sgl/gl"]],
["glugetstring",">sgl/gl.html#(def._((lib._sgl/gl..ss)._glu.Get.String))",[0,[1,"gluGetString"]],["sgl/gl"]],
["gluint",">sgl/gl.html#(idx._(gentag._7._(lib._sgl/scribblings/sgl..scrbl)))",[5,"GLuint"],false],
["glulookat",">sgl/gl.html#(def._((lib._sgl/gl..ss)._glu.Look.At))",[0,[1,"gluLookAt"]],["sgl/gl"]],
["glunewquadric",">sgl/gl.html#(def._((lib._sgl/gl..ss)._glu.New.Quadric))",[0,[1,"gluNewQuadric"]],["sgl/gl"]],
["gluortho2d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._glu.Ortho2.D))",[0,[1,"gluOrtho2D"]],["sgl/gl"]],
["glupartialdisk",">sgl/gl.html#(def._((lib._sgl/gl..ss)._glu.Partial.Disk))",[0,[1,"gluPartialDisk"]],["sgl/gl"]],
["gluperspective",">sgl/gl.html#(def._((lib._sgl/gl..ss)._glu.Perspective))",[0,[1,"gluPerspective"]],["sgl/gl"]],
["glupickmatrix",">sgl/gl.html#(def._((lib._sgl/gl..ss)._glu.Pick.Matrix))",[0,[1,"gluPickMatrix"]],["sgl/gl"]],
["gluproject",">sgl/gl.html#(def._((lib._sgl/gl..ss)._glu.Project))",[0,[1,"gluProject"]],["sgl/gl"]],
["gluquadricdrawstyle",">sgl/gl.html#(def._((lib._sgl/gl..ss)._glu.Quadric.Draw.Style))",[0,[1,"gluQuadricDrawStyle"]],["sgl/gl"]],
["gluquadricnormals",">sgl/gl.html#(def._((lib._sgl/gl..ss)._glu.Quadric.Normals))",[0,[1,"gluQuadricNormals"]],["sgl/gl"]],
["gluquadricorientation",">sgl/gl.html#(def._((lib._sgl/gl..ss)._glu.Quadric.Orientation))",[0,[1,"gluQuadricOrientation"]],["sgl/gl"]],
["gluquadrictexture",">sgl/gl.html#(def._((lib._sgl/gl..ss)._glu.Quadric.Texture))",[0,[1,"gluQuadricTexture"]],["sgl/gl"]],
["gluscaleimage",">sgl/gl.html#(def._((lib._sgl/gl..ss)._glu.Scale.Image))",[0,[1,"gluScaleImage"]],["sgl/gl"]],
["glushort",">sgl/gl.html#(idx._(gentag._6._(lib._sgl/scribblings/sgl..scrbl)))",[5,"GLushort"],false],
["glusphere",">sgl/gl.html#(def._((lib._sgl/gl..ss)._glu.Sphere))",[0,[1,"gluSphere"]],["sgl/gl"]],
["gluunproject",">sgl/gl.html#(def._((lib._sgl/gl..ss)._glu.Un.Project))",[0,[1,"gluUnProject"]],["sgl/gl"]],
["gluunproject4",">sgl/gl.html#(def._((lib._sgl/gl..ss)._glu.Un.Project4))",[0,[1,"gluUnProject4"]],["sgl/gl"]],
["glvertex2d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Vertex2d))",[0,[1,"glVertex2d"]],["sgl/gl"]],
["glvertex2dv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Vertex2dv))",[0,[1,"glVertex2dv"]],["sgl/gl"]],
["glvertex2f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Vertex2f))",[0,[1,"glVertex2f"]],["sgl/gl"]],
["glvertex2fv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Vertex2fv))",[0,[1,"glVertex2fv"]],["sgl/gl"]],
["glvertex2i",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Vertex2i))",[0,[1,"glVertex2i"]],["sgl/gl"]],
["glvertex2iv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Vertex2iv))",[0,[1,"glVertex2iv"]],["sgl/gl"]],
["glvertex2s",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Vertex2s))",[0,[1,"glVertex2s"]],["sgl/gl"]],
["glvertex2sv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Vertex2sv))",[0,[1,"glVertex2sv"]],["sgl/gl"]],
["glvertex3d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Vertex3d))",[0,[1,"glVertex3d"]],["sgl/gl"]],
["glvertex3dv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Vertex3dv))",[0,[1,"glVertex3dv"]],["sgl/gl"]],
["glvertex3f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Vertex3f))",[0,[1,"glVertex3f"]],["sgl/gl"]],
["glvertex3fv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Vertex3fv))",[0,[1,"glVertex3fv"]],["sgl/gl"]],
["glvertex3i",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Vertex3i))",[0,[1,"glVertex3i"]],["sgl/gl"]],
["glvertex3iv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Vertex3iv))",[0,[1,"glVertex3iv"]],["sgl/gl"]],
["glvertex3s",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Vertex3s))",[0,[1,"glVertex3s"]],["sgl/gl"]],
["glvertex3sv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Vertex3sv))",[0,[1,"glVertex3sv"]],["sgl/gl"]],
["glvertex4d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Vertex4d))",[0,[1,"glVertex4d"]],["sgl/gl"]],
["glvertex4dv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Vertex4dv))",[0,[1,"glVertex4dv"]],["sgl/gl"]],
["glvertex4f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Vertex4f))",[0,[1,"glVertex4f"]],["sgl/gl"]],
["glvertex4fv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Vertex4fv))",[0,[1,"glVertex4fv"]],["sgl/gl"]],
["glvertex4i",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Vertex4i))",[0,[1,"glVertex4i"]],["sgl/gl"]],
["glvertex4iv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Vertex4iv))",[0,[1,"glVertex4iv"]],["sgl/gl"]],
["glvertex4s",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Vertex4s))",[0,[1,"glVertex4s"]],["sgl/gl"]],
["glvertex4sv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Vertex4sv))",[0,[1,"glVertex4sv"]],["sgl/gl"]],
["glviewport",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Viewport))",[0,[1,"glViewport"]],["sgl/gl"]],
["glwindowpos2d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Window.Pos2d))",[0,[1,"glWindowPos2d"]],["sgl/gl"]],
["glwindowpos2dv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Window.Pos2dv))",[0,[1,"glWindowPos2dv"]],["sgl/gl"]],
["glwindowpos2f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Window.Pos2f))",[0,[1,"glWindowPos2f"]],["sgl/gl"]],
["glwindowpos2fv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Window.Pos2fv))",[0,[1,"glWindowPos2fv"]],["sgl/gl"]],
["glwindowpos2i",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Window.Pos2i))",[0,[1,"glWindowPos2i"]],["sgl/gl"]],
["glwindowpos2iv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Window.Pos2iv))",[0,[1,"glWindowPos2iv"]],["sgl/gl"]],
["glwindowpos2s",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Window.Pos2s))",[0,[1,"glWindowPos2s"]],["sgl/gl"]],
["glwindowpos2sv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Window.Pos2sv))",[0,[1,"glWindowPos2sv"]],["sgl/gl"]],
["glwindowpos3d",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Window.Pos3d))",[0,[1,"glWindowPos3d"]],["sgl/gl"]],
["glwindowpos3dv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Window.Pos3dv))",[0,[1,"glWindowPos3dv"]],["sgl/gl"]],
["glwindowpos3f",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Window.Pos3f))",[0,[1,"glWindowPos3f"]],["sgl/gl"]],
["glwindowpos3fv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Window.Pos3fv))",[0,[1,"glWindowPos3fv"]],["sgl/gl"]],
["glwindowpos3i",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Window.Pos3i))",[0,[1,"glWindowPos3i"]],["sgl/gl"]],
["glwindowpos3iv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Window.Pos3iv))",[0,[1,"glWindowPos3iv"]],["sgl/gl"]],
["glwindowpos3s",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Window.Pos3s))",[0,[1,"glWindowPos3s"]],["sgl/gl"]],
["glwindowpos3sv",">sgl/gl.html#(def._((lib._sgl/gl..ss)._gl.Window.Pos3sv))",[0,[1,"glWindowPos3sv"]],["sgl/gl"]],
["glyph-exists?",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._glyph-exists~3f))",[[0,[1,"glyph-exists?"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["glyphlist.txt",">gui/fontresources.html#(idx._(gentag._311._(lib._scribblings/gui/gui..scrbl)))",[5,"\"glyphlist.txt\""],false],
["glyphshortlist.txt",">gui/fontresources.html#(idx._(gentag._312._(lib._scribblings/gui/gui..scrbl)))",[5,"\"glyphshortlist.txt\""],false],
["go button",">drscheme/debugger.html#(idx._(gentag._34._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Go</font></b> button",false],
["go fish --- kid's card game",">games/gofish.html",[[13,"<img src=\"gofish.png\" />"]," ","<b><font size=\"-1\" face=\"Helvetica\">Go Fish</font></b>","  ","&ndash;","  Kid","&rsquo;","s Card Game"],false],
["go!",">more/index.html#(part._.Go_)","Go!",false],
["go!",">quick/index.html#(part._.Go_)","Go!",false],
["go-back",">mysterx/browsers.html#(meth._(((lib._mysterx/main..ss)._mx-browser~25)._go-back))",[[0,[1,"go-back"]],[12,[" (method of ",[0,[1,"mx-browser%"]],")"]]],["mysterx"]],
["go-forward",">mysterx/browsers.html#(meth._(((lib._mysterx/main..ss)._mx-browser~25)._go-forward))",[[0,[1,"go-forward"]],[12,[" (method of ",[0,[1,"mx-browser%"]],")"]]],["mysterx"]],
["gobblet --- strategy game",">games/gobblet.html",[[13,"<img src=\"gobblet.png\" />"]," ","<b><font size=\"-1\" face=\"Helvetica\">Gobblet</font></b>","  ","&ndash;","  Strategy Game"],false],
["gotchas",">guide/contracts-gotchas.html","Gotchas",false],
["goto-line",">framework/Keymap.html#(idx._(gentag._28._(lib._scribblings/framework/framework..scrbl)))","goto-line",false],
["goto-position",">framework/Keymap.html#(idx._(gentag._29._(lib._scribblings/framework/framework..scrbl)))","goto-position",false],
["goto-url",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-canvas-mixin)._goto-url))",[[0,[1,"goto-url"]],[12,[" (method of ",[0,[1,"hyper-canvas-mixin"]],")"]]],["browser"]],
["grab-caret",">gui/editor-admin_.html#(meth._(((lib._mred/main..ss)._editor-admin~25)._grab-caret))",[[0,[1,"grab-caret"]],[12,[" (method of ",[0,[1,"editor-admin%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["gradient",">plot/plot.html#(def._((lib._plot/main..ss)._gradient))",[0,[1,"gradient"]],["plot"]],
["graph functions",">mrlib/Graph_Functions.html","Graph Functions",false],
["graph-fun",">teachpack/graphing.html#(def._((lib._teachpack/htdp/graphing..ss)._graph-fun))",[0,[1,"graph-fun"]],["teachpack/htdp/graphing"]],
["graph-line",">teachpack/graphing.html#(def._((lib._teachpack/htdp/graphing..ss)._graph-line))",[0,[1,"graph-line"]],["teachpack/htdp/graphing"]],
["graph-pasteboard-mixin",">mrlib/graph-pasteboard-mixin.html",[0,[1,"graph-pasteboard-mixin"]],["mrlib/graph"]],
["graph-pasteboard<%>",">mrlib/graph-pasteboard___.html",[0,[1,"graph-pasteboard&lt;%&gt;"]],["mrlib/graph"]],
["graph-snip-mixin",">mrlib/graph-snip-mixin.html",[0,[1,"graph-snip-mixin"]],["mrlib/graph"]],
["graph-snip<%>",">mrlib/graph-snip___.html",[0,[1,"graph-snip&lt;%&gt;"]],["mrlib/graph"]],
["graphic",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..ss)._graphic))",[0,[6,"graphic"]],["parser-tools/lex"]],
["graphical debugging interface",">drscheme/debugger.html","Graphical Debugging Interface",false],
["graphical demo programs",">frtime/index.html#(part._.Graphical_.Demo_.Programs)","Graphical Demo Programs",false],
["graphical minimum height",">gui/windowing-overview.html#(tech._graphical._minimum._height)","<i>graphical minimum height</i>",false],
["graphical minimum size",">gui/windowing-overview.html#(tech._graphical._minimum._size)","<i>graphical minimum size</i>",false],
["graphical minimum width",">gui/windowing-overview.html#(tech._graphical._minimum._width)","<i>graphical minimum width</i>",false],
["graphical syntax",">drscheme/Graphical_Syntax.html","Graphical Syntax",false],
["graphical-read-eval-print-loop",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._graphical-read-eval-print-loop))",[0,[1,"graphical-read-eval-print-loop"]],["scheme/gui/base","scheme/gui"]],
["graphics library as a unit",">graphics/Graphics_Library_as_a_Unit.html","Graphics Library as a Unit",false],
["graphics-bexam",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..ss)._graphics-bexam))",[0,[1,"graphics-bexam"]],["graphics/turtle-examples"]],
["graphics-posn-less@",">graphics/Graphics_Library_as_a_Unit.html#(def._((lib._graphics/graphics-posn-less-unit..ss)._graphics-posn-less~40))",[0,[1,"graphics-posn-less@"]],["graphics/graphics-posn-less-unit"]],
["graphics/graphics",">graphics/index.html",[14,[0,"graphics/graphics"]],"module"],
["graphics/graphics-posn-less-unit",">graphics/Graphics_Library_as_a_Unit.html#(mod-path._graphics/graphics-posn-less-unit)",[14,[0,"graphics/graphics-posn-less-unit"]],"module"],
["graphics/graphics-sig",">graphics/Graphics_Library_as_a_Unit.html#(mod-path._graphics/graphics-sig)",[14,[0,"graphics/graphics-sig"]],"module"],
["graphics/graphics-unit",">graphics/Graphics_Library_as_a_Unit.html#(mod-path._graphics/graphics-unit)",[14,[0,"graphics/graphics-unit"]],"module"],
["graphics/turtle-examples",">turtles/Traditional_Turtles.html#(mod-path._graphics/turtle-examples)",[14,[0,"graphics/turtle-examples"]],"module"],
["graphics/turtles",">turtles/Traditional_Turtles.html",[14,[0,"graphics/turtles"]],"module"],
["graphics/value-turtle-examples",">turtles/Value_Turtles.html#(mod-path._graphics/value-turtle-examples)",[14,[0,"graphics/value-turtle-examples"]],"module"],
["graphics/value-turtles",">turtles/Value_Turtles.html",[14,[0,"graphics/value-turtles"]],"module"],
["graphics: legacy library",">graphics/index.html","<b>Graphics</b>: Legacy Library",false],
["graphics:posn^",">graphics/Graphics_Library_as_a_Unit.html#(form._((lib._graphics/graphics-sig..ss)._graphics~3aposn~5e))",[0,[6,"graphics:posn^"]],["graphics/graphics-sig"]],
["graphics@",">graphics/Graphics_Library_as_a_Unit.html#(def._((lib._graphics/graphics-unit..ss)._graphics~40))",[0,[1,"graphics@"]],["graphics/graphics-unit"]],
["graphics^",">graphics/Graphics_Library_as_a_Unit.html#(form._((lib._graphics/graphics-sig..ss)._graphics~5e))",[0,[6,"graphics^"]],["graphics/graphics-sig"]],
["graphing functions: \"graphing.ss\"",">teachpack/graphing.html",["Graphing Functions: ",[5,"\"graphing.ss\""],"<a name=\"(idx._(gentag._10._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["graphing teachpack",">teachpack/graphing.html#(idx._(gentag._10._(lib._teachpack/teachpack..scrbl)))","graphing teachpack",false],
["graphs",">mrlib/Graphs.html","Graphs",false],
["gray highlight regions",">drscheme/editor.html#(idx._(gentag._18._(lib._scribblings/drscheme/drscheme..scrbl)))","gray highlight\nregions",false],
["greatest common divisor",">reference/numbers.html#(idx._(gentag._15._(lib._scribblings/reference/reference..scrbl)))","greatest common divisor",false],
["greatest-fixnum",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_862",[0,[1,"greatest-fixnum"]],["rnrs/arithmetic/fixnums-6"]],
["greedy",">guide/regexp-quant.html#(tech._greedy)","<i>greedy</i>",false],
["green",">gui/color_.html#(meth._(((lib._mred/main..ss)._color~25)._green))",[[0,[1,"green"]],[12,[" (method of ",[0,[1,"color%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["grey-editor-mixin",">embedded-gui/Helpers.html#(def._((lib._embedded-gui/main..ss)._grey-editor-mixin))",[0,[1,"grey-editor-mixin"]],["embedded-gui"]],
["grey-editor-snip-mixin",">embedded-gui/Helpers.html#(def._((lib._embedded-gui/main..ss)._grey-editor-snip-mixin))",[0,[1,"grey-editor-snip-mixin"]],["embedded-gui"]],
["group",">framework/Group.html","Group",false],
["group-box-panel%",">gui/group-box-panel_.html",[0,[1,"group-box-panel%"]],["scheme/gui/base","scheme/gui"]],
["group:%",">framework/Group.html#(def._((lib._framework/main..ss)._group~3a~25))",[0,[1,"group:%"]],["framework"]],
["group:can-close-check",">framework/Group.html#(def._((lib._framework/main..ss)._group~3acan-close-check))",[0,[1,"group:can-close-check"]],["framework"]],
["group:get-the-frame-group",">framework/Group.html#(def._((lib._framework/main..ss)._group~3aget-the-frame-group))",[0,[1,"group:get-the-frame-group"]],["framework"]],
["group:on-close-action",">framework/Group.html#(def._((lib._framework/main..ss)._group~3aon-close-action))",[0,[1,"group:on-close-action"]],["framework"]],
["grow-box-spacer-pane%",">gui/grow-box-spacer-pane_.html",[0,[1,"grow-box-spacer-pane%"]],["scheme/gui/base","scheme/gui"]],
["guard",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_370",[0,[6,"guard"]],["rnrs/exceptions-6"]],
["guard",">srfi-std/srfi-34.html#guard",[0,[6,"guard"]],["srfi/34"]],
["guard-evt",">reference/sync.html#(def._((lib._scheme/private/misc..ss)._guard-evt))",[0,[1,"guard-evt"]],["scheme/base","scheme"]],
["guarded evaluation: when and unless",">reference/when_unless.html",["Guarded Evaluation: ",[0,[6,"when"]]," and ",[0,[6,"unless"]]],false],
["guess teachpack",">teachpack/guess.html#(idx._(gentag._3._(lib._teachpack/teachpack..scrbl)))","guess teachpack",false],
["guess-with-gui",">teachpack/guess.html#(def._((lib._teachpack/htdp/guess..ss)._guess-with-gui))",[0,[1,"guess-with-gui"]],["teachpack/htdp/guess"]],
["guess-with-gui-3",">teachpack/guess.html#(def._((lib._teachpack/htdp/guess..ss)._guess-with-gui-3))",[0,[1,"guess-with-gui-3"]],["teachpack/htdp/guess"]],
["guess-with-gui-list",">teachpack/guess.html#(def._((lib._teachpack/htdp/guess..ss)._guess-with-gui-list))",[0,[1,"guess-with-gui-list"]],["teachpack/htdp/guess"]],
["guessing numbers: \"guess.ss\"",">teachpack/guess.html",["Guessing Numbers: ",[5,"\"guess.ss\""],"<a name=\"(idx._(gentag._3._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["gui",">redex/GUI.html","GUI",false],
["gui installer",">setup-plt/_plt-archives.html#(part._gui-unpacking)","GUI Installer",false],
["gui teachpack",">teachpack/gui.html#(idx._(gentag._11._(lib._teachpack/teachpack..scrbl)))","gui teachpack",false],
["gui unpacking signature",">setup-plt/_plt-archives.html#(part._.G.U.I_.Unpacking_.Signature)","GUI Unpacking Signature",false],
["gui unpacking unit",">setup-plt/_plt-archives.html#(part._.G.U.I_.Unpacking_.Unit)","GUI Unpacking Unit",false],
["gui utilities",">framework/GUI_Utilities.html","GUI Utilities",false],
["gui-available?",">gui/Dynamic_Loading.html#(def._((lib._scheme/gui/dynamic..ss)._gui-available~3f))",[0,[1,"gui-available?"]],["scheme/gui/dynamic"]],
["gui-dynamic-require",">gui/Dynamic_Loading.html#(def._((lib._scheme/gui/dynamic..ss)._gui-dynamic-require))",[0,[1,"gui-dynamic-require"]],["scheme/gui/dynamic"]],
["gui-item",">teachpack/gui.html#(tech._gui._item)","<i>GUI-ITEM</i>",false],
["gui-utils:cancel-on-right?",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..ss)._gui-utils~3acancel-on-right~3f))",[0,[1,"gui-utils:cancel-on-right?"]],["framework/gui-utils"]],
["gui-utils:cursor-delay",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..ss)._gui-utils~3acursor-delay))",[0,[1,"gui-utils:cursor-delay"]],["framework/gui-utils"]],
["gui-utils:delay-action",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..ss)._gui-utils~3adelay-action))",[0,[1,"gui-utils:delay-action"]],["framework/gui-utils"]],
["gui-utils:format-literal-label",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..ss)._gui-utils~3aformat-literal-label))",[0,[1,"gui-utils:format-literal-label"]],["framework/gui-utils"]],
["gui-utils:get-choice",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..ss)._gui-utils~3aget-choice))",[0,[1,"gui-utils:get-choice"]],["framework/gui-utils"]],
["gui-utils:get-clickback-delta",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..ss)._gui-utils~3aget-clickback-delta))",[0,[1,"gui-utils:get-clickback-delta"]],["framework/gui-utils"]],
["gui-utils:get-clicked-clickback-delta",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..ss)._gui-utils~3aget-clicked-clickback-delta))",[0,[1,"gui-utils:get-clicked-clickback-delta"]],["framework/gui-utils"]],
["gui-utils:local-busy-cursor",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..ss)._gui-utils~3alocal-busy-cursor))",[0,[1,"gui-utils:local-busy-cursor"]],["framework/gui-utils"]],
["gui-utils:next-untitled-name",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..ss)._gui-utils~3anext-untitled-name))",[0,[1,"gui-utils:next-untitled-name"]],["framework/gui-utils"]],
["gui-utils:ok/cancel-buttons",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..ss)._gui-utils~3aok/cancel-buttons))",[0,[1,"gui-utils:ok/cancel-buttons"]],["framework/gui-utils"]],
["gui-utils:quote-literal-label",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..ss)._gui-utils~3aquote-literal-label))",[0,[1,"gui-utils:quote-literal-label"]],["framework/gui-utils"]],
["gui-utils:show-busy-cursor",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..ss)._gui-utils~3ashow-busy-cursor))",[0,[1,"gui-utils:show-busy-cursor"]],["framework/gui-utils"]],
["gui-utils:trim-string",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..ss)._gui-utils~3atrim-string))",[0,[1,"gui-utils:trim-string"]],["framework/gui-utils"]],
["gui-utils:unsaved-warning",">framework/GUI_Utilities.html#(def._((lib._framework/gui-utils..ss)._gui-utils~3aunsaved-warning))",[0,[1,"gui-utils:unsaved-warning"]],["framework/gui-utils"]],
["gui: plt graphics toolkit",">gui/index.html","<b>GUI</b>: PLT Graphics Toolkit",false],
["gui?",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._gui~3f))",[0,[1,"gui?"]],["scheme/sandbox"]],
["guide: plt scheme",">guide/index.html","<b>Guide</b>: PLT Scheme",false],
["guidelines for using assignment",">guide/set_.html#(part._using-set!)","Guidelines for Using Assignment",false],
["guiding mzc --xform",">inside/im_memoryalloc.html#(part._im~3a3m~3amacros)",["Guiding ",[5,"mzc"]," ",[9,[5,"--xform"]]],false],
["guids",">mzcom/index.html#(part._guids)","GUIDs",false],
["guilty-party",">reference/Contract_Utilities.html#(def._((lib._scheme/private/contract-guts..ss)._guilty-party))",[0,[1,"guilty-party"]],["scheme/contract","scheme"]],
["gunzip",">file/gunzip.html#(def._((lib._file/gunzip..ss)._gunzip))",[0,[1,"gunzip"]],["file/gunzip"]],
["gunzip-through-ports",">file/gunzip.html#(def._((lib._file/gunzip..ss)._gunzip-through-ports))",[0,[1,"gunzip-through-ports"]],["file/gunzip"]],
["gzip",">file/gzip.html#(def._((lib._file/gzip..ss)._gzip))",[0,[1,"gzip"]],["file/gzip"]],
["gzip compression and file creation",">file/gzip.html",[[5,"gzip"]," Compression and File Creation"],false],
["gzip decompression",">file/gunzip.html",[[5,"gzip"]," Decompression"],false],
["gzip-through-ports",">file/gzip.html#(def._((lib._file/gzip..ss)._gzip-through-ports))",[0,[1,"gzip-through-ports"]],["file/gzip"]],
["h-expressions",">honu/H-expressions.html","H-expressions",false],
["h-expressions",">honu/index.html#(idx._(gentag._0._(lib._scribblings/honu/honu..scrbl)))","H-expressions",false],
["h1",">html/index.html#(def._((lib._html/main..ss)._h1))",[0,[1,"h1"]],["html"]],
["h1?",">html/index.html#(def._((lib._html/main..ss)._h1~3f))",[0,[1,"h1?"]],["html"]],
["h2",">html/index.html#(def._((lib._html/main..ss)._h2))",[0,[1,"h2"]],["html"]],
["h2?",">html/index.html#(def._((lib._html/main..ss)._h2~3f))",[0,[1,"h2?"]],["html"]],
["h3",">html/index.html#(def._((lib._html/main..ss)._h3))",[0,[1,"h3"]],["html"]],
["h3?",">html/index.html#(def._((lib._html/main..ss)._h3~3f))",[0,[1,"h3?"]],["html"]],
["h4",">html/index.html#(def._((lib._html/main..ss)._h4))",[0,[1,"h4"]],["html"]],
["h4?",">html/index.html#(def._((lib._html/main..ss)._h4~3f))",[0,[1,"h4?"]],["html"]],
["h5",">html/index.html#(def._((lib._html/main..ss)._h5))",[0,[1,"h5"]],["html"]],
["h5?",">html/index.html#(def._((lib._html/main..ss)._h5~3f))",[0,[1,"h5?"]],["html"]],
["h6",">html/index.html#(def._((lib._html/main..ss)._h6))",[0,[1,"h6"]],["html"]],
["h6?",">html/index.html#(def._((lib._html/main..ss)._h6~3f))",[0,[1,"h6?"]],["html"]],
["handle-events",">mysterx/browsers.html#(meth._(((lib._mysterx/main..ss)._mx-browser~25)._handle-events))",[[0,[1,"handle-events"]],[12,[" (method of ",[0,[1,"mx-browser%"]],")"]]],["mysterx"]],
["handle-evt",">reference/sync.html#(def._((quote._~23~25kernel)._handle-evt))",[0,[1,"handle-evt"]],["scheme/base","scheme"]],
["handle-evt?",">reference/sync.html#(def._((quote._~23~25kernel)._handle-evt~3f))",[0,[1,"handle-evt?"]],["scheme/base","scheme"]],
["handle-key-event",">gui/keymap_.html#(meth._(((lib._mred/main..ss)._keymap~25)._handle-key-event))",[[0,[1,"handle-key-event"]],[12,[" (method of ",[0,[1,"keymap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["handle-mouse-event",">gui/keymap_.html#(meth._(((lib._mred/main..ss)._keymap~25)._handle-mouse-event))",[[0,[1,"handle-mouse-event"]],[12,[" (method of ",[0,[1,"keymap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["handler",">framework/Handler.html","Handler",false],
["handler thread",">gui/windowing-overview.html#(tech._handler._thread)","<i>handler thread</i>",false],
["handler:add-to-recent",">framework/Handler.html#(def._((lib._framework/main..ss)._handler~3aadd-to-recent))",[0,[1,"handler:add-to-recent"]],["framework"]],
["handler:current-create-new-window",">framework/Handler.html#(def._((lib._framework/main..ss)._handler~3acurrent-create-new-window))",[0,[1,"handler:current-create-new-window"]],["framework"]],
["handler:edit-file",">framework/Handler.html#(def._((lib._framework/main..ss)._handler~3aedit-file))",[0,[1,"handler:edit-file"]],["framework"]],
["handler:find-format-handler",">framework/Handler.html#(def._((lib._framework/main..ss)._handler~3afind-format-handler))",[0,[1,"handler:find-format-handler"]],["framework"]],
["handler:find-named-format-handler",">framework/Handler.html#(def._((lib._framework/main..ss)._handler~3afind-named-format-handler))",[0,[1,"handler:find-named-format-handler"]],["framework"]],
["handler:handler-extension",">framework/Handler.html#(def._((lib._framework/main..ss)._handler~3ahandler-extension))",[0,[1,"handler:handler-extension"]],["framework"]],
["handler:handler-handler",">framework/Handler.html#(def._((lib._framework/main..ss)._handler~3ahandler-handler))",[0,[1,"handler:handler-handler"]],["framework"]],
["handler:handler-name",">framework/Handler.html#(def._((lib._framework/main..ss)._handler~3ahandler-name))",[0,[1,"handler:handler-name"]],["framework"]],
["handler:handler?",">framework/Handler.html#(def._((lib._framework/main..ss)._handler~3ahandler~3f))",[0,[1,"handler:handler?"]],["framework"]],
["handler:insert-format-handler",">framework/Handler.html#(def._((lib._framework/main..ss)._handler~3ainsert-format-handler))",[0,[1,"handler:insert-format-handler"]],["framework"]],
["handler:install-recent-items",">framework/Handler.html#(def._((lib._framework/main..ss)._handler~3ainstall-recent-items))",[0,[1,"handler:install-recent-items"]],["framework"]],
["handler:open-file",">framework/Handler.html#(def._((lib._framework/main..ss)._handler~3aopen-file))",[0,[1,"handler:open-file"]],["framework"]],
["handler:set-recent-items-frame-superclass",">framework/Handler.html#(def._((lib._framework/main..ss)._handler~3aset-recent-items-frame-superclass))",[0,[1,"handler:set-recent-items-frame-superclass"]],["framework"]],
["handler:set-recent-position",">framework/Handler.html#(def._((lib._framework/main..ss)._handler~3aset-recent-position))",[0,[1,"handler:set-recent-position"]],["framework"]],
["handler:size-recently-opened-files",">framework/Handler.html#(def._((lib._framework/main..ss)._handler~3asize-recently-opened-files))",[0,[1,"handler:size-recently-opened-files"]],["framework"]],
["handles-events",">gui/snip_.html#(idx._(gentag._250._(lib._scribblings/gui/gui..scrbl)))",[7,"'handles-events"],false],
["handles-events",">gui/snip_.html#(idx._(gentag._257._(lib._scribblings/gui/gui..scrbl)))",[7,"'handles-events"],false],
["handles-events",">gui/snip_.html#(idx._(gentag._258._(lib._scribblings/gui/gui..scrbl)))",[7,"'handles-events"],false],
["handling exceptions",">reference/exns.html#(part._.Handling_.Exceptions)","Handling Exceptions",false],
["hangman",">teachpack/hangman.html#(def._((lib._teachpack/htdp/hangman..ss)._hangman))",[0,[1,"hangman"]],["teachpack/htdp/hangman"]],
["hangman teachpack",">teachpack/hangman.html#(idx._(gentag._6._(lib._teachpack/teachpack..scrbl)))","hangman teachpack",false],
["hangman-list",">teachpack/hangman.html#(def._((lib._teachpack/htdp/hangman..ss)._hangman-list))",[0,[1,"hangman-list"]],["teachpack/htdp/hangman"]],
["hangman: \"hangman.ss\"",">teachpack/hangman.html",["Hangman: ",[5,"\"hangman.ss\""],"<a name=\"(idx._(gentag._6._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["hard-newline",">gui/snip_.html#(idx._(gentag._248._(lib._scribblings/gui/gui..scrbl)))",[7,"'hard-newline"],false],
["has-focus?",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._has-focus~3f))",[[0,[1,"has-focus?"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["has-focus?",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abasic~3c~25~3e)._has-focus~3f))",[[0,[1,"has-focus?"]],[12,[" (method of ",[0,[1,"editor:basic&lt;%&gt;"]],")"]]],["framework"]],
["has-status-line?",">gui/frame_.html#(meth._(((lib._mred/main..ss)._frame~25)._has-status-line~3f))",[[0,[1,"has-status-line?"]],[12,[" (method of ",[0,[1,"frame%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["hash",">reference/hashtables.html#(tech._hash)","<i>hash</i>",false],
["hash table",">reference/hashtables.html#(tech._hash._table)","<i>hash table</i>",false],
["hash tables",">guide/hash-tables.html","Hash Tables",false],
["hash tables",">reference/hashtables.html","Hash Tables",false],
["hash-copy",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-copy))",[0,[1,"hash-copy"]],["scheme/base","scheme"]],
["hash-count",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-count))",[0,[1,"hash-count"]],["scheme/base","scheme"]],
["hash-eq?",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-eq~3f))",[0,[1,"hash-eq?"]],["scheme/base","scheme"]],
["hash-eqv?",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-eqv~3f))",[0,[1,"hash-eqv?"]],["scheme/base","scheme"]],
["hash-for-each",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-for-each))",[0,[1,"hash-for-each"]],["scheme/base","scheme"]],
["hash-iterate-first",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-iterate-first))",[0,[1,"hash-iterate-first"]],["scheme/base","scheme"]],
["hash-iterate-key",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-iterate-key))",[0,[1,"hash-iterate-key"]],["scheme/base","scheme"]],
["hash-iterate-next",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-iterate-next))",[0,[1,"hash-iterate-next"]],["scheme/base","scheme"]],
["hash-iterate-value",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-iterate-value))",[0,[1,"hash-iterate-value"]],["scheme/base","scheme"]],
["hash-lang",">scribble/Miscellaneous.html#(def._((lib._scribble/manual..ss)._hash-lang))",[0,[1,"hash-lang"]],["scribble/manual"]],
["hash-map",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-map))",[0,[1,"hash-map"]],["scheme/base","scheme"]],
["hash-placeholder?",">reference/pairs.html#(def._((quote._~23~25kernel)._hash-placeholder~3f))",[0,[1,"hash-placeholder?"]],["scheme/base","scheme"]],
["hash-ref",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-ref))",[0,[1,"hash-ref"]],["scheme/base","scheme"]],
["hash-remove",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-remove))",[0,[1,"hash-remove"]],["scheme/base","scheme"]],
["hash-remove!",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-remove!))",[0,[1,"hash-remove!"]],["scheme/base","scheme"]],
["hash-set",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-set))",[0,[1,"hash-set"]],["scheme/base","scheme"]],
["hash-set!",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-set!))",[0,[1,"hash-set!"]],["scheme/base","scheme"]],
["hash-table",">mzlib/mzlib_etc.html#(form._((lib._mzlib/etc..ss)._hash-table))",[0,[6,"hash-table"]],["mzlib/etc"]],
["hash-table?",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..ss)._hash-table~3f))",[0,[1,"hash-table?"]],["mzscheme"]],
["hash-update",">reference/hashtables.html#(def._((lib._scheme/private/more-scheme..ss)._hash-update))",[0,[1,"hash-update"]],["scheme/base","scheme"]],
["hash-update!",">reference/hashtables.html#(def._((lib._scheme/private/more-scheme..ss)._hash-update!))",[0,[1,"hash-update!"]],["scheme/base","scheme"]],
["hash-weak?",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash-weak~3f))",[0,[1,"hash-weak?"]],["scheme/base","scheme"]],
["hash?",">reference/hashtables.html#(def._((quote._~23~25kernel)._hash~3f))",[0,[1,"hash?"]],["scheme/base","scheme"]],
["hashing on bound-identifier=? and free-identifier=?",">syntax/syntax-helpers.html#(part._boundmap)",["Hashing on ",[0,[1,"bound-identifier=?"]]," and ",[0,[1,"free-identifier=?"]]],false],
["hashtable-clear!",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1204",[0,[1,"hashtable-clear!"]],["rnrs/hashtables-6"]],
["hashtable-contains?",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1196",[0,[1,"hashtable-contains?"]],["rnrs/hashtables-6"]],
["hashtable-copy",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1200",[0,[1,"hashtable-copy"]],["rnrs/hashtables-6"]],
["hashtable-delete!",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1194",[0,[1,"hashtable-delete!"]],["rnrs/hashtables-6"]],
["hashtable-entries",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1210",[0,[1,"hashtable-entries"]],["rnrs/hashtables-6"]],
["hashtable-equivalence-function",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1212",[0,[1,"hashtable-equivalence-function"]],["rnrs/hashtables-6"]],
["hashtable-hash-function",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1214",[0,[1,"hashtable-hash-function"]],["rnrs/hashtables-6"]],
["hashtable-keys",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1208",[0,[1,"hashtable-keys"]],["rnrs/hashtables-6"]],
["hashtable-mutable?",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1216",[0,[1,"hashtable-mutable?"]],["rnrs/hashtables-6"]],
["hashtable-ref",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1190",[0,[1,"hashtable-ref"]],["rnrs/hashtables-6"]],
["hashtable-set!",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1192",[0,[1,"hashtable-set!"]],["rnrs/hashtables-6"]],
["hashtable-size",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1188",[0,[1,"hashtable-size"]],["rnrs/hashtables-6"]],
["hashtable-update!",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1198",[0,[1,"hashtable-update!"]],["rnrs/hashtables-6"]],
["hashtable?",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1186",[0,[1,"hashtable?"]],["rnrs/hashtables-6"]],
["hb-append",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..ss)._hb-append))",[0,[1,"hb-append"]],["slideshow/pict","slideshow"]],
["hbl-append",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..ss)._hbl-append))",[0,[1,"hbl-append"]],["slideshow/pict","slideshow"]],
["hc-append",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..ss)._hc-append))",[0,[1,"hc-append"]],["slideshow/pict","slideshow"]],
["head",">html/index.html#(def._((lib._html/main..ss)._head))",[0,[1,"head"]],["html"]],
["head-impure-port",">net/url.html#(def._((lib._net/url..ss)._head-impure-port))",[0,[1,"head-impure-port"]],["net/url"]],
["head-of-message",">net/nntp.html#(def._((lib._net/nntp..ss)._head-of-message))",[0,[1,"head-of-message"]],["net/nntp"]],
["head-pure-port",">net/url.html#(def._((lib._net/url..ss)._head-pure-port))",[0,[1,"head-pure-port"]],["net/url"]],
["head?",">html/index.html#(def._((lib._html/main..ss)._head~3f))",[0,[1,"head?"]],["html"]],
["head@",">net/head.html#(def._((lib._net/head-unit..ss)._head~40))",[0,[1,"head@"]],["net/head-unit"]],
["head^",">net/head.html#(form._((lib._net/head-sig..ss)._head~5e))",[0,[6,"head^"]],["net/head-sig"]],
["header",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._header))",[0,[1,"header"]],["web-server/private/request-structs"]],
["header",">net/head.html#(tech._header)","<i>header</i>",false],
["header files",">inside/overview.html#(idx._(gentag._3._(lib._scribblings/inside/inside..scrbl)))","header files",false],
["header signature",">net/head.html#(part._.Header_.Signature)","Header Signature",false],
["header unit",">net/head.html#(part._.Header_.Unit)","Header Unit",false],
["header-field",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._header-field))",[0,[1,"header-field"]],["web-server/private/request-structs"]],
["header-value",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._header-value))",[0,[1,"header-value"]],["web-server/private/request-structs"]],
["header?",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._header~3f))",[0,[1,"header?"]],["web-server/private/request-structs"]],
["headers-assq",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._headers-assq))",[0,[1,"headers-assq"]],["web-server/private/request-structs"]],
["headers-assq*",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._headers-assq*))",[0,[1,"headers-assq*"]],["web-server/private/request-structs"]],
["headers: parsing and constructing",">net/head.html","Headers: Parsing and Constructing",false],
["height",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._height))",[[0,[1,"height"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["height-depends-on-x",">gui/snip_.html#(idx._(gentag._254._(lib._scribblings/gui/gui..scrbl)))",[7,"'height-depends-on-x"],false],
["height-depends-on-y",">gui/snip_.html#(idx._(gentag._252._(lib._scribblings/gui/gui..scrbl)))",[7,"'height-depends-on-y"],false],
["height-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._height-native))",[[0,[1,"height-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["help",">drscheme/Menus.html#(part._.Help)","<b><font size=\"-1\" face=\"Helvetica\">Help</font></b>",false],
["help",">reference/Interactive_Help.html#(form._((lib._scheme/help..ss)._help))",[0,[6,"help"]],["scheme/help","scheme/init"]],
["help",">gui/key-event_.html#(idx._(gentag._68._(lib._scribblings/gui/gui..scrbl)))",[7,"'help"],false],
["help desk menu item",">drscheme/Menus.html#(idx._(gentag._145._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Help Desk</font></b> menu item",false],
["help-menu:about-callback",">tools/drscheme_frame.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aframe~3abasics-mixin)._help-menu~3aabout-callback))",[[0,[1,"help-menu:about-callback"]],[12,[" (method of ",[0,[1,"drscheme:frame:basics-mixin"]],")"]]],["drscheme/tool-lib"]],
["help-menu:about-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor-mixin)._help-menu~3aabout-callback))",[[0,[1,"help-menu:about-callback"]],[12,[" (method of ",[0,[1,"frame:editor-mixin"]],")"]]],["framework"]],
["help-menu:about-callback",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._help-menu~3aabout-callback))",[[0,[1,"help-menu:about-callback"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["help-menu:about-help-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._help-menu~3aabout-help-string))",[[0,[1,"help-menu:about-help-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["help-menu:about-on-demand",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._help-menu~3aabout-on-demand))",[[0,[1,"help-menu:about-on-demand"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["help-menu:about-string",">tools/drscheme_frame.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aframe~3abasics-mixin)._help-menu~3aabout-string))",[[0,[1,"help-menu:about-string"]],[12,[" (method of ",[0,[1,"drscheme:frame:basics-mixin"]],")"]]],["drscheme/tool-lib"]],
["help-menu:about-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor-mixin)._help-menu~3aabout-string))",[[0,[1,"help-menu:about-string"]],[12,[" (method of ",[0,[1,"frame:editor-mixin"]],")"]]],["framework"]],
["help-menu:about-string",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._help-menu~3aabout-string))",[[0,[1,"help-menu:about-string"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["help-menu:after-about",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._help-menu~3aafter-about))",[[0,[1,"help-menu:after-about"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["help-menu:before-about",">tools/drscheme_frame.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aframe~3abasics-mixin)._help-menu~3abefore-about))",[[0,[1,"help-menu:before-about"]],[12,[" (method of ",[0,[1,"drscheme:frame:basics-mixin"]],")"]]],["drscheme/tool-lib"]],
["help-menu:before-about",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._help-menu~3abefore-about))",[[0,[1,"help-menu:before-about"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["help-menu:create-about?",">tools/drscheme_frame.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aframe~3abasics-mixin)._help-menu~3acreate-about~3f))",[[0,[1,"help-menu:create-about?"]],[12,[" (method of ",[0,[1,"drscheme:frame:basics-mixin"]],")"]]],["drscheme/tool-lib"]],
["help-menu:create-about?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor-mixin)._help-menu~3acreate-about~3f))",[[0,[1,"help-menu:create-about?"]],[12,[" (method of ",[0,[1,"frame:editor-mixin"]],")"]]],["framework"]],
["help-menu:create-about?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._help-menu~3acreate-about~3f))",[[0,[1,"help-menu:create-about?"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["help-menu:get-about-item",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._help-menu~3aget-about-item))",[[0,[1,"help-menu:get-about-item"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["helper functions",">dynext/Linking.html#(part._.Helper_.Functions)","Helper Functions",false],
["helper functions",">dynext/Compilation.html#(part._.Helper_functions)","Helper functions",false],
["helpers",">embedded-gui/Helpers.html","Helpers",false],
["helpers",">web-server/helpers_ss.html","Helpers",false],
["here strings",">reference/reader.html#(idx._(gentag._170._(lib._scribblings/reference/reference..scrbl)))","here strings",false],
["hidden",">gui/windowing-overview.html#(tech._hidden)","<i>hidden</i>",false],
["hide definitions menu item",">drscheme/Menus.html#(idx._(gentag._98._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Hide Definitions</font></b> menu item",false],
["hide interactions menu item",">drscheme/Menus.html#(idx._(gentag._100._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Hide Interactions</font></b> menu item",false],
["hide module browser menu item",">drscheme/Menus.html#(idx._(gentag._104._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Hide Module Browser</font></b> menu item",false],
["hide profile menu item",">drscheme/Menus.html#(idx._(gentag._108._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Hide Profile</font></b> menu item",false],
["hide program contour menu item",">drscheme/Menus.html#(idx._(gentag._102._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Hide Program Contour</font></b> menu item",false],
["hide toolbar menu item",">drscheme/Menus.html#(idx._(gentag._106._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Hide Toolbar</font></b> menu item",false],
["hide tracing menu item",">drscheme/Menus.html#(idx._(gentag._112._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Hide Tracing</font></b> menu item",false],
["hide-caret",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._hide-caret))",[[0,[1,"hide-caret"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["hide-cursor-until-moved",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._hide-cursor-until-moved))",[0,[1,"hide-cursor-until-moved"]],["scheme/gui/base","scheme/gui"]],
["hide-delegated-text",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3adelegate~3c~25~3e)._hide-delegated-text))",[[0,[1,"hide-delegated-text"]],[12,[" (method of ",[0,[1,"frame:delegate&lt;%&gt;"]],")"]]],["framework"]],
["hide-hole",">redex/Patterns.html#(tech._hide._hole)","<i>hide-hole</i>",false],
["hide-info",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3ainfo~3c~25~3e)._hide-info))",[[0,[1,"hide-info"]],[12,[" (method of ",[0,[1,"frame:info&lt;%&gt;"]],")"]]],["framework"]],
["hide-search",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable~3c~25~3e)._hide-search))",[[0,[1,"hide-search"]],[12,[" (method of ",[0,[1,"frame:searchable&lt;%&gt;"]],")"]]],["framework"]],
["hide-window",">teachpack/gui.html#(def._((lib._teachpack/htdp/gui..ss)._hide-window))",[0,[1,"hide-window"]],["teachpack/htdp/gui"]],
["hierarchical list control",">mrlib/Hierarchical_List_Control.html","Hierarchical List Control",false],
["hierarchical-item-snip%",">mrlib/Snips_in_a_hierarchical-list__Instance.html#(def._((lib._mrlib/hierlist..ss)._hierarchical-item-snip~25))",[0,[1,"hierarchical-item-snip%"]],["mrlib/hierlist"]],
["hierarchical-list%",">mrlib/hierarchical-list_.html",[0,[1,"hierarchical-list%"]],["mrlib/hierlist"]],
["hierarchical-list-compound-item<%>",">mrlib/hierarchical-list-compound-item___.html",[0,[1,"hierarchical-list-compound-item&lt;%&gt;"]],["mrlib/hierlist"]],
["hierarchical-list-item<%>",">mrlib/hierarchical-list-item___.html",[0,[1,"hierarchical-list-item&lt;%&gt;"]],["mrlib/hierlist"]],
["hierarchical-list-snip%",">mrlib/Snips_in_a_hierarchical-list__Instance.html#(def._((lib._mrlib/hierlist..ss)._hierarchical-list-snip~25))",[0,[1,"hierarchical-list-snip%"]],["mrlib/hierlist"]],
["highlight-errors",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3atext~25)._highlight-errors))",[[0,[1,"highlight-errors"]],[12,[" (method of ",[0,[1,"drscheme:rep:text%"]],")"]]],["drscheme/tool-lib"]],
["highlight-errors/exn",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3atext~25)._highlight-errors/exn))",[[0,[1,"highlight-errors/exn"]],[12,[" (method of ",[0,[1,"drscheme:rep:text%"]],")"]]],["drscheme/tool-lib"]],
["highlight-first-line",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3afirst-line~3c~25~3e)._highlight-first-line))",[[0,[1,"highlight-first-line"]],[12,[" (method of ",[0,[1,"text:first-line&lt;%&gt;"]],")"]]],["framework"]],
["highlight-range",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3abasic~3c~25~3e)._highlight-range))",[[0,[1,"highlight-range"]],[12,[" (method of ",[0,[1,"text:basic&lt;%&gt;"]],")"]]],["framework"]],
["highlight-range",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3adelegate-mixin)._highlight-range))",[[0,[1,"highlight-range"]],[12,[" (method of ",[0,[1,"text:delegate-mixin"]],")"]]],["framework"]],
["hilite",">gui/brush_.html#(idx._(gentag._180._(lib._scribblings/gui/gui..scrbl)))",[7,"'hilite"],false],
["hilite",">gui/pen_.html#(idx._(gentag._219._(lib._scribblings/gui/gui..scrbl)))",[7,"'hilite"],false],
["hilite-region",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._hilite-region))",[[0,[1,"hilite-region"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["history-delete",">readline/index.html#(def._((lib._readline/readline..ss)._history-delete))",[0,[1,"history-delete"]],["readline/readline"]],
["history-get",">readline/index.html#(def._((lib._readline/readline..ss)._history-get))",[0,[1,"history-get"]],["readline/readline"]],
["history-length",">readline/index.html#(def._((lib._readline/readline..ss)._history-length))",[0,[1,"history-length"]],["readline/readline"]],
["hkey_classes_root",">gui/Windowing_Functions.html#(idx._(gentag._155._(lib._scribblings/gui/gui..scrbl)))",[7,"\"HKEY_CLASSES_ROOT\""],false],
["hkey_current_config",">gui/Windowing_Functions.html#(idx._(gentag._156._(lib._scribblings/gui/gui..scrbl)))",[7,"\"HKEY_CURRENT_CONFIG\""],false],
["hkey_current_user",">gui/Windowing_Functions.html#(idx._(gentag._157._(lib._scribblings/gui/gui..scrbl)))",[7,"\"HKEY_CURRENT_USER\""],false],
["hkey_local_machine",">gui/Windowing_Functions.html#(idx._(gentag._158._(lib._scribblings/gui/gui..scrbl)))",[7,"\"HKEY_LOCAL_MACHINE\""],false],
["hkey_users",">gui/Windowing_Functions.html#(idx._(gentag._159._(lib._scribblings/gui/gui..scrbl)))",[7,"\"HKEY_USERS\""],false],
["hline",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._hline))",[0,[1,"hline"]],["slideshow/pict","slideshow"]],
["hline%",">embedded-gui/hline_.html",[0,[1,"hline%"]],["embedded-gui"]],
["hold",">frtime/index.html#(def._((lib._frtime/main..ss)._hold))",[0,[1,"hold"]],["frtime"]],
["hole",">redex/Patterns.html#(tech._hole)","<i>hole</i>",false],
["home",">reference/Filesystem.html#(idx._(gentag._238._(lib._scribblings/reference/reference..scrbl)))",[5,"HOME"],false],
["home",">gui/key-event_.html#(idx._(gentag._57._(lib._scribblings/gui/gui..scrbl)))",[7,"'home"],false],
["home-dir",">reference/Filesystem.html#(idx._(gentag._237._(lib._scribblings/reference/reference..scrbl)))",[7,"'home-dir"],false],
["home-region",">cards/index.html#(meth._(((lib._games/cards..ss)._card~3c~25~3e)._home-region))",[[0,[1,"home-region"]],[12,[" (method of ",[0,[1,"card&lt;%&gt;"]],")"]]],["games/cards"]],
["home-vicinity",">srfi-std/srfi-59.html#home-vicinity",[0,[1,"home-vicinity"]],["srfi/59"]],
["homedrive",">reference/Filesystem.html#(idx._(gentag._242._(lib._scribblings/reference/reference..scrbl)))",[5,"HOMEDRIVE"],false],
["homepath",">reference/Filesystem.html#(idx._(gentag._243._(lib._scribblings/reference/reference..scrbl)))",[5,"HOMEPATH"],false],
["honu",">honu/index.html","<b>Honu</b>",false],
["honu output printing",">honu/H-expressions.html#(part._.Honu_.Output_.Printing)","Honu Output Printing",false],
["honu parsing",">reference/reader.html#(part._parse-honu)","Honu Parsing",false],
["horiz-margin",">gui/subarea___.html#(meth._(((lib._mred/main..ss)._subarea~3c~25~3e)._horiz-margin))",[[0,[1,"horiz-margin"]],[12,[" (method of ",[0,[1,"subarea&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["horiz-margin",">gui/subarea___.html#(idx._(gentag._128._(lib._scribblings/gui/gui..scrbl)))",[0,"horiz-margin"],false],
["horizontal-alignment%",">embedded-gui/horizontal-alignment_.html",[0,[1,"horizontal-alignment%"]],["embedded-gui"]],
["horizontal-hatch",">gui/brush_.html#(idx._(gentag._187._(lib._scribblings/gui/gui..scrbl)))",[7,"'horizontal-hatch"],false],
["horizontal-inset",">gui/editor-canvas_.html#(meth._(((lib._mred/main..ss)._editor-canvas~25)._horizontal-inset))",[[0,[1,"horizontal-inset"]],[12,[" (method of ",[0,[1,"editor-canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["horizontal-label-space",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._horizontal-label-space))",[0,"horizontal-label-space"],["redex/pict"]],
["horizontal-pane%",">gui/horizontal-pane_.html",[0,[1,"horizontal-pane%"]],["scheme/gui/base","scheme/gui"]],
["horizontal-panel%",">gui/horizontal-panel_.html",[0,[1,"horizontal-panel%"]],["scheme/gui/base","scheme/gui"]],
["horizontal-pasteboard%",">mrlib/horizontal-pasteboard_.html",[0,[1,"horizontal-pasteboard%"]],["mrlib/aligned-pasteboard"]],
["host",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._host))",[0,[1,"host"]],["web-server/configuration/configuration-table-structs"]],
["host-indices",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._host-indices))",[0,[1,"host-indices"]],["web-server/configuration/configuration-table-structs"]],
["host-log-format",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._host-log-format))",[0,[1,"host-log-format"]],["web-server/configuration/configuration-table-structs"]],
["host-log-path",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._host-log-path))",[0,[1,"host-log-path"]],["web-server/configuration/configuration-table-structs"]],
["host-passwords",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._host-passwords))",[0,[1,"host-passwords"]],["web-server/configuration/configuration-table-structs"]],
["host-paths",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._host-paths))",[0,[1,"host-paths"]],["web-server/configuration/configuration-table-structs"]],
["host-responders",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._host-responders))",[0,[1,"host-responders"]],["web-server/configuration/configuration-table-structs"]],
["host-table",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._host-table))",[0,[1,"host-table"]],["web-server/configuration/configuration-table-structs"]],
["host-table-indices",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._host-table-indices))",[0,[1,"host-table-indices"]],["web-server/configuration/configuration-table-structs"]],
["host-table-log-format",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._host-table-log-format))",[0,[1,"host-table-log-format"]],["web-server/configuration/configuration-table-structs"]],
["host-table-messages",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._host-table-messages))",[0,[1,"host-table-messages"]],["web-server/configuration/configuration-table-structs"]],
["host-table-paths",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._host-table-paths))",[0,[1,"host-table-paths"]],["web-server/configuration/configuration-table-structs"]],
["host-table-timeouts",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._host-table-timeouts))",[0,[1,"host-table-timeouts"]],["web-server/configuration/configuration-table-structs"]],
["host-table?",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._host-table~3f))",[0,[1,"host-table?"]],["web-server/configuration/configuration-table-structs"]],
["host-timeouts",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._host-timeouts))",[0,[1,"host-timeouts"]],["web-server/configuration/configuration-table-structs"]],
["host?",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._host~3f))",[0,[1,"host?"]],["web-server/configuration/configuration-table-structs"]],
["hover-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._hover-element))",[0,[1,"hover-element"]],["scribble/struct"]],
["hover-element-text",">scribble/struct.html#(def._((lib._scribble/struct..ss)._hover-element-text))",[0,[1,"hover-element-text"]],["scribble/struct"]],
["hover-element?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._hover-element~3f))",[0,[1,"hover-element?"]],["scribble/struct"]],
["how do i set up the server to use https?",">web-server/Troubleshooting.html#(part._faq~3ahttps)","How do I set up the server to use HTTPS?",false],
["how do i use apache with the plt web server?",">web-server/Troubleshooting.html#(part._.How_do_.I_use_.Apache_with_the_.P.L.T_.Web_.Server_)","How do I use Apache with the PLT Web Server?",false],
["how to design classes languages",">htdc/index.html","<i>How to Design Classes</i> Languages",false],
["how to design programs languages",">htdp-langs/index.html","<i>How to Design Programs</i> Languages",false],
["how to design programs teaching languages",">drscheme/htdp-langs.html","<i>How to Design Programs</i> Teaching Languages",false],
["how to scribble documentation",">scribble/How_to_Scribble_Documentation.html","How to Scribble Documentation",false],
["hr",">html/index.html#(def._((lib._html/main..ss)._hr))",[0,[1,"hr"]],["html"]],
["hr?",">html/index.html#(def._((lib._html/main..ss)._hr~3f))",[0,[1,"hr?"]],["html"]],
["hscroll",">gui/canvas_.html#(idx._(gentag._32._(lib._scribblings/gui/gui..scrbl)))",[7,"'hscroll"],false],
["hscroll",">gui/canvas_.html#(idx._(gentag._34._(lib._scribblings/gui/gui..scrbl)))",[7,"'hscroll"],false],
["hspace",">scribble/basic.html#(def._((lib._scribble/basic..ss)._hspace))",[0,[1,"hspace"]],["scribble/basic"]],
["ht-append",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..ss)._ht-append))",[0,[1,"ht-append"]],["slideshow/pict","slideshow"]],
["htdc teachpacks",">teachpack/htdc.html","HtDC Teachpacks",false],
["htdp advanced student",">htdp-lib/index.html#(part._.Ht.D.P_.Advanced_.Student)","<i>HtDP</i> Advanced Student",false],
["htdp beginning student",">htdp-lib/index.html#(part._.Ht.D.P_.Beginning_.Student)","<i>HtDP</i> Beginning Student",false],
["htdp beginning student with abbreviations",">htdp-lib/index.html#(part._.Ht.D.P_.Beginning_.Student_with_.Abbreviations)","<i>HtDP</i> Beginning Student with Abbreviations",false],
["htdp intermediate student",">htdp-lib/index.html#(part._.Ht.D.P_.Intermediate_.Student)","<i>HtDP</i> Intermediate Student",false],
["htdp intermediate student with lambda",">htdp-lib/index.html#(part._.Ht.D.P_.Intermediate_.Student_with_.Lambda)","<i>HtDP</i> Intermediate Student with Lambda",false],
["htdp teachpacks",">teachpack/htdp.html","HtDP Teachpacks",false],
["htdp: languages as libraries",">htdp-lib/index.html","<b>HtDP</b>: Languages as Libraries",false],
["htl-append",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..ss)._htl-append))",[0,[1,"htl-append"]],["slideshow/pict","slideshow"]],
["html",">html/index.html",[14,[0,[1,"html"]]],"module"],
["html",">html/index.html#(def._((lib._html/main..ss)._html))",[0,[1,"html"]],["html"]],
["html and dynamic html",">mysterx/html.html","HTML and Dynamic HTML",false],
["html as text editor",">browser/index.html#(part._html-text)","HTML As Text Editor",false],
["html elements",">mysterx/html-element.html","HTML Elements",false],
["html events",">mysterx/html-events.html","HTML Events",false],
["html renderer",">scribble/renderer.html#(part._.H.T.M.L_.Renderer)","HTML Renderer",false],
["html structures",">html/index.html#(part._.H.T.M.L_.Structures)","HTML Structures",false],
["html-element",">html/index.html#(def._((lib._html/main..ss)._html-element))",[0,[1,"html-element"]],["html"]],
["html-element-attributes",">html/index.html#(def._((lib._html/main..ss)._html-element-attributes))",[0,[1,"html-element-attributes"]],["html"]],
["html-element?",">html/index.html#(def._((lib._html/main..ss)._html-element~3f))",[0,[1,"html-element?"]],["html"]],
["html-empty-tags",">xml/index.html#(def._((lib._xml/main..ss)._html-empty-tags))",[0,[1,"html-empty-tags"]],["xml"]],
["html-eval-ok",">browser/index.html#(def._((lib._browser/main..ss)._html-eval-ok))",[0,[1,"html-eval-ok"]],["browser"]],
["html-full",">html/index.html#(def._((lib._html/main..ss)._html-full))",[0,[1,"html-full"]],["html"]],
["html-full-content",">html/index.html#(def._((lib._html/main..ss)._html-full-content))",[0,[1,"html-full-content"]],["html"]],
["html-full?",">html/index.html#(def._((lib._html/main..ss)._html-full~3f))",[0,[1,"html-full?"]],["html"]],
["html-img-ok",">browser/index.html#(def._((lib._browser/main..ss)._html-img-ok))",[0,[1,"html-img-ok"]],["browser"]],
["html-text-mixin",">browser/index.html#(def._((lib._browser/htmltext..ss)._html-text-mixin))",[0,[1,"html-text-mixin"]],["browser/htmltext"]],
["html-text<%>",">browser/index.html#(def._((lib._browser/htmltext..ss)._html-text~3c~25~3e))",[0,[1,"html-text&lt;%&gt;"]],["browser/htmltext"]],
["html: parsing library",">html/index.html","<b>HTML</b>: Parsing Library",false],
["html?",">html/index.html#(def._((lib._html/main..ss)._html~3f))",[0,[1,"html?"]],["html"]],
["http requests",">web-server/request-structs_ss.html","HTTP Requests",false],
["http responses",">web-server/response-structs_ss.html","HTTP Responses",false],
["http-download-servlet-url",">planet/Utility_Libraries.html#(def._((lib._planet/config..ss)._.H.T.T.P-.D.O.W.N.L.O.A.D-.S.E.R.V.L.E.T-.U.R.L))",[0,[1,"HTTP-DOWNLOAD-SERVLET-URL"]],["planet/config"]],
["hyper-canvas-mixin",">browser/index.html#(def._((lib._browser/main..ss)._hyper-canvas-mixin))",[0,[1,"hyper-canvas-mixin"]],["browser"]],
["hyper-delta",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-text-mixin)._hyper-delta))",[[0,[1,"hyper-delta"]],[12,[" (method of ",[0,[1,"hyper-text-mixin"]],")"]]],["browser"]],
["hyper-frame%",">browser/index.html#(def._((lib._browser/main..ss)._hyper-frame~25))",[0,[1,"hyper-frame%"]],["browser"]],
["hyper-frame-mixin",">browser/index.html#(def._((lib._browser/main..ss)._hyper-frame-mixin))",[0,[1,"hyper-frame-mixin"]],["browser"]],
["hyper-no-show-frame%",">browser/index.html#(def._((lib._browser/main..ss)._hyper-no-show-frame~25))",[0,[1,"hyper-no-show-frame%"]],["browser"]],
["hyper-no-show-frame-mixin",">browser/index.html#(def._((lib._browser/main..ss)._hyper-no-show-frame-mixin))",[0,[1,"hyper-no-show-frame-mixin"]],["browser"]],
["hyper-panel%",">browser/index.html#(def._((lib._browser/main..ss)._hyper-panel~25))",[0,[1,"hyper-panel%"]],["browser"]],
["hyper-panel-mixin",">browser/index.html#(def._((lib._browser/main..ss)._hyper-panel-mixin))",[0,[1,"hyper-panel-mixin"]],["browser"]],
["hyper-text%",">browser/index.html#(def._((lib._browser/main..ss)._hyper-text~25))",[0,[1,"hyper-text%"]],["browser"]],
["hyper-text-mixin",">browser/index.html#(def._((lib._browser/main..ss)._hyper-text-mixin))",[0,[1,"hyper-text-mixin"]],["browser"]],
["hyperlinkize",">slideshow/Miscellaneous.html#(def._((lib._slideshow/pict..ss)._hyperlinkize))",[0,[1,"hyperlinkize"]],["slideshow/pict","slideshow"]],
["i",">html/index.html#(def._((lib._html/main..ss)._i))",[0,[1,"i"]],["html"]],
["i/o",">drscheme/interactions-window.html#(idx._(gentag._28._(lib._scribblings/drscheme/drscheme..scrbl)))","I/O",false],
["i/o patterns",">guide/I_O_Patterns.html","I/O Patterns",false],
["i/o-decoding-error?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_604",[0,[1,"i/o-decoding-error?"]],["rnrs/io/ports-6"]],
["i/o-encoding-error-char",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_612",[0,[1,"i/o-encoding-error-char"]],["rnrs/io/ports-6"]],
["i/o-encoding-error?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_610",[0,[1,"i/o-encoding-error?"]],["rnrs/io/ports-6"]],
["i/o-error-filename",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_526",[0,[1,"i/o-error-filename"]],["rnrs/io/ports-6"]],
["i/o-error-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_558",[0,[1,"i/o-error-port"]],["rnrs/io/ports-6"]],
["i/o-error-position",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_518",[0,[1,"i/o-error-position"]],["rnrs/io/ports-6"]],
["i/o-error?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_498",[0,[1,"i/o-error?"]],["rnrs/io/ports-6"]],
["i/o-file-already-exists-error?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_544",[0,[1,"i/o-file-already-exists-error?"]],["rnrs/io/ports-6"]],
["i/o-file-does-not-exist-error?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_550",[0,[1,"i/o-file-does-not-exist-error?"]],["rnrs/io/ports-6"]],
["i/o-file-is-read-only-error?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_538",[0,[1,"i/o-file-is-read-only-error?"]],["rnrs/io/ports-6"]],
["i/o-file-protection-error?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_532",[0,[1,"i/o-file-protection-error?"]],["rnrs/io/ports-6"]],
["i/o-filename-error?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_524",[0,[1,"i/o-filename-error?"]],["rnrs/io/ports-6"]],
["i/o-invalid-position-error?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_516",[0,[1,"i/o-invalid-position-error?"]],["rnrs/io/ports-6"]],
["i/o-port-error?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_556",[0,[1,"i/o-port-error?"]],["rnrs/io/ports-6"]],
["i/o-read-error?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_504",[0,[1,"i/o-read-error?"]],["rnrs/io/ports-6"]],
["i/o-write-error?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_510",[0,[1,"i/o-write-error?"]],["rnrs/io/ports-6"]],
["i?",">html/index.html#(def._((lib._html/main..ss)._i~3f))",[0,[1,"i?"]],["html"]],
["icolor",">teachpack/colors.html#(tech._icolor)","<i>IColor</i>",false],
["icon",">framework/Icon.html","Icon",false],
["icon:get-anchor-bitmap",">framework/Icon.html#(def._((lib._framework/main..ss)._icon~3aget-anchor-bitmap))",[0,[1,"icon:get-anchor-bitmap"]],["framework"]],
["icon:get-autowrap-bitmap",">framework/Icon.html#(def._((lib._framework/main..ss)._icon~3aget-autowrap-bitmap))",[0,[1,"icon:get-autowrap-bitmap"]],["framework"]],
["icon:get-eof-bitmap",">framework/Icon.html#(def._((lib._framework/main..ss)._icon~3aget-eof-bitmap))",[0,[1,"icon:get-eof-bitmap"]],["framework"]],
["icon:get-gc-off-bitmap",">framework/Icon.html#(def._((lib._framework/main..ss)._icon~3aget-gc-off-bitmap))",[0,[1,"icon:get-gc-off-bitmap"]],["framework"]],
["icon:get-gc-on-bitmap",">framework/Icon.html#(def._((lib._framework/main..ss)._icon~3aget-gc-on-bitmap))",[0,[1,"icon:get-gc-on-bitmap"]],["framework"]],
["icon:get-left/right-cursor",">framework/Icon.html#(def._((lib._framework/main..ss)._icon~3aget-left/right-cursor))",[0,[1,"icon:get-left/right-cursor"]],["framework"]],
["icon:get-lock-bitmap",">framework/Icon.html#(def._((lib._framework/main..ss)._icon~3aget-lock-bitmap))",[0,[1,"icon:get-lock-bitmap"]],["framework"]],
["icon:get-paren-highlight-bitmap",">framework/Icon.html#(def._((lib._framework/main..ss)._icon~3aget-paren-highlight-bitmap))",[0,[1,"icon:get-paren-highlight-bitmap"]],["framework"]],
["icon:get-unlock-bitmap",">framework/Icon.html#(def._((lib._framework/main..ss)._icon~3aget-unlock-bitmap))",[0,[1,"icon:get-unlock-bitmap"]],["framework"]],
["icon:get-up/down-cursor",">framework/Icon.html#(def._((lib._framework/main..ss)._icon~3aget-up/down-cursor))",[0,[1,"icon:get-up/down-cursor"]],["framework"]],
["iconize",">gui/frame_.html#(meth._(((lib._mred/main..ss)._frame~25)._iconize))",[[0,[1,"iconize"]],[12,[" (method of ",[0,[1,"frame%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["iconize",">mysterx/browsers.html#(meth._(((lib._mysterx/main..ss)._mx-browser~25)._iconize))",[[0,[1,"iconize"]],[12,[" (method of ",[0,[1,"mx-browser%"]],")"]]],["mysterx"]],
["id",">mysterx/html-events.html#(meth._(((lib._mysterx/main..ss)._mx-event~3c~25~3e)._id))",[[0,[1,"id"]],[12,[" (method of ",[0,[1,"mx-event&lt;%&gt;"]],")"]]],["mysterx"]],
["id-color",">slideshow/Typesetting_Scheme_Code.html#(def._((lib._slideshow/code..ss)._id-color))",[0,[1,"id-color"]],["slideshow/code"]],
["idefterm",">scribble/manual-indexing.html#(def._((lib._scribble/manual..ss)._idefterm))",[0,[1,"idefterm"]],["scribble/manual"]],
["identifier",">reference/syntax-model.html#(tech._identifier)","<i>identifier</i>",false],
["identifier macro",">guide/pattern-macros.html#(tech._identifier._macro)","<i>identifier macro</i>",false],
["identifier macros",">guide/pattern-macros.html#(part._.Identifier_.Macros)","Identifier Macros",false],
["identifier syntax object",">guide/stx-obj.html#(tech._identifier._syntax._object)","<i>identifier\nsyntax object</i>",false],
["identifier-binding",">reference/stxcmp.html#(def._((quote._~23~25kernel)._identifier-binding))",[0,[1,"identifier-binding"]],["scheme/base","scheme"]],
["identifier-label-binding",">reference/stxcmp.html#(def._((quote._~23~25kernel)._identifier-label-binding))",[0,[1,"identifier-label-binding"]],["scheme/base","scheme"]],
["identifier-syntax",">r6rs-std/r6rs-Z-H-14.html#node_idx_796",[0,[6,"identifier-syntax"]],["r6rs/private/base-for-syntax"]],
["identifier-template-binding",">reference/stxcmp.html#(def._((quote._~23~25kernel)._identifier-template-binding))",[0,[1,"identifier-template-binding"]],["scheme/base","scheme"]],
["identifier-transformer-binding",">reference/stxcmp.html#(def._((quote._~23~25kernel)._identifier-transformer-binding))",[0,[1,"identifier-transformer-binding"]],["scheme/base","scheme"]],
["identifier?",">reference/stxops.html#(def._((lib._scheme/private/stx..ss)._identifier~3f))",[0,[1,"identifier?"]],["scheme/base","scheme"]],
["identifier?",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1138",[0,[1,"identifier?"]],["rnrs/syntax-case-6"]],
["identifiers",">guide/syntax-overview.html#(part._.Identifiers)","Identifiers",false],
["identifiers",">honu/H-expressions.html#(part._honu~3aidentifiers)","Identifiers",false],
["identifiers",">htdp-langs/beginner-id.html","Identifiers",false],
["identifiers",">htdp-langs/intermediate-id.html","Identifiers",false],
["identifiers and binding",">guide/binding.html","Identifiers and Binding",false],
["identifiers and binding",">reference/syntax-model.html#(part._id-model)","Identifiers and Binding",false],
["identity",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._identity))",[0,[1,"identity"]],["lang/htdp-advanced"]],
["identity",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._identity))",[0,[1,"identity"]],["lang/htdp-beginner"]],
["identity",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._identity))",[0,[1,"identity"]],["lang/htdp-beginner-abbr"]],
["identity",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._identity))",[0,[1,"identity"]],["lang/htdp-intermediate"]],
["identity",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._identity))",[0,[1,"identity"]],["lang/htdp-intermediate-lambda"]],
["identity",">lazy/index.html#(def._((lib._lazy/main..ss)._identity))",[0,[1,"identity"]],["lazy"]],
["identity",">mzlib/mzlib_etc.html#(def._((lib._mzlib/etc..ss)._identity))",[0,[1,"identity"]],["mzlib/etc"]],
["ie ignores my css or behaves strange in other ways",">web-server/Troubleshooting.html#(part._.I.E_ignores_my_.C.S.S_or_behaves_strange_in_other_ways)","IE ignores my CSS or behaves strange in other ways",false],
["ieee floating-point numbers",">reference/numbers.html#(idx._(gentag._13._(lib._scribblings/reference/reference..scrbl)))","IEEE floating-point numbers",false],
["if",">htdp-langs/if.html",[0,[6,"if"]],false],
["if",">reference/if.html#(form._((quote._~23~25kernel)._if))",[0,[6,"if"]],["scheme/base","scheme"]],
["if",">r5rs-std/r5rs-Z-H-7.html#%_idx_98",[0,[6,"if"]],["r5rs"]],
["if",">r6rs-std/r6rs-Z-H-14.html#node_idx_366",[0,[6,"if"]],["rnrs/base-6"]],
["if",">htdp-langs/advanced-unchanged.html#(form._((lib._lang/htdp-advanced..ss)._if))",[0,[6,"if"]],["lang/htdp-advanced"]],
["if",">htdp-langs/if.html#(form._((lib._lang/htdp-beginner..ss)._if))",[0,[6,"if"]],["lang/htdp-beginner"]],
["if",">htdp-langs/Unchanged_Forms.html#(form._((lib._lang/htdp-beginner-abbr..ss)._if))",[0,[6,"if"]],["lang/htdp-beginner-abbr"]],
["if",">htdp-langs/intermediate-unchanged.html#(form._((lib._lang/htdp-intermediate..ss)._if))",[0,[6,"if"]],["lang/htdp-intermediate"]],
["if",">htdp-langs/intermediate-lambda-unchanged.html#(form._((lib._lang/htdp-intermediate-lambda..ss)._if))",[0,[6,"if"]],["lang/htdp-intermediate-lambda"]],
["if",">lazy/index.html#(form._((lib._lazy/main..ss)._if))",[0,[6,"if"]],["lazy"]],
["if",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..ss)._if))",[0,[6,"if"]],["mzscheme"]],
["if",">srfi-std/srfi-42.html#if",[0,[6,"if"]],["srfi/42"]],
["iframe",">html/index.html#(def._((lib._html/main..ss)._iframe))",[0,[1,"iframe"]],["html"]],
["iframe?",">html/index.html#(def._((lib._html/main..ss)._iframe~3f))",[0,[1,"iframe?"]],["html"]],
["illegal-message-number",">net/pop3.html#(def._((lib._net/pop3..ss)._illegal-message-number))",[0,[1,"illegal-message-number"]],["net/pop3"]],
["illegal-message-number-communicator",">net/pop3.html#(def._((lib._net/pop3..ss)._illegal-message-number-communicator))",[0,[1,"illegal-message-number-communicator"]],["net/pop3"]],
["illegal-message-number-message",">net/pop3.html#(def._((lib._net/pop3..ss)._illegal-message-number-message))",[0,[1,"illegal-message-number-message"]],["net/pop3"]],
["illegal-message-number?",">net/pop3.html#(def._((lib._net/pop3..ss)._illegal-message-number~3f))",[0,[1,"illegal-message-number?"]],["net/pop3"]],
["imag-part",">reference/numbers.html#(def._((quote._~23~25kernel)._imag-part))",[0,[1,"imag-part"]],["scheme/base","scheme"]],
["imag-part",">r5rs-std/r5rs-Z-H-9.html#%_idx_354",[0,[1,"imag-part"]],["r5rs"]],
["imag-part",">r6rs-std/r6rs-Z-H-14.html#node_idx_572",[0,[1,"imag-part"]],["rnrs/base-6"]],
["imag-part",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._imag-part))",[0,[1,"imag-part"]],["lang/htdp-advanced"]],
["imag-part",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._imag-part))",[0,[1,"imag-part"]],["lang/htdp-beginner"]],
["imag-part",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._imag-part))",[0,[1,"imag-part"]],["lang/htdp-beginner-abbr"]],
["imag-part",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._imag-part))",[0,[1,"imag-part"]],["lang/htdp-intermediate"]],
["imag-part",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._imag-part))",[0,[1,"imag-part"]],["lang/htdp-intermediate-lambda"]],
["image",">scribble/Images.html#(def._((lib._scribble/manual..ss)._image))",[0,[1,"image"]],["scribble/manual"]],
["image equality in htdp languages",">htdp-lib/index.html#(part._.Image_.Equality_in_.Ht.D.P_.Languages)","Image Equality in <i>HtDP</i> Languages",false],
["image teachpack",">teachpack/image.html#(idx._(gentag._0._(lib._teachpack/teachpack..scrbl)))","image teachpack",false],
["image%",">gui/WXME_Decoding.html#(def._((lib._wxme/image..ss)._image~25))",[0,[1,"image%"]],["wxme/image"]],
["image->alpha-color-list",">teachpack/image.html#(def._((lib._htdp/image..ss)._image-~3ealpha-color-list))",[0,[1,"image-&gt;alpha-color-list"]],["teachpack/htdp/image"]],
["image->color-list",">teachpack/image.html#(def._((lib._htdp/image..ss)._image-~3ecolor-list))",[0,[1,"image-&gt;color-list"]],["teachpack/htdp/image"]],
["image-color?",">teachpack/image.html#(def._((lib._htdp/image..ss)._image-color~3f))",[0,[1,"image-color?"]],["teachpack/htdp/image"]],
["image-file",">scribble/struct.html#(def._((lib._scribble/struct..ss)._image-file))",[0,[1,"image-file"]],["scribble/struct"]],
["image-file-path",">scribble/struct.html#(def._((lib._scribble/struct..ss)._image-file-path))",[0,[1,"image-file-path"]],["scribble/struct"]],
["image-file-scale",">scribble/struct.html#(def._((lib._scribble/struct..ss)._image-file-scale))",[0,[1,"image-file-scale"]],["scribble/struct"]],
["image-file?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._image-file~3f))",[0,[1,"image-file?"]],["scribble/struct"]],
["image-height",">teachpack/image.html#(def._((lib._htdp/image..ss)._image-height))",[0,[1,"image-height"]],["teachpack/htdp/image"]],
["image-inside?",">teachpack/image.html#(def._((lib._htdp/image..ss)._image-inside~3f))",[0,[1,"image-inside?"]],["teachpack/htdp/image"]],
["image-map-snip%",">browser/index.html#(def._((lib._browser/main..ss)._image-map-snip~25))",[0,[1,"image-map-snip%"]],["browser"]],
["image-or-control-ready-gif-stream?",">file/gif.html#(def._((lib._file/gif..ss)._image-or-control-ready-gif-stream~3f))",[0,[1,"image-or-control-ready-gif-stream?"]],["file/gif"]],
["image-ready-gif-stream?",">file/gif.html#(def._((lib._file/gif..ss)._image-ready-gif-stream~3f))",[0,[1,"image-ready-gif-stream?"]],["file/gif"]],
["image-snip%",">gui/image-snip_.html",[0,[1,"image-snip%"]],["scheme/gui/base","scheme/gui"]],
["image-width",">teachpack/image.html#(def._((lib._htdp/image..ss)._image-width))",[0,[1,"image-width"]],["teachpack/htdp/image"]],
["image/plain",">scribble/Images.html#(def._((lib._scribble/manual..ss)._image/plain))",[0,[1,"image/plain"]],["scribble/manual"]],
["image=?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._image~3d~3f))",[0,[1,"image=?"]],["lang/htdp-advanced"]],
["image=?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._image~3d~3f))",[0,[1,"image=?"]],["lang/htdp-beginner"]],
["image=?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._image~3d~3f))",[0,[1,"image=?"]],["lang/htdp-beginner-abbr"]],
["image=?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._image~3d~3f))",[0,[1,"image=?"]],["lang/htdp-intermediate"]],
["image=?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._image~3d~3f))",[0,[1,"image=?"]],["lang/htdp-intermediate-lambda"]],
["image=?",">htdp-lib/index.html#(def._((lib._lang/imageeq..ss)._image~3d~3f))",[0,[1,"image=?"]],["lang/imageeq"]],
["image?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._image~3f))",[0,[1,"image?"]],["lang/htdp-advanced"]],
["image?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._image~3f))",[0,[1,"image?"]],["lang/htdp-beginner"]],
["image?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._image~3f))",[0,[1,"image?"]],["lang/htdp-beginner-abbr"]],
["image?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._image~3f))",[0,[1,"image?"]],["lang/htdp-intermediate"]],
["image?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._image~3f))",[0,[1,"image?"]],["lang/htdp-intermediate-lambda"]],
["image?",">teachpack/image.html#(def._((lib._lang/private/imageeq..ss)._image~3f))",[0,[1,"image?"]],["lang/private/imageeq"]],
["images",">drscheme/Graphical_Syntax.html#(part._.Images)","Images",false],
["images",">gui/WXME_Decoding.html#(part._.Images)","Images",false],
["images",">scribble/Images.html","Images",false],
["images",">teachpack/image.html#(part._.Images)","Images",false],
["imap signature",">net/imap.html#(part._.I.M.A.P_.Signature)","IMAP Signature",false],
["imap unit",">net/imap.html#(part._.I.M.A.P_.Unit)","IMAP Unit",false],
["imap-append",">net/imap.html#(def._((lib._net/imap..ss)._imap-append))",[0,[1,"imap-append"]],["net/imap"]],
["imap-connect",">net/imap.html#(def._((lib._net/imap..ss)._imap-connect))",[0,[1,"imap-connect"]],["net/imap"]],
["imap-connect*",">net/imap.html#(def._((lib._net/imap..ss)._imap-connect*))",[0,[1,"imap-connect*"]],["net/imap"]],
["imap-connection?",">net/imap.html#(def._((lib._net/imap..ss)._imap-connection~3f))",[0,[1,"imap-connection?"]],["net/imap"]],
["imap-copy",">net/imap.html#(def._((lib._net/imap..ss)._imap-copy))",[0,[1,"imap-copy"]],["net/imap"]],
["imap-create-mailbox",">net/imap.html#(def._((lib._net/imap..ss)._imap-create-mailbox))",[0,[1,"imap-create-mailbox"]],["net/imap"]],
["imap-disconnect",">net/imap.html#(def._((lib._net/imap..ss)._imap-disconnect))",[0,[1,"imap-disconnect"]],["net/imap"]],
["imap-examine",">net/imap.html#(def._((lib._net/imap..ss)._imap-examine))",[0,[1,"imap-examine"]],["net/imap"]],
["imap-expunge",">net/imap.html#(def._((lib._net/imap..ss)._imap-expunge))",[0,[1,"imap-expunge"]],["net/imap"]],
["imap-flag->symbol",">net/imap.html#(def._((lib._net/imap..ss)._imap-flag-~3esymbol))",[0,[1,"imap-flag-&gt;symbol"]],["net/imap"]],
["imap-force-disconnect",">net/imap.html#(def._((lib._net/imap..ss)._imap-force-disconnect))",[0,[1,"imap-force-disconnect"]],["net/imap"]],
["imap-get-expunges",">net/imap.html#(def._((lib._net/imap..ss)._imap-get-expunges))",[0,[1,"imap-get-expunges"]],["net/imap"]],
["imap-get-hierarchy-delimiter",">net/imap.html#(def._((lib._net/imap..ss)._imap-get-hierarchy-delimiter))",[0,[1,"imap-get-hierarchy-delimiter"]],["net/imap"]],
["imap-get-messages",">net/imap.html#(def._((lib._net/imap..ss)._imap-get-messages))",[0,[1,"imap-get-messages"]],["net/imap"]],
["imap-get-updates",">net/imap.html#(def._((lib._net/imap..ss)._imap-get-updates))",[0,[1,"imap-get-updates"]],["net/imap"]],
["imap-list-child-mailboxes",">net/imap.html#(def._((lib._net/imap..ss)._imap-list-child-mailboxes))",[0,[1,"imap-list-child-mailboxes"]],["net/imap"]],
["imap-mailbox-exists?",">net/imap.html#(def._((lib._net/imap..ss)._imap-mailbox-exists~3f))",[0,[1,"imap-mailbox-exists?"]],["net/imap"]],
["imap-mailbox-flags",">net/imap.html#(def._((lib._net/imap..ss)._imap-mailbox-flags))",[0,[1,"imap-mailbox-flags"]],["net/imap"]],
["imap-messages",">net/imap.html#(def._((lib._net/imap..ss)._imap-messages))",[0,[1,"imap-messages"]],["net/imap"]],
["imap-new?",">net/imap.html#(def._((lib._net/imap..ss)._imap-new~3f))",[0,[1,"imap-new?"]],["net/imap"]],
["imap-noop",">net/imap.html#(def._((lib._net/imap..ss)._imap-noop))",[0,[1,"imap-noop"]],["net/imap"]],
["imap-pending-expunges?",">net/imap.html#(def._((lib._net/imap..ss)._imap-pending-expunges~3f))",[0,[1,"imap-pending-expunges?"]],["net/imap"]],
["imap-pending-updates?",">net/imap.html#(def._((lib._net/imap..ss)._imap-pending-updates~3f))",[0,[1,"imap-pending-updates?"]],["net/imap"]],
["imap-poll",">net/imap.html#(def._((lib._net/imap..ss)._imap-poll))",[0,[1,"imap-poll"]],["net/imap"]],
["imap-port-number",">net/imap.html#(def._((lib._net/imap..ss)._imap-port-number))",[0,[1,"imap-port-number"]],["net/imap"]],
["imap-recent",">net/imap.html#(def._((lib._net/imap..ss)._imap-recent))",[0,[1,"imap-recent"]],["net/imap"]],
["imap-reselect",">net/imap.html#(def._((lib._net/imap..ss)._imap-reselect))",[0,[1,"imap-reselect"]],["net/imap"]],
["imap-reset-new!",">net/imap.html#(def._((lib._net/imap..ss)._imap-reset-new!))",[0,[1,"imap-reset-new!"]],["net/imap"]],
["imap-status",">net/imap.html#(def._((lib._net/imap..ss)._imap-status))",[0,[1,"imap-status"]],["net/imap"]],
["imap-store",">net/imap.html#(def._((lib._net/imap..ss)._imap-store))",[0,[1,"imap-store"]],["net/imap"]],
["imap-uidnext",">net/imap.html#(def._((lib._net/imap..ss)._imap-uidnext))",[0,[1,"imap-uidnext"]],["net/imap"]],
["imap-uidvalidity",">net/imap.html#(def._((lib._net/imap..ss)._imap-uidvalidity))",[0,[1,"imap-uidvalidity"]],["net/imap"]],
["imap-unseen",">net/imap.html#(def._((lib._net/imap..ss)._imap-unseen))",[0,[1,"imap-unseen"]],["net/imap"]],
["imap: reading mail",">net/imap.html","IMAP: Reading Mail",false],
["imap@",">net/imap.html#(def._((lib._net/imap-unit..ss)._imap~40))",[0,[1,"imap@"]],["net/imap-unit"]],
["imap^",">net/imap.html#(form._((lib._net/imap-sig..ss)._imap~5e))",[0,[6,"imap^"]],["net/imap-sig"]],
["img",">html/index.html#(def._((lib._html/main..ss)._img))",[0,[1,"img"]],["html"]],
["img?",">html/index.html#(def._((lib._html/main..ss)._img~3f))",[0,[1,"img?"]],["html"]],
["immutable",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_294",[0,[6,"immutable"]],["rnrs/records/syntactic-6"]],
["immutable cyclic data",">reference/pairs.html#(part._.Immutable_.Cyclic_.Data)","Immutable Cyclic Data",false],
["immutable?",">reference/booleans.html#(def._((quote._~23~25kernel)._immutable~3f))",[0,[1,"immutable?"]],["scheme/base","scheme"]],
["implementation",">algol60/index.html#(part._.Implementation)","Implementation",false],
["implementation notes",">openssl/index.html#(part._.Implementation_.Notes)","Implementation Notes",false],
["implementation-restriction-violation?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_470",[0,[1,"implementation-restriction-violation?"]],["rnrs/conditions-6"]],
["implementation-vicinity",">srfi-std/srfi-59.html#implementation-vicinity",[0,[1,"implementation-vicinity"]],["srfi/59"]],
["implementation?",">reference/objectutils.html#(def._((lib._scheme/private/class-internal..ss)._implementation~3f))",[0,[1,"implementation?"]],["scheme/class","scheme"]],
["implementation?/c",">reference/Object_and_Class_Contracts.html#(def._((lib._scheme/class..ss)._implementation~3f/c))",[0,[1,"implementation?/c"]],["scheme/class","scheme"]],
["implementing drscheme tools",">tools/implementing-tools.html","Implementing DrScheme Tools",false],
["implementing new games",">games/new-games.html","Implementing New Games",false],
["implements",">reference/mzlib_class.html#(tech._implement)","<i>implements</i>",false],
["import",">htdc/advanced_import.html",[0,"import"],false],
["import",">htdc/import.html",[0,"import"],false],
["import",">htdc/intermed_import.html",[0,"import"],false],
["import",">htdc/intermedAcc_import.html",[0,"import"],false],
["import",">reference/stxtrans.html#(def._((lib._scheme/require-transform..ss)._import))",[0,[1,"import"]],["scheme/require-transform"]],
["import",">reference/creatingunits.html#(form._((lib._mzlib/unit..ss)._import))",[0,[6,"import"]],["scheme/unit","scheme"]],
["import-local-id",">reference/stxtrans.html#(def._((lib._scheme/require-transform..ss)._import-local-id))",[0,[1,"import-local-id"]],["scheme/require-transform"]],
["import-mode",">reference/stxtrans.html#(def._((lib._scheme/require-transform..ss)._import-mode))",[0,[1,"import-mode"]],["scheme/require-transform"]],
["import-orig-mode",">reference/stxtrans.html#(def._((lib._scheme/require-transform..ss)._import-orig-mode))",[0,[1,"import-orig-mode"]],["scheme/require-transform"]],
["import-orig-stx",">reference/stxtrans.html#(def._((lib._scheme/require-transform..ss)._import-orig-stx))",[0,[1,"import-orig-stx"]],["scheme/require-transform"]],
["import-req-mode",">reference/stxtrans.html#(def._((lib._scheme/require-transform..ss)._import-req-mode))",[0,[1,"import-req-mode"]],["scheme/require-transform"]],
["import-source",">reference/stxtrans.html#(def._((lib._scheme/require-transform..ss)._import-source))",[0,[1,"import-source"]],["scheme/require-transform"]],
["import-source-mod-path-stx",">reference/stxtrans.html#(def._((lib._scheme/require-transform..ss)._import-source-mod-path-stx))",[0,[1,"import-source-mod-path-stx"]],["scheme/require-transform"]],
["import-source-mode",">reference/stxtrans.html#(def._((lib._scheme/require-transform..ss)._import-source-mode))",[0,[1,"import-source-mode"]],["scheme/require-transform"]],
["import-source?",">reference/stxtrans.html#(def._((lib._scheme/require-transform..ss)._import-source~3f))",[0,[1,"import-source?"]],["scheme/require-transform"]],
["import-src-mod-path",">reference/stxtrans.html#(def._((lib._scheme/require-transform..ss)._import-src-mod-path))",[0,[1,"import-src-mod-path"]],["scheme/require-transform"]],
["import-src-sym",">reference/stxtrans.html#(def._((lib._scheme/require-transform..ss)._import-src-sym))",[0,[1,"import-src-sym"]],["scheme/require-transform"]],
["import?",">reference/stxtrans.html#(def._((lib._scheme/require-transform..ss)._import~3f))",[0,[1,"import?"]],["scheme/require-transform"]],
["importing and exporting: require and provide",">reference/require.html",["Importing and Exporting: ",[0,[6,"require"]]," and ",[0,[6,"provide"]]],false],
["imports: require",">guide/module-require.html",["Imports: ",[0,[6,"require"]]],false],
["imposing obligations on a module's clients",">guide/contract-boundaries.html#(part._contracts-obligations)","Imposing Obligations on a Module&rsquo;s Clients",false],
["impure port",">net/url.html#(tech._impure._port)","<i>impure port</i>",false],
["in-bytes",">reference/sequences.html#(def._((lib._scheme/base..ss)._in-bytes))",[0,[1,"in-bytes"]],["scheme/base","scheme"]],
["in-dict",">reference/dicts.html#(def._((lib._scheme/dict..ss)._in-dict))",[0,[1,"in-dict"]],["scheme/dict","scheme"]],
["in-dict-keys",">reference/dicts.html#(def._((lib._scheme/dict..ss)._in-dict-keys))",[0,[1,"in-dict-keys"]],["scheme/dict","scheme"]],
["in-dict-pairs",">reference/dicts.html#(def._((lib._scheme/dict..ss)._in-dict-pairs))",[0,[1,"in-dict-pairs"]],["scheme/dict","scheme"]],
["in-dict-values",">reference/dicts.html#(def._((lib._scheme/dict..ss)._in-dict-values))",[0,[1,"in-dict-values"]],["scheme/dict","scheme"]],
["in-domain?",">redex/Metafunctions.html#(form._((lib._redex/main..ss)._in-domain~3f))",[0,[6,"in-domain?"]],["redex"]],
["in-edit-sequence?",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._in-edit-sequence~3f))",[[0,[1,"in-edit-sequence?"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["in-hash",">reference/sequences.html#(def._((lib._scheme/base..ss)._in-hash))",[0,[1,"in-hash"]],["scheme/base","scheme"]],
["in-hash-keys",">reference/sequences.html#(def._((lib._scheme/base..ss)._in-hash-keys))",[0,[1,"in-hash-keys"]],["scheme/base","scheme"]],
["in-hash-pairs",">reference/sequences.html#(def._((lib._scheme/base..ss)._in-hash-pairs))",[0,[1,"in-hash-pairs"]],["scheme/base","scheme"]],
["in-hash-values",">reference/sequences.html#(def._((lib._scheme/base..ss)._in-hash-values))",[0,[1,"in-hash-values"]],["scheme/base","scheme"]],
["in-hole",">redex/Patterns.html#(tech._in._hole)","<i>in-hole</i>",false],
["in-indexed",">reference/sequences.html#(def._((lib._scheme/base..ss)._in-indexed))",[0,[1,"in-indexed"]],["scheme/base","scheme"]],
["in-input-port-bytes",">reference/sequences.html#(def._((lib._scheme/base..ss)._in-input-port-bytes))",[0,[1,"in-input-port-bytes"]],["scheme/base","scheme"]],
["in-input-port-chars",">reference/sequences.html#(def._((lib._scheme/base..ss)._in-input-port-chars))",[0,[1,"in-input-port-chars"]],["scheme/base","scheme"]],
["in-lines",">reference/sequences.html#(def._((lib._scheme/base..ss)._in-lines))",[0,[1,"in-lines"]],["scheme/base","scheme"]],
["in-list",">reference/sequences.html#(def._((lib._scheme/base..ss)._in-list))",[0,[1,"in-list"]],["scheme/base","scheme"]],
["in-naturals",">reference/sequences.html#(def._((lib._scheme/base..ss)._in-naturals))",[0,[1,"in-naturals"]],["scheme/base","scheme"]],
["in-parallel",">reference/sequences.html#(def._((lib._scheme/base..ss)._in-parallel))",[0,[1,"in-parallel"]],["scheme/base","scheme"]],
["in-range",">reference/sequences.html#(def._((lib._scheme/base..ss)._in-range))",[0,[1,"in-range"]],["scheme/base","scheme"]],
["in-region?",">gui/region_.html#(meth._(((lib._mred/main..ss)._region~25)._in-region~3f))",[[0,[1,"in-region?"]],[12,[" (method of ",[0,[1,"region%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["in-string",">reference/sequences.html#(def._((lib._scheme/base..ss)._in-string))",[0,[1,"in-string"]],["scheme/base","scheme"]],
["in-value",">reference/sequences.html#(def._((lib._scheme/base..ss)._in-value))",[0,[1,"in-value"]],["scheme/base","scheme"]],
["in-vector",">reference/sequences.html#(def._((lib._scheme/base..ss)._in-vector))",[0,[1,"in-vector"]],["scheme/base","scheme"]],
["in-vicinity",">srfi-std/srfi-59.html#in-vicinity",[0,[1,"in-vicinity"]],["srfi/59"]],
["inactive certificate",">reference/stxcerts.html#(tech._inactive._certificate)","<i>inactive certificate</i>",false],
["include",">reference/include.html#(form._((lib._scheme/include..ss)._include))",[0,[6,"include"]],["scheme/include","scheme"]],
["include",">mzlib/mzlib_include.html#(form._((lib._mzlib/include..ss)._include))",[0,[6,"include"]],["mzlib/include"]],
["include",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..ss)._include))",[0,[1,"include"]],["preprocessor/mzpp"]],
["include",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..ss)._include))",[0,[1,"include"]],["preprocessor/mztext"]],
["include",">scribble/preprocessor.html#(form._((lib._scribble/text..ss)._include))",[0,[6,"include"]],["scribble/text"]],
["include bitmap",">mrlib/Include_Bitmap.html","Include Bitmap",false],
["include-algol",">algol60/index.html#(form._((lib._algol60/algol60..ss)._include-algol))",[0,[6,"include-algol"]],["algol60/algol60"]],
["include-at/relative-to",">reference/include.html#(form._((lib._scheme/include..ss)._include-at/relative-to))",[0,[6,"include-at/relative-to"]],["scheme/include","scheme"]],
["include-at/relative-to",">mzlib/mzlib_include.html#(form._((lib._mzlib/include..ss)._include-at/relative-to))",[0,[6,"include-at/relative-to"]],["mzlib/include"]],
["include-at/relative-to/reader",">reference/include.html#(form._((lib._scheme/include..ss)._include-at/relative-to/reader))",[0,[6,"include-at/relative-to/reader"]],["scheme/include","scheme"]],
["include-at/relative-to/reader",">mzlib/mzlib_include.html#(form._((lib._mzlib/include..ss)._include-at/relative-to/reader))",[0,[6,"include-at/relative-to/reader"]],["mzlib/include"]],
["include-bitmap",">mrlib/Include_Bitmap.html#(form._((lib._mrlib/include-bitmap..ss)._include-bitmap))",[0,[6,"include-bitmap"]],["mrlib/include-bitmap"]],
["include-bitmap/relative-to",">mrlib/Include_Bitmap.html#(form._((lib._mrlib/include-bitmap..ss)._include-bitmap/relative-to))",[0,[6,"include-bitmap/relative-to"]],["mrlib/include-bitmap"]],
["include-dir",">config/index.html#(def._((lib._config/main..ss)._include-dir))",[0,[1,"include-dir"]],["config"]],
["include-search-dirs",">config/index.html#(def._((lib._config/main..ss)._include-search-dirs))",[0,[1,"include-search-dirs"]],["config"]],
["include-section",">scribble/basic.html#(form._((lib._scribble/basic..ss)._include-section))",[0,[6,"include-section"]],["scribble/basic"]],
["include/reader",">reference/include.html#(form._((lib._scheme/include..ss)._include/reader))",[0,[6,"include/reader"]],["scheme/include","scheme"]],
["include/reader",">mzlib/mzlib_include.html#(form._((lib._mzlib/include..ss)._include/reader))",[0,[6,"include/reader"]],["mzlib/include"]],
["including algol 60 programs",">algol60/index.html#(part._.Including_.Algol_60_.Programs)","Including Algol 60 Programs",false],
["incomplete-%-suffix",">net/cgi.html#(def._((lib._net/cgi..ss)._incomplete-~25-suffix))",[0,[1,"incomplete-%-suffix"]],["net/cgi"]],
["incomplete-%-suffix-chars",">net/cgi.html#(def._((lib._net/cgi..ss)._incomplete-~25-suffix-chars))",[0,[1,"incomplete-%-suffix-chars"]],["net/cgi"]],
["incomplete-%-suffix?",">net/cgi.html#(def._((lib._net/cgi..ss)._incomplete-~25-suffix~3f))",[0,[1,"incomplete-%-suffix?"]],["net/cgi"]],
["increment-timer!",">web-server/timer_ss.html#(def._((lib._web-server/private/timer..ss)._increment-timer!))",[0,[1,"increment-timer!"]],["web-server/private/timer"]],
["indenting scheme code",">drscheme/editor.html#(idx._(gentag._20._(lib._scribblings/drscheme/drscheme..scrbl)))","indenting Scheme\ncode",false],
["index",">scribble/basic.html#(def._((lib._scribble/basic..ss)._index))",[0,[1,"index"]],["scribble/basic"]],
["index pairs",">guide/regexp-match.html#(tech._index._pair)","<i>index pairs</i>",false],
["index*",">scribble/basic.html#(def._((lib._scribble/basic..ss)._index*))",[0,[1,"index*"]],["scribble/basic"]],
["index-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._index-element))",[0,[1,"index-element"]],["scribble/struct"]],
["index-element-desc",">scribble/struct.html#(def._((lib._scribble/struct..ss)._index-element-desc))",[0,[1,"index-element-desc"]],["scribble/struct"]],
["index-element-entry-seq",">scribble/struct.html#(def._((lib._scribble/struct..ss)._index-element-entry-seq))",[0,[1,"index-element-entry-seq"]],["scribble/struct"]],
["index-element-plain-seq",">scribble/struct.html#(def._((lib._scribble/struct..ss)._index-element-plain-seq))",[0,[1,"index-element-plain-seq"]],["scribble/struct"]],
["index-element-tag",">scribble/struct.html#(def._((lib._scribble/struct..ss)._index-element-tag))",[0,[1,"index-element-tag"]],["scribble/struct"]],
["index-element?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._index-element~3f))",[0,[1,"index-element?"]],["scribble/struct"]],
["index-entry descriptions",">scribble/index-entries.html","Index-Entry Descriptions",false],
["index-section",">scribble/basic.html#(def._((lib._scribble/basic..ss)._index-section))",[0,[1,"index-section"]],["scribble/basic"]],
["index-to-style",">gui/style-list_.html#(meth._(((lib._mred/main..ss)._style-list~25)._index-to-style))",[[0,[1,"index-to-style"]],[12,[" (method of ",[0,[1,"style-list%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["indexed-envvar",">scribble/manual-indexing.html#(def._((lib._scribble/manual..ss)._indexed-envvar))",[0,[1,"indexed-envvar"]],["scribble/manual"]],
["indexed-file",">scribble/manual-indexing.html#(def._((lib._scribble/manual..ss)._indexed-file))",[0,[1,"indexed-file"]],["scribble/manual"]],
["indexed-scheme",">scribble/manual-indexing.html#(form._((lib._scribble/manual..ss)._indexed-scheme))",[0,[6,"indexed-scheme"]],["scribble/manual"]],
["indexing",">scribble/basic.html#(part._.Indexing)","Indexing",false],
["indexing",">scribble/manual-indexing.html","Indexing",false],
["inexact",">r6rs-std/r6rs-Z-H-14.html#node_idx_460",[0,[1,"inexact"]],["rnrs/base-6"]],
["inexact number",">reference/numbers.html#(tech._inexact._number)","<i>inexact number</i>",false],
["inexact->exact",">reference/numbers.html#(def._((quote._~23~25kernel)._inexact-~3eexact))",[0,[1,"inexact-&gt;exact"]],["scheme/base","scheme"]],
["inexact->exact",">r5rs-std/r5rs-Z-H-9.html#%_idx_362",[0,[1,"inexact-&gt;exact"]],["r5rs"]],
["inexact->exact",">r6rs-lib-std/r6rs-lib-Z-H-20.html#node_idx_1288",[0,[1,"inexact-&gt;exact"]],["rnrs/r5rs-6"]],
["inexact->exact",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._inexact-~3eexact))",[0,[1,"inexact-&gt;exact"]],["lang/htdp-advanced"]],
["inexact->exact",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._inexact-~3eexact))",[0,[1,"inexact-&gt;exact"]],["lang/htdp-beginner"]],
["inexact->exact",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._inexact-~3eexact))",[0,[1,"inexact-&gt;exact"]],["lang/htdp-beginner-abbr"]],
["inexact->exact",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._inexact-~3eexact))",[0,[1,"inexact-&gt;exact"]],["lang/htdp-intermediate"]],
["inexact->exact",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._inexact-~3eexact))",[0,[1,"inexact-&gt;exact"]],["lang/htdp-intermediate-lambda"]],
["inexact-real?",">reference/numbers.html#(def._((quote._~23~25kernel)._inexact-real~3f))",[0,[1,"inexact-real?"]],["scheme/base","scheme"]],
["inexact?",">reference/numbers.html#(def._((quote._~23~25kernel)._inexact~3f))",[0,[1,"inexact?"]],["scheme/base","scheme"]],
["inexact?",">r5rs-std/r5rs-Z-H-9.html#%_idx_256",[0,[1,"inexact?"]],["r5rs"]],
["inexact?",">r6rs-std/r6rs-Z-H-14.html#node_idx_458",[0,[1,"inexact?"]],["rnrs/base-6"]],
["inexact?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._inexact~3f))",[0,[1,"inexact?"]],["lang/htdp-advanced"]],
["inexact?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._inexact~3f))",[0,[1,"inexact?"]],["lang/htdp-beginner"]],
["inexact?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._inexact~3f))",[0,[1,"inexact?"]],["lang/htdp-beginner-abbr"]],
["inexact?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._inexact~3f))",[0,[1,"inexact?"]],["lang/htdp-intermediate"]],
["inexact?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._inexact~3f))",[0,[1,"inexact?"]],["lang/htdp-intermediate-lambda"]],
["inferred linking",">reference/linkinference.html","Inferred Linking",false],
["inferred value names",">reference/syntax-model.html#(part._infernames)","Inferred Value Names",false],
["inferred-name",">reference/syntax-model.html#(idx._(gentag._1._(lib._scribblings/reference/reference..scrbl)))",[7,"'inferred-name"],false],
["infinite?",">r6rs-std/r6rs-Z-H-14.html#node_idx_486",[0,[1,"infinite?"]],["rnrs/base-6"]],
["infinity",">reference/numbers.html#(idx._(gentag._9._(lib._scribblings/reference/reference..scrbl)))","infinity",false],
["infix",">reference/reader.html#(idx._(gentag._147._(lib._scribblings/reference/reference..scrbl)))","infix",false],
["infix contract notation",">guide/contract-func.html#(part._contracts-dots)","Infix Contract Notation",false],
["inflate",">file/gunzip.html#(def._((lib._file/gunzip..ss)._inflate))",[0,[1,"inflate"]],["file/gunzip"]],
["info key",">scribble/struct.html#(tech._info._key)","<i>info key</i>",false],
["info-domain",">setup-plt/getinfo.html#(idx._(gentag._1._(lib._scribblings/setup-plt/setup-plt..scrbl)))",[5,"\"info-domain\""],false],
["info-key?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._info-key~3f))",[0,[1,"info-key?"]],["scribble/struct"]],
["information on expanded modules",">reference/Expanding_Top-Level_Forms.html#(part._modinfo)","Information on Expanded Modules",false],
["inherit",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._inherit))",[0,[6,"inherit"]],["scheme/class","scheme"]],
["inherit and super in traits",">guide/classes.html#(part._.Inherit_and_.Super_in_.Traits)","Inherit and Super in Traits",false],
["inherit-field",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._inherit-field))",[0,[6,"inherit-field"]],["scheme/class","scheme"]],
["inherit/inner",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._inherit/inner))",[0,[6,"inherit/inner"]],["scheme/class","scheme"]],
["inherit/super",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._inherit/super))",[0,[6,"inherit/super"]],["scheme/class","scheme"]],
["inheritance",">reference/mzlib_class.html#(tech._inheritance)","<i>inheritance</i>",false],
["inherited and superclass methods",">reference/createclass.html#(part._classinherit)","Inherited and Superclass Methods",false],
["init",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._init))",[0,[6,"init"]],["scheme/class","scheme"]],
["init libraries",">reference/running-sa.html#(part._.Init_.Libraries)","Init Libraries",false],
["init-auto-scrollbars",">gui/canvas_.html#(meth._(((lib._mred/main..ss)._canvas~25)._init-auto-scrollbars))",[[0,[1,"init-auto-scrollbars"]],[12,[" (method of ",[0,[1,"canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["init-depend",">reference/creatingunits.html#(form._((lib._mzlib/unit..ss)._init-depend))",[0,[6,"init-depend"]],["scheme/unit","scheme"]],
["init-dir",">reference/Filesystem.html#(idx._(gentag._250._(lib._scribblings/reference/reference..scrbl)))",[7,"'init-dir"],false],
["init-field",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._init-field))",[0,[6,"init-field"]],["scheme/class","scheme"]],
["init-file",">reference/Filesystem.html#(idx._(gentag._251._(lib._scribblings/reference/reference..scrbl)))",[7,"'init-file"],false],
["init-manual-scrollbars",">gui/canvas_.html#(meth._(((lib._mred/main..ss)._canvas~25)._init-manual-scrollbars))",[[0,[1,"init-manual-scrollbars"]],[12,[" (method of ",[0,[1,"canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["init-rest",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._init-rest))",[0,[6,"init-rest"]],["scheme/class","scheme"]],
["init-world",">graphics/World_Operations.html#(def._((lib._graphics/graphics..ss)._init-world))",[0,[1,"init-world"]],["graphics/graphics"]],
["initial-autowrap-bitmap",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3abasic~3c~25~3e)._initial-autowrap-bitmap))",[[0,[1,"initial-autowrap-bitmap"]],[12,[" (method of ",[0,[1,"text:basic&lt;%&gt;"]],")"]]],["framework"]],
["initial-char-width",">redex/GUI.html#(def._((lib._redex/gui..ss)._initial-char-width))",[0,[1,"initial-char-width"]],["redex/gui"]],
["initial-connection-timeout",">web-server/dispatch-server-unit_ss.html#(sig-val._((lib._web-server/private/dispatch-server-sig..ss)._dispatch-server-config~5e._initial-connection-timeout))",[0,[1,"initial-connection-timeout"]],["web-server/private/dispatch-server-sig"]],
["initial-connection-timeout",">web-server/web-config-unit_ss.html#(sig-val._((lib._web-server/web-config-sig..ss)._web-config~5e._initial-connection-timeout))",[0,[1,"initial-connection-timeout"]],["web-server/web-config-sig"]],
["initial-font-size",">redex/GUI.html#(def._((lib._redex/gui..ss)._initial-font-size))",[0,[1,"initial-font-size"]],["redex/gui"]],
["initialization",">reference/running-sa.html#(part._init-actions)","Initialization",false],
["initialization arguments",">guide/classes.html#(part._initargs)","Initialization Arguments",false],
["initialization variables",">reference/createclass.html#(part._clinitvars)","Initialization Variables",false],
["initialize-console",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3atext~25)._initialize-console))",[[0,[1,"initialize-console"]],[12,[" (method of ",[0,[1,"drscheme:rep:text%"]],")"]]],["drscheme/tool-lib"]],
["initialize-profile-point",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..ss)._stacktrace-imports~5e._initialize-profile-point))",[0,[1,"initialize-profile-point"]],["errortrace/stacktrace"]],
["initialize-test-coverage-point",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..ss)._stacktrace-imports~5e._initialize-test-coverage-point))",[0,[1,"initialize-test-coverage-point"]],["errortrace/stacktrace"]],
["inner",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._inner))",[0,[6,"inner"]],["scheme/class","scheme"]],
["inode",">reference/file-ports.html#(idx._(gentag._115._(lib._scribblings/reference/reference..scrbl)))","inode",false],
["input",">html/index.html#(def._((lib._html/main..ss)._input))",[0,[1,"input"]],["html"]],
["input and output",">drscheme/interactions-window.html#(part._.Input_and_.Output)","Input and Output",false],
["input and output",">guide/i_o.html","Input and Output",false],
["input and output",">reference/input-and-output.html","Input and Output",false],
["input ports pattern matching",">reference/regexp.html","input ports, pattern matching",false],
["input-int",">web-server/input-formlets.html#(def._((lib._web-server/formlets/input..ss)._input-int))",[0,[1,"input-int"]],["web-server/formlets/input"]],
["input-port",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..ss)._input-port))",[0,[6,"input-port"]],["parser-tools/lex"]],
["input-port-append",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._input-port-append))",[0,[1,"input-port-append"]],["scheme/port"]],
["input-port?",">reference/port-ops.html#(def._((quote._~23~25kernel)._input-port~3f))",[0,[1,"input-port?"]],["scheme/base","scheme"]],
["input-port?",">r5rs-std/r5rs-Z-H-9.html#%_idx_614",[0,[1,"input-port?"]],["r5rs"]],
["input-port?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_664",[0,[1,"input-port?"]],["rnrs/io/ports-6"]],
["input-string",">web-server/input-formlets.html#(def._((lib._web-server/formlets/input..ss)._input-string))",[0,[1,"input-string"]],["web-server/formlets/input"]],
["input-symbol",">web-server/input-formlets.html#(def._((lib._web-server/formlets/input..ss)._input-symbol))",[0,[1,"input-symbol"]],["web-server/formlets/input"]],
["input?",">html/index.html#(def._((lib._html/main..ss)._input~3f))",[0,[1,"input?"]],["html"]],
["ins",">html/index.html#(def._((lib._html/main..ss)._ins))",[0,[1,"ins"]],["html"]],
["ins?",">html/index.html#(def._((lib._html/main..ss)._ins~3f))",[0,[1,"ins?"]],["html"]],
["insert",">drscheme/Menus.html#(part._.Insert)","<b><font size=\"-1\" face=\"Helvetica\">Insert</font></b>",false],
["insert",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._insert))",[[0,[1,"insert"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["insert",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._insert))",[[0,[1,"insert"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["insert",">gui/string-snip_.html#(meth._(((lib._mred/main..ss)._string-snip~25)._insert))",[[0,[1,"insert"]],[12,[" (method of ",[0,[1,"string-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["insert",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._insert))",[[0,[1,"insert"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["insert",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3a1-pixel-string-snip~25)._insert))",[[0,[1,"insert"]],[12,[" (method of ",[0,[1,"text:1-pixel-string-snip%"]],")"]]],["framework"]],
["insert",">gui/key-event_.html#(idx._(gentag._67._(lib._scribblings/gui/gui..scrbl)))",[7,"'insert"],false],
["insert comment box menu item",">drscheme/Menus.html#(idx._(gentag._132._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Insert Comment Box</font></b> menu item",false],
["insert fraction... menu item",">drscheme/Menus.html#(idx._(gentag._134._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Insert Fraction...</font></b> menu item",false],
["insert image... menu item",">drscheme/Menus.html#(idx._(gentag._133._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Insert Image...</font></b> menu item",false],
["insert java comment box menu item",">drscheme/Menus.html#(idx._(gentag._137._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Insert Java Comment Box</font></b> menu item",false],
["insert java interactions box menu item",">drscheme/Menus.html#(idx._(gentag._138._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Insert Java Interactions Box</font></b> menu item",false],
["insert large letters... menu item",">drscheme/Menus.html#(idx._(gentag._135._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Insert Large Letters...</font></b> menu item",false],
["insert pict box menu item",">drscheme/Menus.html#(idx._(gentag._142._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Insert Pict Box</font></b> menu item",false],
["insert scheme box menu item",">drscheme/Menus.html#(idx._(gentag._140._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Insert Scheme Box</font></b> menu item",false],
["insert scheme splice box menu item",">drscheme/Menus.html#(idx._(gentag._141._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Insert Scheme Splice Box</font></b> menu item",false],
["insert xml box menu item",">drscheme/Menus.html#(idx._(gentag._139._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Insert XML Box</font></b> menu item",false],
["insert \u03bb menu item",">drscheme/Menus.html#(idx._(gentag._136._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Insert &#955;</font></b> menu item",false],
["insert-before",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._insert-before))",[[0,[1,"insert-before"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["insert-between",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._insert-between))",[[0,[1,"insert-between"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["insert-box",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._insert-box))",[[0,[1,"insert-box"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["insert-close-paren",">framework/Color.html#(meth._(((lib._framework/main..ss)._color~3atext~3c~25~3e)._insert-close-paren))",[[0,[1,"insert-close-paren"]],[12,[" (method of ",[0,[1,"color:text&lt;%&gt;"]],")"]]],["framework"]],
["insert-field",">net/head.html#(def._((lib._net/head..ss)._insert-field))",[0,[1,"insert-field"]],["net/head"]],
["insert-file",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._insert-file))",[[0,[1,"insert-file"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["insert-first!",">syntax-color/index.html#(def._((lib._syntax-color/token-tree..ss)._insert-first!))",[0,[1,"insert-first!"]],["syntax-color/token-tree"]],
["insert-frame",">framework/Group.html#(meth._(((lib._framework/main..ss)._group~3a~25)._insert-frame))",[[0,[1,"insert-frame"]],[12,[" (method of ",[0,[1,"group:%"]],")"]]],["framework"]],
["insert-html",">mysterx/documents.html#(meth._(((lib._mysterx/main..ss)._mx-document~3c~25~3e)._insert-html))",[[0,[1,"insert-html"]],[12,[" (method of ",[0,[1,"mx-document&lt;%&gt;"]],")"]]],["mysterx"]],
["insert-html",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._insert-html))",[[0,[1,"insert-html"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["insert-image",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._insert-image))",[[0,[1,"insert-image"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["insert-last!",">syntax-color/index.html#(def._((lib._syntax-color/token-tree..ss)._insert-last!))",[0,[1,"insert-last!"]],["syntax-color/token-tree"]],
["insert-last-spec!",">syntax-color/index.html#(def._((lib._syntax-color/token-tree..ss)._insert-last-spec!))",[0,[1,"insert-last-spec!"]],["syntax-color/token-tree"]],
["insert-object-from-coclass",">mysterx/documents.html#(meth._(((lib._mysterx/main..ss)._mx-document~3c~25~3e)._insert-object-from-coclass))",[[0,[1,"insert-object-from-coclass"]],[12,[" (method of ",[0,[1,"mx-document&lt;%&gt;"]],")"]]],["mysterx"]],
["insert-object-from-coclass",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._insert-object-from-coclass))",[[0,[1,"insert-object-from-coclass"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["insert-object-from-progid",">mysterx/documents.html#(meth._(((lib._mysterx/main..ss)._mx-document~3c~25~3e)._insert-object-from-progid))",[[0,[1,"insert-object-from-progid"]],[12,[" (method of ",[0,[1,"mx-document&lt;%&gt;"]],")"]]],["mysterx"]],
["insert-object-from-progid",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._insert-object-from-progid))",[[0,[1,"insert-object-from-progid"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["insert-param",">web-server/url-param_ss.html#(def._((lib._web-server/private/url-param..ss)._insert-param))",[0,[1,"insert-param"]],["web-server/private/url-param"]],
["insert-port",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._insert-port))",[[0,[1,"insert-port"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["insert-prompt",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3atext~25)._insert-prompt))",[[0,[1,"insert-prompt"]],[12,[" (method of ",[0,[1,"drscheme:rep:text%"]],")"]]],["drscheme/tool-lib"]],
["insert-return",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._insert-return))",[[0,[1,"insert-return"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["insert-text",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._insert-text))",[[0,[1,"insert-text"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["inset",">slideshow/Bounding-Box_Adjusters.html#(def._((lib._slideshow/pict..ss)._inset))",[0,[1,"inset"]],["slideshow/pict","slideshow"]],
["inset/clip",">slideshow/Pict_Drawing_Adjusters.html#(def._((lib._slideshow/pict..ss)._inset/clip))",[0,[1,"inset/clip"]],["slideshow/pict","slideshow"]],
["inside: plt scheme c api",">inside/index.html","<b>Inside</b>: PLT Scheme C API",false],
["inspect",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._inspect))",[0,[6,"inspect"]],["scheme/class","scheme"]],
["inspecting modules and module dependencies",">syntax/module-helpers.html#(part._moddep)","Inspecting Modules and Module Dependencies",false],
["inspecting requests",">continue/index.html#(part._.Inspecting_.Requests)","Inspecting Requests",false],
["inspector",">reference/inspectors.html#(tech._inspector)","<i>inspector</i>",false],
["inspector?",">reference/inspectors.html#(def._((quote._~23~25kernel)._inspector~3f))",[0,[1,"inspector?"]],["scheme/base","scheme"]],
["inst",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._inst))",[0,[6,"inst"]],["typed-scheme"]],
["install",">planet/cmdline.html#(part._install)",[5,"install"],false],
["install plt file... menu item",">drscheme/Menus.html#(idx._(gentag._62._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Install PLT File...</font></b> menu item",false],
["install-converting-printer",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..ss)._install-converting-printer))",[0,[1,"install-converting-printer"]],["mzlib/pconvert"]],
["install-eopl-exception-handler",">eopl/index.html#(def._((lib._eopl/eopl..ss)._install-eopl-exception-handler))",[0,[1,"install-eopl-exception-handler"]],["eopl/eopl"]],
["install-help-browser-preference-panel",">browser/index.html#(def._((lib._browser/external..ss)._install-help-browser-preference-panel))",[0,[1,"install-help-browser-preference-panel"]],["browser/external"]],
["install-mred-program-launcher",">mzc/launcher.html#(def._((lib._launcher/launcher..ss)._install-mred-program-launcher))",[0,[1,"install-mred-program-launcher"]],["launcher/launcher"]],
["install-mzscheme-program-launcher",">mzc/launcher.html#(def._((lib._launcher/launcher..ss)._install-mzscheme-program-launcher))",[0,[1,"install-mzscheme-program-launcher"]],["launcher/launcher"]],
["install-readline!",">readline/index.html#(def._((lib._readline/main..ss)._install-readline!))",[0,[1,"install-readline!"]],["readline","readline/rep-start"]],
["installation",">mysterx/overview.html#(part._.Installation)","Installation",false],
["installation-specific launchers for scheme code",">mzc/launcher.html","Installation-Specific Launchers for Scheme Code",false],
["installed patch level",">version/index.html#(part._.Installed_.Patch_.Level)","Installed Patch Level",false],
["installing a single \".plt\" file",">setup-plt/_plt-archives.html#(part._.Installing_a_.Single___plt__.File)",["Installing a Single ",[5,"\".plt\""]," File"],false],
["installing calltrace",">trace/index.html#(part._.Installing_.Calltrace)","Installing Calltrace",false],
["installing errortrace",">errortrace/installing-errortrace.html","Installing Errortrace",false],
["installing libraries",">r6rs/Installing_Libraries.html","Installing Libraries",false],
["instant servlets",">web-server/insta.html","Instant Servlets",false],
["instantiate",">reference/objcreation.html#(form._((lib._scheme/private/class-internal..ss)._instantiate))",[0,[6,"instantiate"]],["scheme/class","scheme"]],
["instantiates",">guide/module-require.html#(tech._instantiate)","<i>instantiates</i>",false],
["instantiates",">reference/eval-model.html#(tech._instantiate)","<i>instantiates</i>",false],
["instantiation",">reference/eval-model.html#(tech._instantiation)","<i>instantiation</i>",false],
["instrumentation and profiling",">errortrace/using-errortrace.html#(part._instrumentation-and-profiling)","Instrumentation and Profiling",false],
["instrumenting-enabled",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..ss)._instrumenting-enabled))",[0,[1,"instrumenting-enabled"]],["errortrace"]],
["instrumenting-enabled",">trace/index.html#(def._((lib._trace/calltrace-lib..ss)._instrumenting-enabled))",[0,[1,"instrumenting-enabled"]],["trace/calltrace-lib"]],
["integer",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._.Integer))",[0,[6,"Integer"]],["typed-scheme"]],
["integer",">guide/numbers.html#(tech._integer)","<i>integer</i>",false],
["integer->char",">reference/characters.html#(def._((quote._~23~25kernel)._integer-~3echar))",[0,[1,"integer-&gt;char"]],["scheme/base","scheme"]],
["integer->char",">r5rs-std/r5rs-Z-H-9.html#%_idx_500",[0,[1,"integer-&gt;char"]],["r5rs"]],
["integer->char",">r6rs-std/r6rs-Z-H-14.html#node_idx_672",[0,[1,"integer-&gt;char"]],["rnrs/base-6"]],
["integer->char",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._integer-~3echar))",[0,[1,"integer-&gt;char"]],["lang/htdp-advanced"]],
["integer->char",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._integer-~3echar))",[0,[1,"integer-&gt;char"]],["lang/htdp-beginner"]],
["integer->char",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._integer-~3echar))",[0,[1,"integer-&gt;char"]],["lang/htdp-beginner-abbr"]],
["integer->char",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._integer-~3echar))",[0,[1,"integer-&gt;char"]],["lang/htdp-intermediate"]],
["integer->char",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._integer-~3echar))",[0,[1,"integer-&gt;char"]],["lang/htdp-intermediate-lambda"]],
["integer->integer-bytes",">reference/numbers.html#(def._((quote._~23~25kernel)._integer-~3einteger-bytes))",[0,[1,"integer-&gt;integer-bytes"]],["scheme/base","scheme"]],
["integer-bytes->integer",">reference/numbers.html#(def._((quote._~23~25kernel)._integer-bytes-~3einteger))",[0,[1,"integer-bytes-&gt;integer"]],["scheme/base","scheme"]],
["integer-in",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._integer-in))",[0,[1,"integer-in"]],["scheme/contract","scheme"]],
["integer-length",">reference/numbers.html#(def._((quote._~23~25kernel)._integer-length))",[0,[1,"integer-length"]],["scheme/base","scheme"]],
["integer-set-contents",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..ss)._integer-set-contents))",[0,[1,"integer-set-contents"]],["mzlib/integer-set"]],
["integer-set?",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..ss)._integer-set~3f))",[0,[1,"integer-set?"]],["mzlib/integer-set"]],
["integer-sqrt",">reference/numbers.html#(def._((quote._~23~25kernel)._integer-sqrt))",[0,[1,"integer-sqrt"]],["scheme/base","scheme"]],
["integer-sqrt/remainder",">reference/numbers.html#(def._((quote._~23~25kernel)._integer-sqrt/remainder))",[0,[1,"integer-sqrt/remainder"]],["scheme/base","scheme"]],
["integer-valued?",">r6rs-std/r6rs-Z-H-14.html#node_idx_454",[0,[1,"integer-valued?"]],["rnrs/base-6"]],
["integer?",">reference/numbers.html#(def._((quote._~23~25kernel)._integer~3f))",[0,[1,"integer?"]],["scheme/base","scheme"]],
["integer?",">r5rs-std/r5rs-Z-H-9.html#%_idx_252",[0,[1,"integer?"]],["r5rs"]],
["integer?",">r6rs-std/r6rs-Z-H-14.html#node_idx_448",[0,[1,"integer?"]],["rnrs/base-6"]],
["integer?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._integer~3f))",[0,[1,"integer?"]],["lang/htdp-advanced"]],
["integer?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._integer~3f))",[0,[1,"integer?"]],["lang/htdp-beginner"]],
["integer?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._integer~3f))",[0,[1,"integer?"]],["lang/htdp-beginner-abbr"]],
["integer?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._integer~3f))",[0,[1,"integer?"]],["lang/htdp-intermediate"]],
["integer?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._integer~3f))",[0,[1,"integer?"]],["lang/htdp-intermediate-lambda"]],
["integers",">inside/overview.html#(part._im~3aintsize)","Integers",false],
["integers",">reference/numbers.html#(tech._integer)","<i>integers</i>",false],
["integral",">frtime/index.html#(def._((lib._frtime/main..ss)._integral))",[0,[1,"integral"]],["frtime"]],
["integration with threads",">inside/threads.html#(part._.Integration_with_.Threads)","Integration with Threads",false],
["interact with drscheme in english menu item",">drscheme/Menus.html#(idx._(gentag._149._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Interact with DrScheme in English</font></b> menu item",false],
["interacting with evaluators",">reference/Sandboxed_Evaluation.html#(part._.Interacting_with_.Evaluators)","Interacting with Evaluators",false],
["interacting with scheme",">guide/intro.html#(part._.Interacting_with_.Scheme)","Interacting with Scheme",false],
["interacting with the readline-enabled input port",">readline/index.html#(part._.Interacting_with_the_.Readline-.Enabled_.Input_.Port_)","Interacting with the Readline-Enabled Input Port ",false],
["interaction",">scribble/eval.html#(form._((lib._scribble/eval..ss)._interaction))",[0,[6,"interaction"]],["scribble/eval"]],
["interaction wrapper: #%top-interaction",">reference/__top-interaction.html",["Interaction Wrapper: ",[0,[6,"#%top-interaction"]]],false],
["interaction-environment",">r5rs-std/r5rs-Z-H-9.html#%_idx_606",[0,[1,"interaction-environment"]],["r5rs"]],
["interaction-eval",">scribble/eval.html#(form._((lib._scribble/eval..ss)._interaction-eval))",[0,[6,"interaction-eval"]],["scribble/eval"]],
["interaction-eval-show",">scribble/eval.html#(form._((lib._scribble/eval..ss)._interaction-eval-show))",[0,[6,"interaction-eval-show"]],["scribble/eval"]],
["interactions",">drscheme/Keyboard_Shortcuts.html#(part._.Interactions)","Interactions",false],
["interactions",">teachpack/world.html#(part._interactive)","Interactions",false],
["interactions window",">drscheme/interface-essentials.html#(tech._interactions._window)","<i>interactions window</i>",false],
["interactions with canvas",">teachpack/draw.html#(part._interaction)","Interactions with Canvas",false],
["interactive help",">reference/Interactive_Help.html","Interactive Help",false],
["interactive mode",">guide/mzscheme.html#(part._start-interactive-mode)","Interactive Mode",false],
["interactive module loading",">reference/enter.html","Interactive Module Loading",false],
["interactive value port",">mrlib/Interactive_Value_Port.html","Interactive Value Port",false],
["interactive-adjust-mouse",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._interactive-adjust-mouse))",[[0,[1,"interactive-adjust-mouse"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["interactive-adjust-move",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._interactive-adjust-move))",[[0,[1,"interactive-adjust-move"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["interactive-adjust-resize",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._interactive-adjust-resize))",[[0,[1,"interactive-adjust-resize"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["interface",">scribble/reader.html#(part._.Interface)","Interface",false],
["interface",">htdc/advanced_iface.html",[0,"interface"],false],
["interface",">htdc/interface.html",[0,"interface"],false],
["interface",">htdc/intermed_iface.html",[0,"interface"],false],
["interface",">htdc/intermedAcc_iface.html",[0,"interface"],false],
["interface",">reference/createinterface.html#(form._((lib._scheme/private/class-internal..ss)._interface))",[0,[6,"interface"]],["scheme/class","scheme"]],
["interface",">reference/mzlib_class.html#(tech._interface)","<i>interface</i>",false],
["interface essentials",">drscheme/interface-essentials.html","Interface Essentials",false],
["interface reference",">drscheme/Interface_Reference.html","Interface Reference",false],
["interface->method-names",">reference/objectutils.html#(def._((lib._scheme/private/class-internal..ss)._interface-~3emethod-names))",[0,[1,"interface-&gt;method-names"]],["scheme/class","scheme"]],
["interface-extension?",">reference/objectutils.html#(def._((lib._scheme/private/class-internal..ss)._interface-extension~3f))",[0,[1,"interface-extension?"]],["scheme/class","scheme"]],
["interface-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._interface-index-desc))",[0,[1,"interface-index-desc"]],["scribble/manual-struct"]],
["interface-index-desc?",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._interface-index-desc~3f))",[0,[1,"interface-index-desc?"]],["scribble/manual-struct"]],
["interface-version",">web-server/module-servlets.html#(def._((lib._web-server/scribblings/dummy-servlet..ss)._interface-version))",[0,[1,"interface-version"]],[]],
["interface?",">reference/objectutils.html#(def._((lib._scheme/private/class-internal..ss)._interface~3f))",[0,[1,"interface?"]],["scheme/class","scheme"]],
["interfaces",">guide/classes.html#(part._.Interfaces)","Interfaces",false],
["interior",">foreign/foreign_pointer-funcs.html#(idx._(gentag._9._(lib._scribblings/foreign/foreign..scrbl)))",[7,"'interior"],false],
["intermediate student",">htdp-langs/intermediate.html","Intermediate Student",false],
["intermediate student language",">drscheme/htdp-langs.html#(idx._(gentag._45._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Intermediate Student</font></b> language",false],
["intermediate student with lambda",">htdp-langs/intermediate-lam.html","Intermediate Student with Lambda",false],
["intermediate student with lambda language",">drscheme/htdp-langs.html#(idx._(gentag._46._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Intermediate Student with Lambda</font></b>\nlanguage",false],
["internal",">web-server/private.html","Internal",false],
["internal and external names",">guide/classes.html#(part._intnames)","Internal and External Names",false],
["internal and external names",">reference/createclass.html#(part._extnames)","Internal and External Names",false],
["internal certificates",">guide/stx-certs.html#(part._.Internal_.Certificates)","Internal Certificates",false],
["internal definitions",">guide/define.html#(part._intdefs)","Internal Definitions",false],
["internal definitions",">reference/syntax-model.html#(part._intdef-body)","Internal Definitions",false],
["internal editor locks",">gui/editor-overview.html#(part._lockinfo)","Internal Editor Locks",false],
["internal preferences",">gui/fontresources.html#(part._.Internal_.Preferences)","Internal Preferences",false],
["internal-definition context",">reference/syntax-model.html#(tech._internal._definition._context)","<i>internal-definition context</i>",false],
["interned",">reference/symbols.html#(tech._interned)","<i>interned</i>",false],
["intersect",">gui/region_.html#(meth._(((lib._mred/main..ss)._region~25)._intersect))",[[0,[1,"intersect"]],[12,[" (method of ",[0,[1,"region%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["intersect",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..ss)._intersect))",[0,[1,"intersect"]],["mzlib/integer-set"]],
["interval",">gui/timer_.html#(meth._(((lib._mred/main..ss)._timer~25)._interval))",[[0,[1,"interval"]],[12,[" (method of ",[0,[1,"timer%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["introduce-let-ans",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._introduce-let-ans))",[[0,[1,"introduce-let-ans"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["introducing bindings",">reference/syntax-model.html#(part._intro-binding)","Introducing Bindings",false],
["invalid-%-suffix",">net/cgi.html#(def._((lib._net/cgi..ss)._invalid-~25-suffix))",[0,[1,"invalid-%-suffix"]],["net/cgi"]],
["invalid-%-suffix-char",">net/cgi.html#(def._((lib._net/cgi..ss)._invalid-~25-suffix-char))",[0,[1,"invalid-%-suffix-char"]],["net/cgi"]],
["invalid-%-suffix?",">net/cgi.html#(def._((lib._net/cgi..ss)._invalid-~25-suffix~3f))",[0,[1,"invalid-%-suffix?"]],["net/cgi"]],
["invalidate-bitmap-cache",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._invalidate-bitmap-cache))",[[0,[1,"invalidate-bitmap-cache"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["invert",">graphics/Draw__Clear__and_Flip_Operations.html#(tech._invert)","<i>invert</i>",false],
["invisible",">gui/snip_.html#(idx._(gentag._247._(lib._scribblings/gui/gui..scrbl)))",[7,"'invisible"],false],
["invoke-unit",">reference/invokingunits.html#(form._((lib._mzlib/unit..ss)._invoke-unit))",[0,[6,"invoke-unit"]],["scheme/unit","scheme"]],
["invoke-unit/infer",">reference/linkinference.html#(form._((lib._mzlib/unit..ss)._invoke-unit/infer))",[0,[6,"invoke-unit/infer"]],["scheme/unit","scheme"]],
["invoked",">guide/units.html#(tech._invoked)","<i>invoked</i>",false],
["invoked",">reference/mzlib_unit.html#(tech._invoked)","<i>invoked</i>",false],
["invoking mzpp",">preprocessor/mzpp.html#(part._.Invoking_mzpp)","Invoking mzpp",false],
["invoking mztext",">preprocessor/mztext.html#(part._.Invoking_mztext)","Invoking mztext",false],
["invoking units",">guide/Invoking_Units.html","Invoking Units",false],
["invoking units",">reference/invokingunits.html","Invoking Units",false],
["iota",">srfi-std/srfi-1.html#iota",[0,[1,"iota"]],["srfi/1"]],
["irritants-condition?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_448",[0,[1,"irritants-condition?"]],["rnrs/conditions-6"]],
["is-a?",">reference/objectutils.html#(def._((lib._scheme/private/class-internal..ss)._is-a~3f))",[0,[1,"is-a?"]],["scheme/class","scheme"]],
["is-a?/c",">reference/Object_and_Class_Contracts.html#(def._((lib._scheme/class..ss)._is-a~3f/c))",[0,[1,"is-a?/c"]],["scheme/class","scheme"]],
["is-busy?",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._is-busy~3f))",[0,[1,"is-busy?"]],["scheme/gui/base","scheme/gui"]],
["is-checked?",">gui/checkable-menu-item_.html#(meth._(((lib._mred/main..ss)._checkable-menu-item~25)._is-checked~3f))",[[0,[1,"is-checked?"]],[12,[" (method of ",[0,[1,"checkable-menu-item%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["is-color-display?",">gui/Drawing_Functions.html#(def._((lib._mred/main..ss)._is-color-display~3f))",[0,[1,"is-color-display?"]],["scheme/gui/base","scheme/gui"]],
["is-color?",">gui/bitmap_.html#(meth._(((lib._mred/main..ss)._bitmap~25)._is-color~3f))",[[0,[1,"is-color?"]],[12,[" (method of ",[0,[1,"bitmap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["is-current-tab?",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3atab~3c~25~3e)._is-current-tab~3f))",[[0,[1,"is-current-tab?"]],[12,[" (method of ",[0,[1,"drscheme:unit:tab&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["is-deleted?",">gui/menu-item___.html#(meth._(((lib._mred/main..ss)._menu-item~3c~25~3e)._is-deleted~3f))",[[0,[1,"is-deleted?"]],[12,[" (method of ",[0,[1,"menu-item&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["is-empty?",">gui/region_.html#(meth._(((lib._mred/main..ss)._region~25)._is-empty~3f))",[[0,[1,"is-empty?"]],[12,[" (method of ",[0,[1,"region%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["is-enabled?",">gui/labelled-menu-item___.html#(meth._(((lib._mred/main..ss)._labelled-menu-item~3c~25~3e)._is-enabled~3f))",[[0,[1,"is-enabled?"]],[12,[" (method of ",[0,[1,"labelled-menu-item&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["is-enabled?",">gui/menu-bar_.html#(meth._(((lib._mred/main..ss)._menu-bar~25)._is-enabled~3f))",[[0,[1,"is-enabled?"]],[12,[" (method of ",[0,[1,"menu-bar%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["is-enabled?",">gui/radio-box_.html#(meth._(((lib._mred/main..ss)._radio-box~25)._is-enabled~3f))",[[0,[1,"is-enabled?"]],[12,[" (method of ",[0,[1,"radio-box%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["is-enabled?",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._is-enabled~3f))",[[0,[1,"is-enabled?"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["is-frozen?",">framework/Color.html#(meth._(((lib._framework/main..ss)._color~3atext~3c~25~3e)._is-frozen~3f))",[[0,[1,"is-frozen?"]],[12,[" (method of ",[0,[1,"color:text&lt;%&gt;"]],")"]]],["framework"]],
["is-iconized?",">gui/frame_.html#(meth._(((lib._mred/main..ss)._frame~25)._is-iconized~3f))",[[0,[1,"is-iconized?"]],[12,[" (method of ",[0,[1,"frame%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["is-info-hidden?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3ainfo~3c~25~3e)._is-info-hidden~3f))",[[0,[1,"is-info-hidden?"]],[12,[" (method of ",[0,[1,"frame:info&lt;%&gt;"]],")"]]],["framework"]],
["is-join?",">gui/style___.html#(meth._(((lib._mred/main..ss)._style~3c~25~3e)._is-join~3f))",[[0,[1,"is-join?"]],[12,[" (method of ",[0,[1,"style&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["is-locked?",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._is-locked~3f))",[[0,[1,"is-locked?"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["is-maximized?",">gui/frame_.html#(meth._(((lib._mred/main..ss)._frame~25)._is-maximized~3f))",[[0,[1,"is-maximized?"]],[12,[" (method of ",[0,[1,"frame%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["is-modified?",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._is-modified~3f))",[[0,[1,"is-modified?"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["is-open",">mrlib/hierarchical-list-compound-item___.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list-compound-item~3c~25~3e)._is-open))",[[0,[1,"is-open"]],[12,[" (method of ",[0,[1,"hierarchical-list-compound-item&lt;%&gt;"]],")"]]],["mrlib/hierlist"]],
["is-owned?",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._is-owned~3f))",[[0,[1,"is-owned?"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["is-running?",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3atab~3c~25~3e)._is-running~3f))",[[0,[1,"is-running?"]],[12,[" (method of ",[0,[1,"drscheme:unit:tab&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["is-selected?",">gui/list-box_.html#(meth._(((lib._mred/main..ss)._list-box~25)._is-selected~3f))",[[0,[1,"is-selected?"]],[12,[" (method of ",[0,[1,"list-box%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["is-selected?",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._is-selected~3f))",[[0,[1,"is-selected?"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["is-selected?",">mrlib/hierarchical-list-item___.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list-item~3c~25~3e)._is-selected~3f))",[[0,[1,"is-selected?"]],[12,[" (method of ",[0,[1,"hierarchical-list-item&lt;%&gt;"]],")"]]],["mrlib/hierlist"]],
["is-shown?",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._is-shown~3f))",[[0,[1,"is-shown?"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["is-shown?",">embedded-gui/alignment-parent___.html#(meth._(((lib._embedded-gui/main..ss)._alignment-parent~3c~25~3e)._is-shown~3f))",[[0,[1,"is-shown?"]],[12,[" (method of ",[0,[1,"alignment-parent&lt;%&gt;"]],")"]]],["embedded-gui"]],
["is-special-first-line?",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3afirst-line~3c~25~3e)._is-special-first-line~3f))",[[0,[1,"is-special-first-line?"]],[12,[" (method of ",[0,[1,"text:first-line&lt;%&gt;"]],")"]]],["framework"]],
["is-stopped?",">framework/Color.html#(meth._(((lib._framework/main..ss)._color~3atext~3c~25~3e)._is-stopped~3f))",[[0,[1,"is-stopped?"]],[12,[" (method of ",[0,[1,"color:text&lt;%&gt;"]],")"]]],["framework"]],
["is-text",">gui/snip_.html#(idx._(gentag._245._(lib._scribblings/gui/gui..scrbl)))",[7,"'is-text"],false],
["is-wxme-stream?",">gui/WXME_Decoding.html#(def._((lib._wxme/main..ss)._is-wxme-stream~3f))",[0,[1,"is-wxme-stream?"]],["wxme"]],
["isindex",">html/index.html#(def._((lib._html/main..ss)._isindex))",[0,[1,"isindex"]],["html"]],
["isindex?",">html/index.html#(def._((lib._html/main..ss)._isindex~3f))",[0,[1,"isindex?"]],["html"]],
["iso-control",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..ss)._iso-control))",[0,[6,"iso-control"]],["parser-tools/lex"]],
["it",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..ss)._it))",[0,[1,"it"]],["slideshow/base","slideshow"]],
["italic",">scribble/basic.html#(def._((lib._scribble/basic..ss)._italic))",[0,[1,"italic"]],["scribble/basic"]],
["italic",">gui/font_.html#(idx._(gentag._204._(lib._scribblings/gui/gui..scrbl)))",[7,"'italic"],false],
["italic",">gui/style-delta_.html#(idx._(gentag._265._(lib._scribblings/gui/gui..scrbl)))",[7,"'italic"],false],
["item",">scribble/basic.html#(def._((lib._scribble/basic..ss)._item))",[0,[1,"item"]],["scribble/basic"]],
["item",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..ss)._item))",[0,[1,"item"]],["slideshow/base","slideshow"]],
["item",">gui/editor-overview.html#(tech._item)","<i>item</i>",false],
["item?",">scribble/basic.html#(def._((lib._scribble/basic..ss)._item~3f))",[0,[1,"item?"]],["scribble/basic"]],
["itemization",">scribble/struct.html#(def._((lib._scribble/struct..ss)._itemization))",[0,[1,"itemization"]],["scribble/struct"]],
["itemization",">scribble/struct.html#(tech._itemization)","<i>itemization</i>",false],
["itemization-flows",">scribble/struct.html#(def._((lib._scribble/struct..ss)._itemization-flows))",[0,[1,"itemization-flows"]],["scribble/struct"]],
["itemization?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._itemization~3f))",[0,[1,"itemization?"]],["scribble/struct"]],
["itemize",">scribble/basic.html#(def._((lib._scribble/basic..ss)._itemize))",[0,[1,"itemize"]],["scribble/basic"]],
["iteration and comprehension forms",">reference/for.html#(part._.Iteration_and_.Comprehension_.Forms)","Iteration and Comprehension Forms",false],
["iteration performance",">guide/for.html#(part._for-performance)","Iteration Performance",false],
["iterations and comprehensions",">guide/for.html","Iterations and Comprehensions",false],
["iterations and comprehensions: for, for/list, ...",">reference/for.html",["Iterations and Comprehensions: ",[0,[6,"for"]],", ",[0,[6,"for/list"]],", ..."],false],
["jack-o-lantern",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._jack-o-lantern))",[0,[1,"jack-o-lantern"]],["slideshow/pict","slideshow"]],
["javascript",">scribble/struct.html#(idx._(gentag._0._(lib._scribblings/scribble/scribble..scrbl)))","Javascript",false],
["jewel --- 3-d skill game",">games/jewel.html",[[13,"<img src=\"jewel.png\" />"]," ","<b><font size=\"-1\" face=\"Helvetica\">Jewel</font></b>","  ","&ndash;","  3-D Skill Game"],false],
["jit",">guide/performance.html#(tech._jit)","<i>JIT</i>",false],
["join style",">gui/editor-overview.html#(tech._join._style)","<i>join style</i>",false],
["jpeg",">gui/bitmap_.html#(idx._(gentag._164._(lib._scribblings/gui/gui..scrbl)))","JPEG",false],
["jpeg",">gui/bitmap_.html#(idx._(gentag._173._(lib._scribblings/gui/gui..scrbl)))","JPEG",false],
["julian-day->date",">srfi-std/srfi-19.html#julian-day->date",[0,[1,"julian-day-&gt;date"]],["srfi/19"]],
["julian-day->time-monotonic",">srfi-std/srfi-19.html#julian-day->time-monotonic",[0,[1,"julian-day-&gt;time-monotonic"]],["srfi/19"]],
["julian-day->time-tai",">srfi-std/srfi-19.html#julian-day->time-tai",[0,[1,"julian-day-&gt;time-tai"]],["srfi/19"]],
["julian-day->time-utc",">srfi-std/srfi-19.html#julian-day->time-utc",[0,[1,"julian-day-&gt;time-utc"]],["srfi/19"]],
["julian/scalinger->string",">reference/time.html#(def._((lib._scheme/date..ss)._julian/scalinger-~3estring))",[0,[1,"julian/scalinger-&gt;string"]],["scheme/date"]],
["jump-to",">gui/editor-stream-in_.html#(meth._(((lib._mred/main..ss)._editor-stream-in~25)._jump-to))",[[0,[1,"jump-to"]],[12,[" (method of ",[0,[1,"editor-stream-in%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["jump-to",">gui/editor-stream-out_.html#(meth._(((lib._mred/main..ss)._editor-stream-out~25)._jump-to))",[[0,[1,"jump-to"]],[12,[" (method of ",[0,[1,"editor-stream-out%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["just-after",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._just-after))",[0,[1,"just-after"]],["redex/pict"]],
["just-before",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._just-before))",[0,[1,"just-before"]],["redex/pict"]],
["just-in-time",">guide/performance.html#(tech._just._in._time)","<i>just-in-time</i>",false],
["k-url?",">web-server/servlet-structs_ss.html#(def._((lib._web-server/servlet/servlet-structs..ss)._k-url~3f))",[0,[1,"k-url?"]],["web-server/servlet/servlet-structs"]],
["kbd",">html/index.html#(def._((lib._html/main..ss)._kbd))",[0,[1,"kbd"]],["html"]],
["kbd?",">html/index.html#(def._((lib._html/main..ss)._kbd~3f))",[0,[1,"kbd?"]],["html"]],
["keep-blanks",">readline/index.html#(def._((lib._readline/pread..ss)._keep-blanks))",[0,[1,"keep-blanks"]],["readline/pread"]],
["keep-duplicates",">readline/index.html#(def._((lib._readline/pread..ss)._keep-duplicates))",[0,[1,"keep-duplicates"]],["readline/pread"]],
["kernel-form-identifier-list",">syntax/syntax-helpers.html#(def._((lib._syntax/kerncase..ss)._kernel-form-identifier-list))",[0,[1,"kernel-form-identifier-list"]],["syntax/kerncase"]],
["kernel-syntax-case",">syntax/syntax-helpers.html#(form._((lib._syntax/kerncase..ss)._kernel-syntax-case))",[0,[6,"kernel-syntax-case"]],["syntax/kerncase"]],
["kernel-syntax-case*",">syntax/syntax-helpers.html#(form._((lib._syntax/kerncase..ss)._kernel-syntax-case*))",[0,[6,"kernel-syntax-case*"]],["syntax/kerncase"]],
["key-event%",">gui/key-event_.html",[0,[1,"key-event%"]],["scheme/gui/base","scheme/gui"]],
["key-event?",">teachpack/world.html#(def._((lib._teachpack/htdp/world..ss)._key-event~3f))",[0,[1,"key-event?"]],["teachpack/htdp/world"]],
["key-value",">graphics/Keyboard_Operations.html#(def._((lib._graphics/graphics..ss)._key-value))",[0,[1,"key-value"]],["graphics/graphics"]],
["key=?",">teachpack/world.html#(def._((lib._teachpack/htdp/world..ss)._key~3d~3f))",[0,[1,"key=?"]],["teachpack/htdp/world"]],
["keybindings",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._152._(lib._scribblings/drscheme/drscheme..scrbl)))","keybindings",false],
["keybindings menu item",">drscheme/Menus.html#(idx._(gentag._92._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Keybindings</font></b> menu item",false],
["keyboard events overview",">gui/windowing-overview.html#(idx._(gentag._4._(lib._scribblings/gui/gui..scrbl)))","keyboard\n events, overview",false],
["keyboard focus snips",">gui/editor___.html#(idx._(gentag._232._(lib._scribblings/gui/gui..scrbl)))","keyboard focus, snips",false],
["keyboard focus setting",">gui/window___.html#(idx._(gentag._142._(lib._scribblings/gui/gui..scrbl)))","keyboard focus, setting",false],
["keyboard focus overview",">gui/windowing-overview.html#(idx._(gentag._3._(lib._scribblings/gui/gui..scrbl)))","keyboard focus, overview",false],
["keyboard focus notification",">gui/window___.html#(idx._(gentag._144._(lib._scribblings/gui/gui..scrbl)))","keyboard focus, notification",false],
["keyboard focus notification",">gui/editor___.html#(idx._(gentag._234._(lib._scribblings/gui/gui..scrbl)))","keyboard focus, notification",false],
["keyboard focus navigation",">gui/top-level-window___.html#(idx._(gentag._138._(lib._scribblings/gui/gui..scrbl)))","keyboard focus, navigation",false],
["keyboard focus navigation",">gui/editor-canvas_.html#(idx._(gentag._238._(lib._scribblings/gui/gui..scrbl)))","keyboard focus, navigation",false],
["keyboard focus navigation",">gui/canvas_.html#(idx._(gentag._31._(lib._scribblings/gui/gui..scrbl)))","keyboard focus, navigation",false],
["keyboard focus navigation",">gui/windowing-overview.html#(idx._(gentag._8._(lib._scribblings/gui/gui..scrbl)))","keyboard focus, navigation",false],
["keyboard focus last active",">gui/top-level-window___.html#(idx._(gentag._133._(lib._scribblings/gui/gui..scrbl)))","keyboard focus, last active",false],
["keyboard focus last active",">gui/top-level-window___.html#(idx._(gentag._134._(lib._scribblings/gui/gui..scrbl)))","keyboard focus, last active",false],
["keyboard focus",">gui/top-level-window___.html#(idx._(gentag._135._(lib._scribblings/gui/gui..scrbl)))","keyboard focus",false],
["keyboard focus",">gui/top-level-window___.html#(idx._(gentag._136._(lib._scribblings/gui/gui..scrbl)))","keyboard focus",false],
["keyboard focus",">gui/windowing-overview.html#(tech._keyboard._focu)","<i>keyboard focus</i>",false],
["keyboard operations",">graphics/Keyboard_Operations.html","Keyboard Operations",false],
["keyboard shortcuts",">drscheme/Keyboard_Shortcuts.html","Keyboard Shortcuts",false],
["keycode",">mysterx/html-events.html#(meth._(((lib._mysterx/main..ss)._mx-event~3c~25~3e)._keycode))",[[0,[1,"keycode"]],[12,[" (method of ",[0,[1,"mx-event&lt;%&gt;"]],")"]]],["mysterx"]],
["keydown?",">mysterx/html-events.html#(meth._(((lib._mysterx/main..ss)._mx-event~3c~25~3e)._keydown~3f))",[[0,[1,"keydown?"]],[12,[" (method of ",[0,[1,"mx-event&lt;%&gt;"]],")"]]],["mysterx"]],
["keyevent",">teachpack/world.html#(tech._keyevent)","<i>KeyEvent</i>",false],
["keymap",">framework/Keymap.html","Keymap",false],
["keymap%",">gui/keymap_.html",[0,[1,"keymap%"]],["scheme/gui/base","scheme/gui"]],
["keymap:add-to-right-button-menu",">framework/Keymap.html#(def._((lib._framework/main..ss)._keymap~3aadd-to-right-button-menu))",[0,[1,"keymap:add-to-right-button-menu"]],["framework"]],
["keymap:add-to-right-button-menu/before",">framework/Keymap.html#(def._((lib._framework/main..ss)._keymap~3aadd-to-right-button-menu/before))",[0,[1,"keymap:add-to-right-button-menu/before"]],["framework"]],
["keymap:add-user-keybindings-file",">framework/Keymap.html#(def._((lib._framework/main..ss)._keymap~3aadd-user-keybindings-file))",[0,[1,"keymap:add-user-keybindings-file"]],["framework"]],
["keymap:aug-keymap%",">framework/Keymap.html#(def._((lib._framework/main..ss)._keymap~3aaug-keymap~25))",[0,[1,"keymap:aug-keymap%"]],["framework"]],
["keymap:aug-keymap-mixin",">framework/Keymap.html#(def._((lib._framework/main..ss)._keymap~3aaug-keymap-mixin))",[0,[1,"keymap:aug-keymap-mixin"]],["framework"]],
["keymap:aug-keymap<%>",">framework/Keymap.html#(def._((lib._framework/main..ss)._keymap~3aaug-keymap~3c~25~3e))",[0,[1,"keymap:aug-keymap&lt;%&gt;"]],["framework"]],
["keymap:call/text-keymap-initializer",">framework/Keymap.html#(def._((lib._framework/main..ss)._keymap~3acall/text-keymap-initializer))",[0,[1,"keymap:call/text-keymap-initializer"]],["framework"]],
["keymap:canonicalize-keybinding-string",">framework/Keymap.html#(def._((lib._framework/main..ss)._keymap~3acanonicalize-keybinding-string))",[0,[1,"keymap:canonicalize-keybinding-string"]],["framework"]],
["keymap:get-editor",">framework/Keymap.html#(def._((lib._framework/main..ss)._keymap~3aget-editor))",[0,[1,"keymap:get-editor"]],["framework"]],
["keymap:get-file",">framework/Keymap.html#(def._((lib._framework/main..ss)._keymap~3aget-file))",[0,[1,"keymap:get-file"]],["framework"]],
["keymap:get-global",">framework/Keymap.html#(def._((lib._framework/main..ss)._keymap~3aget-global))",[0,[1,"keymap:get-global"]],["framework"]],
["keymap:get-search",">framework/Keymap.html#(def._((lib._framework/main..ss)._keymap~3aget-search))",[0,[1,"keymap:get-search"]],["framework"]],
["keymap:make-meta-prefix-list",">framework/Keymap.html#(def._((lib._framework/main..ss)._keymap~3amake-meta-prefix-list))",[0,[1,"keymap:make-meta-prefix-list"]],["framework"]],
["keymap:remove-chained-keymap",">framework/Keymap.html#(def._((lib._framework/main..ss)._keymap~3aremove-chained-keymap))",[0,[1,"keymap:remove-chained-keymap"]],["framework"]],
["keymap:remove-user-keybindings-file",">framework/Keymap.html#(def._((lib._framework/main..ss)._keymap~3aremove-user-keybindings-file))",[0,[1,"keymap:remove-user-keybindings-file"]],["framework"]],
["keymap:send-map-function-meta",">framework/Keymap.html#(def._((lib._framework/main..ss)._keymap~3asend-map-function-meta))",[0,[1,"keymap:send-map-function-meta"]],["framework"]],
["keymap:set-chained-keymaps",">framework/Keymap.html#(def._((lib._framework/main..ss)._keymap~3aset-chained-keymaps))",[0,[1,"keymap:set-chained-keymaps"]],["framework"]],
["keymap:setup-editor",">framework/Keymap.html#(def._((lib._framework/main..ss)._keymap~3asetup-editor))",[0,[1,"keymap:setup-editor"]],["framework"]],
["keymap:setup-file",">framework/Keymap.html#(def._((lib._framework/main..ss)._keymap~3asetup-file))",[0,[1,"keymap:setup-file"]],["framework"]],
["keymap:setup-global",">framework/Keymap.html#(def._((lib._framework/main..ss)._keymap~3asetup-global))",[0,[1,"keymap:setup-global"]],["framework"]],
["keymap:setup-search",">framework/Keymap.html#(def._((lib._framework/main..ss)._keymap~3asetup-search))",[0,[1,"keymap:setup-search"]],["framework"]],
["keypress?",">mysterx/html-events.html#(meth._(((lib._mysterx/main..ss)._mx-event~3c~25~3e)._keypress~3f))",[[0,[1,"keypress?"]],[12,[" (method of ",[0,[1,"mx-event&lt;%&gt;"]],")"]]],["mysterx"]],
["keyup?",">mysterx/html-events.html#(meth._(((lib._mysterx/main..ss)._mx-event~3c~25~3e)._keyup~3f))",[[0,[1,"keyup?"]],[12,[" (method of ",[0,[1,"mx-event&lt;%&gt;"]],")"]]],["mysterx"]],
["keyword",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._.Keyword))",[0,[6,"Keyword"]],["typed-scheme"]],
["keyword",">guide/keywords.html#(tech._keyword)","<i>keyword</i>",false],
["keyword",">reference/keywords.html#(tech._keyword)","<i>keyword</i>",false],
["keyword arguments",">mzlib/mzlib_kw.html#(part._.Keyword_.Arguments)","Keyword Arguments",false],
["keyword arguments",">guide/contracts-general-functions.html#(part._contracts-keywords)","Keyword Arguments",false],
["keyword arguments",">guide/application.html#(part._keyword-args)","Keyword Arguments",false],
["keyword->string",">reference/keywords.html#(def._((quote._~23~25kernel)._keyword-~3estring))",[0,[1,"keyword-&gt;string"]],["scheme/base","scheme"]],
["keyword-apply",">reference/procedures.html#(def._((lib._scheme/base..ss)._keyword-apply))",[0,[1,"keyword-apply"]],["scheme/base","scheme"]],
["keyword-color",">slideshow/Typesetting_Scheme_Code.html#(def._((lib._slideshow/code..ss)._keyword-color))",[0,[1,"keyword-color"]],["slideshow/code"]],
["keyword-get",">mzlib/mzlib_kw.html#(def._((lib._mzlib/kw..ss)._keyword-get))",[0,[1,"keyword-get"]],["mzlib/kw"]],
["keyword<?",">reference/keywords.html#(def._((quote._~23~25kernel)._keyword~3c~3f))",[0,[1,"keyword&lt;?"]],["scheme/base","scheme"]],
["keyword?",">reference/keywords.html#(def._((quote._~23~25kernel)._keyword~3f))",[0,[1,"keyword?"]],["scheme/base","scheme"]],
["keywords",">guide/keywords.html","Keywords",false],
["keywords",">reference/keywords.html","Keywords",false],
["keywords and arity",">reference/procedures.html#(part._.Keywords_and_.Arity)","Keywords and Arity",false],
["kill",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._kill))",[[0,[1,"kill"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["kill",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._kill))",[[0,[1,"kill"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["kill menu item",">drscheme/Menus.html#(idx._(gentag._120._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Kill</font></b> menu item",false],
["kill-connection!",">web-server/connection-manager_ss.html#(def._((lib._web-server/private/connection-manager..ss)._kill-connection!))",[0,[1,"kill-connection!"]],["web-server/private/connection-manager"]],
["kill-evaluation",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3atext~25)._kill-evaluation))",[[0,[1,"kill-evaluation"]],[12,[" (method of ",[0,[1,"drscheme:rep:text%"]],")"]]],["drscheme/tool-lib"]],
["kill-evaluator",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._kill-evaluator))",[0,[1,"kill-evaluator"]],["scheme/sandbox"]],
["kill-thread",">reference/threads.html#(def._((quote._~23~25kernel)._kill-thread))",[0,[1,"kill-thread"]],["scheme/base","scheme"]],
["kill-word",">framework/Keymap.html#(idx._(gentag._26._(lib._scribblings/framework/framework..scrbl)))","kill-word",false],
["kleeneplus",">scribble/bnf.html#(def._((lib._scribble/bnf..ss)._kleeneplus))",[0,[1,"kleeneplus"]],["scribble/bnf"]],
["kleenerange",">scribble/bnf.html#(def._((lib._scribble/bnf..ss)._kleenerange))",[0,[1,"kleenerange"]],["scribble/bnf"]],
["kleenestar",">scribble/bnf.html#(def._((lib._scribble/bnf..ss)._kleenestar))",[0,[1,"kleenestar"]],["scribble/bnf"]],
["kmp-step",">srfi-std/srfi-13.html#kmp-step",[0,[1,"kmp-step"]],["srfi/13"]],
["koch",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..ss)._koch))",[0,"koch"],["graphics/turtle-examples"]],
["koch snowflake",">turtles/Traditional_Turtles.html#(idx._(gentag._1._(lib._graphics/scribblings/turtles..scrbl)))","Koch snowflake",false],
["koch-nosplit",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..ss)._koch-nosplit))",[0,"koch-nosplit"],["graphics/turtle-examples"]],
["koch-size",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..ss)._koch-size))",[0,[1,"koch-size"]],["graphics/turtle-examples"]],
["label",">html/index.html#(def._((lib._html/main..ss)._label))",[0,[1,"label"]],["html"]],
["label phase level",">reference/syntax-model.html#(tech._label._phase._level)","<i>label phase level</i>",false],
["label->plain-label",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._label-~3eplain-label))",[0,[1,"label-&gt;plain-label"]],["scheme/gui/base","scheme/gui"]],
["label-font-size",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._label-font-size))",[0,[1,"label-font-size"]],["redex/pict"]],
["label-style",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._label-style))",[0,[1,"label-style"]],["redex/pict"]],
["label?",">html/index.html#(def._((lib._html/main..ss)._label~3f))",[0,[1,"label?"]],["html"]],
["labelled-menu-item<%>",">gui/labelled-menu-item___.html",[0,[1,"labelled-menu-item&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["lambda",">htdp-langs/advanced-lambda.html",[0,[6,"lambda"]],false],
["lambda",">htdp-langs/intermediate-lambda.html",[0,[6,"lambda"]],false],
["lambda",">reference/lambda.html#(form._((lib._scheme/base..ss)._lambda))",[0,[6,"lambda"]],["scheme/base","scheme"]],
["lambda",">r5rs-std/r5rs-Z-H-7.html#%_idx_96",[0,[6,"lambda"]],["r5rs"]],
["lambda",">r6rs-std/r6rs-Z-H-14.html#node_idx_364",[0,[6,"lambda"]],["rnrs/base-6"]],
["lambda",">htdp-langs/advanced-lambda.html#(form._((lib._lang/htdp-advanced..ss)._lambda))",[0,[6,"lambda"]],["lang/htdp-advanced"]],
["lambda",">htdp-langs/define.html#(form._((lib._lang/htdp-beginner..ss)._lambda))",[0,[6,"lambda"]],["lang/htdp-beginner"]],
["lambda",">htdp-langs/Unchanged_Forms.html#(form._((lib._lang/htdp-beginner-abbr..ss)._lambda))",[0,[6,"lambda"]],["lang/htdp-beginner-abbr"]],
["lambda",">htdp-langs/intermediate-define.html#(form._((lib._lang/htdp-intermediate..ss)._lambda))",[0,[6,"lambda"]],["lang/htdp-intermediate"]],
["lambda",">htdp-langs/intermediate-lambda.html#(form._((lib._lang/htdp-intermediate-lambda..ss)._lambda))",[0,[6,"lambda"]],["lang/htdp-intermediate-lambda"]],
["lambda",">lazy/index.html#(form._((lib._lazy/main..ss)._lambda))",[0,[6,"lambda"]],["lazy"]],
["lambda",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..ss)._lambda))",[0,[6,"lambda"]],["mzscheme"]],
["lambda/kw",">mzlib/mzlib_kw.html#(form._((lib._mzlib/kw..ss)._lambda/kw))",[0,[6,"lambda/kw"]],["mzlib/kw"]],
["lambda:",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._lambda~3a))",[0,[6,"lambda:"]],["typed-scheme"]],
["lang",">reference/runtime.html#(idx._(gentag._311._(lib._scribblings/reference/reference..scrbl)))",[5,"LANG"],false],
["lang/htdp-advanced",">htdp-lib/index.html#(mod-path._lang/htdp-advanced)",[14,[0,"lang/htdp-advanced"]],"module"],
["lang/htdp-beginner",">htdp-lib/index.html#(mod-path._lang/htdp-beginner)",[14,[0,"lang/htdp-beginner"]],"module"],
["lang/htdp-beginner-abbr",">htdp-lib/index.html#(mod-path._lang/htdp-beginner-abbr)",[14,[0,"lang/htdp-beginner-abbr"]],"module"],
["lang/htdp-intermediate",">htdp-lib/index.html#(mod-path._lang/htdp-intermediate)",[14,[0,"lang/htdp-intermediate"]],"module"],
["lang/htdp-intermediate-lambda",">htdp-lib/index.html#(mod-path._lang/htdp-intermediate-lambda)",[14,[0,"lang/htdp-intermediate-lambda"]],"module"],
["lang/imageeq",">htdp-lib/index.html#(mod-path._lang/imageeq)",[14,[0,"lang/imageeq"]],"module"],
["lang/plt-pretty-big",">htdp-lib/index.html#(mod-path._lang/plt-pretty-big)",[14,[0,"lang/plt-pretty-big"]],"module"],
["lang/plt-pretty-big-text",">htdp-lib/index.html#(mod-path._lang/plt-pretty-big-text)",[14,[0,"lang/plt-pretty-big-text"]],"module"],
["lang/posn",">htdp-lib/index.html#(mod-path._lang/posn)",[14,[0,"lang/posn"]],"module"],
["lang/prim",">htdp-lib/index.html#(mod-path._lang/prim)",[14,[0,"lang/prim"]],"module"],
["language",">algol60/index.html#(part._.Language)","Language",false],
["language",">drscheme/Menus.html#(part._.Language)","<b><font size=\"-1\" face=\"Helvetica\">Language</font></b>",false],
["language environment variables",">string-constants/index.html#(part._.Language_.Environment_.Variables)","Language Environment Variables",false],
["language extensions",">tools/adding-languages.html#(part._.Language_.Extensions)","Language Extensions",false],
["language levels",">drscheme/choose-language.html","language levels",false],
["language model",">reference/model.html","Language Model",false],
["language->pict",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._language-~3epict))",[0,[1,"language-&gt;pict"]],["redex/pict"]],
["language-nts",">redex/Languages.html#(def._((lib._redex/main..ss)._language-nts))",[0,[1,"language-nts"]],["redex"]],
["language-specific capabilities",">tools/Language-specific_capabilities.html","Language-specific capabilities",false],
["languages extending",">drscheme/extending-drscheme.html#(idx._(gentag._228._(lib._scribblings/drscheme/drscheme..scrbl)))","languages, extending",false],
["languages",">redex/Languages.html","Languages",false],
["languages",">drscheme/languages.html","Languages",false],
["last",">reference/pairs.html#(def._((lib._scheme/list..ss)._last))",[0,[1,"last"]],["scheme/list","scheme"]],
["last",">srfi-std/srfi-1.html#last",[0,[1,"last"]],["srfi/1"]],
["last-ec",">srfi-std/srfi-42.html#last-ec",[0,[6,"last-ec"]],["srfi/42"]],
["last-line",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._last-line))",[[0,[1,"last-line"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["last-pair",">reference/pairs.html#(def._((lib._scheme/list..ss)._last-pair))",[0,[1,"last-pair"]],["scheme/list","scheme"]],
["last-pair",">lazy/index.html#(def._((lib._lazy/main..ss)._last-pair))",[0,[1,"last-pair"]],["lazy"]],
["last-pair",">mzlib/mzlib_list.html#(def._((lib._mzlib/list..ss)._last-pair))",[0,[1,"last-pair"]],["mzlib/list"]],
["last-pair",">srfi-std/srfi-1.html#last-pair",[0,[1,"last-pair"]],["srfi/1"]],
["last-paragraph",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._last-paragraph))",[[0,[1,"last-paragraph"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["last-position",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._last-position))",[[0,[1,"last-position"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["latex",">slatex-wrap/index.html#(def._((lib._slatex/slatex-wrapper..ss)._latex))",[0,[1,"latex"]],["slatex/slatex-wrapper"]],
["latex renderer",">scribble/renderer.html#(part._.Latex_.Renderer)","Latex Renderer",false],
["latin-1-codec",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_590",[0,[1,"latin-1-codec"]],["rnrs/io/ports-6"]],
["launcher configuration",">mzc/launcher.html#(part._.Launcher_.Configuration)","Launcher Configuration",false],
["launcher creation signature",">mzc/launcher.html#(part._.Launcher_.Creation_.Signature)","Launcher Creation Signature",false],
["launcher creation unit",">mzc/launcher.html#(part._.Launcher_.Creation_.Unit)","Launcher Creation Unit",false],
["launcher executable",">drscheme/create-exe.html#(tech._launcher._executable)","<i>launcher executable</i>",false],
["launcher path and platform conventions",">mzc/launcher.html#(part._.Launcher_.Path_and_.Platform_.Conventions)","Launcher Path and Platform Conventions",false],
["launcher/launcher",">mzc/launcher.html",[14,[0,"launcher/launcher"]],"module"],
["launcher/launcher-sig",">mzc/launcher.html#(mod-path._launcher/launcher-sig)",[14,[0,"launcher/launcher-sig"]],"module"],
["launcher/launcher-unit",">mzc/launcher.html#(mod-path._launcher/launcher-unit)",[14,[0,"launcher/launcher-unit"]],"module"],
["launcher@",">mzc/launcher.html#(def._((lib._launcher/launcher-unit..ss)._launcher~40))",[0,[1,"launcher@"]],["launcher/launcher-unit"]],
["launcher^",">mzc/launcher.html#(form._((lib._launcher/launcher-sig..ss)._launcher~5e))",[0,[6,"launcher^"]],["launcher/launcher-sig"]],
["launching an external browser",">browser/index.html#(part._external)","Launching an External Browser",false],
["launder",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..ss)._launder))",[0,[1,"launder"]],["slideshow/pict","slideshow"]],
["layer roadmap",">scribble/layers.html#(part._.Layer_.Roadmap)","Layer Roadmap",false],
["lazy",">lazy/index.html",[14,[0,"lazy"]],"module"],
["lazy",">reference/Delayed_Evaluation.html#(form._((lib._scheme/promise..ss)._lazy))",[0,[6,"lazy"]],["scheme/promise","scheme"]],
["lazy",">srfi-std/srfi-45.html#lazy",[0,[6,"lazy"]],["srfi/45"]],
["lazy data-structure contracts",">reference/Lazy_Data-structure_Contracts.html","Lazy Data-structure Contracts",false],
["lazy forms and functions",">lazy/index.html#(part._.Lazy_.Forms_and_.Functions)","Lazy Forms and Functions",false],
["lazy scheme",">lazy/index.html","<b>Lazy Scheme</b>",false],
["lazy-refresh",">gui/editor-canvas_.html#(meth._(((lib._mred/main..ss)._editor-canvas~25)._lazy-refresh))",[[0,[1,"lazy-refresh"]],[12,[" (method of ",[0,[1,"editor-canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["lazy/force",">lazy/index.html#(mod-path._lazy/force)",[14,[0,"lazy/force"]],"module"],
["lb-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..ss)._lb-find))",[0,[1,"lb-find"]],["slideshow/pict","slideshow"]],
["lb-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..ss)._lb-superimpose))",[0,[1,"lb-superimpose"]],["slideshow/pict","slideshow"]],
["lbl-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..ss)._lbl-find))",[0,[1,"lbl-find"]],["slideshow/pict","slideshow"]],
["lbl-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..ss)._lbl-superimpose))",[0,[1,"lbl-superimpose"]],["slideshow/pict","slideshow"]],
["lc-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..ss)._lc-find))",[0,[1,"lc-find"]],["slideshow/pict","slideshow"]],
["lc-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..ss)._lc-superimpose))",[0,[1,"lc-superimpose"]],["slideshow/pict","slideshow"]],
["lc_all",">reference/runtime.html#(idx._(gentag._309._(lib._scribblings/reference/reference..scrbl)))",[5,"LC_ALL"],false],
["lc_type",">reference/runtime.html#(idx._(gentag._310._(lib._scribblings/reference/reference..scrbl)))",[5,"LC_TYPE"],false],
["lcm",">reference/numbers.html#(def._((quote._~23~25kernel)._lcm))",[0,[1,"lcm"]],["scheme/base","scheme"]],
["lcm",">r5rs-std/r5rs-Z-H-9.html#%_idx_308",[0,[1,"lcm"]],["r5rs"]],
["lcm",">r6rs-std/r6rs-Z-H-14.html#node_idx_522",[0,[1,"lcm"]],["rnrs/base-6"]],
["lcm",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._lcm))",[0,[1,"lcm"]],["lang/htdp-advanced"]],
["lcm",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._lcm))",[0,[1,"lcm"]],["lang/htdp-beginner"]],
["lcm",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._lcm))",[0,[1,"lcm"]],["lang/htdp-beginner-abbr"]],
["lcm",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._lcm))",[0,[1,"lcm"]],["lang/htdp-intermediate"]],
["lcm",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._lcm))",[0,[1,"lcm"]],["lang/htdp-intermediate-lambda"]],
["least common multiple",">reference/numbers.html#(idx._(gentag._16._(lib._scribblings/reference/reference..scrbl)))","least\ncommon multiple",false],
["least-fixnum",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_860",[0,[1,"least-fixnum"]],["rnrs/arithmetic/fixnums-6"]],
["leaving drscheme",">continue/index.html#(part._.Leaving_.Dr.Scheme)","Leaving DrScheme",false],
["leaving-page",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-panel-mixin)._leaving-page))",[[0,[1,"leaving-page"]],[12,[" (method of ",[0,[1,"hyper-panel-mixin"]],")"]]],["browser"]],
["leaving?",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._leaving~3f))",[[0,[1,"leaving?"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["left",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._left))",[[0,[1,"left"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["left",">gui/windowing-overview.html#(idx._(gentag._0._(lib._scribblings/gui/gui..scrbl)))",[7,"'left"],false],
["left",">gui/key-event_.html#(idx._(gentag._58._(lib._scribblings/gui/gui..scrbl)))",[7,"'left"],false],
["left-mouse-click?",">graphics/Mouse_Operations.html#(def._((lib._graphics/graphics..ss)._left-mouse-click~3f))",[0,[1,"left-mouse-click?"]],["graphics/graphics"]],
["left-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._left-native))",[[0,[1,"left-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["legacy languages",">drscheme/legacy.html","Legacy Languages",false],
["legacy zodiac interface",">syntax/syntax-helpers.html#(part._zodiac)","Legacy Zodiac Interface",false],
["legend",">html/index.html#(def._((lib._html/main..ss)._legend))",[0,[1,"legend"]],["html"]],
["legend?",">html/index.html#(def._((lib._html/main..ss)._legend~3f))",[0,[1,"legend?"]],["html"]],
["length",">reference/pairs.html#(def._((quote._~23~25kernel)._length))",[0,[1,"length"]],["scheme/base","scheme"]],
["length",">r5rs-std/r5rs-Z-H-9.html#%_idx_436",[0,[1,"length"]],["r5rs"]],
["length",">r6rs-std/r6rs-Z-H-14.html#node_idx_632",[0,[1,"length"]],["rnrs/base-6"]],
["length",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._length))",[0,[1,"length"]],["lang/htdp-advanced"]],
["length",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._length))",[0,[1,"length"]],["lang/htdp-beginner"]],
["length",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._length))",[0,[1,"length"]],["lang/htdp-beginner-abbr"]],
["length",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._length))",[0,[1,"length"]],["lang/htdp-intermediate"]],
["length",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._length))",[0,[1,"length"]],["lang/htdp-intermediate-lambda"]],
["length",">lazy/index.html#(def._((lib._lazy/main..ss)._length))",[0,[1,"length"]],["lazy"]],
["length",">srfi-std/srfi-1.html#length",[0,[1,"length"]],["srfi/1"]],
["length+",">srfi-std/srfi-1.html#length+",[0,[1,"length+"]],["srfi/1"]],
["let",">htdp-langs/advanced-let.html",[0,[6,"let"]],false],
["let",">reference/let.html#(form._((lib._scheme/private/letstx-scheme..ss)._let))",[0,[6,"let"]],["scheme/base","scheme"]],
["let",">r5rs-std/r5rs-Z-H-7.html#%_idx_126",[0,[6,"let"]],["r5rs"]],
["let",">r6rs-std/r6rs-Z-H-14.html#node_idx_394",[0,[6,"let"]],["rnrs/base-6"]],
["let",">htdp-langs/advanced-let.html#(form._((lib._lang/htdp-advanced..ss)._let))",[0,[6,"let"]],["lang/htdp-advanced"]],
["let",">htdp-langs/letrec__let__and_let_.html#(form._((lib._lang/htdp-intermediate..ss)._let))",[0,[6,"let"]],["lang/htdp-intermediate"]],
["let",">htdp-langs/intermediate-lambda-unchanged.html#(form._((lib._lang/htdp-intermediate-lambda..ss)._let))",[0,[6,"let"]],["lang/htdp-intermediate-lambda"]],
["let",">lazy/index.html#(form._((lib._lazy/main..ss)._let))",[0,[6,"let"]],["lazy"]],
["let",">srfi-std/srfi-5.html#unnamed",[0,[6,"let"]],["srfi/5"]],
["let*",">reference/let.html#(form._((lib._scheme/private/letstx-scheme..ss)._let*))",[0,[6,"let*"]],["scheme/base","scheme"]],
["let*",">r5rs-std/r5rs-Z-H-7.html#%_idx_130",[0,[6,"let*"]],["r5rs"]],
["let*",">r6rs-std/r6rs-Z-H-14.html#node_idx_398",[0,[6,"let*"]],["rnrs/base-6"]],
["let*",">htdp-langs/advanced-unchanged.html#(form._((lib._lang/htdp-advanced..ss)._let*))",[0,[6,"let*"]],["lang/htdp-advanced"]],
["let*",">htdp-langs/letrec__let__and_let_.html#(form._((lib._lang/htdp-intermediate..ss)._let*))",[0,[6,"let*"]],["lang/htdp-intermediate"]],
["let*",">htdp-langs/intermediate-lambda-unchanged.html#(form._((lib._lang/htdp-intermediate-lambda..ss)._let*))",[0,[6,"let*"]],["lang/htdp-intermediate-lambda"]],
["let*",">lazy/index.html#(form._((lib._lazy/main..ss)._let*))",[0,[6,"let*"]],["lazy"]],
["let*-values",">reference/let.html#(form._((quote._~23~25kernel)._let*-values))",[0,[6,"let*-values"]],["scheme/base","scheme"]],
["let*-values",">r6rs-std/r6rs-Z-H-14.html#node_idx_414",[0,[6,"let*-values"]],["rnrs/base-6"]],
["let*-values",">lazy/index.html#(form._((lib._lazy/main..ss)._let*-values))",[0,[6,"let*-values"]],["lazy"]],
["let*-values",">srfi-std/srfi-11.html#let*-values",[0,[6,"let*-values"]],["srfi/11"]],
["let*:",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._let*~3a))",[0,[6,"let*:"]],["typed-scheme"]],
["let+",">mzlib/mzlib_etc.html#(form._((lib._mzlib/etc..ss)._let+))",[0,[6,"let+"]],["mzlib/etc"]],
["let-string-start+end",">srfi-std/srfi-13.html#let-string-start+end",[0,[1,"let-string-start+end"]],["srfi/13"]],
["let-struct",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..ss)._let-struct))",[0,[6,"let-struct"]],["mzscheme"]],
["let-syntax",">reference/let.html#(form._((lib._scheme/private/letstx-scheme..ss)._let-syntax))",[0,[6,"let-syntax"]],["scheme/base","scheme"]],
["let-syntax",">r5rs-std/r5rs-Z-H-7.html#%_idx_184",[0,[6,"let-syntax"]],["r5rs"]],
["let-syntax",">r6rs-std/r6rs-Z-H-14.html#node_idx_776",[0,[6,"let-syntax"]],["rnrs/base-6"]],
["let-syntaxes",">reference/let.html#(form._((lib._scheme/private/letstx-scheme..ss)._let-syntaxes))",[0,[6,"let-syntaxes"]],["scheme/base","scheme"]],
["let-values",">reference/let.html#(form._((quote._~23~25kernel)._let-values))",[0,[6,"let-values"]],["scheme/base","scheme"]],
["let-values",">r6rs-std/r6rs-Z-H-14.html#node_idx_410",[0,[6,"let-values"]],["rnrs/base-6"]],
["let-values",">lazy/index.html#(form._((lib._lazy/main..ss)._let-values))",[0,[6,"let-values"]],["lazy"]],
["let-values",">srfi-std/srfi-11.html#let-values",[0,[6,"let-values"]],["srfi/11"]],
["let/cc",">reference/cont.html#(form._((lib._scheme/private/more-scheme..ss)._let/cc))",[0,[6,"let/cc"]],["scheme/base","scheme"]],
["let/ec",">reference/cont.html#(form._((lib._scheme/private/letstx-scheme..ss)._let/ec))",[0,[6,"let/ec"]],["scheme/base","scheme"]],
["let:",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._let~3a))",[0,[6,"let:"]],["typed-scheme"]],
["letrec",">reference/let.html#(form._((lib._scheme/private/letstx-scheme..ss)._letrec))",[0,[6,"letrec"]],["scheme/base","scheme"]],
["letrec",">r5rs-std/r5rs-Z-H-7.html#%_idx_134",[0,[6,"letrec"]],["r5rs"]],
["letrec",">r6rs-std/r6rs-Z-H-14.html#node_idx_402",[0,[6,"letrec"]],["rnrs/base-6"]],
["letrec",">htdp-langs/advanced-unchanged.html#(form._((lib._lang/htdp-advanced..ss)._letrec))",[0,[6,"letrec"]],["lang/htdp-advanced"]],
["letrec",">htdp-langs/letrec__let__and_let_.html#(form._((lib._lang/htdp-intermediate..ss)._letrec))",[0,[6,"letrec"]],["lang/htdp-intermediate"]],
["letrec",">htdp-langs/intermediate-lambda-unchanged.html#(form._((lib._lang/htdp-intermediate-lambda..ss)._letrec))",[0,[6,"letrec"]],["lang/htdp-intermediate-lambda"]],
["letrec",">lazy/index.html#(form._((lib._lazy/main..ss)._letrec))",[0,[6,"letrec"]],["lazy"]],
["letrec performance",">guide/performance.html#(part._letrec-performance)",[[0,[6,"letrec"]]," Performance"],false],
["letrec*",">r6rs-std/r6rs-Z-H-14.html#node_idx_406",[0,[6,"letrec*"]],["rnrs/base-6"]],
["letrec, let, and let*",">htdp-langs/letrec__let__and_let_.html",[[0,[6,"letrec"]],", ",[0,[6,"let"]],", and ",[0,[6,"let*"]]],false],
["letrec-syntax",">reference/let.html#(form._((lib._scheme/private/letstx-scheme..ss)._letrec-syntax))",[0,[6,"letrec-syntax"]],["scheme/base","scheme"]],
["letrec-syntax",">r5rs-std/r5rs-Z-H-7.html#%_idx_186",[0,[6,"letrec-syntax"]],["r5rs"]],
["letrec-syntax",">r6rs-std/r6rs-Z-H-14.html#node_idx_782",[0,[6,"letrec-syntax"]],["rnrs/base-6"]],
["letrec-syntaxes",">reference/let.html#(form._((lib._scheme/private/letstx-scheme..ss)._letrec-syntaxes))",[0,[6,"letrec-syntaxes"]],["scheme/base","scheme"]],
["letrec-syntaxes+values",">reference/let.html#(form._((quote._~23~25kernel)._letrec-syntaxes+values))",[0,[6,"letrec-syntaxes+values"]],["scheme/base","scheme"]],
["letrec-values",">reference/let.html#(form._((quote._~23~25kernel)._letrec-values))",[0,[6,"letrec-values"]],["scheme/base","scheme"]],
["letrec-values",">lazy/index.html#(form._((lib._lazy/main..ss)._letrec-values))",[0,[6,"letrec-values"]],["lazy"]],
["letrec:",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._letrec~3a))",[0,[6,"letrec:"]],["typed-scheme"]],
["letter-spacing",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._letter-spacing))",[[0,[1,"letter-spacing"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["letter-spacing-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._letter-spacing-native))",[[0,[1,"letter-spacing-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["lexeme",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..ss)._lexeme))",[0,[6,"lexeme"]],["parser-tools/lex"]],
["lexer",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..ss)._lexer))",[0,[6,"lexer"]],["parser-tools/lex"]],
["lexer abbreviation",">parser-tools/Lexers.html#(tech._lexer._abbreviation)","<i>lexer abbreviation</i>",false],
["lexer abbreviations and macros",">parser-tools/Lexers.html#(part._.Lexer_.Abbreviations_and_.Macros)","Lexer Abbreviations and Macros",false],
["lexer legacy operators",">parser-tools/Lexers.html#(part._.Lexer_.Legacy_.Operators)","Lexer Legacy Operators",false],
["lexer macro",">parser-tools/Lexers.html#(tech._lexer._macro)","<i>lexer macro</i>",false],
["lexer sre operators",">parser-tools/Lexers.html#(part._.Lexer_.S.R.E_.Operators)","Lexer SRE Operators",false],
["lexer-src-pos",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..ss)._lexer-src-pos))",[0,[6,"lexer-src-pos"]],["parser-tools/lex"]],
["lexers",">parser-tools/Lexers.html","Lexers",false],
["lexical",">reference/stxcmp.html#(idx._(gentag._83._(lib._scribblings/reference/reference..scrbl)))",[7,"'lexical"],false],
["lexical information",">reference/syntax-model.html#(tech._lexical._information)","<i>lexical information</i>",false],
["lexical scope",">guide/pattern-macros.html#(part._.Lexical_.Scope)","Lexical Scope",false],
["lexical scope",">quick/index.html#(part._.Lexical_.Scope)","Lexical Scope",false],
["lexical scoping",">reference/eval-model.html#(tech._lexical._scoping)","<i>lexical scoping</i>",false],
["lexical-violation?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_476",[0,[1,"lexical-violation?"]],["rnrs/conditions-6"]],
["li",">html/index.html#(def._((lib._html/main..ss)._li))",[0,[1,"li"]],["html"]],
["li?",">html/index.html#(def._((lib._html/main..ss)._li~3f))",[0,[1,"li?"]],["html"]],
["lib",">reference/require.html#(form._((lib._scheme/base..ss)._lib))",[0,[6,"lib"]],["scheme/base","scheme"]],
["lib-dir",">config/index.html#(def._((lib._config/main..ss)._lib-dir))",[0,[1,"lib-dir"]],["config"]],
["lib-search-dirs",">config/index.html#(def._((lib._config/main..ss)._lib-search-dirs))",[0,[1,"lib-search-dirs"]],["config"]],
["libraries",">swindle/index.html#(part._.Libraries)","Libraries",false],
["libraries and collections",">r6rs/libpaths.html","Libraries and Collections",false],
["libraries and collections",">reference/collects.html","Libraries and Collections",false],
["library",">reference/collects.html#(tech._library)","<i>library</i>",false],
["library-vicinity",">srfi-std/srfi-59.html#library-vicinity",[0,[1,"library-vicinity"]],["srfi/59"]],
["license",">license/index.html","License",false],
["license issues",">readline/index.html#(part._.License_.Issues)","License Issues",false],
["lift-above-baseline",">slideshow/Bounding-Box_Adjusters.html#(def._((lib._slideshow/pict..ss)._lift-above-baseline))",[0,[1,"lift-above-baseline"]],["slideshow/pict","slideshow"]],
["lift-strict",">frtime/index.html#(def._((lib._frtime/main..ss)._lift-strict))",[0,[1,"lift-strict"]],["frtime"]],
["lifting procedures",">web-server/dispatch-lift_ss.html","Lifting Procedures",false],
["light",">gui/font_.html#(idx._(gentag._206._(lib._scribblings/gui/gui..scrbl)))",[7,"'light"],false],
["light",">gui/style-delta_.html#(idx._(gentag._275._(lib._scribblings/gui/gui..scrbl)))",[7,"'light"],false],
["light-brush-color",">redex/GUI.html#(def._((lib._redex/gui..ss)._light-brush-color))",[0,[1,"light-brush-color"]],["redex/gui"]],
["light-pen-color",">redex/GUI.html#(def._((lib._redex/gui..ss)._light-pen-color))",[0,[1,"light-pen-color"]],["redex/gui"]],
["lights out --- logic game",">games/lights-out.html",[[13,"<img src=\"lights-out.png\" />"]," ","<b><font size=\"-1\" face=\"Helvetica\">Lights Out</font></b>","  ","&ndash;","  Logic Game"],false],
["limit memory... menu item",">drscheme/Menus.html#(idx._(gentag._121._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Limit Memory...</font></b> menu item",false],
["limiting memory use",">more/index.html#(part._.Limiting_.Memory_.Use)","Limiting Memory Use",false],
["line",">plot/plot.html#(def._((lib._plot/main..ss)._line))",[0,[1,"line"]],["plot"]],
["line",">teachpack/image.html#(def._((lib._htdp/image..ss)._line))",[0,[1,"line"]],["teachpack/htdp/image"]],
["line",">reference/port-buffers.html#(idx._(gentag._100._(lib._scribblings/reference/reference..scrbl)))",[7,"'line"],false],
["line",">gui/editor-wordbreak-map_.html#(idx._(gentag._240._(lib._scribblings/gui/gui..scrbl)))",[7,"'line"],false],
["line locations",">reference/linecol.html#(tech._line._location)","<i>line locations</i>",false],
["line numbers",">reference/linecol.html","line numbers",false],
["line-end-position",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._line-end-position))",[[0,[1,"line-end-position"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["line-height",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._line-height))",[[0,[1,"line-height"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["line-height-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._line-height-native))",[[0,[1,"line-height-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["line-length",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._line-length))",[[0,[1,"line-length"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["line-location",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._line-location))",[[0,[1,"line-location"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["line-output hook",">reference/pretty-print.html#(part._.Line-.Output_.Hook)","Line-Output Hook",false],
["line-paragraph",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._line-paragraph))",[[0,[1,"line-paragraph"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["line-start-position",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._line-start-position))",[[0,[1,"line-start-position"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["line-to",">gui/dc-path_.html#(meth._(((lib._mred/main..ss)._dc-path~25)._line-to))",[[0,[1,"line-to"]],[12,[" (method of ",[0,[1,"dc-path%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["linefeed",">reference/Byte_and_String_Input.html#(idx._(gentag._116._(lib._scribblings/reference/reference..scrbl)))",[7,"'linefeed"],false],
["lines",">graphics/Draw__Clear__and_Flip_Operations.html#(part._.Lines)","Lines",false],
["lines",">gui/dc-path_.html#(meth._(((lib._mred/main..ss)._dc-path~25)._lines))",[[0,[1,"lines"]],[12,[" (method of ",[0,[1,"dc-path%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["linewidth",">slideshow/Pict_Drawing_Adjusters.html#(def._((lib._slideshow/pict..ss)._linewidth))",[0,[1,"linewidth"]],["slideshow/pict","slideshow"]],
["link",">planet/cmdline.html#(part._link)",[5,"link"],false],
["link",">reference/creatingunits.html#(form._((lib._scheme/unit..ss)._link))",[0,"link"],["scheme/unit","scheme"]],
["link",">scribble/section-links.html#(def._((lib._scribble/manual..ss)._link))",[0,[1,"link"]],["scribble/manual"]],
["link",">reference/runtime.html#(idx._(gentag._302._(lib._scribblings/reference/reference..scrbl)))",[7,"'link"],false],
["link",">guide/Linking_Units.html#(tech._link)","<i>link</i>",false],
["link-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._link-element))",[0,[1,"link-element"]],["scribble/struct"]],
["link-element-tag",">scribble/struct.html#(def._((lib._scribble/struct..ss)._link-element-tag))",[0,[1,"link-element-tag"]],["scribble/struct"]],
["link-element?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._link-element~3f))",[0,[1,"link-element?"]],["scribble/struct"]],
["link-exists?",">reference/Filesystem.html#(def._((quote._~23~25kernel)._link-exists~3f))",[0,[1,"link-exists?"]],["scheme/base","scheme"]],
["link-extension",">dynext/Linking.html#(def._((lib._dynext/link..ss)._link-extension))",[0,[1,"link-extension"]],["dynext/link"]],
["link-variant",">dynext/Linking.html#(def._((lib._dynext/link..ss)._link-variant))",[0,[1,"link-variant"]],["dynext/link"]],
["linkage-file",">planet/Utility_Libraries.html#(def._((lib._planet/config..ss)._.L.I.N.K.A.G.E-.F.I.L.E))",[0,[1,"LINKAGE-FILE"]],["planet/config"]],
["linked",">reference/mzlib_unit.html#(tech._linked)","<i>linked</i>",false],
["linking",">dynext/Linking.html","Linking",false],
["linking parameters",">dynext/Linking.html#(part._link-params)","Linking Parameters",false],
["linking units",">guide/Linking_Units.html","Linking Units",false],
["linking units and creating compound units",">reference/compoundunits.html","Linking Units and Creating Compound Units",false],
["links",">scribble/section-links.html","Links",false],
["list",">reference/pairs.html#(def._((quote._~23~25kernel)._list))",[0,[1,"list"]],["scheme/base","scheme"]],
["list",">r5rs-std/r5rs-Z-H-9.html#%_idx_434",[0,[1,"list"]],["r5rs"]],
["list",">r6rs-std/r6rs-Z-H-14.html#node_idx_630",[0,[1,"list"]],["rnrs/base-6"]],
["list",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._list))",[0,[1,"list"]],["lang/htdp-advanced"]],
["list",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._list))",[0,[1,"list"]],["lang/htdp-beginner"]],
["list",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._list))",[0,[1,"list"]],["lang/htdp-beginner-abbr"]],
["list",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._list))",[0,[1,"list"]],["lang/htdp-intermediate"]],
["list",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._list))",[0,[1,"list"]],["lang/htdp-intermediate-lambda"]],
["list",">lazy/index.html#(def._((lib._lazy/main..ss)._list))",[0,[1,"list"]],["lazy"]],
["list",">srfi-std/srfi-1.html#list",[0,[1,"list"]],["srfi/1"]],
["list",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._.List))",[0,[6,"List"]],["typed-scheme"]],
["list",">guide/pairs.html#(tech._list)","<i>list</i>",false],
["list",">reference/pairs.html#(tech._list)","<i>list</i>",false],
["list box",">gui/windowing-overview.html#(tech._list._box)","<i>list box</i>",false],
["list filtering",">reference/pairs.html#(part._.List_.Filtering)","List Filtering",false],
["list iteration",">reference/pairs.html#(part._.List_.Iteration)","List Iteration",false],
["list iteration from scratch",">guide/Lists__Iteration__and_Recursion.html#(part._.List_.Iteration_from_.Scratch)","List Iteration from Scratch",false],
["list operations",">reference/pairs.html#(part._.List_.Operations)","List Operations",false],
["list searching",">reference/pairs.html#(part._.List_.Searching)","List Searching",false],
["list*",">reference/pairs.html#(def._((quote._~23~25kernel)._list*))",[0,[1,"list*"]],["scheme/base","scheme"]],
["list*",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._list*))",[0,[1,"list*"]],["lang/htdp-beginner"]],
["list*",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._list*))",[0,[1,"list*"]],["lang/htdp-beginner-abbr"]],
["list*",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._list*))",[0,[1,"list*"]],["lang/htdp-intermediate"]],
["list*",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._list*))",[0,[1,"list*"]],["lang/htdp-intermediate-lambda"]],
["list*",">lazy/index.html#(def._((lib._lazy/main..ss)._list*))",[0,[1,"list*"]],["lazy"]],
["list->bytes",">reference/bytestrings.html#(def._((quote._~23~25kernel)._list-~3ebytes))",[0,[1,"list-&gt;bytes"]],["scheme/base","scheme"]],
["list->cblock",">foreign/Miscellaneous_Support.html#(def._((lib._scheme/foreign..ss)._list-~3ecblock))",[0,[1,"list-&gt;cblock"]],["scheme/foreign"]],
["list->char-set",">srfi-std/srfi-14.html#list->char-set",[0,[1,"list-&gt;char-set"]],["srfi/14"]],
["list->char-set!",">srfi-std/srfi-14.html#list->char-set!",[0,[1,"list-&gt;char-set!"]],["srfi/14"]],
["list->cvector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._list-~3ecvector))",[0,[1,"list-&gt;cvector"]],["scheme/foreign"]],
["list->f32vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._list-~3ef32vector))",[0,[1,"list-&gt;f32vector"]],["scheme/foreign"]],
["list->f64vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._list-~3ef64vector))",[0,[1,"list-&gt;f64vector"]],["scheme/foreign"]],
["list->gl-boolean-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._list-~3egl-boolean-vector))",[0,[1,"list-&gt;gl-boolean-vector"]],["sgl/gl-vectors"]],
["list->gl-byte-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._list-~3egl-byte-vector))",[0,[1,"list-&gt;gl-byte-vector"]],["sgl/gl-vectors"]],
["list->gl-double-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._list-~3egl-double-vector))",[0,[1,"list-&gt;gl-double-vector"]],["sgl/gl-vectors"]],
["list->gl-float-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._list-~3egl-float-vector))",[0,[1,"list-&gt;gl-float-vector"]],["sgl/gl-vectors"]],
["list->gl-int-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._list-~3egl-int-vector))",[0,[1,"list-&gt;gl-int-vector"]],["sgl/gl-vectors"]],
["list->gl-short-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._list-~3egl-short-vector))",[0,[1,"list-&gt;gl-short-vector"]],["sgl/gl-vectors"]],
["list->gl-ubyte-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._list-~3egl-ubyte-vector))",[0,[1,"list-&gt;gl-ubyte-vector"]],["sgl/gl-vectors"]],
["list->gl-uint-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._list-~3egl-uint-vector))",[0,[1,"list-&gt;gl-uint-vector"]],["sgl/gl-vectors"]],
["list->gl-ushort-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._list-~3egl-ushort-vector))",[0,[1,"list-&gt;gl-ushort-vector"]],["sgl/gl-vectors"]],
["list->mlist",">reference/mpairs.html#(def._((lib._scheme/mpair..ss)._list-~3emlist))",[0,[1,"list-&gt;mlist"]],["scheme/mpair"]],
["list->s16vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._list-~3es16vector))",[0,[1,"list-&gt;s16vector"]],["scheme/foreign"]],
["list->s32vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._list-~3es32vector))",[0,[1,"list-&gt;s32vector"]],["scheme/foreign"]],
["list->s64vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._list-~3es64vector))",[0,[1,"list-&gt;s64vector"]],["scheme/foreign"]],
["list->s8vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._list-~3es8vector))",[0,[1,"list-&gt;s8vector"]],["scheme/foreign"]],
["list->stream",">srfi-std/srfi-41/srfi-41.html#list-to-stream",[0,[1,"list-&gt;stream"]],["srfi/41"]],
["list->string",">reference/strings.html#(def._((quote._~23~25kernel)._list-~3estring))",[0,[1,"list-&gt;string"]],["scheme/base","scheme"]],
["list->string",">r5rs-std/r5rs-Z-H-9.html#%_idx_548",[0,[1,"list-&gt;string"]],["r5rs"]],
["list->string",">r6rs-std/r6rs-Z-H-14.html#node_idx_714",[0,[1,"list-&gt;string"]],["rnrs/base-6"]],
["list->string",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._list-~3estring))",[0,[1,"list-&gt;string"]],["lang/htdp-advanced"]],
["list->string",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._list-~3estring))",[0,[1,"list-&gt;string"]],["lang/htdp-beginner"]],
["list->string",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._list-~3estring))",[0,[1,"list-&gt;string"]],["lang/htdp-beginner-abbr"]],
["list->string",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._list-~3estring))",[0,[1,"list-&gt;string"]],["lang/htdp-intermediate"]],
["list->string",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._list-~3estring))",[0,[1,"list-&gt;string"]],["lang/htdp-intermediate-lambda"]],
["list->string",">srfi-std/srfi-13.html#list2string",[0,[1,"list-&gt;string"]],["srfi/13"]],
["list->u16vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._list-~3eu16vector))",[0,[1,"list-&gt;u16vector"]],["scheme/foreign"]],
["list->u32vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._list-~3eu32vector))",[0,[1,"list-&gt;u32vector"]],["scheme/foreign"]],
["list->u64vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._list-~3eu64vector))",[0,[1,"list-&gt;u64vector"]],["scheme/foreign"]],
["list->u8vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._list-~3eu8vector))",[0,[1,"list-&gt;u8vector"]],["scheme/foreign"]],
["list->vector",">reference/vectors.html#(def._((quote._~23~25kernel)._list-~3evector))",[0,[1,"list-&gt;vector"]],["scheme/base","scheme"]],
["list->vector",">r5rs-std/r5rs-Z-H-9.html#%_idx_572",[0,[1,"list-&gt;vector"]],["r5rs"]],
["list->vector",">r6rs-std/r6rs-Z-H-14.html#node_idx_738",[0,[1,"list-&gt;vector"]],["rnrs/base-6"]],
["list->vector",">srfi-std/srfi-43.html#list->vector",[0,[1,"list-&gt;vector"]],["srfi/43"]],
["list-box",">gui/list-box_.html#(idx._(gentag._118._(lib._scribblings/gui/gui..scrbl)))",[7,"'list-box"],false],
["list-box%",">gui/list-box_.html",[0,[1,"list-box%"]],["scheme/gui/base","scheme/gui"]],
["list-box-dclick",">gui/list-box_.html#(idx._(gentag._117._(lib._scribblings/gui/gui..scrbl)))",[7,"'list-box-dclick"],false],
["list-control<%>",">gui/list-control___.html",[0,[1,"list-control&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["list-copy",">srfi-std/srfi-1.html#list-copy",[0,[1,"list-copy"]],["srfi/1"]],
["list-ec",">srfi-std/srfi-42.html#list-ec",[0,[6,"list-ec"]],["srfi/42"]],
["list-index",">srfi-std/srfi-1.html#list-index",[0,[1,"list-index"]],["srfi/1"]],
["list-of",">eopl/index.html#(def._((lib._eopl/eopl..ss)._list-of))",[0,[1,"list-of"]],["eopl/eopl"]],
["list-of-color",">teachpack/image.html#(def._((lib._htdp/image..ss)._.List-of-color))",[0,"List-of-color"],["teachpack/htdp/image"]],
["list-prefix?",">web-server/util_ss.html#(def._((lib._web-server/private/util..ss)._list-prefix~3f))",[0,[1,"list-prefix?"]],["web-server/private/util"]],
["list-ref",">reference/pairs.html#(def._((quote._~23~25kernel)._list-ref))",[0,[1,"list-ref"]],["scheme/base","scheme"]],
["list-ref",">r5rs-std/r5rs-Z-H-9.html#%_idx_444",[0,[1,"list-ref"]],["r5rs"]],
["list-ref",">r6rs-std/r6rs-Z-H-14.html#node_idx_640",[0,[1,"list-ref"]],["rnrs/base-6"]],
["list-ref",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._list-ref))",[0,[1,"list-ref"]],["lang/htdp-advanced"]],
["list-ref",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._list-ref))",[0,[1,"list-ref"]],["lang/htdp-beginner"]],
["list-ref",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._list-ref))",[0,[1,"list-ref"]],["lang/htdp-beginner-abbr"]],
["list-ref",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._list-ref))",[0,[1,"list-ref"]],["lang/htdp-intermediate"]],
["list-ref",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._list-ref))",[0,[1,"list-ref"]],["lang/htdp-intermediate-lambda"]],
["list-ref",">lazy/index.html#(def._((lib._lazy/main..ss)._list-ref))",[0,[1,"list-ref"]],["lazy"]],
["list-ref",">srfi-std/srfi-1.html#list-ref",[0,[1,"list-ref"]],["srfi/1"]],
["list-sort",">r6rs-lib-std/r6rs-lib-Z-H-5.html#node_idx_246",[0,[1,"list-sort"]],["rnrs/sorting-6"]],
["list-style",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._list-style))",[[0,[1,"list-style"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["list-style-image",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._list-style-image))",[[0,[1,"list-style-image"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["list-style-image-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._list-style-image-native))",[[0,[1,"list-style-image-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["list-style-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._list-style-native))",[[0,[1,"list-style-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["list-style-position",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._list-style-position))",[[0,[1,"list-style-position"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["list-style-position-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._list-style-position-native))",[[0,[1,"list-style-position-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["list-style-type",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._list-style-type))",[[0,[1,"list-style-type"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["list-style-type-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._list-style-type-native))",[[0,[1,"list-style-type-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["list-tabulate",">srfi-std/srfi-1.html#list-tabulate",[0,[1,"list-tabulate"]],["srfi/1"]],
["list-tail",">reference/pairs.html#(def._((quote._~23~25kernel)._list-tail))",[0,[1,"list-tail"]],["scheme/base","scheme"]],
["list-tail",">r5rs-std/r5rs-Z-H-9.html#%_idx_442",[0,[1,"list-tail"]],["r5rs"]],
["list-tail",">r6rs-std/r6rs-Z-H-14.html#node_idx_638",[0,[1,"list-tail"]],["rnrs/base-6"]],
["list-tail",">lazy/index.html#(def._((lib._lazy/main..ss)._list-tail))",[0,[1,"list-tail"]],["lazy"]],
["list/c",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._list/c))",[0,[1,"list/c"]],["scheme/contract","scheme"]],
["list?",">reference/pairs.html#(def._((quote._~23~25kernel)._list~3f))",[0,[1,"list?"]],["scheme/base","scheme"]],
["list?",">r5rs-std/r5rs-Z-H-9.html#%_idx_432",[0,[1,"list?"]],["r5rs"]],
["list?",">r6rs-std/r6rs-Z-H-14.html#node_idx_628",[0,[1,"list?"]],["rnrs/base-6"]],
["list?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._list~3f))",[0,[1,"list?"]],["lang/htdp-advanced"]],
["list?",">lazy/index.html#(def._((lib._lazy/main..ss)._list~3f))",[0,[1,"list?"]],["lazy"]],
["listen-ip",">web-server/dispatch-server-unit_ss.html#(sig-val._((lib._web-server/private/dispatch-server-sig..ss)._dispatch-server-config~5e._listen-ip))",[0,[1,"listen-ip"]],["web-server/private/dispatch-server-sig"]],
["listen-ip",">web-server/web-config-unit_ss.html#(sig-val._((lib._web-server/web-config-sig..ss)._web-config~5e._listen-ip))",[0,[1,"listen-ip"]],["web-server/web-config-sig"]],
["listof",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._listof))",[0,[1,"listof"]],["scheme/contract","scheme"]],
["listof",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._.Listof))",[0,[6,"Listof"]],["typed-scheme"]],
["lists",">quick/index.html#(part._.Lists)","Lists",false],
["lists",">web-server/util_ss.html#(part._.Lists)","Lists",false],
["lists and scheme syntax",">guide/Pairs__Lists__and_Scheme_Syntax.html#(part._lists-and-syntax)","Lists and Scheme Syntax",false],
["lists, iteration, and recursion",">guide/Lists__Iteration__and_Recursion.html","Lists, Iteration, and Recursion",false],
["litchar",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..ss)._litchar))",[0,[1,"litchar"]],["scribble/manual"]],
["literal-color",">slideshow/Typesetting_Scheme_Code.html#(def._((lib._slideshow/code..ss)._literal-color))",[0,[1,"literal-color"]],["slideshow/code"]],
["literal-style",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._literal-style))",[0,[1,"literal-style"]],["redex/pict"]],
["literals: quote and #%datum",">reference/quote.html",["Literals: ",[0,[6,"quote"]]," and ",[0,[6,"#%datum"]]],false],
["ll",">reference/characters.html#(idx._(gentag._37._(lib._scribblings/reference/reference..scrbl)))",[7,"'ll"],false],
["lm",">reference/characters.html#(idx._(gentag._39._(lib._scribblings/reference/reference..scrbl)))",[7,"'lm"],false],
["lo",">reference/characters.html#(idx._(gentag._40._(lib._scribblings/reference/reference..scrbl)))",[7,"'lo"],false],
["load",">reference/Evaluation_and_Compilation.html#(def._((quote._~23~25kernel)._load))",[0,[1,"load"]],["scheme/base","scheme"]],
["load",">r5rs-std/r5rs-Z-H-9.html#%_idx_668",[0,[1,"load"]],["r5rs"]],
["load handler",">reference/Evaluation_and_Compilation.html#(tech._load._handler)","<i>load handler</i>",false],
["load mode",">guide/mzscheme.html#(part._start-load-mode)","Load Mode",false],
["load-bundle!",">srfi-std/srfi-29.html#load-bundle!",[0,[1,"load-bundle!"]],["srfi/29"]],
["load-collections-xref",">setup-plt/xref.html#(def._((lib._setup/xref..ss)._load-collections-xref))",[0,[1,"load-collections-xref"]],["setup/xref"]],
["load-extension",">reference/Evaluation_and_Compilation.html#(def._((quote._~23~25kernel)._load-extension))",[0,[1,"load-extension"]],["scheme/base","scheme"]],
["load-file",">gui/bitmap_.html#(meth._(((lib._mred/main..ss)._bitmap~25)._load-file))",[[0,[1,"load-file"]],[12,[" (method of ",[0,[1,"bitmap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["load-file",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._load-file))",[[0,[1,"load-file"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["load-file",">gui/image-snip_.html#(meth._(((lib._mred/main..ss)._image-snip~25)._load-file))",[[0,[1,"load-file"]],[12,[" (method of ",[0,[1,"image-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["load-file",">framework/Keymap.html#(idx._(gentag._10._(lib._scribblings/framework/framework..scrbl)))","load-file",false],
["load-file/gui-error",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abasic~3c~25~3e)._load-file/gui-error))",[[0,[1,"load-file/gui-error"]],[12,[" (method of ",[0,[1,"editor:basic&lt;%&gt;"]],")"]]],["framework"]],
["load-on-demand-enabled",">reference/Evaluation_and_Compilation.html#(def._((quote._~23~25kernel)._load-on-demand-enabled))",[0,[1,"load-on-demand-enabled"]],["scheme/base","scheme"]],
["load-relative",">reference/Evaluation_and_Compilation.html#(def._((lib._scheme/private/misc..ss)._load-relative))",[0,[1,"load-relative"]],["scheme/base","scheme"]],
["load-relative-extension",">reference/Evaluation_and_Compilation.html#(def._((lib._scheme/private/misc..ss)._load-relative-extension))",[0,[1,"load-relative-extension"]],["scheme/base","scheme"]],
["load-xref",">scribble/xref.html#(def._((lib._scribble/xref..ss)._load-xref))",[0,[1,"load-xref"]],["scribble/xref"]],
["load/cd",">reference/Evaluation_and_Compilation.html#(def._((lib._scheme/private/misc..ss)._load/cd))",[0,[1,"load/cd"]],["scheme/base","scheme"]],
["load/use-compiled",">reference/Evaluation_and_Compilation.html#(def._((lib._scheme/private/misc..ss)._load/use-compiled))",[0,[1,"load/use-compiled"]],["scheme/base","scheme"]],
["loading",">mysterx/overview.html#(part._.Loading)","Loading",false],
["loading compiler support",">mzc/Scheme_API_for_Compilation.html#(part._api~3aloading)","Loading compiler support",false],
["loading foreign libraries",">foreign/Loading_Foreign_Libraries.html","Loading Foreign Libraries",false],
["loading mzcom",">mzcom/index.html#(part._.Loading_.Mz.C.O.M)","Loading MzCOM",false],
["local",">htdp-langs/local.html",[0,[6,"local"]],false],
["local",">reference/local.html#(form._((lib._scheme/local..ss)._local))",[0,[6,"local"]],["scheme/local","scheme"]],
["local",">htdp-langs/advanced-unchanged.html#(form._((lib._lang/htdp-advanced..ss)._local))",[0,[6,"local"]],["lang/htdp-advanced"]],
["local",">htdp-langs/local.html#(form._((lib._lang/htdp-intermediate..ss)._local))",[0,[6,"local"]],["lang/htdp-intermediate"]],
["local",">htdp-langs/intermediate-lambda-unchanged.html#(form._((lib._lang/htdp-intermediate-lambda..ss)._local))",[0,[6,"local"]],["lang/htdp-intermediate-lambda"]],
["local binding",">guide/let.html","Local Binding",false],
["local binding",">quick/index.html#(part._.Local_.Binding)","Local Binding",false],
["local binding",">reference/syntax-model.html#(tech._local._binding)","<i>local binding</i>",false],
["local binding with define, let, and let*",">guide/syntax-overview.html#(part._local-binding-intro)",["Local Binding with\n",[0,[6,"define"]],", ",[0,[6,"let"]],", and ",[0,[6,"let*"]]],false],
["local binding: let, let*, letrec, ...",">reference/let.html",["Local Binding: ",[0,[6,"let"]],", ",[0,[6,"let*"]],", ",[0,[6,"letrec"]],", ..."],false],
["local definitions: local",">reference/local.html",["Local Definitions: ",[0,[6,"local"]]],false],
["local pointers",">inside/im_memoryalloc.html#(part._im~3a3m~3astack)","Local Pointers",false],
["local pointers and mzc --xform",">inside/im_memoryalloc.html#(part._im~3a3m~3amzc)",["Local Pointers and ",[5,"mzc"]," ",[9,[5,"--xform"]]],false],
["local scopes",">guide/eval.html#(part._.Local_.Scopes)","Local Scopes",false],
["local variable",">reference/eval-model.html#(tech._local._variable)","<i>local variable</i>",false],
["local-edit-sequence?",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abasic~3c~25~3e)._local-edit-sequence~3f))",[[0,[1,"local-edit-sequence?"]],[12,[" (method of ",[0,[1,"editor:basic&lt;%&gt;"]],")"]]],["framework"]],
["local-expand",">reference/stxtrans.html#(def._((quote._~23~25kernel)._local-expand))",[0,[1,"local-expand"]],["scheme/base","scheme"]],
["local-expand/capture-lifts",">reference/stxtrans.html#(def._((quote._~23~25kernel)._local-expand/capture-lifts))",[0,[1,"local-expand/capture-lifts"]],["scheme/base","scheme"]],
["local-table-of-contents",">scribble/basic.html#(def._((lib._scribble/basic..ss)._local-table-of-contents))",[0,[1,"local-table-of-contents"]],["scribble/basic"]],
["local-to-global",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._local-to-global))",[[0,[1,"local-to-global"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["local-transformer-expand",">reference/stxtrans.html#(def._((quote._~23~25kernel)._local-transformer-expand))",[0,[1,"local-transformer-expand"]],["scheme/base","scheme"]],
["local-transformer-expand/capture-lifts",">reference/stxtrans.html#(def._((quote._~23~25kernel)._local-transformer-expand/capture-lifts))",[0,[1,"local-transformer-expand/capture-lifts"]],["scheme/base","scheme"]],
["locale",">reference/encodings.html#(tech._locale)","<i>locale</i>",false],
["locale-specific string operations",">reference/strings.html#(part._.Locale-.Specific_.String_.Operations)","Locale-Specific String Operations",false],
["locale-string-encoding",">reference/bytestrings.html#(def._((quote._~23~25kernel)._locale-string-encoding))",[0,[1,"locale-string-encoding"]],["scheme/base","scheme"]],
["localized-template",">srfi-std/srfi-29.html#localized-template",[0,[1,"localized-template"]],["srfi/29"]],
["locate-file",">framework/Group.html#(meth._(((lib._framework/main..ss)._group~3a~25)._locate-file))",[[0,[1,"locate-file"]],[12,[" (method of ",[0,[1,"group:%"]],")"]]],["framework"]],
["locating paths",">reference/Filesystem.html#(part._findpaths)","Locating Paths",false],
["location",">xml/index.html#(def._((lib._xml/main..ss)._location))",[0,[1,"location"]],["xml"]],
["location",">gui/editor-overview.html#(tech._location)","<i>location</i>",false],
["location",">reference/eval-model.html#(tech._location)","<i>location</i>",false],
["location-char",">xml/index.html#(def._((lib._xml/main..ss)._location-char))",[0,[1,"location-char"]],["xml"]],
["location-line",">xml/index.html#(def._((lib._xml/main..ss)._location-line))",[0,[1,"location-line"]],["xml"]],
["location-offset",">xml/index.html#(def._((lib._xml/main..ss)._location-offset))",[0,[1,"location-offset"]],["xml"]],
["location?",">xml/index.html#(def._((lib._xml/main..ss)._location~3f))",[0,[1,"location?"]],["xml"]],
["locations-computed?",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._locations-computed~3f))",[[0,[1,"locations-computed?"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["locations: #%variable-reference",">reference/Locations____variable-reference.html",["Locations: ",[0,[6,"#%variable-reference"]]],false],
["lock",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._lock))",[[0,[1,"lock"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["lock",">framework/Color.html#(meth._(((lib._framework/main..ss)._color~3atext-mixin)._lock))",[[0,[1,"lock"]],[12,[" (method of ",[0,[1,"color:text-mixin"]],")"]]],["framework"]],
["lock",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3ainfo-mixin)._lock))",[[0,[1,"lock"]],[12,[" (method of ",[0,[1,"editor:info-mixin"]],")"]]],["framework"]],
["lock-status-changed",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3ainfo~3c~25~3e)._lock-status-changed))",[[0,[1,"lock-status-changed"]],[12,[" (method of ",[0,[1,"frame:info&lt;%&gt;"]],")"]]],["framework"]],
["locked-for-flow?",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._locked-for-flow~3f))",[[0,[1,"locked-for-flow?"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["locked-for-read?",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._locked-for-read~3f))",[[0,[1,"locked-for-read?"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["locked-for-write?",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._locked-for-write~3f))",[[0,[1,"locked-for-write?"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["log",">reference/numbers.html#(def._((quote._~23~25kernel)._log))",[0,[1,"log"]],["scheme/base","scheme"]],
["log",">r5rs-std/r5rs-Z-H-9.html#%_idx_328",[0,[1,"log"]],["r5rs"]],
["log",">r6rs-std/r6rs-Z-H-14.html#node_idx_542",[0,[1,"log"]],["rnrs/base-6"]],
["log",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._log))",[0,[1,"log"]],["lang/htdp-advanced"]],
["log",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._log))",[0,[1,"log"]],["lang/htdp-beginner"]],
["log",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._log))",[0,[1,"log"]],["lang/htdp-beginner-abbr"]],
["log",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._log))",[0,[1,"log"]],["lang/htdp-intermediate"]],
["log",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._log))",[0,[1,"log"]],["lang/htdp-intermediate-lambda"]],
["log definitions and interactions... menu item",">drscheme/Menus.html#(idx._(gentag._71._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Log Definitions and Interactions...</font></b> menu item",false],
["log receiver",">reference/logging.html#(tech._log._receiver)","<i>log receiver</i>",false],
["log-debug",">reference/logging.html#(form._((lib._scheme/private/more-scheme..ss)._log-debug))",[0,[6,"log-debug"]],["scheme/base","scheme"]],
["log-error",">reference/logging.html#(form._((lib._scheme/private/more-scheme..ss)._log-error))",[0,[6,"log-error"]],["scheme/base","scheme"]],
["log-fatal",">reference/logging.html#(form._((lib._scheme/private/more-scheme..ss)._log-fatal))",[0,[6,"log-fatal"]],["scheme/base","scheme"]],
["log-file",">planet/Utility_Libraries.html#(def._((lib._planet/config..ss)._.L.O.G-.F.I.L.E))",[0,[1,"LOG-FILE"]],["planet/config"]],
["log-format->format",">web-server/dispatch-log_ss.html#(def._((lib._web-server/dispatchers/dispatch-log..ss)._log-format-~3eformat))",[0,[1,"log-format-&gt;format"]],["web-server/dispatchers/dispatch-log"]],
["log-info",">reference/logging.html#(form._((lib._scheme/private/more-scheme..ss)._log-info))",[0,[6,"log-info"]],["scheme/base","scheme"]],
["log-level?",">reference/logging.html#(def._((quote._~23~25kernel)._log-level~3f))",[0,[1,"log-level?"]],["scheme/base","scheme"]],
["log-message",">reference/logging.html#(def._((quote._~23~25kernel)._log-message))",[0,[1,"log-message"]],["scheme/base","scheme"]],
["log-receiver?",">reference/logging.html#(def._((quote._~23~25kernel)._log-receiver~3f))",[0,[1,"log-receiver?"]],["scheme/base","scheme"]],
["log-warning",">reference/logging.html#(form._((lib._scheme/private/more-scheme..ss)._log-warning))",[0,[6,"log-warning"]],["scheme/base","scheme"]],
["logger",">reference/logging.html#(tech._logger)","<i>logger</i>",false],
["logger-name",">reference/logging.html#(def._((quote._~23~25kernel)._logger-name))",[0,[1,"logger-name"]],["scheme/base","scheme"]],
["logger?",">reference/logging.html#(def._((quote._~23~25kernel)._logger~3f))",[0,[1,"logger?"]],["scheme/base","scheme"]],
["logging",">reference/logging.html","Logging",false],
["logging",">web-server/dispatch-log_ss.html","Logging",false],
["logging events",">reference/logging.html#(part._.Logging_.Events)","Logging Events",false],
["logical operators",">reference/numbers.html#(idx._(gentag._18._(lib._scribblings/reference/reference..scrbl)))","logical operators",false],
["logname",">reference/Filesystem.html#(idx._(gentag._240._(lib._scribblings/reference/reference..scrbl)))",[5,"LOGNAME"],false],
["long-dash",">gui/pen_.html#(idx._(gentag._221._(lib._scribblings/gui/gui..scrbl)))",[7,"'long-dash"],false],
["lookahead",">guide/Looking_Ahead_and_Behind.html#(part._.Lookahead)","Lookahead",false],
["lookahead-char",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_698",[0,[1,"lookahead-char"]],["rnrs/io/ports-6"]],
["lookahead-u8",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_686",[0,[1,"lookahead-u8"]],["rnrs/io/ports-6"]],
["lookbehind",">guide/Looking_Ahead_and_Behind.html#(part._.Lookbehind)","Lookbehind",false],
["looking ahead and behind",">guide/Looking_Ahead_and_Behind.html","Looking Ahead and Behind",false],
["lookup-documentation",">syntax/docprovide.html#(def._((lib._syntax/docprovide..ss)._lookup-documentation))",[0,[1,"lookup-documentation"]],["syntax/docprovide"]],
["loop-until",">mzlib/mzlib_etc.html#(def._((lib._mzlib/etc..ss)._loop-until))",[0,[1,"loop-until"]],["mzlib/etc"]],
["lorenz",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..ss)._lorenz))",[0,[1,"lorenz"]],["graphics/turtle-examples"]],
["lorenz attractor",">turtles/Traditional_Turtles.html#(idx._(gentag._2._(lib._graphics/scribblings/turtles..scrbl)))","Lorenz attractor",false],
["lorenz1",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..ss)._lorenz1))",[0,[1,"lorenz1"]],["graphics/turtle-examples"]],
["lower",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._lower))",[[0,[1,"lower"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["lower-case",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..ss)._lower-case))",[0,[6,"lower-case"]],["parser-tools/lex"]],
["lowercase-symbol!",">web-server/util_ss.html#(def._((lib._web-server/private/util..ss)._lowercase-symbol!))",[0,[1,"lowercase-symbol!"]],["web-server/private/util"]],
["lpt1",">reference/windowspaths.html#(idx._(gentag._228._(lib._scribblings/reference/reference..scrbl)))",[5,"\"LPT1\""],false],
["lpt2",">reference/windowspaths.html#(idx._(gentag._229._(lib._scribblings/reference/reference..scrbl)))",[5,"\"LPT2\""],false],
["lpt3",">reference/windowspaths.html#(idx._(gentag._230._(lib._scribblings/reference/reference..scrbl)))",[5,"\"LPT3\""],false],
["lpt4",">reference/windowspaths.html#(idx._(gentag._231._(lib._scribblings/reference/reference..scrbl)))",[5,"\"LPT4\""],false],
["lpt5",">reference/windowspaths.html#(idx._(gentag._232._(lib._scribblings/reference/reference..scrbl)))",[5,"\"LPT5\""],false],
["lpt6",">reference/windowspaths.html#(idx._(gentag._233._(lib._scribblings/reference/reference..scrbl)))",[5,"\"LPT6\""],false],
["lpt7",">reference/windowspaths.html#(idx._(gentag._234._(lib._scribblings/reference/reference..scrbl)))",[5,"\"LPT7\""],false],
["lpt8",">reference/windowspaths.html#(idx._(gentag._235._(lib._scribblings/reference/reference..scrbl)))",[5,"\"LPT8\""],false],
["lpt9",">reference/windowspaths.html#(idx._(gentag._236._(lib._scribblings/reference/reference..scrbl)))",[5,"\"LPT9\""],false],
["lru",">web-server/lru_ss.html","LRU",false],
["lset",">srfi-std/srfi-1.html#lset",[0,[1,"lset"]],["srfi/1"]],
["lset-adjoin",">srfi-std/srfi-1.html#lset-adjoin",[0,[1,"lset-adjoin"]],["srfi/1"]],
["lset-diff+intersection",">srfi-std/srfi-1.html#lset-diff+intersection",[0,[1,"lset-diff+intersection"]],["srfi/1"]],
["lset-diff+intersection!",">srfi-std/srfi-1.html#lset-diff+intersection!",[0,[1,"lset-diff+intersection!"]],["srfi/1"]],
["lset-difference",">srfi-std/srfi-1.html#lset-difference",[0,[1,"lset-difference"]],["srfi/1"]],
["lset-difference!",">srfi-std/srfi-1.html#lset-difference!",[0,[1,"lset-difference!"]],["srfi/1"]],
["lset-intersection",">srfi-std/srfi-1.html#lset-intersection",[0,[1,"lset-intersection"]],["srfi/1"]],
["lset-intersection!",">srfi-std/srfi-1.html#lset-intersection!",[0,[1,"lset-intersection!"]],["srfi/1"]],
["lset-union",">srfi-std/srfi-1.html#lset-union",[0,[1,"lset-union"]],["srfi/1"]],
["lset-union!",">srfi-std/srfi-1.html#lset-union!",[0,[1,"lset-union!"]],["srfi/1"]],
["lset-xor",">srfi-std/srfi-1.html#lset-xor",[0,[1,"lset-xor"]],["srfi/1"]],
["lset-xor!",">srfi-std/srfi-1.html#lset-xor!",[0,[1,"lset-xor!"]],["srfi/1"]],
["lset=",">srfi-std/srfi-1.html#lset=",[0,[1,"lset="]],["srfi/1"]],
["lt",">reference/characters.html#(idx._(gentag._38._(lib._scribblings/reference/reference..scrbl)))",[7,"'lt"],false],
["lt-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..ss)._lt-find))",[0,[1,"lt-find"]],["slideshow/pict","slideshow"]],
["lt-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..ss)._lt-superimpose))",[0,[1,"lt-superimpose"]],["slideshow/pict","slideshow"]],
["ltl-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..ss)._ltl-find))",[0,[1,"ltl-find"]],["slideshow/pict","slideshow"]],
["ltl-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..ss)._ltl-superimpose))",[0,[1,"ltl-superimpose"]],["slideshow/pict","slideshow"]],
["lu",">reference/characters.html#(idx._(gentag._36._(lib._scribblings/reference/reference..scrbl)))",[7,"'lu"],false],
["lw",">redex/Typesetting.html#(part._.L.W)","LW",false],
["lw",">redex/Typesetting.html#(form._((lib._redex/pict..ss)._lw))",[10,"lw"],["redex/pict"]],
["lw->pict",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._lw-~3epict))",[0,[1,"lw-&gt;pict"]],["redex/pict"]],
["lw-column",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._lw-column))",[0,[1,"lw-column"]],["redex/pict"]],
["lw-column-span",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._lw-column-span))",[0,[1,"lw-column-span"]],["redex/pict"]],
["lw-e",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._lw-e))",[0,[1,"lw-e"]],["redex/pict"]],
["lw-line",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._lw-line))",[0,[1,"lw-line"]],["redex/pict"]],
["lw-line-span",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._lw-line-span))",[0,[1,"lw-line-span"]],["redex/pict"]],
["lw?",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._lw~3f))",[0,[1,"lw?"]],["redex/pict"]],
["m-( keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._198._(lib._scribblings/drscheme/drscheme..scrbl)))","M-( keybinding",false],
["m-< keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._160._(lib._scribblings/drscheme/drscheme..scrbl)))","M-&lt; keybinding",false],
["m-> keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._161._(lib._scribblings/drscheme/drscheme..scrbl)))","M-&gt; keybinding",false],
["m-[ keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._199._(lib._scribblings/drscheme/drscheme..scrbl)))","M-[ keybinding",false],
["m-b keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._157._(lib._scribblings/drscheme/drscheme..scrbl)))","M-b keybinding",false],
["m-c-b keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._167._(lib._scribblings/drscheme/drscheme..scrbl)))","M-C-b keybinding",false],
["m-c-d keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._169._(lib._scribblings/drscheme/drscheme..scrbl)))","M-C-d keybinding",false],
["m-c-down keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._178._(lib._scribblings/drscheme/drscheme..scrbl)))","M-C-down keybinding",false],
["m-c-f keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._166._(lib._scribblings/drscheme/drscheme..scrbl)))","M-C-f keybinding",false],
["m-c-k keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._189._(lib._scribblings/drscheme/drscheme..scrbl)))","M-C-k keybinding",false],
["m-c-k keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._197._(lib._scribblings/drscheme/drscheme..scrbl)))","M-C-k keybinding",false],
["m-c-left keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._172._(lib._scribblings/drscheme/drscheme..scrbl)))","M-C-left keybinding",false],
["m-c-m keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._196._(lib._scribblings/drscheme/drscheme..scrbl)))","M-C-m keybinding",false],
["m-c-p keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._171._(lib._scribblings/drscheme/drscheme..scrbl)))","M-C-p keybinding",false],
["m-c-right keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._174._(lib._scribblings/drscheme/drscheme..scrbl)))","M-C-right keybinding",false],
["m-c-space keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._170._(lib._scribblings/drscheme/drscheme..scrbl)))","M-C-SPACE keybinding",false],
["m-c-t keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._195._(lib._scribblings/drscheme/drscheme..scrbl)))","M-C-t keybinding",false],
["m-c-u keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._168._(lib._scribblings/drscheme/drscheme..scrbl)))","M-C-u keybinding",false],
["m-c-up keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._176._(lib._scribblings/drscheme/drscheme..scrbl)))","M-C-up keybinding",false],
["m-d keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._186._(lib._scribblings/drscheme/drscheme..scrbl)))","M-d keybinding",false],
["m-del keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._187._(lib._scribblings/drscheme/drscheme..scrbl)))","M-DEL keybinding",false],
["m-f keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._156._(lib._scribblings/drscheme/drscheme..scrbl)))","M-f keybinding",false],
["m-n keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._213._(lib._scribblings/drscheme/drscheme..scrbl)))","M-n keybinding",false],
["m-o keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._205._(lib._scribblings/drscheme/drscheme..scrbl)))","M-o keybinding",false],
["m-p keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._212._(lib._scribblings/drscheme/drscheme..scrbl)))","M-p keybinding",false],
["m-s-l keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._201._(lib._scribblings/drscheme/drscheme..scrbl)))","M-S-L keybinding",false],
["m-t keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._194._(lib._scribblings/drscheme/drscheme..scrbl)))","M-t keybinding",false],
["m-v keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._159._(lib._scribblings/drscheme/drscheme..scrbl)))","M-v keybinding",false],
["m-w keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._190._(lib._scribblings/drscheme/drscheme..scrbl)))","M-w keybinding",false],
["m-{ keybinding",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._200._(lib._scribblings/drscheme/drscheme..scrbl)))","M-{ keybinding",false],
["machine",">reference/runtime.html#(idx._(gentag._308._(lib._scribblings/reference/reference..scrbl)))",[7,"'machine"],false],
["macosx",">reference/runtime.html#(idx._(gentag._298._(lib._scribblings/reference/reference..scrbl)))",[7,"'macosx"],false],
["macro",">guide/macros.html#(tech._macro)","<i>macro</i>",false],
["macro",">reference/syntax-model.html#(tech._macro)","<i>macro</i>",false],
["macro debugger",">macro-debugger/index.html","<b>Macro Debugger</b>",false],
["macro expansion tools",">macro-debugger/index.html#(part._.Macro_expansion_tools)","Macro expansion tools",false],
["macro hiding",">macro-debugger/index.html#(part._.Macro_hiding)","Macro hiding",false],
["macro pattern variables",">guide/pattern-macros.html#(tech._macro._pattern._variable)","<i>macro pattern\nvariables</i>",false],
["macro stepper",">macro-debugger/index.html#(part._.Macro_stepper)","Macro stepper",false],
["macro stepper text interface",">macro-debugger/index.html#(part._.Macro_stepper_text_interface)","Macro stepper text interface",false],
["macro transformer",">guide/proc-macros.html#(tech._macro._transformer)","<i>macro transformer</i>",false],
["macro transformer helpers",">syntax/transformer-helpers.html","Macro Transformer Helpers",false],
["macro-debugger/expand",">macro-debugger/index.html#(mod-path._macro-debugger/expand)",[14,[0,"macro-debugger/expand"]],"module"],
["macro-debugger/stepper",">macro-debugger/index.html#(mod-path._macro-debugger/stepper)",[14,[0,"macro-debugger/stepper"]],"module"],
["macro-debugger/stepper-text",">macro-debugger/index.html#(mod-path._macro-debugger/stepper-text)",[14,[0,"macro-debugger/stepper-text"]],"module"],
["macro-debugger/syntax-browser",">macro-debugger/index.html#(mod-path._macro-debugger/syntax-browser)",[14,[0,"macro-debugger/syntax-browser"]],"module"],
["macro-generating macro",">guide/pattern-macros.html#(tech._macro._generating._macro)","<i>macro-generating\nmacro</i>",false],
["macro-generating macros",">guide/pattern-macros.html#(part._.Macro-.Generating_.Macros)","Macro-Generating Macros",false],
["macro-stepper<%>",">macro-debugger/index.html#(def._((lib._macro-debugger/stepper..ss)._macro-stepper~3c~25~3e))",[0,"macro-stepper&lt;%&gt;"],["macro-debugger/stepper"]],
["macros",">guide/macros.html","Macros",false],
["macros",">quick/index.html#(part._.Macros)","Macros",false],
["macros",">reference/Macros.html","Macros",false],
["macros for unsafety",">foreign/Macros_for_Unsafety.html","Macros for Unsafety",false],
["magnitude",">reference/numbers.html#(def._((quote._~23~25kernel)._magnitude))",[0,[1,"magnitude"]],["scheme/base","scheme"]],
["magnitude",">r5rs-std/r5rs-Z-H-9.html#%_idx_356",[0,[1,"magnitude"]],["r5rs"]],
["magnitude",">r6rs-std/r6rs-Z-H-14.html#node_idx_574",[0,[1,"magnitude"]],["rnrs/base-6"]],
["magnitude",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._magnitude))",[0,[1,"magnitude"]],["lang/htdp-advanced"]],
["magnitude",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._magnitude))",[0,[1,"magnitude"]],["lang/htdp-beginner"]],
["magnitude",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._magnitude))",[0,[1,"magnitude"]],["lang/htdp-beginner-abbr"]],
["magnitude",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._magnitude))",[0,[1,"magnitude"]],["lang/htdp-intermediate"]],
["magnitude",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._magnitude))",[0,[1,"magnitude"]],["lang/htdp-intermediate-lambda"]],
["main compiler unit",">mzc/Scheme_API_for_Compilation.html#(part._.Main_.Compiler_.Unit)","Main Compiler Unit",false],
["main-collects-relative->path",">setup-plt/main-collects.html#(def._((lib._setup/main-collects..ss)._main-collects-relative-~3epath))",[0,[1,"main-collects-relative-&gt;path"]],["setup/main-collects"]],
["make",">make/make.html",[14,[0,[6,"make"]]],"module"],
["make",">make/make.html#(form._((lib._make/main..ss)._make))",[0,[6,"make"]],["make"]],
["make",">web-server/dispatch-files_ss.html#(def._((lib._web-server/dispatchers/dispatch-files..ss)._make))",[0,[1,"make"]],["web-server/dispatchers/dispatch-files"]],
["make",">web-server/dispatch-filter_ss.html#(def._((lib._web-server/dispatchers/dispatch-filter..ss)._make))",[0,[1,"make"]],["web-server/dispatchers/dispatch-filter"]],
["make",">web-server/dispatch-host_ss.html#(def._((lib._web-server/dispatchers/dispatch-host..ss)._make))",[0,[1,"make"]],["web-server/dispatchers/dispatch-host"]],
["make",">web-server/dispatch-lang_ss.html#(def._((lib._web-server/dispatchers/dispatch-lang..ss)._make))",[0,[1,"make"]],["web-server/dispatchers/dispatch-lang"]],
["make",">web-server/dispatch-lift_ss.html#(def._((lib._web-server/dispatchers/dispatch-lift..ss)._make))",[0,[1,"make"]],["web-server/dispatchers/dispatch-lift"]],
["make",">web-server/dispatch-log_ss.html#(def._((lib._web-server/dispatchers/dispatch-log..ss)._make))",[0,[1,"make"]],["web-server/dispatchers/dispatch-log"]],
["make",">web-server/dispatch-passwords_ss.html#(def._((lib._web-server/dispatchers/dispatch-passwords..ss)._make))",[0,[1,"make"]],["web-server/dispatchers/dispatch-passwords"]],
["make",">web-server/dispatch-pathprocedure_ss.html#(def._((lib._web-server/dispatchers/dispatch-pathprocedure..ss)._make))",[0,[1,"make"]],["web-server/dispatchers/dispatch-pathprocedure"]],
["make",">web-server/dispatch-sequencer_ss.html#(def._((lib._web-server/dispatchers/dispatch-sequencer..ss)._make))",[0,[1,"make"]],["web-server/dispatchers/dispatch-sequencer"]],
["make",">web-server/dispatch-servlets_ss.html#(def._((lib._web-server/dispatchers/dispatch-servlets..ss)._make))",[0,[1,"make"]],["web-server/dispatchers/dispatch-servlets"]],
["make",">web-server/dispatch-stat_ss.html#(def._((lib._web-server/dispatchers/dispatch-stat..ss)._make))",[0,[1,"make"]],["web-server/dispatchers/dispatch-stat"]],
["make",">web-server/dispatch-timeout_ss.html#(def._((lib._web-server/dispatchers/dispatch-timeout..ss)._make))",[0,[1,"make"]],["web-server/dispatchers/dispatch-timeout"]],
["make from dependencies",">make/make.html","Make from Dependencies",false],
["make->vector",">mzlib/mzlib_struct.html#(form._((lib._mzlib/struct..ss)._make-~3evector))",[0,"make-&gt;vector"],["mzlib/struct"]],
["make-a",">html/index.html#(def._((lib._html/main..ss)._make-a))",[0,[1,"make-a"]],["html"]],
["make-abbr",">html/index.html#(def._((lib._html/main..ss)._make-abbr))",[0,[1,"make-abbr"]],["html"]],
["make-acronym",">html/index.html#(def._((lib._html/main..ss)._make-acronym))",[0,[1,"make-acronym"]],["html"]],
["make-address",">html/index.html#(def._((lib._html/main..ss)._make-address))",[0,[1,"make-address"]],["html"]],
["make-alink",">html/index.html#(def._((lib._html/main..ss)._make-alink))",[0,[1,"make-alink"]],["html"]],
["make-alpha-color",">teachpack/image.html#(def._((lib._htdp/image..ss)._make-alpha-color))",[0,[1,"make-alpha-color"]],["teachpack/htdp/image"]],
["make-applet",">html/index.html#(def._((lib._html/main..ss)._make-applet))",[0,[1,"make-applet"]],["html"]],
["make-area",">html/index.html#(def._((lib._html/main..ss)._make-area))",[0,[1,"make-area"]],["html"]],
["make-argb",">mrlib/Cache-image_Snip.html#(def._((lib._mrlib/cache-image-snip..ss)._make-argb))",[0,[1,"make-argb"]],["mrlib/cache-image-snip"]],
["make-arity-at-least",">reference/procedures.html#(def._((quote._~23~25kernel)._make-arity-at-least))",[0,[1,"make-arity-at-least"]],["scheme/base","scheme"]],
["make-array",">srfi-std/srfi-25.html#make-array",[0,[1,"make-array"]],["srfi/25"]],
["make-article-not-found",">net/nntp.html#(def._((lib._net/nntp..ss)._make-article-not-found))",[0,[1,"make-article-not-found"]],["net/nntp"]],
["make-article-not-in-group",">net/nntp.html#(def._((lib._net/nntp..ss)._make-article-not-in-group))",[0,[1,"make-article-not-in-group"]],["net/nntp"]],
["make-assertion-violation",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_440",[0,[1,"make-assertion-violation"]],["rnrs/conditions-6"]],
["make-async-channel",">reference/async-channel.html#(def._((lib._scheme/async-channel..ss)._make-async-channel))",[0,[1,"make-async-channel"]],["scheme/async-channel"]],
["make-at-readtable",">scribble/reader.html#(def._((lib._scribble/reader..ss)._make-at-readtable))",[0,[1,"make-at-readtable"]],["scribble/reader"]],
["make-attribute",">xml/index.html#(def._((lib._xml/main..ss)._make-attribute))",[0,[1,"make-attribute"]],["xml"]],
["make-authentication-rejected",">net/nntp.html#(def._((lib._net/nntp..ss)._make-authentication-rejected))",[0,[1,"make-authentication-rejected"]],["net/nntp"]],
["make-aux-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-aux-element))",[0,[1,"make-aux-element"]],["scribble/struct"]],
["make-b",">html/index.html#(def._((lib._html/main..ss)._make-b))",[0,[1,"make-b"]],["html"]],
["make-background-region",">cards/index.html#(def._((lib._games/cards..ss)._make-background-region))",[0,[1,"make-background-region"]],["games/cards"]],
["make-bad-newsgroup-line",">net/nntp.html#(def._((lib._net/nntp..ss)._make-bad-newsgroup-line))",[0,[1,"make-bad-newsgroup-line"]],["net/nntp"]],
["make-bad-status-line",">net/nntp.html#(def._((lib._net/nntp..ss)._make-bad-status-line))",[0,[1,"make-bad-status-line"]],["net/nntp"]],
["make-balloon",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/balloon..ss)._make-balloon))",[0,[1,"make-balloon"]],["slideshow/balloon"]],
["make-base",">html/index.html#(def._((lib._html/main..ss)._make-base))",[0,[1,"make-base"]],["html"]],
["make-base-empty-namespace",">reference/Namespaces.html#(def._((lib._scheme/base..ss)._make-base-empty-namespace))",[0,[1,"make-base-empty-namespace"]],["scheme/base","scheme"]],
["make-base-eval",">scribble/eval.html#(def._((lib._scribble/eval..ss)._make-base-eval))",[0,[1,"make-base-eval"]],["scribble/eval"]],
["make-base-namespace",">reference/Namespaces.html#(def._((lib._scheme/base..ss)._make-base-namespace))",[0,[1,"make-base-namespace"]],["scheme/base","scheme"]],
["make-basefont",">html/index.html#(def._((lib._html/main..ss)._make-basefont))",[0,[1,"make-basefont"]],["html"]],
["make-bdo",">html/index.html#(def._((lib._html/main..ss)._make-bdo))",[0,[1,"make-bdo"]],["html"]],
["make-big",">html/index.html#(def._((lib._html/main..ss)._make-big))",[0,[1,"make-big"]],["html"]],
["make-bind",">redex/Patterns.html#(def._((lib._redex/reduction-semantics..ss)._make-bind))",[0,[1,"make-bind"]],["redex/reduction-semantics"]],
["make-binding",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._make-binding))",[0,[1,"make-binding"]],["web-server/private/request-structs"]],
["make-binding:file",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._make-binding~3afile))",[0,[1,"make-binding:file"]],["web-server/private/request-structs"]],
["make-binding:form",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._make-binding~3aform))",[0,[1,"make-binding:form"]],["web-server/private/request-structs"]],
["make-bitmap-label",">mrlib/Bitmap_Label.html#(def._((lib._mrlib/bitmap-label..ss)._make-bitmap-label))",[0,[1,"make-bitmap-label"]],["mrlib/bitmap-label"]],
["make-blockquote",">html/index.html#(def._((lib._html/main..ss)._make-blockquote))",[0,[1,"make-blockquote"]],["html"]],
["make-blockquote",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-blockquote))",[0,[1,"make-blockquote"]],["scribble/struct"]],
["make-blog",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/dummy-10..ss)._make-blog))",[0,[1,"make-blog"]],[]],
["make-blog",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-4..ss)._make-blog))",[0,[1,"make-blog"]],[]],
["make-blog",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-9..ss)._make-blog))",[0,[1,"make-blog"]],[]],
["make-body",">html/index.html#(def._((lib._html/main..ss)._make-body))",[0,[1,"make-body"]],["html"]],
["make-bound-identifier-mapping",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..ss)._make-bound-identifier-mapping))",[0,[1,"make-bound-identifier-mapping"]],["syntax/boundmap"]],
["make-br",">html/index.html#(def._((lib._html/main..ss)._make-br))",[0,[1,"make-br"]],["html"]],
["make-button",">html/index.html#(def._((lib._html/main..ss)._make-button))",[0,[1,"make-button"]],["html"]],
["make-button",">teachpack/gui.html#(def._((lib._teachpack/htdp/gui..ss)._make-button))",[0,[1,"make-button"]],["teachpack/htdp/gui"]],
["make-button-region",">cards/index.html#(def._((lib._games/cards..ss)._make-button-region))",[0,[1,"make-button-region"]],["games/cards"]],
["make-bytes",">reference/bytestrings.html#(def._((quote._~23~25kernel)._make-bytes))",[0,[1,"make-bytes"]],["scheme/base","scheme"]],
["make-bytevector",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_82",[0,[1,"make-bytevector"]],["rnrs/bytevectors-6"]],
["make-c-parameter",">foreign/Loading_Foreign_Libraries.html#(def._((lib._scribblings/foreign/unsafe-foreign..ss)._make-c-parameter))",[0,[1,"make-c-parameter"]],["scribblings/foreign/unsafe-foreign"]],
["make-cache-table",">web-server/cache-table_ss.html#(def._((lib._web-server/private/cache-table..ss)._make-cache-table))",[0,[1,"make-cache-table"]],["web-server/private/cache-table"]],
["make-caching-managed-compile-zo",">mzc/make.html#(def._((lib._compiler/cm..ss)._make-caching-managed-compile-zo))",[0,[1,"make-caching-managed-compile-zo"]],["compiler/cm"]],
["make-cannot-connect",">net/pop3.html#(def._((lib._net/pop3..ss)._make-cannot-connect))",[0,[1,"make-cannot-connect"]],["net/pop3"]],
["make-cannot-delete-message",">net/pop3.html#(def._((lib._net/pop3..ss)._make-cannot-delete-message))",[0,[1,"make-cannot-delete-message"]],["net/pop3"]],
["make-canvas",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-panel-mixin)._make-canvas))",[[0,[1,"make-canvas"]],[12,[" (method of ",[0,[1,"hyper-panel-mixin"]],")"]]],["browser"]],
["make-caption",">html/index.html#(def._((lib._html/main..ss)._make-caption))",[0,[1,"make-caption"]],["html"]],
["make-card",">cards/index.html#(def._((lib._games/cards..ss)._make-card))",[0,[1,"make-card"]],["games/cards"]],
["make-cdata",">xml/index.html#(def._((lib._xml/main..ss)._make-cdata))",[0,[1,"make-cdata"]],["xml"]],
["make-center",">html/index.html#(def._((lib._html/main..ss)._make-center))",[0,[1,"make-center"]],["html"]],
["make-cgi-error",">net/cgi.html#(def._((lib._net/cgi..ss)._make-cgi-error))",[0,[1,"make-cgi-error"]],["net/cgi"]],
["make-channel",">reference/channel.html#(def._((quote._~23~25kernel)._make-channel))",[0,[1,"make-channel"]],["scheme/base","scheme"]],
["make-child",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..ss)._make-child))",[0,[1,"make-child"]],["slideshow/pict","slideshow"]],
["make-choice",">teachpack/gui.html#(def._((lib._teachpack/htdp/gui..ss)._make-choice))",[0,[1,"make-choice"]],["teachpack/htdp/gui"]],
["make-cite",">html/index.html#(def._((lib._html/main..ss)._make-cite))",[0,[1,"make-cite"]],["html"]],
["make-class-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._make-class-index-desc))",[0,[1,"make-class-index-desc"]],["scribble/manual-struct"]],
["make-closure-definition-syntax",">web-server/closure_ss.html#(def._((lib._web-server/private/closure..ss)._make-closure-definition-syntax))",[0,[1,"make-closure-definition-syntax"]],["web-server/private/closure"]],
["make-code",">html/index.html#(def._((lib._html/main..ss)._make-code))",[0,[1,"make-code"]],["html"]],
["make-col",">html/index.html#(def._((lib._html/main..ss)._make-col))",[0,[1,"make-col"]],["html"]],
["make-colgroup",">html/index.html#(def._((lib._html/main..ss)._make-colgroup))",[0,[1,"make-colgroup"]],["html"]],
["make-collect-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-collect-element))",[0,[1,"make-collect-element"]],["scribble/struct"]],
["make-collect-info",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-collect-info))",[0,[1,"make-collect-info"]],["scribble/struct"]],
["make-collected-info",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-collected-info))",[0,[1,"make-collected-info"]],["scribble/struct"]],
["make-collection",">make/collection.html#(def._((lib._make/collection..ss)._make-collection))",[0,[1,"make-collection"]],["make/collection"]],
["make-color",">teachpack/image.html#(def._((lib._htdp/image..ss)._make-color))",[0,[1,"make-color"]],["teachpack/htdp/image"]],
["make-column",">plot/extend.html#(def._((lib._plot/extend..ss)._make-column))",[0,[1,"make-column"]],["plot/extend"]],
["make-comment",">xml/index.html#(def._((lib._xml/main..ss)._make-comment))",[0,[1,"make-comment"]],["xml"]],
["make-communicator",">net/nntp.html#(def._((lib._net/nntp..ss)._make-communicator))",[0,[1,"make-communicator"]],["net/nntp"]],
["make-communicator",">net/pop3.html#(def._((lib._net/pop3..ss)._make-communicator))",[0,[1,"make-communicator"]],["net/pop3"]],
["make-compilation-manager-load/use-compiled-handler",">mzc/make.html#(def._((lib._compiler/cm..ss)._make-compilation-manager-load/use-compiled-handler))",[0,[1,"make-compilation-manager-load/use-compiled-handler"]],["compiler/cm"]],
["make-composite-input",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..ss)._make-composite-input))",[0,[1,"make-composite-input"]],["preprocessor/mztext"]],
["make-configuration-table",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._make-configuration-table))",[0,[1,"make-configuration-table"]],["web-server/configuration/configuration-table-structs"]],
["make-connection",">web-server/connection-manager_ss.html#(def._((lib._web-server/private/connection-manager..ss)._make-connection))",[0,[1,"make-connection"]],["web-server/private/connection-manager"]],
["make-continuation-prompt-tag",">reference/cont.html#(def._((quote._~23~25kernel)._make-continuation-prompt-tag))",[0,[1,"make-continuation-prompt-tag"]],["scheme/base","scheme"]],
["make-control-bar-panel",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-panel-mixin)._make-control-bar-panel))",[[0,[1,"make-control-bar-panel"]],[12,[" (method of ",[0,[1,"hyper-panel-mixin"]],")"]]],["browser"]],
["make-cookie-error",">net/cookie.html#(def._((lib._net/cookie..ss)._make-cookie-error))",[0,[1,"make-cookie-error"]],["net/cookie"]],
["make-css-length",">mysterx/CSS.html#(def._((lib._mysterx/main..ss)._make-css-length))",[0,[1,"make-css-length"]],["mysterx"]],
["make-css-percentage",">mysterx/CSS.html#(def._((lib._mysterx/main..ss)._make-css-percentage))",[0,[1,"make-css-percentage"]],["mysterx"]],
["make-cstruct-type",">foreign/C_Struct_Types.html#(def._((lib._scheme/foreign..ss)._make-cstruct-type))",[0,[1,"make-cstruct-type"]],["scheme/foreign"]],
["make-ctype",">foreign/Type_Constructors.html#(def._((lib._scheme/foreign..ss)._make-ctype))",[0,[1,"make-ctype"]],["scheme/foreign"]],
["make-custodian",">reference/custodians.html#(def._((quote._~23~25kernel)._make-custodian))",[0,[1,"make-custodian"]],["scheme/base","scheme"]],
["make-custodian-box",">reference/custodians.html#(def._((quote._~23~25kernel)._make-custodian-box))",[0,[1,"make-custodian-box"]],["scheme/base","scheme"]],
["make-custom-binary-input-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_680",[0,[1,"make-custom-binary-input-port"]],["rnrs/io/ports-6"]],
["make-custom-binary-input/output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_762",[0,[1,"make-custom-binary-input/output-port"]],["rnrs/io/ports-6"]],
["make-custom-binary-output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_738",[0,[1,"make-custom-binary-output-port"]],["rnrs/io/ports-6"]],
["make-custom-hash",">reference/dicts.html#(def._((lib._scheme/dict..ss)._make-custom-hash))",[0,[1,"make-custom-hash"]],["scheme/dict","scheme"]],
["make-custom-textual-input-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_682",[0,[1,"make-custom-textual-input-port"]],["rnrs/io/ports-6"]],
["make-custom-textual-input/output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_764",[0,[1,"make-custom-textual-input/output-port"]],["rnrs/io/ports-6"]],
["make-custom-textual-output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_740",[0,[1,"make-custom-textual-output-port"]],["rnrs/io/ports-6"]],
["make-cvector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._make-cvector))",[0,[1,"make-cvector"]],["scheme/foreign"]],
["make-cvector*",">foreign/Derived_Utilities.html#(def._((lib._scribblings/foreign/unsafe-foreign..ss)._make-cvector*))",[0,[1,"make-cvector*"]],["scribblings/foreign/unsafe-foreign"]],
["make-data-set",">mrlib/Plot.html#(def._((lib._mrlib/plot..ss)._make-data-set))",[0,[1,"make-data-set"]],["mrlib/plot"]],
["make-date",">reference/time.html#(def._((quote._~23~25kernel)._make-date))",[0,[1,"make-date"]],["scheme/base","scheme"]],
["make-date",">srfi-std/srfi-19.html#make-date",[0,[1,"make-date"]],["srfi/19"]],
["make-dd",">html/index.html#(def._((lib._html/main..ss)._make-dd))",[0,[1,"make-dd"]],["html"]],
["make-deck",">cards/index.html#(def._((lib._games/cards..ss)._make-deck))",[0,[1,"make-deck"]],["games/cards"]],
["make-del",">html/index.html#(def._((lib._html/main..ss)._make-del))",[0,[1,"make-del"]],["html"]],
["make-delayed-block",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-delayed-block))",[0,[1,"make-delayed-block"]],["scribble/struct"]],
["make-delayed-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-delayed-element))",[0,[1,"make-delayed-element"]],["scribble/struct"]],
["make-derived-parameter",">reference/parameters.html#(def._((quote._~23~25kernel)._make-derived-parameter))",[0,[1,"make-derived-parameter"]],["scheme/base","scheme"]],
["make-deserialize-info",">reference/serialization.html#(def._((lib._scheme/private/serialize..ss)._make-deserialize-info))",[0,[1,"make-deserialize-info"]],["scheme/serialize"]],
["make-desired-header",">net/nntp.html#(def._((lib._net/nntp..ss)._make-desired-header))",[0,[1,"make-desired-header"]],["net/nntp"]],
["make-desired-header",">net/pop3.html#(def._((lib._net/pop3..ss)._make-desired-header))",[0,[1,"make-desired-header"]],["net/pop3"]],
["make-dfn",">html/index.html#(def._((lib._html/main..ss)._make-dfn))",[0,[1,"make-dfn"]],["html"]],
["make-dir",">html/index.html#(def._((lib._html/main..ss)._make-dir))",[0,[1,"make-dir"]],["html"]],
["make-dir",">teachpack/dir.html#(def._((lib._teachpack/htdp/dir..ss)._make-dir))",[0,[1,"make-dir"]],["teachpack/htdp/dir"]],
["make-directory",">reference/Filesystem.html#(def._((quote._~23~25kernel)._make-directory))",[0,[1,"make-directory"]],["scheme/base","scheme"]],
["make-directory*",">reference/Filesystem.html#(def._((lib._scheme/file..ss)._make-directory*))",[0,[1,"make-directory*"]],["scheme/file","scheme"]],
["make-disconnect-not-quiet",">net/pop3.html#(def._((lib._net/pop3..ss)._make-disconnect-not-quiet))",[0,[1,"make-disconnect-not-quiet"]],["net/pop3"]],
["make-disposition",">net/mime.html#(def._((lib._net/mime..ss)._make-disposition))",[0,[1,"make-disposition"]],["net/mime"]],
["make-div",">html/index.html#(def._((lib._html/main..ss)._make-div))",[0,[1,"make-div"]],["html"]],
["make-dl",">html/index.html#(def._((lib._html/main..ss)._make-dl))",[0,[1,"make-dl"]],["html"]],
["make-do-sequence",">reference/sequences.html#(def._((lib._scheme/base..ss)._make-do-sequence))",[0,[1,"make-do-sequence"]],["scheme/base","scheme"]],
["make-document",">xml/index.html#(def._((lib._xml/main..ss)._make-document))",[0,[1,"make-document"]],["xml"]],
["make-document-type",">xml/index.html#(def._((lib._xml/main..ss)._make-document-type))",[0,[1,"make-document-type"]],["xml"]],
["make-dt",">html/index.html#(def._((lib._html/main..ss)._make-dt))",[0,[1,"make-dt"]],["html"]],
["make-editor",">framework/Comment_Box.html#(meth._(((lib._framework/main..ss)._comment-box~3asnip~25)._make-editor))",[[0,[1,"make-editor"]],[12,[" (method of ",[0,[1,"comment-box:snip%"]],")"]]],["framework"]],
["make-editor",">framework/editor-snip.html#(meth._(((lib._framework/main..ss)._editor-snip~3adecorated~25)._make-editor))",[[0,[1,"make-editor"]],[12,[" (method of ",[0,[1,"editor-snip:decorated%"]],")"]]],["framework"]],
["make-editor",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor~3c~25~3e)._make-editor))",[[0,[1,"make-editor"]],[12,[" (method of ",[0,[1,"frame:editor&lt;%&gt;"]],")"]]],["framework"]],
["make-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-element))",[0,[1,"make-element"]],["scribble/struct"]],
["make-element",">xml/index.html#(def._((lib._xml/main..ss)._make-element))",[0,[1,"make-element"]],["xml"]],
["make-em",">html/index.html#(def._((lib._html/main..ss)._make-em))",[0,[1,"make-em"]],["html"]],
["make-embedding-executable",">mzc/exe.html#(def._((lib._compiler/embed..ss)._make-embedding-executable))",[0,[1,"make-embedding-executable"]],["compiler/embed"]],
["make-empty-disposition-type",">net/mime.html#(def._((lib._net/mime..ss)._make-empty-disposition-type))",[0,[1,"make-empty-disposition-type"]],["net/mime"]],
["make-empty-mechanism",">net/mime.html#(def._((lib._net/mime..ss)._make-empty-mechanism))",[0,[1,"make-empty-mechanism"]],["net/mime"]],
["make-empty-namespace",">reference/Namespaces.html#(def._((quote._~23~25kernel)._make-empty-namespace))",[0,[1,"make-empty-namespace"]],["scheme/base","scheme"]],
["make-empty-subtype",">net/mime.html#(def._((lib._net/mime..ss)._make-empty-subtype))",[0,[1,"make-empty-subtype"]],["net/mime"]],
["make-empty-type",">net/mime.html#(def._((lib._net/mime..ss)._make-empty-type))",[0,[1,"make-empty-type"]],["net/mime"]],
["make-entity",">net/mime.html#(def._((lib._net/mime..ss)._make-entity))",[0,[1,"make-entity"]],["net/mime"]],
["make-entity",">xml/index.html#(def._((lib._xml/main..ss)._make-entity))",[0,[1,"make-entity"]],["xml"]],
["make-entry",">scribble/xref.html#(def._((lib._scribble/xref..ss)._make-entry))",[0,[1,"make-entry"]],["scribble/xref"]],
["make-enumeration",">r6rs-lib-std/r6rs-lib-Z-H-15.html#node_idx_1236",[0,[1,"make-enumeration"]],["rnrs/enums-6"]],
["make-ephemeron",">reference/ephemerons.html#(def._((quote._~23~25kernel)._make-ephemeron))",[0,[1,"make-ephemeron"]],["scheme/base","scheme"]],
["make-eq-hashtable",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1174",[0,[1,"make-eq-hashtable"]],["rnrs/hashtables-6"]],
["make-eqv-hashtable",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1178",[0,[1,"make-eqv-hashtable"]],["rnrs/hashtables-6"]],
["make-error",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_428",[0,[1,"make-error"]],["rnrs/conditions-6"]],
["make-evaluator",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._make-evaluator))",[0,[1,"make-evaluator"]],["scheme/sandbox"]],
["make-evaluator",">mzlib/mzlib_sandbox.html#(def._((lib._mzlib/sandbox..ss)._make-evaluator))",[0,[1,"make-evaluator"]],["mzlib/sandbox"]],
["make-eventspace",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._make-eventspace))",[0,[1,"make-eventspace"]],["scheme/gui/base","scheme/gui"]],
["make-exn",">reference/exns.html#(def._((quote._~23~25kernel)._make-exn))",[0,[1,"make-exn"]],["scheme/base","scheme"]],
["make-exn:break",">reference/exns.html#(def._((quote._~23~25kernel)._make-exn~3abreak))",[0,[1,"make-exn:break"]],["scheme/base","scheme"]],
["make-exn:dispatcher",">web-server/dispatch_ss.html#(def._((lib._web-server/dispatchers/dispatch..ss)._make-exn~3adispatcher))",[0,[1,"make-exn:dispatcher"]],["web-server/dispatchers/dispatch"]],
["make-exn:fail",">reference/exns.html#(def._((quote._~23~25kernel)._make-exn~3afail))",[0,[1,"make-exn:fail"]],["scheme/base","scheme"]],
["make-exn:fail:contract",">reference/exns.html#(def._((quote._~23~25kernel)._make-exn~3afail~3acontract))",[0,[1,"make-exn:fail:contract"]],["scheme/base","scheme"]],
["make-exn:fail:contract:arity",">reference/exns.html#(def._((quote._~23~25kernel)._make-exn~3afail~3acontract~3aarity))",[0,[1,"make-exn:fail:contract:arity"]],["scheme/base","scheme"]],
["make-exn:fail:contract:continuation",">reference/exns.html#(def._((quote._~23~25kernel)._make-exn~3afail~3acontract~3acontinuation))",[0,[1,"make-exn:fail:contract:continuation"]],["scheme/base","scheme"]],
["make-exn:fail:contract:divide-by-zero",">reference/exns.html#(def._((quote._~23~25kernel)._make-exn~3afail~3acontract~3adivide-by-zero))",[0,[1,"make-exn:fail:contract:divide-by-zero"]],["scheme/base","scheme"]],
["make-exn:fail:contract:variable",">reference/exns.html#(def._((quote._~23~25kernel)._make-exn~3afail~3acontract~3avariable))",[0,[1,"make-exn:fail:contract:variable"]],["scheme/base","scheme"]],
["make-exn:fail:filesystem",">reference/exns.html#(def._((quote._~23~25kernel)._make-exn~3afail~3afilesystem))",[0,[1,"make-exn:fail:filesystem"]],["scheme/base","scheme"]],
["make-exn:fail:filesystem:exists",">reference/exns.html#(def._((quote._~23~25kernel)._make-exn~3afail~3afilesystem~3aexists))",[0,[1,"make-exn:fail:filesystem:exists"]],["scheme/base","scheme"]],
["make-exn:fail:filesystem:version",">reference/exns.html#(def._((quote._~23~25kernel)._make-exn~3afail~3afilesystem~3aversion))",[0,[1,"make-exn:fail:filesystem:version"]],["scheme/base","scheme"]],
["make-exn:fail:make",">make/make.html#(def._((lib._make/main..ss)._make-exn~3afail~3amake))",[0,[1,"make-exn:fail:make"]],["make"]],
["make-exn:fail:network",">reference/exns.html#(def._((quote._~23~25kernel)._make-exn~3afail~3anetwork))",[0,[1,"make-exn:fail:network"]],["scheme/base","scheme"]],
["make-exn:fail:object",">reference/objectutils.html#(def._((lib._scheme/private/class-internal..ss)._make-exn~3afail~3aobject))",[0,[1,"make-exn:fail:object"]],["scheme/class","scheme"]],
["make-exn:fail:out-of-memory",">reference/exns.html#(def._((quote._~23~25kernel)._make-exn~3afail~3aout-of-memory))",[0,[1,"make-exn:fail:out-of-memory"]],["scheme/base","scheme"]],
["make-exn:fail:read",">reference/exns.html#(def._((quote._~23~25kernel)._make-exn~3afail~3aread))",[0,[1,"make-exn:fail:read"]],["scheme/base","scheme"]],
["make-exn:fail:read:eof",">reference/exns.html#(def._((quote._~23~25kernel)._make-exn~3afail~3aread~3aeof))",[0,[1,"make-exn:fail:read:eof"]],["scheme/base","scheme"]],
["make-exn:fail:read:non-char",">reference/exns.html#(def._((quote._~23~25kernel)._make-exn~3afail~3aread~3anon-char))",[0,[1,"make-exn:fail:read:non-char"]],["scheme/base","scheme"]],
["make-exn:fail:servlet-manager:no-continuation",">web-server/manager_ss.html#(def._((lib._web-server/managers/manager..ss)._make-exn~3afail~3aservlet-manager~3ano-continuation))",[0,[1,"make-exn:fail:servlet-manager:no-continuation"]],["web-server/managers/manager"]],
["make-exn:fail:servlet-manager:no-instance",">web-server/manager_ss.html#(def._((lib._web-server/managers/manager..ss)._make-exn~3afail~3aservlet-manager~3ano-instance))",[0,[1,"make-exn:fail:servlet-manager:no-instance"]],["web-server/managers/manager"]],
["make-exn:fail:syntax",">reference/exns.html#(def._((quote._~23~25kernel)._make-exn~3afail~3asyntax))",[0,[1,"make-exn:fail:syntax"]],["scheme/base","scheme"]],
["make-exn:fail:unsupported",">reference/exns.html#(def._((quote._~23~25kernel)._make-exn~3afail~3aunsupported))",[0,[1,"make-exn:fail:unsupported"]],["scheme/base","scheme"]],
["make-exn:fail:user",">reference/exns.html#(def._((quote._~23~25kernel)._make-exn~3afail~3auser))",[0,[1,"make-exn:fail:user"]],["scheme/base","scheme"]],
["make-exn:get-module-code",">syntax/module-helpers.html#(def._((lib._syntax/modcode..ss)._make-exn~3aget-module-code))",[0,[1,"make-exn:get-module-code"]],["syntax/modcode"]],
["make-exn:invalid-xexpr",">xml/index.html#(def._((lib._xml/main..ss)._make-exn~3ainvalid-xexpr))",[0,[1,"make-exn:invalid-xexpr"]],["xml"]],
["make-export",">reference/stxtrans.html#(def._((lib._scheme/provide-transform..ss)._make-export))",[0,[1,"make-export"]],["scheme/provide-transform"]],
["make-exported-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._make-exported-index-desc))",[0,[1,"make-exported-index-desc"]],["scribble/manual-struct"]],
["make-external-dtd",">xml/index.html#(def._((lib._xml/main..ss)._make-external-dtd))",[0,[1,"make-external-dtd"]],["xml"]],
["make-external-dtd/public",">xml/index.html#(def._((lib._xml/main..ss)._make-external-dtd/public))",[0,[1,"make-external-dtd/public"]],["xml"]],
["make-external-dtd/system",">xml/index.html#(def._((lib._xml/main..ss)._make-external-dtd/system))",[0,[1,"make-external-dtd/system"]],["xml"]],
["make-f32vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._make-f32vector))",[0,[1,"make-f32vector"]],["scheme/foreign"]],
["make-f64vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._make-f64vector))",[0,[1,"make-f64vector"]],["scheme/foreign"]],
["make-fieldset",">html/index.html#(def._((lib._html/main..ss)._make-fieldset))",[0,[1,"make-fieldset"]],["html"]],
["make-file",">teachpack/dir.html#(def._((lib._teachpack/htdp/dir..ss)._make-file))",[0,[1,"make-file"]],["teachpack/htdp/dir"]],
["make-file-or-directory-link",">reference/Filesystem.html#(def._((quote._~23~25kernel)._make-file-or-directory-link))",[0,[1,"make-file-or-directory-link"]],["scheme/base","scheme"]],
["make-fit-result",">plot/plot.html#(def._((lib._plot/main..ss)._make-fit-result))",[0,[1,"make-fit-result"]],["plot"]],
["make-flow",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-flow))",[0,[1,"make-flow"]],["scribble/struct"]],
["make-font",">html/index.html#(def._((lib._html/main..ss)._make-font))",[0,[1,"make-font"]],["html"]],
["make-form",">html/index.html#(def._((lib._html/main..ss)._make-form))",[0,[1,"make-form"]],["html"]],
["make-form-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._make-form-index-desc))",[0,[1,"make-form-index-desc"]],["scribble/manual-struct"]],
["make-free-identifier-mapping",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..ss)._make-free-identifier-mapping))",[0,[1,"make-free-identifier-mapping"]],["syntax/boundmap"]],
["make-gc-thread",">web-server/dispatch-stat_ss.html#(def._((lib._web-server/dispatchers/dispatch-stat..ss)._make-gc-thread))",[0,[1,"make-gc-thread"]],["web-server/dispatchers/dispatch-stat"]],
["make-generated-tag",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-generated-tag))",[0,[1,"make-generated-tag"]],["scribble/struct"]],
["make-generic",">reference/ivaraccess.html#(def._((lib._scheme/private/class-internal..ss)._make-generic))",[0,[1,"make-generic"]],["scheme/class","scheme"]],
["make-gl-boolean-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._make-gl-boolean-vector))",[0,[1,"make-gl-boolean-vector"]],["sgl/gl-vectors"]],
["make-gl-byte-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._make-gl-byte-vector))",[0,[1,"make-gl-byte-vector"]],["sgl/gl-vectors"]],
["make-gl-double-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._make-gl-double-vector))",[0,[1,"make-gl-double-vector"]],["sgl/gl-vectors"]],
["make-gl-float-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._make-gl-float-vector))",[0,[1,"make-gl-float-vector"]],["sgl/gl-vectors"]],
["make-gl-int-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._make-gl-int-vector))",[0,[1,"make-gl-int-vector"]],["sgl/gl-vectors"]],
["make-gl-selection-record",">sgl/main.html#(def._((lib._sgl/main..ss)._make-gl-selection-record))",[0,[1,"make-gl-selection-record"]],["sgl"]],
["make-gl-short-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._make-gl-short-vector))",[0,[1,"make-gl-short-vector"]],["sgl/gl-vectors"]],
["make-gl-ubyte-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._make-gl-ubyte-vector))",[0,[1,"make-gl-ubyte-vector"]],["sgl/gl-vectors"]],
["make-gl-uint-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._make-gl-uint-vector))",[0,[1,"make-gl-uint-vector"]],["sgl/gl-vectors"]],
["make-gl-ushort-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._make-gl-ushort-vector))",[0,[1,"make-gl-ushort-vector"]],["sgl/gl-vectors"]],
["make-gui-empty-namespace",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._make-gui-empty-namespace))",[0,[1,"make-gui-empty-namespace"]],["scheme/gui/base","scheme/gui"]],
["make-gui-namespace",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._make-gui-namespace))",[0,[1,"make-gui-namespace"]],["scheme/gui/base","scheme/gui"]],
["make-h1",">html/index.html#(def._((lib._html/main..ss)._make-h1))",[0,[1,"make-h1"]],["html"]],
["make-h2",">html/index.html#(def._((lib._html/main..ss)._make-h2))",[0,[1,"make-h2"]],["html"]],
["make-h3",">html/index.html#(def._((lib._html/main..ss)._make-h3))",[0,[1,"make-h3"]],["html"]],
["make-h4",">html/index.html#(def._((lib._html/main..ss)._make-h4))",[0,[1,"make-h4"]],["html"]],
["make-h5",">html/index.html#(def._((lib._html/main..ss)._make-h5))",[0,[1,"make-h5"]],["html"]],
["make-h6",">html/index.html#(def._((lib._html/main..ss)._make-h6))",[0,[1,"make-h6"]],["html"]],
["make-hash",">reference/hashtables.html#(def._((quote._~23~25kernel)._make-hash))",[0,[1,"make-hash"]],["scheme/base","scheme"]],
["make-hash-placeholder",">reference/pairs.html#(def._((quote._~23~25kernel)._make-hash-placeholder))",[0,[1,"make-hash-placeholder"]],["scheme/base","scheme"]],
["make-hash-table",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..ss)._make-hash-table))",[0,[1,"make-hash-table"]],["mzscheme"]],
["make-hasheq",">reference/hashtables.html#(def._((quote._~23~25kernel)._make-hasheq))",[0,[1,"make-hasheq"]],["scheme/base","scheme"]],
["make-hasheq-placeholder",">reference/pairs.html#(def._((quote._~23~25kernel)._make-hasheq-placeholder))",[0,[1,"make-hasheq-placeholder"]],["scheme/base","scheme"]],
["make-hasheqv",">reference/hashtables.html#(def._((quote._~23~25kernel)._make-hasheqv))",[0,[1,"make-hasheqv"]],["scheme/base","scheme"]],
["make-hashtable",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1182",[0,[1,"make-hashtable"]],["rnrs/hashtables-6"]],
["make-head",">html/index.html#(def._((lib._html/main..ss)._make-head))",[0,[1,"make-head"]],["html"]],
["make-header",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._make-header))",[0,[1,"make-header"]],["web-server/private/request-structs"]],
["make-host",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._make-host))",[0,[1,"make-host"]],["web-server/configuration/configuration-table-structs"]],
["make-host-table",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._make-host-table))",[0,[1,"make-host-table"]],["web-server/configuration/configuration-table-structs"]],
["make-hover-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-hover-element))",[0,[1,"make-hover-element"]],["scribble/struct"]],
["make-hr",">html/index.html#(def._((lib._html/main..ss)._make-hr))",[0,[1,"make-hr"]],["html"]],
["make-html",">html/index.html#(def._((lib._html/main..ss)._make-html))",[0,[1,"make-html"]],["html"]],
["make-html-element",">html/index.html#(def._((lib._html/main..ss)._make-html-element))",[0,[1,"make-html-element"]],["html"]],
["make-html-full",">html/index.html#(def._((lib._html/main..ss)._make-html-full))",[0,[1,"make-html-full"]],["html"]],
["make-i",">html/index.html#(def._((lib._html/main..ss)._make-i))",[0,[1,"make-i"]],["html"]],
["make-i/o-decoding-error",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_602",[0,[1,"make-i/o-decoding-error"]],["rnrs/io/ports-6"]],
["make-i/o-encoding-error",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_608",[0,[1,"make-i/o-encoding-error"]],["rnrs/io/ports-6"]],
["make-i/o-error",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_496",[0,[1,"make-i/o-error"]],["rnrs/io/ports-6"]],
["make-i/o-file-already-exists-error",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_542",[0,[1,"make-i/o-file-already-exists-error"]],["rnrs/io/ports-6"]],
["make-i/o-file-does-not-exist-error",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_548",[0,[1,"make-i/o-file-does-not-exist-error"]],["rnrs/io/ports-6"]],
["make-i/o-file-is-read-only-error",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_536",[0,[1,"make-i/o-file-is-read-only-error"]],["rnrs/io/ports-6"]],
["make-i/o-file-protection-error",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_530",[0,[1,"make-i/o-file-protection-error"]],["rnrs/io/ports-6"]],
["make-i/o-filename-error",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_522",[0,[1,"make-i/o-filename-error"]],["rnrs/io/ports-6"]],
["make-i/o-invalid-position-error",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_514",[0,[1,"make-i/o-invalid-position-error"]],["rnrs/io/ports-6"]],
["make-i/o-port-error",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_554",[0,[1,"make-i/o-port-error"]],["rnrs/io/ports-6"]],
["make-i/o-read-error",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_502",[0,[1,"make-i/o-read-error"]],["rnrs/io/ports-6"]],
["make-i/o-write-error",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_508",[0,[1,"make-i/o-write-error"]],["rnrs/io/ports-6"]],
["make-iframe",">html/index.html#(def._((lib._html/main..ss)._make-iframe))",[0,[1,"make-iframe"]],["html"]],
["make-illegal-message-number",">net/pop3.html#(def._((lib._net/pop3..ss)._make-illegal-message-number))",[0,[1,"make-illegal-message-number"]],["net/pop3"]],
["make-image-file",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-image-file))",[0,[1,"make-image-file"]],["scribble/struct"]],
["make-img",">html/index.html#(def._((lib._html/main..ss)._make-img))",[0,[1,"make-img"]],["html"]],
["make-immutable-custom-hash",">reference/dicts.html#(def._((lib._scheme/dict..ss)._make-immutable-custom-hash))",[0,[1,"make-immutable-custom-hash"]],["scheme/dict","scheme"]],
["make-immutable-hash",">reference/hashtables.html#(def._((quote._~23~25kernel)._make-immutable-hash))",[0,[1,"make-immutable-hash"]],["scheme/base","scheme"]],
["make-immutable-hash-table",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..ss)._make-immutable-hash-table))",[0,[1,"make-immutable-hash-table"]],["mzscheme"]],
["make-immutable-hasheq",">reference/hashtables.html#(def._((quote._~23~25kernel)._make-immutable-hasheq))",[0,[1,"make-immutable-hasheq"]],["scheme/base","scheme"]],
["make-immutable-hasheqv",">reference/hashtables.html#(def._((quote._~23~25kernel)._make-immutable-hasheqv))",[0,[1,"make-immutable-hasheqv"]],["scheme/base","scheme"]],
["make-implementation-restriction-violation",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_468",[0,[1,"make-implementation-restriction-violation"]],["rnrs/conditions-6"]],
["make-import",">reference/stxtrans.html#(def._((lib._scheme/require-transform..ss)._make-import))",[0,[1,"make-import"]],["scheme/require-transform"]],
["make-import-source",">reference/stxtrans.html#(def._((lib._scheme/require-transform..ss)._make-import-source))",[0,[1,"make-import-source"]],["scheme/require-transform"]],
["make-incomplete-%-suffix",">net/cgi.html#(def._((lib._net/cgi..ss)._make-incomplete-~25-suffix))",[0,[1,"make-incomplete-%-suffix"]],["net/cgi"]],
["make-index-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-index-element))",[0,[1,"make-index-element"]],["scribble/struct"]],
["make-info-domain",">setup-plt/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..ss)._setup-option~5e._make-info-domain))",[0,[1,"make-info-domain"]],["setup/option-sig"]],
["make-input",">html/index.html#(def._((lib._html/main..ss)._make-input))",[0,[1,"make-input"]],["html"]],
["make-input-port",">reference/customport.html#(def._((quote._~23~25kernel)._make-input-port))",[0,[1,"make-input-port"]],["scheme/base","scheme"]],
["make-input-port/read-to-peek",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._make-input-port/read-to-peek))",[0,[1,"make-input-port/read-to-peek"]],["scheme/port"]],
["make-ins",">html/index.html#(def._((lib._html/main..ss)._make-ins))",[0,[1,"make-ins"]],["html"]],
["make-inspector",">reference/inspectors.html#(def._((quote._~23~25kernel)._make-inspector))",[0,[1,"make-inspector"]],["scheme/base","scheme"]],
["make-integer-set",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..ss)._make-integer-set))",[0,[1,"make-integer-set"]],["mzlib/integer-set"]],
["make-interface-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._make-interface-index-desc))",[0,[1,"make-interface-index-desc"]],["scribble/manual-struct"]],
["make-invalid-%-suffix",">net/cgi.html#(def._((lib._net/cgi..ss)._make-invalid-~25-suffix))",[0,[1,"make-invalid-%-suffix"]],["net/cgi"]],
["make-irritants-condition",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_446",[0,[1,"make-irritants-condition"]],["rnrs/conditions-6"]],
["make-isindex",">html/index.html#(def._((lib._html/main..ss)._make-isindex))",[0,[1,"make-isindex"]],["html"]],
["make-itemization",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-itemization))",[0,[1,"make-itemization"]],["scribble/struct"]],
["make-kbd",">html/index.html#(def._((lib._html/main..ss)._make-kbd))",[0,[1,"make-kbd"]],["html"]],
["make-keyword-procedure",">reference/procedures.html#(def._((lib._scheme/base..ss)._make-keyword-procedure))",[0,[1,"make-keyword-procedure"]],["scheme/base","scheme"]],
["make-kmp-restart-vector",">srfi-std/srfi-13.html#make-kmp-restart-vector",[0,[1,"make-kmp-restart-vector"]],["srfi/13"]],
["make-known-char-range-list",">reference/characters.html#(def._((quote._~23~25kernel)._make-known-char-range-list))",[0,[1,"make-known-char-range-list"]],["scheme/base","scheme"]],
["make-label",">html/index.html#(def._((lib._html/main..ss)._make-label))",[0,[1,"make-label"]],["html"]],
["make-launchers",">setup-plt/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..ss)._setup-option~5e._make-launchers))",[0,[1,"make-launchers"]],["setup/option-sig"]],
["make-legend",">html/index.html#(def._((lib._html/main..ss)._make-legend))",[0,[1,"make-legend"]],["html"]],
["make-lexical-violation",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_474",[0,[1,"make-lexical-violation"]],["rnrs/conditions-6"]],
["make-li",">html/index.html#(def._((lib._html/main..ss)._make-li))",[0,[1,"make-li"]],["html"]],
["make-limited-input-port",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._make-limited-input-port))",[0,[1,"make-limited-input-port"]],["scheme/port"]],
["make-link-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-link-element))",[0,[1,"make-link-element"]],["scribble/struct"]],
["make-link-style",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-text-mixin)._make-link-style))",[[0,[1,"make-link-style"]],[12,[" (method of ",[0,[1,"hyper-text-mixin"]],")"]]],["browser"]],
["make-link-style",">browser/index.html#(meth._(((lib._browser/htmltext..ss)._html-text~3c~25~3e)._make-link-style))",[[0,[1,"make-link-style"]],[12,[" (method of ",[0,[1,"html-text&lt;%&gt;"]],")"]]],["browser/htmltext"]],
["make-list",">srfi-std/srfi-1.html#make-list",[0,[1,"make-list"]],["srfi/1"]],
["make-location",">xml/index.html#(def._((lib._xml/main..ss)._make-location))",[0,[1,"make-location"]],["xml"]],
["make-log-receiver",">reference/logging.html#(def._((quote._~23~25kernel)._make-log-receiver))",[0,[1,"make-log-receiver"]],["scheme/base","scheme"]],
["make-logger",">reference/logging.html#(def._((quote._~23~25kernel)._make-logger))",[0,[1,"make-logger"]],["scheme/base","scheme"]],
["make-make-servlet-namespace",">web-server/namespace_ss.html#(def._((lib._web-server/configuration/namespace..ss)._make-make-servlet-namespace))",[0,[1,"make-make-servlet-namespace"]],["web-server/configuration/namespace"]],
["make-malformed-multipart-entity",">net/mime.html#(def._((lib._net/mime..ss)._make-malformed-multipart-entity))",[0,[1,"make-malformed-multipart-entity"]],["net/mime"]],
["make-malformed-server-response",">net/pop3.html#(def._((lib._net/pop3..ss)._make-malformed-server-response))",[0,[1,"make-malformed-server-response"]],["net/pop3"]],
["make-manager",">web-server/manager_ss.html#(def._((lib._web-server/managers/manager..ss)._make-manager))",[0,[1,"make-manager"]],["web-server/managers/manager"]],
["make-map",">html/index.html#(def._((lib._html/main..ss)._make-map))",[0,[1,"make-map"]],["html"]],
["make-matrix",">teachpack/matrix.html#(def._((lib._teachpack/htdp/matrix..ss)._make-matrix))",[0,[1,"make-matrix"]],["teachpack/htdp/matrix"]],
["make-menu",">html/index.html#(def._((lib._html/main..ss)._make-menu))",[0,[1,"make-menu"]],["html"]],
["make-message",">net/mime.html#(def._((lib._net/mime..ss)._make-message))",[0,[1,"make-message"]],["net/mime"]],
["make-message",">teachpack/gui.html#(def._((lib._teachpack/htdp/gui..ss)._make-message))",[0,[1,"make-message"]],["teachpack/htdp/gui"]],
["make-message-condition",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_408",[0,[1,"make-message-condition"]],["rnrs/conditions-6"]],
["make-messages",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._make-messages))",[0,[1,"make-messages"]],["web-server/configuration/configuration-table-structs"]],
["make-meta",">html/index.html#(def._((lib._html/main..ss)._make-meta))",[0,[1,"make-meta"]],["html"]],
["make-method-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._make-method-index-desc))",[0,[1,"make-method-index-desc"]],["scribble/manual-struct"]],
["make-mime-error",">net/mime.html#(def._((lib._net/mime..ss)._make-mime-error))",[0,[1,"make-mime-error"]],["net/mime"]],
["make-missing-multipart-boundary-parameter",">net/mime.html#(def._((lib._net/mime..ss)._make-missing-multipart-boundary-parameter))",[0,[1,"make-missing-multipart-boundary-parameter"]],["net/mime"]],
["make-mixin-contract",">reference/Object_and_Class_Contracts.html#(def._((lib._scheme/class..ss)._make-mixin-contract))",[0,[1,"make-mixin-contract"]],["scheme/class","scheme"]],
["make-mixin-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._make-mixin-index-desc))",[0,[1,"make-mixin-index-desc"]],["scribble/manual-struct"]],
["make-module-evaluator",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._make-module-evaluator))",[0,[1,"make-module-evaluator"]],["scheme/sandbox"]],
["make-module-identifier-mapping",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..ss)._make-module-identifier-mapping))",[0,[1,"make-module-identifier-mapping"]],["syntax/boundmap"]],
["make-module-path-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._make-module-path-index-desc))",[0,[1,"make-module-path-index-desc"]],["scribble/manual-struct"]],
["make-mred-launcher",">mzc/launcher.html#(def._((lib._launcher/launcher..ss)._make-mred-launcher))",[0,[1,"make-mred-launcher"]],["launcher/launcher"]],
["make-mred-program-launcher",">mzc/launcher.html#(def._((lib._launcher/launcher..ss)._make-mred-program-launcher))",[0,[1,"make-mred-program-launcher"]],["launcher/launcher"]],
["make-mzscheme-launcher",">mzc/launcher.html#(def._((lib._launcher/launcher..ss)._make-mzscheme-launcher))",[0,[1,"make-mzscheme-launcher"]],["launcher/launcher"]],
["make-mzscheme-program-launcher",">mzc/launcher.html#(def._((lib._launcher/launcher..ss)._make-mzscheme-program-launcher))",[0,[1,"make-mzscheme-program-launcher"]],["launcher/launcher"]],
["make-namespace",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..ss)._make-namespace))",[0,[1,"make-namespace"]],["mzscheme"]],
["make-nntp",">net/nntp.html#(def._((lib._net/nntp..ss)._make-nntp))",[0,[1,"make-nntp"]],["net/nntp"]],
["make-no-group-selected",">net/nntp.html#(def._((lib._net/nntp..ss)._make-no-group-selected))",[0,[1,"make-no-group-selected"]],["net/nntp"]],
["make-no-infinities-violation",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1050",[0,[1,"make-no-infinities-violation"]],["rnrs/arithmetic/flonums-6"]],
["make-no-mail-recipients",">net/sendmail.html#(def._((lib._net/sendmail..ss)._make-no-mail-recipients))",[0,[1,"make-no-mail-recipients"]],["net/sendmail"]],
["make-no-nans-violation",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1056",[0,[1,"make-no-nans-violation"]],["rnrs/arithmetic/flonums-6"]],
["make-noframes",">html/index.html#(def._((lib._html/main..ss)._make-noframes))",[0,[1,"make-noframes"]],["html"]],
["make-non-continuable-violation",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_462",[0,[1,"make-non-continuable-violation"]],["rnrs/conditions-6"]],
["make-non-existent-group",">net/nntp.html#(def._((lib._net/nntp..ss)._make-non-existent-group))",[0,[1,"make-non-existent-group"]],["net/nntp"]],
["make-none/c",">reference/Contract_Utilities.html#(def._((lib._scheme/private/contract-guts..ss)._make-none/c))",[0,[1,"make-none/c"]],["scheme/contract","scheme"]],
["make-noscript",">html/index.html#(def._((lib._html/main..ss)._make-noscript))",[0,[1,"make-noscript"]],["html"]],
["make-not-given-headers",">net/pop3.html#(def._((lib._net/pop3..ss)._make-not-given-headers))",[0,[1,"make-not-given-headers"]],["net/pop3"]],
["make-not-ready-for-transaction",">net/pop3.html#(def._((lib._net/pop3..ss)._make-not-ready-for-transaction))",[0,[1,"make-not-ready-for-transaction"]],["net/pop3"]],
["make-object",">reference/objcreation.html#(def._((lib._scheme/private/class-internal..ss)._make-object))",[0,[1,"make-object"]],["scheme/class","scheme"]],
["make-object",">html/index.html#(def._((lib._html/main..ss)._make-object))",[0,[1,"make-object"]],["html"]],
["make-ol",">html/index.html#(def._((lib._html/main..ss)._make-ol))",[0,[1,"make-ol"]],["html"]],
["make-omitable-paragraph",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-omitable-paragraph))",[0,[1,"make-omitable-paragraph"]],["scribble/struct"]],
["make-optgroup",">html/index.html#(def._((lib._html/main..ss)._make-optgroup))",[0,[1,"make-optgroup"]],["html"]],
["make-option",">html/index.html#(def._((lib._html/main..ss)._make-option))",[0,[1,"make-option"]],["html"]],
["make-outline",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..ss)._make-outline))",[0,[1,"make-outline"]],["slideshow/base","slideshow"]],
["make-output-port",">reference/customport.html#(def._((quote._~23~25kernel)._make-output-port))",[0,[1,"make-output-port"]],["scheme/base","scheme"]],
["make-p",">html/index.html#(def._((lib._html/main..ss)._make-p))",[0,[1,"make-p"]],["html"]],
["make-p-i",">xml/index.html#(def._((lib._xml/main..ss)._make-p-i))",[0,[1,"make-p-i"]],["xml"]],
["make-paragraph",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-paragraph))",[0,[1,"make-paragraph"]],["scribble/struct"]],
["make-param",">html/index.html#(def._((lib._html/main..ss)._make-param))",[0,[1,"make-param"]],["html"]],
["make-parameter",">reference/parameters.html#(def._((quote._~23~25kernel)._make-parameter))",[0,[1,"make-parameter"]],["scheme/base","scheme"]],
["make-parameter",">srfi-std/srfi-39.html#make-parameter",[0,[1,"make-parameter"]],["srfi/39"]],
["make-parameter-rename-transformer",">reference/stxparam.html#(def._((lib._scheme/stxparam-exptime..ss)._make-parameter-rename-transformer))",[0,[1,"make-parameter-rename-transformer"]],["scheme/stxparam-exptime","scheme/stxparam"]],
["make-part",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-part))",[0,[1,"make-part"]],["scribble/struct"]],
["make-part-collect-decl",">scribble/decode.html#(def._((lib._scribble/decode..ss)._make-part-collect-decl))",[0,[1,"make-part-collect-decl"]],["scribble/decode"]],
["make-part-index-decl",">scribble/decode.html#(def._((lib._scribble/decode..ss)._make-part-index-decl))",[0,[1,"make-part-index-decl"]],["scribble/decode"]],
["make-part-relative-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-part-relative-element))",[0,[1,"make-part-relative-element"]],["scribble/struct"]],
["make-part-start",">scribble/decode.html#(def._((lib._scribble/decode..ss)._make-part-start))",[0,[1,"make-part-start"]],["scribble/decode"]],
["make-part-tag-decl",">scribble/decode.html#(def._((lib._scribble/decode..ss)._make-part-tag-decl))",[0,[1,"make-part-tag-decl"]],["scribble/decode"]],
["make-password-rejected",">net/pop3.html#(def._((lib._net/pop3..ss)._make-password-rejected))",[0,[1,"make-password-rejected"]],["net/pop3"]],
["make-path->mime-type",">web-server/mime-types_ss.html#(def._((lib._web-server/private/mime-types..ss)._make-path-~3emime-type))",[0,[1,"make-path-&gt;mime-type"]],["web-server/private/mime-types"]],
["make-path/param",">net/url.html#(def._((lib._net/url-structs..ss)._make-path/param))",[0,[1,"make-path/param"]],["net/url-structs","net/url"]],
["make-paths",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._make-paths))",[0,[1,"make-paths"]],["web-server/configuration/configuration-table-structs"]],
["make-pcdata",">xml/index.html#(def._((lib._xml/main..ss)._make-pcdata))",[0,[1,"make-pcdata"]],["xml"]],
["make-pict",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..ss)._make-pict))",[0,[1,"make-pict"]],["slideshow/pict","slideshow"]],
["make-pict-drawer",">slideshow/Rendering.html#(def._((lib._slideshow/pict..ss)._make-pict-drawer))",[0,[1,"make-pict-drawer"]],["slideshow/pict","slideshow"]],
["make-pipe",">reference/pipeports.html#(def._((quote._~23~25kernel)._make-pipe))",[0,[1,"make-pipe"]],["scheme/base","scheme"]],
["make-pipe-with-specials",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._make-pipe-with-specials))",[0,[1,"make-pipe-with-specials"]],["scheme/port"]],
["make-placeholder",">reference/pairs.html#(def._((quote._~23~25kernel)._make-placeholder))",[0,[1,"make-placeholder"]],["scheme/base","scheme"]],
["make-planet-archive",">planet/Utility_Libraries.html#(def._((lib._planet/util..ss)._make-planet-archive))",[0,[1,"make-planet-archive"]],["planet/util"]],
["make-plot-setup",">mrlib/Plot.html#(def._((lib._mrlib/plot..ss)._make-plot-setup))",[0,[1,"make-plot-setup"]],["mrlib/plot"]],
["make-polar",">reference/numbers.html#(def._((quote._~23~25kernel)._make-polar))",[0,[1,"make-polar"]],["scheme/base","scheme"]],
["make-polar",">r5rs-std/r5rs-Z-H-9.html#%_idx_350",[0,[1,"make-polar"]],["r5rs"]],
["make-polar",">r6rs-std/r6rs-Z-H-14.html#node_idx_568",[0,[1,"make-polar"]],["rnrs/base-6"]],
["make-polar",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._make-polar))",[0,[1,"make-polar"]],["lang/htdp-advanced"]],
["make-polar",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._make-polar))",[0,[1,"make-polar"]],["lang/htdp-beginner"]],
["make-polar",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._make-polar))",[0,[1,"make-polar"]],["lang/htdp-beginner-abbr"]],
["make-polar",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._make-polar))",[0,[1,"make-polar"]],["lang/htdp-intermediate"]],
["make-polar",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._make-polar))",[0,[1,"make-polar"]],["lang/htdp-intermediate-lambda"]],
["make-pop3",">net/pop3.html#(def._((lib._net/pop3..ss)._make-pop3))",[0,[1,"make-pop3"]],["net/pop3"]],
["make-position",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..ss)._make-position))",[0,[1,"make-position"]],["parser-tools/lex"]],
["make-position-token",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..ss)._make-position-token))",[0,[1,"make-position-token"]],["parser-tools/lex"]],
["make-posn",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._make-posn))",[0,[1,"make-posn"]],["lang/htdp-advanced"]],
["make-posn",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._make-posn))",[0,[1,"make-posn"]],["lang/htdp-beginner"]],
["make-posn",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._make-posn))",[0,[1,"make-posn"]],["lang/htdp-beginner-abbr"]],
["make-posn",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._make-posn))",[0,[1,"make-posn"]],["lang/htdp-intermediate"]],
["make-posn",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._make-posn))",[0,[1,"make-posn"]],["lang/htdp-intermediate-lambda"]],
["make-posn",">htdp-lib/index.html#(def._((lib._lang/posn..ss)._make-posn))",[0,[1,"make-posn"]],["lang/posn"]],
["make-posn",">graphics/posn.html#(def._((lib._graphics/graphics..ss)._make-posn))",[0,[1,"make-posn"]],["graphics/graphics"]],
["make-post",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/dummy-10..ss)._make-post))",[0,[1,"make-post"]],[]],
["make-post",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-1..ss)._make-post))",[0,[1,"make-post"]],[]],
["make-post",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-5..ss)._make-post))",[0,[1,"make-post"]],[]],
["make-pre",">html/index.html#(def._((lib._html/main..ss)._make-pre))",[0,[1,"make-pre"]],["html"]],
["make-prefab-struct",">reference/structutils.html#(def._((quote._~23~25kernel)._make-prefab-struct))",[0,[1,"make-prefab-struct"]],["scheme/base","scheme"]],
["make-premature-close",">net/nntp.html#(def._((lib._net/nntp..ss)._make-premature-close))",[0,[1,"make-premature-close"]],["net/nntp"]],
["make-print-checking",">make/make.html#(def._((lib._make/main..ss)._make-print-checking))",[0,[1,"make-print-checking"]],["make"]],
["make-print-dep-no-line",">make/make.html#(def._((lib._make/main..ss)._make-print-dep-no-line))",[0,[1,"make-print-dep-no-line"]],["make"]],
["make-print-reasons",">make/make.html#(def._((lib._make/main..ss)._make-print-reasons))",[0,[1,"make-print-reasons"]],["make"]],
["make-procedure-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._make-procedure-index-desc))",[0,[1,"make-procedure-index-desc"]],["scribble/manual-struct"]],
["make-proj-contract",">reference/Building_New_Contract_Combinators.html#(def._((lib._scheme/private/contract-guts..ss)._make-proj-contract))",[0,[1,"make-proj-contract"]],["scheme/contract","scheme"]],
["make-prolog",">xml/index.html#(def._((lib._xml/main..ss)._make-prolog))",[0,[1,"make-prolog"]],["xml"]],
["make-provide-transformer",">reference/stxtrans.html#(def._((lib._scheme/provide-transform..ss)._make-provide-transformer))",[0,[1,"make-provide-transformer"]],["scheme/provide-transform"]],
["make-pseudo-random-generator",">reference/numbers.html#(def._((quote._~23~25kernel)._make-pseudo-random-generator))",[0,[1,"make-pseudo-random-generator"]],["scheme/base","scheme"]],
["make-q",">html/index.html#(def._((lib._html/main..ss)._make-q))",[0,[1,"make-q"]],["html"]],
["make-qp-error",">net/qp.html#(def._((lib._net/qp..ss)._make-qp-error))",[0,[1,"make-qp-error"]],["net/qp"]],
["make-qp-wrong-input",">net/qp.html#(def._((lib._net/qp..ss)._make-qp-wrong-input))",[0,[1,"make-qp-wrong-input"]],["net/qp"]],
["make-qp-wrong-line-size",">net/qp.html#(def._((lib._net/qp..ss)._make-qp-wrong-line-size))",[0,[1,"make-qp-wrong-line-size"]],["net/qp"]],
["make-random-source",">srfi-std/srfi-27.html#make-random-source",[0,[1,"make-random-source"]],["srfi/27"]],
["make-range",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..ss)._make-range))",[0,[1,"make-range"]],["mzlib/integer-set"]],
["make-reader-graph",">reference/pairs.html#(def._((quote._~23~25kernel)._make-reader-graph))",[0,[1,"make-reader-graph"]],["scheme/base","scheme"]],
["make-readtable",">reference/readtables.html#(def._((quote._~23~25kernel)._make-readtable))",[0,[1,"make-readtable"]],["scheme/base","scheme"]],
["make-record-constructor-descriptor",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_322",[0,[1,"make-record-constructor-descriptor"]],["rnrs/records/procedural-6"]],
["make-record-type-descriptor",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_314",[0,[1,"make-record-type-descriptor"]],["rnrs/records/procedural-6"]],
["make-rectangular",">reference/numbers.html#(def._((quote._~23~25kernel)._make-rectangular))",[0,[1,"make-rectangular"]],["scheme/base","scheme"]],
["make-rectangular",">r5rs-std/r5rs-Z-H-9.html#%_idx_348",[0,[1,"make-rectangular"]],["r5rs"]],
["make-rectangular",">r6rs-std/r6rs-Z-H-14.html#node_idx_566",[0,[1,"make-rectangular"]],["rnrs/base-6"]],
["make-region",">cards/index.html#(def._((lib._games/cards..ss)._make-region))",[0,[1,"make-region"]],["games/cards"]],
["make-rename-transformer",">reference/stxtrans.html#(def._((quote._~23~25kernel)._make-rename-transformer))",[0,[1,"make-rename-transformer"]],["scheme/base","scheme"]],
["make-render-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-render-element))",[0,[1,"make-render-element"]],["scribble/struct"]],
["make-request",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._make-request))",[0,[1,"make-request"]],["web-server/private/request-structs"]],
["make-require-transformer",">reference/stxtrans.html#(def._((lib._scheme/require-transform..ss)._make-require-transformer))",[0,[1,"make-require-transformer"]],["scheme/require-transform"]],
["make-resolve-info",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-resolve-info))",[0,[1,"make-resolve-info"]],["scribble/struct"]],
["make-resolved-module-path",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._make-resolved-module-path))",[0,[1,"make-resolved-module-path"]],["scheme/base","scheme"]],
["make-responders",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._make-responders))",[0,[1,"make-responders"]],["web-server/configuration/configuration-table-structs"]],
["make-response/basic",">web-server/response-structs_ss.html#(def._((lib._web-server/private/response-structs..ss)._make-response/basic))",[0,[1,"make-response/basic"]],["web-server/private/response-structs"]],
["make-response/full",">web-server/response-structs_ss.html#(def._((lib._web-server/private/response-structs..ss)._make-response/full))",[0,[1,"make-response/full"]],["web-server/private/response-structs"]],
["make-response/incremental",">web-server/response-structs_ss.html#(def._((lib._web-server/private/response-structs..ss)._make-response/incremental))",[0,[1,"make-response/incremental"]],["web-server/private/response-structs"]],
["make-rgb",">graphics/Color_Operations.html#(def._((lib._graphics/graphics..ss)._make-rgb))",[0,[1,"make-rgb"]],["graphics/graphics"]],
["make-root-area-container",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3abasic~3c~25~3e)._make-root-area-container))",[[0,[1,"make-root-area-container"]],[12,[" (method of ",[0,[1,"frame:basic&lt;%&gt;"]],")"]]],["framework"]],
["make-root-area-container",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3adelegate-mixin)._make-root-area-container))",[[0,[1,"make-root-area-container"]],[12,[" (method of ",[0,[1,"frame:delegate-mixin"]],")"]]],["framework"]],
["make-root-area-container",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3ainfo-mixin)._make-root-area-container))",[[0,[1,"make-root-area-container"]],[12,[" (method of ",[0,[1,"frame:info-mixin"]],")"]]],["framework"]],
["make-root-area-container",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable-mixin)._make-root-area-container))",[[0,[1,"make-root-area-container"]],[12,[" (method of ",[0,[1,"frame:searchable-mixin"]],")"]]],["framework"]],
["make-root-area-container",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astatus-line-mixin)._make-root-area-container))",[[0,[1,"make-root-area-container"]],[12,[" (method of ",[0,[1,"frame:status-line-mixin"]],")"]]],["framework"]],
["make-s",">html/index.html#(def._((lib._html/main..ss)._make-s))",[0,[1,"make-s"]],["html"]],
["make-s16vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._make-s16vector))",[0,[1,"make-s16vector"]],["scheme/foreign"]],
["make-s32vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._make-s32vector))",[0,[1,"make-s32vector"]],["scheme/foreign"]],
["make-s64vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._make-s64vector))",[0,[1,"make-s64vector"]],["scheme/foreign"]],
["make-s8vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._make-s8vector))",[0,[1,"make-s8vector"]],["scheme/foreign"]],
["make-samp",">html/index.html#(def._((lib._html/main..ss)._make-samp))",[0,[1,"make-samp"]],["html"]],
["make-script",">html/index.html#(def._((lib._html/main..ss)._make-script))",[0,[1,"make-script"]],["html"]],
["make-script-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-script-element))",[0,[1,"make-script-element"]],["scribble/struct"]],
["make-searchable",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._make-searchable))",[[0,[1,"make-searchable"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["make-security-guard",">reference/securityguards.html#(def._((quote._~23~25kernel)._make-security-guard))",[0,[1,"make-security-guard"]],["scheme/base","scheme"]],
["make-select",">html/index.html#(def._((lib._html/main..ss)._make-select))",[0,[1,"make-select"]],["html"]],
["make-semaphore",">reference/semaphore.html#(def._((quote._~23~25kernel)._make-semaphore))",[0,[1,"make-semaphore"]],["scheme/base","scheme"]],
["make-serialize-info",">reference/serialization.html#(def._((lib._scheme/private/serialize..ss)._make-serialize-info))",[0,[1,"make-serialize-info"]],["scheme/serialize"]],
["make-serious-condition",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_422",[0,[1,"make-serious-condition"]],["rnrs/conditions-6"]],
["make-servlet-namespace",">web-server/web-config-unit_ss.html#(sig-val._((lib._web-server/web-config-sig..ss)._web-config~5e._make-servlet-namespace))",[0,[1,"make-servlet-namespace"]],["web-server/web-config-sig"]],
["make-servlet-namespace/c",">web-server/namespace_ss.html#(def._((lib._web-server/configuration/namespace..ss)._make-servlet-namespace/c))",[0,[1,"make-servlet-namespace/c"]],["web-server/configuration/namespace"]],
["make-set!-transformer",">reference/stxtrans.html#(def._((quote._~23~25kernel)._make-set!-transformer))",[0,[1,"make-set!-transformer"]],["scheme/base","scheme"]],
["make-sibling-inspector",">reference/inspectors.html#(def._((quote._~23~25kernel)._make-sibling-inspector))",[0,[1,"make-sibling-inspector"]],["scheme/base","scheme"]],
["make-sized-byte-string",">foreign/foreign_pointer-funcs.html#(def._((lib._scribblings/foreign/unsafe-foreign..ss)._make-sized-byte-string))",[0,[1,"make-sized-byte-string"]],["scribblings/foreign/unsafe-foreign"]],
["make-slide-inset",">slideshow/Configuration.html#(def._((lib._slideshow/base..ss)._make-slide-inset))",[0,[1,"make-slide-inset"]],["slideshow/base","slideshow"]],
["make-small",">html/index.html#(def._((lib._html/main..ss)._make-small))",[0,[1,"make-small"]],["html"]],
["make-snip",">framework/Comment_Box.html#(meth._(((lib._framework/main..ss)._comment-box~3asnip~25)._make-snip))",[[0,[1,"make-snip"]],[12,[" (method of ",[0,[1,"comment-box:snip%"]],")"]]],["framework"]],
["make-snip",">framework/editor-snip.html#(meth._(((lib._framework/main..ss)._editor-snip~3adecorated~25)._make-snip))",[[0,[1,"make-snip"]],[12,[" (method of ",[0,[1,"editor-snip:decorated%"]],")"]]],["framework"]],
["make-snip",">framework/editor-snip.html#(meth._(((lib._framework/main..ss)._editor-snip~3adecorated-snipclass~25)._make-snip))",["make-snip",[12,[" (method of ",[0,[1,"editor-snip:decorated-snipclass%"]],")"]]],["framework"]],
["make-so",">setup-plt/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..ss)._setup-option~5e._make-so))",[0,[1,"make-so"]],["setup/option-sig"]],
["make-source",">xml/index.html#(def._((lib._xml/main..ss)._make-source))",[0,[1,"make-source"]],["xml"]],
["make-span",">html/index.html#(def._((lib._html/main..ss)._make-span))",[0,[1,"make-span"]],["html"]],
["make-special-comment",">reference/special-comments.html#(def._((quote._~23~25kernel)._make-special-comment))",[0,[1,"make-special-comment"]],["scheme/base","scheme"]],
["make-splice",">scribble/decode.html#(def._((lib._scribble/decode..ss)._make-splice))",[0,[1,"make-splice"]],["scribble/decode"]],
["make-srcloc",">reference/exns.html#(def._((quote._~23~25kernel)._make-srcloc))",[0,[1,"make-srcloc"]],["scheme/base","scheme"]],
["make-ssl-tcp@",">net/ssl-tcp-unit.html#(def._((lib._net/ssl-tcp-unit..ss)._make-ssl-tcp~40))",[0,[1,"make-ssl-tcp@"]],["net/ssl-tcp-unit"]],
["make-st-mark",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..ss)._stacktrace~5e._make-st-mark))",[0,[1,"make-st-mark"]],["errortrace/stacktrace"]],
["make-strike",">html/index.html#(def._((lib._html/main..ss)._make-strike))",[0,[1,"make-strike"]],["html"]],
["make-string",">reference/strings.html#(def._((quote._~23~25kernel)._make-string))",[0,[1,"make-string"]],["scheme/base","scheme"]],
["make-string",">r5rs-std/r5rs-Z-H-9.html#%_idx_512",[0,[1,"make-string"]],["r5rs"]],
["make-string",">r6rs-std/r6rs-Z-H-14.html#node_idx_688",[0,[1,"make-string"]],["rnrs/base-6"]],
["make-string",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._make-string))",[0,[1,"make-string"]],["lang/htdp-advanced"]],
["make-string",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._make-string))",[0,[1,"make-string"]],["lang/htdp-beginner"]],
["make-string",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._make-string))",[0,[1,"make-string"]],["lang/htdp-beginner-abbr"]],
["make-string",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._make-string))",[0,[1,"make-string"]],["lang/htdp-intermediate"]],
["make-string",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._make-string))",[0,[1,"make-string"]],["lang/htdp-intermediate-lambda"]],
["make-string",">srfi-std/srfi-13.html#make-string",[0,[1,"make-string"]],["srfi/13"]],
["make-strong",">html/index.html#(def._((lib._html/main..ss)._make-strong))",[0,[1,"make-strong"]],["html"]],
["make-struct-field-accessor",">reference/creatingmorestructs.html#(def._((quote._~23~25kernel)._make-struct-field-accessor))",[0,[1,"make-struct-field-accessor"]],["scheme/base","scheme"]],
["make-struct-field-mutator",">reference/creatingmorestructs.html#(def._((quote._~23~25kernel)._make-struct-field-mutator))",[0,[1,"make-struct-field-mutator"]],["scheme/base","scheme"]],
["make-struct-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._make-struct-index-desc))",[0,[1,"make-struct-index-desc"]],["scribble/manual-struct"]],
["make-struct-info",">reference/structinfo.html#(def._((lib._scheme/struct-info..ss)._make-struct-info))",[0,[1,"make-struct-info"]],["scheme/struct-info"]],
["make-struct-type",">reference/creatingmorestructs.html#(def._((quote._~23~25kernel)._make-struct-type))",[0,[1,"make-struct-type"]],["scheme/base","scheme"]],
["make-struct-type",">lazy/index.html#(def._((lib._lazy/main..ss)._make-struct-type))",[0,[1,"make-struct-type"]],["lazy"]],
["make-struct-type-property",">reference/structprops.html#(def._((quote._~23~25kernel)._make-struct-type-property))",[0,[1,"make-struct-type-property"]],["scheme/base","scheme"]],
["make-style",">html/index.html#(def._((lib._html/main..ss)._make-style))",[0,[1,"make-style"]],["html"]],
["make-styled-paragraph",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-styled-paragraph))",[0,[1,"make-styled-paragraph"]],["scribble/struct"]],
["make-sub",">html/index.html#(def._((lib._html/main..ss)._make-sub))",[0,[1,"make-sub"]],["html"]],
["make-sup",">html/index.html#(def._((lib._html/main..ss)._make-sup))",[0,[1,"make-sup"]],["html"]],
["make-syntax-delta-introducer",">reference/stxtrans.html#(def._((quote._~23~25kernel)._make-syntax-delta-introducer))",[0,[1,"make-syntax-delta-introducer"]],["scheme/base","scheme"]],
["make-syntax-introducer",">reference/stxtrans.html#(def._((quote._~23~25kernel)._make-syntax-introducer))",[0,[1,"make-syntax-introducer"]],["scheme/base","scheme"]],
["make-syntax-violation",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_480",[0,[1,"make-syntax-violation"]],["rnrs/conditions-6"]],
["make-table",">cards/index.html#(def._((lib._games/cards..ss)._make-table))",[0,[1,"make-table"]],["games/cards"]],
["make-table",">html/index.html#(def._((lib._html/main..ss)._make-table))",[0,[1,"make-table"]],["html"]],
["make-table",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-table))",[0,[1,"make-table"]],["scribble/struct"]],
["make-target-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-target-element))",[0,[1,"make-target-element"]],["scribble/struct"]],
["make-target-url",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-target-url))",[0,[1,"make-target-url"]],["scribble/struct"]],
["make-tbody",">html/index.html#(def._((lib._html/main..ss)._make-tbody))",[0,[1,"make-tbody"]],["html"]],
["make-td",">html/index.html#(def._((lib._html/main..ss)._make-td))",[0,[1,"make-td"]],["html"]],
["make-temporary-file",">reference/Filesystem.html#(def._((lib._scheme/file..ss)._make-temporary-file))",[0,[1,"make-temporary-file"]],["scheme/file","scheme"]],
["make-tentative-pretty-print-output-port",">reference/pretty-print.html#(def._((lib._scheme/pretty..ss)._make-tentative-pretty-print-output-port))",[0,[1,"make-tentative-pretty-print-output-port"]],["scheme/pretty","scheme"]],
["make-text",">teachpack/gui.html#(def._((lib._teachpack/htdp/gui..ss)._make-text))",[0,[1,"make-text"]],["teachpack/htdp/gui"]],
["make-textarea",">html/index.html#(def._((lib._html/main..ss)._make-textarea))",[0,[1,"make-textarea"]],["html"]],
["make-tfoot",">html/index.html#(def._((lib._html/main..ss)._make-tfoot))",[0,[1,"make-tfoot"]],["html"]],
["make-th",">html/index.html#(def._((lib._html/main..ss)._make-th))",[0,[1,"make-th"]],["html"]],
["make-thead",">html/index.html#(def._((lib._html/main..ss)._make-thead))",[0,[1,"make-thead"]],["html"]],
["make-thing-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._make-thing-index-desc))",[0,[1,"make-thing-index-desc"]],["scribble/manual-struct"]],
["make-thread-cell",">reference/threadcells.html#(def._((quote._~23~25kernel)._make-thread-cell))",[0,[1,"make-thread-cell"]],["scheme/base","scheme"]],
["make-thread-group",">reference/threadgroups.html#(def._((quote._~23~25kernel)._make-thread-group))",[0,[1,"make-thread-group"]],["scheme/base","scheme"]],
["make-threshold-lru-manager",">web-server/lru_ss.html#(def._((lib._web-server/managers/lru..ss)._make-threshold-.L.R.U-manager))",[0,[1,"make-threshold-LRU-manager"]],["web-server/managers/lru"]],
["make-time",">srfi-std/srfi-19.html#make-time",[0,[1,"make-time"]],["srfi/19"]],
["make-timeouts",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._make-timeouts))",[0,[1,"make-timeouts"]],["web-server/configuration/configuration-table-structs"]],
["make-timer",">web-server/timer_ss.html#(def._((lib._web-server/private/timer..ss)._make-timer))",[0,[1,"make-timer"]],["web-server/private/timer"]],
["make-title",">html/index.html#(def._((lib._html/main..ss)._make-title))",[0,[1,"make-title"]],["html"]],
["make-title-decl",">scribble/decode.html#(def._((lib._scribble/decode..ss)._make-title-decl))",[0,[1,"make-title-decl"]],["scribble/decode"]],
["make-toc-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-toc-element))",[0,[1,"make-toc-element"]],["scribble/struct"]],
["make-toc-target-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-toc-target-element))",[0,[1,"make-toc-target-element"]],["scribble/struct"]],
["make-tr",">html/index.html#(def._((lib._html/main..ss)._make-tr))",[0,[1,"make-tr"]],["html"]],
["make-transcoder",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_616",[0,[1,"make-transcoder"]],["rnrs/io/ports-6"]],
["make-tt",">html/index.html#(def._((lib._html/main..ss)._make-tt))",[0,[1,"make-tt"]],["html"]],
["make-u",">html/index.html#(def._((lib._html/main..ss)._make-u))",[0,[1,"make-u"]],["html"]],
["make-u16vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._make-u16vector))",[0,[1,"make-u16vector"]],["scheme/foreign"]],
["make-u32vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._make-u32vector))",[0,[1,"make-u32vector"]],["scheme/foreign"]],
["make-u64vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._make-u64vector))",[0,[1,"make-u64vector"]],["scheme/foreign"]],
["make-u8vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._make-u8vector))",[0,[1,"make-u8vector"]],["scheme/foreign"]],
["make-ul",">html/index.html#(def._((lib._html/main..ss)._make-ul))",[0,[1,"make-ul"]],["html"]],
["make-undefined-violation",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_490",[0,[1,"make-undefined-violation"]],["rnrs/conditions-6"]],
["make-unexpected-response",">net/nntp.html#(def._((lib._net/nntp..ss)._make-unexpected-response))",[0,[1,"make-unexpected-response"]],["net/nntp"]],
["make-unexpected-termination",">net/mime.html#(def._((lib._net/mime..ss)._make-unexpected-termination))",[0,[1,"make-unexpected-termination"]],["net/mime"]],
["make-unnumbered-part",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-unnumbered-part))",[0,[1,"make-unnumbered-part"]],["scribble/struct"]],
["make-url",">net/url.html#(def._((lib._net/url-structs..ss)._make-url))",[0,[1,"make-url"]],["net/url-structs","net/url"]],
["make-url->path",">web-server/filesystem-map_ss.html#(def._((lib._web-server/dispatchers/filesystem-map..ss)._make-url-~3epath))",[0,[1,"make-url-&gt;path"]],["web-server/dispatchers/filesystem-map"]],
["make-url->valid-path",">web-server/filesystem-map_ss.html#(def._((lib._web-server/dispatchers/filesystem-map..ss)._make-url-~3evalid-path))",[0,[1,"make-url-&gt;valid-path"]],["web-server/dispatchers/filesystem-map"]],
["make-username-rejected",">net/pop3.html#(def._((lib._net/pop3..ss)._make-username-rejected))",[0,[1,"make-username-rejected"]],["net/pop3"]],
["make-var",">html/index.html#(def._((lib._html/main..ss)._make-var))",[0,[1,"make-var"]],["html"]],
["make-variable-transformer",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1120",[0,[1,"make-variable-transformer"]],["rnrs/syntax-case-6"]],
["make-vec",">plot/plot.html#(def._((lib._plot/main..ss)._make-vec))",[0,[1,"make-vec"]],["plot"]],
["make-vector",">reference/vectors.html#(def._((quote._~23~25kernel)._make-vector))",[0,[1,"make-vector"]],["scheme/base","scheme"]],
["make-vector",">r5rs-std/r5rs-Z-H-9.html#%_idx_560",[0,[1,"make-vector"]],["r5rs"]],
["make-vector",">r6rs-std/r6rs-Z-H-14.html#node_idx_724",[0,[1,"make-vector"]],["rnrs/base-6"]],
["make-vector",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._make-vector))",[0,[1,"make-vector"]],["lang/htdp-advanced"]],
["make-vector",">srfi-std/srfi-43.html#make-vector",[0,[1,"make-vector"]],["srfi/43"]],
["make-verbose",">setup-plt/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..ss)._setup-option~5e._make-verbose))",[0,[1,"make-verbose"]],["setup/option-sig"]],
["make-versioned-part",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-versioned-part))",[0,[1,"make-versioned-part"]],["scribble/struct"]],
["make-vicinity",">srfi-std/srfi-59.html#make-vicinity",[0,[1,"make-vicinity"]],["srfi/59"]],
["make-violation",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_434",[0,[1,"make-violation"]],["rnrs/conditions-6"]],
["make-visible",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3abasic~3c~25~3e)._make-visible))",[[0,[1,"make-visible"]],[12,[" (method of ",[0,[1,"frame:basic&lt;%&gt;"]],")"]]],["framework"]],
["make-warning",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_416",[0,[1,"make-warning"]],["rnrs/conditions-6"]],
["make-weak-box",">reference/weakbox.html#(def._((quote._~23~25kernel)._make-weak-box))",[0,[1,"make-weak-box"]],["scheme/base","scheme"]],
["make-weak-custom-hash",">reference/dicts.html#(def._((lib._scheme/dict..ss)._make-weak-custom-hash))",[0,[1,"make-weak-custom-hash"]],["scheme/dict","scheme"]],
["make-weak-hash",">reference/hashtables.html#(def._((quote._~23~25kernel)._make-weak-hash))",[0,[1,"make-weak-hash"]],["scheme/base","scheme"]],
["make-weak-hasheq",">reference/hashtables.html#(def._((quote._~23~25kernel)._make-weak-hasheq))",[0,[1,"make-weak-hasheq"]],["scheme/base","scheme"]],
["make-weak-hasheqv",">reference/hashtables.html#(def._((quote._~23~25kernel)._make-weak-hasheqv))",[0,[1,"make-weak-hasheqv"]],["scheme/base","scheme"]],
["make-web-cell",">web-server/lang_web-cells_ss.html#(form._((lib._web-server/lang/web-cells..ss)._make-web-cell))",[0,[6,"make-web-cell"]],["web-server/lang/web-cells"]],
["make-web-cell",">web-server/web-cells_ss.html#(def._((lib._web-server/servlet/web-cells..ss)._make-web-cell))",[0,[1,"make-web-cell"]],["web-server/servlet/web-cells"]],
["make-web-parameter",">web-server/lang_web-param_ss.html#(form._((lib._web-server/lang/web-param..ss)._make-web-parameter))",[0,[6,"make-web-parameter"]],["web-server/lang/web-param"]],
["make-who-condition",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_454",[0,[1,"make-who-condition"]],["rnrs/conditions-6"]],
["make-will-executor",">reference/willexecutor.html#(def._((quote._~23~25kernel)._make-will-executor))",[0,[1,"make-will-executor"]],["scheme/base","scheme"]],
["make-with-attributes",">scribble/struct.html#(def._((lib._scribble/struct..ss)._make-with-attributes))",[0,[1,"make-with-attributes"]],["scribble/struct"]],
["make-zo",">setup-plt/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..ss)._setup-option~5e._make-zo))",[0,[1,"make-zo"]],["setup/option-sig"]],
["make/collection",">make/collection.html",[14,[0,"make/collection"]],"module"],
["make/collection-sig",">make/collection.html#(mod-path._make/collection-sig)",[14,[0,"make/collection-sig"]],"module"],
["make/collection-unit",">make/collection.html#(mod-path._make/collection-unit)",[14,[0,"make/collection-unit"]],"module"],
["make/make-sig",">make/make.html#(mod-path._make/make-sig)",[14,[0,"make/make-sig"]],"module"],
["make/make-unit",">make/make.html#(mod-path._make/make-unit)",[14,[0,"make/make-unit"]],"module"],
["make/proc",">make/make.html#(def._((lib._make/main..ss)._make/proc))",[0,[1,"make/proc"]],["make"]],
["make/setup-extension",">make/setup-extension.html",[14,[0,"make/setup-extension"]],"module"],
["make: dependency manager",">make/index.html","<b>Make</b>: Dependency Manager",false],
["make:collection@",">make/collection.html#(def._((lib._make/collection-unit..ss)._make~3acollection~40))",[0,[1,"make:collection@"]],["make/collection-unit"]],
["make:collection^",">make/collection.html#(form._((lib._make/collection-sig..ss)._make~3acollection~5e))",[0,[6,"make:collection^"]],["make/collection-sig"]],
["make@",">make/make.html#(def._((lib._make/make-unit..ss)._make~40))",[0,[1,"make@"]],["make/make-unit"]],
["make^",">make/make.html#(form._((lib._make/make-sig..ss)._make~5e))",[0,[6,"make^"]],["make/make-sig"]],
["making \".plt\" archives",">setup-plt/_plt-archives.html#(part._making-..plt-archives)",["Making ",[5,"\".plt\""]," Archives"],false],
["making collections",">make/collection.html","Making Collections",false],
["making pictures",">slideshow/Making_Pictures.html","Making Pictures",false],
["making slides",">slideshow/Making_Slides.html","Making Slides",false],
["malformed-multipart-entity",">net/mime.html#(def._((lib._net/mime..ss)._malformed-multipart-entity))",[0,[1,"malformed-multipart-entity"]],["net/mime"]],
["malformed-multipart-entity-msg",">net/mime.html#(def._((lib._net/mime..ss)._malformed-multipart-entity-msg))",[0,[1,"malformed-multipart-entity-msg"]],["net/mime"]],
["malformed-multipart-entity?",">net/mime.html#(def._((lib._net/mime..ss)._malformed-multipart-entity~3f))",[0,[1,"malformed-multipart-entity?"]],["net/mime"]],
["malformed-server-response",">net/pop3.html#(def._((lib._net/pop3..ss)._malformed-server-response))",[0,[1,"malformed-server-response"]],["net/pop3"]],
["malformed-server-response-communicator",">net/pop3.html#(def._((lib._net/pop3..ss)._malformed-server-response-communicator))",[0,[1,"malformed-server-response-communicator"]],["net/pop3"]],
["malformed-server-response?",">net/pop3.html#(def._((lib._net/pop3..ss)._malformed-server-response~3f))",[0,[1,"malformed-server-response?"]],["net/pop3"]],
["malloc",">foreign/foreign_pointer-funcs.html#(def._((lib._scribblings/foreign/unsafe-foreign..ss)._malloc))",[0,[1,"malloc"]],["scribblings/foreign/unsafe-foreign"]],
["malloc-immobile-cell",">foreign/foreign_pointer-funcs.html#(def._((lib._scribblings/foreign/unsafe-foreign..ss)._malloc-immobile-cell))",[0,[1,"malloc-immobile-cell"]],["scribblings/foreign/unsafe-foreign"]],
["managed-compile-zo",">mzc/make.html#(def._((lib._compiler/cm..ss)._managed-compile-zo))",[0,[1,"managed-compile-zo"]],["compiler/cm"]],
["manager",">web-server/module-servlets.html#(def._((lib._web-server/scribblings/dummy-servlet..ss)._manager))",[0,[1,"manager"]],[]],
["manager",">web-server/manager_ss.html#(def._((lib._web-server/managers/manager..ss)._manager))",[0,[1,"manager"]],["web-server/managers/manager"]],
["manager-adjust-timeout!",">web-server/manager_ss.html#(def._((lib._web-server/managers/manager..ss)._manager-adjust-timeout!))",[0,[1,"manager-adjust-timeout!"]],["web-server/managers/manager"]],
["manager-clear-continuations!",">web-server/manager_ss.html#(def._((lib._web-server/managers/manager..ss)._manager-clear-continuations!))",[0,[1,"manager-clear-continuations!"]],["web-server/managers/manager"]],
["manager-compile-notify-handler",">mzc/make.html#(def._((lib._compiler/cm..ss)._manager-compile-notify-handler))",[0,[1,"manager-compile-notify-handler"]],["compiler/cm"]],
["manager-continuation-lookup",">web-server/manager_ss.html#(def._((lib._web-server/managers/manager..ss)._manager-continuation-lookup))",[0,[1,"manager-continuation-lookup"]],["web-server/managers/manager"]],
["manager-continuation-store!",">web-server/manager_ss.html#(def._((lib._web-server/managers/manager..ss)._manager-continuation-store!))",[0,[1,"manager-continuation-store!"]],["web-server/managers/manager"]],
["manager-create-instance",">web-server/manager_ss.html#(def._((lib._web-server/managers/manager..ss)._manager-create-instance))",[0,[1,"manager-create-instance"]],["web-server/managers/manager"]],
["manager-trace-handler",">mzc/make.html#(def._((lib._compiler/cm..ss)._manager-trace-handler))",[0,[1,"manager-trace-handler"]],["compiler/cm"]],
["manager?",">web-server/manager_ss.html#(def._((lib._web-server/managers/manager..ss)._manager~3f))",[0,[1,"manager?"]],["web-server/managers/manager"]],
["managing control arrows: \"arrow.ss\"",">teachpack/arrow.html",["Managing Control Arrows: ",[5,"\"arrow.ss\""],"<a name=\"(idx._(gentag._7._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["managing ports",">reference/port-ops.html","Managing Ports",false],
["manipulating images",">teachpack/image.html#(part._manipulation)","Manipulating Images",false],
["manipulating images: \"image.ss\"",">teachpack/image.html",["Manipulating Images: ",[5,"\"image.ss\""],"<a name=\"(idx._(gentag._0._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["manipulating messages",">net/imap.html#(part._.Manipulating_.Messages)","Manipulating Messages",false],
["manipulating namespaces",">guide/mk-namespace.html","Manipulating Namespaces",false],
["manipulating paths",">reference/Manipulating_Paths.html","Manipulating Paths",false],
["manipulating simple html documents: \"docs.ss\"",">teachpack/docs.html",["Manipulating Simple HTML Documents: ",[5,"\"docs.ss\""],"<a name=\"(idx._(gentag._8._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["manual forms",">scribble/manual.html","Manual Forms",false],
["map",">reference/pairs.html#(def._((quote._~23~25kernel)._map))",[0,[1,"map"]],["scheme/base","scheme"]],
["map",">r5rs-std/r5rs-Z-H-9.html#%_idx_580",[0,[1,"map"]],["r5rs"]],
["map",">r6rs-std/r6rs-Z-H-14.html#node_idx_642",[0,[1,"map"]],["rnrs/base-6"]],
["map",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._map))",[0,[1,"map"]],["lang/htdp-advanced"]],
["map",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._map))",[0,[1,"map"]],["lang/htdp-intermediate"]],
["map",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._map))",[0,[1,"map"]],["lang/htdp-intermediate-lambda"]],
["map",">html/index.html#(def._((lib._html/main..ss)._map))",[0,[1,"map"]],["html"]],
["map",">lazy/index.html#(def._((lib._lazy/main..ss)._map))",[0,[1,"map"]],["lazy"]],
["map",">srfi-std/srfi-1.html#map",[0,[1,"map"]],["srfi/1"]],
["map!",">srfi-std/srfi-1.html#map!",[0,[1,"map!"]],["srfi/1"]],
["map-command-as-meta-key",">gui/Editor_Functions.html#(def._((lib._mred/main..ss)._map-command-as-meta-key))",[0,[1,"map-command-as-meta-key"]],["scheme/gui/base","scheme/gui"]],
["map-e",">frtime/index.html#(def._((lib._frtime/main..ss)._map-e))",[0,[1,"map-e"]],["frtime"]],
["map-function",">gui/keymap_.html#(meth._(((lib._mred/main..ss)._keymap~25)._map-function))",[[0,[1,"map-function"]],[12,[" (method of ",[0,[1,"keymap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["map-function",">framework/Keymap.html#(meth._(((lib._framework/main..ss)._keymap~3aaug-keymap-mixin)._map-function))",[[0,[1,"map-function"]],[12,[" (method of ",[0,[1,"keymap:aug-keymap-mixin"]],")"]]],["framework"]],
["map-in-order",">srfi-std/srfi-1.html#map-in-order",[0,[1,"map-in-order"]],["srfi/1"]],
["map-shift-style",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-text-mixin)._map-shift-style))",[[0,[1,"map-shift-style"]],[12,[" (method of ",[0,[1,"hyper-text-mixin"]],")"]]],["browser"]],
["map-snip",">embedded-gui/snip-related-functions.html#(def._((lib._embedded-gui/main..ss)._map-snip))",[0,[1,"map-snip"]],["embedded-gui"]],
["map-to-list",">embedded-gui/dllist___.html#(meth._(((lib._embedded-gui/main..ss)._dllist~3c~25~3e)._map-to-list))",[[0,[1,"map-to-list"]],[12,[" (method of ",[0,[1,"dllist&lt;%&gt;"]],")"]]],["embedded-gui"]],
["map?",">html/index.html#(def._((lib._html/main..ss)._map~3f))",[0,[1,"map?"]],["html"]],
["mappend",">reference/mpairs.html#(def._((lib._scheme/mpair..ss)._mappend))",[0,[1,"mappend"]],["scheme/mpair"]],
["mappend!",">reference/mpairs.html#(def._((lib._scheme/mpair..ss)._mappend!))",[0,[1,"mappend!"]],["scheme/mpair"]],
["mapping urls to paths",">web-server/filesystem-map_ss.html","Mapping URLs to Paths",false],
["margin",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._margin))",[[0,[1,"margin"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["margin",">slideshow/Constants_and_Layout_Variables.html#(form._((lib._slideshow/base..ss)._margin))",[0,[6,"margin"]],["slideshow/base","slideshow"]],
["margin",">gui/windowing-overview.html#(tech._margin)","<i>margin</i>",false],
["margin-bottom",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._margin-bottom))",[[0,[1,"margin-bottom"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["margin-bottom-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._margin-bottom-native))",[[0,[1,"margin-bottom-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["margin-left",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._margin-left))",[[0,[1,"margin-left"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["margin-left-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._margin-left-native))",[[0,[1,"margin-left-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["margin-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._margin-native))",[[0,[1,"margin-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["margin-note",">scribble/Miscellaneous.html#(def._((lib._scribble/manual..ss)._margin-note))",[0,[1,"margin-note"]],["scribble/manual"]],
["margin-right",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._margin-right))",[[0,[1,"margin-right"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["margin-right-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._margin-right-native))",[[0,[1,"margin-right-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["margin-top",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._margin-top))",[[0,[1,"margin-top"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["margin-top-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._margin-top-native))",[[0,[1,"margin-top-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["mark-matching-parenthesis",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._mark-matching-parenthesis))",[[0,[1,"mark-matching-parenthesis"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["marshall-settings",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e)._marshall-settings))",[[0,[1,"marshall-settings"]],[12,[" (method of ",[0,[1,"drscheme:language:language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["marshall-settings",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3amodule-based-language~3c~25~3e)._marshall-settings))",[[0,[1,"marshall-settings"]],[12,[" (method of ",[0,[1,"drscheme:language:module-based-language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["marshall-settings",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-module-based-language-~3emodule-based-language-mixin)._marshall-settings))",[[0,[1,"marshall-settings"]],[12,[" (method of ",[0,[1,"drscheme:language:simple-module-based-language-&gt;module-based-language-mixin"]],")"]]],["drscheme/tool-lib"]],
["massoc",">reference/mpairs.html#(def._((lib._scheme/mpair..ss)._massoc))",[0,[1,"massoc"]],["scheme/mpair"]],
["massq",">reference/mpairs.html#(def._((lib._scheme/mpair..ss)._massq))",[0,[1,"massq"]],["scheme/mpair"]],
["massv",">reference/mpairs.html#(def._((lib._scheme/mpair..ss)._massv))",[0,[1,"massv"]],["scheme/mpair"]],
["master",">teachpack/master.html#(def._((lib._teachpack/htdp/master..ss)._master))",[0,[1,"master"]],["teachpack/htdp/master"]],
["master teachpack",">teachpack/master.html#(idx._(gentag._4._(lib._teachpack/teachpack..scrbl)))","master teachpack",false],
["masterminding: \"master.ss\"",">teachpack/master.html",["MasterMinding: ",[5,"\"master.ss\""],"<a name=\"(idx._(gentag._4._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["match",">reference/match.html#(form._((lib._scheme/match..ss)._match))",[0,[6,"match"]],["scheme/match","scheme"]],
["match",">mzlib/mzlib_match.html#(form._((lib._mzlib/match..ss)._match))",[0,[6,"match"]],["mzlib/match"]],
["match-bindings",">redex/Patterns.html#(def._((lib._redex/reduction-semantics..ss)._match-bindings))",[0,[1,"match-bindings"]],["redex/reduction-semantics"]],
["match-define",">reference/match.html#(form._((lib._scheme/match..ss)._match-define))",[0,[6,"match-define"]],["scheme/match","scheme"]],
["match-define",">mzlib/mzlib_match.html#(form._((lib._mzlib/match..ss)._match-define))",[0,[6,"match-define"]],["mzlib/match"]],
["match-equality-test",">reference/match.html#(def._((lib._scheme/match..ss)._match-equality-test))",[0,[1,"match-equality-test"]],["scheme/match","scheme"]],
["match-equality-test",">mzlib/mzlib_match.html#(def._((lib._mzlib/match..ss)._match-equality-test))",[0,[1,"match-equality-test"]],["mzlib/match"]],
["match-lambda",">reference/match.html#(form._((lib._scheme/match..ss)._match-lambda))",[0,[6,"match-lambda"]],["scheme/match","scheme"]],
["match-lambda",">mzlib/mzlib_match.html#(form._((lib._mzlib/match..ss)._match-lambda))",[0,[6,"match-lambda"]],["mzlib/match"]],
["match-lambda*",">reference/match.html#(form._((lib._scheme/match..ss)._match-lambda*))",[0,[6,"match-lambda*"]],["scheme/match","scheme"]],
["match-lambda*",">mzlib/mzlib_match.html#(form._((lib._mzlib/match..ss)._match-lambda*))",[0,[6,"match-lambda*"]],["mzlib/match"]],
["match-let",">reference/match.html#(form._((lib._scheme/match..ss)._match-let))",[0,[6,"match-let"]],["scheme/match","scheme"]],
["match-let",">mzlib/mzlib_match.html#(form._((lib._mzlib/match..ss)._match-let))",[0,[6,"match-let"]],["mzlib/match"]],
["match-let*",">reference/match.html#(form._((lib._scheme/match..ss)._match-let*))",[0,[6,"match-let*"]],["scheme/match","scheme"]],
["match-let*",">mzlib/mzlib_match.html#(form._((lib._mzlib/match..ss)._match-let*))",[0,[6,"match-let*"]],["mzlib/match"]],
["match-letrec",">reference/match.html#(form._((lib._scheme/match..ss)._match-letrec))",[0,[6,"match-letrec"]],["scheme/match","scheme"]],
["match-letrec",">mzlib/mzlib_match.html#(form._((lib._mzlib/match..ss)._match-letrec))",[0,[6,"match-letrec"]],["mzlib/match"]],
["match:end",">mzlib/mzlib_awk.html#(def._((lib._mzlib/awk..ss)._match~3aend))",[0,[1,"match:end"]],["mzlib/awk"]],
["match:start",">mzlib/mzlib_awk.html#(def._((lib._mzlib/awk..ss)._match~3astart))",[0,[1,"match:start"]],["mzlib/awk"]],
["match:substring",">mzlib/mzlib_awk.html#(def._((lib._mzlib/awk..ss)._match~3asubstring))",[0,[1,"match:substring"]],["mzlib/awk"]],
["match?",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._match~3f))",[[0,[1,"match?"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["match?",">redex/Patterns.html#(def._((lib._redex/reduction-semantics..ss)._match~3f))",[0,[1,"match?"]],["redex/reduction-semantics"]],
["matching fully-expanded expressions",">syntax/syntax-helpers.html#(part._kerncase)","Matching Fully-Expanded Expressions",false],
["matching regexp patterns",">guide/regexp-match.html","Matching Regexp Patterns",false],
["matching sequences",">guide/pattern-macros.html#(part._.Matching_.Sequences)","Matching Sequences",false],
["matching-identifiers-in",">reference/require.html#(form._((lib._scheme/require..ss)._matching-identifiers-in))",[0,[6,"matching-identifiers-in"]],["scheme/require"]],
["matching-identifiers-out",">reference/require.html#(form._((lib._scheme/provide..ss)._matching-identifiers-out))",[0,[6,"matching-identifiers-out"]],["scheme/provide"]],
["math",">scribble/doc-strings.html#(def._((lib._scribble/manual..ss)._math))",[0,[1,"math"]],["scribble/manual"]],
["matrix operations: \"matrix.ss\"",">teachpack/matrix.html",["Matrix Operations: ",[5,"\"matrix.ss\""],"<a name=\"(idx._(gentag._15._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["matrix teachpack",">teachpack/matrix.html#(idx._(gentag._15._(lib._teachpack/teachpack..scrbl)))","matrix teachpack",false],
["matrix->rectangle",">teachpack/matrix.html#(def._((lib._teachpack/htdp/matrix..ss)._matrix-~3erectangle))",[0,[1,"matrix-&gt;rectangle"]],["teachpack/htdp/matrix"]],
["matrix-cols",">teachpack/matrix.html#(def._((lib._teachpack/htdp/matrix..ss)._matrix-cols))",[0,[1,"matrix-cols"]],["teachpack/htdp/matrix"]],
["matrix-minor",">teachpack/matrix.html#(def._((lib._teachpack/htdp/matrix..ss)._matrix-minor))",[0,[1,"matrix-minor"]],["teachpack/htdp/matrix"]],
["matrix-ref",">teachpack/matrix.html#(def._((lib._teachpack/htdp/matrix..ss)._matrix-ref))",[0,[1,"matrix-ref"]],["teachpack/htdp/matrix"]],
["matrix-render",">teachpack/matrix.html#(def._((lib._teachpack/htdp/matrix..ss)._matrix-render))",[0,[1,"matrix-render"]],["teachpack/htdp/matrix"]],
["matrix-rows",">teachpack/matrix.html#(def._((lib._teachpack/htdp/matrix..ss)._matrix-rows))",[0,[1,"matrix-rows"]],["teachpack/htdp/matrix"]],
["matrix-set",">teachpack/matrix.html#(def._((lib._teachpack/htdp/matrix..ss)._matrix-set))",[0,[1,"matrix-set"]],["teachpack/htdp/matrix"]],
["matrix-set!",">teachpack/matrix.html#(def._((lib._teachpack/htdp/matrix..ss)._matrix-set!))",[0,[1,"matrix-set!"]],["teachpack/htdp/matrix"]],
["matrix-where?",">teachpack/matrix.html#(def._((lib._teachpack/htdp/matrix..ss)._matrix-where~3f))",[0,[1,"matrix-where?"]],["teachpack/htdp/matrix"]],
["matrix?",">teachpack/matrix.html#(def._((lib._teachpack/htdp/matrix..ss)._matrix~3f))",[0,[1,"matrix?"]],["teachpack/htdp/matrix"]],
["max",">reference/numbers.html#(def._((quote._~23~25kernel)._max))",[0,[1,"max"]],["scheme/base","scheme"]],
["max",">r5rs-std/r5rs-Z-H-9.html#%_idx_278",[0,[1,"max"]],["r5rs"]],
["max",">r6rs-std/r6rs-Z-H-14.html#node_idx_490",[0,[1,"max"]],["rnrs/base-6"]],
["max",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._max))",[0,[1,"max"]],["lang/htdp-advanced"]],
["max",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._max))",[0,[1,"max"]],["lang/htdp-beginner"]],
["max",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._max))",[0,[1,"max"]],["lang/htdp-beginner-abbr"]],
["max",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._max))",[0,[1,"max"]],["lang/htdp-intermediate"]],
["max",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._max))",[0,[1,"max"]],["lang/htdp-intermediate-lambda"]],
["max-ec",">srfi-std/srfi-42.html#max-ec",[0,[6,"max-ec"]],["srfi/42"]],
["max-exprs-per-top-level-set",">mzc/Scheme_API_for_Compilation.html#(def._((lib._compiler/option..ss)._max-exprs-per-top-level-set))",[0,[1,"max-exprs-per-top-level-set"]],["compiler/option"]],
["max-history",">readline/index.html#(def._((lib._readline/pread..ss)._max-history))",[0,[1,"max-history"]],["readline/pread"]],
["max-waiting",">web-server/dispatch-server-unit_ss.html#(sig-val._((lib._web-server/private/dispatch-server-sig..ss)._dispatch-server-config~5e._max-waiting))",[0,[1,"max-waiting"]],["web-server/private/dispatch-server-sig"]],
["max-waiting",">web-server/web-config-unit_ss.html#(sig-val._((lib._web-server/web-config-sig..ss)._web-config~5e._max-waiting))",[0,[1,"max-waiting"]],["web-server/web-config-sig"]],
["maximize",">gui/frame_.html#(meth._(((lib._mred/main..ss)._frame~25)._maximize))",[[0,[1,"maximize"]],[12,[" (method of ",[0,[1,"frame%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["maybe",">eopl/index.html#(def._((lib._eopl/eopl..ss)._maybe))",[0,[1,"maybe"]],["eopl/eopl"]],
["mc",">reference/characters.html#(idx._(gentag._42._(lib._scribblings/reference/reference..scrbl)))",[7,"'mc"],false],
["mcar",">reference/mpairs.html#(def._((quote._~23~25kernel)._mcar))",[0,[1,"mcar"]],["scheme/base","scheme"]],
["mcdr",">reference/mpairs.html#(def._((quote._~23~25kernel)._mcdr))",[0,[1,"mcdr"]],["scheme/base","scheme"]],
["mcons",">reference/mpairs.html#(def._((quote._~23~25kernel)._mcons))",[0,[1,"mcons"]],["scheme/base","scheme"]],
["md5",">file/md5.html#(def._((lib._file/md5..ss)._md5))",[0,[1,"md5"]],["file/md5"]],
["md5 message digest",">file/md5.html","MD5 Message Digest",false],
["me",">reference/characters.html#(idx._(gentag._43._(lib._scribblings/reference/reference..scrbl)))",[7,"'me"],false],
["member",">reference/pairs.html#(def._((quote._~23~25kernel)._member))",[0,[1,"member"]],["scheme/base","scheme"]],
["member",">r5rs-std/r5rs-Z-H-9.html#%_idx_450",[0,[1,"member"]],["r5rs"]],
["member",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_226",[0,[1,"member"]],["rnrs/lists-6"]],
["member",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._member))",[0,[1,"member"]],["lang/htdp-advanced"]],
["member",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._member))",[0,[1,"member"]],["lang/htdp-beginner"]],
["member",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._member))",[0,[1,"member"]],["lang/htdp-beginner-abbr"]],
["member",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._member))",[0,[1,"member"]],["lang/htdp-intermediate"]],
["member",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._member))",[0,[1,"member"]],["lang/htdp-intermediate-lambda"]],
["member",">lazy/index.html#(def._((lib._lazy/main..ss)._member))",[0,[1,"member"]],["lazy"]],
["member",">srfi-std/srfi-1.html#member",[0,[1,"member"]],["srfi/1"]],
["member-name-key",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._member-name-key))",[0,[6,"member-name-key"]],["scheme/class","scheme"]],
["member-name-key-hash-code",">reference/createclass.html#(def._((lib._scheme/private/class-internal..ss)._member-name-key-hash-code))",[0,[1,"member-name-key-hash-code"]],["scheme/class","scheme"]],
["member-name-key=?",">reference/createclass.html#(def._((lib._scheme/private/class-internal..ss)._member-name-key~3d~3f))",[0,[1,"member-name-key=?"]],["scheme/class","scheme"]],
["member-name-key?",">reference/createclass.html#(def._((lib._scheme/private/class-internal..ss)._member-name-key~3f))",[0,[1,"member-name-key?"]],["scheme/class","scheme"]],
["member?",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..ss)._member~3f))",[0,[1,"member?"]],["mzlib/integer-set"]],
["memcpy",">foreign/foreign_pointer-funcs.html#(def._((lib._scribblings/foreign/unsafe-foreign..ss)._memcpy))",[0,[1,"memcpy"]],["scribblings/foreign/unsafe-foreign"]],
["memf",">reference/pairs.html#(def._((lib._scheme/base..ss)._memf))",[0,[1,"memf"]],["scheme/base","scheme"]],
["memf",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._memf))",[0,[1,"memf"]],["lang/htdp-advanced"]],
["memf",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._memf))",[0,[1,"memf"]],["lang/htdp-intermediate"]],
["memf",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._memf))",[0,[1,"memf"]],["lang/htdp-intermediate-lambda"]],
["memf",">lazy/index.html#(def._((lib._lazy/main..ss)._memf))",[0,[1,"memf"]],["lazy"]],
["memmove",">foreign/foreign_pointer-funcs.html#(def._((lib._scribblings/foreign/unsafe-foreign..ss)._memmove))",[0,[1,"memmove"]],["scribblings/foreign/unsafe-foreign"]],
["memory",">inside/im_memoryalloc.html","memory",false],
["memory --- kid's game",">games/memory.html",[[13,"<img src=\"memory.png\" />"]," ","<b><font size=\"-1\" face=\"Helvetica\">Memory</font></b>","  ","&ndash;","  Kid","&rsquo;","s Game"],false],
["memory allocation",">inside/im_memoryalloc.html","Memory Allocation",false],
["memory functions",">inside/im_memoryalloc.html#(part._.Memory_.Functions)","Memory Functions",false],
["memory management",">guide/performance.html#(part._gc-perf)","Memory Management",false],
["memory management",">reference/memory.html","Memory Management",false],
["memp",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_224",[0,[1,"memp"]],["rnrs/lists-6"]],
["memq",">reference/pairs.html#(def._((quote._~23~25kernel)._memq))",[0,[1,"memq"]],["scheme/base","scheme"]],
["memq",">r5rs-std/r5rs-Z-H-9.html#%_idx_446",[0,[1,"memq"]],["r5rs"]],
["memq",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_230",[0,[1,"memq"]],["rnrs/lists-6"]],
["memq",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._memq))",[0,[1,"memq"]],["lang/htdp-advanced"]],
["memq",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._memq))",[0,[1,"memq"]],["lang/htdp-beginner"]],
["memq",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._memq))",[0,[1,"memq"]],["lang/htdp-beginner-abbr"]],
["memq",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._memq))",[0,[1,"memq"]],["lang/htdp-intermediate"]],
["memq",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._memq))",[0,[1,"memq"]],["lang/htdp-intermediate-lambda"]],
["memq",">lazy/index.html#(def._((lib._lazy/main..ss)._memq))",[0,[1,"memq"]],["lazy"]],
["memq",">srfi-std/srfi-1.html#memq",[0,[1,"memq"]],["srfi/1"]],
["memset",">foreign/foreign_pointer-funcs.html#(def._((lib._scribblings/foreign/unsafe-foreign..ss)._memset))",[0,[1,"memset"]],["scribblings/foreign/unsafe-foreign"]],
["memv",">reference/pairs.html#(def._((quote._~23~25kernel)._memv))",[0,[1,"memv"]],["scheme/base","scheme"]],
["memv",">r5rs-std/r5rs-Z-H-9.html#%_idx_448",[0,[1,"memv"]],["r5rs"]],
["memv",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_228",[0,[1,"memv"]],["rnrs/lists-6"]],
["memv",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._memv))",[0,[1,"memv"]],["lang/htdp-advanced"]],
["memv",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._memv))",[0,[1,"memv"]],["lang/htdp-beginner"]],
["memv",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._memv))",[0,[1,"memv"]],["lang/htdp-beginner-abbr"]],
["memv",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._memv))",[0,[1,"memv"]],["lang/htdp-intermediate"]],
["memv",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._memv))",[0,[1,"memv"]],["lang/htdp-intermediate-lambda"]],
["memv",">lazy/index.html#(def._((lib._lazy/main..ss)._memv))",[0,[1,"memv"]],["lazy"]],
["memv",">srfi-std/srfi-1.html#memv",[0,[1,"memv"]],["srfi/1"]],
["menu",">framework/Menu.html","Menu",false],
["menu",">html/index.html#(def._((lib._html/main..ss)._menu))",[0,[1,"menu"]],["html"]],
["menu",">gui/menu-item_.html#(idx._(gentag._120._(lib._scribblings/gui/gui..scrbl)))",[7,"'menu"],false],
["menu",">gui/checkable-menu-item_.html#(idx._(gentag._37._(lib._scribblings/gui/gui..scrbl)))",[7,"'menu"],false],
["menu",">gui/key-event_.html#(idx._(gentag._51._(lib._scribblings/gui/gui..scrbl)))",[7,"'menu"],false],
["menu",">gui/windowing-overview.html#(tech._menu)","<i>menu</i>",false],
["menu bar",">gui/windowing-overview.html#(tech._menu._bar)","<i>menu bar</i>",false],
["menu item containers",">gui/windowing-overview.html#(tech._menu._item._container)","<i>Menu Item Containers</i>",false],
["menu items",">gui/windowing-overview.html#(tech._menu._item)","<i>Menu Items</i>",false],
["menu%",">gui/menu_.html",[0,[1,"menu%"]],["scheme/gui/base","scheme/gui"]],
["menu-bar%",">gui/menu-bar_.html",[0,[1,"menu-bar%"]],["scheme/gui/base","scheme/gui"]],
["menu-control-font",">gui/Drawing_Functions.html#(def._((lib._mred/main..ss)._menu-control-font))",[0,[1,"menu-control-font"]],["scheme/gui/base","scheme/gui"]],
["menu-item%",">gui/menu-item_.html",[0,[1,"menu-item%"]],["scheme/gui/base","scheme/gui"]],
["menu-item-container<%>",">gui/menu-item-container___.html",[0,[1,"menu-item-container&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["menu-item<%>",">gui/menu-item___.html",[0,[1,"menu-item&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["menu-popdown",">gui/popup-menu_.html#(idx._(gentag._125._(lib._scribblings/gui/gui..scrbl)))",[7,"'menu-popdown"],false],
["menu-popdown-none",">gui/popup-menu_.html#(idx._(gentag._124._(lib._scribblings/gui/gui..scrbl)))",[7,"'menu-popdown-none"],false],
["menu:can-restore-checkable-menu-item%",">framework/Menu.html#(def._((lib._framework/main..ss)._menu~3acan-restore-checkable-menu-item~25))",[0,[1,"menu:can-restore-checkable-menu-item%"]],["framework"]],
["menu:can-restore-menu-item%",">framework/Menu.html#(def._((lib._framework/main..ss)._menu~3acan-restore-menu-item~25))",[0,[1,"menu:can-restore-menu-item%"]],["framework"]],
["menu:can-restore-mixin",">framework/Menu.html#(def._((lib._framework/main..ss)._menu~3acan-restore-mixin))",[0,[1,"menu:can-restore-mixin"]],["framework"]],
["menu:can-restore-underscore-menu%",">framework/Menu.html#(def._((lib._framework/main..ss)._menu~3acan-restore-underscore-menu~25))",[0,[1,"menu:can-restore-underscore-menu%"]],["framework"]],
["menu:can-restore-underscore-mixin",">framework/Menu.html#(def._((lib._framework/main..ss)._menu~3acan-restore-underscore-mixin))",[0,[1,"menu:can-restore-underscore-mixin"]],["framework"]],
["menu:can-restore-underscore<%>",">framework/Menu.html#(def._((lib._framework/main..ss)._menu~3acan-restore-underscore~3c~25~3e))",[0,[1,"menu:can-restore-underscore&lt;%&gt;"]],["framework"]],
["menu:can-restore<%>",">framework/Menu.html#(def._((lib._framework/main..ss)._menu~3acan-restore~3c~25~3e))",[0,[1,"menu:can-restore&lt;%&gt;"]],["framework"]],
["menu?",">html/index.html#(def._((lib._html/main..ss)._menu~3f))",[0,[1,"menu?"]],["html"]],
["menuitem",">scribble/doc-strings.html#(def._((lib._scribble/manual..ss)._menuitem))",[0,[1,"menuitem"]],["scribble/manual"]],
["menus",">drscheme/Menus.html","Menus",false],
["merge",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles..ss)._merge))",[0,[1,"merge"]],["graphics/value-turtles"]],
["merge-e",">frtime/index.html#(def._((lib._frtime/main..ss)._merge-e))",[0,[1,"merge-e"]],["frtime"]],
["merge-input",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._merge-input))",[0,[1,"merge-input"]],["scheme/port"]],
["merge-sorted-lists",">mzlib/mzlib_list.html#(def._((lib._mzlib/list..ss)._merge-sorted-lists))",[0,[1,"merge-sorted-lists"]],["mzlib/list"]],
["merge-with",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._merge-with))",[[0,[1,"merge-with"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["mergesort",">mzlib/mzlib_list.html#(def._((lib._mzlib/list..ss)._mergesort))",[0,[1,"mergesort"]],["mzlib/list"]],
["message",">net/mime.html#(def._((lib._net/mime..ss)._message))",[0,[1,"message"]],["net/mime"]],
["message",">gui/windowing-overview.html#(tech._message)","<i>message</i>",false],
["message decoding",">net/mime.html#(part._.Message_.Decoding)","Message Decoding",false],
["message%",">gui/message_.html",[0,[1,"message%"]],["scheme/gui/base","scheme/gui"]],
["message+check-box",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._message+check-box))",[0,[1,"message+check-box"]],["scheme/gui/base","scheme/gui"]],
["message+check-box/custom",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._message+check-box/custom))",[0,[1,"message+check-box/custom"]],["scheme/gui/base","scheme/gui"]],
["message-box",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._message-box))",[0,[1,"message-box"]],["scheme/gui/base","scheme/gui"]],
["message-box/custom",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._message-box/custom))",[0,[1,"message-box/custom"]],["scheme/gui/base","scheme/gui"]],
["message-condition?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_410",[0,[1,"message-condition?"]],["rnrs/conditions-6"]],
["message-entity",">net/mime.html#(def._((lib._net/mime..ss)._message-entity))",[0,[1,"message-entity"]],["net/mime"]],
["message-fields",">net/mime.html#(def._((lib._net/mime..ss)._message-fields))",[0,[1,"message-fields"]],["net/mime"]],
["message-version",">net/mime.html#(def._((lib._net/mime..ss)._message-version))",[0,[1,"message-version"]],["net/mime"]],
["message?",">net/mime.html#(def._((lib._net/mime..ss)._message~3f))",[0,[1,"message?"]],["net/mime"]],
["messages",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._messages))",[0,[1,"messages"]],["web-server/configuration/configuration-table-structs"]],
["messages-authentication",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._messages-authentication))",[0,[1,"messages-authentication"]],["web-server/configuration/configuration-table-structs"]],
["messages-collect-garbage",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._messages-collect-garbage))",[0,[1,"messages-collect-garbage"]],["web-server/configuration/configuration-table-structs"]],
["messages-file-not-found",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._messages-file-not-found))",[0,[1,"messages-file-not-found"]],["web-server/configuration/configuration-table-structs"]],
["messages-passwords-refreshed",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._messages-passwords-refreshed))",[0,[1,"messages-passwords-refreshed"]],["web-server/configuration/configuration-table-structs"]],
["messages-protocol",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._messages-protocol))",[0,[1,"messages-protocol"]],["web-server/configuration/configuration-table-structs"]],
["messages-servlet",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._messages-servlet))",[0,[1,"messages-servlet"]],["web-server/configuration/configuration-table-structs"]],
["messages-servlets-refreshed",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._messages-servlets-refreshed))",[0,[1,"messages-servlets-refreshed"]],["web-server/configuration/configuration-table-structs"]],
["messages?",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._messages~3f))",[0,[1,"messages?"]],["web-server/configuration/configuration-table-structs"]],
["meta",">html/index.html#(def._((lib._html/main..ss)._meta))",[0,[1,"meta"]],["html"]],
["meta",">framework/Keymap.html#(idx._(gentag._4._(lib._scribblings/framework/framework..scrbl)))","Meta",false],
["meta-compile phase level",">guide/stx-phases.html#(tech._meta._compile._phase._level)","<i>meta-compile phase level</i>",false],
["meta?",">html/index.html#(def._((lib._html/main..ss)._meta~3f))",[0,[1,"meta?"]],["html"]],
["metacharacters",">guide/regexp-intro.html#(tech._metacharacter)","<i>metacharacters</i>",false],
["metadata->settings",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e)._metadata-~3esettings))",[[0,[1,"metadata-&gt;settings"]],[12,[" (method of ",[0,[1,"drscheme:language:language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["metafunction->pict",">redex/Typesetting.html#(form._((lib._redex/pict..ss)._metafunction-~3epict))",[0,[6,"metafunction-&gt;pict"]],["redex/pict"]],
["metafunction-font-size",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._metafunction-font-size))",[0,[1,"metafunction-font-size"]],["redex/pict"]],
["metafunction-pict-style",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._metafunction-pict-style))",[0,[1,"metafunction-pict-style"]],["redex/pict"]],
["metafunction-style",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._metafunction-style))",[0,[1,"metafunction-style"]],["redex/pict"]],
["metafunctions",">redex/Metafunctions.html","Metafunctions",false],
["metasequences",">guide/regexp-intro.html#(tech._metasequence)","<i>metasequences</i>",false],
["method",">htdc/Method.html",[0,"Method"],false],
["method",">htdc/advanced_method.html",[0,"Method"],false],
["method",">htdc/intermed_method.html",[0,"Method"],false],
["method",">htdc/intermedAcc_method.html",[0,"Method"],false],
["method",">scribble/doc-classes.html#(form._((lib._scribble/manual..ss)._method))",[0,[6,"method"]],["scribble/manual"]],
["method definitions",">reference/createclass.html#(part._clmethoddefs)","Method Definitions",false],
["method-arity-error",">reference/lambda.html#(idx._(gentag._7._(lib._scribblings/reference/reference..scrbl)))",[7,"'method-arity-error"],false],
["method-in-interface?",">reference/objectutils.html#(def._((lib._scheme/private/class-internal..ss)._method-in-interface~3f))",[0,[1,"method-in-interface?"]],["scheme/class","scheme"]],
["method-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._method-index-desc))",[0,[1,"method-index-desc"]],["scribble/manual-struct"]],
["method-index-desc-class-tag",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._method-index-desc-class-tag))",[0,[1,"method-index-desc-class-tag"]],["scribble/manual-struct"]],
["method-index-desc-method-name",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._method-index-desc-method-name))",[0,[1,"method-index-desc-method-name"]],["scribble/manual-struct"]],
["method-index-desc?",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._method-index-desc~3f))",[0,[1,"method-index-desc?"]],["scribble/manual-struct"]],
["methods",">mzcom/index.html#(part._.Methods)","Methods",false],
["methods",">guide/classes.html#(part._methods)","Methods",false],
["methods",">reference/createclass.html#(part._clmethods)","Methods",false],
["methods",">reference/ivaraccess.html#(part._methodcalls)","Methods",false],
["mfor-each",">reference/mpairs.html#(def._((lib._scheme/mpair..ss)._mfor-each))",[0,[1,"mfor-each"]],["scheme/mpair"]],
["middle-mouse-click?",">graphics/Mouse_Operations.html#(def._((lib._graphics/graphics..ss)._middle-mouse-click~3f))",[0,[1,"middle-mouse-click?"]],["graphics/graphics"]],
["milliseconds",">frtime/index.html#(def._((lib._frtime/main..ss)._milliseconds))",[0,[1,"milliseconds"]],["frtime"]],
["mime signature",">net/mime.html#(part._.M.I.M.E_.Signature)","MIME Signature",false],
["mime types",">web-server/mime-types_ss.html","MIME Types",false],
["mime unit",">net/mime.html#(part._.M.I.M.E_.Unit)","MIME Unit",false],
["mime-analyze",">net/mime.html#(def._((lib._net/mime..ss)._mime-analyze))",[0,[1,"mime-analyze"]],["net/mime"]],
["mime-error",">net/mime.html#(def._((lib._net/mime..ss)._mime-error))",[0,[1,"mime-error"]],["net/mime"]],
["mime-error?",">net/mime.html#(def._((lib._net/mime..ss)._mime-error~3f))",[0,[1,"mime-error?"]],["net/mime"]],
["mime: decoding internet data",">net/mime.html","MIME: Decoding Internet Data",false],
["mime@",">net/mime.html#(def._((lib._net/mime-unit..ss)._mime~40))",[0,[1,"mime@"]],["net/mime-unit"]],
["mime^",">net/mime.html#(form._((lib._net/mime-sig..ss)._mime~5e))",[0,[6,"mime^"]],["net/mime-sig"]],
["min",">reference/numbers.html#(def._((quote._~23~25kernel)._min))",[0,[1,"min"]],["scheme/base","scheme"]],
["min",">r5rs-std/r5rs-Z-H-9.html#%_idx_280",[0,[1,"min"]],["r5rs"]],
["min",">r6rs-std/r6rs-Z-H-14.html#node_idx_492",[0,[1,"min"]],["rnrs/base-6"]],
["min",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._min))",[0,[1,"min"]],["lang/htdp-advanced"]],
["min",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._min))",[0,[1,"min"]],["lang/htdp-beginner"]],
["min",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._min))",[0,[1,"min"]],["lang/htdp-beginner-abbr"]],
["min",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._min))",[0,[1,"min"]],["lang/htdp-intermediate"]],
["min",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._min))",[0,[1,"min"]],["lang/htdp-intermediate-lambda"]],
["min-client-height",">gui/canvas___.html#(meth._(((lib._mred/main..ss)._canvas~3c~25~3e)._min-client-height))",[[0,[1,"min-client-height"]],[12,[" (method of ",[0,[1,"canvas&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["min-client-width",">gui/canvas___.html#(meth._(((lib._mred/main..ss)._canvas~3c~25~3e)._min-client-width))",[[0,[1,"min-client-width"]],[12,[" (method of ",[0,[1,"canvas&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["min-ec",">srfi-std/srfi-42.html#min-ec",[0,[6,"min-ec"]],["srfi/42"]],
["min-height",">gui/area___.html#(meth._(((lib._mred/main..ss)._area~3c~25~3e)._min-height))",[[0,[1,"min-height"]],[12,[" (method of ",[0,[1,"area&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["min-height",">gui/area___.html#(idx._(gentag._22._(lib._scribblings/gui/gui..scrbl)))",[0,"min-height"],false],
["min-width",">gui/area___.html#(meth._(((lib._mred/main..ss)._area~3c~25~3e)._min-width))",[[0,[1,"min-width"]],[12,[" (method of ",[0,[1,"area&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["min-width",">gui/area___.html#(idx._(gentag._21._(lib._scribblings/gui/gui..scrbl)))",[0,"min-width"],false],
["minesweeper --- logic game",">games/mines.html",[[13,"<img src=\"mines.png\" />"]," ","<b><font size=\"-1\" face=\"Helvetica\">Minesweeper</font></b>","  ","&ndash;","  Logic Game"],false],
["minimizes",">gui/frame_.html#(idx._(gentag._44._(lib._scribblings/gui/gui..scrbl)))","minimizes",false],
["miscellaneous",">drscheme/Keyboard_Shortcuts.html#(part._.Miscellaneous)","Miscellaneous",false],
["miscellaneous",">gui/Windowing_Functions.html#(part._.Miscellaneous)","Miscellaneous",false],
["miscellaneous",">reference/Sandboxed_Evaluation.html#(part._.Miscellaneous)","Miscellaneous",false],
["miscellaneous",">scribble/Miscellaneous.html","Miscellaneous",false],
["miscellaneous",">slideshow/Miscellaneous.html","Miscellaneous",false],
["miscellaneous functions",">plot/plot.html#(part._.Miscellaneous_.Functions)","Miscellaneous Functions",false],
["miscellaneous image manipulation and creation",">teachpack/image.html#(part._pixel-lists)","Miscellaneous Image Manipulation and Creation",false],
["miscellaneous operations",">graphics/Miscellaneous_Operations.html","Miscellaneous Operations",false],
["miscellaneous support",">foreign/Miscellaneous_Support.html","Miscellaneous Support",false],
["miscellaneous utilities",">inside/Miscellaneous_Utilities.html","Miscellaneous Utilities",false],
["miscellaneous utilities",">web-server/util_ss.html","Miscellaneous Utilities",false],
["missing-multipart-boundary-parameter",">net/mime.html#(def._((lib._net/mime..ss)._missing-multipart-boundary-parameter))",[0,[1,"missing-multipart-boundary-parameter"]],["net/mime"]],
["missing-multipart-boundary-parameter?",">net/mime.html#(def._((lib._net/mime..ss)._missing-multipart-boundary-parameter~3f))",[0,[1,"missing-multipart-boundary-parameter?"]],["net/mime"]],
["mix",">plot/plot.html#(def._((lib._plot/main..ss)._mix))",[0,[1,"mix"]],["plot"]],
["mixin",">reference/mixins.html#(form._((lib._scheme/private/class-internal..ss)._mixin))",[0,[6,"mixin"]],["scheme/class","scheme"]],
["mixin",">guide/classes.html#(tech._mixin)","<i>mixin</i>",false],
["mixin",">reference/mixins.html#(tech._mixin)","<i>mixin</i>",false],
["mixin-contract",">reference/Object_and_Class_Contracts.html#(def._((lib._scheme/class..ss)._mixin-contract))",[0,[1,"mixin-contract"]],["scheme/class","scheme"]],
["mixin-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._mixin-index-desc))",[0,[1,"mixin-index-desc"]],["scribble/manual-struct"]],
["mixin-index-desc?",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._mixin-index-desc~3f))",[0,[1,"mixin-index-desc?"]],["scribble/manual-struct"]],
["mixing patterns and expressions: syntax-case",">guide/syntax-case.html",["Mixing Patterns and Expressions: ",[0,[6,"syntax-case"]]],false],
["mixins",">guide/classes.html#(part._.Mixins)","Mixins",false],
["mixins",">reference/mixins.html","Mixins",false],
["mixins and interfaces",">guide/classes.html#(part._.Mixins_and_.Interfaces)","Mixins and Interfaces",false],
["mlength",">reference/mpairs.html#(def._((lib._scheme/mpair..ss)._mlength))",[0,[1,"mlength"]],["scheme/mpair"]],
["mlist",">reference/mpairs.html#(def._((lib._scheme/mpair..ss)._mlist))",[0,[1,"mlist"]],["scheme/mpair"]],
["mlist->list",">reference/mpairs.html#(def._((lib._scheme/mpair..ss)._mlist-~3elist))",[0,[1,"mlist-&gt;list"]],["scheme/mpair"]],
["mlist-ref",">reference/mpairs.html#(def._((lib._scheme/mpair..ss)._mlist-ref))",[0,[1,"mlist-ref"]],["scheme/mpair"]],
["mlist-tail",">reference/mpairs.html#(def._((lib._scheme/mpair..ss)._mlist-tail))",[0,[1,"mlist-tail"]],["scheme/mpair"]],
["mlist?",">reference/mpairs.html#(def._((lib._scheme/mpair..ss)._mlist~3f))",[0,[1,"mlist?"]],["scheme/mpair"]],
["mlistof",">reference/mpairs.html#(def._((lib._scheme/mpair..ss)._mlistof))",[0,[1,"mlistof"]],["scheme/mpair"]],
["mmap",">reference/mpairs.html#(def._((lib._scheme/mpair..ss)._mmap))",[0,[1,"mmap"]],["scheme/mpair"]],
["mmember",">reference/mpairs.html#(def._((lib._scheme/mpair..ss)._mmember))",[0,[1,"mmember"]],["scheme/mpair"]],
["mmemq",">reference/mpairs.html#(def._((lib._scheme/mpair..ss)._mmemq))",[0,[1,"mmemq"]],["scheme/mpair"]],
["mmemv",">reference/mpairs.html#(def._((lib._scheme/mpair..ss)._mmemv))",[0,[1,"mmemv"]],["scheme/mpair"]],
["mn",">reference/characters.html#(idx._(gentag._41._(lib._scribblings/reference/reference..scrbl)))",[7,"'mn"],false],
["mod",">r6rs-std/r6rs-Z-H-14.html#node_idx_512",[0,[1,"mod"]],["rnrs/base-6"]],
["mod0",">r6rs-std/r6rs-Z-H-14.html#node_idx_518",[0,[1,"mod0"]],["rnrs/base-6"]],
["moddep-current-open-input-file",">syntax/module-helpers.html#(def._((lib._syntax/modcode..ss)._moddep-current-open-input-file))",[0,[1,"moddep-current-open-input-file"]],["syntax/modcode"]],
["mode",">framework/Mode.html","Mode",false],
["mode",">teachpack/image.html#(tech._mode)","<i>Mode</i>",false],
["mode keywords",">mzlib/mzlib_kw.html#(part._mode-keywords)","Mode Keywords",false],
["mode:host-text-mixin",">framework/Mode.html#(def._((lib._framework/main..ss)._mode~3ahost-text-mixin))",[0,[1,"mode:host-text-mixin"]],["framework"]],
["mode:host-text<%>",">framework/Mode.html#(def._((lib._framework/main..ss)._mode~3ahost-text~3c~25~3e))",[0,[1,"mode:host-text&lt;%&gt;"]],["framework"]],
["mode:surrogate-text%",">framework/Mode.html#(def._((lib._framework/main..ss)._mode~3asurrogate-text~25))",[0,[1,"mode:surrogate-text%"]],["framework"]],
["mode:surrogate-text<%>",">framework/Mode.html#(def._((lib._framework/main..ss)._mode~3asurrogate-text~3c~25~3e))",[0,[1,"mode:surrogate-text&lt;%&gt;"]],["framework"]],
["modelt",">teachpack/arrow-gui.html#(tech._modelt)","<i>modelT</i>",false],
["modern",">gui/font_.html#(idx._(gentag._199._(lib._scribblings/gui/gui..scrbl)))",[7,"'modern"],false],
["modern",">gui/style-delta_.html#(idx._(gentag._284._(lib._scribblings/gui/gui..scrbl)))",[7,"'modern"],false],
["modes",">tools/Editor_Modes.html#(idx._(gentag._12._(lib._scribblings/tools/tools..scrbl)))","modes",false],
["modes and colors",">teachpack/image.html#(part._modes-colors)","Modes and Colors",false],
["modified",">gui/editor-admin_.html#(meth._(((lib._mred/main..ss)._editor-admin~25)._modified))",[[0,[1,"modified"]],[12,[" (method of ",[0,[1,"editor-admin%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["modified",">gui/frame_.html#(meth._(((lib._mred/main..ss)._frame~25)._modified))",[[0,[1,"modified"]],[12,[" (method of ",[0,[1,"frame%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["modified",">gui/snip-admin_.html#(meth._(((lib._mred/main..ss)._snip-admin~25)._modified))",[[0,[1,"modified"]],[12,[" (method of ",[0,[1,"snip-admin%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["modified-julian-day->date",">srfi-std/srfi-19.html#modified-julian-day->date",[0,[1,"modified-julian-day-&gt;date"]],["srfi/19"]],
["modified-julian-day->time-monotonic",">srfi-std/srfi-19.html#modified-julian-day->time-monotonic",[0,[1,"modified-julian-day-&gt;time-monotonic"]],["srfi/19"]],
["modified-julian-day->time-tai",">srfi-std/srfi-19.html#modified-julian-day->time-tai",[0,[1,"modified-julian-day-&gt;time-tai"]],["srfi/19"]],
["modified-julian-day->time-utc",">srfi-std/srfi-19.html#modified-julian-day->time-utc",[0,[1,"modified-julian-day-&gt;time-utc"]],["srfi/19"]],
["modifiers",">htdc/advanced_mods.html",[0,"Modifiers"],false],
["modifiers",">htdc/intermedAcc_mods.html",[0,"Modifiers"],false],
["module",">reference/module.html#(form._((quote._~23~25kernel)._module))",[0,[6,"module"]],["scheme/base","scheme"]],
["module",">inside/im_env.html#(idx._(gentag._239._(lib._scribblings/inside/inside..scrbl)))","module",false],
["module basics",">guide/module-basics.html","Module Basics",false],
["module binding",">reference/syntax-model.html#(tech._module._binding)","<i>module binding</i>",false],
["module browser... menu item",">drscheme/Menus.html#(idx._(gentag._124._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Module Browser...</font></b> menu item",false],
["module context",">reference/syntax-model.html#(tech._module._context)","<i>module context</i>",false],
["module language",">drscheme/module.html#(idx._(gentag._39._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Module</font></b> language",false],
["module mode",">guide/mzscheme.html#(part._start-module-mode)","Module Mode",false],
["module name resolver",">reference/Module_Names_and_Loading.html#(tech._module._name._resolver)","<i>module name\nresolver</i>",false],
["module names and loading",">reference/Module_Names_and_Loading.html","Module Names and Loading",false],
["module path",">guide/module-paths.html#(tech._module._path)","<i>module path</i>",false],
["module path",">reference/Module_Names_and_Loading.html#(tech._module._path)","<i>module path</i>",false],
["module path index",">reference/Module_Names_and_Loading.html#(tech._module._path._index)","<i>module path index</i>",false],
["module path resolver",">reference/Module_Names_and_Loading.html#(tech._module._path._resolver)","<i>module path resolver</i>",false],
["module paths",">guide/module-paths.html","Module Paths",false],
["module phases and visits",">reference/syntax-model.html#(part._mod-parse)","Module Phases and Visits",false],
["module re-declarations",">reference/eval-model.html#(part._module-redeclare)","Module Re-declarations",false],
["module reader",">syntax/reader-helpers.html#(part._module-reader)","Module Reader",false],
["module registry",">reference/syntax-model.html#(tech._module._registry)","<i>module registry</i>",false],
["module syntax",">guide/Module_Syntax.html","Module Syntax",false],
["module->language-info",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._module-~3elanguage-info))",[0,[1,"module-&gt;language-info"]],["scheme/base","scheme"]],
["module->namespace",">reference/Namespaces.html#(def._((quote._~23~25kernel)._module-~3enamespace))",[0,[1,"module-&gt;namespace"]],["scheme/base","scheme"]],
["module-begin context",">reference/syntax-model.html#(tech._module._begin._context)","<i>module-begin context</i>",false],
["module-compiled-exports",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._module-compiled-exports))",[0,[1,"module-compiled-exports"]],["scheme/base","scheme"]],
["module-compiled-imports",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._module-compiled-imports))",[0,[1,"module-compiled-imports"]],["scheme/base","scheme"]],
["module-compiled-language-info",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._module-compiled-language-info))",[0,[1,"module-compiled-language-info"]],["scheme/base","scheme"]],
["module-compiled-name",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._module-compiled-name))",[0,[1,"module-compiled-name"]],["scheme/base","scheme"]],
["module-direct-for-syntax-requires",">reference/Expanding_Top-Level_Forms.html#(idx._(gentag._93._(lib._scribblings/reference/reference..scrbl)))",[7,"'module-direct-for-syntax-requires"],false],
["module-direct-for-template-requires",">reference/Expanding_Top-Level_Forms.html#(idx._(gentag._94._(lib._scribblings/reference/reference..scrbl)))",[7,"'module-direct-for-template-requires"],false],
["module-direct-requires",">reference/Expanding_Top-Level_Forms.html#(idx._(gentag._92._(lib._scribblings/reference/reference..scrbl)))",[7,"'module-direct-requires"],false],
["module-identifier-mapping-for-each",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..ss)._module-identifier-mapping-for-each))",[0,[1,"module-identifier-mapping-for-each"]],["syntax/boundmap"]],
["module-identifier-mapping-get",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..ss)._module-identifier-mapping-get))",[0,[1,"module-identifier-mapping-get"]],["syntax/boundmap"]],
["module-identifier-mapping-map",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..ss)._module-identifier-mapping-map))",[0,[1,"module-identifier-mapping-map"]],["syntax/boundmap"]],
["module-identifier-mapping-put!",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..ss)._module-identifier-mapping-put!))",[0,[1,"module-identifier-mapping-put!"]],["syntax/boundmap"]],
["module-identifier-mapping?",">syntax/syntax-helpers.html#(def._((lib._syntax/boundmap..ss)._module-identifier-mapping~3f))",[0,[1,"module-identifier-mapping?"]],["syntax/boundmap"]],
["module-identifier=?",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..ss)._module-identifier~3d~3f))",[0,[1,"module-identifier=?"]],["mzscheme"]],
["module-indirect-provides",">reference/Expanding_Top-Level_Forms.html#(idx._(gentag._97._(lib._scribblings/reference/reference..scrbl)))",[7,"'module-indirect-provides"],false],
["module-label-identifier=?",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..ss)._module-label-identifier~3d~3f))",[0,[1,"module-label-identifier=?"]],["mzscheme"]],
["module-language",">reference/Module_Names_and_Loading.html#(idx._(gentag._202._(lib._scribblings/reference/reference..scrbl)))",[7,"'module-language"],false],
["module-language",">reference/module.html#(idx._(gentag._3._(lib._scribblings/reference/reference..scrbl)))",[7,"'module-language"],false],
["module-level variable",">reference/eval-model.html#(tech._module._level._variable)","<i>module-level\nvariable</i>",false],
["module-or-top-identifier=?",">syntax/syntax-helpers.html#(def._((lib._syntax/stx..ss)._module-or-top-identifier~3d~3f))",[0,[1,"module-or-top-identifier=?"]],["syntax/stx"]],
["module-path-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._module-path-index-desc))",[0,[1,"module-path-index-desc"]],["scribble/manual-struct"]],
["module-path-index-desc?",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._module-path-index-desc~3f))",[0,[1,"module-path-index-desc?"]],["scribble/manual-struct"]],
["module-path-index-join",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._module-path-index-join))",[0,[1,"module-path-index-join"]],["scheme/base","scheme"]],
["module-path-index-resolve",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._module-path-index-resolve))",[0,[1,"module-path-index-resolve"]],["scheme/base","scheme"]],
["module-path-index-split",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._module-path-index-split))",[0,[1,"module-path-index-split"]],["scheme/base","scheme"]],
["module-path-index?",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._module-path-index~3f))",[0,[1,"module-path-index?"]],["scheme/base","scheme"]],
["module-path-prefix->string",">scribble/basic.html#(def._((lib._scribble/basic..ss)._module-path-prefix-~3estring))",[0,[1,"module-path-prefix-&gt;string"]],["scribble/basic"]],
["module-path?",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._module-path~3f))",[0,[1,"module-path?"]],["scheme/base","scheme"]],
["module-processing helpers",">syntax/module-helpers.html","Module-Processing Helpers",false],
["module-provide-protected?",">reference/Namespaces.html#(def._((quote._~23~25kernel)._module-provide-protected~3f))",[0,[1,"module-provide-protected?"]],["scheme/base","scheme"]],
["module-syntax-provides",">reference/Expanding_Top-Level_Forms.html#(idx._(gentag._96._(lib._scribblings/reference/reference..scrbl)))",[7,"'module-syntax-provides"],false],
["module-template-identifier=?",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..ss)._module-template-identifier~3d~3f))",[0,[1,"module-template-identifier=?"]],["mzscheme"]],
["module-transformer-identifier=?",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..ss)._module-transformer-identifier~3d~3f))",[0,[1,"module-transformer-identifier=?"]],["mzscheme"]],
["module-variable-provides",">reference/Expanding_Top-Level_Forms.html#(idx._(gentag._95._(lib._scribblings/reference/reference..scrbl)))",[7,"'module-variable-provides"],false],
["modules re-define",">reference/eval-model.html#(idx._(gentag._0._(lib._scribblings/reference/reference..scrbl)))","modules, re-define",false],
["modules imports",">reference/require.html","modules, imports",false],
["modules exports",">reference/require.html","modules, exports",false],
["modules",">drscheme/module.html","Modules",false],
["modules",">guide/modules.html","Modules",false],
["modules",">quick/index.html#(part._.Modules)","Modules",false],
["modules and module-level variables",">reference/eval-model.html#(part._module-eval-model)","Modules and Module-Level Variables",false],
["modules and performance",">guide/performance.html#(part._.Modules_and_.Performance)","Modules and Performance",false],
["modules: module, ...",">reference/module.html",["Modules: ",[0,[6,"module"]],", ..."],false],
["modulo",">reference/numbers.html#(def._((quote._~23~25kernel)._modulo))",[0,[1,"modulo"]],["scheme/base","scheme"]],
["modulo",">r5rs-std/r5rs-Z-H-9.html#%_idx_304",[0,[1,"modulo"]],["r5rs"]],
["modulo",">r6rs-lib-std/r6rs-lib-Z-H-20.html#node_idx_1294",[0,[1,"modulo"]],["rnrs/r5rs-6"]],
["modulo",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._modulo))",[0,[1,"modulo"]],["lang/htdp-advanced"]],
["modulo",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._modulo))",[0,[1,"modulo"]],["lang/htdp-beginner"]],
["modulo",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._modulo))",[0,[1,"modulo"]],["lang/htdp-beginner-abbr"]],
["modulo",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._modulo))",[0,[1,"modulo"]],["lang/htdp-intermediate"]],
["modulo",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._modulo))",[0,[1,"modulo"]],["lang/htdp-intermediate-lambda"]],
["more file and directory utilities",">reference/Filesystem.html#(part._file-lib)","More File and Directory Utilities",false],
["more libraries",">guide/More_Libraries.html","More Libraries",false],
["more path utilities",">reference/More_Path_Utilities.html","More Path Utilities",false],
["more pict constructors",">slideshow/More_Pict_Constructors.html","More Pict Constructors",false],
["more port constructors and events",">reference/More_Port_Constructors_and_Events.html","More Port Constructors and Events",false],
["more structure type options",">guide/define-struct.html#(part._struct-options)","More Structure Type Options",false],
["more: systems programming with plt scheme",">more/index.html","<b>More</b>: Systems Programming with PLT Scheme",false],
["most recent window menu item",">drscheme/Menus.html#(idx._(gentag._144._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Most Recent Window</font></b> menu item",false],
["most-recent-slide",">slideshow/Slide_Registration.html#(def._((lib._slideshow/base..ss)._most-recent-slide))",[0,[1,"most-recent-slide"]],["slideshow/base","slideshow"]],
["mouse and keyboard events",">gui/windowing-overview.html#(part._mouseandkey)","Mouse and Keyboard Events",false],
["mouse events overview",">gui/windowing-overview.html#(idx._(gentag._2._(lib._scribblings/gui/gui..scrbl)))","mouse events, overview",false],
["mouse operations",">graphics/Mouse_Operations.html","Mouse Operations",false],
["mouse-click-posn",">graphics/Mouse_Operations.html#(def._((lib._graphics/graphics..ss)._mouse-click-posn))",[0,[1,"mouse-click-posn"]],["graphics/graphics"]],
["mouse-event%",">gui/mouse-event_.html",[0,[1,"mouse-event%"]],["scheme/gui/base","scheme/gui"]],
["mousedown?",">mysterx/html-events.html#(meth._(((lib._mysterx/main..ss)._mx-event~3c~25~3e)._mousedown~3f))",[[0,[1,"mousedown?"]],[12,[" (method of ",[0,[1,"mx-event&lt;%&gt;"]],")"]]],["mysterx"]],
["mouseevent",">teachpack/world.html#(tech._mouseevent)","<i>MouseEvent</i>",false],
["mousemove?",">mysterx/html-events.html#(meth._(((lib._mysterx/main..ss)._mx-event~3c~25~3e)._mousemove~3f))",[[0,[1,"mousemove?"]],[12,[" (method of ",[0,[1,"mx-event&lt;%&gt;"]],")"]]],["mysterx"]],
["mouseout?",">mysterx/html-events.html#(meth._(((lib._mysterx/main..ss)._mx-event~3c~25~3e)._mouseout~3f))",[[0,[1,"mouseout?"]],[12,[" (method of ",[0,[1,"mx-event&lt;%&gt;"]],")"]]],["mysterx"]],
["mouseover?",">mysterx/html-events.html#(meth._(((lib._mysterx/main..ss)._mx-event~3c~25~3e)._mouseover~3f))",[[0,[1,"mouseover?"]],[12,[" (method of ",[0,[1,"mx-event&lt;%&gt;"]],")"]]],["mysterx"]],
["mouseup?",">mysterx/html-events.html#(meth._(((lib._mysterx/main..ss)._mx-event~3c~25~3e)._mouseup~3f))",[[0,[1,"mouseup?"]],[12,[" (method of ",[0,[1,"mx-event&lt;%&gt;"]],")"]]],["mysterx"]],
["move",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._move))",[[0,[1,"move"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["move",">gui/top-level-window___.html#(meth._(((lib._mred/main..ss)._top-level-window~3c~25~3e)._move))",[[0,[1,"move"]],[12,[" (method of ",[0,[1,"top-level-window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["move",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtles..ss)._move))",[0,[1,"move"]],["graphics/turtles"]],
["move",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles..ss)._move))",[0,[1,"move"]],["graphics/value-turtles"]],
["move-card",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._move-card))",[[0,[1,"move-card"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["move-cards",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._move-cards))",[[0,[1,"move-cards"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["move-cards-to-region",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._move-cards-to-region))",[[0,[1,"move-cards-to-region"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["move-offset",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtles..ss)._move-offset))",[0,[1,"move-offset"]],["graphics/turtles"]],
["move-offset",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles..ss)._move-offset))",[0,"move-offset"],["graphics/value-turtles"]],
["move-pinhole",">teachpack/image.html#(def._((lib._htdp/image..ss)._move-pinhole))",[0,[1,"move-pinhole"]],["teachpack/htdp/image"]],
["move-position",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._move-position))",[[0,[1,"move-position"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["move-sexp-out",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._move-sexp-out))",[[0,[1,"move-sexp-out"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["move-to",">gui/dc-path_.html#(meth._(((lib._mred/main..ss)._dc-path~25)._move-to))",[[0,[1,"move-to"]],[12,[" (method of ",[0,[1,"dc-path%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["move-to",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._move-to))",[[0,[1,"move-to"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["move/copy-to-edit",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3abasic~3c~25~3e)._move/copy-to-edit))",[[0,[1,"move/copy-to-edit"]],[12,[" (method of ",[0,[1,"text:basic&lt;%&gt;"]],")"]]],["framework"]],
["moving around",">drscheme/Keyboard_Shortcuts.html#(part._.Moving_.Around)","Moving Around",false],
["moving forward",">continue/index.html#(part._.Moving_.Forward)","Moving Forward",false],
["moving?",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._moving~3f))",[[0,[1,"moving?"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["mpair?",">reference/mpairs.html#(def._((quote._~23~25kernel)._mpair~3f))",[0,[1,"mpair?"]],["scheme/base","scheme"]],
["mr. potatohead",">slideshow/More_Pict_Constructors.html#(idx._(gentag._0._(lib._scribblings/slideshow/slideshow..scrbl)))","Mr. Potatohead",false],
["mred",">reference/running-sa.html#(idx._(gentag._314._(lib._scribblings/reference/reference..scrbl)))",[5,"mred"],false],
["mred-launcher-add-suffix",">mzc/launcher.html#(def._((lib._launcher/launcher..ss)._mred-launcher-add-suffix))",[0,[1,"mred-launcher-add-suffix"]],["launcher/launcher"]],
["mred-launcher-is-actually-directory?",">mzc/launcher.html#(def._((lib._launcher/launcher..ss)._mred-launcher-is-actually-directory~3f))",[0,[1,"mred-launcher-is-actually-directory?"]],["launcher/launcher"]],
["mred-launcher-is-directory?",">mzc/launcher.html#(def._((lib._launcher/launcher..ss)._mred-launcher-is-directory~3f))",[0,[1,"mred-launcher-is-directory?"]],["launcher/launcher"]],
["mred-launcher-put-file-extension+style+filters",">mzc/launcher.html#(def._((lib._launcher/launcher..ss)._mred-launcher-put-file-extension+style+filters))",[0,[1,"mred-launcher-put-file-extension+style+filters"]],["launcher/launcher"]],
["mred-launcher-up-to-date?",">mzc/launcher.html#(def._((lib._launcher/launcher..ss)._mred-launcher-up-to-date~3f))",[0,[1,"mred-launcher-up-to-date?"]],["launcher/launcher"]],
["mred-program-launcher-path",">mzc/launcher.html#(def._((lib._launcher/launcher..ss)._mred-program-launcher-path))",[0,[1,"mred-program-launcher-path"]],["launcher/launcher"]],
["mred.app",">reference/running-sa.html#(idx._(gentag._316._(lib._scribblings/reference/reference..scrbl)))",[5,"MrEd.app"],false],
["mred.exe",">reference/running-sa.html#(idx._(gentag._315._(lib._scribblings/reference/reference..scrbl)))",[5,"MrEd.exe"],false],
["mred:altupselectsmenu preference",">gui/mredprefs.html#(idx._(gentag._293._(lib._scribblings/gui/gui..scrbl)))",[[7,"'MrEd:altUpSelectsMenu"],"\npreference"],false],
["mred:controlfontsize preference",">gui/mredprefs.html#(idx._(gentag._291._(lib._scribblings/gui/gui..scrbl)))",[[7,"'MrEd:controlFontSize"],"\npreference"],false],
["mred:default-font-size preference",">gui/style-list_.html#(idx._(gentag._288._(lib._scribblings/gui/gui..scrbl)))",[[7,"'MrEd:default-font-size"],"\npreference"],false],
["mred:default-font-size preference",">gui/mredprefs.html#(idx._(gentag._290._(lib._scribblings/gui/gui..scrbl)))",[[7,"'MrEd:default-font-size"],"\npreference"],false],
["mred:defaultmenuprefix preference",">gui/mredprefs.html#(idx._(gentag._292._(lib._scribblings/gui/gui..scrbl)))",[[7,"'MrEd:defaultMenuPrefix"],"\npreference"],false],
["mred:doubleclicktime preference",">gui/keymap_.html#(idx._(gentag._244._(lib._scribblings/gui/gui..scrbl)))",[[7,"'MrEd:doubleClickTime"],"\npreference"],false],
["mred:doubleclicktime preference",">gui/mredprefs.html#(idx._(gentag._301._(lib._scribblings/gui/gui..scrbl)))",[[7,"'MrEd:doubleClickTime"],"\npreference"],false],
["mred:emacsundo preference",">gui/mredprefs.html#(idx._(gentag._294._(lib._scribblings/gui/gui..scrbl)))",[[7,"'MrEd:emacsUndo"],"\npreference"],false],
["mred:forcefocus preference",">gui/mredprefs.html#(idx._(gentag._300._(lib._scribblings/gui/gui..scrbl)))",[[7,"'MrEd:forceFocus"],"\npreference"],false],
["mred:gamma preference",">gui/bitmap_.html#(idx._(gentag._170._(lib._scribblings/gui/gui..scrbl)))",[[7,"'MrEd:gamma"],"\npreference"],false],
["mred:gamma preference",">gui/mredprefs.html#(idx._(gentag._302._(lib._scribblings/gui/gui..scrbl)))",[[7,"'MrEd:gamma"],"\npreference"],false],
["mred:hilitecolor preference",">gui/brush_.html#(idx._(gentag._181._(lib._scribblings/gui/gui..scrbl)))",[[7,"'MrEd:hiliteColor"],"\npreference"],false],
["mred:hilitecolor preference",">gui/mredprefs.html#(idx._(gentag._295._(lib._scribblings/gui/gui..scrbl)))",[[7,"'MrEd:hiliteColor"],"\npreference"],false],
["mred:hilitemenuborder preference",">gui/mredprefs.html#(idx._(gentag._296._(lib._scribblings/gui/gui..scrbl)))",[[7,"'MrEd:hiliteMenuBorder"],"\npreference"],false],
["mred:outlineinactiveselection preference",">gui/mredprefs.html#(idx._(gentag._298._(lib._scribblings/gui/gui..scrbl)))",[[7,"'MrEd:outlineInactiveSelection"],"\npreference"],false],
["mred:playcmd preference",">gui/Windowing_Functions.html#(idx._(gentag._160._(lib._scribblings/gui/gui..scrbl)))",[[7,"'MrEd:playcmd"],"\npreference"],false],
["mred:playcmd preference",">gui/mredprefs.html#(idx._(gentag._299._(lib._scribblings/gui/gui..scrbl)))",[[7,"'MrEd:playcmd"],"\npreference"],false],
["mred:selectionasclipboard preference",">gui/mredprefs.html#(idx._(gentag._303._(lib._scribblings/gui/gui..scrbl)))",[[7,"'MrEd:selectionAsClipboard"],"\npreference"],false],
["mred:selectionasclipboard preference",">gui/clipboard___.html#(idx._(gentag._41._(lib._scribblings/gui/gui..scrbl)))",[[7,"'MrEd:selectionAsClipboard"],"\npreference"],false],
["mred:wheelstep preference",">gui/editor-canvas_.html#(idx._(gentag._237._(lib._scribblings/gui/gui..scrbl)))",[[7,"'MrEd:wheelStep"],"\npreference"],false],
["mred:wheelstep preference",">gui/mredprefs.html#(idx._(gentag._297._(lib._scribblings/gui/gui..scrbl)))",[[7,"'MrEd:wheelStep"],"\npreference"],false],
["mredrc.ss",">gui/Windowing_Functions.html#(idx._(gentag._151._(lib._scribblings/gui/gui..scrbl)))",[5,"\"mredrc.ss\""],false],
["mreverse",">reference/mpairs.html#(def._((lib._scheme/mpair..ss)._mreverse))",[0,[1,"mreverse"]],["scheme/mpair"]],
["mreverse!",">reference/mpairs.html#(def._((lib._scheme/mpair..ss)._mreverse!))",[0,[1,"mreverse!"]],["scheme/mpair"]],
["mrlib/aligned-pasteboard",">mrlib/Aligned_Pasteboard.html",[14,[0,"mrlib/aligned-pasteboard"]],"module"],
["mrlib/bitmap-label",">mrlib/Bitmap_Label.html",[14,[0,"mrlib/bitmap-label"]],"module"],
["mrlib/cache-image-snip",">mrlib/Cache-image_Snip.html",[14,[0,"mrlib/cache-image-snip"]],"module"],
["mrlib/close-icon",">mrlib/Close_Icon.html",[14,[0,"mrlib/close-icon"]],"module"],
["mrlib/gif",">mrlib/GIF_and_Animated_GIF_Writing.html",[14,[0,"mrlib/gif"]],"module"],
["mrlib/graph",">mrlib/Graphs.html",[14,[0,"mrlib/graph"]],"module"],
["mrlib/hierlist",">mrlib/Hierarchical_List_Control.html",[14,[0,"mrlib/hierlist"]],"module"],
["mrlib/include-bitmap",">mrlib/Include_Bitmap.html",[14,[0,"mrlib/include-bitmap"]],"module"],
["mrlib/interactive-value-port",">mrlib/Interactive_Value_Port.html",[14,[0,"mrlib/interactive-value-port"]],"module"],
["mrlib/name-message",">mrlib/Name_Message.html",[14,[0,"mrlib/name-message"]],"module"],
["mrlib/path-dialog",">mrlib/Path_Dialog.html",[14,[0,"mrlib/path-dialog"]],"module"],
["mrlib/plot",">mrlib/Plot.html",[14,[0,"mrlib/plot"]],"module"],
["mrlib/switchable-button",">mrlib/Switchable_Button.html",[14,[0,"mrlib/switchable-button"]],"module"],
["mrlib/tex-table",">mrlib/TeX_Table.html",[14,[0,"mrlib/tex-table"]],"module"],
["mrlib: extra gui libraries",">mrlib/index.html","<b>MrLib</b>: Extra GUI Libraries",false],
["mult-color<%>",">gui/mult-color___.html",[0,[1,"mult-color&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["multi-line mode",">guide/regexp-clusters.html#(tech._multi._line._mode)","<i>multi-line mode</i>",false],
["multi-page sections",">scribble/How_to_Scribble_Documentation.html#(part._.Multi-.Page_.Sections)","Multi-Page Sections",false],
["multimedia file format",">drscheme/drscheme-files.html#(tech._multimedia._file._format)","<i>Multimedia file format</i>",false],
["multiple",">gui/Windowing_Functions.html#(idx._(gentag._147._(lib._scribblings/gui/gui..scrbl)))",[7,"'multiple"],false],
["multiple result values",">guide/contracts-general-functions.html#(part._contracts-multiple)","Multiple Result Values",false],
["multiple return values",">reference/eval-model.html#(part._values-model)","Multiple Return Values",false],
["multiple values",">inside/Evaluation.html#(part._multiple)","Multiple Values",false],
["multiple values",">reference/values.html","Multiple Values",false],
["multiple values",">reference/eval-model.html#(tech._multiple._value)","<i>multiple values</i>",false],
["multiple values and define-values",">guide/define.html#(part._multiple-values)",["Multiple Values and ",[0,[6,"define-values"]]],false],
["multiple values: let-values, let*-values, letrec-values",">guide/let.html#(part._.Multiple_.Values__let-values__let_-values__letrec-values)",["Multiple Values: ",[0,[6,"let-values"]],", ",[0,[6,"let*-values"]],", ",[0,[6,"letrec-values"]]],false],
["multiple values: set!-values",">guide/set_.html#(part._.Multiple_.Values__set_-values)",["Multiple Values: ",[0,[6,"set!-values"]]],false],
["multiple-valued sequences",">guide/for.html#(part._.Multiple-.Valued_.Sequences)","Multiple-Valued Sequences",false],
["multiply",">gui/key-event_.html#(idx._(gentag._80._(lib._scribblings/gui/gui..scrbl)))",[7,"'multiply"],false],
["must-truncate",">reference/file-ports.html#(idx._(gentag._110._(lib._scribblings/reference/reference..scrbl)))",[7,"'must-truncate"],false],
["mutable",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_292",[0,[6,"mutable"]],["rnrs/records/syntactic-6"]],
["mutable list",">reference/mpairs.html#(tech._mutable._list)","<i>mutable list</i>",false],
["mutable list functions",">reference/mpairs.html#(part._.Mutable_.List_.Functions)","Mutable List Functions",false],
["mutable pair",">reference/mpairs.html#(tech._mutable._pair)","<i>mutable pair</i>",false],
["mutable pair constructors and selectors",">reference/mpairs.html#(part._.Mutable_.Pair_.Constructors_and_.Selectors)","Mutable Pair Constructors and Selectors",false],
["mutable pairs and lists",">reference/mpairs.html","Mutable Pairs and Lists",false],
["mutation and performance",">guide/performance.html#(part._.Mutation_and_.Performance)","Mutation and Performance",false],
["mutator",">guide/define-struct.html#(tech._mutator)","<i>mutator</i>",false],
["mutator",">reference/define-struct.html#(tech._mutator)","<i>mutator</i>",false],
["mx-any",">mysterx/com-types.html#(idx._(gentag._1._(lib._mysterx/scribblings/mysterx..scrbl)))",[7,"'mx-any"],false],
["mx-browser%",">mysterx/browsers.html#(def._((lib._mysterx/main..ss)._mx-browser~25))",[0,[1,"mx-browser%"]],["mysterx"]],
["mx-document<%>",">mysterx/documents.html#(def._((lib._mysterx/main..ss)._mx-document~3c~25~3e))",[0,[1,"mx-document&lt;%&gt;"]],["mysterx"]],
["mx-element%",">mysterx/html-element.html#(def._((lib._mysterx/main..ss)._mx-element~25))",[0,[1,"mx-element%"]],["mysterx"]],
["mx-event<%>",">mysterx/html-events.html#(def._((lib._mysterx/main..ss)._mx-event~3c~25~3e))",[0,[1,"mx-event&lt;%&gt;"]],["mysterx"]],
["mx-version",">mysterx/version.html#(def._((lib._mysterx/main..ss)._mx-version))",[0,[1,"mx-version"]],["mysterx"]],
["mysterx",">mysterx/index.html",[14,[0,"mysterx"]],"module"],
["mysterx: using windows com objects in scheme",">mysterx/index.html","<b>MysterX</b>: Using Windows COM Objects in Scheme",false],
["mzc",">inside/overview.html#(idx._(gentag._5._(lib._scribblings/inside/inside..scrbl)))",[5,"mzc"],false],
["mzc: plt compilation and packaging",">mzc/index.html",[[5,"mzc"],": PLT Compilation and Packaging"],false],
["mzcom: scheme as a windows com object",">mzcom/index.html","<b>MzCOM</b>: Scheme as a Windows COM Object",false],
["mzconfig_allow_set_undefined",">inside/config.html#(idx._(gentag._353._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_ALLOW_SET_UNDEFINED"]],false],
["mzconfig_can_read_box",">inside/config.html#(idx._(gentag._344._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_CAN_READ_BOX"]],false],
["mzconfig_can_read_compiled",">inside/config.html#(idx._(gentag._343._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_CAN_READ_COMPILED"]],false],
["mzconfig_can_read_graph",">inside/config.html#(idx._(gentag._342._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_CAN_READ_GRAPH"]],false],
["mzconfig_can_read_pipe_quote",">inside/config.html#(idx._(gentag._345._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_CAN_READ_PIPE_QUOTE"]],false],
["mzconfig_case_sens",">inside/config.html#(idx._(gentag._349._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_CASE_SENS"]],false],
["mzconfig_collection_paths",">inside/config.html#(idx._(gentag._357._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_COLLECTION_PATHS"]],false],
["mzconfig_curly_braces_are_parens",">inside/config.html#(idx._(gentag._351._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_CURLY_BRACES_ARE_PARENS"]],false],
["mzconfig_custodian",">inside/config.html#(idx._(gentag._354._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_CUSTODIAN"]],false],
["mzconfig_env",">inside/config.html#(idx._(gentag._330._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_ENV"]],false],
["mzconfig_error_display_handler",">inside/config.html#(idx._(gentag._334._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_ERROR_DISPLAY_HANDLER"]],false],
["mzconfig_error_port",">inside/config.html#(idx._(gentag._333._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_ERROR_PORT"]],false],
["mzconfig_error_print_value_handler",">inside/config.html#(idx._(gentag._335._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_ERROR_PRINT_VALUE_HANDLER"]],false],
["mzconfig_error_print_width",">inside/config.html#(idx._(gentag._352._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_ERROR_PRINT_WIDTH"]],false],
["mzconfig_eval_handler",">inside/config.html#(idx._(gentag._338._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_EVAL_HANDLER"]],false],
["mzconfig_exit_handler",">inside/config.html#(idx._(gentag._336._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_EXIT_HANDLER"]],false],
["mzconfig_init_exn_handler",">inside/config.html#(idx._(gentag._337._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_INIT_EXN_HANDLER"]],false],
["mzconfig_input_port",">inside/config.html#(idx._(gentag._331._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_INPUT_PORT"]],false],
["mzconfig_load_directory",">inside/config.html#(idx._(gentag._356._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_LOAD_DIRECTORY"]],false],
["mzconfig_load_extension_handler",">inside/config.html#(idx._(gentag._359._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_LOAD_EXTENSION_HANDLER"]],false],
["mzconfig_load_handler",">inside/config.html#(idx._(gentag._339._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_LOAD_HANDLER"]],false],
["mzconfig_output_port",">inside/config.html#(idx._(gentag._332._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_OUTPUT_PORT"]],false],
["mzconfig_port_print_handler",">inside/config.html#(idx._(gentag._358._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_PORT_PRINT_HANDLER"]],false],
["mzconfig_print_box",">inside/config.html#(idx._(gentag._348._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_PRINT_BOX"]],false],
["mzconfig_print_graph",">inside/config.html#(idx._(gentag._346._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_PRINT_GRAPH"]],false],
["mzconfig_print_handler",">inside/config.html#(idx._(gentag._340._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_PRINT_HANDLER"]],false],
["mzconfig_print_struct",">inside/config.html#(idx._(gentag._347._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_PRINT_STRUCT"]],false],
["mzconfig_prompt_read_handler",">inside/config.html#(idx._(gentag._341._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_PROMPT_READ_HANDLER"]],false],
["mzconfig_square_brackets_are_parens",">inside/config.html#(idx._(gentag._350._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_SQUARE_BRACKETS_ARE_PARENS"]],false],
["mzconfig_use_compiled_kind",">inside/config.html#(idx._(gentag._355._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"MZCONFIG_USE_COMPILED_KIND"]],false],
["mzlib/a-signature",">mzlib/mzlib_a-signature.html",[14,[0,"mzlib/a-signature"]],"module"],
["mzlib/a-unit",">mzlib/mzlib_a-unit.html",[14,[0,"mzlib/a-unit"]],"module"],
["mzlib/async-channel",">mzlib/mzlib_async-channel.html",[14,[0,"mzlib/async-channel"]],"module"],
["mzlib/awk",">mzlib/mzlib_awk.html",[14,[0,"mzlib/awk"]],"module"],
["mzlib/class",">mzlib/mzlib_class.html",[14,[0,"mzlib/class"]],"module"],
["mzlib/class100",">mzlib/mzlib_class100.html",[14,[0,"mzlib/class100"]],"module"],
["mzlib/cm",">mzlib/mzlib_cm.html",[14,[0,"mzlib/cm"]],"module"],
["mzlib/cm-accomplice",">mzlib/mzlib_cm-accomplice.html",[14,[0,"mzlib/cm-accomplice"]],"module"],
["mzlib/cmdline",">mzlib/mzlib_cmdline.html",[14,[0,"mzlib/cmdline"]],"module"],
["mzlib/cml",">mzlib/mzlib_cml.html",[14,[0,"mzlib/cml"]],"module"],
["mzlib/compat",">mzlib/mzlib_compat.html",[14,[0,"mzlib/compat"]],"module"],
["mzlib/compile",">mzlib/mzlib_compile.html",[14,[0,"mzlib/compile"]],"module"],
["mzlib/contract",">mzlib/mzlib_contract.html",[14,[0,"mzlib/contract"]],"module"],
["mzlib/control",">mzlib/mzlib_control.html",[14,[0,"mzlib/control"]],"module"],
["mzlib/date",">mzlib/mzlib_date.html",[14,[0,"mzlib/date"]],"module"],
["mzlib/deflate",">mzlib/mzlib_deflate.html",[14,[0,"mzlib/deflate"]],"module"],
["mzlib/defmacro",">mzlib/mzlib_defmacro.html",[14,[0,"mzlib/defmacro"]],"module"],
["mzlib/etc",">mzlib/mzlib_etc.html",[14,[0,"mzlib/etc"]],"module"],
["mzlib/file",">mzlib/mzlib_file.html",[14,[0,"mzlib/file"]],"module"],
["mzlib/for",">mzlib/mzlib_for.html",[14,[0,"mzlib/for"]],"module"],
["mzlib/foreign",">mzlib/mzlib_foreign.html",[14,[0,"mzlib/foreign"]],"module"],
["mzlib/include",">mzlib/mzlib_include.html",[14,[0,"mzlib/include"]],"module"],
["mzlib/inflate",">mzlib/mzlib_inflate.html",[14,[0,"mzlib/inflate"]],"module"],
["mzlib/integer-set",">mzlib/mzlib_integer-set.html",[14,[0,"mzlib/integer-set"]],"module"],
["mzlib/kw",">mzlib/mzlib_kw.html",[14,[0,"mzlib/kw"]],"module"],
["mzlib/list",">mzlib/mzlib_list.html",[14,[0,"mzlib/list"]],"module"],
["mzlib/match",">mzlib/mzlib_match.html",[14,[0,"mzlib/match"]],"module"],
["mzlib/math",">mzlib/mzlib_math.html",[14,[0,"mzlib/math"]],"module"],
["mzlib/md5",">mzlib/mzlib_md5.html",[14,[0,"mzlib/md5"]],"module"],
["mzlib/os",">mzlib/mzlib_os.html",[14,[0,"mzlib/os"]],"module"],
["mzlib/pconvert",">mzlib/mzlib_pconvert.html",[14,[0,"mzlib/pconvert"]],"module"],
["mzlib/pconvert-prop",">mzlib/mzlib_pconvert-prop.html",[14,[0,"mzlib/pconvert-prop"]],"module"],
["mzlib/plt-match",">mzlib/mzlib_plt-match.html",[14,[0,"mzlib/plt-match"]],"module"],
["mzlib/port",">mzlib/mzlib_port.html",[14,[0,"mzlib/port"]],"module"],
["mzlib/pregexp",">mzlib/mzlib_pregexp.html",[14,[0,"mzlib/pregexp"]],"module"],
["mzlib/pretty",">mzlib/mzlib_pretty.html",[14,[0,"mzlib/pretty"]],"module"],
["mzlib/process",">mzlib/mzlib_process.html",[14,[0,"mzlib/process"]],"module"],
["mzlib/restart",">mzlib/mzlib_restart.html",[14,[0,"mzlib/restart"]],"module"],
["mzlib/runtime-path",">mzlib/mzlib_runtime-path.html",[14,[0,"mzlib/runtime-path"]],"module"],
["mzlib/sandbox",">mzlib/mzlib_sandbox.html",[14,[0,"mzlib/sandbox"]],"module"],
["mzlib/sendevent",">mzlib/mzlib_sendevent.html",[14,[0,"mzlib/sendevent"]],"module"],
["mzlib/serialize",">mzlib/mzlib_serialize.html",[14,[0,"mzlib/serialize"]],"module"],
["mzlib/shared",">mzlib/mzlib_shared.html",[14,[0,"mzlib/shared"]],"module"],
["mzlib/string",">mzlib/mzlib_string.html",[14,[0,"mzlib/string"]],"module"],
["mzlib/struct",">mzlib/mzlib_struct.html",[14,[0,"mzlib/struct"]],"module"],
["mzlib/stxparam",">mzlib/mzlib_stxparam.html",[14,[0,"mzlib/stxparam"]],"module"],
["mzlib/surrogate",">mzlib/mzlib_surrogate.html",[14,[0,"mzlib/surrogate"]],"module"],
["mzlib/tar",">mzlib/mzlib_tar.html",[14,[0,"mzlib/tar"]],"module"],
["mzlib/thread",">mzlib/mzlib_thread.html",[14,[0,"mzlib/thread"]],"module"],
["mzlib/trace",">mzlib/mzlib_trace.html",[14,[0,"mzlib/trace"]],"module"],
["mzlib/traceld",">mzlib/mzlib_traceld.html",[14,[0,"mzlib/traceld"]],"module"],
["mzlib/trait",">mzlib/mzlib_trait.html",[14,[0,"mzlib/trait"]],"module"],
["mzlib/transcr",">mzlib/mzlib_transcr.html",[14,[0,"mzlib/transcr"]],"module"],
["mzlib/unit",">mzlib/mzlib_unit.html",[14,[0,"mzlib/unit"]],"module"],
["mzlib/unit-exptime",">mzlib/mzlib_unit-exptime.html",[14,[0,"mzlib/unit-exptime"]],"module"],
["mzlib/unit200",">mzlib/mzlib_unit200.html",[14,[0,"mzlib/unit200"]],"module"],
["mzlib/unitsig200",">mzlib/mzlib_unitsig200.html",[14,[0,"mzlib/unitsig200"]],"module"],
["mzlib/zip",">mzlib/mzlib_zip.html",[14,[0,"mzlib/zip"]],"module"],
["mzlib: legacy plt libraries",">mzlib/index.html","<b>MzLib</b>: Legacy PLT Libraries",false],
["mzpp",">preprocessor/mzpp.html",[5,"mzpp"],false],
["mzpp and mztext: preprocessors",">preprocessor/index.html",[[5,"mzpp"]," and ",[5,"mztext"],": Preprocessors"],false],
["mzpp files",">preprocessor/mzpp.html#(part._mzpp_files)","mzpp files",false],
["mzscheme",">mzscheme/index.html",[14,[0,"mzscheme"]],"module"],
["mzscheme",">reference/running-sa.html#(idx._(gentag._312._(lib._scribblings/reference/reference..scrbl)))",[5,"mzscheme"],false],
["mzscheme and threads",">inside/overview.html#(part._.Mz.Scheme_and_.Threads)","MzScheme and Threads",false],
["mzscheme, unicode, characters, and strings",">inside/overview.html#(part._im~3aunicode)","MzScheme, Unicode, Characters, and Strings",false],
["mzscheme-const-list",">slideshow/Typesetting_Scheme_Code.html#(def._((lib._slideshow/code..ss)._mzscheme-const-list))",[0,[1,"mzscheme-const-list"]],["slideshow/code"]],
["mzscheme-launcher-add-suffix",">mzc/launcher.html#(def._((lib._launcher/launcher..ss)._mzscheme-launcher-add-suffix))",[0,[1,"mzscheme-launcher-add-suffix"]],["launcher/launcher"]],
["mzscheme-launcher-is-actually-directory?",">mzc/launcher.html#(def._((lib._launcher/launcher..ss)._mzscheme-launcher-is-actually-directory~3f))",[0,[1,"mzscheme-launcher-is-actually-directory?"]],["launcher/launcher"]],
["mzscheme-launcher-is-directory?",">mzc/launcher.html#(def._((lib._launcher/launcher..ss)._mzscheme-launcher-is-directory~3f))",[0,[1,"mzscheme-launcher-is-directory?"]],["launcher/launcher"]],
["mzscheme-launcher-put-file-extension+style+filters",">mzc/launcher.html#(def._((lib._launcher/launcher..ss)._mzscheme-launcher-put-file-extension+style+filters))",[0,[1,"mzscheme-launcher-put-file-extension+style+filters"]],["launcher/launcher"]],
["mzscheme-launcher-up-to-date?",">mzc/launcher.html#(def._((lib._launcher/launcher..ss)._mzscheme-launcher-up-to-date~3f))",[0,[1,"mzscheme-launcher-up-to-date?"]],["launcher/launcher"]],
["mzscheme-program-launcher-path",">mzc/launcher.html#(def._((lib._launcher/launcher..ss)._mzscheme-program-launcher-path))",[0,[1,"mzscheme-program-launcher-path"]],["launcher/launcher"]],
["mzscheme.exe",">reference/running-sa.html#(idx._(gentag._313._(lib._scribblings/reference/reference..scrbl)))",[5,"MzScheme.exe"],false],
["mzscheme: legacy module language",">mzscheme/index.html","<b>MzScheme</b>: Legacy Module Language",false],
["mzschemerc.ss",">reference/Filesystem.html#(idx._(gentag._253._(lib._scribblings/reference/reference..scrbl)))",[5,"\"mzschemerc.ss\""],false],
["mztar",">setup-plt/_plt-archives.html#(def._((lib._setup/pack..ss)._mztar))",[0,[1,"mztar"]],["setup/pack"]],
["mztext",">preprocessor/mztext.html",[5,"mztext"],false],
["mztext processing: the standard command dispatcher",">preprocessor/mztext.html#(part._mztext_processing__the_standard_command_dispatcher)","mztext processing: the standard command dispatcher",false],
["nack-guard-evt",">reference/sync.html#(def._((quote._~23~25kernel)._nack-guard-evt))",[0,[1,"nack-guard-evt"]],["scheme/base","scheme"]],
["name",">mzc/Scheme_API_for_Compilation.html#(idx._(gentag._60._(lib._scribblings/mzc/mzc..scrbl)))",[0,"name"],false],
["name",">redex/Patterns.html#(tech._name)","<i>name</i>",false],
["name message",">mrlib/Name_Message.html","Name Message",false],
["name-message%",">mrlib/Name_Message.html#(def._((lib._mrlib/name-message..ss)._name-message~25))",[0,[1,"name-message%"]],["mrlib/name-message"]],
["named let",">guide/let.html#(part._.Named_let)",["Named ",[0,[6,"let"]]],false],
["named/undefined-handler",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..ss)._named/undefined-handler))",[0,[1,"named/undefined-handler"]],["mzlib/pconvert"]],
["namespace",">guide/eval.html#(tech._namespace)","<i>namespace</i>",false],
["namespace",">reference/syntax-model.html#(tech._namespace)","<i>namespace</i>",false],
["namespace-anchor->empty-namespace",">reference/Namespaces.html#(def._((lib._scheme/base..ss)._namespace-anchor-~3eempty-namespace))",[0,[1,"namespace-anchor-&gt;empty-namespace"]],["scheme/base","scheme"]],
["namespace-anchor->namespace",">reference/Namespaces.html#(def._((lib._scheme/base..ss)._namespace-anchor-~3enamespace))",[0,[1,"namespace-anchor-&gt;namespace"]],["scheme/base","scheme"]],
["namespace-anchor?",">reference/Namespaces.html#(def._((lib._scheme/base..ss)._namespace-anchor~3f))",[0,[1,"namespace-anchor?"]],["scheme/base","scheme"]],
["namespace-attach-module",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-attach-module))",[0,[1,"namespace-attach-module"]],["scheme/base","scheme"]],
["namespace-base-phase",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-base-phase))",[0,[1,"namespace-base-phase"]],["scheme/base","scheme"]],
["namespace-defined?",">mzlib/mzlib_etc.html#(def._((lib._mzlib/etc..ss)._namespace-defined~3f))",[0,[1,"namespace-defined?"]],["mzlib/etc"]],
["namespace-mapped-symbols",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-mapped-symbols))",[0,[1,"namespace-mapped-symbols"]],["scheme/base","scheme"]],
["namespace-module-identifier",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-module-identifier))",[0,[1,"namespace-module-identifier"]],["scheme/base","scheme"]],
["namespace-module-registry",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-module-registry))",[0,[1,"namespace-module-registry"]],["scheme/base","scheme"]],
["namespace-require",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-require))",[0,[1,"namespace-require"]],["scheme/base","scheme"]],
["namespace-require/constant",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-require/constant))",[0,[1,"namespace-require/constant"]],["scheme/base","scheme"]],
["namespace-require/copy",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-require/copy))",[0,[1,"namespace-require/copy"]],["scheme/base","scheme"]],
["namespace-require/expansion-time",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-require/expansion-time))",[0,[1,"namespace-require/expansion-time"]],["scheme/base","scheme"]],
["namespace-set-variable-value!",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-set-variable-value!))",[0,[1,"namespace-set-variable-value!"]],["scheme/base","scheme"]],
["namespace-symbol->identifier",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-symbol-~3eidentifier))",[0,[1,"namespace-symbol-&gt;identifier"]],["scheme/base","scheme"]],
["namespace-syntax-introduce",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-syntax-introduce))",[0,[1,"namespace-syntax-introduce"]],["scheme/base","scheme"]],
["namespace-transformer-require",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..ss)._namespace-transformer-require))",[0,[1,"namespace-transformer-require"]],["mzscheme"]],
["namespace-undefine-variable!",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-undefine-variable!))",[0,[1,"namespace-undefine-variable!"]],["scheme/base","scheme"]],
["namespace-unprotect-module",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-unprotect-module))",[0,[1,"namespace-unprotect-module"]],["scheme/base","scheme"]],
["namespace-variable-value",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace-variable-value))",[0,[1,"namespace-variable-value"]],["scheme/base","scheme"]],
["namespace?",">reference/Namespaces.html#(def._((quote._~23~25kernel)._namespace~3f))",[0,[1,"namespace?"]],["scheme/base","scheme"]],
["namespaces",">guide/eval.html#(part._namespaces)","Namespaces",false],
["namespaces",">reference/Namespaces.html","Namespaces",false],
["namespaces",">reference/syntax-model.html#(part._namespace-model)","Namespaces",false],
["namespaces and modules",">guide/eval.html#(part._.Namespaces_and_.Modules)","Namespaces and Modules",false],
["namespaces and modules",">inside/im_env.html","Namespaces and Modules",false],
["nan?",">r6rs-std/r6rs-Z-H-14.html#node_idx_488",[0,[1,"nan?"]],["rnrs/base-6"]],
["nand",">mzlib/mzlib_etc.html#(form._((lib._mzlib/etc..ss)._nand))",[0,[6,"nand"]],["mzlib/etc"]],
["native-endianness",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_78",[0,[1,"native-endianness"]],["rnrs/bytevectors-6"]],
["native-eol-style",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_598",[0,[1,"native-eol-style"]],["rnrs/io/ports-6"]],
["native-transcoder",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_622",[0,[1,"native-transcoder"]],["rnrs/io/ports-6"]],
["natural-number/c",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._natural-number/c))",[0,[1,"natural-number/c"]],["scheme/contract","scheme"]],
["navigate",">mysterx/browsers.html#(meth._(((lib._mysterx/main..ss)._mx-browser~25)._navigate))",[[0,[1,"navigate"]],[12,[" (method of ",[0,[1,"mx-browser%"]],")"]]],["mysterx"]],
["navigate-down",">macro-debugger/index.html#(meth._(((lib._macro-debugger/stepper..ss)._macro-stepper~3c~25~3e)._navigate-down))",["navigate-down",[12,[" (method of ",[0,[1,"macro-stepper&lt;%&gt;"]],")"]]],["macro-debugger/stepper"]],
["navigate-next",">macro-debugger/index.html#(meth._(((lib._macro-debugger/stepper..ss)._macro-stepper~3c~25~3e)._navigate-next))",["navigate-next",[12,[" (method of ",[0,[1,"macro-stepper&lt;%&gt;"]],")"]]],["macro-debugger/stepper"]],
["navigate-previous",">macro-debugger/index.html#(meth._(((lib._macro-debugger/stepper..ss)._macro-stepper~3c~25~3e)._navigate-previous))",["navigate-previous",[12,[" (method of ",[0,[1,"macro-stepper&lt;%&gt;"]],")"]]],["macro-debugger/stepper"]],
["navigate-to-end",">macro-debugger/index.html#(meth._(((lib._macro-debugger/stepper..ss)._macro-stepper~3c~25~3e)._navigate-to-end))",["navigate-to-end",[12,[" (method of ",[0,[1,"macro-stepper&lt;%&gt;"]],")"]]],["macro-debugger/stepper"]],
["navigate-to-start",">macro-debugger/index.html#(meth._(((lib._macro-debugger/stepper..ss)._macro-stepper~3c~25~3e)._navigate-to-start))",["navigate-to-start",[12,[" (method of ",[0,[1,"macro-stepper&lt;%&gt;"]],")"]]],["macro-debugger/stepper"]],
["navigate-up",">macro-debugger/index.html#(meth._(((lib._macro-debugger/stepper..ss)._macro-stepper~3c~25~3e)._navigate-up))",["navigate-up",[12,[" (method of ",[0,[1,"macro-stepper&lt;%&gt;"]],")"]]],["macro-debugger/stepper"]],
["navigate/status",">mysterx/browsers.html#(meth._(((lib._mysterx/main..ss)._mx-browser~25)._navigate/status))",[[0,[1,"navigate/status"]],[12,[" (method of ",[0,[1,"mx-browser%"]],")"]]],["mysterx"]],
["navigation",">macro-debugger/index.html#(part._.Navigation)","Navigation",false],
["nd",">reference/characters.html#(idx._(gentag._44._(lib._scribblings/reference/reference..scrbl)))",[7,"'nd"],false],
["neato",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..ss)._neato))",[0,[1,"neato"]],["graphics/turtle-examples"]],
["needs-execution",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3acontext~3c~25~3e)._needs-execution))",[[0,[1,"needs-execution"]],[12,[" (method of ",[0,[1,"drscheme:rep:context&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["needs-update",">gui/editor-admin_.html#(meth._(((lib._mred/main..ss)._editor-admin~25)._needs-update))",[[0,[1,"needs-update"]],[12,[" (method of ",[0,[1,"editor-admin%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["needs-update",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._needs-update))",[[0,[1,"needs-update"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["needs-update",">gui/snip-admin_.html#(meth._(((lib._mred/main..ss)._snip-admin~25)._needs-update))",[[0,[1,"needs-update"]],[12,[" (method of ",[0,[1,"snip-admin%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["negate",">reference/procedures.html#(def._((lib._scheme/function..ss)._negate))",[0,[1,"negate"]],["scheme/function","scheme"]],
["negative?",">reference/numbers.html#(def._((quote._~23~25kernel)._negative~3f))",[0,[1,"negative?"]],["scheme/base","scheme"]],
["negative?",">r5rs-std/r5rs-Z-H-9.html#%_idx_272",[0,[1,"negative?"]],["r5rs"]],
["negative?",">r6rs-std/r6rs-Z-H-14.html#node_idx_478",[0,[1,"negative?"]],["rnrs/base-6"]],
["negative?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._negative~3f))",[0,[1,"negative?"]],["lang/htdp-advanced"]],
["negative?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._negative~3f))",[0,[1,"negative?"]],["lang/htdp-beginner"]],
["negative?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._negative~3f))",[0,[1,"negative?"]],["lang/htdp-beginner-abbr"]],
["negative?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._negative~3f))",[0,[1,"negative?"]],["lang/htdp-intermediate"]],
["negative?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._negative~3f))",[0,[1,"negative?"]],["lang/htdp-intermediate-lambda"]],
["nest",">reference/nest.html#(form._((lib._scheme/nest..ss)._nest))",[0,[6,"nest"]],["scheme/nest","scheme"]],
["nested",">srfi-std/srfi-42.html#nested",[0,[6,"nested"]],["srfi/42"]],
["nested editors",">gui/WXME_Decoding.html#(part._.Nested_.Editors)","Nested Editors",false],
["net/base64",">net/base64.html",[14,[0,"net/base64"]],"module"],
["net/base64-sig",">net/base64.html#(mod-path._net/base64-sig)",[14,[0,"net/base64-sig"]],"module"],
["net/base64-unit",">net/base64.html#(mod-path._net/base64-unit)",[14,[0,"net/base64-unit"]],"module"],
["net/cgi",">net/cgi.html",[14,[0,"net/cgi"]],"module"],
["net/cgi-sig",">net/cgi.html#(mod-path._net/cgi-sig)",[14,[0,"net/cgi-sig"]],"module"],
["net/cgi-unit",">net/cgi.html#(mod-path._net/cgi-unit)",[14,[0,"net/cgi-unit"]],"module"],
["net/cookie",">net/cookie.html",[14,[0,"net/cookie"]],"module"],
["net/cookie-sig",">net/cookie.html#(mod-path._net/cookie-sig)",[14,[0,"net/cookie-sig"]],"module"],
["net/cookie-unit",">net/cookie.html#(mod-path._net/cookie-unit)",[14,[0,"net/cookie-unit"]],"module"],
["net/dns",">net/dns.html",[14,[0,"net/dns"]],"module"],
["net/dns-sig",">net/dns.html#(mod-path._net/dns-sig)",[14,[0,"net/dns-sig"]],"module"],
["net/dns-unit",">net/dns.html#(mod-path._net/dns-unit)",[14,[0,"net/dns-unit"]],"module"],
["net/ftp",">net/ftp.html",[14,[0,"net/ftp"]],"module"],
["net/ftp-sig",">net/ftp.html#(mod-path._net/ftp-sig)",[14,[0,"net/ftp-sig"]],"module"],
["net/ftp-unit",">net/ftp.html#(mod-path._net/ftp-unit)",[14,[0,"net/ftp-unit"]],"module"],
["net/head",">net/head.html",[14,[0,"net/head"]],"module"],
["net/head-sig",">net/head.html#(mod-path._net/head-sig)",[14,[0,"net/head-sig"]],"module"],
["net/head-unit",">net/head.html#(mod-path._net/head-unit)",[14,[0,"net/head-unit"]],"module"],
["net/imap",">net/imap.html",[14,[0,"net/imap"]],"module"],
["net/imap-sig",">net/imap.html#(mod-path._net/imap-sig)",[14,[0,"net/imap-sig"]],"module"],
["net/imap-unit",">net/imap.html#(mod-path._net/imap-unit)",[14,[0,"net/imap-unit"]],"module"],
["net/mime",">net/mime.html",[14,[0,"net/mime"]],"module"],
["net/mime-sig",">net/mime.html#(mod-path._net/mime-sig)",[14,[0,"net/mime-sig"]],"module"],
["net/mime-unit",">net/mime.html#(mod-path._net/mime-unit)",[14,[0,"net/mime-unit"]],"module"],
["net/nntp",">net/nntp.html",[14,[0,"net/nntp"]],"module"],
["net/nntp-sig",">net/nntp.html#(mod-path._net/nntp-sig)",[14,[0,"net/nntp-sig"]],"module"],
["net/nntp-unit",">net/nntp.html#(mod-path._net/nntp-unit)",[14,[0,"net/nntp-unit"]],"module"],
["net/pop3",">net/pop3.html",[14,[0,"net/pop3"]],"module"],
["net/pop3-sig",">net/pop3.html#(mod-path._net/pop3-sig)",[14,[0,"net/pop3-sig"]],"module"],
["net/pop3-unit",">net/pop3.html#(mod-path._net/pop3-unit)",[14,[0,"net/pop3-unit"]],"module"],
["net/qp",">net/qp.html",[14,[0,"net/qp"]],"module"],
["net/qp-sig",">net/qp.html#(mod-path._net/qp-sig)",[14,[0,"net/qp-sig"]],"module"],
["net/qp-unit",">net/qp.html#(mod-path._net/qp-unit)",[14,[0,"net/qp-unit"]],"module"],
["net/sendmail",">net/sendmail.html",[14,[0,"net/sendmail"]],"module"],
["net/sendmail-sig",">net/sendmail.html#(mod-path._net/sendmail-sig)",[14,[0,"net/sendmail-sig"]],"module"],
["net/sendmail-unit",">net/sendmail.html#(mod-path._net/sendmail-unit)",[14,[0,"net/sendmail-unit"]],"module"],
["net/sendurl",">net/sendurl.html",[14,[0,"net/sendurl"]],"module"],
["net/smtp",">net/smtp.html",[14,[0,"net/smtp"]],"module"],
["net/smtp-sig",">net/smtp.html#(mod-path._net/smtp-sig)",[14,[0,"net/smtp-sig"]],"module"],
["net/smtp-unit",">net/smtp.html#(mod-path._net/smtp-unit)",[14,[0,"net/smtp-unit"]],"module"],
["net/ssl-tcp-unit",">net/ssl-tcp-unit.html",[14,[0,"net/ssl-tcp-unit"]],"module"],
["net/tcp-redirect",">net/tcp-redirect.html",[14,[0,"net/tcp-redirect"]],"module"],
["net/tcp-sig",">net/tcp.html#(mod-path._net/tcp-sig)",[14,[0,"net/tcp-sig"]],"module"],
["net/tcp-unit",">net/tcp.html#(mod-path._net/tcp-unit)",[14,[0,"net/tcp-unit"]],"module"],
["net/uri-codec",">net/uri-codec.html",[14,[0,"net/uri-codec"]],"module"],
["net/url",">net/url.html",[14,[0,"net/url"]],"module"],
["net/url-sig",">net/url.html#(mod-path._net/url-sig)",[14,[0,"net/url-sig"]],"module"],
["net/url-structs",">net/url.html#(mod-path._net/url-structs)",[14,[0,"net/url-structs"]],"module"],
["net/url-unit",">net/url.html#(mod-path._net/url-unit)",[14,[0,"net/url-unit"]],"module"],
["net: plt networking libraries",">net/index.html","<b>Net</b>: PLT Networking Libraries",false],
["netscape/string->url",">net/url.html#(def._((lib._net/url..ss)._netscape/string-~3eurl))",[0,[1,"netscape/string-&gt;url"]],["net/url"]],
["network-error",">web-server/util_ss.html#(def._((lib._web-server/private/util..ss)._network-error))",[0,[1,"network-error"]],["web-server/private/util"]],
["networking",">reference/networking.html","Networking",false],
["never-e",">frtime/index.html#(def._((lib._frtime/main..ss)._never-e))",[0,[1,"never-e"]],["frtime"]],
["never-evt",">reference/sync.html#(def._((quote._~23~25kernel)._never-evt))",[0,[1,"never-evt"]],["scheme/base","scheme"]],
["new",">reference/objcreation.html#(form._((lib._scheme/private/class-internal..ss)._new))",[0,[6,"new"]],["scheme/class","scheme"]],
["new menu item",">drscheme/Menus.html#(idx._(gentag._59._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">New</font></b> menu item",false],
["new-cafe",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..ss)._new-cafe))",[0,[1,"new-cafe"]],["mzlib/compat"]],
["new-cell",">frtime/index.html#(def._((lib._frtime/main..ss)._new-cell))",[0,[1,"new-cell"]],["frtime"]],
["new-connection",">web-server/connection-manager_ss.html#(def._((lib._web-server/private/connection-manager..ss)._new-connection))",[0,[1,"new-connection"]],["web-server/private/connection-manager"]],
["new-item",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._new-item))",[[0,[1,"new-item"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["new-item",">mrlib/hierarchical-list-compound-item___.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list-compound-item~3c~25~3e)._new-item))",[[0,[1,"new-item"]],[12,[" (method of ",[0,[1,"hierarchical-list-compound-item&lt;%&gt;"]],")"]]],["mrlib/hierlist"]],
["new-list",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._new-list))",[[0,[1,"new-list"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["new-list",">mrlib/hierarchical-list-compound-item___.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list-compound-item~3c~25~3e)._new-list))",[[0,[1,"new-list"]],[12,[" (method of ",[0,[1,"hierarchical-list-compound-item&lt;%&gt;"]],")"]]],["mrlib/hierlist"]],
["new-named-style",">gui/style-list_.html#(meth._(((lib._mred/main..ss)._style-list~25)._new-named-style))",[[0,[1,"new-named-style"]],[12,[" (method of ",[0,[1,"style-list%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["new-prompt",">reference/cont.html#(def._((lib._scheme/control..ss)._new-prompt))",[0,[1,"new-prompt"]],["scheme/control"]],
["newline",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._newline))",[0,[1,"newline"]],["scheme/base","scheme"]],
["newline",">r5rs-std/r5rs-Z-H-9.html#%_idx_662",[0,[1,"newline"]],["r5rs"]],
["newline",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_824",[0,[1,"newline"]],["rnrs/io/simple-6"]],
["newline",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._newline))",[0,[1,"newline"]],["lang/htdp-advanced"]],
["newline",">gui/snip_.html#(idx._(gentag._249._(lib._scribblings/gui/gui..scrbl)))",[7,"'newline"],false],
["newline*",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..ss)._newline*))",[0,[1,"newline*"]],["preprocessor/mzpp"]],
["newnews-since",">net/nntp.html#(def._((lib._net/nntp..ss)._newnews-since))",[0,[1,"newnews-since"]],["net/nntp"]],
["next",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._next))",[[0,[1,"next"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["next",">embedded-gui/dllist___.html#(meth._(((lib._embedded-gui/main..ss)._dllist~3c~25~3e)._next))",[[0,[1,"next"]],[12,[" (method of ",[0,[1,"dllist&lt;%&gt;"]],")"]]],["embedded-gui"]],
["next",">gui/key-event_.html#(idx._(gentag._55._(lib._scribblings/gui/gui..scrbl)))",[7,"'next"],false],
["next-dispatcher",">web-server/dispatch_ss.html#(def._((lib._web-server/dispatchers/dispatch..ss)._next-dispatcher))",[0,[1,"next-dispatcher"]],["web-server/dispatchers/dispatch"]],
["ninth",">reference/pairs.html#(def._((lib._scheme/list..ss)._ninth))",[0,[1,"ninth"]],["scheme/list","scheme"]],
["ninth",">srfi-std/srfi-1.html#ninth",[0,[1,"ninth"]],["srfi/1"]],
["nl",">reference/characters.html#(idx._(gentag._45._(lib._scribblings/reference/reference..scrbl)))",[7,"'nl"],false],
["nntp",">net/nntp.html#(def._((lib._net/nntp..ss)._nntp))",[0,[1,"nntp"]],["net/nntp"]],
["nntp signature",">net/nntp.html#(part._.N.N.T.P_.Signature)","NNTP Signature",false],
["nntp unit",">net/nntp.html#(part._.N.N.T.P_.Unit)","NNTP Unit",false],
["nntp: newsgroup protocol",">net/nntp.html","NNTP: Newsgroup Protocol",false],
["nntp?",">net/nntp.html#(def._((lib._net/nntp..ss)._nntp~3f))",[0,[1,"nntp?"]],["net/nntp"]],
["nntp@",">net/nntp.html#(def._((lib._net/nntp-unit..ss)._nntp~40))",[0,[1,"nntp@"]],["net/nntp-unit"]],
["nntp^",">net/nntp.html#(form._((lib._net/nntp-sig..ss)._nntp~5e))",[0,[6,"nntp^"]],["net/nntp-sig"]],
["no",">reference/characters.html#(idx._(gentag._46._(lib._scribblings/reference/reference..scrbl)))",[7,"'no"],false],
["no continuations",">web-server/none_ss.html","No Continuations",false],
["no-caret",">gui/editor-overview.html#(idx._(gentag._18._(lib._scribblings/gui/gui..scrbl)))",[7,"'no-caret"],false],
["no-group-selected",">net/nntp.html#(def._((lib._net/nntp..ss)._no-group-selected))",[0,[1,"no-group-selected"]],["net/nntp"]],
["no-group-selected?",">net/nntp.html#(def._((lib._net/nntp..ss)._no-group-selected~3f))",[0,[1,"no-group-selected?"]],["net/nntp"]],
["no-infinities-violation?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1052",[0,[1,"no-infinities-violation?"]],["rnrs/arithmetic/flonums-6"]],
["no-mail-recipients",">net/sendmail.html#(def._((lib._net/sendmail..ss)._no-mail-recipients))",[0,[1,"no-mail-recipients"]],["net/sendmail"]],
["no-mail-recipients?",">net/sendmail.html#(def._((lib._net/sendmail..ss)._no-mail-recipients~3f))",[0,[1,"no-mail-recipients?"]],["net/sendmail"]],
["no-nans-violation?",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_1058",[0,[1,"no-nans-violation?"]],["rnrs/arithmetic/flonums-6"]],
["no-selected",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._no-selected))",[[0,[1,"no-selected"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["no-spaces?",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..ss)._no-spaces~3f))",[0,[1,"no-spaces?"]],["preprocessor/mzpp"]],
["no-web-browser",">web-server/insta.html#(def._((lib._web-server/insta/insta..ss)._no-web-browser))",[0,[1,"no-web-browser"]],["web-server/insta/insta"]],
["node-left",">syntax-color/index.html#(def._((lib._syntax-color/token-tree..ss)._node-left))",[0,[1,"node-left"]],["syntax-color/token-tree"]],
["node-left-subtree-length",">syntax-color/index.html#(def._((lib._syntax-color/token-tree..ss)._node-left-subtree-length))",[0,[1,"node-left-subtree-length"]],["syntax-color/token-tree"]],
["node-right",">syntax-color/index.html#(def._((lib._syntax-color/token-tree..ss)._node-right))",[0,[1,"node-right"]],["syntax-color/token-tree"]],
["node-token-data",">syntax-color/index.html#(def._((lib._syntax-color/token-tree..ss)._node-token-data))",[0,[1,"node-token-data"]],["syntax-color/token-tree"]],
["node-token-length",">syntax-color/index.html#(def._((lib._syntax-color/token-tree..ss)._node-token-length))",[0,[1,"node-token-length"]],["syntax-color/token-tree"]],
["node?",">syntax-color/index.html#(def._((lib._syntax-color/token-tree..ss)._node~3f))",[0,[1,"node?"]],["syntax-color/token-tree"]],
["noframes",">html/index.html#(def._((lib._html/main..ss)._noframes))",[0,[1,"noframes"]],["html"]],
["noframes?",">html/index.html#(def._((lib._html/main..ss)._noframes~3f))",[0,[1,"noframes?"]],["html"]],
["non-capturing",">guide/regexp-clusters.html#(tech._non._capturing)","<i>non-capturing</i>",false],
["non-capturing clusters",">guide/regexp-clusters.html#(part._.Non-capturing_.Clusters)","Non-capturing Clusters",false],
["non-continuable-violation?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_464",[0,[1,"non-continuable-violation?"]],["rnrs/conditions-6"]],
["non-existent-group",">net/nntp.html#(def._((lib._net/nntp..ss)._non-existent-group))",[0,[1,"non-existent-group"]],["net/nntp"]],
["non-existent-group-group",">net/nntp.html#(def._((lib._net/nntp..ss)._non-existent-group-group))",[0,[1,"non-existent-group-group"]],["net/nntp"]],
["non-existent-group?",">net/nntp.html#(def._((lib._net/nntp..ss)._non-existent-group~3f))",[0,[1,"non-existent-group?"]],["net/nntp"]],
["non-greedy",">guide/regexp-quant.html#(tech._non._greedy)","<i>non-greedy</i>",false],
["non-gui installer",">setup-plt/_plt-archives.html#(part._.Non-.G.U.I_.Installer)","Non-GUI Installer",false],
["non-module compilation and expansion",">syntax/toplevel.html","Non-Module Compilation And Expansion",false],
["non-r5rs bindings from r5rs",">r5rs/r5rs-mod.html#(part._.Non-.R5.R.S_.Bindings_from_r5rs)",["Non-R","<sup>5</sup>","RS Bindings from ",[14,[0,"r5rs"]]],false],
["non-terminal-style",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._non-terminal-style))",[0,[1,"non-terminal-style"]],["redex/pict"]],
["non-terminal-subscript-style",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._non-terminal-subscript-style))",[0,[1,"non-terminal-subscript-style"]],["redex/pict"]],
["non-terminating-macro",">reference/readtables.html#(idx._(gentag._198._(lib._scribblings/reference/reference..scrbl)))",[7,"'non-terminating-macro"],false],
["non-terminating-macro",">reference/readtables.html#(idx._(gentag._200._(lib._scribblings/reference/reference..scrbl)))",[7,"'non-terminating-macro"],false],
["non-uniform variable-arity functions",">typed-scheme/index.html#(part._.Non-.Uniform_.Variable-.Arity_.Functions)","Non-Uniform Variable-Arity Functions",false],
["non-windows",">gui/windowing-overview.html#(tech._non._window)","<i>non-windows</i>",false],
["nonatomic",">foreign/foreign_pointer-funcs.html#(idx._(gentag._4._(lib._scribblings/foreign/foreign..scrbl)))",[7,"'nonatomic"],false],
["none",">reference/port-buffers.html#(idx._(gentag._99._(lib._scribblings/reference/reference..scrbl)))",[7,"'none"],false],
["none/c",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract-guts..ss)._none/c))",[0,[1,"none/c"]],["scheme/contract","scheme"]],
["nongenerative",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_304",[0,[6,"nongenerative"]],["rnrs/records/syntactic-6"]],
["nonterm",">scribble/bnf.html#(def._((lib._scribble/bnf..ss)._nonterm))",[0,[1,"nonterm"]],["scribble/bnf"]],
["nor",">mzlib/mzlib_etc.html#(form._((lib._mzlib/etc..ss)._nor))",[0,[6,"nor"]],["mzlib/etc"]],
["normal",">gui/font_.html#(idx._(gentag._202._(lib._scribblings/gui/gui..scrbl)))",[7,"'normal"],false],
["normal",">gui/font_.html#(idx._(gentag._205._(lib._scribblings/gui/gui..scrbl)))",[7,"'normal"],false],
["normal",">gui/style-delta_.html#(idx._(gentag._264._(lib._scribblings/gui/gui..scrbl)))",[7,"'normal"],false],
["normal",">gui/style-delta_.html#(idx._(gentag._273._(lib._scribblings/gui/gui..scrbl)))",[7,"'normal"],false],
["normal use of readline",">readline/index.html#(part._.Normal_.Use_of_.Readline)","Normal Use of Readline",false],
["normal-case-path",">reference/Manipulating_Paths.html#(def._((lib._scheme/private/misc..ss)._normal-case-path))",[0,[1,"normal-case-path"]],["scheme/base","scheme"]],
["normal-control-font",">gui/Drawing_Functions.html#(def._((lib._mred/main..ss)._normal-control-font))",[0,[1,"normal-control-font"]],["scheme/gui/base","scheme/gui"]],
["normalize-definition",">syntax/transformer-helpers.html#(def._((lib._syntax/define..ss)._normalize-definition))",[0,[1,"normalize-definition"]],["syntax/define"]],
["normalize-path",">reference/More_Path_Utilities.html#(def._((lib._scheme/path..ss)._normalize-path))",[0,[1,"normalize-path"]],["scheme/path","scheme"]],
["normalize-vector",">plot/extend.html#(def._((lib._plot/extend..ss)._normalize-vector))",[0,[1,"normalize-vector"]],["plot/extend"]],
["normalize-vectors",">plot/extend.html#(def._((lib._plot/extend..ss)._normalize-vectors))",[0,[1,"normalize-vectors"]],["plot/extend"]],
["noscript",">html/index.html#(def._((lib._html/main..ss)._noscript))",[0,[1,"noscript"]],["html"]],
["noscript?",">html/index.html#(def._((lib._html/main..ss)._noscript~3f))",[0,[1,"noscript?"]],["html"]],
["not",">reference/booleans.html#(def._((quote._~23~25kernel)._not))",[0,[1,"not"]],["scheme/base","scheme"]],
["not",">r5rs-std/r5rs-Z-H-9.html#%_idx_386",[0,[1,"not"]],["r5rs"]],
["not",">r6rs-std/r6rs-Z-H-14.html#node_idx_594",[0,[1,"not"]],["rnrs/base-6"]],
["not",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._not))",[0,[1,"not"]],["lang/htdp-advanced"]],
["not",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._not))",[0,[1,"not"]],["lang/htdp-beginner"]],
["not",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._not))",[0,[1,"not"]],["lang/htdp-beginner-abbr"]],
["not",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._not))",[0,[1,"not"]],["lang/htdp-intermediate"]],
["not",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._not))",[0,[1,"not"]],["lang/htdp-intermediate-lambda"]],
["not",">srfi-std/srfi-42.html#not",[0,[6,"not"]],["srfi/42"]],
["not-a-number",">reference/numbers.html#(idx._(gentag._12._(lib._scribblings/reference/reference..scrbl)))","not-a-number",false],
["not-given-headers",">net/pop3.html#(def._((lib._net/pop3..ss)._not-given-headers))",[0,[1,"not-given-headers"]],["net/pop3"]],
["not-given-headers-communicator",">net/pop3.html#(def._((lib._net/pop3..ss)._not-given-headers-communicator))",[0,[1,"not-given-headers-communicator"]],["net/pop3"]],
["not-given-headers-message",">net/pop3.html#(def._((lib._net/pop3..ss)._not-given-headers-message))",[0,[1,"not-given-headers-message"]],["net/pop3"]],
["not-given-headers?",">net/pop3.html#(def._((lib._net/pop3..ss)._not-given-headers~3f))",[0,[1,"not-given-headers?"]],["net/pop3"]],
["not-pair?",">srfi-std/srfi-1.html#not-pair-p",[0,[1,"not-pair?"]],["srfi/1"]],
["not-ready-for-transaction",">net/pop3.html#(def._((lib._net/pop3..ss)._not-ready-for-transaction))",[0,[1,"not-ready-for-transaction"]],["net/pop3"]],
["not-ready-for-transaction-communicator",">net/pop3.html#(def._((lib._net/pop3..ss)._not-ready-for-transaction-communicator))",[0,[1,"not-ready-for-transaction-communicator"]],["net/pop3"]],
["not-ready-for-transaction?",">net/pop3.html#(def._((lib._net/pop3..ss)._not-ready-for-transaction~3f))",[0,[1,"not-ready-for-transaction?"]],["net/pop3"]],
["not-running",">tools/drscheme_frame.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aframe~3a~3c~25~3e)._not-running))",[[0,[1,"not-running"]],[12,[" (method of ",[0,[1,"drscheme:frame:&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["not/c",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._not/c))",[0,[1,"not/c"]],["scheme/contract","scheme"]],
["notation",">guide/syntax-notation.html","Notation",false],
["notes and limitations",">macro-debugger/index.html#(part._.Notes_and_.Limitations)","Notes and Limitations",false],
["notes for drscheme language implementors",">macro-debugger/index.html#(part._.Notes_for_.Dr.Scheme_language_implementors)","Notes for DrScheme language implementors",false],
["notes on r5rs functions",">r5rs/r5rs-mod.html#(part._.Notes_on_.R5.R.S_.Functions)","Notes on R<sup>5</sup>RS Functions",false],
["nothing",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..ss)._nothing))",[0,[6,"nothing"]],["parser-tools/lex"]],
["notify",">gui/timer_.html#(meth._(((lib._mred/main..ss)._timer~25)._notify))",[[0,[1,"notify"]],[12,[" (method of ",[0,[1,"timer%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["notify-on-change",">gui/style-list_.html#(meth._(((lib._mred/main..ss)._style-list~25)._notify-on-change))",[[0,[1,"notify-on-change"]],[12,[" (method of ",[0,[1,"style-list%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["nth",">gui/editor-data-class-list___.html#(meth._(((lib._mred/main..ss)._editor-data-class-list~3c~25~3e)._nth))",[[0,[1,"nth"]],[12,[" (method of ",[0,[1,"editor-data-class-list&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["nth",">gui/snip-class-list___.html#(meth._(((lib._mred/main..ss)._snip-class-list~3c~25~3e)._nth))",[[0,[1,"nth"]],[12,[" (method of ",[0,[1,"snip-class-list&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["nul",">reference/windowspaths.html#(idx._(gentag._215._(lib._scribblings/reference/reference..scrbl)))",[5,"\"NUL\""],false],
["null",">reference/pairs.html#(def._((quote._~23~25kernel)._null))",[0,[1,"null"]],["scheme/base","scheme"]],
["null",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._null))",[0,[1,"null"]],["lang/htdp-advanced"]],
["null",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._null))",[0,[1,"null"]],["lang/htdp-beginner"]],
["null",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._null))",[0,[1,"null"]],["lang/htdp-beginner-abbr"]],
["null",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._null))",[0,[1,"null"]],["lang/htdp-intermediate"]],
["null",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._null))",[0,[1,"null"]],["lang/htdp-intermediate-lambda"]],
["null-environment",">r5rs-std/r5rs-Z-H-9.html#%_idx_604",[0,[1,"null-environment"]],["r5rs"]],
["null-environment",">r6rs-lib-std/r6rs-lib-Z-H-20.html#node_idx_1306",[0,[1,"null-environment"]],["rnrs/r5rs-6"]],
["null-list?",">srfi-std/srfi-1.html#null-list-p",[0,[1,"null-list?"]],["srfi/1"]],
["null?",">reference/pairs.html#(def._((quote._~23~25kernel)._null~3f))",[0,[1,"null?"]],["scheme/base","scheme"]],
["null?",">r5rs-std/r5rs-Z-H-9.html#%_idx_428",[0,[1,"null?"]],["r5rs"]],
["null?",">r6rs-std/r6rs-Z-H-14.html#node_idx_624",[0,[1,"null?"]],["rnrs/base-6"]],
["null?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._null~3f))",[0,[1,"null?"]],["lang/htdp-advanced"]],
["null?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._null~3f))",[0,[1,"null?"]],["lang/htdp-beginner"]],
["null?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._null~3f))",[0,[1,"null?"]],["lang/htdp-beginner-abbr"]],
["null?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._null~3f))",[0,[1,"null?"]],["lang/htdp-intermediate"]],
["null?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._null~3f))",[0,[1,"null?"]],["lang/htdp-intermediate-lambda"]],
["null?",">srfi-std/srfi-1.html#null-p",[0,[1,"null?"]],["srfi/1"]],
["num-scroll-lines",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._num-scroll-lines))",[[0,[1,"num-scroll-lines"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["number",">gui/editor-data-class-list___.html#(meth._(((lib._mred/main..ss)._editor-data-class-list~3c~25~3e)._number))",[[0,[1,"number"]],[12,[" (method of ",[0,[1,"editor-data-class-list&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["number",">gui/snip-class-list___.html#(meth._(((lib._mred/main..ss)._snip-class-list~3c~25~3e)._number))",[[0,[1,"number"]],[12,[" (method of ",[0,[1,"snip-class-list&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["number",">gui/style-list_.html#(meth._(((lib._mred/main..ss)._style-list~25)._number))",[[0,[1,"number"]],[12,[" (method of ",[0,[1,"style-list%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["number",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._.Number))",[0,[6,"Number"]],["typed-scheme"]],
["number",">redex/Patterns.html#(tech._number)","<i>number</i>",false],
["number",">guide/numbers.html#(tech._number)","<i>number</i>",false],
["number comparison",">reference/numbers.html#(part._.Number_.Comparison)","Number Comparison",false],
["number snip",">framework/Number_Snip.html","Number Snip",false],
["number types",">reference/numbers.html#(part._.Number_.Types)","Number Types",false],
["number--string conversions",">reference/numbers.html#(part._.Number--.String_.Conversions)","Number&ndash;String Conversions",false],
["number->com-currency",">mysterx/com-types.html#(def._((lib._mysterx/main..ss)._number-~3ecom-currency))",[0,[1,"number-&gt;com-currency"]],["mysterx"]],
["number->com-scode",">mysterx/com-types.html#(def._((lib._mysterx/main..ss)._number-~3ecom-scode))",[0,[1,"number-&gt;com-scode"]],["mysterx"]],
["number->string",">reference/numbers.html#(def._((quote._~23~25kernel)._number-~3estring))",[0,[1,"number-&gt;string"]],["scheme/base","scheme"]],
["number->string",">r5rs-std/r5rs-Z-H-9.html#%_idx_366",[0,[1,"number-&gt;string"]],["r5rs"]],
["number->string",">r6rs-std/r6rs-Z-H-14.html#node_idx_578",[0,[1,"number-&gt;string"]],["rnrs/base-6"]],
["number->string",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._number-~3estring))",[0,[1,"number-&gt;string"]],["lang/htdp-advanced"]],
["number->string",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._number-~3estring))",[0,[1,"number-&gt;string"]],["lang/htdp-beginner"]],
["number->string",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._number-~3estring))",[0,[1,"number-&gt;string"]],["lang/htdp-beginner-abbr"]],
["number->string",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._number-~3estring))",[0,[1,"number-&gt;string"]],["lang/htdp-intermediate"]],
["number->string",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._number-~3estring))",[0,[1,"number-&gt;string"]],["lang/htdp-intermediate-lambda"]],
["number-of-visible-items",">gui/list-box_.html#(meth._(((lib._mred/main..ss)._list-box~25)._number-of-visible-items))",[[0,[1,"number-of-visible-items"]],[12,[" (method of ",[0,[1,"list-box%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["number-snip:make-fraction-snip",">framework/Number_Snip.html#(def._((lib._framework/main..ss)._number-snip~3amake-fraction-snip))",[0,[1,"number-snip:make-fraction-snip"]],["framework"]],
["number-snip:make-repeating-decimal-snip",">framework/Number_Snip.html#(def._((lib._framework/main..ss)._number-snip~3amake-repeating-decimal-snip))",[0,[1,"number-snip:make-repeating-decimal-snip"]],["framework"]],
["number-snip:snip-class%",">framework/Number_Snip.html#(def._((lib._framework/main..ss)._number-snip~3asnip-class~25))",[0,[1,"number-snip:snip-class%"]],["framework"]],
["number?",">reference/numbers.html#(def._((quote._~23~25kernel)._number~3f))",[0,[1,"number?"]],["scheme/base","scheme"]],
["number?",">r5rs-std/r5rs-Z-H-9.html#%_idx_244",[0,[1,"number?"]],["r5rs"]],
["number?",">r6rs-std/r6rs-Z-H-14.html#node_idx_440",[0,[1,"number?"]],["rnrs/base-6"]],
["number?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._number~3f))",[0,[1,"number?"]],["lang/htdp-advanced"]],
["number?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._number~3f))",[0,[1,"number?"]],["lang/htdp-beginner"]],
["number?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._number~3f))",[0,[1,"number?"]],["lang/htdp-beginner-abbr"]],
["number?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._number~3f))",[0,[1,"number?"]],["lang/htdp-intermediate"]],
["number?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._number~3f))",[0,[1,"number?"]],["lang/htdp-intermediate-lambda"]],
["numbers parsing",">reference/reader.html#(idx._(gentag._129._(lib._scribblings/reference/reference..scrbl)))","numbers, parsing",false],
["numbers machine representations",">reference/numbers.html#(idx._(gentag._23._(lib._scribblings/reference/reference..scrbl)))","numbers, machine representations",false],
["numbers little-endian",">reference/numbers.html#(idx._(gentag._20._(lib._scribblings/reference/reference..scrbl)))","numbers, little-endian",false],
["numbers floating-point",">reference/numbers.html#(idx._(gentag._22._(lib._scribblings/reference/reference..scrbl)))","numbers, floating-point",false],
["numbers converting",">reference/numbers.html#(idx._(gentag._19._(lib._scribblings/reference/reference..scrbl)))","numbers, converting",false],
["numbers big-endian",">reference/numbers.html#(idx._(gentag._21._(lib._scribblings/reference/reference..scrbl)))","numbers, big-endian",false],
["numbers",">guide/numbers.html","Numbers",false],
["numbers",">honu/H-expressions.html#(part._honu~3anumbers)","Numbers",false],
["numbers",">reference/numbers.html","Numbers",false],
["numbers",">reference/numbers.html#(tech._number)","<i>numbers</i>",false],
["numerator",">reference/numbers.html#(def._((quote._~23~25kernel)._numerator))",[0,[1,"numerator"]],["scheme/base","scheme"]],
["numerator",">r5rs-std/r5rs-Z-H-9.html#%_idx_310",[0,[1,"numerator"]],["r5rs"]],
["numerator",">r6rs-std/r6rs-Z-H-14.html#node_idx_524",[0,[1,"numerator"]],["rnrs/base-6"]],
["numerator",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._numerator))",[0,[1,"numerator"]],["lang/htdp-advanced"]],
["numerator",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._numerator))",[0,[1,"numerator"]],["lang/htdp-beginner"]],
["numerator",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._numerator))",[0,[1,"numerator"]],["lang/htdp-beginner-abbr"]],
["numerator",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._numerator))",[0,[1,"numerator"]],["lang/htdp-intermediate"]],
["numerator",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._numerator))",[0,[1,"numerator"]],["lang/htdp-intermediate-lambda"]],
["numeric types",">foreign/Numeric_Types.html","Numeric Types",false],
["numlock",">gui/key-event_.html#(idx._(gentag._110._(lib._scribblings/gui/gui..scrbl)))",[7,"'numlock"],false],
["numpad-enter",">gui/key-event_.html#(idx._(gentag._79._(lib._scribblings/gui/gui..scrbl)))",[7,"'numpad-enter"],false],
["numpad0",">gui/key-event_.html#(idx._(gentag._69._(lib._scribblings/gui/gui..scrbl)))",[7,"'numpad0"],false],
["numpad1",">gui/key-event_.html#(idx._(gentag._70._(lib._scribblings/gui/gui..scrbl)))",[7,"'numpad1"],false],
["numpad2",">gui/key-event_.html#(idx._(gentag._71._(lib._scribblings/gui/gui..scrbl)))",[7,"'numpad2"],false],
["numpad3",">gui/key-event_.html#(idx._(gentag._72._(lib._scribblings/gui/gui..scrbl)))",[7,"'numpad3"],false],
["numpad4",">gui/key-event_.html#(idx._(gentag._73._(lib._scribblings/gui/gui..scrbl)))",[7,"'numpad4"],false],
["numpad5",">gui/key-event_.html#(idx._(gentag._74._(lib._scribblings/gui/gui..scrbl)))",[7,"'numpad5"],false],
["numpad6",">gui/key-event_.html#(idx._(gentag._75._(lib._scribblings/gui/gui..scrbl)))",[7,"'numpad6"],false],
["numpad7",">gui/key-event_.html#(idx._(gentag._76._(lib._scribblings/gui/gui..scrbl)))",[7,"'numpad7"],false],
["numpad8",">gui/key-event_.html#(idx._(gentag._77._(lib._scribblings/gui/gui..scrbl)))",[7,"'numpad8"],false],
["numpad9",">gui/key-event_.html#(idx._(gentag._78._(lib._scribblings/gui/gui..scrbl)))",[7,"'numpad9"],false],
["nw:rectangle",">teachpack/world.html#(def._((lib._teachpack/htdp/world..ss)._nw~3arectangle))",[0,[1,"nw:rectangle"]],["teachpack/htdp/world"]],
["o-bullet",">slideshow/Constants_and_Layout_Variables.html#(def._((lib._slideshow/base..ss)._o-bullet))",[0,[1,"o-bullet"]],["slideshow/base","slideshow"]],
["object",">html/index.html#(def._((lib._html/main..ss)._object))",[0,[1,"object"]],["html"]],
["object and class contracts",">reference/Object_and_Class_Contracts.html","Object and Class Contracts",false],
["object identity and comparisons",">reference/eval-model.html#(part._model-eq)","Object Identity and Comparisons",false],
["object printing",">reference/objectprinting.html","Object Printing",false],
["object serialization",">reference/objectserialize.html","Object Serialization",false],
["object%",">reference/createclass.html#(def._((lib._scheme/private/class-internal..ss)._object~25))",[0,[1,"object%"]],["scheme/class","scheme"]],
["object, class, and interface utilities",">reference/objectutils.html","Object, Class, and Interface Utilities",false],
["object->vector",">reference/objectutils.html#(def._((lib._scheme/private/class-internal..ss)._object-~3evector))",[0,[1,"object-&gt;vector"]],["scheme/class","scheme"]],
["object-contract",">reference/Object_and_Class_Contracts.html#(form._((lib._scheme/class..ss)._object-contract))",[0,[6,"object-contract"]],["scheme/class","scheme"]],
["object-info",">reference/objectutils.html#(def._((lib._scheme/private/class-internal..ss)._object-info))",[0,[1,"object-info"]],["scheme/class","scheme"]],
["object-interface",">reference/objectutils.html#(def._((lib._scheme/private/class-internal..ss)._object-interface))",[0,[1,"object-interface"]],["scheme/class","scheme"]],
["object-method-arity-includes?",">reference/objectutils.html#(def._((lib._scheme/private/class-internal..ss)._object-method-arity-includes~3f))",[0,[1,"object-method-arity-includes?"]],["scheme/class","scheme"]],
["object-name",">reference/inspectors.html#(def._((quote._~23~25kernel)._object-name))",[0,[1,"object-name"]],["scheme/base","scheme"]],
["object=?",">reference/objectutils.html#(def._((lib._scheme/private/class-internal..ss)._object~3d~3f))",[0,[1,"object=?"]],["scheme/class","scheme"]],
["object?",">reference/objectutils.html#(def._((lib._scheme/private/class-internal..ss)._object~3f))",[0,[1,"object?"]],["scheme/class","scheme"]],
["object?",">html/index.html#(def._((lib._html/main..ss)._object~3f))",[0,[1,"object?"]],["html"]],
["objects",">quick/index.html#(part._.Objects)","Objects",false],
["objects",">mysterx/documents.html#(meth._(((lib._mysterx/main..ss)._mx-document~3c~25~3e)._objects))",[[0,[1,"objects"]],[12,[" (method of ",[0,[1,"mx-document&lt;%&gt;"]],")"]]],["mysterx"]],
["objects",">reference/eval-model.html#(tech._object)","<i>objects</i>",false],
["objects and imperative update",">reference/eval-model.html#(part._.Objects_and_.Imperative_.Update)","Objects and Imperative Update",false],
["odd?",">reference/numbers.html#(def._((quote._~23~25kernel)._odd~3f))",[0,[1,"odd?"]],["scheme/base","scheme"]],
["odd?",">r5rs-std/r5rs-Z-H-9.html#%_idx_274",[0,[1,"odd?"]],["r5rs"]],
["odd?",">r6rs-std/r6rs-Z-H-14.html#node_idx_480",[0,[1,"odd?"]],["rnrs/base-6"]],
["odd?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._odd~3f))",[0,[1,"odd?"]],["lang/htdp-advanced"]],
["odd?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._odd~3f))",[0,[1,"odd?"]],["lang/htdp-beginner"]],
["odd?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._odd~3f))",[0,[1,"odd?"]],["lang/htdp-beginner-abbr"]],
["odd?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._odd~3f))",[0,[1,"odd?"]],["lang/htdp-intermediate"]],
["odd?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._odd~3f))",[0,[1,"odd?"]],["lang/htdp-intermediate-lambda"]],
["offset-ptr?",">foreign/foreign_pointer-funcs.html#(def._((lib._scheme/foreign..ss)._offset-ptr~3f))",[0,[1,"offset-ptr?"]],["scheme/foreign"]],
["ok?",">gui/bitmap_.html#(meth._(((lib._mred/main..ss)._bitmap~25)._ok~3f))",[[0,[1,"ok?"]],[12,[" (method of ",[0,[1,"bitmap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["ok?",">gui/color_.html#(meth._(((lib._mred/main..ss)._color~25)._ok~3f))",[[0,[1,"ok?"]],[12,[" (method of ",[0,[1,"color%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["ok?",">gui/cursor_.html#(meth._(((lib._mred/main..ss)._cursor~25)._ok~3f))",[[0,[1,"ok?"]],[12,[" (method of ",[0,[1,"cursor%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["ok?",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._ok~3f))",[[0,[1,"ok?"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["ok?",">gui/editor-stream-in_.html#(meth._(((lib._mred/main..ss)._editor-stream-in~25)._ok~3f))",[[0,[1,"ok?"]],[12,[" (method of ",[0,[1,"editor-stream-in%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["ok?",">gui/editor-stream-out_.html#(meth._(((lib._mred/main..ss)._editor-stream-out~25)._ok~3f))",[[0,[1,"ok?"]],[12,[" (method of ",[0,[1,"editor-stream-out%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["ok?",">gui/gl-context___.html#(meth._(((lib._mred/main..ss)._gl-context~3c~25~3e)._ok~3f))",[[0,[1,"ok?"]],[12,[" (method of ",[0,[1,"gl-context&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["ol",">html/index.html#(def._((lib._html/main..ss)._ol))",[0,[1,"ol"]],["html"]],
["ol?",">html/index.html#(def._((lib._html/main..ss)._ol~3f))",[0,[1,"ol?"]],["html"]],
["old functions",">mzscheme/Old_Functions.html","Old Functions",false],
["old syntactic forms",">mzscheme/Old_Syntactic_Forms.html","Old Syntactic Forms",false],
["omitable-paragraph",">scribble/struct.html#(def._((lib._scribble/struct..ss)._omitable-paragraph))",[0,[1,"omitable-paragraph"]],["scribble/struct"]],
["omitable-paragraph?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._omitable-paragraph~3f))",[0,[1,"omitable-paragraph?"]],["scribble/struct"]],
["on-activate",">gui/top-level-window___.html#(meth._(((lib._mred/main..ss)._top-level-window~3c~25~3e)._on-activate))",[[0,[1,"on-activate"]],[12,[" (method of ",[0,[1,"top-level-window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-activate",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aopen-here-mixin)._on-activate))",[[0,[1,"on-activate"]],[12,[" (method of ",[0,[1,"frame:open-here-mixin"]],")"]]],["framework"]],
["on-activate",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aregister-group-mixin)._on-activate))",[[0,[1,"on-activate"]],[12,[" (method of ",[0,[1,"frame:register-group-mixin"]],")"]]],["framework"]],
["on-change",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._on-change))",[[0,[1,"on-change"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-change",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abackup-autosave-mixin)._on-change))",[[0,[1,"on-change"]],[12,[" (method of ",[0,[1,"editor:backup-autosave-mixin"]],")"]]],["framework"]],
["on-change",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._on-change))",[[0,[1,"on-change"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-change",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._on-change))",[[0,[1,"on-change"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-change-style",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._on-change-style))",[[0,[1,"on-change-style"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-change-style",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._on-change-style))",[[0,[1,"on-change-style"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-change-style",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._on-change-style))",[[0,[1,"on-change-style"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-char",">gui/canvas___.html#(meth._(((lib._mred/main..ss)._canvas~3c~25~3e)._on-char))",[[0,[1,"on-char"]],[12,[" (method of ",[0,[1,"canvas&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-char",">gui/editor-canvas_.html#(meth._(((lib._mred/main..ss)._editor-canvas~25)._on-char))",[[0,[1,"on-char"]],[12,[" (method of ",[0,[1,"editor-canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-char",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._on-char))",[[0,[1,"on-char"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-char",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._on-char))",[[0,[1,"on-char"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-char",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._on-char))",[[0,[1,"on-char"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-char",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._on-char))",[[0,[1,"on-char"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-char",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aautocomplete-mixin)._on-char))",[[0,[1,"on-char"]],[12,[" (method of ",[0,[1,"text:autocomplete-mixin"]],")"]]],["framework"]],
["on-choose-directory",">mrlib/Name_Message.html#(meth._(((lib._mrlib/name-message..ss)._name-message~25)._on-choose-directory))",[[0,[1,"on-choose-directory"]],[12,[" (method of ",[0,[1,"name-message%"]],")"]]],["mrlib/name-message"]],
["on-click",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._on-click))",[[0,[1,"on-click"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["on-click-always",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._on-click-always))",[[0,[1,"on-click-always"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["on-close",">gui/top-level-window___.html#(meth._(((lib._mred/main..ss)._top-level-window~3c~25~3e)._on-close))",[[0,[1,"on-close"]],[12,[" (method of ",[0,[1,"top-level-window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-close",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3atext~25)._on-close))",[[0,[1,"on-close"]],[12,[" (method of ",[0,[1,"drscheme:rep:text%"]],")"]]],["drscheme/tool-lib"]],
["on-close",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._on-close))",[[0,[1,"on-close"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["on-close",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3atab~3c~25~3e)._on-close))",[[0,[1,"on-close"]],[12,[" (method of ",[0,[1,"drscheme:unit:tab&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["on-close",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abackup-autosave-mixin)._on-close))",[[0,[1,"on-close"]],[12,[" (method of ",[0,[1,"editor:backup-autosave-mixin"]],")"]]],["framework"]],
["on-close",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abasic~3c~25~3e)._on-close))",[[0,[1,"on-close"]],[12,[" (method of ",[0,[1,"editor:basic&lt;%&gt;"]],")"]]],["framework"]],
["on-close",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor-mixin)._on-close))",[[0,[1,"on-close"]],[12,[" (method of ",[0,[1,"frame:editor-mixin"]],")"]]],["framework"]],
["on-close",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3ainfo-mixin)._on-close))",[[0,[1,"on-close"]],[12,[" (method of ",[0,[1,"frame:info-mixin"]],")"]]],["framework"]],
["on-close",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aopen-here-mixin)._on-close))",[[0,[1,"on-close"]],[12,[" (method of ",[0,[1,"frame:open-here-mixin"]],")"]]],["framework"]],
["on-close",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aregister-group-mixin)._on-close))",[[0,[1,"on-close"]],[12,[" (method of ",[0,[1,"frame:register-group-mixin"]],")"]]],["framework"]],
["on-close",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable-mixin)._on-close))",[[0,[1,"on-close"]],[12,[" (method of ",[0,[1,"frame:searchable-mixin"]],")"]]],["framework"]],
["on-close",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus-mixin)._on-close))",[[0,[1,"on-close"]],[12,[" (method of ",[0,[1,"frame:standard-menus-mixin"]],")"]]],["framework"]],
["on-close",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astandard-menus~3c~25~3e)._on-close))",[[0,[1,"on-close"]],[12,[" (method of ",[0,[1,"frame:standard-menus&lt;%&gt;"]],")"]]],["framework"]],
["on-close",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3atext-info-mixin)._on-close))",[[0,[1,"on-close"]],[12,[" (method of ",[0,[1,"frame:text-info-mixin"]],")"]]],["framework"]],
["on-close-all",">framework/Group.html#(meth._(((lib._framework/main..ss)._group~3a~25)._on-close-all))",[[0,[1,"on-close-all"]],[12,[" (method of ",[0,[1,"group:%"]],")"]]],["framework"]],
["on-default-char",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._on-default-char))",[[0,[1,"on-default-char"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-default-char",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._on-default-char))",[[0,[1,"on-default-char"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-default-char",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._on-default-char))",[[0,[1,"on-default-char"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-default-char",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._on-default-char))",[[0,[1,"on-default-char"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-default-char",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3ainput-box-mixin)._on-default-char))",[[0,[1,"on-default-char"]],[12,[" (method of ",[0,[1,"text:input-box-mixin"]],")"]]],["framework"]],
["on-default-event",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._on-default-event))",[[0,[1,"on-default-event"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-default-event",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._on-default-event))",[[0,[1,"on-default-event"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-default-event",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._on-default-event))",[[0,[1,"on-default-event"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-default-event",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._on-default-event))",[[0,[1,"on-default-event"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-default-event",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._on-default-event))",[[0,[1,"on-default-event"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-delete",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._on-delete))",[[0,[1,"on-delete"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-delete",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._on-delete))",[[0,[1,"on-delete"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-delete",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._on-delete))",[[0,[1,"on-delete"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-delete",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._on-delete))",[[0,[1,"on-delete"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-demand",">gui/labelled-menu-item___.html#(meth._(((lib._mred/main..ss)._labelled-menu-item~3c~25~3e)._on-demand))",[[0,[1,"on-demand"]],[12,[" (method of ",[0,[1,"labelled-menu-item&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-demand",">gui/menu-item-container___.html#(meth._(((lib._mred/main..ss)._menu-item-container~3c~25~3e)._on-demand))",[[0,[1,"on-demand"]],[12,[" (method of ",[0,[1,"menu-item-container&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-disable-surrogate",">framework/Color.html#(meth._(((lib._framework/main..ss)._color~3atext-mode-mixin)._on-disable-surrogate))",[[0,[1,"on-disable-surrogate"]],[12,[" (method of ",[0,[1,"color:text-mode-mixin"]],")"]]],["framework"]],
["on-disable-surrogate",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~3c~25~3e)._on-disable-surrogate))",[[0,[1,"on-disable-surrogate"]],[12,[" (method of ",[0,[1,"mode:surrogate-text&lt;%&gt;"]],")"]]],["framework"]],
["on-disable-surrogate",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext-mode-mixin)._on-disable-surrogate))",[[0,[1,"on-disable-surrogate"]],[12,[" (method of ",[0,[1,"scheme:text-mode-mixin"]],")"]]],["framework"]],
["on-display-size",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._on-display-size))",[[0,[1,"on-display-size"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-display-size",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._on-display-size))",[[0,[1,"on-display-size"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-display-size",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._on-display-size))",[[0,[1,"on-display-size"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-display-size",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports-mixin)._on-display-size))",[[0,[1,"on-display-size"]],[12,[" (method of ",[0,[1,"text:ports-mixin"]],")"]]],["framework"]],
["on-display-size-when-ready",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._on-display-size-when-ready))",[[0,[1,"on-display-size-when-ready"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-double-click",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._on-double-click))",[[0,[1,"on-double-click"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-double-select",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._on-double-select))",[[0,[1,"on-double-select"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["on-drop-file",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._on-drop-file))",[[0,[1,"on-drop-file"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-drop-file",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3abasic-mixin)._on-drop-file))",[[0,[1,"on-drop-file"]],[12,[" (method of ",[0,[1,"frame:basic-mixin"]],")"]]],["framework"]],
["on-edit-sequence",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._on-edit-sequence))",[[0,[1,"on-edit-sequence"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-edit-sequence",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abasic-mixin)._on-edit-sequence))",[[0,[1,"on-edit-sequence"]],[12,[" (method of ",[0,[1,"editor:basic-mixin"]],")"]]],["framework"]],
["on-edit-sequence",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._on-edit-sequence))",[[0,[1,"on-edit-sequence"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-edit-sequence",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._on-edit-sequence))",[[0,[1,"on-edit-sequence"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-edit-sequence",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3adelegate-mixin)._on-edit-sequence))",[[0,[1,"on-edit-sequence"]],[12,[" (method of ",[0,[1,"text:delegate-mixin"]],")"]]],["framework"]],
["on-enable-surrogate",">framework/Color.html#(meth._(((lib._framework/main..ss)._color~3atext-mode-mixin)._on-enable-surrogate))",[[0,[1,"on-enable-surrogate"]],[12,[" (method of ",[0,[1,"color:text-mode-mixin"]],")"]]],["framework"]],
["on-enable-surrogate",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~3c~25~3e)._on-enable-surrogate))",[[0,[1,"on-enable-surrogate"]],[12,[" (method of ",[0,[1,"mode:surrogate-text&lt;%&gt;"]],")"]]],["framework"]],
["on-enable-surrogate",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext-mode-mixin)._on-enable-surrogate))",[[0,[1,"on-enable-surrogate"]],[12,[" (method of ",[0,[1,"scheme:text-mode-mixin"]],")"]]],["framework"]],
["on-event",">gui/canvas___.html#(meth._(((lib._mred/main..ss)._canvas~3c~25~3e)._on-event))",[[0,[1,"on-event"]],[12,[" (method of ",[0,[1,"canvas&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-event",">gui/editor-canvas_.html#(meth._(((lib._mred/main..ss)._editor-canvas~25)._on-event))",[[0,[1,"on-event"]],[12,[" (method of ",[0,[1,"editor-canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-event",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._on-event))",[[0,[1,"on-event"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-event",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._on-event))",[[0,[1,"on-event"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-event",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._on-event))",[[0,[1,"on-event"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-event",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._on-event))",[[0,[1,"on-event"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-event",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aautocomplete-mixin)._on-event))",[[0,[1,"on-event"]],[12,[" (method of ",[0,[1,"text:autocomplete-mixin"]],")"]]],["framework"]],
["on-event",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3afirst-line-mixin)._on-event))",[[0,[1,"on-event"]],[12,[" (method of ",[0,[1,"text:first-line-mixin"]],")"]]],["framework"]],
["on-event",">mrlib/Name_Message.html#(meth._(((lib._mrlib/name-message..ss)._name-message~25)._on-event))",[[0,[1,"on-event"]],[12,[" (method of ",[0,[1,"name-message%"]],")"]]],["mrlib/name-message"]],
["on-execute",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e)._on-execute))",[[0,[1,"on-execute"]],[12,[" (method of ",[0,[1,"drscheme:language:language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["on-execute",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3amodule-based-language-~3elanguage-mixin)._on-execute))",[[0,[1,"on-execute"]],[12,[" (method of ",[0,[1,"drscheme:language:module-based-language-&gt;language-mixin"]],")"]]],["drscheme/tool-lib"]],
["on-execute",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3amodule-based-language~3c~25~3e)._on-execute))",[[0,[1,"on-execute"]],[12,[" (method of ",[0,[1,"drscheme:language:module-based-language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["on-execute",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-module-based-language-~3emodule-based-language-mixin)._on-execute))",[[0,[1,"on-execute"]],[12,[" (method of ",[0,[1,"drscheme:language:simple-module-based-language-&gt;module-based-language-mixin"]],")"]]],["drscheme/tool-lib"]],
["on-exit",">gui/top-level-window___.html#(meth._(((lib._mred/main..ss)._top-level-window~3c~25~3e)._on-exit))",[[0,[1,"on-exit"]],[12,[" (method of ",[0,[1,"top-level-window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-exit",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3abasic-mixin)._on-exit))",[[0,[1,"on-exit"]],[12,[" (method of ",[0,[1,"frame:basic-mixin"]],")"]]],["framework"]],
["on-focus",">gui/editor-canvas_.html#(meth._(((lib._mred/main..ss)._editor-canvas~25)._on-focus))",[[0,[1,"on-focus"]],[12,[" (method of ",[0,[1,"editor-canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-focus",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._on-focus))",[[0,[1,"on-focus"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-focus",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._on-focus))",[[0,[1,"on-focus"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-focus",">framework/Canvas.html#(meth._(((lib._framework/main..ss)._canvas~3ainfo-mixin)._on-focus))",[[0,[1,"on-focus"]],[12,[" (method of ",[0,[1,"canvas:info-mixin"]],")"]]],["framework"]],
["on-focus",">framework/Color.html#(meth._(((lib._framework/main..ss)._color~3atext-mixin)._on-focus))",[[0,[1,"on-focus"]],[12,[" (method of ",[0,[1,"color:text-mixin"]],")"]]],["framework"]],
["on-focus",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abasic-mixin)._on-focus))",[[0,[1,"on-focus"]],[12,[" (method of ",[0,[1,"editor:basic-mixin"]],")"]]],["framework"]],
["on-focus",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._on-focus))",[[0,[1,"on-focus"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-focus",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._on-focus))",[[0,[1,"on-focus"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-focus",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3asearching-mixin)._on-focus))",[[0,[1,"on-focus"]],[12,[" (method of ",[0,[1,"text:searching-mixin"]],")"]]],["framework"]],
["on-insert",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._on-insert))",[[0,[1,"on-insert"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-insert",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._on-insert))",[[0,[1,"on-insert"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-insert",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._on-insert))",[[0,[1,"on-insert"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-insert",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._on-insert))",[[0,[1,"on-insert"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-insert",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3abasic-mixin)._on-insert))",[[0,[1,"on-insert"]],[12,[" (method of ",[0,[1,"text:basic-mixin"]],")"]]],["framework"]],
["on-insert",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3anbsp-~3espace-mixin)._on-insert))",[[0,[1,"on-insert"]],[12,[" (method of ",[0,[1,"text:nbsp-&gt;space-mixin"]],")"]]],["framework"]],
["on-installer-run",">setup-plt/_plt-archives.html#(def._((lib._setup/plt-installer..ss)._on-installer-run))",[0,[1,"on-installer-run"]],["setup/plt-installer"]],
["on-interactive-move",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._on-interactive-move))",[[0,[1,"on-interactive-move"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-interactive-resize",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._on-interactive-resize))",[[0,[1,"on-interactive-resize"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-item-closed",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._on-item-closed))",[[0,[1,"on-item-closed"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["on-item-opened",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._on-item-opened))",[[0,[1,"on-item-opened"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["on-key-event",">teachpack/draw.html#(def._((lib._teachpack/htdp/draw..ss)._on-key-event))",[0,[1,"on-key-event"]],["teachpack/htdp/draw"]],
["on-key-event",">teachpack/world.html#(def._((lib._teachpack/htdp/world..ss)._on-key-event))",[0,[1,"on-key-event"]],["teachpack/htdp/world"]],
["on-load-file",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._on-load-file))",[[0,[1,"on-load-file"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-load-file",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._on-load-file))",[[0,[1,"on-load-file"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-load-file",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._on-load-file))",[[0,[1,"on-load-file"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-load-file",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3adelegate-mixin)._on-load-file))",[[0,[1,"on-load-file"]],[12,[" (method of ",[0,[1,"text:delegate-mixin"]],")"]]],["framework"]],
["on-local-char",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._on-local-char))",[[0,[1,"on-local-char"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-local-char",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._on-local-char))",[[0,[1,"on-local-char"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-local-char",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._on-local-char))",[[0,[1,"on-local-char"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-local-char",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports-mixin)._on-local-char))",[[0,[1,"on-local-char"]],[12,[" (method of ",[0,[1,"text:ports-mixin"]],")"]]],["framework"]],
["on-local-char",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3areturn-mixin)._on-local-char))",[[0,[1,"on-local-char"]],[12,[" (method of ",[0,[1,"text:return-mixin"]],")"]]],["framework"]],
["on-local-event",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._on-local-event))",[[0,[1,"on-local-event"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-local-event",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._on-local-event))",[[0,[1,"on-local-event"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-local-event",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._on-local-event))",[[0,[1,"on-local-event"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-mdi-activate",">gui/frame_.html#(meth._(((lib._mred/main..ss)._frame~25)._on-mdi-activate))",[[0,[1,"on-mdi-activate"]],[12,[" (method of ",[0,[1,"frame%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-menu-char",">gui/frame_.html#(meth._(((lib._mred/main..ss)._frame~25)._on-menu-char))",[[0,[1,"on-menu-char"]],[12,[" (method of ",[0,[1,"frame%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-message",">gui/top-level-window___.html#(meth._(((lib._mred/main..ss)._top-level-window~3c~25~3e)._on-message))",[[0,[1,"on-message"]],[12,[" (method of ",[0,[1,"top-level-window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-mouse-event",">teachpack/world.html#(def._((lib._teachpack/htdp/world..ss)._on-mouse-event))",[0,[1,"on-mouse-event"]],["teachpack/htdp/world"]],
["on-mouse-over-snips",">mrlib/graph-pasteboard___.html#(meth._(((lib._mrlib/graph..ss)._graph-pasteboard~3c~25~3e)._on-mouse-over-snips))",[[0,[1,"on-mouse-over-snips"]],[12,[" (method of ",[0,[1,"graph-pasteboard&lt;%&gt;"]],")"]]],["mrlib/graph"]],
["on-move",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._on-move))",[[0,[1,"on-move"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-move-to",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._on-move-to))",[[0,[1,"on-move-to"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-navigate",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-panel-mixin)._on-navigate))",[[0,[1,"on-navigate"]],[12,[" (method of ",[0,[1,"hyper-panel-mixin"]],")"]]],["browser"]],
["on-new-box",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._on-new-box))",[[0,[1,"on-new-box"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-new-box",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abasic-mixin)._on-new-box))",[[0,[1,"on-new-box"]],[12,[" (method of ",[0,[1,"editor:basic-mixin"]],")"]]],["framework"]],
["on-new-box",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._on-new-box))",[[0,[1,"on-new-box"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-new-box",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._on-new-box))",[[0,[1,"on-new-box"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-new-image-snip",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._on-new-image-snip))",[[0,[1,"on-new-image-snip"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-new-image-snip",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abasic-mixin)._on-new-image-snip))",[[0,[1,"on-new-image-snip"]],[12,[" (method of ",[0,[1,"editor:basic-mixin"]],")"]]],["framework"]],
["on-new-image-snip",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._on-new-image-snip))",[[0,[1,"on-new-image-snip"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-new-image-snip",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._on-new-image-snip))",[[0,[1,"on-new-image-snip"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-new-string-snip",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._on-new-string-snip))",[[0,[1,"on-new-string-snip"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-new-string-snip",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._on-new-string-snip))",[[0,[1,"on-new-string-snip"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-new-string-snip",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._on-new-string-snip))",[[0,[1,"on-new-string-snip"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-new-tab-snip",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._on-new-tab-snip))",[[0,[1,"on-new-tab-snip"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-new-tab-snip",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._on-new-tab-snip))",[[0,[1,"on-new-tab-snip"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-new-tab-snip",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._on-new-tab-snip))",[[0,[1,"on-new-tab-snip"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-paint",">gui/canvas_.html#(meth._(((lib._mred/main..ss)._canvas~25)._on-paint))",[[0,[1,"on-paint"]],[12,[" (method of ",[0,[1,"canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-paint",">gui/canvas___.html#(meth._(((lib._mred/main..ss)._canvas~3c~25~3e)._on-paint))",[[0,[1,"on-paint"]],[12,[" (method of ",[0,[1,"canvas&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-paint",">gui/editor-canvas_.html#(meth._(((lib._mred/main..ss)._editor-canvas~25)._on-paint))",[[0,[1,"on-paint"]],[12,[" (method of ",[0,[1,"editor-canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-paint",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._on-paint))",[[0,[1,"on-paint"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-paint",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._on-paint))",[[0,[1,"on-paint"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-paint",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._on-paint))",[[0,[1,"on-paint"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-paint",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aautocomplete-mixin)._on-paint))",[[0,[1,"on-paint"]],[12,[" (method of ",[0,[1,"text:autocomplete-mixin"]],")"]]],["framework"]],
["on-paint",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3abasic-mixin)._on-paint))",[[0,[1,"on-paint"]],[12,[" (method of ",[0,[1,"text:basic-mixin"]],")"]]],["framework"]],
["on-paint",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3adelegate-mixin)._on-paint))",[[0,[1,"on-paint"]],[12,[" (method of ",[0,[1,"text:delegate-mixin"]],")"]]],["framework"]],
["on-paint",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3afirst-line-mixin)._on-paint))",[[0,[1,"on-paint"]],[12,[" (method of ",[0,[1,"text:first-line-mixin"]],")"]]],["framework"]],
["on-paint",">mrlib/Name_Message.html#(meth._(((lib._mrlib/name-message..ss)._name-message~25)._on-paint))",[[0,[1,"on-paint"]],[12,[" (method of ",[0,[1,"name-message%"]],")"]]],["mrlib/name-message"]],
["on-popup",">gui/combo-field_.html#(meth._(((lib._mred/main..ss)._combo-field~25)._on-popup))",[[0,[1,"on-popup"]],[12,[" (method of ",[0,[1,"combo-field%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-redraw",">teachpack/world.html#(def._((lib._teachpack/htdp/world..ss)._on-redraw))",[0,[1,"on-redraw"]],["teachpack/htdp/world"]],
["on-reflow",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._on-reflow))",[[0,[1,"on-reflow"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-reorder",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._on-reorder))",[[0,[1,"on-reorder"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-replaced",">gui/clipboard-client_.html#(meth._(((lib._mred/main..ss)._clipboard-client~25)._on-replaced))",[[0,[1,"on-replaced"]],[12,[" (method of ",[0,[1,"clipboard-client%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-resize",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._on-resize))",[[0,[1,"on-resize"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-save-file",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._on-save-file))",[[0,[1,"on-save-file"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-save-file",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abackup-autosave-mixin)._on-save-file))",[[0,[1,"on-save-file"]],[12,[" (method of ",[0,[1,"editor:backup-autosave-mixin"]],")"]]],["framework"]],
["on-save-file",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._on-save-file))",[[0,[1,"on-save-file"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-save-file",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._on-save-file))",[[0,[1,"on-save-file"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-save-file",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aclever-file-format-mixin)._on-save-file))",[[0,[1,"on-save-file"]],[12,[" (method of ",[0,[1,"text:clever-file-format-mixin"]],")"]]],["framework"]],
["on-scroll",">gui/canvas_.html#(meth._(((lib._mred/main..ss)._canvas~25)._on-scroll))",[[0,[1,"on-scroll"]],[12,[" (method of ",[0,[1,"canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-select",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._on-select))",[[0,[1,"on-select"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-select",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._on-select))",[[0,[1,"on-select"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["on-select-always",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._on-select-always))",[[0,[1,"on-select-always"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["on-set-size-constraint",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._on-set-size-constraint))",[[0,[1,"on-set-size-constraint"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-set-size-constraint",">framework/Color.html#(meth._(((lib._framework/main..ss)._color~3atext-mixin)._on-set-size-constraint))",[[0,[1,"on-set-size-constraint"]],[12,[" (method of ",[0,[1,"color:text-mixin"]],")"]]],["framework"]],
["on-set-size-constraint",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._on-set-size-constraint))",[[0,[1,"on-set-size-constraint"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-set-size-constraint",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._on-set-size-constraint))",[[0,[1,"on-set-size-constraint"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-size",">gui/editor-canvas_.html#(meth._(((lib._mred/main..ss)._editor-canvas~25)._on-size))",[[0,[1,"on-size"]],[12,[" (method of ",[0,[1,"editor-canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-size",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._on-size))",[[0,[1,"on-size"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-size",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._on-size))",[[0,[1,"on-size"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["on-size",">framework/Canvas.html#(meth._(((lib._framework/main..ss)._canvas~3awide-snip-mixin)._on-size))",[[0,[1,"on-size"]],[12,[" (method of ",[0,[1,"canvas:wide-snip-mixin"]],")"]]],["framework"]],
["on-size",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asize-pref-mixin)._on-size))",[[0,[1,"on-size"]],[12,[" (method of ",[0,[1,"frame:size-pref-mixin"]],")"]]],["framework"]],
["on-snip-modified",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._on-snip-modified))",[[0,[1,"on-snip-modified"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-snip-modified",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text-mixin)._on-snip-modified))",[[0,[1,"on-snip-modified"]],[12,[" (method of ",[0,[1,"mode:host-text-mixin"]],")"]]],["framework"]],
["on-snip-modified",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3asurrogate-text~25)._on-snip-modified))",[[0,[1,"on-snip-modified"]],[12,[" (method of ",[0,[1,"mode:surrogate-text%"]],")"]]],["framework"]],
["on-submit",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._on-submit))",[[0,[1,"on-submit"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["on-subwindow-char",">gui/dialog_.html#(meth._(((lib._mred/main..ss)._dialog~25)._on-subwindow-char))",[[0,[1,"on-subwindow-char"]],[12,[" (method of ",[0,[1,"dialog%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-subwindow-char",">gui/frame_.html#(meth._(((lib._mred/main..ss)._frame~25)._on-subwindow-char))",[[0,[1,"on-subwindow-char"]],[12,[" (method of ",[0,[1,"frame%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-subwindow-char",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._on-subwindow-char))",[[0,[1,"on-subwindow-char"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-subwindow-event",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._on-subwindow-event))",[[0,[1,"on-subwindow-event"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-subwindow-event",">framework/Panel.html#(meth._(((lib._framework/main..ss)._panel~3adragable-mixin)._on-subwindow-event))",[[0,[1,"on-subwindow-event"]],[12,[" (method of ",[0,[1,"panel:dragable-mixin"]],")"]]],["framework"]],
["on-superwindow-enable",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._on-superwindow-enable))",[[0,[1,"on-superwindow-enable"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-superwindow-show",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._on-superwindow-show))",[[0,[1,"on-superwindow-show"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-superwindow-show",">framework/Canvas.html#(meth._(((lib._framework/main..ss)._canvas~3adelegate-mixin)._on-superwindow-show))",[[0,[1,"on-superwindow-show"]],[12,[" (method of ",[0,[1,"canvas:delegate-mixin"]],")"]]],["framework"]],
["on-superwindow-show",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3abasic-mixin)._on-superwindow-show))",[[0,[1,"on-superwindow-show"]],[12,[" (method of ",[0,[1,"frame:basic-mixin"]],")"]]],["framework"]],
["on-system-menu-char",">gui/top-level-window___.html#(meth._(((lib._mred/main..ss)._top-level-window~3c~25~3e)._on-system-menu-char))",[[0,[1,"on-system-menu-char"]],[12,[" (method of ",[0,[1,"top-level-window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-tab-change",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~3c~25~3e)._on-tab-change))",[[0,[1,"on-tab-change"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["on-tab-in",">gui/canvas___.html#(meth._(((lib._mred/main..ss)._canvas~3c~25~3e)._on-tab-in))",[[0,[1,"on-tab-in"]],[12,[" (method of ",[0,[1,"canvas&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-tick-event",">teachpack/draw.html#(def._((lib._teachpack/htdp/draw..ss)._on-tick-event))",[0,[1,"on-tick-event"]],["teachpack/htdp/draw"]],
["on-tick-event",">teachpack/world.html#(def._((lib._teachpack/htdp/world..ss)._on-tick-event))",[0,[1,"on-tick-event"]],["teachpack/htdp/world"]],
["on-toolbar-button-click",">gui/frame_.html#(meth._(((lib._mred/main..ss)._frame~25)._on-toolbar-button-click))",[[0,[1,"on-toolbar-button-click"]],[12,[" (method of ",[0,[1,"frame%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["on-traverse-char",">gui/top-level-window___.html#(meth._(((lib._mred/main..ss)._top-level-window~3c~25~3e)._on-traverse-char))",[[0,[1,"on-traverse-char"]],[12,[" (method of ",[0,[1,"top-level-window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["once-e",">frtime/index.html#(def._((lib._frtime/main..ss)._once-e))",[0,[1,"once-e"]],["frtime"]],
["one-of/c",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._one-of/c))",[0,[1,"one-of/c"]],["scheme/contract","scheme"]],
["onkeyevent",">teachpack/Jdraw.html#(def._((lib._teachpack/htdc/draw..ss)._on.Key.Event))",[0,[1,"onKeyEvent"]],["teachpack/htdc/draw"]],
["only",">reference/creatingunits.html#(form._((lib._mzlib/unit..ss)._only))",[0,[6,"only"]],["scheme/unit","scheme"]],
["only-in",">reference/require.html#(form._((lib._scheme/base..ss)._only-in))",[0,[6,"only-in"]],["scheme/base","scheme"]],
["only-meta-in",">reference/require.html#(form._((lib._scheme/base..ss)._only-meta-in))",[0,[6,"only-meta-in"]],["scheme/base","scheme"]],
["onscreen",">scribble/doc-strings.html#(def._((lib._scribble/manual..ss)._onscreen))",[0,[1,"onscreen"]],["scribble/manual"]],
["ontick",">teachpack/Jdraw.html#(def._((lib._teachpack/htdc/draw..ss)._on.Tick))",[0,[1,"onTick"]],["teachpack/htdc/draw"]],
["opaque",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_302",[0,[6,"opaque"]],["rnrs/records/syntactic-6"]],
["opaque",">gui/brush_.html#(idx._(gentag._178._(lib._scribblings/gui/gui..scrbl)))",[7,"'opaque"],false],
["opaque",">reference/stxcerts.html#(idx._(gentag._89._(lib._scribblings/reference/reference..scrbl)))",[7,"'opaque"],false],
["opaque",">guide/define-struct.html#(tech._opaque)","<i>opaque</i>",false],
["opaque versus transparent stucture types",">guide/define-struct.html#(part._trans-struct)","Opaque versus Transparent Stucture Types",false],
["open",">planet/cmdline.html#(part._open)",[5,"open"],false],
["open",">reference/creatingunits.html#(form._((lib._mzlib/unit..ss)._open))",[0,[6,"open"]],["scheme/unit","scheme"]],
["open",">mrlib/hierarchical-list-compound-item___.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list-compound-item~3c~25~3e)._open))",[[0,[1,"open"]],[12,[" (method of ",[0,[1,"hierarchical-list-compound-item&lt;%&gt;"]],")"]]],["mrlib/hierlist"]],
["open recent menu item",">drscheme/Menus.html#(idx._(gentag._61._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Open Recent</font></b> menu item",false],
["open sub-path",">gui/dc-path_.html#(tech._open._sub._path)","<i>open sub-path</i>",false],
["open-bytevector-input-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_672",[0,[1,"open-bytevector-input-port"]],["rnrs/io/ports-6"]],
["open-bytevector-output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_720",[0,[1,"open-bytevector-output-port"]],["rnrs/io/ports-6"]],
["open-file-input-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_668",[0,[1,"open-file-input-port"]],["rnrs/io/ports-6"]],
["open-file-input/output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_758",[0,[1,"open-file-input/output-port"]],["rnrs/io/ports-6"]],
["open-file-output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_716",[0,[1,"open-file-output-port"]],["rnrs/io/ports-6"]],
["open-graphics",">graphics/Basic_Commands.html#(def._((lib._graphics/graphics..ss)._open-graphics))",[0,[1,"open-graphics"]],["graphics/graphics"]],
["open-here",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aopen-here~3c~25~3e)._open-here))",[[0,[1,"open-here"]],[12,[" (method of ",[0,[1,"frame:open-here&lt;%&gt;"]],")"]]],["framework"]],
["open-input-bytes",">reference/stringport.html#(def._((quote._~23~25kernel)._open-input-bytes))",[0,[1,"open-input-bytes"]],["scheme/base","scheme"]],
["open-input-file",">reference/file-ports.html#(def._((lib._scheme/base..ss)._open-input-file))",[0,[1,"open-input-file"]],["scheme/base","scheme"]],
["open-input-file",">r5rs-std/r5rs-Z-H-9.html#%_idx_626",[0,[1,"open-input-file"]],["r5rs"]],
["open-input-file",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_800",[0,[1,"open-input-file"]],["rnrs/io/simple-6"]],
["open-input-file",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..ss)._open-input-file))",[0,[1,"open-input-file"]],["mzscheme"]],
["open-input-graphical-file",">gui/Editor_Functions.html#(def._((lib._mred/main..ss)._open-input-graphical-file))",[0,[1,"open-input-graphical-file"]],["scheme/gui/base","scheme/gui"]],
["open-input-output-file",">reference/file-ports.html#(def._((lib._scheme/base..ss)._open-input-output-file))",[0,[1,"open-input-output-file"]],["scheme/base","scheme"]],
["open-input-output-file",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..ss)._open-input-output-file))",[0,[1,"open-input-output-file"]],["mzscheme"]],
["open-input-string",">reference/stringport.html#(def._((quote._~23~25kernel)._open-input-string))",[0,[1,"open-input-string"]],["scheme/base","scheme"]],
["open-input-string",">srfi-std/srfi-6.html#open-input-string",[0,[1,"open-input-string"]],["srfi/6"]],
["open-input-text-editor",">gui/Editor_Functions.html#(def._((lib._mred/main..ss)._open-input-text-editor))",[0,[1,"open-input-text-editor"]],["scheme/gui/base","scheme/gui"]],
["open-line",">framework/Keymap.html#(idx._(gentag._20._(lib._scribblings/framework/framework..scrbl)))","open-line",false],
["open-news-group",">net/nntp.html#(def._((lib._net/nntp..ss)._open-news-group))",[0,[1,"open-news-group"]],["net/nntp"]],
["open-output-bytes",">reference/stringport.html#(def._((quote._~23~25kernel)._open-output-bytes))",[0,[1,"open-output-bytes"]],["scheme/base","scheme"]],
["open-output-file",">reference/file-ports.html#(def._((lib._scheme/base..ss)._open-output-file))",[0,[1,"open-output-file"]],["scheme/base","scheme"]],
["open-output-file",">r5rs-std/r5rs-Z-H-9.html#%_idx_628",[0,[1,"open-output-file"]],["r5rs"]],
["open-output-file",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_802",[0,[1,"open-output-file"]],["rnrs/io/simple-6"]],
["open-output-file",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..ss)._open-output-file))",[0,[1,"open-output-file"]],["mzscheme"]],
["open-output-nowhere",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._open-output-nowhere))",[0,[1,"open-output-nowhere"]],["scheme/port"]],
["open-output-string",">reference/stringport.html#(def._((quote._~23~25kernel)._open-output-string))",[0,[1,"open-output-string"]],["scheme/base","scheme"]],
["open-output-string",">srfi-std/srfi-6.html#open-output-string",[0,[1,"open-output-string"]],["srfi/6"]],
["open-output-text-editor",">gui/Editor_Functions.html#(def._((lib._mred/main..ss)._open-output-text-editor))",[0,[1,"open-output-text-editor"]],["scheme/gui/base","scheme/gui"]],
["open-pixmap",">graphics/Basic_Commands.html#(def._((lib._graphics/graphics..ss)._open-pixmap))",[0,[1,"open-pixmap"]],["graphics/graphics"]],
["open-status-line",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astatus-line~3c~25~3e)._open-status-line))",[[0,[1,"open-status-line"]],[12,[" (method of ",[0,[1,"frame:status-line&lt;%&gt;"]],")"]]],["framework"]],
["open-string-input-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_674",[0,[1,"open-string-input-port"]],["rnrs/io/ports-6"]],
["open-string-output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_726",[0,[1,"open-string-output-port"]],["rnrs/io/ports-6"]],
["open-url",">browser/index.html#(def._((lib._browser/main..ss)._open-url))",[0,[1,"open-url"]],["browser"]],
["open-viewport",">graphics/Basic_Commands.html#(def._((lib._graphics/graphics..ss)._open-viewport))",[0,[1,"open-viewport"]],["graphics/graphics"]],
["open... menu item",">drscheme/Menus.html#(idx._(gentag._60._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Open...</font></b> menu item",false],
["open?",">gui/dc-path_.html#(meth._(((lib._mred/main..ss)._dc-path~25)._open~3f))",[[0,[1,"open?"]],[12,[" (method of ",[0,[1,"dc-path%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["opengl",">sgl/index.html#(idx._(gentag._0._(lib._sgl/scribblings/sgl..scrbl)))","OpenGL",false],
["opengl",">gui/gl-context___.html#(idx._(gentag._215._(lib._scribblings/gui/gui..scrbl)))","OpenGL",false],
["opengl vectors",">sgl/gl-vectors.html","OpenGL Vectors",false],
["openssl",">openssl/index.html","<b>OpenSSL</b>",false],
["openssl",">openssl/index.html",[14,[0,"openssl"]],"module"],
["operating system",">reference/os.html","Operating System",false],
["opt-lambda",">mzlib/mzlib_etc.html#(form._((lib._mzlib/etc..ss)._opt-lambda))",[0,[6,"opt-lambda"]],["mzlib/etc"]],
["opt/c",">reference/Contract_Utilities.html#(form._((lib._scheme/contract..ss)._opt/c))",[0,[6,"opt/c"]],["scheme/contract","scheme"]],
["optgroup",">html/index.html#(def._((lib._html/main..ss)._optgroup))",[0,[1,"optgroup"]],["html"]],
["optgroup?",">html/index.html#(def._((lib._html/main..ss)._optgroup~3f))",[0,[1,"optgroup?"]],["html"]],
["option",">html/index.html#(def._((lib._html/main..ss)._option))",[0,[1,"option"]],["html"]],
["option",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._.Option))",[0,[6,"Option"]],["typed-scheme"]],
["option?",">html/index.html#(def._((lib._html/main..ss)._option~3f))",[0,[1,"option?"]],["html"]],
["optional",">scribble/bnf.html#(def._((lib._scribble/bnf..ss)._optional))",[0,[1,"optional"]],["scribble/bnf"]],
["optional arguments",">mzlib/mzlib_kw.html#(part._.Optional_.Arguments)","Optional Arguments",false],
["optional arguments",">guide/contracts-general-functions.html#(part._contracts-optional)","Optional Arguments",false],
["optional keyword arguments",">guide/contracts-general-functions.html#(part._contracts-optional-keywords)","Optional Keyword Arguments",false],
["options for the compiler",">mzc/Scheme_API_for_Compilation.html#(part._api~3aoptions)","Options for the Compiler",false],
["options signature",">setup-plt/setup-plt-plt.html#(part._.Options_.Signature)","Options Signature",false],
["options unit",">mzc/Scheme_API_for_Compilation.html#(part._.Options_.Unit)","Options Unit",false],
["options unit",">setup-plt/setup-plt-plt.html#(part._.Options_.Unit)","Options Unit",false],
["or",">htdp-langs/or.html",[0,[6,"or"]],false],
["or",">reference/if.html#(form._((lib._scheme/private/letstx-scheme..ss)._or))",[0,[6,"or"]],["scheme/base","scheme"]],
["or",">r5rs-std/r5rs-Z-H-7.html#%_idx_122",[0,[6,"or"]],["r5rs"]],
["or",">r6rs-std/r6rs-Z-H-14.html#node_idx_390",[0,[6,"or"]],["rnrs/base-6"]],
["or",">htdp-langs/advanced-unchanged.html#(form._((lib._lang/htdp-advanced..ss)._or))",[0,[6,"or"]],["lang/htdp-advanced"]],
["or",">htdp-langs/or.html#(form._((lib._lang/htdp-beginner..ss)._or))",[0,[6,"or"]],["lang/htdp-beginner"]],
["or",">htdp-langs/Unchanged_Forms.html#(form._((lib._lang/htdp-beginner-abbr..ss)._or))",[0,[6,"or"]],["lang/htdp-beginner-abbr"]],
["or",">htdp-langs/intermediate-unchanged.html#(form._((lib._lang/htdp-intermediate..ss)._or))",[0,[6,"or"]],["lang/htdp-intermediate"]],
["or",">htdp-langs/intermediate-lambda-unchanged.html#(form._((lib._lang/htdp-intermediate-lambda..ss)._or))",[0,[6,"or"]],["lang/htdp-intermediate-lambda"]],
["or",">lazy/index.html#(def._((lib._lazy/main..ss)._or))",[0,[1,"or"]],["lazy"]],
["or",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-sre..ss)._or))",[0,[6,"or"]],["parser-tools/lex-sre"]],
["or",">srfi-std/srfi-42.html#or",[0,[6,"or"]],["srfi/42"]],
["or/c",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._or/c))",[0,[1,"or/c"]],["scheme/contract","scheme"]],
["order-manuals",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e)._order-manuals))",[[0,[1,"order-manuals"]],[12,[" (method of ",[0,[1,"drscheme:language:language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["org.plt-scheme.prefs.ss",">drscheme/drscheme-files.html#(idx._(gentag._223._(lib._scribblings/drscheme/drscheme..scrbl)))",[5,"\"org.plt-scheme.prefs.ss\""],false],
["orig-dir",">reference/Filesystem.html#(idx._(gentag._261._(lib._scribblings/reference/reference..scrbl)))",[7,"'orig-dir"],false],
["origin",">reference/stxprops.html#(idx._(gentag._84._(lib._scribblings/reference/reference..scrbl)))",[7,"'origin"],false],
["ormap",">reference/pairs.html#(def._((quote._~23~25kernel)._ormap))",[0,[1,"ormap"]],["scheme/base","scheme"]],
["ormap",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._ormap))",[0,[1,"ormap"]],["lang/htdp-advanced"]],
["ormap",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._ormap))",[0,[1,"ormap"]],["lang/htdp-intermediate"]],
["ormap",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._ormap))",[0,[1,"ormap"]],["lang/htdp-intermediate-lambda"]],
["ormap",">lazy/index.html#(def._((lib._lazy/main..ss)._ormap))",[0,[1,"ormap"]],["lazy"]],
["os",">reference/runtime.html#(idx._(gentag._295._(lib._scribblings/reference/reference..scrbl)))",[7,"'os"],false],
["other atomic types",">foreign/Other_Atomic_Types.html","Other Atomic Types",false],
["other errortrace bindings",">errortrace/using-errortrace.html#(part._other-errortrace-bindings)","Other Errortrace Bindings",false],
["other experimental languages",">drscheme/experimental-langs.html","Other Experimental Languages",false],
["other string types",">foreign/String_Types.html#(part._.Other_.String_.Types)","Other String Types",false],
["other-manual",">scribble/section-links.html#(def._((lib._scribble/manual..ss)._other-manual))",[0,[1,"other-manual"]],["scribble/manual"]],
["out button",">drscheme/debugger.html#(idx._(gentag._37._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Out</font></b> button",false],
["outline-flash",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/flash..ss)._outline-flash))",[0,[1,"outline-flash"]],["slideshow/flash"]],
["output printing styles",">drscheme/output-syntax.html","Output Printing Styles",false],
["output-http-headers",">net/cgi.html#(def._((lib._net/cgi..ss)._output-http-headers))",[0,[1,"output-http-headers"]],["net/cgi"]],
["output-port-buffer-mode",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_714",[0,[1,"output-port-buffer-mode"]],["rnrs/io/ports-6"]],
["output-port?",">reference/port-ops.html#(def._((quote._~23~25kernel)._output-port~3f))",[0,[1,"output-port?"]],["scheme/base","scheme"]],
["output-port?",">r5rs-std/r5rs-Z-H-9.html#%_idx_616",[0,[1,"output-port?"]],["r5rs"]],
["output-port?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_710",[0,[1,"output-port?"]],["rnrs/io/ports-6"]],
["output-profile-results",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..ss)._output-profile-results))",[0,[1,"output-profile-results"]],["errortrace"]],
["over button",">drscheme/debugger.html#(idx._(gentag._36._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Over</font></b> button",false],
["overflow",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._overflow))",[[0,[1,"overflow"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["overflow-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._overflow-native))",[[0,[1,"overflow-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["overlay",">teachpack/image.html#(def._((lib._htdp/image..ss)._overlay))",[0,[1,"overlay"]],["teachpack/htdp/image"]],
["overlay-bitmap",">mrlib/Cache-image_Snip.html#(def._((lib._mrlib/cache-image-snip..ss)._overlay-bitmap))",[0,[1,"overlay-bitmap"]],["mrlib/cache-image-snip"]],
["overlay/xy",">teachpack/image.html#(def._((lib._htdp/image..ss)._overlay/xy))",[0,[1,"overlay/xy"]],["teachpack/htdp/image"]],
["overment",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._overment))",[0,[6,"overment"]],["scheme/class","scheme"]],
["overment*",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._overment*))",[0,[6,"overment*"]],["scheme/class","scheme"]],
["override",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._override))",[0,[6,"override"]],["scheme/class","scheme"]],
["override*",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._override*))",[0,[6,"override*"]],["scheme/class","scheme"]],
["override-final",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._override-final))",[0,[6,"override-final"]],["scheme/class","scheme"]],
["override-final*",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._override-final*))",[0,[6,"override-final*"]],["scheme/class","scheme"]],
["overriding",">reference/mzlib_class.html#(tech._overriding)","<i>overriding</i>",false],
["overriding the installation's configuration",">config/index.html#(part._.Overriding_the_.Installation_s_.Configuration)","Overriding the Installation&rsquo;s Configuration",false],
["overview",">make/overview.html","Overview",false],
["overview",">mysterx/overview.html","Overview",false],
["overview",">plot/Quick_Start.html#(part._.Overview)","Overview",false],
["overview",">preprocessor/overview.html","Overview",false],
["overview",">foreign/intro.html","Overview",false],
["overview",">gui/Overview.html","Overview",false],
["overview",">inside/overview.html","Overview",false],
["overwrite mode",">drscheme/Keyboard_Shortcuts.html#(idx._(gentag._206._(lib._scribblings/drscheme/drscheme..scrbl)))","overwrite mode",false],
["overwrite-status-changed",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3atext-info~3c~25~3e)._overwrite-status-changed))",[[0,[1,"overwrite-status-changed"]],[12,[" (method of ",[0,[1,"frame:text-info&lt;%&gt;"]],")"]]],["framework"]],
["own-caret",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._own-caret))",[[0,[1,"own-caret"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["own-caret",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._own-caret))",[[0,[1,"own-caret"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["p",">html/index.html#(def._((lib._html/main..ss)._p))",[0,[1,"p"]],["html"]],
["p-i",">xml/index.html#(def._((lib._xml/main..ss)._p-i))",[0,[1,"p-i"]],["xml"]],
["p-i-instruction",">xml/index.html#(def._((lib._xml/main..ss)._p-i-instruction))",[0,[1,"p-i-instruction"]],["xml"]],
["p-i-target-name",">xml/index.html#(def._((lib._xml/main..ss)._p-i-target-name))",[0,[1,"p-i-target-name"]],["xml"]],
["p-i?",">xml/index.html#(def._((lib._xml/main..ss)._p-i~3f))",[0,[1,"p-i?"]],["xml"]],
["p?",">html/index.html#(def._((lib._html/main..ss)._p~3f))",[0,[1,"p?"]],["html"]],
["pack",">setup-plt/_plt-archives.html#(def._((lib._setup/pack..ss)._pack))",[0,[1,"pack"]],["setup/pack"]],
["pack-collections",">setup-plt/_plt-archives.html#(def._((lib._setup/pack..ss)._pack-collections))",[0,[1,"pack-collections"]],["setup/pack"]],
["pack-collections-plt",">setup-plt/_plt-archives.html#(def._((lib._setup/pack..ss)._pack-collections-plt))",[0,[1,"pack-collections-plt"]],["setup/pack"]],
["pack-plt",">setup-plt/_plt-archives.html#(def._((lib._setup/pack..ss)._pack-plt))",[0,[1,"pack-plt"]],["setup/pack"]],
["package",">htdc/advanced_pack.html",[0,"package"],false],
["packaging library collections",">mzc/plt.html","Packaging Library Collections",false],
["padding",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._padding))",[[0,[1,"padding"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["padding-bottom",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._padding-bottom))",[[0,[1,"padding-bottom"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["padding-bottom-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._padding-bottom-native))",[[0,[1,"padding-bottom-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["padding-left",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._padding-left))",[[0,[1,"padding-left"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["padding-left-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._padding-left-native))",[[0,[1,"padding-left-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["padding-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._padding-native))",[[0,[1,"padding-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["padding-right",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._padding-right))",[[0,[1,"padding-right"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["padding-right-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._padding-right-native))",[[0,[1,"padding-right-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["padding-top",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._padding-top))",[[0,[1,"padding-top"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["padding-top-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._padding-top-native))",[[0,[1,"padding-top-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["page->editor",">browser/index.html#(def._((lib._browser/main..ss)._page-~3eeditor))",[0,[1,"page-&gt;editor"]],["browser"]],
["page-down",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._page-down))",[[0,[1,"page-down"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["page-up",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._page-up))",[[0,[1,"page-up"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["pagebreak-after",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._pagebreak-after))",[[0,[1,"pagebreak-after"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["pagebreak-after-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._pagebreak-after-native))",[[0,[1,"pagebreak-after-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["pagebreak-before",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._pagebreak-before))",[[0,[1,"pagebreak-before"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["pagebreak-before-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._pagebreak-before-native))",[[0,[1,"pagebreak-before-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["paint by numbers --- logic game",">games/paint-by-numbers.html",[[13,"<img src=\"paint-by-numbers.png\" />"]," ","<b><font size=\"-1\" face=\"Helvetica\">Paint By Numbers</font></b>","  ","&ndash;","  Logic Game"],false],
["pair",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._.Pair))",[0,[6,"Pair"]],["typed-scheme"]],
["pair",">guide/pairs.html#(tech._pair)","<i>pair</i>",false],
["pair",">reference/pairs.html#(tech._pair)","<i>pair</i>",false],
["pair accessor shorthands",">reference/pairs.html#(part._.Pair_.Accessor_.Shorthands)","Pair Accessor Shorthands",false],
["pair constructors and selectors",">reference/pairs.html#(part._.Pair_.Constructors_and_.Selectors)","Pair Constructors and Selectors",false],
["pair-fold",">srfi-std/srfi-1.html#pair-fold",[0,[1,"pair-fold"]],["srfi/1"]],
["pair-fold-right",">srfi-std/srfi-1.html#pair-fold-right",[0,[1,"pair-fold-right"]],["srfi/1"]],
["pair-for-each",">srfi-std/srfi-1.html#pair-for-each",[0,[1,"pair-for-each"]],["srfi/1"]],
["pair?",">reference/pairs.html#(def._((quote._~23~25kernel)._pair~3f))",[0,[1,"pair?"]],["scheme/base","scheme"]],
["pair?",">r5rs-std/r5rs-Z-H-9.html#%_idx_406",[0,[1,"pair?"]],["r5rs"]],
["pair?",">r6rs-std/r6rs-Z-H-14.html#node_idx_608",[0,[1,"pair?"]],["rnrs/base-6"]],
["pair?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._pair~3f))",[0,[1,"pair?"]],["lang/htdp-advanced"]],
["pair?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._pair~3f))",[0,[1,"pair?"]],["lang/htdp-beginner"]],
["pair?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._pair~3f))",[0,[1,"pair?"]],["lang/htdp-beginner-abbr"]],
["pair?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._pair~3f))",[0,[1,"pair?"]],["lang/htdp-intermediate"]],
["pair?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._pair~3f))",[0,[1,"pair?"]],["lang/htdp-intermediate-lambda"]],
["pair?",">srfi-std/srfi-1.html#pair-p",[0,[1,"pair?"]],["srfi/1"]],
["pairs and lists",">guide/pairs.html","Pairs and Lists",false],
["pairs and lists",">reference/pairs.html","Pairs and Lists",false],
["pairs, lists, and scheme syntax",">guide/Pairs__Lists__and_Scheme_Syntax.html","Pairs, Lists, and Scheme Syntax",false],
["pane",">gui/windowing-overview.html#(tech._pane)","<i>pane</i>",false],
["pane%",">gui/pane_.html",[0,[1,"pane%"]],["scheme/gui/base","scheme/gui"]],
["panel",">framework/Panel.html","Panel",false],
["panel",">gui/brush_.html#(idx._(gentag._182._(lib._scribblings/gui/gui..scrbl)))",[7,"'panel"],false],
["panel",">gui/windowing-overview.html#(tech._panel)","<i>panel</i>",false],
["panel%",">gui/panel_.html",[0,[1,"panel%"]],["scheme/gui/base","scheme/gui"]],
["panel:dragable-mixin",">framework/Panel.html#(def._((lib._framework/main..ss)._panel~3adragable-mixin))",[0,[1,"panel:dragable-mixin"]],["framework"]],
["panel:dragable<%>",">framework/Panel.html#(def._((lib._framework/main..ss)._panel~3adragable~3c~25~3e))",[0,[1,"panel:dragable&lt;%&gt;"]],["framework"]],
["panel:horizontal-dragable%",">framework/Panel.html#(def._((lib._framework/main..ss)._panel~3ahorizontal-dragable~25))",[0,[1,"panel:horizontal-dragable%"]],["framework"]],
["panel:horizontal-dragable-mixin",">framework/Panel.html#(def._((lib._framework/main..ss)._panel~3ahorizontal-dragable-mixin))",[0,[1,"panel:horizontal-dragable-mixin"]],["framework"]],
["panel:horizontal-dragable<%>",">framework/Panel.html#(def._((lib._framework/main..ss)._panel~3ahorizontal-dragable~3c~25~3e))",[0,[1,"panel:horizontal-dragable&lt;%&gt;"]],["framework"]],
["panel:single%",">framework/Panel.html#(def._((lib._framework/main..ss)._panel~3asingle~25))",[0,[1,"panel:single%"]],["framework"]],
["panel:single-mixin",">framework/Panel.html#(def._((lib._framework/main..ss)._panel~3asingle-mixin))",[0,[1,"panel:single-mixin"]],["framework"]],
["panel:single-pane%",">framework/Panel.html#(def._((lib._framework/main..ss)._panel~3asingle-pane~25))",[0,[1,"panel:single-pane%"]],["framework"]],
["panel:single-window-mixin",">framework/Panel.html#(def._((lib._framework/main..ss)._panel~3asingle-window-mixin))",[0,[1,"panel:single-window-mixin"]],["framework"]],
["panel:single-window<%>",">framework/Panel.html#(def._((lib._framework/main..ss)._panel~3asingle-window~3c~25~3e))",[0,[1,"panel:single-window&lt;%&gt;"]],["framework"]],
["panel:single<%>",">framework/Panel.html#(def._((lib._framework/main..ss)._panel~3asingle~3c~25~3e))",[0,[1,"panel:single&lt;%&gt;"]],["framework"]],
["panel:vertical-dragable%",">framework/Panel.html#(def._((lib._framework/main..ss)._panel~3avertical-dragable~25))",[0,[1,"panel:vertical-dragable%"]],["framework"]],
["panel:vertical-dragable-mixin",">framework/Panel.html#(def._((lib._framework/main..ss)._panel~3avertical-dragable-mixin))",[0,[1,"panel:vertical-dragable-mixin"]],["framework"]],
["panel:vertical-dragable<%>",">framework/Panel.html#(def._((lib._framework/main..ss)._panel~3avertical-dragable~3c~25~3e))",[0,[1,"panel:vertical-dragable&lt;%&gt;"]],["framework"]],
["panorama",">slideshow/Bounding-Box_Adjusters.html#(def._((lib._slideshow/pict..ss)._panorama))",[0,[1,"panorama"]],["slideshow/pict","slideshow"]],
["para",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..ss)._para))",[0,[1,"para"]],["slideshow/base","slideshow"]],
["paragraph",">scribble/struct.html#(def._((lib._scribble/struct..ss)._paragraph))",[0,[1,"paragraph"]],["scribble/struct"]],
["paragraph",">scribble/struct.html#(tech._paragraph)","<i>paragraph</i>",false],
["paragraph-content",">scribble/struct.html#(def._((lib._scribble/struct..ss)._paragraph-content))",[0,[1,"paragraph-content"]],["scribble/struct"]],
["paragraph-end-line",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._paragraph-end-line))",[[0,[1,"paragraph-end-line"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["paragraph-end-position",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._paragraph-end-position))",[[0,[1,"paragraph-end-position"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["paragraph-start-line",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._paragraph-start-line))",[[0,[1,"paragraph-start-line"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["paragraph-start-position",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._paragraph-start-position))",[[0,[1,"paragraph-start-position"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["paragraph?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._paragraph~3f))",[0,[1,"paragraph?"]],["scribble/struct"]],
["parallel binding: let",">guide/let.html#(part._.Parallel_.Binding__let)",["Parallel Binding: ",[0,[6,"let"]]],false],
["param",">html/index.html#(def._((lib._html/main..ss)._param))",[0,[1,"param"]],["html"]],
["param?",">html/index.html#(def._((lib._html/main..ss)._param~3f))",[0,[1,"param?"]],["html"]],
["parameter",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._.Parameter))",[0,[6,"Parameter"]],["typed-scheme"]],
["parameter procedure",">reference/eval-model.html#(tech._parameter._procedure)","<i>parameter procedure</i>",false],
["parameter-procedure=?",">reference/parameters.html#(def._((quote._~23~25kernel)._parameter-procedure~3d~3f))",[0,[1,"parameter-procedure=?"]],["scheme/base","scheme"]],
["parameter/c",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._parameter/c))",[0,[1,"parameter/c"]],["scheme/contract","scheme"]],
["parameter?",">reference/parameters.html#(def._((quote._~23~25kernel)._parameter~3f))",[0,[1,"parameter?"]],["scheme/base","scheme"]],
["parameterization",">reference/eval-model.html#(tech._parameterization)","<i>parameterization</i>",false],
["parameterization?",">reference/parameters.html#(def._((quote._~23~25kernel)._parameterization~3f))",[0,[1,"parameterization?"]],["scheme/base","scheme"]],
["parameterizations",">inside/config.html","Parameterizations",false],
["parameterize",">reference/parameters.html#(form._((lib._scheme/private/more-scheme..ss)._parameterize))",[0,[6,"parameterize"]],["scheme/base","scheme"]],
["parameterize",">lazy/index.html#(form._((lib._lazy/main..ss)._parameterize))",[0,[6,"parameterize"]],["lazy"]],
["parameterize",">srfi-std/srfi-39.html#parameterize",[0,[6,"parameterize"]],["srfi/39"]],
["parameterize*",">reference/parameters.html#(form._((lib._scheme/private/more-scheme..ss)._parameterize*))",[0,[6,"parameterize*"]],["scheme/base","scheme"]],
["parameterize-break",">reference/breakhandler.html#(form._((lib._scheme/private/more-scheme..ss)._parameterize-break))",[0,[6,"parameterize-break"]],["scheme/base","scheme"]],
["parameterized mixins",">guide/classes.html#(part._parammixins)","Parameterized Mixins",false],
["parameters",">reference/eval-model.html#(part._parameter-model)","Parameters",false],
["parameters",">reference/parameters.html","Parameters",false],
["parameters",">xml/index.html#(part._.Parameters)","Parameters",false],
["parameters",">reference/eval-model.html#(tech._parameter)","<i>Parameters</i>",false],
["parcheesi --- board game",">games/parcheesi.html",[[13,"<img src=\"parcheesi.png\" />"]," ","<b><font size=\"-1\" face=\"Helvetica\">Parcheesi</font></b>","  ","&ndash;","  Board Game"],false],
["paren-format",">web-server/dispatch-log_ss.html#(def._((lib._web-server/dispatchers/dispatch-log..ss)._paren-format))",[0,[1,"paren-format"]],["web-server/dispatchers/dispatch-log"]],
["paren-pairs",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..ss)._paren-pairs))",[0,[1,"paren-pairs"]],["preprocessor/mztext"]],
["paren-shape",">reference/reader.html#(idx._(gentag._148._(lib._scribblings/reference/reference..scrbl)))",[7,"'paren-shape"],false],
["paren-tree%",">syntax-color/index.html#(def._((lib._syntax-color/paren-tree..ss)._paren-tree~25))",[0,[1,"paren-tree%"]],["syntax-color/paren-tree"]],
["parent",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_296",[0,[6,"parent"]],["rnrs/records/syntactic-6"]],
["parent-rtd",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_306",[0,[6,"parent-rtd"]],["rnrs/records/syntactic-6"]],
["parentheses, brackets, and braces",">honu/H-expressions.html#(part._honu~3aparens)","Parentheses, Brackets, and Braces",false],
["parenthesis matching",">syntax-color/index.html#(part._.Parenthesis_.Matching)","Parenthesis Matching",false],
["parse",">reference/syntax-model.html#(tech._parse)","<i>parse</i>",false],
["parse-command-line",">reference/Command-Line_Parsing.html#(def._((lib._scheme/cmdline..ss)._parse-command-line))",[0,[1,"parse-command-line"]],["scheme/cmdline","scheme"]],
["parse-define-struct",">syntax/transformer-helpers.html#(def._((lib._syntax/struct..ss)._parse-define-struct))",[0,[1,"parse-define-struct"]],["syntax/struct"]],
["parse-post",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-2..ss)._parse-post))",[0,"parse-post"],[]],
["parsed",">reference/syntax-model.html#(tech._parsed)","<i>parsed</i>",false],
["parser",">parser-tools/Parsers.html#(form._((lib._parser-tools/yacc..ss)._parser))",[0,[6,"parser"]],["parser-tools/yacc"]],
["parser tools: lex and yacc-style parsing",">parser-tools/index.html",["<b>Parser Tools</b>",": ",[5,"lex"]," and ",[5,"yacc"],"-style Parsing"],false],
["parser-tools/lex",">parser-tools/Lexers.html",[14,[0,"parser-tools/lex"]],"module"],
["parser-tools/lex-plt-v200",">parser-tools/Lexers.html#(mod-path._parser-tools/lex-plt-v200)",[14,[0,"parser-tools/lex-plt-v200"]],"module"],
["parser-tools/lex-sre",">parser-tools/Lexers.html#(mod-path._parser-tools/lex-sre)",[14,[0,"parser-tools/lex-sre"]],"module"],
["parser-tools/yacc",">parser-tools/Parsers.html",[14,[0,"parser-tools/yacc"]],"module"],
["parser-tools/yacc-to-scheme",">parser-tools/Converting_yacc_or_bison_Grammars.html",[14,[0,"parser-tools/yacc-to-scheme"]],"module"],
["parsers",">parser-tools/Parsers.html","Parsers",false],
["parsing a cookie",">net/cookie.html#(part._.Parsing_a_cookie)","Parsing a cookie",false],
["parsing define-like forms",">syntax/transformer-helpers.html#(part._define)",["Parsing ",[0,[6,"define"]],"-like Forms"],false],
["part",">scribble/struct.html#(def._((lib._scribble/struct..ss)._part))",[0,[1,"part"]],["scribble/struct"]],
["part",">scribble/struct.html#(tech._part)","<i>part</i>",false],
["part-collect-decl",">scribble/decode.html#(def._((lib._scribble/decode..ss)._part-collect-decl))",[0,[1,"part-collect-decl"]],["scribble/decode"]],
["part-collect-decl-element",">scribble/decode.html#(def._((lib._scribble/decode..ss)._part-collect-decl-element))",[0,[1,"part-collect-decl-element"]],["scribble/decode"]],
["part-collect-decl?",">scribble/decode.html#(def._((lib._scribble/decode..ss)._part-collect-decl~3f))",[0,[1,"part-collect-decl?"]],["scribble/decode"]],
["part-collected-info",">scribble/struct.html#(def._((lib._scribble/struct..ss)._part-collected-info))",[0,[1,"part-collected-info"]],["scribble/struct"]],
["part-flow",">scribble/struct.html#(def._((lib._scribble/struct..ss)._part-flow))",[0,[1,"part-flow"]],["scribble/struct"]],
["part-index-decl",">scribble/decode.html#(def._((lib._scribble/decode..ss)._part-index-decl))",[0,[1,"part-index-decl"]],["scribble/decode"]],
["part-index-decl-entry-seq",">scribble/decode.html#(def._((lib._scribble/decode..ss)._part-index-decl-entry-seq))",[0,[1,"part-index-decl-entry-seq"]],["scribble/decode"]],
["part-index-decl-plain-seq",">scribble/decode.html#(def._((lib._scribble/decode..ss)._part-index-decl-plain-seq))",[0,[1,"part-index-decl-plain-seq"]],["scribble/decode"]],
["part-index-decl?",">scribble/decode.html#(def._((lib._scribble/decode..ss)._part-index-decl~3f))",[0,[1,"part-index-decl?"]],["scribble/decode"]],
["part-parts",">scribble/struct.html#(def._((lib._scribble/struct..ss)._part-parts))",[0,[1,"part-parts"]],["scribble/struct"]],
["part-relative element",">scribble/struct.html#(tech._part._relative._element)","<i>part-relative element</i>",false],
["part-relative-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._part-relative-element))",[0,[1,"part-relative-element"]],["scribble/struct"]],
["part-relative-element-plain",">scribble/struct.html#(def._((lib._scribble/struct..ss)._part-relative-element-plain))",[0,[1,"part-relative-element-plain"]],["scribble/struct"]],
["part-relative-element-resolve",">scribble/struct.html#(def._((lib._scribble/struct..ss)._part-relative-element-resolve))",[0,[1,"part-relative-element-resolve"]],["scribble/struct"]],
["part-relative-element-sizer",">scribble/struct.html#(def._((lib._scribble/struct..ss)._part-relative-element-sizer))",[0,[1,"part-relative-element-sizer"]],["scribble/struct"]],
["part-relative-element?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._part-relative-element~3f))",[0,[1,"part-relative-element?"]],["scribble/struct"]],
["part-start",">scribble/decode.html#(def._((lib._scribble/decode..ss)._part-start))",[0,[1,"part-start"]],["scribble/decode"]],
["part-start-depth",">scribble/decode.html#(def._((lib._scribble/decode..ss)._part-start-depth))",[0,[1,"part-start-depth"]],["scribble/decode"]],
["part-start-style",">scribble/decode.html#(def._((lib._scribble/decode..ss)._part-start-style))",[0,[1,"part-start-style"]],["scribble/decode"]],
["part-start-tag-prefix",">scribble/decode.html#(def._((lib._scribble/decode..ss)._part-start-tag-prefix))",[0,[1,"part-start-tag-prefix"]],["scribble/decode"]],
["part-start-tags",">scribble/decode.html#(def._((lib._scribble/decode..ss)._part-start-tags))",[0,[1,"part-start-tags"]],["scribble/decode"]],
["part-start-title",">scribble/decode.html#(def._((lib._scribble/decode..ss)._part-start-title))",[0,[1,"part-start-title"]],["scribble/decode"]],
["part-start?",">scribble/decode.html#(def._((lib._scribble/decode..ss)._part-start~3f))",[0,[1,"part-start?"]],["scribble/decode"]],
["part-style",">scribble/struct.html#(def._((lib._scribble/struct..ss)._part-style))",[0,[1,"part-style"]],["scribble/struct"]],
["part-tag-decl",">scribble/decode.html#(def._((lib._scribble/decode..ss)._part-tag-decl))",[0,[1,"part-tag-decl"]],["scribble/decode"]],
["part-tag-decl-tag",">scribble/decode.html#(def._((lib._scribble/decode..ss)._part-tag-decl-tag))",[0,[1,"part-tag-decl-tag"]],["scribble/decode"]],
["part-tag-decl?",">scribble/decode.html#(def._((lib._scribble/decode..ss)._part-tag-decl~3f))",[0,[1,"part-tag-decl?"]],["scribble/decode"]],
["part-tag-prefix",">scribble/struct.html#(def._((lib._scribble/struct..ss)._part-tag-prefix))",[0,[1,"part-tag-prefix"]],["scribble/struct"]],
["part-tags",">scribble/struct.html#(def._((lib._scribble/struct..ss)._part-tags))",[0,[1,"part-tags"]],["scribble/struct"]],
["part-title-content",">scribble/struct.html#(def._((lib._scribble/struct..ss)._part-title-content))",[0,[1,"part-title-content"]],["scribble/struct"]],
["part-to-collect",">scribble/struct.html#(def._((lib._scribble/struct..ss)._part-to-collect))",[0,[1,"part-to-collect"]],["scribble/struct"]],
["part?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._part~3f))",[0,[1,"part?"]],["scribble/struct"]],
["partial expansion",">reference/syntax-model.html#(part._partial-expansion)","Partial Expansion",false],
["partial-offset",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._partial-offset))",[[0,[1,"partial-offset"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["partition",">reference/pairs.html#(def._((lib._scheme/list..ss)._partition))",[0,[1,"partition"]],["scheme/list","scheme"]],
["partition",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_210",[0,[1,"partition"]],["rnrs/lists-6"]],
["partition",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..ss)._partition))",[0,[1,"partition"]],["mzlib/integer-set"]],
["partition",">srfi-std/srfi-1.html#partition",[0,[1,"partition"]],["srfi/1"]],
["partition!",">srfi-std/srfi-1.html#partition!",[0,[1,"partition!"]],["srfi/1"]],
["partly-smoothed",">gui/font_.html#(idx._(gentag._209._(lib._scribblings/gui/gui..scrbl)))",[7,"'partly-smoothed"],false],
["partly-smoothed",">gui/style-delta_.html#(idx._(gentag._269._(lib._scribblings/gui/gui..scrbl)))",[7,"'partly-smoothed"],false],
["parts",">scribble/struct.html#(part._parts)","Parts",false],
["password protection",">web-server/dispatch-passwords_ss.html","Password Protection",false],
["password-rejected",">net/pop3.html#(def._((lib._net/pop3..ss)._password-rejected))",[0,[1,"password-rejected"]],["net/pop3"]],
["password-rejected?",">net/pop3.html#(def._((lib._net/pop3..ss)._password-rejected~3f))",[0,[1,"password-rejected?"]],["net/pop3"]],
["paste",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._paste))",[[0,[1,"paste"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["paste",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._paste))",[[0,[1,"paste"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["paste menu item",">drscheme/Menus.html#(idx._(gentag._80._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Paste</font></b> menu item",false],
["paste-click-region",">framework/Keymap.html#(idx._(gentag._35._(lib._scribblings/framework/framework..scrbl)))","paste-click-region",false],
["paste-clipboard",">framework/Keymap.html#(idx._(gentag._32._(lib._scribblings/framework/framework..scrbl)))","paste-clipboard",false],
["paste-next",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._paste-next))",[[0,[1,"paste-next"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["paste-x-selection",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._paste-x-selection))",[[0,[1,"paste-x-selection"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["paste-x-selection",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._paste-x-selection))",[[0,[1,"paste-x-selection"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["pasteboard",">framework/Pasteboard.html","Pasteboard",false],
["pasteboard editor",">gui/editor-overview.html#(tech._pasteboard._editor)","<i>pasteboard editor</i>",false],
["pasteboard%",">gui/pasteboard_.html",[0,[1,"pasteboard%"]],["scheme/gui/base","scheme/gui"]],
["pasteboard:backup-autosave%",">framework/Pasteboard.html#(def._((lib._framework/main..ss)._pasteboard~3abackup-autosave~25))",[0,[1,"pasteboard:backup-autosave%"]],["framework"]],
["pasteboard:basic%",">framework/Pasteboard.html#(def._((lib._framework/main..ss)._pasteboard~3abasic~25))",[0,[1,"pasteboard:basic%"]],["framework"]],
["pasteboard:file%",">framework/Pasteboard.html#(def._((lib._framework/main..ss)._pasteboard~3afile~25))",[0,[1,"pasteboard:file%"]],["framework"]],
["pasteboard:info%",">framework/Pasteboard.html#(def._((lib._framework/main..ss)._pasteboard~3ainfo~25))",[0,[1,"pasteboard:info%"]],["framework"]],
["pasteboard:keymap%",">framework/Pasteboard.html#(def._((lib._framework/main..ss)._pasteboard~3akeymap~25))",[0,[1,"pasteboard:keymap%"]],["framework"]],
["pasteboard:standard-style-list%",">framework/Pasteboard.html#(def._((lib._framework/main..ss)._pasteboard~3astandard-style-list~25))",[0,[1,"pasteboard:standard-style-list%"]],["framework"]],
["patchlevel",">version/index.html#(def._((lib._version/patchlevel..ss)._patchlevel))",[0,[1,"patchlevel"]],["version/patchlevel"]],
["path",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._.Path))",[0,[6,"Path"]],["typed-scheme"]],
["path",">reference/Filesystem.html#(idx._(gentag._262._(lib._scribblings/reference/reference..scrbl)))",[5,"PATH"],false],
["path",">reference/pathutils.html#(tech._path)","<i>path</i>",false],
["path dialog",">mrlib/Path_Dialog.html","Path Dialog",false],
["path utils",">framework/Path_Utils.html","Path Utils",false],
["path->bytes",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._path-~3ebytes))",[0,[1,"path-&gt;bytes"]],["scheme/base","scheme"]],
["path->complete-path",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._path-~3ecomplete-path))",[0,[1,"path-&gt;complete-path"]],["scheme/base","scheme"]],
["path->directory-path",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._path-~3edirectory-path))",[0,[1,"path-&gt;directory-path"]],["scheme/base","scheme"]],
["path->main-collects-relative",">setup-plt/main-collects.html#(def._((lib._setup/main-collects..ss)._path-~3emain-collects-relative))",[0,[1,"path-&gt;main-collects-relative"]],["setup/main-collects"]],
["path->string",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._path-~3estring))",[0,[1,"path-&gt;string"]],["scheme/base","scheme"]],
["path->url",">net/url.html#(def._((lib._net/url..ss)._path-~3eurl))",[0,[1,"path-&gt;url"]],["net/url"]],
["path-add-suffix",">reference/Manipulating_Paths.html#(def._((lib._scheme/private/misc..ss)._path-add-suffix))",[0,[1,"path-add-suffix"]],["scheme/base","scheme"]],
["path-convention-type",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._path-convention-type))",[0,[1,"path-convention-type"]],["scheme/base","scheme"]],
["path-dialog%",">mrlib/Path_Dialog.html#(def._((lib._mrlib/path-dialog..ss)._path-dialog~25))",[0,[1,"path-dialog%"]],["mrlib/path-dialog"]],
["path-element->bytes",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._path-element-~3ebytes))",[0,[1,"path-element-&gt;bytes"]],["scheme/base","scheme"]],
["path-element->string",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._path-element-~3estring))",[0,[1,"path-element-&gt;string"]],["scheme/base","scheme"]],
["path-element?",">web-server/util_ss.html#(def._((lib._web-server/private/util..ss)._path-element~3f))",[0,[1,"path-element?"]],["web-server/private/util"]],
["path-for-some-system?",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._path-for-some-system~3f))",[0,[1,"path-for-some-system?"]],["scheme/base","scheme"]],
["path-list-string->path-list",">reference/Filesystem.html#(def._((lib._scheme/private/misc..ss)._path-list-string-~3epath-list))",[0,[1,"path-list-string-&gt;path-list"]],["scheme/base","scheme"]],
["path-only",">reference/More_Path_Utilities.html#(def._((lib._scheme/path..ss)._path-only))",[0,[1,"path-only"]],["scheme/path","scheme"]],
["path-replace-suffix",">reference/Manipulating_Paths.html#(def._((lib._scheme/private/misc..ss)._path-replace-suffix))",[0,[1,"path-replace-suffix"]],["scheme/base","scheme"]],
["path-string?",">reference/Manipulating_Paths.html#(def._((lib._scheme/private/misc..ss)._path-string~3f))",[0,[1,"path-string?"]],["scheme/base","scheme"]],
["path-utils:generate-autosave-name",">framework/Path_Utils.html#(def._((lib._framework/main..ss)._path-utils~3agenerate-autosave-name))",[0,[1,"path-utils:generate-autosave-name"]],["framework"]],
["path-utils:generate-backup-name",">framework/Path_Utils.html#(def._((lib._framework/main..ss)._path-utils~3agenerate-backup-name))",[0,[1,"path-utils:generate-backup-name"]],["framework"]],
["path-without-base",">web-server/util_ss.html#(def._((lib._web-server/private/util..ss)._path-without-base))",[0,[1,"path-without-base"]],["web-server/private/util"]],
["path/param",">net/url.html#(def._((lib._net/url-structs..ss)._path/param))",[0,[1,"path/param"]],["net/url-structs","net/url"]],
["path/param-param",">net/url.html#(def._((lib._net/url-structs..ss)._path/param-param))",[0,[1,"path/param-param"]],["net/url-structs","net/url"]],
["path/param-path",">net/url.html#(def._((lib._net/url-structs..ss)._path/param-path))",[0,[1,"path/param-path"]],["net/url-structs","net/url"]],
["path/param?",">net/url.html#(def._((lib._net/url-structs..ss)._path/param~3f))",[0,[1,"path/param?"]],["net/url-structs","net/url"]],
["path?",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._path~3f))",[0,[1,"path?"]],["scheme/base","scheme"]],
["pathlist-closure",">reference/Filesystem.html#(def._((lib._scheme/file..ss)._pathlist-closure))",[0,[1,"pathlist-closure"]],["scheme/file","scheme"]],
["pathname->vicinity",">srfi-std/srfi-59.html#pathname-to-vicinity",[0,[1,"pathname-&gt;vicinity"]],["srfi/59"]],
["paths flipping",">gui/dc-path_.html#(idx._(gentag._193._(lib._scribblings/gui/gui..scrbl)))","paths, flipping",false],
["paths",">reference/pathutils.html","Paths",false],
["paths",">web-server/util_ss.html#(part._.Paths)","Paths",false],
["paths",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._paths))",[0,[1,"paths"]],["web-server/configuration/configuration-table-structs"]],
["paths",">gui/drawing-overview.html#(tech._path)","<i>paths</i>",false],
["paths relative to \"collects\"",">setup-plt/main-collects.html",["Paths Relative to ",[5,"\"collects\""]],false],
["paths-conf",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._paths-conf))",[0,[1,"paths-conf"]],["web-server/configuration/configuration-table-structs"]],
["paths-host-base",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._paths-host-base))",[0,[1,"paths-host-base"]],["web-server/configuration/configuration-table-structs"]],
["paths-htdocs",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._paths-htdocs))",[0,[1,"paths-htdocs"]],["web-server/configuration/configuration-table-structs"]],
["paths-log",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._paths-log))",[0,[1,"paths-log"]],["web-server/configuration/configuration-table-structs"]],
["paths-mime-types",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._paths-mime-types))",[0,[1,"paths-mime-types"]],["web-server/configuration/configuration-table-structs"]],
["paths-passwords",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._paths-passwords))",[0,[1,"paths-passwords"]],["web-server/configuration/configuration-table-structs"]],
["paths-servlet",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._paths-servlet))",[0,[1,"paths-servlet"]],["web-server/configuration/configuration-table-structs"]],
["paths?",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._paths~3f))",[0,[1,"paths?"]],["web-server/configuration/configuration-table-structs"]],
["pattern",">redex/Patterns.html#(tech._pattern)","<i>pattern</i>",false],
["pattern matching",">guide/match.html","Pattern Matching",false],
["pattern matching",">reference/match.html","Pattern Matching",false],
["pattern matching",">reference/regexp.html","pattern matching",false],
["pattern variable",">reference/stx-patterns.html#(tech._pattern._variable)","<i>pattern variable</i>",false],
["pattern variables",">guide/match.html#(tech._pattern._variable)","<i>pattern variables</i>",false],
["pattern-based macro",">guide/pattern-macros.html#(tech._pattern._based._macro)","<i>pattern-based macro</i>",false],
["pattern-based macros",">guide/pattern-macros.html","Pattern-Based Macros",false],
["pattern-based syntax matching",">reference/stx-patterns.html","Pattern-Based Syntax Matching",false],
["pattern-sequence",">redex/Patterns.html#(tech._pattern._sequence)","<i>pattern-sequence</i>",false],
["patterns",">redex/Patterns.html","Patterns",false],
["pause",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._pause))",[[0,[1,"pause"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["pause",">drscheme/debugger.html#(idx._(gentag._38._(lib._scribblings/drscheme/drscheme..scrbl)))","Pause",false],
["pause",">gui/key-event_.html#(idx._(gentag._52._(lib._scribblings/gui/gui..scrbl)))",[7,"'pause"],false],
["pause-on-errors",">setup-plt/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..ss)._setup-option~5e._pause-on-errors))",[0,[1,"pause-on-errors"]],["setup/option-sig"]],
["pc",">reference/characters.html#(idx._(gentag._52._(lib._scribblings/reference/reference..scrbl)))",[7,"'pc"],false],
["pcase-lambda:",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._pcase-lambda~3a))",[0,[6,"pcase-lambda:"]],["typed-scheme"]],
["pcdata",">xml/index.html#(def._((lib._xml/main..ss)._pcdata))",[0,[1,"pcdata"]],["xml"]],
["pcdata-string",">xml/index.html#(def._((lib._xml/main..ss)._pcdata-string))",[0,[1,"pcdata-string"]],["xml"]],
["pcdata?",">xml/index.html#(def._((lib._xml/main..ss)._pcdata~3f))",[0,[1,"pcdata?"]],["xml"]],
["pd",">reference/characters.html#(idx._(gentag._51._(lib._scribblings/reference/reference..scrbl)))",[7,"'pd"],false],
["pdf-latex",">slatex-wrap/index.html#(def._((lib._slatex/slatex-wrapper..ss)._pdf-latex))",[0,[1,"pdf-latex"]],["slatex/slatex-wrapper"]],
["pdf-slatex",">slatex-wrap/index.html#(def._((lib._slatex/slatex-wrapper..ss)._pdf-slatex))",[0,[1,"pdf-slatex"]],["slatex/slatex-wrapper"]],
["pe",">reference/characters.html#(idx._(gentag._48._(lib._scribblings/reference/reference..scrbl)))",[7,"'pe"],false],
["peano space-filling curve",">turtles/Traditional_Turtles.html#(idx._(gentag._4._(lib._graphics/scribblings/turtles..scrbl)))","Peano space-filling curve",false],
["peano1",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..ss)._peano1))",[0,"peano1"],["graphics/turtle-examples"]],
["peano2",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..ss)._peano2))",[0,"peano2"],["graphics/turtle-examples"]],
["peek-byte",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._peek-byte))",[0,[1,"peek-byte"]],["scheme/base","scheme"]],
["peek-byte-or-special",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._peek-byte-or-special))",[0,[1,"peek-byte-or-special"]],["scheme/base","scheme"]],
["peek-bytes",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._peek-bytes))",[0,[1,"peek-bytes"]],["scheme/base","scheme"]],
["peek-bytes!",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._peek-bytes!))",[0,[1,"peek-bytes!"]],["scheme/base","scheme"]],
["peek-bytes!-evt",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._peek-bytes!-evt))",[0,[1,"peek-bytes!-evt"]],["scheme/port"]],
["peek-bytes-avail!",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._peek-bytes-avail!))",[0,[1,"peek-bytes-avail!"]],["scheme/base","scheme"]],
["peek-bytes-avail!*",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._peek-bytes-avail!*))",[0,[1,"peek-bytes-avail!*"]],["scheme/base","scheme"]],
["peek-bytes-avail!-evt",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._peek-bytes-avail!-evt))",[0,[1,"peek-bytes-avail!-evt"]],["scheme/port"]],
["peek-bytes-avail!/enable-break",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._peek-bytes-avail!/enable-break))",[0,[1,"peek-bytes-avail!/enable-break"]],["scheme/base","scheme"]],
["peek-bytes-evt",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._peek-bytes-evt))",[0,[1,"peek-bytes-evt"]],["scheme/port"]],
["peek-char",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._peek-char))",[0,[1,"peek-char"]],["scheme/base","scheme"]],
["peek-char",">r5rs-std/r5rs-Z-H-9.html#%_idx_644",[0,[1,"peek-char"]],["r5rs"]],
["peek-char",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_814",[0,[1,"peek-char"]],["rnrs/io/simple-6"]],
["peek-char-or-special",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._peek-char-or-special))",[0,[1,"peek-char-or-special"]],["scheme/base","scheme"]],
["peek-string",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._peek-string))",[0,[1,"peek-string"]],["scheme/base","scheme"]],
["peek-string!",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._peek-string!))",[0,[1,"peek-string!"]],["scheme/base","scheme"]],
["peek-string!-evt",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._peek-string!-evt))",[0,[1,"peek-string!-evt"]],["scheme/port"]],
["peek-string-evt",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._peek-string-evt))",[0,[1,"peek-string-evt"]],["scheme/port"]],
["peeking-input-port",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._peeking-input-port))",[0,[1,"peeking-input-port"]],["scheme/port"]],
["pen%",">gui/pen_.html",[0,[1,"pen%"]],["scheme/gui/base","scheme/gui"]],
["pen-list%",">gui/pen-list_.html",[0,[1,"pen-list%"]],["scheme/gui/base","scheme/gui"]],
["per-symbol special printing",">reference/pretty-print.html#(part._.Per-.Symbol_.Special_.Printing)","Per-Symbol Special Printing",false],
["performance",">guide/performance.html","Performance",false],
["permanently",">web-server/helpers_ss.html#(def._((lib._web-server/servlet/helpers..ss)._permanently))",[0,[1,"permanently"]],["web-server/servlet/helpers"]],
["pf",">reference/characters.html#(idx._(gentag._50._(lib._scribblings/reference/reference..scrbl)))",[7,"'pf"],false],
["pflag",">scribble/doc-strings.html#(def._((lib._scribble/manual..ss)._.P.Flag))",[0,[1,"PFlag"]],["scribble/manual"]],
["phase level",">reference/syntax-model.html#(tech._phase._level)","<i>phase level</i>",false],
["phase level -1",">guide/stx-phases.html#(tech._phase._level._1)","<i>phase level\n-1</i>",false],
["phase level 2",">guide/stx-phases.html#(tech._phase._level._2)","<i>phase level\n2</i>",false],
["phase1",">tools/implementing-tools.html#(idx._(gentag._0._(lib._scribblings/tools/tools..scrbl)))","phase1",false],
["phase2",">tools/implementing-tools.html#(idx._(gentag._1._(lib._scribblings/tools/tools..scrbl)))","phase2",false],
["phases",">reference/eval-model.html#(part._module-phase)","Phases",false],
["phases",">reference/eval-model.html#(tech._phase)","<i>phases</i>",false],
["pi",">reference/numbers.html#(def._((lib._scheme/math..ss)._pi))",[0,[1,"pi"]],["scheme/math","scheme"]],
["pi",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._pi))",[0,[1,"pi"]],["lang/htdp-advanced"]],
["pi",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._pi))",[0,[1,"pi"]],["lang/htdp-beginner"]],
["pi",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._pi))",[0,[1,"pi"]],["lang/htdp-beginner-abbr"]],
["pi",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._pi))",[0,[1,"pi"]],["lang/htdp-intermediate"]],
["pi",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._pi))",[0,[1,"pi"]],["lang/htdp-intermediate-lambda"]],
["pi",">reference/characters.html#(idx._(gentag._49._(lib._scribblings/reference/reference..scrbl)))",[7,"'pi"],false],
["pict",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..ss)._pict))",[0,[1,"pict"]],["slideshow/pict","slideshow"]],
["pict",">gui/bitmap_.html#(idx._(gentag._168._(lib._scribblings/gui/gui..scrbl)))","PICT",false],
["pict combiners",">slideshow/Pict_Combiners.html","Pict Combiners",false],
["pict datatype",">slideshow/Pict_Datatype.html","Pict Datatype",false],
["pict drawing adjusters",">slideshow/Pict_Drawing_Adjusters.html","Pict Drawing Adjusters",false],
["pict finders",">slideshow/Pict_Finders.html","Pict Finders",false],
["pict->code-pict",">slideshow/Typesetting_Scheme_Code.html#(def._((lib._slideshow/code..ss)._pict-~3ecode-pict))",[0,[1,"pict-&gt;code-pict"]],["slideshow/code"]],
["pict-ascent",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..ss)._pict-ascent))",[0,[1,"pict-ascent"]],["slideshow/pict","slideshow"]],
["pict-children",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..ss)._pict-children))",[0,[1,"pict-children"]],["slideshow/pict","slideshow"]],
["pict-descent",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..ss)._pict-descent))",[0,[1,"pict-descent"]],["slideshow/pict","slideshow"]],
["pict-draw",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..ss)._pict-draw))",[0,[1,"pict-draw"]],["slideshow/pict","slideshow"]],
["pict-height",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..ss)._pict-height))",[0,[1,"pict-height"]],["slideshow/pict","slideshow"]],
["pict-last",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..ss)._pict-last))",[0,[1,"pict-last"]],["slideshow/pict","slideshow"]],
["pict-panbox",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..ss)._pict-panbox))",[0,[1,"pict-panbox"]],["slideshow/pict","slideshow"]],
["pict-path?",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..ss)._pict-path~3f))",[0,[1,"pict-path?"]],["slideshow/pict","slideshow"]],
["pict-staging helper",">slideshow/Pict-Staging_Helper.html","Pict-Staging Helper",false],
["pict-width",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..ss)._pict-width))",[0,[1,"pict-width"]],["slideshow/pict","slideshow"]],
["pict?",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..ss)._pict~3f))",[0,[1,"pict?"]],["slideshow/pict","slideshow"]],
["picts & postscript",">redex/Typesetting.html#(part._.Picts___.Post.Script)","Picts &amp; PostScript",false],
["pidefterm",">scribble/manual-indexing.html#(def._((lib._scribble/manual..ss)._pidefterm))",[0,[1,"pidefterm"]],["scribble/manual"]],
["pin-arrow-line",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._pin-arrow-line))",[0,[1,"pin-arrow-line"]],["slideshow/pict","slideshow"]],
["pin-arrows-line",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._pin-arrows-line))",[0,[1,"pin-arrows-line"]],["slideshow/pict","slideshow"]],
["pin-balloon",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/balloon..ss)._pin-balloon))",[0,[1,"pin-balloon"]],["slideshow/balloon"]],
["pin-line",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._pin-line))",[0,[1,"pin-line"]],["slideshow/pict","slideshow"]],
["pin-over",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..ss)._pin-over))",[0,[1,"pin-over"]],["slideshow/pict","slideshow"]],
["pin-under",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..ss)._pin-under))",[0,[1,"pin-under"]],["slideshow/pict","slideshow"]],
["pinhole-x",">teachpack/image.html#(def._((lib._htdp/image..ss)._pinhole-x))",[0,[1,"pinhole-x"]],["teachpack/htdp/image"]],
["pinhole-y",">teachpack/image.html#(def._((lib._htdp/image..ss)._pinhole-y))",[0,[1,"pinhole-y"]],["teachpack/htdp/image"]],
["pip-arrow-line",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._pip-arrow-line))",[0,[1,"pip-arrow-line"]],["slideshow/pict","slideshow"]],
["pip-arrows-line",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._pip-arrows-line))",[0,[1,"pip-arrows-line"]],["slideshow/pict","slideshow"]],
["pip-line",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._pip-line))",[0,[1,"pip-line"]],["slideshow/pict","slideshow"]],
["pip-wrap-balloon",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/balloon..ss)._pip-wrap-balloon))",[0,[1,"pip-wrap-balloon"]],["slideshow/balloon"]],
["pipe",">reference/pipeports.html#(tech._pipe)","<i>pipe</i>",false],
["pipe-content-length",">reference/pipeports.html#(def._((quote._~23~25kernel)._pipe-content-length))",[0,[1,"pipe-content-length"]],["scheme/base","scheme"]],
["pipes",">reference/pipeports.html","Pipes",false],
["pixel-height",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._pixel-height))",[[0,[1,"pixel-height"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["pixel-left",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._pixel-left))",[[0,[1,"pixel-left"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["pixel-top",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._pixel-top))",[[0,[1,"pixel-top"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["pixel-width",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._pixel-width))",[[0,[1,"pixel-width"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["pixels",">graphics/Draw__Clear__and_Flip_Operations.html#(part._.Pixels)","Pixels",false],
["pixmaps",">graphics/Draw__Clear__and_Flip_Operations.html#(part._.Pixmaps)","Pixmaps",false],
["place-children",">gui/area-container___.html#(meth._(((lib._mred/main..ss)._area-container~3c~25~3e)._place-children))",[[0,[1,"place-children"]],[12,[" (method of ",[0,[1,"area-container&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["place-children",">framework/Panel.html#(meth._(((lib._framework/main..ss)._panel~3adragable-mixin)._place-children))",[[0,[1,"place-children"]],[12,[" (method of ",[0,[1,"panel:dragable-mixin"]],")"]]],["framework"]],
["place-children",">framework/Panel.html#(meth._(((lib._framework/main..ss)._panel~3asingle-mixin)._place-children))",[[0,[1,"place-children"]],[12,[" (method of ",[0,[1,"panel:single-mixin"]],")"]]],["framework"]],
["place-image",">teachpack/world.html#(def._((lib._teachpack/htdp/world..ss)._place-image))",[0,[1,"place-image"]],["teachpack/htdp/world"]],
["placeholder-get",">reference/pairs.html#(def._((quote._~23~25kernel)._placeholder-get))",[0,[1,"placeholder-get"]],["scheme/base","scheme"]],
["placeholder-set!",">reference/pairs.html#(def._((quote._~23~25kernel)._placeholder-set!))",[0,[1,"placeholder-set!"]],["scheme/base","scheme"]],
["placeholder?",">reference/pairs.html#(def._((quote._~23~25kernel)._placeholder~3f))",[0,[1,"placeholder?"]],["scheme/base","scheme"]],
["plain menu item",">gui/windowing-overview.html#(tech._plain._menu._item)","<i>plain menu item</i>",false],
["plain-text file format",">drscheme/drscheme-files.html#(tech._plain._text._file._format)","<i>Plain-text file format</i>",false],
["plambda:",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._plambda~3a))",[0,[6,"plambda:"]],["typed-scheme"]],
["planet",">reference/require.html#(form._((lib._scheme/base..ss)._planet))",[0,[6,"planet"]],["scheme/base","scheme"]],
["planet",">scribble/Miscellaneous.html#(def._((lib._scribble/manual..ss)._.P.Lane.T))",[0,[1,"PLaneT"]],["scribble/manual"]],
["planet-dir",">planet/Utility_Libraries.html#(def._((lib._planet/config..ss)._.P.L.A.N.E.T-.D.I.R))",[0,[1,"PLANET-DIR"]],["planet/config"]],
["planet-server-name",">planet/Utility_Libraries.html#(def._((lib._planet/config..ss)._.P.L.A.N.E.T-.S.E.R.V.E.R-.N.A.M.E))",[0,[1,"PLANET-SERVER-NAME"]],["planet/config"]],
["planet-server-port",">planet/Utility_Libraries.html#(def._((lib._planet/config..ss)._.P.L.A.N.E.T-.S.E.R.V.E.R-.P.O.R.T))",[0,[1,"PLANET-SERVER-PORT"]],["planet/config"]],
["planet/config",">planet/Utility_Libraries.html#(mod-path._planet/config)",[14,[0,"planet/config"]],"module"],
["planet/util",">planet/Utility_Libraries.html#(mod-path._planet/util)",[14,[0,"planet/util"]],"module"],
["planet: automatic package distribution",">planet/index.html","<b>PLaneT</b>: Automatic Package Distribution",false],
["play-sound",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._play-sound))",[0,[1,"play-sound"]],["scheme/gui/base","scheme/gui"]],
["plist library",">xml/index.html#(part._.P.List_.Library)","PList Library",false],
["plot",">mrlib/Plot.html","Plot",false],
["plot",">plot/plot.html",[14,[0,[1,"plot"]]],"module"],
["plot",">mrlib/Plot.html#(def._((lib._mrlib/plot..ss)._plot))",[0,[1,"plot"]],["mrlib/plot"]],
["plot",">plot/plot.html#(def._((lib._plot/main..ss)._plot))",[0,[1,"plot"]],["plot"]],
["plot-color?",">plot/plot.html#(def._((lib._plot/main..ss)._plot-color~3f))",[0,[1,"plot-color?"]],["plot"]],
["plot-contours",">plot/extend.html#(meth._(((lib._plot/extend..ss)._2d-view~25)._plot-contours))",[[0,[1,"plot-contours"]],[12,[" (method of ",[0,[1,"2d-view%"]],")"]]],["plot/extend"]],
["plot-line",">plot/extend.html#(meth._(((lib._plot/extend..ss)._2d-view~25)._plot-line))",[[0,[1,"plot-line"]],[12,[" (method of ",[0,[1,"2d-view%"]],")"]]],["plot/extend"]],
["plot-line",">plot/extend.html#(meth._(((lib._plot/extend..ss)._3d-view~25)._plot-line))",[[0,[1,"plot-line"]],[12,[" (method of ",[0,[1,"3d-view%"]],")"]]],["plot/extend"]],
["plot-points",">plot/extend.html#(meth._(((lib._plot/extend..ss)._2d-view~25)._plot-points))",[[0,[1,"plot-points"]],[12,[" (method of ",[0,[1,"2d-view%"]],")"]]],["plot/extend"]],
["plot-setup",">mrlib/Plot.html#(def._((lib._mrlib/plot..ss)._plot-setup))",[0,[1,"plot-setup"]],["mrlib/plot"]],
["plot-setup-axis-label-font",">mrlib/Plot.html#(def._((lib._mrlib/plot..ss)._plot-setup-axis-label-font))",[0,[1,"plot-setup-axis-label-font"]],["mrlib/plot"]],
["plot-setup-axis-number-font",">mrlib/Plot.html#(def._((lib._mrlib/plot..ss)._plot-setup-axis-number-font))",[0,[1,"plot-setup-axis-number-font"]],["mrlib/plot"]],
["plot-setup-axis-pen",">mrlib/Plot.html#(def._((lib._mrlib/plot..ss)._plot-setup-axis-pen))",[0,[1,"plot-setup-axis-pen"]],["mrlib/plot"]],
["plot-setup-grid-pen",">mrlib/Plot.html#(def._((lib._mrlib/plot..ss)._plot-setup-grid-pen))",[0,[1,"plot-setup-grid-pen"]],["mrlib/plot"]],
["plot-setup-grid?",">mrlib/Plot.html#(def._((lib._mrlib/plot..ss)._plot-setup-grid~3f))",[0,[1,"plot-setup-grid?"]],["mrlib/plot"]],
["plot-setup-x-axis-label",">mrlib/Plot.html#(def._((lib._mrlib/plot..ss)._plot-setup-x-axis-label))",[0,[1,"plot-setup-x-axis-label"]],["mrlib/plot"]],
["plot-setup-x-axis-marking",">mrlib/Plot.html#(def._((lib._mrlib/plot..ss)._plot-setup-x-axis-marking))",[0,[1,"plot-setup-x-axis-marking"]],["mrlib/plot"]],
["plot-setup-y-axis-label",">mrlib/Plot.html#(def._((lib._mrlib/plot..ss)._plot-setup-y-axis-label))",[0,[1,"plot-setup-y-axis-label"]],["mrlib/plot"]],
["plot-setup-y-axis-marking",">mrlib/Plot.html#(def._((lib._mrlib/plot..ss)._plot-setup-y-axis-marking))",[0,[1,"plot-setup-y-axis-marking"]],["mrlib/plot"]],
["plot-setup?",">mrlib/Plot.html#(def._((lib._mrlib/plot..ss)._plot-setup~3f))",[0,[1,"plot-setup?"]],["mrlib/plot"]],
["plot-shades",">plot/extend.html#(meth._(((lib._plot/extend..ss)._2d-view~25)._plot-shades))",[[0,[1,"plot-shades"]],[12,[" (method of ",[0,[1,"2d-view%"]],")"]]],["plot/extend"]],
["plot-surface",">plot/extend.html#(meth._(((lib._plot/extend..ss)._3d-view~25)._plot-surface))",[[0,[1,"plot-surface"]],[12,[" (method of ",[0,[1,"3d-view%"]],")"]]],["plot/extend"]],
["plot-vector",">plot/extend.html#(meth._(((lib._plot/extend..ss)._2d-view~25)._plot-vector))",[[0,[1,"plot-vector"]],[12,[" (method of ",[0,[1,"2d-view%"]],")"]]],["plot/extend"]],
["plot-vectors",">plot/extend.html#(meth._(((lib._plot/extend..ss)._2d-view~25)._plot-vectors))",[[0,[1,"plot-vectors"]],[12,[" (method of ",[0,[1,"2d-view%"]],")"]]],["plot/extend"]],
["plot-view%",">plot/extend.html#(def._((lib._plot/extend..ss)._plot-view~25))",[0,[1,"plot-view%"]],["plot/extend"]],
["plot/extend",">plot/extend.html",[14,[0,"plot/extend"]],"module"],
["plot3d",">plot/plot.html#(def._((lib._plot/main..ss)._plot3d))",[0,[1,"plot3d"]],["plot"]],
["plot: graph plotting",">plot/index.html","<b>PLoT</b>: Graph Plotting",false],
["plotting",">plot/plot.html#(part._.Plotting)","Plotting",false],
["plotting",">plot/plot.html","Plotting",false],
["plt pretty big language",">drscheme/legacy.html#(idx._(gentag._41._(lib._scribblings/drscheme/drscheme..scrbl)))","<i>PLT Pretty Big</i> language",false],
["plt scheme",">drscheme/drscheme-files.html#(idx._(gentag._221._(lib._scribblings/drscheme/drscheme..scrbl)))",[5,"\"PLT\nScheme\""],false],
["plt-prefs.ss",">drscheme/drscheme-files.html#(idx._(gentag._219._(lib._scribblings/drscheme/drscheme..scrbl)))",[5,"\"plt-prefs.ss\""],false],
["plt-prefs.ss",">drscheme/drscheme-files.html#(idx._(gentag._220._(lib._scribblings/drscheme/drscheme..scrbl)))",[5,"\"plt-prefs.ss\""],false],
["plt-prefs.ss",">drscheme/drscheme-files.html#(idx._(gentag._227._(lib._scribblings/drscheme/drscheme..scrbl)))",[5,"\"plt-prefs.ss\""],false],
["plt-r5rs",">r5rs/plt-r5rs.html",[5,"plt-r5rs"],false],
["plt_delay_from_zo",">reference/Reading.html#(idx._(gentag._121._(lib._scribblings/reference/reference..scrbl)))",[5,"PLT_DELAY_FROM_ZO"],false],
["plt_extension_lib_paths",">make/setup-extension.html#(idx._(gentag._0._(lib._make/make..scrbl)))",[5,"PLT_EXTENSION_LIB_PATHS"],false],
["pltafmpaths",">gui/fontresources.html#(idx._(gentag._310._(lib._scribblings/gui/gui..scrbl)))",[5,"PLTAFMPATHS"],false],
["pltcmappaths",">gui/fontresources.html#(idx._(gentag._313._(lib._scribblings/gui/gui..scrbl)))",[5,"PLTCMAPPATHS"],false],
["pltcollects",">reference/collects.html#(idx._(gentag._393._(lib._scribblings/reference/reference..scrbl)))",[5,"PLTCOLLECTS"],false],
["pltdrbreak",">drscheme/extending-drscheme.html#(idx._(gentag._234._(lib._scribblings/drscheme/drscheme..scrbl)))",[5,"PLTDRBREAK"],false],
["pltdrcm",">drscheme/extending-drscheme.html#(idx._(gentag._232._(lib._scribblings/drscheme/drscheme..scrbl)))",[5,"PLTDRCM"],false],
["pltdrdebug",">drscheme/extending-drscheme.html#(idx._(gentag._233._(lib._scribblings/drscheme/drscheme..scrbl)))",[5,"PLTDRDEBUG"],false],
["pltdrtests",">drscheme/extending-drscheme.html#(idx._(gentag._235._(lib._scribblings/drscheme/drscheme..scrbl)))",[5,"PLTDRTESTS"],false],
["pltnomzjit",">reference/Evaluation_and_Compilation.html#(idx._(gentag._201._(lib._scribblings/reference/reference..scrbl)))",[5,"PLTNOMZJIT"],false],
["pltnotools",">drscheme/extending-drscheme.html#(idx._(gentag._230._(lib._scribblings/drscheme/drscheme..scrbl)))",[5,"PLTNOTOOLS"],false],
["pltonlytool",">drscheme/extending-drscheme.html#(idx._(gentag._231._(lib._scribblings/drscheme/drscheme..scrbl)))",[5,"PLTONLYTOOL"],false],
["pltstderr",">reference/logging.html#(idx._(gentag._293._(lib._scribblings/reference/reference..scrbl)))",[5,"PLTSTDERR"],false],
["pltstringconstants",">string-constants/index.html#(idx._(gentag._0._(lib._string-constants/string-constants..scrbl)))",[5,"PLTSTRINGCONSTANTS"],false],
["pltstringconstants",">drscheme/extending-drscheme.html#(idx._(gentag._236._(lib._scribblings/drscheme/drscheme..scrbl)))",[5,"PLTSTRINGCONSTANTS"],false],
["pltsyslog",">reference/logging.html#(idx._(gentag._294._(lib._scribblings/reference/reference..scrbl)))",[5,"PLTSYSLOG"],false],
["plug",">redex/Terms.html#(def._((lib._redex/main..ss)._plug))",[0,[1,"plug"]],["redex"]],
["plugins: extending drscheme",">tools/index.html","<b>Plugins</b>: Extending DrScheme",false],
["png",">gui/bitmap_.html#(idx._(gentag._165._(lib._scribblings/gui/gui..scrbl)))","PNG",false],
["png",">gui/bitmap_.html#(idx._(gentag._172._(lib._scribblings/gui/gui..scrbl)))","PNG",false],
["po",">reference/characters.html#(idx._(gentag._53._(lib._scribblings/reference/reference..scrbl)))",[7,"'po"],false],
["point%",">gui/point_.html",[0,[1,"point%"]],["scheme/gui/base","scheme/gui"]],
["pointer functions",">foreign/foreign_pointer-funcs.html","Pointer Functions",false],
["pointer types",">foreign/Pointer_Types.html","Pointer Types",false],
["points",">plot/plot.html#(def._((lib._plot/main..ss)._points))",[0,[1,"points"]],["plot"]],
["poll",">reference/sync.html","poll",false],
["poll-guard-evt",">reference/sync.html#(def._((quote._~23~25kernel)._poll-guard-evt))",[0,[1,"poll-guard-evt"]],["scheme/base","scheme"]],
["polygons",">graphics/Draw__Clear__and_Flip_Operations.html#(part._.Polygons)","Polygons",false],
["polymorphic data structures",">typed-scheme/index.html#(part._.Polymorphic_.Data_.Structures)","Polymorphic Data Structures",false],
["polymorphic functions",">typed-scheme/index.html#(part._.Polymorphic_.Functions)","Polymorphic Functions",false],
["polymorphism",">typed-scheme/index.html#(part._.Polymorphism)","Polymorphism",false],
["pop-indentation",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..ss)._pop-indentation))",[0,[1,"pop-indentation"]],["preprocessor/mzpp"]],
["pop3",">net/pop3.html#(def._((lib._net/pop3..ss)._pop3))",[0,[1,"pop3"]],["net/pop3"]],
["pop3 signature",">net/pop3.html#(part._.P.O.P3_.Signature)","POP3 Signature",false],
["pop3 unit",">net/pop3.html#(part._.P.O.P3_.Unit)","POP3 Unit",false],
["pop3: reading mail",">net/pop3.html","POP3: Reading Mail",false],
["pop3?",">net/pop3.html#(def._((lib._net/pop3..ss)._pop3~3f))",[0,[1,"pop3?"]],["net/pop3"]],
["pop3@",">net/pop3.html#(def._((lib._net/pop3-unit..ss)._pop3~40))",[0,[1,"pop3@"]],["net/pop3-unit"]],
["pop3^",">net/pop3.html#(form._((lib._net/pop3-sig..ss)._pop3~5e))",[0,[6,"pop3^"]],["net/pop3-sig"]],
["popup menu",">gui/windowing-overview.html#(tech._popup._menu)","<i>popup menu</i>",false],
["popup-menu",">gui/editor-admin_.html#(meth._(((lib._mred/main..ss)._editor-admin~25)._popup-menu))",[[0,[1,"popup-menu"]],[12,[" (method of ",[0,[1,"editor-admin%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["popup-menu",">gui/snip-admin_.html#(meth._(((lib._mred/main..ss)._snip-admin~25)._popup-menu))",[[0,[1,"popup-menu"]],[12,[" (method of ",[0,[1,"snip-admin%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["popup-menu",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._popup-menu))",[[0,[1,"popup-menu"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["popup-menu%",">gui/popup-menu_.html",[0,[1,"popup-menu%"]],["scheme/gui/base","scheme/gui"]],
["port",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._.Port))",[0,[6,"Port"]],["typed-scheme"]],
["port",">web-server/dispatch-server-unit_ss.html#(sig-val._((lib._web-server/private/dispatch-server-sig..ss)._dispatch-server-config~5e._port))",[0,[1,"port"]],["web-server/private/dispatch-server-sig"]],
["port",">web-server/web-config-unit_ss.html#(sig-val._((lib._web-server/web-config-sig..ss)._web-config~5e._port))",[0,[1,"port"]],["web-server/web-config-sig"]],
["port",">guide/i_o.html#(tech._port)","<i>port</i>",false],
["port buffers and positions",">reference/port-buffers.html","Port Buffers and Positions",false],
["port display handler",">reference/Writing.html#(tech._port._display._handler)","<i>port display\nhandler</i>",false],
["port events",">reference/More_Port_Constructors_and_Events.html#(part._.Port_.Events)","Port Events",false],
["port positions",">reference/linecol.html","port positions",false],
["port print handler",">reference/Writing.html#(tech._port._print._handler)","<i>port print handler</i>",false],
["port read handler",">reference/Reading.html#(tech._port._read._handler)","<i>port read handler</i>",false],
["port write handler",">reference/Writing.html#(tech._port._write._handler)","<i>port write handler</i>",false],
["port->stream",">srfi-std/srfi-41/srfi-41.html#port-to-stream",[0,[1,"port-&gt;stream"]],["srfi/41"]],
["port-closed?",">reference/port-ops.html#(def._((quote._~23~25kernel)._port-closed~3f))",[0,[1,"port-closed?"]],["scheme/base","scheme"]],
["port-commit-peeked",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._port-commit-peeked))",[0,[1,"port-commit-peeked"]],["scheme/base","scheme"]],
["port-count-lines!",">reference/linecol.html#(def._((quote._~23~25kernel)._port-count-lines!))",[0,[1,"port-count-lines!"]],["scheme/base","scheme"]],
["port-count-lines-enabled",">reference/linecol.html#(def._((quote._~23~25kernel)._port-count-lines-enabled))",[0,[1,"port-count-lines-enabled"]],["scheme/base","scheme"]],
["port-display-handler",">reference/Writing.html#(def._((quote._~23~25kernel)._port-display-handler))",[0,[1,"port-display-handler"]],["scheme/base","scheme"]],
["port-eof?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_666",[0,[1,"port-eof?"]],["rnrs/io/ports-6"]],
["port-file-identity",">reference/file-ports.html#(def._((quote._~23~25kernel)._port-file-identity))",[0,[1,"port-file-identity"]],["scheme/base","scheme"]],
["port-has-port-position?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_652",[0,[1,"port-has-port-position?"]],["rnrs/io/ports-6"]],
["port-has-set-port-position!?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_656",[0,[1,"port-has-set-port-position!?"]],["rnrs/io/ports-6"]],
["port-name-matches?",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3adefinitions-text~3c~25~3e)._port-name-matches~3f))",[[0,[1,"port-name-matches?"]],[12,[" (method of ",[0,[1,"drscheme:unit:definitions-text&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["port-name-matches?",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3abasic~3c~25~3e)._port-name-matches~3f))",[[0,[1,"port-name-matches?"]],[12,[" (method of ",[0,[1,"text:basic&lt;%&gt;"]],")"]]],["framework"]],
["port-next-location",">reference/linecol.html#(def._((quote._~23~25kernel)._port-next-location))",[0,[1,"port-next-location"]],["scheme/base","scheme"]],
["port-number?",">web-server/util_ss.html#(def._((lib._web-server/private/util..ss)._port-number~3f))",[0,[1,"port-number?"]],["web-server/private/util"]],
["port-position",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_654",[0,[1,"port-position"]],["rnrs/io/ports-6"]],
["port-print-handler",">reference/Writing.html#(def._((quote._~23~25kernel)._port-print-handler))",[0,[1,"port-print-handler"]],["scheme/base","scheme"]],
["port-progress-evt",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._port-progress-evt))",[0,[1,"port-progress-evt"]],["scheme/base","scheme"]],
["port-provides-progress-evts?",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._port-provides-progress-evts~3f))",[0,[1,"port-provides-progress-evts?"]],["scheme/base","scheme"]],
["port-read-handler",">reference/Reading.html#(def._((quote._~23~25kernel)._port-read-handler))",[0,[1,"port-read-handler"]],["scheme/base","scheme"]],
["port-transcoder",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_644",[0,[1,"port-transcoder"]],["rnrs/io/ports-6"]],
["port-write-handler",">reference/Writing.html#(def._((quote._~23~25kernel)._port-write-handler))",[0,[1,"port-write-handler"]],["scheme/base","scheme"]],
["port-writes-atomic?",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._port-writes-atomic~3f))",[0,[1,"port-writes-atomic?"]],["scheme/base","scheme"]],
["port-writes-special?",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._port-writes-special~3f))",[0,[1,"port-writes-special?"]],["scheme/base","scheme"]],
["port?",">reference/port-ops.html#(def._((lib._scheme/private/misc..ss)._port~3f))",[0,[1,"port?"]],["scheme/base","scheme"]],
["port?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_642",[0,[1,"port?"]],["rnrs/io/ports-6"]],
["ports flushing",">reference/port-buffers.html#(idx._(gentag._98._(lib._scribblings/reference/reference..scrbl)))","ports, flushing",false],
["ports",">reference/ports.html","Ports",false],
["ports",">reference/ports.html#(tech._port)","<i>Ports</i>",false],
["ports and the filesystem",">inside/Ports_and_the_Filesystem.html","Ports and the Filesystem",false],
["ports->ssl-ports",">openssl/index.html#(def._((lib._openssl/main..ss)._ports-~3essl-ports))",[0,[1,"ports-&gt;ssl-ports"]],["openssl"]],
["pos-height",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._pos-height))",[[0,[1,"pos-height"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["pos-left",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._pos-left))",[[0,[1,"pos-left"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["pos-top",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._pos-top))",[[0,[1,"pos-top"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["pos-width",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._pos-width))",[[0,[1,"pos-width"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["position",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._position))",[[0,[1,"position"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["position",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..ss)._position))",[0,[1,"position"]],["parser-tools/lex"]],
["position",">gui/editor-overview.html#(tech._position)","<i>position</i>",false],
["position",">reference/linecol.html#(tech._position)","<i>position</i>",false],
["position operations",">graphics/posn.html","Position Operations",false],
["position-col",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..ss)._position-col))",[0,[1,"position-col"]],["parser-tools/lex"]],
["position-line",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._position-line))",[[0,[1,"position-line"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["position-line",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..ss)._position-line))",[0,[1,"position-line"]],["parser-tools/lex"]],
["position-location",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._position-location))",[[0,[1,"position-location"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["position-locations",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._position-locations))",[[0,[1,"position-locations"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["position-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._position-native))",[[0,[1,"position-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["position-offset",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..ss)._position-offset))",[0,[1,"position-offset"]],["parser-tools/lex"]],
["position-paragraph",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._position-paragraph))",[[0,[1,"position-paragraph"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["position-token",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..ss)._position-token))",[0,[1,"position-token"]],["parser-tools/lex"]],
["position-token-end-pos",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..ss)._position-token-end-pos))",[0,[1,"position-token-end-pos"]],["parser-tools/lex"]],
["position-token-start-pos",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..ss)._position-token-start-pos))",[0,[1,"position-token-start-pos"]],["parser-tools/lex"]],
["position-token-token",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..ss)._position-token-token))",[0,[1,"position-token-token"]],["parser-tools/lex"]],
["position-token?",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..ss)._position-token~3f))",[0,[1,"position-token?"]],["parser-tools/lex"]],
["position?",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..ss)._position~3f))",[0,[1,"position?"]],["parser-tools/lex"]],
["positive?",">reference/numbers.html#(def._((quote._~23~25kernel)._positive~3f))",[0,[1,"positive?"]],["scheme/base","scheme"]],
["positive?",">r5rs-std/r5rs-Z-H-9.html#%_idx_270",[0,[1,"positive?"]],["r5rs"]],
["positive?",">r6rs-std/r6rs-Z-H-14.html#node_idx_476",[0,[1,"positive?"]],["rnrs/base-6"]],
["positive?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._positive~3f))",[0,[1,"positive?"]],["lang/htdp-advanced"]],
["positive?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._positive~3f))",[0,[1,"positive?"]],["lang/htdp-beginner"]],
["positive?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._positive~3f))",[0,[1,"positive?"]],["lang/htdp-beginner-abbr"]],
["positive?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._positive~3f))",[0,[1,"positive?"]],["lang/htdp-intermediate"]],
["positive?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._positive~3f))",[0,[1,"positive?"]],["lang/htdp-intermediate-lambda"]],
["posix character class",">guide/regexp-chars.html#(tech._posix._character._clas)","<i>POSIX character class</i>",false],
["posix character classes",">guide/regexp-chars.html#(part._.P.O.S.I.X_character_classes)","POSIX character classes",false],
["posn",">htdp-lib/index.html#(def._((lib._lang/posn..ss)._posn))",[0,[1,"posn"]],["lang/posn"]],
["posn",">graphics/posn.html#(def._((lib._graphics/graphics..ss)._posn))",[0,[1,"posn"]],["graphics/graphics"]],
["posn",">teachpack/geometry.html#(tech._posn)","<i>Posn</i>",false],
["posn-x",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._posn-x))",[0,[1,"posn-x"]],["lang/htdp-advanced"]],
["posn-x",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._posn-x))",[0,[1,"posn-x"]],["lang/htdp-beginner"]],
["posn-x",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._posn-x))",[0,[1,"posn-x"]],["lang/htdp-beginner-abbr"]],
["posn-x",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._posn-x))",[0,[1,"posn-x"]],["lang/htdp-intermediate"]],
["posn-x",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._posn-x))",[0,[1,"posn-x"]],["lang/htdp-intermediate-lambda"]],
["posn-x",">htdp-lib/index.html#(def._((lib._lang/posn..ss)._posn-x))",[0,[1,"posn-x"]],["lang/posn"]],
["posn-x",">graphics/posn.html#(def._((lib._graphics/graphics..ss)._posn-x))",[0,[1,"posn-x"]],["graphics/graphics"]],
["posn-y",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._posn-y))",[0,[1,"posn-y"]],["lang/htdp-advanced"]],
["posn-y",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._posn-y))",[0,[1,"posn-y"]],["lang/htdp-beginner"]],
["posn-y",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._posn-y))",[0,[1,"posn-y"]],["lang/htdp-beginner-abbr"]],
["posn-y",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._posn-y))",[0,[1,"posn-y"]],["lang/htdp-intermediate"]],
["posn-y",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._posn-y))",[0,[1,"posn-y"]],["lang/htdp-intermediate-lambda"]],
["posn-y",">htdp-lib/index.html#(def._((lib._lang/posn..ss)._posn-y))",[0,[1,"posn-y"]],["lang/posn"]],
["posn-y",">graphics/posn.html#(def._((lib._graphics/graphics..ss)._posn-y))",[0,[1,"posn-y"]],["graphics/graphics"]],
["posn?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._posn~3f))",[0,[1,"posn?"]],["lang/htdp-advanced"]],
["posn?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._posn~3f))",[0,[1,"posn?"]],["lang/htdp-beginner"]],
["posn?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._posn~3f))",[0,[1,"posn?"]],["lang/htdp-beginner-abbr"]],
["posn?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._posn~3f))",[0,[1,"posn?"]],["lang/htdp-intermediate"]],
["posn?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._posn~3f))",[0,[1,"posn?"]],["lang/htdp-intermediate-lambda"]],
["posn?",">htdp-lib/index.html#(def._((lib._lang/posn..ss)._posn~3f))",[0,[1,"posn?"]],["lang/posn"]],
["posn?",">graphics/posn.html#(def._((lib._graphics/graphics..ss)._posn~3f))",[0,[1,"posn?"]],["graphics/graphics"]],
["posns in htdp languages",">htdp-lib/index.html#(part._posns_in_.Ht.D.P_.Languages)",[[0,[1,"posn"]],"s in ","<i>HtDP</i>"," Languages"],false],
["post",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/dummy-10..ss)._post))",[0,[1,"post"]],[]],
["post",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-1..ss)._post))",[0,[1,"post"]],[]],
["post",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-5..ss)._post))",[0,[1,"post"]],[]],
["post-add-comment!",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-5..ss)._post-add-comment!))",[0,"post-add-comment!"],[]],
["post-blog",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/dummy-10..ss)._post-blog))",[0,[1,"post-blog"]],[]],
["post-body",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-1..ss)._post-body))",[0,[1,"post-body"]],[]],
["post-body",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-5..ss)._post-body))",[0,[1,"post-body"]],[]],
["post-comments",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-5..ss)._post-comments))",[0,[1,"post-comments"]],[]],
["post-id",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/dummy-10..ss)._post-id))",[0,[1,"post-id"]],[]],
["post-impure-port",">net/url.html#(def._((lib._net/url..ss)._post-impure-port))",[0,[1,"post-impure-port"]],["net/url"]],
["post-insert-comment!",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-9..ss)._post-insert-comment!))",[0,"post-insert-comment!"],[]],
["post-pure-port",">net/url.html#(def._((lib._net/url..ss)._post-pure-port))",[0,[1,"post-pure-port"]],["net/url"]],
["post-script-dc%",">gui/post-script-dc_.html",[0,[1,"post-script-dc%"]],["scheme/gui/base","scheme/gui"]],
["post-title",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-1..ss)._post-title))",[0,[1,"post-title"]],[]],
["post-title",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-5..ss)._post-title))",[0,[1,"post-title"]],[]],
["post-url",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-text-mixin)._post-url))",[[0,[1,"post-url"]],[12,[" (method of ",[0,[1,"hyper-text-mixin"]],")"]]],["browser"]],
["post-url",">browser/index.html#(meth._(((lib._browser/htmltext..ss)._html-text~3c~25~3e)._post-url))",[[0,[1,"post-url"]],[12,[" (method of ",[0,[1,"html-text&lt;%&gt;"]],")"]]],["browser/htmltext"]],
["post?",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/dummy-10..ss)._post~3f))",[0,[1,"post?"]],[]],
["post?",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-1..ss)._post~3f))",[0,[1,"post?"]],[]],
["post?",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-5..ss)._post~3f))",[0,[1,"post?"]],[]],
["postscript",">gui/Drawing_Functions.html#(part._.Post.Script)","PostScript",false],
["postscript dc",">gui/drawing-overview.html#(tech._postscript._dc)","<i>PostScript DC</i>",false],
["postscript fonts",">gui/fontresources.html#(part._postscriptfonts)","PostScript Fonts",false],
["postscript fonts",">gui/fontresources.html#(idx._(gentag._307._(lib._scribblings/gui/gui..scrbl)))","PostScript fonts",false],
["pousse --- tic-tac-toe-like game",">games/pousse.html",[[13,"<img src=\"pousse.png\" />"]," ","<b><font size=\"-1\" face=\"Helvetica\">Pousse</font></b>","  ","&ndash;","  Tic-Tac-Toe-like Game"],false],
["powers and roots",">reference/numbers.html#(part._.Powers_and_.Roots)","Powers and Roots",false],
["pre",">html/index.html#(def._((lib._html/main..ss)._pre))",[0,[1,"pre"]],["html"]],
["pre-install",">make/setup-extension.html#(def._((lib._make/setup-extension..ss)._pre-install))",[0,"pre-install"],["make/setup-extension"]],
["pre?",">html/index.html#(def._((lib._html/main..ss)._pre~3f))",[0,[1,"pre?"]],["html"]],
["predefined formlets",">web-server/input-formlets.html","Predefined Formlets",false],
["predefined list loops",">guide/Lists__Iteration__and_Recursion.html#(part._.Predefined_.List_.Loops)","Predefined List Loops",false],
["predicate",">guide/define-struct.html#(tech._predicate)","<i>predicate</i>",false],
["predicate",">reference/define-struct.html#(tech._predicate)","<i>predicate</i>",false],
["pref-dir",">reference/Filesystem.html#(idx._(gentag._244._(lib._scribblings/reference/reference..scrbl)))",[7,"'pref-dir"],false],
["pref-file",">reference/Filesystem.html#(idx._(gentag._245._(lib._scribblings/reference/reference..scrbl)))",[7,"'pref-file"],false],
["pref-file",">gui/mredprefs.html#(idx._(gentag._289._(lib._scribblings/gui/gui..scrbl)))",[7,"'pref-file"],false],
["prefab",">guide/define-struct.html#(tech._prefab)","<i>prefab</i>",false],
["prefab",">reference/structures.html#(tech._prefab)","<i>prefab</i>",false],
["prefab stucture types",">guide/define-struct.html#(part._prefab-struct)","Prefab Stucture Types",false],
["prefab-key->struct-type",">reference/structutils.html#(def._((quote._~23~25kernel)._prefab-key-~3estruct-type))",[0,[1,"prefab-key-&gt;struct-type"]],["scheme/base","scheme"]],
["prefab-struct-key",">reference/structutils.html#(def._((quote._~23~25kernel)._prefab-struct-key))",[0,[1,"prefab-struct-key"]],["scheme/base","scheme"]],
["preference files",">drscheme/drscheme-files.html#(part._.Preference_.Files)","Preference Files",false],
["preferences",">drscheme/prefs-explanation.html","Preferences",false],
["preferences",">framework/Preferences.html","Preferences",false],
["preferences",">gui/mredprefs.html","Preferences",false],
["preferences, textual",">framework/Preferences__Textual.html","Preferences, Textual",false],
["preferences... menu item",">drscheme/Menus.html#(idx._(gentag._96._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Preferences...</font></b> menu item",false],
["preferences:add-callback",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..ss)._preferences~3aadd-callback))",[0,[1,"preferences:add-callback"]],["framework/preferences"]],
["preferences:add-can-close-dialog-callback",">framework/Preferences.html#(def._((lib._framework/main..ss)._preferences~3aadd-can-close-dialog-callback))",[0,[1,"preferences:add-can-close-dialog-callback"]],["framework"]],
["preferences:add-editor-checkbox-panel",">framework/Preferences.html#(def._((lib._framework/main..ss)._preferences~3aadd-editor-checkbox-panel))",[0,[1,"preferences:add-editor-checkbox-panel"]],["framework"]],
["preferences:add-font-panel",">framework/Preferences.html#(def._((lib._framework/main..ss)._preferences~3aadd-font-panel))",[0,[1,"preferences:add-font-panel"]],["framework"]],
["preferences:add-on-close-dialog-callback",">framework/Preferences.html#(def._((lib._framework/main..ss)._preferences~3aadd-on-close-dialog-callback))",[0,[1,"preferences:add-on-close-dialog-callback"]],["framework"]],
["preferences:add-panel",">framework/Preferences.html#(def._((lib._framework/main..ss)._preferences~3aadd-panel))",[0,[1,"preferences:add-panel"]],["framework"]],
["preferences:add-scheme-checkbox-panel",">framework/Preferences.html#(def._((lib._framework/main..ss)._preferences~3aadd-scheme-checkbox-panel))",[0,[1,"preferences:add-scheme-checkbox-panel"]],["framework"]],
["preferences:add-to-editor-checkbox-panel",">framework/Preferences.html#(def._((lib._framework/main..ss)._preferences~3aadd-to-editor-checkbox-panel))",[0,[1,"preferences:add-to-editor-checkbox-panel"]],["framework"]],
["preferences:add-to-scheme-checkbox-panel",">framework/Preferences.html#(def._((lib._framework/main..ss)._preferences~3aadd-to-scheme-checkbox-panel))",[0,[1,"preferences:add-to-scheme-checkbox-panel"]],["framework"]],
["preferences:add-to-warnings-checkbox-panel",">framework/Preferences.html#(def._((lib._framework/main..ss)._preferences~3aadd-to-warnings-checkbox-panel))",[0,[1,"preferences:add-to-warnings-checkbox-panel"]],["framework"]],
["preferences:add-warnings-checkbox-panel",">framework/Preferences.html#(def._((lib._framework/main..ss)._preferences~3aadd-warnings-checkbox-panel))",[0,[1,"preferences:add-warnings-checkbox-panel"]],["framework"]],
["preferences:get",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..ss)._preferences~3aget))",[0,[1,"preferences:get"]],["framework/preferences"]],
["preferences:get-prefs-snapshot",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..ss)._preferences~3aget-prefs-snapshot))",[0,[1,"preferences:get-prefs-snapshot"]],["framework/preferences"]],
["preferences:hide-dialog",">framework/Preferences.html#(def._((lib._framework/main..ss)._preferences~3ahide-dialog))",[0,[1,"preferences:hide-dialog"]],["framework"]],
["preferences:low-level-put-preferences",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..ss)._preferences~3alow-level-put-preferences))",[0,[1,"preferences:low-level-put-preferences"]],["framework/preferences"]],
["preferences:put-preferences/gui",">framework/Preferences.html#(def._((lib._framework/main..ss)._preferences~3aput-preferences/gui))",[0,[1,"preferences:put-preferences/gui"]],["framework"]],
["preferences:restore-defaults",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..ss)._preferences~3arestore-defaults))",[0,[1,"preferences:restore-defaults"]],["framework/preferences"]],
["preferences:restore-prefs-snapshot",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..ss)._preferences~3arestore-prefs-snapshot))",[0,[1,"preferences:restore-prefs-snapshot"]],["framework/preferences"]],
["preferences:set",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..ss)._preferences~3aset))",[0,[1,"preferences:set"]],["framework/preferences"]],
["preferences:set-default",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..ss)._preferences~3aset-default))",[0,[1,"preferences:set-default"]],["framework/preferences"]],
["preferences:set-un/marshall",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..ss)._preferences~3aset-un/marshall))",[0,[1,"preferences:set-un/marshall"]],["framework/preferences"]],
["preferences:show-dialog",">framework/Preferences.html#(def._((lib._framework/main..ss)._preferences~3ashow-dialog))",[0,[1,"preferences:show-dialog"]],["framework"]],
["preferences:snapshot?",">framework/Preferences__Textual.html#(def._((lib._framework/preferences..ss)._preferences~3asnapshot~3f))",[0,[1,"preferences:snapshot?"]],["framework/preferences"]],
["prefix",">reference/creatingunits.html#(form._((lib._mzlib/unit..ss)._prefix))",[0,[6,"prefix"]],["scheme/unit","scheme"]],
["prefix-in",">reference/require.html#(form._((lib._scheme/base..ss)._prefix-in))",[0,[6,"prefix-in"]],["scheme/base","scheme"]],
["prefix-out",">reference/require.html#(form._((lib._scheme/base..ss)._prefix-out))",[0,[6,"prefix-out"]],["scheme/base","scheme"]],
["pregexp",">reference/regexp.html#(def._((quote._~23~25kernel)._pregexp))",[0,[1,"pregexp"]],["scheme/base","scheme"]],
["pregexp-match",">mzlib/mzlib_pregexp.html#(def._((lib._mzlib/pregexp..ss)._pregexp-match))",[0,[1,"pregexp-match"]],["mzlib/pregexp"]],
["pregexp-match-positions",">mzlib/mzlib_pregexp.html#(def._((lib._mzlib/pregexp..ss)._pregexp-match-positions))",[0,[1,"pregexp-match-positions"]],["mzlib/pregexp"]],
["pregexp-replace",">mzlib/mzlib_pregexp.html#(def._((lib._mzlib/pregexp..ss)._pregexp-replace))",[0,[1,"pregexp-replace"]],["mzlib/pregexp"]],
["pregexp-replace*",">mzlib/mzlib_pregexp.html#(def._((lib._mzlib/pregexp..ss)._pregexp-replace*))",[0,[1,"pregexp-replace*"]],["mzlib/pregexp"]],
["pregexp-split",">mzlib/mzlib_pregexp.html#(def._((lib._mzlib/pregexp..ss)._pregexp-split))",[0,[1,"pregexp-split"]],["mzlib/pregexp"]],
["pregexp?",">reference/regexp.html#(def._((quote._~23~25kernel)._pregexp~3f))",[0,[1,"pregexp?"]],["scheme/base","scheme"]],
["premature-close",">net/nntp.html#(def._((lib._net/nntp..ss)._premature-close))",[0,[1,"premature-close"]],["net/nntp"]],
["premature-close-communicator",">net/nntp.html#(def._((lib._net/nntp..ss)._premature-close-communicator))",[0,[1,"premature-close-communicator"]],["net/nntp"]],
["premature-close?",">net/nntp.html#(def._((lib._net/nntp..ss)._premature-close~3f))",[0,[1,"premature-close?"]],["net/nntp"]],
["prepare your distribution",">planet/Developing_Packages_for_PLaneT.html#(part._.Prepare_.Your_.Distribution)","Prepare Your Distribution",false],
["preprocess",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..ss)._preprocess))",[0,[1,"preprocess"]],["preprocessor/mzpp"]],
["preprocess",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..ss)._preprocess))",[0,[1,"preprocess"]],["preprocessor/mztext"]],
["preprocessor/mzpp",">preprocessor/mzpp.html#(mod-path._preprocessor/mzpp)",[14,[0,"preprocessor/mzpp"]],"module"],
["preprocessor/mztext",">preprocessor/mztext.html#(mod-path._preprocessor/mztext)",[14,[0,"preprocessor/mztext"]],"module"],
["preprocessor/pp-run",">preprocessor/overview.html",[14,[0,"preprocessor/pp-run"]],"module"],
["preserved",">reference/eval-model.html#(tech._preserved)","<i>preserved</i>",false],
["press",">gui/key-event_.html#(idx._(gentag._116._(lib._scribblings/gui/gui..scrbl)))",[7,"'press"],false],
["pretty big (legacy language)",">htdp-lib/index.html#(part._.Pretty_.Big__.Legacy_.Language_)","Pretty Big (Legacy Language)",false],
["pretty big text (legacy language)",">htdp-lib/index.html#(part._.Pretty_.Big_.Text__.Legacy_.Language_)","Pretty Big Text (Legacy Language)",false],
["pretty printing",">reference/pretty-print.html","Pretty Printing",false],
["pretty-display",">reference/pretty-print.html#(def._((lib._scheme/pretty..ss)._pretty-display))",[0,[1,"pretty-display"]],["scheme/pretty","scheme"]],
["pretty-finish",">gui/editor-stream-out_.html#(meth._(((lib._mred/main..ss)._editor-stream-out~25)._pretty-finish))",[[0,[1,"pretty-finish"]],[12,[" (method of ",[0,[1,"editor-stream-out%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["pretty-format",">reference/pretty-print.html#(def._((lib._scheme/pretty..ss)._pretty-format))",[0,[1,"pretty-format"]],["scheme/pretty","scheme"]],
["pretty-print",">reference/pretty-print.html#(def._((lib._scheme/pretty..ss)._pretty-print))",[0,[1,"pretty-print"]],["scheme/pretty","scheme"]],
["pretty-print",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._pretty-print))",[0,[1,"pretty-print"]],["lang/htdp-advanced"]],
["pretty-print-.-symbol-without-bars",">reference/pretty-print.html#(def._((lib._scheme/pretty..ss)._pretty-print-..-symbol-without-bars))",[0,[1,"pretty-print-.-symbol-without-bars"]],["scheme/pretty","scheme"]],
["pretty-print-abbreviate-read-macros",">reference/pretty-print.html#(def._((lib._scheme/pretty..ss)._pretty-print-abbreviate-read-macros))",[0,[1,"pretty-print-abbreviate-read-macros"]],["scheme/pretty","scheme"]],
["pretty-print-columns",">reference/pretty-print.html#(def._((lib._scheme/pretty..ss)._pretty-print-columns))",[0,[1,"pretty-print-columns"]],["scheme/pretty","scheme"]],
["pretty-print-current-style-table",">reference/pretty-print.html#(def._((lib._scheme/pretty..ss)._pretty-print-current-style-table))",[0,[1,"pretty-print-current-style-table"]],["scheme/pretty","scheme"]],
["pretty-print-depth",">reference/pretty-print.html#(def._((lib._scheme/pretty..ss)._pretty-print-depth))",[0,[1,"pretty-print-depth"]],["scheme/pretty","scheme"]],
["pretty-print-exact-as-decimal",">reference/pretty-print.html#(def._((lib._scheme/pretty..ss)._pretty-print-exact-as-decimal))",[0,[1,"pretty-print-exact-as-decimal"]],["scheme/pretty","scheme"]],
["pretty-print-extend-style-table",">reference/pretty-print.html#(def._((lib._scheme/pretty..ss)._pretty-print-extend-style-table))",[0,[1,"pretty-print-extend-style-table"]],["scheme/pretty","scheme"]],
["pretty-print-handler",">reference/pretty-print.html#(def._((lib._scheme/pretty..ss)._pretty-print-handler))",[0,[1,"pretty-print-handler"]],["scheme/pretty","scheme"]],
["pretty-print-invalid-xexpr",">web-server/util_ss.html#(def._((lib._web-server/private/util..ss)._pretty-print-invalid-xexpr))",[0,[1,"pretty-print-invalid-xexpr"]],["web-server/private/util"]],
["pretty-print-newline",">reference/pretty-print.html#(def._((lib._scheme/pretty..ss)._pretty-print-newline))",[0,[1,"pretty-print-newline"]],["scheme/pretty","scheme"]],
["pretty-print-post-print-hook",">reference/pretty-print.html#(def._((lib._scheme/pretty..ss)._pretty-print-post-print-hook))",[0,[1,"pretty-print-post-print-hook"]],["scheme/pretty","scheme"]],
["pretty-print-pre-print-hook",">reference/pretty-print.html#(def._((lib._scheme/pretty..ss)._pretty-print-pre-print-hook))",[0,[1,"pretty-print-pre-print-hook"]],["scheme/pretty","scheme"]],
["pretty-print-print-hook",">reference/pretty-print.html#(def._((lib._scheme/pretty..ss)._pretty-print-print-hook))",[0,[1,"pretty-print-print-hook"]],["scheme/pretty","scheme"]],
["pretty-print-print-line",">reference/pretty-print.html#(def._((lib._scheme/pretty..ss)._pretty-print-print-line))",[0,[1,"pretty-print-print-line"]],["scheme/pretty","scheme"]],
["pretty-print-remap-stylable",">reference/pretty-print.html#(def._((lib._scheme/pretty..ss)._pretty-print-remap-stylable))",[0,[1,"pretty-print-remap-stylable"]],["scheme/pretty","scheme"]],
["pretty-print-show-inexactness",">reference/pretty-print.html#(def._((lib._scheme/pretty..ss)._pretty-print-show-inexactness))",[0,[1,"pretty-print-show-inexactness"]],["scheme/pretty","scheme"]],
["pretty-print-size-hook",">reference/pretty-print.html#(def._((lib._scheme/pretty..ss)._pretty-print-size-hook))",[0,[1,"pretty-print-size-hook"]],["scheme/pretty","scheme"]],
["pretty-print-style-table?",">reference/pretty-print.html#(def._((lib._scheme/pretty..ss)._pretty-print-style-table~3f))",[0,[1,"pretty-print-style-table?"]],["scheme/pretty","scheme"]],
["pretty-printing",">reference/pretty-print.html#(def._((lib._scheme/pretty..ss)._pretty-printing))",[0,[1,"pretty-printing"]],["scheme/pretty","scheme"]],
["pretty-start",">gui/editor-stream-out_.html#(meth._(((lib._mred/main..ss)._editor-stream-out~25)._pretty-start))",[[0,[1,"pretty-start"]],[12,[" (method of ",[0,[1,"editor-stream-out%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["prev",">embedded-gui/dllist___.html#(meth._(((lib._embedded-gui/main..ss)._dllist~3c~25~3e)._prev))",[[0,[1,"prev"]],[12,[" (method of ",[0,[1,"dllist&lt;%&gt;"]],")"]]],["embedded-gui"]],
["previous",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._previous))",[[0,[1,"previous"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["previous expression",">drscheme/interactions-window.html#(idx._(gentag._25._(lib._scribblings/drscheme/drscheme..scrbl)))","previous expression",false],
["previous linkage",">planet/search-order.html#(part._.Previous_.Linkage)","Previous Linkage",false],
["primary partition (foreground color)",">macro-debugger/index.html#(part._.Primary_partition__foreground_color_)","Primary partition (foreground color)",false],
["primary slide functions",">slideshow/Primary_Slide_Functions.html","Primary Slide Functions",false],
["primitive calls",">htdp-langs/beginner-prim-call.html","Primitive Calls",false],
["primitive operation names",">htdp-langs/intermediate-lambda-prim-op.html","Primitive Operation Names",false],
["primitive operations",">htdp-langs/advanced-prim-ops.html","Primitive Operations",false],
["primitive operations",">htdp-langs/beginner-abbr-prim-ops.html","Primitive Operations",false],
["primitive operations",">htdp-langs/beginner-prim-ops.html","Primitive Operations",false],
["primitive operations",">htdp-langs/intermediate-prim-op.html","Primitive Operations",false],
["primitive string types",">foreign/String_Types.html#(part._.Primitive_.String_.Types)","Primitive String Types",false],
["primitive-closure?",">reference/procedures.html#(def._((quote._~23~25kernel)._primitive-closure~3f))",[0,[1,"primitive-closure?"]],["scheme/base","scheme"]],
["primitive-result-arity",">reference/procedures.html#(def._((quote._~23~25kernel)._primitive-result-arity))",[0,[1,"primitive-result-arity"]],["scheme/base","scheme"]],
["primitive?",">reference/procedures.html#(def._((quote._~23~25kernel)._primitive~3f))",[0,[1,"primitive?"]],["scheme/base","scheme"]],
["primitives",">frtime/index.html#(part._.Primitives)","Primitives",false],
["primitives in htdp beginner",">htdp-lib/index.html#(part._.Primitives_in_.Ht.D.P_.Beginner)","Primitives in <i>HtDP</i> Beginner",false],
["print",">planet/cmdline.html#(part._print)",[5,"print"],false],
["print",">reference/Writing.html#(def._((quote._~23~25kernel)._print))",[0,[1,"print"]],["scheme/base","scheme"]],
["print",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._print))",[[0,[1,"print"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["print",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._print))",[0,[1,"print"]],["lang/htdp-advanced"]],
["print",">lazy/index.html#(def._((lib._lazy/main..ss)._print))",[0,[1,"print"]],["lazy"]],
["print",">gui/key-event_.html#(idx._(gentag._64._(lib._scribblings/gui/gui..scrbl)))",[7,"'print"],false],
["print definitions... menu item",">drscheme/Menus.html#(idx._(gentag._72._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Print Definitions...</font></b> menu item",false],
["print handler",">reference/Evaluation_and_Compilation.html#(tech._print._handler)","<i>print handler</i>",false],
["print interactions... menu item",">drscheme/Menus.html#(idx._(gentag._73._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Print Interactions...</font></b> menu item",false],
["print-box",">reference/Writing.html#(def._((quote._~23~25kernel)._print-box))",[0,[1,"print-box"]],["scheme/base","scheme"]],
["print-convert",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..ss)._print-convert))",[0,[1,"print-convert"]],["mzlib/pconvert"]],
["print-convert-constructor-name",">mzlib/mzlib_pconvert-prop.html#(def._((lib._mzlib/pconvert-prop..ss)._print-convert-constructor-name))",[0,[1,"print-convert-constructor-name"]],["mzlib/pconvert-prop"]],
["print-convert-expr",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..ss)._print-convert-expr))",[0,[1,"print-convert-expr"]],["mzlib/pconvert"]],
["print-convert-named-constructor?",">mzlib/mzlib_pconvert-prop.html#(def._((lib._mzlib/pconvert-prop..ss)._print-convert-named-constructor~3f))",[0,[1,"print-convert-named-constructor?"]],["mzlib/pconvert-prop"]],
["print-cookie",">net/cookie.html#(def._((lib._net/cookie..ss)._print-cookie))",[0,[1,"print-cookie"]],["net/cookie"]],
["print-document",">mysterx/browsers.html#(meth._(((lib._mysterx/main..ss)._mx-browser~25)._print-document))",[[0,[1,"print-document"]],[12,[" (method of ",[0,[1,"mx-browser%"]],")"]]],["mysterx"]],
["print-error-trace",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..ss)._print-error-trace))",[0,[1,"print-error-trace"]],["errortrace"]],
["print-graph",">reference/Writing.html#(def._((quote._~23~25kernel)._print-graph))",[0,[1,"print-graph"]],["scheme/base","scheme"]],
["print-hash-table",">reference/Writing.html#(def._((quote._~23~25kernel)._print-hash-table))",[0,[1,"print-hash-table"]],["scheme/base","scheme"]],
["print-honu",">reference/Writing.html#(def._((quote._~23~25kernel)._print-honu))",[0,[1,"print-honu"]],["scheme/base","scheme"]],
["print-mpair-curly-braces",">reference/Writing.html#(def._((quote._~23~25kernel)._print-mpair-curly-braces))",[0,[1,"print-mpair-curly-braces"]],["scheme/base","scheme"]],
["print-pair-curly-braces",">reference/Writing.html#(def._((quote._~23~25kernel)._print-pair-curly-braces))",[0,[1,"print-pair-curly-braces"]],["scheme/base","scheme"]],
["print-struct",">reference/Writing.html#(def._((quote._~23~25kernel)._print-struct))",[0,[1,"print-struct"]],["scheme/base","scheme"]],
["print-to-dc",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._print-to-dc))",[[0,[1,"print-to-dc"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["print-unreadable",">reference/Writing.html#(def._((quote._~23~25kernel)._print-unreadable))",[0,[1,"print-unreadable"]],["scheme/base","scheme"]],
["print-vector-length",">reference/Writing.html#(def._((quote._~23~25kernel)._print-vector-length))",[0,[1,"print-vector-length"]],["scheme/base","scheme"]],
["printable/c",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._printable/c))",[0,[1,"printable/c"]],["scheme/contract","scheme"]],
["printable<%>",">reference/objectprinting.html#(def._((lib._scheme/private/class-internal..ss)._printable~3c~25~3e))",[0,[1,"printable&lt;%&gt;"]],["scheme/class","scheme"]],
["printer dc",">gui/drawing-overview.html#(tech._printer._dc)","<i>printer DC</i>",false],
["printer extension",">reference/Printer_Extension.html","Printer Extension",false],
["printer-dc%",">gui/printer-dc_.html",[0,[1,"printer-dc%"]],["scheme/gui/base","scheme/gui"]],
["printf",">reference/Writing.html#(def._((quote._~23~25kernel)._printf))",[0,[1,"printf"]],["scheme/base","scheme"]],
["printf",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._printf))",[0,[1,"printf"]],["lang/htdp-advanced"]],
["printf",">lazy/index.html#(def._((lib._lazy/main..ss)._printf))",[0,[1,"printf"]],["lazy"]],
["printing",">slideshow/Creating_Slide_Presentations.html#(part._.Printing)","Printing",false],
["printing booleans",">reference/printing.html#(part._.Printing_.Booleans)","Printing Booleans",false],
["printing boxes",">reference/printing.html#(part._print-box)","Printing Boxes",false],
["printing characters",">reference/printing.html#(part._.Printing_.Characters)","Printing Characters",false],
["printing format",">drscheme/output-syntax.html","printing format",false],
["printing hash tables",">reference/printing.html#(part._print-hashtable)","Printing Hash Tables",false],
["printing keywords",">reference/printing.html#(part._.Printing_.Keywords)","Printing Keywords",false],
["printing numbers",">reference/printing.html#(part._.Printing_.Numbers)","Printing Numbers",false],
["printing pairs and lists",">reference/printing.html#(part._.Printing_.Pairs_and_.Lists)","Printing Pairs and Lists",false],
["printing regular expressions",">reference/printing.html#(part._.Printing_.Regular_.Expressions)","Printing Regular Expressions",false],
["printing strings",">reference/printing.html#(part._.Printing_.Strings)","Printing Strings",false],
["printing structures",">reference/printing.html#(part._print-structure)","Printing Structures",false],
["printing symbols",">reference/printing.html#(part._print-symbol)","Printing Symbols",false],
["printing unreadable values",">reference/printing.html#(part._print-unreadable)","Printing Unreadable Values",false],
["printing vectors",">reference/printing.html#(part._print-vectors)","Printing Vectors",false],
["printing?",">slideshow/Constants_and_Layout_Variables.html#(def._((lib._slideshow/base..ss)._printing~3f))",[0,[1,"printing?"]],["slideshow/base","slideshow"]],
["prior",">gui/key-event_.html#(idx._(gentag._54._(lib._scribblings/gui/gui..scrbl)))",[7,"'prior"],false],
["private",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._private))",[0,[6,"private"]],["scheme/class","scheme"]],
["private*",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._private*))",[0,[6,"private*"]],["scheme/class","scheme"]],
["prn",">reference/windowspaths.html#(idx._(gentag._217._(lib._scribblings/reference/reference..scrbl)))",[5,"\"PRN\""],false],
["procedure",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..ss)._procedure))",[0,[1,"procedure"]],["scribble/manual"]],
["procedure applications and #%app",">reference/application.html",["Procedure Applications and ",[0,[6,"#%app"]]],false],
["procedure applications and local variables",">reference/eval-model.html#(part._.Procedure_.Applications_and_.Local_.Variables)","Procedure Applications and Local Variables",false],
["procedure expressions: lambda and case-lambda",">reference/lambda.html",["Procedure Expressions: ",[0,[6,"lambda"]]," and ",[0,[6,"case-lambda"]]],false],
["procedure invocation upon request",">web-server/dispatch-pathprocedure_ss.html","Procedure Invocation upon Request",false],
["procedure-arity",">reference/procedures.html#(def._((quote._~23~25kernel)._procedure-arity))",[0,[1,"procedure-arity"]],["scheme/base","scheme"]],
["procedure-arity-includes?",">reference/procedures.html#(def._((quote._~23~25kernel)._procedure-arity-includes~3f))",[0,[1,"procedure-arity-includes?"]],["scheme/base","scheme"]],
["procedure-arity?",">reference/procedures.html#(def._((quote._~23~25kernel)._procedure-arity~3f))",[0,[1,"procedure-arity?"]],["scheme/base","scheme"]],
["procedure-extract-target",">reference/procedures.html#(def._((quote._~23~25kernel)._procedure-extract-target))",[0,[1,"procedure-extract-target"]],["scheme/base","scheme"]],
["procedure-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._procedure-index-desc))",[0,[1,"procedure-index-desc"]],["scribble/manual-struct"]],
["procedure-index-desc?",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._procedure-index-desc~3f))",[0,[1,"procedure-index-desc?"]],["scribble/manual-struct"]],
["procedure-keywords",">reference/procedures.html#(def._((lib._scheme/base..ss)._procedure-keywords))",[0,[1,"procedure-keywords"]],["scheme/base","scheme"]],
["procedure-reduce-arity",">reference/procedures.html#(def._((quote._~23~25kernel)._procedure-reduce-arity))",[0,[1,"procedure-reduce-arity"]],["scheme/base","scheme"]],
["procedure-reduce-keyword-arity",">reference/procedures.html#(def._((lib._scheme/base..ss)._procedure-reduce-keyword-arity))",[0,[1,"procedure-reduce-keyword-arity"]],["scheme/base","scheme"]],
["procedure-struct-type?",">reference/procedures.html#(def._((quote._~23~25kernel)._procedure-struct-type~3f))",[0,[1,"procedure-struct-type?"]],["scheme/base","scheme"]],
["procedure?",">reference/procedures.html#(def._((quote._~23~25kernel)._procedure~3f))",[0,[1,"procedure?"]],["scheme/base","scheme"]],
["procedure?",">r5rs-std/r5rs-Z-H-9.html#%_idx_576",[0,[1,"procedure?"]],["r5rs"]],
["procedure?",">r6rs-std/r6rs-Z-H-14.html#node_idx_342",[0,[1,"procedure?"]],["rnrs/base-6"]],
["procedure?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._procedure~3f))",[0,[1,"procedure?"]],["lang/htdp-advanced"]],
["procedure?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._procedure~3f))",[0,[1,"procedure?"]],["lang/htdp-intermediate"]],
["procedure?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._procedure~3f))",[0,[1,"procedure?"]],["lang/htdp-intermediate-lambda"]],
["procedures",">inside/Procedures.html","Procedures",false],
["procedures",">reference/procedures.html","Procedures",false],
["procedures of some fixed, but statically unknown arity",">guide/contracts-general-functions.html#(part._contracts-no-domain)","Procedures of Some Fixed, but Statically Unknown Arity",false],
["process",">reference/subprocess.html#(def._((lib._scheme/system..ss)._process))",[0,[1,"process"]],["scheme/system"]],
["process*",">reference/subprocess.html#(def._((lib._scheme/system..ss)._process*))",[0,[1,"process*"]],["scheme/system"]],
["process*/ports",">reference/subprocess.html#(def._((lib._scheme/system..ss)._process*/ports))",[0,[1,"process*/ports"]],["scheme/system"]],
["process/ports",">reference/subprocess.html#(def._((lib._scheme/system..ss)._process/ports))",[0,[1,"process/ports"]],["scheme/system"]],
["processes",">reference/subprocess.html","Processes",false],
["product-ec",">srfi-std/srfi-42.html#product-ec",[0,[6,"product-ec"]],["srfi/42"]],
["professorj",">drscheme/profj.html","ProfessorJ",false],
["professorj advanced",">htdc/advanced.html","ProfessorJ Advanced",false],
["professorj advanced language",">drscheme/profj.html#(idx._(gentag._51._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">ProfessorJ Advanced</font></b> language",false],
["professorj beginner",">htdc/beginner.html","ProfessorJ Beginner",false],
["professorj beginner language",">drscheme/profj.html#(idx._(gentag._48._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">ProfessorJ Beginner</font></b> language",false],
["professorj full language",">drscheme/profj.html#(idx._(gentag._52._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">ProfessorJ Full</font></b> language",false],
["professorj intermediate",">htdc/intermediate.html","ProfessorJ Intermediate",false],
["professorj intermediate + access",">htdc/intermediateAcc.html","ProfessorJ Intermediate + Access",false],
["professorj intermediate + access language",">drscheme/profj.html#(idx._(gentag._50._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">ProfessorJ Intermediate + access</font></b> language",false],
["professorj intermediate language",">drscheme/profj.html#(idx._(gentag._49._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">ProfessorJ Intermediate</font></b> language",false],
["professorj java + dynamic language",">drscheme/profj.html#(idx._(gentag._53._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">ProfessorJ Java + dynamic</font></b> language",false],
["profile-key",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..ss)._stacktrace-imports~5e._profile-key))",[0,[1,"profile-key"]],["errortrace/stacktrace"]],
["profile-paths-enabled",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..ss)._profile-paths-enabled))",[0,[1,"profile-paths-enabled"]],["errortrace"]],
["profiling",">drscheme/prefs-explanation.html#(part._.Profiling)","<b><font size=\"-1\" face=\"Helvetica\">Profiling</font></b>",false],
["profiling-enabled",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..ss)._profiling-enabled))",[0,[1,"profiling-enabled"]],["errortrace"]],
["profiling-enabled",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..ss)._stacktrace-imports~5e._profiling-enabled))",[0,[1,"profiling-enabled"]],["errortrace/stacktrace"]],
["profiling-record-enabled",">errortrace/using-errortrace.html#(def._((lib._errortrace/errortrace-lib..ss)._profiling-record-enabled))",[0,[1,"profiling-record-enabled"]],["errortrace"]],
["progid",">mysterx/methprop.html#(def._((lib._mysterx/main..ss)._progid))",[0,[1,"progid"]],["mysterx"]],
["progid->html",">mysterx/Generating_ActiveX_HTML.html#(def._((lib._mysterx/main..ss)._progid-~3ehtml))",[0,[1,"progid-&gt;html"]],["mysterx"]],
["program",">srfi-std/srfi-7.html#program",[0,[6,"program"]],["srfi/7"]],
["program files",">drscheme/drscheme-files.html#(part._drscheme-file-formats)","Program Files",false],
["program-vicinity",">srfi-std/srfi-59.html#program-vicinity",[0,[1,"program-vicinity"]],["srfi/59"]],
["programmer-defined datatypes",">guide/define-struct.html","Programmer-Defined Datatypes",false],
["prolog",">xml/index.html#(def._((lib._xml/main..ss)._prolog))",[0,[1,"prolog"]],["xml"]],
["prolog-dtd",">xml/index.html#(def._((lib._xml/main..ss)._prolog-dtd))",[0,[1,"prolog-dtd"]],["xml"]],
["prolog-misc",">xml/index.html#(def._((lib._xml/main..ss)._prolog-misc))",[0,[1,"prolog-misc"]],["xml"]],
["prolog-misc2",">xml/index.html#(def._((lib._xml/main..ss)._prolog-misc2))",[0,[1,"prolog-misc2"]],["xml"]],
["prolog?",">xml/index.html#(def._((lib._xml/main..ss)._prolog~3f))",[0,[1,"prolog?"]],["xml"]],
["promise",">reference/Delayed_Evaluation.html#(tech._promise)","<i>promise</i>",false],
["promise/c",">reference/Data-structure_Contracts.html#(form._((lib._scheme/private/contract..ss)._promise/c))",[0,[6,"promise/c"]],["scheme/contract","scheme"]],
["promise?",">reference/Delayed_Evaluation.html#(def._((lib._scheme/promise..ss)._promise~3f))",[0,[1,"promise?"]],["scheme/promise","scheme"]],
["promise?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._promise~3f))",[0,[1,"promise?"]],["lang/htdp-advanced"]],
["promise?",">srfi/srfi-45.html#(def._((lib._srfi/45..ss)._promise~3f))",[0,"promise?"],["srfi/45"]],
["promising something about a specific structure",">guide/contracts-struct.html#(part._contracts-single-struct)","Promising Something About a Specific Structure",false],
["promising something about a specific vector",">guide/contracts-struct.html#(part._contracts-single-vector)","Promising Something About a Specific Vector",false],
["prompt",">reference/cont.html#(form._((lib._scheme/control..ss)._prompt))",[0,[6,"prompt"]],["scheme/control"]],
["prompt",">guide/prompt.html#(tech._prompt)","<i>prompt</i>",false],
["prompt",">reference/eval-model.html#(tech._prompt)","<i>prompt</i>",false],
["prompt tag",">guide/prompt.html#(tech._prompt._tag)","<i>prompt tag</i>",false],
["prompt tag",">reference/eval-model.html#(tech._prompt._tag)","<i>prompt tag</i>",false],
["prompt-at",">reference/cont.html#(form._((lib._scheme/control..ss)._prompt-at))",[0,[6,"prompt-at"]],["scheme/control"]],
["prompt0",">reference/cont.html#(form._((lib._scheme/control..ss)._prompt0))",[0,[6,"prompt0"]],["scheme/control"]],
["prompt0-at",">reference/cont.html#(form._((lib._scheme/control..ss)._prompt0-at))",[0,[6,"prompt0-at"]],["scheme/control"]],
["prompts and aborts",">guide/prompt.html","Prompts and Aborts",false],
["prompts, delimited continuations, and barriers",">reference/eval-model.html#(part._prompt-model)","Prompts, Delimited Continuations, and Barriers",false],
["prop:arity-string",">reference/procedures.html#(def._((quote._~23~25kernel)._prop~3aarity-string))",[0,[1,"prop:arity-string"]],["scheme/base","scheme"]],
["prop:custom-write",">reference/Printer_Extension.html#(def._((quote._~23~25kernel)._prop~3acustom-write))",[0,[1,"prop:custom-write"]],["scheme/base","scheme"]],
["prop:dict",">reference/dicts.html#(def._((lib._scheme/dict..ss)._prop~3adict))",[0,[1,"prop:dict"]],["scheme/dict","scheme"]],
["prop:equal+hash",">reference/booleans.html#(def._((quote._~23~25kernel)._prop~3aequal+hash))",[0,[1,"prop:equal+hash"]],["scheme/base","scheme"]],
["prop:evt",">reference/sync.html#(def._((quote._~23~25kernel)._prop~3aevt))",[0,[1,"prop:evt"]],["scheme/base","scheme"]],
["prop:exn:srclocs",">reference/exns.html#(def._((quote._~23~25kernel)._prop~3aexn~3asrclocs))",[0,[1,"prop:exn:srclocs"]],["scheme/base","scheme"]],
["prop:input-port",">reference/portstructs.html#(def._((quote._~23~25kernel)._prop~3ainput-port))",[0,[1,"prop:input-port"]],["scheme/base","scheme"]],
["prop:output-port",">reference/portstructs.html#(def._((quote._~23~25kernel)._prop~3aoutput-port))",[0,[1,"prop:output-port"]],["scheme/base","scheme"]],
["prop:print-convert-constructor-name",">mzlib/mzlib_pconvert-prop.html#(def._((lib._mzlib/pconvert-prop..ss)._prop~3aprint-convert-constructor-name))",[0,[1,"prop:print-convert-constructor-name"]],["mzlib/pconvert-prop"]],
["prop:procedure",">reference/procedures.html#(def._((lib._scheme/base..ss)._prop~3aprocedure))",[0,[1,"prop:procedure"]],["scheme/base","scheme"]],
["prop:procedure",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..ss)._prop~3aprocedure))",[0,[1,"prop:procedure"]],["mzscheme"]],
["prop:provide-transformer",">reference/stxtrans.html#(def._((lib._scheme/provide-transform..ss)._prop~3aprovide-transformer))",[0,[1,"prop:provide-transformer"]],["scheme/provide-transform"]],
["prop:require-transformer",">reference/stxtrans.html#(def._((lib._scheme/require-transform..ss)._prop~3arequire-transformer))",[0,[1,"prop:require-transformer"]],["scheme/require-transform"]],
["prop:sequence",">reference/sequences.html#(def._((lib._scheme/base..ss)._prop~3asequence))",[0,[1,"prop:sequence"]],["scheme/base","scheme"]],
["prop:serializable",">reference/serialization.html#(def._((lib._scheme/private/serialize..ss)._prop~3aserializable))",[0,[1,"prop:serializable"]],["scheme/serialize"]],
["propagate-constants",">mzc/Scheme_API_for_Compilation.html#(def._((lib._compiler/option..ss)._propagate-constants))",[0,[1,"propagate-constants"]],["compiler/option"]],
["proper-list?",">srfi-std/srfi-1.html#proper-list-p",[0,[1,"proper-list?"]],["srfi/1"]],
["properties",">macro-debugger/index.html#(part._.Properties)","Properties",false],
["property",">guide/define-struct.html#(tech._property)","<i>property</i>",false],
["property accessor",">reference/structprops.html#(tech._property._accessor)","<i>property accessor</i>",false],
["property lists",">mzlib/mzlib_kw.html#(part._keyword-get)","Property Lists",false],
["property predicate",">reference/structprops.html#(tech._property._predicate)","<i>property predicate</i>",false],
["prose and terminology",">scribble/How_to_Scribble_Documentation.html#(part._.Prose_and_.Terminology)","Prose and Terminology",false],
["protect-out",">reference/require.html#(form._((lib._scheme/base..ss)._protect-out))",[0,[6,"protect-out"]],["scheme/base","scheme"]],
["protected",">reference/stxprops.html#(idx._(gentag._87._(lib._scribblings/reference/reference..scrbl)))",[7,"'protected"],false],
["protecting graphics operations",">graphics/Protecting_Graphics_Operations.html","Protecting Graphics Operations",false],
["protocol",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_298",[0,[6,"protocol"]],["rnrs/records/syntactic-6"]],
["provide",">reference/require.html#(form._((lib._scheme/base..ss)._provide))",[0,[6,"provide"]],["scheme/base","scheme"]],
["provide",">eopl/index.html#(form._((lib._eopl/eopl..ss)._provide))",[0,[6,"provide"]],["eopl/eopl"]],
["provide",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..ss)._provide))",[0,[6,"provide"]],["mzscheme"]],
["provide macros",">reference/define.html#(part._provide-syntax)",[[0,[6,"provide"]]," Macros"],false],
["provide transformer",">reference/stxtrans.html#(tech._provide._transformer)","<i>provide transformer</i>",false],
["provide transformers",">reference/stxtrans.html#(part._provide-trans)",[[0,[6,"provide"]]," Transformers"],false],
["provide*",">foreign/Macros_for_Unsafety.html#(form._((lib._scheme/foreign..ss)._provide*))",[0,[6,"provide*"]],["scheme/foreign"]],
["provide-and-document",">syntax/docprovide.html#(form._((lib._syntax/docprovide..ss)._provide-and-document))",[0,[6,"provide-and-document"]],["syntax/docprovide"]],
["provide-for-label",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..ss)._provide-for-label))",[0,[6,"provide-for-label"]],["mzscheme"]],
["provide-for-syntax",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..ss)._provide-for-syntax))",[0,[6,"provide-for-syntax"]],["mzscheme"]],
["provide-higher-order-primitive",">htdp-lib/index.html#(form._((lib._lang/prim..ss)._provide-higher-order-primitive))",[0,[6,"provide-higher-order-primitive"]],["lang/prim"]],
["provide-primitive",">htdp-lib/index.html#(form._((lib._lang/prim..ss)._provide-primitive))",[0,[6,"provide-primitive"]],["lang/prim"]],
["provide-primitives",">htdp-lib/index.html#(form._((lib._lang/prim..ss)._provide-primitives))",[0,[6,"provide-primitives"]],["lang/prim"]],
["provide-signature-elements",">reference/Unit_Utilities.html#(form._((lib._mzlib/unit..ss)._provide-signature-elements))",[0,[6,"provide-signature-elements"]],["scheme/unit","scheme"]],
["provide-transformer?",">reference/stxtrans.html#(def._((lib._scheme/provide-transform..ss)._provide-transformer~3f))",[0,[1,"provide-transformer?"]],["scheme/provide-transform"]],
["provide/contract",">reference/Attaching_Contracts_to_Values.html#(form._((lib._scheme/private/contract..ss)._provide/contract))",[0,[6,"provide/contract"]],["scheme/contract","scheme"]],
["provided bindings",">preprocessor/mzpp.html#(part._mzpp-lib)","Provided bindings",false],
["provided bindings",">preprocessor/mztext.html#(part._mztext-lib)","Provided bindings",false],
["proxy design pattern",">reference/Surrogates.html#(tech._proxy._design._pattern)","<i>proxy design pattern</i>",false],
["ps",">reference/characters.html#(idx._(gentag._47._(lib._scribblings/reference/reference..scrbl)))",[7,"'ps"],false],
["ps-setup%",">gui/ps-setup_.html",[0,[1,"ps-setup%"]],["scheme/gui/base","scheme/gui"]],
["pseudo-random-generator->vector",">reference/numbers.html#(def._((quote._~23~25kernel)._pseudo-random-generator-~3evector))",[0,[1,"pseudo-random-generator-&gt;vector"]],["scheme/base","scheme"]],
["pseudo-random-generator?",">reference/numbers.html#(def._((quote._~23~25kernel)._pseudo-random-generator~3f))",[0,[1,"pseudo-random-generator?"]],["scheme/base","scheme"]],
["ptr-add",">foreign/foreign_pointer-funcs.html#(def._((lib._scheme/foreign..ss)._ptr-add))",[0,[1,"ptr-add"]],["scheme/foreign"]],
["ptr-add!",">foreign/foreign_pointer-funcs.html#(def._((lib._scribblings/foreign/unsafe-foreign..ss)._ptr-add!))",[0,[1,"ptr-add!"]],["scribblings/foreign/unsafe-foreign"]],
["ptr-equal?",">foreign/foreign_pointer-funcs.html#(def._((lib._scheme/foreign..ss)._ptr-equal~3f))",[0,[1,"ptr-equal?"]],["scheme/foreign"]],
["ptr-offset",">foreign/foreign_pointer-funcs.html#(def._((lib._scheme/foreign..ss)._ptr-offset))",[0,[1,"ptr-offset"]],["scheme/foreign"]],
["ptr-ref",">foreign/foreign_pointer-funcs.html#(def._((lib._scribblings/foreign/unsafe-foreign..ss)._ptr-ref))",[0,[1,"ptr-ref"]],["scribblings/foreign/unsafe-foreign"]],
["ptr-set!",">foreign/foreign_pointer-funcs.html#(def._((lib._scribblings/foreign/unsafe-foreign..ss)._ptr-set!))",[0,[1,"ptr-set!"]],["scribblings/foreign/unsafe-foreign"]],
["public",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._public))",[0,[6,"public"]],["scheme/class","scheme"]],
["public*",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._public*))",[0,[6,"public*"]],["scheme/class","scheme"]],
["public-final",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._public-final))",[0,[6,"public-final"]],["scheme/class","scheme"]],
["public-final*",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._public-final*))",[0,[6,"public-final*"]],["scheme/class","scheme"]],
["pubment",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._pubment))",[0,[6,"pubment"]],["scheme/class","scheme"]],
["pubment*",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._pubment*))",[0,[6,"pubment*"]],["scheme/class","scheme"]],
["punctuation",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..ss)._punctuation))",[0,[6,"punctuation"]],["parser-tools/lex"]],
["pure",">web-server/Functional_Usage.html#(def._((lib._web-server/formlets/lib..ss)._pure))",[0,[1,"pure"]],["web-server/formlets/lib"]],
["pure port",">net/url.html#(tech._pure._port)","<i>pure port</i>",false],
["purify-port",">net/url.html#(def._((lib._net/url..ss)._purify-port))",[0,[1,"purify-port"]],["net/url"]],
["push-indentation",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..ss)._push-indentation))",[0,[1,"push-indentation"]],["preprocessor/mzpp"]],
["put",">gui/editor-stream-out_.html#(meth._(((lib._mred/main..ss)._editor-stream-out~25)._put))",[[0,[1,"put"]],[12,[" (method of ",[0,[1,"editor-stream-out%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["put-bytevector",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_744",[0,[1,"put-bytevector"]],["rnrs/io/ports-6"]],
["put-char",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_748",[0,[1,"put-char"]],["rnrs/io/ports-6"]],
["put-datum",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_756",[0,[1,"put-datum"]],["rnrs/io/ports-6"]],
["put-file",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._put-file))",[0,[1,"put-file"]],["scheme/gui/base","scheme/gui"]],
["put-file",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._put-file))",[[0,[1,"put-file"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["put-file",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abasic-mixin)._put-file))",[[0,[1,"put-file"]],[12,[" (method of ",[0,[1,"editor:basic-mixin"]],")"]]],["framework"]],
["put-file",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3abasic-mixin)._put-file))",[[0,[1,"put-file"]],[12,[" (method of ",[0,[1,"text:basic-mixin"]],")"]]],["framework"]],
["put-fixed",">gui/editor-stream-out_.html#(meth._(((lib._mred/main..ss)._editor-stream-out~25)._put-fixed))",[[0,[1,"put-fixed"]],[12,[" (method of ",[0,[1,"editor-stream-out%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["put-impure-port",">net/url.html#(def._((lib._net/url..ss)._put-impure-port))",[0,[1,"put-impure-port"]],["net/url"]],
["put-input",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._put-input))",[0,[1,"put-input"]],["scheme/sandbox"]],
["put-pinhole",">teachpack/image.html#(def._((lib._htdp/image..ss)._put-pinhole))",[0,[1,"put-pinhole"]],["teachpack/htdp/image"]],
["put-preferences",">reference/Filesystem.html#(def._((lib._scheme/file..ss)._put-preferences))",[0,[1,"put-preferences"]],["scheme/file","scheme"]],
["put-pure-port",">net/url.html#(def._((lib._net/url..ss)._put-pure-port))",[0,[1,"put-pure-port"]],["net/url"]],
["put-string",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_750",[0,[1,"put-string"]],["rnrs/io/ports-6"]],
["put-u8",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_742",[0,[1,"put-u8"]],["rnrs/io/ports-6"]],
["putenv",">reference/runtime.html#(def._((quote._~23~25kernel)._putenv))",[0,[1,"putenv"]],["scheme/base","scheme"]],
["putprop",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..ss)._putprop))",[0,[1,"putprop"]],["mzlib/compat"]],
["q",">html/index.html#(def._((lib._html/main..ss)._q))",[0,[1,"q"]],["html"]],
["q?",">html/index.html#(def._((lib._html/main..ss)._q~3f))",[0,[1,"q?"]],["html"]],
["qp-decode",">net/qp.html#(def._((lib._net/qp..ss)._qp-decode))",[0,[1,"qp-decode"]],["net/qp"]],
["qp-decode-stream",">net/qp.html#(def._((lib._net/qp..ss)._qp-decode-stream))",[0,[1,"qp-decode-stream"]],["net/qp"]],
["qp-encode",">net/qp.html#(def._((lib._net/qp..ss)._qp-encode))",[0,[1,"qp-encode"]],["net/qp"]],
["qp-encode-stream",">net/qp.html#(def._((lib._net/qp..ss)._qp-encode-stream))",[0,[1,"qp-encode-stream"]],["net/qp"]],
["qp-error",">net/qp.html#(def._((lib._net/qp..ss)._qp-error))",[0,[1,"qp-error"]],["net/qp"]],
["qp-error?",">net/qp.html#(def._((lib._net/qp..ss)._qp-error~3f))",[0,[1,"qp-error?"]],["net/qp"]],
["qp-wrong-input",">net/qp.html#(def._((lib._net/qp..ss)._qp-wrong-input))",[0,[1,"qp-wrong-input"]],["net/qp"]],
["qp-wrong-input?",">net/qp.html#(def._((lib._net/qp..ss)._qp-wrong-input~3f))",[0,[1,"qp-wrong-input?"]],["net/qp"]],
["qp-wrong-line-size",">net/qp.html#(def._((lib._net/qp..ss)._qp-wrong-line-size))",[0,[1,"qp-wrong-line-size"]],["net/qp"]],
["qp-wrong-line-size?",">net/qp.html#(def._((lib._net/qp..ss)._qp-wrong-line-size~3f))",[0,[1,"qp-wrong-line-size?"]],["net/qp"]],
["qp@",">net/qp.html#(def._((lib._net/qp-unit..ss)._qp~40))",[0,[1,"qp@"]],["net/qp-unit"]],
["qp^",">net/qp.html#(form._((lib._net/qp-sig..ss)._qp~5e))",[0,[6,"qp^"]],["net/qp-sig"]],
["quantifiers",">guide/regexp-quant.html","Quantifiers",false],
["quantifiers",">guide/regexp-quant.html#(tech._quantifier)","<i>quantifiers</i>",false],
["quantize",">file/gif.html#(def._((lib._file/gif..ss)._quantize))",[0,[1,"quantize"]],["file/gif"]],
["quasi-read-style-printing",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..ss)._quasi-read-style-printing))",[0,[1,"quasi-read-style-printing"]],["mzlib/pconvert"]],
["quasiquote",">htdp-langs/beginner-abbr-quasiquote.html","Quasiquote",false],
["quasiquote",">reference/quasiquote.html#(form._((lib._scheme/private/letstx-scheme..ss)._quasiquote))",[0,[6,"quasiquote"]],["scheme/base","scheme"]],
["quasiquote",">r5rs-std/r5rs-Z-H-7.html#%_idx_154",[0,[6,"quasiquote"]],["r5rs"]],
["quasiquote",">r6rs-std/r6rs-Z-H-14.html#node_idx_768",[0,[1,"quasiquote"]],["rnrs/base-6"]],
["quasiquote",">htdp-langs/beginner-abbr-quasiquote.html#(form._((lib._lang/htdp-beginner-abbr..ss)._quasiquote))",[0,[6,"quasiquote"]],["lang/htdp-beginner-abbr"]],
["quasiquote output",">drscheme/output-syntax.html#(idx._(gentag._56._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Quasiquote</font></b> output",false],
["quasiquoting: quasiquote and `",">guide/Quasiquoting__quasiquote_and__.html",["Quasiquoting: ",[0,[6,"quasiquote"]]," and ",[7,"`"]],false],
["quasiquoting: quasiquote, unquote, and unquote-splicing",">reference/quasiquote.html",["Quasiquoting: ",[0,[6,"quasiquote"]],", ",[0,[6,"unquote"]],", and ",[0,[6,"unquote-splicing"]]],false],
["quasisyntax",">reference/stx-patterns.html#(form._((lib._scheme/private/qqstx..ss)._quasisyntax))",[0,[6,"quasisyntax"]],["scheme/base","scheme"]],
["quasisyntax",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1154",[0,[6,"quasisyntax"]],["rnrs/syntax-case-6"]],
["quasisyntax/loc",">reference/stx-patterns.html#(form._((lib._scheme/private/qqstx..ss)._quasisyntax/loc))",[0,[6,"quasisyntax/loc"]],["scheme/base","scheme"]],
["queens: \"show-queen.ss\"",">teachpack/show-queen.html",["Queens: ",[5,"\"show-queen.ss\""],"<a name=\"(idx._(gentag._14._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["query-mouse-posn",">graphics/Mouse_Operations.html#(def._((lib._graphics/graphics..ss)._query-mouse-posn))",[0,[1,"query-mouse-posn"]],["graphics/graphics"]],
["querying and changing (other) mailboxes",">net/imap.html#(part._.Querying_and_.Changing__.Other__.Mailboxes)","Querying and Changing (Other) Mailboxes",false],
["queue-callback",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._queue-callback))",[0,[1,"queue-callback"]],["scheme/gui/base","scheme/gui"]],
["queue-output",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3atext~25)._queue-output))",[[0,[1,"queue-output"]],[12,[" (method of ",[0,[1,"drscheme:rep:text%"]],")"]]],["drscheme/tool-lib"]],
["quick instructions",">errortrace/quick-instructions.html","Quick Instructions",false],
["quick instructions",">trace/index.html#(part._quick-instructions)","Quick Instructions",false],
["quick start",">plot/Quick_Start.html","Quick Start",false],
["quick: an introduction to plt scheme with pictures",">quick/index.html","<b>Quick</b>: An Introduction to PLT Scheme with Pictures",false],
["quicksort",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._quicksort))",[0,[1,"quicksort"]],["lang/htdp-advanced"]],
["quicksort",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._quicksort))",[0,[1,"quicksort"]],["lang/htdp-intermediate"]],
["quicksort",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._quicksort))",[0,[1,"quicksort"]],["lang/htdp-intermediate-lambda"]],
["quicksort",">mzlib/mzlib_list.html#(def._((lib._mzlib/list..ss)._quicksort))",[0,[1,"quicksort"]],["mzlib/list"]],
["quote",">htdp-langs/beginner-abbr-quote.html","Quote",false],
["quote",">reference/quote.html#(form._((quote._~23~25kernel)._quote))",[0,[6,"quote"]],["scheme/base","scheme"]],
["quote",">r5rs-std/r5rs-Z-H-7.html#%_idx_86",[0,[6,"quote"]],["r5rs"]],
["quote",">r6rs-std/r6rs-Z-H-14.html#node_idx_362",[0,[1,"quote"]],["rnrs/base-6"]],
["quote",">htdp-langs/beginner-quote.html#(form._((lib._lang/htdp-beginner..ss)._quote))",[0,[6,"quote"]],["lang/htdp-beginner"]],
["quote",">htdp-langs/beginner-abbr-quote.html#(form._((lib._lang/htdp-beginner-abbr..ss)._quote))",[0,[6,"quote"]],["lang/htdp-beginner-abbr"]],
["quote-syntax",">reference/Syntax_Quoting__quote-syntax.html#(form._((quote._~23~25kernel)._quote-syntax))",[0,[6,"quote-syntax"]],["scheme/base","scheme"]],
["quoted-printable unit",">net/qp.html#(part._.Quoted-.Printable_.Unit)","Quoted-Printable Unit",false],
["quoted-printable: encoding and decoding",">net/qp.html","Quoted-Printable: Encoding and Decoding",false],
["quotient",">reference/numbers.html#(def._((quote._~23~25kernel)._quotient))",[0,[1,"quotient"]],["scheme/base","scheme"]],
["quotient",">r5rs-std/r5rs-Z-H-9.html#%_idx_300",[0,[1,"quotient"]],["r5rs"]],
["quotient",">r6rs-lib-std/r6rs-lib-Z-H-20.html#node_idx_1290",[0,[1,"quotient"]],["rnrs/r5rs-6"]],
["quotient",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._quotient))",[0,[1,"quotient"]],["lang/htdp-advanced"]],
["quotient",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._quotient))",[0,[1,"quotient"]],["lang/htdp-beginner"]],
["quotient",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._quotient))",[0,[1,"quotient"]],["lang/htdp-beginner-abbr"]],
["quotient",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._quotient))",[0,[1,"quotient"]],["lang/htdp-intermediate"]],
["quotient",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._quotient))",[0,[1,"quotient"]],["lang/htdp-intermediate-lambda"]],
["quotient/remainder",">reference/numbers.html#(def._((quote._~23~25kernel)._quotient/remainder))",[0,[1,"quotient/remainder"]],["scheme/base","scheme"]],
["quoting pairs and symbols with quote",">guide/Pairs__Lists__and_Scheme_Syntax.html#(part._quoting-lists)",["Quoting Pairs and Symbols with ",[0,[6,"quote"]]],false],
["quoting: quote and '",">guide/quote.html",["Quoting: ",[0,[6,"quote"]]," and ",[7,"&rsquo;"]],false],
["r5rs",">r5rs/r5rs-mod.html",[14,[0,"r5rs"]],"module"],
["r5rs initialization library",">r5rs/r5rs_init-mod.html","R<sup>5</sup>RS Initialization Library",false],
["r5rs language",">drscheme/legacy.html#(idx._(gentag._40._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">R5RS</font></b> language",false],
["r5rs module language",">r5rs/r5rs-mod.html","R<sup>5</sup>RS Module Language",false],
["r5rs/init",">r5rs/r5rs_init-mod.html",[14,[0,"r5rs/init"]],"module"],
["r5rs: legacy standard language",">r5rs/index.html","<b>R5RS</b>: Legacy Standard Language",false],
["r6rs conformance",">r6rs/conformance.html","R<sup>6</sup>RS Conformance",false],
["r6rs libraries",">r6rs/R6RS_Libraries.html","R<sup>6</sup>RS Libraries",false],
["r6rs: standard language",">r6rs/index.html","<b>R6RS</b>: Standard Language",false],
["radial-turtles",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..ss)._radial-turtles))",[0,[1,"radial-turtles"]],["graphics/turtle-examples"]],
["radio box",">gui/windowing-overview.html#(tech._radio._box)","<i>radio box</i>",false],
["radio buttons",">gui/windowing-overview.html#(tech._radio._button)","<i>radio buttons</i>",false],
["radio-box",">gui/radio-box_.html#(idx._(gentag._126._(lib._scribblings/gui/gui..scrbl)))",[7,"'radio-box"],false],
["radio-box%",">gui/radio-box_.html",[0,[1,"radio-box%"]],["scheme/gui/base","scheme/gui"]],
["raise",">reference/exns.html#(def._((quote._~23~25kernel)._raise))",[0,[1,"raise"]],["scheme/base","scheme"]],
["raise",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._raise))",[[0,[1,"raise"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["raise",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_376",[0,[1,"raise"]],["rnrs/exceptions-6"]],
["raise",">srfi-std/srfi-34.html#raise",[0,[1,"raise"]],["srfi/34"]],
["raise-arity-error",">reference/exns.html#(def._((quote._~23~25kernel)._raise-arity-error))",[0,[1,"raise-arity-error"]],["scheme/base","scheme"]],
["raise-continuable",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_378",[0,[1,"raise-continuable"]],["rnrs/exceptions-6"]],
["raise-contract-error",">reference/Building_New_Contract_Combinators.html#(def._((lib._scheme/private/contract-guts..ss)._raise-contract-error))",[0,[1,"raise-contract-error"]],["scheme/contract","scheme"]],
["raise-mismatch-error",">reference/exns.html#(def._((quote._~23~25kernel)._raise-mismatch-error))",[0,[1,"raise-mismatch-error"]],["scheme/base","scheme"]],
["raise-read-eof-error",">syntax/reader-helpers.html#(def._((lib._syntax/readerr..ss)._raise-read-eof-error))",[0,[1,"raise-read-eof-error"]],["syntax/readerr"]],
["raise-read-error",">syntax/reader-helpers.html#(def._((lib._syntax/readerr..ss)._raise-read-error))",[0,[1,"raise-read-error"]],["syntax/readerr"]],
["raise-syntax-error",">reference/exns.html#(def._((quote._~23~25kernel)._raise-syntax-error))",[0,[1,"raise-syntax-error"]],["scheme/base","scheme"]],
["raise-type-error",">reference/exns.html#(def._((quote._~23~25kernel)._raise-type-error))",[0,[1,"raise-type-error"]],["scheme/base","scheme"]],
["raise-user-error",">reference/exns.html#(def._((quote._~23~25kernel)._raise-user-error))",[0,[1,"raise-user-error"]],["scheme/base","scheme"]],
["raising exceptions",">reference/exns.html#(part._errorproc)","Raising Exceptions",false],
["raising exn:fail:read",">syntax/reader-helpers.html#(part._readerr)",["Raising ",[0,[1,"exn:fail:read"]]],false],
["random",">reference/numbers.html#(def._((quote._~23~25kernel)._random))",[0,[1,"random"]],["scheme/base","scheme"]],
["random",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._random))",[0,[1,"random"]],["lang/htdp-advanced"]],
["random",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._random))",[0,[1,"random"]],["lang/htdp-beginner"]],
["random",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._random))",[0,[1,"random"]],["lang/htdp-beginner-abbr"]],
["random",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._random))",[0,[1,"random"]],["lang/htdp-intermediate"]],
["random",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._random))",[0,[1,"random"]],["lang/htdp-intermediate-lambda"]],
["random numbers",">reference/numbers.html#(part._.Random_.Numbers)","Random Numbers",false],
["random-integer",">srfi-std/srfi-27.html#random-integer",[0,[1,"random-integer"]],["srfi/27"]],
["random-real",">srfi-std/srfi-27.html#random-real",[0,[1,"random-real"]],["srfi/27"]],
["random-seed",">reference/numbers.html#(def._((quote._~23~25kernel)._random-seed))",[0,[1,"random-seed"]],["scheme/base","scheme"]],
["random-source-make-integers",">srfi-std/srfi-27.html#random-source-make-integers",[0,[1,"random-source-make-integers"]],["srfi/27"]],
["random-source-make-reals",">srfi-std/srfi-27.html#random-source-make-reals",[0,[1,"random-source-make-reals"]],["srfi/27"]],
["random-source-pseudo-randomize!",">srfi-std/srfi-27.html#random-source-pseudo-randomize!",[0,[1,"random-source-pseudo-randomize!"]],["srfi/27"]],
["random-source-randomize!",">srfi-std/srfi-27.html#random-source-randomize!",[0,[1,"random-source-randomize!"]],["srfi/27"]],
["random-source-state-ref",">srfi-std/srfi-27.html#random-source-state-ref",[0,[1,"random-source-state-ref"]],["srfi/27"]],
["random-source-state-ref!",">srfi-std/srfi-27.html#random-source-state-ref",[0,[1,"random-source-state-ref!"]],["srfi/27"]],
["random-source?",">srfi-std/srfi-27.html#random-source-p",[0,[1,"random-source?"]],["srfi/27"]],
["rational",">guide/numbers.html#(tech._rational)","<i>rational</i>",false],
["rational numbers",">reference/numbers.html#(tech._rational._number)","<i>rational numbers</i>",false],
["rational-valued?",">r6rs-std/r6rs-Z-H-14.html#node_idx_452",[0,[1,"rational-valued?"]],["rnrs/base-6"]],
["rational?",">reference/numbers.html#(def._((quote._~23~25kernel)._rational~3f))",[0,[1,"rational?"]],["scheme/base","scheme"]],
["rational?",">r5rs-std/r5rs-Z-H-9.html#%_idx_250",[0,[1,"rational?"]],["r5rs"]],
["rational?",">r6rs-std/r6rs-Z-H-14.html#node_idx_446",[0,[1,"rational?"]],["rnrs/base-6"]],
["rational?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._rational~3f))",[0,[1,"rational?"]],["lang/htdp-advanced"]],
["rational?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._rational~3f))",[0,[1,"rational?"]],["lang/htdp-beginner"]],
["rational?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._rational~3f))",[0,[1,"rational?"]],["lang/htdp-beginner-abbr"]],
["rational?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._rational~3f))",[0,[1,"rational?"]],["lang/htdp-intermediate"]],
["rational?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._rational~3f))",[0,[1,"rational?"]],["lang/htdp-intermediate-lambda"]],
["rationalize",">reference/numbers.html#(def._((lib._scheme/private/misc..ss)._rationalize))",[0,[1,"rationalize"]],["scheme/base","scheme"]],
["rationalize",">r5rs-std/r5rs-Z-H-9.html#%_idx_322",[0,[1,"rationalize"]],["r5rs"]],
["rationalize",">r6rs-std/r6rs-Z-H-14.html#node_idx_536",[0,[1,"rationalize"]],["rnrs/base-6"]],
["raw",">foreign/foreign_pointer-funcs.html#(idx._(gentag._11._(lib._scribblings/foreign/foreign..scrbl)))",[7,"'raw"],false],
["raw preprocessing directives",">preprocessor/mzpp.html#(part._.Raw_preprocessing_directives)","Raw preprocessing directives",false],
["rb-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..ss)._rb-find))",[0,[1,"rb-find"]],["slideshow/pict","slideshow"]],
["rb-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..ss)._rb-superimpose))",[0,[1,"rb-superimpose"]],["slideshow/pict","slideshow"]],
["rbl-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..ss)._rbl-find))",[0,[1,"rbl-find"]],["slideshow/pict","slideshow"]],
["rbl-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..ss)._rbl-superimpose))",[0,[1,"rbl-superimpose"]],["slideshow/pict","slideshow"]],
["rc-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..ss)._rc-find))",[0,[1,"rc-find"]],["slideshow/pict","slideshow"]],
["rc-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..ss)._rc-superimpose))",[0,[1,"rc-superimpose"]],["slideshow/pict","slideshow"]],
["re-slide",">slideshow/Slide_Registration.html#(def._((lib._slideshow/base..ss)._re-slide))",[0,[1,"re-slide"]],["slideshow/base","slideshow"]],
["re-using errortrace stack tracing",">errortrace/stacktrace.html","Re-using Errortrace Stack Tracing",false],
["read",">reference/Reading.html#(def._((quote._~23~25kernel)._read))",[0,[1,"read"]],["scheme/base","scheme"]],
["read",">gui/editor-data-class_.html#(meth._(((lib._mred/main..ss)._editor-data-class~25)._read))",[[0,[1,"read"]],[12,[" (method of ",[0,[1,"editor-data-class%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["read",">gui/editor-stream-in-base_.html#(meth._(((lib._mred/main..ss)._editor-stream-in-base~25)._read))",[[0,[1,"read"]],[12,[" (method of ",[0,[1,"editor-stream-in-base%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["read",">gui/snip-class_.html#(meth._(((lib._mred/main..ss)._snip-class~25)._read))",[[0,[1,"read"]],[12,[" (method of ",[0,[1,"snip-class%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["read",">gui/string-snip_.html#(meth._(((lib._mred/main..ss)._string-snip~25)._read))",[[0,[1,"read"]],[12,[" (method of ",[0,[1,"string-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["read",">r5rs-std/r5rs-Z-H-9.html#%_idx_636",[0,[1,"read"]],["r5rs"]],
["read",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_816",[0,[1,"read"]],["rnrs/io/simple-6"]],
["read",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._read))",[0,[1,"read"]],["lang/htdp-advanced"]],
["read",">framework/editor-snip.html#(meth._(((lib._framework/main..ss)._editor-snip~3adecorated-snipclass~25)._read))",["read",[12,[" (method of ",[0,[1,"editor-snip:decorated-snipclass%"]],")"]]],["framework"]],
["read",">framework/Number_Snip.html#(meth._(((lib._framework/main..ss)._number-snip~3asnip-class~25)._read))",[[0,[1,"read"]],[12,[" (method of ",[0,[1,"number-snip:snip-class%"]],")"]]],["framework"]],
["read",">scribble/reader.html#(def._((lib._scribble/reader..ss)._read))",[0,[1,"read"]],["scribble/reader"]],
["read",">reference/securityguards.html#(idx._(gentag._203._(lib._scribblings/reference/reference..scrbl)))",[7,"'read"],false],
["read",">reference/Filesystem.html#(idx._(gentag._263._(lib._scribblings/reference/reference..scrbl)))",[7,"'read"],false],
["read",">drscheme/interactions-window.html#(idx._(gentag._31._(lib._scribblings/drscheme/drscheme..scrbl)))",[0,[1,"read"]],false],
["read",">reference/syntax-model.html#(tech._read)","<i>read</i>",false],
["read-accept-bar-quote",">reference/Reading.html#(def._((quote._~23~25kernel)._read-accept-bar-quote))",[0,[1,"read-accept-bar-quote"]],["scheme/base","scheme"]],
["read-accept-box",">reference/Reading.html#(def._((quote._~23~25kernel)._read-accept-box))",[0,[1,"read-accept-box"]],["scheme/base","scheme"]],
["read-accept-compiled",">reference/Reading.html#(def._((quote._~23~25kernel)._read-accept-compiled))",[0,[1,"read-accept-compiled"]],["scheme/base","scheme"]],
["read-accept-dot",">reference/Reading.html#(def._((quote._~23~25kernel)._read-accept-dot))",[0,[1,"read-accept-dot"]],["scheme/base","scheme"]],
["read-accept-graph",">reference/Reading.html#(def._((quote._~23~25kernel)._read-accept-graph))",[0,[1,"read-accept-graph"]],["scheme/base","scheme"]],
["read-accept-infix-dot",">reference/Reading.html#(def._((quote._~23~25kernel)._read-accept-infix-dot))",[0,[1,"read-accept-infix-dot"]],["scheme/base","scheme"]],
["read-accept-quasiquote",">reference/Reading.html#(def._((quote._~23~25kernel)._read-accept-quasiquote))",[0,[1,"read-accept-quasiquote"]],["scheme/base","scheme"]],
["read-accept-reader",">reference/Reading.html#(def._((quote._~23~25kernel)._read-accept-reader))",[0,[1,"read-accept-reader"]],["scheme/base","scheme"]],
["read-byte",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._read-byte))",[0,[1,"read-byte"]],["scheme/base","scheme"]],
["read-byte-or-special",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._read-byte-or-special))",[0,[1,"read-byte-or-special"]],["scheme/base","scheme"]],
["read-bytes",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._read-bytes))",[0,[1,"read-bytes"]],["scheme/base","scheme"]],
["read-bytes",">gui/WXME_Decoding.html#(meth._(((lib._wxme/main..ss)._stream~3c~25~3e)._read-bytes))",[[0,[1,"read-bytes"]],[12,[" (method of ",[0,[1,"stream&lt;%&gt;"]],")"]]],["wxme"]],
["read-bytes!",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._read-bytes!))",[0,[1,"read-bytes!"]],["scheme/base","scheme"]],
["read-bytes!-evt",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._read-bytes!-evt))",[0,[1,"read-bytes!-evt"]],["scheme/port"]],
["read-bytes-avail!",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._read-bytes-avail!))",[0,[1,"read-bytes-avail!"]],["scheme/base","scheme"]],
["read-bytes-avail!*",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._read-bytes-avail!*))",[0,[1,"read-bytes-avail!*"]],["scheme/base","scheme"]],
["read-bytes-avail!-evt",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._read-bytes-avail!-evt))",[0,[1,"read-bytes-avail!-evt"]],["scheme/port"]],
["read-bytes-avail!/enable-break",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._read-bytes-avail!/enable-break))",[0,[1,"read-bytes-avail!/enable-break"]],["scheme/base","scheme"]],
["read-bytes-evt",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._read-bytes-evt))",[0,[1,"read-bytes-evt"]],["scheme/port"]],
["read-bytes-line",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._read-bytes-line))",[0,[1,"read-bytes-line"]],["scheme/base","scheme"]],
["read-bytes-line-evt",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._read-bytes-line-evt))",[0,[1,"read-bytes-line-evt"]],["scheme/port"]],
["read-case-sensitive",">reference/Reading.html#(def._((quote._~23~25kernel)._read-case-sensitive))",[0,[1,"read-case-sensitive"]],["scheme/base","scheme"]],
["read-char",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._read-char))",[0,[1,"read-char"]],["scheme/base","scheme"]],
["read-char",">r5rs-std/r5rs-Z-H-9.html#%_idx_640",[0,[1,"read-char"]],["r5rs"]],
["read-char",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_808",[0,[1,"read-char"]],["rnrs/io/simple-6"]],
["read-char",">drscheme/interactions-window.html#(idx._(gentag._32._(lib._scribblings/drscheme/drscheme..scrbl)))",[0,[1,"read-char"]],false],
["read-char-or-special",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._read-char-or-special))",[0,[1,"read-char-or-special"]],["scheme/base","scheme"]],
["read-comments",">xml/index.html#(def._((lib._xml/main..ss)._read-comments))",[0,[1,"read-comments"]],["xml"]],
["read-configuration-table",">web-server/configuration-table_ss.html#(def._((lib._web-server/configuration/configuration-table..ss)._read-configuration-table))",[0,[1,"read-configuration-table"]],["web-server/configuration/configuration-table"]],
["read-curly-brace-as-paren",">reference/Reading.html#(def._((quote._~23~25kernel)._read-curly-brace-as-paren))",[0,[1,"read-curly-brace-as-paren"]],["scheme/base","scheme"]],
["read-decimal-as-inexact",">reference/Reading.html#(def._((quote._~23~25kernel)._read-decimal-as-inexact))",[0,[1,"read-decimal-as-inexact"]],["scheme/base","scheme"]],
["read-editor",">gui/WXME_Decoding.html#(meth._(((lib._wxme/main..ss)._stream~3c~25~3e)._read-editor))",[[0,[1,"read-editor"]],[12,[" (method of ",[0,[1,"stream&lt;%&gt;"]],")"]]],["wxme"]],
["read-editor-global-footer",">gui/Editor_Functions.html#(def._((lib._mred/main..ss)._read-editor-global-footer))",[0,[1,"read-editor-global-footer"]],["scheme/gui/base","scheme/gui"]],
["read-editor-global-header",">gui/Editor_Functions.html#(def._((lib._mred/main..ss)._read-editor-global-header))",[0,[1,"read-editor-global-header"]],["scheme/gui/base","scheme/gui"]],
["read-editor-version",">gui/Editor_Functions.html#(def._((lib._mred/main..ss)._read-editor-version))",[0,[1,"read-editor-version"]],["scheme/gui/base","scheme/gui"]],
["read-eval-print-loop",">reference/Evaluation_and_Compilation.html#(def._((lib._scheme/private/misc..ss)._read-eval-print-loop))",[0,[1,"read-eval-print-loop"]],["scheme/base","scheme"]],
["read-fixed-integer",">gui/WXME_Decoding.html#(meth._(((lib._wxme/main..ss)._stream~3c~25~3e)._read-fixed-integer))",[[0,[1,"read-fixed-integer"]],[12,[" (method of ",[0,[1,"stream&lt;%&gt;"]],")"]]],["wxme"]],
["read-footer-from-file",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._read-footer-from-file))",[[0,[1,"read-footer-from-file"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["read-from-file",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._read-from-file))",[[0,[1,"read-from-file"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["read-from-file",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._read-from-file))",[[0,[1,"read-from-file"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["read-from-string",">mzlib/mzlib_string.html#(def._((lib._mzlib/string..ss)._read-from-string))",[0,[1,"read-from-string"]],["mzlib/string"]],
["read-from-string-all",">mzlib/mzlib_string.html#(def._((lib._mzlib/string..ss)._read-from-string-all))",[0,[1,"read-from-string-all"]],["mzlib/string"]],
["read-header",">gui/snip-class_.html#(meth._(((lib._mred/main..ss)._snip-class~25)._read-header))",[[0,[1,"read-header"]],[12,[" (method of ",[0,[1,"snip-class%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["read-header",">gui/WXME_Decoding.html#(meth._(((lib._wxme/main..ss)._snip-reader~3c~25~3e)._read-header))",[[0,[1,"read-header"]],[12,[" (method of ",[0,[1,"snip-reader&lt;%&gt;"]],")"]]],["wxme"]],
["read-header-from-file",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._read-header-from-file))",[[0,[1,"read-header-from-file"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["read-honu",">reference/Reading.html#(def._((quote._~23~25kernel)._read-honu))",[0,[1,"read-honu"]],["scheme/base","scheme"]],
["read-honu-syntax",">reference/Reading.html#(def._((quote._~23~25kernel)._read-honu-syntax))",[0,[1,"read-honu-syntax"]],["scheme/base","scheme"]],
["read-honu-syntax/recursive",">reference/Reading.html#(def._((quote._~23~25kernel)._read-honu-syntax/recursive))",[0,[1,"read-honu-syntax/recursive"]],["scheme/base","scheme"]],
["read-honu/recursive",">reference/Reading.html#(def._((quote._~23~25kernel)._read-honu/recursive))",[0,[1,"read-honu/recursive"]],["scheme/base","scheme"]],
["read-html",">html/index.html#(def._((lib._html/main..ss)._read-html))",[0,[1,"read-html"]],["html"]],
["read-html-as-xml",">html/index.html#(def._((lib._html/main..ss)._read-html-as-xml))",[0,[1,"read-html-as-xml"]],["html"]],
["read-inexact",">gui/WXME_Decoding.html#(meth._(((lib._wxme/main..ss)._stream~3c~25~3e)._read-inexact))",[[0,[1,"read-inexact"]],[12,[" (method of ",[0,[1,"stream&lt;%&gt;"]],")"]]],["wxme"]],
["read-inside",">scribble/reader.html#(def._((lib._scribble/reader..ss)._read-inside))",[0,[1,"read-inside"]],["scribble/reader"]],
["read-integer",">gui/WXME_Decoding.html#(meth._(((lib._wxme/main..ss)._stream~3c~25~3e)._read-integer))",[[0,[1,"read-integer"]],[12,[" (method of ",[0,[1,"stream&lt;%&gt;"]],")"]]],["wxme"]],
["read-language",">reference/Reading.html#(def._((quote._~23~25kernel)._read-language))",[0,[1,"read-language"]],["scheme/base","scheme"]],
["read-line",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._read-line))",[0,[1,"read-line"]],["scheme/base","scheme"]],
["read-line-evt",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._read-line-evt))",[0,[1,"read-line-evt"]],["scheme/port"]],
["read-mime-types",">web-server/mime-types_ss.html#(def._((lib._web-server/private/mime-types..ss)._read-mime-types))",[0,[1,"read-mime-types"]],["web-server/private/mime-types"]],
["read-on-demand-source",">reference/Reading.html#(def._((quote._~23~25kernel)._read-on-demand-source))",[0,[1,"read-on-demand-source"]],["scheme/base","scheme"]],
["read-plist",">xml/index.html#(def._((lib._xml/plist..ss)._read-plist))",[0,[1,"read-plist"]],["xml/plist"]],
["read-raw-bytes",">gui/WXME_Decoding.html#(meth._(((lib._wxme/main..ss)._stream~3c~25~3e)._read-raw-bytes))",[[0,[1,"read-raw-bytes"]],[12,[" (method of ",[0,[1,"stream&lt;%&gt;"]],")"]]],["wxme"]],
["read-request",">web-server/dispatch-server-unit_ss.html#(sig-val._((lib._web-server/private/dispatch-server-sig..ss)._dispatch-server-config~5e._read-request))",[0,[1,"read-request"]],["web-server/private/dispatch-server-sig"]],
["read-snip",">gui/WXME_Decoding.html#(meth._(((lib._wxme/main..ss)._snip-reader~3c~25~3e)._read-snip))",[[0,[1,"read-snip"]],[12,[" (method of ",[0,[1,"snip-reader&lt;%&gt;"]],")"]]],["wxme"]],
["read-special",">gui/readable-snip___.html#(meth._(((lib._mred/main..ss)._readable-snip~3c~25~3e)._read-special))",[[0,[1,"read-special"]],[12,[" (method of ",[0,[1,"readable-snip&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["read-special",">gui/WXME_Decoding.html#(meth._(((lib._wxme/main..ss)._readable~3c~25~3e)._read-special))",[[0,[1,"read-special"]],[12,[" (method of ",[0,[1,"readable&lt;%&gt;"]],")"]]],["wxme"]],
["read-special",">gui/WXME_Decoding.html#(meth._(((lib._wxme/comment..ss)._comment-editor~25)._read-special))",[[0,[1,"read-special"]],[12,[" (method of ",[0,[1,"comment-editor%"]],")"]]],["wxme/comment"]],
["read-special",">gui/WXME_Decoding.html#(meth._(((lib._wxme/scheme..ss)._scheme-editor~25)._read-special))",[[0,[1,"read-special"]],[12,[" (method of ",[0,[1,"scheme-editor%"]],")"]]],["wxme/scheme"]],
["read-special",">gui/WXME_Decoding.html#(meth._(((lib._wxme/text..ss)._text-editor~25)._read-special))",[[0,[1,"read-special"]],[12,[" (method of ",[0,[1,"text-editor%"]],")"]]],["wxme/text"]],
["read-special",">gui/WXME_Decoding.html#(meth._(((lib._wxme/xml..ss)._xml-editor~25)._read-special))",[[0,[1,"read-special"]],[12,[" (method of ",[0,[1,"xml-editor%"]],")"]]],["wxme/xml"]],
["read-square-bracket-as-paren",">reference/Reading.html#(def._((quote._~23~25kernel)._read-square-bracket-as-paren))",[0,[1,"read-square-bracket-as-paren"]],["scheme/base","scheme"]],
["read-string",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._read-string))",[0,[1,"read-string"]],["scheme/base","scheme"]],
["read-string!",">reference/Byte_and_String_Input.html#(def._((quote._~23~25kernel)._read-string!))",[0,[1,"read-string!"]],["scheme/base","scheme"]],
["read-string!-evt",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._read-string!-evt))",[0,[1,"read-string!-evt"]],["scheme/port"]],
["read-string-evt",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._read-string-evt))",[0,[1,"read-string-evt"]],["scheme/port"]],
["read-syntax",">reference/Reading.html#(def._((quote._~23~25kernel)._read-syntax))",[0,[1,"read-syntax"]],["scheme/base","scheme"]],
["read-syntax",">scribble/reader.html#(def._((lib._scribble/reader..ss)._read-syntax))",[0,[1,"read-syntax"]],["scribble/reader"]],
["read-syntax-inside",">scribble/reader.html#(def._((lib._scribble/reader..ss)._read-syntax-inside))",[0,[1,"read-syntax-inside"]],["scribble/reader"]],
["read-syntax/recursive",">reference/Reading.html#(def._((quote._~23~25kernel)._read-syntax/recursive))",[0,[1,"read-syntax/recursive"]],["scheme/base","scheme"]],
["read-with-shared-structure",">srfi-std/srfi-38.html#read-with-shared-structure",[0,[1,"read-with-shared-structure"]],["srfi/38"]],
["read-xhtml",">html/index.html#(def._((lib._html/main..ss)._read-xhtml))",[0,[1,"read-xhtml"]],["html"]],
["read-xml",">xml/index.html#(def._((lib._xml/main..ss)._read-xml))",[0,[1,"read-xml"]],["xml"]],
["read-xml/element",">xml/index.html#(def._((lib._xml/main..ss)._read-xml/element))",[0,[1,"read-xml/element"]],["xml"]],
["read/bytes",">web-server/util_ss.html#(def._((lib._web-server/private/util..ss)._read/bytes))",[0,[1,"read/bytes"]],["web-server/private/util"]],
["read/recursive",">reference/Reading.html#(def._((quote._~23~25kernel)._read/recursive))",[0,[1,"read/recursive"]],["scheme/base","scheme"]],
["read/string",">web-server/util_ss.html#(def._((lib._web-server/private/util..ss)._read/string))",[0,[1,"read/string"]],["web-server/private/util"]],
["readable-snip<%>",">gui/readable-snip___.html",[0,[1,"readable-snip&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["readable<%>",">gui/WXME_Decoding.html#(def._((lib._wxme/main..ss)._readable~3c~25~3e))",[0,[1,"readable&lt;%&gt;"]],["wxme"]],
["reader",">gui/WXME_Decoding.html#(def._((lib._wxme/cache-image..ss)._reader))",[0,[1,"reader"]],["wxme/cache-image"]],
["reader",">gui/WXME_Decoding.html#(def._((lib._wxme/comment..ss)._reader))",[0,[1,"reader"]],["wxme/comment"]],
["reader",">gui/WXME_Decoding.html#(def._((lib._wxme/number..ss)._reader))",[0,[1,"reader"]],["wxme/number"]],
["reader",">gui/WXME_Decoding.html#(def._((lib._wxme/scheme..ss)._reader))",[0,[1,"reader"]],["wxme/scheme"]],
["reader",">gui/WXME_Decoding.html#(def._((lib._wxme/test-case..ss)._reader))",[0,[1,"reader"]],["wxme/test-case"]],
["reader",">gui/WXME_Decoding.html#(def._((lib._wxme/text..ss)._reader))",[0,[1,"reader"]],["wxme/text"]],
["reader",">gui/WXME_Decoding.html#(def._((lib._wxme/xml..ss)._reader))",[0,[1,"reader"]],["wxme/xml"]],
["reader extension",">reference/Reader_Extension.html","Reader Extension",false],
["reader extension procedures",">reference/Reader_Extension.html#(tech._reader._extension._procedure)","<i>reader\nextension procedures</i>",false],
["reader helpers",">syntax/reader-helpers.html","Reader Helpers",false],
["reader language",">reference/Reading.html#(tech._reader._language)","<i>reader language</i>",false],
["reader macro",">reference/readtables.html#(tech._reader._macro)","<i>reader macro</i>",false],
["reader-extension procedures",">reference/reader-procs.html","Reader-Extension Procedures",false],
["reading",">reference/Reading.html","Reading",false],
["reading \"info.ss\" files",">setup-plt/getinfo.html",["Reading ",[5,"\"info.ss\""]," Files"],false],
["reading and writing scheme data",">guide/Reading_and_Writing_Scheme_Data.html","Reading and Writing Scheme Data",false],
["reading and writing xml",">xml/index.html#(part._.Reading_and_.Writing_.X.M.L)","Reading and Writing XML",false],
["reading booleans",">reference/reader.html#(part._parse-boolean)","Reading Booleans",false],
["reading boxes",">reference/reader.html#(part._parse-box)","Reading Boxes",false],
["reading characters",">reference/reader.html#(part._parse-character)","Reading Characters",false],
["reading comments",">reference/reader.html#(part._parse-comment)","Reading Comments",false],
["reading graph structure",">reference/reader.html#(part._parse-graph)","Reading Graph Structure",false],
["reading hash tables",">reference/reader.html#(part._parse-hashtable)","Reading Hash Tables",false],
["reading keywords",">reference/reader.html#(part._parse-keyword)","Reading Keywords",false],
["reading module source code",">syntax/module-helpers.html#(part._modread)","Reading Module Source Code",false],
["reading numbers",">reference/reader.html#(part._parse-number)","Reading Numbers",false],
["reading pairs and lists",">reference/reader.html#(part._parse-pair)","Reading Pairs and Lists",false],
["reading quotes",">reference/reader.html#(part._parse-quote)","Reading Quotes",false],
["reading regular expressions",">reference/reader.html#(part._parse-regexp)","Reading Regular Expressions",false],
["reading strings",">reference/reader.html#(part._parse-string)","Reading Strings",false],
["reading structures",">reference/reader.html#(part._parse-structure)","Reading Structures",false],
["reading symbols",">reference/reader.html#(part._parse-symbol)","Reading Symbols",false],
["reading vectors",">reference/reader.html#(part._parse-vector)","Reading Vectors",false],
["reading via an extension",">reference/reader.html#(part._parse-reader)","Reading via an Extension",false],
["reading-version",">gui/snip-class_.html#(meth._(((lib._mred/main..ss)._snip-class~25)._reading-version))",[[0,[1,"reading-version"]],[12,[" (method of ",[0,[1,"snip-class%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["readline",">readline/index.html#(mod-path._readline)",[14,[0,[1,"readline"]]],"module"],
["readline",">readline/index.html#(def._((lib._readline/readline..ss)._readline))",[0,[1,"readline"]],["readline/readline"]],
["readline-bytes",">readline/index.html#(def._((lib._readline/readline..ss)._readline-bytes))",[0,[1,"readline-bytes"]],["readline/readline"]],
["readline-prompt",">readline/index.html#(def._((lib._readline/pread..ss)._readline-prompt))",[0,[1,"readline-prompt"]],["readline/pread"]],
["readline/pread",">readline/index.html#(mod-path._readline/pread)",[14,[0,"readline/pread"]],"module"],
["readline/readline",">readline/index.html#(mod-path._readline/readline)",[14,[0,"readline/readline"]],"module"],
["readline/rep-start",">readline/index.html#(mod-path._readline/rep-start)",[14,[0,"readline/rep-start"]],"module"],
["readline: terminal interaction",">readline/index.html","<b>Readline</b>: Terminal Interaction",false],
["readtable",">reference/readtables.html#(tech._readtable)","<i>readtable</i>",false],
["readtable-mapping",">reference/readtables.html#(def._((quote._~23~25kernel)._readtable-mapping))",[0,[1,"readtable-mapping"]],["scheme/base","scheme"]],
["readtable?",">reference/readtables.html#(def._((quote._~23~25kernel)._readtable~3f))",[0,[1,"readtable?"]],["scheme/base","scheme"]],
["readtables",">reference/readtables.html","Readtables",false],
["ready-key-press",">graphics/Keyboard_Operations.html#(def._((lib._graphics/graphics..ss)._ready-key-press))",[0,[1,"ready-key-press"]],["graphics/graphics"]],
["ready-mouse-click",">graphics/Mouse_Operations.html#(def._((lib._graphics/graphics..ss)._ready-mouse-click))",[0,[1,"ready-mouse-click"]],["graphics/graphics"]],
["ready-mouse-release",">graphics/Mouse_Operations.html#(def._((lib._graphics/graphics..ss)._ready-mouse-release))",[0,[1,"ready-mouse-release"]],["graphics/graphics"]],
["ready...",">more/index.html#(part._.Ready___)","Ready...",false],
["ready...",">quick/index.html#(part._.Ready___)","Ready...",false],
["real",">guide/numbers.html#(tech._real)","<i>real</i>",false],
["real numbers",">reference/numbers.html#(tech._real._number)","<i>real numbers</i>",false],
["real->decimal-string",">reference/numbers.html#(def._((lib._scheme/base..ss)._real-~3edecimal-string))",[0,[1,"real-&gt;decimal-string"]],["scheme/base","scheme"]],
["real->floating-point-bytes",">reference/numbers.html#(def._((quote._~23~25kernel)._real-~3efloating-point-bytes))",[0,[1,"real-&gt;floating-point-bytes"]],["scheme/base","scheme"]],
["real->flonum",">r6rs-lib-std/r6rs-lib-Z-H-12.html#node_idx_952",[0,[1,"real-&gt;flonum"]],["rnrs/arithmetic/flonums-6"]],
["real-in",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._real-in))",[0,[1,"real-in"]],["scheme/contract","scheme"]],
["real-part",">reference/numbers.html#(def._((quote._~23~25kernel)._real-part))",[0,[1,"real-part"]],["scheme/base","scheme"]],
["real-part",">r5rs-std/r5rs-Z-H-9.html#%_idx_352",[0,[1,"real-part"]],["r5rs"]],
["real-part",">r6rs-std/r6rs-Z-H-14.html#node_idx_570",[0,[1,"real-part"]],["rnrs/base-6"]],
["real-part",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._real-part))",[0,[1,"real-part"]],["lang/htdp-advanced"]],
["real-part",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._real-part))",[0,[1,"real-part"]],["lang/htdp-beginner"]],
["real-part",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._real-part))",[0,[1,"real-part"]],["lang/htdp-beginner-abbr"]],
["real-part",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._real-part))",[0,[1,"real-part"]],["lang/htdp-intermediate"]],
["real-part",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._real-part))",[0,[1,"real-part"]],["lang/htdp-intermediate-lambda"]],
["real-time",">mzlib/mzlib_compat.html#(def._((lib._mzlib/compat..ss)._real-time))",[0,[1,"real-time"]],["mzlib/compat"]],
["real-valued?",">r6rs-std/r6rs-Z-H-14.html#node_idx_450",[0,[1,"real-valued?"]],["rnrs/base-6"]],
["real?",">reference/numbers.html#(def._((quote._~23~25kernel)._real~3f))",[0,[1,"real?"]],["scheme/base","scheme"]],
["real?",">r5rs-std/r5rs-Z-H-9.html#%_idx_248",[0,[1,"real?"]],["r5rs"]],
["real?",">r6rs-std/r6rs-Z-H-14.html#node_idx_444",[0,[1,"real?"]],["rnrs/base-6"]],
["real?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._real~3f))",[0,[1,"real?"]],["lang/htdp-advanced"]],
["real?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._real~3f))",[0,[1,"real?"]],["lang/htdp-beginner"]],
["real?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._real~3f))",[0,[1,"real?"]],["lang/htdp-beginner-abbr"]],
["real?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._real~3f))",[0,[1,"real?"]],["lang/htdp-intermediate"]],
["real?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._real~3f))",[0,[1,"real?"]],["lang/htdp-intermediate-lambda"]],
["realign",">mrlib/aligned-pasteboard___.html#(meth._(((lib._mrlib/aligned-pasteboard..ss)._aligned-pasteboard~3c~25~3e)._realign))",[[0,[1,"realign"]],[12,[" (method of ",[0,[1,"aligned-pasteboard&lt;%&gt;"]],")"]]],["mrlib/aligned-pasteboard"]],
["rec",">mzlib/mzlib_etc.html#(form._((lib._mzlib/etc..ss)._rec))",[0,[6,"rec"]],["mzlib/etc"]],
["rec",">srfi-std/srfi-31.html#rec",[0,[6,"rec"]],["srfi/31"]],
["rec",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._.Rec))",[0,[6,"Rec"]],["typed-scheme"]],
["recalc-snips",">framework/Canvas.html#(meth._(((lib._framework/main..ss)._canvas~3awide-snip~3c~25~3e)._recalc-snips))",[[0,[1,"recalc-snips"]],[12,[" (method of ",[0,[1,"canvas:wide-snip&lt;%&gt;"]],")"]]],["framework"]],
["receive",">srfi-std/srfi-8.html#receive",[0,[6,"receive"]],["srfi/8"]],
["receiving logged events",">reference/logging.html#(part._.Receiving_.Logged_.Events)","Receiving Logged Events",false],
["record-accessor",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_336",[0,[1,"record-accessor"]],["rnrs/records/procedural-6"]],
["record-constructor",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_332",[0,[1,"record-constructor"]],["rnrs/records/procedural-6"]],
["record-constructor-descriptor",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_310",[0,[6,"record-constructor-descriptor"]],["rnrs/records/syntactic-6"]],
["record-field-mutable?",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_360",[0,[1,"record-field-mutable?"]],["rnrs/records/inspection-6"]],
["record-mutator",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_338",[0,[1,"record-mutator"]],["rnrs/records/procedural-6"]],
["record-predicate",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_334",[0,[1,"record-predicate"]],["rnrs/records/procedural-6"]],
["record-rtd",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_344",[0,[1,"record-rtd"]],["rnrs/records/inspection-6"]],
["record-type-descriptor",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_308",[0,[6,"record-type-descriptor"]],["rnrs/records/syntactic-6"]],
["record-type-descriptor?",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_320",[0,[1,"record-type-descriptor?"]],["rnrs/records/procedural-6"]],
["record-type-field-names",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_358",[0,[1,"record-type-field-names"]],["rnrs/records/inspection-6"]],
["record-type-generative?",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_352",[0,[1,"record-type-generative?"]],["rnrs/records/inspection-6"]],
["record-type-name",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_346",[0,[1,"record-type-name"]],["rnrs/records/inspection-6"]],
["record-type-opaque?",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_356",[0,[1,"record-type-opaque?"]],["rnrs/records/inspection-6"]],
["record-type-parent",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_348",[0,[1,"record-type-parent"]],["rnrs/records/inspection-6"]],
["record-type-sealed?",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_354",[0,[1,"record-type-sealed?"]],["rnrs/records/inspection-6"]],
["record-type-uid",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_350",[0,[1,"record-type-uid"]],["rnrs/records/inspection-6"]],
["record?",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_342",[0,[1,"record?"]],["rnrs/records/inspection-6"]],
["recounted",">gui/snip-admin_.html#(meth._(((lib._mred/main..ss)._snip-admin~25)._recounted))",[[0,[1,"recounted"]],[12,[" (method of ",[0,[1,"snip-admin%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["rectangle",">gui/dc-path_.html#(meth._(((lib._mred/main..ss)._dc-path~25)._rectangle))",[[0,[1,"rectangle"]],[12,[" (method of ",[0,[1,"dc-path%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["rectangle",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._rectangle))",[0,[1,"rectangle"]],["slideshow/pict","slideshow"]],
["rectangle",">teachpack/image.html#(def._((lib._htdp/image..ss)._rectangle))",[0,[1,"rectangle"]],["teachpack/htdp/image"]],
["rectangle",">teachpack/matrix.html#(tech._rectangle)","<i>Rectangle</i>",false],
["rectangle->matrix",">teachpack/matrix.html#(def._((lib._teachpack/htdp/matrix..ss)._rectangle-~3ematrix))",[0,[1,"rectangle-&gt;matrix"]],["teachpack/htdp/matrix"]],
["rectangles",">graphics/Draw__Clear__and_Flip_Operations.html#(part._.Rectangles)","Rectangles",false],
["recur",">htdp-langs/recur.html",[0,[6,"recur"]],false],
["recur",">htdp-langs/recur.html#(form._((lib._lang/htdp-advanced..ss)._recur))",[0,[6,"recur"]],["lang/htdp-advanced"]],
["recur",">mzlib/mzlib_etc.html#(form._((lib._mzlib/etc..ss)._recur))",[0,[6,"recur"]],["mzlib/etc"]],
["recursion versus iteration",">guide/Lists__Iteration__and_Recursion.html#(part._.Recursion_versus_.Iteration)","Recursion versus Iteration",false],
["recursive binding: letrec",">guide/let.html#(part._.Recursive_.Binding__letrec)",["Recursive Binding: ",[0,[6,"letrec"]]],false],
["recursive datatypes and unions",">typed-scheme/index.html#(part._.Recursive_.Datatypes_and_.Unions)","Recursive Datatypes and Unions",false],
["recursive-contract",">reference/Contract_Utilities.html#(form._((lib._scheme/private/contract..ss)._recursive-contract))",[0,[6,"recursive-contract"]],["scheme/contract","scheme"]],
["recycling icon",">drscheme/interface-essentials.html#(idx._(gentag._0._(lib._scribblings/drscheme/drscheme..scrbl)))","recycling icon",false],
["red",">gui/color_.html#(meth._(((lib._mred/main..ss)._color~25)._red))",[[0,[1,"red"]],[12,[" (method of ",[0,[1,"color%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["redex",">redex/index.html",[14,[0,"redex"]],"module"],
["redex",">reference/eval-model.html#(tech._redex)","<i>redex</i>",false],
["redex pattern variable-prefix",">redex/Patterns.html#(idx._(gentag._5._(lib._redex/redex..scrbl)))","Redex Pattern, variable-prefix",false],
["redex pattern variable-not-otherwise-mentioned",">redex/Patterns.html#(idx._(gentag._6._(lib._redex/redex..scrbl)))","Redex Pattern, variable-not-otherwise-mentioned",false],
["redex pattern variable-except",">redex/Patterns.html#(idx._(gentag._4._(lib._redex/redex..scrbl)))","Redex Pattern, variable-except",false],
["redex pattern variable",">redex/Patterns.html#(idx._(gentag._3._(lib._redex/redex..scrbl)))","Redex Pattern, variable",false],
["redex pattern symbol",">redex/Patterns.html#(idx._(gentag._8._(lib._redex/redex..scrbl)))","Redex Pattern, symbol",false],
["redex pattern string",">redex/Patterns.html#(idx._(gentag._2._(lib._redex/redex..scrbl)))","Redex Pattern, string",false],
["redex pattern side-condition",">redex/Patterns.html#(idx._(gentag._12._(lib._redex/redex..scrbl)))","Redex Pattern, side-condition",false],
["redex pattern pattern-sequence",">redex/Patterns.html#(idx._(gentag._14._(lib._redex/redex..scrbl)))","Redex Pattern, pattern-sequence",false],
["redex pattern number",">redex/Patterns.html#(idx._(gentag._1._(lib._redex/redex..scrbl)))","Redex Pattern, number",false],
["redex pattern name",">redex/Patterns.html#(idx._(gentag._9._(lib._redex/redex..scrbl)))","Redex Pattern, name",false],
["redex pattern in-hole",">redex/Patterns.html#(idx._(gentag._10._(lib._redex/redex..scrbl)))","Redex Pattern, in-hole",false],
["redex pattern hole",">redex/Patterns.html#(idx._(gentag._7._(lib._redex/redex..scrbl)))","Redex Pattern, hole",false],
["redex pattern hide-hole",">redex/Patterns.html#(idx._(gentag._11._(lib._redex/redex..scrbl)))","Redex Pattern, hide-hole",false],
["redex pattern cross",">redex/Patterns.html#(idx._(gentag._13._(lib._redex/redex..scrbl)))","Redex Pattern, cross",false],
["redex pattern any",">redex/Patterns.html#(idx._(gentag._0._(lib._redex/redex..scrbl)))","Redex Pattern, any",false],
["redex-match",">redex/Patterns.html#(form._((lib._redex/reduction-semantics..ss)._redex-match))",[0,[6,"redex-match"]],["redex/reduction-semantics"]],
["redex/gui",">redex/GUI.html",[14,[0,"redex/gui"]],"module"],
["redex/pict",">redex/Typesetting.html",[14,[0,"redex/pict"]],"module"],
["redex/reduction-semantics",">redex/Patterns.html",[14,[0,"redex/reduction-semantics"]],"module"],
["redex: debugging operational semantics",">redex/index.html","<b>Redex</b>: Debugging Operational Semantics",false],
["redirect-to",">web-server/helpers_ss.html#(def._((lib._web-server/servlet/helpers..ss)._redirect-to))",[0,[1,"redirect-to"]],["web-server/servlet/helpers"]],
["redirect/get",">continue/index.html#(def._((lib._web-server/servlet..ss)._redirect/get))",[0,[1,"redirect/get"]],[]],
["redirect/get",">web-server/lang_web-extras_ss.html#(def._((lib._web-server/lang/web-extras..ss)._redirect/get))",[0,[1,"redirect/get"]],["web-server/lang/web-extras"]],
["redirect/get",">web-server/web_ss.html#(def._((lib._web-server/servlet/web..ss)._redirect/get))",[0,[1,"redirect/get"]],["web-server/servlet/web"]],
["redirect/get/forget",">web-server/web_ss.html#(def._((lib._web-server/servlet/web..ss)._redirect/get/forget))",[0,[1,"redirect/get/forget"]],["web-server/servlet/web"]],
["redirection-status?",">web-server/helpers_ss.html#(def._((lib._web-server/servlet/helpers..ss)._redirection-status~3f))",[0,[1,"redirection-status?"]],["web-server/servlet/helpers"]],
["redo",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._redo))",[[0,[1,"redo"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["redo menu item",">drscheme/Menus.html#(idx._(gentag._77._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Redo</font></b> menu item",false],
["reduce",">srfi-std/srfi-1.html#reduce",[0,[1,"reduce"]],["srfi/1"]],
["reduce-right",">srfi-std/srfi-1.html#reduce-right",[0,[1,"reduce-right"]],["srfi/1"]],
["reduction relations",">redex/Reduction_Relations.html","Reduction Relations",false],
["reduction-relation",">redex/Reduction_Relations.html#(form._((lib._redex/main..ss)._reduction-relation))",[0,[6,"reduction-relation"]],["redex"]],
["reduction-relation->pict",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._reduction-relation-~3epict))",[0,[1,"reduction-relation-&gt;pict"]],["redex/pict"]],
["reduction-relation->rule-names",">redex/Reduction_Relations.html#(def._((lib._redex/main..ss)._reduction-relation-~3erule-names))",[0,[1,"reduction-relation-&gt;rule-names"]],["redex"]],
["reduction-relation-rule-separation",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._reduction-relation-rule-separation))",[0,[1,"reduction-relation-rule-separation"]],["redex/pict"]],
["reduction-relation?",">redex/Reduction_Relations.html#(def._((lib._redex/main..ss)._reduction-relation~3f))",[0,[1,"reduction-relation?"]],["redex"]],
["reduction-rule-style/c",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._reduction-rule-style/c))",[0,[1,"reduction-rule-style/c"]],["redex/pict"]],
["reduction-steps-cutoff",">redex/GUI.html#(def._((lib._redex/gui..ss)._reduction-steps-cutoff))",[0,[1,"reduction-steps-cutoff"]],["redex/gui"]],
["reencode-input-port",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._reencode-input-port))",[0,[1,"reencode-input-port"]],["scheme/port"]],
["reencode-output-port",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._reencode-output-port))",[0,[1,"reencode-output-port"]],["scheme/port"]],
["reference",">gui/Reference.html","Reference",false],
["reference: plt scheme",">reference/index.html","<b>Reference</b>: PLT Scheme",false],
["references",">gui/fontresources.html#(part._.References)","References",false],
["reflecting on primitives",">reference/procedures.html#(part._.Reflecting_on_.Primitives)","Reflecting on Primitives",false],
["reflection and dynamic evaluation",">guide/reflection.html","Reflection and Dynamic Evaluation",false],
["reflection and security",">reference/security.html","Reflection and Security",false],
["reflow-container",">gui/area-container___.html#(meth._(((lib._mred/main..ss)._area-container~3c~25~3e)._reflow-container))",[[0,[1,"reflow-container"]],[12,[" (method of ",[0,[1,"area-container&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["refocus",">slideshow/Bounding-Box_Adjusters.html#(def._((lib._slideshow/pict..ss)._refocus))",[0,[1,"refocus"]],["slideshow/pict","slideshow"]],
["refresh",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._refresh))",[[0,[1,"refresh"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["refresh",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._refresh))",[[0,[1,"refresh"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["refresh",">mysterx/browsers.html#(meth._(((lib._mysterx/main..ss)._mx-browser~25)._refresh))",[[0,[1,"refresh"]],[12,[" (method of ",[0,[1,"mx-browser%"]],")"]]],["mysterx"]],
["refresh-delayed?",">gui/editor-admin_.html#(meth._(((lib._mred/main..ss)._editor-admin~25)._refresh-delayed~3f))",[[0,[1,"refresh-delayed?"]],[12,[" (method of ",[0,[1,"editor-admin%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["refresh-delayed?",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._refresh-delayed~3f))",[[0,[1,"refresh-delayed?"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["regexp",">reference/regexp.html#(def._((quote._~23~25kernel)._regexp))",[0,[1,"regexp"]],["scheme/base","scheme"]],
["regexp",">guide/regexp.html#(tech._regexp)","<i>regexp</i>",false],
["regexp constructors",">reference/regexp.html#(part._.Regexp_.Constructors)","Regexp Constructors",false],
["regexp matching",">reference/regexp.html#(part._.Regexp_.Matching)","Regexp Matching",false],
["regexp splitting",">reference/regexp.html#(part._.Regexp_.Splitting)","Regexp Splitting",false],
["regexp substitution",">reference/regexp.html#(part._.Regexp_.Substitution)","Regexp Substitution",false],
["regexp syntax",">reference/regexp.html#(part._regexp-syntax)","Regexp Syntax",false],
["regexp-exec",">mzlib/mzlib_awk.html#(def._((lib._mzlib/awk..ss)._regexp-exec))",[0,[1,"regexp-exec"]],["mzlib/awk"]],
["regexp-match",">reference/regexp.html#(def._((quote._~23~25kernel)._regexp-match))",[0,[1,"regexp-match"]],["scheme/base","scheme"]],
["regexp-match*",">reference/regexp.html#(def._((lib._scheme/base..ss)._regexp-match*))",[0,[1,"regexp-match*"]],["scheme/base","scheme"]],
["regexp-match-evt",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._regexp-match-evt))",[0,[1,"regexp-match-evt"]],["scheme/port"]],
["regexp-match-exact?",">reference/regexp.html#(def._((lib._scheme/base..ss)._regexp-match-exact~3f))",[0,[1,"regexp-match-exact?"]],["scheme/base","scheme"]],
["regexp-match-peek",">reference/regexp.html#(def._((quote._~23~25kernel)._regexp-match-peek))",[0,[1,"regexp-match-peek"]],["scheme/base","scheme"]],
["regexp-match-peek-immediate",">reference/regexp.html#(def._((quote._~23~25kernel)._regexp-match-peek-immediate))",[0,[1,"regexp-match-peek-immediate"]],["scheme/base","scheme"]],
["regexp-match-peek-positions",">reference/regexp.html#(def._((quote._~23~25kernel)._regexp-match-peek-positions))",[0,[1,"regexp-match-peek-positions"]],["scheme/base","scheme"]],
["regexp-match-peek-positions*",">reference/regexp.html#(def._((lib._scheme/base..ss)._regexp-match-peek-positions*))",[0,[1,"regexp-match-peek-positions*"]],["scheme/base","scheme"]],
["regexp-match-peek-positions-immediate",">reference/regexp.html#(def._((quote._~23~25kernel)._regexp-match-peek-positions-immediate))",[0,[1,"regexp-match-peek-positions-immediate"]],["scheme/base","scheme"]],
["regexp-match-positions",">reference/regexp.html#(def._((quote._~23~25kernel)._regexp-match-positions))",[0,[1,"regexp-match-positions"]],["scheme/base","scheme"]],
["regexp-match-positions*",">reference/regexp.html#(def._((lib._scheme/base..ss)._regexp-match-positions*))",[0,[1,"regexp-match-positions*"]],["scheme/base","scheme"]],
["regexp-match?",">reference/regexp.html#(def._((quote._~23~25kernel)._regexp-match~3f))",[0,[1,"regexp-match?"]],["scheme/base","scheme"]],
["regexp-quote",">reference/regexp.html#(def._((lib._scheme/base..ss)._regexp-quote))",[0,[1,"regexp-quote"]],["scheme/base","scheme"]],
["regexp-replace",">reference/regexp.html#(def._((quote._~23~25kernel)._regexp-replace))",[0,[1,"regexp-replace"]],["scheme/base","scheme"]],
["regexp-replace*",">reference/regexp.html#(def._((quote._~23~25kernel)._regexp-replace*))",[0,[1,"regexp-replace*"]],["scheme/base","scheme"]],
["regexp-replace-quote",">reference/regexp.html#(def._((lib._scheme/base..ss)._regexp-replace-quote))",[0,[1,"regexp-replace-quote"]],["scheme/base","scheme"]],
["regexp-replaces",">foreign/Miscellaneous_Support.html#(def._((lib._scheme/foreign..ss)._regexp-replaces))",[0,[1,"regexp-replaces"]],["scheme/foreign"]],
["regexp-split",">reference/regexp.html#(def._((lib._scheme/base..ss)._regexp-split))",[0,[1,"regexp-split"]],["scheme/base","scheme"]],
["regexp-try-match",">reference/regexp.html#(def._((lib._scheme/base..ss)._regexp-try-match))",[0,[1,"regexp-try-match"]],["scheme/base","scheme"]],
["regexp?",">reference/regexp.html#(def._((quote._~23~25kernel)._regexp~3f))",[0,[1,"regexp?"]],["scheme/base","scheme"]],
["regexps",">reference/regexp.html","regexps",false],
["region",">cards/index.html#(def._((lib._games/cards..ss)._region))",[0,[1,"region"]],["games/cards"]],
["region%",">gui/region_.html",[0,[1,"region%"]],["scheme/gui/base","scheme/gui"]],
["region-callback",">cards/index.html#(def._((lib._games/cards..ss)._region-callback))",[0,[1,"region-callback"]],["games/cards"]],
["region-h",">cards/index.html#(def._((lib._games/cards..ss)._region-h))",[0,[1,"region-h"]],["games/cards"]],
["region-interactive-callback",">cards/index.html#(def._((lib._games/cards..ss)._region-interactive-callback))",[0,[1,"region-interactive-callback"]],["games/cards"]],
["region-label",">cards/index.html#(def._((lib._games/cards..ss)._region-label))",[0,[1,"region-label"]],["games/cards"]],
["region-w",">cards/index.html#(def._((lib._games/cards..ss)._region-w))",[0,[1,"region-w"]],["games/cards"]],
["region-x",">cards/index.html#(def._((lib._games/cards..ss)._region-x))",[0,[1,"region-x"]],["games/cards"]],
["region-y",">cards/index.html#(def._((lib._games/cards..ss)._region-y))",[0,[1,"region-y"]],["games/cards"]],
["region?",">cards/index.html#(def._((lib._games/cards..ss)._region~3f))",[0,[1,"region?"]],["games/cards"]],
["regions and buttons",">cards/index.html#(part._.Regions_and_.Buttons)","Regions and Buttons",false],
["register-capability-menu-item",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~3c~25~3e)._register-capability-menu-item))",[[0,[1,"register-capability-menu-item"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["register-collecting-blit",">gui/Drawing_Functions.html#(def._((lib._mred/main..ss)._register-collecting-blit))",[0,[1,"register-collecting-blit"]],["scheme/gui/base","scheme/gui"]],
["register-event-handler",">mysterx/browsers.html#(meth._(((lib._mysterx/main..ss)._mx-browser~25)._register-event-handler))",[[0,[1,"register-event-handler"]],[12,[" (method of ",[0,[1,"mx-browser%"]],")"]]],["mysterx"]],
["register-external-file",">mzc/make.html#(def._((lib._compiler/cm-accomplice..ss)._register-external-file))",[0,[1,"register-external-file"]],["compiler/cm-accomplice"]],
["register-finalizer",">foreign/foreign_pointer-funcs.html#(def._((lib._scribblings/foreign/unsafe-foreign..ss)._register-finalizer))",[0,[1,"register-finalizer"]],["scribblings/foreign/unsafe-foreign"]],
["register-lib-mapping!",">gui/WXME_Decoding.html#(def._((lib._wxme/main..ss)._register-lib-mapping!))",[0,[1,"register-lib-mapping!"]],["wxme"]],
["register-profile-done",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..ss)._stacktrace-imports~5e._register-profile-done))",[0,[1,"register-profile-done"]],["errortrace/stacktrace"]],
["register-profile-start",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..ss)._stacktrace-imports~5e._register-profile-start))",[0,[1,"register-profile-start"]],["errortrace/stacktrace"]],
["register-toolbar-button",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~3c~25~3e)._register-toolbar-button))",[[0,[1,"register-toolbar-button"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["registry",">gui/Windowing_Functions.html#(idx._(gentag._153._(lib._scribblings/gui/gui..scrbl)))","registry",false],
["regular expressions",">guide/regexp.html","Regular Expressions",false],
["regular expressions",">reference/regexp.html","Regular Expressions",false],
["regular expressions",">reference/regexp.html#(tech._regular._expression)","<i>Regular expressions</i>",false],
["regular-poly",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..ss)._regular-poly))",[0,[1,"regular-poly"]],["graphics/turtle-examples"]],
["regular-polygon",">teachpack/image.html#(def._((lib._htdp/image..ss)._regular-polygon))",[0,[1,"regular-polygon"]],["teachpack/htdp/image"]],
["regular-polys",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..ss)._regular-polys))",[0,[1,"regular-polys"]],["graphics/turtle-examples"]],
["reindent all menu item",">drscheme/Menus.html#(idx._(gentag._126._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Reindent All</font></b> menu item",false],
["reindent menu item",">drscheme/Menus.html#(idx._(gentag._125._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Reindent</font></b> menu item",false],
["related web sites menu item",">drscheme/Menus.html#(idx._(gentag._147._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Related Web Sites</font></b> menu item",false],
["relative",">reference/Manipulating_Paths.html#(idx._(gentag._214._(lib._scribblings/reference/reference..scrbl)))",[7,"'relative"],false],
["relative-path?",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._relative-path~3f))",[0,[1,"relative-path?"]],["scheme/base","scheme"]],
["release",">gui/key-event_.html#(idx._(gentag._115._(lib._scribblings/gui/gui..scrbl)))",[7,"'release"],false],
["release notes",">release/index.html","Release Notes",false],
["release-from-owner",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._release-from-owner))",[[0,[1,"release-from-owner"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["release-snip",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._release-snip))",[[0,[1,"release-snip"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["release-snip",">gui/snip-admin_.html#(meth._(((lib._mred/main..ss)._snip-admin~25)._release-snip))",[[0,[1,"release-snip"]],[12,[" (method of ",[0,[1,"snip-admin%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["reload",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-panel-mixin)._reload))",[[0,[1,"reload"]],[12,[" (method of ",[0,[1,"hyper-panel-mixin"]],")"]]],["browser"]],
["reload",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-text-mixin)._reload))",[[0,[1,"reload"]],[12,[" (method of ",[0,[1,"hyper-text-mixin"]],")"]]],["browser"]],
["relocate-input-port",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._relocate-input-port))",[0,[1,"relocate-input-port"]],["scheme/port"]],
["relocate-output-port",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._relocate-output-port))",[0,[1,"relocate-output-port"]],["scheme/port"]],
["remainder",">reference/numbers.html#(def._((quote._~23~25kernel)._remainder))",[0,[1,"remainder"]],["scheme/base","scheme"]],
["remainder",">r5rs-std/r5rs-Z-H-9.html#%_idx_302",[0,[1,"remainder"]],["r5rs"]],
["remainder",">r6rs-lib-std/r6rs-lib-Z-H-20.html#node_idx_1292",[0,[1,"remainder"]],["rnrs/r5rs-6"]],
["remainder",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._remainder))",[0,[1,"remainder"]],["lang/htdp-advanced"]],
["remainder",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._remainder))",[0,[1,"remainder"]],["lang/htdp-beginner"]],
["remainder",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._remainder))",[0,[1,"remainder"]],["lang/htdp-beginner-abbr"]],
["remainder",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._remainder))",[0,[1,"remainder"]],["lang/htdp-intermediate"]],
["remainder",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._remainder))",[0,[1,"remainder"]],["lang/htdp-intermediate-lambda"]],
["remap-url",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-text-mixin)._remap-url))",[[0,[1,"remap-url"]],[12,[" (method of ",[0,[1,"hyper-text-mixin"]],")"]]],["browser"]],
["remote com servers (dcom)",">mysterx/overview.html#(part._remote)","Remote COM servers (DCOM)",false],
["remove",">planet/cmdline.html#(part._remove)",[5,"remove"],false],
["remove",">reference/pairs.html#(def._((lib._scheme/base..ss)._remove))",[0,[1,"remove"]],["scheme/base","scheme"]],
["remove",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._remove))",[[0,[1,"remove"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["remove",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_218",[0,[1,"remove"]],["rnrs/lists-6"]],
["remove",">lazy/index.html#(def._((lib._lazy/main..ss)._remove))",[0,[1,"remove"]],["lazy"]],
["remove",">srfi-std/srfi-1.html#remove",[0,[1,"remove"]],["srfi/1"]],
["remove!",">srfi-std/srfi-1.html#remove!",[0,[1,"remove!"]],["srfi/1"]],
["remove*",">reference/pairs.html#(def._((lib._scheme/base..ss)._remove*))",[0,[1,"remove*"]],["scheme/base","scheme"]],
["remove*",">lazy/index.html#(def._((lib._lazy/main..ss)._remove*))",[0,[1,"remove*"]],["lazy"]],
["remove-autosave",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abackup-autosave~3c~25~3e)._remove-autosave))",[[0,[1,"remove-autosave"]],[12,[" (method of ",[0,[1,"editor:backup-autosave&lt;%&gt;"]],")"]]],["framework"]],
["remove-boundary",">gui/editor-stream-in_.html#(meth._(((lib._mred/main..ss)._editor-stream-in~25)._remove-boundary))",[[0,[1,"remove-boundary"]],[12,[" (method of ",[0,[1,"editor-stream-in%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["remove-canvas",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._remove-canvas))",[[0,[1,"remove-canvas"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["remove-card",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._remove-card))",[[0,[1,"remove-card"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["remove-cards",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._remove-cards))",[[0,[1,"remove-cards"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["remove-chained-keymap",">gui/keymap_.html#(meth._(((lib._mred/main..ss)._keymap~25)._remove-chained-keymap))",[[0,[1,"remove-chained-keymap"]],[12,[" (method of ",[0,[1,"keymap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["remove-chained-keymap",">framework/Keymap.html#(meth._(((lib._framework/main..ss)._keymap~3aaug-keymap-mixin)._remove-chained-keymap))",[[0,[1,"remove-chained-keymap"]],[12,[" (method of ",[0,[1,"keymap:aug-keymap-mixin"]],")"]]],["framework"]],
["remove-child",">mrlib/graph-snip___.html#(meth._(((lib._mrlib/graph..ss)._graph-snip~3c~25~3e)._remove-child))",[[0,[1,"remove-child"]],[12,[" (method of ",[0,[1,"graph-snip&lt;%&gt;"]],")"]]],["mrlib/graph"]],
["remove-clickback",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._remove-clickback))",[[0,[1,"remove-clickback"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["remove-duplicates",">reference/pairs.html#(def._((lib._scheme/list..ss)._remove-duplicates))",[0,[1,"remove-duplicates"]],["scheme/list","scheme"]],
["remove-field",">net/head.html#(def._((lib._net/head..ss)._remove-field))",[0,[1,"remove-field"]],["net/head"]],
["remove-frame",">framework/Group.html#(meth._(((lib._framework/main..ss)._group~3a~25)._remove-frame))",[[0,[1,"remove-frame"]],[12,[" (method of ",[0,[1,"group:%"]],")"]]],["framework"]],
["remove-grab-key-function",">gui/keymap_.html#(meth._(((lib._mred/main..ss)._keymap~25)._remove-grab-key-function))",[[0,[1,"remove-grab-key-function"]],[12,[" (method of ",[0,[1,"keymap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["remove-grab-mouse-function",">gui/keymap_.html#(meth._(((lib._mred/main..ss)._keymap~25)._remove-grab-mouse-function))",[[0,[1,"remove-grab-mouse-function"]],[12,[" (method of ",[0,[1,"keymap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["remove-hard-link",">planet/Utility_Libraries.html#(def._((lib._planet/util..ss)._remove-hard-link))",[0,[1,"remove-hard-link"]],["planet/util"]],
["remove-heads-up",">gl-board-game/index.html#(meth._(((lib._games/gl-board-game..ss)._gl-board~25)._remove-heads-up))",[[0,[1,"remove-heads-up"]],[12,[" (method of ",[0,[1,"gl-board%"]],")"]]],["games/gl-board-game"]],
["remove-parens-forward",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._remove-parens-forward))",[[0,[1,"remove-parens-forward"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["remove-parent",">mrlib/graph-snip___.html#(meth._(((lib._mrlib/graph..ss)._graph-snip~3c~25~3e)._remove-parent))",[[0,[1,"remove-parent"]],[12,[" (method of ",[0,[1,"graph-snip&lt;%&gt;"]],")"]]],["mrlib/graph"]],
["remove-piece",">gl-board-game/index.html#(meth._(((lib._games/gl-board-game..ss)._gl-board~25)._remove-piece))",[[0,[1,"remove-piece"]],[12,[" (method of ",[0,[1,"gl-board%"]],")"]]],["games/gl-board-game"]],
["remove-pkg",">planet/Utility_Libraries.html#(def._((lib._planet/util..ss)._remove-pkg))",[0,[1,"remove-pkg"]],["planet/util"]],
["remove-region",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._remove-region))",[[0,[1,"remove-region"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["remove-selected",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._remove-selected))",[[0,[1,"remove-selected"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["remove-sexp",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._remove-sexp))",[[0,[1,"remove-sexp"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["remove-space",">framework/Keymap.html#(idx._(gentag._18._(lib._scribblings/framework/framework..scrbl)))","remove-space",false],
["remove-tag",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-text-mixin)._remove-tag))",[[0,[1,"remove-tag"]],[12,[" (method of ",[0,[1,"hyper-text-mixin"]],")"]]],["browser"]],
["removing the pink background from plt redex rendered picts and ps files",">redex/Typesetting.html#(tech._removing._the._pink._background._from._plt._redex._rendered._picts._and._ps._file)","<i>Removing the pink background from PLT Redex rendered picts and ps files</i>",false],
["remp",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_216",[0,[1,"remp"]],["rnrs/lists-6"]],
["remq",">reference/pairs.html#(def._((lib._scheme/base..ss)._remq))",[0,[1,"remq"]],["scheme/base","scheme"]],
["remq",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_222",[0,[1,"remq"]],["rnrs/lists-6"]],
["remq",">lazy/index.html#(def._((lib._lazy/main..ss)._remq))",[0,[1,"remq"]],["lazy"]],
["remq*",">reference/pairs.html#(def._((lib._scheme/base..ss)._remq*))",[0,[1,"remq*"]],["scheme/base","scheme"]],
["remq*",">lazy/index.html#(def._((lib._lazy/main..ss)._remq*))",[0,[1,"remq*"]],["lazy"]],
["remv",">reference/pairs.html#(def._((lib._scheme/base..ss)._remv))",[0,[1,"remv"]],["scheme/base","scheme"]],
["remv",">r6rs-lib-std/r6rs-lib-Z-H-4.html#node_idx_220",[0,[1,"remv"]],["rnrs/lists-6"]],
["remv",">lazy/index.html#(def._((lib._lazy/main..ss)._remv))",[0,[1,"remv"]],["lazy"]],
["remv*",">reference/pairs.html#(def._((lib._scheme/base..ss)._remv*))",[0,[1,"remv*"]],["scheme/base","scheme"]],
["remv*",">lazy/index.html#(def._((lib._lazy/main..ss)._remv*))",[0,[1,"remv*"]],["lazy"]],
["rename",">reference/creatingunits.html#(form._((lib._mzlib/unit..ss)._rename))",[0,[6,"rename"]],["scheme/unit","scheme"]],
["rename transformer",">reference/syntax-model.html#(tech._rename._transformer)","<i>rename transformer</i>",false],
["rename-file-or-directory",">reference/Filesystem.html#(def._((quote._~23~25kernel)._rename-file-or-directory))",[0,[1,"rename-file-or-directory"]],["scheme/base","scheme"]],
["rename-in",">reference/require.html#(form._((lib._scheme/base..ss)._rename-in))",[0,[6,"rename-in"]],["scheme/base","scheme"]],
["rename-inner",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._rename-inner))",[0,[6,"rename-inner"]],["scheme/class","scheme"]],
["rename-out",">reference/require.html#(form._((lib._scheme/base..ss)._rename-out))",[0,[6,"rename-out"]],["scheme/base","scheme"]],
["rename-super",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._rename-super))",[0,[6,"rename-super"]],["scheme/class","scheme"]],
["rename-transformer-target",">reference/stxtrans.html#(def._((quote._~23~25kernel)._rename-transformer-target))",[0,[1,"rename-transformer-target"]],["scheme/base","scheme"]],
["rename-transformer?",">reference/stxtrans.html#(def._((quote._~23~25kernel)._rename-transformer~3f))",[0,[1,"rename-transformer?"]],["scheme/base","scheme"]],
["render",">scribble/renderer.html#(meth._(((lib._scribble/base-render..ss)._render~25)._render))",[[0,[1,"render"]],[12,[" (method of ",[0,[1,"render%"]],")"]]],["scribble/base-render"]],
["render pass",">scribble/struct.html#(tech._render._pas)","<i>render pass</i>",false],
["render%",">scribble/renderer.html#(def._((lib._scribble/base-render..ss)._render~25))",[0,[1,"render%"]],["scribble/base-render"]],
["render-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._render-element))",[0,[1,"render-element"]],["scribble/struct"]],
["render-element-render",">scribble/struct.html#(def._((lib._scribble/struct..ss)._render-element-render))",[0,[1,"render-element-render"]],["scribble/struct"]],
["render-element?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._render-element~3f))",[0,[1,"render-element?"]],["scribble/struct"]],
["render-html-to-text",">browser/index.html#(def._((lib._browser/htmltext..ss)._render-html-to-text))",[0,[1,"render-html-to-text"]],["browser/htmltext"]],
["render-language",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._render-language))",[0,[1,"render-language"]],["redex/pict"]],
["render-language-nts",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._render-language-nts))",[0,[1,"render-language-nts"]],["redex/pict"]],
["render-lw",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._render-lw))",[0,[1,"render-lw"]],["redex/pict"]],
["render-metafunction",">redex/Typesetting.html#(form._((lib._redex/pict..ss)._render-metafunction))",[0,[6,"render-metafunction"]],["redex/pict"]],
["render-mixin",">scribble/renderer.html#(def._((lib._scribble/html-render..ss)._render-mixin))",[0,[1,"render-mixin"]],["scribble/html-render"]],
["render-mixin",">scribble/renderer.html#(def._((lib._scribble/latex-render..ss)._render-mixin))",[0,[1,"render-mixin"]],["scribble/latex-render"]],
["render-mixin",">scribble/renderer.html#(def._((lib._scribble/text-render..ss)._render-mixin))",[0,[1,"render-mixin"]],["scribble/text-render"]],
["render-multi-mixin",">scribble/renderer.html#(def._((lib._scribble/html-render..ss)._render-multi-mixin))",[0,[1,"render-multi-mixin"]],["scribble/html-render"]],
["render-post",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-1..ss)._render-post))",[0,"render-post"],[]],
["render-posts",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-1..ss)._render-posts))",[0,"render-posts"],[]],
["render-reduction-relation",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._render-reduction-relation))",[0,[1,"render-reduction-relation"]],["redex/pict"]],
["render-reduction-relation-rules",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._render-reduction-relation-rules))",[0,[1,"render-reduction-relation-rules"]],["redex/pict"]],
["render-value",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e)._render-value))",[[0,[1,"render-value"]],[12,[" (method of ",[0,[1,"drscheme:language:language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["render-value",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3amodule-based-language~3c~25~3e)._render-value))",[[0,[1,"render-value"]],[12,[" (method of ",[0,[1,"drscheme:language:module-based-language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["render-value",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-module-based-language-~3emodule-based-language-mixin)._render-value))",[[0,[1,"render-value"]],[12,[" (method of ",[0,[1,"drscheme:language:simple-module-based-language-&gt;module-based-language-mixin"]],")"]]],["drscheme/tool-lib"]],
["render-value/format",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e)._render-value/format))",[[0,[1,"render-value/format"]],[12,[" (method of ",[0,[1,"drscheme:language:language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["render-value/format",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3amodule-based-language~3c~25~3e)._render-value/format))",[[0,[1,"render-value/format"]],[12,[" (method of ",[0,[1,"drscheme:language:module-based-language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["render-value/format",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-module-based-language-~3emodule-based-language-mixin)._render-value/format))",[[0,[1,"render-value/format"]],[12,[" (method of ",[0,[1,"drscheme:language:simple-module-based-language-&gt;module-based-language-mixin"]],")"]]],["drscheme/tool-lib"]],
["renderer",">scribble/renderer.html","Renderer",false],
["rendering",">slideshow/Rendering.html","Rendering",false],
["rendering html",">continue/index.html#(part._.Rendering_.H.T.M.L)","Rendering HTML",false],
["rendering syntax objects with formatting",">syntax/syntax-helpers.html#(part._to-string)","Rendering Syntax Objects with Formatting",false],
["repl",">guide/intro.html#(tech._repl)","<i>REPL</i>",false],
["repl",">reference/Evaluation_and_Compilation.html#(tech._repl)","<i>REPL</i>",false],
["replace",">reference/file-ports.html#(idx._(gentag._108._(lib._scribblings/reference/reference..scrbl)))",[7,"'replace"],false],
["replace & find again backwards menu item",">drscheme/Menus.html#(idx._(gentag._89._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Replace &amp; Find Again Backwards</font></b> menu item",false],
["replace & find again menu item",">drscheme/Menus.html#(idx._(gentag._88._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Replace &amp; Find Again</font></b> menu item",false],
["replace all menu item",">drscheme/Menus.html#(idx._(gentag._90._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Replace All</font></b> menu item",false],
["replace-all",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable~3c~25~3e)._replace-all))",[[0,[1,"replace-all"]],[12,[" (method of ",[0,[1,"frame:searchable&lt;%&gt;"]],")"]]],["framework"]],
["replace-html",">mysterx/documents.html#(meth._(((lib._mysterx/main..ss)._mx-document~3c~25~3e)._replace-html))",[[0,[1,"replace-html"]],[12,[" (method of ",[0,[1,"mx-document&lt;%&gt;"]],")"]]],["mysterx"]],
["replace-html",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._replace-html))",[[0,[1,"replace-html"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["replace-named-style",">gui/style-list_.html#(meth._(((lib._mred/main..ss)._style-list~25)._replace-named-style))",[[0,[1,"replace-named-style"]],[12,[" (method of ",[0,[1,"style-list%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["replaces-field",">net/head.html#(def._((lib._net/head..ss)._replaces-field))",[0,"replaces-field"],["net/head"]],
["reprovided api",">web-server/reprovided.html","Reprovided API",false],
["request",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._request))",[0,[1,"request"]],["web-server/private/request-structs"]],
["request bindings",">web-server/bindings_ss.html","Request Bindings",false],
["request->servlet-url",">web-server/servlet-url_ss.html#(def._((lib._web-server/servlet/servlet-url..ss)._request-~3eservlet-url))",[0,[1,"request-&gt;servlet-url"]],["web-server/servlet/servlet-url"]],
["request-bindings",">continue/index.html#(def._((lib._web-server/servlet..ss)._request-bindings))",[0,[1,"request-bindings"]],[]],
["request-bindings",">web-server/bindings_ss.html#(def._((lib._web-server/servlet/bindings..ss)._request-bindings))",[0,[1,"request-bindings"]],["web-server/servlet/bindings"]],
["request-bindings/raw",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._request-bindings/raw))",[0,[1,"request-bindings/raw"]],["web-server/private/request-structs"]],
["request-client-ip",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._request-client-ip))",[0,[1,"request-client-ip"]],["web-server/private/request-structs"]],
["request-headers",">web-server/bindings_ss.html#(def._((lib._web-server/servlet/bindings..ss)._request-headers))",[0,[1,"request-headers"]],["web-server/servlet/bindings"]],
["request-headers/raw",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._request-headers/raw))",[0,[1,"request-headers/raw"]],["web-server/private/request-structs"]],
["request-host-ip",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._request-host-ip))",[0,[1,"request-host-ip"]],["web-server/private/request-structs"]],
["request-host-port",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._request-host-port))",[0,[1,"request-host-port"]],["web-server/private/request-structs"]],
["request-method",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._request-method))",[0,[1,"request-method"]],["web-server/private/request-structs"]],
["request-post-data/raw",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._request-post-data/raw))",[0,[1,"request-post-data/raw"]],["web-server/private/request-structs"]],
["request-uri",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._request-uri))",[0,[1,"request-uri"]],["web-server/private/request-structs"]],
["request?",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._request~3f))",[0,[1,"request?"]],["web-server/private/request-structs"]],
["requested minimum height",">gui/windowing-overview.html#(tech._requested._minimum._height)","<i>requested minimum height</i>",false],
["requested minimum size",">gui/windowing-overview.html#(tech._requested._minimum._size)","<i>requested minimum size</i>",false],
["requested minimum width",">gui/windowing-overview.html#(tech._requested._minimum._width)","<i>requested minimum width</i>",false],
["require",">typed-scheme/index.html#(part._.Require)","Require",false],
["require",">htdp-langs/require.html",[0,[6,"require"]],false],
["require",">reference/require.html#(form._((lib._scheme/base..ss)._require))",[0,[6,"require"]],["scheme/base","scheme"]],
["require",">htdp-langs/advanced-unchanged.html#(form._((lib._lang/htdp-advanced..ss)._require))",[0,[6,"require"]],["lang/htdp-advanced"]],
["require",">htdp-langs/require.html#(form._((lib._lang/htdp-beginner..ss)._require))",[0,[6,"require"]],["lang/htdp-beginner"]],
["require",">htdp-langs/Unchanged_Forms.html#(form._((lib._lang/htdp-beginner-abbr..ss)._require))",[0,[6,"require"]],["lang/htdp-beginner-abbr"]],
["require",">htdp-langs/intermediate-unchanged.html#(form._((lib._lang/htdp-intermediate..ss)._require))",[0,[6,"require"]],["lang/htdp-intermediate"]],
["require",">htdp-langs/intermediate-lambda-unchanged.html#(form._((lib._lang/htdp-intermediate-lambda..ss)._require))",[0,[6,"require"]],["lang/htdp-intermediate-lambda"]],
["require",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..ss)._require))",[0,[6,"require"]],["mzscheme"]],
["require macros",">reference/define.html#(part._require-syntax)",[[0,[6,"require"]]," Macros"],false],
["require transformer",">reference/stxtrans.html#(tech._require._transformer)","<i>require transformer</i>",false],
["require transformers",">reference/stxtrans.html#(part._require-trans)",[[0,[6,"require"]]," Transformers"],false],
["require-for-label",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..ss)._require-for-label))",[0,[6,"require-for-label"]],["mzscheme"]],
["require-for-syntax",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..ss)._require-for-syntax))",[0,[6,"require-for-syntax"]],["mzscheme"]],
["require-for-template",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..ss)._require-for-template))",[0,[6,"require-for-template"]],["mzscheme"]],
["require-transformer?",">reference/stxtrans.html#(def._((lib._scheme/require-transform..ss)._require-transformer~3f))",[0,[1,"require-transformer?"]],["scheme/require-transform"]],
["require-typed-struct",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._require-typed-struct))",[0,[6,"require-typed-struct"]],["typed-scheme"]],
["require/opaque-type",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._require/opaque-type))",[0,[6,"require/opaque-type"]],["typed-scheme"]],
["require/typed",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._require/typed))",[0,[6,"require/typed"]],["typed-scheme"]],
["required arguments",">mzlib/mzlib_kw.html#(part._.Required_.Arguments)","Required Arguments",false],
["reset",">reference/cont.html#(form._((lib._scheme/control..ss)._reset))",[0,[6,"reset"]],["scheme/control"]],
["reset",">gui/dc-path_.html#(meth._(((lib._mred/main..ss)._dc-path~25)._reset))",[[0,[1,"reset"]],[12,[" (method of ",[0,[1,"dc-path%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["reset com method",">mzcom/index.html#(idx._(gentag._2._(lib._mzcom/mzcom..scrbl)))",[[5,"Reset"]," COM method"],false],
["reset-at",">reference/cont.html#(form._((lib._scheme/control..ss)._reset-at))",[0,[6,"reset-at"]],["scheme/control"]],
["reset-console",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3atext~25)._reset-console))",[[0,[1,"reset-console"]],[12,[" (method of ",[0,[1,"drscheme:rep:text%"]],")"]]],["drscheme/tool-lib"]],
["reset-highlighting",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3atext~25)._reset-highlighting))",[[0,[1,"reset-highlighting"]],[12,[" (method of ",[0,[1,"drscheme:rep:text%"]],")"]]],["drscheme/tool-lib"]],
["reset-input-box",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._reset-input-box))",[[0,[1,"reset-input-box"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["reset-min-sizes",">framework/editor-snip.html#(meth._(((lib._framework/main..ss)._editor-snip~3adecorated~3c~25~3e)._reset-min-sizes))",[[0,[1,"reset-min-sizes"]],[12,[" (method of ",[0,[1,"editor-snip:decorated&lt;%&gt;"]],")"]]],["framework"]],
["reset-offer-kill",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3acontext~3c~25~3e)._reset-offer-kill))",[[0,[1,"reset-offer-kill"]],[12,[" (method of ",[0,[1,"drscheme:rep:context&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["reset-offer-kill",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3atab~3c~25~3e)._reset-offer-kill))",[[0,[1,"reset-offer-kill"]],[12,[" (method of ",[0,[1,"drscheme:unit:tab&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["reset-region",">framework/Color.html#(meth._(((lib._framework/main..ss)._color~3atext~3c~25~3e)._reset-region))",[[0,[1,"reset-region"]],[12,[" (method of ",[0,[1,"color:text&lt;%&gt;"]],")"]]],["framework"]],
["reset-regions",">framework/Color.html#(meth._(((lib._framework/main..ss)._color~3atext~3c~25~3e)._reset-regions))",[[0,[1,"reset-regions"]],[12,[" (method of ",[0,[1,"color:text&lt;%&gt;"]],")"]]],["framework"]],
["reset-relevant-directories-state!",">setup-plt/getinfo.html#(def._((lib._setup/getinfo..ss)._reset-relevant-directories-state!))",[0,[1,"reset-relevant-directories-state!"]],["setup/getinfo"]],
["reset-timer!",">web-server/timer_ss.html#(def._((lib._web-server/private/timer..ss)._reset-timer!))",[0,[1,"reset-timer!"]],["web-server/private/timer"]],
["reset0",">reference/cont.html#(form._((lib._scheme/control..ss)._reset0))",[0,[6,"reset0"]],["scheme/control"]],
["reset0-at",">reference/cont.html#(form._((lib._scheme/control..ss)._reset0-at))",[0,[6,"reset0-at"]],["scheme/control"]],
["resize",">gui/editor-snip_.html#(meth._(((lib._mred/main..ss)._editor-snip~25)._resize))",[[0,[1,"resize"]],[12,[" (method of ",[0,[1,"editor-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["resize",">gui/image-snip_.html#(meth._(((lib._mred/main..ss)._image-snip~25)._resize))",[[0,[1,"resize"]],[12,[" (method of ",[0,[1,"image-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["resize",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._resize))",[[0,[1,"resize"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["resize",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._resize))",[[0,[1,"resize"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["resize",">gui/top-level-window___.html#(meth._(((lib._mred/main..ss)._top-level-window~3c~25~3e)._resize))",[[0,[1,"resize"]],[12,[" (method of ",[0,[1,"top-level-window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["resized",">gui/editor-admin_.html#(meth._(((lib._mred/main..ss)._editor-admin~25)._resized))",[[0,[1,"resized"]],[12,[" (method of ",[0,[1,"editor-admin%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["resized",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._resized))",[[0,[1,"resized"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["resized",">gui/snip-admin_.html#(meth._(((lib._mred/main..ss)._snip-admin~25)._resized))",[[0,[1,"resized"]],[12,[" (method of ",[0,[1,"snip-admin%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["resized",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3adelegate-mixin)._resized))",[[0,[1,"resized"]],[12,[" (method of ",[0,[1,"text:delegate-mixin"]],")"]]],["framework"]],
["resized",">mrlib/horizontal-pasteboard_.html#(meth._(((lib._mrlib/aligned-pasteboard..ss)._horizontal-pasteboard~25)._resized))",[[0,[1,"resized"]],[12,[" (method of ",[0,[1,"horizontal-pasteboard%"]],")"]]],["mrlib/aligned-pasteboard"]],
["resized",">mrlib/vertical-pasteboard_.html#(meth._(((lib._mrlib/aligned-pasteboard..ss)._vertical-pasteboard~25)._resized))",[[0,[1,"resized"]],[12,[" (method of ",[0,[1,"vertical-pasteboard%"]],")"]]],["mrlib/aligned-pasteboard"]],
["resolve",">scribble/renderer.html#(meth._(((lib._scribble/base-render..ss)._render~25)._resolve))",[[0,[1,"resolve"]],[12,[" (method of ",[0,[1,"render%"]],")"]]],["scribble/base-render"]],
["resolve pass",">scribble/struct.html#(tech._resolve._pas)","<i>resolve pass</i>",false],
["resolve-get",">scribble/struct.html#(def._((lib._scribble/struct..ss)._resolve-get))",[0,[1,"resolve-get"]],["scribble/struct"]],
["resolve-get-keys",">scribble/struct.html#(def._((lib._scribble/struct..ss)._resolve-get-keys))",[0,[1,"resolve-get-keys"]],["scribble/struct"]],
["resolve-get/ext?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._resolve-get/ext~3f))",[0,[1,"resolve-get/ext?"]],["scribble/struct"]],
["resolve-get/tentative",">scribble/struct.html#(def._((lib._scribble/struct..ss)._resolve-get/tentative))",[0,[1,"resolve-get/tentative"]],["scribble/struct"]],
["resolve-info",">scribble/struct.html#(def._((lib._scribble/struct..ss)._resolve-info))",[0,[1,"resolve-info"]],["scribble/struct"]],
["resolve-info-ci",">scribble/struct.html#(def._((lib._scribble/struct..ss)._resolve-info-ci))",[0,[1,"resolve-info-ci"]],["scribble/struct"]],
["resolve-info-delays",">scribble/struct.html#(def._((lib._scribble/struct..ss)._resolve-info-delays))",[0,[1,"resolve-info-delays"]],["scribble/struct"]],
["resolve-info-undef",">scribble/struct.html#(def._((lib._scribble/struct..ss)._resolve-info-undef))",[0,[1,"resolve-info-undef"]],["scribble/struct"]],
["resolve-info?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._resolve-info~3f))",[0,[1,"resolve-info?"]],["scribble/struct"]],
["resolve-module-path",">syntax/module-helpers.html#(def._((lib._syntax/modresolve..ss)._resolve-module-path))",[0,[1,"resolve-module-path"]],["syntax/modresolve"]],
["resolve-module-path-index",">syntax/module-helpers.html#(def._((lib._syntax/modresolve..ss)._resolve-module-path-index))",[0,[1,"resolve-module-path-index"]],["syntax/modresolve"]],
["resolve-path",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._resolve-path))",[0,[1,"resolve-path"]],["scheme/base","scheme"]],
["resolve-path-spec",">syntax/transformer-helpers.html#(def._((lib._syntax/path-spec..ss)._resolve-path-spec))",[0,[1,"resolve-path-spec"]],["syntax/path-spec"]],
["resolve-planet-path",">planet/Utility_Libraries.html#(def._((lib._planet/util..ss)._resolve-planet-path))",[0,[1,"resolve-planet-path"]],["planet/util"]],
["resolve-search",">scribble/struct.html#(def._((lib._scribble/struct..ss)._resolve-search))",[0,[1,"resolve-search"]],["scribble/struct"]],
["resolved",">reference/Module_Names_and_Loading.html#(tech._resolved)","<i>resolved</i>",false],
["resolved module path",">reference/Module_Names_and_Loading.html#(tech._resolved._module._path)","<i>resolved\nmodule path</i>",false],
["resolved-module-path-name",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._resolved-module-path-name))",[0,[1,"resolved-module-path-name"]],["scheme/base","scheme"]],
["resolved-module-path?",">reference/Module_Names_and_Loading.html#(def._((quote._~23~25kernel)._resolved-module-path~3f))",[0,[1,"resolved-module-path?"]],["scheme/base","scheme"]],
["resolving include-like paths",">syntax/transformer-helpers.html#(part._path-spec)",["Resolving ",[0,"include"],"-like Paths"],false],
["resolving module names",">reference/Module_Names_and_Loading.html#(part._modnameresolver)","Resolving Module Names",false],
["resolving module paths to file paths",">syntax/module-helpers.html#(part._.Resolving_.Module_.Paths_to_.File_.Paths)","Resolving Module Paths to File Paths",false],
["responders",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._responders))",[0,[1,"responders"]],["web-server/configuration/configuration-table-structs"]],
["responders-authentication",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._responders-authentication))",[0,[1,"responders-authentication"]],["web-server/configuration/configuration-table-structs"]],
["responders-collect-garbage",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._responders-collect-garbage))",[0,[1,"responders-collect-garbage"]],["web-server/configuration/configuration-table-structs"]],
["responders-file-not-found",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._responders-file-not-found))",[0,[1,"responders-file-not-found"]],["web-server/configuration/configuration-table-structs"]],
["responders-passwords-refreshed",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._responders-passwords-refreshed))",[0,[1,"responders-passwords-refreshed"]],["web-server/configuration/configuration-table-structs"]],
["responders-protocol",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._responders-protocol))",[0,[1,"responders-protocol"]],["web-server/configuration/configuration-table-structs"]],
["responders-servlet",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._responders-servlet))",[0,[1,"responders-servlet"]],["web-server/configuration/configuration-table-structs"]],
["responders-servlet-loading",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._responders-servlet-loading))",[0,[1,"responders-servlet-loading"]],["web-server/configuration/configuration-table-structs"]],
["responders-servlets-refreshed",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._responders-servlets-refreshed))",[0,[1,"responders-servlets-refreshed"]],["web-server/configuration/configuration-table-structs"]],
["responders?",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._responders~3f))",[0,[1,"responders?"]],["web-server/configuration/configuration-table-structs"]],
["response-generator?",">web-server/servlet-structs_ss.html#(def._((lib._web-server/servlet/servlet-structs..ss)._response-generator~3f))",[0,"response-generator?"],["web-server/servlet/servlet-structs"]],
["response/basic",">web-server/response-structs_ss.html#(def._((lib._web-server/private/response-structs..ss)._response/basic))",[0,[1,"response/basic"]],["web-server/private/response-structs"]],
["response/basic-code",">web-server/response-structs_ss.html#(def._((lib._web-server/private/response-structs..ss)._response/basic-code))",[0,[1,"response/basic-code"]],["web-server/private/response-structs"]],
["response/basic-headers",">web-server/response-structs_ss.html#(def._((lib._web-server/private/response-structs..ss)._response/basic-headers))",[0,[1,"response/basic-headers"]],["web-server/private/response-structs"]],
["response/basic-message",">web-server/response-structs_ss.html#(def._((lib._web-server/private/response-structs..ss)._response/basic-message))",[0,[1,"response/basic-message"]],["web-server/private/response-structs"]],
["response/basic-mime",">web-server/response-structs_ss.html#(def._((lib._web-server/private/response-structs..ss)._response/basic-mime))",[0,[1,"response/basic-mime"]],["web-server/private/response-structs"]],
["response/basic-seconds",">web-server/response-structs_ss.html#(def._((lib._web-server/private/response-structs..ss)._response/basic-seconds))",[0,[1,"response/basic-seconds"]],["web-server/private/response-structs"]],
["response/basic?",">web-server/response-structs_ss.html#(def._((lib._web-server/private/response-structs..ss)._response/basic~3f))",[0,[1,"response/basic?"]],["web-server/private/response-structs"]],
["response/full",">web-server/response-structs_ss.html#(def._((lib._web-server/private/response-structs..ss)._response/full))",[0,[1,"response/full"]],["web-server/private/response-structs"]],
["response/full-body",">web-server/response-structs_ss.html#(def._((lib._web-server/private/response-structs..ss)._response/full-body))",[0,[1,"response/full-body"]],["web-server/private/response-structs"]],
["response/full?",">web-server/response-structs_ss.html#(def._((lib._web-server/private/response-structs..ss)._response/full~3f))",[0,[1,"response/full?"]],["web-server/private/response-structs"]],
["response/incremental",">web-server/response-structs_ss.html#(def._((lib._web-server/private/response-structs..ss)._response/incremental))",[0,[1,"response/incremental"]],["web-server/private/response-structs"]],
["response/incremental-generator",">web-server/response-structs_ss.html#(def._((lib._web-server/private/response-structs..ss)._response/incremental-generator))",[0,[1,"response/incremental-generator"]],["web-server/private/response-structs"]],
["response/incremental?",">web-server/response-structs_ss.html#(def._((lib._web-server/private/response-structs..ss)._response/incremental~3f))",[0,[1,"response/incremental?"]],["web-server/private/response-structs"]],
["response?",">web-server/response-structs_ss.html#(def._((lib._web-server/private/response-structs..ss)._response~3f))",[0,[1,"response?"]],["web-server/private/response-structs"]],
["rest",">reference/pairs.html#(def._((lib._scheme/list..ss)._rest))",[0,[1,"rest"]],["scheme/list","scheme"]],
["rest",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._rest))",[0,[1,"rest"]],["lang/htdp-advanced"]],
["rest",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._rest))",[0,[1,"rest"]],["lang/htdp-beginner"]],
["rest",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._rest))",[0,[1,"rest"]],["lang/htdp-beginner-abbr"]],
["rest",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._rest))",[0,[1,"rest"]],["lang/htdp-intermediate"]],
["rest",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._rest))",[0,[1,"rest"]],["lang/htdp-intermediate-lambda"]],
["rest",">lazy/index.html#(def._((lib._lazy/main..ss)._rest))",[0,[1,"rest"]],["lazy"]],
["rest",">mzlib/mzlib_list.html#(def._((lib._mzlib/list..ss)._rest))",[0,[1,"rest"]],["mzlib/list"]],
["rest and rest-like arguments",">mzlib/mzlib_kw.html#(part._.Rest_and_.Rest-like_.Arguments)","Rest and Rest-like Arguments",false],
["rest arguments",">guide/contracts-general-functions.html#(part._contracts-rest-args)","Rest Arguments",false],
["restart-mzscheme",">mzlib/mzlib_restart.html#(def._((lib._mzlib/restart..ss)._restart-mzscheme))",[0,[1,"restart-mzscheme"]],["mzlib/restart"]],
["restore",">gui/menu-item___.html#(meth._(((lib._mred/main..ss)._menu-item~3c~25~3e)._restore))",[[0,[1,"restore"]],[12,[" (method of ",[0,[1,"menu-item&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["restore",">mysterx/browsers.html#(meth._(((lib._mysterx/main..ss)._mx-browser~25)._restore))",[[0,[1,"restore"]],[12,[" (method of ",[0,[1,"mx-browser%"]],")"]]],["mysterx"]],
["restore-keybinding",">framework/Menu.html#(meth._(((lib._framework/main..ss)._menu~3acan-restore~3c~25~3e)._restore-keybinding))",[[0,[1,"restore-keybinding"]],[12,[" (method of ",[0,[1,"menu:can-restore&lt;%&gt;"]],")"]]],["framework"]],
["restore-underscores",">framework/Menu.html#(meth._(((lib._framework/main..ss)._menu~3acan-restore-underscore~3c~25~3e)._restore-underscores))",[[0,[1,"restore-underscores"]],[12,[" (method of ",[0,[1,"menu:can-restore-underscore&lt;%&gt;"]],")"]]],["framework"]],
["restricting the arguments of a function",">guide/contract-func.html#(part._contracts-argcontract)","Restricting the Arguments of a Function",false],
["restricting the range of a function",">guide/contract-func.html#(part._contracts-range)","Restricting the Range of a Function",false],
["retract-most-recent-slide",">slideshow/Slide_Registration.html#(def._((lib._slideshow/base..ss)._retract-most-recent-slide))",[0,[1,"retract-most-recent-slide"]],["slideshow/base","slideshow"]],
["return",">reference/Byte_and_String_Input.html#(idx._(gentag._117._(lib._scribblings/reference/reference..scrbl)))",[7,"'return"],false],
["return-linefeed",">reference/Byte_and_String_Input.html#(idx._(gentag._118._(lib._scribblings/reference/reference..scrbl)))",[7,"'return-linefeed"],false],
["return-without-pos",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..ss)._return-without-pos))",[0,[6,"return-without-pos"]],["parser-tools/lex"]],
["reverse",">reference/pairs.html#(def._((quote._~23~25kernel)._reverse))",[0,[1,"reverse"]],["scheme/base","scheme"]],
["reverse",">gui/dc-path_.html#(meth._(((lib._mred/main..ss)._dc-path~25)._reverse))",[[0,[1,"reverse"]],[12,[" (method of ",[0,[1,"dc-path%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["reverse",">r5rs-std/r5rs-Z-H-9.html#%_idx_440",[0,[1,"reverse"]],["r5rs"]],
["reverse",">r6rs-std/r6rs-Z-H-14.html#node_idx_636",[0,[1,"reverse"]],["rnrs/base-6"]],
["reverse",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._reverse))",[0,[1,"reverse"]],["lang/htdp-advanced"]],
["reverse",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._reverse))",[0,[1,"reverse"]],["lang/htdp-beginner"]],
["reverse",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._reverse))",[0,[1,"reverse"]],["lang/htdp-beginner-abbr"]],
["reverse",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._reverse))",[0,[1,"reverse"]],["lang/htdp-intermediate"]],
["reverse",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._reverse))",[0,[1,"reverse"]],["lang/htdp-intermediate-lambda"]],
["reverse",">lazy/index.html#(def._((lib._lazy/main..ss)._reverse))",[0,[1,"reverse"]],["lazy"]],
["reverse",">srfi-std/srfi-1.html#reverse",[0,[1,"reverse"]],["srfi/1"]],
["reverse!",">srfi-std/srfi-1.html#srfi-1.html",[0,[1,"reverse!"]],["srfi/1"]],
["reverse-list->string",">srfi-std/srfi-13.html#reverse-list2string",[0,[1,"reverse-list-&gt;string"]],["srfi/13"]],
["reverse-list->vector",">srfi-std/srfi-43.html#reverse-list->vector",[0,[1,"reverse-list-&gt;vector"]],["srfi/43"]],
["reverse-vector->list",">srfi-std/srfi-43.html#reverse-vector->list",[0,[1,"reverse-vector-&gt;list"]],["srfi/43"]],
["revert",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor~3c~25~3e)._revert))",[[0,[1,"revert"]],[12,[" (method of ",[0,[1,"frame:editor&lt;%&gt;"]],")"]]],["framework"]],
["revert menu item",">drscheme/Menus.html#(idx._(gentag._63._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Revert</font></b> menu item",false],
["rewind",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-panel-mixin)._rewind))",[[0,[1,"rewind"]],[12,[" (method of ",[0,[1,"hyper-panel-mixin"]],")"]]],["browser"]],
["rgb",">graphics/Color_Operations.html#(def._((lib._graphics/graphics..ss)._rgb))",[0,[1,"rgb"]],["graphics/graphics"]],
["rgb",">teachpack/image.html#(tech._rgb)","<i>RGB</i>",false],
["rgb-blue",">graphics/Color_Operations.html#(def._((lib._graphics/graphics..ss)._rgb-blue))",[0,[1,"rgb-blue"]],["graphics/graphics"]],
["rgb-green",">graphics/Color_Operations.html#(def._((lib._graphics/graphics..ss)._rgb-green))",[0,[1,"rgb-green"]],["graphics/graphics"]],
["rgb-red",">graphics/Color_Operations.html#(def._((lib._graphics/graphics..ss)._rgb-red))",[0,[1,"rgb-red"]],["graphics/graphics"]],
["rgb?",">graphics/Color_Operations.html#(def._((lib._graphics/graphics..ss)._rgb~3f))",[0,[1,"rgb?"]],["graphics/graphics"]],
["right",">gui/key-event_.html#(idx._(gentag._60._(lib._scribblings/gui/gui..scrbl)))",[7,"'right"],false],
["right-mouse-click?",">graphics/Mouse_Operations.html#(def._((lib._graphics/graphics..ss)._right-mouse-click~3f))",[0,[1,"right-mouse-click?"]],["graphics/graphics"]],
["ring-bell",">framework/Keymap.html#(idx._(gentag._5._(lib._scribblings/framework/framework..scrbl)))","ring-bell",false],
["rnrs/arithmetic/bitwise-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/arithmetic/bitwise-6)",[14,[0,"rnrs/arithmetic/bitwise-6"]],"module"],
["rnrs/arithmetic/fixnums-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/arithmetic/fixnums-6)",[14,[0,"rnrs/arithmetic/fixnums-6"]],"module"],
["rnrs/arithmetic/flonums-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/arithmetic/flonums-6)",[14,[0,"rnrs/arithmetic/flonums-6"]],"module"],
["rnrs/base-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/base-6)",[14,[0,"rnrs/base-6"]],"module"],
["rnrs/bytevectors-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/bytevectors-6)",[14,[0,"rnrs/bytevectors-6"]],"module"],
["rnrs/conditions-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/conditions-6)",[14,[0,"rnrs/conditions-6"]],"module"],
["rnrs/control-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/control-6)",[14,[0,"rnrs/control-6"]],"module"],
["rnrs/enums-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/enums-6)",[14,[0,"rnrs/enums-6"]],"module"],
["rnrs/eval-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/eval-6)",[14,[0,"rnrs/eval-6"]],"module"],
["rnrs/exceptions-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/exceptions-6)",[14,[0,"rnrs/exceptions-6"]],"module"],
["rnrs/files-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/files-6)",[14,[0,"rnrs/files-6"]],"module"],
["rnrs/hashtables-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/hashtables-6)",[14,[0,"rnrs/hashtables-6"]],"module"],
["rnrs/io/ports-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/io/ports-6)",[14,[0,"rnrs/io/ports-6"]],"module"],
["rnrs/io/simple-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/io/simple-6)",[14,[0,"rnrs/io/simple-6"]],"module"],
["rnrs/lists-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/lists-6)",[14,[0,"rnrs/lists-6"]],"module"],
["rnrs/mutable-pairs-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/mutable-pairs-6)",[14,[0,"rnrs/mutable-pairs-6"]],"module"],
["rnrs/mutable-strings-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/mutable-strings-6)",[14,[0,"rnrs/mutable-strings-6"]],"module"],
["rnrs/programs-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/programs-6)",[14,[0,"rnrs/programs-6"]],"module"],
["rnrs/r5rs-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/r5rs-6)",[14,[0,"rnrs/r5rs-6"]],"module"],
["rnrs/records/inspection-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/records/inspection-6)",[14,[0,"rnrs/records/inspection-6"]],"module"],
["rnrs/records/procedural-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/records/procedural-6)",[14,[0,"rnrs/records/procedural-6"]],"module"],
["rnrs/records/syntactic-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/records/syntactic-6)",[14,[0,"rnrs/records/syntactic-6"]],"module"],
["rnrs/sorting-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/sorting-6)",[14,[0,"rnrs/sorting-6"]],"module"],
["rnrs/syntax-case-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/syntax-case-6)",[14,[0,"rnrs/syntax-case-6"]],"module"],
["rnrs/unicode-6",">r6rs/R6RS_Libraries.html#(mod-path._rnrs/unicode-6)",[14,[0,"rnrs/unicode-6"]],"module"],
["rolling your own contracts for function arguments",">guide/contract-func.html#(part._contracts-own)","Rolling Your Own Contracts for Function Arguments",false],
["roman",">gui/font_.html#(idx._(gentag._196._(lib._scribblings/gui/gui..scrbl)))",[7,"'roman"],false],
["roman",">gui/style-delta_.html#(idx._(gentag._281._(lib._scribblings/gui/gui..scrbl)))",[7,"'roman"],false],
["root",">gui/menu-bar_.html#(idx._(gentag._119._(lib._scribblings/gui/gui..scrbl)))",[7,"'root"],false],
["root style",">gui/editor-overview.html#(tech._root._style)","<i>root style</i>",false],
["rotate",">gui/dc-path_.html#(meth._(((lib._mred/main..ss)._dc-path~25)._rotate))",[[0,[1,"rotate"]],[12,[" (method of ",[0,[1,"dc-path%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["round",">reference/numbers.html#(def._((quote._~23~25kernel)._round))",[0,[1,"round"]],["scheme/base","scheme"]],
["round",">r5rs-std/r5rs-Z-H-9.html#%_idx_320",[0,[1,"round"]],["r5rs"]],
["round",">r6rs-std/r6rs-Z-H-14.html#node_idx_534",[0,[1,"round"]],["rnrs/base-6"]],
["round",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._round))",[0,[1,"round"]],["lang/htdp-advanced"]],
["round",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._round))",[0,[1,"round"]],["lang/htdp-beginner"]],
["round",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._round))",[0,[1,"round"]],["lang/htdp-beginner-abbr"]],
["round",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._round))",[0,[1,"round"]],["lang/htdp-intermediate"]],
["round",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._round))",[0,[1,"round"]],["lang/htdp-intermediate-lambda"]],
["rounded-rectangle",">gui/dc-path_.html#(meth._(((lib._mred/main..ss)._dc-path~25)._rounded-rectangle))",[[0,[1,"rounded-rectangle"]],[12,[" (method of ",[0,[1,"dc-path%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["rounded-rectangle",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._rounded-rectangle))",[0,[1,"rounded-rectangle"]],["slideshow/pict","slideshow"]],
["rt",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..ss)._rt))",[0,[1,"rt"]],["slideshow/base","slideshow"]],
["rt-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..ss)._rt-find))",[0,[1,"rt-find"]],["slideshow/pict","slideshow"]],
["rt-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..ss)._rt-superimpose))",[0,[1,"rt-superimpose"]],["slideshow/pict","slideshow"]],
["rtl-find",">slideshow/Pict_Finders.html#(def._((lib._slideshow/pict..ss)._rtl-find))",[0,[1,"rtl-find"]],["slideshow/pict","slideshow"]],
["rtl-superimpose",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..ss)._rtl-superimpose))",[0,[1,"rtl-superimpose"]],["slideshow/pict","slideshow"]],
["rule-pict-style",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._rule-pict-style))",[0,[1,"rule-pict-style"]],["redex/pict"]],
["rummy --- card game",">games/ginrummy.html",[[13,"<img src=\"ginrummy.png\" />"]," ","<b><font size=\"-1\" face=\"Helvetica\">Rummy</font></b>","  ","&ndash;","  Card Game"],false],
["run",">mrlib/Path_Dialog.html#(meth._(((lib._mrlib/path-dialog..ss)._path-dialog~25)._run))",[[0,[1,"run"]],[12,[" (method of ",[0,[1,"path-dialog%"]],")"]]],["mrlib/path-dialog"]],
["run",">teachpack/elevator.html#(def._((lib._teachpack/htdp/elevator..ss)._run))",[0,[1,"run"]],["teachpack/htdp/elevator"]],
["run button",">drscheme/buttons.html#(idx._(gentag._14._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Run</font></b> button",false],
["run menu item",">drscheme/Menus.html#(idx._(gentag._118._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Run</font></b> menu item",false],
["run-after-edit-sequence",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abasic~3c~25~3e)._run-after-edit-sequence))",[[0,[1,"run-after-edit-sequence"]],[12,[" (method of ",[0,[1,"editor:basic&lt;%&gt;"]],")"]]],["framework"]],
["run-file",">reference/Filesystem.html#(idx._(gentag._259._(lib._scribblings/reference/reference..scrbl)))",[7,"'run-file"],false],
["run-in-evaluation-thread",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3atext~25)._run-in-evaluation-thread))",[[0,[1,"run-in-evaluation-thread"]],[12,[" (method of ",[0,[1,"drscheme:rep:text%"]],")"]]],["drscheme/tool-lib"]],
["run-installer",">setup-plt/_plt-archives.html#(def._((lib._setup/plt-installer..ss)._run-installer))",[0,[1,"run-installer"]],["setup/plt-installer"]],
["run-server",">mzlib/mzlib_thread.html#(def._((lib._mzlib/thread..ss)._run-server))",[0,[1,"run-server"]],["mzlib/thread"]],
["run-simulation",">teachpack/world.html#(def._((lib._teachpack/htdp/world..ss)._run-simulation))",[0,[1,"run-simulation"]],["teachpack/htdp/world"]],
["run-single-installer",">setup-plt/_plt-archives.html#(def._((lib._setup/plt-installer..ss)._run-single-installer))",[0,[1,"run-single-installer"]],["setup/plt-installer"]],
["run-single-installer",">setup-plt/_plt-archives.html#(def._((lib._setup/plt-single-installer..ss)._run-single-installer))",[0,[1,"run-single-installer"]],["setup/plt-single-installer"]],
["running",">tools/drscheme_frame.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aframe~3a~3c~25~3e)._running))",[[0,[1,"running"]],[12,[" (method of ",[0,[1,"drscheme:frame:&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["running",">reference/subprocess.html#(idx._(gentag._267._(lib._scribblings/reference/reference..scrbl)))",[7,"'running"],false],
["running a demo",">mysterx/overview.html#(part._.Running_a_.Demo)","Running a Demo",false],
["running and creating executables",">guide/running.html","Running and Creating Executables",false],
["running mzc",">mzc/Running_mzc.html",["Running ",[5,"mzc"]],false],
["running mzscheme and mred",">guide/mzscheme.html",["Running ",[5,"mzscheme"]," and ",[5,"mred"]],false],
["running mzscheme or mred",">reference/running-sa.html","Running MzScheme or MrEd",false],
["running plt scheme",">reference/running.html","Running PLT Scheme",false],
["running r5rs programs",">r5rs/running.html","Running R<sup>5</sup>RS Programs",false],
["running setup-plt executable",">setup-plt/running.html",["Running ",[5,"setup-plt"]," Executable"],false],
["running setup-plt from scheme",">setup-plt/setup-plt-plt.html",["Running ",[5,"setup-plt"]," from Scheme"],false],
["running the web server",">web-server/run_ss.html","Running the Web Server",false],
["running top-level programs",">r6rs/Running_Top-Level_Programs.html","Running Top-Level Programs",false],
["runtime-paths",">reference/Filesystem.html#(form._((lib._scheme/runtime-path..ss)._runtime-paths))",[0,[6,"runtime-paths"]],["scheme/runtime-path"]],
["s",">html/index.html#(def._((lib._html/main..ss)._s))",[0,[1,"s"]],["html"]],
["s16vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._s16vector))",[0,[1,"s16vector"]],["scheme/foreign"]],
["s16vector",">srfi-std/srfi-4.html#s8vector",[0,[1,"s16vector"]],["srfi/4"]],
["s16vector->list",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._s16vector-~3elist))",[0,[1,"s16vector-&gt;list"]],["scheme/foreign"]],
["s16vector-length",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._s16vector-length))",[0,[1,"s16vector-length"]],["scheme/foreign"]],
["s16vector-ref",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._s16vector-ref))",[0,[1,"s16vector-ref"]],["scheme/foreign"]],
["s16vector-set!",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._s16vector-set!))",[0,[1,"s16vector-set!"]],["scheme/foreign"]],
["s16vector?",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._s16vector~3f))",[0,[1,"s16vector?"]],["scheme/foreign"]],
["s32vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._s32vector))",[0,[1,"s32vector"]],["scheme/foreign"]],
["s32vector",">srfi-std/srfi-4.html#s16vector",[0,[1,"s32vector"]],["srfi/4"]],
["s32vector->list",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._s32vector-~3elist))",[0,[1,"s32vector-&gt;list"]],["scheme/foreign"]],
["s32vector-length",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._s32vector-length))",[0,[1,"s32vector-length"]],["scheme/foreign"]],
["s32vector-ref",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._s32vector-ref))",[0,[1,"s32vector-ref"]],["scheme/foreign"]],
["s32vector-set!",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._s32vector-set!))",[0,[1,"s32vector-set!"]],["scheme/foreign"]],
["s32vector?",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._s32vector~3f))",[0,[1,"s32vector?"]],["scheme/foreign"]],
["s64vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._s64vector))",[0,[1,"s64vector"]],["scheme/foreign"]],
["s64vector",">srfi-std/srfi-4.html#s64vector",[0,[1,"s64vector"]],["srfi/4"]],
["s64vector->list",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._s64vector-~3elist))",[0,[1,"s64vector-&gt;list"]],["scheme/foreign"]],
["s64vector-length",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._s64vector-length))",[0,[1,"s64vector-length"]],["scheme/foreign"]],
["s64vector-ref",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._s64vector-ref))",[0,[1,"s64vector-ref"]],["scheme/foreign"]],
["s64vector-set!",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._s64vector-set!))",[0,[1,"s64vector-set!"]],["scheme/foreign"]],
["s64vector?",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._s64vector~3f))",[0,[1,"s64vector?"]],["scheme/foreign"]],
["s8vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._s8vector))",[0,[1,"s8vector"]],["scheme/foreign"]],
["s8vector",">srfi-std/srfi-4.html#s8vector",[0,[1,"s8vector"]],["srfi/4"]],
["s8vector->list",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._s8vector-~3elist))",[0,[1,"s8vector-&gt;list"]],["scheme/foreign"]],
["s8vector-length",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._s8vector-length))",[0,[1,"s8vector-length"]],["scheme/foreign"]],
["s8vector-ref",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._s8vector-ref))",[0,[1,"s8vector-ref"]],["scheme/foreign"]],
["s8vector-set!",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._s8vector-set!))",[0,[1,"s8vector-set!"]],["scheme/foreign"]],
["s8vector?",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._s8vector~3f))",[0,[1,"s8vector?"]],["scheme/foreign"]],
["s?",">html/index.html#(def._((lib._html/main..ss)._s~3f))",[0,[1,"s?"]],["html"]],
["safe c vectors",">foreign/Derived_Utilities.html#(part._foreign~3acvector)","Safe C Vectors",false],
["same",">reference/Manipulating_Paths.html#(idx._(gentag._213._(lib._scribblings/reference/reference..scrbl)))",[7,"'same"],false],
["same --- dot-removing game",">games/same.html",[[13,"<img src=\"same.png\" />"]," ","<b><font size=\"-1\" face=\"Helvetica\">Same</font></b>","  ","&ndash;","  Dot-Removing Game"],false],
["samp",">html/index.html#(def._((lib._html/main..ss)._samp))",[0,[1,"samp"]],["html"]],
["samp?",">html/index.html#(def._((lib._html/main..ss)._samp~3f))",[0,[1,"samp?"]],["html"]],
["sample-size",">plot/extend.html#(def._((lib._plot/extend..ss)._sample-size))",[0,[1,"sample-size"]],["plot/extend"]],
["sandbox-coverage-enabled",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._sandbox-coverage-enabled))",[0,[1,"sandbox-coverage-enabled"]],["scheme/sandbox"]],
["sandbox-error-output",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._sandbox-error-output))",[0,[1,"sandbox-error-output"]],["scheme/sandbox"]],
["sandbox-eval-limits",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._sandbox-eval-limits))",[0,[1,"sandbox-eval-limits"]],["scheme/sandbox"]],
["sandbox-init-hook",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._sandbox-init-hook))",[0,[1,"sandbox-init-hook"]],["scheme/sandbox"]],
["sandbox-input",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._sandbox-input))",[0,[1,"sandbox-input"]],["scheme/sandbox"]],
["sandbox-make-inspector",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._sandbox-make-inspector))",[0,[1,"sandbox-make-inspector"]],["scheme/sandbox"]],
["sandbox-make-logger",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._sandbox-make-logger))",[0,[1,"sandbox-make-logger"]],["scheme/sandbox"]],
["sandbox-namespace-specs",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._sandbox-namespace-specs))",[0,[1,"sandbox-namespace-specs"]],["scheme/sandbox"]],
["sandbox-network-guard",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._sandbox-network-guard))",[0,[1,"sandbox-network-guard"]],["scheme/sandbox"]],
["sandbox-output",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._sandbox-output))",[0,[1,"sandbox-output"]],["scheme/sandbox"]],
["sandbox-override-collection-paths",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._sandbox-override-collection-paths))",[0,[1,"sandbox-override-collection-paths"]],["scheme/sandbox"]],
["sandbox-path-permissions",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._sandbox-path-permissions))",[0,[1,"sandbox-path-permissions"]],["scheme/sandbox"]],
["sandbox-propagate-breaks",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._sandbox-propagate-breaks))",[0,[1,"sandbox-propagate-breaks"]],["scheme/sandbox"]],
["sandbox-reader",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._sandbox-reader))",[0,[1,"sandbox-reader"]],["scheme/sandbox"]],
["sandbox-security-guard",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._sandbox-security-guard))",[0,[1,"sandbox-security-guard"]],["scheme/sandbox"]],
["sandboxed evaluation",">reference/Sandboxed_Evaluation.html","Sandboxed Evaluation",false],
["save",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor~3c~25~3e)._save))",[[0,[1,"save"]],[12,[" (method of ",[0,[1,"frame:editor&lt;%&gt;"]],")"]]],["framework"]],
["save button",">drscheme/buttons.html#(idx._(gentag._3._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Save</font></b> button",false],
["save definitions as text... menu item",">drscheme/Menus.html#(idx._(gentag._67._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Save Definitions As Text...</font></b> menu item",false],
["save definitions as... menu item",">drscheme/Menus.html#(idx._(gentag._65._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Save Definitions As...</font></b> menu item",false],
["save definitions menu item",">drscheme/Menus.html#(idx._(gentag._64._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Save Definitions</font></b> menu item",false],
["save interactions as text... menu item",">drscheme/Menus.html#(idx._(gentag._70._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Save Interactions As Text...</font></b> menu item",false],
["save interactions as... menu item",">drscheme/Menus.html#(idx._(gentag._69._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Save Interactions As...</font></b> menu item",false],
["save interactions menu item",">drscheme/Menus.html#(idx._(gentag._68._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Save Interactions</font></b> menu item",false],
["save other menu item",">drscheme/Menus.html#(idx._(gentag._66._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Save Other</font></b> menu item",false],
["save-as",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor~3c~25~3e)._save-as))",[[0,[1,"save-as"]],[12,[" (method of ",[0,[1,"frame:editor&lt;%&gt;"]],")"]]],["framework"]],
["save-file",">gui/bitmap_.html#(meth._(((lib._mred/main..ss)._bitmap~25)._save-file))",[[0,[1,"save-file"]],[12,[" (method of ",[0,[1,"bitmap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["save-file",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._save-file))",[[0,[1,"save-file"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["save-file",">framework/Keymap.html#(idx._(gentag._6._(lib._scribblings/framework/framework..scrbl)))","save-file",false],
["save-file-as",">framework/Keymap.html#(idx._(gentag._8._(lib._scribblings/framework/framework..scrbl)))","save-file-as",false],
["save-file-out-of-date?",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abasic~3c~25~3e)._save-file-out-of-date~3f))",[[0,[1,"save-file-out-of-date?"]],[12,[" (method of ",[0,[1,"editor:basic&lt;%&gt;"]],")"]]],["framework"]],
["save-file/gui-error",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abasic~3c~25~3e)._save-file/gui-error))",[[0,[1,"save-file/gui-error"]],[12,[" (method of ",[0,[1,"editor:basic&lt;%&gt;"]],")"]]],["framework"]],
["save-pixmap",">graphics/Draw__Clear__and_Flip_Operations.html#(def._((lib._graphics/graphics..ss)._save-pixmap))",[0,[1,"save-pixmap"]],["graphics/graphics"]],
["save-port",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._save-port))",[[0,[1,"save-port"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["sc",">reference/characters.html#(idx._(gentag._54._(lib._scribblings/reference/reference..scrbl)))",[7,"'sc"],false],
["scale",">gui/dc-path_.html#(meth._(((lib._mred/main..ss)._dc-path~25)._scale))",[[0,[1,"scale"]],[12,[" (method of ",[0,[1,"dc-path%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["scale",">slideshow/Pict_Drawing_Adjusters.html#(def._((lib._slideshow/pict..ss)._scale))",[0,[1,"scale"]],["slideshow/pict","slideshow"]],
["scale-color",">slideshow/Miscellaneous.html#(def._((lib._slideshow/pict..ss)._scale-color))",[0,[1,"scale-color"]],["slideshow/pict","slideshow"]],
["scale-vectors",">plot/extend.html#(def._((lib._plot/extend..ss)._scale-vectors))",[0,[1,"scale-vectors"]],["plot/extend"]],
["scale/improve-new-text",">slideshow/Pict_Drawing_Adjusters.html#(form._((lib._slideshow/pict..ss)._scale/improve-new-text))",[0,[6,"scale/improve-new-text"]],["slideshow/pict","slideshow"]],
["scene",">teachpack/world.html#(tech._scene)","<i>Scene</i>",false],
["scene+line",">teachpack/world.html#(def._((lib._teachpack/htdp/world..ss)._scene+line))",[0,[1,"scene+line"]],["teachpack/htdp/world"]],
["scenes and images",">teachpack/world.html#(part._.Scenes_and_.Images)","Scenes and Images",false],
["scheme",">drscheme/Menus.html#(part._menu~3ascheme)","<b><font size=\"-1\" face=\"Helvetica\">Scheme</font></b>",false],
["scheme",">framework/Scheme.html","Scheme",false],
["scheme",">scribble/scheme.html","Scheme",false],
["scheme",">reference/index.html",[14,[0,"scheme"]],"module"],
["scheme",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..ss)._.S.C.H.E.M.E))",[0,[6,"SCHEME"]],["scribble/manual"]],
["scheme",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..ss)._scheme))",[0,[6,"scheme"]],["scribble/manual"]],
["scheme api for bundling distributions",">mzc/exe-dist.html#(part._.Scheme_.A.P.I_for_.Bundling_.Distributions)","Scheme API for Bundling Distributions",false],
["scheme api for compilation",">mzc/Scheme_API_for_Compilation.html","Scheme API for Compilation",false],
["scheme api for creating executables",">mzc/exe.html#(part._.Scheme_.A.P.I_for_.Creating_.Executables)","Scheme API for Creating Executables",false],
["scheme api for distributing executables",">mzc/exe-dist.html#(part._.Scheme_.A.P.I_for_.Distributing_.Executables)","Scheme API for Distributing Executables",false],
["scheme api for packaging",">mzc/plt.html#(part._.Scheme_.A.P.I_for_.Packaging)","Scheme API for Packaging",false],
["scheme compilation manager api",">mzc/make.html#(part._.Scheme_.Compilation_.Manager_.A.P.I)","Scheme Compilation Manager API",false],
["scheme essentials",">guide/to-scheme.html","Scheme Essentials",false],
["scheme interoperability",">r6rs/Scheme_Interoperability.html","Scheme Interoperability",false],
["scheme lexer",">syntax-color/index.html#(part._.Scheme_.Lexer)","Scheme Lexer",false],
["scheme mode",">tools/Editor_Modes.html#(idx._(gentag._13._(lib._scribblings/tools/tools..scrbl)))","scheme mode",false],
["scheme servlets",">web-server/servlet.html","Scheme Servlets",false],
["scheme typesetting and hyperlinks",">scribble/How_to_Scribble_Documentation.html#(part._scheme-hyperlinks)","Scheme Typesetting and Hyperlinks",false],
["scheme-editor%",">gui/WXME_Decoding.html#(def._((lib._wxme/scheme..ss)._scheme-editor~25))",[0,[1,"scheme-editor%"]],["wxme/scheme"]],
["scheme-lexer",">syntax-color/index.html#(def._((lib._syntax-color/scheme-lexer..ss)._scheme-lexer))",[0,[1,"scheme-lexer"]],["syntax-color/scheme-lexer"]],
["scheme-report-environment",">r5rs-std/r5rs-Z-H-9.html#%_idx_602",[0,[1,"scheme-report-environment"]],["r5rs"]],
["scheme-report-environment",">r6rs-lib-std/r6rs-lib-Z-H-20.html#node_idx_1308",[0,[1,"scheme-report-environment"]],["rnrs/r5rs-6"]],
["scheme-style opengl",">sgl/main.html","Scheme-Style OpenGL",false],
["scheme/async-channel",">reference/async-channel.html",[14,[0,"scheme/async-channel"]],"module"],
["scheme/base",">reference/index.html",[14,[0,"scheme/base"]],"module"],
["scheme/bool",">reference/booleans.html#(mod-path._scheme/bool)",[14,[0,"scheme/bool"]],"module"],
["scheme/class",">reference/mzlib_class.html",[14,[0,"scheme/class"]],"module"],
["scheme/cmdline",">reference/Command-Line_Parsing.html",[14,[0,"scheme/cmdline"]],"module"],
["scheme/contract",">reference/contracts.html",[14,[0,"scheme/contract"]],"module"],
["scheme/control",">reference/cont.html#(mod-path._scheme/control)",[14,[0,"scheme/control"]],"module"],
["scheme/date",">reference/time.html#(mod-path._scheme/date)",[14,[0,"scheme/date"]],"module"],
["scheme/dict",">reference/dicts.html",[14,[0,"scheme/dict"]],"module"],
["scheme/enter",">reference/enter.html",[14,[0,"scheme/enter"]],"module"],
["scheme/file",">reference/Filesystem.html#(mod-path._scheme/file)",[14,[0,"scheme/file"]],"module"],
["scheme/foreign",">foreign/index.html",[14,[0,"scheme/foreign"]],"module"],
["scheme/function",">reference/procedures.html#(mod-path._scheme/function)",[14,[0,"scheme/function"]],"module"],
["scheme/gui",">gui/index.html",[14,[0,"scheme/gui"]],"module"],
["scheme/gui/base",">gui/index.html",[14,[0,"scheme/gui/base"]],"module"],
["scheme/gui/dynamic",">gui/Dynamic_Loading.html",[14,[0,"scheme/gui/dynamic"]],"module"],
["scheme/gui/init",">reference/running-sa.html#(mod-path._scheme/gui/init)",[14,[0,"scheme/gui/init"]],"module"],
["scheme/help",">reference/Interactive_Help.html",[14,[0,"scheme/help"]],"module"],
["scheme/include",">reference/include.html",[14,[0,"scheme/include"]],"module"],
["scheme/init",">reference/running-sa.html#(mod-path._scheme/init)",[14,[0,"scheme/init"]],"module"],
["scheme/list",">reference/pairs.html#(mod-path._scheme/list)",[14,[0,"scheme/list"]],"module"],
["scheme/load",">reference/load-lang.html",[14,[0,"scheme/load"]],"module"],
["scheme/local",">reference/local.html",[14,[0,"scheme/local"]],"module"],
["scheme/match",">reference/match.html",[14,[0,"scheme/match"]],"module"],
["scheme/math",">reference/numbers.html#(mod-path._scheme/math)",[14,[0,"scheme/math"]],"module"],
["scheme/mpair",">reference/mpairs.html#(mod-path._scheme/mpair)",[14,[0,"scheme/mpair"]],"module"],
["scheme/nest",">reference/nest.html",[14,[0,"scheme/nest"]],"module"],
["scheme/path",">reference/More_Path_Utilities.html",[14,[0,"scheme/path"]],"module"],
["scheme/port",">reference/More_Port_Constructors_and_Events.html",[14,[0,"scheme/port"]],"module"],
["scheme/pretty",">reference/pretty-print.html",[14,[0,"scheme/pretty"]],"module"],
["scheme/promise",">reference/Delayed_Evaluation.html",[14,[0,"scheme/promise"]],"module"],
["scheme/provide",">reference/require.html#(mod-path._scheme/provide)",[14,[0,"scheme/provide"]],"module"],
["scheme/provide-syntax",">reference/define.html#(mod-path._scheme/provide-syntax)",[14,[0,"scheme/provide-syntax"]],"module"],
["scheme/provide-transform",">reference/stxtrans.html#(mod-path._scheme/provide-transform)",[14,[0,"scheme/provide-transform"]],"module"],
["scheme/require",">reference/require.html#(mod-path._scheme/require)",[14,[0,"scheme/require"]],"module"],
["scheme/require-syntax",">reference/define.html#(mod-path._scheme/require-syntax)",[14,[0,"scheme/require-syntax"]],"module"],
["scheme/require-transform",">reference/stxtrans.html#(mod-path._scheme/require-transform)",[14,[0,"scheme/require-transform"]],"module"],
["scheme/runtime-path",">reference/Filesystem.html#(mod-path._scheme/runtime-path)",[14,[0,"scheme/runtime-path"]],"module"],
["scheme/sandbox",">reference/Sandboxed_Evaluation.html",[14,[0,"scheme/sandbox"]],"module"],
["scheme/serialize",">reference/serialization.html",[14,[0,"scheme/serialize"]],"module"],
["scheme/shared",">reference/shared.html",[14,[0,"scheme/shared"]],"module"],
["scheme/signature",">reference/Single-Signature_Modules.html",[14,[0,"scheme/signature"]],"module"],
["scheme/string",">reference/strings.html#(mod-path._scheme/string)",[14,[0,"scheme/string"]],"module"],
["scheme/struct-info",">reference/structinfo.html",[14,[0,"scheme/struct-info"]],"module"],
["scheme/stxparam",">reference/stxparam.html",[14,[0,"scheme/stxparam"]],"module"],
["scheme/stxparam-exptime",">reference/stxparam.html#(mod-path._scheme/stxparam-exptime)",[14,[0,"scheme/stxparam-exptime"]],"module"],
["scheme/surrogate",">reference/Surrogates.html",[14,[0,"scheme/surrogate"]],"module"],
["scheme/system",">reference/subprocess.html#(mod-path._scheme/system)",[14,[0,"scheme/system"]],"module"],
["scheme/tcp",">reference/tcp.html",[14,[0,"scheme/tcp"]],"module"],
["scheme/trait",">reference/trait.html",[14,[0,"scheme/trait"]],"module"],
["scheme/udp",">reference/udp.html",[14,[0,"scheme/udp"]],"module"],
["scheme/unit",">reference/mzlib_unit.html",[14,[0,"scheme/unit"]],"module"],
["scheme/unit-exptime",">reference/Transformer_Helpers.html",[14,[0,"scheme/unit-exptime"]],"module"],
["scheme:add-coloring-preferences-panel",">framework/Scheme.html#(def._((lib._framework/main..ss)._scheme~3aadd-coloring-preferences-panel))",[0,[1,"scheme:add-coloring-preferences-panel"]],["framework"]],
["scheme:add-preferences-panel",">framework/Scheme.html#(def._((lib._framework/main..ss)._scheme~3aadd-preferences-panel))",[0,[1,"scheme:add-preferences-panel"]],["framework"]],
["scheme:get-color-prefs-table",">framework/Scheme.html#(def._((lib._framework/main..ss)._scheme~3aget-color-prefs-table))",[0,[1,"scheme:get-color-prefs-table"]],["framework"]],
["scheme:get-keymap",">framework/Scheme.html#(def._((lib._framework/main..ss)._scheme~3aget-keymap))",[0,[1,"scheme:get-keymap"]],["framework"]],
["scheme:get-white-on-black-color-prefs-table",">framework/Scheme.html#(def._((lib._framework/main..ss)._scheme~3aget-white-on-black-color-prefs-table))",[0,[1,"scheme:get-white-on-black-color-prefs-table"]],["framework"]],
["scheme:get-wordbreak-map",">framework/Scheme.html#(def._((lib._framework/main..ss)._scheme~3aget-wordbreak-map))",[0,[1,"scheme:get-wordbreak-map"]],["framework"]],
["scheme:init-wordbreak-map",">framework/Scheme.html#(def._((lib._framework/main..ss)._scheme~3ainit-wordbreak-map))",[0,[1,"scheme:init-wordbreak-map"]],["framework"]],
["scheme:set-mode-mixin",">framework/Scheme.html#(def._((lib._framework/main..ss)._scheme~3aset-mode-mixin))",[0,[1,"scheme:set-mode-mixin"]],["framework"]],
["scheme:setup-keymap",">framework/Scheme.html#(def._((lib._framework/main..ss)._scheme~3asetup-keymap))",[0,[1,"scheme:setup-keymap"]],["framework"]],
["scheme:sexp-snip%",">framework/Scheme.html#(def._((lib._framework/main..ss)._scheme~3asexp-snip~25))",[0,[1,"scheme:sexp-snip%"]],["framework"]],
["scheme:sexp-snip<%>",">framework/Scheme.html#(def._((lib._framework/main..ss)._scheme~3asexp-snip~3c~25~3e))",[0,[1,"scheme:sexp-snip&lt;%&gt;"]],["framework"]],
["scheme:short-sym->pref-name",">framework/Scheme.html#(def._((lib._framework/main..ss)._scheme~3ashort-sym-~3epref-name))",[0,[1,"scheme:short-sym-&gt;pref-name"]],["framework"]],
["scheme:short-sym->style-name",">framework/Scheme.html#(def._((lib._framework/main..ss)._scheme~3ashort-sym-~3estyle-name))",[0,[1,"scheme:short-sym-&gt;style-name"]],["framework"]],
["scheme:text%",">framework/Scheme.html#(def._((lib._framework/main..ss)._scheme~3atext~25))",[0,[1,"scheme:text%"]],["framework"]],
["scheme:text-balanced?",">framework/Scheme.html#(def._((lib._framework/main..ss)._scheme~3atext-balanced~3f))",[0,[1,"scheme:text-balanced?"]],["framework"]],
["scheme:text-mixin",">framework/Scheme.html#(def._((lib._framework/main..ss)._scheme~3atext-mixin))",[0,[1,"scheme:text-mixin"]],["framework"]],
["scheme:text-mode%",">framework/Scheme.html#(def._((lib._framework/main..ss)._scheme~3atext-mode~25))",[0,[1,"scheme:text-mode%"]],["framework"]],
["scheme:text-mode-mixin",">framework/Scheme.html#(def._((lib._framework/main..ss)._scheme~3atext-mode-mixin))",[0,[1,"scheme:text-mode-mixin"]],["framework"]],
["scheme:text-mode<%>",">framework/Scheme.html#(def._((lib._framework/main..ss)._scheme~3atext-mode~3c~25~3e))",[0,[1,"scheme:text-mode&lt;%&gt;"]],["framework"]],
["scheme:text<%>",">framework/Scheme.html#(def._((lib._framework/main..ss)._scheme~3atext~3c~25~3e))",[0,[1,"scheme:text&lt;%&gt;"]],["framework"]],
["scheme_add_atexit_closer",">inside/Custodians.html#(idx._(gentag._493._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_add_atexit_closer"]],false],
["scheme_add_evt",">inside/threads.html#(idx._(gentag._318._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_add_evt"]],false],
["scheme_add_evt_through_sema",">inside/threads.html#(idx._(gentag._319._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_add_evt_through_sema"]],false],
["scheme_add_fd_eventmask",">inside/threads.html#(idx._(gentag._317._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_add_fd_eventmask"]],false],
["scheme_add_fd_handle",">inside/threads.html#(idx._(gentag._316._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_add_fd_handle"]],false],
["scheme_add_finalizer",">inside/im_memoryalloc.html#(idx._(gentag._226._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_add_finalizer"]],false],
["scheme_add_finalizer_once",">inside/im_memoryalloc.html#(idx._(gentag._228._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_add_finalizer_once"]],false],
["scheme_add_global",">inside/im_env.html#(idx._(gentag._241._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_add_global"]],false],
["scheme_add_global_symbol",">inside/im_env.html#(idx._(gentag._242._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_add_global_symbol"]],false],
["scheme_add_managed",">inside/Custodians.html#(idx._(gentag._490._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_add_managed"]],false],
["scheme_add_scheme_finalizer",">inside/im_memoryalloc.html#(idx._(gentag._227._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_add_scheme_finalizer"]],false],
["scheme_add_scheme_finalizer_once",">inside/im_memoryalloc.html#(idx._(gentag._229._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_add_scheme_finalizer_once"]],false],
["scheme_add_swap_callback",">inside/threads.html#(idx._(gentag._328._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_add_swap_callback"]],false],
["scheme_add_swap_out_callback",">inside/threads.html#(idx._(gentag._329._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_add_swap_out_callback"]],false],
["scheme_add_to_table",">inside/Miscellaneous_Utilities.html#(idx._(gentag._523._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_add_to_table"]],false],
["scheme_alloc_byte_string",">inside/im_values_types.html#(idx._(gentag._167._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_alloc_byte_string"]],false],
["scheme_alloc_char_string",">inside/im_values_types.html#(idx._(gentag._177._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_alloc_char_string"]],false],
["scheme_allow_set_undefined",">inside/Flags_and_Hooks.html#(idx._(gentag._539._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_allow_set_undefined"]],false],
["scheme_append",">inside/Miscellaneous_Utilities.html#(idx._(gentag._511._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_append"]],false],
["scheme_append_byte_string",">inside/im_values_types.html#(idx._(gentag._168._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_append_byte_string"]],false],
["scheme_append_char_string",">inside/im_values_types.html#(idx._(gentag._178._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_append_char_string"]],false],
["scheme_apply",">inside/Evaluation.html#(idx._(gentag._266._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_apply"]],false],
["scheme_apply_multi",">inside/Evaluation.html#(idx._(gentag._267._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_apply_multi"]],false],
["scheme_apply_to_list",">inside/Evaluation.html#(idx._(gentag._270._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_apply_to_list"]],false],
["scheme_banner",">inside/Miscellaneous_Utilities.html#(idx._(gentag._530._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_banner"]],false],
["scheme_basic_env",">inside/Evaluation.html#(idx._(gentag._264._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_basic_env"]],false],
["scheme_bignum_from_double",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._392._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_bignum_from_double"]],false],
["scheme_bignum_from_float",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._393._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_bignum_from_float"]],false],
["scheme_bignum_normalize",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._397._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_bignum_normalize"]],false],
["scheme_bignum_to_double",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._390._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_bignum_to_double"]],false],
["scheme_bignum_to_float",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._391._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_bignum_to_float"]],false],
["scheme_bignum_to_string",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._394._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_bignum_to_string"]],false],
["scheme_bignum_type",">inside/im_values_types.html#(idx._(gentag._45._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_bignum_type"]],false],
["scheme_bignump",">inside/im_values_types.html#(idx._(gentag._46._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_BIGNUMP"]],false],
["scheme_block_until",">inside/threads.html#(idx._(gentag._309._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_block_until"]],false],
["scheme_block_until_enable_break",">inside/threads.html#(idx._(gentag._310._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_block_until_enable_break"]],false],
["scheme_block_until_unless",">inside/threads.html#(idx._(gentag._311._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_block_until_unless"]],false],
["scheme_bool_type",">inside/im_values_types.html#(idx._(gentag._30._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_bool_type"]],false],
["scheme_boolp",">inside/im_values_types.html#(idx._(gentag._31._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_BOOLP"]],false],
["scheme_box",">inside/im_values_types.html#(idx._(gentag._191._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_box"]],false],
["scheme_box_type",">inside/im_values_types.html#(idx._(gentag._75._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_box_type"]],false],
["scheme_box_val",">inside/im_values_types.html#(idx._(gentag._76._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_BOX_VAL"]],false],
["scheme_boxp",">inside/im_values_types.html#(idx._(gentag._77._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_BOXP"]],false],
["scheme_break_thread",">inside/threads.html#(idx._(gentag._307._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_break_thread"]],false],
["scheme_break_waiting",">inside/threads.html#(idx._(gentag._308._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_break_waiting"]],false],
["scheme_bucket_from_table",">inside/Miscellaneous_Utilities.html#(idx._(gentag._526._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_bucket_from_table"]],false],
["scheme_bucket_table_type",">inside/im_values_types.html#(idx._(gentag._109._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_bucket_table_type"]],false],
["scheme_bucktp",">inside/im_values_types.html#(idx._(gentag._110._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_BUCKTP"]],false],
["scheme_build_list",">inside/Miscellaneous_Utilities.html#(idx._(gentag._502._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_build_list"]],false],
["scheme_build_mac_filename",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._470._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_build_mac_filename"]],false],
["scheme_builtin_value",">inside/im_env.html#(idx._(gentag._247._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_builtin_value"]],false],
["scheme_byte_ready",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._433._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_byte_ready"]],false],
["scheme_byte_str_val",">inside/im_values_types.html#(idx._(gentag._59._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_BYTE_STR_VAL"]],false],
["scheme_byte_string_to_char_string",">inside/im_values_types.html#(idx._(gentag._180._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_byte_string_to_char_string"]],false],
["scheme_byte_string_to_char_string_locale",">inside/im_values_types.html#(idx._(gentag._182._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_byte_string_to_char_string_locale"]],false],
["scheme_byte_string_type",">inside/im_values_types.html#(idx._(gentag._58._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_byte_string_type"]],false],
["scheme_byte_stringp",">inside/im_values_types.html#(idx._(gentag._61._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_BYTE_STRINGP"]],false],
["scheme_byte_strlen_val",">inside/im_values_types.html#(idx._(gentag._60._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_BYTE_STRLEN_VAL"]],false],
["scheme_caddr",">inside/Miscellaneous_Utilities.html#(idx._(gentag._508._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_caddr"]],false],
["scheme_cadr",">inside/Miscellaneous_Utilities.html#(idx._(gentag._507._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_cadr"]],false],
["scheme_call_enable_break",">inside/threads.html#(idx._(gentag._324._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_call_enable_break"]],false],
["scheme_calloc",">inside/im_memoryalloc.html#(idx._(gentag._207._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_calloc"]],false],
["scheme_car",">inside/im_values_types.html#(idx._(gentag._79._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_CAR"]],false],
["scheme_car",">inside/Miscellaneous_Utilities.html#(idx._(gentag._505._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_car"]],false],
["scheme_case_closure_type",">inside/im_values_types.html#(idx._(gentag._125._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_case_closure_type"]],false],
["scheme_case_sensitive",">inside/Flags_and_Hooks.html#(idx._(gentag._538._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_case_sensitive"]],false],
["scheme_cdr",">inside/im_values_types.html#(idx._(gentag._80._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_CDR"]],false],
["scheme_cdr",">inside/Miscellaneous_Utilities.html#(idx._(gentag._506._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_cdr"]],false],
["scheme_change_in_table",">inside/Miscellaneous_Utilities.html#(idx._(gentag._524._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_change_in_table"]],false],
["scheme_char_ready",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._434._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_char_ready"]],false],
["scheme_char_str_val",">inside/im_values_types.html#(idx._(gentag._55._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_CHAR_STR_VAL"]],false],
["scheme_char_string_to_byte_string",">inside/im_values_types.html#(idx._(gentag._179._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_char_string_to_byte_string"]],false],
["scheme_char_string_to_byte_string_locale",">inside/im_values_types.html#(idx._(gentag._181._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_char_string_to_byte_string_locale"]],false],
["scheme_char_string_to_path",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._464._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_char_string_to_path"]],false],
["scheme_char_string_type",">inside/im_values_types.html#(idx._(gentag._53._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_char_string_type"]],false],
["scheme_char_stringp",">inside/im_values_types.html#(idx._(gentag._57._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_CHAR_STRINGP"]],false],
["scheme_char_strlen_val",">inside/im_values_types.html#(idx._(gentag._56._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_CHAR_STRLEN_VAL"]],false],
["scheme_char_type",">inside/im_values_types.html#(idx._(gentag._32._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_char_type"]],false],
["scheme_char_val",">inside/im_values_types.html#(idx._(gentag._33._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_CHAR_VAL"]],false],
["scheme_charp",">inside/im_values_types.html#(idx._(gentag._34._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_CHARP"]],false],
["scheme_check_for_break",">inside/Flags_and_Hooks.html#(idx._(gentag._537._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_check_for_break"]],false],
["scheme_check_proc_arity",">inside/exceptions.html#(idx._(gentag._291._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_check_proc_arity"]],false],
["scheme_check_threads",">inside/threads.html#(idx._(gentag._313._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_check_threads"]],false],
["scheme_clear_escape",">inside/exceptions.html#(idx._(gentag._293._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_clear_escape"]],false],
["scheme_close_input_port",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._440._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_close_input_port"]],false],
["scheme_close_managed",">inside/Custodians.html#(idx._(gentag._492._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_close_managed"]],false],
["scheme_close_output_port",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._441._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_close_output_port"]],false],
["scheme_close_should_force_port_closed",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._479._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_close_should_force_port_closed"]],false],
["scheme_closed_prim_type",">inside/im_values_types.html#(idx._(gentag._121._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_closed_prim_type"]],false],
["scheme_collect_garbage",">inside/im_memoryalloc.html#(idx._(gentag._234._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_collect_garbage"]],false],
["scheme_compile",">inside/Evaluation.html#(idx._(gentag._277._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_compile"]],false],
["scheme_compiled_closure_type",">inside/im_values_types.html#(idx._(gentag._122._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_compiled_closure_type"]],false],
["scheme_complex_imaginary_part",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._407._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_complex_imaginary_part"]],false],
["scheme_complex_izi_type",">inside/im_values_types.html#(idx._(gentag._51._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_complex_izi_type"]],false],
["scheme_complex_izip",">inside/im_values_types.html#(idx._(gentag._52._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_COMPLEX_IZIP"]],false],
["scheme_complex_real_part",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._406._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_complex_real_part"]],false],
["scheme_complex_type",">inside/im_values_types.html#(idx._(gentag._49._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_complex_type"]],false],
["scheme_complexp",">inside/im_values_types.html#(idx._(gentag._50._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_COMPLEXP"]],false],
["scheme_console_output",">inside/Flags_and_Hooks.html#(idx._(gentag._536._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_console_output"]],false],
["scheme_console_printf",">inside/Flags_and_Hooks.html#(idx._(gentag._540._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_console_printf"]],false],
["scheme_cont_type",">inside/im_values_types.html#(idx._(gentag._123._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_cont_type"]],false],
["scheme_count_lines",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._438._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_count_lines"]],false],
["scheme_cpointer_type",">inside/im_values_types.html#(idx._(gentag._116._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_cpointer_type"]],false],
["scheme_cptr_type",">inside/im_values_types.html#(idx._(gentag._118._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_CPTR_TYPE"]],false],
["scheme_cptr_val",">inside/im_values_types.html#(idx._(gentag._117._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_CPTR_VAL"]],false],
["scheme_cptrp",">inside/im_values_types.html#(idx._(gentag._119._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_CPTRP"]],false],
["scheme_current_continuation_marks",">inside/exceptions.html#(idx._(gentag._297._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_current_continuation_marks"]],false],
["scheme_custodian_check_available",">inside/Custodians.html#(idx._(gentag._491._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_custodian_check_available"]],false],
["scheme_dbl_val",">inside/im_values_types.html#(idx._(gentag._40._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_DBL_VAL"]],false],
["scheme_dblp",">inside/im_values_types.html#(idx._(gentag._41._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_DBLP"]],false],
["scheme_debug_print",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._421._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_debug_print"]],false],
["scheme_detach_multiple_array",">inside/Evaluation.html#(idx._(gentag._280._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_detach_multiple_array"]],false],
["scheme_directory_exists",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._461._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_directory_exists"]],false],
["scheme_display",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._411._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_display"]],false],
["scheme_display_to_string",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._419._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_display_to_string"]],false],
["scheme_display_to_string_w_max",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._420._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_display_to_string_w_max"]],false],
["scheme_display_w_max",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._412._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_display_w_max"]],false],
["scheme_dont_gc_ptr",">inside/im_memoryalloc.html#(idx._(gentag._232._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_dont_gc_ptr"]],false],
["scheme_double_to_int",">inside/Miscellaneous_Utilities.html#(idx._(gentag._527._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_double_to_int"]],false],
["scheme_double_type",">inside/im_values_types.html#(idx._(gentag._38._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_double_type"]],false],
["scheme_dynamic_require",">inside/Miscellaneous_Utilities.html#(idx._(gentag._514._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_dynamic_require"]],false],
["scheme_dynamic_wind",">inside/exceptions.html#(idx._(gentag._292._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_dynamic_wind"]],false],
["scheme_end_atomic",">inside/threads.html#(idx._(gentag._326._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_end_atomic"]],false],
["scheme_end_atomic_no_swap",">inside/threads.html#(idx._(gentag._327._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_end_atomic_no_swap"]],false],
["scheme_eof",">inside/im_values_types.html#(idx._(gentag._135._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_eof"]],false],
["scheme_eofp",">inside/im_values_types.html#(idx._(gentag._136._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_EOFP"]],false],
["scheme_eq",">inside/Miscellaneous_Utilities.html#(idx._(gentag._494._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_eq"]],false],
["scheme_equal",">inside/Miscellaneous_Utilities.html#(idx._(gentag._496._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_equal"]],false],
["scheme_equal_hash_key",">inside/Miscellaneous_Utilities.html#(idx._(gentag._498._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_equal_hash_key"]],false],
["scheme_equal_hash_key2",">inside/Miscellaneous_Utilities.html#(idx._(gentag._499._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_equal_hash_key2"]],false],
["scheme_eqv",">inside/Miscellaneous_Utilities.html#(idx._(gentag._495._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_eqv"]],false],
["scheme_escaping_cont_type",">inside/im_values_types.html#(idx._(gentag._124._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_escaping_cont_type"]],false],
["scheme_eval",">inside/Evaluation.html#(idx._(gentag._259._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_eval"]],false],
["scheme_eval_compiled",">inside/Evaluation.html#(idx._(gentag._260._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_eval_compiled"]],false],
["scheme_eval_compiled_multi",">inside/Evaluation.html#(idx._(gentag._261._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_eval_compiled_multi"]],false],
["scheme_eval_string",">inside/Evaluation.html#(idx._(gentag._271._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_eval_string"]],false],
["scheme_eval_string_all",">inside/Evaluation.html#(idx._(gentag._273._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_eval_string_all"]],false],
["scheme_eval_string_multi",">inside/Evaluation.html#(idx._(gentag._272._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_eval_string_multi"]],false],
["scheme_exact_integerp",">inside/im_values_types.html#(idx._(gentag._130._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_EXACT_INTEGERP"]],false],
["scheme_exact_realp",">inside/im_values_types.html#(idx._(gentag._131._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_EXACT_REALP"]],false],
["scheme_exit",">inside/Flags_and_Hooks.html#(idx._(gentag._532._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_exit"]],false],
["scheme_expand",">inside/Evaluation.html#(idx._(gentag._278._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_expand"]],false],
["scheme_expand_filename",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._462._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_expand_filename"]],false],
["scheme_expand_string_filename",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._463._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_expand_string_filename"]],false],
["scheme_extend_config",">inside/config.html#(idx._(gentag._364._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_extend_config"]],false],
["scheme_false",">inside/im_values_types.html#(idx._(gentag._138._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_false"]],false],
["scheme_falsep",">inside/im_values_types.html#(idx._(gentag._139._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_FALSEP"]],false],
["scheme_file_exists",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._460._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_file_exists"]],false],
["scheme_finish_primitive_module",">inside/im_env.html#(idx._(gentag._250._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_finish_primitive_module"]],false],
["scheme_float_type",">inside/im_values_types.html#(idx._(gentag._42._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_float_type"]],false],
["scheme_float_val",">inside/im_values_types.html#(idx._(gentag._39._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_FLOAT_VAL"]],false],
["scheme_floatp",">inside/im_values_types.html#(idx._(gentag._132._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_FLOATP"]],false],
["scheme_flt_val",">inside/im_values_types.html#(idx._(gentag._43._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_FLT_VAL"]],false],
["scheme_fltp",">inside/im_values_types.html#(idx._(gentag._44._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_FLTP"]],false],
["scheme_flush_output",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._422._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_flush_output"]],false],
["scheme_format",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._475._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_format"]],false],
["scheme_format_utf8",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._477._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_format_utf8"]],false],
["scheme_free_code",">inside/im_memoryalloc.html#(idx._(gentag._216._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_free_code"]],false],
["scheme_free_immobile_box",">inside/im_memoryalloc.html#(idx._(gentag._214._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_free_immobile_box"]],false],
["scheme_gc_ptr_ok",">inside/im_memoryalloc.html#(idx._(gentag._233._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_gc_ptr_ok"]],false],
["scheme_get_byte",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._423._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_get_byte"]],false],
["scheme_get_byte_string",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._429._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_get_byte_string"]],false],
["scheme_get_byte_string_output",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._454._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_get_byte_string_output"]],false],
["scheme_get_bytes",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._431._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_get_bytes"]],false],
["scheme_get_char_string",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._430._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_get_char_string"]],false],
["scheme_get_env",">inside/im_env.html#(idx._(gentag._248._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_get_env"]],false],
["scheme_get_fdset",">inside/threads.html#(idx._(gentag._315._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_get_fdset"]],false],
["scheme_get_int_val",">inside/im_values_types.html#(idx._(gentag._155._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_get_int_val"]],false],
["scheme_get_long_long_val",">inside/im_values_types.html#(idx._(gentag._157._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_get_long_long_val"]],false],
["scheme_get_milliseconds",">inside/Miscellaneous_Utilities.html#(idx._(gentag._528._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_get_milliseconds"]],false],
["scheme_get_param",">inside/config.html#(idx._(gentag._360._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_get_param"]],false],
["scheme_get_port_fd",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._443._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_get_port_fd"]],false],
["scheme_get_port_file_descriptor",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._442._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_get_port_file_descriptor"]],false],
["scheme_get_process_milliseconds",">inside/Miscellaneous_Utilities.html#(idx._(gentag._529._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_get_process_milliseconds"]],false],
["scheme_get_sized_byte_string_output",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._455._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_get_sized_byte_string_output"]],false],
["scheme_get_thread_param",">inside/config.html#(idx._(gentag._362._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_get_thread_param"]],false],
["scheme_get_unsigned_int_val",">inside/im_values_types.html#(idx._(gentag._156._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_get_unsigned_int_val"]],false],
["scheme_get_unsigned_long_long_val",">inside/im_values_types.html#(idx._(gentag._158._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_get_unsigned_long_long_val"]],false],
["scheme_getc",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._424._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_getc"]],false],
["scheme_global_bucket",">inside/im_env.html#(idx._(gentag._244._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_global_bucket"]],false],
["scheme_hash_get",">inside/Miscellaneous_Utilities.html#(idx._(gentag._521._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_hash_get"]],false],
["scheme_hash_set",">inside/Miscellaneous_Utilities.html#(idx._(gentag._520._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_hash_set"]],false],
["scheme_hash_table_type",">inside/im_values_types.html#(idx._(gentag._107._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_hash_table_type"]],false],
["scheme_hashtp",">inside/im_values_types.html#(idx._(gentag._108._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_HASHTP"]],false],
["scheme_inherit_cells",">inside/config.html#(idx._(gentag._366._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_inherit_cells"]],false],
["scheme_init_collection_paths",">inside/Flags_and_Hooks.html#(idx._(gentag._543._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_init_collection_paths"]],false],
["scheme_init_collection_paths_post",">inside/Flags_and_Hooks.html#(idx._(gentag._542._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_init_collection_paths_post"]],false],
["scheme_inport_val",">inside/im_values_types.html#(idx._(gentag._96._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_INPORT_VAL"]],false],
["scheme_inportp",">inside/im_values_types.html#(idx._(gentag._97._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_INPORTP"]],false],
["scheme_input_port_record",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._458._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_input_port_record"]],false],
["scheme_input_port_type",">inside/im_values_types.html#(idx._(gentag._95._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_input_port_type"]],false],
["scheme_input_portp",">inside/im_values_types.html#(idx._(gentag._98._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_INPUT_PORTP"]],false],
["scheme_install_config",">inside/config.html#(idx._(gentag._365._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_install_config"]],false],
["scheme_int_val",">inside/im_values_types.html#(idx._(gentag._36._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_INT_VAL"]],false],
["scheme_integer_type",">inside/im_values_types.html#(idx._(gentag._35._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_integer_type"]],false],
["scheme_intern_exact_char_keyword",">inside/im_values_types.html#(idx._(gentag._189._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_intern_exact_char_keyword"]],false],
["scheme_intern_exact_char_symbol",">inside/im_values_types.html#(idx._(gentag._185._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_intern_exact_char_symbol"]],false],
["scheme_intern_exact_keyword",">inside/im_values_types.html#(idx._(gentag._188._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_intern_exact_keyword"]],false],
["scheme_intern_exact_symbol",">inside/im_values_types.html#(idx._(gentag._184._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_intern_exact_symbol"]],false],
["scheme_intern_symbol",">inside/im_values_types.html#(idx._(gentag._183._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_intern_symbol"]],false],
["scheme_intp",">inside/im_values_types.html#(idx._(gentag._37._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_INTP"]],false],
["scheme_is_exact",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._386._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_is_exact"]],false],
["scheme_is_inexact",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._387._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_is_inexact"]],false],
["scheme_is_struct_instance",">inside/Structures.html#(idx._(gentag._484._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_is_struct_instance"]],false],
["scheme_keyword_len",">inside/im_values_types.html#(idx._(gentag._73._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_KEYWORD_LEN"]],false],
["scheme_keyword_type",">inside/im_values_types.html#(idx._(gentag._71._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_keyword_type"]],false],
["scheme_keyword_val",">inside/im_values_types.html#(idx._(gentag._72._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_KEYWORD_VAL"]],false],
["scheme_keywordp",">inside/im_values_types.html#(idx._(gentag._74._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_KEYWORDP"]],false],
["scheme_list_length",">inside/Miscellaneous_Utilities.html#(idx._(gentag._503._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_list_length"]],false],
["scheme_list_to_vector",">inside/Miscellaneous_Utilities.html#(idx._(gentag._510._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_list_to_vector"]],false],
["scheme_load",">inside/Miscellaneous_Utilities.html#(idx._(gentag._516._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_load"]],false],
["scheme_load_extension",">inside/Miscellaneous_Utilities.html#(idx._(gentag._517._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_load_extension"]],false],
["scheme_lookup_global",">inside/im_env.html#(idx._(gentag._243._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_lookup_global"]],false],
["scheme_lookup_in_table",">inside/Miscellaneous_Utilities.html#(idx._(gentag._525._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_lookup_in_table"]],false],
["scheme_mac_path_to_spec",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._471._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_mac_path_to_spec"]],false],
["scheme_main_setup",">inside/im_memoryalloc.html#(idx._(gentag._218._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_main_setup"]],false],
["scheme_main_stack_setup",">inside/im_memoryalloc.html#(idx._(gentag._219._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_main_stack_setup"]],false],
["scheme_make_args_string",">inside/exceptions.html#(idx._(gentag._290._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_args_string"]],false],
["scheme_make_ascii_character",">inside/im_values_types.html#(idx._(gentag._147._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_ascii_character"]],false],
["scheme_make_bignum",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._388._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_bignum"]],false],
["scheme_make_bignum_from_unsigned",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._389._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_bignum_from_unsigned"]],false],
["scheme_make_bucket_table",">inside/Miscellaneous_Utilities.html#(idx._(gentag._522._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_bucket_table"]],false],
["scheme_make_byte_string",">inside/im_values_types.html#(idx._(gentag._163._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_byte_string"]],false],
["scheme_make_byte_string_output_port",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._453._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_byte_string_output_port"]],false],
["scheme_make_byte_string_without_copying",">inside/im_values_types.html#(idx._(gentag._164._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_byte_string_without_copying"]],false],
["scheme_make_char",">inside/im_values_types.html#(idx._(gentag._144._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_char"]],false],
["scheme_make_char_or_null",">inside/im_values_types.html#(idx._(gentag._145._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_char_or_null"]],false],
["scheme_make_char_string",">inside/im_values_types.html#(idx._(gentag._173._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_char_string"]],false],
["scheme_make_char_string_without_copying",">inside/im_values_types.html#(idx._(gentag._174._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_char_string_without_copying"]],false],
["scheme_make_character",">inside/im_values_types.html#(idx._(gentag._146._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_character"]],false],
["scheme_make_closed_prim",">inside/Procedures.html#(idx._(gentag._257._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_closed_prim"]],false],
["scheme_make_closed_prim_w_arity",">inside/Procedures.html#(idx._(gentag._256._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_closed_prim_w_arity"]],false],
["scheme_make_complex",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._405._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_complex"]],false],
["scheme_make_cptr",">inside/im_values_types.html#(idx._(gentag._194._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_cptr"]],false],
["scheme_make_custodian",">inside/Custodians.html#(idx._(gentag._489._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_custodian"]],false],
["scheme_make_double",">inside/im_values_types.html#(idx._(gentag._159._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_double"]],false],
["scheme_make_exact_symbol",">inside/im_values_types.html#(idx._(gentag._187._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_exact_symbol"]],false],
["scheme_make_fd_input_port",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._452._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_fd_input_port"]],false],
["scheme_make_file_input_port",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._447._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_file_input_port"]],false],
["scheme_make_file_output_port",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._451._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_file_output_port"]],false],
["scheme_make_float",">inside/im_values_types.html#(idx._(gentag._160._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_float"]],false],
["scheme_make_folding_prim",">inside/Procedures.html#(idx._(gentag._253._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_folding_prim"]],false],
["scheme_make_hash_table",">inside/Miscellaneous_Utilities.html#(idx._(gentag._518._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_hash_table"]],false],
["scheme_make_hash_table_equal",">inside/Miscellaneous_Utilities.html#(idx._(gentag._519._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_hash_table_equal"]],false],
["scheme_make_input_port",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._445._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_input_port"]],false],
["scheme_make_integer",">inside/im_values_types.html#(idx._(gentag._148._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_integer"]],false],
["scheme_make_integer_value",">inside/im_values_types.html#(idx._(gentag._149._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_integer_value"]],false],
["scheme_make_integer_value_from_long_halves",">inside/im_values_types.html#(idx._(gentag._153._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_integer_value_from_long_halves"]],false],
["scheme_make_integer_value_from_long_long",">inside/im_values_types.html#(idx._(gentag._151._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_integer_value_from_long_long"]],false],
["scheme_make_integer_value_from_unsigned",">inside/im_values_types.html#(idx._(gentag._150._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_integer_value_from_unsigned"]],false],
["scheme_make_integer_value_from_unsigned_long_halves",">inside/im_values_types.html#(idx._(gentag._154._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_integer_value_from_unsigned_long_halves"]],false],
["scheme_make_integer_value_from_unsigned_long_long",">inside/im_values_types.html#(idx._(gentag._152._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_integer_value_from_unsigned_long_long"]],false],
["scheme_make_locale_string",">inside/im_values_types.html#(idx._(gentag._169._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_locale_string"]],false],
["scheme_make_named_file_input_port",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._449._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_named_file_input_port"]],false],
["scheme_make_namespace",">inside/Evaluation.html#(idx._(gentag._265._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_namespace"]],false],
["scheme_make_offset_cptr",">inside/im_values_types.html#(idx._(gentag._195._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_offset_cptr"]],false],
["scheme_make_output_port",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._446._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_output_port"]],false],
["scheme_make_pair",">inside/im_values_types.html#(idx._(gentag._162._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_pair"]],false],
["scheme_make_path",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._466._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_path"]],false],
["scheme_make_path_without_copying",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._467._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_path_without_copying"]],false],
["scheme_make_port_type",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._444._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_port_type"]],false],
["scheme_make_prim",">inside/Procedures.html#(idx._(gentag._254._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_prim"]],false],
["scheme_make_prim_closure_w_arity",">inside/Procedures.html#(idx._(gentag._255._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_prim_closure_w_arity"]],false],
["scheme_make_prim_w_arity",">inside/Procedures.html#(idx._(gentag._251._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_prim_w_arity"]],false],
["scheme_make_provided_string",">inside/exceptions.html#(idx._(gentag._289._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_provided_string"]],false],
["scheme_make_rational",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._398._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_rational"]],false],
["scheme_make_sema",">inside/threads.html#(idx._(gentag._301._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_sema"]],false],
["scheme_make_sized_byte_string",">inside/im_values_types.html#(idx._(gentag._165._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_sized_byte_string"]],false],
["scheme_make_sized_char_string",">inside/im_values_types.html#(idx._(gentag._175._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_sized_char_string"]],false],
["scheme_make_sized_offset_byte_string",">inside/im_values_types.html#(idx._(gentag._166._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_sized_offset_byte_string"]],false],
["scheme_make_sized_offset_char_string",">inside/im_values_types.html#(idx._(gentag._176._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_sized_offset_char_string"]],false],
["scheme_make_sized_offset_path",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._469._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_sized_offset_path"]],false],
["scheme_make_sized_offset_utf8_string",">inside/im_values_types.html#(idx._(gentag._172._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_sized_offset_utf8_string"]],false],
["scheme_make_sized_path",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._468._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_sized_path"]],false],
["scheme_make_sized_utf8_string",">inside/im_values_types.html#(idx._(gentag._171._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_sized_utf8_string"]],false],
["scheme_make_stderr",">inside/Flags_and_Hooks.html#(idx._(gentag._535._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_stderr"]],false],
["scheme_make_stdin",">inside/Flags_and_Hooks.html#(idx._(gentag._533._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_stdin"]],false],
["scheme_make_stdout",">inside/Flags_and_Hooks.html#(idx._(gentag._534._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_stdout"]],false],
["scheme_make_struct_instance",">inside/Structures.html#(idx._(gentag._483._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_struct_instance"]],false],
["scheme_make_struct_names",">inside/Structures.html#(idx._(gentag._481._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_struct_names"]],false],
["scheme_make_struct_type",">inside/Structures.html#(idx._(gentag._480._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_struct_type"]],false],
["scheme_make_struct_values",">inside/Structures.html#(idx._(gentag._482._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_struct_values"]],false],
["scheme_make_symbol",">inside/im_values_types.html#(idx._(gentag._186._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_symbol"]],false],
["scheme_make_thread_cell",">inside/threads.html#(idx._(gentag._325._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_thread_cell"]],false],
["scheme_make_type",">inside/im_values_types.html#(idx._(gentag._193._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_type"]],false],
["scheme_make_utf8_string",">inside/im_values_types.html#(idx._(gentag._170._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_utf8_string"]],false],
["scheme_make_vector",">inside/im_values_types.html#(idx._(gentag._190._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_vector"]],false],
["scheme_make_weak_box",">inside/im_values_types.html#(idx._(gentag._192._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_make_weak_box"]],false],
["scheme_making_progress",">inside/threads.html#(idx._(gentag._320._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_making_progress"]],false],
["scheme_malloc",">inside/im_memoryalloc.html#(idx._(gentag._203._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_malloc"]],false],
["scheme_malloc_allow_interior",">inside/im_memoryalloc.html#(idx._(gentag._209._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_malloc_allow_interior"]],false],
["scheme_malloc_atomic",">inside/im_memoryalloc.html#(idx._(gentag._204._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_malloc_atomic"]],false],
["scheme_malloc_code",">inside/im_memoryalloc.html#(idx._(gentag._215._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_malloc_code"]],false],
["scheme_malloc_eternal",">inside/im_memoryalloc.html#(idx._(gentag._206._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_malloc_eternal"]],false],
["scheme_malloc_fail_ok",">inside/im_memoryalloc.html#(idx._(gentag._212._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_malloc_fail_ok"]],false],
["scheme_malloc_immobile_box",">inside/im_memoryalloc.html#(idx._(gentag._213._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_malloc_immobile_box"]],false],
["scheme_malloc_tagged",">inside/im_memoryalloc.html#(idx._(gentag._208._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_malloc_tagged"]],false],
["scheme_malloc_uncollectable",">inside/im_memoryalloc.html#(idx._(gentag._205._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_malloc_uncollectable"]],false],
["scheme_mcar",">inside/im_values_types.html#(idx._(gentag._83._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_MCAR"]],false],
["scheme_mcdr",">inside/im_values_types.html#(idx._(gentag._84._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_MCDR"]],false],
["scheme_module_bucket",">inside/im_env.html#(idx._(gentag._245._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_module_bucket"]],false],
["scheme_mpairp",">inside/im_values_types.html#(idx._(gentag._85._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_MPAIRP"]],false],
["scheme_mutable_pair_type",">inside/im_values_types.html#(idx._(gentag._82._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_mutable_pair_type"]],false],
["scheme_namespace_require",">inside/Miscellaneous_Utilities.html#(idx._(gentag._515._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_namespace_require"]],false],
["scheme_namespace_type",">inside/im_values_types.html#(idx._(gentag._114._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_namespace_type"]],false],
["scheme_namespacep",">inside/im_values_types.html#(idx._(gentag._115._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_NAMESPACEP"]],false],
["scheme_native_closure_type",">inside/im_values_types.html#(idx._(gentag._126._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_native_closure_type"]],false],
["scheme_need_wakeup",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._435._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_need_wakeup"]],false],
["scheme_new_param",">inside/config.html#(idx._(gentag._367._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_new_param"]],false],
["scheme_null",">inside/im_values_types.html#(idx._(gentag._133._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_null"]],false],
["scheme_nullp",">inside/im_values_types.html#(idx._(gentag._134._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_NULLP"]],false],
["scheme_numberp",">inside/im_values_types.html#(idx._(gentag._128._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_NUMBERP"]],false],
["scheme_open_input_file",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._448._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_open_input_file"]],false],
["scheme_open_output_file",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._450._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_open_output_file"]],false],
["scheme_os_getcwd",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._472._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_os_getcwd"]],false],
["scheme_os_setcwd",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._474._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_os_setcwd"]],false],
["scheme_outport_val",">inside/im_values_types.html#(idx._(gentag._100._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_OUTPORT_VAL"]],false],
["scheme_outportp",">inside/im_values_types.html#(idx._(gentag._101._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_OUTPORTP"]],false],
["scheme_output_port_record",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._459._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_output_port_record"]],false],
["scheme_output_port_type",">inside/im_values_types.html#(idx._(gentag._99._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_output_port_type"]],false],
["scheme_output_portp",">inside/im_values_types.html#(idx._(gentag._102._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_OUTPUT_PORTP"]],false],
["scheme_pair_type",">inside/im_values_types.html#(idx._(gentag._78._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_pair_type"]],false],
["scheme_pairp",">inside/im_values_types.html#(idx._(gentag._81._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_PAIRP"]],false],
["scheme_param_config",">inside/config.html#(idx._(gentag._369._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_param_config"]],false],
["scheme_path_len",">inside/im_values_types.html#(idx._(gentag._65._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_PATH_LEN"]],false],
["scheme_path_to_char_string",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._465._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_path_to_char_string"]],false],
["scheme_path_type",">inside/im_values_types.html#(idx._(gentag._62._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_path_type"]],false],
["scheme_path_val",">inside/im_values_types.html#(idx._(gentag._64._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_PATH_VAL"]],false],
["scheme_pathp",">inside/im_values_types.html#(idx._(gentag._66._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_PATHP"]],false],
["scheme_peek_byte",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._425._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_peek_byte"]],false],
["scheme_peek_byte_skip",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._427._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_peek_byte_skip"]],false],
["scheme_peekc",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._426._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_peekc"]],false],
["scheme_peekc_skip",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._428._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_peekc_skip"]],false],
["scheme_pipe",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._456._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_pipe"]],false],
["scheme_pipe_with_limit",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._457._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_pipe_with_limit"]],false],
["scheme_pop_break_enable",">inside/exceptions.html#(idx._(gentag._296._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_pop_break_enable"]],false],
["scheme_pop_continuation_frame",">inside/contmarks.html#(idx._(gentag._372._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_pop_continuation_frame"]],false],
["scheme_post_sema",">inside/threads.html#(idx._(gentag._302._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_post_sema"]],false],
["scheme_prim_type",">inside/im_values_types.html#(idx._(gentag._120._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_prim_type"]],false],
["scheme_primitive_module",">inside/im_env.html#(idx._(gentag._249._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_primitive_module"]],false],
["scheme_print_bytes",">inside/im_values_types.html#(idx._(gentag._197._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_print_bytes"]],false],
["scheme_print_string",">inside/im_values_types.html#(idx._(gentag._198._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_print_string"]],false],
["scheme_printf",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._476._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_printf"]],false],
["scheme_printf_utf8",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._478._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_printf_utf8"]],false],
["scheme_procp",">inside/im_values_types.html#(idx._(gentag._127._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_PROCP"]],false],
["scheme_proper_list_length",">inside/Miscellaneous_Utilities.html#(idx._(gentag._504._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_proper_list_length"]],false],
["scheme_push_break_enable",">inside/exceptions.html#(idx._(gentag._295._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_push_break_enable"]],false],
["scheme_push_continuation_frame",">inside/contmarks.html#(idx._(gentag._371._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_push_continuation_frame"]],false],
["scheme_put_byte_string",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._415._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_put_byte_string"]],false],
["scheme_put_char_string",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._416._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_put_char_string"]],false],
["scheme_raise_exn",">inside/exceptions.html#(idx._(gentag._283._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_raise_exn"]],false],
["scheme_rational_denominator",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._402._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_rational_denominator"]],false],
["scheme_rational_from_double",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._403._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_rational_from_double"]],false],
["scheme_rational_from_float",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._404._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_rational_from_float"]],false],
["scheme_rational_numerator",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._401._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_rational_numerator"]],false],
["scheme_rational_to_double",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._399._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_rational_to_double"]],false],
["scheme_rational_to_float",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._400._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_rational_to_float"]],false],
["scheme_rational_type",">inside/im_values_types.html#(idx._(gentag._47._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_rational_type"]],false],
["scheme_rationalp",">inside/im_values_types.html#(idx._(gentag._48._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_RATIONALP"]],false],
["scheme_read",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._408._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_read"]],false],
["scheme_read_bignum",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._395._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_read_bignum"]],false],
["scheme_read_bignum_bytes",">inside/Bignums__Rationals__and_Complex_Numbers.html#(idx._(gentag._396._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_read_bignum_bytes"]],false],
["scheme_real_to_double",">inside/im_values_types.html#(idx._(gentag._161._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_real_to_double"]],false],
["scheme_realp",">inside/im_values_types.html#(idx._(gentag._129._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_REALP"]],false],
["scheme_recur_equal",">inside/Miscellaneous_Utilities.html#(idx._(gentag._497._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_recur_equal"]],false],
["scheme_recur_equal_hash_key",">inside/Miscellaneous_Utilities.html#(idx._(gentag._500._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_recur_equal_hash_key"]],false],
["scheme_recur_equal_hash_key2",">inside/Miscellaneous_Utilities.html#(idx._(gentag._501._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_recur_equal_hash_key2"]],false],
["scheme_register_extension_global",">inside/im_memoryalloc.html#(idx._(gentag._217._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_register_extension_global"]],false],
["scheme_register_finalizer",">inside/im_memoryalloc.html#(idx._(gentag._225._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_register_finalizer"]],false],
["scheme_register_parameter",">inside/config.html#(idx._(gentag._368._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_register_parameter"]],false],
["scheme_register_static",">inside/im_memoryalloc.html#(idx._(gentag._222._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_register_static"]],false],
["scheme_remove_all_finalization",">inside/im_memoryalloc.html#(idx._(gentag._231._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_remove_all_finalization"]],false],
["scheme_security_check_file",">inside/security.html#(idx._(gentag._487._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_security_check_file"]],false],
["scheme_security_check_network",">inside/security.html#(idx._(gentag._488._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_security_check_network"]],false],
["scheme_sema_type",">inside/im_values_types.html#(idx._(gentag._105._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_sema_type"]],false],
["scheme_semap",">inside/im_values_types.html#(idx._(gentag._106._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_SEMAP"]],false],
["scheme_set_box",">inside/Miscellaneous_Utilities.html#(idx._(gentag._513._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_set_box"]],false],
["scheme_set_can_break",">inside/exceptions.html#(idx._(gentag._294._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_set_can_break"]],false],
["scheme_set_collects_path",">inside/Flags_and_Hooks.html#(idx._(gentag._541._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_set_collects_path"]],false],
["scheme_set_cont_mark",">inside/contmarks.html#(idx._(gentag._370._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_set_cont_mark"]],false],
["scheme_set_file_position",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._439._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_set_file_position"]],false],
["scheme_set_global_bucket",">inside/im_env.html#(idx._(gentag._246._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_set_global_bucket"]],false],
["scheme_set_param",">inside/config.html#(idx._(gentag._361._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_set_param"]],false],
["scheme_set_stack_base",">inside/im_memoryalloc.html#(idx._(gentag._220._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_set_stack_base"]],false],
["scheme_set_stack_bounds",">inside/im_memoryalloc.html#(idx._(gentag._221._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_set_stack_bounds"]],false],
["scheme_set_thread_param",">inside/config.html#(idx._(gentag._363._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_set_thread_param"]],false],
["scheme_set_type_equality",">inside/im_values_types.html#(idx._(gentag._199._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_set_type_equality"]],false],
["scheme_set_type_printer",">inside/im_values_types.html#(idx._(gentag._196._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_set_type_printer"]],false],
["scheme_signal_error",">inside/exceptions.html#(idx._(gentag._282._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_signal_error"]],false],
["scheme_signal_received",">inside/threads.html#(idx._(gentag._312._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_signal_received"]],false],
["scheme_strdup",">inside/im_memoryalloc.html#(idx._(gentag._210._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_strdup"]],false],
["scheme_strdup_eternal",">inside/im_memoryalloc.html#(idx._(gentag._211._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_strdup_eternal"]],false],
["scheme_struct_property_type",">inside/im_values_types.html#(idx._(gentag._94._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_struct_property_type"]],false],
["scheme_struct_ref",">inside/Structures.html#(idx._(gentag._485._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_struct_ref"]],false],
["scheme_struct_set",">inside/Structures.html#(idx._(gentag._486._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_struct_set"]],false],
["scheme_struct_type_type",">inside/im_values_types.html#(idx._(gentag._92._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_struct_type_type"]],false],
["scheme_struct_typep",">inside/im_values_types.html#(idx._(gentag._93._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_STRUCT_TYPEP"]],false],
["scheme_structp",">inside/im_values_types.html#(idx._(gentag._91._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_STRUCTP"]],false],
["scheme_structure_type",">inside/im_values_types.html#(idx._(gentag._90._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_structure_type"]],false],
["scheme_subtract_finalizer",">inside/im_memoryalloc.html#(idx._(gentag._230._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_subtract_finalizer"]],false],
["scheme_swap_thread",">inside/threads.html#(idx._(gentag._306._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_swap_thread"]],false],
["scheme_sym_len",">inside/im_values_types.html#(idx._(gentag._69._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_SYM_LEN"]],false],
["scheme_sym_val",">inside/im_values_types.html#(idx._(gentag._68._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_SYM_VAL"]],false],
["scheme_symbol_type",">inside/im_values_types.html#(idx._(gentag._67._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_symbol_type"]],false],
["scheme_symbolp",">inside/im_values_types.html#(idx._(gentag._70._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_SYMBOLP"]],false],
["scheme_tail_apply",">inside/Evaluation.html#(idx._(gentag._274._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_tail_apply"]],false],
["scheme_tail_apply_no_copy",">inside/Evaluation.html#(idx._(gentag._275._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_tail_apply_no_copy"]],false],
["scheme_tail_apply_to_list",">inside/Evaluation.html#(idx._(gentag._276._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_tail_apply_to_list"]],false],
["scheme_tell",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._436._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_tell"]],false],
["scheme_tell_line",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._437._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_tell_line"]],false],
["scheme_thread",">inside/threads.html#(idx._(gentag._299._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_thread"]],false],
["scheme_thread_block",">inside/threads.html#(idx._(gentag._304._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_thread_block"]],false],
["scheme_thread_block_enable_break",">inside/threads.html#(idx._(gentag._305._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_thread_block_enable_break"]],false],
["scheme_thread_type",">inside/im_values_types.html#(idx._(gentag._103._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_thread_type"]],false],
["scheme_thread_w_details",">inside/threads.html#(idx._(gentag._300._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_thread_w_details"]],false],
["scheme_threadp",">inside/im_values_types.html#(idx._(gentag._104._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_THREADP"]],false],
["scheme_tls_allocate",">inside/threads.html#(idx._(gentag._321._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_tls_allocate"]],false],
["scheme_tls_get",">inside/threads.html#(idx._(gentag._323._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_tls_get"]],false],
["scheme_tls_set",">inside/threads.html#(idx._(gentag._322._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_tls_set"]],false],
["scheme_true",">inside/im_values_types.html#(idx._(gentag._137._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_true"]],false],
["scheme_truep",">inside/im_values_types.html#(idx._(gentag._140._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_TRUEP"]],false],
["scheme_type",">inside/im_values_types.html#(idx._(gentag._28._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_TYPE"]],false],
["scheme_ucs4_to_utf16",">inside/im_encodings.html#(idx._(gentag._384._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_ucs4_to_utf16"]],false],
["scheme_unbound_global",">inside/exceptions.html#(idx._(gentag._288._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_unbound_global"]],false],
["scheme_unbox",">inside/Miscellaneous_Utilities.html#(idx._(gentag._512._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_unbox"]],false],
["scheme_undefined",">inside/im_values_types.html#(idx._(gentag._143._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_undefined"]],false],
["scheme_ungetc",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._432._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_ungetc"]],false],
["scheme_utf16_to_ucs4",">inside/im_encodings.html#(idx._(gentag._385._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_utf16_to_ucs4"]],false],
["scheme_utf8_decode",">inside/im_encodings.html#(idx._(gentag._373._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_utf8_decode"]],false],
["scheme_utf8_decode_all",">inside/im_encodings.html#(idx._(gentag._375._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_utf8_decode_all"]],false],
["scheme_utf8_decode_as_prefix",">inside/im_encodings.html#(idx._(gentag._374._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_utf8_decode_as_prefix"]],false],
["scheme_utf8_decode_count",">inside/im_encodings.html#(idx._(gentag._379._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_utf8_decode_count"]],false],
["scheme_utf8_decode_prefix",">inside/im_encodings.html#(idx._(gentag._376._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_utf8_decode_prefix"]],false],
["scheme_utf8_decode_to_buffer",">inside/im_encodings.html#(idx._(gentag._377._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_utf8_decode_to_buffer"]],false],
["scheme_utf8_decode_to_buffer_len",">inside/im_encodings.html#(idx._(gentag._378._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_utf8_decode_to_buffer_len"]],false],
["scheme_utf8_encode",">inside/im_encodings.html#(idx._(gentag._380._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_utf8_encode"]],false],
["scheme_utf8_encode_all",">inside/im_encodings.html#(idx._(gentag._381._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_utf8_encode_all"]],false],
["scheme_utf8_encode_to_buffer",">inside/im_encodings.html#(idx._(gentag._382._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_utf8_encode_to_buffer"]],false],
["scheme_utf8_encode_to_buffer_len",">inside/im_encodings.html#(idx._(gentag._383._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_utf8_encode_to_buffer_len"]],false],
["scheme_values",">inside/Evaluation.html#(idx._(gentag._279._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_values"]],false],
["scheme_vec_els",">inside/im_values_types.html#(idx._(gentag._88._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_VEC_ELS"]],false],
["scheme_vec_size",">inside/im_values_types.html#(idx._(gentag._87._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_VEC_SIZE"]],false],
["scheme_vector_to_list",">inside/Miscellaneous_Utilities.html#(idx._(gentag._509._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_vector_to_list"]],false],
["scheme_vector_type",">inside/im_values_types.html#(idx._(gentag._86._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_vector_type"]],false],
["scheme_vectorp",">inside/im_values_types.html#(idx._(gentag._89._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_VECTORP"]],false],
["scheme_version",">inside/Miscellaneous_Utilities.html#(idx._(gentag._531._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_version"]],false],
["scheme_void",">inside/im_values_types.html#(idx._(gentag._141._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_void"]],false],
["scheme_voidp",">inside/im_values_types.html#(idx._(gentag._142._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_VOIDP"]],false],
["scheme_wait_sema",">inside/threads.html#(idx._(gentag._303._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_wait_sema"]],false],
["scheme_wake_up",">inside/threads.html#(idx._(gentag._314._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_wake_up"]],false],
["scheme_warning",">inside/exceptions.html#(idx._(gentag._284._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_warning"]],false],
["scheme_weak_box_type",">inside/im_values_types.html#(idx._(gentag._111._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_weak_box_type"]],false],
["scheme_weak_ptr",">inside/im_values_types.html#(idx._(gentag._113._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_WEAK_PTR"]],false],
["scheme_weak_reference",">inside/im_memoryalloc.html#(idx._(gentag._223._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_weak_reference"]],false],
["scheme_weak_reference_indirect",">inside/im_memoryalloc.html#(idx._(gentag._224._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_weak_reference_indirect"]],false],
["scheme_weakp",">inside/im_values_types.html#(idx._(gentag._112._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"SCHEME_WEAKP"]],false],
["scheme_write",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._409._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_write"]],false],
["scheme_write_byte_string",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._413._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_write_byte_string"]],false],
["scheme_write_char_string",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._414._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_write_char_string"]],false],
["scheme_write_to_string",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._417._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_write_to_string"]],false],
["scheme_write_to_string_w_max",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._418._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_write_to_string_w_max"]],false],
["scheme_write_w_max",">inside/Ports_and_the_Filesystem.html#(idx._(gentag._410._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_write_w_max"]],false],
["scheme_wrong_count",">inside/exceptions.html#(idx._(gentag._285._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_wrong_count"]],false],
["scheme_wrong_return_arity",">inside/exceptions.html#(idx._(gentag._287._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_wrong_return_arity"]],false],
["scheme_wrong_type",">inside/exceptions.html#(idx._(gentag._286._(lib._scribblings/inside/inside..scrbl)))",[6,[5,"scheme_wrong_type"]],false],
["schemeblock",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..ss)._.S.C.H.E.M.E.B.L.O.C.K))",[0,[6,"SCHEMEBLOCK"]],["scribble/manual"]],
["schemeblock",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..ss)._schemeblock))",[0,[6,"schemeblock"]],["scribble/manual"]],
["schemeblock+eval",">scribble/eval.html#(form._((lib._scribble/eval..ss)._schemeblock+eval))",[0,[6,"schemeblock+eval"]],["scribble/eval"]],
["schemeblock0",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..ss)._.S.C.H.E.M.E.B.L.O.C.K0))",[0,[6,"SCHEMEBLOCK0"]],["scribble/manual"]],
["schemeblock0",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..ss)._schemeblock0))",[0,[6,"schemeblock0"]],["scribble/manual"]],
["schemeerror",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..ss)._schemeerror))",[0,[1,"schemeerror"]],["scribble/manual"]],
["schemeerror com event",">mzcom/index.html#(idx._(gentag._3._(lib._mzcom/mzcom..scrbl)))",[[5,"SchemeError"]," COM event"],false],
["schemefont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..ss)._schemefont))",[0,[1,"schemefont"]],["scribble/manual"]],
["schemegrammar",">scribble/doc-forms.html#(form._((lib._scribble/manual..ss)._schemegrammar))",[0,[6,"schemegrammar"]],["scribble/manual"]],
["schemegrammar*",">scribble/doc-forms.html#(form._((lib._scribble/manual..ss)._schemegrammar*))",[0,[6,"schemegrammar*"]],["scribble/manual"]],
["schemeid",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..ss)._schemeid))",[0,[6,"schemeid"]],["scribble/manual"]],
["schemeidfont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..ss)._schemeidfont))",[0,[1,"schemeidfont"]],["scribble/manual"]],
["schemeinput",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..ss)._schemeinput))",[0,[6,"schemeinput"]],["scribble/manual"]],
["schemekeywordfont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..ss)._schemekeywordfont))",[0,[1,"schemekeywordfont"]],["scribble/manual"]],
["schemelink",">scribble/section-links.html#(def._((lib._scribble/manual..ss)._schemelink))",[0,[1,"schemelink"]],["scribble/manual"]],
["schememetafont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..ss)._schememetafont))",[0,[1,"schememetafont"]],["scribble/manual"]],
["schememod",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..ss)._schememod))",[0,[6,"schememod"]],["scribble/manual"]],
["schememod+eval",">scribble/eval.html#(form._((lib._scribble/eval..ss)._schememod+eval))",[0,[6,"schememod+eval"]],["scribble/eval"]],
["schememodname",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..ss)._schememodname))",[0,[6,"schememodname"]],["scribble/manual"]],
["schemeparenfont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..ss)._schemeparenfont))",[0,[1,"schemeparenfont"]],["scribble/manual"]],
["schemeresult",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..ss)._schemeresult))",[0,[6,"schemeresult"]],["scribble/manual"]],
["schemeresultfont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..ss)._schemeresultfont))",[0,[1,"schemeresultfont"]],["scribble/manual"]],
["schemevalfont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..ss)._schemevalfont))",[0,[1,"schemevalfont"]],["scribble/manual"]],
["schemevarfont",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..ss)._schemevarfont))",[0,[1,"schemevarfont"]],["scribble/manual"]],
["scope",">reference/syntax-model.html#(tech._scope)","<i>scope</i>",false],
["screen resolution",">gui/Drawing_Functions.html#(idx._(gentag._231._(lib._scribblings/gui/gui..scrbl)))","screen resolution",false],
["screen->client",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._screen-~3eclient))",[[0,[1,"screen-&gt;client"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["screen-glyph-exists?",">gui/font_.html#(meth._(((lib._mred/main..ss)._font~25)._screen-glyph-exists~3f))",[[0,[1,"screen-glyph-exists?"]],[12,[" (method of ",[0,[1,"font%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["screen_gamma",">gui/bitmap_.html#(idx._(gentag._171._(lib._scribblings/gui/gui..scrbl)))",[5,"SCREEN_GAMMA"],false],
["scribble layers",">scribble/layers.html","Scribble Layers",false],
["scribble-eval-handler",">scribble/eval.html#(def._((lib._scribble/eval..ss)._scribble-eval-handler))",[0,[1,"scribble-eval-handler"]],["scribble/eval"]],
["scribble/base-render",">scribble/renderer.html#(mod-path._scribble/base-render)",[14,[0,"scribble/base-render"]],"module"],
["scribble/basic",">scribble/basic.html",[14,[0,"scribble/basic"]],"module"],
["scribble/bnf",">scribble/bnf.html",[14,[0,"scribble/bnf"]],"module"],
["scribble/decode",">scribble/decode.html",[14,[0,"scribble/decode"]],"module"],
["scribble/doc",">scribble/docreader.html",[14,[0,"scribble/doc"]],"module"],
["scribble/doclang",">scribble/doclang.html",[14,[0,"scribble/doclang"]],"module"],
["scribble/eval",">scribble/eval.html",[14,[0,"scribble/eval"]],"module"],
["scribble/html-render",">scribble/renderer.html#(mod-path._scribble/html-render)",[14,[0,"scribble/html-render"]],"module"],
["scribble/latex-render",">scribble/renderer.html#(mod-path._scribble/latex-render)",[14,[0,"scribble/latex-render"]],"module"],
["scribble/manual",">scribble/manual.html",[14,[0,"scribble/manual"]],"module"],
["scribble/manual-struct",">scribble/index-entries.html",[14,[0,"scribble/manual-struct"]],"module"],
["scribble/reader",">scribble/reader.html#(mod-path._scribble/reader)",[14,[0,"scribble/reader"]],"module"],
["scribble/scheme",">scribble/scheme.html",[14,[0,"scribble/scheme"]],"module"],
["scribble/struct",">scribble/struct.html",[14,[0,"scribble/struct"]],"module"],
["scribble/text",">scribble/preprocessor.html",[14,[0,"scribble/text"]],"module"],
["scribble/text-render",">scribble/renderer.html#(mod-path._scribble/text-render)",[14,[0,"scribble/text-render"]],"module"],
["scribble/xref",">scribble/xref.html",[14,[0,"scribble/xref"]],"module"],
["scribble: plt documentation tool",">scribble/index.html","<b>Scribble</b>: PLT Documentation Tool",false],
["scribblings",">setup-plt/running.html#(idx._(gentag._0._(lib._scribblings/setup-plt/setup-plt..scrbl)))",[0,"scribblings"],false],
["scribblings",">mzc/Scheme_API_for_Compilation.html#(idx._(gentag._63._(lib._scribblings/mzc/mzc..scrbl)))",[0,"scribblings"],false],
["script",">html/index.html#(def._((lib._html/main..ss)._script))",[0,[1,"script"]],["html"]],
["script",">gui/font_.html#(idx._(gentag._197._(lib._scribblings/gui/gui..scrbl)))",[7,"'script"],false],
["script",">gui/style-delta_.html#(idx._(gentag._282._(lib._scribblings/gui/gui..scrbl)))",[7,"'script"],false],
["script-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._script-element))",[0,[1,"script-element"]],["scribble/struct"]],
["script-element-script",">scribble/struct.html#(def._((lib._scribble/struct..ss)._script-element-script))",[0,[1,"script-element-script"]],["scribble/struct"]],
["script-element-type",">scribble/struct.html#(def._((lib._scribble/struct..ss)._script-element-type))",[0,[1,"script-element-type"]],["scribble/struct"]],
["script-element?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._script-element~3f))",[0,[1,"script-element?"]],["scribble/struct"]],
["script?",">html/index.html#(def._((lib._html/main..ss)._script~3f))",[0,[1,"script?"]],["html"]],
["scripts",">web-server/web-config-unit_ss.html#(sig-val._((lib._web-server/web-config-sig..ss)._web-config~5e._scripts))",[0,[1,"scripts"]],["web-server/web-config-sig"]],
["scroll",">gui/canvas_.html#(meth._(((lib._mred/main..ss)._canvas~25)._scroll))",[[0,[1,"scroll"]],[12,[" (method of ",[0,[1,"canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["scroll",">gui/key-event_.html#(idx._(gentag._111._(lib._scribblings/gui/gui..scrbl)))",[7,"'scroll"],false],
["scroll-editor-to",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._scroll-editor-to))",[[0,[1,"scroll-editor-to"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["scroll-editor-to",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3afirst-line-mixin)._scroll-editor-to))",[[0,[1,"scroll-editor-to"]],[12,[" (method of ",[0,[1,"text:first-line-mixin"]],")"]]],["framework"]],
["scroll-event%",">gui/scroll-event_.html",[0,[1,"scroll-event%"]],["scheme/gui/base","scheme/gui"]],
["scroll-line-location",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._scroll-line-location))",[[0,[1,"scroll-line-location"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["scroll-to",">gui/editor-admin_.html#(meth._(((lib._mred/main..ss)._editor-admin~25)._scroll-to))",[[0,[1,"scroll-to"]],[12,[" (method of ",[0,[1,"editor-admin%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["scroll-to",">gui/editor-canvas_.html#(meth._(((lib._mred/main..ss)._editor-canvas~25)._scroll-to))",[[0,[1,"scroll-to"]],[12,[" (method of ",[0,[1,"editor-canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["scroll-to",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._scroll-to))",[[0,[1,"scroll-to"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["scroll-to",">gui/snip-admin_.html#(meth._(((lib._mred/main..ss)._snip-admin~25)._scroll-to))",[[0,[1,"scroll-to"]],[12,[" (method of ",[0,[1,"snip-admin%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["scroll-to-position",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._scroll-to-position))",[[0,[1,"scroll-to-position"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["scroll-with-bottom-base",">gui/editor-canvas_.html#(meth._(((lib._mred/main..ss)._editor-canvas~25)._scroll-with-bottom-base))",[[0,[1,"scroll-with-bottom-base"]],[12,[" (method of ",[0,[1,"editor-canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["sd",">teachpack/world.html#(tech._sd)","<i>SD</i>",false],
["sealed",">r6rs-lib-std/r6rs-lib-Z-H-7.html#node_idx_300",[0,[6,"sealed"]],["rnrs/records/syntactic-6"]],
["search",">drscheme/Keyboard_Shortcuts.html#(part._.Search)","Search",false],
["search",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable~3c~25~3e)._search))",[[0,[1,"search"]],[12,[" (method of ",[0,[1,"frame:searchable&lt;%&gt;"]],")"]]],["framework"]],
["search anchor",">drscheme/Searching.html#(tech._search._anchor)","<i>search anchor</i>",false],
["search in files... menu item",">drscheme/Menus.html#(idx._(gentag._74._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Search in Files...</font></b> menu item",false],
["search!",">syntax-color/index.html#(meth._(((lib._syntax-color/token-tree..ss)._token-tree~25)._search!))",[[0,[1,"search!"]],[12,[" (method of ",[0,[1,"token-tree%"]],")"]]],["syntax-color/token-tree"]],
["search-hidden?",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable~3c~25~3e)._search-hidden~3f))",[[0,[1,"search-hidden?"]],[12,[" (method of ",[0,[1,"frame:searchable&lt;%&gt;"]],")"]]],["framework"]],
["search-hits-changed",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable~3c~25~3e)._search-hits-changed))",[[0,[1,"search-hits-changed"]],[12,[" (method of ",[0,[1,"frame:searchable&lt;%&gt;"]],")"]]],["framework"]],
["search-replace",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable~3c~25~3e)._search-replace))",[[0,[1,"search-replace"]],[12,[" (method of ",[0,[1,"frame:searchable&lt;%&gt;"]],")"]]],["framework"]],
["searching",">drscheme/Searching.html","Searching",false],
["seclink",">scribble/section-links.html#(def._((lib._scribble/manual..ss)._seclink))",[0,[1,"seclink"]],["scribble/manual"]],
["second",">reference/pairs.html#(def._((lib._scheme/list..ss)._second))",[0,[1,"second"]],["scheme/list","scheme"]],
["second",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._second))",[0,[1,"second"]],["lang/htdp-advanced"]],
["second",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._second))",[0,[1,"second"]],["lang/htdp-beginner"]],
["second",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._second))",[0,[1,"second"]],["lang/htdp-beginner-abbr"]],
["second",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._second))",[0,[1,"second"]],["lang/htdp-intermediate"]],
["second",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._second))",[0,[1,"second"]],["lang/htdp-intermediate-lambda"]],
["second",">lazy/index.html#(def._((lib._lazy/main..ss)._second))",[0,[1,"second"]],["lazy"]],
["second",">mzlib/mzlib_list.html#(def._((lib._mzlib/list..ss)._second))",[0,[1,"second"]],["mzlib/list"]],
["second",">srfi-std/srfi-1.html#second",[0,[1,"second"]],["srfi/1"]],
["secondary partitioning (highlight)",">macro-debugger/index.html#(part._.Secondary_partitioning__highlight_)","Secondary partitioning (highlight)",false],
["seconds",">frtime/index.html#(def._((lib._frtime/main..ss)._seconds))",[0,[1,"seconds"]],["frtime"]],
["seconds->date",">reference/time.html#(def._((quote._~23~25kernel)._seconds-~3edate))",[0,[1,"seconds-&gt;date"]],["scheme/base","scheme"]],
["secref",">scribble/section-links.html#(def._((lib._scribble/manual..ss)._secref))",[0,[1,"secref"]],["scribble/manual"]],
["section",">scribble/basic.html#(def._((lib._scribble/basic..ss)._section))",[0,[1,"section"]],["scribble/basic"]],
["section hyperlinks",">scribble/How_to_Scribble_Documentation.html#(part._section-hyperlinks)","Section Hyperlinks",false],
["section titles",">scribble/How_to_Scribble_Documentation.html#(part._.Section_.Titles)","Section Titles",false],
["section-index",">scribble/basic.html#(def._((lib._scribble/basic..ss)._section-index))",[0,[1,"section-index"]],["scribble/basic"]],
["security guard",">reference/securityguards.html#(tech._security._guard)","<i>security guard</i>",false],
["security guards",">inside/security.html","Security Guards",false],
["security guards",">reference/securityguards.html","Security Guards",false],
["security-guard?",">reference/securityguards.html#(def._((quote._~23~25kernel)._security-guard~3f))",[0,[1,"security-guard?"]],["scheme/base","scheme"]],
["see-other",">web-server/helpers_ss.html#(def._((lib._web-server/servlet/helpers..ss)._see-other))",[0,[1,"see-other"]],["web-server/servlet/helpers"]],
["seed",">mzc/Scheme_API_for_Compilation.html#(def._((lib._compiler/option..ss)._seed))",[0,[1,"seed"]],["compiler/option"]],
["seek",">gui/editor-stream-in-base_.html#(meth._(((lib._mred/main..ss)._editor-stream-in-base~25)._seek))",[[0,[1,"seek"]],[12,[" (method of ",[0,[1,"editor-stream-in-base%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["seek",">gui/editor-stream-out-base_.html#(meth._(((lib._mred/main..ss)._editor-stream-out-base~25)._seek))",[[0,[1,"seek"]],[12,[" (method of ",[0,[1,"editor-stream-out-base%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["select",">gui/list-box_.html#(meth._(((lib._mred/main..ss)._list-box~25)._select))",[[0,[1,"select"]],[12,[" (method of ",[0,[1,"list-box%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["select",">html/index.html#(def._((lib._html/main..ss)._select))",[0,[1,"select"]],["html"]],
["select",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._select))",[[0,[1,"select"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["select",">mrlib/hierarchical-list-item___.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list-item~3c~25~3e)._select))",[[0,[1,"select"]],[12,[" (method of ",[0,[1,"hierarchical-list-item&lt;%&gt;"]],")"]]],["mrlib/hierlist"]],
["select",">gui/key-event_.html#(idx._(gentag._63._(lib._scribblings/gui/gui..scrbl)))",[7,"'select"],false],
["select",">reference/sync.html","select",false],
["select all menu item",">drscheme/Menus.html#(idx._(gentag._83._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Select All</font></b> menu item",false],
["select-all",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._select-all))",[[0,[1,"select-all"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["select-backward-sexp",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._select-backward-sexp))",[[0,[1,"select-backward-sexp"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["select-buffer->gl-uint-vector",">sgl/gl.html#(def._((lib._sgl/gl..ss)._select-buffer-~3egl-uint-vector))",[0,[1,"select-buffer-&gt;gl-uint-vector"]],["sgl/gl"]],
["select-click-line",">framework/Keymap.html#(idx._(gentag._37._(lib._scribblings/framework/framework..scrbl)))","select-click-line",false],
["select-click-word",">framework/Keymap.html#(idx._(gentag._36._(lib._scribblings/framework/framework..scrbl)))","select-click-word",false],
["select-down-sexp",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._select-down-sexp))",[[0,[1,"select-down-sexp"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["select-first",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._select-first))",[[0,[1,"select-first"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["select-forward-sexp",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._select-forward-sexp))",[[0,[1,"select-forward-sexp"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["select-in",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._select-in))",[[0,[1,"select-in"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["select-last",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._select-last))",[[0,[1,"select-last"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["select-next",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._select-next))",[[0,[1,"select-next"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["select-out",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._select-out))",[[0,[1,"select-out"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["select-prev",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._select-prev))",[[0,[1,"select-prev"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["select-up-sexp",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._select-up-sexp))",[[0,[1,"select-up-sexp"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["select?",">html/index.html#(def._((lib._html/main..ss)._select~3f))",[0,[1,"select?"]],["html"]],
["selectable",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._selectable))",[[0,[1,"selectable"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["selectable-menu-item<%>",">gui/selectable-menu-item___.html",[0,[1,"selectable-menu-item&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["selected mailbox state",">net/imap.html#(part._.Selected_.Mailbox_.State)","Selected Mailbox State",false],
["selection",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._selection))",[[0,[1,"selection"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["selection",">gui/editor-wordbreak-map_.html#(idx._(gentag._241._(lib._scribblings/gui/gui..scrbl)))",[7,"'selection"],false],
["selection (bold)",">macro-debugger/index.html#(part._.Selection__bold_)","Selection (bold)",false],
["self",">reference/createclass.html#(idx._(gentag._75._(lib._scribblings/reference/reference..scrbl)))","self",false],
["semaphore",">reference/semaphore.html#(tech._semaphore)","<i>semaphore</i>",false],
["semaphore-peek-evt",">reference/semaphore.html#(def._((quote._~23~25kernel)._semaphore-peek-evt))",[0,[1,"semaphore-peek-evt"]],["scheme/base","scheme"]],
["semaphore-post",">reference/semaphore.html#(def._((quote._~23~25kernel)._semaphore-post))",[0,[1,"semaphore-post"]],["scheme/base","scheme"]],
["semaphore-try-wait?",">reference/semaphore.html#(def._((quote._~23~25kernel)._semaphore-try-wait~3f))",[0,[1,"semaphore-try-wait?"]],["scheme/base","scheme"]],
["semaphore-wait",">reference/semaphore.html#(def._((quote._~23~25kernel)._semaphore-wait))",[0,[1,"semaphore-wait"]],["scheme/base","scheme"]],
["semaphore-wait/enable-break",">reference/semaphore.html#(def._((quote._~23~25kernel)._semaphore-wait/enable-break))",[0,[1,"semaphore-wait/enable-break"]],["scheme/base","scheme"]],
["semaphore?",">reference/semaphore.html#(def._((quote._~23~25kernel)._semaphore~3f))",[0,[1,"semaphore?"]],["scheme/base","scheme"]],
["semaphores",">reference/semaphore.html","Semaphores",false],
["send",">reference/ivaraccess.html#(form._((lib._scheme/private/class-internal..ss)._send))",[0,[6,"send"]],["scheme/class","scheme"]],
["send url: opening a web browser",">net/sendurl.html","Send URL: Opening a Web Browser",false],
["send*",">reference/ivaraccess.html#(form._((lib._scheme/private/class-internal..ss)._send*))",[0,[6,"send*"]],["scheme/class","scheme"]],
["send-eof-to-box-in-port",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._send-eof-to-box-in-port))",[[0,[1,"send-eof-to-box-in-port"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["send-eof-to-in-port",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._send-eof-to-in-port))",[[0,[1,"send-eof-to-in-port"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["send-event",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._send-event))",[0,[1,"send-event"]],["scheme/gui/base","scheme/gui"]],
["send-event",">frtime/index.html#(def._((lib._frtime/main..ss)._send-event))",[0,[1,"send-event"]],["frtime"]],
["send-event",">mzlib/mzlib_sendevent.html#(def._((lib._mzlib/sendevent..ss)._send-event))",[0,[1,"send-event"]],["mzlib/sendevent"]],
["send-generic",">reference/ivaraccess.html#(form._((lib._scheme/private/class-internal..ss)._send-generic))",[0,[6,"send-generic"]],["scheme/class","scheme"]],
["send-mail-message",">net/sendmail.html#(def._((lib._net/sendmail..ss)._send-mail-message))",[0,[1,"send-mail-message"]],["net/sendmail"]],
["send-mail-message/port",">net/sendmail.html#(def._((lib._net/sendmail..ss)._send-mail-message/port))",[0,[1,"send-mail-message/port"]],["net/sendmail"]],
["send-message-to-window",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._send-message-to-window))",[0,[1,"send-message-to-window"]],["scheme/gui/base","scheme/gui"]],
["send-url",">browser/index.html#(def._((lib._browser/external..ss)._send-url))",[0,[1,"send-url"]],["browser/external"]],
["send-url",">net/sendurl.html#(def._((lib._net/sendurl..ss)._send-url))",[0,[1,"send-url"]],["net/sendurl"]],
["send-url/contents",">net/sendurl.html#(def._((lib._net/sendurl..ss)._send-url/contents))",[0,[1,"send-url/contents"]],["net/sendurl"]],
["send-url/file",">net/sendurl.html#(def._((lib._net/sendurl..ss)._send-url/file))",[0,[1,"send-url/file"]],["net/sendurl"]],
["send/apply",">reference/ivaraccess.html#(form._((lib._scheme/private/class-internal..ss)._send/apply))",[0,[6,"send/apply"]],["scheme/class","scheme"]],
["send/back",">web-server/web_ss.html#(def._((lib._web-server/servlet/web..ss)._send/back))",[0,[1,"send/back"]],["web-server/servlet/web"]],
["send/finish",">web-server/web_ss.html#(def._((lib._web-server/servlet/web..ss)._send/finish))",[0,[1,"send/finish"]],["web-server/servlet/web"]],
["send/formlet",">web-server/Utilities.html#(def._((lib._web-server/formlets/servlet..ss)._send/formlet))",[0,[1,"send/formlet"]],["web-server/formlets/servlet"]],
["send/forward",">web-server/web_ss.html#(def._((lib._web-server/servlet/web..ss)._send/forward))",[0,[1,"send/forward"]],["web-server/servlet/web"]],
["send/suspend",">web-server/web_ss.html#(def._((lib._web-server/servlet/web..ss)._send/suspend))",[0,[1,"send/suspend"]],["web-server/servlet/web"]],
["send/suspend/dispatch",">web-server/lang_web_ss.html#(def._((lib._web-server/lang/web..ss)._send/suspend/dispatch))",[0,[1,"send/suspend/dispatch"]],["web-server/lang/web"]],
["send/suspend/dispatch",">web-server/web_ss.html#(def._((lib._web-server/servlet/web..ss)._send/suspend/dispatch))",[0,[1,"send/suspend/dispatch"]],["web-server/servlet/web"]],
["send/suspend/hidden",">web-server/lang_web_ss.html#(def._((lib._web-server/lang/web..ss)._send/suspend/hidden))",[0,[1,"send/suspend/hidden"]],["web-server/lang/web"]],
["send/suspend/url",">web-server/lang_web_ss.html#(def._((lib._web-server/lang/web..ss)._send/suspend/url))",[0,[1,"send/suspend/url"]],["web-server/lang/web"]],
["sendmail functions",">net/sendmail.html#(part._.Sendmail_.Functions)","Sendmail Functions",false],
["sendmail signature",">net/sendmail.html#(part._.Sendmail_.Signature)","Sendmail Signature",false],
["sendmail unit",">net/sendmail.html#(part._.Sendmail_.Unit)","Sendmail Unit",false],
["sendmail: sending e-mail",">net/sendmail.html",[[5,"sendmail"],": Sending E-Mail"],false],
["sendmail@",">net/sendmail.html#(def._((lib._net/sendmail-unit..ss)._sendmail~40))",[0,[1,"sendmail@"]],["net/sendmail-unit"]],
["sendmail^",">net/sendmail.html#(form._((lib._net/sendmail-sig..ss)._sendmail~5e))",[0,[6,"sendmail^"]],["net/sendmail-sig"]],
["separator",">gui/key-event_.html#(idx._(gentag._82._(lib._scribblings/gui/gui..scrbl)))",[7,"'separator"],false],
["separator",">gui/windowing-overview.html#(tech._separator)","<i>separator</i>",false],
["separator-menu-item%",">gui/separator-menu-item_.html",[0,[1,"separator-menu-item%"]],["scheme/gui/base","scheme/gui"]],
["seq",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-sre..ss)._seq))",[0,[6,"seq"]],["parser-tools/lex-sre"]],
["sequence",">games/spider.html#(tech._sequence)","<i>Sequence</i>",false],
["sequence",">reference/sequences.html#(tech._sequence)","<i>sequence</i>",false],
["sequence constructors",">guide/for.html#(part._sequences)","Sequence Constructors",false],
["sequence generators",">reference/sequences.html#(part._.Sequence_.Generators)","Sequence Generators",false],
["sequence predicate and constructors",">reference/sequences.html#(part._.Sequence_.Predicate_and_.Constructors)","Sequence Predicate and Constructors",false],
["sequence-generate",">reference/sequences.html#(def._((lib._scheme/base..ss)._sequence-generate))",[0,[1,"sequence-generate"]],["scheme/base","scheme"]],
["sequence?",">reference/sequences.html#(def._((lib._scheme/base..ss)._sequence~3f))",[0,[1,"sequence?"]],["scheme/base","scheme"]],
["sequences",">reference/sequences.html","Sequences",false],
["sequencing",">guide/begin.html","Sequencing",false],
["sequencing",">web-server/dispatch-sequencer_ss.html","Sequencing",false],
["sequencing: begin, begin0, and begin-for-syntax",">reference/begin.html",["Sequencing: ",[0,[6,"begin"]],", ",[0,[6,"begin0"]],", and ",[0,[6,"begin-for-syntax"]]],false],
["sequential binding: let*",">guide/let.html#(part._.Sequential_.Binding__let_)",["Sequential Binding: ",[0,[6,"let*"]]],false],
["serializable closures",">web-server/closure_ss.html","Serializable Closures",false],
["serializable?",">reference/serialization.html#(def._((lib._scheme/private/serialize..ss)._serializable~3f))",[0,[1,"serializable?"]],["scheme/serialize"]],
["serialization",">reference/serialization.html","Serialization",false],
["serialization",">guide/serialization.html#(tech._serialization)","<i>serialization</i>",false],
["serialization utilities",">web-server/mod-map_ss.html","Serialization Utilities",false],
["serialize",">reference/serialization.html#(def._((lib._scheme/private/serialize..ss)._serialize))",[0,[1,"serialize"]],["scheme/serialize"]],
["serialize-info",">scribble/renderer.html#(meth._(((lib._scribble/base-render..ss)._render~25)._serialize-info))",[[0,[1,"serialize-info"]],[12,[" (method of ",[0,[1,"render%"]],")"]]],["scribble/base-render"]],
["serialized=?",">reference/serialization.html#(def._((lib._scheme/private/serialize..ss)._serialized~3d~3f))",[0,[1,"serialized=?"]],["scheme/serialize"]],
["serious-condition?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_424",[0,[1,"serious-condition?"]],["rnrs/conditions-6"]],
["serp",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..ss)._serp))",[0,[1,"serp"]],["graphics/turtle-examples"]],
["serp-nosplit",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..ss)._serp-nosplit))",[0,[1,"serp-nosplit"]],["graphics/turtle-examples"]],
["serp-size",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..ss)._serp-size))",[0,[1,"serp-size"]],["graphics/turtle-examples"]],
["serpinski triangle",">turtles/Traditional_Turtles.html#(idx._(gentag._0._(lib._graphics/scribblings/turtles..scrbl)))","Serpinski triangle",false],
["serve",">web-server/dispatch-server-unit_ss.html#(sig-val._((lib._web-server/private/dispatch-server-sig..ss)._dispatch-server~5e._serve))",[0,[1,"serve"]],["web-server/private/dispatch-server-sig"]],
["serve",">web-server/web-server_ss.html#(def._((lib._web-server/web-server..ss)._serve))",[0,[1,"serve"]],["web-server/web-server"]],
["serve",">web-server/web-server-unit_ss.html#(sig-val._((lib._web-server/web-server-sig..ss)._web-server~5e._serve))",[0,[1,"serve"]],["web-server/web-server-sig"]],
["serve-ports",">web-server/dispatch-server-unit_ss.html#(sig-val._((lib._web-server/private/dispatch-server-sig..ss)._dispatch-server~5e._serve-ports))",[0,[1,"serve-ports"]],["web-server/private/dispatch-server-sig"]],
["serve-ports",">web-server/web-server-unit_ss.html#(sig-val._((lib._web-server/web-server-sig..ss)._web-server~5e._serve-ports))",[0,[1,"serve-ports"]],["web-server/web-server-sig"]],
["serve/ips+ports",">web-server/web-server_ss.html#(def._((lib._web-server/web-server..ss)._serve/ips+ports))",[0,[1,"serve/ips+ports"]],["web-server/web-server"]],
["serve/ports",">web-server/web-server_ss.html#(def._((lib._web-server/web-server..ss)._serve/ports))",[0,[1,"serve/ports"]],["web-server/web-server"]],
["serve/servlet",">web-server/servlet-env_ss.html#(def._((lib._web-server/servlet-env..ss)._serve/servlet))",[0,[1,"serve/servlet"]],["web-server/servlet-env"]],
["server",">reference/securityguards.html#(idx._(gentag._209._(lib._scribblings/reference/reference..scrbl)))",[7,"'server"],false],
["server thread",">more/index.html#(part._.Server_.Thread)","Server Thread",false],
["serving files",">web-server/dispatch-files_ss.html","Serving Files",false],
["serving scheme servlets",">web-server/dispatch-servlets_ss.html","Serving Scheme Servlets",false],
["serving web language servlets",">web-server/dispatch-lang_ss.html","Serving Web Language Servlets",false],
["servlet namespaces",">web-server/namespace_ss.html","Servlet Namespaces",false],
["servlet urls",">web-server/servlet-url_ss.html","Servlet URLs",false],
["servlet-error-responder",">web-server/responders_ss.html#(def._((lib._web-server/configuration/responders..ss)._servlet-error-responder))",[0,[1,"servlet-error-responder"]],["web-server/configuration/responders"]],
["servlet-loading-responder",">web-server/responders_ss.html#(def._((lib._web-server/configuration/responders..ss)._servlet-loading-responder))",[0,[1,"servlet-loading-responder"]],["web-server/configuration/responders"]],
["servlet-url->url-string/no-continuation",">web-server/servlet-url_ss.html#(def._((lib._web-server/servlet/servlet-url..ss)._servlet-url-~3eurl-string/no-continuation))",[0,[1,"servlet-url-&gt;url-string/no-continuation"]],["web-server/servlet/servlet-url"]],
["servlets and sessions",">more/index.html#(part._.Servlets_and_.Sessions)","Servlets and Sessions",false],
["set",">reference/cont.html#(form._((lib._scheme/control..ss)._set))",[0,[6,"set"]],["scheme/control"]],
["set",">gui/add-color___.html#(meth._(((lib._mred/main..ss)._add-color~3c~25~3e)._set))",[[0,[1,"set"]],[12,[" (method of ",[0,[1,"add-color&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set",">gui/color_.html#(meth._(((lib._mred/main..ss)._color~25)._set))",[[0,[1,"set"]],[12,[" (method of ",[0,[1,"color%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set",">gui/list-box_.html#(meth._(((lib._mred/main..ss)._list-box~25)._set))",[[0,[1,"set"]],[12,[" (method of ",[0,[1,"list-box%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set",">gui/mult-color___.html#(meth._(((lib._mred/main..ss)._mult-color~3c~25~3e)._set))",[[0,[1,"set"]],[12,[" (method of ",[0,[1,"mult-color&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set",">gui/tab-panel_.html#(meth._(((lib._mred/main..ss)._tab-panel~25)._set))",[[0,[1,"set"]],[12,[" (method of ",[0,[1,"tab-panel%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set!",">htdp-langs/set_.html",[0,[6,"set!"]],false],
["set!",">reference/set_.html#(form._((quote._~23~25kernel)._set!))",[0,[6,"set!"]],["scheme/base","scheme"]],
["set!",">r5rs-std/r5rs-Z-H-7.html#%_idx_104",[0,[6,"set!"]],["r5rs"]],
["set!",">r6rs-std/r6rs-Z-H-14.html#node_idx_372",[0,[1,"set!"]],["rnrs/base-6"]],
["set!",">htdp-langs/set_.html#(form._((lib._lang/htdp-advanced..ss)._set!))",[0,[6,"set!"]],["lang/htdp-advanced"]],
["set!",">lazy/index.html#(form._((lib._lazy/main..ss)._set!))",[0,[6,"set!"]],["lazy"]],
["set!",">srfi-std/srfi-17.html#set!",[0,[6,"set!"]],["srfi/17"]],
["set!-transformer-procedure",">reference/stxtrans.html#(def._((quote._~23~25kernel)._set!-transformer-procedure))",[0,[1,"set!-transformer-procedure"]],["scheme/base","scheme"]],
["set!-transformer?",">reference/stxtrans.html#(def._((quote._~23~25kernel)._set!-transformer~3f))",[0,[1,"set!-transformer?"]],["scheme/base","scheme"]],
["set!-values",">reference/set_.html#(form._((lib._scheme/private/more-scheme..ss)._set!-values))",[0,[6,"set!-values"]],["scheme/base","scheme"]],
["set-accum-size",">gui/gl-config_.html#(meth._(((lib._mred/main..ss)._gl-config~25)._set-accum-size))",[[0,[1,"set-accum-size"]],[12,[" (method of ",[0,[1,"gl-config%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-active-canvas",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._set-active-canvas))",[[0,[1,"set-active-canvas"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-active-frame",">framework/Group.html#(meth._(((lib._framework/main..ss)._group~3a~25)._set-active-frame))",[[0,[1,"set-active-frame"]],[12,[" (method of ",[0,[1,"group:%"]],")"]]],["framework"]],
["set-admin",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._set-admin))",[[0,[1,"set-admin"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-admin",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._set-admin))",[[0,[1,"set-admin"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-after",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._set-after))",[[0,[1,"set-after"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-ahead",">embedded-gui/Helpers.html#(meth._(((lib._embedded-gui/main..ss)._tabbable-text~3c~25~3e)._set-ahead))",[[0,[1,"set-ahead"]],[12,[" (method of ",[0,[1,"tabbable-text&lt;%&gt;"]],")"]]],["embedded-gui"]],
["set-align-top-line",">gui/editor-snip_.html#(meth._(((lib._mred/main..ss)._editor-snip~25)._set-align-top-line))",[[0,[1,"set-align-top-line"]],[12,[" (method of ",[0,[1,"editor-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-aligned-min-sizes",">mrlib/aligned-pasteboard-parent___.html#(meth._(((lib._mrlib/aligned-pasteboard..ss)._aligned-pasteboard-parent~3c~25~3e)._set-aligned-min-sizes))",[[0,[1,"set-aligned-min-sizes"]],[12,[" (method of ",[0,[1,"aligned-pasteboard-parent&lt;%&gt;"]],")"]]],["mrlib/aligned-pasteboard"]],
["set-aligned-min-sizes",">mrlib/aligned-pasteboard___.html#(meth._(((lib._mrlib/aligned-pasteboard..ss)._aligned-pasteboard~3c~25~3e)._set-aligned-min-sizes))",[[0,[1,"set-aligned-min-sizes"]],[12,[" (method of ",[0,[1,"aligned-pasteboard&lt;%&gt;"]],")"]]],["mrlib/aligned-pasteboard"]],
["set-alignment",">gui/area-container___.html#(meth._(((lib._mred/main..ss)._area-container~3c~25~3e)._set-alignment))",[[0,[1,"set-alignment"]],[12,[" (method of ",[0,[1,"area-container&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-alignment-off",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._set-alignment-off))",[[0,[1,"set-alignment-off"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-alignment-on",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._set-alignment-on))",[[0,[1,"set-alignment-on"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-allow-edits",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._set-allow-edits))",[[0,[1,"set-allow-edits"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["set-allow-selection",">mrlib/hierarchical-list-item___.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list-item~3c~25~3e)._set-allow-selection))",[[0,[1,"set-allow-selection"]],[12,[" (method of ",[0,[1,"hierarchical-list-item&lt;%&gt;"]],")"]]],["mrlib/hierlist"]],
["set-allow-shrinking",">mrlib/Name_Message.html#(meth._(((lib._mrlib/name-message..ss)._name-message~25)._set-allow-shrinking))",[[0,[1,"set-allow-shrinking"]],[12,[" (method of ",[0,[1,"name-message%"]],")"]]],["mrlib/name-message"]],
["set-alpha",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._set-alpha))",[[0,[1,"set-alpha"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-alt-down",">gui/key-event_.html#(meth._(((lib._mred/main..ss)._key-event~25)._set-alt-down))",[[0,[1,"set-alt-down"]],[12,[" (method of ",[0,[1,"key-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-alt-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._set-alt-down))",[[0,[1,"set-alt-down"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-anchor",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._set-anchor))",[[0,[1,"set-anchor"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-anchor",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3ainfo-mixin)._set-anchor))",[[0,[1,"set-anchor"]],[12,[" (method of ",[0,[1,"text:info-mixin"]],")"]]],["framework"]],
["set-arc",">gui/region_.html#(meth._(((lib._mred/main..ss)._region~25)._set-arc))",[[0,[1,"set-arc"]],[12,[" (method of ",[0,[1,"region%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-argb-pixels",">gui/bitmap-dc_.html#(meth._(((lib._mred/main..ss)._bitmap-dc~25)._set-argb-pixels))",[[0,[1,"set-argb-pixels"]],[12,[" (method of ",[0,[1,"bitmap-dc%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-arrow-pict!",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._set-arrow-pict!))",[0,[1,"set-arrow-pict!"]],["redex/pict"]],
["set-arrowhead-params",">mrlib/graph-pasteboard___.html#(meth._(((lib._mrlib/graph..ss)._graph-pasteboard~3c~25~3e)._set-arrowhead-params))",[[0,[1,"set-arrowhead-params"]],[12,[" (method of ",[0,[1,"graph-pasteboard&lt;%&gt;"]],")"]]],["mrlib/graph"]],
["set-attribute!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-attribute!))",[[0,[1,"set-attribute!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-autowrap-bitmap",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._set-autowrap-bitmap))",[[0,[1,"set-autowrap-bitmap"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-b",">gui/add-color___.html#(meth._(((lib._mred/main..ss)._add-color~3c~25~3e)._set-b))",[[0,[1,"set-b"]],[12,[" (method of ",[0,[1,"add-color&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-b",">gui/mult-color___.html#(meth._(((lib._mred/main..ss)._mult-color~3c~25~3e)._set-b))",[[0,[1,"set-b"]],[12,[" (method of ",[0,[1,"mult-color&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-back",">embedded-gui/Helpers.html#(meth._(((lib._embedded-gui/main..ss)._tabbable-text~3c~25~3e)._set-back))",[[0,[1,"set-back"]],[12,[" (method of ",[0,[1,"tabbable-text&lt;%&gt;"]],")"]]],["embedded-gui"]],
["set-background",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._set-background))",[[0,[1,"set-background"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-background-color!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-background-color!))",[[0,[1,"set-background-color!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-background-color-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-background-color-native!))",[[0,[1,"set-background-color-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-background-image!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-background-image!))",[[0,[1,"set-background-image!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-background-image-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-background-image-native!))",[[0,[1,"set-background-image-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-background-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-background-native!))",[[0,[1,"set-background-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-background-position!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-background-position!))",[[0,[1,"set-background-position!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-background-position-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-background-position-native!))",[[0,[1,"set-background-position-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-background-position-x!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-background-position-x!))",[[0,[1,"set-background-position-x!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-background-position-x-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-background-position-x-native!))",[[0,[1,"set-background-position-x-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-background-position-y!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-background-position-y!))",[[0,[1,"set-background-position-y!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-background-position-y-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-background-position-y-native!))",[[0,[1,"set-background-position-y-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-background-repeat!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-background-repeat!))",[[0,[1,"set-background-repeat!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-background-repeat-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-background-repeat-native!))",[[0,[1,"set-background-repeat-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-base-style",">gui/style___.html#(meth._(((lib._mred/main..ss)._style~3c~25~3e)._set-base-style))",[[0,[1,"set-base-style"]],[12,[" (method of ",[0,[1,"style&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-before",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._set-before))",[[0,[1,"set-before"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-between-threshold",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._set-between-threshold))",[[0,[1,"set-between-threshold"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-bitmap",">gui/bitmap-dc_.html#(meth._(((lib._mred/main..ss)._bitmap-dc~25)._set-bitmap))",[[0,[1,"set-bitmap"]],[12,[" (method of ",[0,[1,"bitmap-dc%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-bitmap",">gui/image-snip_.html#(meth._(((lib._mred/main..ss)._image-snip~25)._set-bitmap))",[[0,[1,"set-bitmap"]],[12,[" (method of ",[0,[1,"image-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-blog-home!",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-9..ss)._set-blog-home!))",[0,[1,"set-blog-home!"]],[]],
["set-blog-posts!",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-4..ss)._set-blog-posts!))",[0,"set-blog-posts!"],[]],
["set-blog-posts!",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-9..ss)._set-blog-posts!))",[0,[1,"set-blog-posts!"]],[]],
["set-border!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border!))",[[0,[1,"set-border!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-bottom!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-bottom!))",[[0,[1,"set-border-bottom!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-bottom-color!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-bottom-color!))",[[0,[1,"set-border-bottom-color!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-bottom-color-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-bottom-color-native!))",[[0,[1,"set-border-bottom-color-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-bottom-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-bottom-native!))",[[0,[1,"set-border-bottom-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-bottom-style!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-bottom-style!))",[[0,[1,"set-border-bottom-style!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-bottom-style-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-bottom-style-native!))",[[0,[1,"set-border-bottom-style-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-bottom-width!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-bottom-width!))",[[0,[1,"set-border-bottom-width!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-bottom-width-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-bottom-width-native!))",[[0,[1,"set-border-bottom-width-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-color!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-color!))",[[0,[1,"set-border-color!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-color-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-color-native!))",[[0,[1,"set-border-color-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-left!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-left!))",[[0,[1,"set-border-left!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-left-color!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-left-color!))",[[0,[1,"set-border-left-color!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-left-color-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-left-color-native!))",[[0,[1,"set-border-left-color-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-left-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-left-native!))",[[0,[1,"set-border-left-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-left-style!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-left-style!))",[[0,[1,"set-border-left-style!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-left-style-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-left-style-native!))",[[0,[1,"set-border-left-style-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-left-width!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-left-width!))",[[0,[1,"set-border-left-width!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-left-width-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-left-width-native!))",[[0,[1,"set-border-left-width-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-native!))",[[0,[1,"set-border-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-right!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-right!))",[[0,[1,"set-border-right!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-right-color!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-right-color!))",[[0,[1,"set-border-right-color!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-right-color-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-right-color-native!))",[[0,[1,"set-border-right-color-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-right-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-right-native!))",[[0,[1,"set-border-right-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-right-style!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-right-style!))",[[0,[1,"set-border-right-style!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-right-style-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-right-style-native!))",[[0,[1,"set-border-right-style-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-right-width!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-right-width!))",[[0,[1,"set-border-right-width!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-right-width-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-right-width-native!))",[[0,[1,"set-border-right-width-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-style!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-style!))",[[0,[1,"set-border-style!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-style-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-style-native!))",[[0,[1,"set-border-style-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-top!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-top!))",[[0,[1,"set-border-top!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-top-color!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-top-color!))",[[0,[1,"set-border-top-color!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-top-color-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-top-color-native!))",[[0,[1,"set-border-top-color-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-top-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-top-native!))",[[0,[1,"set-border-top-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-top-style!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-top-style!))",[[0,[1,"set-border-top-style!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-top-style-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-top-style-native!))",[[0,[1,"set-border-top-style-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-top-width!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-top-width!))",[[0,[1,"set-border-top-width!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-top-width-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-top-width-native!))",[[0,[1,"set-border-top-width-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-width!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-width!))",[[0,[1,"set-border-width!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-border-width-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-border-width-native!))",[[0,[1,"set-border-width-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-boundary",">gui/editor-stream-in_.html#(meth._(((lib._mred/main..ss)._editor-stream-in~25)._set-boundary))",[[0,[1,"set-boundary"]],[12,[" (method of ",[0,[1,"editor-stream-in%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-box!",">reference/boxes.html#(def._((quote._~23~25kernel)._set-box!))",[0,[1,"set-box!"]],["scheme/base","scheme"]],
["set-box!",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._set-box!))",[0,[1,"set-box!"]],["lang/htdp-advanced"]],
["set-box!",">lazy/index.html#(def._((lib._lazy/main..ss)._set-box!))",[0,[1,"set-box!"]],["lazy"]],
["set-break-sequence-callback",">gui/keymap_.html#(meth._(((lib._mred/main..ss)._keymap~25)._set-break-sequence-callback))",[[0,[1,"set-break-sequence-callback"]],[12,[" (method of ",[0,[1,"keymap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-breakables",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3acontext~3c~25~3e)._set-breakables))",[[0,[1,"set-breakables"]],[12,[" (method of ",[0,[1,"drscheme:rep:context&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["set-breakables",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3atab~3c~25~3e)._set-breakables))",[[0,[1,"set-breakables"]],[12,[" (method of ",[0,[1,"drscheme:unit:tab&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["set-brush",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._set-brush))",[[0,[1,"set-brush"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-button-action",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._set-button-action))",[[0,[1,"set-button-action"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["set-cache-size!",">redex/Patterns.html#(def._((lib._redex/reduction-semantics..ss)._set-cache-size!))",[0,[1,"set-cache-size!"]],["redex/reduction-semantics"]],
["set-canvas-background",">gui/canvas___.html#(meth._(((lib._mred/main..ss)._canvas~3c~25~3e)._set-canvas-background))",[[0,[1,"set-canvas-background"]],[12,[" (method of ",[0,[1,"canvas&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-cap",">gui/pen_.html#(meth._(((lib._mred/main..ss)._pen~25)._set-cap))",[[0,[1,"set-cap"]],[12,[" (method of ",[0,[1,"pen%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-caps-down",">gui/key-event_.html#(meth._(((lib._mred/main..ss)._key-event~25)._set-caps-down))",[[0,[1,"set-caps-down"]],[12,[" (method of ",[0,[1,"key-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-caps-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._set-caps-down))",[[0,[1,"set-caps-down"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-car!",">r5rs-std/r5rs-Z-H-9.html#%_idx_416",[0,[1,"set-car!"]],["r5rs"]],
["set-car!",">r6rs-lib-std/r6rs-lib-Z-H-18.html#node_idx_1274",[0,[1,"set-car!"]],["rnrs/mutable-pairs-6"]],
["set-caret-owner",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._set-caret-owner))",[[0,[1,"set-caret-owner"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-caret-owner",">gui/snip-admin_.html#(meth._(((lib._mred/main..ss)._snip-admin~25)._set-caret-owner))",[[0,[1,"set-caret-owner"]],[12,[" (method of ",[0,[1,"snip-admin%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-caret-owner",">embedded-gui/Helpers.html#(meth._(((lib._embedded-gui/main..ss)._tabbable-text~3c~25~3e)._set-caret-owner))",[[0,[1,"set-caret-owner"]],[12,[" (method of ",[0,[1,"tabbable-text&lt;%&gt;"]],")"]]],["embedded-gui"]],
["set-cdr!",">r5rs-std/r5rs-Z-H-9.html#%_idx_418",[0,[1,"set-cdr!"]],["r5rs"]],
["set-cdr!",">r6rs-lib-std/r6rs-lib-Z-H-18.html#node_idx_1276",[0,[1,"set-cdr!"]],["rnrs/mutable-pairs-6"]],
["set-cell!",">frtime/index.html#(def._((lib._frtime/main..ss)._set-cell!))",[0,[1,"set-cell!"]],["frtime"]],
["set-classname",">gui/editor-data-class_.html#(meth._(((lib._mred/main..ss)._editor-data-class~25)._set-classname))",[[0,[1,"set-classname"]],[12,[" (method of ",[0,[1,"editor-data-class%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-classname",">gui/snip-class_.html#(meth._(((lib._mred/main..ss)._snip-class~25)._set-classname))",[[0,[1,"set-classname"]],[12,[" (method of ",[0,[1,"snip-class%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-clear!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-clear!))",[[0,[1,"set-clear!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-clear-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-clear-native!))",[[0,[1,"set-clear-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-clickback",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._set-clickback))",[[0,[1,"set-clickback"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-clip!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-clip!))",[[0,[1,"set-clip!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-clip-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-clip-native!))",[[0,[1,"set-clip-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-clipboard-bitmap",">gui/clipboard___.html#(meth._(((lib._mred/main..ss)._clipboard~3c~25~3e)._set-clipboard-bitmap))",[[0,[1,"set-clipboard-bitmap"]],[12,[" (method of ",[0,[1,"clipboard&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-clipboard-client",">gui/clipboard___.html#(meth._(((lib._mred/main..ss)._clipboard~3c~25~3e)._set-clipboard-client))",[[0,[1,"set-clipboard-client"]],[12,[" (method of ",[0,[1,"clipboard&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-clipboard-string",">gui/clipboard___.html#(meth._(((lib._mred/main..ss)._clipboard~3c~25~3e)._set-clipboard-string))",[[0,[1,"set-clipboard-string"]],[12,[" (method of ",[0,[1,"clipboard&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-clipping-rect",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._set-clipping-rect))",[[0,[1,"set-clipping-rect"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-clipping-region",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._set-clipping-region))",[[0,[1,"set-clipping-region"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-coclass!",">mysterx/methprop.html#(def._((lib._mysterx/main..ss)._set-coclass!))",[0,[1,"set-coclass!"]],["mysterx"]],
["set-coclass-from-progid!",">mysterx/methprop.html#(def._((lib._mysterx/main..ss)._set-coclass-from-progid!))",[0,[1,"set-coclass-from-progid!"]],["mysterx"]],
["set-color",">gui/brush_.html#(meth._(((lib._mred/main..ss)._brush~25)._set-color))",[[0,[1,"set-color"]],[12,[" (method of ",[0,[1,"brush%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-color",">gui/pen_.html#(meth._(((lib._mred/main..ss)._pen~25)._set-color))",[[0,[1,"set-color"]],[12,[" (method of ",[0,[1,"pen%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-color!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-color!))",[[0,[1,"set-color!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-color-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-color-native!))",[[0,[1,"set-color-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-command",">gui/ps-setup_.html#(meth._(((lib._mred/main..ss)._ps-setup~25)._set-command))",[[0,[1,"set-command"]],[12,[" (method of ",[0,[1,"ps-setup%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-completion-function!",">readline/index.html#(def._((lib._readline/readline..ss)._set-completion-function!))",[0,[1,"set-completion-function!"]],["readline/readline"]],
["set-control-down",">gui/key-event_.html#(meth._(((lib._mred/main..ss)._key-event~25)._set-control-down))",[[0,[1,"set-control-down"]],[12,[" (method of ",[0,[1,"key-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-control-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._set-control-down))",[[0,[1,"set-control-down"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-cookie",">net/cookie.html#(def._((lib._net/cookie..ss)._set-cookie))",[0,[1,"set-cookie"]],["net/cookie"]],
["set-count",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._set-count))",[[0,[1,"set-count"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-cpointer-tag!",">foreign/foreign_pointer-funcs.html#(def._((lib._scribblings/foreign/unsafe-foreign..ss)._set-cpointer-tag!))",[0,[1,"set-cpointer-tag!"]],["scribblings/foreign/unsafe-foreign"]],
["set-css-text-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-css-text-native!))",[[0,[1,"set-css-text-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-cursor",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._set-cursor))",[[0,[1,"set-cursor"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-cursor",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._set-cursor))",[[0,[1,"set-cursor"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-cursor!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-cursor!))",[[0,[1,"set-cursor!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-cursor-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-cursor-native!))",[[0,[1,"set-cursor-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-data",">gui/list-box_.html#(meth._(((lib._mred/main..ss)._list-box~25)._set-data))",[[0,[1,"set-data"]],[12,[" (method of ",[0,[1,"list-box%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-dataclass",">gui/editor-data_.html#(meth._(((lib._mred/main..ss)._editor-data~25)._set-dataclass))",[[0,[1,"set-dataclass"]],[12,[" (method of ",[0,[1,"editor-data%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-delegate",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3adelegate~3c~25~3e)._set-delegate))",[[0,[1,"set-delegate"]],[12,[" (method of ",[0,[1,"text:delegate&lt;%&gt;"]],")"]]],["framework"]],
["set-delta",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._set-delta))",[[0,[1,"set-delta"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-delta",">gui/style___.html#(meth._(((lib._mred/main..ss)._style~3c~25~3e)._set-delta))",[[0,[1,"set-delta"]],[12,[" (method of ",[0,[1,"style&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-delta-background",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._set-delta-background))",[[0,[1,"set-delta-background"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-delta-face",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._set-delta-face))",[[0,[1,"set-delta-face"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-delta-foreground",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._set-delta-foreground))",[[0,[1,"set-delta-foreground"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-depth-size",">gui/gl-config_.html#(meth._(((lib._mred/main..ss)._gl-config~25)._set-depth-size))",[[0,[1,"set-depth-size"]],[12,[" (method of ",[0,[1,"gl-config%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-direction",">gui/scroll-event_.html#(meth._(((lib._mred/main..ss)._scroll-event~25)._set-direction))",[[0,[1,"set-direction"]],[12,[" (method of ",[0,[1,"scroll-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-display!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-display!))",[[0,[1,"set-display!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-display-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-display-native!))",[[0,[1,"set-display-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-double-buffered",">gui/gl-config_.html#(meth._(((lib._mred/main..ss)._gl-config~25)._set-double-buffered))",[[0,[1,"set-double-buffered"]],[12,[" (method of ",[0,[1,"gl-config%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-double-click-action",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._set-double-click-action))",[[0,[1,"set-double-click-action"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["set-double-click-interval",">gui/keymap_.html#(meth._(((lib._mred/main..ss)._keymap~25)._set-double-click-interval))",[[0,[1,"set-double-click-interval"]],[12,[" (method of ",[0,[1,"keymap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-dragable",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._set-dragable))",[[0,[1,"set-dragable"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-draw-arrow-heads?",">mrlib/graph-pasteboard___.html#(meth._(((lib._mrlib/graph..ss)._graph-pasteboard~3c~25~3e)._set-draw-arrow-heads~3f))",[[0,[1,"set-draw-arrow-heads?"]],[12,[" (method of ",[0,[1,"graph-pasteboard&lt;%&gt;"]],")"]]],["mrlib/graph"]],
["set-editor",">gui/editor-canvas_.html#(meth._(((lib._mred/main..ss)._editor-canvas~25)._set-editor))",[[0,[1,"set-editor"]],[12,[" (method of ",[0,[1,"editor-canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-editor",">gui/editor-snip_.html#(meth._(((lib._mred/main..ss)._editor-snip~25)._set-editor))",[[0,[1,"set-editor"]],[12,[" (method of ",[0,[1,"editor-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-editor",">framework/Canvas.html#(meth._(((lib._framework/main..ss)._canvas~3ainfo-mixin)._set-editor))",[[0,[1,"set-editor"]],[12,[" (method of ",[0,[1,"canvas:info-mixin"]],")"]]],["framework"]],
["set-editor-margin",">gui/ps-setup_.html#(meth._(((lib._mred/main..ss)._ps-setup~25)._set-editor-margin))",[[0,[1,"set-editor-margin"]],[12,[" (method of ",[0,[1,"ps-setup%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-ellipse",">gui/region_.html#(meth._(((lib._mred/main..ss)._region~25)._set-ellipse))",[[0,[1,"set-ellipse"]],[12,[" (method of ",[0,[1,"region%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-eval-limits",">reference/Sandboxed_Evaluation.html#(def._((lib._scheme/sandbox..ss)._set-eval-limits))",[0,[1,"set-eval-limits"]],["scheme/sandbox"]],
["set-event-type",">gui/control-event_.html#(meth._(((lib._mred/main..ss)._control-event~25)._set-event-type))",[[0,[1,"set-event-type"]],[12,[" (method of ",[0,[1,"control-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-event-type",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._set-event-type))",[[0,[1,"set-event-type"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-event-type",">gui/scroll-event_.html#(meth._(((lib._mred/main..ss)._scroll-event~25)._set-event-type))",[[0,[1,"set-event-type"]],[12,[" (method of ",[0,[1,"scroll-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-external-tag-path",">scribble/renderer.html#(meth._(((lib._scribble/html-render..ss)._render-mixin)._set-external-tag-path))",[[0,[1,"set-external-tag-path"]],[12,[" (method of ",[0,[1,"render-mixin"]],")"]]],["scribble/html-render"]],
["set-face",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._set-face))",[[0,[1,"set-face"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-family",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._set-family))",[[0,[1,"set-family"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-ffi-obj!",">foreign/Loading_Foreign_Libraries.html#(def._((lib._scribblings/foreign/unsafe-foreign..ss)._set-ffi-obj!))",[0,[1,"set-ffi-obj!"]],["scribblings/foreign/unsafe-foreign"]],
["set-file",">gui/ps-setup_.html#(meth._(((lib._mred/main..ss)._ps-setup~25)._set-file))",[[0,[1,"set-file"]],[12,[" (method of ",[0,[1,"ps-setup%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-file-format",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._set-file-format))",[[0,[1,"set-file-format"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-filename",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._set-filename))",[[0,[1,"set-filename"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-filename",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3adefinitions-text~25)._set-filename))",["set-filename",[12,[" (method of ",[0,[1,"drscheme:unit:definitions-text%"]],")"]]],["drscheme/tool-lib"]],
["set-filename",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3afile-mixin)._set-filename))",[[0,[1,"set-filename"]],[12,[" (method of ",[0,[1,"editor:file-mixin"]],")"]]],["framework"]],
["set-filter!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-filter!))",[[0,[1,"set-filter!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-filter-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-filter-native!))",[[0,[1,"set-filter-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-first-visible-item",">gui/list-box_.html#(meth._(((lib._mred/main..ss)._list-box~25)._set-first-visible-item))",[[0,[1,"set-first-visible-item"]],[12,[" (method of ",[0,[1,"list-box%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-flags",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._set-flags))",[[0,[1,"set-flags"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-font",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._set-font))",[[0,[1,"set-font"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-font-family!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-font-family!))",[[0,[1,"set-font-family!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-font-family-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-font-family-native!))",[[0,[1,"set-font-family-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-font-size!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-font-size!))",[[0,[1,"set-font-size!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-font-size-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-font-size-native!))",[[0,[1,"set-font-size-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-font-style!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-font-style!))",[[0,[1,"set-font-style!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-font-style-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-font-style-native!))",[[0,[1,"set-font-style-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-font-variant!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-font-variant!))",[[0,[1,"set-font-variant!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-font-variant-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-font-variant-native!))",[[0,[1,"set-font-variant-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-font-weight!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-font-weight!))",[[0,[1,"set-font-weight!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-font-weight-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-font-weight-native!))",[[0,[1,"set-font-weight-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-g",">gui/add-color___.html#(meth._(((lib._mred/main..ss)._add-color~3c~25~3e)._set-g))",[[0,[1,"set-g"]],[12,[" (method of ",[0,[1,"add-color&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-g",">gui/mult-color___.html#(meth._(((lib._mred/main..ss)._mult-color~3c~25~3e)._set-g))",[[0,[1,"set-g"]],[12,[" (method of ",[0,[1,"mult-color&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-gl-config",">gui/bitmap_.html#(meth._(((lib._mred/main..ss)._bitmap~25)._set-gl-config))",[[0,[1,"set-gl-config"]],[12,[" (method of ",[0,[1,"bitmap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-grab-key-function",">gui/keymap_.html#(meth._(((lib._mred/main..ss)._keymap~25)._set-grab-key-function))",[[0,[1,"set-grab-key-function"]],[12,[" (method of ",[0,[1,"keymap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-grab-mouse-function",">gui/keymap_.html#(meth._(((lib._mred/main..ss)._keymap~25)._set-grab-mouse-function))",[[0,[1,"set-grab-mouse-function"]],[12,[" (method of ",[0,[1,"keymap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-height!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-height!))",[[0,[1,"set-height!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-height-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-height-native!))",[[0,[1,"set-height-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-help-string",">gui/labelled-menu-item___.html#(meth._(((lib._mred/main..ss)._labelled-menu-item~3c~25~3e)._set-help-string))",[[0,[1,"set-help-string"]],[12,[" (method of ",[0,[1,"labelled-menu-item&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-hidden?",">mrlib/Name_Message.html#(meth._(((lib._mrlib/name-message..ss)._name-message~25)._set-hidden~3f))",[[0,[1,"set-hidden?"]],[12,[" (method of ",[0,[1,"name-message%"]],")"]]],["mrlib/name-message"]],
["set-icon",">gui/frame_.html#(meth._(((lib._mred/main..ss)._frame~25)._set-icon))",[[0,[1,"set-icon"]],[12,[" (method of ",[0,[1,"frame%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-inactive-caret-threshold",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._set-inactive-caret-threshold))",[[0,[1,"set-inactive-caret-threshold"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-info-canvas",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3ainfo~3c~25~3e)._set-info-canvas))",[[0,[1,"set-info-canvas"]],[12,[" (method of ",[0,[1,"frame:info&lt;%&gt;"]],")"]]],["framework"]],
["set-insertion-point",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._set-insertion-point))",[[0,[1,"set-insertion-point"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["set-inset",">gui/editor-snip_.html#(meth._(((lib._mred/main..ss)._editor-snip~25)._set-inset))",[[0,[1,"set-inset"]],[12,[" (method of ",[0,[1,"editor-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-integer-set-contents!",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..ss)._set-integer-set-contents!))",[0,[1,"set-integer-set-contents!"]],["mzlib/integer-set"]],
["set-interactive-display-handler",">mrlib/Interactive_Value_Port.html#(def._((lib._mrlib/interactive-value-port..ss)._set-interactive-display-handler))",[0,[1,"set-interactive-display-handler"]],["mrlib/interactive-value-port"]],
["set-interactive-print-handler",">mrlib/Interactive_Value_Port.html#(def._((lib._mrlib/interactive-value-port..ss)._set-interactive-print-handler))",[0,[1,"set-interactive-print-handler"]],["mrlib/interactive-value-port"]],
["set-interactive-write-handler",">mrlib/Interactive_Value_Port.html#(def._((lib._mrlib/interactive-value-port..ss)._set-interactive-write-handler))",[0,[1,"set-interactive-write-handler"]],["mrlib/interactive-value-port"]],
["set-item-label",">gui/tab-panel_.html#(meth._(((lib._mred/main..ss)._tab-panel~25)._set-item-label))",[[0,[1,"set-item-label"]],[12,[" (method of ",[0,[1,"tab-panel%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-join",">gui/pen_.html#(meth._(((lib._mred/main..ss)._pen~25)._set-join))",[[0,[1,"set-join"]],[12,[" (method of ",[0,[1,"pen%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-key",">browser/index.html#(meth._(((lib._browser/main..ss)._image-map-snip~25)._set-key))",[[0,[1,"set-key"]],[12,[" (method of ",[0,[1,"image-map-snip%"]],")"]]],["browser"]],
["set-key-code",">gui/key-event_.html#(meth._(((lib._mred/main..ss)._key-event~25)._set-key-code))",[[0,[1,"set-key-code"]],[12,[" (method of ",[0,[1,"key-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-key-release-code",">gui/key-event_.html#(meth._(((lib._mred/main..ss)._key-event~25)._set-key-release-code))",[[0,[1,"set-key-release-code"]],[12,[" (method of ",[0,[1,"key-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-keymap",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._set-keymap))",[[0,[1,"set-keymap"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-label",">gui/button_.html#(meth._(((lib._mred/main..ss)._button~25)._set-label))",[[0,[1,"set-label"]],[12,[" (method of ",[0,[1,"button%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-label",">gui/check-box_.html#(meth._(((lib._mred/main..ss)._check-box~25)._set-label))",[[0,[1,"set-label"]],[12,[" (method of ",[0,[1,"check-box%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-label",">gui/labelled-menu-item___.html#(meth._(((lib._mred/main..ss)._labelled-menu-item~3c~25~3e)._set-label))",[[0,[1,"set-label"]],[12,[" (method of ",[0,[1,"labelled-menu-item&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-label",">gui/message_.html#(meth._(((lib._mred/main..ss)._message~25)._set-label))",[[0,[1,"set-label"]],[12,[" (method of ",[0,[1,"message%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-label",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._set-label))",[[0,[1,"set-label"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-label",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor-mixin)._set-label))",[[0,[1,"set-label"]],[12,[" (method of ",[0,[1,"frame:editor-mixin"]],")"]]],["framework"]],
["set-label-prefix",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3aeditor~3c~25~3e)._set-label-prefix))",[[0,[1,"set-label-prefix"]],[12,[" (method of ",[0,[1,"frame:editor&lt;%&gt;"]],")"]]],["framework"]],
["set-label-visible",">mrlib/Switchable_Button.html#(meth._(((lib._mrlib/switchable-button..ss)._switchable-button~25)._set-label-visible))",[[0,[1,"set-label-visible"]],[12,[" (method of ",[0,[1,"switchable-button%"]],")"]]],["mrlib/switchable-button"]],
["set-labels",">plot/extend.html#(meth._(((lib._plot/extend..ss)._2d-view~25)._set-labels))",[[0,[1,"set-labels"]],[12,[" (method of ",[0,[1,"2d-view%"]],")"]]],["plot/extend"]],
["set-language-pref",">string-constants/index.html#(def._((lib._string-constants/main..ss)._set-language-pref))",[0,[1,"set-language-pref"]],["string-constants"]],
["set-left!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-left!))",[[0,[1,"set-left!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-left-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._set-left-down))",[[0,[1,"set-left-down"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-left-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-left-native!))",[[0,[1,"set-left-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-letter-spacing!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-letter-spacing!))",[[0,[1,"set-letter-spacing!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-letter-spacing-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-letter-spacing-native!))",[[0,[1,"set-letter-spacing-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-level-2",">gui/ps-setup_.html#(meth._(((lib._mred/main..ss)._ps-setup~25)._set-level-2))",[[0,[1,"set-level-2"]],[12,[" (method of ",[0,[1,"ps-setup%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-line-color",">plot/extend.html#(meth._(((lib._plot/extend..ss)._plot-view~25)._set-line-color))",[[0,[1,"set-line-color"]],[12,[" (method of ",[0,[1,"plot-view%"]],")"]]],["plot/extend"]],
["set-line-count",">gui/editor-canvas_.html#(meth._(((lib._mred/main..ss)._editor-canvas~25)._set-line-count))",[[0,[1,"set-line-count"]],[12,[" (method of ",[0,[1,"editor-canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-line-height!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-line-height!))",[[0,[1,"set-line-height!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-line-height-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-line-height-native!))",[[0,[1,"set-line-height-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-line-spacing",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._set-line-spacing))",[[0,[1,"set-line-spacing"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-line-width",">plot/extend.html#(meth._(((lib._plot/extend..ss)._plot-view~25)._set-line-width))",[[0,[1,"set-line-width"]],[12,[" (method of ",[0,[1,"plot-view%"]],")"]]],["plot/extend"]],
["set-list-style!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-list-style!))",[[0,[1,"set-list-style!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-list-style-image!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-list-style-image!))",[[0,[1,"set-list-style-image!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-list-style-image-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-list-style-image-native!))",[[0,[1,"set-list-style-image-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-list-style-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-list-style-native!))",[[0,[1,"set-list-style-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-list-style-position!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-list-style-position!))",[[0,[1,"set-list-style-position!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-list-style-position-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-list-style-position-native!))",[[0,[1,"set-list-style-position-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-list-style-type!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-list-style-type!))",[[0,[1,"set-list-style-type!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-list-style-type-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-list-style-type-native!))",[[0,[1,"set-list-style-type-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-load-overwrites-styles",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._set-load-overwrites-styles))",[[0,[1,"set-load-overwrites-styles"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-loaded-mask",">gui/bitmap_.html#(meth._(((lib._mred/main..ss)._bitmap~25)._set-loaded-mask))",[[0,[1,"set-loaded-mask"]],[12,[" (method of ",[0,[1,"bitmap%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-macro-recording",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3atext-info~3c~25~3e)._set-macro-recording))",[[0,[1,"set-macro-recording"]],[12,[" (method of ",[0,[1,"frame:text-info&lt;%&gt;"]],")"]]],["framework"]],
["set-map",">gui/editor-wordbreak-map_.html#(meth._(((lib._mred/main..ss)._editor-wordbreak-map~25)._set-map))",[[0,[1,"set-map"]],[12,[" (method of ",[0,[1,"editor-wordbreak-map%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-margin",">gui/editor-snip_.html#(meth._(((lib._mred/main..ss)._editor-snip~25)._set-margin))",[[0,[1,"set-margin"]],[12,[" (method of ",[0,[1,"editor-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-margin",">gui/ps-setup_.html#(meth._(((lib._mred/main..ss)._ps-setup~25)._set-margin))",[[0,[1,"set-margin"]],[12,[" (method of ",[0,[1,"ps-setup%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-margin!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-margin!))",[[0,[1,"set-margin!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-margin!",">slideshow/Configuration.html#(def._((lib._slideshow/base..ss)._set-margin!))",[0,[1,"set-margin!"]],["slideshow/base","slideshow"]],
["set-margin-bottom!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-margin-bottom!))",[[0,[1,"set-margin-bottom!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-margin-bottom-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-margin-bottom-native!))",[[0,[1,"set-margin-bottom-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-margin-left!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-margin-left!))",[[0,[1,"set-margin-left!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-margin-left-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-margin-left-native!))",[[0,[1,"set-margin-left-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-margin-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-margin-native!))",[[0,[1,"set-margin-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-margin-right!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-margin-right!))",[[0,[1,"set-margin-right!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-margin-right-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-margin-right-native!))",[[0,[1,"set-margin-right-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-margin-top!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-margin-top!))",[[0,[1,"set-margin-top!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-margin-top-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-margin-top-native!))",[[0,[1,"set-margin-top-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-max-height",">gui/editor-snip_.html#(meth._(((lib._mred/main..ss)._editor-snip~25)._set-max-height))",[[0,[1,"set-max-height"]],[12,[" (method of ",[0,[1,"editor-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-max-height",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._set-max-height))",[[0,[1,"set-max-height"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-max-undo-history",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._set-max-undo-history))",[[0,[1,"set-max-undo-history"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-max-width",">gui/editor-snip_.html#(meth._(((lib._mred/main..ss)._editor-snip~25)._set-max-width))",[[0,[1,"set-max-width"]],[12,[" (method of ",[0,[1,"editor-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-max-width",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._set-max-width))",[[0,[1,"set-max-width"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-mcar!",">reference/mpairs.html#(def._((quote._~23~25kernel)._set-mcar!))",[0,[1,"set-mcar!"]],["scheme/base","scheme"]],
["set-mcar!",">lazy/index.html#(def._((lib._lazy/main..ss)._set-mcar!))",[0,[1,"set-mcar!"]],["lazy"]],
["set-mcdr!",">reference/mpairs.html#(def._((quote._~23~25kernel)._set-mcdr!))",[0,[1,"set-mcdr!"]],["scheme/base","scheme"]],
["set-mcdr!",">lazy/index.html#(def._((lib._lazy/main..ss)._set-mcdr!))",[0,[1,"set-mcdr!"]],["lazy"]],
["set-message",">tools/drscheme_frame.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aframe~3aname-message~25)._set-message))",["set-message",[12,[" (method of ",[0,[1,"drscheme:frame:name-message%"]],")"]]],["drscheme/tool-lib"]],
["set-message",">mrlib/Name_Message.html#(meth._(((lib._mrlib/name-message..ss)._name-message~25)._set-message))",[[0,[1,"set-message"]],[12,[" (method of ",[0,[1,"name-message%"]],")"]]],["mrlib/name-message"]],
["set-meta-down",">gui/key-event_.html#(meth._(((lib._mred/main..ss)._key-event~25)._set-meta-down))",[[0,[1,"set-meta-down"]],[12,[" (method of ",[0,[1,"key-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-meta-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._set-meta-down))",[[0,[1,"set-meta-down"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-middle-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._set-middle-down))",[[0,[1,"set-middle-down"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-min-height",">gui/editor-snip_.html#(meth._(((lib._mred/main..ss)._editor-snip~25)._set-min-height))",[[0,[1,"set-min-height"]],[12,[" (method of ",[0,[1,"editor-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-min-height",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._set-min-height))",[[0,[1,"set-min-height"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-min-sizes",">embedded-gui/alignment___.html#(meth._(((lib._embedded-gui/main..ss)._alignment~3c~25~3e)._set-min-sizes))",[[0,[1,"set-min-sizes"]],[12,[" (method of ",[0,[1,"alignment&lt;%&gt;"]],")"]]],["embedded-gui"]],
["set-min-width",">gui/editor-snip_.html#(meth._(((lib._mred/main..ss)._editor-snip~25)._set-min-width))",[[0,[1,"set-min-width"]],[12,[" (method of ",[0,[1,"editor-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-min-width",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._set-min-width))",[[0,[1,"set-min-width"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-min-width",">gui/popup-menu_.html#(meth._(((lib._mred/main..ss)._popup-menu~25)._set-min-width))",[[0,[1,"set-min-width"]],[12,[" (method of ",[0,[1,"popup-menu%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-mode",">gui/ps-setup_.html#(meth._(((lib._mred/main..ss)._ps-setup~25)._set-mode))",[[0,[1,"set-mode"]],[12,[" (method of ",[0,[1,"ps-setup%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-modified",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._set-modified))",[[0,[1,"set-modified"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-modified",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3adefinitions-text~25)._set-modified))",["set-modified",[12,[" (method of ",[0,[1,"drscheme:unit:definitions-text%"]],")"]]],["drscheme/tool-lib"]],
["set-modified",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3abackup-autosave-mixin)._set-modified))",[[0,[1,"set-modified"]],[12,[" (method of ",[0,[1,"editor:backup-autosave-mixin"]],")"]]],["framework"]],
["set-multisample-size",">gui/gl-config_.html#(meth._(((lib._mred/main..ss)._gl-config~25)._set-multisample-size))",[[0,[1,"set-multisample-size"]],[12,[" (method of ",[0,[1,"gl-config%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-needs-execution-message",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3adefinitions-text~3c~25~3e)._set-needs-execution-message))",[[0,[1,"set-needs-execution-message"]],[12,[" (method of ",[0,[1,"drscheme:unit:definitions-text&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["set-next",">gui/editor-data_.html#(meth._(((lib._mred/main..ss)._editor-data~25)._set-next))",[[0,[1,"set-next"]],[12,[" (method of ",[0,[1,"editor-data%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-next-settings",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3adefinitions-text~3c~25~3e)._set-next-settings))",[[0,[1,"set-next-settings"]],[12,[" (method of ",[0,[1,"drscheme:unit:definitions-text&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["set-no-sublists",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._set-no-sublists))",[[0,[1,"set-no-sublists"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["set-no-sublists",">mrlib/hierarchical-list-compound-item___.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list-compound-item~3c~25~3e)._set-no-sublists))",[[0,[1,"set-no-sublists"]],[12,[" (method of ",[0,[1,"hierarchical-list-compound-item&lt;%&gt;"]],")"]]],["mrlib/hierlist"]],
["set-offset",">gui/image-snip_.html#(meth._(((lib._mred/main..ss)._image-snip~25)._set-offset))",[[0,[1,"set-offset"]],[12,[" (method of ",[0,[1,"image-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-on-key-event",">graphics/World_Operations.html#(def._((lib._graphics/graphics..ss)._set-on-key-event))",[0,[1,"set-on-key-event"]],["graphics/graphics"]],
["set-on-tick-event",">graphics/World_Operations.html#(def._((lib._graphics/graphics..ss)._set-on-tick-event))",[0,[1,"set-on-tick-event"]],["graphics/graphics"]],
["set-open-here-frame",">framework/Group.html#(meth._(((lib._framework/main..ss)._group~3a~25)._set-open-here-frame))",[[0,[1,"set-open-here-frame"]],[12,[" (method of ",[0,[1,"group:%"]],")"]]],["framework"]],
["set-orientation",">gui/horizontal-panel_.html#(meth._(((lib._mred/main..ss)._horizontal-panel~25)._set-orientation))",[[0,[1,"set-orientation"]],[12,[" (method of ",[0,[1,"horizontal-panel%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-orientation",">gui/ps-setup_.html#(meth._(((lib._mred/main..ss)._ps-setup~25)._set-orientation))",[[0,[1,"set-orientation"]],[12,[" (method of ",[0,[1,"ps-setup%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-orientation",">gui/vertical-panel_.html#(meth._(((lib._mred/main..ss)._vertical-panel~25)._set-orientation))",[[0,[1,"set-orientation"]],[12,[" (method of ",[0,[1,"vertical-panel%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-origin",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._set-origin))",[[0,[1,"set-origin"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-other-altgr-key-code",">gui/key-event_.html#(meth._(((lib._mred/main..ss)._key-event~25)._set-other-altgr-key-code))",[[0,[1,"set-other-altgr-key-code"]],[12,[" (method of ",[0,[1,"key-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-other-caps-key-code",">gui/key-event_.html#(meth._(((lib._mred/main..ss)._key-event~25)._set-other-caps-key-code))",[[0,[1,"set-other-caps-key-code"]],[12,[" (method of ",[0,[1,"key-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-other-shift-altgr-key-code",">gui/key-event_.html#(meth._(((lib._mred/main..ss)._key-event~25)._set-other-shift-altgr-key-code))",[[0,[1,"set-other-shift-altgr-key-code"]],[12,[" (method of ",[0,[1,"key-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-other-shift-key-code",">gui/key-event_.html#(meth._(((lib._mred/main..ss)._key-event~25)._set-other-shift-key-code))",[[0,[1,"set-other-shift-key-code"]],[12,[" (method of ",[0,[1,"key-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-overflow!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-overflow!))",[[0,[1,"set-overflow!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-overflow-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-overflow-native!))",[[0,[1,"set-overflow-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-overwrite-mode",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._set-overwrite-mode))",[[0,[1,"set-overwrite-mode"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-overwrite-mode",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3ainfo-mixin)._set-overwrite-mode))",[[0,[1,"set-overwrite-mode"]],[12,[" (method of ",[0,[1,"text:info-mixin"]],")"]]],["framework"]],
["set-padding!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-padding!))",[[0,[1,"set-padding!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-padding-bottom!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-padding-bottom!))",[[0,[1,"set-padding-bottom!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-padding-bottom-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-padding-bottom-native!))",[[0,[1,"set-padding-bottom-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-padding-left!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-padding-left!))",[[0,[1,"set-padding-left!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-padding-left-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-padding-left-native!))",[[0,[1,"set-padding-left-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-padding-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-padding-native!))",[[0,[1,"set-padding-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-padding-right!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-padding-right!))",[[0,[1,"set-padding-right!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-padding-right-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-padding-right-native!))",[[0,[1,"set-padding-right-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-padding-top!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-padding-top!))",[[0,[1,"set-padding-top!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-padding-top-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-padding-top-native!))",[[0,[1,"set-padding-top-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-page",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-canvas-mixin)._set-page))",[[0,[1,"set-page"]],[12,[" (method of ",[0,[1,"hyper-canvas-mixin"]],")"]]],["browser"]],
["set-page-numbers-visible!",">slideshow/Viewer_Control.html#(def._((lib._slideshow/base..ss)._set-page-numbers-visible!))",[0,[1,"set-page-numbers-visible!"]],["slideshow/base","slideshow"]],
["set-pagebreak-after!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-pagebreak-after!))",[[0,[1,"set-pagebreak-after!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-pagebreak-after-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-pagebreak-after-native!))",[[0,[1,"set-pagebreak-after-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-pagebreak-before!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-pagebreak-before!))",[[0,[1,"set-pagebreak-before!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-pagebreak-before-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-pagebreak-before-native!))",[[0,[1,"set-pagebreak-before-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-paper-name",">gui/ps-setup_.html#(meth._(((lib._mred/main..ss)._ps-setup~25)._set-paper-name))",[[0,[1,"set-paper-name"]],[12,[" (method of ",[0,[1,"ps-setup%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-paragraph-alignment",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._set-paragraph-alignment))",[[0,[1,"set-paragraph-alignment"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-paragraph-margins",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._set-paragraph-margins))",[[0,[1,"set-paragraph-margins"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-paste-text-only",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._set-paste-text-only))",[[0,[1,"set-paste-text-only"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-path",">gui/region_.html#(meth._(((lib._mred/main..ss)._region~25)._set-path))",[[0,[1,"set-path"]],[12,[" (method of ",[0,[1,"region%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-pen",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._set-pen))",[[0,[1,"set-pen"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-percentages",">framework/Panel.html#(meth._(((lib._framework/main..ss)._panel~3adragable~3c~25~3e)._set-percentages))",[[0,[1,"set-percentages"]],[12,[" (method of ",[0,[1,"panel:dragable&lt;%&gt;"]],")"]]],["framework"]],
["set-piece-draw",">gl-board-game/index.html#(meth._(((lib._games/gl-board-game..ss)._gl-board~25)._set-piece-draw))",[[0,[1,"set-piece-draw"]],[12,[" (method of ",[0,[1,"gl-board%"]],")"]]],["games/gl-board-game"]],
["set-pixel",">gui/bitmap-dc_.html#(meth._(((lib._mred/main..ss)._bitmap-dc~25)._set-pixel))",[[0,[1,"set-pixel"]],[12,[" (method of ",[0,[1,"bitmap-dc%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-pixel-height!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-pixel-height!))",[[0,[1,"set-pixel-height!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-pixel-left!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-pixel-left!))",[[0,[1,"set-pixel-left!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-pixel-top!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-pixel-top!))",[[0,[1,"set-pixel-top!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-pixel-width!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-pixel-width!))",[[0,[1,"set-pixel-width!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-polygon",">gui/region_.html#(meth._(((lib._mred/main..ss)._region~25)._set-polygon))",[[0,[1,"set-polygon"]],[12,[" (method of ",[0,[1,"region%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-port-position!",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_658",[0,[1,"set-port-position!"]],["rnrs/io/ports-6"]],
["set-pos-height!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-pos-height!))",[[0,[1,"set-pos-height!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-pos-left!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-pos-left!))",[[0,[1,"set-pos-left!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-pos-top!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-pos-top!))",[[0,[1,"set-pos-top!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-pos-width!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-pos-width!))",[[0,[1,"set-pos-width!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-position",">gui/scroll-event_.html#(meth._(((lib._mred/main..ss)._scroll-event~25)._set-position))",[[0,[1,"set-position"]],[12,[" (method of ",[0,[1,"scroll-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-position",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._set-position))",[[0,[1,"set-position"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-position!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-position!))",[[0,[1,"set-position!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-position-bias-scroll",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._set-position-bias-scroll))",[[0,[1,"set-position-bias-scroll"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-position-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-position-native!))",[[0,[1,"set-position-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-posn-x!",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._set-posn-x!))",[0,[1,"set-posn-x!"]],["lang/htdp-advanced"]],
["set-posn-y!",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._set-posn-y!))",[0,[1,"set-posn-y!"]],["lang/htdp-advanced"]],
["set-post-body!",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-5..ss)._set-post-body!))",[0,[1,"set-post-body!"]],[]],
["set-post-comments!",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-5..ss)._set-post-comments!))",[0,[1,"set-post-comments!"]],[]],
["set-post-script-name",">gui/font-name-directory___.html#(meth._(((lib._mred/main..ss)._font-name-directory~3c~25~3e)._set-post-script-name))",[[0,[1,"set-post-script-name"]],[12,[" (method of ",[0,[1,"font-name-directory&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-post-title!",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-5..ss)._set-post-title!))",[0,[1,"set-post-title!"]],[]],
["set-preview-command",">gui/ps-setup_.html#(meth._(((lib._mred/main..ss)._ps-setup~25)._set-preview-command))",[[0,[1,"set-preview-command"]],[12,[" (method of ",[0,[1,"ps-setup%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-ptr-offset!",">foreign/foreign_pointer-funcs.html#(def._((lib._scribblings/foreign/unsafe-foreign..ss)._set-ptr-offset!))",[0,[1,"set-ptr-offset!"]],["scribblings/foreign/unsafe-foreign"]],
["set-r",">gui/add-color___.html#(meth._(((lib._mred/main..ss)._add-color~3c~25~3e)._set-r))",[[0,[1,"set-r"]],[12,[" (method of ",[0,[1,"add-color&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-r",">gui/mult-color___.html#(meth._(((lib._mred/main..ss)._mult-color~3c~25~3e)._set-r))",[[0,[1,"set-r"]],[12,[" (method of ",[0,[1,"mult-color&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-range",">gui/gauge_.html#(meth._(((lib._mred/main..ss)._gauge~25)._set-range))",[[0,[1,"set-range"]],[12,[" (method of ",[0,[1,"gauge%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-rectangle",">gui/region_.html#(meth._(((lib._mred/main..ss)._region~25)._set-rectangle))",[[0,[1,"set-rectangle"]],[12,[" (method of ",[0,[1,"region%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-region-callback!",">cards/index.html#(def._((lib._games/cards..ss)._set-region-callback!))",[0,[1,"set-region-callback!"]],["games/cards"]],
["set-region-data",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._set-region-data))",[[0,[1,"set-region-data"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-region-interactive-callback!",">cards/index.html#(def._((lib._games/cards..ss)._set-region-interactive-callback!))",[0,[1,"set-region-interactive-callback!"]],["games/cards"]],
["set-replace-start",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3asearching~3c~25~3e)._set-replace-start))",[[0,[1,"set-replace-start"]],[12,[" (method of ",[0,[1,"text:searching&lt;%&gt;"]],")"]]],["framework"]],
["set-resize-corner",">gui/canvas___.html#(meth._(((lib._mred/main..ss)._canvas~3c~25~3e)._set-resize-corner))",[[0,[1,"set-resize-corner"]],[12,[" (method of ",[0,[1,"canvas&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-right-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._set-right-down))",[[0,[1,"set-right-down"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-rounded-rectangle",">gui/region_.html#(meth._(((lib._mred/main..ss)._region~25)._set-rounded-rectangle))",[[0,[1,"set-rounded-rectangle"]],[12,[" (method of ",[0,[1,"region%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-scale",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._set-scale))",[[0,[1,"set-scale"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-scaling",">gui/ps-setup_.html#(meth._(((lib._mred/main..ss)._ps-setup~25)._set-scaling))",[[0,[1,"set-scaling"]],[12,[" (method of ",[0,[1,"ps-setup%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-screen-name",">gui/font-name-directory___.html#(meth._(((lib._mred/main..ss)._font-name-directory~3c~25~3e)._set-screen-name))",[[0,[1,"set-screen-name"]],[12,[" (method of ",[0,[1,"font-name-directory&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-scroll-page",">gui/canvas_.html#(meth._(((lib._mred/main..ss)._canvas~25)._set-scroll-page))",[[0,[1,"set-scroll-page"]],[12,[" (method of ",[0,[1,"canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-scroll-pos",">gui/canvas_.html#(meth._(((lib._mred/main..ss)._canvas~25)._set-scroll-pos))",[[0,[1,"set-scroll-pos"]],[12,[" (method of ",[0,[1,"canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-scroll-range",">gui/canvas_.html#(meth._(((lib._mred/main..ss)._canvas~25)._set-scroll-range))",[[0,[1,"set-scroll-range"]],[12,[" (method of ",[0,[1,"canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-scroll-step",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._set-scroll-step))",[[0,[1,"set-scroll-step"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-search-anchor",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3asearching~3c~25~3e)._set-search-anchor))",[[0,[1,"set-search-anchor"]],[12,[" (method of ",[0,[1,"text:searching&lt;%&gt;"]],")"]]],["framework"]],
["set-searching-state",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3asearching~3c~25~3e)._set-searching-state))",[[0,[1,"set-searching-state"]],[12,[" (method of ",[0,[1,"text:searching&lt;%&gt;"]],")"]]],["framework"]],
["set-selected",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._set-selected))",[[0,[1,"set-selected"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-selection",">gui/list-control___.html#(meth._(((lib._mred/main..ss)._list-control~3c~25~3e)._set-selection))",[[0,[1,"set-selection"]],[12,[" (method of ",[0,[1,"list-control&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-selection",">gui/radio-box_.html#(meth._(((lib._mred/main..ss)._radio-box~25)._set-selection))",[[0,[1,"set-selection"]],[12,[" (method of ",[0,[1,"radio-box%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-selection",">gui/tab-panel_.html#(meth._(((lib._mred/main..ss)._tab-panel~25)._set-selection))",[[0,[1,"set-selection"]],[12,[" (method of ",[0,[1,"tab-panel%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-selection!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-selection!))",[[0,[1,"set-selection!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-selection-visible",">gui/pasteboard_.html#(meth._(((lib._mred/main..ss)._pasteboard~25)._set-selection-visible))",[[0,[1,"set-selection-visible"]],[12,[" (method of ",[0,[1,"pasteboard%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-shift-down",">gui/key-event_.html#(meth._(((lib._mred/main..ss)._key-event~25)._set-shift-down))",[[0,[1,"set-shift-down"]],[12,[" (method of ",[0,[1,"key-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-shift-down",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._set-shift-down))",[[0,[1,"set-shift-down"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-shift-style",">gui/style___.html#(meth._(((lib._mred/main..ss)._style~3c~25~3e)._set-shift-style))",[[0,[1,"set-shift-style"]],[12,[" (method of ",[0,[1,"style&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-shortcut",">gui/selectable-menu-item___.html#(meth._(((lib._mred/main..ss)._selectable-menu-item~3c~25~3e)._set-shortcut))",[[0,[1,"set-shortcut"]],[12,[" (method of ",[0,[1,"selectable-menu-item&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-shortcut-prefix",">gui/selectable-menu-item___.html#(meth._(((lib._mred/main..ss)._selectable-menu-item~3c~25~3e)._set-shortcut-prefix))",[[0,[1,"set-shortcut-prefix"]],[12,[" (method of ",[0,[1,"selectable-menu-item&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-single-click-action",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._set-single-click-action))",[[0,[1,"set-single-click-action"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["set-size-add",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._set-size-add))",[[0,[1,"set-size-add"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-size-in-pixels-off",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._set-size-in-pixels-off))",[[0,[1,"set-size-in-pixels-off"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-size-in-pixels-on",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._set-size-in-pixels-on))",[[0,[1,"set-size-in-pixels-on"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-size-mult",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._set-size-mult))",[[0,[1,"set-size-mult"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-size-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-size-native!))",[[0,[1,"set-size-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-smoothing",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._set-smoothing))",[[0,[1,"set-smoothing"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-smoothing-off",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._set-smoothing-off))",[[0,[1,"set-smoothing-off"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-smoothing-on",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._set-smoothing-on))",[[0,[1,"set-smoothing-on"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-snip-data",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._set-snip-data))",[[0,[1,"set-snip-data"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-snipclass",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._set-snipclass))",[[0,[1,"set-snipclass"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-space-draw",">gl-board-game/index.html#(meth._(((lib._games/gl-board-game..ss)._gl-board~25)._set-space-draw))",[[0,[1,"set-space-draw"]],[12,[" (method of ",[0,[1,"gl-board%"]],")"]]],["games/gl-board-game"]],
["set-status",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._set-status))",[[0,[1,"set-status"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["set-status-text",">gui/frame_.html#(meth._(((lib._mred/main..ss)._frame~25)._set-status-text))",[[0,[1,"set-status-text"]],[12,[" (method of ",[0,[1,"frame%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-stencil-size",">gui/gl-config_.html#(meth._(((lib._mred/main..ss)._gl-config~25)._set-stencil-size))",[[0,[1,"set-stencil-size"]],[12,[" (method of ",[0,[1,"gl-config%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-stereo",">gui/gl-config_.html#(meth._(((lib._mred/main..ss)._gl-config~25)._set-stereo))",[[0,[1,"set-stereo"]],[12,[" (method of ",[0,[1,"gl-config%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-stipple",">gui/brush_.html#(meth._(((lib._mred/main..ss)._brush~25)._set-stipple))",[[0,[1,"set-stipple"]],[12,[" (method of ",[0,[1,"brush%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-stipple",">gui/pen_.html#(meth._(((lib._mred/main..ss)._pen~25)._set-stipple))",[[0,[1,"set-stipple"]],[12,[" (method of ",[0,[1,"pen%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-string",">gui/list-box_.html#(meth._(((lib._mred/main..ss)._list-box~25)._set-string))",[[0,[1,"set-string"]],[12,[" (method of ",[0,[1,"list-box%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-string-selection",">gui/list-control___.html#(meth._(((lib._mred/main..ss)._list-control~3c~25~3e)._set-string-selection))",[[0,[1,"set-string-selection"]],[12,[" (method of ",[0,[1,"list-control&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-style",">gui/brush_.html#(meth._(((lib._mred/main..ss)._brush~25)._set-style))",[[0,[1,"set-style"]],[12,[" (method of ",[0,[1,"brush%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-style",">gui/pen_.html#(meth._(((lib._mred/main..ss)._pen~25)._set-style))",[[0,[1,"set-style"]],[12,[" (method of ",[0,[1,"pen%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-style",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._set-style))",[[0,[1,"set-style"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-style-float!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-style-float!))",[[0,[1,"set-style-float!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-style-float-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-style-float-native!))",[[0,[1,"set-style-float-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-style-list",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._set-style-list))",[[0,[1,"set-style-list"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-style-off",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._set-style-off))",[[0,[1,"set-style-off"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-style-on",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._set-style-on))",[[0,[1,"set-style-on"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-styles-fixed",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3abasic~3c~25~3e)._set-styles-fixed))",[[0,[1,"set-styles-fixed"]],[12,[" (method of ",[0,[1,"text:basic&lt;%&gt;"]],")"]]],["framework"]],
["set-styles-sticky",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._set-styles-sticky))",[[0,[1,"set-styles-sticky"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-surrogate",">framework/Mode.html#(meth._(((lib._framework/main..ss)._mode~3ahost-text~3c~25~3e)._set-surrogate))",[[0,[1,"set-surrogate"]],[12,[" (method of ",[0,[1,"mode:host-text&lt;%&gt;"]],")"]]],["framework"]],
["set-tab-size",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._set-tab-size))",[[0,[1,"set-tab-size"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["set-tabbing",">embedded-gui/Helpers.html#(def._((lib._embedded-gui/main..ss)._set-tabbing))",[0,[1,"set-tabbing"]],["embedded-gui"]],
["set-tabs",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._set-tabs))",[[0,[1,"set-tabs"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-text-align!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-text-align!))",[[0,[1,"set-text-align!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-text-align-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-text-align-native!))",[[0,[1,"set-text-align-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-text-background",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._set-text-background))",[[0,[1,"set-text-background"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-text-decoration!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-text-decoration!))",[[0,[1,"set-text-decoration!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-text-decoration-blink!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-text-decoration-blink!))",[[0,[1,"set-text-decoration-blink!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-text-decoration-linethrough!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-text-decoration-linethrough!))",[[0,[1,"set-text-decoration-linethrough!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-text-decoration-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-text-decoration-native!))",[[0,[1,"set-text-decoration-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-text-decoration-none!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-text-decoration-none!))",[[0,[1,"set-text-decoration-none!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-text-decoration-overline!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-text-decoration-overline!))",[[0,[1,"set-text-decoration-overline!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-text-decoration-underline!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-text-decoration-underline!))",[[0,[1,"set-text-decoration-underline!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-text-foreground",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._set-text-foreground))",[[0,[1,"set-text-foreground"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-text-indent!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-text-indent!))",[[0,[1,"set-text-indent!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-text-indent-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-text-indent-native!))",[[0,[1,"set-text-indent-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-text-mode",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._set-text-mode))",[[0,[1,"set-text-mode"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-text-to-search",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable~3c~25~3e)._set-text-to-search))",[[0,[1,"set-text-to-search"]],[12,[" (method of ",[0,[1,"frame:searchable&lt;%&gt;"]],")"]]],["framework"]],
["set-text-transform!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-text-transform!))",[[0,[1,"set-text-transform!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-text-transform-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-text-transform-native!))",[[0,[1,"set-text-transform-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-tight-text-fit",">gui/editor-snip_.html#(meth._(((lib._mred/main..ss)._editor-snip~25)._set-tight-text-fit))",[[0,[1,"set-tight-text-fit"]],[12,[" (method of ",[0,[1,"editor-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-time-nanosecond!",">srfi-std/srfi-19.html#set-time-nanosecond!",[0,[1,"set-time-nanosecond!"]],["srfi/19"]],
["set-time-second!",">srfi-std/srfi-19.html#set-time-second!",[0,[1,"set-time-second!"]],["srfi/19"]],
["set-time-stamp",">gui/event_.html#(meth._(((lib._mred/main..ss)._event~25)._set-time-stamp))",[[0,[1,"set-time-stamp"]],[12,[" (method of ",[0,[1,"event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-time-type!",">srfi-std/srfi-19.html#set-time-type!",[0,[1,"set-time-type!"]],["srfi/19"]],
["set-title",">browser/index.html#(meth._(((lib._browser/main..ss)._hyper-text-mixin)._set-title))",[[0,[1,"set-title"]],[12,[" (method of ",[0,[1,"hyper-text-mixin"]],")"]]],["browser"]],
["set-title",">browser/index.html#(meth._(((lib._browser/htmltext..ss)._html-text~3c~25~3e)._set-title))",[[0,[1,"set-title"]],[12,[" (method of ",[0,[1,"html-text&lt;%&gt;"]],")"]]],["browser/htmltext"]],
["set-title-h!",">slideshow/Configuration.html#(def._((lib._slideshow/base..ss)._set-title-h!))",[0,[1,"set-title-h!"]],["slideshow/base","slideshow"]],
["set-top!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-top!))",[[0,[1,"set-top!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-top-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-top-native!))",[[0,[1,"set-top-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-translation",">gui/ps-setup_.html#(meth._(((lib._mred/main..ss)._ps-setup~25)._set-translation))",[[0,[1,"set-translation"]],[12,[" (method of ",[0,[1,"ps-setup%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-transparent-text-backing-off",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._set-transparent-text-backing-off))",[[0,[1,"set-transparent-text-backing-off"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-transparent-text-backing-on",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._set-transparent-text-backing-on))",[[0,[1,"set-transparent-text-backing-on"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-underlined-off",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._set-underlined-off))",[[0,[1,"set-underlined-off"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-underlined-on",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._set-underlined-on))",[[0,[1,"set-underlined-on"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-unmodified",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._set-unmodified))",[[0,[1,"set-unmodified"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-unread-start-point",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._set-unread-start-point))",[[0,[1,"set-unread-start-point"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["set-use-background-frame!",">slideshow/Viewer_Control.html#(def._((lib._slideshow/base..ss)._set-use-background-frame!))",[0,[1,"set-use-background-frame!"]],["slideshow/base","slideshow"]],
["set-value",">gui/check-box_.html#(meth._(((lib._mred/main..ss)._check-box~25)._set-value))",[[0,[1,"set-value"]],[12,[" (method of ",[0,[1,"check-box%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-value",">gui/gauge_.html#(meth._(((lib._mred/main..ss)._gauge~25)._set-value))",[[0,[1,"set-value"]],[12,[" (method of ",[0,[1,"gauge%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-value",">gui/slider_.html#(meth._(((lib._mred/main..ss)._slider~25)._set-value))",[[0,[1,"set-value"]],[12,[" (method of ",[0,[1,"slider%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-value",">gui/text-field_.html#(meth._(((lib._mred/main..ss)._text-field~25)._set-value))",[[0,[1,"set-value"]],[12,[" (method of ",[0,[1,"text-field%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-version",">gui/snip-class_.html#(meth._(((lib._mred/main..ss)._snip-class~25)._set-version))",[[0,[1,"set-version"]],[12,[" (method of ",[0,[1,"snip-class%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-vertical-align!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-vertical-align!))",[[0,[1,"set-vertical-align!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-vertical-align-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-vertical-align-native!))",[[0,[1,"set-vertical-align-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-visibility!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-visibility!))",[[0,[1,"set-visibility!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-visibility-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-visibility-native!))",[[0,[1,"set-visibility-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-weight-off",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._set-weight-off))",[[0,[1,"set-weight-off"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-weight-on",">gui/style-delta_.html#(meth._(((lib._mred/main..ss)._style-delta~25)._set-weight-on))",[[0,[1,"set-weight-on"]],[12,[" (method of ",[0,[1,"style-delta%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-width",">gui/pen_.html#(meth._(((lib._mred/main..ss)._pen~25)._set-width))",[[0,[1,"set-width"]],[12,[" (method of ",[0,[1,"pen%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-width!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-width!))",[[0,[1,"set-width!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-width-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-width-native!))",[[0,[1,"set-width-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-wordbreak-func",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._set-wordbreak-func))",[[0,[1,"set-wordbreak-func"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-wordbreak-map",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._set-wordbreak-map))",[[0,[1,"set-wordbreak-map"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-x",">gui/key-event_.html#(meth._(((lib._mred/main..ss)._key-event~25)._set-x))",[[0,[1,"set-x"]],[12,[" (method of ",[0,[1,"key-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-x",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._set-x))",[[0,[1,"set-x"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-x",">gui/point_.html#(meth._(((lib._mred/main..ss)._point~25)._set-x))",[[0,[1,"set-x"]],[12,[" (method of ",[0,[1,"point%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-y",">gui/key-event_.html#(meth._(((lib._mred/main..ss)._key-event~25)._set-y))",[[0,[1,"set-y"]],[12,[" (method of ",[0,[1,"key-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-y",">gui/mouse-event_.html#(meth._(((lib._mred/main..ss)._mouse-event~25)._set-y))",[[0,[1,"set-y"]],[12,[" (method of ",[0,[1,"mouse-event%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-y",">gui/point_.html#(meth._(((lib._mred/main..ss)._point~25)._set-y))",[[0,[1,"set-y"]],[12,[" (method of ",[0,[1,"point%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["set-z-index!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-z-index!))",[[0,[1,"set-z-index!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set-z-index-native!",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._set-z-index-native!))",[[0,[1,"set-z-index-native!"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["set...",">more/index.html#(part._.Set___)","Set...",false],
["set...",">quick/index.html#(part._.Set___)","Set...",false],
["setup-file",">gui/Windowing_Functions.html#(idx._(gentag._152._(lib._scribblings/gui/gui..scrbl)))",[7,"'setup-file"],false],
["setup-file",">gui/Windowing_Functions.html#(idx._(gentag._162._(lib._scribblings/gui/gui..scrbl)))",[7,"'setup-file"],false],
["setup-option^",">setup-plt/setup-plt-plt.html#(form._((lib._setup/option-sig..ss)._setup-option~5e))",[0,[6,"setup-option^"]],["setup/option-sig"]],
["setup-plt: plt configuration and installation",">setup-plt/index.html",[[5,"setup-plt"],": PLT Configuration and Installation"],false],
["setup-prefix",">mzc/Scheme_API_for_Compilation.html#(def._((lib._compiler/option..ss)._setup-prefix))",[0,[1,"setup-prefix"]],["compiler/option"]],
["setup/configtab",">config/index.html#(mod-path._setup/configtab)",[14,[0,"setup/configtab"]],"module"],
["setup/dirs",">setup-plt/dirs.html",[14,[0,"setup/dirs"]],"module"],
["setup/getinfo",">setup-plt/getinfo.html",[14,[0,"setup/getinfo"]],"module"],
["setup/infotab",">setup-plt/info_ss.html",[14,[0,"setup/infotab"]],"module"],
["setup/main-collects",">setup-plt/main-collects.html",[14,[0,"setup/main-collects"]],"module"],
["setup/option-sig",">setup-plt/setup-plt-plt.html#(mod-path._setup/option-sig)",[14,[0,"setup/option-sig"]],"module"],
["setup/option-unit",">setup-plt/setup-plt-plt.html#(mod-path._setup/option-unit)",[14,[0,"setup/option-unit"]],"module"],
["setup/pack",">setup-plt/_plt-archives.html#(mod-path._setup/pack)",[14,[0,"setup/pack"]],"module"],
["setup/plt-installer",">setup-plt/_plt-archives.html#(mod-path._setup/plt-installer)",[14,[0,"setup/plt-installer"]],"module"],
["setup/plt-installer-sig",">setup-plt/_plt-archives.html#(mod-path._setup/plt-installer-sig)",[14,[0,"setup/plt-installer-sig"]],"module"],
["setup/plt-installer-unit",">setup-plt/_plt-archives.html#(mod-path._setup/plt-installer-unit)",[14,[0,"setup/plt-installer-unit"]],"module"],
["setup/plt-single-installer",">setup-plt/_plt-archives.html#(mod-path._setup/plt-single-installer)",[14,[0,"setup/plt-single-installer"]],"module"],
["setup/setup-unit",">setup-plt/setup-plt-plt.html",[14,[0,"setup/setup-unit"]],"module"],
["setup/unpack",">setup-plt/_plt-archives.html#(mod-path._setup/unpack)",[14,[0,"setup/unpack"]],"module"],
["setup/xref",">setup-plt/xref.html",[14,[0,"setup/xref"]],"module"],
["setup:option@",">setup-plt/setup-plt-plt.html#(def._((lib._setup/option-unit..ss)._setup~3aoption~40))",[0,[1,"setup:option@"]],["setup/option-unit"]],
["setup:plt-installer^",">setup-plt/_plt-archives.html#(form._((lib._setup/plt-installer-sig..ss)._setup~3aplt-installer~5e))",[0,[6,"setup:plt-installer^"]],["setup/plt-installer-sig"]],
["setup@",">setup-plt/setup-plt-plt.html#(def._((lib._setup/setup-unit..ss)._setup~40))",[0,[1,"setup@"]],["setup/setup-unit"]],
["seventh",">reference/pairs.html#(def._((lib._scheme/list..ss)._seventh))",[0,[1,"seventh"]],["scheme/list","scheme"]],
["seventh",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._seventh))",[0,[1,"seventh"]],["lang/htdp-advanced"]],
["seventh",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._seventh))",[0,[1,"seventh"]],["lang/htdp-beginner"]],
["seventh",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._seventh))",[0,[1,"seventh"]],["lang/htdp-beginner-abbr"]],
["seventh",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._seventh))",[0,[1,"seventh"]],["lang/htdp-intermediate"]],
["seventh",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._seventh))",[0,[1,"seventh"]],["lang/htdp-intermediate-lambda"]],
["seventh",">lazy/index.html#(def._((lib._lazy/main..ss)._seventh))",[0,[1,"seventh"]],["lazy"]],
["seventh",">mzlib/mzlib_list.html#(def._((lib._mzlib/list..ss)._seventh))",[0,[1,"seventh"]],["mzlib/list"]],
["seventh",">srfi-std/srfi-1.html#seventh",[0,[1,"seventh"]],["srfi/1"]],
["sexpr->configuration-table",">web-server/configuration-table_ss.html#(def._((lib._web-server/configuration/configuration-table..ss)._sexpr-~3econfiguration-table))",[0,[1,"sexpr-&gt;configuration-table"]],["web-server/configuration/configuration-table"]],
["sgl",">sgl/main.html",[14,[0,"sgl"]],"module"],
["sgl/bitmap",">sgl/bitmaps.html",[14,[0,"sgl/bitmap"]],"module"],
["sgl/gl",">sgl/gl.html",[14,[0,"sgl/gl"]],"module"],
["sgl/gl-vectors",">sgl/gl-vectors.html",[14,[0,"sgl/gl-vectors"]],"module"],
["sgn",">reference/numbers.html#(def._((lib._scheme/math..ss)._sgn))",[0,[1,"sgn"]],["scheme/math","scheme"]],
["sgn",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._sgn))",[0,[1,"sgn"]],["lang/htdp-advanced"]],
["sgn",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._sgn))",[0,[1,"sgn"]],["lang/htdp-beginner"]],
["sgn",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._sgn))",[0,[1,"sgn"]],["lang/htdp-beginner-abbr"]],
["sgn",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._sgn))",[0,[1,"sgn"]],["lang/htdp-intermediate"]],
["sgn",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._sgn))",[0,[1,"sgn"]],["lang/htdp-intermediate-lambda"]],
["shade",">plot/plot.html#(def._((lib._plot/main..ss)._shade))",[0,[1,"shade"]],["plot"]],
["shadowing",">reference/syntax-model.html#(tech._shadowing)","<i>shadowing</i>",false],
["shadows",">reference/syntax-model.html#(tech._shadow)","<i>shadows</i>",false],
["shape",">srfi-std/srfi-25.html#shape",[0,[1,"shape"]],["srfi/25"]],
["share and share alike",">continue/index.html#(part._.Share_and_.Share_.Alike)","Share and Share Alike",false],
["share-array",">srfi-std/srfi-25.html#share-array",[0,[1,"share-array"]],["srfi/25"]],
["shared",">htdp-langs/shared.html",[0,[6,"shared"]],false],
["shared",">reference/shared.html#(form._((lib._scheme/shared..ss)._shared))",[0,[6,"shared"]],["scheme/shared","scheme"]],
["shared",">htdp-langs/shared.html#(form._((lib._lang/htdp-advanced..ss)._shared))",[0,[6,"shared"]],["lang/htdp-advanced"]],
["shared",">reference/runtime.html#(idx._(gentag._304._(lib._scribblings/reference/reference..scrbl)))",[7,"'shared"],false],
["shared libraries",">foreign/Loading_Foreign_Libraries.html#(idx._(gentag._2._(lib._scribblings/foreign/foreign..scrbl)))","shared\nlibraries",false],
["shared objects",">foreign/Loading_Foreign_Libraries.html#(idx._(gentag._1._(lib._scribblings/foreign/foreign..scrbl)))","shared objects",false],
["sharing data and code across namespaces",">guide/mk-namespace.html#(part._.Sharing_.Data_and_.Code_.Across_.Namespaces)","Sharing Data and Code Across Namespaces",false],
["shell-execute",">reference/subprocess.html#(def._((quote._~23~25kernel)._shell-execute))",[0,[1,"shell-execute"]],["scheme/base","scheme"]],
["shellexecute",">reference/subprocess.html#(idx._(gentag._268._(lib._scribblings/reference/reference..scrbl)))","ShellExecute",false],
["shift",">reference/cont.html#(form._((lib._scheme/control..ss)._shift))",[0,[6,"shift"]],["scheme/control"]],
["shift",">gui/key-event_.html#(idx._(gentag._49._(lib._scribblings/gui/gui..scrbl)))",[7,"'shift"],false],
["shift style",">gui/editor-overview.html#(tech._shift._style)","<i>shift style</i>",false],
["shift-at",">reference/cont.html#(form._((lib._scheme/control..ss)._shift-at))",[0,[6,"shift-at"]],["scheme/control"]],
["shift-key",">mysterx/html-events.html#(meth._(((lib._mysterx/main..ss)._mx-event~3c~25~3e)._shift-key))",[[0,[1,"shift-key"]],[12,[" (method of ",[0,[1,"mx-event&lt;%&gt;"]],")"]]],["mysterx"]],
["shift0",">reference/cont.html#(form._((lib._scheme/control..ss)._shift0))",[0,[6,"shift0"]],["scheme/control"]],
["shift0-at",">reference/cont.html#(form._((lib._scheme/control..ss)._shift0-at))",[0,[6,"shift0-at"]],["scheme/control"]],
["short-dash",">gui/pen_.html#(idx._(gentag._222._(lib._scribblings/gui/gui..scrbl)))",[7,"'short-dash"],false],
["shorthand syntax",">planet/Using_PLaneT.html#(part._.Shorthand_.Syntax)","Shorthand Syntax",false],
["show",">planet/cmdline.html#(part._show)",[5,"show"],false],
["show",">gui/dialog_.html#(meth._(((lib._mred/main..ss)._dialog~25)._show))",[[0,[1,"show"]],[12,[" (method of ",[0,[1,"dialog%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["show",">gui/top-level-window___.html#(meth._(((lib._mred/main..ss)._top-level-window~3c~25~3e)._show))",[[0,[1,"show"]],[12,[" (method of ",[0,[1,"top-level-window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["show",">gui/window___.html#(meth._(((lib._mred/main..ss)._window~3c~25~3e)._show))",[[0,[1,"show"]],[12,[" (method of ",[0,[1,"window&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["show",">embedded-gui/alignment___.html#(meth._(((lib._embedded-gui/main..ss)._alignment~3c~25~3e)._show))",[[0,[1,"show"]],[12,[" (method of ",[0,[1,"alignment&lt;%&gt;"]],")"]]],["embedded-gui"]],
["show",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3abasic-mixin)._show))",[[0,[1,"show"]],[12,[" (method of ",[0,[1,"frame:basic-mixin"]],")"]]],["framework"]],
["show",">mysterx/browsers.html#(meth._(((lib._mysterx/main..ss)._mx-browser~25)._show))",[[0,[1,"show"]],[12,[" (method of ",[0,[1,"mx-browser%"]],")"]]],["mysterx"]],
["show",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..ss)._show))",[0,[1,"show"]],["preprocessor/mzpp"]],
["show",">teachpack/Jdraw.html#(def._((lib._teachpack/htdc/draw..ss)._show))",[0,[1,"show"]],["teachpack/htdc/draw"]],
["show active keybindings menu item",">drscheme/Menus.html#(idx._(gentag._93._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Show Active Keybindings</font></b> menu item",false],
["show definitions menu item",">drscheme/Menus.html#(idx._(gentag._97._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Show Definitions</font></b> menu item",false],
["show interactions menu item",">drscheme/Menus.html#(idx._(gentag._99._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Show Interactions</font></b> menu item",false],
["show module browser menu item",">drscheme/Menus.html#(idx._(gentag._103._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Show Module Browser</font></b> menu item",false],
["show profile menu item",">drscheme/Menus.html#(idx._(gentag._107._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Show Profile</font></b> menu item",false],
["show program contour menu item",">drscheme/Menus.html#(idx._(gentag._101._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Show Program Contour</font></b> menu item",false],
["show toolbar menu item",">drscheme/Menus.html#(idx._(gentag._105._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Show Toolbar</font></b> menu item",false],
["show tracing menu item",">drscheme/Menus.html#(idx._(gentag._111._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Show Tracing</font></b> menu item",false],
["show-all-prompts",">readline/index.html#(def._((lib._readline/pread..ss)._show-all-prompts))",[0,"show-all-prompts"],["readline/pread"]],
["show-border",">gui/editor-snip_.html#(meth._(((lib._mred/main..ss)._editor-snip~25)._show-border))",[[0,[1,"show-border"]],[12,[" (method of ",[0,[1,"editor-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["show-caret",">gui/editor-overview.html#(idx._(gentag._20._(lib._scribblings/gui/gui..scrbl)))",[7,"'show-caret"],false],
["show-caret",">gui/editor___.html#(idx._(gentag._233._(lib._scribblings/gui/gui..scrbl)))",[7,"'show-caret"],false],
["show-delegated-text",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3adelegate~3c~25~3e)._show-delegated-text))",[[0,[1,"show-delegated-text"]],[12,[" (method of ",[0,[1,"frame:delegate&lt;%&gt;"]],")"]]],["framework"]],
["show-help",">games/Showing_Text_Help.html#(def._((lib._games/show-help..ss)._show-help))",[0,[1,"show-help"]],["games/show-help"]],
["show-import-tree",">syntax/module-helpers.html#(def._((lib._syntax/moddep..ss)._show-import-tree))",[0,[1,"show-import-tree"]],["syntax/moddep"]],
["show-inactive-caret",">gui/editor-overview.html#(idx._(gentag._19._(lib._scribblings/gui/gui..scrbl)))",[7,"'show-inactive-caret"],false],
["show-info",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3ainfo~3c~25~3e)._show-info))",[[0,[1,"show-info"]],[12,[" (method of ",[0,[1,"frame:info&lt;%&gt;"]],")"]]],["framework"]],
["show-pict",">slideshow/Rendering.html#(def._((lib._slideshow/pict..ss)._show-pict))",[0,[1,"show-pict"]],["slideshow/pict","slideshow"]],
["show-queen",">teachpack/show-queen.html#(def._((lib._teachpack/htdp/show-queen..ss)._show-queen))",[0,[1,"show-queen"]],["teachpack/htdp/show-queen"]],
["show-queen teachpack",">teachpack/show-queen.html#(idx._(gentag._14._(lib._teachpack/teachpack..scrbl)))","show-queen teachpack",false],
["show-scribbling",">games/Showing_Scribbled_Help.html#(def._((lib._games/show-scribbling..ss)._show-scribbling))",[0,[1,"show-scribbling"]],["games/show-scribbling"]],
["show-scrollbars",">gui/canvas_.html#(meth._(((lib._mred/main..ss)._canvas~25)._show-scrollbars))",[[0,[1,"show-scrollbars"]],[12,[" (method of ",[0,[1,"canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["show-sharing",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..ss)._show-sharing))",[0,[1,"show-sharing"]],["mzlib/pconvert"]],
["show-window",">teachpack/gui.html#(def._((lib._teachpack/htdp/gui..ss)._show-window))",[0,[1,"show-window"]],["teachpack/htdp/gui"]],
["show/hide",">embedded-gui/alignment___.html#(meth._(((lib._embedded-gui/main..ss)._alignment~3c~25~3e)._show/hide))",[[0,[1,"show/hide"]],[12,[" (method of ",[0,[1,"alignment&lt;%&gt;"]],")"]]],["embedded-gui"]],
["showing scheme examples",">scribble/How_to_Scribble_Documentation.html#(part._.Showing_.Scheme_.Examples)","Showing Scheme Examples",false],
["showing scribbled help",">games/Showing_Scribbled_Help.html","Showing Scribbled Help",false],
["showing text help",">games/Showing_Text_Help.html","Showing Text Help",false],
["shrink",">teachpack/image.html#(def._((lib._htdp/image..ss)._shrink))",[0,[1,"shrink"]],["teachpack/htdp/image"]],
["shrink-bl",">teachpack/image.html#(def._((lib._htdp/image..ss)._shrink-bl))",[0,[1,"shrink-bl"]],["teachpack/htdp/image"]],
["shrink-br",">teachpack/image.html#(def._((lib._htdp/image..ss)._shrink-br))",[0,[1,"shrink-br"]],["teachpack/htdp/image"]],
["shrink-tl",">teachpack/image.html#(def._((lib._htdp/image..ss)._shrink-tl))",[0,[1,"shrink-tl"]],["teachpack/htdp/image"]],
["shrink-tr",">teachpack/image.html#(def._((lib._htdp/image..ss)._shrink-tr))",[0,[1,"shrink-tr"]],["teachpack/htdp/image"]],
["shuffle-list",">cards/index.html#(def._((lib._games/cards..ss)._shuffle-list))",[0,[1,"shuffle-list"]],["games/cards"]],
["shutdown",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3atext~25)._shutdown))",[[0,[1,"shutdown"]],[12,[" (method of ",[0,[1,"drscheme:rep:text%"]],")"]]],["drscheme/tool-lib"]],
["side-condition",">redex/Patterns.html#(tech._side._condition)","<i>side-condition</i>",false],
["sigelem",">scribble/doc-signatures.html#(form._((lib._scribble/manual..ss)._sigelem))",[0,[6,"sigelem"]],["scribble/manual"]],
["signal-processing procedures",">frtime/index.html#(part._.Signal-.Processing_.Procedures)","Signal-Processing Procedures",false],
["signal?",">frtime/index.html#(def._((lib._frtime/main..ss)._signal~3f))",[0,[1,"signal?"]],["frtime"]],
["signature",">dynext/Compilation.html#(part._compile-sig)","Signature",false],
["signature",">dynext/Filenames.html#(part._file-sig)","Signature",false],
["signature",">dynext/Linking.html#(part._link-sig)","Signature",false],
["signature",">make/collection.html#(part._.Signature)","Signature",false],
["signature",">make/make.html#(part._make-signature)","Signature",false],
["signature",">web-server/web-server-unit_ss.html#(part._.Signature)","Signature",false],
["signature",">reference/mzlib_unit.html#(tech._signature)","<i>signature</i>",false],
["signature-desc",">scribble/doc-signatures.html#(def._((lib._scribble/manual..ss)._signature-desc))",[0,[1,"signature-desc"]],["scribble/manual"]],
["signature-members",">reference/Transformer_Helpers.html#(def._((lib._mzlib/unit-exptime..ss)._signature-members))",[0,[1,"signature-members"]],["scheme/unit-exptime"]],
["signatures",">graphics/Graphics_Library_as_a_Unit.html#(part._.Signatures)","Signatures",false],
["signatures",">mzc/Scheme_API_for_Compilation.html#(part._.Signatures)","Signatures",false],
["signatures",">guide/Signatures_and_Units.html#(tech._signature)","<i>signatures</i>",false],
["signatures and units",">guide/Signatures_and_Units.html","Signatures and Units",false],
["simple branching: if",">guide/conditionals.html#(part._.Simple_.Branching__if)",["Simple Branching: ",[0,[6,"if"]]],false],
["simple contracts on functions",">guide/contract-func.html","Simple Contracts on Functions",false],
["simple definitions and expressions",">guide/syntax-overview.html","Simple Definitions and Expressions",false],
["simple dispatch: case",">guide/Simple_Dispatch__case.html",["Simple Dispatch: ",[0,[6,"case"]]],false],
["simple drawing: \"draw.ss\"",">teachpack/draw.html",["Simple Drawing: ",[5,"\"draw.ss\""],"<a name=\"(idx._(gentag._5._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["simple graphical user interfaces: \"gui.ss\"",">teachpack/gui.html",["Simple Graphical User Interfaces: ",[5,"\"gui.ss\""],"<a name=\"(idx._(gentag._11._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["simple simulations",">teachpack/world.html#(part._simulations)","Simple Simulations",false],
["simple single servlet servers",">web-server/servlet-env_ss.html","Simple Single Servlet Servers",false],
["simple structure types: define-struct",">guide/define-struct.html#(part._.Simple_.Structure_.Types__define-struct)",["Simple Structure Types: ",[0,[6,"define-struct"]]],false],
["simple subprocesses",">reference/subprocess.html#(part._.Simple_.Subprocesses)","Simple Subprocesses",false],
["simple text",">gui/editor-overview.html#(tech._simple._text)","<i>Simple text</i>",false],
["simple values",">guide/Simple_Values.html","Simple Values",false],
["simple-conditions",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_396",[0,[1,"simple-conditions"]],["rnrs/conditions-6"]],
["simple-form-path",">reference/More_Path_Utilities.html#(def._((lib._scheme/path..ss)._simple-form-path))",[0,[1,"simple-form-path"]],["scheme/path","scheme"]],
["simplify-path",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._simplify-path))",[0,[1,"simplify-path"]],["scheme/base","scheme"]],
["simplifying module paths",">syntax/module-helpers.html#(part._modcollapse)","Simplifying Module Paths",false],
["simulating a door: data",">teachpack/world.html#(part._.Simulating_a_.Door__.Data)","Simulating a Door: Data",false],
["simulating a door: functions",">teachpack/world.html#(part._.Simulating_a_.Door__.Functions)","Simulating a Door: Functions",false],
["simulations and animations: \"world.ss\"",">teachpack/world.html",["Simulations and Animations: ",[5,"\"world.ss\""],"<a name=\"(idx._(gentag._1._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["simulations of the world",">teachpack/world.html#(part._.Simulations_of_the_.World)","Simulations of the World",false],
["sin",">reference/numbers.html#(def._((quote._~23~25kernel)._sin))",[0,[1,"sin"]],["scheme/base","scheme"]],
["sin",">r5rs-std/r5rs-Z-H-9.html#%_idx_330",[0,[1,"sin"]],["r5rs"]],
["sin",">r6rs-std/r6rs-Z-H-14.html#node_idx_546",[0,[1,"sin"]],["rnrs/base-6"]],
["sin",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._sin))",[0,[1,"sin"]],["lang/htdp-advanced"]],
["sin",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._sin))",[0,[1,"sin"]],["lang/htdp-beginner"]],
["sin",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._sin))",[0,[1,"sin"]],["lang/htdp-beginner-abbr"]],
["sin",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._sin))",[0,[1,"sin"]],["lang/htdp-intermediate"]],
["sin",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._sin))",[0,[1,"sin"]],["lang/htdp-intermediate-lambda"]],
["single",">gui/Windowing_Functions.html#(idx._(gentag._146._(lib._scribblings/gui/gui..scrbl)))",[7,"'single"],false],
["single-line-text-mixin",">embedded-gui/Helpers.html#(def._((lib._embedded-gui/main..ss)._single-line-text-mixin))",[0,[1,"single-line-text-mixin"]],["embedded-gui"]],
["single-signature modules",">reference/Single-Signature_Modules.html","Single-Signature Modules",false],
["single-unit modules",">reference/single-unit.html","Single-Unit Modules",false],
["sinh",">reference/numbers.html#(def._((lib._scheme/math..ss)._sinh))",[0,[1,"sinh"]],["scheme/math","scheme"]],
["sinh",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._sinh))",[0,[1,"sinh"]],["lang/htdp-advanced"]],
["sinh",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._sinh))",[0,[1,"sinh"]],["lang/htdp-beginner"]],
["sinh",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._sinh))",[0,[1,"sinh"]],["lang/htdp-beginner-abbr"]],
["sinh",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._sinh))",[0,[1,"sinh"]],["lang/htdp-intermediate"]],
["sinh",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._sinh))",[0,[1,"sinh"]],["lang/htdp-intermediate-lambda"]],
["sint-list->bytevector",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_122",[0,[1,"sint-list-&gt;bytevector"]],["rnrs/bytevectors-6"]],
["sixth",">reference/pairs.html#(def._((lib._scheme/list..ss)._sixth))",[0,[1,"sixth"]],["scheme/list","scheme"]],
["sixth",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._sixth))",[0,[1,"sixth"]],["lang/htdp-advanced"]],
["sixth",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._sixth))",[0,[1,"sixth"]],["lang/htdp-beginner"]],
["sixth",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._sixth))",[0,[1,"sixth"]],["lang/htdp-beginner-abbr"]],
["sixth",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._sixth))",[0,[1,"sixth"]],["lang/htdp-intermediate"]],
["sixth",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._sixth))",[0,[1,"sixth"]],["lang/htdp-intermediate-lambda"]],
["sixth",">lazy/index.html#(def._((lib._lazy/main..ss)._sixth))",[0,[1,"sixth"]],["lazy"]],
["sixth",">mzlib/mzlib_list.html#(def._((lib._mzlib/list..ss)._sixth))",[0,[1,"sixth"]],["mzlib/list"]],
["sixth",">srfi-std/srfi-1.html#sixth",[0,[1,"sixth"]],["srfi/1"]],
["size-cache-invalid",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._size-cache-invalid))",[[0,[1,"size-cache-invalid"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["size-in-pixels",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..ss)._size-in-pixels))",[0,[1,"size-in-pixels"]],["slideshow/base","slideshow"]],
["sk",">reference/characters.html#(idx._(gentag._56._(lib._scribblings/reference/reference..scrbl)))",[7,"'sk"],false],
["skip",">gui/editor-stream-in_.html#(meth._(((lib._mred/main..ss)._editor-stream-in~25)._skip))",[[0,[1,"skip"]],[12,[" (method of ",[0,[1,"editor-stream-in%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["skip",">gui/editor-stream-in-base_.html#(meth._(((lib._mred/main..ss)._editor-stream-in-base~25)._skip))",[[0,[1,"skip"]],[12,[" (method of ",[0,[1,"editor-stream-in-base%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["skip-to",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..ss)._skip-to))",[0,[1,"skip-to"]],["preprocessor/mzpp"]],
["skip-whitespace",">framework/Color.html#(meth._(((lib._framework/main..ss)._color~3atext~3c~25~3e)._skip-whitespace))",[[0,[1,"skip-whitespace"]],[12,[" (method of ",[0,[1,"color:text&lt;%&gt;"]],")"]]],["framework"]],
["slant",">gui/font_.html#(idx._(gentag._203._(lib._scribblings/gui/gui..scrbl)))",[7,"'slant"],false],
["slant",">gui/style-delta_.html#(idx._(gentag._266._(lib._scribblings/gui/gui..scrbl)))",[7,"'slant"],false],
["slatex",">slatex-wrap/index.html#(def._((lib._slatex/slatex-wrapper..ss)._slatex))",[0,[1,"slatex"]],["slatex/slatex-wrapper"]],
["slatex wrapper",">slatex-wrap/index.html","SLaTeX Wrapper",false],
["slatex/no-latex",">slatex-wrap/index.html#(def._((lib._slatex/slatex-wrapper..ss)._slatex/no-latex))",[0,[1,"slatex/no-latex"]],["slatex/slatex-wrapper"]],
["slatex/slatex-wrapper",">slatex-wrap/index.html",[14,[0,"slatex/slatex-wrapper"]],"module"],
["sleep",">reference/threads.html#(def._((quote._~23~25kernel)._sleep))",[0,[1,"sleep"]],["scheme/base","scheme"]],
["sleep-for-a-while",">teachpack/draw.html#(def._((lib._teachpack/htdp/draw..ss)._sleep-for-a-while))",[0,[1,"sleep-for-a-while"]],["teachpack/htdp/draw"]],
["sleep/yield",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._sleep/yield))",[0,[1,"sleep/yield"]],["scheme/gui/base","scheme/gui"]],
["sleeping by embedded scheme",">inside/threads.html#(part._sleeping)","Sleeping by Embedded Scheme",false],
["slide",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..ss)._slide))",[0,[1,"slide"]],["slideshow/base","slideshow"]],
["slide basics",">slideshow/Creating_Slide_Presentations.html#(part._.Slide_.Basics)","Slide Basics",false],
["slide registration",">slideshow/Slide_Registration.html","Slide Registration",false],
["slide-inset?",">slideshow/Configuration.html#(def._((lib._slideshow/base..ss)._slide-inset~3f))",[0,[1,"slide-inset?"]],["slideshow/base","slideshow"]],
["slide?",">slideshow/Slide_Registration.html#(def._((lib._slideshow/base..ss)._slide~3f))",[0,[1,"slide?"]],["slideshow/base","slideshow"]],
["slider",">gui/slider_.html#(idx._(gentag._127._(lib._scribblings/gui/gui..scrbl)))",[7,"'slider"],false],
["slider",">gui/windowing-overview.html#(tech._slider)","<i>slider</i>",false],
["slider%",">gui/slider_.html",[0,[1,"slider%"]],["scheme/gui/base","scheme/gui"]],
["slides to picts",">slideshow/Slides_to_Picts.html","Slides to Picts",false],
["slideshow",">slideshow/index.html",[14,[0,"slideshow"]],"module"],
["slideshow/balloon",">slideshow/More_Pict_Constructors.html#(mod-path._slideshow/balloon)",[14,[0,"slideshow/balloon"]],"module"],
["slideshow/base",">slideshow/Making_Slides.html",[14,[0,"slideshow/base"]],"module"],
["slideshow/code",">slideshow/Typesetting_Scheme_Code.html",[14,[0,"slideshow/code"]],"module"],
["slideshow/face",">slideshow/More_Pict_Constructors.html#(mod-path._slideshow/face)",[14,[0,"slideshow/face"]],"module"],
["slideshow/flash",">slideshow/More_Pict_Constructors.html#(mod-path._slideshow/flash)",[14,[0,"slideshow/flash"]],"module"],
["slideshow/pict",">slideshow/Making_Pictures.html",[14,[0,"slideshow/pict"]],"module"],
["slideshow/slides-to-picts",">slideshow/Slides_to_Picts.html",[14,[0,"slideshow/slides-to-picts"]],"module"],
["slideshow/start",">slideshow/Creating_Slide_Presentations.html#(mod-path._slideshow/start)",[14,[0,"slideshow/start"]],"module"],
["slideshow/step",">slideshow/Pict-Staging_Helper.html",[14,[0,"slideshow/step"]],"module"],
["slideshow: plt figure and presentation tools",">slideshow/index.html","<b>Slideshow</b>: PLT Figure and Presentation Tools",false],
["slidey --- picture puzzle",">games/slidey.html",[[13,"<img src=\"slidey.png\" />"]," ","<b><font size=\"-1\" face=\"Helvetica\">Slidey</font></b>","  ","&ndash;","  Picture Puzzle"],false],
["sllgen:list-define-datatypes",">eopl/index.html#(form._((lib._eopl/eopl..ss)._sllgen~3alist-define-datatypes))",[0,[6,"sllgen:list-define-datatypes"]],["eopl/eopl"]],
["sllgen:make-define-datatypes",">eopl/index.html#(form._((lib._eopl/eopl..ss)._sllgen~3amake-define-datatypes))",[0,[6,"sllgen:make-define-datatypes"]],["eopl/eopl"]],
["sllgen:make-rep-loop",">eopl/index.html#(def._((lib._eopl/eopl..ss)._sllgen~3amake-rep-loop))",[0,[1,"sllgen:make-rep-loop"]],["eopl/eopl"]],
["sllgen:make-stream-parser",">eopl/index.html#(form._((lib._eopl/eopl..ss)._sllgen~3amake-stream-parser))",[0,[6,"sllgen:make-stream-parser"]],["eopl/eopl"]],
["sllgen:make-string-parser",">eopl/index.html#(form._((lib._eopl/eopl..ss)._sllgen~3amake-string-parser))",[0,[6,"sllgen:make-string-parser"]],["eopl/eopl"]],
["sllgen:make-string-scanner",">eopl/index.html#(form._((lib._eopl/eopl..ss)._sllgen~3amake-string-scanner))",[0,[6,"sllgen:make-string-scanner"]],["eopl/eopl"]],
["sllgen:show-define-datatypes",">eopl/index.html#(form._((lib._eopl/eopl..ss)._sllgen~3ashow-define-datatypes))",[0,[6,"sllgen:show-define-datatypes"]],["eopl/eopl"]],
["sm",">reference/characters.html#(idx._(gentag._55._(lib._scribblings/reference/reference..scrbl)))",[7,"'sm"],false],
["small",">html/index.html#(def._((lib._html/main..ss)._small))",[0,[1,"small"]],["html"]],
["small-control-font",">gui/Drawing_Functions.html#(def._((lib._mred/main..ss)._small-control-font))",[0,[1,"small-control-font"]],["scheme/gui/base","scheme/gui"]],
["small?",">html/index.html#(def._((lib._html/main..ss)._small~3f))",[0,[1,"small?"]],["html"]],
["smoothed",">gui/font_.html#(idx._(gentag._210._(lib._scribblings/gui/gui..scrbl)))",[7,"'smoothed"],false],
["smoothed",">gui/style-delta_.html#(idx._(gentag._270._(lib._scribblings/gui/gui..scrbl)))",[7,"'smoothed"],false],
["smtp functions",">net/smtp.html#(part._.S.M.T.P_.Functions)","SMTP Functions",false],
["smtp signature",">net/smtp.html#(part._.S.M.T.P_.Signature)","SMTP Signature",false],
["smtp unit",">net/smtp.html#(part._.S.M.T.P_.Unit)","SMTP Unit",false],
["smtp-send-message",">net/smtp.html#(def._((lib._net/smtp..ss)._smtp-send-message))",[0,[1,"smtp-send-message"]],["net/smtp"]],
["smtp-sending-end-of-message",">net/smtp.html#(def._((lib._net/smtp..ss)._smtp-sending-end-of-message))",[0,[1,"smtp-sending-end-of-message"]],["net/smtp"]],
["smtp: sending e-mail",">net/smtp.html","SMTP: Sending E-Mail",false],
["smtp@",">net/smtp.html#(def._((lib._net/smtp-unit..ss)._smtp~40))",[0,[1,"smtp@"]],["net/smtp-unit"]],
["smtp^",">net/smtp.html#(form._((lib._net/smtp-sig..ss)._smtp~5e))",[0,[6,"smtp^"]],["net/smtp-sig"]],
["snap-back-after-move",">cards/index.html#(meth._(((lib._games/cards..ss)._card~3c~25~3e)._snap-back-after-move))",[[0,[1,"snap-back-after-move"]],[12,[" (method of ",[0,[1,"card&lt;%&gt;"]],")"]]],["games/cards"]],
["snapshot",">gui/key-event_.html#(idx._(gentag._66._(lib._scribblings/gui/gui..scrbl)))",[7,"'snapshot"],false],
["snip",">gui/editor-overview.html#(tech._snip)","<i>snip</i>",false],
["snip administrator",">gui/editor-overview.html#(tech._snip._administrator)","<i>snip administrator</i>",false],
["snip class",">gui/editor-overview.html#(tech._snip._clas)","<i>snip class</i>",false],
["snip class list",">gui/editor-overview.html#(tech._snip._class._list)","<i>snip class list</i>",false],
["snip class mapping",">gui/WXME_Decoding.html#(part._snipclassmapping)","Snip Class Mapping",false],
["snip classes",">gui/editor-overview.html#(part._editorsnipclasses)","Snip Classes",false],
["snip functions",">embedded-gui/snip-related-functions.html","Snip Functions",false],
["snip%",">gui/snip_.html",[0,[1,"snip%"]],["scheme/gui/base","scheme/gui"]],
["snip-admin%",">gui/snip-admin_.html",[0,[1,"snip-admin%"]],["scheme/gui/base","scheme/gui"]],
["snip-class",">mrlib/Cache-image_Snip.html#(def._((lib._mrlib/cache-image-snip..ss)._snip-class))",[0,[1,"snip-class"]],["mrlib/cache-image-snip"]],
["snip-class%",">gui/snip-class_.html",[0,[1,"snip-class%"]],["scheme/gui/base","scheme/gui"]],
["snip-class-list<%>",">gui/snip-class-list___.html",[0,[1,"snip-class-list&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["snip-height",">embedded-gui/snip-related-functions.html#(def._((lib._embedded-gui/main..ss)._snip-height))",[0,[1,"snip-height"]],["embedded-gui"]],
["snip-min-height",">embedded-gui/snip-related-functions.html#(def._((lib._embedded-gui/main..ss)._snip-min-height))",[0,[1,"snip-min-height"]],["embedded-gui"]],
["snip-min-width",">embedded-gui/snip-related-functions.html#(def._((lib._embedded-gui/main..ss)._snip-min-width))",[0,[1,"snip-min-width"]],["embedded-gui"]],
["snip-parent",">embedded-gui/snip-related-functions.html#(def._((lib._embedded-gui/main..ss)._snip-parent))",[0,[1,"snip-parent"]],["embedded-gui"]],
["snip-reader<%>",">gui/WXME_Decoding.html#(def._((lib._wxme/main..ss)._snip-reader~3c~25~3e))",[0,[1,"snip-reader&lt;%&gt;"]],["wxme"]],
["snip-width",">embedded-gui/snip-related-functions.html#(def._((lib._embedded-gui/main..ss)._snip-width))",[0,[1,"snip-width"]],["embedded-gui"]],
["snip-wrapper%",">embedded-gui/snip-wrapper_.html",[0,[1,"snip-wrapper%"]],["embedded-gui"]],
["snips saving",">gui/editor-overview.html#(idx._(gentag._16._(lib._scribblings/gui/gui..scrbl)))","snips, saving",false],
["snips cut and paste",">gui/editor-overview.html#(idx._(gentag._17._(lib._scribblings/gui/gui..scrbl)))","snips, cut and paste",false],
["snips in a hierarchical-list% instance",">mrlib/Snips_in_a_hierarchical-list__Instance.html",["Snips in a ",[0,[1,"hierarchical-list%"]]," Instance"],false],
["so",">reference/characters.html#(idx._(gentag._57._(lib._scribblings/reference/reference..scrbl)))",[7,"'so"],false],
["so-suffix",">reference/runtime.html#(idx._(gentag._307._(lib._scribblings/reference/reference..scrbl)))",[7,"'so-suffix"],false],
["solid",">gui/brush_.html#(idx._(gentag._177._(lib._scribblings/gui/gui..scrbl)))",[7,"'solid"],false],
["solid",">gui/pen_.html#(idx._(gentag._217._(lib._scribblings/gui/gui..scrbl)))",[7,"'solid"],false],
["some frequently used character classes",">guide/regexp-chars.html#(part._.Some_.Frequently_.Used_.Character_.Classes)","Some Frequently Used Character Classes",false],
["sort",">reference/pairs.html#(def._((lib._scheme/base..ss)._sort))",[0,[1,"sort"]],["scheme/base","scheme"]],
["sort",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._sort))",[0,[1,"sort"]],["lang/htdp-advanced"]],
["sort",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._sort))",[0,[1,"sort"]],["lang/htdp-intermediate"]],
["sort",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._sort))",[0,[1,"sort"]],["lang/htdp-intermediate-lambda"]],
["sort",">lazy/index.html#(def._((lib._lazy/main..ss)._sort))",[0,[1,"sort"]],["lazy"]],
["sort",">mrlib/hierarchical-list_.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list~25)._sort))",[[0,[1,"sort"]],[12,[" (method of ",[0,[1,"hierarchical-list%"]],")"]]],["mrlib/hierlist"]],
["source",">xml/index.html#(def._((lib._xml/main..ss)._source))",[0,[1,"source"]],["xml"]],
["source-start",">xml/index.html#(def._((lib._xml/main..ss)._source-start))",[0,[1,"source-start"]],["xml"]],
["source-stop",">xml/index.html#(def._((lib._xml/main..ss)._source-stop))",[0,[1,"source-stop"]],["xml"]],
["source?",">xml/index.html#(def._((lib._xml/main..ss)._source~3f))",[0,[1,"source?"]],["xml"]],
["spaced-turtles",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..ss)._spaced-turtles))",[0,[1,"spaced-turtles"]],["graphics/turtle-examples"]],
["spacing",">gui/area-container___.html#(meth._(((lib._mred/main..ss)._area-container~3c~25~3e)._spacing))",[[0,[1,"spacing"]],[12,[" (method of ",[0,[1,"area-container&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["spacing",">gui/area-container___.html#(idx._(gentag._26._(lib._scribblings/gui/gui..scrbl)))",[0,"spacing"],false],
["span",">html/index.html#(def._((lib._html/main..ss)._span))",[0,[1,"span"]],["html"]],
["span",">srfi-std/srfi-1.html#span",[0,[1,"span"]],["srfi/1"]],
["span!",">srfi-std/srfi-1.html#span!",[0,[1,"span!"]],["srfi/1"]],
["span-class",">scribble/basic.html#(def._((lib._scribble/basic..ss)._span-class))",[0,[1,"span-class"]],["scribble/basic"]],
["span?",">html/index.html#(def._((lib._html/main..ss)._span~3f))",[0,[1,"span?"]],["html"]],
["spawn",">reference/cont.html#(def._((lib._scheme/control..ss)._spawn))",[0,[1,"spawn"]],["scheme/control"]],
["spawn",">mzlib/mzlib_cml.html#(def._((lib._mzlib/cml..ss)._spawn))",[0,[1,"spawn"]],["mzlib/cml"]],
["specform",">scribble/doc-forms.html#(form._((lib._scribble/manual..ss)._specform))",[0,[6,"specform"]],["scribble/manual"]],
["special comments",">reference/special-comments.html","Special Comments",false],
["special form reference",">typed-scheme/index.html#(part._special-forms)","Special Form Reference",false],
["special-comment-value",">reference/special-comments.html#(def._((quote._~23~25kernel)._special-comment-value))",[0,[1,"special-comment-value"]],["scheme/base","scheme"]],
["special-comment?",">reference/special-comments.html#(def._((quote._~23~25kernel)._special-comment~3f))",[0,[1,"special-comment?"]],["scheme/base","scheme"]],
["special-control-key",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._special-control-key))",[0,[1,"special-control-key"]],["scheme/gui/base","scheme/gui"]],
["special-option-key",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._special-option-key))",[0,[1,"special-option-key"]],["scheme/gui/base","scheme/gui"]],
["specific-collections",">setup-plt/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..ss)._setup-option~5e._specific-collections))",[0,[1,"specific-collections"]],["setup/option-sig"]],
["specspecsubform",">scribble/doc-forms.html#(form._((lib._scribble/manual..ss)._specspecsubform))",[0,[6,"specspecsubform"]],["scribble/manual"]],
["specspecsubform/subs",">scribble/doc-forms.html#(form._((lib._scribble/manual..ss)._specspecsubform/subs))",[0,[6,"specspecsubform/subs"]],["scribble/manual"]],
["specsubform",">scribble/doc-forms.html#(form._((lib._scribble/manual..ss)._specsubform))",[0,[6,"specsubform"]],["scribble/manual"]],
["specsubform/subs",">scribble/doc-forms.html#(form._((lib._scribble/manual..ss)._specsubform/subs))",[0,[6,"specsubform/subs"]],["scribble/manual"]],
["spider --- solitaire card game",">games/spider.html",[[13,"<img src=\"spider.png\" />"]," ","<b><font size=\"-1\" face=\"Helvetica\">Spider</font></b>","  ","&ndash;","  Solitaire Card Game"],false],
["splay tree for tokenization",">syntax-color/index.html#(part._.Splay_.Tree_for_.Tokenization)","Splay Tree for Tokenization",false],
["splice",">scribble/decode.html#(def._((lib._scribble/decode..ss)._splice))",[0,[1,"splice"]],["scribble/decode"]],
["splice-run",">scribble/decode.html#(def._((lib._scribble/decode..ss)._splice-run))",[0,[1,"splice-run"]],["scribble/decode"]],
["splice?",">scribble/decode.html#(def._((lib._scribble/decode..ss)._splice~3f))",[0,[1,"splice?"]],["scribble/decode"]],
["split",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._split))",[[0,[1,"split"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["split",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3a1-pixel-string-snip~25)._split))",[[0,[1,"split"]],[12,[" (method of ",[0,[1,"text:1-pixel-string-snip%"]],")"]]],["framework"]],
["split",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3a1-pixel-tab-snip~25)._split))",[[0,[1,"split"]],[12,[" (method of ",[0,[1,"text:1-pixel-tab-snip%"]],")"]]],["framework"]],
["split",">turtles/Traditional_Turtles.html#(form._((lib._graphics/turtles..ss)._split))",[0,[6,"split"]],["graphics/turtles"]],
["split",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..ss)._split))",[0,[1,"split"]],["mzlib/integer-set"]],
["split menu item",">drscheme/Menus.html#(idx._(gentag._113._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Split</font></b> menu item",false],
["split*",">turtles/Traditional_Turtles.html#(form._((lib._graphics/turtles..ss)._split*))",[0,[6,"split*"]],["graphics/turtles"]],
["split-at",">reference/pairs.html#(def._((lib._scheme/list..ss)._split-at))",[0,[1,"split-at"]],["scheme/list","scheme"]],
["split-at",">srfi-std/srfi-1.html#split-at",[0,[1,"split-at"]],["srfi/1"]],
["split-at!",">srfi-std/srfi-1.html#split-at!",[0,[1,"split-at!"]],["srfi/1"]],
["split-at-right",">reference/pairs.html#(def._((lib._scheme/list..ss)._split-at-right))",[0,[1,"split-at-right"]],["scheme/list","scheme"]],
["split-path",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._split-path))",[0,[1,"split-path"]],["scheme/base","scheme"]],
["split-snip",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._split-snip))",[[0,[1,"split-snip"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["splitter",">reference/cont.html#(def._((lib._scheme/control..ss)._splitter))",[0,[1,"splitter"]],["scheme/control"]],
["splitting the document source",">scribble/How_to_Scribble_Documentation.html#(part._.Splitting_the_.Document_.Source)","Splitting the Document Source",false],
["spokes",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..ss)._spokes))",[0,[1,"spokes"]],["graphics/turtle-examples"]],
["spyro-gyra",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtle-examples..ss)._spyro-gyra))",[0,[1,"spyro-gyra"]],["graphics/turtle-examples"]],
["sqlite:db?",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/dummy-sqlite..ss)._sqlite~3adb~3f))",[0,[1,"sqlite:db?"]],[]],
["sqlite:exec/ignore",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/dummy-sqlite..ss)._sqlite~3aexec/ignore))",[0,[1,"sqlite:exec/ignore"]],[]],
["sqlite:insert",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/dummy-sqlite..ss)._sqlite~3ainsert))",[0,[1,"sqlite:insert"]],[]],
["sqlite:open",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/dummy-sqlite..ss)._sqlite~3aopen))",[0,[1,"sqlite:open"]],[]],
["sqlite:select",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/dummy-sqlite..ss)._sqlite~3aselect))",[0,[1,"sqlite:select"]],[]],
["sqr",">reference/numbers.html#(def._((lib._scheme/math..ss)._sqr))",[0,[1,"sqr"]],["scheme/math","scheme"]],
["sqr",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._sqr))",[0,[1,"sqr"]],["lang/htdp-advanced"]],
["sqr",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._sqr))",[0,[1,"sqr"]],["lang/htdp-beginner"]],
["sqr",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._sqr))",[0,[1,"sqr"]],["lang/htdp-beginner-abbr"]],
["sqr",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._sqr))",[0,[1,"sqr"]],["lang/htdp-intermediate"]],
["sqr",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._sqr))",[0,[1,"sqr"]],["lang/htdp-intermediate-lambda"]],
["sqrt",">reference/numbers.html#(def._((quote._~23~25kernel)._sqrt))",[0,[1,"sqrt"]],["scheme/base","scheme"]],
["sqrt",">r5rs-std/r5rs-Z-H-9.html#%_idx_344",[0,[1,"sqrt"]],["r5rs"]],
["sqrt",">r6rs-std/r6rs-Z-H-14.html#node_idx_560",[0,[1,"sqrt"]],["rnrs/base-6"]],
["sqrt",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._sqrt))",[0,[1,"sqrt"]],["lang/htdp-advanced"]],
["sqrt",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._sqrt))",[0,[1,"sqrt"]],["lang/htdp-beginner"]],
["sqrt",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._sqrt))",[0,[1,"sqrt"]],["lang/htdp-beginner-abbr"]],
["sqrt",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._sqrt))",[0,[1,"sqrt"]],["lang/htdp-intermediate"]],
["sqrt",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._sqrt))",[0,[1,"sqrt"]],["lang/htdp-intermediate-lambda"]],
["square root",">reference/numbers.html#(idx._(gentag._17._(lib._scribblings/reference/reference..scrbl)))","square root",false],
["srcloc",">reference/exns.html#(def._((quote._~23~25kernel)._srcloc))",[0,[1,"srcloc"]],["scheme/base","scheme"]],
["srcloc-column",">reference/exns.html#(def._((quote._~23~25kernel)._srcloc-column))",[0,[1,"srcloc-column"]],["scheme/base","scheme"]],
["srcloc-line",">reference/exns.html#(def._((quote._~23~25kernel)._srcloc-line))",[0,[1,"srcloc-line"]],["scheme/base","scheme"]],
["srcloc-position",">reference/exns.html#(def._((quote._~23~25kernel)._srcloc-position))",[0,[1,"srcloc-position"]],["scheme/base","scheme"]],
["srcloc-source",">reference/exns.html#(def._((quote._~23~25kernel)._srcloc-source))",[0,[1,"srcloc-source"]],["scheme/base","scheme"]],
["srcloc-span",">reference/exns.html#(def._((quote._~23~25kernel)._srcloc-span))",[0,[1,"srcloc-span"]],["scheme/base","scheme"]],
["srcloc?",">reference/exns.html#(def._((quote._~23~25kernel)._srcloc~3f))",[0,[1,"srcloc?"]],["scheme/base","scheme"]],
["srfi",">srfi/index.html#(tech._srfi)","<i>SRFI</i>",false],
["srfi 11: syntax for receiving multiple values",">srfi/srfi-11.html","SRFI 11: Syntax for receiving multiple values",false],
["srfi 13: string libraries",">srfi/srfi-13.html","SRFI 13: String Libraries",false],
["srfi 14: character-set library",">srfi/srfi-14.html","SRFI 14: Character-set Library",false],
["srfi 16: syntax for procedures of variable arity",">srfi/srfi-16.html","SRFI 16: Syntax for procedures of variable arity",false],
["srfi 17: generalized set!",">srfi/srfi-17.html","SRFI 17: Generalized set!",false],
["srfi 19: time data types and procedures",">srfi/srfi-19.html","SRFI 19: Time Data Types and Procedures",false],
["srfi 1: list library",">srfi/srfi-1.html","SRFI 1: List Library",false],
["srfi 23: error reporting mechanism",">srfi/srfi-23.html","SRFI 23: Error reporting mechanism",false],
["srfi 25: multi-dimensional array primitives",">srfi/srfi-25.html","SRFI 25: Multi-dimensional Array Primitives",false],
["srfi 26: notation for specializing parameters without currying",">srfi/srfi-26.html","SRFI 26: Notation for Specializing Parameters without Currying",false],
["srfi 27: sources of random bits",">srfi/srfi-27.html","SRFI 27: Sources of Random Bits",false],
["srfi 28: basic format strings",">srfi/srfi-28.html","SRFI 28: Basic Format Strings",false],
["srfi 29: localization",">srfi/srfi-29.html","SRFI 29: Localization",false],
["srfi 2: and-let*: an and with local bindings...",">srfi/srfi-2.html","SRFI 2: AND-LET*: an AND with local bindings...",false],
["srfi 30: nested multi-line comments",">srfi/srfi-30.html","SRFI 30: Nested Multi-line Comments",false],
["srfi 31: a special form rec for recursive evaluation",">srfi/srfi-31.html","SRFI 31: A special form rec for recursive evaluation",false],
["srfi 34: exception handling for programs",">srfi/srfi-34.html","SRFI 34: Exception Handling for Programs",false],
["srfi 35: conditions",">srfi/srfi-35.html","SRFI 35: Conditions",false],
["srfi 38: external representation for data with shared structure",">srfi/srfi-38.html","SRFI 38: External Representation for Data With Shared Structure",false],
["srfi 39: parameter objects",">srfi/srfi-39.html","SRFI 39: Parameter objects",false],
["srfi 40: a library of streams",">srfi/srfi-40.html","SRFI 40: A Library of Streams",false],
["srfi 41: streams",">srfi/srfi-41.html","SRFI 41: Streams",false],
["srfi 42: eager comprehensions",">srfi/srfi-42.html","SRFI 42: Eager Comprehensions",false],
["srfi 43: vector library",">srfi/srfi-43.html","SRFI 43: Vector Library",false],
["srfi 45: primitives for expressing iterative lazy algorithms",">srfi/srfi-45.html","SRFI 45: Primitives for Expressing Iterative Lazy Algorithms",false],
["srfi 48: intermediate format strings",">srfi/srfi-48.html","SRFI 48: Intermediate Format Strings",false],
["srfi 4: homogeneous numeric vector datatypes",">srfi/srfi-4.html","SRFI 4: Homogeneous numeric vector datatypes",false],
["srfi 54: formatting",">srfi/srfi-54.html","SRFI 54: Formatting",false],
["srfi 57: records",">srfi/srfi-57.html","SRFI 57: Records",false],
["srfi 59: vicinity",">srfi/srfi-59.html","SRFI 59: Vicinity",false],
["srfi 5: a compatible let form with signatures and rest arguments",">srfi/srfi-5.html","SRFI 5: A compatible let form with signatures and rest arguments",false],
["srfi 60: integers as bits",">srfi/srfi-60.html","SRFI 60: Integers as Bits",false],
["srfi 61: a more general cond clause",">srfi/srfi-61.html","SRFI 61: A more general cond clause",false],
["srfi 62: s-expression comments",">srfi/srfi-62.html","SRFI 62: S-expression comments",false],
["srfi 63: homogeneous and heterogeneous arrays",">srfi/srfi-63.html","SRFI 63: Homogeneous and Heterogeneous Arrays",false],
["srfi 64: a scheme api for test suites",">srfi/srfi-64.html","SRFI 64: A Scheme API for test suites",false],
["srfi 66: octet vectors",">srfi/srfi-66.html","SRFI 66: Octet Vectors",false],
["srfi 67: compare procedures",">srfi/srfi-67.html","SRFI 67: Compare Procedures",false],
["srfi 69: basic hash tables",">srfi/srfi-69.html","SRFI 69: Basic hash tables",false],
["srfi 6: basic string ports",">srfi/srfi-6.html","SRFI 6: Basic String Ports",false],
["srfi 71: extended let-syntax for multiple values",">srfi/srfi-71.html","SRFI 71: Extended LET-syntax for multiple values",false],
["srfi 74: octet-addressed binary blocks",">srfi/srfi-74.html","SRFI 74: Octet-Addressed Binary Blocks",false],
["srfi 78: lightweight testing",">srfi/srfi-78.html","SRFI 78: Lightweight testing",false],
["srfi 7: feature-based program configuration language",">srfi/srfi-7.html","SRFI 7: Feature-based program configuration language",false],
["srfi 86: mu & nu simulating values & call-with-values...",">srfi/srfi-86.html","SRFI 86: MU &amp; NU simulating VALUES &amp; CALL-WITH-VALUES...",false],
["srfi 87: => in case clauses",">srfi/srfi-87.html","SRFI 87: =&gt; in case clauses",false],
["srfi 8: receive: binding to multiple values",">srfi/srfi-8.html","SRFI 8: RECEIVE: Binding to multiple values",false],
["srfi 9: defining record types",">srfi/srfi-9.html","SRFI 9: Defining Record Types",false],
["srfi-4 vectors",">foreign/Derived_Utilities.html#(part._.S.R.F.I-4_.Vectors)","SRFI-4 Vectors",false],
["srfi/1",">srfi/srfi-1.html",[14,[0,"srfi/1"]],"module"],
["srfi/11",">srfi/srfi-11.html",[14,[0,"srfi/11"]],"module"],
["srfi/13",">srfi/srfi-13.html",[14,[0,"srfi/13"]],"module"],
["srfi/14",">srfi/srfi-14.html",[14,[0,"srfi/14"]],"module"],
["srfi/16",">srfi/srfi-16.html",[14,[0,"srfi/16"]],"module"],
["srfi/17",">srfi/srfi-17.html",[14,[0,"srfi/17"]],"module"],
["srfi/19",">srfi/srfi-19.html",[14,[0,"srfi/19"]],"module"],
["srfi/2",">srfi/srfi-2.html",[14,[0,"srfi/2"]],"module"],
["srfi/23",">srfi/srfi-23.html",[14,[0,"srfi/23"]],"module"],
["srfi/25",">srfi/srfi-25.html",[14,[0,"srfi/25"]],"module"],
["srfi/26",">srfi/srfi-26.html",[14,[0,"srfi/26"]],"module"],
["srfi/27",">srfi/srfi-27.html",[14,[0,"srfi/27"]],"module"],
["srfi/28",">srfi/srfi-28.html",[14,[0,"srfi/28"]],"module"],
["srfi/29",">srfi/srfi-29.html",[14,[0,"srfi/29"]],"module"],
["srfi/30",">srfi/srfi-30.html",[14,[0,"srfi/30"]],"module"],
["srfi/31",">srfi/srfi-31.html",[14,[0,"srfi/31"]],"module"],
["srfi/34",">srfi/srfi-34.html",[14,[0,"srfi/34"]],"module"],
["srfi/35",">srfi/srfi-35.html",[14,[0,"srfi/35"]],"module"],
["srfi/38",">srfi/srfi-38.html",[14,[0,"srfi/38"]],"module"],
["srfi/39",">srfi/srfi-39.html",[14,[0,"srfi/39"]],"module"],
["srfi/4",">srfi/srfi-4.html",[14,[0,"srfi/4"]],"module"],
["srfi/40",">srfi/srfi-40.html",[14,[0,"srfi/40"]],"module"],
["srfi/41",">srfi/srfi-41.html",[14,[0,"srfi/41"]],"module"],
["srfi/42",">srfi/srfi-42.html",[14,[0,"srfi/42"]],"module"],
["srfi/43",">srfi/srfi-43.html",[14,[0,"srfi/43"]],"module"],
["srfi/45",">srfi/srfi-45.html",[14,[0,"srfi/45"]],"module"],
["srfi/48",">srfi/srfi-48.html",[14,[0,"srfi/48"]],"module"],
["srfi/5",">srfi/srfi-5.html",[14,[0,"srfi/5"]],"module"],
["srfi/54",">srfi/srfi-54.html",[14,[0,"srfi/54"]],"module"],
["srfi/57",">srfi/srfi-57.html",[14,[0,"srfi/57"]],"module"],
["srfi/59",">srfi/srfi-59.html",[14,[0,"srfi/59"]],"module"],
["srfi/6",">srfi/srfi-6.html",[14,[0,"srfi/6"]],"module"],
["srfi/60",">srfi/srfi-60.html",[14,[0,"srfi/60"]],"module"],
["srfi/61",">srfi/srfi-61.html",[14,[0,"srfi/61"]],"module"],
["srfi/63",">srfi/srfi-63.html",[14,[0,"srfi/63"]],"module"],
["srfi/64",">srfi/srfi-64.html",[14,[0,"srfi/64"]],"module"],
["srfi/66",">srfi/srfi-66.html",[14,[0,"srfi/66"]],"module"],
["srfi/67",">srfi/srfi-67.html",[14,[0,"srfi/67"]],"module"],
["srfi/69",">srfi/srfi-69.html",[14,[0,"srfi/69"]],"module"],
["srfi/7",">srfi/srfi-7.html",[14,[0,"srfi/7"]],"module"],
["srfi/71",">srfi/srfi-71.html",[14,[0,"srfi/71"]],"module"],
["srfi/74",">srfi/srfi-74.html",[14,[0,"srfi/74"]],"module"],
["srfi/78",">srfi/srfi-78.html",[14,[0,"srfi/78"]],"module"],
["srfi/8",">srfi/srfi-8.html",[14,[0,"srfi/8"]],"module"],
["srfi/86",">srfi/srfi-86.html",[14,[0,"srfi/86"]],"module"],
["srfi/87",">srfi/srfi-87.html",[14,[0,"srfi/87"]],"module"],
["srfi/9",">srfi/srfi-9.html",[14,[0,"srfi/9"]],"module"],
["srfis: libraries",">srfi/index.html","<b>SRFIs</b>: Libraries",false],
["ssl unit: tcp^ via ssl",">net/ssl-tcp-unit.html",["SSL Unit: ",[0,[6,"tcp^"]]," via SSL"],false],
["ssl-accept",">openssl/index.html#(def._((lib._openssl/main..ss)._ssl-accept))",[0,[1,"ssl-accept"]],["openssl"]],
["ssl-accept/enable-break",">openssl/index.html#(def._((lib._openssl/main..ss)._ssl-accept/enable-break))",[0,[1,"ssl-accept/enable-break"]],["openssl"]],
["ssl-available?",">openssl/index.html#(def._((lib._openssl/main..ss)._ssl-available~3f))",[0,[1,"ssl-available?"]],["openssl"]],
["ssl-client-context?",">openssl/index.html#(def._((lib._openssl/main..ss)._ssl-client-context~3f))",[0,[1,"ssl-client-context?"]],["openssl"]],
["ssl-close",">openssl/index.html#(def._((lib._openssl/main..ss)._ssl-close))",[0,[1,"ssl-close"]],["openssl"]],
["ssl-connect",">openssl/index.html#(def._((lib._openssl/main..ss)._ssl-connect))",[0,[1,"ssl-connect"]],["openssl"]],
["ssl-connect/enable-break",">openssl/index.html#(def._((lib._openssl/main..ss)._ssl-connect/enable-break))",[0,[1,"ssl-connect/enable-break"]],["openssl"]],
["ssl-listen",">openssl/index.html#(def._((lib._openssl/main..ss)._ssl-listen))",[0,[1,"ssl-listen"]],["openssl"]],
["ssl-listener?",">openssl/index.html#(def._((lib._openssl/main..ss)._ssl-listener~3f))",[0,[1,"ssl-listener?"]],["openssl"]],
["ssl-load-certificate-chain!",">openssl/index.html#(def._((lib._openssl/main..ss)._ssl-load-certificate-chain!))",[0,[1,"ssl-load-certificate-chain!"]],["openssl"]],
["ssl-load-fail-reason",">openssl/index.html#(def._((lib._openssl/main..ss)._ssl-load-fail-reason))",[0,[1,"ssl-load-fail-reason"]],["openssl"]],
["ssl-load-private-key!",">openssl/index.html#(def._((lib._openssl/main..ss)._ssl-load-private-key!))",[0,[1,"ssl-load-private-key!"]],["openssl"]],
["ssl-load-suggested-certificate-authorities!",">openssl/index.html#(def._((lib._openssl/main..ss)._ssl-load-suggested-certificate-authorities!))",[0,[1,"ssl-load-suggested-certificate-authorities!"]],["openssl"]],
["ssl-load-verify-root-certificates!",">openssl/index.html#(def._((lib._openssl/main..ss)._ssl-load-verify-root-certificates!))",[0,[1,"ssl-load-verify-root-certificates!"]],["openssl"]],
["ssl-make-client-context",">openssl/index.html#(def._((lib._openssl/main..ss)._ssl-make-client-context))",[0,[1,"ssl-make-client-context"]],["openssl"]],
["ssl-make-server-context",">openssl/index.html#(def._((lib._openssl/main..ss)._ssl-make-server-context))",[0,[1,"ssl-make-server-context"]],["openssl"]],
["ssl-server-context?",">openssl/index.html#(def._((lib._openssl/main..ss)._ssl-server-context~3f))",[0,[1,"ssl-server-context?"]],["openssl"]],
["ssl-set-verify!",">openssl/index.html#(def._((lib._openssl/main..ss)._ssl-set-verify!))",[0,[1,"ssl-set-verify!"]],["openssl"]],
["ssl-wrapper interface",">openssl/index.html#(part._.S.S.L-wrapper_.Interface)","SSL-wrapper Interface",false],
["st-mark-bindings",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..ss)._stacktrace~5e._st-mark-bindings))",[0,[1,"st-mark-bindings"]],["errortrace/stacktrace"]],
["st-mark-source",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..ss)._stacktrace~5e._st-mark-source))",[0,[1,"st-mark-source"]],["errortrace/stacktrace"]],
["stack dump",">reference/contmarks.html#(idx._(gentag._76._(lib._scribblings/reference/reference..scrbl)))","stack\ndump",false],
["stack trace",">reference/contmarks.html#(idx._(gentag._77._(lib._scribblings/reference/reference..scrbl)))","stack trace",false],
["stack view pane",">drscheme/debugger.html#(part._.Stack_.View_.Pane)","Stack View Pane",false],
["stack-cards",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._stack-cards))",[[0,[1,"stack-cards"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["stacktrace-imports^",">errortrace/stacktrace.html#(form._((lib._errortrace/stacktrace..ss)._stacktrace-imports~5e))",[0,[6,"stacktrace-imports^"]],["errortrace/stacktrace"]],
["stacktrace@",">errortrace/stacktrace.html#(def._((lib._errortrace/stacktrace..ss)._stacktrace~40))",[0,[1,"stacktrace@"]],["errortrace/stacktrace"]],
["stacktrace^",">errortrace/stacktrace.html#(form._((lib._errortrace/stacktrace..ss)._stacktrace~5e))",[0,[6,"stacktrace^"]],["errortrace/stacktrace"]],
["staging slides",">slideshow/Creating_Slide_Presentations.html#(part._staging)","Staging Slides",false],
["stand-alone executable",">drscheme/create-exe.html#(tech._stand._alone._executable)","<i>stand-alone executable</i>",false],
["stand-alone executables from scheme code",">mzc/exe.html","Stand-Alone Executables from Scheme Code",false],
["standard responders",">web-server/responders_ss.html","Standard Responders",false],
["standard style",">gui/editor-overview.html#(idx._(gentag._15._(lib._scribblings/gui/gui..scrbl)))",[[7,"\"Standard\""],"\nstyle"],false],
["standard types",">inside/im_values_types.html#(part._im~3astdtypes)","Standard Types",false],
["standard-error-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_732",[0,[1,"standard-error-port"]],["rnrs/io/ports-6"]],
["standard-fish",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._standard-fish))",[0,[1,"standard-fish"]],["slideshow/pict","slideshow"]],
["standard-input-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_676",[0,[1,"standard-input-port"]],["rnrs/io/ports-6"]],
["standard-message-header",">net/head.html#(def._((lib._net/head..ss)._standard-message-header))",[0,[1,"standard-message-header"]],["net/head"]],
["standard-output-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_730",[0,[1,"standard-output-port"]],["rnrs/io/ports-6"]],
["star",">teachpack/image.html#(def._((lib._htdp/image..ss)._star))",[0,[1,"star"]],["teachpack/htdp/image"]],
["start",">web-server/lang-servlets.html#(def._((lib._web-server/scribblings/dummy-language-servlet..ss)._start))",[0,[1,"start"]],[]],
["start",">web-server/module-servlets.html#(def._((lib._web-server/scribblings/dummy-servlet..ss)._start))",[0,[1,"start"]],[]],
["start",">gui/timer_.html#(meth._(((lib._mred/main..ss)._timer~25)._start))",[[0,[1,"start"]],[12,[" (method of ",[0,[1,"timer%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["start",">teachpack/draw.html#(def._((lib._teachpack/htdp/draw..ss)._start))",[0,[1,"start"]],["teachpack/htdp/draw"]],
["start",">gui/key-event_.html#(idx._(gentag._46._(lib._scribblings/gui/gui..scrbl)))",[7,"'start"],false],
["start-at-recent-slide",">slideshow/Viewer_Control.html#(def._((lib._slideshow/base..ss)._start-at-recent-slide))",[0,[1,"start-at-recent-slide"]],["slideshow/base","slideshow"]],
["start-colorer",">framework/Color.html#(meth._(((lib._framework/main..ss)._color~3atext~3c~25~3e)._start-colorer))",[[0,[1,"start-colorer"]],[12,[" (method of ",[0,[1,"color:text&lt;%&gt;"]],")"]]],["framework"]],
["start-connection-manager",">web-server/connection-manager_ss.html#(def._((lib._web-server/private/connection-manager..ss)._start-connection-manager))",[0,[1,"start-connection-manager"]],["web-server/private/connection-manager"]],
["start-doc",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._start-doc))",[[0,[1,"start-doc"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["start-macro",">framework/Keymap.html#(idx._(gentag._38._(lib._scribblings/framework/framework..scrbl)))","start-macro",false],
["start-page",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._start-page))",[[0,[1,"start-page"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["start-pos",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..ss)._start-pos))",[0,[6,"start-pos"]],["parser-tools/lex"]],
["start-timer",">web-server/timer_ss.html#(def._((lib._web-server/private/timer..ss)._start-timer))",[0,[1,"start-timer"]],["web-server/private/timer"]],
["start-timer-manager",">web-server/timer_ss.html#(def._((lib._web-server/private/timer..ss)._start-timer-manager))",[0,[1,"start-timer-manager"]],["web-server/private/timer"]],
["start/cartesian-plane",">teachpack/draw.html#(def._((lib._teachpack/htdp/draw..ss)._start/cartesian-plane))",[0,[1,"start/cartesian-plane"]],["teachpack/htdp/draw"]],
["starting with typed scheme",">typed-scheme/index.html#(part._.Starting_with_.Typed_.Scheme)","Starting with Typed Scheme",false],
["statement",">htdc/Statement.html",[0,"Statement"],false],
["statement",">htdc/advanced_stmt.html",[0,"Statement"],false],
["statement",">htdc/intermed_stmt.html",[0,"Statement"],false],
["statement",">htdc/intermedAcc_stmt.html",[0,"Statement"],false],
["static",">reference/runtime.html#(idx._(gentag._303._(lib._scribblings/reference/reference..scrbl)))",[7,"'static"],false],
["static-files-path",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-7..ss)._static-files-path))",[0,"static-files-path"],[]],
["static-files-path",">web-server/insta.html#(def._((lib._web-server/insta/insta..ss)._static-files-path))",[0,[1,"static-files-path"]],["web-server/insta/insta"]],
["statistics",">web-server/dispatch-stat_ss.html","Statistics",false],
["status line",">drscheme/interface-essentials.html#(tech._status._line)","<i>status line</i>",false],
["stay-in-region",">cards/index.html#(meth._(((lib._games/cards..ss)._card~3c~25~3e)._stay-in-region))",[[0,[1,"stay-in-region"]],[12,[" (method of ",[0,[1,"card&lt;%&gt;"]],")"]]],["games/cards"]],
["std-filter",">setup-plt/_plt-archives.html#(def._((lib._setup/pack..ss)._std-filter))",[0,[1,"std-filter"]],["setup/pack"]],
["stderr",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..ss)._stderr))",[0,[1,"stderr"]],["preprocessor/mzpp"]],
["stderr",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..ss)._stderr))",[0,[1,"stderr"]],["preprocessor/mztext"]],
["stdin",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..ss)._stdin))",[0,[1,"stdin"]],["preprocessor/mzpp"]],
["stdin",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..ss)._stdin))",[0,[1,"stdin"]],["preprocessor/mztext"]],
["stdout",">preprocessor/mzpp.html#(def._((lib._preprocessor/mzpp..ss)._stdout))",[0,[1,"stdout"]],["preprocessor/mzpp"]],
["stdout",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..ss)._stdout))",[0,[1,"stdout"]],["preprocessor/mztext"]],
["step button",">drscheme/debugger.html#(idx._(gentag._35._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Step</font></b> button",false],
["step button",">drscheme/buttons.html#(idx._(gentag._4._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Step</font></b> button",false],
["stepper",">redex/GUI.html#(def._((lib._redex/gui..ss)._stepper))",[0,[1,"stepper"]],["redex/gui"]],
["stepper",">drscheme/buttons.html#(idx._(gentag._5._(lib._scribblings/drscheme/drscheme..scrbl)))","Stepper",false],
["stepper-text",">macro-debugger/index.html#(def._((lib._macro-debugger/stepper-text..ss)._stepper-text))",[0,[1,"stepper-text"]],["macro-debugger/stepper-text"]],
["stepper/seed",">redex/GUI.html#(def._((lib._redex/gui..ss)._stepper/seed))",[0,[1,"stepper/seed"]],["redex/gui"]],
["still-untouched?",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._still-untouched~3f))",[[0,[1,"still-untouched?"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["stop",">gui/timer_.html#(meth._(((lib._mred/main..ss)._timer~25)._stop))",[[0,[1,"stop"]],[12,[" (method of ",[0,[1,"timer%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["stop",">teachpack/draw.html#(def._((lib._teachpack/htdp/draw..ss)._stop))",[0,[1,"stop"]],["teachpack/htdp/draw"]],
["stop",">gui/message_.html#(idx._(gentag._123._(lib._scribblings/gui/gui..scrbl)))",[7,"'stop"],false],
["stop-after",">reference/sequences.html#(def._((lib._scheme/base..ss)._stop-after))",[0,[1,"stop-after"]],["scheme/base","scheme"]],
["stop-before",">reference/sequences.html#(def._((lib._scheme/base..ss)._stop-before))",[0,[1,"stop-before"]],["scheme/base","scheme"]],
["stop-colorer",">framework/Color.html#(meth._(((lib._framework/main..ss)._color~3atext~3c~25~3e)._stop-colorer))",[[0,[1,"stop-colorer"]],[12,[" (method of ",[0,[1,"color:text&lt;%&gt;"]],")"]]],["framework"]],
["stop-handling-events",">mysterx/browsers.html#(meth._(((lib._mysterx/main..ss)._mx-browser~25)._stop-handling-events))",[[0,[1,"stop-handling-events"]],[12,[" (method of ",[0,[1,"mx-browser%"]],")"]]],["mysterx"]],
["stop-tick",">graphics/World_Operations.html#(def._((lib._graphics/graphics..ss)._stop-tick))",[0,[1,"stop-tick"]],["graphics/graphics"]],
["stop-when",">teachpack/world.html#(def._((lib._teachpack/htdp/world..ss)._stop-when))",[0,[1,"stop-when"]],["teachpack/htdp/world"]],
["store-bundle",">srfi-std/srfi-29.html#store-bundle",[0,[1,"store-bundle"]],["srfi/29"]],
["stream",">srfi-std/srfi-40.html#stream",[0,[1,"stream"]],["srfi/40"]],
["stream",">srfi-std/srfi-41/srfi-41.html#stream",[0,[6,"stream"]],["srfi/41"]],
["stream->list",">srfi-std/srfi-41/srfi-41.html#stream-to-list",[0,[1,"stream-&gt;list"]],["srfi/41"]],
["stream-append",">srfi-std/srfi-41/srfi-41.html#stream-append",[0,[1,"stream-append"]],["srfi/41"]],
["stream-car",">srfi-std/srfi-40.html#stream-car",[0,[1,"stream-car"]],["srfi/40"]],
["stream-car",">srfi-std/srfi-41/srfi-41.html#stream-car",[0,[1,"stream-car"]],["srfi/41"]],
["stream-cdr",">srfi-std/srfi-40.html#stream-cdr",[0,[1,"stream-cdr"]],["srfi/40"]],
["stream-cdr",">srfi-std/srfi-41/srfi-41.html#stream-cdr",[0,[1,"stream-cdr"]],["srfi/41"]],
["stream-concat",">srfi-std/srfi-41/srfi-41.html#stream-concat",[0,[1,"stream-concat"]],["srfi/41"]],
["stream-cons",">srfi-std/srfi-40.html#stream-cons",[0,[6,"stream-cons"]],["srfi/40"]],
["stream-cons",">srfi-std/srfi-41/srfi-41.html#stream-cons",[0,[6,"stream-cons"]],["srfi/41"]],
["stream-constant",">srfi-std/srfi-41/srfi-41.html#stream-constant",[0,[1,"stream-constant"]],["srfi/41"]],
["stream-delay",">srfi-std/srfi-40.html#stream-delay",[0,[6,"stream-delay"]],["srfi/40"]],
["stream-drop",">srfi-std/srfi-41/srfi-41.html#stream-drop",[0,[1,"stream-drop"]],["srfi/41"]],
["stream-drop-while",">srfi-std/srfi-41/srfi-41.html#stream-drop-while",[0,[1,"stream-drop-while"]],["srfi/41"]],
["stream-filter",">srfi-std/srfi-40.html#stream-filter",[0,[1,"stream-filter"]],["srfi/40"]],
["stream-filter",">srfi-std/srfi-41/srfi-41.html#stream-filter",[0,[1,"stream-filter"]],["srfi/41"]],
["stream-fold",">srfi-std/srfi-41/srfi-41.html#stream-fold",[0,[1,"stream-fold"]],["srfi/41"]],
["stream-for-each",">srfi-std/srfi-40.html#stream-for-each",[0,[1,"stream-for-each"]],["srfi/40"]],
["stream-for-each",">srfi-std/srfi-41/srfi-41.html#stream-for-each",[0,[1,"stream-for-each"]],["srfi/41"]],
["stream-from",">srfi-std/srfi-41/srfi-41.html#stream-from",[0,[1,"stream-from"]],["srfi/41"]],
["stream-iterate",">srfi-std/srfi-41/srfi-41.html#stream-iterate",[0,[1,"stream-iterate"]],["srfi/41"]],
["stream-lambda",">srfi-std/srfi-41/srfi-41.html#stream-lambda",[0,[6,"stream-lambda"]],["srfi/41"]],
["stream-length",">srfi-std/srfi-41/srfi-41.html#stream-length",[0,[1,"stream-length"]],["srfi/41"]],
["stream-let",">srfi-std/srfi-41/srfi-41.html#stream-let",[0,[6,"stream-let"]],["srfi/41"]],
["stream-map",">srfi-std/srfi-40.html#stream-map",[0,[1,"stream-map"]],["srfi/40"]],
["stream-map",">srfi-std/srfi-41/srfi-41.html#stream-map",[0,[1,"stream-map"]],["srfi/41"]],
["stream-match",">srfi-std/srfi-41/srfi-41.html#stream-match",[0,[6,"stream-match"]],["srfi/41"]],
["stream-null",">srfi-std/srfi-40.html#stream-null",[0,[1,"stream-null"]],["srfi/40"]],
["stream-null",">srfi-std/srfi-41/srfi-41.html#stream-null",[0,[1,"stream-null"]],["srfi/41"]],
["stream-null?",">srfi-std/srfi-40.html#stream-null?",[0,[1,"stream-null?"]],["srfi/40"]],
["stream-null?",">srfi-std/srfi-41/srfi-41.html#stream-null?",[0,[1,"stream-null?"]],["srfi/41"]],
["stream-of",">srfi-std/srfi-41/srfi-41.html#stream-of",[0,[6,"stream-of"]],["srfi/41"]],
["stream-pair?",">srfi-std/srfi-41/srfi-41.html#stream-pair?",[0,[1,"stream-pair?"]],["srfi/41"]],
["stream-range",">srfi-std/srfi-41/srfi-41.html#stream-range",[0,[1,"stream-range"]],["srfi/41"]],
["stream-ref",">srfi-std/srfi-41/srfi-41.html#stream-ref",[0,[1,"stream-ref"]],["srfi/41"]],
["stream-reverse",">srfi-std/srfi-41/srfi-41.html#stream-reverse",[0,[1,"stream-reverse"]],["srfi/41"]],
["stream-scan",">srfi-std/srfi-41/srfi-41.html#stream-scan",[0,[1,"stream-scan"]],["srfi/41"]],
["stream-take",">srfi-std/srfi-41/srfi-41.html#stream-take",[0,[1,"stream-take"]],["srfi/41"]],
["stream-take-while",">srfi-std/srfi-41/srfi-41.html#stream-take-while",[0,[1,"stream-take-while"]],["srfi/41"]],
["stream-unfold",">srfi-std/srfi-41/srfi-41.html#stream-unfold",[0,[1,"stream-unfold"]],["srfi/41"]],
["stream-unfoldn",">srfi-std/srfi-40.html#stream-unfoldn",[0,[1,"stream-unfoldn"]],["srfi/40"]],
["stream-zip",">srfi-std/srfi-41/srfi-41.html#stream-zip",[0,[1,"stream-zip"]],["srfi/41"]],
["stream<%>",">gui/WXME_Decoding.html#(def._((lib._wxme/main..ss)._stream~3c~25~3e))",[0,[1,"stream&lt;%&gt;"]],["wxme"]],
["stream?",">srfi-std/srfi-40.html#stream?",[0,[1,"stream?"]],["srfi/40"]],
["stream?",">srfi-std/srfi-41/srfi-41.html#stream?",[0,[1,"stream?"]],["srfi/41"]],
["stretchability",">gui/windowing-overview.html#(tech._stretchability)","<i>stretchability</i>",false],
["stretchable-editor-snip%",">embedded-gui/Helpers.html#(def._((lib._embedded-gui/main..ss)._stretchable-editor-snip~25))",[0,[1,"stretchable-editor-snip%"]],["embedded-gui"]],
["stretchable-editor-snip-mixin",">embedded-gui/Helpers.html#(def._((lib._embedded-gui/main..ss)._stretchable-editor-snip-mixin))",[0,[1,"stretchable-editor-snip-mixin"]],["embedded-gui"]],
["stretchable-height",">gui/area___.html#(meth._(((lib._mred/main..ss)._area~3c~25~3e)._stretchable-height))",[[0,[1,"stretchable-height"]],[12,[" (method of ",[0,[1,"area&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["stretchable-height",">embedded-gui/alignment___.html#(meth._(((lib._embedded-gui/main..ss)._alignment~3c~25~3e)._stretchable-height))",[[0,[1,"stretchable-height"]],[12,[" (method of ",[0,[1,"alignment&lt;%&gt;"]],")"]]],["embedded-gui"]],
["stretchable-height",">embedded-gui/stretchable-snip___.html#(meth._(((lib._embedded-gui/main..ss)._stretchable-snip~3c~25~3e)._stretchable-height))",[[0,[1,"stretchable-height"]],[12,[" (method of ",[0,[1,"stretchable-snip&lt;%&gt;"]],")"]]],["embedded-gui"]],
["stretchable-height",">mrlib/stretchable-snip___.html#(meth._(((lib._mrlib/aligned-pasteboard..ss)._stretchable-snip~3c~25~3e)._stretchable-height))",[[0,[1,"stretchable-height"]],[12,[" (method of ",[0,[1,"stretchable-snip&lt;%&gt;"]],")"]]],["mrlib/aligned-pasteboard"]],
["stretchable-height",">gui/area___.html#(idx._(gentag._24._(lib._scribblings/gui/gui..scrbl)))",[0,"stretchable-height"],false],
["stretchable-height?",">embedded-gui/snip-related-functions.html#(def._((lib._embedded-gui/main..ss)._stretchable-height~3f))",[0,[1,"stretchable-height?"]],["embedded-gui"]],
["stretchable-snip<%>",">embedded-gui/stretchable-snip___.html",[0,[1,"stretchable-snip&lt;%&gt;"]],["embedded-gui"]],
["stretchable-snip<%>",">mrlib/stretchable-snip___.html",[0,[1,"stretchable-snip&lt;%&gt;"]],["mrlib/aligned-pasteboard"]],
["stretchable-width",">gui/area___.html#(meth._(((lib._mred/main..ss)._area~3c~25~3e)._stretchable-width))",[[0,[1,"stretchable-width"]],[12,[" (method of ",[0,[1,"area&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["stretchable-width",">embedded-gui/alignment___.html#(meth._(((lib._embedded-gui/main..ss)._alignment~3c~25~3e)._stretchable-width))",[[0,[1,"stretchable-width"]],[12,[" (method of ",[0,[1,"alignment&lt;%&gt;"]],")"]]],["embedded-gui"]],
["stretchable-width",">embedded-gui/stretchable-snip___.html#(meth._(((lib._embedded-gui/main..ss)._stretchable-snip~3c~25~3e)._stretchable-width))",[[0,[1,"stretchable-width"]],[12,[" (method of ",[0,[1,"stretchable-snip&lt;%&gt;"]],")"]]],["embedded-gui"]],
["stretchable-width",">mrlib/stretchable-snip___.html#(meth._(((lib._mrlib/aligned-pasteboard..ss)._stretchable-snip~3c~25~3e)._stretchable-width))",[[0,[1,"stretchable-width"]],[12,[" (method of ",[0,[1,"stretchable-snip&lt;%&gt;"]],")"]]],["mrlib/aligned-pasteboard"]],
["stretchable-width",">gui/area___.html#(idx._(gentag._23._(lib._scribblings/gui/gui..scrbl)))",[0,"stretchable-width"],false],
["stretchable-width?",">embedded-gui/snip-related-functions.html#(def._((lib._embedded-gui/main..ss)._stretchable-width~3f))",[0,[1,"stretchable-width?"]],["embedded-gui"]],
["strike",">html/index.html#(def._((lib._html/main..ss)._strike))",[0,[1,"strike"]],["html"]],
["strike?",">html/index.html#(def._((lib._html/main..ss)._strike~3f))",[0,[1,"strike?"]],["html"]],
["string",">reference/strings.html#(def._((quote._~23~25kernel)._string))",[0,[1,"string"]],["scheme/base","scheme"]],
["string",">r5rs-std/r5rs-Z-H-9.html#%_idx_514",[0,[1,"string"]],["r5rs"]],
["string",">r6rs-std/r6rs-Z-H-14.html#node_idx_692",[0,[1,"string"]],["rnrs/base-6"]],
["string",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._string))",[0,[1,"string"]],["lang/htdp-advanced"]],
["string",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._string))",[0,[1,"string"]],["lang/htdp-beginner"]],
["string",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._string))",[0,[1,"string"]],["lang/htdp-beginner-abbr"]],
["string",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._string))",[0,[1,"string"]],["lang/htdp-intermediate"]],
["string",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._string))",[0,[1,"string"]],["lang/htdp-intermediate-lambda"]],
["string",">srfi-std/srfi-13.html#string",[0,[1,"string"]],["srfi/13"]],
["string",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._.String))",[0,[6,"String"]],["typed-scheme"]],
["string",">redex/Patterns.html#(tech._string)","<i>string</i>",false],
["string",">guide/strings.html#(tech._string)","<i>string</i>",false],
["string",">reference/strings.html#(tech._string)","<i>string</i>",false],
["string comparisons",">reference/strings.html#(part._.String_.Comparisons)","String Comparisons",false],
["string constants: gui internationalization",">string-constants/index.html","<b>String Constants</b>: GUI Internationalization",false],
["string constructors, selectors, and mutators",">reference/strings.html#(part._.String_.Constructors__.Selectors__and_.Mutators)","String Constructors, Selectors, and Mutators",false],
["string conversions",">reference/strings.html#(part._.String_.Conversions)","String Conversions",false],
["string encodings",">inside/im_encodings.html","String Encodings",false],
["string ports",">reference/stringport.html","String Ports",false],
["string types",">foreign/String_Types.html","String Types",false],
["string->bytes/latin-1",">reference/bytestrings.html#(def._((quote._~23~25kernel)._string-~3ebytes/latin-1))",[0,[1,"string-&gt;bytes/latin-1"]],["scheme/base","scheme"]],
["string->bytes/locale",">reference/bytestrings.html#(def._((quote._~23~25kernel)._string-~3ebytes/locale))",[0,[1,"string-&gt;bytes/locale"]],["scheme/base","scheme"]],
["string->bytes/utf-8",">reference/bytestrings.html#(def._((quote._~23~25kernel)._string-~3ebytes/utf-8))",[0,[1,"string-&gt;bytes/utf-8"]],["scheme/base","scheme"]],
["string->bytevector",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_632",[0,[1,"string-&gt;bytevector"]],["rnrs/io/ports-6"]],
["string->char-set",">srfi-std/srfi-14.html#string->char-set",[0,[1,"string-&gt;char-set"]],["srfi/14"]],
["string->char-set!",">srfi-std/srfi-14.html#string->char-set!",[0,[1,"string-&gt;char-set!"]],["srfi/14"]],
["string->date",">srfi-std/srfi-19.html#string->date",[0,[1,"string-&gt;date"]],["srfi/19"]],
["string->html",">net/cgi.html#(def._((lib._net/cgi..ss)._string-~3ehtml))",[0,[1,"string-&gt;html"]],["net/cgi"]],
["string->immutable-string",">reference/strings.html#(def._((quote._~23~25kernel)._string-~3eimmutable-string))",[0,[1,"string-&gt;immutable-string"]],["scheme/base","scheme"]],
["string->keyword",">reference/keywords.html#(def._((quote._~23~25kernel)._string-~3ekeyword))",[0,[1,"string-&gt;keyword"]],["scheme/base","scheme"]],
["string->lib-path",">gui/WXME_Decoding.html#(def._((lib._wxme/main..ss)._string-~3elib-path))",[0,[1,"string-&gt;lib-path"]],["wxme"]],
["string->list",">reference/strings.html#(def._((quote._~23~25kernel)._string-~3elist))",[0,[1,"string-&gt;list"]],["scheme/base","scheme"]],
["string->list",">r5rs-std/r5rs-Z-H-9.html#%_idx_546",[0,[1,"string-&gt;list"]],["r5rs"]],
["string->list",">r6rs-std/r6rs-Z-H-14.html#node_idx_712",[0,[1,"string-&gt;list"]],["rnrs/base-6"]],
["string->list",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._string-~3elist))",[0,[1,"string-&gt;list"]],["lang/htdp-advanced"]],
["string->list",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._string-~3elist))",[0,[1,"string-&gt;list"]],["lang/htdp-beginner"]],
["string->list",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._string-~3elist))",[0,[1,"string-&gt;list"]],["lang/htdp-beginner-abbr"]],
["string->list",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._string-~3elist))",[0,[1,"string-&gt;list"]],["lang/htdp-intermediate"]],
["string->list",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._string-~3elist))",[0,[1,"string-&gt;list"]],["lang/htdp-intermediate-lambda"]],
["string->list",">srfi-std/srfi-13.html#string2list",[0,[1,"string-&gt;list"]],["srfi/13"]],
["string->number",">reference/numbers.html#(def._((quote._~23~25kernel)._string-~3enumber))",[0,[1,"string-&gt;number"]],["scheme/base","scheme"]],
["string->number",">r5rs-std/r5rs-Z-H-9.html#%_idx_370",[0,[1,"string-&gt;number"]],["r5rs"]],
["string->number",">r6rs-std/r6rs-Z-H-14.html#node_idx_584",[0,[1,"string-&gt;number"]],["rnrs/base-6"]],
["string->number",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._string-~3enumber))",[0,[1,"string-&gt;number"]],["lang/htdp-advanced"]],
["string->number",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._string-~3enumber))",[0,[1,"string-&gt;number"]],["lang/htdp-beginner"]],
["string->number",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._string-~3enumber))",[0,[1,"string-&gt;number"]],["lang/htdp-beginner-abbr"]],
["string->number",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._string-~3enumber))",[0,[1,"string-&gt;number"]],["lang/htdp-intermediate"]],
["string->number",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._string-~3enumber))",[0,[1,"string-&gt;number"]],["lang/htdp-intermediate-lambda"]],
["string->path",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._string-~3epath))",[0,[1,"string-&gt;path"]],["scheme/base","scheme"]],
["string->path-element",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._string-~3epath-element))",[0,[1,"string-&gt;path-element"]],["scheme/base","scheme"]],
["string->symbol",">reference/symbols.html#(def._((quote._~23~25kernel)._string-~3esymbol))",[0,[1,"string-&gt;symbol"]],["scheme/base","scheme"]],
["string->symbol",">r5rs-std/r5rs-Z-H-9.html#%_idx_464",[0,[1,"string-&gt;symbol"]],["r5rs"]],
["string->symbol",">r6rs-std/r6rs-Z-H-14.html#node_idx_652",[0,[1,"string-&gt;symbol"]],["rnrs/base-6"]],
["string->symbol",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._string-~3esymbol))",[0,[1,"string-&gt;symbol"]],["lang/htdp-advanced"]],
["string->symbol",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._string-~3esymbol))",[0,[1,"string-&gt;symbol"]],["lang/htdp-beginner"]],
["string->symbol",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._string-~3esymbol))",[0,[1,"string-&gt;symbol"]],["lang/htdp-beginner-abbr"]],
["string->symbol",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._string-~3esymbol))",[0,[1,"string-&gt;symbol"]],["lang/htdp-intermediate"]],
["string->symbol",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._string-~3esymbol))",[0,[1,"string-&gt;symbol"]],["lang/htdp-intermediate-lambda"]],
["string->uninterned-symbol",">reference/symbols.html#(def._((quote._~23~25kernel)._string-~3euninterned-symbol))",[0,[1,"string-&gt;uninterned-symbol"]],["scheme/base","scheme"]],
["string->url",">net/url.html#(def._((lib._net/url..ss)._string-~3eurl))",[0,[1,"string-&gt;url"]],["net/url"]],
["string->utf16",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_186",[0,[1,"string-&gt;utf16"]],["rnrs/bytevectors-6"]],
["string->utf32",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_190",[0,[1,"string-&gt;utf32"]],["rnrs/bytevectors-6"]],
["string->utf8",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_184",[0,[1,"string-&gt;utf8"]],["rnrs/bytevectors-6"]],
["string-any",">srfi-std/srfi-13.html#string-any",[0,[1,"string-any"]],["srfi/13"]],
["string-append",">reference/strings.html#(def._((quote._~23~25kernel)._string-append))",[0,[1,"string-append"]],["scheme/base","scheme"]],
["string-append",">r5rs-std/r5rs-Z-H-9.html#%_idx_544",[0,[1,"string-append"]],["r5rs"]],
["string-append",">r6rs-std/r6rs-Z-H-14.html#node_idx_710",[0,[1,"string-append"]],["rnrs/base-6"]],
["string-append",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._string-append))",[0,[1,"string-append"]],["lang/htdp-advanced"]],
["string-append",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._string-append))",[0,[1,"string-append"]],["lang/htdp-beginner"]],
["string-append",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._string-append))",[0,[1,"string-append"]],["lang/htdp-beginner-abbr"]],
["string-append",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._string-append))",[0,[1,"string-append"]],["lang/htdp-intermediate"]],
["string-append",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._string-append))",[0,[1,"string-append"]],["lang/htdp-intermediate-lambda"]],
["string-append",">srfi-std/srfi-13.html#string-append",[0,[1,"string-append"]],["srfi/13"]],
["string-append*",">reference/strings.html#(def._((lib._scheme/string..ss)._string-append*))",[0,[1,"string-append*"]],["scheme/string","scheme"]],
["string-append-ec",">srfi-std/srfi-42.html#string-append-ec",[0,[6,"string-append-ec"]],["srfi/42"]],
["string-append/shared",">srfi-std/srfi-13.html#string-append/shared",[0,[1,"string-append/shared"]],["srfi/13"]],
["string-ci-hash",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1222",[0,[1,"string-ci-hash"]],["rnrs/hashtables-6"]],
["string-ci<",">srfi-std/srfi-13.html#string-ci<",[0,[1,"string-ci&lt;"]],["srfi/13"]],
["string-ci<=",">srfi-std/srfi-13.html#string-ci<=",[0,[1,"string-ci&lt;="]],["srfi/13"]],
["string-ci<=?",">reference/strings.html#(def._((quote._~23~25kernel)._string-ci~3c~3d~3f))",[0,[1,"string-ci&lt;=?"]],["scheme/base","scheme"]],
["string-ci<=?",">r5rs-std/r5rs-Z-H-9.html#%_idx_538",[0,[1,"string-ci&lt;=?"]],["r5rs"]],
["string-ci<=?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_50",[0,[1,"string-ci&lt;=?"]],["rnrs/unicode-6"]],
["string-ci<=?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._string-ci~3c~3d~3f))",[0,[1,"string-ci&lt;=?"]],["lang/htdp-advanced"]],
["string-ci<=?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._string-ci~3c~3d~3f))",[0,[1,"string-ci&lt;=?"]],["lang/htdp-beginner"]],
["string-ci<=?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._string-ci~3c~3d~3f))",[0,[1,"string-ci&lt;=?"]],["lang/htdp-beginner-abbr"]],
["string-ci<=?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._string-ci~3c~3d~3f))",[0,[1,"string-ci&lt;=?"]],["lang/htdp-intermediate"]],
["string-ci<=?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._string-ci~3c~3d~3f))",[0,[1,"string-ci&lt;=?"]],["lang/htdp-intermediate-lambda"]],
["string-ci<>",">srfi-std/srfi-13.html#string-ci<>",[0,[1,"string-ci&lt;&gt;"]],["srfi/13"]],
["string-ci<?",">reference/strings.html#(def._((quote._~23~25kernel)._string-ci~3c~3f))",[0,[1,"string-ci&lt;?"]],["scheme/base","scheme"]],
["string-ci<?",">r5rs-std/r5rs-Z-H-9.html#%_idx_534",[0,[1,"string-ci&lt;?"]],["r5rs"]],
["string-ci<?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_46",[0,[1,"string-ci&lt;?"]],["rnrs/unicode-6"]],
["string-ci<?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._string-ci~3c~3f))",[0,[1,"string-ci&lt;?"]],["lang/htdp-advanced"]],
["string-ci<?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._string-ci~3c~3f))",[0,[1,"string-ci&lt;?"]],["lang/htdp-beginner"]],
["string-ci<?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._string-ci~3c~3f))",[0,[1,"string-ci&lt;?"]],["lang/htdp-beginner-abbr"]],
["string-ci<?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._string-ci~3c~3f))",[0,[1,"string-ci&lt;?"]],["lang/htdp-intermediate"]],
["string-ci<?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._string-ci~3c~3f))",[0,[1,"string-ci&lt;?"]],["lang/htdp-intermediate-lambda"]],
["string-ci=",">srfi-std/srfi-13.html#string-ci=",[0,[1,"string-ci="]],["srfi/13"]],
["string-ci=?",">reference/strings.html#(def._((quote._~23~25kernel)._string-ci~3d~3f))",[0,[1,"string-ci=?"]],["scheme/base","scheme"]],
["string-ci=?",">r5rs-std/r5rs-Z-H-9.html#%_idx_524",[0,[1,"string-ci=?"]],["r5rs"]],
["string-ci=?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_44",[0,[1,"string-ci=?"]],["rnrs/unicode-6"]],
["string-ci=?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._string-ci~3d~3f))",[0,[1,"string-ci=?"]],["lang/htdp-advanced"]],
["string-ci=?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._string-ci~3d~3f))",[0,[1,"string-ci=?"]],["lang/htdp-beginner"]],
["string-ci=?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._string-ci~3d~3f))",[0,[1,"string-ci=?"]],["lang/htdp-beginner-abbr"]],
["string-ci=?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._string-ci~3d~3f))",[0,[1,"string-ci=?"]],["lang/htdp-intermediate"]],
["string-ci=?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._string-ci~3d~3f))",[0,[1,"string-ci=?"]],["lang/htdp-intermediate-lambda"]],
["string-ci>",">srfi-std/srfi-13.html#string-ci>",[0,[1,"string-ci&gt;"]],["srfi/13"]],
["string-ci>=",">srfi-std/srfi-13.html#string-ci>=",[0,[1,"string-ci&gt;="]],["srfi/13"]],
["string-ci>=?",">reference/strings.html#(def._((quote._~23~25kernel)._string-ci~3e~3d~3f))",[0,[1,"string-ci&gt;=?"]],["scheme/base","scheme"]],
["string-ci>=?",">r5rs-std/r5rs-Z-H-9.html#%_idx_540",[0,[1,"string-ci&gt;=?"]],["r5rs"]],
["string-ci>=?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_52",[0,[1,"string-ci&gt;=?"]],["rnrs/unicode-6"]],
["string-ci>=?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._string-ci~3e~3d~3f))",[0,[1,"string-ci&gt;=?"]],["lang/htdp-advanced"]],
["string-ci>=?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._string-ci~3e~3d~3f))",[0,[1,"string-ci&gt;=?"]],["lang/htdp-beginner"]],
["string-ci>=?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._string-ci~3e~3d~3f))",[0,[1,"string-ci&gt;=?"]],["lang/htdp-beginner-abbr"]],
["string-ci>=?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._string-ci~3e~3d~3f))",[0,[1,"string-ci&gt;=?"]],["lang/htdp-intermediate"]],
["string-ci>=?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._string-ci~3e~3d~3f))",[0,[1,"string-ci&gt;=?"]],["lang/htdp-intermediate-lambda"]],
["string-ci>?",">reference/strings.html#(def._((quote._~23~25kernel)._string-ci~3e~3f))",[0,[1,"string-ci&gt;?"]],["scheme/base","scheme"]],
["string-ci>?",">r5rs-std/r5rs-Z-H-9.html#%_idx_536",[0,[1,"string-ci&gt;?"]],["r5rs"]],
["string-ci>?",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_48",[0,[1,"string-ci&gt;?"]],["rnrs/unicode-6"]],
["string-ci>?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._string-ci~3e~3f))",[0,[1,"string-ci&gt;?"]],["lang/htdp-advanced"]],
["string-ci>?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._string-ci~3e~3f))",[0,[1,"string-ci&gt;?"]],["lang/htdp-beginner"]],
["string-ci>?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._string-ci~3e~3f))",[0,[1,"string-ci&gt;?"]],["lang/htdp-beginner-abbr"]],
["string-ci>?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._string-ci~3e~3f))",[0,[1,"string-ci&gt;?"]],["lang/htdp-intermediate"]],
["string-ci>?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._string-ci~3e~3f))",[0,[1,"string-ci&gt;?"]],["lang/htdp-intermediate-lambda"]],
["string-compare",">srfi-std/srfi-13.html#string-compare",[0,[1,"string-compare"]],["srfi/13"]],
["string-compare-ci",">srfi-std/srfi-13.html#string-compare-ci",[0,[1,"string-compare-ci"]],["srfi/13"]],
["string-concatenate",">srfi-std/srfi-13.html#string-concatenate",[0,[1,"string-concatenate"]],["srfi/13"]],
["string-concatenate-reverse",">srfi-std/srfi-13.html#string-concatenate-reverse",[0,[1,"string-concatenate-reverse"]],["srfi/13"]],
["string-concatenate-reverse/shared",">srfi-std/srfi-13.html#string-concatenate-reverse/shared",[0,[1,"string-concatenate-reverse/shared"]],["srfi/13"]],
["string-concatenate/shared",">srfi-std/srfi-13.html#string-concatenate/shared",[0,[1,"string-concatenate/shared"]],["srfi/13"]],
["string-constant",">string-constants/index.html#(form._((lib._string-constants/main..ss)._string-constant))",[0,[6,"string-constant"]],["string-constants"]],
["string-constants",">string-constants/index.html#(mod-path._string-constants)",[14,[0,[6,"string-constants"]]],"module"],
["string-constants",">string-constants/index.html#(form._((lib._string-constants/main..ss)._string-constants))",[0,[6,"string-constants"]],["string-constants"]],
["string-constants/string-constant-lang",">string-constants/index.html#(mod-path._string-constants/string-constant-lang)",[14,[0,"string-constants/string-constant-lang"]],"module"],
["string-contains",">srfi-std/srfi-13.html#string-contains",[0,[1,"string-contains"]],["srfi/13"]],
["string-contains-ci",">srfi-std/srfi-13.html#string-contains-ci",[0,[1,"string-contains-ci"]],["srfi/13"]],
["string-copy",">reference/strings.html#(def._((quote._~23~25kernel)._string-copy))",[0,[1,"string-copy"]],["scheme/base","scheme"]],
["string-copy",">r5rs-std/r5rs-Z-H-9.html#%_idx_550",[0,[1,"string-copy"]],["r5rs"]],
["string-copy",">r6rs-std/r6rs-Z-H-14.html#node_idx_718",[0,[1,"string-copy"]],["rnrs/base-6"]],
["string-copy",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._string-copy))",[0,[1,"string-copy"]],["lang/htdp-advanced"]],
["string-copy",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._string-copy))",[0,[1,"string-copy"]],["lang/htdp-beginner"]],
["string-copy",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._string-copy))",[0,[1,"string-copy"]],["lang/htdp-beginner-abbr"]],
["string-copy",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._string-copy))",[0,[1,"string-copy"]],["lang/htdp-intermediate"]],
["string-copy",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._string-copy))",[0,[1,"string-copy"]],["lang/htdp-intermediate-lambda"]],
["string-copy",">srfi-std/srfi-13.html#string-copy",[0,[1,"string-copy"]],["srfi/13"]],
["string-copy!",">reference/strings.html#(def._((quote._~23~25kernel)._string-copy!))",[0,[1,"string-copy!"]],["scheme/base","scheme"]],
["string-copy!",">srfi-std/srfi-13.html#string-copy!",[0,[1,"string-copy!"]],["srfi/13"]],
["string-count",">srfi-std/srfi-13.html#string-count",[0,[1,"string-count"]],["srfi/13"]],
["string-delete",">srfi-std/srfi-13.html#string-delete",[0,[1,"string-delete"]],["srfi/13"]],
["string-downcase",">reference/strings.html#(def._((quote._~23~25kernel)._string-downcase))",[0,[1,"string-downcase"]],["scheme/base","scheme"]],
["string-downcase",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_38",[0,[1,"string-downcase"]],["rnrs/unicode-6"]],
["string-downcase",">srfi-std/srfi-13.html#string-downcase",[0,[1,"string-downcase"]],["srfi/13"]],
["string-downcase!",">srfi-std/srfi-13.html#string-downcase!",[0,[1,"string-downcase!"]],["srfi/13"]],
["string-drop",">srfi-std/srfi-13.html#string-drop",[0,[1,"string-drop"]],["srfi/13"]],
["string-drop-right",">srfi-std/srfi-13.html#string-drop-right",[0,[1,"string-drop-right"]],["srfi/13"]],
["string-ec",">srfi-std/srfi-42.html#string-ec",[0,[6,"string-ec"]],["srfi/42"]],
["string-every",">srfi-std/srfi-13.html#string-every",[0,[1,"string-every"]],["srfi/13"]],
["string-fill!",">reference/strings.html#(def._((quote._~23~25kernel)._string-fill!))",[0,[1,"string-fill!"]],["scheme/base","scheme"]],
["string-fill!",">r5rs-std/r5rs-Z-H-9.html#%_idx_552",[0,[1,"string-fill!"]],["r5rs"]],
["string-fill!",">r6rs-lib-std/r6rs-lib-Z-H-19.html#node_idx_1282",[0,[1,"string-fill!"]],["rnrs/mutable-strings-6"]],
["string-fill!",">srfi-std/srfi-13.html#string-fill!",[0,[1,"string-fill!"]],["srfi/13"]],
["string-filter",">srfi-std/srfi-13.html#string-filter",[0,[1,"string-filter"]],["srfi/13"]],
["string-fold",">srfi-std/srfi-13.html#string-fold",[0,[1,"string-fold"]],["srfi/13"]],
["string-fold-right",">srfi-std/srfi-13.html#string-fold-right",[0,[1,"string-fold-right"]],["srfi/13"]],
["string-foldcase",">reference/strings.html#(def._((quote._~23~25kernel)._string-foldcase))",[0,[1,"string-foldcase"]],["scheme/base","scheme"]],
["string-foldcase",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_42",[0,[1,"string-foldcase"]],["rnrs/unicode-6"]],
["string-for-each",">r6rs-std/r6rs-Z-H-14.html#node_idx_716",[0,[1,"string-for-each"]],["rnrs/base-6"]],
["string-for-each",">srfi-std/srfi-13.html#string-for-each",[0,[1,"string-for-each"]],["srfi/13"]],
["string-for-each-index",">srfi-std/srfi-13.html#string-for-each-index",[0,[1,"string-for-each-index"]],["srfi/13"]],
["string-hash",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1220",[0,[1,"string-hash"]],["rnrs/hashtables-6"]],
["string-hash",">srfi-std/srfi-13.html#string-hash",[0,[1,"string-hash"]],["srfi/13"]],
["string-hash-ci",">srfi-std/srfi-13.html#string-hash-ci",[0,[1,"string-hash-ci"]],["srfi/13"]],
["string-index",">srfi-std/srfi-13.html#string-index",[0,[1,"string-index"]],["srfi/13"]],
["string-index-right",">srfi-std/srfi-13.html#string-index-right",[0,[1,"string-index-right"]],["srfi/13"]],
["string-join",">reference/strings.html#(def._((lib._scheme/string..ss)._string-join))",[0,[1,"string-join"]],["scheme/string","scheme"]],
["string-join",">srfi-std/srfi-13.html#string-join",[0,[1,"string-join"]],["srfi/13"]],
["string-kmp-partial-search",">srfi-std/srfi-13.html#string-kmp-partial-search",[0,[1,"string-kmp-partial-search"]],["srfi/13"]],
["string-len/c",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._string-len/c))",[0,[1,"string-len/c"]],["scheme/contract","scheme"]],
["string-length",">reference/strings.html#(def._((quote._~23~25kernel)._string-length))",[0,[1,"string-length"]],["scheme/base","scheme"]],
["string-length",">r5rs-std/r5rs-Z-H-9.html#%_idx_516",[0,[1,"string-length"]],["r5rs"]],
["string-length",">r6rs-std/r6rs-Z-H-14.html#node_idx_694",[0,[1,"string-length"]],["rnrs/base-6"]],
["string-length",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._string-length))",[0,[1,"string-length"]],["lang/htdp-advanced"]],
["string-length",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._string-length))",[0,[1,"string-length"]],["lang/htdp-beginner"]],
["string-length",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._string-length))",[0,[1,"string-length"]],["lang/htdp-beginner-abbr"]],
["string-length",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._string-length))",[0,[1,"string-length"]],["lang/htdp-intermediate"]],
["string-length",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._string-length))",[0,[1,"string-length"]],["lang/htdp-intermediate-lambda"]],
["string-length",">srfi-std/srfi-13.html#string-length",[0,[1,"string-length"]],["srfi/13"]],
["string-locale-ci<?",">reference/strings.html#(def._((quote._~23~25kernel)._string-locale-ci~3c~3f))",[0,[1,"string-locale-ci&lt;?"]],["scheme/base","scheme"]],
["string-locale-ci=?",">reference/strings.html#(def._((quote._~23~25kernel)._string-locale-ci~3d~3f))",[0,[1,"string-locale-ci=?"]],["scheme/base","scheme"]],
["string-locale-ci>?",">reference/strings.html#(def._((quote._~23~25kernel)._string-locale-ci~3e~3f))",[0,[1,"string-locale-ci&gt;?"]],["scheme/base","scheme"]],
["string-locale-downcase",">reference/strings.html#(def._((quote._~23~25kernel)._string-locale-downcase))",[0,[1,"string-locale-downcase"]],["scheme/base","scheme"]],
["string-locale-upcase",">reference/strings.html#(def._((quote._~23~25kernel)._string-locale-upcase))",[0,[1,"string-locale-upcase"]],["scheme/base","scheme"]],
["string-locale<?",">reference/strings.html#(def._((quote._~23~25kernel)._string-locale~3c~3f))",[0,[1,"string-locale&lt;?"]],["scheme/base","scheme"]],
["string-locale=?",">reference/strings.html#(def._((quote._~23~25kernel)._string-locale~3d~3f))",[0,[1,"string-locale=?"]],["scheme/base","scheme"]],
["string-locale>?",">reference/strings.html#(def._((quote._~23~25kernel)._string-locale~3e~3f))",[0,[1,"string-locale&gt;?"]],["scheme/base","scheme"]],
["string-lowercase!",">mzlib/mzlib_string.html#(def._((lib._mzlib/string..ss)._string-lowercase!))",[0,[1,"string-lowercase!"]],["mzlib/string"]],
["string-map",">srfi-std/srfi-13.html#string-map",[0,[1,"string-map"]],["srfi/13"]],
["string-map!",">srfi-std/srfi-13.html#string-map!",[0,[1,"string-map!"]],["srfi/13"]],
["string-normalize-nfc",">reference/strings.html#(def._((quote._~23~25kernel)._string-normalize-nfc))",[0,[1,"string-normalize-nfc"]],["scheme/base","scheme"]],
["string-normalize-nfc",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_58",[0,[1,"string-normalize-nfc"]],["rnrs/unicode-6"]],
["string-normalize-nfd",">reference/strings.html#(def._((quote._~23~25kernel)._string-normalize-nfd))",[0,[1,"string-normalize-nfd"]],["scheme/base","scheme"]],
["string-normalize-nfd",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_54",[0,[1,"string-normalize-nfd"]],["rnrs/unicode-6"]],
["string-normalize-nfkc",">reference/strings.html#(def._((quote._~23~25kernel)._string-normalize-nfkc))",[0,[1,"string-normalize-nfkc"]],["scheme/base","scheme"]],
["string-normalize-nfkc",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_60",[0,[1,"string-normalize-nfkc"]],["rnrs/unicode-6"]],
["string-normalize-nfkd",">reference/strings.html#(def._((quote._~23~25kernel)._string-normalize-nfkd))",[0,[1,"string-normalize-nfkd"]],["scheme/base","scheme"]],
["string-normalize-nfkd",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_56",[0,[1,"string-normalize-nfkd"]],["rnrs/unicode-6"]],
["string-null?",">srfi-std/srfi-13.html#string-null-p",[0,[1,"string-null?"]],["srfi/13"]],
["string-pad",">srfi-std/srfi-13.html#string-pad",[0,[1,"string-pad"]],["srfi/13"]],
["string-pad-right",">srfi-std/srfi-13.html#string-pad-right",[0,[1,"string-pad-right"]],["srfi/13"]],
["string-parse-final-start+end",">srfi-std/srfi-13.html#string-parse-final-start+end",[0,[1,"string-parse-final-start+end"]],["srfi/13"]],
["string-parse-start+end",">srfi-std/srfi-13.html#string-parse-start+end",[0,[1,"string-parse-start+end"]],["srfi/13"]],
["string-prefix-ci?",">srfi-std/srfi-13.html#string-prefix-ci-p",[0,[1,"string-prefix-ci?"]],["srfi/13"]],
["string-prefix-length",">srfi-std/srfi-13.html#string-prefix-length",[0,[1,"string-prefix-length"]],["srfi/13"]],
["string-prefix-length-ci",">srfi-std/srfi-13.html#string-prefix-length-ci",[0,[1,"string-prefix-length-ci"]],["srfi/13"]],
["string-prefix?",">srfi-std/srfi-13.html#string-prefix-p",[0,[1,"string-prefix?"]],["srfi/13"]],
["string-ref",">reference/strings.html#(def._((quote._~23~25kernel)._string-ref))",[0,[1,"string-ref"]],["scheme/base","scheme"]],
["string-ref",">r5rs-std/r5rs-Z-H-9.html#%_idx_518",[0,[1,"string-ref"]],["r5rs"]],
["string-ref",">r6rs-std/r6rs-Z-H-14.html#node_idx_696",[0,[1,"string-ref"]],["rnrs/base-6"]],
["string-ref",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._string-ref))",[0,[1,"string-ref"]],["lang/htdp-advanced"]],
["string-ref",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._string-ref))",[0,[1,"string-ref"]],["lang/htdp-beginner"]],
["string-ref",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._string-ref))",[0,[1,"string-ref"]],["lang/htdp-beginner-abbr"]],
["string-ref",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._string-ref))",[0,[1,"string-ref"]],["lang/htdp-intermediate"]],
["string-ref",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._string-ref))",[0,[1,"string-ref"]],["lang/htdp-intermediate-lambda"]],
["string-ref",">srfi-std/srfi-13.html#string-ref",[0,[1,"string-ref"]],["srfi/13"]],
["string-replace",">srfi-std/srfi-13.html#string-replace",[0,[1,"string-replace"]],["srfi/13"]],
["string-reverse",">srfi-std/srfi-13.html#string-reverse",[0,[1,"string-reverse"]],["srfi/13"]],
["string-reverse!",">srfi-std/srfi-13.html#string-reverse!",[0,[1,"string-reverse!"]],["srfi/13"]],
["string-set!",">reference/strings.html#(def._((quote._~23~25kernel)._string-set!))",[0,[1,"string-set!"]],["scheme/base","scheme"]],
["string-set!",">r5rs-std/r5rs-Z-H-9.html#%_idx_520",[0,[1,"string-set!"]],["r5rs"]],
["string-set!",">r6rs-lib-std/r6rs-lib-Z-H-19.html#node_idx_1280",[0,[1,"string-set!"]],["rnrs/mutable-strings-6"]],
["string-set!",">srfi-std/srfi-13.html#string-set!",[0,[1,"string-set!"]],["srfi/13"]],
["string-skip",">srfi-std/srfi-13.html#string-skip",[0,[1,"string-skip"]],["srfi/13"]],
["string-skip-right",">srfi-std/srfi-13.html#string-skip-right",[0,[1,"string-skip-right"]],["srfi/13"]],
["string-snip%",">gui/string-snip_.html",[0,[1,"string-snip%"]],["scheme/gui/base","scheme/gui"]],
["string-suffix-ci?",">srfi-std/srfi-13.html#string-suffix-ci-p",[0,[1,"string-suffix-ci?"]],["srfi/13"]],
["string-suffix-length",">srfi-std/srfi-13.html#string-suffix-length",[0,[1,"string-suffix-length"]],["srfi/13"]],
["string-suffix-length-ci",">srfi-std/srfi-13.html#string-suffix-length-ci",[0,[1,"string-suffix-length-ci"]],["srfi/13"]],
["string-suffix?",">srfi-std/srfi-13.html#string-suffix-p",[0,[1,"string-suffix?"]],["srfi/13"]],
["string-tabulate",">srfi-std/srfi-13.html#string-tabulate",[0,[1,"string-tabulate"]],["srfi/13"]],
["string-take",">srfi-std/srfi-13.html#string-take",[0,[1,"string-take"]],["srfi/13"]],
["string-take-right",">srfi-std/srfi-13.html#string-take-right",[0,[1,"string-take-right"]],["srfi/13"]],
["string-titlecase",">reference/strings.html#(def._((quote._~23~25kernel)._string-titlecase))",[0,[1,"string-titlecase"]],["scheme/base","scheme"]],
["string-titlecase",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_40",[0,[1,"string-titlecase"]],["rnrs/unicode-6"]],
["string-titlecase",">srfi-std/srfi-13.html#string-titlecase",[0,[1,"string-titlecase"]],["srfi/13"]],
["string-titlecase!",">srfi-std/srfi-13.html#string-titlecase!",[0,[1,"string-titlecase!"]],["srfi/13"]],
["string-tokenize",">srfi-std/srfi-13.html#string-tokenize",[0,[1,"string-tokenize"]],["srfi/13"]],
["string-trim",">srfi-std/srfi-13.html#string-trim",[0,[1,"string-trim"]],["srfi/13"]],
["string-trim-both",">srfi-std/srfi-13.html#string-trim-both",[0,[1,"string-trim-both"]],["srfi/13"]],
["string-trim-right",">srfi-std/srfi-13.html#string-trim-right",[0,[1,"string-trim-right"]],["srfi/13"]],
["string-unfold",">srfi-std/srfi-13.html#string-unfold",[0,[1,"string-unfold"]],["srfi/13"]],
["string-unfold-right",">srfi-std/srfi-13.html#string-unfold-right",[0,[1,"string-unfold-right"]],["srfi/13"]],
["string-upcase",">reference/strings.html#(def._((quote._~23~25kernel)._string-upcase))",[0,[1,"string-upcase"]],["scheme/base","scheme"]],
["string-upcase",">r6rs-lib-std/r6rs-lib-Z-H-2.html#node_idx_36",[0,[1,"string-upcase"]],["rnrs/unicode-6"]],
["string-upcase",">srfi-std/srfi-13.html#string-upcase",[0,[1,"string-upcase"]],["srfi/13"]],
["string-upcase!",">srfi-std/srfi-13.html#string-upcase!",[0,[1,"string-upcase!"]],["srfi/13"]],
["string-uppercase!",">mzlib/mzlib_string.html#(def._((lib._mzlib/string..ss)._string-uppercase!))",[0,[1,"string-uppercase!"]],["mzlib/string"]],
["string-utf-8-length",">reference/bytestrings.html#(def._((quote._~23~25kernel)._string-utf-8-length))",[0,[1,"string-utf-8-length"]],["scheme/base","scheme"]],
["string-xcopy!",">srfi-std/srfi-13.html#string-xcopy!",[0,[1,"string-xcopy!"]],["srfi/13"]],
["string<",">srfi-std/srfi-13.html#string<",[0,[1,"string&lt;"]],["srfi/13"]],
["string<=",">srfi-std/srfi-13.html#string<=",[0,[1,"string&lt;="]],["srfi/13"]],
["string<=?",">reference/strings.html#(def._((quote._~23~25kernel)._string~3c~3d~3f))",[0,[1,"string&lt;=?"]],["scheme/base","scheme"]],
["string<=?",">r5rs-std/r5rs-Z-H-9.html#%_idx_530",[0,[1,"string&lt;=?"]],["r5rs"]],
["string<=?",">r6rs-std/r6rs-Z-H-14.html#node_idx_704",[0,[1,"string&lt;=?"]],["rnrs/base-6"]],
["string<=?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._string~3c~3d~3f))",[0,[1,"string&lt;=?"]],["lang/htdp-advanced"]],
["string<=?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._string~3c~3d~3f))",[0,[1,"string&lt;=?"]],["lang/htdp-beginner"]],
["string<=?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._string~3c~3d~3f))",[0,[1,"string&lt;=?"]],["lang/htdp-beginner-abbr"]],
["string<=?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._string~3c~3d~3f))",[0,[1,"string&lt;=?"]],["lang/htdp-intermediate"]],
["string<=?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._string~3c~3d~3f))",[0,[1,"string&lt;=?"]],["lang/htdp-intermediate-lambda"]],
["string<>",">srfi-std/srfi-13.html#string<>",[0,[1,"string&lt;&gt;"]],["srfi/13"]],
["string<?",">reference/strings.html#(def._((quote._~23~25kernel)._string~3c~3f))",[0,[1,"string&lt;?"]],["scheme/base","scheme"]],
["string<?",">r5rs-std/r5rs-Z-H-9.html#%_idx_526",[0,[1,"string&lt;?"]],["r5rs"]],
["string<?",">r6rs-std/r6rs-Z-H-14.html#node_idx_700",[0,[1,"string&lt;?"]],["rnrs/base-6"]],
["string<?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._string~3c~3f))",[0,[1,"string&lt;?"]],["lang/htdp-advanced"]],
["string<?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._string~3c~3f))",[0,[1,"string&lt;?"]],["lang/htdp-beginner"]],
["string<?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._string~3c~3f))",[0,[1,"string&lt;?"]],["lang/htdp-beginner-abbr"]],
["string<?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._string~3c~3f))",[0,[1,"string&lt;?"]],["lang/htdp-intermediate"]],
["string<?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._string~3c~3f))",[0,[1,"string&lt;?"]],["lang/htdp-intermediate-lambda"]],
["string=",">srfi-std/srfi-13.html#string=",[0,[1,"string="]],["srfi/13"]],
["string=?",">reference/strings.html#(def._((quote._~23~25kernel)._string~3d~3f))",[0,[1,"string=?"]],["scheme/base","scheme"]],
["string=?",">r5rs-std/r5rs-Z-H-9.html#%_idx_522",[0,[1,"string=?"]],["r5rs"]],
["string=?",">r6rs-std/r6rs-Z-H-14.html#node_idx_698",[0,[1,"string=?"]],["rnrs/base-6"]],
["string=?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._string~3d~3f))",[0,[1,"string=?"]],["lang/htdp-advanced"]],
["string=?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._string~3d~3f))",[0,[1,"string=?"]],["lang/htdp-beginner"]],
["string=?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._string~3d~3f))",[0,[1,"string=?"]],["lang/htdp-beginner-abbr"]],
["string=?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._string~3d~3f))",[0,[1,"string=?"]],["lang/htdp-intermediate"]],
["string=?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._string~3d~3f))",[0,[1,"string=?"]],["lang/htdp-intermediate-lambda"]],
["string>",">srfi-std/srfi-13.html#string>",[0,[1,"string&gt;"]],["srfi/13"]],
["string>=",">srfi-std/srfi-13.html#string>=",[0,[1,"string&gt;="]],["srfi/13"]],
["string>=?",">reference/strings.html#(def._((quote._~23~25kernel)._string~3e~3d~3f))",[0,[1,"string&gt;=?"]],["scheme/base","scheme"]],
["string>=?",">r5rs-std/r5rs-Z-H-9.html#%_idx_532",[0,[1,"string&gt;=?"]],["r5rs"]],
["string>=?",">r6rs-std/r6rs-Z-H-14.html#node_idx_706",[0,[1,"string&gt;=?"]],["rnrs/base-6"]],
["string>=?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._string~3e~3d~3f))",[0,[1,"string&gt;=?"]],["lang/htdp-advanced"]],
["string>=?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._string~3e~3d~3f))",[0,[1,"string&gt;=?"]],["lang/htdp-beginner"]],
["string>=?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._string~3e~3d~3f))",[0,[1,"string&gt;=?"]],["lang/htdp-beginner-abbr"]],
["string>=?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._string~3e~3d~3f))",[0,[1,"string&gt;=?"]],["lang/htdp-intermediate"]],
["string>=?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._string~3e~3d~3f))",[0,[1,"string&gt;=?"]],["lang/htdp-intermediate-lambda"]],
["string>?",">reference/strings.html#(def._((quote._~23~25kernel)._string~3e~3f))",[0,[1,"string&gt;?"]],["scheme/base","scheme"]],
["string>?",">r5rs-std/r5rs-Z-H-9.html#%_idx_528",[0,[1,"string&gt;?"]],["r5rs"]],
["string>?",">r6rs-std/r6rs-Z-H-14.html#node_idx_702",[0,[1,"string&gt;?"]],["rnrs/base-6"]],
["string>?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._string~3e~3f))",[0,[1,"string&gt;?"]],["lang/htdp-advanced"]],
["string>?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._string~3e~3f))",[0,[1,"string&gt;?"]],["lang/htdp-beginner"]],
["string>?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._string~3e~3f))",[0,[1,"string&gt;?"]],["lang/htdp-beginner-abbr"]],
["string>?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._string~3e~3f))",[0,[1,"string&gt;?"]],["lang/htdp-intermediate"]],
["string>?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._string~3e~3f))",[0,[1,"string&gt;?"]],["lang/htdp-intermediate-lambda"]],
["string?",">reference/strings.html#(def._((quote._~23~25kernel)._string~3f))",[0,[1,"string?"]],["scheme/base","scheme"]],
["string?",">r5rs-std/r5rs-Z-H-9.html#%_idx_508",[0,[1,"string?"]],["r5rs"]],
["string?",">r6rs-std/r6rs-Z-H-14.html#node_idx_686",[0,[1,"string?"]],["rnrs/base-6"]],
["string?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._string~3f))",[0,[1,"string?"]],["lang/htdp-advanced"]],
["string?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._string~3f))",[0,[1,"string?"]],["lang/htdp-beginner"]],
["string?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._string~3f))",[0,[1,"string?"]],["lang/htdp-beginner-abbr"]],
["string?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._string~3f))",[0,[1,"string?"]],["lang/htdp-intermediate"]],
["string?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._string~3f))",[0,[1,"string?"]],["lang/htdp-intermediate-lambda"]],
["string?",">srfi-std/srfi-13.html#string-p",[0,[1,"string?"]],["srfi/13"]],
["stringconstants",">string-constants/index.html#(idx._(gentag._1._(lib._string-constants/string-constants..scrbl)))",[5,"STRINGCONSTANTS"],false],
["strings pattern matching",">reference/regexp.html","strings, pattern matching",false],
["strings parsing",">reference/reader.html#(idx._(gentag._150._(lib._scribblings/reference/reference..scrbl)))","strings, parsing",false],
["strings immutable",">reference/strings.html#(idx._(gentag._24._(lib._scribblings/reference/reference..scrbl)))","strings, immutable",false],
["strings conversion to c",">inside/im_values_types.html#(idx._(gentag._54._(lib._scribblings/inside/inside..scrbl)))","strings, conversion to C",false],
["strings conversion to c",">inside/im_values_types.html#(idx._(gentag._63._(lib._scribblings/inside/inside..scrbl)))","strings, conversion to C",false],
["strings concatenate",">reference/strings.html#(idx._(gentag._25._(lib._scribblings/reference/reference..scrbl)))","strings, concatenate",false],
["strings",">graphics/Draw__Clear__and_Flip_Operations.html#(part._.Strings)","Strings",false],
["strings",">honu/H-expressions.html#(part._honu~3astrings)","Strings",false],
["strings",">inside/im_values_types.html#(part._im~3astrings)","Strings",false],
["strings",">reference/strings.html","Strings",false],
["strings",">web-server/util_ss.html#(part._.Strings)","Strings",false],
["strings (unicode)",">guide/strings.html","Strings (Unicode)",false],
["strip-prefix-ups",">web-server/util_ss.html#(def._((lib._web-server/private/util..ss)._strip-prefix-ups))",[0,[1,"strip-prefix-ups"]],["web-server/private/util"]],
["strip-shell-command-start",">mzlib/mzlib_port.html#(def._((lib._mzlib/port..ss)._strip-shell-command-start))",[0,[1,"strip-shell-command-start"]],["mzlib/port"]],
["strong",">html/index.html#(def._((lib._html/main..ss)._strong))",[0,[1,"strong"]],["html"]],
["strong?",">html/index.html#(def._((lib._html/main..ss)._strong~3f))",[0,[1,"strong?"]],["html"]],
["struct",">reference/define-sig-form.html#(form._((lib._scheme/unit..ss)._struct))",[0,[6,"struct"]],["scheme/unit","scheme"]],
["struct",">mzlib/mzlib_unit.html#(form._((lib._mzlib/unit..ss)._struct))",[0,[6,"struct"]],["mzlib/unit"]],
["struct->vector",">reference/structutils.html#(def._((quote._~23~25kernel)._struct-~3evector))",[0,[1,"struct-&gt;vector"]],["scheme/base","scheme"]],
["struct-accessor-procedure?",">reference/structutils.html#(def._((quote._~23~25kernel)._struct-accessor-procedure~3f))",[0,[1,"struct-accessor-procedure?"]],["scheme/base","scheme"]],
["struct-constructor-procedure?",">reference/structutils.html#(def._((quote._~23~25kernel)._struct-constructor-procedure~3f))",[0,[1,"struct-constructor-procedure?"]],["scheme/base","scheme"]],
["struct-copy",">reference/struct-copy.html#(form._((lib._scheme/base..ss)._struct-copy))",[0,[6,"struct-copy"]],["scheme/base","scheme"]],
["struct-declaration-info?",">syntax/transformer-helpers.html#(def._((lib._syntax/struct..ss)._struct-declaration-info~3f))",[0,[1,"struct-declaration-info?"]],["syntax/struct"]],
["struct-field-index",">reference/define-struct.html#(form._((lib._scheme/base..ss)._struct-field-index))",[0,[6,"struct-field-index"]],["scheme/base","scheme"]],
["struct-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._struct-index-desc))",[0,[1,"struct-index-desc"]],["scribble/manual-struct"]],
["struct-index-desc?",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._struct-index-desc~3f))",[0,[1,"struct-index-desc?"]],["scribble/manual-struct"]],
["struct-info",">reference/inspectors.html#(def._((quote._~23~25kernel)._struct-info))",[0,[1,"struct-info"]],["scheme/base","scheme"]],
["struct-info?",">reference/structinfo.html#(def._((lib._scheme/struct-info..ss)._struct-info~3f))",[0,[1,"struct-info?"]],["scheme/struct-info"]],
["struct-mutator-procedure?",">reference/structutils.html#(def._((quote._~23~25kernel)._struct-mutator-procedure~3f))",[0,[1,"struct-mutator-procedure?"]],["scheme/base","scheme"]],
["struct-out",">reference/require.html#(form._((lib._scheme/base..ss)._struct-out))",[0,[6,"struct-out"]],["scheme/base","scheme"]],
["struct-predicate-procedure?",">reference/structutils.html#(def._((quote._~23~25kernel)._struct-predicate-procedure~3f))",[0,[1,"struct-predicate-procedure?"]],["scheme/base","scheme"]],
["struct-type-info",">reference/inspectors.html#(def._((quote._~23~25kernel)._struct-type-info))",[0,[1,"struct-type-info"]],["scheme/base","scheme"]],
["struct-type-make-constructor",">reference/inspectors.html#(def._((quote._~23~25kernel)._struct-type-make-constructor))",[0,[1,"struct-type-make-constructor"]],["scheme/base","scheme"]],
["struct-type-make-predicate",">reference/inspectors.html#(def._((quote._~23~25kernel)._struct-type-make-predicate))",[0,[1,"struct-type-make-predicate"]],["scheme/base","scheme"]],
["struct-type-property?",">reference/structprops.html#(def._((quote._~23~25kernel)._struct-type-property~3f))",[0,[1,"struct-type-property?"]],["scheme/base","scheme"]],
["struct-type?",">reference/structutils.html#(def._((quote._~23~25kernel)._struct-type~3f))",[0,[1,"struct-type?"]],["scheme/base","scheme"]],
["struct/c",">reference/Data-structure_Contracts.html#(form._((lib._scheme/private/contract..ss)._struct/c))",[0,[6,"struct/c"]],["scheme/contract","scheme"]],
["struct:a",">html/index.html#(def._((lib._html/main..ss)._struct~3aa))",[0,[1,"struct:a"]],["html"]],
["struct:abbr",">html/index.html#(def._((lib._html/main..ss)._struct~3aabbr))",[0,[1,"struct:abbr"]],["html"]],
["struct:acronym",">html/index.html#(def._((lib._html/main..ss)._struct~3aacronym))",[0,[1,"struct:acronym"]],["html"]],
["struct:address",">html/index.html#(def._((lib._html/main..ss)._struct~3aaddress))",[0,[1,"struct:address"]],["html"]],
["struct:alink",">html/index.html#(def._((lib._html/main..ss)._struct~3aalink))",[0,[1,"struct:alink"]],["html"]],
["struct:alpha-color",">teachpack/image.html#(def._((lib._htdp/image..ss)._struct~3aalpha-color))",[0,[1,"struct:alpha-color"]],["teachpack/htdp/image"]],
["struct:applet",">html/index.html#(def._((lib._html/main..ss)._struct~3aapplet))",[0,[1,"struct:applet"]],["html"]],
["struct:area",">html/index.html#(def._((lib._html/main..ss)._struct~3aarea))",[0,[1,"struct:area"]],["html"]],
["struct:arity-at-least",">reference/procedures.html#(def._((quote._~23~25kernel)._struct~3aarity-at-least))",[0,[1,"struct:arity-at-least"]],["scheme/base","scheme"]],
["struct:article-not-found",">net/nntp.html#(def._((lib._net/nntp..ss)._struct~3aarticle-not-found))",[0,[1,"struct:article-not-found"]],["net/nntp"]],
["struct:article-not-in-group",">net/nntp.html#(def._((lib._net/nntp..ss)._struct~3aarticle-not-in-group))",[0,[1,"struct:article-not-in-group"]],["net/nntp"]],
["struct:attribute",">xml/index.html#(def._((lib._xml/main..ss)._struct~3aattribute))",[0,[1,"struct:attribute"]],["xml"]],
["struct:authentication-rejected",">net/nntp.html#(def._((lib._net/nntp..ss)._struct~3aauthentication-rejected))",[0,[1,"struct:authentication-rejected"]],["net/nntp"]],
["struct:aux-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3aaux-element))",[0,[1,"struct:aux-element"]],["scribble/struct"]],
["struct:b",">html/index.html#(def._((lib._html/main..ss)._struct~3ab))",[0,[1,"struct:b"]],["html"]],
["struct:bad-newsgroup-line",">net/nntp.html#(def._((lib._net/nntp..ss)._struct~3abad-newsgroup-line))",[0,[1,"struct:bad-newsgroup-line"]],["net/nntp"]],
["struct:bad-status-line",">net/nntp.html#(def._((lib._net/nntp..ss)._struct~3abad-status-line))",[0,[1,"struct:bad-status-line"]],["net/nntp"]],
["struct:base",">html/index.html#(def._((lib._html/main..ss)._struct~3abase))",[0,[1,"struct:base"]],["html"]],
["struct:basefont",">html/index.html#(def._((lib._html/main..ss)._struct~3abasefont))",[0,[1,"struct:basefont"]],["html"]],
["struct:bdo",">html/index.html#(def._((lib._html/main..ss)._struct~3abdo))",[0,[1,"struct:bdo"]],["html"]],
["struct:big",">html/index.html#(def._((lib._html/main..ss)._struct~3abig))",[0,[1,"struct:big"]],["html"]],
["struct:bind",">redex/Patterns.html#(def._((lib._redex/reduction-semantics..ss)._struct~3abind))",[0,[1,"struct:bind"]],["redex/reduction-semantics"]],
["struct:binding",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._struct~3abinding))",[0,[1,"struct:binding"]],["web-server/private/request-structs"]],
["struct:binding:file",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._struct~3abinding~3afile))",[0,[1,"struct:binding:file"]],["web-server/private/request-structs"]],
["struct:binding:form",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._struct~3abinding~3aform))",[0,[1,"struct:binding:form"]],["web-server/private/request-structs"]],
["struct:blockquote",">html/index.html#(def._((lib._html/main..ss)._struct~3ablockquote))",[0,[1,"struct:blockquote"]],["html"]],
["struct:blockquote",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3ablockquote))",[0,[1,"struct:blockquote"]],["scribble/struct"]],
["struct:blog",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/dummy-10..ss)._struct~3ablog))",[0,[1,"struct:blog"]],[]],
["struct:blog",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-4..ss)._struct~3ablog))",[0,[1,"struct:blog"]],[]],
["struct:blog",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-9..ss)._struct~3ablog))",[0,[1,"struct:blog"]],[]],
["struct:body",">html/index.html#(def._((lib._html/main..ss)._struct~3abody))",[0,[1,"struct:body"]],["html"]],
["struct:br",">html/index.html#(def._((lib._html/main..ss)._struct~3abr))",[0,[1,"struct:br"]],["html"]],
["struct:button",">html/index.html#(def._((lib._html/main..ss)._struct~3abutton))",[0,[1,"struct:button"]],["html"]],
["struct:cannot-connect",">net/pop3.html#(def._((lib._net/pop3..ss)._struct~3acannot-connect))",[0,[1,"struct:cannot-connect"]],["net/pop3"]],
["struct:cannot-delete-message",">net/pop3.html#(def._((lib._net/pop3..ss)._struct~3acannot-delete-message))",[0,[1,"struct:cannot-delete-message"]],["net/pop3"]],
["struct:caption",">html/index.html#(def._((lib._html/main..ss)._struct~3acaption))",[0,[1,"struct:caption"]],["html"]],
["struct:cdata",">xml/index.html#(def._((lib._xml/main..ss)._struct~3acdata))",[0,[1,"struct:cdata"]],["xml"]],
["struct:center",">html/index.html#(def._((lib._html/main..ss)._struct~3acenter))",[0,[1,"struct:center"]],["html"]],
["struct:cgi-error",">net/cgi.html#(def._((lib._net/cgi..ss)._struct~3acgi-error))",[0,[1,"struct:cgi-error"]],["net/cgi"]],
["struct:child",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..ss)._struct~3achild))",[0,[1,"struct:child"]],["slideshow/pict","slideshow"]],
["struct:cite",">html/index.html#(def._((lib._html/main..ss)._struct~3acite))",[0,[1,"struct:cite"]],["html"]],
["struct:class-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._struct~3aclass-index-desc))",[0,[1,"struct:class-index-desc"]],["scribble/manual-struct"]],
["struct:code",">html/index.html#(def._((lib._html/main..ss)._struct~3acode))",[0,[1,"struct:code"]],["html"]],
["struct:col",">html/index.html#(def._((lib._html/main..ss)._struct~3acol))",[0,[1,"struct:col"]],["html"]],
["struct:colgroup",">html/index.html#(def._((lib._html/main..ss)._struct~3acolgroup))",[0,[1,"struct:colgroup"]],["html"]],
["struct:collect-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3acollect-element))",[0,[1,"struct:collect-element"]],["scribble/struct"]],
["struct:collect-info",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3acollect-info))",[0,[1,"struct:collect-info"]],["scribble/struct"]],
["struct:collected-info",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3acollected-info))",[0,[1,"struct:collected-info"]],["scribble/struct"]],
["struct:color",">teachpack/image.html#(def._((lib._htdp/image..ss)._struct~3acolor))",[0,[1,"struct:color"]],["teachpack/htdp/image"]],
["struct:comment",">xml/index.html#(def._((lib._xml/main..ss)._struct~3acomment))",[0,[1,"struct:comment"]],["xml"]],
["struct:communicator",">net/nntp.html#(def._((lib._net/nntp..ss)._struct~3acommunicator))",[0,[1,"struct:communicator"]],["net/nntp"]],
["struct:communicator",">net/pop3.html#(def._((lib._net/pop3..ss)._struct~3acommunicator))",[0,[1,"struct:communicator"]],["net/pop3"]],
["struct:configuration-table",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._struct~3aconfiguration-table))",[0,[1,"struct:configuration-table"]],["web-server/configuration/configuration-table-structs"]],
["struct:connection",">web-server/connection-manager_ss.html#(def._((lib._web-server/private/connection-manager..ss)._struct~3aconnection))",[0,[1,"struct:connection"]],["web-server/private/connection-manager"]],
["struct:cookie-error",">net/cookie.html#(def._((lib._net/cookie..ss)._struct~3acookie-error))",[0,[1,"struct:cookie-error"]],["net/cookie"]],
["struct:css-length",">mysterx/CSS.html#(def._((lib._mysterx/main..ss)._struct~3acss-length))",[0,[1,"struct:css-length"]],["mysterx"]],
["struct:css-percentage",">mysterx/CSS.html#(def._((lib._mysterx/main..ss)._struct~3acss-percentage))",[0,[1,"struct:css-percentage"]],["mysterx"]],
["struct:data-set",">mrlib/Plot.html#(def._((lib._mrlib/plot..ss)._struct~3adata-set))",[0,[1,"struct:data-set"]],["mrlib/plot"]],
["struct:date",">reference/time.html#(def._((quote._~23~25kernel)._struct~3adate))",[0,[1,"struct:date"]],["scheme/base","scheme"]],
["struct:dd",">html/index.html#(def._((lib._html/main..ss)._struct~3add))",[0,[1,"struct:dd"]],["html"]],
["struct:del",">html/index.html#(def._((lib._html/main..ss)._struct~3adel))",[0,[1,"struct:del"]],["html"]],
["struct:delayed-block",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3adelayed-block))",[0,[1,"struct:delayed-block"]],["scribble/struct"]],
["struct:delayed-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3adelayed-element))",[0,[1,"struct:delayed-element"]],["scribble/struct"]],
["struct:dfn",">html/index.html#(def._((lib._html/main..ss)._struct~3adfn))",[0,[1,"struct:dfn"]],["html"]],
["struct:dir",">html/index.html#(def._((lib._html/main..ss)._struct~3adir))",[0,[1,"struct:dir"]],["html"]],
["struct:dir",">teachpack/dir.html#(def._((lib._teachpack/htdp/dir..ss)._struct~3adir))",[0,[1,"struct:dir"]],["teachpack/htdp/dir"]],
["struct:disconnect-not-quiet",">net/pop3.html#(def._((lib._net/pop3..ss)._struct~3adisconnect-not-quiet))",[0,[1,"struct:disconnect-not-quiet"]],["net/pop3"]],
["struct:disposition",">net/mime.html#(def._((lib._net/mime..ss)._struct~3adisposition))",[0,[1,"struct:disposition"]],["net/mime"]],
["struct:div",">html/index.html#(def._((lib._html/main..ss)._struct~3adiv))",[0,[1,"struct:div"]],["html"]],
["struct:dl",">html/index.html#(def._((lib._html/main..ss)._struct~3adl))",[0,[1,"struct:dl"]],["html"]],
["struct:document",">xml/index.html#(def._((lib._xml/main..ss)._struct~3adocument))",[0,[1,"struct:document"]],["xml"]],
["struct:document-type",">xml/index.html#(def._((lib._xml/main..ss)._struct~3adocument-type))",[0,[1,"struct:document-type"]],["xml"]],
["struct:dt",">html/index.html#(def._((lib._html/main..ss)._struct~3adt))",[0,[1,"struct:dt"]],["html"]],
["struct:element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3aelement))",[0,[1,"struct:element"]],["scribble/struct"]],
["struct:element",">xml/index.html#(def._((lib._xml/main..ss)._struct~3aelement))",[0,[1,"struct:element"]],["xml"]],
["struct:em",">html/index.html#(def._((lib._html/main..ss)._struct~3aem))",[0,[1,"struct:em"]],["html"]],
["struct:empty-disposition-type",">net/mime.html#(def._((lib._net/mime..ss)._struct~3aempty-disposition-type))",[0,[1,"struct:empty-disposition-type"]],["net/mime"]],
["struct:empty-mechanism",">net/mime.html#(def._((lib._net/mime..ss)._struct~3aempty-mechanism))",[0,[1,"struct:empty-mechanism"]],["net/mime"]],
["struct:empty-subtype",">net/mime.html#(def._((lib._net/mime..ss)._struct~3aempty-subtype))",[0,[1,"struct:empty-subtype"]],["net/mime"]],
["struct:empty-type",">net/mime.html#(def._((lib._net/mime..ss)._struct~3aempty-type))",[0,[1,"struct:empty-type"]],["net/mime"]],
["struct:entity",">net/mime.html#(def._((lib._net/mime..ss)._struct~3aentity))",[0,[1,"struct:entity"]],["net/mime"]],
["struct:entity",">xml/index.html#(def._((lib._xml/main..ss)._struct~3aentity))",[0,[1,"struct:entity"]],["xml"]],
["struct:entry",">scribble/xref.html#(def._((lib._scribble/xref..ss)._struct~3aentry))",[0,[1,"struct:entry"]],["scribble/xref"]],
["struct:exn",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn))",[0,[1,"struct:exn"]],["scheme/base","scheme"]],
["struct:exn:break",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3abreak))",[0,[1,"struct:exn:break"]],["scheme/base","scheme"]],
["struct:exn:dispatcher",">web-server/dispatch_ss.html#(def._((lib._web-server/dispatchers/dispatch..ss)._struct~3aexn~3adispatcher))",[0,[1,"struct:exn:dispatcher"]],["web-server/dispatchers/dispatch"]],
["struct:exn:fail",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail))",[0,[1,"struct:exn:fail"]],["scheme/base","scheme"]],
["struct:exn:fail:contract",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3acontract))",[0,[1,"struct:exn:fail:contract"]],["scheme/base","scheme"]],
["struct:exn:fail:contract:arity",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3acontract~3aarity))",[0,[1,"struct:exn:fail:contract:arity"]],["scheme/base","scheme"]],
["struct:exn:fail:contract:continuation",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3acontract~3acontinuation))",[0,[1,"struct:exn:fail:contract:continuation"]],["scheme/base","scheme"]],
["struct:exn:fail:contract:divide-by-zero",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3acontract~3adivide-by-zero))",[0,[1,"struct:exn:fail:contract:divide-by-zero"]],["scheme/base","scheme"]],
["struct:exn:fail:contract:variable",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3acontract~3avariable))",[0,[1,"struct:exn:fail:contract:variable"]],["scheme/base","scheme"]],
["struct:exn:fail:filesystem",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3afilesystem))",[0,[1,"struct:exn:fail:filesystem"]],["scheme/base","scheme"]],
["struct:exn:fail:filesystem:exists",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3afilesystem~3aexists))",[0,[1,"struct:exn:fail:filesystem:exists"]],["scheme/base","scheme"]],
["struct:exn:fail:filesystem:version",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3afilesystem~3aversion))",[0,[1,"struct:exn:fail:filesystem:version"]],["scheme/base","scheme"]],
["struct:exn:fail:make",">make/make.html#(def._((lib._make/main..ss)._struct~3aexn~3afail~3amake))",[0,[1,"struct:exn:fail:make"]],["make"]],
["struct:exn:fail:network",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3anetwork))",[0,[1,"struct:exn:fail:network"]],["scheme/base","scheme"]],
["struct:exn:fail:object",">reference/objectutils.html#(def._((lib._scheme/private/class-internal..ss)._struct~3aexn~3afail~3aobject))",[0,[1,"struct:exn:fail:object"]],["scheme/class","scheme"]],
["struct:exn:fail:out-of-memory",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3aout-of-memory))",[0,[1,"struct:exn:fail:out-of-memory"]],["scheme/base","scheme"]],
["struct:exn:fail:read",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3aread))",[0,[1,"struct:exn:fail:read"]],["scheme/base","scheme"]],
["struct:exn:fail:read:eof",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3aread~3aeof))",[0,[1,"struct:exn:fail:read:eof"]],["scheme/base","scheme"]],
["struct:exn:fail:read:non-char",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3aread~3anon-char))",[0,[1,"struct:exn:fail:read:non-char"]],["scheme/base","scheme"]],
["struct:exn:fail:servlet-manager:no-continuation",">web-server/manager_ss.html#(def._((lib._web-server/managers/manager..ss)._struct~3aexn~3afail~3aservlet-manager~3ano-continuation))",[0,[1,"struct:exn:fail:servlet-manager:no-continuation"]],["web-server/managers/manager"]],
["struct:exn:fail:servlet-manager:no-instance",">web-server/manager_ss.html#(def._((lib._web-server/managers/manager..ss)._struct~3aexn~3afail~3aservlet-manager~3ano-instance))",[0,[1,"struct:exn:fail:servlet-manager:no-instance"]],["web-server/managers/manager"]],
["struct:exn:fail:syntax",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3asyntax))",[0,[1,"struct:exn:fail:syntax"]],["scheme/base","scheme"]],
["struct:exn:fail:unsupported",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3aunsupported))",[0,[1,"struct:exn:fail:unsupported"]],["scheme/base","scheme"]],
["struct:exn:fail:user",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3aexn~3afail~3auser))",[0,[1,"struct:exn:fail:user"]],["scheme/base","scheme"]],
["struct:exn:get-module-code",">syntax/module-helpers.html#(def._((lib._syntax/modcode..ss)._struct~3aexn~3aget-module-code))",[0,[1,"struct:exn:get-module-code"]],["syntax/modcode"]],
["struct:exn:invalid-xexpr",">xml/index.html#(def._((lib._xml/main..ss)._struct~3aexn~3ainvalid-xexpr))",[0,[1,"struct:exn:invalid-xexpr"]],["xml"]],
["struct:export",">reference/stxtrans.html#(def._((lib._scheme/provide-transform..ss)._struct~3aexport))",[0,[1,"struct:export"]],["scheme/provide-transform"]],
["struct:exported-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._struct~3aexported-index-desc))",[0,[1,"struct:exported-index-desc"]],["scribble/manual-struct"]],
["struct:external-dtd",">xml/index.html#(def._((lib._xml/main..ss)._struct~3aexternal-dtd))",[0,[1,"struct:external-dtd"]],["xml"]],
["struct:external-dtd/public",">xml/index.html#(def._((lib._xml/main..ss)._struct~3aexternal-dtd/public))",[0,[1,"struct:external-dtd/public"]],["xml"]],
["struct:external-dtd/system",">xml/index.html#(def._((lib._xml/main..ss)._struct~3aexternal-dtd/system))",[0,[1,"struct:external-dtd/system"]],["xml"]],
["struct:fieldset",">html/index.html#(def._((lib._html/main..ss)._struct~3afieldset))",[0,[1,"struct:fieldset"]],["html"]],
["struct:file",">teachpack/dir.html#(def._((lib._teachpack/htdp/dir..ss)._struct~3afile))",[0,[1,"struct:file"]],["teachpack/htdp/dir"]],
["struct:fit-result",">plot/plot.html#(def._((lib._plot/main..ss)._struct~3afit-result))",[0,[1,"struct:fit-result"]],["plot"]],
["struct:flow",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3aflow))",[0,[1,"struct:flow"]],["scribble/struct"]],
["struct:font",">html/index.html#(def._((lib._html/main..ss)._struct~3afont))",[0,[1,"struct:font"]],["html"]],
["struct:form",">html/index.html#(def._((lib._html/main..ss)._struct~3aform))",[0,[1,"struct:form"]],["html"]],
["struct:form-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._struct~3aform-index-desc))",[0,[1,"struct:form-index-desc"]],["scribble/manual-struct"]],
["struct:generated-tag",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3agenerated-tag))",[0,[1,"struct:generated-tag"]],["scribble/struct"]],
["struct:gl-selection-record",">sgl/main.html#(def._((lib._sgl/main..ss)._struct~3agl-selection-record))",[0,[1,"struct:gl-selection-record"]],["sgl"]],
["struct:h1",">html/index.html#(def._((lib._html/main..ss)._struct~3ah1))",[0,[1,"struct:h1"]],["html"]],
["struct:h2",">html/index.html#(def._((lib._html/main..ss)._struct~3ah2))",[0,[1,"struct:h2"]],["html"]],
["struct:h3",">html/index.html#(def._((lib._html/main..ss)._struct~3ah3))",[0,[1,"struct:h3"]],["html"]],
["struct:h4",">html/index.html#(def._((lib._html/main..ss)._struct~3ah4))",[0,[1,"struct:h4"]],["html"]],
["struct:h5",">html/index.html#(def._((lib._html/main..ss)._struct~3ah5))",[0,[1,"struct:h5"]],["html"]],
["struct:h6",">html/index.html#(def._((lib._html/main..ss)._struct~3ah6))",[0,[1,"struct:h6"]],["html"]],
["struct:head",">html/index.html#(def._((lib._html/main..ss)._struct~3ahead))",[0,[1,"struct:head"]],["html"]],
["struct:header",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._struct~3aheader))",[0,[1,"struct:header"]],["web-server/private/request-structs"]],
["struct:host",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._struct~3ahost))",[0,[1,"struct:host"]],["web-server/configuration/configuration-table-structs"]],
["struct:host-table",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._struct~3ahost-table))",[0,[1,"struct:host-table"]],["web-server/configuration/configuration-table-structs"]],
["struct:hover-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3ahover-element))",[0,[1,"struct:hover-element"]],["scribble/struct"]],
["struct:hr",">html/index.html#(def._((lib._html/main..ss)._struct~3ahr))",[0,[1,"struct:hr"]],["html"]],
["struct:html",">html/index.html#(def._((lib._html/main..ss)._struct~3ahtml))",[0,[1,"struct:html"]],["html"]],
["struct:html-element",">html/index.html#(def._((lib._html/main..ss)._struct~3ahtml-element))",[0,[1,"struct:html-element"]],["html"]],
["struct:html-full",">html/index.html#(def._((lib._html/main..ss)._struct~3ahtml-full))",[0,[1,"struct:html-full"]],["html"]],
["struct:i",">html/index.html#(def._((lib._html/main..ss)._struct~3ai))",[0,[1,"struct:i"]],["html"]],
["struct:iframe",">html/index.html#(def._((lib._html/main..ss)._struct~3aiframe))",[0,[1,"struct:iframe"]],["html"]],
["struct:illegal-message-number",">net/pop3.html#(def._((lib._net/pop3..ss)._struct~3aillegal-message-number))",[0,[1,"struct:illegal-message-number"]],["net/pop3"]],
["struct:image-file",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3aimage-file))",[0,[1,"struct:image-file"]],["scribble/struct"]],
["struct:img",">html/index.html#(def._((lib._html/main..ss)._struct~3aimg))",[0,[1,"struct:img"]],["html"]],
["struct:import",">reference/stxtrans.html#(def._((lib._scheme/require-transform..ss)._struct~3aimport))",[0,[1,"struct:import"]],["scheme/require-transform"]],
["struct:import-source",">reference/stxtrans.html#(def._((lib._scheme/require-transform..ss)._struct~3aimport-source))",[0,[1,"struct:import-source"]],["scheme/require-transform"]],
["struct:incomplete-%-suffix",">net/cgi.html#(def._((lib._net/cgi..ss)._struct~3aincomplete-~25-suffix))",[0,[1,"struct:incomplete-%-suffix"]],["net/cgi"]],
["struct:index-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3aindex-element))",[0,[1,"struct:index-element"]],["scribble/struct"]],
["struct:input",">html/index.html#(def._((lib._html/main..ss)._struct~3ainput))",[0,[1,"struct:input"]],["html"]],
["struct:ins",">html/index.html#(def._((lib._html/main..ss)._struct~3ains))",[0,[1,"struct:ins"]],["html"]],
["struct:interface-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._struct~3ainterface-index-desc))",[0,[1,"struct:interface-index-desc"]],["scribble/manual-struct"]],
["struct:invalid-%-suffix",">net/cgi.html#(def._((lib._net/cgi..ss)._struct~3ainvalid-~25-suffix))",[0,[1,"struct:invalid-%-suffix"]],["net/cgi"]],
["struct:isindex",">html/index.html#(def._((lib._html/main..ss)._struct~3aisindex))",[0,[1,"struct:isindex"]],["html"]],
["struct:itemization",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3aitemization))",[0,[1,"struct:itemization"]],["scribble/struct"]],
["struct:kbd",">html/index.html#(def._((lib._html/main..ss)._struct~3akbd))",[0,[1,"struct:kbd"]],["html"]],
["struct:label",">html/index.html#(def._((lib._html/main..ss)._struct~3alabel))",[0,[1,"struct:label"]],["html"]],
["struct:legend",">html/index.html#(def._((lib._html/main..ss)._struct~3alegend))",[0,[1,"struct:legend"]],["html"]],
["struct:li",">html/index.html#(def._((lib._html/main..ss)._struct~3ali))",[0,[1,"struct:li"]],["html"]],
["struct:link-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3alink-element))",[0,[1,"struct:link-element"]],["scribble/struct"]],
["struct:location",">xml/index.html#(def._((lib._xml/main..ss)._struct~3alocation))",[0,[1,"struct:location"]],["xml"]],
["struct:malformed-multipart-entity",">net/mime.html#(def._((lib._net/mime..ss)._struct~3amalformed-multipart-entity))",[0,[1,"struct:malformed-multipart-entity"]],["net/mime"]],
["struct:malformed-server-response",">net/pop3.html#(def._((lib._net/pop3..ss)._struct~3amalformed-server-response))",[0,[1,"struct:malformed-server-response"]],["net/pop3"]],
["struct:manager",">web-server/manager_ss.html#(def._((lib._web-server/managers/manager..ss)._struct~3amanager))",[0,[1,"struct:manager"]],["web-server/managers/manager"]],
["struct:map",">html/index.html#(def._((lib._html/main..ss)._struct~3amap))",[0,[1,"struct:map"]],["html"]],
["struct:menu",">html/index.html#(def._((lib._html/main..ss)._struct~3amenu))",[0,[1,"struct:menu"]],["html"]],
["struct:message",">net/mime.html#(def._((lib._net/mime..ss)._struct~3amessage))",[0,[1,"struct:message"]],["net/mime"]],
["struct:messages",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._struct~3amessages))",[0,[1,"struct:messages"]],["web-server/configuration/configuration-table-structs"]],
["struct:meta",">html/index.html#(def._((lib._html/main..ss)._struct~3ameta))",[0,[1,"struct:meta"]],["html"]],
["struct:method-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._struct~3amethod-index-desc))",[0,[1,"struct:method-index-desc"]],["scribble/manual-struct"]],
["struct:mime-error",">net/mime.html#(def._((lib._net/mime..ss)._struct~3amime-error))",[0,[1,"struct:mime-error"]],["net/mime"]],
["struct:missing-multipart-boundary-parameter",">net/mime.html#(def._((lib._net/mime..ss)._struct~3amissing-multipart-boundary-parameter))",[0,[1,"struct:missing-multipart-boundary-parameter"]],["net/mime"]],
["struct:mixin-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._struct~3amixin-index-desc))",[0,[1,"struct:mixin-index-desc"]],["scribble/manual-struct"]],
["struct:module-path-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._struct~3amodule-path-index-desc))",[0,[1,"struct:module-path-index-desc"]],["scribble/manual-struct"]],
["struct:nntp",">net/nntp.html#(def._((lib._net/nntp..ss)._struct~3anntp))",[0,[1,"struct:nntp"]],["net/nntp"]],
["struct:no-group-selected",">net/nntp.html#(def._((lib._net/nntp..ss)._struct~3ano-group-selected))",[0,[1,"struct:no-group-selected"]],["net/nntp"]],
["struct:no-mail-recipients",">net/sendmail.html#(def._((lib._net/sendmail..ss)._struct~3ano-mail-recipients))",[0,[1,"struct:no-mail-recipients"]],["net/sendmail"]],
["struct:noframes",">html/index.html#(def._((lib._html/main..ss)._struct~3anoframes))",[0,[1,"struct:noframes"]],["html"]],
["struct:non-existent-group",">net/nntp.html#(def._((lib._net/nntp..ss)._struct~3anon-existent-group))",[0,[1,"struct:non-existent-group"]],["net/nntp"]],
["struct:noscript",">html/index.html#(def._((lib._html/main..ss)._struct~3anoscript))",[0,[1,"struct:noscript"]],["html"]],
["struct:not-given-headers",">net/pop3.html#(def._((lib._net/pop3..ss)._struct~3anot-given-headers))",[0,[1,"struct:not-given-headers"]],["net/pop3"]],
["struct:not-ready-for-transaction",">net/pop3.html#(def._((lib._net/pop3..ss)._struct~3anot-ready-for-transaction))",[0,[1,"struct:not-ready-for-transaction"]],["net/pop3"]],
["struct:object",">html/index.html#(def._((lib._html/main..ss)._struct~3aobject))",[0,[1,"struct:object"]],["html"]],
["struct:ol",">html/index.html#(def._((lib._html/main..ss)._struct~3aol))",[0,[1,"struct:ol"]],["html"]],
["struct:omitable-paragraph",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3aomitable-paragraph))",[0,[1,"struct:omitable-paragraph"]],["scribble/struct"]],
["struct:optgroup",">html/index.html#(def._((lib._html/main..ss)._struct~3aoptgroup))",[0,[1,"struct:optgroup"]],["html"]],
["struct:option",">html/index.html#(def._((lib._html/main..ss)._struct~3aoption))",[0,[1,"struct:option"]],["html"]],
["struct:p",">html/index.html#(def._((lib._html/main..ss)._struct~3ap))",[0,[1,"struct:p"]],["html"]],
["struct:p-i",">xml/index.html#(def._((lib._xml/main..ss)._struct~3ap-i))",[0,[1,"struct:p-i"]],["xml"]],
["struct:paragraph",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3aparagraph))",[0,[1,"struct:paragraph"]],["scribble/struct"]],
["struct:param",">html/index.html#(def._((lib._html/main..ss)._struct~3aparam))",[0,[1,"struct:param"]],["html"]],
["struct:part",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3apart))",[0,[1,"struct:part"]],["scribble/struct"]],
["struct:part-collect-decl",">scribble/decode.html#(def._((lib._scribble/decode..ss)._struct~3apart-collect-decl))",[0,[1,"struct:part-collect-decl"]],["scribble/decode"]],
["struct:part-index-decl",">scribble/decode.html#(def._((lib._scribble/decode..ss)._struct~3apart-index-decl))",[0,[1,"struct:part-index-decl"]],["scribble/decode"]],
["struct:part-relative-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3apart-relative-element))",[0,[1,"struct:part-relative-element"]],["scribble/struct"]],
["struct:part-start",">scribble/decode.html#(def._((lib._scribble/decode..ss)._struct~3apart-start))",[0,[1,"struct:part-start"]],["scribble/decode"]],
["struct:part-tag-decl",">scribble/decode.html#(def._((lib._scribble/decode..ss)._struct~3apart-tag-decl))",[0,[1,"struct:part-tag-decl"]],["scribble/decode"]],
["struct:password-rejected",">net/pop3.html#(def._((lib._net/pop3..ss)._struct~3apassword-rejected))",[0,[1,"struct:password-rejected"]],["net/pop3"]],
["struct:path/param",">net/url.html#(def._((lib._net/url-structs..ss)._struct~3apath/param))",[0,[1,"struct:path/param"]],["net/url-structs","net/url"]],
["struct:paths",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._struct~3apaths))",[0,[1,"struct:paths"]],["web-server/configuration/configuration-table-structs"]],
["struct:pcdata",">xml/index.html#(def._((lib._xml/main..ss)._struct~3apcdata))",[0,[1,"struct:pcdata"]],["xml"]],
["struct:pict",">slideshow/Pict_Datatype.html#(def._((lib._slideshow/pict..ss)._struct~3apict))",[0,[1,"struct:pict"]],["slideshow/pict","slideshow"]],
["struct:plot-setup",">mrlib/Plot.html#(def._((lib._mrlib/plot..ss)._struct~3aplot-setup))",[0,[1,"struct:plot-setup"]],["mrlib/plot"]],
["struct:pop3",">net/pop3.html#(def._((lib._net/pop3..ss)._struct~3apop3))",[0,[1,"struct:pop3"]],["net/pop3"]],
["struct:position",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..ss)._struct~3aposition))",[0,[1,"struct:position"]],["parser-tools/lex"]],
["struct:position-token",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..ss)._struct~3aposition-token))",[0,[1,"struct:position-token"]],["parser-tools/lex"]],
["struct:posn",">htdp-lib/index.html#(def._((lib._lang/posn..ss)._struct~3aposn))",[0,[1,"struct:posn"]],["lang/posn"]],
["struct:posn",">graphics/posn.html#(def._((lib._graphics/graphics..ss)._struct~3aposn))",[0,[1,"struct:posn"]],["graphics/graphics"]],
["struct:post",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/dummy-10..ss)._struct~3apost))",[0,[1,"struct:post"]],[]],
["struct:post",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-1..ss)._struct~3apost))",[0,[1,"struct:post"]],[]],
["struct:post",">continue/index.html#(def._((lib._web-server/scribblings/tutorial/examples/iteration-5..ss)._struct~3apost))",[0,[1,"struct:post"]],[]],
["struct:pre",">html/index.html#(def._((lib._html/main..ss)._struct~3apre))",[0,[1,"struct:pre"]],["html"]],
["struct:premature-close",">net/nntp.html#(def._((lib._net/nntp..ss)._struct~3apremature-close))",[0,[1,"struct:premature-close"]],["net/nntp"]],
["struct:procedure-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._struct~3aprocedure-index-desc))",[0,[1,"struct:procedure-index-desc"]],["scribble/manual-struct"]],
["struct:prolog",">xml/index.html#(def._((lib._xml/main..ss)._struct~3aprolog))",[0,[1,"struct:prolog"]],["xml"]],
["struct:q",">html/index.html#(def._((lib._html/main..ss)._struct~3aq))",[0,[1,"struct:q"]],["html"]],
["struct:qp-error",">net/qp.html#(def._((lib._net/qp..ss)._struct~3aqp-error))",[0,[1,"struct:qp-error"]],["net/qp"]],
["struct:qp-wrong-input",">net/qp.html#(def._((lib._net/qp..ss)._struct~3aqp-wrong-input))",[0,[1,"struct:qp-wrong-input"]],["net/qp"]],
["struct:qp-wrong-line-size",">net/qp.html#(def._((lib._net/qp..ss)._struct~3aqp-wrong-line-size))",[0,[1,"struct:qp-wrong-line-size"]],["net/qp"]],
["struct:region",">cards/index.html#(def._((lib._games/cards..ss)._struct~3aregion))",[0,[1,"struct:region"]],["games/cards"]],
["struct:render-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3arender-element))",[0,[1,"struct:render-element"]],["scribble/struct"]],
["struct:request",">web-server/request-structs_ss.html#(def._((lib._web-server/private/request-structs..ss)._struct~3arequest))",[0,[1,"struct:request"]],["web-server/private/request-structs"]],
["struct:resolve-info",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3aresolve-info))",[0,[1,"struct:resolve-info"]],["scribble/struct"]],
["struct:responders",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._struct~3aresponders))",[0,[1,"struct:responders"]],["web-server/configuration/configuration-table-structs"]],
["struct:response/basic",">web-server/response-structs_ss.html#(def._((lib._web-server/private/response-structs..ss)._struct~3aresponse/basic))",[0,[1,"struct:response/basic"]],["web-server/private/response-structs"]],
["struct:response/full",">web-server/response-structs_ss.html#(def._((lib._web-server/private/response-structs..ss)._struct~3aresponse/full))",[0,[1,"struct:response/full"]],["web-server/private/response-structs"]],
["struct:response/incremental",">web-server/response-structs_ss.html#(def._((lib._web-server/private/response-structs..ss)._struct~3aresponse/incremental))",[0,[1,"struct:response/incremental"]],["web-server/private/response-structs"]],
["struct:rgb",">graphics/Color_Operations.html#(def._((lib._graphics/graphics..ss)._struct~3argb))",[0,[1,"struct:rgb"]],["graphics/graphics"]],
["struct:s",">html/index.html#(def._((lib._html/main..ss)._struct~3as))",[0,[1,"struct:s"]],["html"]],
["struct:samp",">html/index.html#(def._((lib._html/main..ss)._struct~3asamp))",[0,[1,"struct:samp"]],["html"]],
["struct:script",">html/index.html#(def._((lib._html/main..ss)._struct~3ascript))",[0,[1,"struct:script"]],["html"]],
["struct:script-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3ascript-element))",[0,[1,"struct:script-element"]],["scribble/struct"]],
["struct:select",">html/index.html#(def._((lib._html/main..ss)._struct~3aselect))",[0,[1,"struct:select"]],["html"]],
["struct:small",">html/index.html#(def._((lib._html/main..ss)._struct~3asmall))",[0,[1,"struct:small"]],["html"]],
["struct:source",">xml/index.html#(def._((lib._xml/main..ss)._struct~3asource))",[0,[1,"struct:source"]],["xml"]],
["struct:span",">html/index.html#(def._((lib._html/main..ss)._struct~3aspan))",[0,[1,"struct:span"]],["html"]],
["struct:splice",">scribble/decode.html#(def._((lib._scribble/decode..ss)._struct~3asplice))",[0,[1,"struct:splice"]],["scribble/decode"]],
["struct:srcloc",">reference/exns.html#(def._((quote._~23~25kernel)._struct~3asrcloc))",[0,[1,"struct:srcloc"]],["scheme/base","scheme"]],
["struct:strike",">html/index.html#(def._((lib._html/main..ss)._struct~3astrike))",[0,[1,"struct:strike"]],["html"]],
["struct:strong",">html/index.html#(def._((lib._html/main..ss)._struct~3astrong))",[0,[1,"struct:strong"]],["html"]],
["struct:struct-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._struct~3astruct-index-desc))",[0,[1,"struct:struct-index-desc"]],["scribble/manual-struct"]],
["struct:struct-info",">reference/structinfo.html#(def._((lib._scheme/struct-info..ss)._struct~3astruct-info))",[0,[1,"struct:struct-info"]],["scheme/struct-info"]],
["struct:style",">html/index.html#(def._((lib._html/main..ss)._struct~3astyle))",[0,[1,"struct:style"]],["html"]],
["struct:styled-paragraph",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3astyled-paragraph))",[0,[1,"struct:styled-paragraph"]],["scribble/struct"]],
["struct:sub",">html/index.html#(def._((lib._html/main..ss)._struct~3asub))",[0,[1,"struct:sub"]],["html"]],
["struct:sup",">html/index.html#(def._((lib._html/main..ss)._struct~3asup))",[0,[1,"struct:sup"]],["html"]],
["struct:table",">html/index.html#(def._((lib._html/main..ss)._struct~3atable))",[0,[1,"struct:table"]],["html"]],
["struct:table",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3atable))",[0,[1,"struct:table"]],["scribble/struct"]],
["struct:target-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3atarget-element))",[0,[1,"struct:target-element"]],["scribble/struct"]],
["struct:target-url",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3atarget-url))",[0,[1,"struct:target-url"]],["scribble/struct"]],
["struct:tbody",">html/index.html#(def._((lib._html/main..ss)._struct~3atbody))",[0,[1,"struct:tbody"]],["html"]],
["struct:td",">html/index.html#(def._((lib._html/main..ss)._struct~3atd))",[0,[1,"struct:td"]],["html"]],
["struct:textarea",">html/index.html#(def._((lib._html/main..ss)._struct~3atextarea))",[0,[1,"struct:textarea"]],["html"]],
["struct:tfoot",">html/index.html#(def._((lib._html/main..ss)._struct~3atfoot))",[0,[1,"struct:tfoot"]],["html"]],
["struct:th",">html/index.html#(def._((lib._html/main..ss)._struct~3ath))",[0,[1,"struct:th"]],["html"]],
["struct:thead",">html/index.html#(def._((lib._html/main..ss)._struct~3athead))",[0,[1,"struct:thead"]],["html"]],
["struct:thing-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._struct~3athing-index-desc))",[0,[1,"struct:thing-index-desc"]],["scribble/manual-struct"]],
["struct:timeouts",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._struct~3atimeouts))",[0,[1,"struct:timeouts"]],["web-server/configuration/configuration-table-structs"]],
["struct:timer",">web-server/timer_ss.html#(def._((lib._web-server/private/timer..ss)._struct~3atimer))",[0,[1,"struct:timer"]],["web-server/private/timer"]],
["struct:title",">html/index.html#(def._((lib._html/main..ss)._struct~3atitle))",[0,[1,"struct:title"]],["html"]],
["struct:title-decl",">scribble/decode.html#(def._((lib._scribble/decode..ss)._struct~3atitle-decl))",[0,[1,"struct:title-decl"]],["scribble/decode"]],
["struct:toc-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3atoc-element))",[0,[1,"struct:toc-element"]],["scribble/struct"]],
["struct:toc-target-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3atoc-target-element))",[0,[1,"struct:toc-target-element"]],["scribble/struct"]],
["struct:tr",">html/index.html#(def._((lib._html/main..ss)._struct~3atr))",[0,[1,"struct:tr"]],["html"]],
["struct:tt",">html/index.html#(def._((lib._html/main..ss)._struct~3att))",[0,[1,"struct:tt"]],["html"]],
["struct:u",">html/index.html#(def._((lib._html/main..ss)._struct~3au))",[0,[1,"struct:u"]],["html"]],
["struct:ul",">html/index.html#(def._((lib._html/main..ss)._struct~3aul))",[0,[1,"struct:ul"]],["html"]],
["struct:unexpected-response",">net/nntp.html#(def._((lib._net/nntp..ss)._struct~3aunexpected-response))",[0,[1,"struct:unexpected-response"]],["net/nntp"]],
["struct:unexpected-termination",">net/mime.html#(def._((lib._net/mime..ss)._struct~3aunexpected-termination))",[0,[1,"struct:unexpected-termination"]],["net/mime"]],
["struct:unnumbered-part",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3aunnumbered-part))",[0,[1,"struct:unnumbered-part"]],["scribble/struct"]],
["struct:url",">net/url.html#(def._((lib._net/url-structs..ss)._struct~3aurl))",[0,[1,"struct:url"]],["net/url-structs","net/url"]],
["struct:username-rejected",">net/pop3.html#(def._((lib._net/pop3..ss)._struct~3ausername-rejected))",[0,[1,"struct:username-rejected"]],["net/pop3"]],
["struct:var",">html/index.html#(def._((lib._html/main..ss)._struct~3avar))",[0,[1,"struct:var"]],["html"]],
["struct:versioned-part",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3aversioned-part))",[0,[1,"struct:versioned-part"]],["scribble/struct"]],
["struct:with-attributes",">scribble/struct.html#(def._((lib._scribble/struct..ss)._struct~3awith-attributes))",[0,[1,"struct:with-attributes"]],["scribble/struct"]],
["struct?",">reference/structutils.html#(def._((quote._~23~25kernel)._struct~3f))",[0,[1,"struct?"]],["scheme/base","scheme"]],
["struct?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._struct~3f))",[0,[1,"struct?"]],["lang/htdp-advanced"]],
["struct?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._struct~3f))",[0,[1,"struct?"]],["lang/htdp-beginner"]],
["struct?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._struct~3f))",[0,[1,"struct?"]],["lang/htdp-beginner-abbr"]],
["struct?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._struct~3f))",[0,[1,"struct?"]],["lang/htdp-intermediate"]],
["struct?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._struct~3f))",[0,[1,"struct?"]],["lang/htdp-intermediate-lambda"]],
["structural matching",">reference/Structural_Matching.html","Structural Matching",false],
["structure",">planet/cmdline.html#(part._structure)",[5,"structure"],false],
["structure",">reference/structures.html#(tech._structure)","<i>structure</i>",false],
["structure definitions",">typed-scheme/index.html#(part._.Structure_.Definitions)","Structure Definitions",false],
["structure inspectors",">reference/inspectors.html","Structure Inspectors",false],
["structure reference",">scribble/struct.html#(part._.Structure_.Reference)","Structure Reference",false],
["structure subtypes",">guide/define-struct.html#(part._struct-subtypes)","Structure Subtypes",false],
["structure subtypes",">reference/structures.html#(idx._(gentag._72._(lib._scribblings/reference/reference..scrbl)))","structure subtypes",false],
["structure type",">reference/structures.html#(tech._structure._type)","<i>structure type</i>",false],
["structure type descriptor",">guide/define-struct.html#(tech._structure._type._descriptor)","<i>structure type descriptor</i>",false],
["structure type descriptor",">reference/define-struct.html#(tech._structure._type._descriptor)","<i>structure type\ndescriptor</i>",false],
["structure type generativity",">guide/define-struct.html#(part._.Structure_.Type_.Generativity)","Structure Type Generativity",false],
["structure type properties",">reference/structprops.html","Structure Type Properties",false],
["structure type property",">reference/structprops.html#(tech._structure._type._property)","<i>structure type property</i>",false],
["structure type property descriptor",">reference/structprops.html#(tech._structure._type._property._descriptor)","<i>structure type property descriptor</i>",false],
["structure type transformer binding",">reference/structinfo.html","Structure Type Transformer Binding",false],
["structure utilities",">reference/structutils.html","Structure Utilities",false],
["structures equality",">reference/structures.html#(idx._(gentag._73._(lib._scribblings/reference/reference..scrbl)))","structures, equality",false],
["structures",">inside/Structures.html","Structures",false],
["structures",">reference/structures.html","Structures",false],
["structures and processing",">scribble/struct.html","Structures And Processing",false],
["structures as ports",">reference/portstructs.html","Structures as Ports",false],
["stubborn",">foreign/foreign_pointer-funcs.html#(idx._(gentag._6._(lib._scribblings/foreign/foreign..scrbl)))",[7,"'stubborn"],false],
["stuff url",">web-server/lang_stuff-url_ss.html","Stuff URL",false],
["stuff-url",">web-server/lang_stuff-url_ss.html#(def._((lib._web-server/lang/stuff-url..ss)._stuff-url))",[0,[1,"stuff-url"]],["web-server/lang/stuff-url"]],
["stuffed-url?",">web-server/lang_stuff-url_ss.html#(def._((lib._web-server/lang/stuff-url..ss)._stuffed-url~3f))",[0,[1,"stuffed-url?"]],["web-server/lang/stuff-url"]],
["stupid",">mzc/Scheme_API_for_Compilation.html#(def._((lib._compiler/option..ss)._stupid))",[0,[1,"stupid"]],["compiler/option"]],
["stx->list",">syntax/syntax-helpers.html#(def._((lib._syntax/stx..ss)._stx-~3elist))",[0,[1,"stx-&gt;list"]],["syntax/stx"]],
["stx-car",">syntax/syntax-helpers.html#(def._((lib._syntax/stx..ss)._stx-car))",[0,[1,"stx-car"]],["syntax/stx"]],
["stx-cdr",">syntax/syntax-helpers.html#(def._((lib._syntax/stx..ss)._stx-cdr))",[0,[1,"stx-cdr"]],["syntax/stx"]],
["stx-list?",">syntax/syntax-helpers.html#(def._((lib._syntax/stx..ss)._stx-list~3f))",[0,[1,"stx-list?"]],["syntax/stx"]],
["stx-null?",">syntax/syntax-helpers.html#(def._((lib._syntax/stx..ss)._stx-null~3f))",[0,[1,"stx-null?"]],["syntax/stx"]],
["stx-pair?",">syntax/syntax-helpers.html#(def._((lib._syntax/stx..ss)._stx-pair~3f))",[0,[1,"stx-pair?"]],["syntax/stx"]],
["style",">html/index.html#(def._((lib._html/main..ss)._style))",[0,[1,"style"]],["html"]],
["style",">gui/editor-overview.html#(tech._style)","<i>style</i>",false],
["style delta",">gui/editor-overview.html#(tech._style._delta)","<i>style delta</i>",false],
["style guide",">scribble/How_to_Scribble_Documentation.html#(part._reference-style)","Style Guide",false],
["style list",">gui/editor-overview.html#(tech._style._list)","<i>style list</i>",false],
["style-background-used?",">gui/editor-snip_.html#(meth._(((lib._mred/main..ss)._editor-snip~25)._style-background-used~3f))",[[0,[1,"style-background-used?"]],[12,[" (method of ",[0,[1,"editor-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["style-delta%",">gui/style-delta_.html",[0,[1,"style-delta%"]],["scheme/gui/base","scheme/gui"]],
["style-float",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._style-float))",[[0,[1,"style-float"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["style-float-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._style-float-native))",[[0,[1,"style-float-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["style-has-changed",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._style-has-changed))",[[0,[1,"style-has-changed"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["style-list%",">gui/style-list_.html",[0,[1,"style-list%"]],["scheme/gui/base","scheme/gui"]],
["style-string",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._style-string))",[[0,[1,"style-string"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["style-to-index",">gui/style-list_.html#(meth._(((lib._mred/main..ss)._style-list~25)._style-to-index))",[[0,[1,"style-to-index"]],[12,[" (method of ",[0,[1,"style-list%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["style<%>",">gui/style___.html",[0,[1,"style&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["style?",">html/index.html#(def._((lib._html/main..ss)._style~3f))",[0,[1,"style?"]],["html"]],
["styled-paragraph",">scribble/struct.html#(def._((lib._scribble/struct..ss)._styled-paragraph))",[0,[1,"styled-paragraph"]],["scribble/struct"]],
["styled-paragraph-style",">scribble/struct.html#(def._((lib._scribble/struct..ss)._styled-paragraph-style))",[0,[1,"styled-paragraph-style"]],["scribble/struct"]],
["styled-paragraph?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._styled-paragraph~3f))",[0,[1,"styled-paragraph?"]],["scribble/struct"]],
["styles",">gui/editor-overview.html#(part._editorstyles)","Styles",false],
["sub",">html/index.html#(def._((lib._html/main..ss)._sub))",[0,[1,"sub"]],["html"]],
["sub-expression evaluation and continuations",">reference/eval-model.html#(part._cont-model)","Sub-expression Evaluation and Continuations",false],
["sub-vicinity",">srfi-std/srfi-59.html#sub-vicinity",[0,[1,"sub-vicinity"]],["srfi/59"]],
["sub1",">reference/numbers.html#(def._((quote._~23~25kernel)._sub1))",[0,[1,"sub1"]],["scheme/base","scheme"]],
["sub1",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._sub1))",[0,[1,"sub1"]],["lang/htdp-advanced"]],
["sub1",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._sub1))",[0,[1,"sub1"]],["lang/htdp-beginner"]],
["sub1",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._sub1))",[0,[1,"sub1"]],["lang/htdp-beginner-abbr"]],
["sub1",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._sub1))",[0,[1,"sub1"]],["lang/htdp-intermediate"]],
["sub1",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._sub1))",[0,[1,"sub1"]],["lang/htdp-intermediate-lambda"]],
["sub?",">html/index.html#(def._((lib._html/main..ss)._sub~3f))",[0,[1,"sub?"]],["html"]],
["subarea<%>",">gui/subarea___.html",[0,[1,"subarea&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["subbytes",">reference/bytestrings.html#(def._((quote._~23~25kernel)._subbytes))",[0,[1,"subbytes"]],["scheme/base","scheme"]],
["subclass?",">reference/objectutils.html#(def._((lib._scheme/private/class-internal..ss)._subclass~3f))",[0,[1,"subclass?"]],["scheme/class","scheme"]],
["subclass?/c",">reference/Object_and_Class_Contracts.html#(def._((lib._scheme/class..ss)._subclass~3f/c))",[0,[1,"subclass?/c"]],["scheme/class","scheme"]],
["subcluster",">guide/regexp-clusters.html#(tech._subcluster)","<i>subcluster</i>",false],
["subitem",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..ss)._subitem))",[0,[1,"subitem"]],["slideshow/base","slideshow"]],
["submatch",">guide/regexp-clusters.html#(tech._submatch)","<i>submatch</i>",false],
["submit your package",">planet/Developing_Packages_for_PLaneT.html#(part._.Submit_.Your_.Package)","Submit Your Package",false],
["submit-to-port?",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3aports~3c~25~3e)._submit-to-port~3f))",[[0,[1,"submit-to-port?"]],[12,[" (method of ",[0,[1,"text:ports&lt;%&gt;"]],")"]]],["framework"]],
["subpattern",">guide/regexp-clusters.html#(tech._subpattern)","<i>subpattern</i>",false],
["subprocess",">reference/subprocess.html#(def._((quote._~23~25kernel)._subprocess))",[0,[1,"subprocess"]],["scheme/base","scheme"]],
["subprocess-kill",">reference/subprocess.html#(def._((quote._~23~25kernel)._subprocess-kill))",[0,[1,"subprocess-kill"]],["scheme/base","scheme"]],
["subprocess-pid",">reference/subprocess.html#(def._((quote._~23~25kernel)._subprocess-pid))",[0,[1,"subprocess-pid"]],["scheme/base","scheme"]],
["subprocess-status",">reference/subprocess.html#(def._((quote._~23~25kernel)._subprocess-status))",[0,[1,"subprocess-status"]],["scheme/base","scheme"]],
["subprocess-wait",">reference/subprocess.html#(def._((quote._~23~25kernel)._subprocess-wait))",[0,[1,"subprocess-wait"]],["scheme/base","scheme"]],
["subprocess?",">reference/subprocess.html#(def._((quote._~23~25kernel)._subprocess~3f))",[0,[1,"subprocess?"]],["scheme/base","scheme"]],
["subscript",">scribble/basic.html#(def._((lib._scribble/basic..ss)._subscript))",[0,[1,"subscript"]],["scribble/basic"]],
["subsection",">scribble/basic.html#(def._((lib._scribble/basic..ss)._subsection))",[0,[1,"subsection"]],["scribble/basic"]],
["subset?",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..ss)._subset~3f))",[0,[1,"subset?"]],["mzlib/integer-set"]],
["substring",">reference/strings.html#(def._((quote._~23~25kernel)._substring))",[0,[1,"substring"]],["scheme/base","scheme"]],
["substring",">r5rs-std/r5rs-Z-H-9.html#%_idx_542",[0,[1,"substring"]],["r5rs"]],
["substring",">r6rs-std/r6rs-Z-H-14.html#node_idx_708",[0,[1,"substring"]],["rnrs/base-6"]],
["substring",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._substring))",[0,[1,"substring"]],["lang/htdp-advanced"]],
["substring",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._substring))",[0,[1,"substring"]],["lang/htdp-beginner"]],
["substring",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._substring))",[0,[1,"substring"]],["lang/htdp-beginner-abbr"]],
["substring",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._substring))",[0,[1,"substring"]],["lang/htdp-intermediate"]],
["substring",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._substring))",[0,[1,"substring"]],["lang/htdp-intermediate-lambda"]],
["substring-spec-ok?",">srfi-std/srfi-13.html#substring-spec-ok-p",[0,[1,"substring-spec-ok?"]],["srfi/13"]],
["substring/shared",">srfi-std/srfi-13.html#substring/shared",[0,[1,"substring/shared"]],["srfi/13"]],
["subsubsection",">scribble/basic.html#(def._((lib._scribble/basic..ss)._subsubsection))",[0,[1,"subsubsection"]],["scribble/basic"]],
["subsubsub*section",">scribble/basic.html#(def._((lib._scribble/basic..ss)._subsubsub*section))",[0,[1,"subsubsub*section"]],["scribble/basic"]],
["subtract",">gui/region_.html#(meth._(((lib._mred/main..ss)._region~25)._subtract))",[[0,[1,"subtract"]],[12,[" (method of ",[0,[1,"region%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["subtract",">gui/key-event_.html#(idx._(gentag._83._(lib._scribblings/gui/gui..scrbl)))",[7,"'subtract"],false],
["subtract-duration",">srfi-std/srfi-19.html#subtract-duration",[0,[1,"subtract-duration"]],["srfi/19"]],
["subtract-duration!",">srfi-std/srfi-19.html#subtract-duration!",[0,[1,"subtract-duration!"]],["srfi/19"]],
["subtract-in",">reference/require.html#(form._((lib._scheme/require..ss)._subtract-in))",[0,[6,"subtract-in"]],["scheme/require"]],
["subwindow<%>",">gui/subwindow___.html",[0,[1,"subwindow&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["sum-ec",">srfi-std/srfi-42.html#sum-ec",[0,[6,"sum-ec"]],["srfi/42"]],
["sup",">html/index.html#(def._((lib._html/main..ss)._sup))",[0,[1,"sup"]],["html"]],
["sup?",">html/index.html#(def._((lib._html/main..ss)._sup~3f))",[0,[1,"sup?"]],["html"]],
["super",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._super))",[0,[6,"super"]],["scheme/class","scheme"]],
["super-init",">mzlib/mzlib_class100.html#(form._((lib._mzlib/class100..ss)._super-init))",[0,[6,"super-init"]],["mzlib/class100"]],
["super-instantiate",">reference/objcreation.html#(form._((lib._scheme/private/class-internal..ss)._super-instantiate))",[0,[6,"super-instantiate"]],["scheme/class","scheme"]],
["super-make-object",">reference/objcreation.html#(form._((lib._scheme/private/class-internal..ss)._super-make-object))",[0,[6,"super-make-object"]],["scheme/class","scheme"]],
["super-new",">reference/objcreation.html#(form._((lib._scheme/private/class-internal..ss)._super-new))",[0,[6,"super-new"]],["scheme/class","scheme"]],
["superclass",">reference/mzlib_class.html#(tech._superclas)","<i>superclass</i>",false],
["superscript",">scribble/basic.html#(def._((lib._scribble/basic..ss)._superscript))",[0,[1,"superscript"]],["scribble/basic"]],
["support for local-expand",">syntax/transformer-helpers.html#(part._context)",["Support for ",[0,[1,"local-expand"]]],false],
["surface",">plot/plot.html#(def._((lib._plot/main..ss)._surface))",[0,[1,"surface"]],["plot"]],
["surrogate",">reference/Surrogates.html#(form._((lib._scheme/surrogate..ss)._surrogate))",[0,[6,"surrogate"]],["scheme/surrogate"]],
["surrogates",">reference/Surrogates.html","Surrogates",false],
["suspending, resuming, and killing threads",">reference/threads.html#(part._threadkill)","Suspending, Resuming, and Killing Threads",false],
["svar",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..ss)._svar))",[0,[6,"svar"]],["scribble/manual"]],
["sw_hide",">reference/subprocess.html#(idx._(gentag._270._(lib._scribblings/reference/reference..scrbl)))",[7,"'SW_HIDE"],false],
["sw_hide",">reference/subprocess.html#(idx._(gentag._269._(lib._scribblings/reference/reference..scrbl)))",[7,"'sw_hide"],false],
["sw_maximize",">reference/subprocess.html#(idx._(gentag._272._(lib._scribblings/reference/reference..scrbl)))",[7,"'SW_MAXIMIZE"],false],
["sw_maximize",">reference/subprocess.html#(idx._(gentag._271._(lib._scribblings/reference/reference..scrbl)))",[7,"'sw_maximize"],false],
["sw_minimize",">reference/subprocess.html#(idx._(gentag._274._(lib._scribblings/reference/reference..scrbl)))",[7,"'SW_MINIMIZE"],false],
["sw_minimize",">reference/subprocess.html#(idx._(gentag._273._(lib._scribblings/reference/reference..scrbl)))",[7,"'sw_minimize"],false],
["sw_restore",">reference/subprocess.html#(idx._(gentag._276._(lib._scribblings/reference/reference..scrbl)))",[7,"'SW_RESTORE"],false],
["sw_restore",">reference/subprocess.html#(idx._(gentag._275._(lib._scribblings/reference/reference..scrbl)))",[7,"'sw_restore"],false],
["sw_show",">reference/subprocess.html#(idx._(gentag._278._(lib._scribblings/reference/reference..scrbl)))",[7,"'SW_SHOW"],false],
["sw_show",">reference/subprocess.html#(idx._(gentag._277._(lib._scribblings/reference/reference..scrbl)))",[7,"'sw_show"],false],
["sw_showdefault",">reference/subprocess.html#(idx._(gentag._280._(lib._scribblings/reference/reference..scrbl)))",[7,"'SW_SHOWDEFAULT"],false],
["sw_showdefault",">reference/subprocess.html#(idx._(gentag._279._(lib._scribblings/reference/reference..scrbl)))",[7,"'sw_showdefault"],false],
["sw_showmaximized",">reference/subprocess.html#(idx._(gentag._282._(lib._scribblings/reference/reference..scrbl)))",[7,"'SW_SHOWMAXIMIZED"],false],
["sw_showmaximized",">reference/subprocess.html#(idx._(gentag._281._(lib._scribblings/reference/reference..scrbl)))",[7,"'sw_showmaximized"],false],
["sw_showminimized",">reference/subprocess.html#(idx._(gentag._284._(lib._scribblings/reference/reference..scrbl)))",[7,"'SW_SHOWMINIMIZED"],false],
["sw_showminimized",">reference/subprocess.html#(idx._(gentag._283._(lib._scribblings/reference/reference..scrbl)))",[7,"'sw_showminimized"],false],
["sw_showminnoactive",">reference/subprocess.html#(idx._(gentag._286._(lib._scribblings/reference/reference..scrbl)))",[7,"'SW_SHOWMINNOACTIVE"],false],
["sw_showminnoactive",">reference/subprocess.html#(idx._(gentag._285._(lib._scribblings/reference/reference..scrbl)))",[7,"'sw_showminnoactive"],false],
["sw_showna",">reference/subprocess.html#(idx._(gentag._288._(lib._scribblings/reference/reference..scrbl)))",[7,"'SW_SHOWNA"],false],
["sw_showna",">reference/subprocess.html#(idx._(gentag._287._(lib._scribblings/reference/reference..scrbl)))",[7,"'sw_showna"],false],
["sw_shownoactivate",">reference/subprocess.html#(idx._(gentag._290._(lib._scribblings/reference/reference..scrbl)))",[7,"'SW_SHOWNOACTIVATE"],false],
["sw_shownoactivate",">reference/subprocess.html#(idx._(gentag._289._(lib._scribblings/reference/reference..scrbl)))",[7,"'sw_shownoactivate"],false],
["sw_shownormal",">reference/subprocess.html#(idx._(gentag._292._(lib._scribblings/reference/reference..scrbl)))",[7,"'SW_SHOWNORMAL"],false],
["sw_shownormal",">reference/subprocess.html#(idx._(gentag._291._(lib._scribblings/reference/reference..scrbl)))",[7,"'sw_shownormal"],false],
["swallow-newline",">preprocessor/mztext.html#(def._((lib._preprocessor/mztext..ss)._swallow-newline))",[0,[1,"swallow-newline"]],["preprocessor/mztext"]],
["swap-buffers",">gui/gl-context___.html#(meth._(((lib._mred/main..ss)._gl-context~3c~25~3e)._swap-buffers))",[[0,[1,"swap-buffers"]],[12,[" (method of ",[0,[1,"gl-context&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["swap-gl-buffers",">gui/canvas_.html#(meth._(((lib._mred/main..ss)._canvas~25)._swap-gl-buffers))",[[0,[1,"swap-gl-buffers"]],[12,[" (method of ",[0,[1,"canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["swindle",">swindle/index.html","<b>Swindle</b>",false],
["swindle",">swindle/index.html",[14,[0,"swindle"]],"module"],
["swindle language",">drscheme/legacy.html#(idx._(gentag._42._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Swindle</font></b> language",false],
["swiss",">gui/font_.html#(idx._(gentag._198._(lib._scribblings/gui/gui..scrbl)))",[7,"'swiss"],false],
["swiss",">gui/style-delta_.html#(idx._(gentag._283._(lib._scribblings/gui/gui..scrbl)))",[7,"'swiss"],false],
["switch",">frtime/index.html#(def._((lib._frtime/main..ss)._switch))",[0,[1,"switch"]],["frtime"]],
["switch-to",">gui/style___.html#(meth._(((lib._mred/main..ss)._style~3c~25~3e)._switch-to))",[[0,[1,"switch-to"]],[12,[" (method of ",[0,[1,"style&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["switchable button",">mrlib/Switchable_Button.html","Switchable Button",false],
["switchable-button%",">mrlib/Switchable_Button.html#(def._((lib._mrlib/switchable-button..ss)._switchable-button~25))",[0,[1,"switchable-button%"]],["mrlib/switchable-button"]],
["symbol",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._.Symbol))",[0,[6,"Symbol"]],["typed-scheme"]],
["symbol",">gui/font_.html#(idx._(gentag._200._(lib._scribblings/gui/gui..scrbl)))",[7,"'symbol"],false],
["symbol",">gui/style-delta_.html#(idx._(gentag._285._(lib._scribblings/gui/gui..scrbl)))",[7,"'symbol"],false],
["symbol",">redex/Patterns.html#(tech._symbol)","<i>symbol</i>",false],
["symbol",">guide/symbols.html#(tech._symbol)","<i>symbol</i>",false],
["symbol",">reference/symbols.html#(tech._symbol)","<i>symbol</i>",false],
["symbol->imap-flag",">net/imap.html#(def._((lib._net/imap..ss)._symbol-~3eimap-flag))",[0,[1,"symbol-&gt;imap-flag"]],["net/imap"]],
["symbol->string",">reference/symbols.html#(def._((quote._~23~25kernel)._symbol-~3estring))",[0,[1,"symbol-&gt;string"]],["scheme/base","scheme"]],
["symbol->string",">r5rs-std/r5rs-Z-H-9.html#%_idx_462",[0,[1,"symbol-&gt;string"]],["r5rs"]],
["symbol->string",">r6rs-std/r6rs-Z-H-14.html#node_idx_648",[0,[1,"symbol-&gt;string"]],["rnrs/base-6"]],
["symbol->string",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._symbol-~3estring))",[0,[1,"symbol-&gt;string"]],["lang/htdp-advanced"]],
["symbol->string",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._symbol-~3estring))",[0,[1,"symbol-&gt;string"]],["lang/htdp-beginner"]],
["symbol->string",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._symbol-~3estring))",[0,[1,"symbol-&gt;string"]],["lang/htdp-beginner-abbr"]],
["symbol->string",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._symbol-~3estring))",[0,[1,"symbol-&gt;string"]],["lang/htdp-intermediate"]],
["symbol->string",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._symbol-~3estring))",[0,[1,"symbol-&gt;string"]],["lang/htdp-intermediate-lambda"]],
["symbol-hash",">r6rs-lib-std/r6rs-lib-Z-H-14.html#node_idx_1224",[0,[1,"symbol-hash"]],["rnrs/hashtables-6"]],
["symbol=?",">reference/booleans.html#(def._((lib._scheme/bool..ss)._symbol~3d~3f))",[0,[1,"symbol=?"]],["scheme/bool","scheme"]],
["symbol=?",">r6rs-std/r6rs-Z-H-14.html#node_idx_650",[0,[1,"symbol=?"]],["rnrs/base-6"]],
["symbol=?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._symbol~3d~3f))",[0,[1,"symbol=?"]],["lang/htdp-advanced"]],
["symbol=?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._symbol~3d~3f))",[0,[1,"symbol=?"]],["lang/htdp-beginner"]],
["symbol=?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._symbol~3d~3f))",[0,[1,"symbol=?"]],["lang/htdp-beginner-abbr"]],
["symbol=?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._symbol~3d~3f))",[0,[1,"symbol=?"]],["lang/htdp-intermediate"]],
["symbol=?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._symbol~3d~3f))",[0,[1,"symbol=?"]],["lang/htdp-intermediate-lambda"]],
["symbol=?",">lazy/index.html#(def._((lib._lazy/main..ss)._symbol~3d~3f))",[0,[1,"symbol=?"]],["lazy"]],
["symbol?",">reference/symbols.html#(def._((quote._~23~25kernel)._symbol~3f))",[0,[1,"symbol?"]],["scheme/base","scheme"]],
["symbol?",">r5rs-std/r5rs-Z-H-9.html#%_idx_460",[0,[1,"symbol?"]],["r5rs"]],
["symbol?",">r6rs-std/r6rs-Z-H-14.html#node_idx_646",[0,[1,"symbol?"]],["rnrs/base-6"]],
["symbol?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._symbol~3f))",[0,[1,"symbol?"]],["lang/htdp-advanced"]],
["symbol?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._symbol~3f))",[0,[1,"symbol?"]],["lang/htdp-beginner"]],
["symbol?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._symbol~3f))",[0,[1,"symbol?"]],["lang/htdp-beginner-abbr"]],
["symbol?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._symbol~3f))",[0,[1,"symbol?"]],["lang/htdp-intermediate"]],
["symbol?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._symbol~3f))",[0,[1,"symbol?"]],["lang/htdp-intermediate-lambda"]],
["symbolic",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..ss)._symbolic))",[0,[6,"symbolic"]],["parser-tools/lex"]],
["symbols unique",">reference/symbols.html","symbols, unique",false],
["symbols generating",">reference/symbols.html","symbols, generating",false],
["symbols",">guide/symbols.html","Symbols",false],
["symbols",">htdp-langs/beginner-quote.html","Symbols",false],
["symbols",">reference/symbols.html","Symbols",false],
["symbols",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._symbols))",[0,[1,"symbols"]],["scheme/contract","scheme"]],
["sync",">reference/sync.html#(def._((quote._~23~25kernel)._sync))",[0,[1,"sync"]],["scheme/base","scheme"]],
["sync",">inside/threads.html#(idx._(gentag._298._(lib._scribblings/inside/inside..scrbl)))",[0,[1,"sync"]],false],
["sync/enable-break",">reference/sync.html#(def._((quote._~23~25kernel)._sync/enable-break))",[0,[1,"sync/enable-break"]],["scheme/base","scheme"]],
["sync/timeout",">reference/sync.html#(def._((quote._~23~25kernel)._sync/timeout))",[0,[1,"sync/timeout"]],["scheme/base","scheme"]],
["sync/timeout/enable-break",">reference/sync.html#(def._((quote._~23~25kernel)._sync/timeout/enable-break))",[0,[1,"sync/timeout/enable-break"]],["scheme/base","scheme"]],
["synchronizable event",">reference/sync.html#(tech._synchronizable._event)","<i>synchronizable event</i>",false],
["synchronization",">reference/all-sync.html","Synchronization",false],
["synchronization result",">reference/sync.html#(tech._synchronization._result)","<i>synchronization result</i>",false],
["synchronizing thread state",">reference/threads.html#(part._threadsync)","Synchronizing Thread State",false],
["syntactic form",">reference/syntax-model.html#(tech._syntactic._form)","<i>syntactic form</i>",false],
["syntactic forms",">reference/syntax.html","Syntactic Forms",false],
["syntactic shorthand",">web-server/Syntactic_Shorthand.html","Syntactic Shorthand",false],
["syntax",">reference/stx-patterns.html#(form._((lib._scheme/private/stxcase-scheme..ss)._syntax))",[0,[6,"syntax"]],["scheme/base","scheme"]],
["syntax",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1134",[0,[6,"syntax"]],["rnrs/syntax-case-6"]],
["syntax browser",">macro-debugger/index.html#(part._.Syntax_browser)","Syntax browser",false],
["syntax certificate",">reference/stxcerts.html#(tech._syntax._certificate)","<i>syntax certificate</i>",false],
["syntax certificates",">guide/stx-certs.html","Syntax Certificates",false],
["syntax certificates",">reference/stxcerts.html","Syntax Certificates",false],
["syntax color: utilities",">syntax-color/index.html","<b>Syntax Color</b>: Utilities",false],
["syntax mark",">reference/syntax-model.html#(tech._syntax._mark)","<i>syntax mark</i>",false],
["syntax model",">reference/syntax-model.html","Syntax Model",false],
["syntax object",">reference/syntax-model.html#(tech._syntax._object)","<i>syntax object</i>",false],
["syntax object bindings",">reference/stxcmp.html","Syntax Object Bindings",false],
["syntax object content",">reference/stxops.html","Syntax Object Content",false],
["syntax object helpers",">syntax/syntax-helpers.html","Syntax Object Helpers",false],
["syntax object properties",">reference/stxprops.html","Syntax Object Properties",false],
["syntax objects",">guide/stx-obj.html","Syntax Objects",false],
["syntax objects",">reference/syntax-model.html#(part._stxobj-model)","Syntax Objects",false],
["syntax objects",">guide/stx-obj.html#(tech._syntax._object)","<i>syntax objects</i>",false],
["syntax pair",">reference/stxops.html#(tech._syntax._pair)","<i>syntax pair</i>",false],
["syntax parameter",">reference/stxparam.html#(tech._syntax._parameter)","<i>syntax\nparameter</i>",false],
["syntax parameter inspection",">reference/stxparam.html#(part._.Syntax_.Parameter_.Inspection)","Syntax Parameter Inspection",false],
["syntax parameters",">reference/stxparam.html","Syntax Parameters",false],
["syntax properties",">scribble/reader.html#(part._.Syntax_.Properties)","Syntax Properties",false],
["syntax property",">reference/stxprops.html#(tech._syntax._property)","<i>syntax property</i>",false],
["syntax quoting: quote-syntax",">reference/Syntax_Quoting__quote-syntax.html",["Syntax Quoting: ",[0,[6,"quote-syntax"]]],false],
["syntax transformer",">reference/syntax-model.html#(tech._syntax._transformer)","<i>syntax transformer</i>",false],
["syntax transformers",">reference/stxtrans.html","Syntax Transformers",false],
["syntax->datum",">reference/stxops.html#(def._((quote._~23~25kernel)._syntax-~3edatum))",[0,[1,"syntax-&gt;datum"]],["scheme/base","scheme"]],
["syntax->datum",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1144",[0,[1,"syntax-&gt;datum"]],["rnrs/syntax-case-6"]],
["syntax->list",">reference/stxops.html#(def._((quote._~23~25kernel)._syntax-~3elist))",[0,[1,"syntax-&gt;list"]],["scheme/base","scheme"]],
["syntax->string",">syntax/syntax-helpers.html#(def._((lib._syntax/to-string..ss)._syntax-~3estring))",[0,[1,"syntax-&gt;string"]],["syntax/to-string"]],
["syntax-case",">reference/stx-patterns.html#(form._((lib._scheme/private/stxcase-scheme..ss)._syntax-case))",[0,[6,"syntax-case"]],["scheme/base","scheme"]],
["syntax-case",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1124",[0,[6,"syntax-case"]],["rnrs/syntax-case-6"]],
["syntax-case*",">reference/stx-patterns.html#(form._((lib._scheme/private/stxcase-scheme..ss)._syntax-case*))",[0,[6,"syntax-case*"]],["scheme/base","scheme"]],
["syntax-color/default-lexer",">syntax-color/index.html#(mod-path._syntax-color/default-lexer)",[14,[0,"syntax-color/default-lexer"]],"module"],
["syntax-color/paren-tree",">syntax-color/index.html#(mod-path._syntax-color/paren-tree)",[14,[0,"syntax-color/paren-tree"]],"module"],
["syntax-color/scheme-lexer",">syntax-color/index.html#(mod-path._syntax-color/scheme-lexer)",[14,[0,"syntax-color/scheme-lexer"]],"module"],
["syntax-color/token-tree",">syntax-color/index.html#(mod-path._syntax-color/token-tree)",[14,[0,"syntax-color/token-tree"]],"module"],
["syntax-column",">reference/stxops.html#(def._((quote._~23~25kernel)._syntax-column))",[0,[1,"syntax-column"]],["scheme/base","scheme"]],
["syntax-e",">reference/stxops.html#(def._((quote._~23~25kernel)._syntax-e))",[0,[1,"syntax-e"]],["scheme/base","scheme"]],
["syntax-id-rules",">reference/stx-patterns.html#(form._((lib._scheme/private/stxcase-scheme..ss)._syntax-id-rules))",[0,[6,"syntax-id-rules"]],["scheme/base","scheme"]],
["syntax-line",">reference/stxops.html#(def._((quote._~23~25kernel)._syntax-line))",[0,[1,"syntax-line"]],["scheme/base","scheme"]],
["syntax-local-bind-syntaxes",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-bind-syntaxes))",[0,[1,"syntax-local-bind-syntaxes"]],["scheme/base","scheme"]],
["syntax-local-certifier",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-certifier))",[0,[1,"syntax-local-certifier"]],["scheme/base","scheme"]],
["syntax-local-context",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-context))",[0,[1,"syntax-local-context"]],["scheme/base","scheme"]],
["syntax-local-expand-expression",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-expand-expression))",[0,[1,"syntax-local-expand-expression"]],["scheme/base","scheme"]],
["syntax-local-get-shadower",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-get-shadower))",[0,[1,"syntax-local-get-shadower"]],["scheme/base","scheme"]],
["syntax-local-infer-name",">syntax/transformer-helpers.html#(def._((lib._syntax/name..ss)._syntax-local-infer-name))",[0,[1,"syntax-local-infer-name"]],["syntax/name"]],
["syntax-local-introduce",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-introduce))",[0,[1,"syntax-local-introduce"]],["scheme/base","scheme"]],
["syntax-local-lift-context",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-lift-context))",[0,[1,"syntax-local-lift-context"]],["scheme/base","scheme"]],
["syntax-local-lift-expression",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-lift-expression))",[0,[1,"syntax-local-lift-expression"]],["scheme/base","scheme"]],
["syntax-local-lift-module-end-declaration",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-lift-module-end-declaration))",[0,[1,"syntax-local-lift-module-end-declaration"]],["scheme/base","scheme"]],
["syntax-local-make-definition-context",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-make-definition-context))",[0,[1,"syntax-local-make-definition-context"]],["scheme/base","scheme"]],
["syntax-local-module-defined-identifiers",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-module-defined-identifiers))",[0,[1,"syntax-local-module-defined-identifiers"]],["scheme/base","scheme"]],
["syntax-local-module-exports",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-module-exports))",[0,[1,"syntax-local-module-exports"]],["scheme/base","scheme"]],
["syntax-local-module-required-identifiers",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-module-required-identifiers))",[0,[1,"syntax-local-module-required-identifiers"]],["scheme/base","scheme"]],
["syntax-local-name",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-name))",[0,[1,"syntax-local-name"]],["scheme/base","scheme"]],
["syntax-local-phase-level",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-phase-level))",[0,[1,"syntax-local-phase-level"]],["scheme/base","scheme"]],
["syntax-local-provide-certifier",">reference/stxtrans.html#(def._((lib._scheme/provide-transform..ss)._syntax-local-provide-certifier))",[0,[1,"syntax-local-provide-certifier"]],["scheme/provide-transform"]],
["syntax-local-require-certifier",">reference/stxtrans.html#(def._((lib._scheme/require-transform..ss)._syntax-local-require-certifier))",[0,[1,"syntax-local-require-certifier"]],["scheme/require-transform"]],
["syntax-local-transforming-module-provides?",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-transforming-module-provides~3f))",[0,[1,"syntax-local-transforming-module-provides?"]],["scheme/base","scheme"]],
["syntax-local-value",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-local-value))",[0,[1,"syntax-local-value"]],["scheme/base","scheme"]],
["syntax-object->datum",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..ss)._syntax-object-~3edatum))",[0,[1,"syntax-object-&gt;datum"]],["mzscheme"]],
["syntax-original?",">reference/stxops.html#(def._((quote._~23~25kernel)._syntax-original~3f))",[0,[1,"syntax-original?"]],["scheme/base","scheme"]],
["syntax-parameter-value",">reference/stxparam.html#(def._((lib._scheme/stxparam-exptime..ss)._syntax-parameter-value))",[0,[1,"syntax-parameter-value"]],["scheme/stxparam-exptime","scheme/stxparam"]],
["syntax-parameterize",">reference/stxparam.html#(form._((lib._scheme/stxparam..ss)._syntax-parameterize))",[0,[6,"syntax-parameterize"]],["scheme/stxparam"]],
["syntax-position",">reference/stxops.html#(def._((quote._~23~25kernel)._syntax-position))",[0,[1,"syntax-position"]],["scheme/base","scheme"]],
["syntax-property",">reference/stxprops.html#(def._((quote._~23~25kernel)._syntax-property))",[0,[1,"syntax-property"]],["scheme/base","scheme"]],
["syntax-property-symbol-keys",">reference/stxprops.html#(def._((quote._~23~25kernel)._syntax-property-symbol-keys))",[0,[1,"syntax-property-symbol-keys"]],["scheme/base","scheme"]],
["syntax-recertify",">reference/stxcerts.html#(def._((quote._~23~25kernel)._syntax-recertify))",[0,[1,"syntax-recertify"]],["scheme/base","scheme"]],
["syntax-rules",">reference/stx-patterns.html#(form._((lib._scheme/private/stxcase-scheme..ss)._syntax-rules))",[0,[6,"syntax-rules"]],["scheme/base","scheme"]],
["syntax-rules",">r6rs-std/r6rs-Z-H-14.html#node_idx_786",[0,[6,"syntax-rules"]],["r6rs/private/base-for-syntax"]],
["syntax-source",">reference/stxops.html#(def._((quote._~23~25kernel)._syntax-source))",[0,[1,"syntax-source"]],["scheme/base","scheme"]],
["syntax-source-module",">reference/stxops.html#(def._((quote._~23~25kernel)._syntax-source-module))",[0,[1,"syntax-source-module"]],["scheme/base","scheme"]],
["syntax-span",">reference/stxops.html#(def._((quote._~23~25kernel)._syntax-span))",[0,[1,"syntax-span"]],["scheme/base","scheme"]],
["syntax-track-origin",">reference/stxprops.html#(def._((quote._~23~25kernel)._syntax-track-origin))",[0,[1,"syntax-track-origin"]],["scheme/base","scheme"]],
["syntax-transforming?",">reference/stxtrans.html#(def._((quote._~23~25kernel)._syntax-transforming~3f))",[0,[1,"syntax-transforming?"]],["scheme/base","scheme"]],
["syntax-violation",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1160",[0,[1,"syntax-violation"]],["rnrs/syntax-case-6"]],
["syntax-violation-form",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_484",[0,[1,"syntax-violation-form"]],["rnrs/conditions-6"]],
["syntax-violation-subform",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_486",[0,[1,"syntax-violation-subform"]],["rnrs/conditions-6"]],
["syntax-violation?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_482",[0,[1,"syntax-violation?"]],["rnrs/conditions-6"]],
["syntax/boundmap",">syntax/syntax-helpers.html#(mod-path._syntax/boundmap)",[14,[0,"syntax/boundmap"]],"module"],
["syntax/c",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._syntax/c))",[0,[1,"syntax/c"]],["scheme/contract","scheme"]],
["syntax/context",">syntax/transformer-helpers.html#(mod-path._syntax/context)",[14,[0,"syntax/context"]],"module"],
["syntax/define",">syntax/transformer-helpers.html#(mod-path._syntax/define)",[14,[0,"syntax/define"]],"module"],
["syntax/docprovide",">syntax/docprovide.html",[14,[0,"syntax/docprovide"]],"module"],
["syntax/free-vars",">syntax/syntax-helpers.html#(mod-path._syntax/free-vars)",[14,[0,"syntax/free-vars"]],"module"],
["syntax/kerncase",">syntax/syntax-helpers.html#(mod-path._syntax/kerncase)",[14,[0,"syntax/kerncase"]],"module"],
["syntax/loc",">reference/stx-patterns.html#(form._((lib._scheme/private/stxcase-scheme..ss)._syntax/loc))",[0,[6,"syntax/loc"]],["scheme/base","scheme"]],
["syntax/modcode",">syntax/module-helpers.html#(mod-path._syntax/modcode)",[14,[0,"syntax/modcode"]],"module"],
["syntax/modcollapse",">syntax/module-helpers.html#(mod-path._syntax/modcollapse)",[14,[0,"syntax/modcollapse"]],"module"],
["syntax/moddep",">syntax/module-helpers.html#(mod-path._syntax/moddep)",[14,[0,"syntax/moddep"]],"module"],
["syntax/modread",">syntax/module-helpers.html#(mod-path._syntax/modread)",[14,[0,"syntax/modread"]],"module"],
["syntax/modresolve",">syntax/module-helpers.html#(mod-path._syntax/modresolve)",[14,[0,"syntax/modresolve"]],"module"],
["syntax/module-reader",">syntax/reader-helpers.html#(mod-path._syntax/module-reader)",[14,[0,"syntax/module-reader"]],"module"],
["syntax/name",">syntax/transformer-helpers.html#(mod-path._syntax/name)",[14,[0,"syntax/name"]],"module"],
["syntax/path-spec",">syntax/transformer-helpers.html#(mod-path._syntax/path-spec)",[14,[0,"syntax/path-spec"]],"module"],
["syntax/readerr",">syntax/reader-helpers.html#(mod-path._syntax/readerr)",[14,[0,"syntax/readerr"]],"module"],
["syntax/struct",">syntax/transformer-helpers.html#(mod-path._syntax/struct)",[14,[0,"syntax/struct"]],"module"],
["syntax/stx",">syntax/syntax-helpers.html#(mod-path._syntax/stx)",[14,[0,"syntax/stx"]],"module"],
["syntax/to-string",">syntax/syntax-helpers.html#(mod-path._syntax/to-string)",[14,[0,"syntax/to-string"]],"module"],
["syntax/toplevel",">syntax/toplevel.html",[14,[0,"syntax/toplevel"]],"module"],
["syntax/trusted-xforms",">syntax/trusted-xforms.html",[14,[0,"syntax/trusted-xforms"]],"module"],
["syntax/zodiac",">syntax/syntax-helpers.html#(mod-path._syntax/zodiac)",[14,[0,"syntax/zodiac"]],"module"],
["syntax/zodiac-sig",">syntax/syntax-helpers.html#(mod-path._syntax/zodiac-sig)",[14,[0,"syntax/zodiac-sig"]],"module"],
["syntax/zodiac-unit",">syntax/syntax-helpers.html#(mod-path._syntax/zodiac-unit)",[14,[0,"syntax/zodiac-unit"]],"module"],
["syntax: meta-programming helpers",">syntax/index.html","<b>Syntax</b>: Meta-Programming Helpers",false],
["syntax:read-xml",">xml/index.html#(def._((lib._xml/main..ss)._syntax~3aread-xml))",[0,[1,"syntax:read-xml"]],["xml"]],
["syntax:read-xml/element",">xml/index.html#(def._((lib._xml/main..ss)._syntax~3aread-xml/element))",[0,[1,"syntax:read-xml/element"]],["xml"]],
["syntax?",">reference/stxops.html#(def._((quote._~23~25kernel)._syntax~3f))",[0,[1,"syntax?"]],["scheme/base","scheme"]],
["sys-dir",">reference/Filesystem.html#(idx._(gentag._257._(lib._scribblings/reference/reference..scrbl)))",[7,"'sys-dir"],false],
["system",">reference/subprocess.html#(def._((lib._scheme/system..ss)._system))",[0,[1,"system"]],["scheme/system"]],
["system",">gui/font_.html#(idx._(gentag._201._(lib._scribblings/gui/gui..scrbl)))",[7,"'system"],false],
["system",">gui/style-delta_.html#(idx._(gentag._286._(lib._scribblings/gui/gui..scrbl)))",[7,"'system"],false],
["system menus",">gui/Windowing_Functions.html#(part._.System_.Menus)","System Menus",false],
["system*",">reference/subprocess.html#(def._((lib._scheme/system..ss)._system*))",[0,[1,"system*"]],["scheme/system"]],
["system*/exit-code",">reference/subprocess.html#(def._((lib._scheme/system..ss)._system*/exit-code))",[0,[1,"system*/exit-code"]],["scheme/system"]],
["system-big-endian?",">reference/numbers.html#(def._((quote._~23~25kernel)._system-big-endian~3f))",[0,[1,"system-big-endian?"]],["scheme/base","scheme"]],
["system-idle-evt",">reference/sync.html#(def._((quote._~23~25kernel)._system-idle-evt))",[0,[1,"system-idle-evt"]],["scheme/base","scheme"]],
["system-language+country",">reference/runtime.html#(def._((quote._~23~25kernel)._system-language+country))",[0,[1,"system-language+country"]],["scheme/base","scheme"]],
["system-library-subpath",">reference/runtime.html#(def._((quote._~23~25kernel)._system-library-subpath))",[0,[1,"system-library-subpath"]],["scheme/base","scheme"]],
["system-path-convention-type",">reference/Manipulating_Paths.html#(def._((quote._~23~25kernel)._system-path-convention-type))",[0,[1,"system-path-convention-type"]],["scheme/base","scheme"]],
["system-position-ok-before-cancel?",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._system-position-ok-before-cancel~3f))",[0,[1,"system-position-ok-before-cancel?"]],["scheme/gui/base","scheme/gui"]],
["system-type",">reference/runtime.html#(def._((quote._~23~25kernel)._system-type))",[0,[1,"system-type"]],["scheme/base","scheme"]],
["system/exit-code",">reference/subprocess.html#(def._((lib._scheme/system..ss)._system/exit-code))",[0,[1,"system/exit-code"]],["scheme/system"]],
["t",">scribble/Miscellaneous.html#(def._((lib._scribble/manual..ss)._t))",[0,[1,"t"]],["scribble/manual"]],
["t",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..ss)._t))",[0,[1,"t"]],["slideshow/base","slideshow"]],
["tab-panel",">gui/tab-panel_.html#(idx._(gentag._130._(lib._scribblings/gui/gui..scrbl)))",[7,"'tab-panel"],false],
["tab-panel%",">gui/tab-panel_.html",[0,[1,"tab-panel%"]],["scheme/gui/base","scheme/gui"]],
["tab-snip%",">gui/tab-snip_.html",[0,[1,"tab-snip%"]],["scheme/gui/base","scheme/gui"]],
["tabbable-text-mixin",">embedded-gui/Helpers.html#(def._((lib._embedded-gui/main..ss)._tabbable-text-mixin))",[0,[1,"tabbable-text-mixin"]],["embedded-gui"]],
["tabbable-text<%>",">embedded-gui/Helpers.html#(def._((lib._embedded-gui/main..ss)._tabbable-text~3c~25~3e))",[0,[1,"tabbable-text&lt;%&gt;"]],["embedded-gui"]],
["tabbed editing",">drscheme/Tabbed_Editing.html","Tabbed Editing",false],
["tabify",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._tabify))",[[0,[1,"tabify"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["tabify-all",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._tabify-all))",[[0,[1,"tabify-all"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["tabify-on-return?",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._tabify-on-return~3f))",[[0,[1,"tabify-on-return?"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["tabify-selection",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._tabify-selection))",[[0,[1,"tabify-selection"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["table",">html/index.html#(def._((lib._html/main..ss)._table))",[0,[1,"table"]],["html"]],
["table",">scribble/struct.html#(def._((lib._scribble/struct..ss)._table))",[0,[1,"table"]],["scribble/struct"]],
["table",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..ss)._table))",[0,[1,"table"]],["slideshow/pict","slideshow"]],
["table",">scribble/struct.html#(tech._table)","<i>table</i>",false],
["table methods",">cards/index.html#(part._.Table_.Methods)","Table Methods",false],
["table-flowss",">scribble/struct.html#(def._((lib._scribble/struct..ss)._table-flowss))",[0,[1,"table-flowss"]],["scribble/struct"]],
["table-height",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._table-height))",[[0,[1,"table-height"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["table-of-contents",">scribble/basic.html#(def._((lib._scribble/basic..ss)._table-of-contents))",[0,[1,"table-of-contents"]],["scribble/basic"]],
["table-style",">scribble/struct.html#(def._((lib._scribble/struct..ss)._table-style))",[0,[1,"table-style"]],["scribble/struct"]],
["table-width",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._table-width))",[[0,[1,"table-width"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["table<%>",">cards/index.html#(def._((lib._games/cards..ss)._table~3c~25~3e))",[0,[1,"table&lt;%&gt;"]],["games/cards"]],
["table?",">html/index.html#(def._((lib._html/main..ss)._table~3f))",[0,[1,"table?"]],["html"]],
["table?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._table~3f))",[0,[1,"table?"]],["scribble/struct"]],
["tableau",">games/spider.html#(tech._tableau)","<i>Tableau</i>",false],
["tables of contents",">scribble/basic.html#(part._.Tables_of_.Contents)","Tables of Contents",false],
["tag",">reference/creatingunits.html#(form._((lib._mzlib/unit..ss)._tag))",[0,[6,"tag"]],["scheme/unit","scheme"]],
["tag",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._tag))",[[0,[1,"tag"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["tag",">mysterx/html-events.html#(meth._(((lib._mysterx/main..ss)._mx-event~3c~25~3e)._tag))",[[0,[1,"tag"]],[12,[" (method of ",[0,[1,"mx-event&lt;%&gt;"]],")"]]],["mysterx"]],
["tag",">scribble/struct.html#(tech._tag)","<i>tag</i>",false],
["tag prefix",">scribble/struct.html#(tech._tag._prefix)","<i>tag prefix</i>",false],
["tag-key",">scribble/struct.html#(def._((lib._scribble/struct..ss)._tag-key))",[0,[1,"tag-key"]],["scribble/struct"]],
["tag-xexpr",">web-server/Functional_Usage.html#(def._((lib._web-server/formlets/lib..ss)._tag-xexpr))",[0,[1,"tag-xexpr"]],["web-server/formlets/lib"]],
["tag?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._tag~3f))",[0,[1,"tag?"]],["scribble/struct"]],
["tagged c pointer types",">foreign/Derived_Utilities.html#(part._foreign~3atagged-pointers)","Tagged C Pointer Types",false],
["tagged objects",">inside/im_memoryalloc.html#(part._im~3a3m~3atagged)","Tagged Objects",false],
["tags",">scribble/struct.html#(part._tags)","Tags",false],
["tail calls",">drscheme/buttons.html#(idx._(gentag._13._(lib._scribblings/drscheme/drscheme..scrbl)))","tail calls",false],
["tail evaluation",">inside/Evaluation.html#(part._.Tail_.Evaluation)","Tail Evaluation",false],
["tail position",">reference/eval-model.html#(part._.Tail_.Position)","Tail Position",false],
["tail position",">reference/eval-model.html#(tech._tail._position)","<i>tail position</i>",false],
["tail recursion",">guide/Lists__Iteration__and_Recursion.html#(part._tail-recursion)","Tail Recursion",false],
["tail recursion",">inside/Evaluation.html#(idx._(gentag._258._(lib._scribblings/inside/inside..scrbl)))","tail recursion",false],
["take",">reference/pairs.html#(def._((lib._scheme/list..ss)._take))",[0,[1,"take"]],["scheme/list","scheme"]],
["take",">lazy/index.html#(def._((lib._lazy/main..ss)._take))",[0,[1,"take"]],["lazy"]],
["take",">srfi-std/srfi-1.html#take",[0,[1,"take"]],["srfi/1"]],
["take!",">srfi-std/srfi-1.html#take!",[0,[1,"take!"]],["srfi/1"]],
["take-right",">reference/pairs.html#(def._((lib._scheme/list..ss)._take-right))",[0,[1,"take-right"]],["scheme/list","scheme"]],
["take-right",">srfi-std/srfi-1.html#take-right",[0,[1,"take-right"]],["srfi/1"]],
["take-while",">srfi-std/srfi-1.html#take-while",[0,[1,"take-while"]],["srfi/1"]],
["take-while!",">srfi-std/srfi-1.html#take-while!",[0,[1,"take-while!"]],["srfi/1"]],
["tan",">reference/numbers.html#(def._((quote._~23~25kernel)._tan))",[0,[1,"tan"]],["scheme/base","scheme"]],
["tan",">r5rs-std/r5rs-Z-H-9.html#%_idx_334",[0,[1,"tan"]],["r5rs"]],
["tan",">r6rs-std/r6rs-Z-H-14.html#node_idx_550",[0,[1,"tan"]],["rnrs/base-6"]],
["tan",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._tan))",[0,[1,"tan"]],["lang/htdp-advanced"]],
["tan",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._tan))",[0,[1,"tan"]],["lang/htdp-beginner"]],
["tan",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._tan))",[0,[1,"tan"]],["lang/htdp-beginner-abbr"]],
["tan",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._tan))",[0,[1,"tan"]],["lang/htdp-intermediate"]],
["tan",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._tan))",[0,[1,"tan"]],["lang/htdp-intermediate-lambda"]],
["tar",">file/tar.html#(def._((lib._file/tar..ss)._tar))",[0,[1,"tar"]],["file/tar"]],
["tar file creation",">file/tar.html",[[5,"tar"]," File Creation"],false],
["tar->output",">file/tar.html#(def._((lib._file/tar..ss)._tar-~3eoutput))",[0,[1,"tar-&gt;output"]],["file/tar"]],
["target-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._target-element))",[0,[1,"target-element"]],["scribble/struct"]],
["target-element-tag",">scribble/struct.html#(def._((lib._scribble/struct..ss)._target-element-tag))",[0,[1,"target-element-tag"]],["scribble/struct"]],
["target-element?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._target-element~3f))",[0,[1,"target-element?"]],["scribble/struct"]],
["target-url",">scribble/struct.html#(def._((lib._scribble/struct..ss)._target-url))",[0,[1,"target-url"]],["scribble/struct"]],
["target-url-addr",">scribble/struct.html#(def._((lib._scribble/struct..ss)._target-url-addr))",[0,[1,"target-url-addr"]],["scribble/struct"]],
["target-url-style",">scribble/struct.html#(def._((lib._scribble/struct..ss)._target-url-style))",[0,[1,"target-url-style"]],["scribble/struct"]],
["target-url?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._target-url~3f))",[0,[1,"target-url?"]],["scribble/struct"]],
["tbody",">html/index.html#(def._((lib._html/main..ss)._tbody))",[0,[1,"tbody"]],["html"]],
["tbody?",">html/index.html#(def._((lib._html/main..ss)._tbody~3f))",[0,[1,"tbody?"]],["html"]],
["tcp",">reference/tcp.html","TCP",false],
["tcp redirect: tcp^ via channels",">net/tcp-redirect.html",["TCP Redirect: ",[0,[6,"tcp^"]]," via Channels"],false],
["tcp signature",">net/tcp.html#(part._.T.C.P_.Signature)","TCP Signature",false],
["tcp unit",">net/tcp.html#(part._.T.C.P_.Unit)","TCP Unit",false],
["tcp-abandon-port",">reference/tcp.html#(def._((lib._scheme/tcp..ss)._tcp-abandon-port))",[0,[1,"tcp-abandon-port"]],["scheme/tcp","scheme"]],
["tcp-abandon-port",">net/tcp.html#(sig-val._((lib._net/tcp-sig..ss)._tcp~5e._tcp-abandon-port))",[0,[1,"tcp-abandon-port"]],["net/tcp-sig"]],
["tcp-accept",">reference/tcp.html#(def._((lib._scheme/tcp..ss)._tcp-accept))",[0,[1,"tcp-accept"]],["scheme/tcp","scheme"]],
["tcp-accept",">net/tcp.html#(sig-val._((lib._net/tcp-sig..ss)._tcp~5e._tcp-accept))",[0,[1,"tcp-accept"]],["net/tcp-sig"]],
["tcp-accept-evt",">reference/tcp.html#(def._((lib._scheme/tcp..ss)._tcp-accept-evt))",[0,[1,"tcp-accept-evt"]],["scheme/tcp","scheme"]],
["tcp-accept-ready?",">reference/tcp.html#(def._((lib._scheme/tcp..ss)._tcp-accept-ready~3f))",[0,[1,"tcp-accept-ready?"]],["scheme/tcp","scheme"]],
["tcp-accept-ready?",">net/tcp.html#(sig-val._((lib._net/tcp-sig..ss)._tcp~5e._tcp-accept-ready~3f))",[0,[1,"tcp-accept-ready?"]],["net/tcp-sig"]],
["tcp-accept/enable-break",">reference/tcp.html#(def._((lib._scheme/tcp..ss)._tcp-accept/enable-break))",[0,[1,"tcp-accept/enable-break"]],["scheme/tcp","scheme"]],
["tcp-accept/enable-break",">net/tcp.html#(sig-val._((lib._net/tcp-sig..ss)._tcp~5e._tcp-accept/enable-break))",[0,[1,"tcp-accept/enable-break"]],["net/tcp-sig"]],
["tcp-addresses",">reference/tcp.html#(def._((lib._scheme/tcp..ss)._tcp-addresses))",[0,[1,"tcp-addresses"]],["scheme/tcp","scheme"]],
["tcp-addresses",">net/tcp.html#(sig-val._((lib._net/tcp-sig..ss)._tcp~5e._tcp-addresses))",[0,[1,"tcp-addresses"]],["net/tcp-sig"]],
["tcp-close",">reference/tcp.html#(def._((lib._scheme/tcp..ss)._tcp-close))",[0,[1,"tcp-close"]],["scheme/tcp","scheme"]],
["tcp-close",">net/tcp.html#(sig-val._((lib._net/tcp-sig..ss)._tcp~5e._tcp-close))",[0,[1,"tcp-close"]],["net/tcp-sig"]],
["tcp-connect",">reference/tcp.html#(def._((lib._scheme/tcp..ss)._tcp-connect))",[0,[1,"tcp-connect"]],["scheme/tcp","scheme"]],
["tcp-connect",">net/tcp.html#(sig-val._((lib._net/tcp-sig..ss)._tcp~5e._tcp-connect))",[0,[1,"tcp-connect"]],["net/tcp-sig"]],
["tcp-connect/enable-break",">reference/tcp.html#(def._((lib._scheme/tcp..ss)._tcp-connect/enable-break))",[0,[1,"tcp-connect/enable-break"]],["scheme/tcp","scheme"]],
["tcp-connect/enable-break",">net/tcp.html#(sig-val._((lib._net/tcp-sig..ss)._tcp~5e._tcp-connect/enable-break))",[0,[1,"tcp-connect/enable-break"]],["net/tcp-sig"]],
["tcp-like client procedures",">openssl/index.html#(part._.T.C.P-like_.Client_.Procedures)","TCP-like Client Procedures",false],
["tcp-like server procedures",">openssl/index.html#(part._.T.C.P-like_.Server_.Procedures)","TCP-like Server Procedures",false],
["tcp-listen",">reference/tcp.html#(def._((lib._scheme/tcp..ss)._tcp-listen))",[0,[1,"tcp-listen"]],["scheme/tcp","scheme"]],
["tcp-listen",">net/tcp.html#(sig-val._((lib._net/tcp-sig..ss)._tcp~5e._tcp-listen))",[0,[1,"tcp-listen"]],["net/tcp-sig"]],
["tcp-listener?",">reference/tcp.html#(def._((lib._scheme/tcp..ss)._tcp-listener~3f))",[0,[1,"tcp-listener?"]],["scheme/tcp","scheme"]],
["tcp-listener?",">net/tcp.html#(sig-val._((lib._net/tcp-sig..ss)._tcp~5e._tcp-listener~3f))",[0,[1,"tcp-listener?"]],["net/tcp-sig"]],
["tcp-port?",">reference/tcp.html#(def._((lib._scheme/tcp..ss)._tcp-port~3f))",[0,[1,"tcp-port?"]],["scheme/tcp","scheme"]],
["tcp-redirect",">net/tcp-redirect.html#(def._((lib._net/tcp-redirect..ss)._tcp-redirect))",[0,[1,"tcp-redirect"]],["net/tcp-redirect"]],
["tcp: unit and signature",">net/tcp.html","TCP: Unit and Signature",false],
["tcp@",">net/tcp.html#(def._((lib._net/tcp-unit..ss)._tcp~40))",[0,[1,"tcp@"]],["net/tcp-unit"]],
["tcp^",">net/tcp.html#(form._((lib._net/tcp-sig..ss)._tcp~5e))",[0,[6,"tcp^"]],["net/tcp-sig"]],
["td",">html/index.html#(def._((lib._html/main..ss)._td))",[0,[1,"td"]],["html"]],
["td?",">html/index.html#(def._((lib._html/main..ss)._td~3f))",[0,[1,"td?"]],["html"]],
["teachpack",">drscheme/extending-drscheme.html#(tech._teachpack)","<i>teachpack</i>",false],
["teachpacks",">drscheme/extending-drscheme.html#(part._teachpacks)","Teachpacks",false],
["teachpacks",">teachpack/index.html","Teachpacks",false],
["tech",">scribble/section-links.html#(def._((lib._scribble/manual..ss)._tech))",[0,[1,"tech"]],["scribble/manual"]],
["techlink",">scribble/section-links.html#(def._((lib._scribble/manual..ss)._techlink))",[0,[1,"techlink"]],["scribble/manual"]],
["technical issues",">framework/Test.html#(part._.Technical_.Issues)","Technical Issues",false],
["tell",">gui/editor-stream-in_.html#(meth._(((lib._mred/main..ss)._editor-stream-in~25)._tell))",[[0,[1,"tell"]],[12,[" (method of ",[0,[1,"editor-stream-in%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["tell",">gui/editor-stream-in-base_.html#(meth._(((lib._mred/main..ss)._editor-stream-in-base~25)._tell))",[[0,[1,"tell"]],[12,[" (method of ",[0,[1,"editor-stream-in-base%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["tell",">gui/editor-stream-out_.html#(meth._(((lib._mred/main..ss)._editor-stream-out~25)._tell))",[[0,[1,"tell"]],[12,[" (method of ",[0,[1,"editor-stream-out%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["tell",">gui/editor-stream-out-base_.html#(meth._(((lib._mred/main..ss)._editor-stream-out-base~25)._tell))",[[0,[1,"tell"]],[12,[" (method of ",[0,[1,"editor-stream-out-base%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["temp",">reference/Filesystem.html#(idx._(gentag._249._(lib._scribblings/reference/reference..scrbl)))",[5,"TEMP"],false],
["temp-dir",">reference/Filesystem.html#(idx._(gentag._246._(lib._scribblings/reference/reference..scrbl)))",[7,"'temp-dir"],false],
["template",">guide/pattern-macros.html#(tech._template)","<i>template</i>",false],
["template environment",">reference/syntax-model.html#(tech._template._environment)","<i>template environment</i>",false],
["template phase level",">guide/stx-phases.html#(tech._template._phase._level)","<i>template phase level</i>",false],
["temporarily",">web-server/helpers_ss.html#(def._((lib._web-server/servlet/helpers..ss)._temporarily))",[0,[1,"temporarily"]],["web-server/servlet/helpers"]],
["temporarily catching error escapes",">inside/exceptions.html#(part._imz~3atempcatch)","Temporarily Catching Error Escapes",false],
["tentative-pretty-print-port-cancel",">reference/pretty-print.html#(def._((lib._scheme/pretty..ss)._tentative-pretty-print-port-cancel))",[0,[1,"tentative-pretty-print-port-cancel"]],["scheme/pretty","scheme"]],
["tentative-pretty-print-port-transfer",">reference/pretty-print.html#(def._((lib._scheme/pretty..ss)._tentative-pretty-print-port-transfer))",[0,[1,"tentative-pretty-print-port-transfer"]],["scheme/pretty","scheme"]],
["tenth",">reference/pairs.html#(def._((lib._scheme/list..ss)._tenth))",[0,[1,"tenth"]],["scheme/list","scheme"]],
["tenth",">srfi-std/srfi-1.html#tenth",[0,[1,"tenth"]],["srfi/1"]],
["term",">redex/Terms.html#(form._((lib._redex/main..ss)._term))",[0,[6,"term"]],["redex"]],
["term",">redex/Terms.html#(tech._term)","<i>term</i>",false],
["term-let",">redex/Terms.html#(form._((lib._redex/main..ss)._term-let))",[0,[6,"term-let"]],["redex"]],
["term-match",">redex/Terms.html#(form._((lib._redex/main..ss)._term-match))",[0,[6,"term-match"]],["redex"]],
["term-match/single",">redex/Terms.html#(form._((lib._redex/main..ss)._term-match/single))",[0,[6,"term-match/single"]],["redex"]],
["term-node-children",">redex/GUI.html#(def._((lib._redex/gui..ss)._term-node-children))",[0,[1,"term-node-children"]],["redex/gui"]],
["term-node-expr",">redex/GUI.html#(def._((lib._redex/gui..ss)._term-node-expr))",[0,[1,"term-node-expr"]],["redex/gui"]],
["term-node-labels",">redex/GUI.html#(def._((lib._redex/gui..ss)._term-node-labels))",[0,[1,"term-node-labels"]],["redex/gui"]],
["term-node-parents",">redex/GUI.html#(def._((lib._redex/gui..ss)._term-node-parents))",[0,[1,"term-node-parents"]],["redex/gui"]],
["term-node-set-color!",">redex/GUI.html#(def._((lib._redex/gui..ss)._term-node-set-color!))",[0,[1,"term-node-set-color!"]],["redex/gui"]],
["term-node-set-red!",">redex/GUI.html#(def._((lib._redex/gui..ss)._term-node-set-red!))",[0,[1,"term-node-set-red!"]],["redex/gui"]],
["term-node?",">redex/GUI.html#(def._((lib._redex/gui..ss)._term-node~3f))",[0,[1,"term-node?"]],["redex/gui"]],
["terminal-port?",">reference/port-ops.html#(def._((quote._~23~25kernel)._terminal-port~3f))",[0,[1,"terminal-port?"]],["scheme/base","scheme"]],
["terminating connections",">more/index.html#(part._.Terminating_.Connections)","Terminating Connections",false],
["terminating-macro",">reference/readtables.html#(idx._(gentag._197._(lib._scribblings/reference/reference..scrbl)))",[7,"'terminating-macro"],false],
["terms",">redex/Terms.html","Terms",false],
["test",">framework/Test.html","Test",false],
["test",">mzc/Scheme_API_for_Compilation.html#(def._((lib._compiler/option..ss)._test))",[0,[1,"test"]],["compiler/option"]],
["test box recovery tool",">test-box-recovery/index.html","Test Box Recovery Tool",false],
["test cases",">htdp-langs/Test_Cases.html","Test Cases",false],
["test functions",">framework/Test.html#(part._.Test_.Functions)","Test Functions",false],
["test-->",">redex/Testing.html#(form._((lib._redex/main..ss)._test--~3e))",[0,[6,"test--&gt;"]],["redex"]],
["test-case%",">gui/WXME_Decoding.html#(def._((lib._wxme/test-case..ss)._test-case~25))",[0,[1,"test-case%"]],["wxme/test-case"]],
["test-coverage-enabled",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..ss)._stacktrace-imports~5e._test-coverage-enabled))",[0,[1,"test-coverage-enabled"]],["errortrace/stacktrace"]],
["test-covered",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..ss)._stacktrace-imports~5e._test-covered))",[0,[1,"test-covered"]],["errortrace/stacktrace"]],
["test-equal",">redex/Testing.html#(form._((lib._redex/main..ss)._test-equal))",[0,[6,"test-equal"]],["redex"]],
["test-pixel",">graphics/posn.html#(def._((lib._graphics/graphics..ss)._test-pixel))",[0,[1,"test-pixel"]],["graphics/graphics"]],
["test-predicate",">redex/Testing.html#(form._((lib._redex/main..ss)._test-predicate))",[0,[6,"test-predicate"]],["redex"]],
["test-results",">redex/Testing.html#(def._((lib._redex/main..ss)._test-results))",[0,[1,"test-results"]],["redex"]],
["test:button-push",">framework/Test.html#(def._((lib._framework/test..ss)._test~3abutton-push))",[0,[1,"test:button-push"]],["framework/test"]],
["test:close-top-level-window",">framework/Test.html#(def._((lib._framework/test..ss)._test~3aclose-top-level-window))",[0,[1,"test:close-top-level-window"]],["framework/test"]],
["test:current-get-eventspaces",">framework/Test.html#(def._((lib._framework/test..ss)._test~3acurrent-get-eventspaces))",[0,[1,"test:current-get-eventspaces"]],["framework/test"]],
["test:keystroke",">framework/Test.html#(def._((lib._framework/test..ss)._test~3akeystroke))",[0,[1,"test:keystroke"]],["framework/test"]],
["test:menu-select",">framework/Test.html#(def._((lib._framework/test..ss)._test~3amenu-select))",[0,[1,"test:menu-select"]],["framework/test"]],
["test:mouse-click",">framework/Test.html#(def._((lib._framework/test..ss)._test~3amouse-click))",[0,[1,"test:mouse-click"]],["framework/test"]],
["test:new-window",">framework/Test.html#(def._((lib._framework/test..ss)._test~3anew-window))",[0,[1,"test:new-window"]],["framework/test"]],
["test:number-pending-actions",">framework/Test.html#(def._((lib._framework/test..ss)._test~3anumber-pending-actions))",[0,[1,"test:number-pending-actions"]],["framework/test"]],
["test:reraise-error",">framework/Test.html#(def._((lib._framework/test..ss)._test~3areraise-error))",[0,[1,"test:reraise-error"]],["framework/test"]],
["test:run-interval",">framework/Test.html#(def._((lib._framework/test..ss)._test~3arun-interval))",[0,[1,"test:run-interval"]],["framework/test"]],
["test:run-one",">framework/Test.html#(def._((lib._framework/test..ss)._test~3arun-one))",[0,[1,"test:run-one"]],["framework/test"]],
["test:set-check-box!",">framework/Test.html#(def._((lib._framework/test..ss)._test~3aset-check-box!))",[0,[1,"test:set-check-box!"]],["framework/test"]],
["test:set-choice!",">framework/Test.html#(def._((lib._framework/test..ss)._test~3aset-choice!))",[0,[1,"test:set-choice!"]],["framework/test"]],
["test:set-list-box!",">framework/Test.html#(def._((lib._framework/test..ss)._test~3aset-list-box!))",[0,[1,"test:set-list-box!"]],["framework/test"]],
["test:set-radio-box!",">framework/Test.html#(def._((lib._framework/test..ss)._test~3aset-radio-box!))",[0,[1,"test:set-radio-box!"]],["framework/test"]],
["test:set-radio-box-item!",">framework/Test.html#(def._((lib._framework/test..ss)._test~3aset-radio-box-item!))",[0,[1,"test:set-radio-box-item!"]],["framework/test"]],
["test:top-level-focus-window-has?",">framework/Test.html#(def._((lib._framework/test..ss)._test~3atop-level-focus-window-has~3f))",[0,[1,"test:top-level-focus-window-has?"]],["framework/test"]],
["testing",">redex/Testing.html","Testing",false],
["tex table",">mrlib/TeX_Table.html","TeX Table",false],
["tex-shortcut-table",">mrlib/TeX_Table.html#(def._((lib._mrlib/tex-table..ss)._tex-shortcut-table))",[0,"tex-shortcut-table"],["mrlib/tex-table"]],
["text",">framework/Text.html","Text",false],
["text",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._text))",[0,[1,"text"]],["slideshow/pict","slideshow"]],
["text",">teachpack/image.html#(def._((lib._htdp/image..ss)._text))",[0,[1,"text"]],["teachpack/htdp/image"]],
["text",">web-server/Functional_Usage.html#(def._((lib._web-server/formlets/lib..ss)._text))",[0,[1,"text"]],["web-server/formlets/lib"]],
["text",">reference/file-ports.html#(idx._(gentag._106._(lib._scribblings/reference/reference..scrbl)))",[7,"'text"],false],
["text editor",">gui/editor-overview.html#(tech._text._editor)","<i>text editor</i>",false],
["text field",">gui/windowing-overview.html#(tech._text._field)","<i>text field</i>",false],
["text preprocessor",">scribble/preprocessor.html","Text Preprocessor",false],
["text renderer",">scribble/renderer.html#(part._.Text_.Renderer)","Text Renderer",false],
["text string",">guide/regexp.html#(tech._text._string)","<i>text string</i>",false],
["text styles",">scribble/basic.html#(part._.Text_.Styles)","Text Styles",false],
["text%",">gui/text_.html",[0,[1,"text%"]],["scheme/gui/base","scheme/gui"]],
["text-align",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._text-align))",[[0,[1,"text-align"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["text-align-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._text-align-native))",[[0,[1,"text-align-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["text-button-snip%",">embedded-gui/text-button-snip_.html",[0,[1,"text-button-snip%"]],["embedded-gui"]],
["text-contents",">teachpack/gui.html#(def._((lib._teachpack/htdp/gui..ss)._text-contents))",[0,[1,"text-contents"]],["teachpack/htdp/gui"]],
["text-decoration",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._text-decoration))",[[0,[1,"text-decoration"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["text-decoration-blink",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._text-decoration-blink))",[[0,[1,"text-decoration-blink"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["text-decoration-linethrough",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._text-decoration-linethrough))",[[0,[1,"text-decoration-linethrough"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["text-decoration-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._text-decoration-native))",[[0,[1,"text-decoration-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["text-decoration-none",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._text-decoration-none))",[[0,[1,"text-decoration-none"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["text-decoration-overline",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._text-decoration-overline))",[[0,[1,"text-decoration-overline"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["text-decoration-underline",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._text-decoration-underline))",[[0,[1,"text-decoration-underline"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["text-editor%",">gui/WXME_Decoding.html#(def._((lib._wxme/text..ss)._text-editor~25))",[0,[1,"text-editor%"]],["wxme/text"]],
["text-editor-load-handler",">gui/Editor_Functions.html#(def._((lib._mred/main..ss)._text-editor-load-handler))",[0,[1,"text-editor-load-handler"]],["scheme/gui/base","scheme/gui"]],
["text-field",">gui/text-field_.html#(idx._(gentag._132._(lib._scribblings/gui/gui..scrbl)))",[7,"'text-field"],false],
["text-field",">gui/combo-field_.html#(idx._(gentag._43._(lib._scribblings/gui/gui..scrbl)))",[7,"'text-field"],false],
["text-field%",">gui/text-field_.html",[0,[1,"text-field%"]],["scheme/gui/base","scheme/gui"]],
["text-field-enter",">gui/text-field_.html#(idx._(gentag._131._(lib._scribblings/gui/gui..scrbl)))",[7,"'text-field-enter"],false],
["text-field-enter",">gui/combo-field_.html#(idx._(gentag._42._(lib._scribblings/gui/gui..scrbl)))",[7,"'text-field-enter"],false],
["text-indent",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._text-indent))",[[0,[1,"text-indent"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["text-indent-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._text-indent-native))",[[0,[1,"text-indent-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["text-style/c",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._text-style/c))",[0,[1,"text-style/c"]],["slideshow/pict","slideshow"]],
["text-transform",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._text-transform))",[[0,[1,"text-transform"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["text-transform-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._text-transform-native))",[[0,[1,"text-transform-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["text/html-mime-type",">web-server/response-structs_ss.html#(def._((lib._web-server/private/response-structs..ss)._.T.E.X.T/.H.T.M.L-.M.I.M.E-.T.Y.P.E))",[0,[1,"TEXT/HTML-MIME-TYPE"]],["web-server/private/response-structs"]],
["text:1-pixel-string-snip%",">framework/Text.html#(def._((lib._framework/main..ss)._text~3a1-pixel-string-snip~25))",[0,[1,"text:1-pixel-string-snip%"]],["framework"]],
["text:1-pixel-tab-snip%",">framework/Text.html#(def._((lib._framework/main..ss)._text~3a1-pixel-tab-snip~25))",[0,[1,"text:1-pixel-tab-snip%"]],["framework"]],
["text:autocomplete-append-after",">framework/Text.html#(def._((lib._framework/main..ss)._text~3aautocomplete-append-after))",[0,[1,"text:autocomplete-append-after"]],["framework"]],
["text:autocomplete-limit",">framework/Text.html#(def._((lib._framework/main..ss)._text~3aautocomplete-limit))",[0,[1,"text:autocomplete-limit"]],["framework"]],
["text:autocomplete-mixin",">framework/Text.html#(def._((lib._framework/main..ss)._text~3aautocomplete-mixin))",[0,[1,"text:autocomplete-mixin"]],["framework"]],
["text:autocomplete<%>",">framework/Text.html#(def._((lib._framework/main..ss)._text~3aautocomplete~3c~25~3e))",[0,[1,"text:autocomplete&lt;%&gt;"]],["framework"]],
["text:autowrap%",">framework/Text.html#(def._((lib._framework/main..ss)._text~3aautowrap~25))",[0,[1,"text:autowrap%"]],["framework"]],
["text:backup-autosave%",">framework/Text.html#(def._((lib._framework/main..ss)._text~3abackup-autosave~25))",[0,[1,"text:backup-autosave%"]],["framework"]],
["text:basic%",">framework/Text.html#(def._((lib._framework/main..ss)._text~3abasic~25))",[0,[1,"text:basic%"]],["framework"]],
["text:basic-mixin",">framework/Text.html#(def._((lib._framework/main..ss)._text~3abasic-mixin))",[0,[1,"text:basic-mixin"]],["framework"]],
["text:basic<%>",">framework/Text.html#(def._((lib._framework/main..ss)._text~3abasic~3c~25~3e))",[0,[1,"text:basic&lt;%&gt;"]],["framework"]],
["text:clever-file-format%",">framework/Text.html#(def._((lib._framework/main..ss)._text~3aclever-file-format~25))",[0,[1,"text:clever-file-format%"]],["framework"]],
["text:clever-file-format-mixin",">framework/Text.html#(def._((lib._framework/main..ss)._text~3aclever-file-format-mixin))",[0,[1,"text:clever-file-format-mixin"]],["framework"]],
["text:clever-file-format<%>",">framework/Text.html#(def._((lib._framework/main..ss)._text~3aclever-file-format~3c~25~3e))",[0,[1,"text:clever-file-format&lt;%&gt;"]],["framework"]],
["text:delegate%",">framework/Text.html#(def._((lib._framework/main..ss)._text~3adelegate~25))",[0,[1,"text:delegate%"]],["framework"]],
["text:delegate-mixin",">framework/Text.html#(def._((lib._framework/main..ss)._text~3adelegate-mixin))",[0,[1,"text:delegate-mixin"]],["framework"]],
["text:delegate<%>",">framework/Text.html#(def._((lib._framework/main..ss)._text~3adelegate~3c~25~3e))",[0,[1,"text:delegate&lt;%&gt;"]],["framework"]],
["text:file%",">framework/Text.html#(def._((lib._framework/main..ss)._text~3afile~25))",[0,[1,"text:file%"]],["framework"]],
["text:file-mixin",">framework/Text.html#(def._((lib._framework/main..ss)._text~3afile-mixin))",[0,[1,"text:file-mixin"]],["framework"]],
["text:file<%>",">framework/Text.html#(def._((lib._framework/main..ss)._text~3afile~3c~25~3e))",[0,[1,"text:file&lt;%&gt;"]],["framework"]],
["text:first-line-mixin",">framework/Text.html#(def._((lib._framework/main..ss)._text~3afirst-line-mixin))",[0,[1,"text:first-line-mixin"]],["framework"]],
["text:first-line<%>",">framework/Text.html#(def._((lib._framework/main..ss)._text~3afirst-line~3c~25~3e))",[0,[1,"text:first-line&lt;%&gt;"]],["framework"]],
["text:foreground-color-mixin",">framework/Text.html#(def._((lib._framework/main..ss)._text~3aforeground-color-mixin))",[0,[1,"text:foreground-color-mixin"]],["framework"]],
["text:foreground-color<%>",">framework/Text.html#(def._((lib._framework/main..ss)._text~3aforeground-color~3c~25~3e))",[0,[1,"text:foreground-color&lt;%&gt;"]],["framework"]],
["text:get-completions/manuals",">framework/Text.html#(def._((lib._framework/main..ss)._text~3aget-completions/manuals))",[0,[1,"text:get-completions/manuals"]],["framework"]],
["text:hide-caret/selection%",">framework/Text.html#(def._((lib._framework/main..ss)._text~3ahide-caret/selection~25))",[0,[1,"text:hide-caret/selection%"]],["framework"]],
["text:hide-caret/selection-mixin",">framework/Text.html#(def._((lib._framework/main..ss)._text~3ahide-caret/selection-mixin))",[0,[1,"text:hide-caret/selection-mixin"]],["framework"]],
["text:hide-caret/selection<%>",">framework/Text.html#(def._((lib._framework/main..ss)._text~3ahide-caret/selection~3c~25~3e))",[0,[1,"text:hide-caret/selection&lt;%&gt;"]],["framework"]],
["text:info%",">framework/Text.html#(def._((lib._framework/main..ss)._text~3ainfo~25))",[0,[1,"text:info%"]],["framework"]],
["text:info-mixin",">framework/Text.html#(def._((lib._framework/main..ss)._text~3ainfo-mixin))",[0,[1,"text:info-mixin"]],["framework"]],
["text:info<%>",">framework/Text.html#(def._((lib._framework/main..ss)._text~3ainfo~3c~25~3e))",[0,[1,"text:info&lt;%&gt;"]],["framework"]],
["text:input-box%",">framework/Text.html#(def._((lib._framework/main..ss)._text~3ainput-box~25))",[0,[1,"text:input-box%"]],["framework"]],
["text:input-box-mixin",">framework/Text.html#(def._((lib._framework/main..ss)._text~3ainput-box-mixin))",[0,[1,"text:input-box-mixin"]],["framework"]],
["text:input-box<%>",">framework/Text.html#(def._((lib._framework/main..ss)._text~3ainput-box~3c~25~3e))",[0,[1,"text:input-box&lt;%&gt;"]],["framework"]],
["text:keymap%",">framework/Text.html#(def._((lib._framework/main..ss)._text~3akeymap~25))",[0,[1,"text:keymap%"]],["framework"]],
["text:lookup-port-name",">framework/Text.html#(def._((lib._framework/main..ss)._text~3alookup-port-name))",[0,[1,"text:lookup-port-name"]],["framework"]],
["text:nbsp->space%",">framework/Text.html#(def._((lib._framework/main..ss)._text~3anbsp-~3espace~25))",[0,[1,"text:nbsp-&gt;space%"]],["framework"]],
["text:nbsp->space-mixin",">framework/Text.html#(def._((lib._framework/main..ss)._text~3anbsp-~3espace-mixin))",[0,[1,"text:nbsp-&gt;space-mixin"]],["framework"]],
["text:nbsp->space<%>",">framework/Text.html#(def._((lib._framework/main..ss)._text~3anbsp-~3espace~3c~25~3e))",[0,[1,"text:nbsp-&gt;space&lt;%&gt;"]],["framework"]],
["text:ports-mixin",">framework/Text.html#(def._((lib._framework/main..ss)._text~3aports-mixin))",[0,[1,"text:ports-mixin"]],["framework"]],
["text:ports<%>",">framework/Text.html#(def._((lib._framework/main..ss)._text~3aports~3c~25~3e))",[0,[1,"text:ports&lt;%&gt;"]],["framework"]],
["text:return%",">framework/Text.html#(def._((lib._framework/main..ss)._text~3areturn~25))",[0,[1,"text:return%"]],["framework"]],
["text:return-mixin",">framework/Text.html#(def._((lib._framework/main..ss)._text~3areturn-mixin))",[0,[1,"text:return-mixin"]],["framework"]],
["text:return<%>",">framework/Text.html#(def._((lib._framework/main..ss)._text~3areturn~3c~25~3e))",[0,[1,"text:return&lt;%&gt;"]],["framework"]],
["text:searching%",">framework/Text.html#(def._((lib._framework/main..ss)._text~3asearching~25))",[0,[1,"text:searching%"]],["framework"]],
["text:searching-mixin",">framework/Text.html#(def._((lib._framework/main..ss)._text~3asearching-mixin))",[0,[1,"text:searching-mixin"]],["framework"]],
["text:searching<%>",">framework/Text.html#(def._((lib._framework/main..ss)._text~3asearching~3c~25~3e))",[0,[1,"text:searching&lt;%&gt;"]],["framework"]],
["text:standard-style-list%",">framework/Text.html#(def._((lib._framework/main..ss)._text~3astandard-style-list~25))",[0,[1,"text:standard-style-list%"]],["framework"]],
["text:wide-snip%",">framework/Text.html#(def._((lib._framework/main..ss)._text~3awide-snip~25))",[0,[1,"text:wide-snip%"]],["framework"]],
["text:wide-snip-mixin",">framework/Text.html#(def._((lib._framework/main..ss)._text~3awide-snip-mixin))",[0,[1,"text:wide-snip-mixin"]],["framework"]],
["text:wide-snip<%>",">framework/Text.html#(def._((lib._framework/main..ss)._text~3awide-snip~3c~25~3e))",[0,[1,"text:wide-snip&lt;%&gt;"]],["framework"]],
["textarea",">html/index.html#(def._((lib._html/main..ss)._textarea))",[0,[1,"textarea"]],["html"]],
["textarea?",">html/index.html#(def._((lib._html/main..ss)._textarea~3f))",[0,[1,"textarea?"]],["html"]],
["textual-port?",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_646",[0,[1,"textual-port?"]],["rnrs/io/ports-6"]],
["textual-read-eval-print-loop",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._textual-read-eval-print-loop))",[0,[1,"textual-read-eval-print-loop"]],["scheme/gui/base","scheme/gui"]],
["tfoot",">html/index.html#(def._((lib._html/main..ss)._tfoot))",[0,[1,"tfoot"]],["html"]],
["tfoot?",">html/index.html#(def._((lib._html/main..ss)._tfoot~3f))",[0,[1,"tfoot?"]],["html"]],
["th",">html/index.html#(def._((lib._html/main..ss)._th))",[0,[1,"th"]],["html"]],
["th?",">html/index.html#(def._((lib._html/main..ss)._th~3f))",[0,[1,"th?"]],["html"]],
["thaw-colorer",">framework/Color.html#(meth._(((lib._framework/main..ss)._color~3atext~3c~25~3e)._thaw-colorer))",[[0,[1,"thaw-colorer"]],[12,[" (method of ",[0,[1,"color:text&lt;%&gt;"]],")"]]],["framework"]],
["the #lang shorthand",">guide/Module_Syntax.html#(part._hash-lang)",["The ",[15,"#lang"]," Shorthand"],false],
["the and/c, or/c, and listof contract combinators",">guide/contract-func.html#(part._contracts-and-or)",["The ",[0,[1,"and/c"]],", ",[0,[1,"or/c"]],", and ",[0,[1,"listof"]]," Contract Combinators"],false],
["the application",">continue/index.html#(part._.The_.Application)","The Application",false],
["the apply function",">guide/application.html#(part._apply)",["The ",[0,[1,"apply"]]," Function"],false],
["the body part",">scribble/reader.html#(part._.The_.Body_.Part)","The Body Part",false],
["the bytecode and just-in-time (jit) compilers",">guide/performance.html#(part._.The_.Bytecode_and_.Just-in-.Time__.J.I.T__.Compilers)","The Bytecode and Just-in-Time (JIT) Compilers",false],
["the command part",">scribble/reader.html#(part._.The_.Command_.Part)","The Command Part",false],
["the compiler as a unit",">mzc/Scheme_API_for_Compilation.html#(part._api~3aunit)","The Compiler as a Unit",false],
["the datum part",">scribble/reader.html#(part._.The_.Datum_.Part)","The Datum Part",false],
["the difference between any and any/c",">guide/contract-func.html#(part._.The_.Difference_.Between_any_and_any_c)",["The Difference Between ",[0,[6,"any"]]," and ",[0,[1,"any/c"]]],false],
["the double submit bug",">continue/index.html#(part._.The_.Double_.Submit_.Bug)","The Double Submit Bug",false],
["the interactions window",">drscheme/interactions-window.html","The Interactions Window",false],
["the mixin form",">guide/classes.html#(part._.The_mixin_.Form)",["The ",[0,[6,"mixin"]]," Form"],false],
["the module form",">guide/Module_Syntax.html#(part._module-syntax)",["The ",[0,[6,"module"]]," Form"],false],
["the mzpp read-eval-print loop",">preprocessor/mzpp.html#(part._.The_mzpp_read-eval-print_loop)","The mzpp read-eval-print loop",false],
["the planet command-line tool",">planet/cmdline.html",["The ",[5,"planet"]," Command-Line Tool"],false],
["the planet search order",">planet/search-order.html","The PLaneT Search Order",false],
["the printer",">reference/printing.html","The Printer",false],
["the reader",">reference/reader.html","The Reader",false],
["the scheme/load language",">reference/load-lang.html",["The ",[14,[0,"scheme/load"]]," Language"],false],
["the scribble syntax at a glance",">scribble/reader.html#(part._.The_.Scribble_.Syntax_at_a_.Glance)","The Scribble Syntax at a Glance",false],
["the trait form",">guide/classes.html#(part._.The_trait_.Form)",["The ",[0,[6,"trait"]]," Form"],false],
["the window layout",">games/gcalc.html#(part._.The_.Window_.Layout)","The Window Layout",false],
["the-brush-list",">gui/Drawing_Functions.html#(def._((lib._mred/main..ss)._the-brush-list))",[0,[1,"the-brush-list"]],["scheme/gui/base","scheme/gui"]],
["the-brush-list",">gui/brush_.html#(idx._(gentag._190._(lib._scribblings/gui/gui..scrbl)))",[0,[1,"the-brush-list"]],false],
["the-clipboard",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._the-clipboard))",[0,[1,"the-clipboard"]],["scheme/gui/base","scheme/gui"]],
["the-clipboard",">gui/clipboard___.html#(idx._(gentag._39._(lib._scribblings/gui/gui..scrbl)))",[0,[1,"the-clipboard"]],false],
["the-color-database",">gui/Drawing_Functions.html#(def._((lib._mred/main..ss)._the-color-database))",[0,[1,"the-color-database"]],["scheme/gui/base","scheme/gui"]],
["the-color-database",">gui/color-database___.html#(idx._(gentag._191._(lib._scribblings/gui/gui..scrbl)))",[0,[1,"the-color-database"]],false],
["the-editor-wordbreak-map",">gui/Editor_Functions.html#(def._((lib._mred/main..ss)._the-editor-wordbreak-map))",[0,[1,"the-editor-wordbreak-map"]],["scheme/gui/base","scheme/gui"]],
["the-font-list",">gui/Drawing_Functions.html#(def._((lib._mred/main..ss)._the-font-list))",[0,[1,"the-font-list"]],["scheme/gui/base","scheme/gui"]],
["the-font-list",">gui/font_.html#(idx._(gentag._212._(lib._scribblings/gui/gui..scrbl)))",[0,[1,"the-font-list"]],false],
["the-font-name-directory",">gui/Drawing_Functions.html#(def._((lib._mred/main..ss)._the-font-name-directory))",[0,[1,"the-font-name-directory"]],["scheme/gui/base","scheme/gui"]],
["the-font-name-directory",">gui/font-name-directory___.html#(idx._(gentag._213._(lib._scribblings/gui/gui..scrbl)))",[0,[1,"the-font-name-directory"]],false],
["the-font-name-directory",">gui/font-name-directory___.html#(idx._(gentag._214._(lib._scribblings/gui/gui..scrbl)))",[0,[1,"the-font-name-directory"]],false],
["the-pen-list",">gui/Drawing_Functions.html#(def._((lib._mred/main..ss)._the-pen-list))",[0,[1,"the-pen-list"]],["scheme/gui/base","scheme/gui"]],
["the-pen-list",">gui/pen_.html#(idx._(gentag._228._(lib._scribblings/gui/gui..scrbl)))",[0,[1,"the-pen-list"]],false],
["the-pen-list",">gui/pen-list_.html#(idx._(gentag._229._(lib._scribblings/gui/gui..scrbl)))",[0,[1,"the-pen-list"]],false],
["the-style-list",">gui/Editor_Functions.html#(def._((lib._mred/main..ss)._the-style-list))",[0,[1,"the-style-list"]],["scheme/gui/base","scheme/gui"]],
["the-style-list",">gui/editor-overview.html#(idx._(gentag._14._(lib._scribblings/gui/gui..scrbl)))",[0,[1,"the-style-list"]],false],
["the-style-list",">gui/style-list_.html#(idx._(gentag._287._(lib._scribblings/gui/gui..scrbl)))",[0,[1,"the-style-list"]],false],
["the-x-selection-clipboard",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._the-x-selection-clipboard))",[0,[1,"the-x-selection-clipboard"]],["scheme/gui/base","scheme/gui"]],
["the-x-selection-clipboard",">gui/clipboard___.html#(idx._(gentag._40._(lib._scribblings/gui/gui..scrbl)))",[0,[1,"the-x-selection-clipboard"]],false],
["thead",">html/index.html#(def._((lib._html/main..ss)._thead))",[0,[1,"thead"]],["html"]],
["thead?",">html/index.html#(def._((lib._html/main..ss)._thead~3f))",[0,[1,"thead?"]],["html"]],
["thing-index-desc",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._thing-index-desc))",[0,[1,"thing-index-desc"]],["scribble/manual-struct"]],
["thing-index-desc?",">scribble/index-entries.html#(def._((lib._scribble/manual-struct..ss)._thing-index-desc~3f))",[0,[1,"thing-index-desc?"]],["scribble/manual-struct"]],
["third",">reference/pairs.html#(def._((lib._scheme/list..ss)._third))",[0,[1,"third"]],["scheme/list","scheme"]],
["third",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._third))",[0,[1,"third"]],["lang/htdp-advanced"]],
["third",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._third))",[0,[1,"third"]],["lang/htdp-beginner"]],
["third",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._third))",[0,[1,"third"]],["lang/htdp-beginner-abbr"]],
["third",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._third))",[0,[1,"third"]],["lang/htdp-intermediate"]],
["third",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._third))",[0,[1,"third"]],["lang/htdp-intermediate-lambda"]],
["third",">lazy/index.html#(def._((lib._lazy/main..ss)._third))",[0,[1,"third"]],["lazy"]],
["third",">mzlib/mzlib_list.html#(def._((lib._mzlib/list..ss)._third))",[0,[1,"third"]],["mzlib/list"]],
["third",">srfi-std/srfi-1.html#third",[0,[1,"third"]],["srfi/1"]],
["this",">reference/createclass.html#(form._((lib._scheme/private/class-internal..ss)._this))",[0,[6,"this"]],["scheme/class","scheme"]],
["this-expression-file-name",">mzlib/mzlib_etc.html#(form._((lib._mzlib/etc..ss)._this-expression-file-name))",[0,[6,"this-expression-file-name"]],["mzlib/etc"]],
["this-expression-source-directory",">mzlib/mzlib_etc.html#(form._((lib._mzlib/etc..ss)._this-expression-source-directory))",[0,[6,"this-expression-source-directory"]],["mzlib/etc"]],
["this-language",">string-constants/index.html#(form._((lib._string-constants/main..ss)._this-language))",[0,[6,"this-language"]],["string-constants"]],
["this-package-version",">planet/Utility_Libraries.html#(form._((lib._planet/util..ss)._this-package-version))",[0,[6,"this-package-version"]],["planet/util"]],
["this-package-version-maj",">planet/Utility_Libraries.html#(form._((lib._planet/util..ss)._this-package-version-maj))",[0,[6,"this-package-version-maj"]],["planet/util"]],
["this-package-version-min",">planet/Utility_Libraries.html#(form._((lib._planet/util..ss)._this-package-version-min))",[0,[6,"this-package-version-min"]],["planet/util"]],
["this-package-version-name",">planet/Utility_Libraries.html#(form._((lib._planet/util..ss)._this-package-version-name))",[0,[6,"this-package-version-name"]],["planet/util"]],
["this-package-version-owner",">planet/Utility_Libraries.html#(form._((lib._planet/util..ss)._this-package-version-owner))",[0,[6,"this-package-version-owner"]],["planet/util"]],
["thread",">reference/threads.html#(def._((quote._~23~25kernel)._thread))",[0,[1,"thread"]],["scheme/base","scheme"]],
["thread cells",">reference/threadcells.html","Thread Cells",false],
["thread cells",">reference/eval-model.html#(tech._thread._cell)","<i>thread\ncells</i>",false],
["thread descriptor",">reference/threads.html#(tech._thread._descriptor)","<i>thread\ndescriptor</i>",false],
["thread functions",">inside/threads.html#(part._.Thread_.Functions)","Thread Functions",false],
["thread group",">reference/threadgroups.html#(tech._thread._group)","<i>thread group</i>",false],
["thread groups",">reference/threadgroups.html","Thread Groups",false],
["thread issues",">framework/Test.html#(part._.Thread_.Issues)","Thread Issues",false],
["thread mailboxes",">reference/threads.html#(part._threadmbox)","Thread Mailboxes",false],
["thread-cell-ref",">reference/threadcells.html#(def._((quote._~23~25kernel)._thread-cell-ref))",[0,[1,"thread-cell-ref"]],["scheme/base","scheme"]],
["thread-cell-set!",">reference/threadcells.html#(def._((quote._~23~25kernel)._thread-cell-set!))",[0,[1,"thread-cell-set!"]],["scheme/base","scheme"]],
["thread-cell?",">reference/threadcells.html#(def._((quote._~23~25kernel)._thread-cell~3f))",[0,[1,"thread-cell?"]],["scheme/base","scheme"]],
["thread-dead-evt",">reference/threads.html#(def._((quote._~23~25kernel)._thread-dead-evt))",[0,[1,"thread-dead-evt"]],["scheme/base","scheme"]],
["thread-dead?",">reference/threads.html#(def._((quote._~23~25kernel)._thread-dead~3f))",[0,[1,"thread-dead?"]],["scheme/base","scheme"]],
["thread-done-evt",">mzlib/mzlib_cml.html#(def._((lib._mzlib/cml..ss)._thread-done-evt))",[0,[1,"thread-done-evt"]],["mzlib/cml"]],
["thread-group?",">reference/threadgroups.html#(def._((quote._~23~25kernel)._thread-group~3f))",[0,[1,"thread-group?"]],["scheme/base","scheme"]],
["thread-local storage",">reference/thread-local-storage.html","Thread-Local Storage",false],
["thread-receive",">reference/threads.html#(def._((quote._~23~25kernel)._thread-receive))",[0,[1,"thread-receive"]],["scheme/base","scheme"]],
["thread-receive-evt",">reference/threads.html#(def._((quote._~23~25kernel)._thread-receive-evt))",[0,[1,"thread-receive-evt"]],["scheme/base","scheme"]],
["thread-resume",">reference/threads.html#(def._((quote._~23~25kernel)._thread-resume))",[0,[1,"thread-resume"]],["scheme/base","scheme"]],
["thread-resume-evt",">reference/threads.html#(def._((quote._~23~25kernel)._thread-resume-evt))",[0,[1,"thread-resume-evt"]],["scheme/base","scheme"]],
["thread-rewind-receive",">reference/threads.html#(def._((quote._~23~25kernel)._thread-rewind-receive))",[0,[1,"thread-rewind-receive"]],["scheme/base","scheme"]],
["thread-running?",">reference/threads.html#(def._((quote._~23~25kernel)._thread-running~3f))",[0,[1,"thread-running?"]],["scheme/base","scheme"]],
["thread-send",">reference/threads.html#(def._((quote._~23~25kernel)._thread-send))",[0,[1,"thread-send"]],["scheme/base","scheme"]],
["thread-suspend",">reference/threads.html#(def._((quote._~23~25kernel)._thread-suspend))",[0,[1,"thread-suspend"]],["scheme/base","scheme"]],
["thread-suspend-evt",">reference/threads.html#(def._((quote._~23~25kernel)._thread-suspend-evt))",[0,[1,"thread-suspend-evt"]],["scheme/base","scheme"]],
["thread-try-receive",">reference/threads.html#(def._((quote._~23~25kernel)._thread-try-receive))",[0,[1,"thread-try-receive"]],["scheme/base","scheme"]],
["thread-wait",">reference/threads.html#(def._((quote._~23~25kernel)._thread-wait))",[0,[1,"thread-wait"]],["scheme/base","scheme"]],
["thread/suspend-to-kill",">reference/threads.html#(def._((quote._~23~25kernel)._thread/suspend-to-kill))",[0,[1,"thread/suspend-to-kill"]],["scheme/base","scheme"]],
["thread?",">reference/threads.html#(def._((quote._~23~25kernel)._thread~3f))",[0,[1,"thread?"]],["scheme/base","scheme"]],
["threads run state",">reference/threads.html#(idx._(gentag._80._(lib._scribblings/reference/reference..scrbl)))","threads, run state",false],
["threads breaking",">reference/breakhandler.html","threads, breaking",false],
["threads breaking",">reference/threads.html#(idx._(gentag._79._(lib._scribblings/reference/reference..scrbl)))","threads, breaking",false],
["threads",">inside/threads.html","Threads",false],
["threads",">reference/eval-model.html#(part._thread-model)","Threads",false],
["threads",">reference/threads.html","Threads",false],
["threads",">reference/eval-model.html#(tech._thread)","<i>threads</i>",false],
["threads in embedded scheme with event loops",">inside/threads.html#(part._threadtime)","Threads in Embedded Scheme with Event Loops",false],
["thunk",">preprocessor/mzpp.html#(form._((lib._preprocessor/mzpp..ss)._thunk))",[0,[6,"thunk"]],["preprocessor/mzpp"]],
["time",">reference/time.html","Time",false],
["time",">htdp-langs/time.html",[0,[6,"time"]],false],
["time",">reference/time.html#(form._((lib._scheme/private/more-scheme..ss)._time))",[0,[6,"time"]],["scheme/base","scheme"]],
["time",">htdp-langs/advanced-unchanged.html#(form._((lib._lang/htdp-advanced..ss)._time))",[0,[6,"time"]],["lang/htdp-advanced"]],
["time",">htdp-langs/time.html#(form._((lib._lang/htdp-intermediate..ss)._time))",[0,[6,"time"]],["lang/htdp-intermediate"]],
["time",">htdp-langs/intermediate-lambda-unchanged.html#(form._((lib._lang/htdp-intermediate-lambda..ss)._time))",[0,[6,"time"]],["lang/htdp-intermediate-lambda"]],
["time",">eopl/index.html#(form._((lib._eopl/eopl..ss)._time))",[0,[6,"time"]],["eopl/eopl"]],
["time-apply",">reference/time.html#(def._((quote._~23~25kernel)._time-apply))",[0,[1,"time-apply"]],["scheme/base","scheme"]],
["time-difference",">srfi-std/srfi-19.html#time-difference",[0,[1,"time-difference"]],["srfi/19"]],
["time-difference!",">srfi-std/srfi-19.html#time-difference!",[0,[1,"time-difference!"]],["srfi/19"]],
["time-duration",">srfi-std/srfi-19.html#",[0,[1,"time-duration"]],["srfi/19"]],
["time-evt",">mzlib/mzlib_cml.html#(def._((lib._mzlib/cml..ss)._time-evt))",[0,[1,"time-evt"]],["mzlib/cml"]],
["time-monotonic",">srfi-std/srfi-19.html#time-monotonic",[0,[1,"time-monotonic"]],["srfi/19"]],
["time-monotonic->date",">srfi-std/srfi-19.html#time-monotonic->date",[0,[1,"time-monotonic-&gt;date"]],["srfi/19"]],
["time-monotonic->julian-day",">srfi-std/srfi-19.html#time-monotonic->julian-day",[0,[1,"time-monotonic-&gt;julian-day"]],["srfi/19"]],
["time-monotonic->modified-julian-day",">srfi-std/srfi-19.html#time-monotonic->modified-julian-day",[0,[1,"time-monotonic-&gt;modified-julian-day"]],["srfi/19"]],
["time-monotonic->time-tai",">srfi-std/srfi-19.html#time-monotonic->time-tai",[0,[1,"time-monotonic-&gt;time-tai"]],["srfi/19"]],
["time-monotonic->time-tai!",">srfi-std/srfi-19.html#time-monotonic->time-tai!",[0,[1,"time-monotonic-&gt;time-tai!"]],["srfi/19"]],
["time-monotonic->time-utc",">srfi-std/srfi-19.html#time-monotonic->time-utc",[0,[1,"time-monotonic-&gt;time-utc"]],["srfi/19"]],
["time-monotonic->time-utc!",">srfi-std/srfi-19.html#time-monotonic->time-utc!",[0,[1,"time-monotonic-&gt;time-utc!"]],["srfi/19"]],
["time-nanosecond",">srfi-std/srfi-19.html#time-nanosecond",[0,[1,"time-nanosecond"]],["srfi/19"]],
["time-process",">srfi-std/srfi-19.html#time-process",[0,[1,"time-process"]],["srfi/19"]],
["time-resolution",">srfi-std/srfi-19.html#time-resolution",[0,[1,"time-resolution"]],["srfi/19"]],
["time-second",">srfi-std/srfi-19.html#time-second",[0,[1,"time-second"]],["srfi/19"]],
["time-tai",">srfi-std/srfi-19.html#time-tai",[0,[1,"time-tai"]],["srfi/19"]],
["time-tai->date",">srfi-std/srfi-19.html#time-tai->date",[0,[1,"time-tai-&gt;date"]],["srfi/19"]],
["time-tai->julian-day",">srfi-std/srfi-19.html#time-tai->julian-day",[0,[1,"time-tai-&gt;julian-day"]],["srfi/19"]],
["time-tai->modified-julian-day",">srfi-std/srfi-19.html#time-tai->modified-julian-day",[0,[1,"time-tai-&gt;modified-julian-day"]],["srfi/19"]],
["time-tai->time-monotonic",">srfi-std/srfi-19.html#time-tai->time-monotonic",[0,[1,"time-tai-&gt;time-monotonic"]],["srfi/19"]],
["time-tai->time-monotonic!",">srfi-std/srfi-19.html#time-tai->time-monotonic!",[0,[1,"time-tai-&gt;time-monotonic!"]],["srfi/19"]],
["time-tai->time-utc",">srfi-std/srfi-19.html#time-tai->time-utc",[0,[1,"time-tai-&gt;time-utc"]],["srfi/19"]],
["time-tai->time-utc!",">srfi-std/srfi-19.html#time-tai->time-utc!",[0,[1,"time-tai-&gt;time-utc!"]],["srfi/19"]],
["time-thread",">srfi-std/srfi-19.html#time-thread",[0,[1,"time-thread"]],["srfi/19"]],
["time-type",">srfi-std/srfi-19.html#time-type",[0,[1,"time-type"]],["srfi/19"]],
["time-utc",">srfi-std/srfi-19.html#time-utc",[0,[1,"time-utc"]],["srfi/19"]],
["time-utc->date",">srfi-std/srfi-19.html#time-utc->date",[0,[1,"time-utc-&gt;date"]],["srfi/19"]],
["time-utc->julian-day",">srfi-std/srfi-19.html#time-utc->julian-day",[0,[1,"time-utc-&gt;julian-day"]],["srfi/19"]],
["time-utc->modified-julian-day",">srfi-std/srfi-19.html#time-utc->modified-julian-day",[0,[1,"time-utc-&gt;modified-julian-day"]],["srfi/19"]],
["time-utc->time-monotonic",">srfi-std/srfi-19.html#time-utc->time-monotonic",[0,[1,"time-utc-&gt;time-monotonic"]],["srfi/19"]],
["time-utc->time-monotonic!",">srfi-std/srfi-19.html#time-utc->time-monotonic!",[0,[1,"time-utc-&gt;time-monotonic!"]],["srfi/19"]],
["time-utc->time-tai",">srfi-std/srfi-19.html#time-utc->time-tai",[0,[1,"time-utc-&gt;time-tai"]],["srfi/19"]],
["time-utc->time-tai!",">srfi-std/srfi-19.html#time-utc->time-tai!",[0,[1,"time-utc-&gt;time-tai!"]],["srfi/19"]],
["time<=?",">srfi-std/srfi-19.html#time<=-p",[0,[1,"time&lt;=?"]],["srfi/19"]],
["time<?",">srfi-std/srfi-19.html#time<-p",[0,[1,"time&lt;?"]],["srfi/19"]],
["time=?",">srfi-std/srfi-19.html#time=-p",[0,[1,"time=?"]],["srfi/19"]],
["time>=?",">srfi-std/srfi-19.html#time>=-p",[0,[1,"time&gt;=?"]],["srfi/19"]],
["time>?",">srfi-std/srfi-19.html#time>-p",[0,[1,"time&gt;?"]],["srfi/19"]],
["time?",">srfi-std/srfi-19.html#time-p",[0,[1,"time?"]],["srfi/19"]],
["timeout",">web-server/module-servlets.html#(def._((lib._web-server/scribblings/dummy-servlet..ss)._timeout))",[0,[1,"timeout"]],[]],
["timeouts",">web-server/dispatch-timeout_ss.html","Timeouts",false],
["timeouts",">web-server/timeouts_ss.html","Timeouts",false],
["timeouts",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._timeouts))",[0,[1,"timeouts"]],["web-server/configuration/configuration-table-structs"]],
["timeouts-default-servlet",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._timeouts-default-servlet))",[0,[1,"timeouts-default-servlet"]],["web-server/configuration/configuration-table-structs"]],
["timeouts-file-base",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._timeouts-file-base))",[0,[1,"timeouts-file-base"]],["web-server/configuration/configuration-table-structs"]],
["timeouts-file-per-byte",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._timeouts-file-per-byte))",[0,[1,"timeouts-file-per-byte"]],["web-server/configuration/configuration-table-structs"]],
["timeouts-password",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._timeouts-password))",[0,[1,"timeouts-password"]],["web-server/configuration/configuration-table-structs"]],
["timeouts-servlet-connection",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._timeouts-servlet-connection))",[0,[1,"timeouts-servlet-connection"]],["web-server/configuration/configuration-table-structs"]],
["timeouts?",">web-server/configuration-table-structs_ss.html#(def._((lib._web-server/configuration/configuration-table-structs..ss)._timeouts~3f))",[0,[1,"timeouts?"]],["web-server/configuration/configuration-table-structs"]],
["timer",">web-server/timer_ss.html#(def._((lib._web-server/private/timer..ss)._timer))",[0,[1,"timer"]],["web-server/private/timer"]],
["timer events",">gui/windowing-overview.html#(tech._timer._event)","<i>Timer events</i>",false],
["timer%",">gui/timer_.html",[0,[1,"timer%"]],["scheme/gui/base","scheme/gui"]],
["timer-action",">web-server/timer_ss.html#(def._((lib._web-server/private/timer..ss)._timer-action))",[0,[1,"timer-action"]],["web-server/private/timer"]],
["timer-evt",">web-server/timer_ss.html#(def._((lib._web-server/private/timer..ss)._timer-evt))",[0,[1,"timer-evt"]],["web-server/private/timer"]],
["timer-expire-seconds",">web-server/timer_ss.html#(def._((lib._web-server/private/timer..ss)._timer-expire-seconds))",[0,[1,"timer-expire-seconds"]],["web-server/private/timer"]],
["timer?",">web-server/timer_ss.html#(def._((lib._web-server/private/timer..ss)._timer~3f))",[0,[1,"timer?"]],["web-server/private/timer"]],
["timers",">web-server/timer_ss.html","Timers",false],
["tiny-control-font",">gui/Drawing_Functions.html#(def._((lib._mred/main..ss)._tiny-control-font))",[0,[1,"tiny-control-font"]],["scheme/gui/base","scheme/gui"]],
["title",">html/index.html#(def._((lib._html/main..ss)._title))",[0,[1,"title"]],["html"]],
["title",">mysterx/documents.html#(meth._(((lib._mysterx/main..ss)._mx-document~3c~25~3e)._title))",[[0,[1,"title"]],[12,[" (method of ",[0,[1,"mx-document&lt;%&gt;"]],")"]]],["mysterx"]],
["title",">scribble/basic.html#(def._((lib._scribble/basic..ss)._title))",[0,[1,"title"]],["scribble/basic"]],
["title-case",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..ss)._title-case))",[0,[6,"title-case"]],["parser-tools/lex"]],
["title-decl",">scribble/decode.html#(def._((lib._scribble/decode..ss)._title-decl))",[0,[1,"title-decl"]],["scribble/decode"]],
["title-decl-content",">scribble/decode.html#(def._((lib._scribble/decode..ss)._title-decl-content))",[0,[1,"title-decl-content"]],["scribble/decode"]],
["title-decl-style",">scribble/decode.html#(def._((lib._scribble/decode..ss)._title-decl-style))",[0,[1,"title-decl-style"]],["scribble/decode"]],
["title-decl-tag-prefix",">scribble/decode.html#(def._((lib._scribble/decode..ss)._title-decl-tag-prefix))",[0,[1,"title-decl-tag-prefix"]],["scribble/decode"]],
["title-decl-tags",">scribble/decode.html#(def._((lib._scribble/decode..ss)._title-decl-tags))",[0,[1,"title-decl-tags"]],["scribble/decode"]],
["title-decl-version",">scribble/decode.html#(def._((lib._scribble/decode..ss)._title-decl-version))",[0,[1,"title-decl-version"]],["scribble/decode"]],
["title-decl?",">scribble/decode.html#(def._((lib._scribble/decode..ss)._title-decl~3f))",[0,[1,"title-decl?"]],["scribble/decode"]],
["title-h",">slideshow/Constants_and_Layout_Variables.html#(form._((lib._slideshow/base..ss)._title-h))",[0,[6,"title-h"]],["slideshow/base","slideshow"]],
["title?",">html/index.html#(def._((lib._html/main..ss)._title~3f))",[0,[1,"title?"]],["html"]],
["titleless-page",">slideshow/Constants_and_Layout_Variables.html#(form._((lib._slideshow/base..ss)._titleless-page))",[0,[6,"titleless-page"]],["slideshow/base","slideshow"]],
["titlet",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..ss)._titlet))",[0,[1,"titlet"]],["slideshow/base","slideshow"]],
["tmp",">reference/Filesystem.html#(idx._(gentag._248._(lib._scribblings/reference/reference..scrbl)))",[5,"TMP"],false],
["tmpdir",">reference/Filesystem.html#(idx._(gentag._247._(lib._scribblings/reference/reference..scrbl)))",[5,"TMPDIR"],false],
["to-id",">mysterx/html-events.html#(meth._(((lib._mysterx/main..ss)._mx-event~3c~25~3e)._to-id))",[[0,[1,"to-id"]],[12,[" (method of ",[0,[1,"mx-event&lt;%&gt;"]],")"]]],["mysterx"]],
["to-lw",">redex/Typesetting.html#(form._((lib._redex/pict..ss)._to-lw))",[0,[6,"to-lw"]],["redex/pict"]],
["to-tag",">mysterx/html-events.html#(meth._(((lib._mysterx/main..ss)._mx-event~3c~25~3e)._to-tag))",[[0,[1,"to-tag"]],[12,[" (method of ",[0,[1,"mx-event&lt;%&gt;"]],")"]]],["mysterx"]],
["toc-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._toc-element))",[0,[1,"toc-element"]],["scribble/struct"]],
["toc-element-toc-content",">scribble/struct.html#(def._((lib._scribble/struct..ss)._toc-element-toc-content))",[0,[1,"toc-element-toc-content"]],["scribble/struct"]],
["toc-element?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._toc-element~3f))",[0,[1,"toc-element?"]],["scribble/struct"]],
["toc-target-element",">scribble/struct.html#(def._((lib._scribble/struct..ss)._toc-target-element))",[0,[1,"toc-target-element"]],["scribble/struct"]],
["toc-target-element?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._toc-target-element~3f))",[0,[1,"toc-target-element?"]],["scribble/struct"]],
["toggle-anchor",">framework/Keymap.html#(idx._(gentag._15._(lib._scribblings/framework/framework..scrbl)))","toggle-anchor",false],
["toggle-button-snip%",">embedded-gui/toggle-button-snip_.html",[0,[1,"toggle-button-snip%"]],["embedded-gui"]],
["toggle-open/closed",">mrlib/hierarchical-list-compound-item___.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list-compound-item~3c~25~3e)._toggle-open/closed))",[[0,[1,"toggle-open/closed"]],[12,[" (method of ",[0,[1,"hierarchical-list-compound-item&lt;%&gt;"]],")"]]],["mrlib/hierlist"]],
["toggle-overwrite",">framework/Keymap.html#(idx._(gentag._41._(lib._scribblings/framework/framework..scrbl)))","toggle-overwrite",false],
["token",">parser-tools/Lexers.html#(tech._token)","<i>token</i>",false],
["token-name",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..ss)._token-name))",[0,[1,"token-name"]],["parser-tools/lex"]],
["token-tree%",">syntax-color/index.html#(def._((lib._syntax-color/token-tree..ss)._token-tree~25))",[0,[1,"token-tree%"]],["syntax-color/token-tree"]],
["token-value",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..ss)._token-value))",[0,[1,"token-value"]],["parser-tools/lex"]],
["token?",">parser-tools/Lexers.html#(def._((lib._parser-tools/lex..ss)._token~3f))",[0,[1,"token?"]],["parser-tools/lex"]],
["tokens",">parser-tools/Lexers.html#(part._.Tokens)","Tokens",false],
["tool",">drscheme/extending-drscheme.html#(tech._tool)","<i>tool</i>",false],
["tool web sites menu item",">drscheme/Menus.html#(idx._(gentag._148._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Tool Web Sites</font></b> menu item",false],
["tool@",">browser/index.html#(def._((lib._browser/tool..ss)._tool~40))",[0,[1,"tool@"]],["browser/tool"]],
["toolbar-button",">gui/frame_.html#(idx._(gentag._45._(lib._scribblings/gui/gui..scrbl)))",[7,"'toolbar-button"],false],
["top",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._top))",[[0,[1,"top"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["top",">gui/style-delta_.html#(idx._(gentag._260._(lib._scribblings/gui/gui..scrbl)))",[7,"'top"],false],
["top-level binding",">reference/syntax-model.html#(tech._top._level._binding)","<i>top-level binding</i>",false],
["top-level context",">reference/syntax-model.html#(tech._top._level._context)","<i>top-level context</i>",false],
["top-level evaluation functions",">inside/Evaluation.html#(part._topleveleval)","Top-level Evaluation Functions",false],
["top-level variable",">reference/eval-model.html#(tech._top._level._variable)","<i>top-level variable</i>",false],
["top-level variables",">reference/eval-model.html#(part._.Top-.Level_.Variables)","Top-Level Variables",false],
["top-level-window<%>",">gui/top-level-window___.html",[0,[1,"top-level-window&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["top-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._top-native))",[[0,[1,"top-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["tprompt",">turtles/Traditional_Turtles.html#(form._((lib._graphics/turtles..ss)._tprompt))",[0,[6,"tprompt"]],["graphics/turtles"]],
["tr",">html/index.html#(def._((lib._html/main..ss)._tr))",[0,[1,"tr"]],["html"]],
["tr?",">html/index.html#(def._((lib._html/main..ss)._tr~3f))",[0,[1,"tr?"]],["html"]],
["trace",">trace/index.html#(mod-path._trace)",[14,[0,"trace"]],"module"],
["trace",">eopl/index.html#(form._((lib._eopl/eopl..ss)._trace))",[0,[6,"trace"]],["eopl/eopl"]],
["trace",">mzlib/mzlib_trace.html#(form._((lib._mzlib/trace..ss)._trace))",[0,[6,"trace"]],["mzlib/trace"]],
["trace/calltrace-lib",">trace/index.html#(mod-path._trace/calltrace-lib)",[14,[0,"trace/calltrace-lib"]],"module"],
["trace: instrumentation to show function calls",">trace/index.html","<b>Trace</b>: Instrumentation to Show Function Calls",false],
["traces",">redex/GUI.html#(def._((lib._redex/gui..ss)._traces))",[0,[1,"traces"]],["redex/gui"]],
["traditional turtles",">turtles/Traditional_Turtles.html","Traditional Turtles",false],
["trait",">reference/trait.html#(form._((lib._scheme/trait..ss)._trait))",[0,[6,"trait"]],["scheme/trait"]],
["trait",">reference/trait.html#(tech._trait)","<i>trait</i>",false],
["trait->mixin",">reference/trait.html#(def._((lib._scheme/trait..ss)._trait-~3emixin))",[0,[1,"trait-&gt;mixin"]],["scheme/trait"]],
["trait-alias",">reference/trait.html#(form._((lib._scheme/trait..ss)._trait-alias))",[0,[6,"trait-alias"]],["scheme/trait"]],
["trait-exclude",">reference/trait.html#(form._((lib._scheme/trait..ss)._trait-exclude))",[0,[6,"trait-exclude"]],["scheme/trait"]],
["trait-exclude-field",">reference/trait.html#(form._((lib._scheme/trait..ss)._trait-exclude-field))",[0,[6,"trait-exclude-field"]],["scheme/trait"]],
["trait-rename",">reference/trait.html#(form._((lib._scheme/trait..ss)._trait-rename))",[0,[6,"trait-rename"]],["scheme/trait"]],
["trait-rename-field",">reference/trait.html#(form._((lib._scheme/trait..ss)._trait-rename-field))",[0,[6,"trait-rename-field"]],["scheme/trait"]],
["trait-sum",">reference/trait.html#(def._((lib._scheme/trait..ss)._trait-sum))",[0,[1,"trait-sum"]],["scheme/trait"]],
["trait?",">reference/trait.html#(def._((lib._scheme/trait..ss)._trait~3f))",[0,[1,"trait?"]],["scheme/trait"]],
["traits",">guide/classes.html#(part._.Traits)","Traits",false],
["traits",">reference/trait.html","Traits",false],
["traits as sets of mixins",">guide/classes.html#(part._.Traits_as_.Sets_of_.Mixins)","Traits as Sets of Mixins",false],
["trans",">parser-tools/Converting_yacc_or_bison_Grammars.html#(def._((lib._parser-tools/yacc-to-scheme..ss)._trans))",[0,"trans"],["parser-tools/yacc-to-scheme"]],
["transcoded-port",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_650",[0,[1,"transcoded-port"]],["rnrs/io/ports-6"]],
["transcoder-codec",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_624",[0,[1,"transcoder-codec"]],["rnrs/io/ports-6"]],
["transcoder-eol-style",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_626",[0,[1,"transcoder-eol-style"]],["rnrs/io/ports-6"]],
["transcoder-error-handling-mode",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_628",[0,[1,"transcoder-error-handling-mode"]],["rnrs/io/ports-6"]],
["transcript-off",">r5rs-std/r5rs-Z-H-9.html#%_idx_672",[0,[1,"transcript-off"]],["r5rs"]],
["transcript-off",">mzlib/mzlib_transcr.html#(def._((lib._mzlib/transcr..ss)._transcript-off))",[0,[1,"transcript-off"]],["mzlib/transcr"]],
["transcript-off",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..ss)._transcript-off))",[0,[1,"transcript-off"]],["mzscheme"]],
["transcript-on",">r5rs-std/r5rs-Z-H-9.html#%_idx_670",[0,[1,"transcript-on"]],["r5rs"]],
["transcript-on",">mzlib/mzlib_transcr.html#(def._((lib._mzlib/transcr..ss)._transcript-on))",[0,[1,"transcript-on"]],["mzlib/transcr"]],
["transcript-on",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..ss)._transcript-on))",[0,[1,"transcript-on"]],["mzscheme"]],
["transformer",">guide/macros.html#(tech._transformer)","<i>transformer</i>",false],
["transformer binding",">guide/proc-macros.html#(tech._transformer._binding)","<i>transformer\nbinding</i>",false],
["transformer binding",">reference/syntax-model.html#(tech._transformer._binding)","<i>transformer\nbinding</i>",false],
["transformer bindings",">reference/syntax-model.html#(part._transformer-model)","Transformer Bindings",false],
["transformer environment",">reference/syntax-model.html#(tech._transformer._environment)","<i>transformer environment</i>",false],
["transformer helpers",">reference/Transformer_Helpers.html","Transformer Helpers",false],
["translate",">gui/dc-path_.html#(meth._(((lib._mred/main..ss)._dc-path~25)._translate))",[[0,[1,"translate"]],[12,[" (method of ",[0,[1,"dc-path%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["transparent",">gui/brush_.html#(idx._(gentag._176._(lib._scribblings/gui/gui..scrbl)))",[7,"'transparent"],false],
["transparent",">gui/pen_.html#(idx._(gentag._216._(lib._scribblings/gui/gui..scrbl)))",[7,"'transparent"],false],
["transparent",">gui/canvas___.html#(idx._(gentag._29._(lib._scribblings/gui/gui..scrbl)))",[7,"'transparent"],false],
["transparent",">gui/canvas___.html#(idx._(gentag._30._(lib._scribblings/gui/gui..scrbl)))",[7,"'transparent"],false],
["transparent",">reference/stxcerts.html#(idx._(gentag._90._(lib._scribblings/reference/reference..scrbl)))",[7,"'transparent"],false],
["transparent",">guide/define-struct.html#(tech._transparent)","<i>transparent</i>",false],
["transparent-binding",">reference/stxcerts.html#(idx._(gentag._91._(lib._scribblings/reference/reference..scrbl)))",[7,"'transparent-binding"],false],
["transplant-input-port",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._transplant-input-port))",[0,[1,"transplant-input-port"]],["scheme/port"]],
["transplant-output-port",">reference/More_Port_Constructors_and_Events.html#(def._((lib._scheme/port..ss)._transplant-output-port))",[0,[1,"transplant-output-port"]],["scheme/port"]],
["transpose-chars",">framework/Keymap.html#(idx._(gentag._21._(lib._scribblings/framework/framework..scrbl)))","transpose-chars",false],
["transpose-sexp",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._transpose-sexp))",[[0,[1,"transpose-sexp"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["transpose-words",">framework/Keymap.html#(idx._(gentag._22._(lib._scribblings/framework/framework..scrbl)))","transpose-words",false],
["triangle",">teachpack/image.html#(def._((lib._htdp/image..ss)._triangle))",[0,[1,"triangle"]],["teachpack/htdp/image"]],
["trignometric functions",">reference/numbers.html#(part._.Trignometric_.Functions)","Trignometric Functions",false],
["troubleshooting",">web-server/Troubleshooting.html","Troubleshooting",false],
["true",">reference/booleans.html#(def._((lib._scheme/bool..ss)._true))",[0,[1,"true"]],["scheme/bool","scheme"]],
["true",">htdp-langs/advanced-unchanged.html#(def._((lib._lang/htdp-advanced..ss)._true))",[0,[1,"true"]],["lang/htdp-advanced"]],
["true",">htdp-langs/true_and_false.html#(def._((lib._lang/htdp-beginner..ss)._true))",[0,[1,"true"]],["lang/htdp-beginner"]],
["true",">htdp-langs/Unchanged_Forms.html#(def._((lib._lang/htdp-beginner-abbr..ss)._true))",[0,[1,"true"]],["lang/htdp-beginner-abbr"]],
["true",">htdp-langs/intermediate-unchanged.html#(def._((lib._lang/htdp-intermediate..ss)._true))",[0,[1,"true"]],["lang/htdp-intermediate"]],
["true",">htdp-langs/intermediate-lambda-unchanged.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._true))",[0,[1,"true"]],["lang/htdp-intermediate-lambda"]],
["true",">lazy/index.html#(def._((lib._lazy/main..ss)._true))",[0,[1,"true"]],["lazy"]],
["true and false",">htdp-langs/true_and_false.html",[[0,[1,"true"]]," and ",[0,[1,"false"]]],false],
["truncate",">reference/numbers.html#(def._((quote._~23~25kernel)._truncate))",[0,[1,"truncate"]],["scheme/base","scheme"]],
["truncate",">r5rs-std/r5rs-Z-H-9.html#%_idx_318",[0,[1,"truncate"]],["r5rs"]],
["truncate",">r6rs-std/r6rs-Z-H-14.html#node_idx_532",[0,[1,"truncate"]],["rnrs/base-6"]],
["truncate",">reference/file-ports.html#(idx._(gentag._109._(lib._scribblings/reference/reference..scrbl)))",[7,"'truncate"],false],
["truncate-file",">mzlib/mzlib_os.html#(def._((lib._mzlib/os..ss)._truncate-file))",[0,[1,"truncate-file"]],["mzlib/os"]],
["truncate/replace",">reference/file-ports.html#(idx._(gentag._111._(lib._scribblings/reference/reference..scrbl)))",[7,"'truncate/replace"],false],
["trust-existing-zos",">mzc/make.html#(def._((lib._compiler/cm..ss)._trust-existing-zos))",[0,[1,"trust-existing-zos"]],["compiler/cm"]],
["trusting standard recertifying transformers",">syntax/trusted-xforms.html","Trusting Standard Recertifying Transformers",false],
["try-color",">gui/dc___.html#(meth._(((lib._mred/main..ss)._dc~3c~25~3e)._try-color))",[[0,[1,"try-color"]],[12,[" (method of ",[0,[1,"dc&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["tt",">html/index.html#(def._((lib._html/main..ss)._tt))",[0,[1,"tt"]],["html"]],
["tt",">scribble/basic.html#(def._((lib._scribble/basic..ss)._tt))",[0,[1,"tt"]],["scribble/basic"]],
["tt",">slideshow/Primary_Slide_Functions.html#(def._((lib._slideshow/base..ss)._tt))",[0,[1,"tt"]],["slideshow/base","slideshow"]],
["tt?",">html/index.html#(def._((lib._html/main..ss)._tt~3f))",[0,[1,"tt?"]],["html"]],
["turn",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtles..ss)._turn))",[0,[1,"turn"]],["graphics/turtles"]],
["turn",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles..ss)._turn))",[0,[1,"turn"]],["graphics/value-turtles"]],
["turn/radians",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtles..ss)._turn/radians))",[0,[1,"turn/radians"]],["graphics/turtles"]],
["turn/radians",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles..ss)._turn/radians))",[0,[1,"turn/radians"]],["graphics/value-turtles"]],
["turtle graphics",">turtles/index.html","<b>Turtle Graphics</b>",false],
["turtles",">turtles/Traditional_Turtles.html#(def._((lib._graphics/turtles..ss)._turtles))",[0,[1,"turtles"]],["graphics/turtles"]],
["turtles",">turtles/Value_Turtles.html#(def._((lib._graphics/value-turtles..ss)._turtles))",[0,[1,"turtles"]],["graphics/value-turtles"]],
["type aliases",">typed-scheme/index.html#(part._.Type_.Aliases)","Type Aliases",false],
["type annotation and instantiation",">typed-scheme/index.html#(part._.Type_.Annotation_and_.Instantiation)","Type Annotation and Instantiation",false],
["type constructors",">foreign/Type_Constructors.html","Type Constructors",false],
["type reference",">typed-scheme/index.html#(part._type-ref)","Type Reference",false],
["typed scheme: scheme with static types",">typed-scheme/index.html","<b>Typed Scheme</b>: Scheme with Static Types",false],
["typed-scheme",">typed-scheme/index.html",[14,[0,"typed-scheme"]],"module"],
["types creating",">inside/im_values_types.html#(idx._(gentag._29._(lib._scribblings/inside/inside..scrbl)))","types, creating",false],
["typeset-code",">slideshow/Typesetting_Scheme_Code.html#(def._((lib._slideshow/code..ss)._typeset-code))",[0,[1,"typeset-code"]],["slideshow/code"]],
["typesetting",">redex/Typesetting.html","Typesetting",false],
["typesetting code",">scribble/How_to_Scribble_Documentation.html#(part._.Typesetting_.Code)","Typesetting Code",false],
["typesetting code",">scribble/scribble_manual_code.html","Typesetting Code",false],
["typesetting prose",">scribble/How_to_Scribble_Documentation.html#(part._.Typesetting_.Prose)","Typesetting Prose",false],
["typesetting scheme code",">slideshow/Typesetting_Scheme_Code.html","Typesetting Scheme Code",false],
["typical composition",">scribble/layers.html#(part._.Typical_.Composition)","Typical Composition",false],
["u",">html/index.html#(def._((lib._html/main..ss)._u))",[0,[1,"u"]],["html"]],
["u",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._.U))",[0,[6,"U"]],["typed-scheme"]],
["u16vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._u16vector))",[0,[1,"u16vector"]],["scheme/foreign"]],
["u16vector",">srfi-std/srfi-4.html#u8vector",[0,[1,"u16vector"]],["srfi/4"]],
["u16vector->list",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._u16vector-~3elist))",[0,[1,"u16vector-&gt;list"]],["scheme/foreign"]],
["u16vector-length",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._u16vector-length))",[0,[1,"u16vector-length"]],["scheme/foreign"]],
["u16vector-ref",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._u16vector-ref))",[0,[1,"u16vector-ref"]],["scheme/foreign"]],
["u16vector-set!",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._u16vector-set!))",[0,[1,"u16vector-set!"]],["scheme/foreign"]],
["u16vector?",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._u16vector~3f))",[0,[1,"u16vector?"]],["scheme/foreign"]],
["u32vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._u32vector))",[0,[1,"u32vector"]],["scheme/foreign"]],
["u32vector",">srfi-std/srfi-4.html#u16vector",[0,[1,"u32vector"]],["srfi/4"]],
["u32vector->list",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._u32vector-~3elist))",[0,[1,"u32vector-&gt;list"]],["scheme/foreign"]],
["u32vector-length",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._u32vector-length))",[0,[1,"u32vector-length"]],["scheme/foreign"]],
["u32vector-ref",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._u32vector-ref))",[0,[1,"u32vector-ref"]],["scheme/foreign"]],
["u32vector-set!",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._u32vector-set!))",[0,[1,"u32vector-set!"]],["scheme/foreign"]],
["u32vector?",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._u32vector~3f))",[0,[1,"u32vector?"]],["scheme/foreign"]],
["u64vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._u64vector))",[0,[1,"u64vector"]],["scheme/foreign"]],
["u64vector",">srfi-std/srfi-4.html#u64vector",[0,[1,"u64vector"]],["srfi/4"]],
["u64vector->list",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._u64vector-~3elist))",[0,[1,"u64vector-&gt;list"]],["scheme/foreign"]],
["u64vector-length",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._u64vector-length))",[0,[1,"u64vector-length"]],["scheme/foreign"]],
["u64vector-ref",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._u64vector-ref))",[0,[1,"u64vector-ref"]],["scheme/foreign"]],
["u64vector-set!",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._u64vector-set!))",[0,[1,"u64vector-set!"]],["scheme/foreign"]],
["u64vector?",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._u64vector~3f))",[0,[1,"u64vector?"]],["scheme/foreign"]],
["u8-list->bytevector",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_106",[0,[1,"u8-list-&gt;bytevector"]],["rnrs/bytevectors-6"]],
["u8vector",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._u8vector))",[0,[1,"u8vector"]],["scheme/foreign"]],
["u8vector",">srfi-std/srfi-4.html#s8vector",[0,[1,"u8vector"]],["srfi/4"]],
["u8vector->list",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._u8vector-~3elist))",[0,[1,"u8vector-&gt;list"]],["scheme/foreign"]],
["u8vector-length",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._u8vector-length))",[0,[1,"u8vector-length"]],["scheme/foreign"]],
["u8vector-ref",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._u8vector-ref))",[0,[1,"u8vector-ref"]],["scheme/foreign"]],
["u8vector-set!",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._u8vector-set!))",[0,[1,"u8vector-set!"]],["scheme/foreign"]],
["u8vector?",">foreign/Derived_Utilities.html#(def._((lib._scheme/foreign..ss)._u8vector~3f))",[0,[1,"u8vector?"]],["scheme/foreign"]],
["u?",">html/index.html#(def._((lib._html/main..ss)._u~3f))",[0,[1,"u?"]],["html"]],
["ucs-range->char-set",">srfi-std/srfi-14.html#ucs-range->char-set",[0,[1,"ucs-range-&gt;char-set"]],["srfi/14"]],
["ucs-range->char-set!",">srfi-std/srfi-14.html#ucs-range->char-set!",[0,[1,"ucs-range-&gt;char-set!"]],["srfi/14"]],
["udp",">reference/udp.html","UDP",false],
["udp-bind!",">reference/udp.html#(def._((lib._scheme/udp..ss)._udp-bind!))",[0,[1,"udp-bind!"]],["scheme/udp","scheme"]],
["udp-bound?",">reference/udp.html#(def._((lib._scheme/udp..ss)._udp-bound~3f))",[0,[1,"udp-bound?"]],["scheme/udp","scheme"]],
["udp-close",">reference/udp.html#(def._((lib._scheme/udp..ss)._udp-close))",[0,[1,"udp-close"]],["scheme/udp","scheme"]],
["udp-connect!",">reference/udp.html#(def._((lib._scheme/udp..ss)._udp-connect!))",[0,[1,"udp-connect!"]],["scheme/udp","scheme"]],
["udp-connected?",">reference/udp.html#(def._((lib._scheme/udp..ss)._udp-connected~3f))",[0,[1,"udp-connected?"]],["scheme/udp","scheme"]],
["udp-open-socket",">reference/udp.html#(def._((lib._scheme/udp..ss)._udp-open-socket))",[0,[1,"udp-open-socket"]],["scheme/udp","scheme"]],
["udp-receive!",">reference/udp.html#(def._((lib._scheme/udp..ss)._udp-receive!))",[0,[1,"udp-receive!"]],["scheme/udp","scheme"]],
["udp-receive!*",">reference/udp.html#(def._((lib._scheme/udp..ss)._udp-receive!*))",[0,[1,"udp-receive!*"]],["scheme/udp","scheme"]],
["udp-receive!-evt",">reference/udp.html#(def._((lib._scheme/udp..ss)._udp-receive!-evt))",[0,[1,"udp-receive!-evt"]],["scheme/udp","scheme"]],
["udp-receive!/enable-break",">reference/udp.html#(def._((lib._scheme/udp..ss)._udp-receive!/enable-break))",[0,[1,"udp-receive!/enable-break"]],["scheme/udp","scheme"]],
["udp-receive-ready-evt",">reference/udp.html#(def._((lib._scheme/udp..ss)._udp-receive-ready-evt))",[0,[1,"udp-receive-ready-evt"]],["scheme/udp","scheme"]],
["udp-send",">reference/udp.html#(def._((lib._scheme/udp..ss)._udp-send))",[0,[1,"udp-send"]],["scheme/udp","scheme"]],
["udp-send*",">reference/udp.html#(def._((lib._scheme/udp..ss)._udp-send*))",[0,[1,"udp-send*"]],["scheme/udp","scheme"]],
["udp-send-evt",">reference/udp.html#(def._((lib._scheme/udp..ss)._udp-send-evt))",[0,[1,"udp-send-evt"]],["scheme/udp","scheme"]],
["udp-send-ready-evt",">reference/udp.html#(def._((lib._scheme/udp..ss)._udp-send-ready-evt))",[0,[1,"udp-send-ready-evt"]],["scheme/udp","scheme"]],
["udp-send-to",">reference/udp.html#(def._((lib._scheme/udp..ss)._udp-send-to))",[0,[1,"udp-send-to"]],["scheme/udp","scheme"]],
["udp-send-to*",">reference/udp.html#(def._((lib._scheme/udp..ss)._udp-send-to*))",[0,[1,"udp-send-to*"]],["scheme/udp","scheme"]],
["udp-send-to-evt",">reference/udp.html#(def._((lib._scheme/udp..ss)._udp-send-to-evt))",[0,[1,"udp-send-to-evt"]],["scheme/udp","scheme"]],
["udp-send-to/enable-break",">reference/udp.html#(def._((lib._scheme/udp..ss)._udp-send-to/enable-break))",[0,[1,"udp-send-to/enable-break"]],["scheme/udp","scheme"]],
["udp-send/enable-break",">reference/udp.html#(def._((lib._scheme/udp..ss)._udp-send/enable-break))",[0,[1,"udp-send/enable-break"]],["scheme/udp","scheme"]],
["udp?",">reference/udp.html#(def._((lib._scheme/udp..ss)._udp~3f))",[0,[1,"udp?"]],["scheme/udp","scheme"]],
["uint-list->bytevector",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_120",[0,[1,"uint-list-&gt;bytevector"]],["rnrs/bytevectors-6"]],
["ul",">html/index.html#(def._((lib._html/main..ss)._ul))",[0,[1,"ul"]],["html"]],
["ul?",">html/index.html#(def._((lib._html/main..ss)._ul~3f))",[0,[1,"ul?"]],["html"]],
["unbox",">reference/boxes.html#(def._((quote._~23~25kernel)._unbox))",[0,[1,"unbox"]],["scheme/base","scheme"]],
["unbox",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._unbox))",[0,[1,"unbox"]],["lang/htdp-advanced"]],
["uncaught-exception-handler",">reference/exns.html#(def._((quote._~23~25kernel)._uncaught-exception-handler))",[0,[1,"uncaught-exception-handler"]],["scheme/base","scheme"]],
["unchanged forms",">htdp-langs/Unchanged_Forms.html","Unchanged Forms",false],
["unchanged forms",">htdp-langs/advanced-unchanged.html","Unchanged Forms",false],
["unchanged forms",">htdp-langs/intermediate-lambda-unchanged.html","Unchanged Forms",false],
["unchanged forms",">htdp-langs/intermediate-unchanged.html","Unchanged Forms",false],
["uncollectable",">foreign/foreign_pointer-funcs.html#(idx._(gentag._7._(lib._scribblings/foreign/foreign..scrbl)))",[7,"'uncollectable"],false],
["uncomment menu item",">drscheme/Menus.html#(idx._(gentag._129._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Uncomment</font></b> menu item",false],
["uncomment-selection",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._uncomment-selection))",[[0,[1,"uncomment-selection"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["unconstrained-domain->",">reference/Function_Contracts.html#(form._((lib._scheme/contract..ss)._unconstrained-domain-~3e))",[0,[6,"unconstrained-domain-&gt;"]],["scheme/contract","scheme"]],
["undefined",">frtime/index.html#(def._((lib._frtime/main..ss)._undefined))",[0,[1,"undefined"]],["frtime"]],
["undefined-const",">scribble/Miscellaneous.html#(def._((lib._scribble/manual..ss)._undefined-const))",[0,[1,"undefined-const"]],["scribble/manual"]],
["undefined-violation?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_492",[0,[1,"undefined-violation?"]],["rnrs/conditions-6"]],
["undefined?",">frtime/index.html#(def._((lib._frtime/main..ss)._undefined~3f))",[0,[1,"undefined?"]],["frtime"]],
["understanding a door",">teachpack/world.html#(part._.Understanding_a_.Door)","Understanding a Door",false],
["undo",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._undo))",[[0,[1,"undo"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["undo menu item",">drscheme/Menus.html#(idx._(gentag._76._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Undo</font></b> menu item",false],
["undock test report menu item",">drscheme/Menus.html#(idx._(gentag._110._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Undock Test Report</font></b> menu item",false],
["unexpected-response",">net/nntp.html#(def._((lib._net/nntp..ss)._unexpected-response))",[0,[1,"unexpected-response"]],["net/nntp"]],
["unexpected-response-code",">net/nntp.html#(def._((lib._net/nntp..ss)._unexpected-response-code))",[0,[1,"unexpected-response-code"]],["net/nntp"]],
["unexpected-response-text",">net/nntp.html#(def._((lib._net/nntp..ss)._unexpected-response-text))",[0,[1,"unexpected-response-text"]],["net/nntp"]],
["unexpected-response?",">net/nntp.html#(def._((lib._net/nntp..ss)._unexpected-response~3f))",[0,[1,"unexpected-response?"]],["net/nntp"]],
["unexpected-termination",">net/mime.html#(def._((lib._net/mime..ss)._unexpected-termination))",[0,[1,"unexpected-termination"]],["net/mime"]],
["unexpected-termination-msg",">net/mime.html#(def._((lib._net/mime..ss)._unexpected-termination-msg))",[0,[1,"unexpected-termination-msg"]],["net/mime"]],
["unexpected-termination?",">net/mime.html#(def._((lib._net/mime..ss)._unexpected-termination~3f))",[0,[1,"unexpected-termination?"]],["net/mime"]],
["unexported primitive functions",">foreign/foreign_c-only.html","Unexported Primitive Functions",false],
["unfold",">srfi-std/srfi-1.html#unfold",[0,[1,"unfold"]],["srfi/1"]],
["unhide-search",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3asearchable~3c~25~3e)._unhide-search))",[[0,[1,"unhide-search"]],[12,[" (method of ",[0,[1,"frame:searchable&lt;%&gt;"]],")"]]],["framework"]],
["unhighlight-range",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3abasic~3c~25~3e)._unhighlight-range))",[[0,[1,"unhighlight-range"]],[12,[" (method of ",[0,[1,"text:basic&lt;%&gt;"]],")"]]],["framework"]],
["unhighlight-range",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3adelegate-mixin)._unhighlight-range))",[[0,[1,"unhighlight-range"]],[12,[" (method of ",[0,[1,"text:delegate-mixin"]],")"]]],["framework"]],
["unhilite-region",">cards/index.html#(meth._(((lib._games/cards..ss)._table~3c~25~3e)._unhilite-region))",[[0,[1,"unhilite-region"]],[12,[" (method of ",[0,[1,"table&lt;%&gt;"]],")"]]],["games/cards"]],
["unicns-utf32-h",">gui/fontresources.html#(idx._(gentag._314._(lib._scribblings/gui/gui..scrbl)))",[5,"\"UniCNS-UTF32-H\""],false],
["uniform type identifier",">mzc/exe.html#(idx._(gentag._22._(lib._scribblings/mzc/mzc..scrbl)))","Uniform Type\nIdentifier",false],
["uniform variable-arity functions",">typed-scheme/index.html#(part._.Uniform_.Variable-.Arity_.Functions)","Uniform Variable-Arity Functions",false],
["uninstalled-package-cache",">planet/Utility_Libraries.html#(def._((lib._planet/config..ss)._.U.N.I.N.S.T.A.L.L.E.D-.P.A.C.K.A.G.E-.C.A.C.H.E))",[0,[1,"UNINSTALLED-PACKAGE-CACHE"]],["planet/config"]],
["uninterned",">reference/symbols.html#(tech._uninterned)","<i>uninterned</i>",false],
["union",">gui/region_.html#(meth._(((lib._mred/main..ss)._region~25)._union))",[[0,[1,"union"]],[12,[" (method of ",[0,[1,"region%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["union",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..ss)._union))",[0,[1,"union"]],["mzlib/integer-set"]],
["union-reduction-relations",">redex/Reduction_Relations.html#(def._((lib._redex/main..ss)._union-reduction-relations))",[0,[1,"union-reduction-relations"]],["redex"]],
["unit",">dynext/Compilation.html#(part._compile-unit)","Unit",false],
["unit",">dynext/Filenames.html#(part._file-unit)","Unit",false],
["unit",">dynext/Linking.html#(part._link-unit)","Unit",false],
["unit",">make/collection.html#(part._.Unit)","Unit",false],
["unit",">make/make.html#(part._make-unit)","Unit",false],
["unit",">web-server/web-server-unit_ss.html#(part._.Unit)","Unit",false],
["unit",">reference/creatingunits.html#(form._((lib._mzlib/unit..ss)._unit))",[0,[6,"unit"]],["scheme/unit","scheme"]],
["unit utilities",">reference/Unit_Utilities.html","Unit Utilities",false],
["unit versus module",">guide/unit_versus_module.html",[[0,[6,"unit"]]," versus ",[0,[6,"module"]]],false],
["unit with posn",">graphics/Graphics_Library_as_a_Unit.html#(part._.Unit_with_posn)",["Unit with ",[0,[1,"posn"]]],false],
["unit without posn",">graphics/Graphics_Library_as_a_Unit.html#(part._.Unit_without_posn)",["Unit without ",[0,[1,"posn"]]],false],
["unit-from-context",">reference/Generating_A_Unit_from_Context.html#(form._((lib._mzlib/unit..ss)._unit-from-context))",[0,[6,"unit-from-context"]],["scheme/unit","scheme"]],
["unit-static-signatures",">reference/Transformer_Helpers.html#(def._((lib._mzlib/unit-exptime..ss)._unit-static-signatures))",[0,[1,"unit-static-signatures"]],["scheme/unit-exptime"]],
["unit/new-import-export",">reference/Structural_Matching.html#(form._((lib._mzlib/unit..ss)._unit/new-import-export))",[0,[6,"unit/new-import-export"]],["scheme/unit","scheme"]],
["unit?",">reference/Unit_Utilities.html#(def._((lib._mzlib/unit..ss)._unit~3f))",[0,[1,"unit?"]],["scheme/unit","scheme"]],
["units",">reference/mzlib_unit.html","Units",false],
["units",">guide/units.html#(tech._unit)","<i>Units</i>",false],
["units",">reference/mzlib_unit.html#(tech._unit)","<i>Units</i>",false],
["units (components)",">guide/units.html","Units (Components)",false],
["unix",">reference/Manipulating_Paths.html#(idx._(gentag._210._(lib._scribblings/reference/reference..scrbl)))",[7,"'unix"],false],
["unix",">reference/runtime.html#(idx._(gentag._296._(lib._scribblings/reference/reference..scrbl)))",[7,"'unix"],false],
["unix and mac os x paths",">reference/unixpaths.html","Unix and Mac OS X Paths",false],
["unix scripts",">guide/scripts.html","Unix Scripts",false],
["unix-browser-list",">net/sendurl.html#(def._((lib._net/sendurl..ss)._unix-browser-list))",[0,[1,"unix-browser-list"]],["net/sendurl"]],
["unknown-extensions-skip-enabled",">gui/WXME_Decoding.html#(def._((lib._wxme/main..ss)._unknown-extensions-skip-enabled))",[0,[1,"unknown-extensions-skip-enabled"]],["wxme"]],
["unless",">reference/when_unless.html#(form._((lib._scheme/private/letstx-scheme..ss)._unless))",[0,[6,"unless"]],["scheme/base","scheme"]],
["unless",">r6rs-lib-std/r6rs-lib-Z-H-6.html#node_idx_256",[0,[6,"unless"]],["rnrs/control-6"]],
["unless",">htdp-langs/when_and_unless.html#(form._((lib._lang/htdp-advanced..ss)._unless))",[0,[6,"unless"]],["lang/htdp-advanced"]],
["unless",">lazy/index.html#(form._((lib._lazy/main..ss)._unless))",[0,[6,"unless"]],["lazy"]],
["unlink",">planet/cmdline.html#(part._unlink)",[5,"unlink"],false],
["unlink-all",">planet/Utility_Libraries.html#(def._((lib._planet/util..ss)._unlink-all))",[0,[1,"unlink-all"]],["planet/util"]],
["unmarshall-settings",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3alanguage~3c~25~3e)._unmarshall-settings))",[[0,[1,"unmarshall-settings"]],[12,[" (method of ",[0,[1,"drscheme:language:language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["unmarshall-settings",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3amodule-based-language~3c~25~3e)._unmarshall-settings))",[[0,[1,"unmarshall-settings"]],[12,[" (method of ",[0,[1,"drscheme:language:module-based-language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["unmarshall-settings",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-module-based-language-~3emodule-based-language-mixin)._unmarshall-settings))",[[0,[1,"unmarshall-settings"]],[12,[" (method of ",[0,[1,"drscheme:language:simple-module-based-language-&gt;module-based-language-mixin"]],")"]]],["drscheme/tool-lib"]],
["unnumbered-part",">scribble/struct.html#(def._((lib._scribble/struct..ss)._unnumbered-part))",[0,[1,"unnumbered-part"]],["scribble/struct"]],
["unnumbered-part?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._unnumbered-part~3f))",[0,[1,"unnumbered-part?"]],["scribble/struct"]],
["unpack",">setup-plt/_plt-archives.html#(def._((lib._setup/unpack..ss)._unpack))",[0,[1,"unpack"]],["setup/unpack"]],
["unpack-environments",">mzc/Scheme_API_for_Compilation.html#(def._((lib._compiler/option..ss)._unpack-environments))",[0,[1,"unpack-environments"]],["compiler/option"]],
["unpack-planet-archive",">planet/Utility_Libraries.html#(def._((lib._planet/util..ss)._unpack-planet-archive))",[0,[1,"unpack-planet-archive"]],["planet/util"]],
["unpackable",">setup-plt/_plt-archives.html#(tech._unpackable)","<i>unpackable</i>",false],
["unpacking \".plt\" archives",">setup-plt/_plt-archives.html#(part._unpacking-..plt-archives)",["Unpacking ",[5,"\".plt\""]," Archives"],false],
["unquote",">reference/quasiquote.html#(form._((quote._~23~25kernel)._unquote))",[0,[6,"unquote"]],["scheme/base","scheme"]],
["unquote",">r6rs-std/r6rs-Z-H-14.html#node_idx_770",[0,[1,"unquote"]],["rnrs/base-6"]],
["unquote",">htdp-langs/beginner-abbr-quasiquote.html#(form._((lib._lang/htdp-beginner-abbr..ss)._unquote))",[0,[6,"unquote"]],["lang/htdp-beginner-abbr"]],
["unquote-splicing",">reference/quasiquote.html#(form._((quote._~23~25kernel)._unquote-splicing))",[0,[6,"unquote-splicing"]],["scheme/base","scheme"]],
["unquote-splicing",">r6rs-std/r6rs-Z-H-14.html#node_idx_772",[0,[1,"unquote-splicing"]],["rnrs/base-6"]],
["unquote-splicing",">htdp-langs/beginner-abbr-quasiquote.html#(form._((lib._lang/htdp-beginner-abbr..ss)._unquote-splicing))",[0,[6,"unquote-splicing"]],["lang/htdp-beginner-abbr"]],
["unregister-collecting-blit",">gui/Drawing_Functions.html#(def._((lib._mred/main..ss)._unregister-collecting-blit))",[0,[1,"unregister-collecting-blit"]],["scheme/gui/base","scheme/gui"]],
["unregister-event-handler",">mysterx/browsers.html#(meth._(((lib._mysterx/main..ss)._mx-browser~25)._unregister-event-handler))",[[0,[1,"unregister-event-handler"]],[12,[" (method of ",[0,[1,"mx-browser%"]],")"]]],["mysterx"]],
["unsafe c vector construction",">foreign/Derived_Utilities.html#(part._.Unsafe_.C_.Vector_.Construction)","Unsafe C Vector Construction",false],
["unsafe library functions",">foreign/Loading_Foreign_Libraries.html#(part._.Unsafe_.Library_.Functions)","Unsafe Library Functions",false],
["unsafe memory management",">foreign/foreign_pointer-funcs.html#(part._.Unsafe_.Memory_.Management)","Unsafe Memory Management",false],
["unsafe miscellaneous operations",">foreign/Miscellaneous_Support.html#(part._.Unsafe_.Miscellaneous_.Operations)","Unsafe Miscellaneous Operations",false],
["unsafe pointer operations",">foreign/foreign_pointer-funcs.html#(part._.Unsafe_.Pointer_.Operations)","Unsafe Pointer Operations",false],
["unsafe tagged c pointer functions",">foreign/Derived_Utilities.html#(part._.Unsafe_.Tagged_.C_.Pointer_.Functions)","Unsafe Tagged C Pointer Functions",false],
["unsafe!",">foreign/Macros_for_Unsafety.html#(form._((lib._scheme/foreign..ss)._unsafe!))",[0,[6,"unsafe!"]],["scheme/foreign"]],
["unsafe!",">foreign/intro.html#(idx._(gentag._0._(lib._scribblings/foreign/foreign..scrbl)))",[0,[6,"unsafe!"]],false],
["unsmoothed",">gui/font_.html#(idx._(gentag._211._(lib._scribblings/gui/gui..scrbl)))",[7,"'unsmoothed"],false],
["unsmoothed",">gui/style-delta_.html#(idx._(gentag._271._(lib._scribblings/gui/gui..scrbl)))",[7,"'unsmoothed"],false],
["unstuff-url",">web-server/lang_stuff-url_ss.html#(def._((lib._web-server/lang/stuff-url..ss)._unstuff-url))",[0,[1,"unstuff-url"]],["web-server/lang/stuff-url"]],
["unsyntax",">reference/stx-patterns.html#(form._((lib._scheme/private/qqstx..ss)._unsyntax))",[0,[6,"unsyntax"]],["scheme/base","scheme"]],
["unsyntax",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1156",[0,[6,"unsyntax"]],["rnrs/syntax-case-6"]],
["unsyntax-splicing",">reference/stx-patterns.html#(form._((lib._scheme/private/qqstx..ss)._unsyntax-splicing))",[0,[6,"unsyntax-splicing"]],["scheme/base","scheme"]],
["unsyntax-splicing",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1158",[0,[6,"unsyntax-splicing"]],["rnrs/syntax-case-6"]],
["untrace",">eopl/index.html#(form._((lib._eopl/eopl..ss)._untrace))",[0,[6,"untrace"]],["eopl/eopl"]],
["untrace",">mzlib/mzlib_trace.html#(form._((lib._mzlib/trace..ss)._untrace))",[0,[6,"untrace"]],["mzlib/trace"]],
["unzip1",">srfi-std/srfi-1.html#unzip1",[0,[1,"unzip1"]],["srfi/1"]],
["unzip2",">srfi-std/srfi-1.html#unzip2",[0,[1,"unzip2"]],["srfi/1"]],
["unzip3",">srfi-std/srfi-1.html#unzip3",[0,[1,"unzip3"]],["srfi/1"]],
["unzip4",">srfi-std/srfi-1.html#unzip4",[0,[1,"unzip4"]],["srfi/1"]],
["unzip5",">srfi-std/srfi-1.html#unzip5",[0,[1,"unzip5"]],["srfi/1"]],
["up",">reference/Manipulating_Paths.html#(idx._(gentag._212._(lib._scribblings/reference/reference..scrbl)))",[7,"'up"],false],
["up",">gui/key-event_.html#(idx._(gentag._59._(lib._scribblings/gui/gui..scrbl)))",[7,"'up"],false],
["up-sexp",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3atext~3c~25~3e)._up-sexp))",[[0,[1,"up-sexp"]],[12,[" (method of ",[0,[1,"scheme:text&lt;%&gt;"]],")"]]],["framework"]],
["upcase-word",">framework/Keymap.html#(idx._(gentag._24._(lib._scribblings/framework/framework..scrbl)))","upcase-word",false],
["update",">reference/file-ports.html#(idx._(gentag._112._(lib._scribblings/reference/reference..scrbl)))",[7,"'update"],false],
["update-browser-preference",">browser/index.html#(def._((lib._browser/external..ss)._update-browser-preference))",[0,[1,"update-browser-preference"]],["browser/external"]],
["update-cursor",">gui/editor-admin_.html#(meth._(((lib._mred/main..ss)._editor-admin~25)._update-cursor))",[[0,[1,"update-cursor"]],[12,[" (method of ",[0,[1,"editor-admin%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["update-cursor",">gui/snip-admin_.html#(meth._(((lib._mred/main..ss)._snip-admin~25)._update-cursor))",[[0,[1,"update-cursor"]],[12,[" (method of ",[0,[1,"snip-admin%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["update-frame-filename",">framework/Editor.html#(meth._(((lib._framework/main..ss)._editor~3afile~3c~25~3e)._update-frame-filename))",[[0,[1,"update-frame-filename"]],[12,[" (method of ",[0,[1,"editor:file&lt;%&gt;"]],")"]]],["framework"]],
["update-info",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3ainfo~3c~25~3e)._update-info))",[[0,[1,"update-info"]],[12,[" (method of ",[0,[1,"frame:info&lt;%&gt;"]],")"]]],["framework"]],
["update-info",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3atext-info-mixin)._update-info))",[[0,[1,"update-info"]],[12,[" (method of ",[0,[1,"frame:text-info-mixin"]],")"]]],["framework"]],
["update-running",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3acontext~3c~25~3e)._update-running))",[[0,[1,"update-running"]],[12,[" (method of ",[0,[1,"drscheme:rep:context&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["update-save-button",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._update-save-button))",[[0,[1,"update-save-button"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["update-save-message",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._update-save-message))",[[0,[1,"update-save-message"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["update-shown",">tools/drscheme_frame.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aframe~3a~3c~25~3e)._update-shown))",[[0,[1,"update-shown"]],[12,[" (method of ",[0,[1,"drscheme:frame:&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["update-shown",">tools/drscheme_unit.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3aunit~3aframe~25)._update-shown))",[[0,[1,"update-shown"]],[12,[" (method of ",[0,[1,"drscheme:unit:frame%"]],")"]]],["drscheme/tool-lib"]],
["update-status-line",">framework/Frame.html#(meth._(((lib._framework/main..ss)._frame~3astatus-line~3c~25~3e)._update-status-line))",[[0,[1,"update-status-line"]],[12,[" (method of ",[0,[1,"frame:status-line&lt;%&gt;"]],")"]]],["framework"]],
["upper-case",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..ss)._upper-case))",[0,[6,"upper-case"]],["parser-tools/lex"]],
["uri codec: encoding and decoding uris",">net/uri-codec.html","URI Codec: Encoding and Decoding URIs",false],
["uri-decode",">net/uri-codec.html#(def._((lib._net/uri-codec..ss)._uri-decode))",[0,[1,"uri-decode"]],["net/uri-codec"]],
["uri-encode",">net/uri-codec.html#(def._((lib._net/uri-codec..ss)._uri-encode))",[0,[1,"uri-encode"]],["net/uri-codec"]],
["url",">planet/cmdline.html#(part._url)",[5,"url"],false],
["url",">net/url.html#(def._((lib._net/url-structs..ss)._url))",[0,[1,"url"]],["net/url-structs","net/url"]],
["url functions",">net/url.html#(part._.U.R.L_.Functions)","URL Functions",false],
["url param",">web-server/url-param_ss.html","URL Param",false],
["url signature",">net/url.html#(part._.U.R.L_.Signature)","URL Signature",false],
["url structure",">net/url.html#(part._.U.R.L_.Structure)","URL Structure",false],
["url unit",">net/url.html#(part._.U.R.L_.Unit)","URL Unit",false],
["url->path",">net/url.html#(def._((lib._net/url..ss)._url-~3epath))",[0,[1,"url-&gt;path"]],["net/url"]],
["url->string",">net/url.html#(def._((lib._net/url..ss)._url-~3estring))",[0,[1,"url-&gt;string"]],["net/url"]],
["url-fragment",">net/url.html#(def._((lib._net/url-structs..ss)._url-fragment))",[0,[1,"url-fragment"]],["net/url-structs","net/url"]],
["url-host",">net/url.html#(def._((lib._net/url-structs..ss)._url-host))",[0,[1,"url-host"]],["net/url-structs","net/url"]],
["url-path",">net/url.html#(def._((lib._net/url-structs..ss)._url-path))",[0,[1,"url-path"]],["net/url-structs","net/url"]],
["url-path->string",">web-server/util_ss.html#(def._((lib._web-server/private/util..ss)._url-path-~3estring))",[0,[1,"url-path-&gt;string"]],["web-server/private/util"]],
["url-path-absolute?",">net/url.html#(def._((lib._net/url-structs..ss)._url-path-absolute~3f))",[0,[1,"url-path-absolute?"]],["net/url-structs","net/url"]],
["url-path/c",">web-server/filesystem-map_ss.html#(def._((lib._web-server/dispatchers/filesystem-map..ss)._url-path/c))",[0,[1,"url-path/c"]],["web-server/dispatchers/filesystem-map"]],
["url-port",">net/url.html#(def._((lib._net/url-structs..ss)._url-port))",[0,[1,"url-port"]],["net/url-structs","net/url"]],
["url-query",">net/url.html#(def._((lib._net/url-structs..ss)._url-query))",[0,[1,"url-query"]],["net/url-structs","net/url"]],
["url-replace-path",">web-server/util_ss.html#(def._((lib._web-server/private/util..ss)._url-replace-path))",[0,[1,"url-replace-path"]],["web-server/private/util"]],
["url-scheme",">net/url.html#(def._((lib._net/url-structs..ss)._url-scheme))",[0,[1,"url-scheme"]],["net/url-structs","net/url"]],
["url-transform?",">web-server/servlet-structs_ss.html#(def._((lib._web-server/servlet/servlet-structs..ss)._url-transform~3f))",[0,"url-transform?"],["web-server/servlet/servlet-structs"]],
["url-user",">net/url.html#(def._((lib._net/url-structs..ss)._url-user))",[0,[1,"url-user"]],["net/url-structs","net/url"]],
["url?",">net/url.html#(def._((lib._net/url-structs..ss)._url~3f))",[0,[1,"url?"]],["net/url-structs","net/url"]],
["url@",">net/url.html#(def._((lib._net/url-unit..ss)._url~40))",[0,[1,"url@"]],["net/url-unit"]],
["url^",">net/url.html#(form._((lib._net/url-sig..ss)._url~5e))",[0,[6,"url^"]],["net/url-sig"]],
["urls",">web-server/util_ss.html#(part._.U.R.Ls)","URLs",false],
["urls and http",">net/url.html","URLs and HTTP",false],
["usage considerations",">web-server/considerations.html","Usage Considerations",false],
["use-at-readtable",">scribble/reader.html#(def._((lib._scribble/reader..ss)._use-at-readtable))",[0,[1,"use-at-readtable"]],["scribble/reader"]],
["use-compiled-file-paths",">reference/Evaluation_and_Compilation.html#(def._((quote._~23~25kernel)._use-compiled-file-paths))",[0,[1,"use-compiled-file-paths"]],["scheme/base","scheme"]],
["use-file-text-mode",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._use-file-text-mode))",[[0,[1,"use-file-text-mode"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["use-http-downloads?",">planet/Utility_Libraries.html#(def._((lib._planet/config..ss)._.U.S.E-.H.T.T.P-.D.O.W.N.L.O.A.D.S~3f))",[0,[1,"USE-HTTP-DOWNLOADS?"]],["planet/config"]],
["use-last",">slideshow/Bounding-Box_Adjusters.html#(def._((lib._slideshow/pict..ss)._use-last))",[0,[1,"use-last"]],["slideshow/pict","slideshow"]],
["use-last*",">slideshow/Bounding-Box_Adjusters.html#(def._((lib._slideshow/pict..ss)._use-last*))",[0,[1,"use-last*"]],["slideshow/pict","slideshow"]],
["use-mred-launcher",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3amodule-based-language~3c~25~3e)._use-mred-launcher))",[[0,[1,"use-mred-launcher"]],[12,[" (method of ",[0,[1,"drscheme:language:module-based-language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["use-mred-launcher",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3asimple-module-based-language-~3emodule-based-language-mixin)._use-mred-launcher))",[[0,[1,"use-mred-launcher"]],[12,[" (method of ",[0,[1,"drscheme:language:simple-module-based-language-&gt;module-based-language-mixin"]],")"]]],["drscheme/tool-lib"]],
["use-named/undefined-handler",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..ss)._use-named/undefined-handler))",[0,[1,"use-named/undefined-handler"]],["mzlib/pconvert"]],
["use-namespace-require/copy?",">tools/drscheme_language.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3alanguage~3amodule-based-language~3c~25~3e)._use-namespace-require/copy~3f))",[[0,[1,"use-namespace-require/copy?"]],[12,[" (method of ",[0,[1,"drscheme:language:module-based-language&lt;%&gt;"]],")"]]],["drscheme/tool-lib"]],
["use-standard-compiler",">dynext/Compilation.html#(def._((lib._dynext/compile..ss)._use-standard-compiler))",[0,[1,"use-standard-compiler"]],["dynext/compile"]],
["use-standard-linker",">dynext/Linking.html#(def._((lib._dynext/link..ss)._use-standard-linker))",[0,[1,"use-standard-linker"]],["dynext/link"]],
["use-style-background",">gui/editor-snip_.html#(meth._(((lib._mred/main..ss)._editor-snip~25)._use-style-background))",[[0,[1,"use-style-background"]],[12,[" (method of ",[0,[1,"editor-snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["use-user-specific-search-paths",">reference/collects.html#(def._((quote._~23~25kernel)._use-user-specific-search-paths))",[0,[1,"use-user-specific-search-paths"]],["scheme/base","scheme"]],
["user",">reference/Filesystem.html#(idx._(gentag._239._(lib._scribblings/reference/reference..scrbl)))",[5,"USER"],false],
["user interaction",">games/gcalc.html#(part._.User_.Interaction)","User Interaction",false],
["user-can-flip",">cards/index.html#(meth._(((lib._games/cards..ss)._card~3c~25~3e)._user-can-flip))",[[0,[1,"user-can-flip"]],[12,[" (method of ",[0,[1,"card&lt;%&gt;"]],")"]]],["games/cards"]],
["user-can-move",">cards/index.html#(meth._(((lib._games/cards..ss)._card~3c~25~3e)._user-can-move))",[[0,[1,"user-can-move"]],[12,[" (method of ",[0,[1,"card&lt;%&gt;"]],")"]]],["games/cards"]],
["user-data",">mrlib/hierarchical-list-item___.html#(meth._(((lib._mrlib/hierlist..ss)._hierarchical-list-item~3c~25~3e)._user-data))",[[0,[1,"user-data"]],[12,[" (method of ",[0,[1,"hierarchical-list-item&lt;%&gt;"]],")"]]],["mrlib/hierlist"]],
["user-vicinity",">srfi-std/srfi-59.html#user-vicinity",[0,[1,"user-vicinity"]],["srfi/59"]],
["user1",">gui/editor-wordbreak-map_.html#(idx._(gentag._242._(lib._scribblings/gui/gui..scrbl)))",[7,"'user1"],false],
["user2",">gui/editor-wordbreak-map_.html#(idx._(gentag._243._(lib._scribblings/gui/gui..scrbl)))",[7,"'user2"],false],
["username-rejected",">net/pop3.html#(def._((lib._net/pop3..ss)._username-rejected))",[0,[1,"username-rejected"]],["net/pop3"]],
["username-rejected?",">net/pop3.html#(def._((lib._net/pop3..ss)._username-rejected~3f))",[0,[1,"username-rejected?"]],["net/pop3"]],
["userprofile",">reference/Filesystem.html#(idx._(gentag._241._(lib._scribblings/reference/reference..scrbl)))",[5,"USERPROFILE"],false],
["uses-editor-path",">gui/snip_.html#(idx._(gentag._255._(lib._scribblings/gui/gui..scrbl)))",[7,"'uses-editor-path"],false],
["using an sql database",">continue/index.html#(part._.Using_an_.S.Q.L_database)","Using an SQL database",false],
["using errortrace",">errortrace/using-errortrace.html","Using Errortrace",false],
["using external files",">scribble/preprocessor.html#(part._.Using_.External_.Files)","Using External Files",false],
["using https",">continue/index.html#(part._.Using_.H.T.T.P.S)","Using HTTPS",false],
["using opengl",">sgl/overview.html","Using OpenGL",false],
["using planet",">planet/Using_PLaneT.html","Using PLaneT",false],
["using set! to assign to variables provided via provide/contract",">guide/contracts-gotchas.html#(part._.Using_set__to_.Assign_to_.Variables_.Provided_via_provide_contract)",["Using ",[0,[6,"set!"]]," to Assign to Variables Provided via ",[0,[6,"provide/contract"]]],false],
["using string constants",">string-constants/index.html#(part._.Using_.String_.Constants)","Using String Constants",false],
["using the macro stepper",">macro-debugger/index.html#(part._.Using_the_macro_stepper)","Using the macro stepper",false],
["using the syntax browser",">macro-debugger/index.html#(part._.Using_the_syntax_browser)","Using the syntax browser",false],
["utf-16-codec",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_594",[0,[1,"utf-16-codec"]],["rnrs/io/ports-6"]],
["utf-8-codec",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_592",[0,[1,"utf-8-codec"]],["rnrs/io/ports-6"]],
["utf-8-permissive",">reference/bytestrings.html#(idx._(gentag._29._(lib._scribblings/reference/reference..scrbl)))","UTF-8-permissive",false],
["utf16->string",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_196",[0,[1,"utf16-&gt;string"]],["rnrs/bytevectors-6"]],
["utf32->string",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_198",[0,[1,"utf32-&gt;string"]],["rnrs/bytevectors-6"]],
["utf8->string",">r6rs-lib-std/r6rs-lib-Z-H-3.html#node_idx_194",[0,[1,"utf8-&gt;string"]],["rnrs/bytevectors-6"]],
["util.ss: utilities",">planet/Utility_Libraries.html#(part._util..ss)","util.ss: Utilities",false],
["utilities",">web-server/Utilities.html","Utilities",false],
["utility libraries",">planet/Utility_Libraries.html","Utility Libraries",false],
["valid-version?",">version/index.html#(def._((lib._version/utils..ss)._valid-version~3f))",[0,[1,"valid-version?"]],["version/utils"]],
["validate-header",">net/head.html#(def._((lib._net/head..ss)._validate-header))",[0,[1,"validate-header"]],["net/head"]],
["validate-xexpr",">xml/index.html#(def._((lib._xml/main..ss)._validate-xexpr))",[0,[1,"validate-xexpr"]],["xml"]],
["value",">reference/eval-model.html#(tech._value)","<i>value</i>",false],
["value functions",">inside/im_values_types.html#(part._.Value_.Functions)","Value Functions",false],
["value output hook",">reference/pretty-print.html#(part._.Value_.Output_.Hook)","Value Output Hook",false],
["value turtles",">turtles/Value_Turtles.html","Value Turtles",false],
["value-now",">frtime/index.html#(def._((lib._frtime/main..ss)._value-now))",[0,[1,"value-now"]],["frtime"]],
["values",">reference/values.html#(def._((quote._~23~25kernel)._values))",[0,[1,"values"]],["scheme/base","scheme"]],
["values",">r5rs-std/r5rs-Z-H-9.html#%_idx_594",[0,[1,"values"]],["r5rs"]],
["values",">r6rs-std/r6rs-Z-H-14.html#node_idx_760",[0,[1,"values"]],["rnrs/base-6"]],
["values",">lazy/index.html#(def._((lib._lazy/main..ss)._values))",[0,[1,"values"]],["lazy"]],
["values",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._values))",[0,[6,"values"]],["typed-scheme"]],
["values and types",">inside/im_values_types.html","Values and Types",false],
["var",">html/index.html#(def._((lib._html/main..ss)._var))",[0,[1,"var"]],["html"]],
["var",">scribble/scribble_manual_code.html#(form._((lib._scribble/manual..ss)._var))",[0,[6,"var"]],["scribble/manual"]],
["var?",">html/index.html#(def._((lib._html/main..ss)._var~3f))",[0,[1,"var?"]],["html"]],
["variable",">redex/Patterns.html#(tech._variable)","<i>variable</i>",false],
["variable",">reference/eval-model.html#(tech._variable)","<i>variable</i>",false],
["variable auto-converting string type",">foreign/String_Types.html#(part._.Variable_.Auto-.Converting_.String_.Type)","Variable Auto-Converting String Type",false],
["variable references and #%top",">reference/__top.html",["Variable References and ",[0,[6,"#%top"]]],false],
["variable-arity functions: programming with rest arguments",">typed-scheme/index.html#(part._.Variable-.Arity_.Functions__.Programming_with_.Rest_.Arguments)","Variable-Arity Functions: Programming with Rest Arguments",false],
["variable-except",">redex/Patterns.html#(tech._variable._except)","<i>variable-except</i>",false],
["variable-not-in",">redex/Terms.html#(def._((lib._redex/main..ss)._variable-not-in))",[0,[1,"variable-not-in"]],["redex"]],
["variable-not-otherwise-mentioned",">redex/Patterns.html#(tech._variable._not._otherwise._mentioned)","<i>variable-not-otherwise-mentioned</i>",false],
["variable-prefix",">redex/Patterns.html#(tech._variable._prefix)","<i>variable-prefix</i>",false],
["variable-reference->empty-namespace",">reference/Namespaces.html#(def._((quote._~23~25kernel)._variable-reference-~3eempty-namespace))",[0,[1,"variable-reference-&gt;empty-namespace"]],["scheme/base","scheme"]],
["variable-reference->namespace",">reference/Namespaces.html#(def._((quote._~23~25kernel)._variable-reference-~3enamespace))",[0,[1,"variable-reference-&gt;namespace"]],["scheme/base","scheme"]],
["variable-reference->phase",">reference/Namespaces.html#(def._((quote._~23~25kernel)._variable-reference-~3ephase))",[0,[1,"variable-reference-&gt;phase"]],["scheme/base","scheme"]],
["variable-reference->resolved-module-path",">reference/Namespaces.html#(def._((quote._~23~25kernel)._variable-reference-~3eresolved-module-path))",[0,[1,"variable-reference-&gt;resolved-module-path"]],["scheme/base","scheme"]],
["variables",">gui/fontresources.html#(part._.Variables)","Variables",false],
["variables and locations",">reference/eval-model.html#(part._.Variables_and_.Locations)","Variables and Locations",false],
["variables-not-in",">redex/Terms.html#(def._((lib._redex/main..ss)._variables-not-in))",[0,[1,"variables-not-in"]],["redex"]],
["varieties of ports",">guide/Varieties_of_Ports.html","Varieties of Ports",false],
["various string forms",">scribble/doc-strings.html","Various String Forms",false],
["vc-append",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..ss)._vc-append))",[0,[1,"vc-append"]],["slideshow/pict","slideshow"]],
["vector",">reference/vectors.html#(def._((quote._~23~25kernel)._vector))",[0,[1,"vector"]],["scheme/base","scheme"]],
["vector",">r5rs-std/r5rs-Z-H-9.html#%_idx_562",[0,[1,"vector"]],["r5rs"]],
["vector",">r6rs-std/r6rs-Z-H-14.html#node_idx_728",[0,[1,"vector"]],["rnrs/base-6"]],
["vector",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._vector))",[0,[1,"vector"]],["lang/htdp-advanced"]],
["vector",">lazy/index.html#(def._((lib._lazy/main..ss)._vector))",[0,[1,"vector"]],["lazy"]],
["vector",">srfi-std/srfi-43.html#vector",[0,[1,"vector"]],["srfi/43"]],
["vector",">guide/vectors.html#(tech._vector)","<i>vector</i>",false],
["vector",">reference/vectors.html#(tech._vector)","<i>vector</i>",false],
["vector->cblock",">foreign/Miscellaneous_Support.html#(def._((lib._scheme/foreign..ss)._vector-~3ecblock))",[0,[1,"vector-&gt;cblock"]],["scheme/foreign"]],
["vector->gl-boolean-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._vector-~3egl-boolean-vector))",[0,[1,"vector-&gt;gl-boolean-vector"]],["sgl/gl-vectors"]],
["vector->gl-byte-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._vector-~3egl-byte-vector))",[0,[1,"vector-&gt;gl-byte-vector"]],["sgl/gl-vectors"]],
["vector->gl-double-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._vector-~3egl-double-vector))",[0,[1,"vector-&gt;gl-double-vector"]],["sgl/gl-vectors"]],
["vector->gl-float-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._vector-~3egl-float-vector))",[0,[1,"vector-&gt;gl-float-vector"]],["sgl/gl-vectors"]],
["vector->gl-int-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._vector-~3egl-int-vector))",[0,[1,"vector-&gt;gl-int-vector"]],["sgl/gl-vectors"]],
["vector->gl-short-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._vector-~3egl-short-vector))",[0,[1,"vector-&gt;gl-short-vector"]],["sgl/gl-vectors"]],
["vector->gl-ubyte-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._vector-~3egl-ubyte-vector))",[0,[1,"vector-&gt;gl-ubyte-vector"]],["sgl/gl-vectors"]],
["vector->gl-uint-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._vector-~3egl-uint-vector))",[0,[1,"vector-&gt;gl-uint-vector"]],["sgl/gl-vectors"]],
["vector->gl-ushort-vector",">sgl/gl-vectors.html#(def._((lib._sgl/gl-vectors..ss)._vector-~3egl-ushort-vector))",[0,[1,"vector-&gt;gl-ushort-vector"]],["sgl/gl-vectors"]],
["vector->immutable-vector",">reference/vectors.html#(def._((quote._~23~25kernel)._vector-~3eimmutable-vector))",[0,[1,"vector-&gt;immutable-vector"]],["scheme/base","scheme"]],
["vector->list",">reference/vectors.html#(def._((quote._~23~25kernel)._vector-~3elist))",[0,[1,"vector-&gt;list"]],["scheme/base","scheme"]],
["vector->list",">r5rs-std/r5rs-Z-H-9.html#%_idx_570",[0,[1,"vector-&gt;list"]],["r5rs"]],
["vector->list",">r6rs-std/r6rs-Z-H-14.html#node_idx_736",[0,[1,"vector-&gt;list"]],["rnrs/base-6"]],
["vector->list",">srfi-std/srfi-43.html#vector->list",[0,[1,"vector-&gt;list"]],["srfi/43"]],
["vector->pseudo-random-generator",">reference/numbers.html#(def._((quote._~23~25kernel)._vector-~3epseudo-random-generator))",[0,[1,"vector-&gt;pseudo-random-generator"]],["scheme/base","scheme"]],
["vector->pseudo-random-generator!",">reference/numbers.html#(def._((quote._~23~25kernel)._vector-~3epseudo-random-generator!))",[0,[1,"vector-&gt;pseudo-random-generator!"]],["scheme/base","scheme"]],
["vector->values",">reference/vectors.html#(def._((quote._~23~25kernel)._vector-~3evalues))",[0,[1,"vector-&gt;values"]],["scheme/base","scheme"]],
["vector-any",">srfi-std/srfi-43.html#vector-any",[0,[1,"vector-any"]],["srfi/43"]],
["vector-append",">srfi-std/srfi-43.html#vector-append",[0,[1,"vector-append"]],["srfi/43"]],
["vector-binary-search",">srfi-std/srfi-43.html#vector-binary-search",[0,[1,"vector-binary-search"]],["srfi/43"]],
["vector-concatenate",">srfi-std/srfi-43.html#vector-concatenate",[0,[1,"vector-concatenate"]],["srfi/43"]],
["vector-copy",">srfi-std/srfi-43.html#vector-copy",[0,[1,"vector-copy"]],["srfi/43"]],
["vector-copy!",">reference/vectors.html#(def._((quote._~23~25kernel)._vector-copy!))",[0,[1,"vector-copy!"]],["scheme/base","scheme"]],
["vector-copy!",">srfi-std/srfi-43.html#vector-copy-bang",[0,[1,"vector-copy!"]],["srfi/43"]],
["vector-count",">srfi-std/srfi-43.html#vector-count",[0,[1,"vector-count"]],["srfi/43"]],
["vector-ec",">srfi-std/srfi-42.html#vector-ec",[0,[6,"vector-ec"]],["srfi/42"]],
["vector-empty?",">srfi-std/srfi-43.html#vector-empty?",[0,[1,"vector-empty?"]],["srfi/43"]],
["vector-every",">srfi-std/srfi-43.html#vector-every",[0,[1,"vector-every"]],["srfi/43"]],
["vector-field",">plot/plot.html#(def._((lib._plot/main..ss)._vector-field))",[0,[1,"vector-field"]],["plot"]],
["vector-fill!",">reference/vectors.html#(def._((quote._~23~25kernel)._vector-fill!))",[0,[1,"vector-fill!"]],["scheme/base","scheme"]],
["vector-fill!",">r5rs-std/r5rs-Z-H-9.html#%_idx_574",[0,[1,"vector-fill!"]],["r5rs"]],
["vector-fill!",">r6rs-std/r6rs-Z-H-14.html#node_idx_740",[0,[1,"vector-fill!"]],["rnrs/base-6"]],
["vector-fill!",">srfi-std/srfi-43.html#vector-fill-bang",[0,[1,"vector-fill!"]],["srfi/43"]],
["vector-fold",">srfi-std/srfi-43.html#vector-fold",[0,[1,"vector-fold"]],["srfi/43"]],
["vector-fold-right",">srfi-std/srfi-43.html#vector-fold-right",[0,[1,"vector-fold-right"]],["srfi/43"]],
["vector-for-each",">r6rs-std/r6rs-Z-H-14.html#node_idx_744",[0,[1,"vector-for-each"]],["rnrs/base-6"]],
["vector-for-each",">srfi-std/srfi-43.html#vector-for-each",[0,[1,"vector-for-each"]],["srfi/43"]],
["vector-immutable",">reference/vectors.html#(def._((quote._~23~25kernel)._vector-immutable))",[0,[1,"vector-immutable"]],["scheme/base","scheme"]],
["vector-immutable/c",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._vector-immutable/c))",[0,[1,"vector-immutable/c"]],["scheme/contract","scheme"]],
["vector-immutableof",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._vector-immutableof))",[0,[1,"vector-immutableof"]],["scheme/contract","scheme"]],
["vector-index",">srfi-std/srfi-43.html#vector-index",[0,[1,"vector-index"]],["srfi/43"]],
["vector-index-right",">srfi-std/srfi-43.html#vector-index-right",[0,[1,"vector-index-right"]],["srfi/43"]],
["vector-length",">reference/vectors.html#(def._((quote._~23~25kernel)._vector-length))",[0,[1,"vector-length"]],["scheme/base","scheme"]],
["vector-length",">r5rs-std/r5rs-Z-H-9.html#%_idx_564",[0,[1,"vector-length"]],["r5rs"]],
["vector-length",">r6rs-std/r6rs-Z-H-14.html#node_idx_730",[0,[1,"vector-length"]],["rnrs/base-6"]],
["vector-length",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._vector-length))",[0,[1,"vector-length"]],["lang/htdp-advanced"]],
["vector-length",">srfi-std/srfi-43.html#vector-length",[0,[1,"vector-length"]],["srfi/43"]],
["vector-map",">r6rs-std/r6rs-Z-H-14.html#node_idx_742",[0,[1,"vector-map"]],["rnrs/base-6"]],
["vector-map",">srfi-std/srfi-43.html#vector-map",[0,[1,"vector-map"]],["srfi/43"]],
["vector-map!",">srfi-std/srfi-43.html#vector-map-bang",[0,[1,"vector-map!"]],["srfi/43"]],
["vector-of-length-ec",">srfi-std/srfi-42.html#vector-of-length-ec",[0,[6,"vector-of-length-ec"]],["srfi/42"]],
["vector-ref",">reference/vectors.html#(def._((quote._~23~25kernel)._vector-ref))",[0,[1,"vector-ref"]],["scheme/base","scheme"]],
["vector-ref",">r5rs-std/r5rs-Z-H-9.html#%_idx_566",[0,[1,"vector-ref"]],["r5rs"]],
["vector-ref",">r6rs-std/r6rs-Z-H-14.html#node_idx_732",[0,[1,"vector-ref"]],["rnrs/base-6"]],
["vector-ref",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._vector-ref))",[0,[1,"vector-ref"]],["lang/htdp-advanced"]],
["vector-ref",">srfi-std/srfi-43.html#vector-ref",[0,[1,"vector-ref"]],["srfi/43"]],
["vector-reverse!",">srfi-std/srfi-43.html#vector-reverse-bang",[0,[1,"vector-reverse!"]],["srfi/43"]],
["vector-reverse-copy",">srfi-std/srfi-43.html#vector-reverse-copy",[0,[1,"vector-reverse-copy"]],["srfi/43"]],
["vector-reverse-copy!",">srfi-std/srfi-43.html#vector-reverse-copy-bang",[0,[1,"vector-reverse-copy!"]],["srfi/43"]],
["vector-set!",">reference/vectors.html#(def._((quote._~23~25kernel)._vector-set!))",[0,[1,"vector-set!"]],["scheme/base","scheme"]],
["vector-set!",">r5rs-std/r5rs-Z-H-9.html#%_idx_568",[0,[1,"vector-set!"]],["r5rs"]],
["vector-set!",">r6rs-std/r6rs-Z-H-14.html#node_idx_734",[0,[1,"vector-set!"]],["rnrs/base-6"]],
["vector-set!",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._vector-set!))",[0,[1,"vector-set!"]],["lang/htdp-advanced"]],
["vector-set!",">lazy/index.html#(def._((lib._lazy/main..ss)._vector-set!))",[0,[1,"vector-set!"]],["lazy"]],
["vector-set!",">srfi-std/srfi-43.html#vector-set-bang",[0,[1,"vector-set!"]],["srfi/43"]],
["vector-set-performance-stats!",">reference/runtime.html#(def._((quote._~23~25kernel)._vector-set-performance-stats!))",[0,[1,"vector-set-performance-stats!"]],["scheme/base","scheme"]],
["vector-skip",">srfi-std/srfi-43.html#vector-skip",[0,[1,"vector-skip"]],["srfi/43"]],
["vector-skip-right",">srfi-std/srfi-43.html#vector-skip-right",[0,[1,"vector-skip-right"]],["srfi/43"]],
["vector-sort",">r6rs-lib-std/r6rs-lib-Z-H-5.html#node_idx_248",[0,[1,"vector-sort"]],["rnrs/sorting-6"]],
["vector-sort!",">r6rs-lib-std/r6rs-lib-Z-H-5.html#node_idx_250",[0,[1,"vector-sort!"]],["rnrs/sorting-6"]],
["vector-swap!",">srfi-std/srfi-43.html#vector-swap-bang",[0,[1,"vector-swap!"]],["srfi/43"]],
["vector-unfold",">srfi-std/srfi-43.html#vector-unfold",[0,[1,"vector-unfold"]],["srfi/43"]],
["vector-unfold-right",">srfi-std/srfi-43.html#vector-unfold-right",[0,[1,"vector-unfold-right"]],["srfi/43"]],
["vector/c",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._vector/c))",[0,[1,"vector/c"]],["scheme/contract","scheme"]],
["vector=",">srfi-std/srfi-43.html#vector-eq",[0,[1,"vector="]],["srfi/43"]],
["vector?",">reference/vectors.html#(def._((quote._~23~25kernel)._vector~3f))",[0,[1,"vector?"]],["scheme/base","scheme"]],
["vector?",">r5rs-std/r5rs-Z-H-9.html#%_idx_556",[0,[1,"vector?"]],["r5rs"]],
["vector?",">r6rs-std/r6rs-Z-H-14.html#node_idx_722",[0,[1,"vector?"]],["rnrs/base-6"]],
["vector?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._vector~3f))",[0,[1,"vector?"]],["lang/htdp-advanced"]],
["vector?",">srfi-std/srfi-43.html#vector-p",[0,[1,"vector?"]],["srfi/43"]],
["vectorof",">reference/Data-structure_Contracts.html#(def._((lib._scheme/private/contract..ss)._vectorof))",[0,[1,"vectorof"]],["scheme/contract","scheme"]],
["vectorof",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._.Vectorof))",[0,[6,"Vectorof"]],["typed-scheme"]],
["vectors",">guide/vectors.html","Vectors",false],
["vectors",">reference/vectors.html","Vectors",false],
["vehicles",">mzc/Scheme_API_for_Compilation.html#(def._((lib._compiler/option..ss)._vehicles))",[0,[1,"vehicles"]],["compiler/option"]],
["vehicles:monoliths",">mzc/Scheme_API_for_Compilation.html#(def._((lib._compiler/option..ss)._vehicles~3amonoliths))",[0,[1,"vehicles:monoliths"]],["compiler/option"]],
["verbatim",">scribble/scribble_manual_code.html#(def._((lib._scribble/manual..ss)._verbatim))",[0,[1,"verbatim"]],["scribble/manual"]],
["verbose",">mzc/Scheme_API_for_Compilation.html#(def._((lib._compiler/option..ss)._verbose))",[0,[1,"verbose"]],["compiler/option"]],
["verbose",">setup-plt/setup-plt-plt.html#(sig-val._((lib._setup/option-sig..ss)._setup-option~5e._verbose))",[0,[1,"verbose"]],["setup/option-sig"]],
["version",">mysterx/version.html","Version",false],
["version",">framework/Version.html","Version",false],
["version",">reference/runtime.html#(def._((quote._~23~25kernel)._version))",[0,[1,"version"]],["scheme/base","scheme"]],
["version utilities",">version/index.html#(part._.Version_.Utilities)","Version Utilities",false],
["version->integer",">version/index.html#(def._((lib._version/utils..ss)._version-~3einteger))",[0,[1,"version-&gt;integer"]],["version/utils"]],
["version->list",">version/index.html#(def._((lib._version/utils..ss)._version-~3elist))",[0,[1,"version-&gt;list"]],["version/utils"]],
["version/check",">version/index.html#(mod-path._version/check)",[14,[0,"version/check"]],"module"],
["version/patchlevel",">version/index.html#(mod-path._version/patchlevel)",[14,[0,"version/patchlevel"]],"module"],
["version/tool",">version/index.html#(mod-path._version/tool)",[14,[0,"version/tool"]],"module"],
["version/utils",">version/index.html#(mod-path._version/utils)",[14,[0,"version/utils"]],"module"],
["version: plt version checking",">version/index.html","<b>Version</b>: PLT Version Checking",false],
["version:add-spec",">framework/Version.html#(def._((lib._framework/main..ss)._version~3aadd-spec))",[0,[1,"version:add-spec"]],["framework"]],
["version:version",">framework/Version.html#(def._((lib._framework/main..ss)._version~3aversion))",[0,[1,"version:version"]],["framework"]],
["version<=?",">version/index.html#(def._((lib._version/utils..ss)._version~3c~3d~3f))",[0,[1,"version&lt;=?"]],["version/utils"]],
["version<?",">version/index.html#(def._((lib._version/utils..ss)._version~3c~3f))",[0,[1,"version&lt;?"]],["version/utils"]],
["versioned-part",">scribble/struct.html#(def._((lib._scribble/struct..ss)._versioned-part))",[0,[1,"versioned-part"]],["scribble/struct"]],
["versioned-part-version",">scribble/struct.html#(def._((lib._scribble/struct..ss)._versioned-part-version))",[0,[1,"versioned-part-version"]],["scribble/struct"]],
["versioned-part?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._versioned-part~3f))",[0,[1,"versioned-part?"]],["scribble/struct"]],
["vert-margin",">gui/subarea___.html#(meth._(((lib._mred/main..ss)._subarea~3c~25~3e)._vert-margin))",[[0,[1,"vert-margin"]],[12,[" (method of ",[0,[1,"subarea&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["vert-margin",">gui/subarea___.html#(idx._(gentag._129._(lib._scribblings/gui/gui..scrbl)))",[0,"vert-margin"],false],
["vertical-align",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._vertical-align))",[[0,[1,"vertical-align"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["vertical-align-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._vertical-align-native))",[[0,[1,"vertical-align-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["vertical-alignment%",">embedded-gui/vertical-alignment_.html",[0,[1,"vertical-alignment%"]],["embedded-gui"]],
["vertical-hatch",">gui/brush_.html#(idx._(gentag._188._(lib._scribblings/gui/gui..scrbl)))",[7,"'vertical-hatch"],false],
["vertical-inset",">gui/editor-canvas_.html#(meth._(((lib._mred/main..ss)._editor-canvas~25)._vertical-inset))",[[0,[1,"vertical-inset"]],[12,[" (method of ",[0,[1,"editor-canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["vertical-pane%",">gui/vertical-pane_.html",[0,[1,"vertical-pane%"]],["scheme/gui/base","scheme/gui"]],
["vertical-panel%",">gui/vertical-panel_.html",[0,[1,"vertical-panel%"]],["scheme/gui/base","scheme/gui"]],
["vertical-pasteboard%",">mrlib/vertical-pasteboard_.html",[0,[1,"vertical-pasteboard%"]],["mrlib/aligned-pasteboard"]],
["vicinity:suffix?",">srfi-std/srfi-59.html#vicinity:suffix-p",[0,[1,"vicinity:suffix?"]],["srfi/59"]],
["view",">drscheme/Menus.html#(part._menu~3aview)","<b><font size=\"-1\" face=\"Helvetica\">View</font></b>",false],
["view",">teachpack/arrow-gui.html#(def._((lib._teachpack/htdp/arrow-gui..ss)._view))",[0,[1,"view"]],["teachpack/htdp/arrow-gui"]],
["view menu",">tools/drscheme_frame.html#(idx._(gentag._15._(lib._scribblings/tools/tools..scrbl)))","View menu",false],
["view-control-font",">gui/Drawing_Functions.html#(def._((lib._mred/main..ss)._view-control-font))",[0,[1,"view-control-font"]],["scheme/gui/base","scheme/gui"]],
["viewer control",">slideshow/Viewer_Control.html","Viewer Control",false],
["viewport->snip",">graphics/Miscellaneous_Operations.html#(def._((lib._graphics/graphics..ss)._viewport-~3esnip))",[0,[1,"viewport-&gt;snip"]],["graphics/graphics"]],
["viewport-buffer-dc",">graphics/Miscellaneous_Operations.html#(def._((lib._graphics/graphics..ss)._viewport-buffer-dc))",[0,[1,"viewport-buffer-dc"]],["graphics/graphics"]],
["viewport-dc",">graphics/Miscellaneous_Operations.html#(def._((lib._graphics/graphics..ss)._viewport-dc))",[0,[1,"viewport-dc"]],["graphics/graphics"]],
["viewport-flush-input",">graphics/Flushing.html#(def._((lib._graphics/graphics..ss)._viewport-flush-input))",[0,[1,"viewport-flush-input"]],["graphics/graphics"]],
["viewport?",">graphics/Basic_Commands.html#(def._((lib._graphics/graphics..ss)._viewport~3f))",[0,[1,"viewport?"]],["graphics/graphics"]],
["viewports",">graphics/Draw__Clear__and_Flip_Operations.html#(part._.Viewports)","Viewports",false],
["violation?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_436",[0,[1,"violation?"]],["rnrs/conditions-6"]],
["virtual hosts",">web-server/dispatch-host_ss.html","Virtual Hosts",false],
["virtual-hosts",">web-server/web-config-unit_ss.html#(sig-val._((lib._web-server/web-config-sig..ss)._web-config~5e._virtual-hosts))",[0,[1,"virtual-hosts"]],["web-server/web-config-sig"]],
["visibility",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._visibility))",[[0,[1,"visibility"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["visibility-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._visibility-native))",[[0,[1,"visibility-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["visits",">reference/syntax-model.html#(tech._visit)","<i>visits</i>",false],
["vl-append",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..ss)._vl-append))",[0,[1,"vl-append"]],["slideshow/pict","slideshow"]],
["vline",">slideshow/Basic_Pict_Constructors.html#(def._((lib._slideshow/pict..ss)._vline))",[0,[1,"vline"]],["slideshow/pict","slideshow"]],
["vline%",">embedded-gui/vline_.html",[0,[1,"vline%"]],["embedded-gui"]],
["void",">reference/void.html#(def._((quote._~23~25kernel)._void))",[0,[1,"void"]],["scheme/base","scheme"]],
["void",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._void))",[0,[1,"void"]],["lang/htdp-advanced"]],
["void",">typed-scheme/index.html#(form._((lib._typed-scheme/main..ss)._.Void))",[0,[6,"Void"]],["typed-scheme"]],
["void and undefined",">guide/void_undefined.html","Void and Undefined",false],
["void and undefined",">reference/void.html","Void and Undefined",false],
["void-const",">scribble/Miscellaneous.html#(def._((lib._scribble/manual..ss)._void-const))",[0,[1,"void-const"]],["scribble/manual"]],
["void?",">reference/void.html#(def._((quote._~23~25kernel)._void~3f))",[0,[1,"void?"]],["scheme/base","scheme"]],
["void?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._void~3f))",[0,[1,"void?"]],["lang/htdp-advanced"]],
["vr-append",">slideshow/Pict_Combiners.html#(def._((lib._slideshow/pict..ss)._vr-append))",[0,[1,"vr-append"]],["slideshow/pict","slideshow"]],
["vscroll",">gui/canvas_.html#(idx._(gentag._33._(lib._scribblings/gui/gui..scrbl)))",[7,"'vscroll"],false],
["vscroll",">gui/canvas_.html#(idx._(gentag._35._(lib._scribblings/gui/gui..scrbl)))",[7,"'vscroll"],false],
["wait",">gui/Windowing_Functions.html#(idx._(gentag._149._(lib._scribblings/gui/gui..scrbl)))",[7,"'wait"],false],
["wait-for-io-to-complete",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3atext~25)._wait-for-io-to-complete))",[[0,[1,"wait-for-io-to-complete"]],[12,[" (method of ",[0,[1,"drscheme:rep:text%"]],")"]]],["drscheme/tool-lib"]],
["wait-for-io-to-complete/user",">tools/drscheme_rep.html#(meth._(((lib._drscheme/tool-lib..ss)._drscheme~3arep~3atext~25)._wait-for-io-to-complete/user))",[[0,[1,"wait-for-io-to-complete/user"]],[12,[" (method of ",[0,[1,"drscheme:rep:text%"]],")"]]],["drscheme/tool-lib"]],
["wait-for-mouse-click",">teachpack/draw.html#(def._((lib._teachpack/htdp/draw..ss)._wait-for-mouse-click))",[0,[1,"wait-for-mouse-click"]],["teachpack/htdp/draw"]],
["warning?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_418",[0,[1,"warning?"]],["rnrs/conditions-6"]],
["warnings",">drscheme/prefs-explanation.html#(part._.Warnings)","<b><font size=\"-1\" face=\"Helvetica\">Warnings</font></b>",false],
["warnings about interpreting syntax",">macro-debugger/index.html#(part._.Warnings_about_interpreting_syntax)","Warnings about interpreting syntax",false],
["warp-pointer",">gui/canvas___.html#(meth._(((lib._mred/main..ss)._canvas~3c~25~3e)._warp-pointer))",[[0,[1,"warp-pointer"]],[12,[" (method of ",[0,[1,"canvas&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["weak",">mzscheme/Old_Functions.html#(idx._(gentag._0._(lib._mzscheme/mzscheme..scrbl)))",[7,"'weak"],false],
["weak box",">reference/weakbox.html#(tech._weak._box)","<i>weak box</i>",false],
["weak boxes",">reference/weakbox.html","Weak Boxes",false],
["weak references",">reference/eval-model.html#(tech._weak._reference)","<i>weak references</i>",false],
["weak-box-value",">reference/weakbox.html#(def._((quote._~23~25kernel)._weak-box-value))",[0,[1,"weak-box-value"]],["scheme/base","scheme"]],
["weak-box?",">reference/weakbox.html#(def._((quote._~23~25kernel)._weak-box~3f))",[0,[1,"weak-box?"]],["scheme/base","scheme"]],
["web",">web-server/lang_web_ss.html","Web",false],
["web",">web-server/web_ss.html","Web",false],
["web cells",">web-server/lang_web-cells_ss.html","Web Cells",false],
["web cells",">web-server/web-cells_ss.html","Web Cells",false],
["web config unit",">web-server/web-config-unit_ss.html","Web Config Unit",false],
["web extras",">web-server/lang_web-extras_ss.html","Web Extras",false],
["web language servlets",">web-server/lang.html","Web Language Servlets",false],
["web parameters",">web-server/lang_web-param_ss.html","Web Parameters",false],
["web server unit",">web-server/web-server-unit_ss.html","Web Server Unit",false],
["web server: plt http server",">web-server/index.html","<b>Web Server</b>: PLT HTTP Server",false],
["web-cell-ref",">web-server/lang_web-cells_ss.html#(def._((lib._web-server/lang/web-cells..ss)._web-cell-ref))",[0,[1,"web-cell-ref"]],["web-server/lang/web-cells"]],
["web-cell-ref",">web-server/web-cells_ss.html#(def._((lib._web-server/servlet/web-cells..ss)._web-cell-ref))",[0,[1,"web-cell-ref"]],["web-server/servlet/web-cells"]],
["web-cell-shadow",">web-server/lang_web-cells_ss.html#(def._((lib._web-server/lang/web-cells..ss)._web-cell-shadow))",[0,[1,"web-cell-shadow"]],["web-server/lang/web-cells"]],
["web-cell-shadow",">web-server/web-cells_ss.html#(def._((lib._web-server/servlet/web-cells..ss)._web-cell-shadow))",[0,[1,"web-cell-shadow"]],["web-server/servlet/web-cells"]],
["web-cell?",">web-server/lang_web-cells_ss.html#(def._((lib._web-server/lang/web-cells..ss)._web-cell~3f))",[0,[1,"web-cell?"]],["web-server/lang/web-cells"]],
["web-cell?",">web-server/web-cells_ss.html#(def._((lib._web-server/servlet/web-cells..ss)._web-cell~3f))",[0,[1,"web-cell?"]],["web-server/servlet/web-cells"]],
["web-config^",">web-server/web-config-unit_ss.html#(form._((lib._web-server/web-config-sig..ss)._web-config~5e))",[0,[6,"web-config^"]],["web-server/web-config-sig"]],
["web-parameter?",">web-server/lang_web-param_ss.html#(def._((lib._web-server/lang/web-param..ss)._web-parameter~3f))",[0,[1,"web-parameter?"]],["web-server/lang/web-param"]],
["web-parameterize",">web-server/lang_web-param_ss.html#(form._((lib._web-server/lang/web-param..ss)._web-parameterize))",[0,[6,"web-parameterize"]],["web-server/lang/web-param"]],
["web-server/configuration/configuration-table",">web-server/configuration-table_ss.html",[14,[0,"web-server/configuration/configuration-table"]],"module"],
["web-server/configuration/configuration-table-structs",">web-server/configuration-table-structs_ss.html",[14,[0,"web-server/configuration/configuration-table-structs"]],"module"],
["web-server/configuration/namespace",">web-server/namespace_ss.html",[14,[0,"web-server/configuration/namespace"]],"module"],
["web-server/configuration/responders",">web-server/responders_ss.html",[14,[0,"web-server/configuration/responders"]],"module"],
["web-server/dispatchers/dispatch",">web-server/dispatch_ss.html",[14,[0,"web-server/dispatchers/dispatch"]],"module"],
["web-server/dispatchers/dispatch-files",">web-server/dispatch-files_ss.html",[14,[0,"web-server/dispatchers/dispatch-files"]],"module"],
["web-server/dispatchers/dispatch-filter",">web-server/dispatch-filter_ss.html",[14,[0,"web-server/dispatchers/dispatch-filter"]],"module"],
["web-server/dispatchers/dispatch-host",">web-server/dispatch-host_ss.html",[14,[0,"web-server/dispatchers/dispatch-host"]],"module"],
["web-server/dispatchers/dispatch-lang",">web-server/dispatch-lang_ss.html",[14,[0,"web-server/dispatchers/dispatch-lang"]],"module"],
["web-server/dispatchers/dispatch-lift",">web-server/dispatch-lift_ss.html",[14,[0,"web-server/dispatchers/dispatch-lift"]],"module"],
["web-server/dispatchers/dispatch-log",">web-server/dispatch-log_ss.html",[14,[0,"web-server/dispatchers/dispatch-log"]],"module"],
["web-server/dispatchers/dispatch-passwords",">web-server/dispatch-passwords_ss.html",[14,[0,"web-server/dispatchers/dispatch-passwords"]],"module"],
["web-server/dispatchers/dispatch-pathprocedure",">web-server/dispatch-pathprocedure_ss.html",[14,[0,"web-server/dispatchers/dispatch-pathprocedure"]],"module"],
["web-server/dispatchers/dispatch-sequencer",">web-server/dispatch-sequencer_ss.html",[14,[0,"web-server/dispatchers/dispatch-sequencer"]],"module"],
["web-server/dispatchers/dispatch-servlets",">web-server/dispatch-servlets_ss.html",[14,[0,"web-server/dispatchers/dispatch-servlets"]],"module"],
["web-server/dispatchers/dispatch-stat",">web-server/dispatch-stat_ss.html",[14,[0,"web-server/dispatchers/dispatch-stat"]],"module"],
["web-server/dispatchers/dispatch-timeout",">web-server/dispatch-timeout_ss.html",[14,[0,"web-server/dispatchers/dispatch-timeout"]],"module"],
["web-server/dispatchers/filesystem-map",">web-server/filesystem-map_ss.html",[14,[0,"web-server/dispatchers/filesystem-map"]],"module"],
["web-server/formlets",">web-server/formlets.html",[14,[0,"web-server/formlets"]],"module"],
["web-server/formlets/input",">web-server/input-formlets.html",[14,[0,"web-server/formlets/input"]],"module"],
["web-server/formlets/lib",">web-server/Functional_Usage.html",[14,[0,"web-server/formlets/lib"]],"module"],
["web-server/formlets/servlet",">web-server/Utilities.html",[14,[0,"web-server/formlets/servlet"]],"module"],
["web-server/formlets/syntax",">web-server/Syntactic_Shorthand.html",[14,[0,"web-server/formlets/syntax"]],"module"],
["web-server/insta",">web-server/insta.html",[14,[0,"web-server/insta"]],"module"],
["web-server/insta/insta",">web-server/insta.html#(mod-path._web-server/insta/insta)",[14,[0,"web-server/insta/insta"]],"module"],
["web-server/lang",">web-server/lang-servlets.html",[14,[0,"web-server/lang"]],"module"],
["web-server/lang/file-box",">web-server/lang_file-box_ss.html",[14,[0,"web-server/lang/file-box"]],"module"],
["web-server/lang/stuff-url",">web-server/lang_stuff-url_ss.html",[14,[0,"web-server/lang/stuff-url"]],"module"],
["web-server/lang/web",">web-server/lang_web_ss.html",[14,[0,"web-server/lang/web"]],"module"],
["web-server/lang/web-cells",">web-server/lang_web-cells_ss.html",[14,[0,"web-server/lang/web-cells"]],"module"],
["web-server/lang/web-extras",">web-server/lang_web-extras_ss.html",[14,[0,"web-server/lang/web-extras"]],"module"],
["web-server/lang/web-param",">web-server/lang_web-param_ss.html",[14,[0,"web-server/lang/web-param"]],"module"],
["web-server/managers/lru",">web-server/lru_ss.html",[14,[0,"web-server/managers/lru"]],"module"],
["web-server/managers/manager",">web-server/manager_ss.html",[14,[0,"web-server/managers/manager"]],"module"],
["web-server/managers/none",">web-server/none_ss.html",[14,[0,"web-server/managers/none"]],"module"],
["web-server/managers/timeouts",">web-server/timeouts_ss.html",[14,[0,"web-server/managers/timeouts"]],"module"],
["web-server/private/cache-table",">web-server/cache-table_ss.html",[14,[0,"web-server/private/cache-table"]],"module"],
["web-server/private/closure",">web-server/closure_ss.html",[14,[0,"web-server/private/closure"]],"module"],
["web-server/private/connection-manager",">web-server/connection-manager_ss.html",[14,[0,"web-server/private/connection-manager"]],"module"],
["web-server/private/define-closure",">web-server/closure_ss.html#(mod-path._web-server/private/define-closure)",[14,[0,"web-server/private/define-closure"]],"module"],
["web-server/private/dispatch-server-sig",">web-server/dispatch-server-unit_ss.html#(mod-path._web-server/private/dispatch-server-sig)",[14,[0,"web-server/private/dispatch-server-sig"]],"module"],
["web-server/private/dispatch-server-unit",">web-server/dispatch-server-unit_ss.html#(mod-path._web-server/private/dispatch-server-unit)",[14,[0,"web-server/private/dispatch-server-unit"]],"module"],
["web-server/private/mime-types",">web-server/mime-types_ss.html",[14,[0,"web-server/private/mime-types"]],"module"],
["web-server/private/mod-map",">web-server/mod-map_ss.html",[14,[0,"web-server/private/mod-map"]],"module"],
["web-server/private/request-structs",">web-server/request-structs_ss.html",[14,[0,"web-server/private/request-structs"]],"module"],
["web-server/private/response-structs",">web-server/response-structs_ss.html",[14,[0,"web-server/private/response-structs"]],"module"],
["web-server/private/timer",">web-server/timer_ss.html",[14,[0,"web-server/private/timer"]],"module"],
["web-server/private/url-param",">web-server/url-param_ss.html",[14,[0,"web-server/private/url-param"]],"module"],
["web-server/private/util",">web-server/util_ss.html",[14,[0,"web-server/private/util"]],"module"],
["web-server/servlet",">web-server/servlet.html",[14,[0,"web-server/servlet"]],"module"],
["web-server/servlet-env",">web-server/servlet-env_ss.html",[14,[0,"web-server/servlet-env"]],"module"],
["web-server/servlet/basic-auth",">web-server/basic-auth_ss.html",[14,[0,"web-server/servlet/basic-auth"]],"module"],
["web-server/servlet/bindings",">web-server/bindings_ss.html",[14,[0,"web-server/servlet/bindings"]],"module"],
["web-server/servlet/helpers",">web-server/helpers_ss.html",[14,[0,"web-server/servlet/helpers"]],"module"],
["web-server/servlet/servlet-structs",">web-server/servlet-structs_ss.html",[14,[0,"web-server/servlet/servlet-structs"]],"module"],
["web-server/servlet/servlet-url",">web-server/servlet-url_ss.html",[14,[0,"web-server/servlet/servlet-url"]],"module"],
["web-server/servlet/web",">web-server/web_ss.html",[14,[0,"web-server/servlet/web"]],"module"],
["web-server/servlet/web-cells",">web-server/web-cells_ss.html",[14,[0,"web-server/servlet/web-cells"]],"module"],
["web-server/web-config-sig",">web-server/web-config-unit_ss.html#(mod-path._web-server/web-config-sig)",[14,[0,"web-server/web-config-sig"]],"module"],
["web-server/web-config-unit",">web-server/web-config-unit_ss.html#(mod-path._web-server/web-config-unit)",[14,[0,"web-server/web-config-unit"]],"module"],
["web-server/web-server",">web-server/web-server_ss.html",[14,[0,"web-server/web-server"]],"module"],
["web-server/web-server-sig",">web-server/web-server-unit_ss.html#(mod-path._web-server/web-server-sig)",[14,[0,"web-server/web-server-sig"]],"module"],
["web-server/web-server-unit",">web-server/web-server-unit_ss.html#(mod-path._web-server/web-server-unit)",[14,[0,"web-server/web-server-unit"]],"module"],
["web-server@",">web-server/web-server-unit_ss.html#(def._((lib._web-server/web-server-unit..ss)._web-server~40))",[0,[1,"web-server@"]],["web-server/web-server-unit"]],
["web-server^",">web-server/web-server-unit_ss.html#(form._((lib._web-server/web-server-sig..ss)._web-server~5e))",[0,[6,"web-server^"]],["web-server/web-server-sig"]],
["welcome to plt scheme",">guide/intro.html","Welcome to PLT Scheme",false],
["well-formed-set?",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..ss)._well-formed-set~3f))",[0,[1,"well-formed-set?"]],["mzlib/integer-set"]],
["what special considerations are there for security with the web server?",">web-server/Troubleshooting.html#(part._.What_special_considerations_are_there_for_security_with_the_.Web_.Server_)","What special considerations are there for security with the Web Server?",false],
["wheel on mouse",">gui/key-event_.html#(idx._(gentag._113._(lib._scribblings/gui/gui..scrbl)))","wheel on mouse",false],
["wheel on mouse",">gui/editor-canvas_.html#(idx._(gentag._236._(lib._scribblings/gui/gui..scrbl)))","wheel on mouse",false],
["wheel-down",">gui/key-event_.html#(idx._(gentag._114._(lib._scribblings/gui/gui..scrbl)))",[7,"'wheel-down"],false],
["wheel-down",">gui/windowing-overview.html#(idx._(gentag._6._(lib._scribblings/gui/gui..scrbl)))",[7,"'wheel-down"],false],
["wheel-step",">gui/editor-canvas_.html#(meth._(((lib._mred/main..ss)._editor-canvas~25)._wheel-step))",[[0,[1,"wheel-step"]],[12,[" (method of ",[0,[1,"editor-canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["wheel-up",">gui/key-event_.html#(idx._(gentag._112._(lib._scribblings/gui/gui..scrbl)))",[7,"'wheel-up"],false],
["wheel-up",">gui/windowing-overview.html#(idx._(gentag._5._(lib._scribblings/gui/gui..scrbl)))",[7,"'wheel-up"],false],
["when",">reference/when_unless.html#(form._((lib._scheme/private/letstx-scheme..ss)._when))",[0,[6,"when"]],["scheme/base","scheme"]],
["when",">r6rs-lib-std/r6rs-lib-Z-H-6.html#node_idx_254",[0,[6,"when"]],["rnrs/control-6"]],
["when",">htdp-langs/when_and_unless.html#(form._((lib._lang/htdp-advanced..ss)._when))",[0,[6,"when"]],["lang/htdp-advanced"]],
["when",">lazy/index.html#(form._((lib._lazy/main..ss)._when))",[0,[6,"when"]],["lazy"]],
["when a function's result depends on its arguments",">guide/contracts-general-functions.html#(part._contracts-arrow-d)","When a Function&rsquo;s Result Depends on its Arguments",false],
["when and unless",">htdp-langs/when_and_unless.html",[[0,[6,"when"]]," and ",[0,[6,"unless"]]],false],
["when contract arguments depend on each other",">guide/contracts-general-functions.html#(part._contracts-arrow-d-args)","When Contract Arguments Depend on Each Other",false],
["when-e",">frtime/index.html#(def._((lib._frtime/main..ss)._when-e))",[0,[1,"when-e"]],["frtime"]],
["where to go from here",">more/index.html#(part._.Where_to_.Go_.From_.Here)","Where to Go From Here",false],
["where to go from here",">quick/index.html#(part._.Where_to_.Go_.From_.Here)","Where to Go From Here",false],
["while-unlocked",">framework/Text.html#(meth._(((lib._framework/main..ss)._text~3afile~3c~25~3e)._while-unlocked))",[[0,[1,"while-unlocked"]],[12,[" (method of ",[0,[1,"text:file&lt;%&gt;"]],")"]]],["framework"]],
["white-bracket-sizing",">redex/Typesetting.html#(def._((lib._redex/pict..ss)._white-bracket-sizing))",[0,[1,"white-bracket-sizing"]],["redex/pict"]],
["whitespace",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex..ss)._whitespace))",[0,[6,"whitespace"]],["parser-tools/lex"]],
["whitespace?",">scribble/decode.html#(def._((lib._scribble/decode..ss)._whitespace~3f))",[0,[1,"whitespace?"]],["scribble/decode"]],
["who-condition?",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_456",[0,[1,"who-condition?"]],["rnrs/conditions-6"]],
["whole-module signatures and units",">guide/Whole-module_Signatures_and_Units.html",["Whole-",[0,[6,"module"]]," Signatures and Units"],false],
["whole/fractional-exact-numbers",">mzlib/mzlib_pconvert.html#(def._((lib._mzlib/pconvert..ss)._whole/fractional-exact-numbers))",[0,[1,"whole/fractional-exact-numbers"]],["mzlib/pconvert"]],
["why this is useful",">web-server/namespace_ss.html#(part._.Why_this_is_useful)","Why this is useful",false],
["width",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._width))",[[0,[1,"width"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["width-depends-on-x",">gui/snip_.html#(idx._(gentag._251._(lib._scribblings/gui/gui..scrbl)))",[7,"'width-depends-on-x"],false],
["width-depends-on-y",">gui/snip_.html#(idx._(gentag._253._(lib._scribblings/gui/gui..scrbl)))",[7,"'width-depends-on-y"],false],
["width-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._width-native))",[[0,[1,"width-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["wildcarding references",">gui/fontresources.html#(part._.Wildcarding_.References)","Wildcarding References",false],
["wildcards",">gui/fontresources.html#(part._exampleresources)","Wildcards",false],
["will",">reference/willexecutor.html#(tech._will)","<i>will</i>",false],
["will executor",">reference/willexecutor.html#(tech._will._executor)","<i>will executor</i>",false],
["will-execute",">reference/willexecutor.html#(def._((quote._~23~25kernel)._will-execute))",[0,[1,"will-execute"]],["scheme/base","scheme"]],
["will-executor?",">reference/willexecutor.html#(def._((quote._~23~25kernel)._will-executor~3f))",[0,[1,"will-executor?"]],["scheme/base","scheme"]],
["will-register",">reference/willexecutor.html#(def._((quote._~23~25kernel)._will-register))",[0,[1,"will-register"]],["scheme/base","scheme"]],
["will-try-execute",">reference/willexecutor.html#(def._((quote._~23~25kernel)._will-try-execute))",[0,[1,"will-try-execute"]],["scheme/base","scheme"]],
["wills and executors",">reference/willexecutor.html","Wills and Executors",false],
["window",">teachpack/gui.html#(tech._window)","<i>Window</i>",false],
["window manager (unix only)",">framework/Test.html#(part._.Window_.Manager__.Unix_only_)","Window Manager (Unix only)",false],
["window<%>",">gui/window___.html",[0,[1,"window&lt;%&gt;"]],["scheme/gui/base","scheme/gui"]],
["window?",">teachpack/gui.html#(def._((lib._teachpack/htdp/gui..ss)._window~3f))",[0,[1,"window?"]],["teachpack/htdp/gui"]],
["windowing",">gui/windowing-overview.html","Windowing",false],
["windowing classes",">gui/Windowing_Classes.html","Windowing Classes",false],
["windowing functions",">gui/Windowing_Functions.html","Windowing Functions",false],
["windowing toolbox",">gui/Overview.html#(tech._windowing._toolbox)","<i>windowing toolbox</i>",false],
["windows",">drscheme/Menus.html#(part._.Windows)","<b><font size=\"-1\" face=\"Helvetica\">Windows</font></b>",false],
["windows",">reference/Manipulating_Paths.html#(idx._(gentag._211._(lib._scribblings/reference/reference..scrbl)))",[7,"'windows"],false],
["windows",">reference/runtime.html#(idx._(gentag._297._(lib._scribblings/reference/reference..scrbl)))",[7,"'windows"],false],
["windows",">gui/windowing-overview.html#(tech._window)","<i>windows</i>",false],
["windows menu",">framework/Frame.html#(idx._(gentag._3._(lib._scribblings/framework/framework..scrbl)))","Windows menu",false],
["windows path conventions",">reference/windowspaths.html","Windows Path Conventions",false],
["windows registry",">gui/Windowing_Functions.html#(idx._(gentag._154._(lib._scribblings/gui/gui..scrbl)))","Windows registry",false],
["with",">redex/Reduction_Relations.html#(form._((lib._redex/main..ss)._with))",[0,[6,"with"]],["redex"]],
["with-atomic-rewriter",">redex/Typesetting.html#(form._((lib._redex/pict..ss)._with-atomic-rewriter))",[0,[6,"with-atomic-rewriter"]],["redex/pict"]],
["with-attributes",">scribble/struct.html#(def._((lib._scribble/struct..ss)._with-attributes))",[0,[1,"with-attributes"]],["scribble/struct"]],
["with-attributes-assoc",">scribble/struct.html#(def._((lib._scribble/struct..ss)._with-attributes-assoc))",[0,[1,"with-attributes-assoc"]],["scribble/struct"]],
["with-attributes-style",">scribble/struct.html#(def._((lib._scribble/struct..ss)._with-attributes-style))",[0,[1,"with-attributes-style"]],["scribble/struct"]],
["with-attributes?",">scribble/struct.html#(def._((lib._scribble/struct..ss)._with-attributes~3f))",[0,[1,"with-attributes?"]],["scribble/struct"]],
["with-compound-rewriter",">redex/Typesetting.html#(form._((lib._redex/pict..ss)._with-compound-rewriter))",[0,[6,"with-compound-rewriter"]],["redex/pict"]],
["with-continuation-mark",">reference/wcm.html#(form._((quote._~23~25kernel)._with-continuation-mark))",[0,[6,"with-continuation-mark"]],["scheme/base","scheme"]],
["with-errors-to-browser",">web-server/helpers_ss.html#(def._((lib._web-server/servlet/helpers..ss)._with-errors-to-browser))",[0,[1,"with-errors-to-browser"]],["web-server/servlet/helpers"]],
["with-exception-handler",">r6rs-lib-std/r6rs-lib-Z-H-8.html#node_idx_368",[0,[1,"with-exception-handler"]],["rnrs/exceptions-6"]],
["with-exception-handler",">srfi-std/srfi-34.html#with-exception-handler",[0,[1,"with-exception-handler"]],["srfi/34"]],
["with-gl-context",">gui/canvas_.html#(meth._(((lib._mred/main..ss)._canvas~25)._with-gl-context))",[[0,[1,"with-gl-context"]],[12,[" (method of ",[0,[1,"canvas%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["with-handlers",">reference/exns.html#(form._((lib._scheme/private/more-scheme..ss)._with-handlers))",[0,[6,"with-handlers"]],["scheme/base","scheme"]],
["with-handlers*",">reference/exns.html#(form._((lib._scheme/private/more-scheme..ss)._with-handlers*))",[0,[6,"with-handlers*"]],["scheme/base","scheme"]],
["with-input-from-file",">reference/file-ports.html#(def._((lib._scheme/base..ss)._with-input-from-file))",[0,[1,"with-input-from-file"]],["scheme/base","scheme"]],
["with-input-from-file",">r5rs-std/r5rs-Z-H-9.html#%_idx_622",[0,[1,"with-input-from-file"]],["r5rs"]],
["with-input-from-file",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_796",[0,[1,"with-input-from-file"]],["rnrs/io/simple-6"]],
["with-input-from-file",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..ss)._with-input-from-file))",[0,[1,"with-input-from-file"]],["mzscheme"]],
["with-installer-window",">setup-plt/_plt-archives.html#(def._((lib._setup/plt-installer..ss)._with-installer-window))",[0,[1,"with-installer-window"]],["setup/plt-installer"]],
["with-limits",">reference/Sandboxed_Evaluation.html#(form._((lib._scheme/sandbox..ss)._with-limits))",[0,[6,"with-limits"]],["scheme/sandbox"]],
["with-mark",">errortrace/stacktrace.html#(sig-val._((lib._errortrace/stacktrace..ss)._stacktrace-imports~5e._with-mark))",[0,[1,"with-mark"]],["errortrace/stacktrace"]],
["with-method",">reference/ivaraccess.html#(form._((lib._scheme/private/class-internal..ss)._with-method))",[0,[6,"with-method"]],["scheme/class","scheme"]],
["with-module-reading-parameterization",">syntax/module-helpers.html#(def._((lib._syntax/modread..ss)._with-module-reading-parameterization))",[0,[1,"with-module-reading-parameterization"]],["syntax/modread"]],
["with-output-to-file",">reference/file-ports.html#(def._((lib._scheme/base..ss)._with-output-to-file))",[0,[1,"with-output-to-file"]],["scheme/base","scheme"]],
["with-output-to-file",">r5rs-std/r5rs-Z-H-9.html#%_idx_624",[0,[1,"with-output-to-file"]],["r5rs"]],
["with-output-to-file",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_798",[0,[1,"with-output-to-file"]],["rnrs/io/simple-6"]],
["with-output-to-file",">mzscheme/Old_Functions.html#(def._((lib._mzscheme/main..ss)._with-output-to-file))",[0,[1,"with-output-to-file"]],["mzscheme"]],
["with-steps",">slideshow/Pict-Staging_Helper.html#(form._((lib._slideshow/step..ss)._with-steps))",[0,[6,"with-steps"]],["slideshow/step"]],
["with-steps~",">slideshow/Pict-Staging_Helper.html#(form._((lib._slideshow/step..ss)._with-steps~7e))",[0,[6,"with-steps~"]],["slideshow/step"]],
["with-syntax",">reference/stx-patterns.html#(form._((lib._scheme/private/stxcase-scheme..ss)._with-syntax))",[0,[6,"with-syntax"]],["scheme/base","scheme"]],
["with-syntax",">r6rs-lib-std/r6rs-lib-Z-H-13.html#node_idx_1152",[0,[6,"with-syntax"]],["rnrs/syntax-case-6"]],
["with-syntax and generate-temporaries",">guide/with-syntax.html",[[0,[6,"with-syntax"]]," and ",[0,[1,"generate-temporaries"]]],false],
["with-unquote-rewriter",">redex/Typesetting.html#(form._((lib._redex/pict..ss)._with-unquote-rewriter))",[0,[6,"with-unquote-rewriter"]],["redex/pict"]],
["working with files and directories: \"dir.ss\"",">teachpack/dir.html",["Working with Files and Directories: ",[5,"\"dir.ss\""],"<a name=\"(idx._(gentag._9._(lib._teachpack/teachpack..scrbl)))\"></a>"],false],
["world",">teachpack/Jdraw.html#(part._.Jworld)","World",false],
["world",">teachpack/world.html#(tech._world)","<i>World</i>",false],
["world operations",">graphics/World_Operations.html","World Operations",false],
["world teachpack",">teachpack/world.html#(idx._(gentag._1._(lib._teachpack/teachpack..scrbl)))","world teachpack",false],
["wrap text menu item",">drscheme/Menus.html#(idx._(gentag._84._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">Wrap Text</font></b> menu item",false],
["wrap-balloon",">slideshow/More_Pict_Constructors.html#(def._((lib._slideshow/balloon..ss)._wrap-balloon))",[0,[1,"wrap-balloon"]],["slideshow/balloon"]],
["wrap-evt",">reference/sync.html#(def._((quote._~23~25kernel)._wrap-evt))",[0,[1,"wrap-evt"]],["scheme/base","scheme"]],
["wrap-read-all",">syntax/reader-helpers.html#(def._((lib._syntax/module-reader..ss)._wrap-read-all))",[0,[1,"wrap-read-all"]],["syntax/module-reader"]],
["write",">reference/Writing.html#(def._((quote._~23~25kernel)._write))",[0,[1,"write"]],["scheme/base","scheme"]],
["write",">gui/editor-data_.html#(meth._(((lib._mred/main..ss)._editor-data~25)._write))",[[0,[1,"write"]],[12,[" (method of ",[0,[1,"editor-data%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["write",">gui/editor-stream-out-base_.html#(meth._(((lib._mred/main..ss)._editor-stream-out-base~25)._write))",[[0,[1,"write"]],[12,[" (method of ",[0,[1,"editor-stream-out-base%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["write",">gui/snip_.html#(meth._(((lib._mred/main..ss)._snip~25)._write))",[[0,[1,"write"]],[12,[" (method of ",[0,[1,"snip%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["write",">r5rs-std/r5rs-Z-H-9.html#%_idx_654",[0,[1,"write"]],["r5rs"]],
["write",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_832",[0,[1,"write"]],["rnrs/io/simple-6"]],
["write",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._write))",[0,[1,"write"]],["lang/htdp-advanced"]],
["write",">framework/Scheme.html#(meth._(((lib._framework/main..ss)._scheme~3asexp-snip~25)._write))",[[0,[1,"write"]],[12,[" (method of ",[0,[1,"scheme:sexp-snip%"]],")"]]],["framework"]],
["write",">lazy/index.html#(def._((lib._lazy/main..ss)._write))",[0,[1,"write"]],["lazy"]],
["write",">reference/securityguards.html#(idx._(gentag._204._(lib._scribblings/reference/reference..scrbl)))",[7,"'write"],false],
["write",">reference/Filesystem.html#(idx._(gentag._264._(lib._scribblings/reference/reference..scrbl)))",[7,"'write"],false],
["write",">drscheme/interactions-window.html#(idx._(gentag._29._(lib._scribblings/drscheme/drscheme..scrbl)))",[0,[1,"write"]],false],
["write output",">drscheme/output-syntax.html#(idx._(gentag._57._(lib._scribblings/drscheme/drscheme..scrbl)))","<b><font size=\"-1\" face=\"Helvetica\">write</font></b> output",false],
["write your package",">planet/Developing_Packages_for_PLaneT.html#(part._.Write_.Your_.Package)","Write Your Package",false],
["write-animated-gif",">mrlib/GIF_and_Animated_GIF_Writing.html#(def._((lib._mrlib/gif..ss)._write-animated-gif))",[0,[1,"write-animated-gif"]],["mrlib/gif"]],
["write-byte",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._write-byte))",[0,[1,"write-byte"]],["scheme/base","scheme"]],
["write-bytes",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._write-bytes))",[0,[1,"write-bytes"]],["scheme/base","scheme"]],
["write-bytes-avail",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._write-bytes-avail))",[0,[1,"write-bytes-avail"]],["scheme/base","scheme"]],
["write-bytes-avail*",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._write-bytes-avail*))",[0,[1,"write-bytes-avail*"]],["scheme/base","scheme"]],
["write-bytes-avail-evt",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._write-bytes-avail-evt))",[0,[1,"write-bytes-avail-evt"]],["scheme/base","scheme"]],
["write-bytes-avail/enable-break",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._write-bytes-avail/enable-break))",[0,[1,"write-bytes-avail/enable-break"]],["scheme/base","scheme"]],
["write-char",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._write-char))",[0,[1,"write-char"]],["scheme/base","scheme"]],
["write-char",">r5rs-std/r5rs-Z-H-9.html#%_idx_666",[0,[1,"write-char"]],["r5rs"]],
["write-char",">r6rs-lib-std/r6rs-lib-Z-H-9.html#node_idx_820",[0,[1,"write-char"]],["rnrs/io/simple-6"]],
["write-configuration-table",">web-server/configuration-table_ss.html#(def._((lib._web-server/configuration/configuration-table..ss)._write-configuration-table))",[0,[1,"write-configuration-table"]],["web-server/configuration/configuration-table"]],
["write-editor-global-footer",">gui/Editor_Functions.html#(def._((lib._mred/main..ss)._write-editor-global-footer))",[0,[1,"write-editor-global-footer"]],["scheme/gui/base","scheme/gui"]],
["write-editor-global-header",">gui/Editor_Functions.html#(def._((lib._mred/main..ss)._write-editor-global-header))",[0,[1,"write-editor-global-header"]],["scheme/gui/base","scheme/gui"]],
["write-editor-version",">gui/Editor_Functions.html#(def._((lib._mred/main..ss)._write-editor-version))",[0,[1,"write-editor-version"]],["scheme/gui/base","scheme/gui"]],
["write-file",">teachpack/docs.html#(def._((lib._teachpack/htdp/docs..ss)._write-file))",[0,[1,"write-file"]],["teachpack/htdp/docs"]],
["write-footers-to-file",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._write-footers-to-file))",[[0,[1,"write-footers-to-file"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["write-gif",">mrlib/GIF_and_Animated_GIF_Writing.html#(def._((lib._mrlib/gif..ss)._write-gif))",[0,[1,"write-gif"]],["mrlib/gif"]],
["write-header",">gui/snip-class_.html#(meth._(((lib._mred/main..ss)._snip-class~25)._write-header))",[[0,[1,"write-header"]],[12,[" (method of ",[0,[1,"snip-class%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["write-headers-to-file",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._write-headers-to-file))",[[0,[1,"write-headers-to-file"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["write-module-bundle",">mzc/exe.html#(def._((lib._compiler/embed..ss)._write-module-bundle))",[0,[1,"write-module-bundle"]],["compiler/embed"]],
["write-plist",">xml/index.html#(def._((lib._xml/plist..ss)._write-plist))",[0,[1,"write-plist"]],["xml/plist"]],
["write-resource",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._write-resource))",[0,[1,"write-resource"]],["scheme/gui/base","scheme/gui"]],
["write-special",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._write-special))",[0,[1,"write-special"]],["scheme/base","scheme"]],
["write-special-avail*",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._write-special-avail*))",[0,[1,"write-special-avail*"]],["scheme/base","scheme"]],
["write-special-evt",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._write-special-evt))",[0,[1,"write-special-evt"]],["scheme/base","scheme"]],
["write-string",">reference/Byte_and_String_Output.html#(def._((quote._~23~25kernel)._write-string))",[0,[1,"write-string"]],["scheme/base","scheme"]],
["write-to-file",">gui/editor___.html#(meth._(((lib._mred/main..ss)._editor~3c~25~3e)._write-to-file))",[[0,[1,"write-to-file"]],[12,[" (method of ",[0,[1,"editor&lt;%&gt;"]],")"]]],["scheme/gui/base","scheme/gui"]],
["write-to-file",">gui/text_.html#(meth._(((lib._mred/main..ss)._text~25)._write-to-file))",[[0,[1,"write-to-file"]],[12,[" (method of ",[0,[1,"text%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["write-with-shared-structure",">srfi-std/srfi-38.html#write-with-shared-structure",[0,[1,"write-with-shared-structure"]],["srfi/38"]],
["write-xml",">xml/index.html#(def._((lib._xml/main..ss)._write-xml))",[0,[1,"write-xml"]],["xml"]],
["write-xml/content",">xml/index.html#(def._((lib._xml/main..ss)._write-xml/content))",[0,[1,"write-xml/content"]],["xml"]],
["write/bytes",">web-server/util_ss.html#(def._((lib._web-server/private/util..ss)._write/bytes))",[0,[1,"write/bytes"]],["web-server/private/util"]],
["write/string",">web-server/util_ss.html#(def._((lib._web-server/private/util..ss)._write/string))",[0,[1,"write/string"]],["web-server/private/util"]],
["writing",">reference/Writing.html","Writing",false],
["writing mzscheme extensions",">inside/overview.html#(part._.Writing_.Mz.Scheme_.Extensions)","Writing MzScheme Extensions",false],
["writing regexp patterns",">guide/regexp-intro.html","Writing Regexp Patterns",false],
["wxme",">gui/WXME_Decoding.html",[14,[0,"wxme"]],"module"],
["wxme",">gui/editor-overview.html#(tech._wxme)","<i>WXME</i>",false],
["wxme decoding",">gui/WXME_Decoding.html","WXME Decoding",false],
["wxme-port->port",">gui/WXME_Decoding.html#(def._((lib._wxme/main..ss)._wxme-port-~3eport))",[0,[1,"wxme-port-&gt;port"]],["wxme"]],
["wxme-port->text-port",">gui/WXME_Decoding.html#(def._((lib._wxme/main..ss)._wxme-port-~3etext-port))",[0,[1,"wxme-port-&gt;text-port"]],["wxme"]],
["wxme-read",">gui/WXME_Decoding.html#(def._((lib._wxme/main..ss)._wxme-read))",[0,[1,"wxme-read"]],["wxme"]],
["wxme-read-syntax",">gui/WXME_Decoding.html#(def._((lib._wxme/main..ss)._wxme-read-syntax))",[0,[1,"wxme-read-syntax"]],["wxme"]],
["wxme/cache-image",">gui/WXME_Decoding.html#(mod-path._wxme/cache-image)",[14,[0,"wxme/cache-image"]],"module"],
["wxme/comment",">gui/WXME_Decoding.html#(mod-path._wxme/comment)",[14,[0,"wxme/comment"]],"module"],
["wxme/editor",">gui/WXME_Decoding.html#(mod-path._wxme/editor)",[14,[0,"wxme/editor"]],"module"],
["wxme/image",">gui/WXME_Decoding.html#(mod-path._wxme/image)",[14,[0,"wxme/image"]],"module"],
["wxme/number",">gui/WXME_Decoding.html#(mod-path._wxme/number)",[14,[0,"wxme/number"]],"module"],
["wxme/scheme",">gui/WXME_Decoding.html#(mod-path._wxme/scheme)",[14,[0,"wxme/scheme"]],"module"],
["wxme/test-case",">gui/WXME_Decoding.html#(mod-path._wxme/test-case)",[14,[0,"wxme/test-case"]],"module"],
["wxme/text",">gui/WXME_Decoding.html#(mod-path._wxme/text)",[14,[0,"wxme/text"]],"module"],
["wxme/xml",">gui/WXME_Decoding.html#(mod-path._wxme/xml)",[14,[0,"wxme/xml"]],"module"],
["x",">mysterx/html-events.html#(meth._(((lib._mysterx/main..ss)._mx-event~3c~25~3e)._x))",[[0,[1,"x"]],[12,[" (method of ",[0,[1,"mx-event&lt;%&gt;"]],")"]]],["mysterx"]],
["x-expression",">xml/index.html#(tech._x._expression)","<i>X-expression</i>",false],
["x-expression",">drscheme/Graphical_Syntax.html#(tech._x._expression)","<i>x-expression</i>",false],
["x-values",">plot/extend.html#(def._((lib._plot/extend..ss)._x-values))",[0,[1,"x-values"]],["plot/extend"]],
["xbm",">gui/bitmap_.html#(idx._(gentag._166._(lib._scribblings/gui/gui..scrbl)))","XBM",false],
["xbm",">gui/bitmap_.html#(idx._(gentag._174._(lib._scribblings/gui/gui..scrbl)))","XBM",false],
["xcons",">srfi-std/srfi-1.html#xcons",[0,[1,"xcons"]],["srfi/1"]],
["xexpr",">drscheme/Graphical_Syntax.html#(tech._xexpr)","<i>xexpr</i>",false],
["xexpr->string",">xml/index.html#(def._((lib._xml/main..ss)._xexpr-~3estring))",[0,[1,"xexpr-&gt;string"]],["xml"]],
["xexpr->xml",">xml/index.html#(def._((lib._xml/main..ss)._xexpr-~3exml))",[0,[1,"xexpr-&gt;xml"]],["xml"]],
["xexpr-drop-empty-attributes",">xml/index.html#(def._((lib._xml/main..ss)._xexpr-drop-empty-attributes))",[0,[1,"xexpr-drop-empty-attributes"]],["xml"]],
["xexpr-forest/c",">web-server/Functional_Usage.html#(def._((lib._web-server/formlets/lib..ss)._xexpr-forest/c))",[0,[1,"xexpr-forest/c"]],["web-server/formlets/lib"]],
["xexpr?",">xml/index.html#(def._((lib._xml/main..ss)._xexpr~3f))",[0,[1,"xexpr?"]],["xml"]],
["xmethod",">scribble/doc-classes.html#(form._((lib._scribble/manual..ss)._xmethod))",[0,[6,"xmethod"]],["scribble/manual"]],
["xml",">xml/index.html",[14,[0,"xml"]],"module"],
["xml",">web-server/Functional_Usage.html#(def._((lib._web-server/formlets/lib..ss)._xml))",[0,[1,"xml"]],["web-server/formlets/lib"]],
["xml and x-expression conversions",">xml/index.html#(part._.X.M.L_and_.X-expression_.Conversions)","XML and X-expression Conversions",false],
["xml boxes and scheme boxes",">drscheme/Graphical_Syntax.html#(part._xml-boxes)","XML Boxes and Scheme Boxes",false],
["xml->xexpr",">xml/index.html#(def._((lib._xml/main..ss)._xml-~3exexpr))",[0,[1,"xml-&gt;xexpr"]],["xml"]],
["xml-editor%",">gui/WXME_Decoding.html#(def._((lib._wxme/xml..ss)._xml-editor~25))",[0,[1,"xml-editor%"]],["wxme/xml"]],
["xml-forest",">web-server/Functional_Usage.html#(def._((lib._web-server/formlets/lib..ss)._xml-forest))",[0,[1,"xml-forest"]],["web-server/formlets/lib"]],
["xml/plist",">xml/index.html#(mod-path._xml/plist)",[14,[0,"xml/plist"]],"module"],
["xml: parsing and writing",">xml/index.html","<b>XML</b>: Parsing and Writing",false],
["xor",">gui/region_.html#(meth._(((lib._mred/main..ss)._region~25)._xor))",[[0,[1,"xor"]],[12,[" (method of ",[0,[1,"region%"]],")"]]],["scheme/gui/base","scheme/gui"]],
["xor",">mzlib/mzlib_integer-set.html#(def._((lib._mzlib/integer-set..ss)._xor))",[0,[1,"xor"]],["mzlib/integer-set"]],
["xor",">gui/brush_.html#(idx._(gentag._179._(lib._scribblings/gui/gui..scrbl)))",[7,"'xor"],false],
["xor",">gui/pen_.html#(idx._(gentag._218._(lib._scribblings/gui/gui..scrbl)))",[7,"'xor"],false],
["xor-dot",">gui/pen_.html#(idx._(gentag._224._(lib._scribblings/gui/gui..scrbl)))",[7,"'xor-dot"],false],
["xor-dot-dash",">gui/pen_.html#(idx._(gentag._227._(lib._scribblings/gui/gui..scrbl)))",[7,"'xor-dot-dash"],false],
["xor-long-dash",">gui/pen_.html#(idx._(gentag._225._(lib._scribblings/gui/gui..scrbl)))",[7,"'xor-long-dash"],false],
["xor-short-dash",">gui/pen_.html#(idx._(gentag._226._(lib._scribblings/gui/gui..scrbl)))",[7,"'xor-short-dash"],false],
["xpm",">gui/bitmap_.html#(idx._(gentag._167._(lib._scribblings/gui/gui..scrbl)))","XPM",false],
["xpm",">gui/bitmap_.html#(idx._(gentag._175._(lib._scribblings/gui/gui..scrbl)))","XPM",false],
["xref-binding->definition-tag",">scribble/xref.html#(def._((lib._scribble/xref..ss)._xref-binding-~3edefinition-tag))",[0,[1,"xref-binding-&gt;definition-tag"]],["scribble/xref"]],
["xref-index",">scribble/xref.html#(def._((lib._scribble/xref..ss)._xref-index))",[0,[1,"xref-index"]],["scribble/xref"]],
["xref-render",">scribble/xref.html#(def._((lib._scribble/xref..ss)._xref-render))",[0,[1,"xref-render"]],["scribble/xref"]],
["xref-tag->index-entry",">scribble/xref.html#(def._((lib._scribble/xref..ss)._xref-tag-~3eindex-entry))",[0,[1,"xref-tag-&gt;index-entry"]],["scribble/xref"]],
["xref-tag->path+anchor",">scribble/xref.html#(def._((lib._scribble/xref..ss)._xref-tag-~3epath+anchor))",[0,[1,"xref-tag-&gt;path+anchor"]],["scribble/xref"]],
["xref-transfer-info",">scribble/xref.html#(def._((lib._scribble/xref..ss)._xref-transfer-info))",[0,[1,"xref-transfer-info"]],["scribble/xref"]],
["xref?",">scribble/xref.html#(def._((lib._scribble/xref..ss)._xref~3f))",[0,[1,"xref?"]],["scribble/xref"]],
["xsubstring",">srfi-std/srfi-13.html#xsubstring",[0,[1,"xsubstring"]],["srfi/13"]],
["xy-list",">plot/extend.html#(def._((lib._plot/extend..ss)._xy-list))",[0,[1,"xy-list"]],["plot/extend"]],
["y",">mysterx/html-events.html#(meth._(((lib._mysterx/main..ss)._mx-event~3c~25~3e)._y))",[[0,[1,"y"]],[12,[" (method of ",[0,[1,"mx-event&lt;%&gt;"]],")"]]],["mysterx"]],
["yield",">gui/Windowing_Functions.html#(def._((lib._mred/main..ss)._yield))",[0,[1,"yield"]],["scheme/gui/base","scheme/gui"]],
["yield",">gui/windowing-overview.html#(tech._yield)","<i>yield</i>",false],
["z-index",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._z-index))",[[0,[1,"z-index"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["z-index-native",">mysterx/html-element.html#(meth._(((lib._mysterx/main..ss)._mx-element~25)._z-index-native))",[[0,[1,"z-index-native"]],[12,[" (method of ",[0,[1,"mx-element%"]],")"]]],["mysterx"]],
["zero?",">reference/numbers.html#(def._((quote._~23~25kernel)._zero~3f))",[0,[1,"zero?"]],["scheme/base","scheme"]],
["zero?",">r5rs-std/r5rs-Z-H-9.html#%_idx_268",[0,[1,"zero?"]],["r5rs"]],
["zero?",">r6rs-std/r6rs-Z-H-14.html#node_idx_474",[0,[1,"zero?"]],["rnrs/base-6"]],
["zero?",">htdp-langs/advanced-prim-ops.html#(def._((lib._lang/htdp-advanced..ss)._zero~3f))",[0,[1,"zero?"]],["lang/htdp-advanced"]],
["zero?",">htdp-langs/beginner-prim-ops.html#(def._((lib._lang/htdp-beginner..ss)._zero~3f))",[0,[1,"zero?"]],["lang/htdp-beginner"]],
["zero?",">htdp-langs/beginner-abbr-prim-ops.html#(def._((lib._lang/htdp-beginner-abbr..ss)._zero~3f))",[0,[1,"zero?"]],["lang/htdp-beginner-abbr"]],
["zero?",">htdp-langs/intermediate-prim-op.html#(def._((lib._lang/htdp-intermediate..ss)._zero~3f))",[0,[1,"zero?"]],["lang/htdp-intermediate"]],
["zero?",">htdp-langs/intermediate-lambda-prim-op.html#(def._((lib._lang/htdp-intermediate-lambda..ss)._zero~3f))",[0,[1,"zero?"]],["lang/htdp-intermediate-lambda"]],
["zgrid",">plot/extend.html#(def._((lib._plot/extend..ss)._zgrid))",[0,[1,"zgrid"]],["plot/extend"]],
["zip",">file/zip.html#(def._((lib._file/zip..ss)._zip))",[0,[1,"zip"]],["file/zip"]],
["zip",">srfi-std/srfi-1.html#zip",[0,[1,"zip"]],["srfi/1"]],
["zip file creation",">file/zip.html",[[5,"zip"]," File Creation"],false],
["zip->output",">file/zip.html#(def._((lib._file/zip..ss)._zip-~3eoutput))",[0,[1,"zip-&gt;output"]],["file/zip"]],
["zip-verbose",">file/zip.html#(def._((lib._file/zip..ss)._zip-verbose))",[0,[1,"zip-verbose"]],["file/zip"]],
["zl",">reference/characters.html#(idx._(gentag._60._(lib._scribblings/reference/reference..scrbl)))",[7,"'zl"],false],
["zp",">reference/characters.html#(idx._(gentag._59._(lib._scribblings/reference/reference..scrbl)))",[7,"'zp"],false],
["zs",">reference/characters.html#(idx._(gentag._58._(lib._scribblings/reference/reference..scrbl)))",[7,"'zs"],false],
["{",">reference/reader.html#(idx._(gentag._142._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"{"],[3,""]]],false],
["|",">reference/reader.html#(idx._(gentag._122._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"|"],[3,""]]],false],
["}",">reference/reader.html#(idx._(gentag._145._(lib._scribblings/reference/reference..scrbl)))",[2,[[3,""],[4,"}"],[3,""]]],false],
["~",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-plt-v200..ss)._~7e))",[0,[6,"~"]],["parser-tools/lex-plt-v200"]],
["~",">parser-tools/Lexers.html#(form._((lib._parser-tools/lex-sre..ss)._~7e))",[0,[6,"~"]],["parser-tools/lex-sre"]],
["~",">drscheme/prefs-explanation.html#(idx._(gentag._151._(lib._scribblings/drscheme/drscheme..scrbl)))",[5,"\"~\""],false],
["\u03b1-rename",">drscheme/buttons.html#(idx._(gentag._12._(lib._scribblings/drscheme/drscheme..scrbl)))","&#945;-rename",false],
["\u03bb",">reference/lambda.html#(form._((lib._scheme/base..ss)._~ce~bb))",[0,[6,"&#955;"]],["scheme/base","scheme"]],
["\u03bb",">mzscheme/Old_Syntactic_Forms.html#(form._((lib._mzscheme/main..ss)._~ce~bb))",[0,[6,"&#955;"]],["mzscheme"]]];

// array of pointers to the previous array, for items that are manuals
plt_manual_ptrs = {
  "acks": 610,
  "algol60": 792,
  "browser": 1444,
  "cffi": 1621,
  "cards": 1863,
  "config": 2753,
  "continue": 2868,
  "drscheme": 3872,
  "dynext": 4015,
  "embedded-gui": 4255,
  "errortrace": 4492,
  "eopl": 4495,
  "foreign": 4902,
  "file": 5050,
  "framework": 5488,
  "frtime": 5515,
  "games": 5609,
  "gl-board-game": 6347,
  "sgl": 6547,
  "graphics": 8074,
  "gui": 8127,
  "guide": 8129,
  "honu": 8327,
  "htdc": 8360,
  "htdp-langs": 8361,
  "htdp-lib": 8377,
  "html": 8398,
  "inside": 8798,
  "lazy": 9165,
  "license": 9289,
  "macro-debugger": 9637,
  "make": 10229,
  "more": 10674,
  "mrlib": 10755,
  "mysterx": 10788,
  "mzc": 10790,
  "mzcom": 10791,
  "mzlib": 10880,
  "preprocessor": 10882,
  "mzscheme": 10896,
  "net": 11018,
  "openssl": 11522,
  "parser-tools": 11718,
  "planet": 11963,
  "plot": 11993,
  "tools": 12019,
  "quick": 12533,
  "r5rs": 12563,
  "r6rs": 12566,
  "readline": 12772,
  "redex": 12867,
  "reference": 12889,
  "release": 12963,
  "scribble": 14001,
  "setup-plt": 14683,
  "slatex-wrap": 14866,
  "slideshow": 14892,
  "srfi": 15122,
  "string-constants": 15293,
  "swindle": 16050,
  "syntax-color": 16116,
  "syntax": 16215,
  "teachpack": 16342,
  "test-box-recovery": 16379,
  "trace": 16732,
  "turtles": 16806,
  "typed-scheme": 16813,
  "version": 17230,
  "web-server": 17303,
  "xml": 17564};
